Package: lessR
Version: 4.5.6
Title: Less Code with More Comprehensive Results
Authors@R: person(given = "David W.", family = "Gerbing", email = "gerbing@pdx.edu",
  role = c("aut", "cre"),
  comment = c(ORCID = "0000-0001-6998-8350",
              Affiliation = "School of Business, Portland State University"))
Description: Each function replaces multiple standard R functions. For example,
    two function calls, Read() and CountAll(), generate summary statistics for
    all variables in the data frame, plus histograms and bar charts. Other
    functions provide data aggregation via pivot tables; comprehensive
    regression, ANOVA, and t-test; visualizations including integrated
    Violin/Box/Scatter plot for a numerical variable, bar chart, histogram,
    box plot, density curves, calibrated power curve; reading multiple data
    formats with the same call; variable labels; time series with aggregation
    and forecasting; color themes; and Trellis (facet) graphics. Also includes
    a confirmatory factor analysis of multiple-indicator measurement models,
    pedagogical routines for data simulation (e.g., Central Limit Theorem),
    generation and rendering of regression instructions for interpretative output,
    and both interactive construction of visualizations and interactive
    visualizations with plotly.
Depends: R (>= 3.6.0)
Imports: graphics, grDevices, grid, stats, utils, methods, lattice,
        latticeExtra, robustbase, ellipse, leaps, openxlsx, colorspace,
        shiny, knitr, kableExtra, xts, zoo, MASS, conflicted, plotly
        (>= 4.11.0), htmlwidgets, htmltools
Suggests: KernSmooth, haven, hexbin, readODS, triangle, arrow,
        rmarkdown, wesanderson, tsibble, fable, fabletools,
        distributional, rstudioapi
VignetteBuilder: knitr
License: GPL (>= 2)
Encoding: UTF-8
LazyLoad: yes
NeedsCompilation: no
Packaged: 2026-08-02 18:13:19 UTC; davidgerbing
Maintainer: David W. Gerbing <gerbing@pdx.edu>
Author: David W. Gerbing [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-6998-8350>, Affiliation: School of
    Business, Portland State University)
Repository: CRAN
Date/Publication: 2026-08-03 05:10:09 UTC

importFrom("ellipse", ellipse)
importFrom("leaps", leaps)
importFrom("openxlsx", read.xlsx, addWorksheet, createStyle, createWorkbook, saveWorkbook, setColWidths, writeDataTable, writeData)
importFrom("robustbase", adjboxStats, mc)
importFrom("colorspace", sequential_hcl, diverge_hcl,
                         rainbow_hcl, terrain_hcl, heat_hcl)
importFrom("knitr", engine_output, "kable")
importFrom("kableExtra", kable_styling)
importFrom("MASS", kde2d)
importFrom(htmlwidgets, saveWidget, sizingPolicy)
importFrom(htmltools, attachDependencies, htmlDependency)
#importFrom("rlang", enquo, quo_is_missing, eval_tidy, as_label, caller_env, abort)
#importFrom("xts", endpoints, period.apply)
#importFrom("triangle", dtriangle, rtriangle)
#importFrom("sas7bdat", read.sas7bdat)
#importFrom("png", readPNG)
#importFrom("wesanderson", wes_palette)
#importFrom("rmarkdown", render, pandoc_available)
#importFrom("MBESS", ci.smd)
#importFrom("randomcoloR", distinctColorPalette)

importFrom("graphics", abline, arrows, axis, axis.Date, barplot, box, boxplot, grconvertX, grconvertY, hist, image, legend, lines, mtext, pairs, par, pie, plot, plot.default, plot.new, plot.window, points, polygon, rasterImage, rect, rug, segments, stripchart, strwidth, sunflowerplot, symbols, text, title, axTicks, smoothScatter, strheight, filled.contour, .filled.contour)

importFrom("grDevices", boxplot.stats, col2rgb, colorRampPalette, colors, dev.cur, dev.list, dev.new, dev.off, dev.set, gray, heat.colors, hcl, palette, pdf, rainbow, rgb, terrain.colors, as.graphicsAnnot, hcl.colors, palette.colors, gray.colors,
convertColor)

importFrom("stats", approx, binom.test, confint.default, IQR, TukeyHSD, addmargins, anova, aov, as.formula, bw.nrd0, chisq.test, coef, complete.cases, confint, contrasts, cooks.distance, cor, cor.test, cov, density, dffits, dlnorm, dnorm, dt, dunif, factanal, fitted, frequency, glm, heatmap, interaction.plot, lm, lm.influence, loadings, loess, lowess, median, mahalanobis, na.omit, pf, pnorm, prop.test, power.t.test, predict, printCoefmat, promax, pt, qnorm, qt, quantile, rbinom, replications, residuals, reformulate, rlnorm, rnorm, reshape, rstandard, rstudent, runif, sd, setNames, shapiro.test, start, stl, t.test, terms.formula, update, var, varimax, is.ts, time,  weighted.mean, fivenum, as.dist, hclust, cutree, aggregate, DF2formula, model.matrix, HoltWinters, ts, vcov, xtabs)

importFrom("utils", capture.output, head, help, packageVersion, read.csv, read.delim, read.fwf, read.table, type.convert, write.csv, write.table, browseURL, tail)

importFrom("methods", hasArg)

importFrom("lattice", xyplot, histogram, barchart, panel.grid, panel.xyplot, panel.loess, panel.lmline, panel.densityplot, panel.superpose, trellis.par.get, current.panel.limits, panel.text, panel.barchart, panel.histogram, panel.dotplot, panel.points, panel.polygon, panel.segments, panel.violin, panel.bwplot, panel.stripplot, panel.number, panel.lines)

importFrom("latticeExtra", panel.ellipse, panel.xyarea)

#importFrom("shiny", runApp)

S3method(print, out_all)
S3method(print, out)

# Export all names except those that begin with .
#exportPattern("^[^\\.]")
#
# Export all names
#exportPattern(".")


export (

  ANOVA, av, av_brief,
  BarChart,
  BoxPlot, bx,
  Chart,
  Correlation, cr, cr_brief,
  CountAll, ca,
  corCFA, cfa, scales,
  corPrint,
  corRead, rd.cor,
  corReorder, reord,
  corReflect, reflect, corProp, cp, corRead,
  corScree, scree, corEFA, efa,
  Density,
  details, db,
  factors,
  Flows,
  getColors,
  Histogram, hs,
  interact,
  kurtosis,
  label,
  Logit, lr,
  Merge, mrg,
  Model, model, model_brief,
  Nest,
  order_by,
  PieChart, pc,
  pivot,
  Plot,
  print.out_all, print.out,
  prob_norm, prob_znorm, prob_tcut,
  Prop_test, prop,
  Read, rd, rd_lbl, Read2,
  recode, rescale,
  Regression, reg, reg_brief, regPlot,
  rename,
  reshape_long, reshape_wide,
  savePlotly,
  showColors, showPalettes,
  simCImean, simCLT, simFlips, simMeans,
  ScatterPlot, sp,
  see, skew,
  Subset,
  SummaryStats, ss, ss_brief,
  STL,
  style,
  to,
  train_test,
  Transform,
  tsExtract,
  ttest, tt, tt_brief,
  ttestPower, ttp,
  values, VariableLabels, vl,
  ViolinPlot, vp,
  Write, wrt, wrt_r, wrt_x,
  X, XY,
  xAnd, xNum, xP, xRow, xU, xW,
  .
)

# -----------
# Scatterplot
# -----------

library(shiny)
library(lessR)
library(openxlsx)

clr.one <- list(
  "#324E5C", "dodgerblue3", "cornflowerblue", "steelblue", "darkblue",
  "pink2", "red3", "firebrick2", "darkred",
  "violetred", "mediumorchid", "purple3",
  "darkorange2", "salmon", "orange3", "sienna", "rosybrown", 
  "wheat3", "goldenrod2", "khaki", "yellow2",
  "darkseagreen2", "springgreen3", "seagreen4", "darkgreen",
  "black", "gray45", "slategray4", "gray75", "snow3", "gray95",
  "lavender", "ivory2", "aliceblue", "white")

clr.edge <- list("off", "black", "gray50", "gray75", "white", "ivory", 
  "darkblue", "darkred", "darkgreen", "rosybrown2", "bisque", 
  "slategray2", "aliceblue", "thistle1", "coral", "gold")

clr.qual <- c("hues", "Okabe-Ito", "viridis")

clr.seq <- list("reds", "rusts", "browns", "olives", "greens",
  "emeralds", "turquoises", "aquas", "blues", "purples", "violets",
  "magentas", "grays")

clr.fit <- c("#5C4032", clr.one[2:length(clr.one)])

addResourcePath("shiny_dir", system.file("shiny_apps", package="lessR"))


ui <- fluidPage(
  tags$head(tags$link(rel="stylesheet", href="shiny_dir/styles.css")),

  tabsetPanel(

    tabPanel("Data",
      titlePanel(div("Upload a text (.csv, .txt) or Excel file", id="hp")),

      sidebarLayout(
        sidebarPanel(

          radioButtons("fType", HTML("<h5 class='soft'>Format</h5>"), 
                       c("Excel"="Excel", "Text"="Text")),
          conditionalPanel(condition="input.fType == 'Text'",
            radioButtons("sep", HTML("<h5 class='soft'>Separator</h5>"),
                         c(Comma=",", Semicolon=";", Tab="\t"), ","),
            radioButtons("decimal", HTML("<h5 class='soft'>Decimal</h5>"),
                         c("Point"=".", "Comma"=",")),
          ),

          radioButtons("fSource", HTML("<h5 class='soft'>Source</h5>"), 
                       c("Local"="local", "Web"="web")),
          conditionalPanel(condition="input.fSource == 'local'",
            fileInput("myFile", "Locate your data file",
                      accept=c(".csv", ".txt", ".xlsx", ".xlsm")),
          ),
          conditionalPanel(condition="input.fSource == 'web'",
            textInput("myURL", "Web address of data file"),
            actionButton("submitURL", "Submit")
          ),

          textOutput("nrows"),
          textOutput("ncols"),
          uiOutput("d.show"),

        ),  # end sidbarPanel

        mainPanel(
          tableOutput("d.table"),
          tags$style(type="text/css", "#d.table {font-size: .95em;}")
        )

      )  # end sidbarLayout
    ),  # end tabPanel 1


    tabPanel("Scatterplot",
      pageWithSidebar(
        titlePanel(""),

        sidebarPanel(
          selectInput('x.col', 'x Variable', ""),
          selectInput('y.col', 'y Variable', "", selected=""),

          checkboxInput("do_by", div("by variable", class="view"), FALSE),
          conditionalPanel(condition="input.do_by == true",
            selectInput("by.col", "by Variable", "", selected=""),
            selectInput("myFill_by", "fill",
              choices=list("Qualitative"=clr.qual, "Sequential"=clr.seq)),
          ),

          checkboxInput("do_size", div("size variable", class="view"), FALSE),
          conditionalPanel(condition="input.do_size == true",
            selectInput('size.col', 'size Variable', "", selected=""),
          ),

          tags$hr(),
          checkboxInput("do_geom", div("Points", class="view"), FALSE),
          conditionalPanel(condition="input.do_geom == true",
            conditionalPanel(condition="input.do_by == false",
              selectInput("myFill", "fill", choices=clr.one),
              selectInput("myColor", label="color", choices=clr.edge),
            ),
            sliderInput("myTrans", "transparency", min=0, max=1, value=0),
            conditionalPanel(condition="input.do_size == false",
              sliderInput("mySize", "size", min=0.0, max=5, value=1.25,
                          step=0.25)),
            conditionalPanel(condition="input.do_size == false",
              selectInput("myShape", "shape",
              choices=list("circle", "square", "diamond", "triup", "tridown")),
            ),
          ),

          tags$hr(),
          checkboxInput("do_FlEO", 
                        div("Line, Ellipse, Outliers", class="view"), FALSE),
          conditionalPanel(condition="input.do_FlEO == true",
            conditionalPanel(condition="input.do_by == false",
              checkboxInput("myEnhance", "enhance", value=FALSE),
              checkboxInput("myAddMeans", "add=\"means\"", value=FALSE),
            ),
            selectInput("myFit", "fit",
              choices=list("off", "loess", "lm", "exp", "quad", "null")),
            conditionalPanel(condition="input.myFit != 'off'",
              checkboxInput("myErrors", "plot_errors", value=FALSE),
              conditionalPanel(condition="input.do_by == false",
                selectInput("myFitClr", "fit_color", choices=clr.fit),
              ),
              sliderInput("myFitSE", "fit_se", min=0, max=0.99, value=0.95),
            ),
            sliderInput("myEllipse", "ellipse", min=0, max=0.99, value=0),
            conditionalPanel(condition="input.do_by == false",
              sliderInput("myMDcut", "MD_cut", min=0, max=15, value=0),
              conditionalPanel(condition="input.myMDcut > 0",
                selectInput('ID.col', 'ID variable', "", selected=""),
              ),
            ),
          ),

          tags$hr(),
          checkboxInput("do_jitter", div("Jitter", class="view"), FALSE),
          conditionalPanel(condition="input.do_jitter == true",
            sliderInput("myJitx", "jitter_x", min=0, max=1000, value=0,
                        step=0.5),  # need the max value set from data
            sliderInput("myJity", "jitter_y", min=0, max=1000, value=0,
                        step=0.5),
          ),

          tags$hr(),
          checkboxInput("do_rotate", div("Rotate Labels", class="view"), FALSE),
          conditionalPanel(condition="input.do_rotate == true",
            sliderInput("myRttx", "rotate_x", min=0, max=90, value=0, step=10),
            sliderInput("myRtty", "rotate_y", min=0, max=90, value=0, step=10),
            sliderInput("myOff", "offset", min=0, max=4, value=0.5, step=0.25),
          ),

          tags$hr(),
          checkboxInput("do_pdf", div("Save", class="view"), FALSE),
          conditionalPanel(condition="input.do_pdf == true",
            sliderInput("w", "width (inches):", min=3, max=20, value=8),
            sliderInput("h", "height (inches):", min=3, max=20, value=6),
            checkboxInput("do_cmt", "include comments in R file", TRUE),
            actionButton(inputId="btn_pdf", "Save"),
            tags$p(div("Save pdf file and R code file",
                  style="margin-top:.25em; margin-bottom:0em;")),
          ),

          tags$hr(),
          checkboxInput("do_help", div("Help", class="view"), FALSE),

        ),  # end sidebarPanel

        mainPanel(
          plotOutput('myPlot'),
          verbatimTextOutput("summary"),
          plotOutput("saved_plot"), 
          textOutput("help")
        )

      )  # end pageWithSidebar
    )  # end tabPanel 2
  )  # end tabsetPanel
)  # end fluidPage 


server <- function(input, output, session) {

  v <- reactiveValues()
  v$add <- NULL


  # ------- Read and Display Data -----------
  # -----------------------------------------

  # process the URL for reading from the web
  theURL <- eventReactive(input$submitURL, {
    input$myURL
  })

  data <- reactive({
    if (input$fSource == "local") {
      shiny::req(input$myFile)
      myPath <- input$myFile$datapath
      theRead <- input$myFile$name
    }
    if (input$fSource == "web") {
      url <- theURL()
      if (!grepl("^https?://", url))
        url <- paste("https://", url, sep="")
      myPath <- url
      theRead <- myPath
    }
      
    shiny::req(myPath)
    if (input$fType == "Excel") { 
      if (grepl(".xlsx", myPath, fixed=TRUE)) {
        d <- read.xlsx(myPath, detectDates=TRUE)
      }
      else {
        message("\n>>> Excel file must have file type of .xlsx <<<\n\n")
        stopApp()
      }
    }
    if (input$fType == "Text") { 
      if ((grepl(".csv", myPath, fixed=TRUE)) ||
          (grepl(".txt", myPath, fixed=TRUE))) {
        d <- read.csv(myPath, sep=input$sep, dec=input$decimal,
                      na.strings="")  # default is NOT a blank char missing
      }
      else {
        message("\n>>> Text file must have file type of .csv or .txt <<<\n\n")
        stopApp()
      }       
    }  # end fType is "Text"

    shiny::updateSelectInput(session, inputId="x.col", label="x variable",
                      choices=c("Select a variable"="", names(d)))
    shiny::updateSelectInput(session, inputId="y.col", label="y variable",
                      choices=c("Select a variable"="", names(d)))
    
    return(d)
  })  # end reactive()


  output$nrows <- renderText({
    shiny::req(data())
    paste("Number of data rows:", nrow(data()))
  })
  output$ncols <- renderText({
    shiny::req(data())
    paste("Number of variables:", ncol(data()))
  })

  output$d.show <- renderUI({
    shiny::req(data())
    if (nrow(data()) > 10)
      radioButtons("d.show", HTML("<h5 class='soft'>Rows to display</h5>"),
                   c("First 10"="head", "Last 10"="tail", "Random 10"="random",
                     "All"="all"))
  })


  output$d.table <- renderTable({
    if (is.null(input$d.show)) 
      data()
    else {
      nr <- min(11, nrow(data()))
      if (nr == 11) {
        if (input$d.show == "all")
          data()
        else if (input$d.show == "head")
          head(data(), n=10)
        else if (input$d.show == "tail")
          tail(data(), n=10)
        else if (input$d.show == "random") { 
          dd <- data()
          dd[sample(nrow(dd), min(10, nrow(dd))), ]
        }
      }
    }
  }, striped=TRUE)  # end renderTable

  # -----------------------------------------


  observeEvent(input$do_by, {

    d <- data()
    is.cat <- sapply(d, function(x) {
      lu.x <- length(unique(x))
      (is.character(x) || is.factor(x) || lu.x < 11) && (lu.x < nrow(d))
    })

    if (all(!is.cat)) {
      message("A  by  variable partitions values of a categorical variable.\n",
              "Categorical variables have non-numeric values or, if numeric,\n",
              "  defined here as 10 or fewer unique values.\n\n",
              "No categorical variables are present in this data set.")
      stopApp()
    }

    the.cats <- names(d)[is.cat]
    shiny::updateSelectInput(session, inputId="by.col", label="by variable",
                        choices=c("Select a categorical variable"="", the.cats))
  })


  observeEvent(input$do_size, {
    d <- data()
    shiny::updateSelectInput(session, inputId="size.col", label="size variable",
                        choices=c("Select a numerical variable"="",
                        names(d)[sapply(d, is.numeric)]))
  })


  observeEvent(input$myMDcut, {
    shiny::req(input$myMDcut > 0)

    d <- data()
    is.unique <- sapply(d, function(x) {
      l.x <- length(x)
      lu.x <- length(unique(x))
      l.x == lu.x
    })

    if (all(!is.unique)) {
      message("An  ID  variable must have unique values.\n",
              "No variables have unique values in this data set.")
      stopApp()
    }

    the.unique <- c("row.name", names(d)[is.unique])
    shiny::updateSelectInput(session, inputId="ID.col", label="ID variable",
                        choices=c("Var with unique values"="", the.unique),
                        selected="row.name")
  })


  # ------------ Enhance and Add ------------
  # -----------------------------------------

  observeEvent(input$myAddMeans, {
    if (input$myAddMeans)
      v$add <- "means"
    else
      v$add <- NULL    
  })


  observeEvent(input$myEnhance, {
    if (input$myEnhance) {
      v$add <- "means"
      add.val <- TRUE
    }
    else {
      v$add <- NULL
      add.val <- FALSE
    }
    updateCheckboxInput(session, inputId="myAddMeans", "add=\"means\"",
        value=add.val)

    elp.val <- ifelse (input$myEnhance, 0.95, 0)
    updateSliderInput(session, inputId="myEllipse", "ellipse",
         min=0, max=0.99, value=elp.val)

    fit.val <- ifelse (input$myEnhance, "lm", "off")
    updateSelectInput(session, inputId="myFit", "fit", 
         choices=list("off", "loess", "lm", "exp", "quad", "null"),
         selected=fit.val)
    if (!input$do_by) {
      MDc.val <- ifelse (input$myEnhance, 6, 0)
      updateSliderInput(session, inputId="myMDcut", "MD_cut",
           min=0, max=15, value=MDc.val)
    }
  })
 


  # ------------ The Scatterplot ------------
  # -----------------------------------------

  output$myPlot <- renderPlot({
    x.name <- input$x.col
    shiny::req(x.name)
    x <- data()[, x.name]

    y.name <- input$y.col
    shiny::req(y.name)
    y <- data()[, y.name]

    in.fill <- input$myFill
    in.shp  <- input$myShape

    by <- NULL
    lt <- NULL  # legend_title

    # by-variable logic + shape mapping
    if (input$do_by) {  # a by variable
      by.name <- input$by.col
      shiny::req(by.name)
      by <- data()[, by.name]
      in.fill <- input$myFill_by  # color range selection

      # still map to numeric, but we won't pass shape to XY() when by is present
      if (in.shp == "circle") in.shp <- 21
      if (in.shp == "square") in.shp <- 22
      if (in.shp == "diamond") in.shp <- 23
      if (in.shp == "triup")   in.shp <- 24
      if (in.shp == "tridown") in.shp <- 25

      lt <- by.name
    }

    in.size <- input$mySize   # constant value of size from slider
    if (input$do_size) {  # size variable
      shiny::req(input$size.col)
      in.size <- data()[, input$size.col]
    }
    if (!input$do_size) in.size <- 1.4 * in.size  # scale up, as with axes

    in.fit <- input$myFit
    in.elp <- input$myEllipse
    in.add <- v$add 

    if (input$do_by) {  # choose MD then by var
      in.MD <- 0
      in.ID <- row.names(data())
      if (input$myEnhance) {
        in.fit <- "off" 
        in.elp <- 0
        in.add <- NULL
      }
    }
    else {
      in.MD <- input$myMDcut 
      if (nchar(input$ID.col) != 0) {
        if (input$ID.col != "row.name")
          in.ID <- data()[, input$ID.col]
        else
          in.ID <- row.names(data())
      }
      else
        in.ID <- row.names(data())
    }

    ## ---- Call XY() (scatter) depending on by presence ----
    v$x <- x; v$y <- y; v$by <- by
    v$x.name <- x.name; v$y.name <- y.name

    if (input$do_by) {
      v$stats <- XY(
        x, y, by = by, data = NULL,
        type = "scatter",
        fill  = in.fill,
        # no color when by is present; XY will choose colors per group
        transparency = input$myTrans,
        size  = in.size,
        # no shape when by is present; XY aligns shapes internally as needed
        plot_errors = input$myErrors,
        fit        = in.fit,
        fit_color  = input$myFitClr,
        fit_se     = input$myFitSE,
        ellipse    = in.elp,
        MD_cut     = in.MD,
        ID         = in.ID,
        add        = in.add,
        enhance    = input$myEnhance,
        jitter_x   = input$myJitx,
        jitter_y   = input$myJity,
        rotate_x   = input$myRttx,
        rotate_y   = input$myRtty,
        offset     = input$myOff,  
        xlab = x.name,
        ylab = y.name,
        legend_title = lt,
        quiet = TRUE
      )
    } else {
      v$stats <- XY(
        x, y, data = NULL,
        type = "scatter",
        fill  = in.fill,
        color = input$myColor,
        transparency = input$myTrans,
        size  = in.size,
        shape = in.shp,
        plot_errors = input$myErrors,
        fit        = in.fit,
        fit_color  = input$myFitClr,
        fit_se     = input$myFitSE, 
        ellipse    = in.elp,
        MD_cut     = in.MD,
        ID         = in.ID,
        add        = in.add, 
        enhance    = input$myEnhance,
        jitter_x   = input$myJitx,
        jitter_y   = input$myJity,
        rotate_x   = input$myRttx,
        rotate_y   = input$myRtty,
        offset     = input$myOff,  
        xlab = x.name,
        ylab = y.name,
        legend_title = lt,
        quiet = TRUE
      )
    }

    # defaults for code string
    p_fill <- ifelse (!input$do_by, in.fill == "#324E5C",
                                   in.fill == "hues")
    p_color <- input$myColor == "off" || input$do_by
    p_trans <- input$myTrans == 0
    p_by <- input$do_by == FALSE
    p_size <- input$mySize==1.25 && length(in.size)==1
    p_shape <- input$myShape == "circle" || input$do_by  # no shape arg for by
    p_errors <- input$myErrors == FALSE
    p_fit <- in.fit == "off"
    p_fitclr <- input$myFitClr == getOption("fit_color")
    p_fitse <- input$myFitSE == 0.95
    p_ellipse <- in.elp == 0
    p_MDcut <- in.MD == 0
    p_ID <- nchar(input$ID.col)==0 || input$ID.col=="row.name" || in.MD==0
    p_jitx <- input$myJitx == 0
    p_jity <- input$myJity == 0
    p_add <- is.null(in.add)

    # all enhance default settings must be TRUE for enhance to be TRUE
    p_enhance <- FALSE
    if (input$myEnhance && in.MD > 0 && !is.null(v$add)) {
      if (input$myFit=="lm" && input$myEllipse==0.95
          && input$myMDcut==6 && v$add=="means")
        p_enhance <- TRUE
      else
        p_enhance <- FALSE
    }

    out <- paste("XY(", x.name, ", ", y.name, sep="")

    if (!p_fill) out <- paste(out, ", fill=\"", in.fill, "\"", sep="")
    if (!p_color) out <- paste(out, ", color=\"", input$myColor, "\"", sep="")
    if (!p_trans) out <- paste(out, ", transparency=", input$myTrans, sep="")
    if (!p_by && input$do_by)
      out <- paste(out, ", by=", by.name, sep="")
    if (!p_size) {
      sz.out <- ifelse (length(in.size)==1, input$mySize, input$size.col)
      out <- paste(out, ", size=", sz.out, sep="")
    }
    if (!p_shape && !input$do_by)
      out <- paste(out, ", shape=\"", input$myShape, "\"", sep="")
    if (!p_errors) out <- paste(out, ", plot_errors=", input$myErrors, sep="")
    if (!p_fitclr) out <- paste(out, ", fit_color=\"", input$myFitClr,
                                "\"", sep="")
    if (!p_fitse) out <- paste(out, ", fit_se=", input$myFitSE, sep="")
    if (!p_jitx) out <- paste(out, ", jitter_x=", input$myJitx, sep="")
    if (!p_jity) out <- paste(out, ", jitter_y=", input$myJity, sep="")

    if (!p_enhance) {
      if (!p_fit) out <- paste(out, ", fit=\"", in.fit, "\"", sep="")
      if (!p_ellipse) out <- paste(out, ", ellipse=", in.elp, sep="")
      if (!p_MDcut) out <- paste(out, ", MD_cut=", in.MD, sep="")
      if (!p_add) out <- paste(out, ", add=\"", in.add, "\"", sep="")
    }
    else
      out <- paste(out, ", enhance=", p_enhance, sep="")

    if (!p_ID) out <- paste(out, ", ID=\"", input$ID.col, "\"", sep="")

    out <- paste(out, ", type=\"scatter\")", sep="")
    cat(out, "\n")
    v$code <- out  # save the code for a pdf file
  })  # end renderPlot


  # print stats
  output$summary <- renderPrint({
    shiny::req(v$stats)
    if (!is.null(v$stats)) print(v$stats)
  })


  # clicking on the Save button generates a pdf file 
  plotInput <- eventReactive(input$btn_pdf, {

    code <- v$code

    x.name <- input$x.col
    shiny::req(x.name)
    x <- data()[, x.name]

    y.name <- input$y.col
    shiny::req(y.name)
    y <- data()[, y.name]

    in.fill <- input$myFill

    by <- NULL
    lt <- NULL  # legend_title
    if (input$do_by) {  # a by variable
      by.name <- input$by.col
      shiny::req(by.name)
      by <- data()[, by.name]
      in.fill <- input$myFill_by  # color range selection
      lt <- by.name
    }

    in.size <- input$mySize   # constant value of size from slider
    if (input$do_size) {  # see if proceed with size is a variable
      shiny::req(input$size.col)
      in.size <- data()[, input$size.col]
    }
    if (!input$do_size) in.size <- 1.4 * in.size  # match renderPlot scaling
     
    pdf.fname <- paste("plot_", x.name, y.name, ".pdf", sep="")
    pdf.path <- file.path(path.expand("~"), pdf.fname)

    in.fit <- input$myFit
    in.elp <- input$myEllipse
    in.add <- v$add 
    if (input$do_by) {  # choose MD then by var
      in.MD <- 0
      in.ID <- row.names(data())
      if (input$myEnhance) {
        in.fit <- "off" 
        in.elp <- 0
        in.add <- NULL
      }
    }
    else {
      in.MD <- input$myMDcut 
      if (nchar(input$ID.col) != 0) {
        if (input$ID.col != "row.name")
          in.ID <- data()[, input$ID.col]
        else
          in.ID <- row.names(data())
      }
      else
        in.ID <- row.names(data())
    }

    # styles before re-set in interact() were saved
    style(lab_cex=getOption("l.cex"))
    style(axis_cex=getOption("l.axc"))

    ## ---- XY() call for saved plot ----

    if (input$do_by) {
      XY(
        x, y, by = by, data = NULL,
        type = "scatter",
        fill  = in.fill,
        # no color when by is present
        transparency = input$myTrans,
        size  = in.size,
        # no shape when by is present
        plot_errors = input$myErrors,
        fit        = in.fit,
        fit_color  = input$myFitClr,
        fit_se     = input$myFitSE, 
        ellipse    = in.elp,
        MD_cut     = in.MD,
        ID         = in.ID,
        add        = in.add,
        enhance    = input$myEnhance,
        jitter_x   = input$myJitx,
        jitter_y   = input$myJity,
        rotate_x   = input$myRttx,
        rotate_y   = input$myRtty,
        offset     = input$myOff,  
        xlab = x.name,
        ylab = y.name,
        legend_title = lt,
        quiet = TRUE,
        pdf_file = pdf.path,
        width  = as.numeric(input$w),
        height = as.numeric(input$h)
      )
    } else {
      XY(
        x, y, data = NULL,
        type = "scatter",
        fill  = in.fill,
        color = input$myColor,
        transparency = input$myTrans,
        size  = in.size,
        shape = input$myShape,
        plot_errors = input$myErrors,
        fit        = input$myFit,
        fit_color  = input$myFitClr,
        fit_se     = input$myFitSE, 
        ellipse    = input$myEllipse,
        MD_cut     = in.MD,
        ID         = in.ID,
        add        = in.add,
        enhance    = input$myEnhance,
        jitter_x   = input$myJitx,
        jitter_y   = input$myJity,
        rotate_x   = input$myRttx,
        rotate_y   = input$myRtty,
        offset     = input$myOff,  
        xlab = x.name,
        ylab = y.name,
        legend_title = lt,
        quiet = TRUE,
        pdf_file = pdf.path,
        width  = as.numeric(input$w),
        height = as.numeric(input$h)
      )
    }

    # reset back to shiny setting
    style(lab_cex=1.201, axis_cex=1.011, suggest=FALSE)

    # R code
    r.fname <- paste("plot_", x.name, y.name, ".r", sep="")
    r.path <- file.path(path.expand("~"), r.fname)
    cat("\n")
    message("---------------------------------------------")
    cat("Files written to folder:", path.expand("~"), "\n")
    message("---------------------------------------------")
    cat("pdf file: ", pdf.fname, "\n")
    cat("R code file: ", r.fname, "\n")
    message("---------------------------------------------")
    cat("\n")

    if (input$fSource == "web") {
      url <- theURL()
      if (!grepl("^https?://", url))
        url <- paste("https://", url, sep="")
    }

    read.path <- ifelse (input$fSource == "local", input$myFile$name, url)
    read.code <- paste("d <- Read(\"", read.path, "\")", sep="")
    is.local <- !grepl("http://", read.path, fixed=TRUE)

    if (input$do_cmt)
      cat("# The # symbol indicates a comment rather than an R instruction\n\n",
          "# Begin the R session by loading the lessR functions ",
          "from the library\n", sep="", file=r.path)
    cat("library(\"lessR\")\n\n", file=r.path, append=TRUE)

    if (input$do_cmt) {
      cat("# Read your data into an R data table, the data frame, here d",
          "\n", sep="", file=r.path, append=TRUE)
      if (is.local)
        cat("# To browse for the data file, include nothing between the quotes",
            "\n", sep="", file=r.path, append=TRUE)
    }
    if (is.local && input$do_cmt)
      cat("d <- Read(\"\")\n\n", file=r.path, append=TRUE)

    if (is.local && input$do_cmt) {
      cat("# For security, the path to your data file is not available\n",
          "# You can replace PATHtoFILE in the following with the path\n",
          "# Remove the # sign in the first column and delete the previous ",
          "Read()\n", sep="", file=r.path, append=TRUE)
      read.path <- file.path("PATHtoFILE", read.path) 
      read.code <- paste("# d <- Read(\"", read.path, "\")", sep="")
    }
    cat(read.code, "\n\n", file=r.path, append=TRUE)

    if (input$do_cmt)
      cat("# When you have your data table, do the scatterplot analysis of\n",
          "#   two variables in the data table\n",
          "# d is the default data frame name, so no need to specify\n",
          sep="", file=r.path, append=TRUE)
    cat(code, "\n\n", file=r.path, append=TRUE)

    anlys <- "XY()"
    if (input$do_cmt)
      cat("# If accessing data with a name other than d, must add  data=NAME\n",
          paste("#   to the", anlys, "call, where NAME is the name of your",
          "data frame"), "\n", sep="", file=r.path, append=TRUE)

  })
  output$saved_plot <- renderPlot({ plotInput() })


  # access web page help file
  observeEvent(input$do_help, {
    fp <- system.file("shiny_apps/help/ScatterPlot.html", package="lessR")
    browseURL(fp)
  })
  output$help <- renderText({ "" })

}  # end server

shinyApp(ui, server)

# --------
# PieChart
# --------

library(shiny)
library(lessR)

clr.one <- list(
  "#96AAC3", "dodgerblue3", "cornflowerblue", "steelblue", "darkblue",
  "pink2", "red3", "firebrick2", "darkred",
  "violetred", "mediumorchid", "purple3",
  "darkorange2", "salmon", "orange3", "sienna", "rosybrown", 
  "wheat3", "goldenrod2", "khaki", "yellow2",
  "darkseagreen2", "springgreen3", "seagreen4", "darkgreen",
  "black", "gray45", "slategray4", "gray75", "snow3", "gray95",
  "lavender", "ivory2", "aliceblue", "white")

clr.edge <- list("off", "black", "gray50", "gray75", "white", "ivory", 
  "darkblue", "darkred", "darkgreen", "rosybrown2", "bisque", 
  "slategray2", "aliceblue", "thistle1", "coral", "gold")

clr.qual <- c("hues", "Okabe-Ito", "viridis")

clr.seq <- list("reds", "rusts", "browns", "olives", "greens",
  "emeralds", "turquoises", "aquas", "blues", "purples", "violets",
  "magentas", "grays")

clr.hole <- list("white", "gray75", "gray95", "gray98", "aliceblue", 
  "antiquewhite", "ghostwhite", "whitesmoke", "ivory", "mintcream", 
  "mistyrose", "azure1", "seashell", 
  "beige", "cornsilk", "darkblue", "darkred", "darkgreen")


addResourcePath("shiny_dir", system.file("shiny_apps", package="lessR"))


ui <- fluidPage(
tags$head(tags$link(rel="stylesheet", href="shiny_dir/styles.css")),

  tabsetPanel(

    tabPanel("Data",
      titlePanel(div("Upload a text (.csv, .txt) or Excel file", id="hp")),

      sidebarLayout(
        sidebarPanel(

          radioButtons("fType", HTML("<h5 class='soft'>Format</h5>"), 
                       c("Excel"="Excel", "Text"="Text")),
          conditionalPanel(condition="input.fType == 'Text'",
            radioButtons("sep", HTML("<h5 class='soft'>Separator</h5>"),
                         c(Comma=",", Semicolon=";", Tab="\t"), ","),
            radioButtons("decimal", HTML("<h5 class='soft'>Decimal</h5>"),
                         c("Point"=".", "Comma"=",")),
          ),

          radioButtons("fSource", HTML("<h5 class='soft'>Source</h5>"), 
                       c("Local"="local", "Web"="web")),
          conditionalPanel(condition="input.fSource == 'local'",
            fileInput("myFile", "Locate your data file",
                      accept=c(".csv", ".txt", ".xlsx", ".xlsm")),
          ),
          conditionalPanel(condition="input.fSource == 'web'",
            textInput("myURL", "Web address of data file"),
            actionButton("submitURL", "Submit")
          ),

          textOutput("ncols"),
          textOutput("nrows"),
          uiOutput("d.radio"),

        ),  # end sidbarPanel

        mainPanel(
          tableOutput("d.table"),
          tags$style(type="text/css", "#d.table {font-size: .95em;}")
        )

      )  # end sidbarLayout
    ),  # end tabPanel 1


    tabPanel("PieChart",
      pageWithSidebar(
        titlePanel(""),

        sidebarPanel(
          selectInput('x.col', 'x Variable', ""),

          tags$hr(),
          checkboxInput("do_geom", div("Colors", class="view"), FALSE),
          conditionalPanel(condition="input.do_geom == true",
            selectInput("myFill", "fill",
              choices=list("Qualitative"=clr.qual, "Sequential"=clr.seq)),
            selectInput("myColor", label="color", choices=clr.edge),
            sliderInput("myTrans", label="transparency", min=0, max=1, value=0),
          ),

          tags$hr(),
          checkboxInput("do_hole", div("Hole", class="view"), FALSE),
          conditionalPanel(condition="input.do_hole == true",
            sliderInput("myHole", "hole", min=0, max=1, value=0.65),
            selectInput("myHoleFill", label="hole_fill", choices=clr.hole),
          ),

          tags$hr(),
          checkboxInput("do_values", div("Values", class="view"), FALSE),
          conditionalPanel(condition="input.do_values == true",
            selectInput("myValues", "values", choices=list("%", "input", "off")),
            selectInput("myValuesColor", "values_color",
               choices=list("white", "gray", "darkgray", "black",
                            "red", "green3")),
            selectInput("myValuesPos", "values_position",
               choices=list("in", "out")),
            sliderInput("myValuesSize", "values_size",
                        min=0, max=2, value=0.9, step=0.1)
          ),

          tags$hr(),
          checkboxInput("do_pdf", div("Save", class="view"), FALSE),
          conditionalPanel(condition="input.do_pdf == true",
            sliderInput("w", "width (inches):", min=3, max=20, value=8),
            sliderInput("h", "height (inches):", min=3, max=20, value=6),
            checkboxInput("do_cmt", "include comments in R file", TRUE),
            actionButton(inputId="btn_pdf", "Save"),
            tags$p(div("Save pdf file and R code file",
                  style="margin-top:.25em;"))
          ),

          tags$hr(),
          checkboxInput("do_help", div("Help", class="view"), FALSE),

        ),  # end sidebarPanel

      mainPanel(
        plotOutput("myPlot"),
        verbatimTextOutput("summary"),
        plotOutput("saved_plot"), 
        textOutput("help")
      )

    )  # end pageWithSidebar
  )  # end tabPanel 2
  )  # end tabsetPanel
)  # end fluidPage 


server <- function(input, output, session) {

  v <- reactiveValues()
  # select categorical variables from read data frame

  the.vars <- function(data, cats=TRUE) {

    lu.x <- sapply(data, function(x) { length(unique(x)) }) 
    is.cat <- logical(length=ncol(data))
    nr <- min(nrow(data), 500)
    for (i in 1:ncol(data)) {
      is.cat[i] <- is.character(data[1:nr,i]) || is.factor(data[1:nr,i])
      # numeric var is.cat if 10 or less unique values but not a summary tbl
      if (is.numeric(data[1:nr,i]) && lu.x[i]<11)
        if (nrow(data)>lu.x[i] && ncol(data)>2) is.cat[i] <- TRUE 
    }

    if (all(!is.cat)) {
      message("A pie chart displays the values of a categorical variable.\n",
              "Categorical variables have non-numeric values or, if numeric,\n",
              "  defined here as 10 or fewer unique values.\n\n",
              "There are no categorical variables in this data set.")
      stopApp()
    }

    if (cats)
      return(names(data)[is.cat])
    else
      return(names(data)[!is.cat])
  }


# ------- Read and Display Data -----------
# -----------------------------------------

  # process the URL for reading from the web
  theURL <- eventReactive(input$submitURL, {
    input$myURL
  })

  data <- reactive({
    if (input$fSource == "local") {
      shiny::req("input$myFile")
      myPath <- input$myFile$datapath
      theRead <- input$myFile$name
    }
    if (input$fSource == "web") {
      url <- theURL()
      if (!(grepl("http://", url)))
        url <- paste("http://", url, sep="")
      myPath <- url
       theRead <- myPath
    }
      
    shiny::req(myPath)
    if (input$fType == "Excel") { 
      library(openxlsx)
      if (grepl(".xlsx", myPath, fixed=TRUE)) {
        d <- read.xlsx(myPath)
      }
      else {
        message("\n>>> Excel file must have file type of .xlsx <<<\n\n")
        stopApp()
      }
    }
      if (input$fType == "Text") { 
        if ((grepl(".csv", myPath, fixed=TRUE)) ||
            (grepl(".txt", myPath, fixed=TRUE))) {
            d <- read.csv(myPath, sep=input$sep, dec=input$decimal,
                          na.strings="")  # default is NOT a blank char missing
        }
        else {
          message("\n>>> Text file must have file type of .csv or .txt <<<\n\n")
          stopApp()
        }       
      }  # end fType is "Text"

    updateSelectInput(session, inputId="x.col", label="x variable",
                      choices=c("Select a categorical variable" = "",
                              the.vars(d, cats=TRUE)))
    return(d)
  })  # end reactive()


  output$d.radio <- renderUI({
    shiny::req(data())
    output$nrows <- renderText({paste("Number of data rows:", nrow(data()))})
    output$ncols <- renderText({paste("Number of variables:", ncol(data()))})
    if (nrow(data()) > 10)
      radioButtons("d.radio", HTML("<h5 class='soft'>Rows to display</h5>"),
                   c("First 10"="head", "Last 10"="tail", "Random 10"="random",
                     "All"="all"))
  })

  output$d.table <- renderTable({
    if (is.null(input$d.radio)) 
      data()
    else {
      nr <- min(11, nrow(data()))
      if (nr == 11) {
        if (input$d.radio == "all")
          data()
        else if (input$d.radio == "head")
          head(data(), n=10)
        else if (input$d.radio == "tail")
          tail(data(), n=10)
        else if (input$d.radio == "random") { 
          dd <- data()
          dd[.(random(10)), ]
        }
      }
    }
  }, striped=TRUE)  # end renderTable



# ------------- The PieChart --------------
# -----------------------------------------

  output$myPlot <- renderPlot({
    x.name <- input$x.col
    shiny::req(x.name)
    x <- data()[, x.name]
    # no summary table possible because that requires a y-variable

   v$p <- PieChart(x, data=NULL,
        fill=input$myFill, color=input$myColor, transparency=input$myTrans,
        hole=input$myHole, hole_fill=input$myHoleFill,
        values=input$myValues, values_color=input$myValuesColor,
        values_position=input$myValuesPos,
        values_size=input$myValuesSize,
        main=x.name, quiet=TRUE)

      p_fill <- input$myFill == "hues"
      p_color <- input$myColor == "off"
      p_trans <- input$myTrans == 0
      p_hole <- input$myHole == .65
      p_holefill <- input$myHoleFill == "white"
      p_sort <- input$mySort == "0"
      p_values <- input$myValues == "%"
      p_values_color <- input$myValuesColor == "white"
      p_values_position <- input$myValuesPos == "in"
      p_values_size <- input$myValuesSize == 0.9
      
      out <- paste("PieChart(", x.name, sep="")

      if (!p_fill) out <- paste(out, ", fill=\"", input$myFill, "\"", sep="")
      if (!p_color) out <- paste(out, ", color=\"", input$myColor, "\"", sep="")
      if (!p_trans) out <- paste(out, ", transparency=", input$myTrans, sep="")
      if (!p_hole) out <- paste(out, ", hole=", input$myHole, sep="")
      if (!p_holefill) out <- paste(out, ", hole_fill=\"", 
                                        input$myHoleFill, "\"", sep="")
      if (!p_values) out <- paste(out, ", values=\"", input$myValues, "\"",
                                  sep="")
      if (!p_values_color) out <- paste(out, ", values_color=\"", 
                                        input$myValuesColor, "\"", sep="")
      if (!p_values_position) out <- paste(out, ", values_position=\"", 
                                        input$myValuesPos, "\"", sep="")
      if (!p_values_size) out <- paste(out, ", values_size=", 
                                       input$myValuesSize, sep="")

      out <- paste(out, ")", sep="")
      cat(out, "\n")
      v$code <- out  # save the code for a pdf file
  })  # end renderPlot


  # print stats
  output$summary <- renderPrint({
    shiny::req(v$p)
    p <- v$p
    out2 <- c(p$out_txttl, " ", p$out_counts, " ", p$out_chi)
    for (i in 1:length(out2)) cat(out2[i], "\n")
  })


  # clicking on the Save button generates a pdf file 
  plotInput <- eventReactive(input$btn_pdf, {

    code <- v$code

    x.name <- input$x.col
    shiny::req(x.name)
    x <- data()[, x.name]
    y.name <- paste("Count of", x.name)

    pdf.fname <- paste("pc_", x.name, ".pdf", sep="")
    pdf.path <- file.path(path.expand("~"), pdf.fname)

    # styles before re-set in interact() were saved
    style(lab_cex=getOption("l.cex"))
    style(axis_cex=getOption("l.axc"))

   PieChart(x, data=NULL,
        fill=input$myFill, color=input$myColor, transparency=input$myTrans,
        hole=input$myHole, hole_fill=input$myHoleFill,
        values=input$myValues, values_color=input$myValuesColor,
        values_position=input$myValuesPos,
        values_size=input$myValuesSize,
        main=x.name, quiet=TRUE,
        pdf_file=pdf.path,
        width=as.numeric(input$w), height=as.numeric(input$h))

    # reset back to shiny setting
    style(lab_cex=1.201, axis_cex=1.011, suggest=FALSE)

    # R code
    r.fname <- paste("pc_", x.name, ".r", sep="")
    r.path <- file.path(path.expand("~"), r.fname)
    cat("\n")
    message("---------------------------------------------")
    cat("Files written to folder:", path.expand("~"), "\n")
    message("---------------------------------------------")
    cat("pdf file: ", pdf.fname, "\n")
    cat("R code file: ", r.fname, "\n")
    message("---------------------------------------------")
    cat("\n")

    if (input$fSource == "web") {
      url <- theURL()
      if (!(grepl("http://", url)))
        url <- paste("http://", url, sep="")
    }

    read.path <- ifelse (input$fSource == "local", input$myFile$name, url)
    read.code <- paste("d <- Read(\"", read.path, "\")", sep="")
    is.local <- !grepl("http://", read.path, fixed=TRUE)

    if (input$do_cmt)
      cat("# The # symbol indicates a comment rather than an R instruction\n\n",
          "# Begin the R session by loading the lessR functions ",
          "from the library\n", sep="", file=r.path)
      cat("library(\"lessR\")\n\n", file=r.path, append=TRUE)

    if (input$do_cmt) {
      cat("# Read your data into an R data table, the data frame, here d",
          "\n", sep="", file=r.path, append=TRUE)
      if (is.local)
        cat("# To browse for the data file, include nothing between the quotes",
            "\n", sep="", file=r.path, append=TRUE)
    }
    if (is.local && input$do_cmt)
      cat("d <- Read(\"\")\n\n", file=r.path, append=TRUE)

    if (is.local && input$do_cmt) {
      cat("# For security, the path to your data file is not available\n",
          "# You can replace PATHtoFILE in the following with the path\n",
          "# Remove the # sign in the first column and delete the previous ",
          "Read()\n", sep="", file=r.path, append=TRUE)
      read.path <- file.path("PATHtoFILE", read.path) 
      read.code <- paste("# d <- Read(\"", read.path, "\")", sep="")
    }
    cat(read.code, "\n\n", file=r.path, append=TRUE)

    if (input$do_cmt)
      cat("# When you have your data table, do the pie chart analysis of a\n",
          "#   categorical variable in the data table\n",
          "# d is the default data frame name, so no need to specify\n",
          sep="", file=r.path, append=TRUE)
    cat(code, "\n\n", file=r.path, append=TRUE)


    anlys <- "PieChart()"
    if (input$do_cmt)
      cat("# If accessing data with a name other than d, must add  data=NAME\n",
          paste("#   to the", anlys, "call, where NAME is the name of your",
          "data frame"), "\n", sep="", file=r.path, append=TRUE)
  })
  output$saved_plot <- renderPlot({ plotInput() })


  # access web page help file
  output$help <- eventReactive(input$do_help, {
    shiny::req(input$do_help)
    fp <- system.file("shiny_apps/help/PieChart.html", package="lessR")
    browseURL(fp)
  })

}  # end server

shinyApp(ui, server)

corPrint <- function(R, min_value=0)  {

  crs <- .prntbl(R, digits_d=2, cut=min_value, cc=NULL, cors=TRUE)

  tx <- character(length = 0)
  for (i in seq_along(crs)) tx[length(tx)+1] <- crs[i]
  class(tx) <- "out"

  return(tx)
}

.style.show <-
function() {

    cat("\nAvailable Themes\n")
    cat("----------------\n")
    cat("colors", "lightbronze",  "dodgerblue", "darkred", "gray", "gold",
        "darkgreen", "blue", "red", "rose", "slatered", "green", "purple",
        "sienna", "brown", "orange", "white", "light", "\n", fill=60)

    cat("\nAvailable Sub-themes\n")
    cat("--------------------\n")
    cat("default", "black", "wsj", "\n\n")

    cat("THEME\n")
    cat("theme ........ Theme color .......", getOption("theme"), "\n")
    cat("sub_theme .... Sub-theme style ...", getOption("sub_theme"), "\n")

    cat("\n")
    cat("BACKGROUND\n")
    cat("window_fill .. Window fill color .........",
        .to_rgb(getOption("window_fill")), "\n")
    cat("panel_fill ... Panel fill color ..........",
        .to_rgb(getOption("panel_fill")), "\n")
    cat("panel_color .. Panel border color ....... ",
        .to_rgb(getOption("panel_color")), "\n")
    cat("panel_lwd .... Panel border line width .. ",
        .fmt(getOption("panel_lwd"), 1), "\n")
    cat("panel_lty .... Panel border line type ... ",
        getOption("panel_lty"), "\n")

    cat("\n")
    cat("DATA OBJECTS\n")
    cat("bar_fill ......... Bar fill color ............",
        .to_rgb(getOption("bar_fill")), "\n")
    cat("trans_bar_fill ... Bar fill transparency .....",
        .fmt(getOption("trans_bar_fill"), 2), "\n")
    cat("bar_color ........ Bar border color ..........",
        .to_rgb(getOption("bar_color")), "\n")
    cat("labels ........... Form of bar or pie labels .",
        .to_str(getOption("labels")), "\n")
    cat("labels_color ..... Color of bar or pie labels .",
        .to_rgb(getOption("labels_color")), "\n")
    cat("labels_cex ....... Size of labels on bars, pie ",
        .to_num(getOption("labels_cex")), "\n")
    cat("labels_digits .... Decimal digits on bars, pie ",
        .to_num(getOption("labels_digits")), "\n")
    cat("labels_position .... Position of labels ...... ..",
        .to_str(getOption("labels_position")), "\n")

    cat("\n")
    cat("pt_fill .......... Point fill color ..........",
        .to_rgb(getOption("pt_fill")), "\n")
    cat("trans_pt_fill .... Point fill transparency .. ",
        .fmt(getOption("trans_pt_fill"), 2), "\n")
    cat("pt_color ......... Point border color ....... ",
        .to_rgb(getOption("pt_color")), "\n")
    cat("out_fill ......... Outlier point fill ....... ",
        .to_rgb(getOption("out_fill")), "\n")
    cat("out_color ........ Outlier point color ...... ",
        .to_rgb(getOption("out_color")), "\n")
    cat("out2_fill ........ Extreme outlier point fill ",
        .to_rgb(getOption("out2_fill")), "\n")
    cat("out2_color ....... Extreme outlier point color",
        .to_rgb(getOption("out2_color")), "\n")
    cat("violin_fill ...... Violin fill color .........",
        .to_rgb(getOption("violin_fill")), "\n")
    cat("violin_color ..... Violin border color .......",
        .to_rgb(getOption("violin_color")), "\n")
    cat("box_fill ......... Boxplot fill color ........",
        .to_rgb(getOption("box_fill")), "\n")
    cat("box_color ........ Boxplot border color ......",
        .to_rgb(getOption("box_color")), "\n")
    cat("fit_color ........ Fit line_color ........... ",
        .to_rgb(getOption("fit_color")), "\n")
    cat("se_fill .......... Stnd error fill color .... ",
        .to_rgb(getOption("se_fill")), "\n")
    cat("ellipse_fill ..... Ellipse fill color ....... ",
        .to_rgb(getOption("ellipse_fill")), "\n")
    cat("ellipse_color .... Ellipse border color ..... ",
        .to_rgb(getOption("ellipse_color")), "\n")
    cat("ellipse_lwd ...... Ellipse border width ..... ",
        .fmt(getOption("ellipse_lwd"), 2), "\n")
    cat("bubble_text_color  Bubble text color .........",
        .to_rgb(getOption("bubble_text_color")), "\n")
    cat("segment_color .... Line segment color ........",
        .to_rgb(getOption("segment_color")), "\n")
    cat("heat ............. Heat map color ............",
        .to_rgb(getOption("heat")), "\n")

    cat("\n")
    cat("AXES\n")
    cat("axis_color ..... Color of axes ..............",
        .to_rgb(getOption("axis_color")), "\n")
    cat("axis_x_color ... Color of x-axis ............",
        .to_rgb(getOption("axis_x_color")), "\n")
    cat("axis_y_color ... Color of y-axis ............",
        .to_rgb(getOption("axis_y_color")), "\n")

    cat("axis_lwd ....... Axis line width ............", 
      .to_num(getOption("axis_lwd")), "\n")
    cat("axis_x_lwd ..... x-axis line width ..........", 
      .to_num(getOption("axis_x_lwd")), "\n")
    cat("axis_y_lwd ..... y-axis line width ..........", 
      .to_num(getOption("axis_y_lwd")), "\n")

    cat("axis_lty ....... Line type of axes ..........",
      .to_str(getOption("axis_lty")), "\n")
    cat("axis_x_lty ..... Line type of x-axis ........", 
      .to_str(getOption("axis_x_lty")), "\n")
    cat("axis_y_lty ..... Line type of y-axis ........", 
      .to_str(getOption("axis_y_lty")), "\n")

    cat("axis_size ...... Font size of axis value text ......",
        .to_num(getOption("axis_size"), 2), "\n")
    cat("axis_x_size .... Font size of x-axis value text ...",
        .to_num(getOption("axis_x_size"), 2), "\n")
    cat("axis_y_size .... Font size of y-axis value text ...",
        .to_num(getOption("axis_y_size"), 2), "\n")
    cat("axis_text_color  x and y axis values text color ...",
        .to_rgb(getOption("axis_text_color")), "\n")
    cat("axis_x_text_color  x-axis values text color .......",
        .to_rgb(getOption("axis_x_text_color")), "\n")
    cat("axis_y_text_color  y-axis values text color .......",
        .to_rgb(getOption("axis_y_text_color")), "\n")
    cat("rotate_x ....... Rotation of x axis text ..........",
        .fmt(getOption("rotate_x"), 2), "\n")
    cat("rotate_y ....... Rotation of y axis text ..........",
        .fmt(getOption("rotate_y"), 2), "\n")
    cat("offset ......... Offset of values text from axis ..",
        .fmt(getOption("offset"), 2), "\n")

    cat("\n")
    cat("LABELS\n")
    cat("lab_color ...... Color of axis labels .............",
        .to_rgb(getOption("lab_color")), "\n")
    cat("lab_x_color .... Color of x-axis label ............",
        .to_rgb(getOption("lab_x_color")), "\n")
    cat("lab_y_color .... Color of y-axis label ............",
        .to_rgb(getOption("lab_y_color")), "\n")
    cat("lab_size ....... Font size of axis labels ..........",
        .to_num(getOption("lab_size"),2), "\n")
    cat("lab_x_size ..... Font size of x-axis label .........",
        .to_num(getOption("lab_x_size"),2), "\n")
    cat("lab_y_size ..... Font size of y-axis label .........",
        .to_num(getOption("lab_y_size"),2), "\n")
    cat("main_color ..... Color of plot label ..............",
        .to_rgb(getOption("main_color")), "\n")
    cat("main_size ...... Font size of plot title ...........",
        .to_num(getOption("main_size"),2), "\n")

    cat("\n")
    cat("GRID LINES\n")
    cat("grid_color .... Grid color ......................",
        .to_rgb(getOption("grid_color")), "\n")
    cat("grid_x_color .. Grid color, vertical ............",
        .to_rgb(getOption("grid_x_color")), "\n")
    cat("grid_y_color .. Grid color, horizontal ..........",
        .to_rgb(getOption("grid_y_color")), "\n")

    cat("grid_lwd ...... Grid line width .................",
        .fmt(getOption("grid_lwd"), 1), "\n")
    cat("grid_x_lwd .... Grid line width, vertical .......",
        .fmt(getOption("grid_x_lwd"), 1), "\n")
    cat("grid_y_lwd .... Grid line width, horizontal .....",
        .fmt(getOption("grid_y_lwd"), 1), "\n")

    cat("grid_lty ...... Grid line type ..................",
        .to_str(getOption("grid_lty")), "\n")
    cat("grid_x_lty .... Grid line type, vertical ........",
        .to_str(getOption("grid_x_lty")), "\n")
    cat("grid_y_lty .... Grid line type, horizontal ......",
        .to_str(getOption("grid_y_lty")), "\n")

    cat("\n")
    cat("TRELLIS STRIP\n")
    cat("strip_fill ...... Trellis strip fill color .....",
        .to_rgb(getOption("strip_fill")), "\n")
    cat("strip_color ..... Trellis strip border color ...",
        .to_rgb(getOption("strip_color")), "\n")
    cat("strip_text_color  Trellis strip text color .....",
        .to_rgb(getOption("strip_text_color")), "\n")

    cat("\n")
    cat("ANNOTATION\n")
    cat("add_fill  .. Fill color of annotated figures ..",
        .to_rgb(getOption("add_fill")), "\n")
    cat("add_trans .. Fill transparency ................",
        getOption("add_trans"), "\n")
    cat("add_color .. Color of annotated lines .........",
        getOption("add_color"), "\n")
    cat("add_size ... Size of annotated text ...........",
        .fmt(getOption("add_size"), 2), "\n")
    cat("add_lwd  ... Line width of annotated lines ....",
        .fmt(getOption("add_lwd"), 1), "\n")
    cat("add_lty  ... Line type of annotated lines .....",
        getOption("add_lty"), "\n")

    cat("\n")
    cat("NON-GRAPHICAL\n")
    cat("quiet ..... Suppress console output for many functions ..",
        getOption("quiet"), "\n")
    cat("brief ..... Reduce console output for many functions ....",
        getOption("brief"), "\n")
    cat("suggest ... Suggestions for enhanced input ..............",
        getOption("suggest"), "\n")
    cat("note ...... Notes for enhanced input ....................",
        getOption("note"), "\n")
    cat("width ..... Column width ................................",
        getOption("width"), "\n")
    cat("n_cat ..... Largest number of unique, equally spaced\n",
        "           integer values of a variable for which the\n",
        "           variable will be analyzed as categorical ....",
        getOption("n_cat"), "\n")
    cat("\n")

}

.reg.Rmd <-
function(nm, dname, fun_call, n_res_rows, n_pred_rows, res_sort, d.ancova,
         digits_d, results, explain, interpret, code,
         pvalues, tolerances, resid.max, X1_new,
         new.val=matrix(nrow=n.vars-1, ncol=2, byrow=TRUE),
         Rmd_data, Rmd_custom, Rmd_dir, Rmd_labels) {

  # simplify function call
  fncl <- .fun_call.deparse(fun_call) 
  if (regexec("Rmd", fncl)[1] > 0)     fc <- .rm.arg("Rmd", fncl) 
  if (regexec("explain", fc)[1] > 0)   fc <- .rm.arg.ns("explain", fc) 
  if (regexec("interpret", fc)[1] > 0) fc <- .rm.arg.ns("interpret", fc) 
  if (regexec("results", fc)[1] > 0)   fc <- .rm.arg.ns("results", fc) 

  n.vars <- length(nm)
  n.pred <- n.vars - 1


# ---------------------------
# functions to be interpreted
# ---------------------------

lbls <- function(the.lbl) {
  paste("\n------\n\n", "<span style='color:maroon;'>**", the.lbl,
                          "**</span>\n", sep="")
}

eq.model_b <- function() {
  cv <- paste("<span style='color:maroon;'>", "eq.model_b", "</span>")
  cv <- paste(cv, "$$\\hat Y_{", Y, "} = b_0 + b_1 X_{", nm[2], "}", sep="")
  if (n.vars > 2)
    for (i in 3:n.vars)
      cv <- paste(cv, " + b_", i-1, " X_{", nm[i], "}", sep="")
  cv <- paste(cv, "$$", sep="")
}

eq.model_beta <- function() {
  cv <- paste("<span style='color:maroon;'>", "eq.model_beta", "</span>")
  cv <- paste(cv, 
              "$$\\hat Y_{", Y, "} = \\beta_0 + \\beta_1 X_{", nm[2], "}", 
               sep="")
  if (n.vars > 2)
    for (i in 3:n.vars)
      cv <- paste(cv, " + \\beta_", i-1, " X_{", nm[i], "}", sep="")
  cv <- paste(cv, "$$", sep="")
}

eq.model_est <- function() {
  cv <- paste("<span style='color:maroon;'>", "eq.model_est", "</span>")
  cv <- paste(cv,
"$$\\hat Y_{", Y, "} = `r xP(r$coefficients[1],", d_d, ")` ", 
"`r ifelse(sign(r$coefficients)==1, \"+\", \"-\")[2]` ",
"`r xP(abs(r$coefficients[2]),", d_d, ")` X_{", nm[2], "}", 
sep="")
  if (n.vars > 2) {
    for (i in 3:n.vars)
      cv <- paste(cv,
"`r ifelse(sign(r$coefficients)==1, \"+\", \"-\")[", i, "]` ",
" `r xP(abs(r$coefficients[", i, "]),", d_d, ")`",
" X_{", nm[i], "}", "\n",
sep="")
  }
  cv <- paste(cv, "$$")
  return(cv)
}

eq.resid <- function() {
  cv <- paste("<span style='color:maroon;'>", "eq.resid", "</span>")
  cv <- paste(cv, "$$e_i = Y_i - \\hat Y_i$$", sep="")
}

in.read <- function() {
  out <- paste("<span style='color:maroon;'>", "in.read", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, dname, " <- ", rdcall, "\n", sep="")
  out <- paste(out, "```", "\n", sep="")
}

in.reg <- function() {
  locTRUE <- regexec("graphics = TRUE", fc)
  if (locTRUE == -1) {
    loc <- regexec("graphics = FALSE", fc)
    if (loc == -1) fc <- sub(")$", ", graphics = FALSE)", fc)
  }
  out <- paste("<span style='color:maroon;'>", "in.reg", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "r <-", fc, "\n", sep="")
  out <- paste(out, "```", "\n", sep="")
}

out.bck <- function() {
  out <- paste("<span style='color:maroon;'>", "out.bck", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "r$out_background", "\n", sep="")
  out <- paste(out, "```", "\n", sep="")
}

out.ANOVA <- function() {
  out <- paste("<span style='color:maroon;'>", "out.ANOVA", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "r$out_anova", "\n", sep="")
  out <- paste(out, "```", "\n", sep="")
}

out.estimates <- function() {
  out <- paste("<span style='color:maroon;'>", "out.estimates", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "r$out_estimates", "\n", sep="")
  out <- paste(out, "```", "\n", sep="")
}

plot.scatter <- function() {
  out <- "\n"
  out <- paste(out, "```{r echo=FALSE}\n", sep="")
  out <- paste(out, "regPlot(r, 1, d.ancova, pred.intervals=FALSE)\n", sep="")
  out <- paste(out, "```", "\n", sep="")
}

plot.sp_pred <- function() {
  out <- "\n"
  out <- paste(out, "```{r echo=FALSE}\n", sep="")
  out <- paste(out, "regPlot(r, 1, d.ancova, pred.intervals=TRUE)\n", sep="")
  out <- paste(out, "```", "\n", sep="")
}

plot.resids_dist <- function() {
  out <- "\n"
  out <- paste(out, "```{r echo=FALSE}\n", sep="")
  out <- paste(out, "regPlot(r, 2, d.ancova)\n", sep="")
  out <- paste(out, "```", "\n", sep="")
}

plot.fitted_resids <- function() {
  out <- "\n"
  out <- paste(out, "```{r echo=FALSE}\n", sep="")
  out <- paste(out, "regPlot(r, 3, d.ancova)\n", sep="")
  out <- paste(out, "```", "\n", sep="")
}

out.collinear <- function() {
  out <- paste("<span style='color:maroon;'>", "out.collinear", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "r$out_collinear", "\n", sep="")
  out <- paste(out, "```", "\n", sep="")
}

eq.decomp <- function() {
  out <- paste("<span style='color:maroon;'>", "eq.decomp", "</span>")
  out <- paste(out, "$$SS_{", `Y`, "} = SS_{Model} + SS_{Residual}")
  out <- paste(out, " = `r xP(r$anova_model[\"ss\"],", d_d, ")`", sep="")
  out <- paste(out, " + `r xP(r$anova_residual[\"ss\"],", d_d, ")`", sep="")
  out <- paste(out, 
             "= `r xP(r$anova_total[\"ss\"],", d_d,",", uYq, ", semi=TRUE)` $$")
}

eq.model_decomp <- function() {
  out <- paste("<span style='color:maroon;'>", "eq.model_decomp", "</span>")
  out <- paste(out, "$$SS_{Model}")
  for (i in 2:n.vars) out <- paste(out, " + SS_{", nm[i], "}", sep="")
  out <- paste(out, " = `r xP(r$anova_model[\"ss\"],", d_d, ")`$$", sep="")
  out <- sub("+", "=", out, fixed=TRUE)
}

eq.se <- function() {
  out <- paste("<span style='color:maroon;'>", "eq.se", "</span>")
  out <- paste(out, "$$s_e = ")
  out <- paste(out, "\\sqrt{MS_{Residual}} = ")
  out <- paste(out, "\\sqrt{`r xP(r$anova_residual[\"ms\"],", d_d, ")`} = ",
               sep="")
  out <- paste(out, "`r xP(r$se,", d_d, ",", uYq, ", semi=TRUE)`$$", sep="")
}

eq.se_range <- function() {
  out <- paste("<span style='color:maroon;'>", "eq.se_range", "</span>")
  out <- paste(out, "$$95\\% \\; Range \\; of \\; Variation:",
               "2 * t_{cutoff} * s_e = ")
  out <- paste(out, "2 * `r xP(-qt(0.025, df=r$anova_residual[\"df\"]),3)` * `r xP(r$se,", d_d, ")`")
  out <- paste(out, "= `r xP(r$resid_range,", d_d, ",", uYq, ", semi=TRUE)`$$", sep="")
}

eq.R2 <- function() {
  out <- paste("<span style='color:maroon;'>", "eq.R2", "</span>")
  out <- paste(out, "$$R^2 = 1 - \\frac{SS_{Residual}}{SS_{", Y, "}} = ")
  out <- paste(out, "1 - \\frac{`r xP(r$anova_residual[\"ss\"],", d_d, ")`} ")
  out <- paste(out, "{`r xP(r$anova_total[\"ss\"],", d_d, ")`} = ")
  out <- paste(out, "`r xP(r$Rsq,3)` $$ ") 
}

eq.R2adj <- function() {
  out <- paste("<span style='color:maroon;'>", "eq.R2adj", "</span>")
  out <- paste(out, "$$R^2_{adj} = 1 - \\frac{MS_{Residual}}{MS_{", Y, "}} = ")
  out <- paste(out, "1 - \\frac{SS_{Residual} \\; / \\; 
                    `r r$anova_residual[\"df\"]`} {SS_{", Y, "} \\; / \\;
                    `r r$anova_total[\"df\"]`} = ")
  out <- paste(out, "1 - \\frac{`r xP(r$anova_residual[\"ms\"],", d_d, ")`} ")
  out <- paste(out, "{`r xP(r$anova_total[\"ms\"],", d_d, ")`} = ")
  out <- paste(out, "`r xP(r$Rsqadj,3)` $$ ") 
}

eq.R2press <- function() {
  out <- paste("<span style='color:maroon;'>", "eq.R2press", "</span>")
  out <- paste(out, "$$R^2_{PRESS} = 1 - \\frac{SS_{PRE}}{SS_{", Y, "}} = ")
  out <- paste(out, "1 - \\frac{`r xP(r$PRESS,", d_d, ")`} ",
                    "{`r xP(r$anova_total[\"ss\"],", d_d, ")`} = ", sep="")
  out <- paste(out, "`r xP(r$RsqPRESS,3)` $$ ") 
}

eq.multNull <- function() {
  cv <- paste("\\beta_{", nm[2], "} = \\beta_{", nm[3], "}", sep="")
  if (n.vars > 2)
    for (i in 4:n.vars)
      cv <- paste(cv, " = \\beta_{", nm[i], "}", sep="")
  out <- paste("<span style='color:maroon;'>", "eq.multNull", "</span>")
  out <- paste(out, "\n",
"\\begin{aligned}\n",
"H_0&: \\;", cv, "= 0\\\\",
"H_1&: \\; at \\; least \\;  one \\;  \\beta_j \\ne 0",
"\\end{aligned}"
) 
}

eq.mult2Null <- function() {
  cv <- paste("\\beta_{", nm[n.vars-1], "} = \\beta_{", nm[n.vars], "}", sep="")
  out <- paste("<span style='color:maroon;'>", "eq.mult2Null", "</span>")
  out <- paste(out, "\n$$\n",
"\\begin{aligned}\n",
"H_0&: \\;", cv, "=0\\\\",
"H_1&: \\; at \\; least \\;  one \\;  \\beta_j \\ne 0",
"\\end{aligned}\n",
"$$") 
}

in.nest <- function() {
  cv <- "n <- Nest("
  cv <- paste(cv, nm[1], ", c(", sep="")
  for (i in 2:(n.vars-2)) {
    txt <- ","
    if (i == n.vars-2) txt <- ")"
    cv <- paste(cv, nm[i], txt, sep="")
  }
  cv <- paste(cv,", c(", nm[n.vars-1], ", ", nm[n.vars],"))", sep="")
  out <- paste("<span style='color:maroon;'>", "in.nest", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, cv, "\n", sep="") 
  out <- paste(out, "```", "\n", sep="")
}

out.fit <- function() {
  out <- paste("<span style='color:maroon;'>", "out.fit", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "r$out_fit", "\n")
  out <- paste(out, "```", "\n", sep="")
}

out.nest <- function() {
  out <- paste("<span style='color:maroon;'>", "out.nest", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "n$out_models", "\n")
  out <- paste(out, "```", "\n", sep="")
}

out.av_nest <- function() {
  out <- paste("<span style='color:maroon;'>", "out.av_nest", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "n$out_anova", "\n")
  out <- paste(out, "```", "\n", sep="")
}

out.predict <- function() {
  out <- paste("<span style='color:maroon;'>", "out.predict", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "r$out_predict", "\n")
  out <- paste(out, "```", "\n", sep="")
}

out.subsets <- function() {
  out <- paste("<span style='color:maroon;'>", "out.subsets", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "r$out_subsets", "\n")
  out <- paste(out, "```", "\n", sep="")
}

out.residuals <- function() {
  out <- paste("<span style='color:maroon;'>", "out.residuals", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "r$out_residuals", "\n")
  out <- paste(out, "```", "\n", sep="")
}

eq.s_pred <- function() {
  out <- paste("<span style='color:maroon;'>", "eq.s_pred", "</span>")
  out <- paste(out, "$$s_{\\hat Y_{p,i}} = \\sqrt{s^2_e + s^2_{\\hat Y_{p,i}}}$$")
}

intr.tolerance <- function() {
      out <- ""
      l20 <- length(which(tolerances < 0.20))
      if (l20 > 1)
        hh <- "s have tolerances"
      else
        hh <- " has a tolerance"

      if (l20 > 0)
        out <- paste(
"Collinearity is indicated. ", 
xU(xNum(l20)), " variable", hh, " less than the ", 
"cutoff of 0.20: ",  # r$tolerances has no names, so get them at r$model
"`r xAnd(names(r$model[which(r$tolerances < 0.20) + 1]))`.", sep="")

      l2030 <- length(which(tolerances >= 0.20 & tolerances < 0.30))
      if (l2030 > 1)
        hh <- "s have tolerances"
      else
        hh <- " has a tolerance"

      if (l2030 > 0) 
         out <- paste(out,
xU(xNum(l2030)), " variable", hh, " greater than the ", 
"cutoff of 0.20, but still somewhat low, less than 0.30: ",
"`r xAnd(names(r$model[which(r$tolerances >= 0.20 & r$tolerances < 0.30) + 1]))`. ",
sep="")

      if (length(which(tolerances < 0.30)) == 0)
        out <- paste(out,
"No collinearity exists according to the tolerance cutoff of 0.30. ",
sep="")

      pl2 <- ifelse (length(which(tolerances == min(tolerances))) > 1, "s", "")
      vrb <- ifelse (length(which(tolerances == min(tolerances))) > 1,
                     "are", "is")

      out <- paste(out, " ",
"The predictor variable", pl2, " with the lowest tolerance ", vrb, " ",
"`r xAnd(names(r$model[which(r$tolerances == min(r$tolerances)) + 1]))` at ",
"`r xP(min(r$tolerances),3)`.",
sep="")
}

intr.max_influence <- function() {
    cv <- character(10)
    cv[1] <- paste("`r xP(r$resid.max[1],3)`", sep="")
    for (i in 2:4)
      cv <- paste(cv, ", `r xP(r$resid.max[", i, "],3)`", sep="")
    cv <- paste(cv, " and `r xP(r$resid.max[5],3)`.", sep="")
    

    if (res_sort == "cooks") txt <- "Cook's distances"
    else if (res_sort == "rstudent") txt <- "Studentized residuals" 
    else if (res_sort == "dffits") txt <- "dffits values" 
 
      out <- paste(
"From this analysis, the largest ", txt, ": ", cv,
sep="")
}

intr.threshold_influence <- function() {
    lbl <- xRow(resid.max)
    if (res_sort == "cooks"  && (length(which(resid.max > 1)) > 0))
      out <- paste(
"The following case", hh, " more than the ", 
"cutoff of 1: ", xAnd(lbl[which(resid.max > 1)]), ". ",
sep="")

    if (res_sort == "cooks"  && (length(which(resid.max > 1)) == 0))
      out <- paste(
"No cases have a Cook's distance larger than 1 in this analysis. ", 
sep="")
}

in.new_data <- function() {
  out <- paste("<span style='color:maroon;'>", "in.new_data", "</span>  \n")
  for (i in 1:n.pred) {
      out <- paste(out,
        pred[i], ": ", new.val[i,1], ", ", new.val[i,2], "  \n", sep="")
  }
  return(out)
}

in.reg_new <- function() {
  locTRUE <- regexec("graphics = TRUE", fc)
  if (locTRUE == -1) {
    loc <- regexec("graphics = FALSE", fc)
    if (loc == -1) fc <- sub(")$", ", graphics = FALSE)", fc)
  }
  cv <- ",\n        "
  for (i in 1:n.pred)
    cv <- paste(cv,
" X", i, "_new=c(", new.val[i,1], ",", new.val[i,2], ")",
ifelse(i == n.pred, "", ","), 
sep="")
#   cv <- paste(cv, ",\n         graphics = FALSE", sep="")
    fc <- sub(")", paste(cv, ")", sep=""), fc, fixed=TRUE)
  out <- paste("<span style='color:maroon;'>", "in.reg_new", "</span>\n")
  out <- paste(out, "```{r", show, "}", "\n", sep="")
  out <- paste(out, "r <-", fc, "\n", sep="")
  out <- paste(out, "```", "\n", sep="")
}


intr.CI_nosig <- function() {
  gt05 <- length(which(pvalues[2:length(pvalues)] > 0.05)) 
  if (gt05 > 0) {
    if (gt05  > 1) {
      txt1 <- "these"
      txt3 <- "have _p_-values"
      txt5 <- "each "
      pl2 <- "s"
    }
    else {
      txt1 <- "this"
      txt3 <- "has a _p_-value"
      txt5 <- "the "
      pl2 <- ""
    }
    out <- paste(xU(xNum(gt05)), " predictor variable", pl2, " ", txt3,
           " larger than ", "$\\alpha$ = 0.05: ", 
           "_`r xAnd(names(which(r$pvalues[2:length(r$pvalues)] > 0.05)))`_. ", 
           sep="")
    out <- paste(out, xU(txt5), "null hypothesis of no ",
"relationship could not be rejected, so there is a reasonable possibility ",
"that ", txt5, " predictor variable may not contribute to ",
"explaining the values of ", Y, cnst, ". ", sep="")
  }  #  p > .05
}

intr.CI_sig <- function() {
  out <- ""  # no significant predictors: return.value when n.sig == 0
  n.sig <- length(which(pvalues[2:length(pvalues)] <= 0.05))
  if (n.sig > 0) {
    if (length(which(pvalues[2:length(pvalues)] <= 0.05)) > 1) {
      txt1 <- "These predictor variables each have "
      txt2 <- "their"
      txt3 <- "these corresponding slope coefficients"
      txt4 <- "these"
      pl3 <- "s"
    }
    else {
      txt1 <- "This predictor variable has "
      txt2 <- "its"
      txt3 <- "this corresponding slope coefficient"
      txt4 <- "this"
      pl3 <- ""
    }
    out <- paste("\n",
txt1, "a _p_-value less than or equal to $\\alpha$ = 0.05: ", 
"_`r xAnd(names(which(r$pvalues[2:length(r$pvalues)] <= 0.05)))`_. ",
sep="")

      if (n.pred > 1  && n.sig < n.pred)
        out <- paste(out,
"The possibility should be further explored in the remainder of this ",
"analysis that ", txt4," ", xNum(n.sig), " variable", pl3, " ", 
"may form an equally effective ",
"but more parsimonious model in terms of ", txt2, " ",
"cumulative contribution to explaining the values of ", Y, ", ", 
"compared to the current model with ", xNum(n.pred), " predictor variables. ", 
sep="")

      out <- paste(out, "\n\n",
"To extend the ",
"results beyond this sample to the population from which the sample ",
"was obtained, interpret the meaning of ", txt3, " ",
"in terms of ", txt2, " confidence interval", pl3, ". ",
sep="")

      # response variable labels
      txtY <- Y
      if (!is.null(l)) {
        txtY <- l[which(row.names(l) == Y), "label"] 
        if (length(txtY) == 0) txtY <- Y
      }

      # response variable units
      if (!is.null(l)  &&  ncol(l) == 2) {
        uY <- l[which(row.names(l) == Y), "unit"]
        if (length(uY) == 0)  uY <- ""
        uYq <- paste("\"", uY, "\"", sep="")  # unit with quotes
        if (uY != "dollar") {
          if (uY != "")
            txtY <- paste("the value of", uY, "of", txtY)
          else
            txtY <- paste("the value of", txtY)
        }
      }
      else
        uYq <- ""

      # identify significant predictors
      for (i in 1:n.sig) {
        j <- which(pvalues[2:length(pvalues)] <= 0.05)[i]
        if (n.pred > 1)
          out <- paste(out, "\n\n", "- _", pred[j], "_: ", sep="")

        # significant predictor j variable labels
        if (!is.null(l)) {
          txtX <- l[which(row.names(l) == pred[j]), "label"]
          if (length(txtX) == 0) txtX <- pred[j]
        } 
        else
          txtX <- pred[j]

        # significant predictor j variable units
        if (!is.null(l)  &&  ncol(l) == 2) {
          uX <- l[which(row.names(l) == pred[j]), "unit"]
          if (length(uX) == 0) uX <- "unit"
        }
        else
          uX <- "unit" 

        txt <- paste(uX, " of ", txtX)

        out <- paste(out,
"With 95% confidence, for each additional ",
txt,
", on average, ", txtY, " changes somewhere between ",
"`r xP(r$cilb[", j+1, "],", d_d, ",", uYq, ")`", " to ",
"`r xP(r$ciub[", j+1, "],", d_d, "," ,uYq, ")`",
sep="") 
        remn <- sub(pred[j], "", pred)  # leaves an empty vector value
        remain <- character(length=0)
        for (k in 1:n.pred)  # collate into a single string
          if (nzchar(remn[k])) remain[length(remain)+1] <- remn[k]
        remain <- xAnd(remain)
        if (n.pred > 1)
          out <- paste(out, ", with the values of ",
            remain, " held constant", sep="")
        out <- paste(out, ".", sep="")
      }  #  i in n.sig

  }  #  n.sig > 0, i.e., at least one predictor significant

  else
    uYq <- ""

  return(out)
}

  # ----------------------------------------------------------
  # set values for symbols to be interpreted in input markdown
  # ----------------------------------------------------------

  # input markdown is sent to .RmdParse(), which processes the input
  #  including providing the values for all defined symbols, and then
  #  returns the processed input to this function, which then outputs
  #  to the R markdown document

  uYq <- ""  # initialize in case interpret=FALSE, so not used

  # internal
  d_d <- digits_d  # needed here for internal to function calls
  pred <- character(length=0)
  for (i in 1:n.pred) pred[i] <- nm[i+1]

  # for users
  Y <- nm[1]
  X <- xAnd(pred)
  W_n.vars <- xNum(n.vars)
  W_n.pred <- xNum(n.pred)

  if (n.pred > 1) {
    et <- "each "
    et.c <- "Each "
    pl <- "s" 
    cnst <- ", with the values of all remaining predictor variables held constant"
    mult <- paste("through $b_", n.pred, "$", sep="")
  }
  else {
    et <- "the "
    et.c <- "The"
    pl <- ""
    cnst <- ""
    mult <- ""
  }


  # --------------------------------------
  # get variable labels and units if exist
  # --------------------------------------

  l.name <- "l"
  if (l.name %in% ls(name=.GlobalEnv)) {
    l <- get(l.name, pos=.GlobalEnv)
    n.lbls <- length(which(row.names(l) %in% nm))
    var.lbl <- character(length=0)
    # var.unit <- character(length=0)
    for (i in 1:n.lbls) {
      i.row <- which(row.names(l) == nm[i])
      if (length(i.row) > 0) if (is.numeric(i.row)) if (all(!is.na(l[i.row, ])))
        var.lbl[i] <- l[i.row,1]

      myunits <- NULL
      #myunits <- attr(get(dname, pos=.GlobalEnv), which="variable.units")
      #if (!is.null(myunits))
    }
  }
  else {
    l <- NULL
    var.lbl <- NULL
    myunits <- NULL
  }
 

  # ------------------------------------------
  # flags to use default input or custom input
  # ------------------------------------------

  alt1Intro <-  ifelse ("1Intro" %in% Rmd_custom, TRUE, FALSE)
  alt2Data <-  ifelse ("2Data" %in% Rmd_custom, TRUE, FALSE)
  alt3Model <-  ifelse ("3Model" %in% Rmd_custom, TRUE, FALSE)
  alt4Fit <- ifelse ("4Fit" %in% Rmd_custom, TRUE, FALSE)
  alt5Rel <- ifelse ("5Rel" %in% Rmd_custom, TRUE, FALSE)
  alt6Infl <- ifelse ("6Infl" %in% Rmd_custom, TRUE, FALSE)
  alt7Pred <- ifelse ("7Pred" %in% Rmd_custom, TRUE, FALSE)
  alt8Valid <- ifelse ("8Valid" %in% Rmd_custom, TRUE, FALSE)


  # ----------------------
  # create R markdown file
  # ----------------------

  # front matter
  # ------------
  tx <- character(length = 0)

  tx[length(tx)+1] <- "---"
  tx[length(tx)+1] <- "output:"
  tx[length(tx)+1] <- "  html_document:"
  tx[length(tx)+1] <- "    toc: true"
  tx[length(tx)+1] <- "    toc_depth: 4"
  tx[length(tx)+1] <- "    fig_height: 4.5"
  tx[length(tx)+1] <- "    fig_width: 5.5"
# tx[length(tx)+1] <- ""
  if (n.pred > 1)
    tx[length(tx)+1] <- paste("title: \"Multiple Regression of ", nm[1],
                              "\"", sep="")
  else
    tx[length(tx)+1] <- paste("title: \"Regression of ", Y, " on ", X, "\"",
                               sep="")
  tx[length(tx)+1] <- "---"


  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "***"

  v <- packageVersion("lessR")
  tx[length(tx)+1] <- paste(
"_", format(Sys.time(), "%a %b %d, %Y at %H:%M"), " &nbsp; with ",
"lessR version ", v, "_",
sep="")

  tx[length(tx)+1] <- paste("\n",
"_Output Options: explain=", explain, ", interpret=", interpret,
", results=", results, ", code=", code, "_",
sep="")

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "***"


  tx[length(tx)+1] <- "```{r echo=FALSE}"
  tx[length(tx)+1] <- "suppressPackageStartupMessages(library(lessR))  # lessR"
  tx[length(tx)+1] <- "```"

  txtY <- ""
  if (!is.null(var.lbl)) {
    if (!is.na(var.lbl[1])) {
      Ylbl <- var.lbl[1]
      txtY <- paste(", ", Ylbl, sep="")
    }
  }

  txtX <- ""
  if (n.pred == 1) {
    if (!is.null(var.lbl)) {
      if (!is.na(var.lbl[2])) {
        Xlbl <- var.lbl[2]
        txtX <- paste(", ", Xlbl, sep="")
      }
    }
  }  # end n.pred==1



  show <- ifelse (code, "", ", echo=FALSE")
  tx[length(tx)+1] <- paste("`r results  <- ", results, "`", sep="")
  tx[length(tx)+1] <- paste("`r explain  <- ", explain, "`", sep="")
  tx[length(tx)+1] <- paste("`r interpret  <- ", interpret, "`", sep="")


# 1 - Intro
# ---------

    if (Rmd_labels) tx[length(tx)+1] <- lbls("1Intro.txt")
    if (!alt1Intro) {
      sf <- system.file("Rmd/reg/1Intro.txt", package="lessR")
      tx[length(tx)+1] <- .RmdParse(sf, NULL, n.pred, explain, results, interpret)
    }
    else  # read and process alternate text
      tx[length(tx)+1] <- .RmdParse("1Intro.txt", Rmd_dir, n.pred,
                                 explain, results, interpret)



# 2 - Data
# --------


  if (is.null(Rmd_data)) 
    rdcall <- getOption("read.call")  # the last Read statement
  else 
    rdcall <- paste("Read(\"", Rmd_data, "\")", sep="")
  if (is.null(rdcall)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
       "To generate an R markdown file, first read the data for this\n",
       "regression analysis with the lessR function Read(), or\n",
       "specify a path name for  Rmd_data.\n\n",
       "ex:  d <- Read(\"\")\n\n")
  }

  if (code) {
    ref <- .get.arg("ref", rdcall)  # only works for Read, not rd or rd_brief
    if (ref %in% c("Employee", "Reading", "Cars93", "Jackets", "Learn", 
                   "Mach4", "BodyMeas", "StockPrice", "WeightLoss",
                   "Anova_1way", "Anova_2way")) {
      tx[length(tx)+1] <- paste(
"Here read from a data file included with the `lessR` package.",
sep="")
    } 
  }

  # get dname resolved to its value and pass the value into markdown
  tx[length(tx)+1] <- paste("`r data.in <- ", dname, "`", sep="")

  if (Rmd_labels) tx[length(tx)+1] <- lbls("2Data.txt")
  if (!alt2Data) {
    sf <- system.file("Rmd/reg/2Data.txt", package="lessR")
    tx[length(tx)+1] <- .RmdParse(sf, NULL, n.pred, explain, results, interpret)
  }
  else  # read and process alternate text
    tx[length(tx)+1] <- .RmdParse("2Data.txt", Rmd_dir, n.pred,
                               explain, results, interpret)



# 3 - Model
# ---------

  if (!alt3Model) {
    if (Rmd_labels) tx[length(tx)+1] <- lbls("3Model.txt")
    sf <- system.file("Rmd/reg/3Model.txt", package="lessR")
    tx[length(tx)+1] <- .RmdParse(sf, NULL, n.pred, explain, results, interpret)
  }
  else
    tx[length(tx)+1] <- .RmdParse("3Model.txt", Rmd_dir, n.pred,
                               explain, results, interpret)



# 4 - Fit
# -------

  if (Rmd_labels) tx[length(tx)+1] <- lbls("4Fit.txt")
  if (!alt4Fit) {
    sf <- system.file("Rmd/reg/4Fit.txt", package="lessR")
    tx[length(tx)+1] <- .RmdParse(sf, NULL, n.pred, explain, results, interpret)
  }
  else
    tx[length(tx)+1] <- .RmdParse("4Fit.txt", Rmd_dir, n.pred, explain,
                               results, interpret)


# 5 - Relations
# -------------

  if (nchar(uYq) == 0) uYq <- NULL

  tx[length(tx)+1] <- paste("`r d_d <-", d_d, "`")

  if (n.pred==1) {
    if (Rmd_labels) tx[length(tx)+1] <- lbls("5Relations1.txt")
    if (!alt5Rel) {
      sf <- system.file("Rmd/reg/5Relations1.txt", package="lessR")
      tx[length(tx)+1] <- .RmdParse(sf, NULL, n.pred, explain, results, interpret)
    }
    else
      tx[length(tx)+1] <- .RmdParse("5Relations1.txt", Rmd_dir, n.pred,
                                 explain, results, interpret)
  }

  else {  # multiple regression`
    if (Rmd_labels) tx[length(tx)+1] <- lbls("5RelationsM.txt")
    if (!alt5Rel) {
      sf <- system.file("Rmd/reg/5RelationsM.txt", package="lessR")
      tx[length(tx)+1] <- .RmdParse(sf, NULL, n.pred, explain, results, interpret)
    }
    else
      tx[length(tx)+1] <- .RmdParse("5RelationsM.txt", Rmd_dir, n.pred,
                                 explain, results, interpret)
  }

  
  if (n_res_rows > 0) {


# 6 - Influence
# -------------

    if (length(which(resid.max > 1)) > 1)
      hh <- "s have values"
    else
      hh <- " has a value"

  if (Rmd_labels) tx[length(tx)+1] <- lbls("6Influence.txt")
  if (!alt6Infl) {
    sf <- system.file("Rmd/reg/6Influence.txt", package="lessR")
    tx[length(tx)+1] <- .RmdParse(sf, NULL, n.pred, explain, results, interpret,
                               res_sort=res_sort)
  }
  else
    tx[length(tx)+1] <- .RmdParse("6Influence.txt", Rmd_dir, n.pred,
                               explain, results, interpret,
                               res_sort=res_sort)
  }  # n_res_rows > 0



#7 - Prediction
# -------------

  if (!is.null(uYq)) if (nchar(uYq) == 0) uYq <- NULL

  if (n_pred_rows > 0  && n.pred <= 6  &&  is.null(X1_new)) {
    tx[length(tx)+1] <- paste("`r uYq <- ", paste("\"", uYq, "\"`", sep=""), sep="")

    if (Rmd_labels) tx[length(tx)+1] <- lbls("7Prediction.txt")
    if (!alt7Pred) {
      sf <- system.file("Rmd/reg/7Prediction.txt", package="lessR")
      tx[length(tx)+1] <- .RmdParse(sf, NULL, n.pred, explain, results, interpret)
    }
    else
      tx[length(tx)+1] <- .RmdParse("7Prediction.txt", Rmd_dir, n.pred,
                                 explain, results, interpret)
  }



#8 - Validity
# -----------

  if (Rmd_labels) tx[length(tx)+1] <- lbls("8Validity.txt")
  if (!alt8Valid) {
    sf <- system.file("Rmd/reg/8Validity.txt", package="lessR")
    tx[length(tx)+1] <- .RmdParse(sf, NULL, n.pred, explain, results, interpret)
  }
  else
    tx[length(tx)+1] <- .RmdParse("8Validity.txt", Rmd_dir, n.pred,
                               explain, results, interpret)



  return(tx)

}

# parser called by .reg.Rmd() to process a file of marked text
.RmdParse <- function(f.name, path, n.pred=-1,
                   explain=NULL, results=NULL, interpret=NULL,
                   res_sort="") {
# path <- getwd()
  if (!is.null(path)) {  # a system file, spec includes full reference
    f.name <- file.path(path, f.name) 
  }
  txt <- readLines(f.name, skipNul=TRUE)  # read all lines in the file

  the.ln <- NULL
  i.line <- 0
  while (i.line < length(txt)) {
    i.line <- i.line + 1
    ln <- paste(txt[i.line], " ", sep="")  # the ith line of vector txt

    if (substr(ln, 1, 1) == "%") { next }  # comment, skip and go to next line 

    cl <- gregexec("`", ln)
    if (cl[[1]][1] != -1) {  # at least 1 var found in the.ln
      cols <- cl[[1]][1,]  # columns that contain vars marks
      n.sym <- length(cols) / 2  # symbol mark comes in pairs
      ind <- (1:length(cols)) %% 2
      c.evn <- cols[ind==0]  # even indices cols
      c.odd <- cols[ind==1]  # odd indices cols
      c.beg <- c(1, c.evn+1)
      c.end <- c(c.odd-1, nchar(ln))

      # sym is symbol, whatever is between ` and `
      for (i.sym in 1:n.sym) {  # process each var within the ith line
        chr <- substr(ln, c.beg[i.sym], c.end[i.sym])
        sym <- substr(ln, c.odd[i.sym]+1, c.evn[i.sym]-1)

        if (substr(sym, 1, 3) == "end") { next }  # end if-block 

        else  # a function
          if (substr(sym, 1,3) == "eq." || substr(sym, 1,4) == "out." ||
              substr(sym, 1,5) == "intr." || substr(sym, 1,5) == "plot." ||
              substr(sym, 1,3) == "in.")
            the.ln <- paste(the.ln, chr, eval.parent(as.name(sym), n=1)(),
                            sep="")

        else  # inline R expression
          if (substr(sym, 1,2) == "r ") {
            sym <- paste("`", sym, "`", sep="") 
            the.ln <- paste(the.ln, chr, sym, sep="")
          }

        else  # assignment statement
          if (grepl("<-", sym, fixed=TRUE))
            the.ln <- paste(the.ln, "\n```{r echo=FALSE}\n", sym, "\n", "```",
                            sep="")
        
        else  # header
          if (substr(sym, 1,1) == "#")
            the.ln <- paste(the.ln, chr, sym, "\n", sep="")

        else  # if block
          if (substr(sym, 1,2) == "if") {
            delete <- FALSE
            if (grepl("explain", sym)) if (!explain) delete <- TRUE
            if (grepl("results", sym)) if (!results) delete <- TRUE
            if (grepl("interpret", sym)) if (!interpret) delete <- TRUE
            if (grepl("n.pred=1", sym)) if (n.pred>1) delete <- TRUE
            if (grepl("n.pred>1", sym)) if (n.pred==1) delete <- TRUE
            if (grepl("n.pred>2", sym)) if (n.pred<=2) delete <- TRUE
            if (grepl("cooks", sym)) if (res_sort != "cooks") delete <- TRUE
            if (delete) {
              while (substr(txt[i.line], 1,4) != "`end")
                i.line <- i.line + 1
            }
          } 

        else  # a variable with an assigned value, such as a variable name
          the.ln <- paste(the.ln, chr, eval.parent(as.name(sym), n=1), sep="")

        if (i.sym == n.sym) {  # get any text past the last sym
          chr <- substr(ln, c.beg[n.sym+1], c.end[n.sym+1])
          the.ln <- paste(the.ln, chr, sep="")
         }

      }  # end each var one at a time on indx
    }  # end found vars on indx

    else { # no vars in the line
      if (ln == " ") ln <- "\n\n"
      the.ln <- paste(the.ln, ln, sep="")
    }
  }  # end line-by-line processing

  return(the.ln)
}

bubble.plotly <- function(
  x, x_name, y_name, by_name, x_lab, y_lab, main = NULL,
  fill, border, opacity,
  power, radius,
  digits_d = 0,
  labels = c("%", "input", "prop", "off"),
  labels_position = "in", labels_color, labels_size,
  labels_decimals = NULL,
  label_min_px = 26,
  label_autocontrast = TRUE,
  facet_tbls = NULL,     # named list of per-facet 1-D tables (faceted path)
  facet_name = NULL,     # display name for the facet variable
  facet_opts = .plotly_facet_opts(),
  style_opts = .plotly_style()
) {

  labels <- match.arg(labels)
  title.size <- round(16 * getOption("main_size", 1))

  # ---------- helpers ----------
  .pick_col <- function(v, i, key) {
    if (!length(v)) return("black")
    nms <- names(v)
    if (!is.null(nms) && length(nms) && key %in% nms) return(v[[key]])
    if (length(v) >= i) return(v[[i]])
    v[[ ((i - 1L) %% length(v)) + 1L ]]
  }

  dpi <- style_opts$plotly_dpi
  bubble.diam.builder <- function(all_values, power, radius, dpi) {
    v <- pmax(0, as.numeric(all_values))
    max.ru <- max(v^power, na.rm = TRUE)
    max.px.diam <- 2 * radius * dpi
    function(vals) {
      vals <- pmax(0, as.numeric(vals))
      if (!is.finite(max.ru) || max.ru <= 0) return(rep(0, length(vals)))
      max.px.diam * (vals^power) / max.ru
    }
  }

  alpha.fill <- if (is.null(opacity)) 0.85 else as.numeric(opacity)
  if (!is.finite(alpha.fill)) alpha.fill <- 0.85
  alpha.fill <- max(0, min(1, alpha.fill))

  # one palette color per category, keyed by category name so the same
  # category keeps the same hue across faceted panels
  build_1d_col_map <- function(cats) {
    n <- length(cats)
    ff <- if (is.null(fill)) .color_range(.get_fill(style_opts$theme), n)
          else              .color_range(fill, n)
    setNames(.to_hex(rep_len(as.character(ff), n)), cats)
  }

  # Render one 1-D bubble panel (categorical x, no by) from a named-numeric
  # table. diam_fun / col_map / max_diam are built once by the caller so
  # bubble sizes, colors, and stem heights stay comparable across panels.
  # Returns a plotly object with traces, stems, and axes (no title).
  render_1d_panel <- function(x, diam_fun, col_map, max_diam,
                              show_x_title = TRUE) {
    xv <- names(x)
    yv <- suppressWarnings(as.numeric(x))
    if (is.null(xv) || !length(xv)) xv <- as.character(seq_along(yv))
    df <- data.frame(..x = factor(xv, levels = xv), ..val = yv)

    total     <- sum(df$..val, na.rm = TRUE)
    share.tot <- if (total > 0) df$..val / total else rep(0, nrow(df))

    custom.rows <- Map(function(xc, pt)
        list(xcat = as.character(xc), bycat = "",
             pct_x = as.numeric(pt), pct_tot = as.numeric(pt)),
      df$..x, share.tot)

    diam.px    <- diam_fun(df$..val)
    border.hex <- .to_hex(border)
    fmt.val    <- .fmt(df$..val, d = digits_d)

    cat.hex          <- unname(col_map[as.character(df$..x)])
    labels.color.vec <- vapply(cat.hex, .contrast_text_for_hex, "",
                               USE.NAMES = FALSE)
    fill.rgba        <- .maketrans_plotly(cat.hex, alpha = alpha.fill)

    if (length(labels_color)) {
      labels.color.vec <- rep_len(.to_hex(labels_color),
                                  length(labels.color.vec))
    } else if (!isTRUE(label_autocontrast)) {
      labels.color.vec <- rep(NA_character_, length(labels.color.vec))
    }
    labels.color.vec[is.na(labels.color.vec)] <- "black"

    # "prop" plots proportions, which digits_d (0 for counts)
    # would flatten to "0"
    lbl.d <- if (!is.null(labels_decimals)) as.integer(labels_decimals)
             else if (identical(labels, "prop")) 2L
             else                           as.integer(digits_d)
    if (!identical(labels, "off")) {
      label.txt <- if (identical(labels, "input")) fmt.val
        else if (identical(labels, "%"))
          sprintf(paste0("%.", lbl.d, "f%%"), 100 * share.tot)
        else sprintf(paste0("%.", lbl.d, "f"), share.tot)
      label.show <- ifelse(is.finite(diam.px) & (diam.px >= label_min_px),
                           label.txt, "")
    } else {
      label.show <- rep("", length(fmt.val))
    }

    trace.mode <- if (identical(labels, "off")) "markers" else "markers+text"
    txt.pos    <- if (identical(tolower(as.character(labels_position[1])),
                                "in")) "middle center" else "top center"
    txt.size   <- round(14 *
                    (if (length(labels_size) && is.numeric(labels_size))
                       labels_size[1] else 1) *
                    getOption("axis_size", 0.9), 0)

    hover <- paste0(
      x_name, ": %{customdata.xcat}",
      "<br>", y_name, ": %{hovertext}",
      "<br>% of ", x_name, ": %{customdata.pct_x:.1%}",
      "<br>% of total: %{customdata.pct_tot:.1%}<extra></extra>"
    )

    plt <- plotly::plot_ly(hoverlabel = list(align = "left"))
    plt <- plotly::add_trace(
      plt,
      type = "scatter", mode = trace.mode,
      x = df$..x,
      y = rep(0, nrow(df)),                 # numeric (avoid category warnings)
      hovertext     = fmt.val,
      hovertemplate = hover,
      customdata    = custom.rows,
      marker = list(
        symbol   = "circle",
        size     = diam.px,
        sizemode = "diameter",
        color    = fill.rgba,
        line     = list(color = border.hex, width = 1),
        sizemin  = 12
      ),
      text         = label.show,
      textposition = txt.pos,
      textfont     = list(size = txt.size, color = labels.color.vec),
      cliponaxis   = FALSE,
      showlegend   = FALSE
    )

    # vertical stems from the plot bottom up to the base of each bubble.
    # Heights use the GLOBAL max diameter so panels stay comparable.
    target.r    <- 0.35
    md          <- if (is.finite(max_diam) && max_diam > 0) max_diam else 1
    radius.data <- (diam.px / md) * target.r
    y.top       <- target.r * 1.20
    seg.color   <- .to_hex(style_opts$grid_color)
    stem.shapes <- lapply(seq_len(nrow(df)), function(i)
      list(type  = "line",
           x0    = i - 1L, x1 = i - 1L, xref = "x",
           y0    = -1, y1 = -radius.data[i], yref = "y",
           line  = list(color = seg.color, width = 1),
           layer = "below"))

    plt <- plotly::layout(
      plt,
      xaxis = list(
        type     = "category",
        title    = list(
          text     = if (show_x_title) x_lab else "",
          standoff = 10,
          font     = list(size = round(15 * getOption("lab_size", 1)))
        ),
        showgrid = FALSE,
        zeroline = FALSE,
        showline = TRUE,
        ticks    = "outside",
        tickfont = list(size = round(16 * getOption("axis_size", 0.9)))
      ),
      yaxis = list(visible = FALSE, fixedrange = TRUE, range = c(-1, y.top)),
      shapes   = stem.shapes,
      template = NULL
    )

    plt$x$layout$plot_bgcolor  <- .to_hex(style_opts$panel_fill)
    plt$x$layout$paper_bgcolor <- .to_hex(style_opts$window_fill)
    plt
  }  # end render_1d_panel()

  # ---------- faceted 1-D path ----------
  # Grid of single-category bubble panels, one per facet level. Sizes and
  # colors are normalized globally; panels are assembled with subplot().
  if (!is.null(facet_tbls)) {
    fac.levels <- names(facet_tbls)
    n.fac      <- length(fac.levels)

    all.vals   <- unlist(lapply(facet_tbls, as.numeric), use.names = FALSE)
    diam.fun   <- bubble.diam.builder(all.vals, power, radius, dpi)
    max.diam   <- {
      m <- suppressWarnings(max(diam.fun(all.vals), na.rm = TRUE))
      if (is.finite(m) && m > 0) m else 1
    }
    # all panels share the same category levels (built with the global set)
    col.map    <- build_1d_col_map(names(facet_tbls[[1]]))

    panels <- lapply(facet_tbls, render_1d_panel,
                     diam_fun = diam.fun, col_map = col.map,
                     max_diam = max.diam, show_x_title = TRUE)

    n.col.use <- facet_opts$n_col %||% min(n.fac, facet_opts$n_col_max)
    n.row.use <- ceiling(n.fac / n.col.use)

    plt <- plotly::subplot(panels,
      nrows  = n.row.use, shareX = FALSE, shareY = FALSE,
      titleX = TRUE, titleY = FALSE, margin = 0.06)

    # subplot() assigns domains automatically; extract them and hand to the
    # shared facet-layout helper so annotation formatting matches hier/radar.
    sub.domains <- lapply(seq_along(fac.levels), function(i) {
      sfx <- if (i == 1L) "" else as.character(i)
      xax <- plt$x$layout[[paste0("xaxis", sfx)]]
      yax <- plt$x$layout[[paste0("yaxis", sfx)]]
      list(x = xax$domain %||% c(0, 1), y = yax$domain %||% c(0, 1))
    })
    ann <- .plotly_facet_layout(
      facet_levels = fac.levels,
      facet_name   = if (!is.null(facet_name) && nzchar(facet_name))
                       facet_name else "",
      domains      = sub.domains,
      yanchor      = "bottom",
      ann_adjust   = function(i, a, d) { a$y <- min(d$y[2] + 0.04, 0.99); a }
    )$annotations
    if (is.null(facet_name) || !nzchar(facet_name))
      ann <- lapply(seq_along(ann), function(i) {
        ann[[i]]$text <- fac.levels[i]; ann[[i]]
      })

    has.title <- !is.null(main) && length(main) && nzchar(main[1])
    plt <- plotly::layout(plt,
      annotations   = ann,
      margin        = list(
                        t = if (has.title) round(title.size * 2.4) else 40,
                        b = 8, l = 20, r = 20),
      showlegend    = FALSE,
      title         = if (has.title)
                        list(text = main[1], x = 0.5, xanchor = "center",
                             y = 0.98, yanchor = "top",
                             font = list(size = title.size))
                      else NULL,
      paper_bgcolor = .to_hex(style_opts$window_fill)
    )

    return(invisible(plt))
  }

  # ---------- single 1-D chart ----------
  one.d <- (length(dim(x)) == 0L) || (length(dim(x)) == 1L)
  if (one.d) {
    cats <- names(x)
    if (is.null(cats) || !length(cats)) cats <- as.character(seq_along(x))
    diam.fun <- bubble.diam.builder(as.numeric(x), power, radius, dpi)
    col.map  <- build_1d_col_map(cats)
    max.diam <- {
      m <- suppressWarnings(max(diam.fun(as.numeric(x)), na.rm = TRUE))
      if (is.finite(m) && m > 0) m else 1
    }

    plt <- render_1d_panel(x, diam.fun, col.map, max.diam, show_x_title = TRUE)

    if (!is.null(main) && length(main) && nzchar(main[1])) {
      plt <- plotly::layout(
        plt,
        title  = list(text = main[1], x = 0.5, xanchor = "center",
                      y = 0.98, yanchor = "top",
                      font = list(size = title.size)),
        margin = list(t = round(title.size * 2.2), r = 25, b = 30, l = 25)
      )
    }

    return(invisible(plt))
  }

  # ---------- 2-D data prep (x is a table or matrix) ----------
  if (is.table(x)) df <- as.data.frame(x)
  else if (is.matrix(x)) df <- as.data.frame(as.table(x))
  else stop("For 2-D bubble plot, x must be a table or matrix.")
  names(df)[1:3] <- c("..by", "..x", "..val")

  if (!is.null(rownames(x))) df$..by <- factor(df$..by, levels = rownames(x))
  else df$..by <- factor(df$..by)

  if (!is.null(colnames(x))) df$..x  <- factor(df$..x,  levels = colnames(x))
  else df$..x <- factor(df$..x)

  n.g <- nlevels(df$..by)
  if (is.null(fill)) {
    theme <- style_opts$theme
    fill <- .color_range(.get_fill(theme), n.g)
  } else {
    fill <- .color_range(fill, n.g)
  }

  # ---------- shares ----------
  total <- sum(df$..val, na.rm = TRUE)
  share.tot <- if (total > 0) df$..val / total else rep(0, nrow(df))
  col.tot <- tapply(df$..val, df$..x, sum, na.rm = TRUE)
  share.x <- df$..val / as.numeric(col.tot[as.character(df$..x)])
  share.x[!is.finite(share.x)] <- 0

  custom.rows <- Map(function(xc, yc, px, pt) {
    list(xcat = as.character(xc), bycat = as.character(yc),
         pct_x = as.numeric(px), pct_tot = as.numeric(pt))
  },
  df$..x, df$..by, share.x, share.tot)

  # ---------- sizes & colors ----------
  diam.fun   <- bubble.diam.builder(df$..val, power, radius, dpi)
  diam.px    <- diam.fun(df$..val)
  border.hex <- .to_hex(border)
  fmt.val    <- .fmt(df$..val, d = digits_d)

  col.map <- setNames(rep_len(as.character(fill), n.g), levels(df$..by))
  grp.hex <- .to_hex(unname(col.map))
  names(grp.hex) <- names(col.map)
  grp.text.col <- vapply(grp.hex, .contrast_text_for_hex, "", USE.NAMES = TRUE)
  labels.color.vec <- unname(grp.text.col[as.character(df$..by)])
  fill.rgba <- .maketrans_plotly(unname(col.map[as.character(df$..by)]),
                                 alpha = alpha.fill)

  if (length(labels_color)) {
    labels.color.vec <- rep_len(.to_hex(labels_color), length(labels.color.vec))
  } else if (!isTRUE(label_autocontrast)) {
    labels.color.vec <- rep(NA_character_, length(labels.color.vec))
  }

  # resolve decimal places for label text
  lbl.d <- if (!is.null(labels_decimals)) as.integer(labels_decimals)
           else                           as.integer(digits_d)

  if (!identical(labels, "off")) {
    if (identical(labels, "input")) {
      label.txt <- fmt.val
    } else if (identical(labels, "%")) {
      label.txt <- sprintf(paste0("%.", lbl.d, "f%%"), 100 * share.tot)
    } else {
      label.txt <- sprintf(paste0("%.", lbl.d, "f"), share.tot)
    }
    label.show <- ifelse(is.finite(diam.px) & (diam.px >= label_min_px),
                         label.txt, "")
  } else {
    label.show <- rep("", length(fmt.val))
  }

  trace.mode <- if (identical(labels, "off")) "markers" else "markers+text"

  txt.pos  <- if (identical(tolower(as.character(labels_position[1])), "in"))
                "middle center" else "top center"
  base.size <- 14
  txt.size  <- round(base.size *
                 (if (length(labels_size) && is.numeric(labels_size))
                    labels_size[1] else 1) *
                 getOption("axis_size", 0.9), 0)

  # replace any NA label colors with a safe default
  labels.color.vec[is.na(labels.color.vec)] <- "black"
  # IMPORTANT: do NOT create an empty trace up front (axis-type warnings)
  plt <- plotly::plot_ly(
    hoverlabel = list(align = "left")
  )

  hover <- paste0(
    x_name, ": %{customdata.xcat}",
    "<br>", by_name, ": %{customdata.bycat}",
    "<br>", y_name, ": %{hovertext}",
    "<br>% of ", x_name, ": %{customdata.pct_x:.1%}",
    "<br>% of total: %{customdata.pct_tot:.1%}<extra></extra>"
  )

  by.levels <- levels(df$..by)

  for (i in seq_along(by.levels)) {
    g <- by.levels[i]
    sel <- df$..by == g
    if (!any(sel)) next

    plt <- plotly::add_trace(
      plt,
      type = "scatter",
      mode = trace.mode,
      x = df$..x[sel],
      y = df$..by[sel],
      hovertext     = fmt.val[sel],
      hovertemplate = hover,
      customdata    = custom.rows[sel],
      marker = list(
        symbol   = "circle",
        size     = diam.px[sel],
        sizemode = "diameter",
        color    = fill.rgba[sel][1],
        line     = list(color = .to_hex(.pick_col(border, i, g)), width = 1)
      ),
      text         = label.show[sel],
      textposition = txt.pos,
      textfont     = list(size = txt.size, color = labels.color.vec[sel]),
      cliponaxis   = FALSE,
      showlegend   = FALSE
    )
  }

  plt <- plotly::layout(
    plt,
    xaxis = list(
      type      = "category",
      title     = list(
        text = x_lab,
        font = list(size = round(15 * getOption("lab_size", 1)))),
      showgrid  = TRUE,
      gridcolor = .to_hex(style_opts$grid_color),
      gridwidth = 1,
      zeroline  = FALSE,
      tickfont  = list(size = round(16 * getOption("axis_size", 0.9)))
    ),
    yaxis = list(
      type = "category",
      title = list(
        text = y_lab,
        font = list(size = round(15 * getOption("lab_size", 1)))),
      showgrid = FALSE,
      zeroline = FALSE,
      categoryorder = "array",
      categoryarray = rev(levels(df$..by)),
      tickfont = list(size = round(16 * getOption("axis_size", 0.9)))
    ),
    template = NULL,
    shapes = list(list(
      type = "rect",
      xref = "paper", yref = "paper",
      x0 = 0, x1 = 1, y0 = 0, y1 = 1,
      line = list(color = .to_hex(style_opts$panel_border), width = 1),
      layer = "below"
    ))
  )

  # backgrounds
  plt$x$layout$plot_bgcolor  <- .to_hex(style_opts$panel_fill)
  plt$x$layout$paper_bgcolor <- .to_hex(style_opts$window_fill)

  # title: only if main= is explicitly provided (default is none)
  if (!is.null(main) && length(main) && nzchar(main[1])) {
    plt <- plotly::layout(
      plt,
      title  = list(text = main[1], x = 0.5, xanchor = "center",
                    y = 0.98, yanchor = "top",
                    font = list(size = title.size)),
      margin = list(t = round(title.size * 2.2),
                    r = 25, b = 30, l = 25)
    )
  }

  invisible(plt)
}

scales <-
function(..., iter=0, resid=FALSE, item_cor=FALSE, sort=FALSE, heat_map=FALSE)

  corCFA(..., iter=0, resid=FALSE, item_cor=FALSE, sort=FALSE,
              heat_map=FALSE, fun_call=match.call())

SummaryStats <-
function(x=NULL, by=NULL, data=d, rows=NULL, n_cat=getOption("n_cat"), 
    digits_d=NULL, brief=getOption("brief"), label_max=20, ...)  {

  message(">>> Deprecated<<<\n\n",
      "New, more flexible replacement is the pivot() function.\n",
      "For inferential tests of proportions, the Prop_test() function.\n",
      "For explanation see the vignettes.\n\n",
      "Enter: browseVignettes(\"lessR\")\n",
      "Select: Summary Statistics with a Pivot Table\n",
      "Select: Proportion Inference\n\n")

  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (!is.null(dots)) if (length(dots) > 0) {
    for (i in 1:length(dots)) {
      if (names(dots)[i] == "values.cex")  labels_size <- dots[[i]]
      if (grepl(".", names(dots)[i], fixed=TRUE)) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
        get(nm)
      }
    }
  }

  # get variable name before potential call of data$x
  x.name <- deparse(substitute(x))  # could be a vars list
  options(xname = x.name)

  data.miss <- ifelse (missing(data), TRUE, FALSE) 

  # let deprecated mydata work as default
  dfs <- .getdfs() 
  mydata.ok <- FALSE
  if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
    d <- mydata
    df.name <- "mydata"
    mydata.ok <- TRUE
    options(dname = df.name)
  }
  if (!mydata.ok) {
    df.name <- deparse(substitute(data))  # get name of data table
    options(dname = df.name)
  }
  
  x.in.df <- FALSE
  if (nchar(x.name) > 0)
    if (exists(df.name, where=.GlobalEnv, inherits=FALSE))
      if (exists(x.name, where=data)) x.in.df <- TRUE
 
  # if a tibble convert to data frame
  if (df.name %in% ls(name=.GlobalEnv)) {  # tibble to df
   if (any(grepl("tbl", class(data), fixed=TRUE))) {
      data <- data.frame(data)
   }
  }

  is.df <- FALSE  # is data frame


  # evaluate by, i.e., get y.call
  if (!missing(by)) {

    # get actual variable name before potential call of data$x
    y.name <- deparse(substitute(by)) 
    options(yname = y.name)

    # see if y exists from a function call
    # indicate a function call with sys.frame returns larger than 1 
    if (exists(y.name, where=parent.frame(n=1)) && sys.nframe() > 1) 
      in.call <- TRUE else in.call <- FALSE

    # get conditions and check for data existing
    if (!in.call)
      in.global <- df.or.global(y.name, df.name, role="by",
                                fun.name="SummaryStats")
    else
      in.global <- FALSE

    # see if var exists in data frame, if not in global env or function call
    if (!in.global && !in.call) .xcheck(y.name, df.name, names(data))

    if (!in.global) y.call <- eval(substitute(data$by))
    else {  # vars that are function names get assigned to global env
      y.call <- by
      if (is.function(y.call)) y.call <- eval(substitute(data$by))
    }
  }
  else
    y.call <- NULL


# -----------------------------------------------------------------
# establish if a data frame, if not then identify variable(s)

  if (!missing(x)) {

    # x not in global env, in df, specify data= forces to data frame
    if (!exists(x.name, where=.GlobalEnv) || x.in.df) {
      .nodf(df.name)  # check to see if data frame container exists     
      .xcheck(x.name, df.name, names(data))  # var in df?, vars lists not checked
      all.vars <- as.list(seq_along(data))  # even if only a single var
      names(all.vars) <- names(data)  # all data in data frame
      ind <- eval(substitute(x), envir=all.vars)  # col num selected vars
      if (!missing(rows)) {  # subset rows
        r <- eval(substitute(rows), envir=data, enclos=parent.frame())
        r <- r & !is.na(r)  # set missing for a row to FALSE
        data <- data[r,,drop=FALSE]
      }
      if (!("list" %in% class(data))) {
        data <- data[, ind]
        if (length(ind) == 1) {  # x is 1 var
          data <- data.frame(data, stringsAsFactors=TRUE)
          names(data) <- x.name
         }
      }
      else {  # class of data is "list"
        data <- data.frame(data[[ind]], stringsAsFactors=TRUE)
        names(data) <- x.name
      }
    }

    else {  # x is in the global environment (vector or data frame)
      if (is.data.frame(x))  # x a data frame
        data <- x
      else {  # x a vector in global env
        .in.global(x.name, quiet=FALSE)  # stop if expression
        if (!is.function(x))
          data <- data.frame(x, stringsAsFactors=TRUE)  # x is 1 var
        else  # x is 1 var
          data <- data.frame(eval(substitute(data$x)), stringsAsFactors=TRUE)
        names(data) <- x.name
      }
    }

  }


# -----------------------------------------------------
# data is now set
# do the analysis for a single variable or a data frame 

  # see if a single variable is categorical; if so, make a factor
  if (ncol(data) == 1) {
    x.call <- data[,1]

    num.cat <- .is.num.cat(x.call, n_cat)
    nu <- length(unique(na.omit(x.call)))

    if (!num.cat && is.integer(x.call) && nu <= n_cat) {
      cat("\n")
      cat(">>> ", x.name, " has only only ", nu, " unique ",
          "integer values, but not equally spaced,\n",
          "      so treat as numerical in this analysis\n",
          "    Convert to an R factor to treat as categorical\n\n",
          sep="")
    }

    if (num.cat || is.character(x.call)) {
      x.call <- as.factor(x.call)
     .ncat("summary statistics", x.name, nu, n_cat)
    }
  }

  if (ncol(data) > 1)
    .ss.data.frame(data, n_cat, brief, ...) 

  else if (!is.factor(x.call)) {  # numeric analysis

    sk <- NA; kt <- NA; q1 <- NA; q3 <- NA;  qr <- NA;
    if (exists("y.name"))
      nm <- y.name
    else
      nm <- NULL
    stuff <- .ss.numeric(x.call, y.call, digits_d, brief, y.name=nm, ...)
    txsts <- stuff$tx
    txotl <- .bx.stats(x.call)$txotl

  }

  # ordered factors have two attributes, "ordered" and "factor"
  else {  # is.factor(x.call)

    gl <- .getlabels(graph.win=FALSE)
    x.name <- gl$xn; x.lab <- gl$xb; x.lbl <- gl$xl
    y.name <- gl$yn; y.lab <- gl$yb; y.lbl <- gl$yl

    stuff <- .ss.factor(x.call, y.call, brief, digits_d,
                      x.name, y.name, x.lbl, y.lbl, label_max, ...)

    n.dim <- stuff$n.dim
    if (n.dim == 1) {
      txttl <- stuff$title
      txsts <- stuff$counts
      txchi <- stuff$chi
      txlbl <- stuff$lbl
      frq <- stuff$freq
      prp <- stuff$prop
    }
    else if (n.dim == 2) {
      txttl <- stuff$txttl
      txXV <- stuff$txXV
      txfrq <- stuff$txfrq
      txprp <- stuff$txprp
      txcol <- stuff$txcol
      txrow <- stuff$txrow
    }
  }

  # else {
  #   cat("\n"); stop(call.=FALSE, "\n","------\n",
  #       "The variable to be analyzed must be numeric or a factor, or have\n",
  #       "character values that can be converted to a factor.\n")
  # }


  # not a data frame analysis
  if (ncol(data) == 1) { 

    if (!is.factor(x.call)) {
      class(txsts) <- "out"
      class(txotl) <- "out"

      output <- list(out_stats=txsts, out_outliers=txotl, n=stuff$n,
           n.miss=stuff$n.miss, mean=stuff$m, sd=stuff$s, skew=stuff$sk,
           kurtosis=stuff$kt, min=stuff$mn, quartile1=stuff$q1,
           median=stuff$md, quartile3=stuff$q3, max=stuff$mx, IQR=stuff$qr)
    }

    else {  # is.factor(x.call)
      if (n.dim == 1) {
        class(txttl) <- "out"
        class(txsts) <- "out"
        class(txchi) <- "out"
        class(txlbl) <- "out"
        output <- list(out_title=txttl, out_stats=txsts, out_chi=txchi,
                       out_lbl=txlbl, freq=frq, prop=prp)
      }
      else if (n.dim == 2) {
        class(txttl) <- "out"
        class(txfrq) <- "out"
        if (brief) {
          output <- list(out_title=txttl, out_freq=txfrq, out_chi=txXV)
        }
        else {
          class(txXV) <- "out"
          class(txprp) <- "out"
          class(txcol) <- "out"
          class(txrow) <- "out"
          output <- list(out_title=txttl, out_freq=txfrq, out_XV=txXV,
             out_prop=txprp, out_colsum=txcol, out_rowsum=txrow)
        }
      }
    }

    class(output) <- "out_all"

    return(output)

  }

}

Write <- 
function(data=d, to=NULL, 

         format=c("csv", "txt", "tsv", "prn",
                  "Excel", "ODS", "R", "SPSS", "feather", "parquet"),

         row_names=NULL, quote="if_needed", missing=NULL, dec=".", sep=NULL,  

         ExcelTable=FALSE, ExcelColWidth=TRUE,

         quiet=getOption("quiet"), ...) {


  format.miss <- ifelse (missing(format), TRUE, FALSE)
  format <- match.arg(format)

  in.df <- deparse(substitute(data))

  dots <- list(...)
  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] == "rowNames") row_names <- dots[[i]]
    }
  }

  .param.old(...)

  if (!exists(in.df, where=.GlobalEnv)) {
    cat("\n");
    if (grepl('"', in.df))
      cat(">>> Do NOT place quotes around the data frame name.\n\n")
    stop(call.=FALSE, "\n","------\n",
         "Data frame ", in.df, " does not exist.\n")
    cat("\n")
  }

  if (is.null(row_names)) {  # if just consecutive integers, ignore row names
    is.seq <- identical(rownames(data), as.character(seq_len(nrow(data))))
    row_names <- ifelse (is.seq, FALSE, TRUE) 
  }

  # check if a filename has a target ext or set ext from format
  fmt_to_ext <- c(csv="csv", txt="txt", tsv="tsv", prn="prn", 
                  R="rda", Excel="xlsx", ODS="ods", SPSS="sav",
                  feather="feather", parquet="parquet")
  if (!is.null(to)) {
    ext <- tolower(tools::file_ext(to))
    if (nzchar(ext)) {  # non-empty string, file extension exists
      ext_to_fmt <- c(csv="csv", txt="txt", tsv="tsv", prn="prn", 
                      rda="R", xlsx="Excel", ods="ODS", sav="SPSS",
                      feather="feather", parquet="parquet")
      format <- ext_to_fmt[ext]  # is NA if file type not recognized
      if (is.na(format) && format.miss) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "File type ", ext, " not recognized. Specify  format  parameter\n",
          "such as format=\"Excel\" or format=\"csv\".\n\n")
      }
      out.df <- to
    }  # end extension exists
    else {  # assign extension from format
      out.df <- paste(to, ".", fmt_to_ext[format], sep="")
    }
  }  # end !is.null(to)
  else {  # create the output df name and ext
    out.df <- paste(in.df, ".", fmt_to_ext[format], sep="")
  }


  # see if needed package is installed
  # ----------------------------------
  if (format %in% c("feather", "parquet")) {
    if (!requireNamespace("arrow", quietly=TRUE))
      stop("Package \"arrow\" needed to write this file\n",
           "Please install:  install.packages(\"arrow\")\n\n",
           call.=FALSE)
  }

  if (format == "SPSS") {
    if (!requireNamespace("haven", quietly=TRUE))
      stop("Package \"haven\" needed to write this file\n",
           "Please install:  install.packages(\"haven\")\n\n",
           call.=FALSE)
  }

  if (format == "ODS") {
    if (!requireNamespace("readODS", quietly=TRUE))
      stop("Package \"readODS\" needed to write this file\n",
           "Please install:  install.packages(\"readODS\")\n\n",
           call.=FALSE)
  }


  if (format %in% c("feather", "parquet", "SPSS")) {  # save the row names
    if (row_names) {
      data <- cbind(RowName = rownames(data), data)
      rownames(data) <- NULL
    }
  }
  

  if (format %in% c("csv", "txt", "tsv", "prn")) {  # text file, txt is default

    if (is.null(missing)) {
      if (format %in% c("csv", "tsv", "txt")) missing <- " "
      else if (format == "prn") missing <- "NA"
    }
    if (format == "csv") sep <- ","
    if (format == "tsv") sep <- "\t"
    if (format == "prn") sep <- " "
    if (format == "txt") if (is.null(sep)) sep <- ","

    # Add quotes to data values that match the pattern
    if (grepl("needed", quote, fixed=TRUE)) {
      data[] <- lapply(data, function(col) {
        if (is.character(col)) {
          return(sapply(col, function(x) {
            if (grepl("[[:space:],;]", x)) {
              return(paste0('"', x, '"'))
            } 
            else {
              return(x)
            }
          }))
        }  # end is a character variable
        else {
          return(col)
        }
      })  # end lapply()

      # Add quotes to row names that match the pattern
      if (is.character(rownames(data))) {
        row.nms <- rownames(data)
        rownames(data) <- ifelse(grepl("[[:space:],;]", row.nms),
                                 paste0('"', row.nms, '"'), row.nms)
        rm(row.nms)
      }
    }  # end "if_needed"

    write.table(data, file=out.df, row.names=row_names, ...,
                sep=sep, dec=dec, na=missing, quote=FALSE)

    # write variable labels if they exist as data frame l
    if ("l" %in% .getdfs()) {
      file.lbl <- substr(out.df,1,nchar(out.df)-4)
      file.lbl <- paste(paste(file.lbl,"_lbl",sep=""), ".csv" ,sep="")
      write.table(l, file=file.lbl, col.names=FALSE, dec=".", sep=",")
      .showfile(file.lbl, c(in.df, "variable labels"))
    }
  }  # end text file
  
  else if (format == "feather") {
    arrow::write_feather(data, out.df)
    if (!quiet)
      cat("[with the write_feather() function from",
          "Richardson's et al. arrow package]\n")
  }  
  
  else if (format == "parquet") {
    arrow::write_parquet(data, out.df)
    if (!quiet)
      cat("[with the write_parquet() function from",
          "Richardson's et al. arrow package]\n")
  }  

  else if (format == "SPSS") {
    haven::write_sav(data, out.df)
    if (!quiet)
      cat("[with the write_sav() function from",
      "Wickham and Miller's haven package]\n")
  }
  
  else if (format == "ODS") {
    readODS::write_ods(data, out.df, row_names=row_names)
    if (!quiet)
      cat("[with the write_ods() function from",
          "Schutten and Chan's readODS package]\n")
  }

  else if (format == "Excel") {
    wb <- openxlsx::createWorkbook()
    openxlsx::addWorksheet(wb, in.df)
    if (ExcelColWidth)
      openxlsx::setColWidths(wb, sheet=1, cols=1:ncol(data), widths="auto") 
    if (ExcelTable)
      openxlsx::writeDataTable(wb, in.df, x=data, colNames=TRUE,
           xy=c("A",1), rowNames=row_names, tableStyle="TableStyleLight9")
    else {
      hsl <- openxlsx::createStyle(fgFill="gray85", border="bottom")
      openxlsx::writeData(wb, in.df, x=data, colNames=TRUE, xy=c("A",1),
                rowNames=row_names, headerStyle=hsl)
    }

    openxlsx::saveWorkbook(wb, file=out.df, overwrite=TRUE)
    txt <- "Schauberger and Walker's openxlsx package]"
    if (!quiet) {
      if (ExcelTable)
        cat("[with the writeDataTable() function from", txt, "\n")
      else
        cat("[with the writeData() function from", txt, "\n")
    }

  }
  
  else if (format == "R") {
    save(list=in.df, file=out.df, ...)
  }

  if (!quiet) .showfile(out.df, c(in.df, "data values"))
}

# ---------
# Histogram
# ---------

library(shiny)
library(lessR)
library(openxlsx)

clr.one <- list(
  "#96AAC3", "dodgerblue3", "cornflowerblue", "steelblue", "darkblue",
  "pink2", "red3", "firebrick2", "darkred",
  "violetred", "mediumorchid", "purple3",
  "darkorange2", "salmon", "orange3", "sienna", "rosybrown",
  "wheat3", "goldenrod2", "khaki", "yellow2",
  "darkseagreen2", "springgreen3", "seagreen4", "darkgreen",
  "black", "gray45", "slategray4", "gray75", "snow3", "gray95",
  "lavender", "ivory2", "aliceblue", "white")

clr.edge <- list("off", "black", "gray50", "gray75", "white", "ivory",
  "darkblue", "darkred", "darkgreen", "rosybrown2", "bisque",
  "slategray2", "aliceblue", "thistle1", "coral", "gold")

clr.qual <- c("hues", "Okabe-Ito", "viridis")

clr.seq <- list("reds", "rusts", "browns", "olives", "greens",
  "emeralds", "turquoises", "aquas", "blues", "purples", "violets",
  "magentas", "grays")

clr.den_g <- c("steelblue3", clr.one[2:length(clr.one)])
clr.den_n <- c("pink1", clr.one[2:length(clr.one)])

addResourcePath("shiny_dir", system.file("shiny_apps", package="lessR"))


ui <- fluidPage(
  tags$head(tags$link(rel="stylesheet", href="shiny_dir/styles.css")),

  tabsetPanel(

    tabPanel("Data",
      titlePanel(div("Upload a text (.csv, .txt) or Excel file", id="hp")),

      sidebarLayout(
        sidebarPanel(

          radioButtons("fType", HTML("<h5 class='soft'>Format</h5>"),
                       c("Excel"="Excel", "Text"="Text")),
          conditionalPanel(condition="input.fType == 'Text'",
            radioButtons("sep", HTML("<h5 class='soft'>Separator</h5>"),
                         c(Comma=",", Semicolon=";", Tab="\t"), ","),
            radioButtons("decimal", HTML("<h5 class='soft'>Decimal</h5>"),
                         c("Point"=".", "Comma"=",")),
          ),

          radioButtons("fSource", HTML("<h5 class='soft'>Source</h5>"),
                       c("Local"="local", "Web"="web")),
          conditionalPanel(condition="input.fSource == 'local'",
            fileInput("myFile", "Locate your data file",
                      accept=c(".csv", ".txt", ".xlsx", ".xlsm")),
          ),
          conditionalPanel(condition="input.fSource == 'web'",
            textInput("myURL", "Web address of data file"),
            actionButton("submitURL", "Submit")
          ),

          textOutput("ncols"),
          textOutput("nrows"),
          uiOutput("d.show"),

        ),  # end sidbarPanel

        mainPanel(
          tableOutput("d.table"),
          tags$style(type="text/css", "#d.table {font-size: .95em;}")
        )

      )  # end sidbarLayout
    ),  # end tabPanel 1


    tabPanel("Histogram",
      pageWithSidebar(
        titlePanel(""),

        sidebarPanel(
          selectInput('x.col', 'x Variable', ""),

          tags$hr(),
          checkboxInput("myBins", div("Bins", class="view"), FALSE),
          conditionalPanel(condition="input.myBins == true",
            uiOutput("slider_bw"),
            uiOutput("slider_bs")
          ),

          tags$hr(),
          checkboxInput("myGeom", div("Colors", class="view"), FALSE),
          conditionalPanel(condition="input.myGeom == true",
            selectInput("myFill", "fill",
               choices=list("Constant"=clr.one,
                            "Qualitative"=clr.qual,
                            "Sequential"=clr.seq)),
            selectInput("myColor", "color", choices=clr.edge),
            sliderInput("myTrans", "transparency", min=0, max=1, value=0)
          ),

          tags$hr(),
          checkboxInput("myValCm", div("Counts, Cumulate", class="view"), FALSE),
          conditionalPanel(condition="input.myValCm == true",
            checkboxInput("myValues", "counts", value=FALSE),
            selectInput("myCumlt", "cumulate", choices=list("off", "on", "both"))
          ),

          tags$hr(),
          checkboxInput("mySmooth", div("Smooth", class="view"), FALSE),
          conditionalPanel(condition="input.mySmooth == true",
            checkboxInput("myDens", "density", TRUE),
            checkboxInput("myHist", "show_histogram", TRUE),
            checkboxInput("myRug", "rug", FALSE),
            radioButtons("myKind", "kind",
                       c("general"="general", "normal"="normal", "both"="both")),
            uiOutput("slider_bndwd"),
            selectInput("myFill_gen", "fill_general", choices=clr.den_g),
            selectInput("myFill_nrm", "fill_normal", choices=clr.den_n)
          ),

          tags$hr(),
          checkboxInput("do_pdf", div("Save", class="view"), FALSE),
          conditionalPanel(condition="input.do_pdf == true",
            sliderInput("w", "width (inches):", min=3, max=20, value=8),
            sliderInput("h", "height (inches):", min=3, max=20, value=6),
            checkboxInput("do_cmt", "include comments in R file", TRUE),
            actionButton(inputId="btn_pdf", "Save"),
            tags$p(div("Save pdf file and R code file",
                  style="margin-top:.25em;"))
          ),

          tags$hr(),
          checkboxInput("do_help", div("Help", class="view"), FALSE),

        ),  # end sidebarPanel

        mainPanel(
          plotOutput('myPlot'),
          verbatimTextOutput("summary"),
          plotOutput("saved_plot"),
          textOutput("help")
        )

      )  # end pageWithSidebar
    )  # end tabPanel 2
  )  # end tabsetPanel
)  # end fluidPage


server <- function(input, output, session) {

  options(shiny.maxRequestSize=50*1024^2)  # max upload file size is 50MB

  v <- reactiveValues()
  v$x.new <- FALSE


  # ------- Read and Display Data -----------
  # -----------------------------------------

  # process the URL for reading from the web
  theURL <- eventReactive(input$submitURL, {
    input$myURL
  })

  data <- reactive({
    if (input$fSource == "local") {
      shiny::req(input$myFile)
      myPath <- input$myFile$datapath
      theRead <- input$myFile$name
    }
    if (input$fSource == "web") {
      url <- theURL()
      if (!grepl("^https?://", url))
        url <- paste("https://", url, sep="")
      myPath <- url
      theRead <- myPath
    }

    shiny::req(myPath)
    if (input$fType == "Excel") {
      if (grepl(".xlsx", myPath, fixed=TRUE)) {
        d <- read.xlsx(myPath)
      }
      else {
        message("\n>>> Excel file must have file type of .xlsx <<<\n\n")
        stopApp()
      }
    }
    if (input$fType == "Text") {
      if ((grepl(".csv", myPath, fixed=TRUE)) ||
          (grepl(".txt", myPath, fixed=TRUE))) {
        d <- read.csv(myPath, sep=input$sep, dec=input$decimal,
                      na.strings="")  # default is NOT a blank char missing
      }
      else {
        message("\n>>> Text file must have file type of .csv or .txt <<<\n\n")
        stopApp()
      }
    }  # end fType is "Text"

    updateSelectInput(session, inputId="x.col", label="x variable",
                      choices=c("Select a numerical variable" = "",
                                names(d)[sapply(d, is.numeric)]))

    return(d)
  })  # end reactive()


  output$nrows <- renderText({
    shiny::req(data())
    paste("Number of data rows:", nrow(data()))
  })
  output$ncols <- renderText({
    shiny::req(data())
    paste("Number of variables:", ncol(data()))
  })

  output$d.show <- renderUI({
    shiny::req(data())
    if (nrow(data()) > 10)
      radioButtons("d.show", HTML("<h5 class='soft'>Rows to display</h5>"),
                   c("First 10"="head", "Last 10"="tail", "Random 10"="random",
                     "All"="all"))
  })


  output$d.table <- renderTable({
    if (is.null(input$d.show))
      data()
    else {
      nr <- min(11, nrow(data()))
      if (nr == 11) {
        if (input$d.show == "all")
          data()
        else if (input$d.show == "head")
          head(data(), n=10)
        else if (input$d.show == "tail")
          tail(data(), n=10)
        else if (input$d.show == "random") {
          dd <- data()
          dd[sample(nrow(dd), min(10, nrow(dd))), ]
        }
      }
    }
  }, striped=TRUE)  # end renderTable

  # -----------------------------------------


  # ------- Bin Width and Bin Start ---------
  # -----------------------------------------

  # get default bin_width and bin_start values for initial histogram
  #  and bin width and start sliders
  # default bin width is v$bw
  observeEvent(input$x.col, {  # processed while still on Get Data tab
    v$x.new <- TRUE

    x.name <- input$x.col
    x <- data()[, x.name]

    v$min.x <- min(x, na.rm=TRUE)
    max.x <- max(x, na.rm=TRUE)

    h <- suppressWarnings(hist(x, plot=FALSE, breaks="Sturges"))
    v$bw <- h$breaks[2]-h$breaks[1]
    if (v$bw == 0.5) v$bw <- 1
    v$rng <- max.x - v$min.x
    v$bw1 <- v$rng/45
    if (v$min.x > 1) v$bw1 <- floor(v$bw1)
    if (v$bw1 == 0) v$bw1 <- 0.5
    v$bw2 <- v$rng/2.5
    if (v$bw2 > 5) v$bw2 <- ceiling(v$bw2)
    v$bw1 <- round(v$bw1, 3)
    v$bw2 <- round(v$bw2, 3)

    pret <- pretty(c((v$min.x-(.01*v$min.x)), max.x))[1]
    v$bs1 <- pret - (v$bw)
    v$bs <- pret
    v$bs2 <- v$min.x
    if(v$bs1 > v$bs2) v$bs2 <- v$bs1
    if (abs(v$min.x) > 1) {
      v$bs1 <- floor(v$bs1)
      v$bs2 <- floor(v$bs2)
    }

    updateSliderInput(session, inputId="slider_bw", label="bin_width",
                      min=v$bw1, max=v$bw2, value=v$bw)

    updateSliderInput(session, inputId="slider_bs", label="bin_start",
                      min=v$bs1, max=v$bs2, value=v$bs)
  })



  # ---------- Density Bandwidth ------------
  # -----------------------------------------
  get_bw <- function(x) {
    bw <- bw.nrd0(x)
    irep <- 0
    repeat {  # iterated value of bw
      irep <- irep + 1
      d.gen <- suppressWarnings(density(x, bw))  # no missing data
      xd <- diff(d.gen$y)
      flip <- 0
      for (j in 2:length(xd))
        if (sign(xd[j-1]) != sign(xd[j])) flip <- flip + 1
      if (flip > 1  &&  irep <= 25)
        bw <- 1.1 * bw
      else
        break;
    }  # end repeat

    v$bndwd <- bw  # cutoff of 7 to keep bw*.15 > 1
    v$bndwd1 <- ifelse (bw>7, floor(bw*0.15), round(bw*0.15, 2))
    if (v$bndwd1 == 0) v$bndwd1 <- 0.00001
    v$bndwd2 <- ifelse (bw>7, ceiling(bw*1.5), round(bw*1.5, 2))
  }

  observeEvent(input$x.col, {  # if switch variable
    if (input$myDens) {
      x.name <- input$x.col
      shiny::req(x.name)
      x <- na.omit(data()[, x.name])
      get_bw(x)

      updateSliderInput(session, inputId="slider_bndwd", label="bandwidth",
                        min=v$bndwd1, max=v$bndwd2, value=v$bndwd)
    }
  })

  # get default band width and min, max for input slider when
  #  "parameters" button is checked
  observeEvent(input$myDens, {
    if (input$myDens) {
      x.name <- input$x.col
      shiny::req(x.name)
      x <- na.omit(data()[, x.name])
      get_bw(x)
    }
  })

  # band width slider, only activates for a variable change
  # runs whenever an input$ in the function changes
  output$slider_bndwd <- renderUI({
    if (!is.null(v$bndwd)) {
      updateSliderInput(session, inputId="slider_bndwd", label="bandwidth",
                        min=v$bndwd1, max=v$bndwd2, value=v$bndwd)
    }
  })


  # ------------ The Histogram --------------
  # -----------------------------------------

  output$slider_bw <- renderUI({
    req(input$myBins, !is.null(v$bw1))
    sliderInput(inputId="slider_bw", label="bin_width",
                min=v$bw1, max=v$bw2, value=v$bw)
  })
  output$slider_bs <- renderUI({
    req(input$myBins, !is.null(v$bs1))
    sliderInput(inputId="slider_bs", label="bin_start",
                min=v$bs1, max=v$bs2, value=v$bs)
  })

  output$myPlot <- renderPlot({

    # the sliders update later, so the old value can be current for a new var
    # update to avoid the extra computation and distracting intermediate plot
    if (!is.null(input$slider_bw)) {
      if (input$slider_bw < v$bw1  || input$slider_bw > v$bw2) {
        if (!input$myBins)
          updateSliderInput(session,"slider_bw", min=v$bw1, max=v$bw2,
                            value=v$bw)
        req(input$slider_bw >= v$bw1)  # takes a while for the update
        req(input$slider_bw <= v$bw2)
      }
    }
    if (!is.null(input$slider_bs)) {
      if (input$slider_bs < v$bs1  || input$slider_bs > v$bs2) {
        if (!input$myBins)
          updateSliderInput(session,"slider_bs", min=v$bs1, max=v$bs2,
                            value=v$bs)
        req(input$slider_bs >= v$bs1)  # takes a while for the update
        req(input$slider_bs <= v$bs2)
      }
    }

    # switching to a new var, v$x.new is TRUE, initiates the histogram
    #   computations twice, so skip the first histogram and take the second
    go.new <- v$x.new
    if (go.new) {
      v$x.new <- FALSE
      req(!go.new)
    }

    # when Bins button clicked do not want any new re-renderings, but get two
    # this hack stops the first re-rendering for the first instance
    # slider values are only null before any click on the Bins button
    if (input$myBins) req(!is.null(input$slider_bw))

    shiny::req(input$x.col)
    x.name <- input$x.col
    x <- data()[, x.name]
    y.name <- paste("Count of", x.name)

    # when beginning, sliders will be NULL
    in.bw <- ifelse (is.null(input$slider_bw), v$bw, input$slider_bw)
    in.bs <- ifelse (is.null(input$slider_bs), v$bs, input$slider_bs)
    v$in.den <- ifelse (input$mySmooth, TRUE, FALSE)

    out <- paste("X(", x.name, sep="")

    if (!v$in.den) {

    v$h <- X(x, data=NULL,
             type="histogram",
             bin_width=in.bw, bin_start=in.bs, bin_end=NULL,
             fill=input$myFill, color=input$myColor, transparency=input$myTrans,
             counts=input$myValues, cumulate=input$myCumlt,
             xlab=x.name, ylab=y.name,
             quiet=TRUE)
      v$plt <- recordPlot()

      p_bin_width <- in.bw == v$bw
      p_bin_start <- in.bs == v$bs
      p_fill <- input$myFill == "#96AAC3"
      p_color <- input$myColor == "off"
      p_trans <- input$myTrans == 0
      p_values <- input$myValues == FALSE
      p_cumul <- input$myCumlt == "off"

      if (!p_bin_width) out <- paste(out, ", bin_width=", in.bw, sep="")
      if (!p_bin_start) out <- paste(out, ", bin_start=", in.bs, sep="")
      if (!p_fill) out <- paste(out, ", fill=\"", input$myFill, "\"", sep="")
      if (!p_color) out <- paste(out, ", color=\"", input$myColor, "\"", sep="")
      if (!p_trans) out <- paste(out, ", transparency=", input$myTrans, sep="")
      if (!p_values) out <- paste(out, ", counts=", input$myValues, sep="")
      if (!p_cumul) out <- paste(out, ", cumulate=\"", input$myCumlt, "\"", sep="")
    }

    else {  # density plot
      shiny::req(input$slider_bndwd)

      fg.rgb <- col2rgb(input$myFill_gen)
      v$fg.trns <- rgb(fg.rgb[1], fg.rgb[2], fg.rgb[3],
                       alpha=80, maxColorValue=255)
      fn.rgb <- col2rgb(input$myFill_nrm)
      v$fn.trns <- rgb(fn.rgb[1], fn.rgb[2], fn.rgb[3],
                       alpha=80, maxColorValue=255)

      v$h <- X(x, data=NULL,
               type="histogram",
               bin_width=in.bw, bin_start=in.bs,
               stat="density", rug=input$myRug, kind=input$myKind,
               bandwidth=input$slider_bndwd, show_histogram=input$myHist,
               fill_general=v$fg.trns, fill_normal=v$fn.trns,
               xlab=x.name, ylab=y.name, quiet=TRUE)
      v$plt <- recordPlot()

      p_dens <- input$myDens == FALSE
      p_rug <- input$myRug == FALSE
      p_kind <- input$myKind == "general"
      p_bw <- (abs(input$slider_bndwd-v$bndwd) < 1)
      p_hist <- input$myHist == TRUE
      p_fill_general <- input$myFill_gen == "steelblue3"
      p_fill_normal <- input$myFill_nrm == "pink1"

      if (!p_dens) out <- paste(out, ", stat='density'", sep="")
      if (!p_rug) out <- paste(out, ", rug=", input$myRug, sep="")
      if (!p_kind) out <- paste(out, ", kind=\"", input$myKind, "\"", sep="")
      if (!p_bw) out <- paste(out, ", bandwidth=", input$slider_bndwd, sep="")
      if (!p_hist) out <- paste(out, ", show_histogram=",input$myHist, sep="")
      if (!p_fill_general) out <- paste(out, ", fill_general=\"",
                                        input$myFill_gen, "\"", sep="")
      if (!p_fill_normal) out <- paste(out, ", fill_normal=\"",
                                       input$myFill_nrm, "\"", sep="")
    }  # end dens

    # always explicit about type
    out <- paste(out, ", type=\"histogram\")", sep="")
    cat(out, "\n")
    v$code <- out  # save the code for a pdf file


    v$x.new <- FALSE
  })  # end renderPlot

  output$summary <- renderPrint({
    shiny::req(v$h)
    h <- v$h
    if (!v$in.den)
      out2 <- c(h$out_summary, " ", h$out_outliers, " ", h$out_freq)
    else
      out2 <- c(h$out_stats, " ", h$out_ss, " ", h$out_outliers)
    for (i in seq_along(out2)) cat(out2[i], "\n")
  })


  # clicking on the Save button generates a pdf file
  plotInput <- eventReactive(input$btn_pdf, {

    code <- v$code

    x.name <- input$x.col
    shiny::req(x.name)
    x <- data()[, x.name]
    y.name <- paste("Count of", x.name)

    pdf.fname <- paste("hs_", x.name, ".pdf", sep="")
    pdf.path <- file.path(path.expand("~"), pdf.fname)

    # styles before re-set in interact() were saved
    style(lab_cex=getOption("l.cex"))
    style(axis_cex=getOption("l.axc"))

    pdf(pdf.path, width=as.numeric(input$w), height=as.numeric(input$h))
    shiny::req(!is.null(v$plt))
    replayPlot(v$plt)
    dev.off()

    # reset back to shiny setting
    style(lab_cex=1.201, axis_cex=1.011, suggest=FALSE)

    # R code
    r.fname <- paste("hs_", x.name, ".r", sep="")
    r.path <- file.path(path.expand("~"), r.fname)
    cat("\n")
    message("---------------------------------------------")
    cat("Files written to folder:", path.expand("~"), "\n")
    message("---------------------------------------------")
    cat("pdf file: ", pdf.fname, "\n")
    cat("R code file: ", r.fname, "\n")
    message("---------------------------------------------")
    cat("\n")

    if (input$fSource == "web") {
      url <- theURL()
      if (!grepl("^https?://", url))
        url <- paste("https://", url, sep="")
    }

    read.path <- ifelse (input$fSource == "local", input$myFile$name, url)
    read.code <- paste("d <- Read(\"", read.path, "\")", sep="")
    is.local <- !grepl("http://", read.path, fixed=TRUE)

    if (input$do_cmt)
      cat("# The # symbol indicates a comment rather than an R instruction\n\n",
          "# Begin the R session by loading the lessR functions ",
          "from the library\n", sep="", file=r.path)
    cat("library(\"lessR\")\n\n", file=r.path, append=TRUE)

    if (input$do_cmt) {
      cat("# Read your data into an R data table, the data frame, here d",
          "\n", sep="", file=r.path, append=TRUE)
      if (is.local)
        cat("# To browse for the data file, include nothing between the quotes",
            "\n", sep="", file=r.path, append=TRUE)
    }
    if (is.local && input$do_cmt)
      cat("d <- Read(\"\")\n\n", file=r.path, append=TRUE)

    if (is.local && input$do_cmt) {
      cat("# For security, the path to your data file is not available\n",
          "# You can replace PATHtoFILE in the following with the path\n",
          "# Remove the # sign in the first column and delete the previous ",
          "Read()\n", sep="", file=r.path, append=TRUE)
      read.path <- file.path("PATHtoFILE", read.path)
      read.code <- paste("# d <- Read(\"", read.path, "\")", sep="")
    }
    cat(read.code, "\n\n", file=r.path, append=TRUE)

    if (input$do_cmt)
      cat("# When you have your data table, do the histogram analysis of a\n",
          "#   continuous variable in the data table\n",
          "# d is the default data frame name, so no need to specify\n",
          sep="", file=r.path, append=TRUE)
    cat(code, "\n\n", file=r.path, append=TRUE)


    anlys <- "X()"
    if (input$do_cmt)
      cat("# If accessing data with a name other than d, must add  data=NAME\n",
          paste("#   to the", anlys, "call, where NAME is the name of your",
                "data frame"), "\n", sep="", file=r.path, append=TRUE)

  })
  output$saved_plot <- renderPlot({ plotInput() })


  # access web page help file
  observeEvent(input$do_help, {
    fp <- system.file("shiny_apps/help/Histogram.html", package="lessR")
    browseURL(fp)
  }, ignoreInit=TRUE)
  output$help <- renderText({ "" })

}  # end server

shinyApp(ui, server)

plt.plotly <- function(
  x, y, by, size, fit,             # per-point data vectors
  by_name, n.by,                               # n.by unused; reserved
  fill, border, shape, pt.size,
  x_lab, y_lab, ax, gridT1, gridT2,
  main = NULL,
  digits_d=2, date.var,                        # date.var unused; reserved
  fit_color=border, fit_lwd=NULL, ln.type=NULL, # ln.type unused; reserved
  connect=FALSE, ts_unit=NULL,                 # for time series
  power=0.5, radius.in=0.12,   # area=size^power (for bubble mode)
  size.name="Size",
  ellipse_region=NULL, ellipse_fill=NULL,
  ellipse_color=NULL, ellipse_lwd=NULL,
  se.poly=NULL, se_fill=NULL,
  pt_opacity=0.95,
  frcst=NULL,                      # forecast bundle
  # --- outlier parameters (coordinates, not indices into g) ----------------
  out_x=NULL, out_y=NULL,          # actual x/y coordinates of outliers
  out_fill=NULL, out_color=NULL, out_shape=NULL,
  out_labels=NULL,                 # pre-extracted ID[out_ind]
  ID_color="black", ID_size=0.6,

  style_opts = .plotly_style()
) {

  title.size <- round(16 * getOption("main_size", 1))

  # rebuild the data frame the body expects from the input vectors
  g <- data.frame(x = x, y = y, f = fit, ind = by, size = size)

  # sanitize opacity
  pt_opacity <- as.numeric(pt_opacity[1])
  if (!is.finite(pt_opacity)) pt_opacity <- 0.95
  pt_opacity <- max(0, min(1, pt_opacity))

  # ---- bubbles (global scale) ----
  # should also apply to discrete bubble plots, e.g., XY(Dept, Gender)
  dpi <- style_opts$plotly_dpi
  pt.rows  <- rep(TRUE, nrow(g))  # placeholder; reserved for future row filtering
  size.vec <- as.numeric(g$size)
  use.bubbles <- length(unique(size.vec[!is.na(size.vec)])) > 1L

  if (use.bubbles) {
    sz.all <- pmax(0, size.vec)^power
    mxru   <- max(sz.all, na.rm = TRUE)
    radius.px <- radius.in * dpi
    bubble.diam <- function(v) {
      v.sz <- pmax(0, as.numeric(v))^power
      if (is.finite(mxru) && mxru > 0)
        2 * (v.sz / mxru) * radius.px else rep(0, length(v.sz))
    }
  } else {
    bubble.diam <- NULL
  }


# groups set up -----------------------------------------------------------

  ind.chr   <- trimws(as.character(g$ind))
  valid     <- !is.na(g$ind)
  idx.list  <- split(seq_len(nrow(g))[valid], ind.chr[valid], drop=TRUE)
  grp.names <- names(idx.list)
  has.groups <- length(grp.names) > 1L

  has.out <- !is.null(out_x) && length(out_x) > 0


# initialization ----------------------------------------------------------
  plt <- plotly::plot_ly()
  border.hex <- .to_hex(border)  # fully opaque borders

  symbol <- switch(as.character(shape),
    "21"="circle","22"="square","23"="diamond",
    "24"="triangle-up","25"="triangle-down","circle"
  )



# no groups ---------------------------------------------------------------

  if (!has.groups) {

    if (!is.null(ts_unit)) {
      xv <- as.Date(g$x, origin="1970-01-01")
      xv <- .format_date_labels(xv, ts_unit)
      xlab.h <- "Date"
    } else {
      xv <- as.numeric(g$x)
      xlab.h <- x_lab
    }
    yv <- as.numeric(g$y)

    y_lab.h    <- trimws(y_lab)
    hover.tmpl <- .hover.fmt(xv, yv, xlab.h, y_lab.h, FALSE, digits_d, ts_unit)

    xv <- as.numeric(g$x)        # keep numeric for plotly axis

    # size/marker setup
    if (use.bubbles) {
      diam.px <- bubble.diam(size.vec)
      hover.tmpl <- sub(
        "<extra></extra>$",
        paste0("<br>", size.name, ": %{customdata:.",
               digits_d, "f}<extra></extra>"),
        hover.tmpl
      )
      customdata <- size.vec
    } else {
      px <- as.numeric(pt.size) * 7.25
      if (!is.finite(px)) px <- 5
      diam.px    <- rep(px, length(xv))
      customdata <- NULL
    }

    # set alpha via rgba colors, and leave marker.opacity at 1
    marker.color <- .maketrans_plotly(fill[1], alpha = pt_opacity)

    # ---- regular points (g already contains only non-outlier rows) --------
    plt <- plotly::add_trace(
      plt,
      type  = "scatter",
      mode  = if (connect) "lines+markers" else "markers",
      x = xv, y = yv,
      marker = list(
        symbol   = symbol,
        size     = diam.px,
        sizemode = "diameter",
        color    = marker.color,
        opacity  = 1,  # do not multiply alpha; already in rgba
        line     = list(color = border.hex[1], width = 1)
      ),
      line          = if (connect) list(color = border.hex[1], width = 1.5)
                      else NULL,
      hovertemplate = hover.tmpl,
      customdata    = customdata,
      showlegend    = FALSE
    )

    # ---- outlier points ---------------------------------------------------
    if (has.out) {
      out.symbol <- switch(as.character(out_shape),
        "21"="circle", "22"="square", "23"="diamond",
        "24"="triangle-up", "25"="triangle-down", "circle-open"
      )
      out.marker.color <- .maketrans_plotly(
        if (!is.null(out_fill)) out_fill else fill[1], alpha = pt_opacity
      )
      out.border.hex <- .to_hex(if (!is.null(out_color)) out_color else border[1])

      # use same pixel size as regular points
      px.out <- as.numeric(pt.size) * 7.25
      if (!is.finite(px.out)) px.out <- 5

      plt <- plotly::add_trace(
        plt,
        type = "scatter", mode = "markers",
        x = as.numeric(out_x), y = as.numeric(out_y),
        marker = list(
          symbol   = out.symbol,
          size     = px.out,
          sizemode = "diameter",
          color    = out.marker.color,
          opacity  = 1,
          line     = list(color = out.border.hex, width = 1.5)
        ),
        hovertemplate = hover.tmpl,
        showlegend    = FALSE
      )

      # ---- outlier labels -------------------------------------------------
      if (!is.null(out_labels) && length(out_labels) > 0) {
        font.sz <- max(9L, round(as.numeric(ID_size) * 14))
        plt <- plotly::add_annotations(
          plt,
          x         = as.numeric(out_x),
          y         = as.numeric(out_y),
          text      = as.character(out_labels),
          showarrow = FALSE,
          yshift    = -12,
          font      = list(color = ID_color, size = font.sz, family = "Arial"),
          xref      = "x",
          yref      = "y"
        )
      }
    }

  }


# groups ------------------------------------------------------------------

  else {  # ---- groups ----

    for (i in seq_along(grp.names)) {
      nm  <- grp.names[i]
      idx <- idx.list[[nm]]
      if (!length(idx)) next

# --- x for hover (formatted as Date if time series) ---
      if (!is.null(ts_unit)) {
        xv.h <- as.Date(g$x[idx], origin = "1970-01-01")
        xv.h <- .format_date_labels(xv.h, ts_unit)
        xlab.h <- "Date"   # generic label for time series hover
      } else {
        xv.h   <- as.numeric(g$x[idx])
        xlab.h <- x_lab
      }

      yv <- as.numeric(g$y[idx])

      y_lab.h <- trimws(y_lab)
      hover.i <- sub(
        "<extra></extra>$",
        paste0("<br>", by_name, ": %{text}<extra></extra>"),
        .hover.fmt(xv.h, yv, xlab.h, y_lab.h, FALSE, digits_d, ts_unit)
      )

# --- x for plotly axis positioning (keep numeric day index) ---
      xv <- as.numeric(g$x[idx])

      if (use.bubbles) {
        diam.px  <- bubble.diam(size.vec[idx])
        hover.i  <- sub(
          "<extra></extra>$",
          paste0("<br>", size.name,
                 ": %{customdata:.", digits_d, "f}<extra></extra>"), hover.i
        )
        custom.i <- size.vec[idx]
      } else {
        # Point sizing for standard scatter / time-series.
        # - If user sets pt.size = 0, we suppress markers entirely (lines only).
        # - Otherwise, scale to plotly pixels.
        px <- as.numeric(pt.size) * 6.5
        if (!is.finite(px)) px <- 5
        if (px < 0) px <- 5
        diam.px  <- rep(px, length(idx))
        custom.i <- NULL
      }

      # per-group fill with desired alpha
      fill.i <- .maketrans_plotly(fill[i], alpha = pt_opacity)

      # ---- Main data trace ----
      # For connected series, keep markers on the plot, remove from the legend
      # by adding a separate legend-only line trace (below).
      mode.data <- if (connect) {
        if (use.bubbles) "lines+markers"
        else if (diam.px[1] <= 0) "lines" else "lines+markers"
      } else {
        "markers"
      }

      plt <- plotly::add_trace(
        plt,
        type = "scatter",
        mode = mode.data,
        name = nm, legendgroup = nm, text = nm,
        x = xv, y = yv,
        marker = if (grepl("markers", mode.data, fixed = TRUE)) list(
          symbol   = symbol,
          size     = diam.px,
          sizemode = "diameter",
          color    = fill.i,
          opacity  = 1,
          line     = list(color = .to_hex(border[i]), width = 1)
        ) else NULL,
        line          = if (connect) list(color = .to_hex(border[i]), width = 1.5) else NULL,
        hovertemplate = hover.i,
        customdata    = custom.i,
        showlegend    = if (connect) FALSE else TRUE
      )

      # ---- Legend-only line sample (no dot) ----
      if (connect) {
        ok2 <- which(is.finite(xv) & is.finite(yv))
        if (length(ok2) >= 2L) {
          idx2 <- ok2[1:2]
          plt <- plotly::add_trace(
            plt,
            type = "scatter",
            mode = "lines",
            name = nm, legendgroup = nm,
            x = xv[idx2], y = yv[idx2],
            line = list(color = .to_hex(border[i]), width = 1.5),
            hoverinfo  = "skip",
            showlegend = TRUE
          )
        }
      }
    }

    # ---- outliers for grouped plots (group-agnostic trace) ----------------
    # out_x/out_y are raw coordinates from the full data, so no index
    # translation needed regardless of how groups partition the rows.
    if (has.out) {
      out.symbol <- switch(as.character(out_shape),
        "21"="circle", "22"="square", "23"="diamond",
        "24"="triangle-up", "25"="triangle-down", "circle-open"
      )
      out.marker.color <- .maketrans_plotly(
        if (!is.null(out_fill)) out_fill else fill[1], alpha = pt_opacity
      )
      out.border.hex <- .to_hex(if (!is.null(out_color)) out_color else border[1])

      px.out <- as.numeric(pt.size) * 6.5
      if (!is.finite(px.out)) px.out <- 5

      plt <- plotly::add_trace(
        plt,
        type = "scatter", mode = "markers",
        x = as.numeric(out_x), y = as.numeric(out_y),
        marker = list(
          symbol   = out.symbol,
          size     = px.out,
          sizemode = "diameter",
          color    = out.marker.color,
          opacity  = 1,
          line     = list(color = out.border.hex, width = 1.5)
        ),
        showlegend = FALSE,
        hoverinfo  = "skip"
      )

      if (!is.null(out_labels) && length(out_labels) > 0) {
        font.sz <- max(9L, round(as.numeric(ID_size) * 14))
        plt <- plotly::add_annotations(
          plt,
          x         = as.numeric(out_x),
          y         = as.numeric(out_y),
          text      = as.character(out_labels),
          showarrow = FALSE,
          yshift    = -12,
          font      = list(color = ID_color, size = font.sz, family = "Arial"),
          xref      = "x",
          yref      = "y"
        )
      }
    }

  }


# forecast (time series only) ---------------------------------------------

  if (!is.null(frcst) && !is.null(ts_unit)) {
    xf  <- frcst$x.fit;  yf  <- frcst$y.fit
    xh  <- frcst$x.hat;  yh  <- frcst$y.hat
    yu  <- frcst$y.upr;  yl_ <- frcst$y.lwr
    clr.f      <- frcst$clr.f
    band.alpha  <- frcst$band.alpha

    # plotly rgba variants
    fit.rgba  <- .maketrans_plotly(clr.f, alpha=0.35)  # muted: fit line & PI lines
    fore.rgba <- .maketrans_plotly(clr.f, alpha=0.90)  # solid: forecast points/line
    band.rgba <- .maketrans_plotly(clr.f, alpha=band.alpha)  # light: PI band fill

    # formatted date strings carried as customdata for hover tooltips
    xf.fmt <- .format_date_labels(as.Date(xf, origin="1970-01-01"), ts_unit)
    xh.fmt <- .format_date_labels(as.Date(xh, origin="1970-01-01"), ts_unit)

    fmty <- .get.tick.fmt(c(yf, yh, yu, yl_), digits_d)
    yfmt <- if (nzchar(fmty)) paste0(":", fmty) else ""

    # 1. model fit line (over the historical data range)
    plt <- plotly::add_trace(plt,
      type="scatter", mode="lines",
      x=xf, y=yf,
      customdata=xf.fmt,
      line=list(color=fit.rgba, width=1.5),
      name="Model fit", legendgroup="frcst_fit",
      hovertemplate=paste0(
        "Date: %{customdata}<br>",
        "Fit: %{y", yfmt, "}<extra></extra>"
      ),
      showlegend=TRUE,
      inherit=FALSE
    )

    # 2. connector: last fit point to first forecast point (no legend entry)
    plt <- plotly::add_trace(plt,
      type="scatter", mode="lines",
      x=c(xf[length(xf)], xh[1]),
      y=c(yf[length(yf)], yh[1]),
      line=list(color=fit.rgba, width=1.5),
      showlegend=FALSE,
      hoverinfo="skip",
      inherit=FALSE
    )

    # 3. PI band: filled polygon (upper boundary + reversed lower boundary)
    plt <- plotly::add_trace(plt,
      type="scatter", mode="none",
      x=c(xh, rev(xh)),
      y=c(yu, rev(yl_)),
      fill="toself",
      fillcolor=band.rgba,
      name="95% PI", legendgroup="frcst_pi",
      showlegend=TRUE,
      hoverinfo="skip",
      inherit=FALSE
    )

    # 4. PI boundary lines (upper and lower, light dashed — no legend clutter)
    plt <- plotly::add_trace(plt,
      type="scatter", mode="lines",
      x=xh, y=yu,
      customdata=xh.fmt,
      line=list(color=fit.rgba, width=1, dash="dot"),
      showlegend=FALSE,
      hovertemplate=paste0(
        "Date: %{customdata}<br>",
        "Upper PI: %{y", yfmt, "}<extra></extra>"
      ),
      inherit=FALSE
    )
    plt <- plotly::add_trace(plt,
      type="scatter", mode="lines",
      x=xh, y=yl_,
      customdata=xh.fmt,
      line=list(color=fit.rgba, width=1, dash="dot"),
      showlegend=FALSE,
      hovertemplate=paste0(
        "Date: %{customdata}<br>",
        "Lower PI: %{y", yfmt, "}<extra></extra>"
      ),
      inherit=FALSE
    )

    # 5. forecast points + line
    px.f <- as.numeric(pt.size) * 7.25
    if (!is.finite(px.f) || px.f <= 0) px.f <- 6
    plt <- plotly::add_trace(plt,
      type="scatter", mode="lines+markers",
      x=xh, y=yh,
      customdata=xh.fmt,
      marker=list(
        symbol="circle",
        size=px.f,
        color=fore.rgba,
        line=list(color=fore.rgba, width=1)
      ),
      line=list(color=fore.rgba, width=2),
      name="Forecast", legendgroup="frcst_fore",
      hovertemplate=paste0(
        "Date: %{customdata}<br>",
        "Forecast: %{y", yfmt, "}<extra></extra>"
      ),
      showlegend=TRUE,
      inherit=FALSE
    )
  }  # end forecast


  # ---- ellipses (support per-group) ----
  if (!is.null(ellipse_region)) {
    to.poly.list <- function(obj) {
      if (is.list(obj) && !is.data.frame(obj)) return(obj)
      list(obj)
    }
    ell.list <- to.poly.list(ellipse_region)
    n.ell <- length(ell.list)
    target.len <- if (has.groups) length(grp.names) else 1L
    if (n.ell != target.len) ell.list <- rep(ell.list, length.out = target.len)

    edge.vec <- if (length(ellipse_color))
                    .to_hex(rep_len(ellipse_color, target.len))
                 else .to_hex(rep_len(border, target.len))
    lw.vec   <- as.numeric(if (length(ellipse_lwd))
                       rep_len(ellipse_lwd, target.len) else rep(1, target.len))

    fill.vec <- if (length(ellipse_fill))
                       .to_hex(rep_len(ellipse_fill, target.len))
                 else rep("transparent", target.len)

    for (k in seq_len(target.len)) {
      el <- as.data.frame(ell.list[[k]])
      if (ncol(el) >= 2 && nrow(el) >= 3) {
        plt <- plotly::add_trace(
          plt,
          type = "scatter",
          mode = "lines",
          x = el[[1]], y = el[[2]],
          line = list(color = edge.vec[k], width = lw.vec[k]),
          fill = "toself",
          fillcolor = fill.vec[k],
          showlegend = FALSE,
          hoverinfo = "skip",
          hovertemplate = NULL,
          hoveron = "points",
          inherit = FALSE
        )
      }
    }
  }

  # ---- SE bands ----
  if (!is.null(se.poly) && length(se.poly)) {
    for (b in seq_along(se.poly)) {
      sb <- as.data.frame(se.poly[[b]])
      plt <- plotly::add_trace(
        plt,
        type = "scatter",
        mode = "none",
        x = sb[[1]], y = sb[[2]],
        fill = "toself",
        fillcolor = .to_hex(se_fill %||% "transparent"),
        hoverinfo = "skip",
        showlegend = FALSE,
        inherit = FALSE
      )
    }
  }

  # ---- fits ----
  fit.rows <- is.finite(g$x) & is.finite(g$f)
  if (any(fit.rows)) {
    fit.valid   <- fit.rows & !is.na(g$ind)
    ind.fit.chr <- trimws(as.character(g$ind[fit.valid]))
    idx.fit     <- split(which(fit.valid), ind.fit.chr, drop = TRUE)
    has.group.fits <- length(idx.fit) > 1L

    if (!has.group.fits) {
      xl <- as.numeric(g$x[fit.rows]); yl <- as.numeric(g$f[fit.rows])
      ok <- is.finite(xl) & is.finite(yl); xl <- xl[ok]; yl <- yl[ok]
      if (length(xl) >= 2L) {
        fmtx <- .get.tick.fmt(xl, digits_d); fmty <- .get.tick.fmt(yl, digits_d)
        hover <- paste0(
          x_lab, ": %{x", if (nzchar(fmtx)) paste0(":", fmtx) else "", "}",
          "<br>Fit: %{y",  if (nzchar(fmty)) paste0(":", fmty) else "", "}",
          "<extra></extra>"
        )
        plt <- plotly::add_trace(
          plt, type = "scatter", mode = "lines",
          name = "Fit",
          x = xl, y = yl,
          line = list(
            color = .to_hex(fit_color[1]),
            width = as.numeric(if (length(fit_lwd)) fit_lwd[1] else 2)
          ),
          hovertemplate = hover,
          showlegend    = TRUE,
          legendgroup   = "fit"
        )
      }
    } else {
      gnames <- names(idx.fit)
      for (i in seq_along(gnames)) {
        nm   <- gnames[i]
        rows <- idx.fit[[nm]]
        xl <- as.numeric(g$x[rows]); yl <- as.numeric(g$f[rows])
        ok <- is.finite(xl) & is.finite(yl); xl <- xl[ok]; yl <- yl[ok]
        if (length(xl) < 2L) next

        fmtx <- .get.tick.fmt(xl, digits_d); fmty <- .get.tick.fmt(yl, digits_d)
        hover <- paste0(
          x_lab, ": %{x", if (nzchar(fmtx)) paste0(":", fmtx) else "", "}",
          "<br>Fit (", nm, "): %{y", if (nzchar(fmty))
                                     paste0(":", fmty) else "", "}",
          "<extra></extra>"
        )

        col.i <- if (length(fill) > 1L) {
          .to_hex(fill[i])  # match group fill, as base R path does
        } else {
          .to_hex(if (length(fit_color) >= i) fit_color[i] else border[i])
        }
        lw.i  <- if (length(fit_lwd)) fit_lwd[min(i, length(fit_lwd))] else 2

        plt <- plotly::add_trace(
          plt, type = "scatter", mode = "lines",
          name = paste0("Fit: ", nm),
          legendgroup = nm,
          x = xl, y = yl,
          line = list(color = col.i, width = lw.i),
          hovertemplate = hover,
          showlegend = TRUE
        )
      }
    }
  }

  # ---- axes, grids, legend, bg ----
  x.axis <- axis_num(x_lab, ax$axT1, ax$axL1)
  y.axis <- axis_num(y_lab, ax$axT2, ax$axL2)
  border.shapes <- plot_border()

  leg.color <- .to_hex(style_opts$lab_color)

  plt <- plotly::layout(
    plt,
    xaxis = x.axis, yaxis = y.axis,
    shapes = c(x_grid(gridT1), y_grid(gridT2), border.shapes),
    legend = list(
      title = list(
        text = if (has.groups) by_name else NULL,
        font = list(size = round(15 * getOption("lab_size", 1)),
                    family = "Arial", color = leg.color)
      ),
      font = list(size = round(16 * getOption("axis_size", 0.9)),
                  family = "Arial", color = leg.color),
      orientation = "v",
      x = 1.05, y = 0.5,
      xanchor = "left", yanchor = "middle",
      bgcolor = .to_hex(style_opts$window_fill),
      bordercolor = "#CCCCCC",
      borderwidth = 1,
      itemsizing = "constant"
    ),
    template = NULL,
    uniformtext = list(minsize = 10, mode = "hide")
  )

  plt$x$layout$plot_bgcolor  <- .to_hex(style_opts$panel_fill)
  plt$x$layout$paper_bgcolor <- .to_hex(style_opts$window_fill)

  # resolve axis/label/grid colors using the same NULL-fallback logic
  # as all other lessR plotting functions
  lab.clr <- style_opts$lab_color

  axis.x.clr      <- style_opts$axis_x_color      %||% style_opts$axis_color
  axis.y.clr      <- style_opts$axis_y_color      %||% style_opts$axis_color
  axis.x.text.clr <- style_opts$axis_x_text_color %||% style_opts$axis_text_color
  axis.y.text.clr <- style_opts$axis_y_text_color %||% style_opts$axis_text_color
  grid.x.clr      <- style_opts$grid_x_color      %||% style_opts$grid_color
  grid.y.clr      <- style_opts$grid_y_color      %||% style_opts$grid_color

  # convert to hex for plotly
  lab.clr         <- .to_hex(lab.clr)
  axis.x.clr      <- .to_hex(axis.x.clr)
  axis.y.clr      <- .to_hex(axis.y.clr)
  axis.x.text.clr <- .to_hex(axis.x.text.clr)
  axis.y.text.clr <- .to_hex(axis.y.text.clr)
  grid.x.clr      <- .to_hex(grid.x.clr)
  grid.y.clr      <- .to_hex(grid.y.clr)

  # x-axis
  if (!is.null(plt$x$layout$xaxis$title))
    plt$x$layout$xaxis$title$font$color <- lab.clr
  if (is.null(plt$x$layout$xaxis$tickfont))
    plt$x$layout$xaxis$tickfont <- list()
  plt$x$layout$xaxis$tickfont$color <- axis.x.text.clr
  plt$x$layout$xaxis$linecolor      <- axis.x.clr
  plt$x$layout$xaxis$tickcolor      <- axis.x.clr
  plt$x$layout$xaxis$gridcolor      <- grid.x.clr

  # y-axis
  if (!is.null(plt$x$layout$yaxis$title))
    plt$x$layout$yaxis$title$font$color <- lab.clr
  if (is.null(plt$x$layout$yaxis$tickfont))
    plt$x$layout$yaxis$tickfont <- list()
  plt$x$layout$yaxis$tickfont$color <- axis.y.text.clr
  plt$x$layout$yaxis$linecolor      <- axis.y.clr
  plt$x$layout$yaxis$tickcolor      <- axis.y.clr
  plt$x$layout$yaxis$gridcolor      <- grid.y.clr

  # patch any custom grid shapes (x_grid/y_grid bake their color in at call time)
  if (!is.null(plt$x$layout$shapes)) {
    plt$x$layout$shapes <- lapply(plt$x$layout$shapes, function(sh) {
      if (!is.null(sh$line)) sh$line$color <- grid.x.clr
      sh
    })
  }

  if (is.null(plt$x$layout$margin)) plt$x$layout$margin <- list()

  if (!nzchar(x_lab)) {
    plt$x$layout$margin$b <- 0L
  } else {
    b.default <- plt$x$layout$margin$b %||% 40
    plt$x$layout$margin$b <- max(b.default, 60)
  }

  if (!is.null(main) && nzchar(main)) {
    plt <- plotly::layout(plt,
      title  = list(text = main, x = 0.5,
                    xanchor = "center", y = 0.99, yanchor = "top",
                    font = list(size = title.size)),
      margin = list(t = round(title.size * 2.2))
    )
  }

  plt <- .finalize_plotly_widget(
    plt,
    kind = "sp",
    x_name = x_lab,
    by_name = by_name,
    add_title = FALSE,
    nudge_viewer = TRUE
  )

  invisible(plt)
}

# express x in terms of units
# includes conversion to dollars
xP <- function(x, d_d=NULL, unit=NULL, semi=FALSE) {

  if (is.null(d_d))
    digits_d <- getOption("digits_d")
  else
    digits_d <- d_d

  if (!is.na(x)) {

    neg.flag <- FALSE
    if (!is.null(unit)) {
      if (unit %in% c("dollar", "dollars")){
        digits_d <- 2
        if (x < 0) {
          neg.flag <- TRUE
          x <- abs(x)  # remove minus sign
        }
      }
    }

    tx <- formatC(x, digits=digits_d, big.mark=",", format="f")

    if (!is.null(unit)) {
      if (unit != "dollar") {  # No $ for display of the value
        if (!semi)
          tx <- paste(tx, unit)
        else
          tx <- paste(tx, "\\:", unit)
      }
      else {
        if (!neg.flag)
          tx <- paste("$", tx, sep="")
        else  # Had removed minus sign, now add back in the front
          tx <- paste("-$", tx, sep="")
        }
    }
    
  }  # end not missing x

  else
    tx <- ""

  return(tx)

}

Read <-
function(from=NULL, format=NULL, var_labels=FALSE, widths=NULL,

         missing=NULL, n_mcut=1,
         miss_show=30, miss_zero=FALSE, miss_matrix=FALSE,

         max_lines=30, sheet=1, row_names=NULL, header=TRUE,

         brief=TRUE, quiet=getOption("quiet"),

         fun_call=NULL, ...) {


  miss.format   <- missing(format)
  row_names.miss <- missing(row_names)


  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (length(dots) > 0) {
    change <- c("var.labels", "n.mcut", "miss.show", "miss.zero",
                "miss.matrix", "max.lines", "fun.call")
    for (i in seq_along(dots)) {
      if (names(dots)[i] %in% change) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
      }
    }
  }

  if (is.null(fun_call)) fun_call <- match.call()

  if (!is.null(from))
    if (nchar(from) == 0) from <- NULL  #  "" to NULL

  if (hasArg(labels)) {
     cat("\n"); stop(call.=FALSE, "\n","------\n",
         ">>> To read a csv or Excel file of variable labels, each row a\n",
         "    variable name and then variable label, and then optionally\n",
         "    a variable unit in the third column, set  var_labels=TRUE \n",
         "    in the Read statement and read into the l data frame\n\n")
  }

  .param.old(...)

  fmts <- c("text", "csv", "tsv", "Excel", "ODS", "R", "SPSS", "SAS", "Stata",
            "feather", "parquet")
  if (!is.null(format)) {
    if (!(format %in% c(fmts, "lessR"))) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
          ">>> Specified format must be one of:\n",
               "\"text\", \"Excel\", \"ODS\", \"R\", \"feather\", \"parquet\",
                \"SPSS\", \"SAS\"\n\n")
    }
    if (format == "text") format <- "csv"

    if (is.null(from) && format=="lessR") {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Cannot browse for a data file that is part of lessR.\n",
          "Specify the file name.\n\n")
    }
  }  # end !is.null(format)

  # option to browse for data file, and then display file name
  browse <- FALSE
  if (is.null(from)) {
    browse <- TRUE
    from <- file.choose()
    fncl <- paste("Read(", "from = \"", from,  "\", quiet = TRUE)", sep="")
  }
  else {
    fncl <- .fun_call.deparse(fun_call)
  }

  # save only data file for knitr run
  # reading from "Employee_lbl" does not require var_labels
  if (!var_labels && !grepl("_lbl", from, fixed=TRUE))
    options(read.call=fncl)

  if (miss.format) {
         if (!is.null(widths)) format <- "fwd"
    else if (grepl(".csv$", from)) format <- "csv"
    else if (grepl(".tsv$", from)) format <- "tsv"
    else if (grepl(".prn$", from)) format <- "prn"
    else if (grepl(".txt$", from)) format <- "txt"  # comma or tab separated
    else if (grepl(".sav$", from)) format <- "SPSS"
    else if (grepl(".zsav$", from)) format <- "SPSS"
    else if (grepl(".dta$", from)) format <- "Stata"
    else if (grepl(".rda$", from)) format <- "R"
    else if (grepl(".sas7bdat$", from)) format <- "SAS"
    else if (grepl(".ods", from)) format <- "ODS"
    else if (grepl(".xls$", from) || grepl(".xlsx$", from)) format <- "Excel"
    else if (grepl(".feather", from)) format <- "feather"
    else if (grepl(".parquet", from)) format <- "parquet"

    if (is.null(format)) {
      df <- list.files(system.file("data", package="lessR"))
      df <- df[!(df %in%"dataFreqTable99.rda")]
      df <- gsub(".rda", "", df, fixed=TRUE)
      df <- gsub("^data", "", df)
      if (from %in% df) {
        format <- "lessR"
        if (grepl("lbl", from, fixed=TRUE)) var_labels <- TRUE
      }
      else {
        df <- paste(" ", df)
        cat("\n"); stop(call.=FALSE, "\n","------\n",
            "Not a recognizable data file. Specify the  format parameter\n",
            "  to identify the file type or specify the name of\n",
            "  a built-in lessR data file without the data prefix.\n\n",
            "Available lessR data files:\n\n", df, "\n\n")
      }
    }
  }  # end miss format

  if (var_labels && format=="R") {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
        "An R data file should already contain labels before it was created.\n",
        "Or add them manually with the lessR function: label\n\n")
  }

  # give credit
  # -----------

  if (!quiet) {
    if (format == "Excel") {
      txt <- "Schauberger and Walker's openxlsx package]"
      cat("[with the read.xlsx() function from", txt, "\n")
    }
    if (format == "ODS") {
      txt <- "Schutten and Chan's readODS package]"
      cat("[with the read_ods() function from", txt, "\n")
    }
    if (format == "feather") {
      txt <- "Richardson's et al. arrow package]"
      cat("[with the read_feather() function from", txt, "\n")
    }
    if (format == "parquet") {
      txt <- "Richardson's et al. arrow package]"
      cat("[with the read_parquet() function from", txt, "\n")
    }

    if (browse) {
      cat("\n")
      cat("Data File:  ", from, "\n\n")
    }
  }


  # see if needed package is installed
  # ----------------------------------

  if (format %in% c("SPSS", "SAS", "Stata")) {
    if (!requireNamespace("haven", quietly=TRUE)) {
      stop("Packages \"haven\" and \"tzdb\" needed to read this file\n",
           "Please install them:  install.packages(c(\"haven\", \"tzdb\"))\n\n",
           call. = FALSE)
    }
  }

  if (format == "ODS") {
    if (!requireNamespace("readODS", quietly=TRUE)) {
      stop("Package \"readODS\" needed to read this file\n",
           "Please install:  install.packages(\"readODS\")\n\n",
           call. = FALSE)
    }
  }

  if (format %in% c("feather", "parquet")) {
    if (!requireNamespace("arrow", quietly=TRUE)) {
      stop("Package \"arrow\" needed to read this file\n",
           "Please install:  install.packages(\"arrow\")\n\n",
           call. = FALSE)
    }
  }


  # get type of txt file
  # --------------------
  if (format == "txt") {  # see if tab delimiter
    line1 <- scan(from, what="character", nlines=1, sep="\t", quiet=TRUE)
    format <- "csv"
    if (length(line1) > 1) {
      message(">>> A tab character detected in the first row of the\n",
          "     data file. Presume tab delimited data.\n", sep="")
      format <- "tsv"
    }
  }


  # read the data (into object d)
  # -----------------------------

  if (format=="fwd")
    d <- read.fwf(file=from, widths=widths, ...)


  else if (format %in% c("csv", "tsv", "prn")) {

    if (is.null(missing)) {
      if (format %in% c("csv", "tsv")) missing <- " "
      else if (format == "prn") missing <- "NA"
    }

    # read data or labels/units
    if (!var_labels) {
      if (row_names.miss) {
        if (format == "csv")
          d <- read.csv(file=from, na.strings=missing, header=header,...)
        else if (format == "tsv")
          d <- read.delim(file=from, na.strings=missing, header=header, ...)
        else if (format == "prn")
          d <- read.table(file=from, na.strings=missing, header=header, ...)
      }
      else {  # row names
        if (is.logical(row_names)) {  # can specify as TRUE
          row.names <- if (row_names) 1 else NULL
        }
        else
          row.names <- row_names
        if (format == "csv")
          d <- read.csv(file=from, na.strings=missing, row.names=row.names, ...)
        else if (format == "tsv")
          d <- read.delim(file=from, na.strings=missing,
                          row.names=row.names, ...)
        else if (format == "prn")
          d <- read.table(file=from, na.strings=missing,
                          row.names=row.names, ...)
      }  # end row names
    }  # not reading var labels

    else {  # read var_labels
      d <- read.csv(file=from, header=FALSE, row.names=1, ...)
      names(d)[1] <- "label"
      if (ncol(d) == 2) names(d)[2] <- "unit"
    }
  }  # end csv etc.


  else if (format %in% c("feather", "parquet")) {  # arrow file

    if (format=="feather")
      d <- arrow::read_feather(file=from, ...)
    else if (format=="parquet")
      d <- arrow::read_parquet(file=from, ...)
    d <- data.frame(d)  # default is a tibble
    if (names(d)[1] == "RowName") {  # when created with Write()
      rownames(d) <- d$RowName
      d$RowName <- NULL
    }
  }


  else if (format == "ODS") {

    if (!var_labels) {
      if (row_names.miss)
        row_names <- FALSE
      else {
        if (row_names == 1) row_names <- TRUE
      }
      if (row_names)
        d <- readODS::read_ods(from, sheet=sheet, row_names=TRUE,
                               as_tibble=FALSE, ...)
      else
        d <- readODS::read_ods(from, sheet=sheet, row_names=FALSE, ...)
      d <- data.frame(d)  # default is a tibble
    }


    else {
      d <- readODS::read_ods(from, sheet=sheet,
                               col_names=FALSE, row_names=TRUE)
      names(d)[1] <- "label"
      if (ncol(d) == 2) {
         names(d)[2] <- "unit"
         for (i in seq_len(nrow(d))) if (is.na(d[i,2])) d[i,2] <- ""
      }
    }
  }   # end (format == "ODS")


  else if (format == "Excel") {

    if (!var_labels) {
      row.names <- !missing(row_names)
      d <- openxlsx::read.xlsx(from, sheet=sheet, detectDates=TRUE,
              rowNames=row.names, ...)
    }

    else {
      d <- openxlsx::read.xlsx(from, sheet=sheet,
                               colNames=FALSE, rowNames=TRUE)
      names(d)[1] <- "label"
      if (ncol(d) == 2) {
         names(d)[2] <- "unit"
         for (i in seq_len(nrow(d))) if (is.na(d[i,2])) d[i,2] <- ""
      }
    }

    if (!is.null(list(...)$row.names))  # add any row.names to data frame
      d <- data.frame(d, row.names=list(...)$row.names)

    # if true integer, then convert from type double to integer
    rows <- min(50, nrow(d))  # save some time scanning
    fnu.col <- logical(length=ncol(d))
    for (i in seq_len(ncol(d)))
      if (.is.integer(d[seq_len(rows),i]))
        fnu.col[i] <- TRUE
     d[fnu.col] <- lapply(d[fnu.col], as.integer) # move to integer

  }  # end (format == "Excel")


  else if (format == "SPSS") {  # data and any labels
    if (!quiet) cat("[with read_spss() from the haven package]\n")
    dt <- haven::read_spss(file=from, ...)  # a tibble with label attribute
    d <- data.frame(dt)
    i.new <- 0
    for (i in seq_len(ncol(dt))) {
      i.new <- i.new + 1
      d[[i.new]] <- dt[[i]]
      names(d)[i.new] <- names(dt)[i]
      if ("haven_labelled" %in% class(dt[[i]])) {
        i.new <- i.new + 1
        d[[i.new]] <- haven::as_factor(dt[[i]])   # labels to a factor var
        names(d)[i.new] <- paste(names(dt)[i], "_f", sep="")
      }
    }  # end col by col 
    if (names(d)[1] == "RowName") {  # when created with Write()
      rownames(d) <- d$RowName
      d$RowName <- NULL
    }
    d[] <- lapply(d, function(col) {
      if (is.character(col)) col[col == ""] <- NA
      col
    })
    d[] <- lapply(d, function(col) {
      if (.is.integer(col)) col <- as.integer(col)
      col
    })

    has.haven <- FALSE
    for (i in seq_len(ncol(dt))) if ("haven_labelled" %in% class(dt[[i]]))
      has.haven <- TRUE
    if (has.haven) {
      cat("\nVariable and Variable Label  --> See vignette(\"Read\"),",
          "SPSS section\n")
      cat(.dash(27))
      for (i in seq_len(ncol(dt))) {
        if ("haven_labelled" %in% class(dt[[i]])) {
          lbl <- attr((dt[[i]]), "label")
          cat(paste(names(dt)[i], ", ", sep=""), lbl, "\n")
          cat(paste(names(dt)[i], "_f, ", sep=""), lbl, "\n")
        }
      }
    }  # end has.haven
    rm(dt)  # no longer need the tibble that was read
  }  # end SPSS

  else if (format == "SAS") { # data
    if (!quiet) cat("[with read_sas() from the haven package]\n")
    d <- haven::read_sas(data_file=from, ...)
  }

  else if (format == "Stata") { # data
    if (!quiet) cat("[with read_stata() from the haven package]\n")
    d <- haven::read_stata(file=from, ...)
  }

  else if (format == "R") {  # data and any labels
    x.env <- new.env()  # scratch environment
    load(from, envir=x.env)
    dname <- ls(x.env)
    d <- get(dname, pos=x.env)
  }

  else if (format == "lessR") {  # data and any labels
    txt <- if (substr(from,1,4) == "data") "" else "data"
    file.name <- paste(txt, from, ".rda", sep="")
    path.name <- paste(find.package("lessR"), "/data/",  file.name, sep="")

    if (!file.exists(path.name)) {  # manually had specified  format="lessR"
      df <- list.files(system.file("data", package="lessR"))
      df <- df[!(df %in%"dataFreqTable99.rda")]
      df <- gsub(".rda", "", df, fixed=TRUE)
      df <- gsub("^data", "", df)
      if (from %in% df)
        format <- "lessR"  # presume exact name not exist in current wd
      else {
        df <- paste(" ", df)
        cat("\n"); stop(call.=FALSE, "\n","------\n",
            "Need to specify  format  or specify the name of\n",
            "  a built-in lessR data file without the data prefix.\n\n",
            "Available lessR data files:\n\n", df, "\n\n")
      }
    }

    x.env <- new.env()  # scratch environment
    load(path.name, envir=x.env)

    dname <- paste(txt, from, sep="")
    d <- get(dname, pos=x.env)
  }  # end (format == "lessR")



  # check for valid characters in the variable names for text files
  # ---------------------------------------------------------------

  if (format %in% c("csv", "Excel")) {
    dg <- as.character(0:9)
    legal <- c(letters, LETTERS, dg, "_", ".", "(", ")")

    # get rid of variables that are not named (NA's)
    nm.miss <- is.na(names(d))
    d[nm.miss] <- NULL

    badchar <- FALSE
    for (i in seq_along(names(d))) {
      cc <- names(d)[i]
      if (!is.na(cc)) {
        for (j in seq_len(nchar(cc))) {
          if (!(substr(cc,j,j) %in% legal)) {
            badchar <- TRUE
            names(d)[i] <- gsub(substr(cc,j,j), "", names(d)[i])
            if (substr(cc,j,j) == " ")
              txt <- "Removed the blank space,"
            else
              txt <- paste("Removed character, ", substr(cc,j,j), ",", sep="")
            if (!quiet) cat(txt, "new variable name: ", names(d)[i], "\n")
          }  # char not legal
        }  # sequence through characters of ith name
      }  # cc cannot be missing
      if (substr(cc,1,1) == ".") {  # remove any beginning .
         while(substr(cc,1,1) == ".") cc <- substr(cc, 2, nchar(cc))
         names(d)[i] <- cc
         if (!quiet)
           cat("\nRemoved leading dots of variable name:", cc, "\n")
      }
    }
    if (badchar && !quiet)
      cat("\nR only allows letters, digits and . or  _ in variable names\n\n")
  }


  # function call for suggestions
  # -----------------------------
  fncl <- .fun_call.deparse(fun_call)

  if (!quiet) {
    if (getOption("suggest")) {
      if (brief || !grepl("var_labels", fncl)) {
        cat("\n>>> Suggestions\n")
        cat("Recommended binary format for data files: feather\n",
            " Create with Write(d, \"your_file\", format=\"feather\")\n")
        if (!grepl("var_labels", fncl)  &&  format != "lessR")
          cat("To read a csv or Excel file of variable labels",
              "var_labels=TRUE\n",
              "  Each row of the file:  Variable Name, Variable Label\n",
              "Read into a data frame named l  (the letter el)\n\n", sep="")
      }
      if (brief) {
        cat("More details about your data, Enter:  details()  for d, or",
           " details(name)\n")
      }
      cat("\n")
    }
  }


  # feedback
  # --------
  if (!quiet  &&  is.data.frame(d))
    details(d, n_mcut, max_lines, miss_show, miss_zero, miss_matrix,
            var_labels, brief)
  else
    cat("\n")

  return(d)

}

.hst.stats <-
function (h, len.x, mx.dd, fun_call) {

    # function call for suggestions
    fncl <- .fun_call.deparse(fun_call)

    tx <- character(length = 0)
    if (getOption("suggest")) {
     tx[length(tx)+1] <- ">>> Suggestions"
     if (!grepl("bin_width", fncl))
        tx[length(tx)+1] <- "bin_width: set the width of each bin"
      if (!grepl("bin_start", fncl))
        tx[length(tx)+1] <- "bin_start: set the start of the first bin"
      if (!grepl("bin_end", fncl))
        tx[length(tx)+1] <- "bin_end: set the end of the last bin"
      txt <- "  # smoothed curve + histogram"
      tx[length(tx)+1] <- paste("X(", getOption("xname"),
         ", type=\"density\")", txt, sep="")
      txt <- "  # Violin/Box/Scatterplot (VBS) plot"
      tx[length(tx)+1] <- paste("X(", getOption("xname"),
                                ", type=\"vbs\")", txt, sep="")
    }
    txsug <- tx
    if (length(txsug) == 0) txsug <- ""


    tx <- character(length = 0)

    # signif() drops floating-point noise, e.g., 11.0-10.9 in binary is
    #   0.0999999999999996, displayed and returned as 0.1
    bin_width <- signif(h$breaks[2]-h$breaks[1], 10)
    n.bins <- length(h$breaks)-1
    tx[length(tx)+1] <- paste("\nBin Width:", bin_width)
    tx[length(tx)+1] <- paste("Number of Bins:", n.bins)
    tx[length(tx)+1] <- ""

    # j<17 condition is to stop the 0.99999... problem
    max.dg <- 0
    for (i in 1:length(h$breaks)) {
      j <- nchar(as.character(h$breaks[i]))
      if (j>max.dg && j<17) max.dg <- j
    }
    max.dg.mid <- 0
    for (i in 1:length(h$mids)) {
      j <- nchar(as.character(h$mids[i]))
      if (j>max.dg.mid && j<19) max.dg.mid <- j
    }

    x.breaks <- format(h$breaks, width=max.dg, justify="right", scientific=FALSE)
    x.mids <- format(h$mids, width=max.dg.mid, justify="right", scientific=FALSE)
    # if bin_start < 0, a midpt approx 0, format() then has too many digits
    if (.lead0(h$mids) > mx.dd)
      x.mids <- .fmt(h$mids, d=mx.dd)

    bn <- character(length=0)
    for (i in 1:(length(x.breaks)-1))
      bn[i] <- paste(x.breaks[i], ">", x.breaks[i+1])

    cum.c <- cumsum(h$counts)
    prop <- h$counts / len.x
    cum.p <- cumsum(prop)

    out <- data.frame(bn)
    out$x.mids <- x.mids
    out$counts <- formatC(h$counts, digits=0, format="f")
    out$prop <- formatC(prop, digits=2, format="f")
    out$cum.c <- formatC(cum.c, digits=0, format="f")
    out$cum.p <- formatC(cum.p, digits=2, format="f")
    names(out) <- c("Bin", "Midpnt", "Count", "  Prop", "Cumul.c", "Cumul.p")

    # width of columns
    max.ln <- integer(length=0)
    for (i in 1:ncol(out)) {
      ln.nm <- nchar(colnames(out)[i]) + 1
      max.val <- max(nchar(out[,i]))
      max.ln[i] <- max(ln.nm, max.val) + 1
    }

    # write col labels
    tx[length(tx)+1] <- ""
    for (i in 1:ncol(out))
      tx[length(tx)] <- paste(tx[length(tx)], .fmtc(colnames(out)[i],
                              w=max.ln[i]), sep="")
    tx[length(tx)+1] <- .dash2(sum(max.ln))

    # write values
    for (i in 1:nrow(out)) {
      tx[length(tx)+1] <- ""
       for (j in 1:ncol(out))
          tx[length(tx)] <- paste(tx[length(tx)], .fmtc(out[i,j],
                                   w=max.ln[j]), sep="")
    }
    tx[length(tx)+1] <- ""

    return(list(txsug=txsug, tx=tx, bin_width=bin_width, n.bins=n.bins,
                prop=prop, counts_cum=cum.c, prop_cum=cum.p))

}

# generate unique ID
.next_eid <- function(prefix = "lessR") {
  counter <- getOption("lessR.widget_counter", 0L) + 1L
  options(lessR.widget_counter = counter)

  # millisecond timestamp as character (no integer overflow)
  stamp <- format(Sys.time(), "%Y%m%d%H%M%OS3")

  sprintf("%s-%s-%d", prefix, stamp, counter)
}




# ----- title builder (consistent across chart types) ---------------------
.plotly_build_title <- function(x_name,
                               by_name   = NULL,
                               facet_name= NULL,
                               y_name    = NULL,
                               stat      = NULL) {
  cap_stat <- function(s) switch(tolower(s),
                                 mean="Mean", sum="Sum", median="Median",
                                 min="Min",  max="Max",  sd="SD",
                                 toupper(s))
  # helper: does y_name already start with a stat word?
  y_has_stat <- function(y) {
    if (is.null(y)) return(FALSE)
    grepl("^(Mean|Sum|Median|Min|Max|SD)\\b", y)
  }
  # helper: detect stat suffix from pivot()-style names like "Salary_mean"
  y_stat_suffix <- function(y) {
    if (is.null(y)) return(NULL)
    m <- regmatches(y, regexpr("_(mean|sum|median|min|max|sd)$",
                               y, ignore.case=TRUE))
    if (length(m) == 0L) NULL else sub("^_", "", m)
  }

  # --- COUNT title only when neither y nor stat is provided ---
  if (is.null(y_name) && is.null(stat)) {
    ttl <- paste("Count of", x_name)
  }
  else if (is.null(stat)) {
    # y_name present but stat missing — likely pre-aggregated data
    suf <- y_stat_suffix(y_name)
    if (!is.null(suf)) {
      # strip suffix and use detected stat
      base_y <- sub("_(mean|sum|median|min|max|sd)$", "", y_name,
                    ignore.case=TRUE)
      ttl    <- paste(cap_stat(suf), "of", base_y, "by", x_name)
    } else if (y_has_stat(y_name)) {
      ttl <- paste(y_name, "by", x_name)
    } else {
      ttl <- paste(y_name, "by", x_name)
    }
  }
  else {
    S <- cap_stat(stat)
    if (y_has_stat(y_name)) {
      ttl <- paste(y_name, "by", x_name)
    } else {
      ttl <- paste(S, "of", y_name, "by", x_name)
    }
  }
  if (!is.null(by_name) && nzchar(by_name)) ttl <- paste(ttl, "by", by_name)
  if (!is.null(facet_name) && nzchar(facet_name))
     ttl <- paste(ttl, "across", facet_name)
  ttl
}


# ----- collected style options for plotly internals ---------------------
# Read once in Chart()/X()/XY() and passed down so plotly fns don't reach
# into getOption() themselves. Defaults match what the prior in-line reads
# applied at each call site.
.plotly_style <- function() {
  pb <- getOption("panel_border", "#808080")
  list(
    axis_color        = getOption("axis_color"),
    axis_text_color   = getOption("axis_text_color"),
    axis_x_color      = getOption("axis_x_color"),
    axis_y_color      = getOption("axis_y_color"),
    axis_x_text_color = getOption("axis_x_text_color"),
    axis_y_text_color = getOption("axis_y_text_color"),
    grid_color        = getOption("grid_color", "gray85"),
    grid_col          = getOption("grid_col",   "gray85"),
    grid_x_color      = getOption("grid_x_color"),
    grid_y_color      = getOption("grid_y_color"),
    lab_color         = getOption("lab_color", "black"),
    legend_border     = getOption("legend_border", pb),
    panel_border      = pb,
    panel_fill        = getOption("panel_fill", "white"),
    plotly_dpi        = getOption("plotly_dpi", 96),
    segment_color     = getOption("segment_color"),
    theme             = getOption("theme"),
    window_fill       = getOption("window_fill", "white")
  )
}


# ----- proportional palette index --------------------------------------
# Map a vector of values into [lo, hi] fraction of a length-n_pal palette.
# Used by .hier_color_resolve() for sequential luminance mapping.
.plotly_prop_idx <- function(vals, n_pal, lo = 0.28, hi = 1.0) {
  mn.s <- min(vals, na.rm = TRUE)
  mx.s <- max(vals, na.rm = TRUE)
  rng  <- mx.s - mn.s
  if (rng > 0)
    round(1 + (lo + (vals - mn.s) / rng * (hi - lo)) * (n_pal - 1))
  else
    rep(round(1 + ((lo + hi) / 2) * (n_pal - 1)), length(vals))
}


# ----- hier-chart fill resolution --------------------------------------
# Returns the per-top-level hex color vector and (if facet supplied) a
# per-facet remapping so sequential palettes span their full luminance
# range within each panel. Replaces the in-line color logic that used to
# live in .hier.plotly().
#
# Returns list(fill_vec, fill_vec_byfac) — both NULL-safe.
#   fill_vec       : named hex vector keyed by top.level (length n.lvl)
#   fill_vec_byfac : NULL when facet is NULL; otherwise a named list
#                    keyed by facet level, each value a named hex vector
#                    keyed by that facet's present top.levels
.hier_color_resolve <- function(x, y, facet, fill, fill.palette,
                                theme, stat) {
  seq.pals <- c("gray", "grays", "grey", "greys",
                "blues", "greens", "reds", "purples",
                "violets", "rusts", "oranges", "browns", "terrain")
  pal.name <- tolower(fill.palette[1L] %||% "")
  is.seq   <- pal.name %in% seq.pals || theme %in% c("gray", "white")

  top.raw <- as.character(x)
  present <- unique(top.raw[!is.na(top.raw)])
  top.levels <- if (is.factor(x)) {
    lv <- levels(x)
    lv[lv %in% present]
  } else present

  STAT     <- tolower(stat %||% "sum")
  stat.fun <- .stat_fun(STAT)

  base.vals <- if (is.null(y)) rep(1, length(top.raw)) else {
    z <- suppressWarnings(as.numeric(y))
    z[!is.finite(z)] <- 0
    z
  }

  # global top.stats (sequential only) — also reorders top.levels by stat
  top.stats <- NULL
  if (is.seq) {
    agg.fun <- if (!is.null(y)) stat.fun
               else function(z) sum(ifelse(is.na(z), 0, 1))
    top.stats <- tapply(base.vals, top.raw, agg.fun)[top.levels]
    ord       <- order(top.stats, decreasing = TRUE)
    top.levels<- top.levels[ord]
    top.stats <- top.stats[ord]
  }

  n.lvl <- length(top.levels)

  big.pal <- if (is.null(fill)) {
    pal <- fill.palette[1L] %||% "hues"
    if (is.seq) .color_range(pal, 256L)
    else .color_range(pal, max(n.lvl, 1L))
  } else fill

  fill.vec <- if (is.seq && !is.null(top.stats) && n.lvl > 1L &&
                  diff(range(top.stats)) > 0) {
    .scale.clr(top.stats, fill=NULL,
      fill_split=0, fill_chroma=75, theme=theme)
  } else if (is.seq) {
    h.v <- if (theme %in% c("gray", "white")) 0 else .get.h(theme)
    c.v <- if (theme %in% c("gray", "white")) 0 else 75
    rep_len(hcl(h=h.v, c=c.v, l=60), max(n.lvl, 1L))
  } else {
    out <- big.pal[seq_len(n.lvl)]
    if (length(out) < n.lvl) out <- rep_len(big.pal, n.lvl)
    out
  }
  fill.vec <- setNames(fill.vec, top.levels)

  fill.vec.byfac <- NULL
  if (!is.null(facet)) {
    fac.chr <- as.character(facet)
    fac.levels <- if (!is.null(levels(facet))) levels(facet)
                  else unique(fac.chr[!is.na(fac.chr)])
    fac.levels <- sort(fac.levels)

    fill.vec.byfac <- setNames(vector("list", length(fac.levels)),
                                fac.levels)
    for (lv in fac.levels) {
      idx <- which(fac.chr == lv)
      if (!is.seq || length(idx) == 0L) {
        # categorical (or empty facet): use global vec
        fill.vec.byfac[[lv]] <- fill.vec
        next
      }
      fac.base  <- base.vals[idx]
      fac.x     <- top.raw[idx]
      fac.stats <- tapply(fac.base, fac.x, stat.fun)
      fac.top   <- top.levels[top.levels %in% names(fac.stats)]
      fac.stats <- fac.stats[fac.top]
      ord.f     <- order(fac.stats, decreasing = TRUE)
      fac.top   <- fac.top[ord.f]
      fac.stats <- fac.stats[ord.f]
      if (length(fac.top) > 1L && diff(range(fac.stats)) > 0) {
        fill.vec.byfac[[lv]] <- setNames(
          .scale.clr(fac.stats, fill=NULL,
            fill_split=0, fill_chroma=75,
            theme=theme),
          fac.top)
      } else {
        h.v <- if (theme %in% c("gray", "white")) 0
               else .get.h(theme)
        c.v <- if (theme %in% c("gray", "white")) 0 else 75
        fill.vec.byfac[[lv]] <- setNames(
          rep_len(hcl(h=h.v, c=c.v, l=60),
                  max(length(fac.top), 1L)),
          fac.top)
      }
    }
  }

  list(fill_vec = fill.vec, fill_vec_byfac = fill.vec.byfac)
}


# ----- hierarchical aggregation ----------------------------------------
# Build the per-level node tables that .hier.plotly() will hand to
# plotly's sunburst/treemap/icicle traces. Called by Chart() so the
# plotly internal stays pure-rendering.
#
# Returns list with:
#   nd            : data frame (ids/labels/parents/values/text/customdata/
#                   root) for the non-faceted call
#   nd_byfac      : named list of nd data frames (one per facet level), or
#                   NULL when facet is NULL
#   stat.label    : "Count" / y_name / "<Stat> of y_name" (hover legend)
#   non.additive  : TRUE when STAT != "sum" (controls label formatting)
#   STAT          : tolower(stat %||% "sum")
.hier_aggregate <- function(x, by = NULL, y = NULL, facet = NULL,
                            stat = NULL,
                            x_name = "X", by_name = NULL,
                            facet_name = "Facet", y_name = "y",
                            digits_d = NULL) {

  mk.char <- function(v) as.character(v)

  if (is.null(by)) {
    path.df   <- data.frame(x = mk.char(x), check.names = FALSE)
    lvl.names <- c(x_name)
  } else if (is.data.frame(by)) {
    tmp <- as.data.frame(lapply(by, mk.char), check.names = FALSE)
    path.df   <- data.frame(x = mk.char(x), tmp, check.names = FALSE)
    lvl.names <- c(x_name, names(tmp))
  } else {
    path.df   <- data.frame(x = mk.char(x), by = mk.char(by),
                            check.names = FALSE)
    lvl.names <- c(x_name, by_name %||% "by")
  }

  path.cols <- names(path.df)
  n.levels  <- length(path.cols)

  base.vals <- if (is.null(y)) rep(1, nrow(path.df)) else {
    z <- suppressWarnings(as.numeric(y))
    z[!is.finite(z)] <- 0
    z
  }

  STAT         <- tolower(stat %||% "sum")
  stat.fun     <- .stat_fun(STAT)

  non.additive <- !identical(STAT, "sum")

  stat.label <- if (is.null(y)) "Count"
                else if (non.additive) paste0(toupper(substr(STAT, 1, 1)),
                                              substr(STAT, 2, nchar(STAT)),
                                              " of ", y_name)
                else y_name

  digits <- if (is.null(digits_d)) 2L else max(0L, as.integer(digits_d))

  # Build the per-level node table for the given row subset. Mirrors the
  # build.nodes closure that used to live in .hier.plotly().
  build_nodes <- function(idx, facet_label = NULL) {
    if (length(idx) == 0L) {
      return(data.frame(
        ids     = character(),
        labels  = character(),
        parents = character(),
        values  = numeric(),
        text    = character(),
        customdata = I(list()),
        root    = character()
      ))
    }

    df  <- path.df[idx, , drop = FALSE]
    val <- base.vals[idx]

    out.ids     <- character(0)
    out.labels  <- character(0)
    out.parents <- character(0)
    out.values  <- numeric(0)
    out.text    <- character(0)
    out.custom  <- list()
    out.root    <- character(0)

    for (lvl in seq_len(n.levels)) {
      cols <- path.cols[1:lvl]
      agg.size <- stats::aggregate(val, by = df[, cols, drop = FALSE],
                                   FUN = stat.fun)
      names(agg.size)[ncol(agg.size)] <- "size"
      agg.stat <- agg.size
      names(agg.stat)[ncol(agg.stat)] <- "stat"

      cur.labels <- mk.char(agg.size[[cols[lvl]]])
      root.vals  <- mk.char(agg.size[[path.cols[1L]]])

      if (lvl == 1L) {
        parents <- rep("", nrow(agg.size))
        ids     <- paste0("I_", cur.labels)
      } else {
        parent.df <- agg.size[, cols[-length(cols)], drop = FALSE]
        parents   <- apply(parent.df, 1, function(r)
          paste0("I_", paste(mk.char(r), collapse = "_")))
        ids       <- paste0(parents, "_", cur.labels)
      }

      meta.lines <- mapply(function(row_i) {
        parts <- character(0)
        for (k in seq_len(lvl))
          parts <- c(parts, paste0(lvl.names[k], ": ",
                                   mk.char(agg.size[row_i, cols[k]])))
        if (!is.null(facet_label))
          parts <- c(parts, paste0(facet_name, ": ", facet_label))
        paste(parts, collapse = "<br>")
      }, seq_len(nrow(agg.size)), SIMPLIFY = TRUE, USE.NAMES = FALSE)

      if (is.null(y)) {
        node.n <- agg.size$size
      } else {
        agg.n <- stats::aggregate(ifelse(is.na(val), 0, 1),
                                  by = df[, cols, drop = FALSE], FUN = sum)
        names(agg.n)[ncol(agg.n)] <- "n"
        key.size <- do.call(paste, c(agg.size[, cols, drop=FALSE], sep="\r"))
        key.n    <- do.call(paste, c(agg.n[, cols, drop=FALSE], sep="\r"))
        node.n   <- agg.n$n[match(key.size, key.n)]
      }

      custom <- Map(
        function(meta_txt, stat_v, n_v)
          list(meta = meta_txt, stat = stat_v, n = n_v, level = lvl),
        meta.lines, agg.stat$stat, node.n
      )

      out.ids     <- c(out.ids,     ids)
      out.labels  <- c(out.labels,  cur.labels)
      out.parents <- c(out.parents, parents)
      out.values  <- c(out.values,
                       if (lvl == n.levels) agg.size$size
                       else                 rep(0, nrow(agg.size)))
      stat.vals   <- agg.stat$stat
      node.text   <- formatC(stat.vals, format = "f", digits = digits)
      out.text    <- c(out.text,    node.text)
      out.custom  <- c(out.custom,  custom)
      out.root    <- c(out.root,    root.vals)
    }

    # top.levels factor ordering is set by Chart's color resolver, not here
    data.frame(
      ids        = out.ids,
      labels     = out.labels,
      parents    = out.parents,
      values     = out.values,
      text       = out.text,
      customdata = I(out.custom),
      root       = out.root,
      stringsAsFactors = FALSE
    )
  }

  nd       <- if (is.null(facet)) build_nodes(seq_len(nrow(path.df)))
              else NULL
  nd_byfac <- NULL
  if (!is.null(facet)) {
    fac.chr    <- mk.char(facet)
    fac.levels <- if (!is.null(levels(facet))) levels(facet)
                  else unique(fac.chr[!is.na(fac.chr)])
    fac.levels <- sort(fac.levels)
    nd_byfac <- setNames(vector("list", length(fac.levels)), fac.levels)
    for (lv in fac.levels) {
      idx <- which(fac.chr == lv)
      nd_byfac[[lv]] <- build_nodes(idx, facet_label = lv)
    }
  }

  list(
    nd           = nd,
    nd_byfac     = nd_byfac,
    stat.label   = stat.label,
    non.additive = non.additive,
    STAT         = STAT,
    n_levels     = n.levels,   # depth: 1 = no by-grouping; 2+ = nested
    has_y        = !is.null(y) # whether y was supplied (affects label/layout)
  )
}


# ----- radar aggregation -----------------------------------------------
# Build the 3-way (facet × by × x) value table that .radar.plotly() will
# render. Called by Chart() so the plotly internal stays pure-rendering.
#
# Returns list with:
#   r.tab     : xtabs 3-way table value ~ facet+by+x
#   facet.fac : factor of facet levels (display order)
#   by.fac    : factor of by levels (display order)
#   x.fac.out : factor of x (axis) levels (display order)
#   rmax      : max value across the table (axis upper bound)
#   n.fac     : length(facet.fac)
#   n.by      : length(by.fac)
#   y.label   : hover-text label ("Count" / y_name / "StatName y_name")
.radar_aggregate <- function(x, by = NULL, facet = NULL, y = NULL,
                             stat = NULL, y_name = "y") {
  n <- length(x)
  if (n == 0L) stop("radar(): x has length 0.")

  x.fac      <- factor(x, levels = sort(unique(x)))
  by.fac.in  <- if (is.null(by))    factor(rep("(All)", n), levels="(All)")
                else factor(by, levels = unique(by))
  fac.fac.in <- if (is.null(facet)) factor(rep("(All)", n), levels="(All)")
                else factor(facet, levels = unique(facet))

  stat.supplied <- !is.null(stat) && nzchar(stat)

  if (is.null(y)) {
    val     <- rep(1, n)
    STAT    <- "sum"
    fun     <- function(z) sum(z, na.rm = TRUE)
    y.label <- "Count"
  } else {
    STAT <- if (stat.supplied) tolower(stat) else "sum"
    fun  <- .stat_fun(STAT)
    val <- suppressWarnings(as.numeric(y))
    val[!is.finite(val)] <- NA_real_

    y.label <- if (stat.supplied) {
      StatName <- switch(STAT,
        mean="Mean", sum="Sum", median="Median",
        min="Min", max="Max", sd="SD", toupper(stat))
      paste(StatName, y_name)
    } else y_name
  }

  df <- data.frame(facet = fac.fac.in, by = by.fac.in,
                   x = x.fac, val = val)
  agg <- stats::aggregate(val ~ facet + by + x, data = df,
                          FUN = fun, drop = FALSE)
  names(agg)[names(agg) == "val"] <- "value"
  r.tab <- xtabs(value ~ facet + by + x, data = agg,
                 drop.unused.levels = FALSE)

  facet.fac <- factor(dimnames(r.tab)[[1]], levels = dimnames(r.tab)[[1]])
  by.fac    <- factor(dimnames(r.tab)[[2]], levels = dimnames(r.tab)[[2]])
  x.fac.out <- factor(dimnames(r.tab)[[3]], levels = dimnames(r.tab)[[3]])

  if (!length(x.fac.out)) stop("radar(): x has no levels to plot.")
  if (!length(by.fac))    stop("radar(): by has no levels to plot.")
  if (!length(facet.fac)) stop("radar(): facet has no levels to plot.")

  rmax <- max(r.tab, na.rm = TRUE)
  if (!is.finite(rmax))
    stop("radar(): all aggregated values are NA; nothing to plot.")

  list(
    r.tab     = r.tab,
    facet.fac = facet.fac,
    by.fac    = by.fac,
    x.fac.out = x.fac.out,
    rmax      = rmax,
    n.fac     = length(facet.fac),
    n.by      = length(by.fac),
    y.label   = y.label
  )
}




# Plots and Viewer window notices ----------------------------------------

if (!exists(".lessR_deprec_env", inherits = FALSE)) {
  .lessR_deprec_env <- new.env(parent = emptyenv())
}

# One-time notice with ANSI color (auto-disables if not supported).
# Persists per R session via options(lessR.seen_notices = list(...)).
# One-time notice (ANSI color only when supported).
# Persists per R session via options(lessR.seen_notices = list(...)).
.viewer_notice_once <- function(plot_name, window_target = "Viewer") {

  # 0) Never print this during knitting / rendering (vignettes, Rmd, Quarto)
  if (isTRUE(getOption("knitr.in.progress"))) return(invisible(NULL))
  if (isTRUE(getOption("quarto.rendering")))  return(invisible(NULL))

  # 1) allow global silence
  if (isTRUE(getOption("lessR.silence_notices", FALSE))) return(invisible(NULL))

  # build a stable key (e.g., "notice_viewer_radar")
  key <- paste0(
    "notice_",
    tolower(gsub("\\s+", "_", window_target)),
    "_",
    tolower(gsub("\\s+", "_", plot_name))
  )

  seen <- getOption("lessR.seen_notices", default = list())
  if (isTRUE(seen[[key]])) return(invisible(NULL))

  # 2) Decide whether to use ANSI sequences (only in interactive terminals)
  use_ansi <- isTRUE(getOption("lessR.use_ansi_notices", TRUE)) &&
              interactive() &&
              nzchar(Sys.getenv("TERM")) &&
              Sys.getenv("TERM") != "dumb" &&
              Sys.getenv("RSTUDIO") != "1"   # RStudio console does not reliably render ANSI

  if (use_ansi) {
    bold     <- "\033[1m"
    unbold   <- "\033[22m"
    darkred  <- "\033[38;5;88m"
    darkblue <- "\033[38;5;19m"
    purple   <- "\033[38;5;93m"
    reset    <- "\033[0m"
  } else {
    bold <- unbold <- darkred <- darkblue <- purple <- reset <- ""
  }

  msg <- switch(
    window_target,
    "Viewer" = paste0(
      " ", darkred, "Viewer", reset, " Window --> Plotly interactive visualization\n",
      "   You may need to properly align the plot by clicking the ", bold, "Refresh button", unbold, " at the\n",
      "   top-right of the Viewer window, especially for legends or labels to display.\n"
    ),
    "Plots" = paste0(
      " ", darkblue, "Plots", reset, " Window --> Static visualization\n",
      "   This chart appears in the Plots pane. Use Export to save or copy.\n"
    ),
    "Both" = paste0(
      " ", purple, "Viewer + Plots", reset, " --> Interactive (Viewer) and static (Plots)\n"
    ),
    paste0(" Output --> Visualization generated in ", window_target, ".\n")
  )

  # Use message() so message=FALSE can suppress in chunks when desired
  message(msg)

  # mark as seen for the remainder of the session
  seen[[key]] <- TRUE
  options(lessR.seen_notices = seen)

  invisible(NULL)
}


# color functions ---------------------------------------------------------

# --- Perceived luminance + black/white auto-contrast -----------------------
.hex_to_rgb3 <- function(h) {
  h <- gsub("#", "", toupper(h))
  if (nchar(h) %in% c(3,4)) {
    h <- paste0(substr(h,1,1), substr(h,1,1),
                substr(h,2,2), substr(h,2,2),
                substr(h,3,3), substr(h,3,3))
  }
  c(strtoi(substr(h,1,2), 16L),
    strtoi(substr(h,3,4), 16L),
    strtoi(substr(h,5,6), 16L))
}

.srgb_to_lin3 <- function(c) {
  c <- c / 255
  ifelse(c <= 0.03928, c / 12.92, ((c + 0.055) / 1.055)^2.4)
}

.contrast_text_for_hex <- function(hex) {
  # expects #RRGGBB (use .to_hex first if needed)
  rgb <- .hex_to_rgb3(hex)
  lin <- .srgb_to_lin3(rgb)
  L   <- 0.2126 * lin[1] + 0.7152 * lin[2] + 0.0722 * lin[3]
  # Compare contrast with white vs black; choose the higher
  if ((1.05) / (L + 0.05) > (L + 0.05) / 0.05) "#FFFFFF" else "#000000"
}
# --------

.resolve_alpha <- function(k, opacity) {
  if (!is.null(opacity)) return(as.numeric(opacity))
  .auto_opacity(k, "fill")
}


.to_hex <- function(col) {
  if (length(col) == 0) return(character(0))
  conv1 <- function(c1) {
    if (is.na(c1)) return(NA_character_)
    c1 <- trimws(as.character(c1))

    # --- rgb()/rgba(): retain alpha if present ----------------------------
    m <- regexec("^rgba?\\(([^)]+)\\)$", c1, perl = TRUE)
    g <- regmatches(c1, m)[[1]]
    if (length(g)) {
      parts <- as.numeric(strsplit(g[2], "\\s*,\\s*")[[1]])
      r  <- as.integer(round(pmax(0, pmin(255, parts[1]))))
      g1 <- as.integer(round(pmax(0, pmin(255, parts[2]))))
      b  <- as.integer(round(pmax(0, pmin(255, parts[3]))))
      if (length(parts) == 4) {                          # rgba() has alpha
        a <- as.integer(round(pmax(0, pmin(1, parts[4])) * 255))
        return(sprintf("#%02X%02X%02X%02X", r, g1, b, a))
      }
      return(sprintf("#%02X%02X%02X", r, g1, b))
    }

    # --- #RRGGBB  ----------------------------------------------------------
    if (grepl("^#[0-9A-Fa-f]{6}$", c1)) return(c1)

    # --- #RGB -> expand ----------------------------------------------------
    if (grepl("^#[0-9A-Fa-f]{3}$", c1)) {
      r <- substr(c1, 2, 2); g1 <- substr(c1, 3, 3); b <- substr(c1, 4, 4)
      return(paste0("#", r, r, g1, g1, b, b))
    }

    # --- #RRGGBBAA: keep as-is --------------------------------------------
    if (grepl("^#[0-9A-Fa-f]{8}$", c1)) return(c1)

    # --- named colors -> col2rgb, retain alpha if present -----------------
    rgb <- grDevices::col2rgb(c1, alpha = TRUE)
    a <- rgb[4, 1]
    if (a < 255L)
      sprintf("#%02X%02X%02X%02X", rgb[1,1], rgb[2,1], rgb[3,1], a)
    else
      sprintf("#%02X%02X%02X", rgb[1,1], rgb[2,1], rgb[3,1])
  }

  col <- ifelse(tolower(trimws(col)) == "off", "transparent", col)
  vapply(col, conv1, "", USE.NAMES = FALSE)
}


# Accepts: #RRGGBB, #RRGGBBAA, #RGB, named colors, or already rgba()
# Returns: rgba(r,g,b,a) with a in [0,1], preserving alpha if present
# shim: convert any color to Plotly rgba(), with alpha boosted for visual parity
# alpha_adjust: add e.g. +0.25 if Plotly looks too transparent
.as_plotly_rgba <- function(col, alpha_adjust = 0) {
  sapply(col, function(c1) {
    s <- trimws(c1)
    if (!nzchar(s)) return("rgba(0,0,0,0)")
    if (grepl("^#[0-9A-Fa-f]{8}$", s)) {
      r <- strtoi(substr(s, 2, 3), 16L)
      g <- strtoi(substr(s, 4, 5), 16L)
      b <- strtoi(substr(s, 6, 7), 16L)
      a <- strtoi(substr(s, 8, 9), 16L) / 255
    } else if (grepl("^#[0-9A-Fa-f]{6}$", s)) {
      r <- strtoi(substr(s, 2, 3), 16L)
      g <- strtoi(substr(s, 4, 5), 16L)
      b <- strtoi(substr(s, 6, 7), 16L)
      a <- 1
    } else {
      rgbm <- grDevices::col2rgb(s)
      r <- rgbm[1,1]; g <- rgbm[2,1]; b <- rgbm[3,1]; a <- 1
    }
    a <- max(0, min(1, a + alpha_adjust))
    sprintf("rgba(%d,%d,%d,%.3f)", r, g, b, a)
  }, USE.NAMES = FALSE)
}


# Lighten colors toward white by 'amount' in [0,1]. Vectorized; returns hex.
.lighten_plotly <- function(col, amount = 0.35) {
  if (!length(col)) return(character(0))
  amount  <- max(0, min(1, as.numeric(amount[1])))
  col_chr <- as.character(col)

  # If any entries are rgba(...), strip alpha -> rgb(...) so col2rgb can parse
  is_rgba <- grepl("^\\s*rgba\\(", col_chr, ignore.case = TRUE)
  if (any(is_rgba)) {
    col_chr[is_rgba] <- sub(
      "^\\s*rgba\\s*\\(([^,]+),([^,]+),([^,]+),.*\\)\\s*$",
      "rgb(\\1,\\2,\\3)", col_chr[is_rgba], ignore.case = TRUE
    )
  }

  # Vectorized col2rgb; fallback element-wise if needed
  M <- tryCatch(
    grDevices::col2rgb(col_chr, alpha = FALSE),
    error = function(e) {
      mm <- sapply(col_chr, function(cc)
        tryCatch(grDevices::col2rgb(cc, alpha = FALSE)[, 1],
                 error = function(e) c(NA_real_, NA_real_, NA_real_)))
      if (is.null(dim(mm))) dim(mm) <- c(3L, length(col_chr))
      mm
    }
  )
  if (is.null(dim(M))) dim(M) <- c(3L, length(col_chr))  # handle single color case

  # Replace NA channels with a neutral mid-gray to avoid rgb() failure
  M[is.na(M)] <- 204

  # Lighten toward white while PRESERVING DIMENSIONS (avoid pmin/pmax)
  M2 <- M * (1 - amount) + 255 * amount
  M2 <- round(M2)
  M2[M2 < 0]   <- 0
  M2[M2 > 255] <- 255
  dim(M2) <- dim(M)  # ensure still 3 x n

  grDevices::rgb(M2[1, ] / 255, M2[2, ] / 255, M2[3, ] / 255)
}


# Adaptive opacity tuned for overlays/fills so traces remain distinguishable.
# Linear adaptive opacity: opacity = 0.65 - 0.058 * k
# k = number of overlapping groups/traces
.auto_opacity <- function(k, mode = c("overlay","fill","lines","stack")) {
  mode <- match.arg(mode)
  k <- max(1L, as.integer(k))

  # base line (your fit)
  base <- 0.65 - 0.058 * k
  if (k == 1L) base <- 1.00  # single series should be fully opaque

  # mode-specific clamps
  rng <- switch(mode,
    overlay = c(0.28, 0.80),  # barpolar overlays
    fill    = c(0.20, 0.65),  # radar polygon fills
    lines   = c(0.40, 0.90),  # line-only traces
    stack   = c(1.00, 1.00)   # stacks don't need transparency
  )

  opacity <- max(rng[1], min(rng[2], base))
  as.numeric(opacity)
}


# Uniform or per-point transparency for FILL colors
# col   : character vector of colors (names or hex)
# alpha : numeric in [0,1]; scalar or same length as 'col'
# recycle: if TRUE, recycle 'alpha' to length(col)
.maketrans_plotly <- function(col, alpha, recycle = TRUE) {
  if (missing(alpha)) stop(".maketrans_plotly(): 'alpha' is required")
  if (!length(col))   return(character(0))

  col_chr <- as.character(col)
  if (recycle) alpha <- rep_len(alpha, length(col_chr))
  a <- pmax(0, pmin(1, as.numeric(alpha)))

  out <- character(length(col_chr))
  lc  <- trimws(tolower(col_chr))

  # transparent / missing shortcuts
  special <- is.na(col_chr) | lc %in% c("", "na", "transparent", "off")
  out[special] <- "rgba(0,0,0,0)"

  # already rgba(): replace alpha
  is_rgba <- grepl("^rgba\\s*\\(", lc)
  if (any(is_rgba & !special)) {
    idx <- which(is_rgba & !special)
    out[idx] <- sub(
      pattern = "rgba\\s*\\(([^,]+),([^,]+),([^,]+),[^\\)]+\\)\\s*$",
      replacement = function(m) {
        # keep r,g,b; swap a
        paste0("rgba(", sub("rgba\\s*\\(|\\)\\s*$", "", regmatches(col_chr[idx], regexpr("rgba\\s*\\([^\\)]*\\)", col_chr[idx]))), ")")
      },
      x = col_chr[idx]
    )
    # Now apply the new alpha cleanly
    # Parse r,g,b fast:
    rgbm <- grDevices::col2rgb(sub("^rgba\\s*\\(", "rgb(", col_chr[idx]))
    out[idx] <- sprintf("rgba(%d,%d,%d,%.3f)", rgbm[1,], rgbm[2,], rgbm[3,], a[idx])
  }

  # normal colors (hex/named)
  norm <- !special & !is_rgba
  if (any(norm)) {
    idx <- which(norm)
    rgbm <- grDevices::col2rgb(col_chr[idx])
    out[idx] <- sprintf("rgba(%d,%d,%d,%.3f)", rgbm[1, ], rgbm[2, ], rgbm[3, ], a[idx])
  }
  out
}


# Opaque border color for Plotly markers/lines (forces a = 1)
.to_plotly_color <- function(col) {
  if (!length(col)) return(character(0))
  col_chr <- as.character(col)
  special <- is.na(col_chr) |
             trimws(tolower(col_chr)) %in% c("", "na", "transparent", "off")
  out <- character(length(col_chr))
  out[special] <- "rgba(0,0,0,0)"  # invisible border if asked to be transparent

  if (any(!special)) {
    idx  <- which(!special)
    rgbm <- grDevices::col2rgb(col_chr[idx])
    out[idx] <- sprintf("rgba(%d,%d,%d,1.000)", rgbm[1, ], rgbm[2, ], rgbm[3, ])
  }
  out
}


# Choose/recycle by names (used everywhere)
.pick_by_names_or_recycle <- function(v, needed_names, needed_len, fallback=NULL) {
  v <- as.character(v); nm <- names(v)
  if (!is.null(nm) && length(nm)) {
    out <- v[match(needed_names, nm)]
    if (anyNA(out)) {
      base <- if (length(v)) v else (fallback %||% grDevices::hcl.colors(needed_len, "Dark 3"))
      out[is.na(out)] <- base[((which(is.na(out)) - 1L) %% length(base)) + 1L]
    }
    return(out)
  }
  if (!length(v)) {
    return(if (!is.null(fallback)) rep_len(fallback, needed_len)
           else grDevices::hcl.colors(needed_len, "Dark 3"))
  }
  rep_len(v, needed_len)
}


# ---- hover format -------------------------------------------------------

.get.tick.fmt <- function(v, digits_d = 2) {
  if (is.null(digits_d)) digits_d <- 2
  if (.is.integer(v)) {
    ""                        # integers: no format
  } else {
    paste0(".", digits_d, "f")  # floats: d3-format string
  }
}

.hover.fmt <- function(x, y, x.lab, y.lab, horiz=FALSE,
                       digits_d=2, ts_unit=NULL) {

  fmtx <- .get.tick.fmt(x, digits_d)
  fmty <- .get.tick.fmt(y, digits_d)

  addfmt <- function(var, fmt) {
    if (nzchar(fmt)) paste0("%{", var, ":", fmt, "}") else paste0("%{", var, "}")
  }

  if (!horiz) {
    # vertical scatter: first line shows X name + value
    paste0(
      x.lab, ": ", if(is.null(ts_unit)) addfmt("x", fmtx) else x,
      "<br>", y.lab, ": ", addfmt("y", fmty),
      "<extra></extra>"
    )
  }
  else {
    # horizontal scatter: first line shows Y name + value
    paste0(
      y.lab, ": ", addfmt("y", fmty),
      "<br>", x.lab, ": ", addfmt("x", fmtx),
      "<extra></extra>"
    )
  }
}


.grid_style <- function() {
  list(
    color = .to_hex(getOption("grid_col", "gray85")),  # convert here
    width = getOption("grid_lwd", 0.5),
    dash  = getOption("grid_lty", NULL)
  )
}

x_grid <- function(x_vals, xref="x", yref="paper", y0=0, y1=1,
                   color=NULL, width=NULL, dash=NULL, layer="below") {
  if (is.null(x_vals) || !length(x_vals)) return(list())
  st  <- .grid_style()
  col <- if (is.null(color)) st$color else color
  wid <- if (is.null(width)) st$width else width
  dsh <- if (is.null(dash))  st$dash  else dash

  # ensure hex for Plotly
  col <- .to_hex(col)

  lapply(x_vals, function(x0) {
    list(
      type  = "line",
      xref  = xref, yref = yref,
      x0    = x0, x1 = x0,
      y0    = y0, y1 = y1,
      line  = c(list(color = col, width = wid),
                if (!is.null(dsh)) list(dash = dsh) else list()),
      layer = layer
    )
  })
}


y_grid <- function(y_vals, xref="paper", yref="y", x0=0, x1=1,
                   color=NULL, width=NULL, dash=NULL, layer="below") {
  if (is.null(y_vals) || !length(y_vals)) return(list())
  st  <- .grid_style()
  col <- if (is.null(color)) st$color else color
  wid <- if (is.null(width)) st$width else width
  dsh <- if (is.null(dash))  st$dash  else dash

  col <- .to_hex(col)

  lapply(y_vals, function(y0) {
    list(
      type  = "line",
      xref  = xref, yref = yref,
      y0    = y0, y1 = y0,
      x0    = x0, x1 = x1,
      line  = c(list(color = col, width = wid),
                if (!is.null(dsh)) list(dash = dsh) else list()),
      layer = layer
    )
  })
}


axis_base <- function() {
        
# ax <- list(
  list(
    zeroline  = FALSE, showline = TRUE,
    linecolor = .to_hex(getOption("axis_color", "black")),
    linewidth = getOption("axis_lwd", 1),
    ticks     = "outside", ticklen = 4,
    automargin = TRUE,
    tickfont = list(
      color  = .to_hex(getOption("axis_color", "black")),
      size   = 16 * getOption("axis_size", 0.9)
    ),
    title = list(
      font = list(
        color = .to_hex(getOption("lab_color", "black")),
        size  = 15 * getOption("lab_size", 1)
      ),
      standoff = 10   # try larger than before
    ),
#   showgrid  = getOption("axis_showgrid", TRUE),
    gridcolor = .to_hex(getOption("grid_color", "gray90")),
    gridwidth = getOption("grid_lwd", 1)
  )
}


axis_num <- function(title_txt, tickvals, ticktext) {
  utils::modifyList(axis_base(), list(
    title      = list(text = title_txt),
    tickmode   = "array",
    tickvals   = tickvals,
    ticktext   = ticktext,
    showgrid = FALSE
  ))
}


# categorical axis: grid off
axis_cat <- function(title_txt) {
  utils::modifyList(
    axis_base(),
    list(title = list(text=title_txt), showgrid=FALSE)
  )
}


# Draw top/right frame lines inside the plotting area
plot_border <- function(top = TRUE, right = TRUE,
                        color = getOption("panel_border"),
                        width = getOption("panel_lwd")) {

  if (is.character(color) && grepl("^gray[0-9]+$", color)) 
    color <- "gray75"  # make a gray a little lighter for plotly 

  out <- list()
  if (isTRUE(top)) {
    out[[length(out)+1]] <- list(
      type  = "line",
      xref  = "paper", yref = "paper",
      x0 = 0, x1 = 1, y0 = 1, y1 = 1,
      line = list(color = .to_hex(color), width = width)
    )
  }
  if (isTRUE(right)) {
    out[[length(out)+1]] <- list(
      type  = "line",
      xref  = "paper", yref = "paper",
      x0 = 1, x1 = 1, y0 = 0, y1 = 1,
      line = list(color = .to_hex(color), width = width)
    )
  }
  out
}


legend_base <- function() {
  fam <- getOption("legend_family", NULL)
  leg <- list(
    font = list(
      color = .to_hex(getOption("legend_color", getOption("lab_color", "black"))),
      size  = 15 * getOption("legend_cex", getOption("lab_size", 1))
    )
  )
  if (!is.null(fam)) leg$font$family <- fam
  leg
}


.nudge_viewer <- function(w) {
  # Coerce plotly -> htmlwidget if needed
  if (!inherits(w, "htmlwidget")) {
    if (inherits(w, "plotly")) {
      w <- plotly::plotly_build(w)
    } else {
      return(w)  # not a widget; don’t try to onRender
    }
  }

  htmlwidgets::onRender(
    w,
    "
    function(el, x){
      requestAnimationFrame(function(){
        if(window.Plotly) Plotly.Plots.resize(el); });
      setTimeout(function(){ if(window.Plotly) Plotly.Plots.resize(el); }, 150);
      setTimeout(function(){ if(window.Plotly) Plotly.Plots.resize(el); }, 400);
    }
    "
  )
}


# --- Optional: legend typography across all plotly charts -------------------
.apply_common_legend <- function(p, title_text = NULL) {
  p <- plotly::layout(
    p,
    legend = list(
      title = list(text = title_text %||% "", font = list(size = 13)),
      font  = list(size = 12),
      itemsizing = "constant"
    )
  )
  p
}

.legend_style <- function(by_name = NULL) {
  list(
    title = list(
      text = by_name,
      font = list(size = 14, family = "Arial", color = "black")
    ),
    font = list(size = 13, family = "Arial", color = "black"),
    orientation = "v",
    x = 1.02, y = 0.5,
    xanchor = "left", yanchor = "middle",
    bgcolor = "rgba(255,255,255,0.6)",
    bordercolor = "#CCCCCC",
    borderwidth = 1,
    tracegroupgap = 6
  )
}


# Legend style: same look everywhere
.legend_box <- function(by_name=NULL) {
  if (!is.null(by_name)) {
    list(
      title = list(text = by_name, font = list(size = 12, family = "Arial", color = "black")),
      orientation = "v",
      x = 1.05, y = 0.5, xanchor = "left", yanchor = "middle",
      bgcolor = "rgba(255,255,255,0.9)",
      bordercolor = "#CCCCCC",
      borderwidth = 1
    )
  } else {
    list(orientation = "v", bgcolor = "rgba(255,255,255,0.0)")
  }
}




# Should an interactive plotly chart auto-display?
# User can override with options(lessR.use_plotly = FALSE)
.allow.interactive <- function() {
  opt <- getOption("lessR_interactive", TRUE)
  isTRUE(opt) && base::interactive()
}



# nudge viewer to address RStudio bug of mis-alignment
force_viewer_reload <- function(plt, delays = c(16, 90, 250, 600, 1200)) {

  js <- sprintf(
"(function(){
  return function(el){
    var kicks = [%s];
    var lastW = -1, lastH = -1;

    function measurable(){
      if (!el) return false;
      if (!(el.offsetParent || el.getClientRects().length)) return false;
      var r = el.getBoundingClientRect();
      return (r.width > 0 && r.height > 0);
    }

    function doKick(){
      try {
        if (!measurable()) return false;
        var r = el.getBoundingClientRect();
        if (window.Plotly && el && el.data) {
          try { Plotly.relayout(el, {autosize: true}); } catch(e){}
          try { Plotly.Plots.resize(el); } catch(e){}
        } else {
          try { window.dispatchEvent(new Event('resize')); } catch(e){}
        }
        lastW = r.width; lastH = r.height;
        return true;
      } catch(e) { return false; }
    }

    function guardedKick(deadlineMs){
      var t0 = Date.now();
      (function loop(){
        if (doKick()) return;
        if (deadlineMs && (Date.now() - t0) > deadlineMs) return;
        setTimeout(loop, 32);
      })();
    }

    // Early kicks
    try { requestAnimationFrame(function(){ guardedKick(250); }); } catch(e){}
    try { requestAnimationFrame(function(){
      requestAnimationFrame(function(){ guardedKick(250); });
    }); } catch(e){}

    // Staggered delayed kicks (FIXED)
    for (var i=0; i<kicks.length; i++) {
      (function(d){
        setTimeout(function(){ guardedKick(0); }, d);
      })(kicks[i]);
    }

    // ResizeObserver
    if (typeof ResizeObserver !== 'undefined') {
      try {
        var ro = new ResizeObserver(function(){
          var r = el.getBoundingClientRect();
          if (r.width !== lastW || r.height !== lastH) doKick();
        });
        ro.observe(el);
        if (el.parentElement) ro.observe(el.parentElement);
      } catch(e){}
    }

    // MutationObserver (can be heavy, but keeping your intent)
    try {
      var mo = new MutationObserver(function(){ guardedKick(0); });
      mo.observe(document.documentElement, {attributes:true, childList:true, subtree:true});
    } catch(e){}

    window.addEventListener('focus', function(){ guardedKick(250); });
    document.addEventListener('visibilitychange', function(){
      if (!document.hidden) guardedKick(250);
    });

    // One last kick after full load (FIXED TYPO)
    if (document.readyState !== 'complete') {
      window.addEventListener('load', function(){ guardedKick(250); }, {once:true});
    } else {
      guardedKick(250);
    }
  }
})();",
    paste(as.integer(delays), collapse = ",")
  )

  htmlwidgets::onRender(plt, js)
}


# -------------------------------------------------------------------
# Finalize a plotly widget (or payload) for lessR
#   - Adds optional title
#   - Pins plotly.js dependency if available
#   - Makes widget responsive in RStudio Viewer
#   - Optionally nudges the Viewer for correct sizing
#   - NOW: robust to vector x_name/by_name (collapses them neatly)
# -------------------------------------------------------------------
.finalize_plotly_widget <- function(
  plt,
  kind,
  x_name = NULL,
  by_name = NULL,
  add_title = TRUE,
  nudge_viewer = TRUE,
  unique_element = TRUE   # if TRUE, force a unique elementId to avoid stale mounts
) {

  # collapse name vectors (safe for scalars, NULL)
  .collapse_names <- function(nm, sep = " \u2192 ") {  # default arrow
    if (is.null(nm) || !length(nm)) return(NULL)
    nm_chr <- trimws(as.character(nm))
    nm_chr <- nm_chr[nchar(nm_chr) > 0]
    if (!length(nm_chr)) return("")
    if (length(nm_chr) == 1L) return(nm_chr)
    paste(nm_chr, collapse = sep)
  }

  # choose separators for titles/meta
  x_name_coll  <- .collapse_names(x_name,  sep = " + ")
  by_name_coll <- .collapse_names(by_name, sep = " \u2192 ")

  # ---- title builder --------------------------------------------------------
  .mk_title <- function(xn, byn) {
    xn  <- trimws(as.character(xn %||% ""))
    byn <- trimws(as.character(byn %||% ""))
    if (nzchar(xn) && nzchar(byn)) paste0(xn, " by ", byn)
    else if (nzchar(xn)) xn
    else if (nzchar(byn)) byn
    else ""
  }

  # ---- attach meta used by savePlotly() etc. --------------------------------
  tag_meta <- function(obj) {
    attr(obj, "lessR_kind")   <- as.character(kind %||% "plotly")
    attr(obj, "lessR_xname")  <- as.character(x_name_coll %||% "")
    attr(obj, "lessR_byname") <- as.character(by_name_coll %||% "")
    attr(obj, "lessR_title")  <- .mk_title(x_name_coll, by_name_coll)
    obj
  }

  # helper: millisecond timestamp as character (no integer overflow)
  .ms_chr <- function() format(Sys.time(), "%Y%m%d%H%M%OS3")

  # helper: per-session sequence counter via options()
  .next_seq <- function() {
    s <- getOption("lessR.seq", 0L)
    s <- s + 1L
    options(lessR.seq = s)
    s
  }

  # ---- normalize plotly -> htmlwidget if needed -----------------------------
  if (inherits(plt, "plotly") && !inherits(plt, "htmlwidget")) {
    plt <- plotly::plotly_build(plt)
  }

  # ---- Case A: raw payload list with $data/$layout --------------------------
  if (is.list(plt) && is.null(plt$x) && !is.null(plt$data)
                   && !is.null(plt$layout)) {
    if (isTRUE(add_title)) {
      ttl <- .mk_title(x_name_coll, by_name_coll)
      if (nzchar(ttl)) {
        if (is.null(plt$layout)) plt$layout <- list()
        plt$layout$title <- list(text = ttl)
      }
    }
    plt <- tag_meta(plt)
    options(lessR.last_plotly = plt)
    return(invisible(plt))
  }

  # ---- Case B: htmlwidget (standard) ----------------------------------------
  if (inherits(plt, "htmlwidget")) {

    # (1) Optional title injection
    if (isTRUE(add_title)) {
      ttl <- .mk_title(x_name_coll, by_name_coll)
      if (nzchar(ttl)) {
        plt$x$layout <- plt$x$layout %||% list()
        plt$x$layout$title <- list(text = ttl)
      }
    }

    # (2) Meta for downstream helpers
    plt <- tag_meta(plt)

    # (3) Optionally force a unique elementId to avoid stale mount issues in Viewer
    if (isTRUE(unique_element)) {
      stamp <- .ms_chr()      # "YYYYmmddHHMMSSmmm" as character
      pid   <- Sys.getpid()
      seqn  <- .next_seq()
      plt$elementId <- sprintf("lessr-%s-%d-%d", stamp, pid, seqn)
    }

    # (4) (optional) pin plotly.js — left disabled/commented by default
    # if (exists(".pin_plotly_js", mode = "function")) {
    #   plt <- .pin_plotly_js(plt)
    # } else if (requireNamespace("htmltools", quietly = TRUE)) {
    #   js_path <- system.file("htmlwidgets/lib/plotlyjs/plotly-2.34.0.min.js",
    #                          package = "lessR")
    #   if (nzchar(js_path)) {
    #     dep <- htmltools::htmlDependency(
    #       name    = "plotly-main",
    #       version = "2.34.0",
    #       src     = c(file = dirname(js_path)),
    #       script  = basename(js_path)
    #     )
    #     plt <- htmltools::attachDependencies(plt, dep, append = FALSE)
    #   }
    # }

    # (5) Register last widget for savePlotly()
    options(lessR.last_plotly = plt)
    plt$x$layout <- plt$x$layout %||% list()
    plt$x$layout$autosize <- TRUE
    plt$x$layout$margin <- utils::modifyList(
      list(t = 40, r = 20, b = 40, l = 60, autoexpand = TRUE),
      plt$x$layout$margin %||% list(),
      keep.null = TRUE
    )
    plt$x$config <- utils::modifyList(plt$x$config %||% list(),
                                      list(responsive = TRUE),
                                      keep.null = TRUE)

    # ensure the widget fills the Viewer pane (avoid fixed pixels)
    plt$sizingPolicy <- htmlwidgets::sizingPolicy(
      viewer.fill   = TRUE,
      browser.fill  = TRUE,
      padding       = 0,
      defaultWidth  = NULL,
      defaultHeight = NULL
    )

    # (6) Viewer robustness: autosize + responsive + margins + fill container
    if (isTRUE(nudge_viewer)) {
      plt <- force_viewer_reload(plt, delays = c(16, 90, 250, 600, 1200))
    }

    return(invisible(plt))
  }
}


.force_full_plotly_js <- function(widget, version = "2.34.0") {
  # Path to vendored full Plotly.js inside *this* package
  js_dir <- system.file("htmlwidgets", "lib", "plotlyjs", package = "lessR")
  file_ok <- nzchar(js_dir) &&
            file.exists(file.path(js_dir, sprintf("plotly-%s.min.js", version)))
  if (!file_ok) {
    warning(
      "Full Plotly.js not found at inst/htmlwidgets/lib/plotlyjs/. ",
      "Sunburst may not render in RStudio Viewer. ",
      "Expected file: plotly-", version, ".min.js"
    )
    return(widget)
  }

  dep <- htmltools::htmlDependency(
    name    = "plotlyjs-full",
    version = version,
    src     = c(file = js_dir),
    script  = sprintf("plotly-%s.min.js", version)
  )

  # PREPEND our full Plotly dep so it overrides any partial one
  deps_existing <- htmltools::htmlDependencies(widget)
  deps_new <- c(list(dep), deps_existing)

  htmltools::attachDependencies(widget, deps_new, append = FALSE)
}



# ==== Common Plotly helpers for lessR facet charts =========================

# ----- small utility -----------------------------------------------------
`%||%` <- function(a, b) if (is.null(a) || length(a) == 0L) b else a

# ----- qualitative palette (lessR sequence) ------------------------------
.plotly_base_colors <- function() {
  c(
    "#4398D0","#B28B2A","#5FA140","#D57388",
    "#9A84D6","#00A898","#C97E5B","#909711",
    "#00A3BA","#D26FAF","#00A76F","#BD76CB"
  )
}

# make rgba fills from hex vector (stable indices across facets)
.plotly_make_fills <- function(cols, alpha = 0.30) {
  to_rgba <- function(hex) {
    rgb <- grDevices::col2rgb(hex)
    sprintf("rgba(%d,%d,%d,%.3f)", rgb[1], rgb[2], rgb[3], alpha)
  }
  vapply(cols, to_rgba, character(1))
}

# ----- canonical facet-configuration bundle ------------------------------
# Single config contract for the plotly facet internals (dot.plotly,
# .radar.plotly, .hier.plotly). Defaults live here, in one place. Each
# chart type reads only the fields it uses: dot reads n_row/n_col (its
# grid comes from plotly::subplot); radar/hier read gap_x/gap_y/facet_size
# and the title offsets. A uniform struct with per-type consumption.
.plotly_facet_opts <- function(
  n_row        = NULL, n_col = NULL, n_col_max = 3L,
  gap_x        = 0.04, gap_y = 0.11, facet_size = 1.0,
  title_y_base = -0.018, title_row_shift = -0.003
) list(n_row = n_row, n_col = n_col, n_col_max = n_col_max,
       gap_x = gap_x, gap_y = gap_y, facet_size = facet_size,
       title_y_base = title_y_base, title_row_shift = title_row_shift)


# ----- grid of facet domains (equal sizes) -------------------------------
# returns list(domains=..., n_row=..., n_col=...)
.plotly_make_domains_grid <- function(n_fac, n_col_max = 3L,
                                      gap_x = 0.04, gap_y = 0.11,
                                      facet_size = 1.0) {
  n_col <- min(n_col_max, n_fac)
  n_row <- ceiling(n_fac / n_col)

  width  <- max(0.01, (1 - (n_col + 1) * gap_x) / n_col)
  height <- max(0.01, (1 - (n_row + 1) * gap_y) / n_row)

  domains <- vector("list", n_fac)
  k <- 1L
  for (r in seq_len(n_row)) {
    for (c in seq_len(n_col)) {
      if (k > n_fac) break

      # base cell
      x0 <- gap_x + (c - 1) * (width + gap_x)
      x1 <- x0 + width
      y1 <- 1 - (r - 1) * (height + gap_y)
      y0 <- y1 - height

      # --- center-preserving scaling (keeps charts from drifting up) ---
      cx <- (x0 + x1) / 2
      cy <- (y0 + y1) / 2
      half_w <- (x1 - x0) * facet_size / 2
      half_h <- (y1 - y0) * facet_size / 2

      x0s <- max(0, cx - half_w); x1s <- min(1, cx + half_w)
      y0s <- max(0, cy - half_h); y1s <- min(1, cy + half_h)

      domains[[k]] <- list(x = c(x0s, x1s), y = c(y0s, y1s), row = r, col = c)
      k <- k + 1L
    }
  }
  list(domains = domains, n_row = n_row, n_col = n_col)
}




# ----- facet title annotations -------------------------------------------
.plotly_facet_annotations <- function(domains, facet_levels, facet_name,
                                      y_base = 0.054,
                                      y_row_shift = -0.002,
                                      font_size = 14) {

  ann <- vector("list", length(domains))
  for (i in seq_along(domains)) {
    d <- domains[[i]]
    # supply a default row/col so callers using externally-supplied domains
    # (no grid computation) still get a sensible y position
    row.i <- d$row %||% 1L
    y_title <- d$y[2] + y_base + y_row_shift * (row.i - 1L)
    ann[[i]] <- list(
      text = paste0(facet_name, ": ", facet_levels[i]),
      x = mean(d$x), y = y_title,
      xref = "paper", yref = "paper",
      xanchor = "center", yanchor = "top",
      showarrow = FALSE, font = list(size = font_size)
    )
  }
  ann
}


# ----- unified facet layout (domains + annotations) ----------------------
# Single helper for the three plotly internals (.hier.plotly, .radar.plotly,
# dot.plotly) that need both a panel-grid layout AND per-panel title
# annotations. Internally calls .plotly_make_domains_grid +
# .plotly_facet_annotations with hooks for per-chart-type tweaks.
#
# Returns list(domains = ..., annotations = ...).
#
# Modes:
#   - Supply n_fac (no domains)              : compute grid here
#   - Supply domains (skip grid)             : use them as-is (dot's
#                                              post-subplot extraction)
#
# Hooks:
#   domain_adjust   = function(d) -> d       per-cell domain tweak
#   reverse_domains = TRUE                   reverse final domain order
#                                            (treemap row-bottom-to-top fix)
#   ann_adjust      = function(i, a, d) -> a per-annotation final tweak
.plotly_facet_layout <- function(
  n_fac           = NULL,
  facet_levels,
  facet_name      = "",
  n_col_max       = 3L,
  gap_x           = 0.04, gap_y = 0.11,
  facet_size      = 1.0,
  domains         = NULL,
  domain_adjust   = NULL,
  reverse_domains = FALSE,
  y_base          = 0.054,
  y_row_shift     = -0.002,
  yanchor         = "top",
  font_size       = round(14 * getOption("lab_size", 1)),
  ann_adjust      = NULL
) {
  if (is.null(domains)) {
    grid    <- .plotly_make_domains_grid(n_fac, n_col_max,
                                         gap_x, gap_y, facet_size)
    domains <- grid$domains
  }
  if (!is.null(domain_adjust))
    domains <- lapply(domains, domain_adjust)
  if (isTRUE(reverse_domains))
    domains <- rev(domains)

  annotations <- .plotly_facet_annotations(
    domains, facet_levels, facet_name,
    y_base = y_base, y_row_shift = y_row_shift, font_size = font_size)

  if (yanchor != "top")
    annotations <- lapply(annotations, function(a) {
      a$yanchor <- yanchor; a
    })

  if (!is.null(ann_adjust))
    annotations <- lapply(seq_along(annotations),
                          function(i) ann_adjust(i, annotations[[i]],
                                                 domains[[i]]))

  list(domains = domains, annotations = annotations)
}



# display or summarize an already-built table, x.tbl
# output: formatted to the R console

.reg5Plot <-
function(lm.out, n_res_rows=NULL, n_pred_rows=NULL,
         scatter_coef=FALSE, X1_new=NULL,
         in.data.frame, c.int, p.int, plot_errors=FALSE,
         digits_d, size=NULL, pdf=FALSE, width=5, height=5,
         bubble_plot=NULL, manage.gr=FALSE, quiet=FALSE, ...) {


  nm <- all.vars(lm.out$terms)  # names of vars in the model
  n.vars <- length(nm)
  n.pred <- n.vars - 1L
  n.obs <- nrow(lm.out$model)
  b0 <- lm.out$coefficients[1]
  b1 <- lm.out$coefficients[2]

  if (is.null(n_pred_rows))
    n_pred_rows <- if (n.obs < 25) n.obs else 4
  if (n_pred_rows == "all") n_pred_rows <- n.obs  # no preds with n_pred_rows=0


  # pdf graphics option
  go.pdf <- pdf  # save before grDevices::pdf() would shadow the name
  if (go.pdf) {
    pdf_file <- "RegScatterplot.pdf"
    if (n.pred > 1) pdf_file <- "RegScatterMatrix.pdf"
    grDevices::pdf(file=pdf_file, width=width, height=height)
  }
  # keep track of the plot in this routine
  plt.i <- 0L
  plt.title  <- character(length=0)

  do.sp <- n.pred < 2


  # ----------------------------------------------------
  # scatterplot, if one (or no) pred variables
  if (do.sp) {

    if (n.pred == 1) {
      x.values <- lm.out$model[,nm[2]]
    }
    else if (n.pred == 0) {  # null model
      x.values <- seq_len(n.obs)
      nm[2] <- "Index"
      x.lab <- nm[2]
    }
    y.values <- lm.out$model[,nm[1]]

    do.predint <- !(n_pred_rows==0 || !is.null(X1_new) || is.null(p.int))
    if (n.pred > 0)
      if (is.factor(lm.out$model[,nm[2]])) do.predint <- FALSE

    # title
    if (!do.predint || !is.numeric(x.values)) {
      ctitle <- "Scatterplot"
      if (is.numeric(x.values)) {
        if (n.pred == 0)
          ctitle <- paste(ctitle, "and Null Model")
        else
          ctitle <- paste(ctitle, "and Least-Squares Line")
      }
      else if (is.factor(x.values) && n.pred==1 && nlevels(x.values)==2) {
        ctitle <- paste(ctitle, "and Least-Squares Line")
      }
      y.min <- min(lm.out$model[,nm[1]])
      y.max <- max(lm.out$model[,nm[1]])
    }
    else {
      ctitle <- "Reg Line, Confidence & Prediction Intervals"
      y.min <- min(p.int$lwr)
      y.max <- max(max(p.int$upr),  max(lm.out$model[,nm[1]]) )
    }

    plt.i <- plt.i + 1L
    plt.title[plt.i] <- gsub(pattern="\n", replacement=" ", x=ctitle)

    # scale for regular R or RStudio
    axis_size <- 0.76
    radius <- 0.22
    adj <- .RSadj(radius, axis_size, lab_size=getOption("lab_size"))
    radius <- adj$radius
    # size of points
    if (is.null(size))
      size.pt <- if (.Platform$OS == "windows") 0.85 else 0.70
    else
      size.pt <- size

    # set margins
    max.width <- strwidth(as.character(max(pretty(y.values))), units="inches")
    margs <- .plt.marg(max.width, y.lab=nm[1], x.lab=nm[2], main=NULL, sub=NULL)
    lm.mar <- margs$lm;  tm <- margs$tm;  rm <- margs$rm;  bm <- margs$bm

    orig.params <- par(no.readonly=TRUE)
    on.exit(par(orig.params))
    par(bg=getOption("window_fill"))
    par(mai=c(bm, lm.mar, tm, rm))

    plot(x.values, y.values, type="n", axes=FALSE, ann=FALSE)
    usr <- par("usr")

    if (is.factor(x.values)) {
      x.lvl <- levels(x.values)
      axT1 <- seq_along(x.lvl)  # mark category values
    }
    else {
      x.lvl <- NULL
      axT1 <- axTicks(1)  # else numeric, so all the ticks
    }

    .plt.bck(usr, axT1, axTicks(2))
    .axes(x.lvl, NULL, axT1, axTicks(2))

    theme <- getOption("theme")
      .axlabs(x.lab=nm[2], y.lab=nm[1], main.lab=NULL, sub.lab=NULL)
      fill <- getOption("pt_fill")
      color <- getOption("pt_color")

    # Plot points
    # -----------
    ux <- length(unique(x.values))
    uy <- length(unique(y.values))
    # bubbles only help when points coincide; require at least 5% of the
    # points to overlap, else plot actual points instead of equal-size bubbles
    n.xy <- nrow(unique(data.frame(x.values, y.values)))
    if (is.null(bubble_plot))
      bubble_plot <- (ux < 13 && uy < 13 && n.xy <= 0.95 * n.obs)

    if (!bubble_plot)  {
        points(x.values, y.values,
               pch=21, col=color[1], bg=fill[1], cex=size.pt)
    }  # end !bubble_plot

    else {  # bubble plot, which would be unusual, x is cat
      mytbl <- table(x.values, y.values)  # get the counts, all x-y combinations
      n.count <- nrow(mytbl) * ncol(mytbl)
      count <- integer(length=n.count)

      # melt the table of counts to a data frame with xx, yy, count
      xx <- integer(length=n.count)
      yy <- integer(length=n.count)
      k <- 0
      for (i in seq_len(nrow(mytbl))) {
        for (j in seq_len(ncol(mytbl))) {
          if (mytbl[i,j] != 0) {  # 0 plots to a single pixel, so remove
            k <- k + 1
            count[k] <- mytbl[i,j]
            xx[k] <- i  # use loop index; aligns with axT1 = seq_along(x.lvl)
            yy[k] <- as.numeric(colnames(mytbl)[j])
          }
        }
      }
      cords <- data.frame(xx, yy, count)

      power <- 0.6
      sz <- cords[,3]**power  # radius unscaled
      radius <- 0.18
      symbols(cords$xx, cords$yy, circles=sz, inches=radius,
          bg=.maketrans(fill, 110), fg=color, add=TRUE, ...)

      q.ind <- seq_len(nrow(cords))  # all bubbles get text
      for (i in seq_len(nrow(cords))) if (cords[i,3] < 5) cords[i,3] <- NA
      text(cords[q.ind,1], cords[q.ind,2], cords[q.ind,3], cex=0.8)
    }  # end bubble plot


    # Plot Line
    # ---------

    if (n.pred == 0) {
      m <- lm.out$coefficients[1]  # mean of Y
      mv <- rep(m, n.obs)
      names(mv) <- NULL
      lines(x.values, mv, lwd=0.75)
    }

    else if (n.pred == 1) {
      if (!is.factor(x.values)) {
        abline(b0, b1, col=getOption("segment_color"), lwd=1)
      }
      else if (nlevels(x.values)==2) {
        y0 <- b0
        y1 <- b0 + (b1*1)
        abline(v=1, col="gray60", lwd=.5)
        abline(v=2, col="gray60", lwd=.5)
        abline(h=y0, col="gray60", lwd=.5)
        abline(h=y1, col="gray60", lwd=.5)
        segments(y0=y0, y1=y1, x0=1, x1=2, col="black", lwd=1.5)
      }
    }

    # Plot Errors
    # -----------
    if (plot_errors)  {
      theme <- getOption("theme")
      red <- rgb(130,40,35, maxColorValue=255)
      pe.clr <- if (theme %in% c("gray", "white")) "gray58" else red
      segments(y0=lm.out$fitted.values, y1=lm.out$model[,1],
               x0=x.values, x1=x.values, col=pe.clr, lwd=1)
    }

    # Plot Intervals
    # --------------
    if (!is.factor(x.values) && do.predint) {
      col.ci <- getOption("segment_color")
      col.pi <- "gray30"

      # sort by x so lines() and polygon() draw smooth curves, not scribbles
      ord.x <- order(x.values)
      xv.s   <- x.values[ord.x]
      ci.lwr <- c.int$lwr[ord.x];  ci.upr <- c.int$upr[ord.x]
      pi.lwr <- p.int$lwr[ord.x];  pi.upr <- p.int$upr[ord.x]

      lines(xv.s, ci.lwr, col=col.ci, lwd=0.75)
      lines(xv.s, ci.upr, col=col.ci, lwd=0.75)
      lines(xv.s, pi.lwr, col=col.pi, lwd=1)
      lines(xv.s, pi.upr, col=col.pi, lwd=1)

      len <- length(xv.s)
      xx <- c( c(xv.s[1], xv.s, xv.s[len]),
               rev(c(xv.s[1], xv.s, xv.s[len])) )

      yy <- c( c(ci.upr[1], ci.upr, ci.upr[len]),
               rev(c(ci.lwr[1], ci.lwr, ci.lwr[len])) )
      polygon(xx, yy, col=getOption("se_fill"), border="transparent")

      yy <- c( c(pi.upr[1], pi.upr, pi.upr[len]),
               rev(c(pi.lwr[1], pi.lwr, pi.lwr[len])) )
      polygon(xx, yy, col=getOption("ellipse_fill"), border="transparent")
    }

  }  # end do.sp, a single scatterplot

  else {  # scatterplot matrix for multiple regression
    if (in.data.frame) {
      plt.i <- plt.i + 1L
      plt.title[plt.i] <- "ScatterPlot Matrix"

      panel_fill <- getOption("panel_fill")
      window_fill <- getOption("window_fill")
      bckg <- if (panel_fill == "transparent") window_fill else panel_fill
      .plt.mat(lm.out$model[c(nm)], fit="lm", col.bg=bckg,
               pt.size=TRUE, size.miss=TRUE)
    }
    else if (!quiet) {
      cat("\n>>> No scatterplot matrix reported because not all variables are ")
      cat("in the data frame.\n")
      if (dev.cur() > 1) dev.off()  # 1 is the null device
    }
  }

  if (go.pdf) {
    if (dev.cur() > 1) {
      dev.off()
      if (n.pred==1)
        .showfile(pdf_file, "scatterplot")
      else
        .showfile(pdf_file, "scatterplot matrix")
      cat("\n\n")
    }
  }

  # just generated plot
  return(invisible(list(i=plt.i, ttl=plt.title)))
}

.reg1anvBasic <-
function(lm.out, digits_d=NULL, show_R=FALSE) {

  nm <- all.vars(lm.out$terms)  # names of vars in the model
  n.vars <- length(nm)
  n.pred <- n.vars - 1L
  n.obs <- nrow(lm.out$model)
  d <- digits_d

  # ANOVA
  smc <- anova(lm.out)
  n.terms <- nrow(smc) - 1
  nt1 <- n.terms + 1

# kable experimentation
# k <- kable(smc, digits=digits_d)
# k <- gsub("|", " ", k, fixed=TRUE)
# k[1] <- gsub("Pr(>F)", "p-value", k[1], fixed=TRUE)
# k[length(k)] <- gsub("NA", "  ", k[length(k)], fixed=TRUE)

  tx <- character(length=0)

  tx[length(tx)+1] <- "-- Analysis of Variance"
  tx[length(tx)+1] <- ""

  if (show_R) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- .dash2(68)
    tx[length(tx)+1] <- paste("> ","anova(model)", "\n",sep="")
    tx[length(tx)+1] <- .dash2(68)
  }

  # width of column 1
  max.c1 <- max(nchar("Model"), nchar(nm))
  for (i in seq_len(nt1)) {
    c1 <- nchar(rownames(smc)[i])
    if (c1 > max.c1) max.c1 <- c1 
   }

  # width of data columns
  max.ln <- integer(length=4)
  for (i in 1:4) {
    ln.nm <- nchar(colnames(smc)[i])
    max.ln[i] <- ln.nm + 1
    for (j in seq_len(nrow(smc))) {
      xjc <- .fmt(smc[j,i], d=digits_d)
      if (nchar(xjc) > max.ln[i]) max.ln[i] <- nchar(xjc)
    }
    max.ln[i] <- max.ln[i] + 1L
    if (max.ln[i] < 9L) max.ln[i] <- 9L
  }

  # header
  df.lbl <- .fmtc("     df", max.ln[1]+1)
  SS.lbl <- .fmtc(" Sum Sq", max.ln[2]+1)
  MS.lbl <- .fmtc("Mean Sq", max.ln[3]+1)
  fv.lbl <- .fmtc("F-value", max.ln[4]+1)
  tx[length(tx)+1] <- paste(eval(format("", width=max.c1-5)), df.lbl, SS.lbl,
                             MS.lbl, fv.lbl, "   p-value", sep="")

  # predictors (terms, including interactions)
  if (n.pred >= 1) {
    for (i in seq_len(n.terms)) {
      rlb <- .fmtc(rownames(smc)[i], max.c1)
      df <- .fmti(smc[i,1], max.ln[1]-5)
      SS <- .fmt(smc[i,2], digits_d, max.ln[2])
      MS <- .fmt(smc[i,3], digits_d, max.ln[3])
      fv <- .fmt(smc[i,4], digits_d, max.ln[4])
      pv <- .fmt(smc[i,5], 3, 9)
      tx[length(tx)+1] <- paste(rlb, df, SS, MS, fv, pv)
    } 
  }
  if (n.pred >= 1) tx[length(tx)+1] <- ""


  # Model term in ANOVA table 
  mdl <- NA
  if (n.pred > 0) {
    rlb <- .fmtc("Model", max.c1, j="left")

    mod.df <- 0
    for (i in seq_len(n.terms)) mod.df <- mod.df + smc[i,1]
    md <- .fmti(mod.df, max.ln[1]-5) 

    mod.ss <- 0 
    for (i in seq_len(n.terms)) mod.ss <- mod.ss + smc[i,2]
    ms <- .fmt(mod.ss, digits_d, max.ln[2])

    mod.ms <- mod.ss/mod.df
    mm <- .fmt(mod.ms, digits_d, max.ln[3])

    mod.f <- mod.ms/smc[nt1, 3]
    mf <- .fmt(mod.f, digits_d, max.ln[4])

    mod.p <- pf(mod.f, mod.df, smc[nt1,1], lower.tail=FALSE)
    mp <- .fmt(mod.p, 3, 9) 

    tx[length(tx)+1] <- paste(rlb, md, ms, mm, mf, mp)
#   if (n.pred >= 1) tx[length(tx)+1] <- ""

    mdl <- c(mod.df, mod.ss, mod.ms, mod.f, mod.p)
    names(mdl) <- c("df", "ss", "ms", "fvalue", "pvalue")
  }

  # Residuals
  rlb <- .fmtc(rownames(smc)[nt1], max.c1, j="left")
  df <- .fmti(smc[nt1,1], max.ln[1]-5)
  SS <- .fmt(smc[nt1,2], digits_d, max.ln[2])
  MS <- .fmt(smc[nt1,3], digits_d, max.ln[3])
  MSW <- smc[nt1,3]
  tx[length(tx)+1] <- paste(rlb, df, SS, MS) 

  rsd <- c(smc[nt1,1], smc[nt1,2], smc[nt1,3])
  names(rsd) <- c("df", "ss", "ms")

  # Total
  tot <- NA
  if (n.pred > 0) {
    rlb <- .fmtc(nm[1], max.c1, j="left")

    tot.df <- mod.df + smc[nt1,1]
    td <- .fmti(tot.df, max.ln[1]-5) 

    tot.ss <- mod.ss + smc[nt1,2]
    ts <- .fmt(tot.ss, digits_d, max.ln[2])

    tot.ms <- tot.ss/tot.df
    tm <- .fmt(tot.ms, digits_d, max.ln[3])

    tx[length(tx)+1] <- paste(rlb, td, ts, tm) 

    tot <- c(tot.df, tot.ss, tot.ms)
    names(tot) <- c("df", "ss", "ms")
  }

  return(list(out_anova=tx, mdl=mdl, rsd=rsd, tot=tot, MSW=MSW))

}

bc.data.frame <-
function(x, stack100,
         col_fill, col_color, col.trans,
         fill_split, fill_scaled, fill_chroma, theme,
         horiz, gap, prop, scale_y, 
         xlab, ylab, main,
         label.size, beside,
         rotate_x, offset,
         axis_fmt, axis_x_pre, axis_y_pre,
         break_x, sort_x,
         labels, labels_color, labels_cex, labels_digits,
         labels_position, labels_cut,
         xlab_adj, ylab_adj, bm.adj, lm.adj, tm.adj, rm.adj,
         pad_y_min, pad_y_max,
         legend_title, legend_position, legend_labels,
         legend_horiz, legend_size, legend_abbrev, legend_adj,
         out_size, do_plot, use_plotly=FALSE, quiet,
         digits_d, shiny, pdf_file, width, height, ...)  {


  sug.keep <- getOption("suggest")
  options(suggest = FALSE)

  manage.gr <- .graphman()  # see if graphics are to be managed
  if (manage.gr && is.null(pdf_file)) {
    i.win <- 0
    for (i in 1:ncol(x)) {
      if (is.numeric(x[,i])  &&  !.is.num.cat(x[,i], 0)) 
        i.win <- i.win + 1
    }
    .graphwin(i.win, width, height)
    open.win <- 2
  }

  plot.i <- 0  # keep track of generated graphics
  plot.title  <- character(length=0)

  for (i in 1:ncol(x)) {

    nu <- length(unique(na.omit(x[,i])))

    if (!is.numeric(x[,i]) || .is.num.cat(x[,i], 0)) {
 
      if (nlevels(factor(x[,i])) < length(x[,i])) {

        x.name <- names(x)[i]
        options(xname = x.name)

        if (nu == 1) {
          cat("\nVariable", x.name, "has only one value.\n",
              "No bar chart produced.\n\n")
        }

        else {

        if (!is.null(pdf_file))  {
          if (!grepl(".pdf", pdf_file))
            pdf_file <- paste(pdf_file, ".pdf", sep="")
          .opendev(pdf_file, width, height)
        }
        else {
          pdf_file <- NULL
          plot.i <- plot.i + 1
          plot.title[plot.i] <- paste("BarChart of ", x.name, sep="")
          if (manage.gr) {
            open.win <- open.win + 1
            dev.set(which = open.win)
          }
        }

        .bc.main(x[,i], y=NULL, by=NULL, stack100,
          col_fill, col_color, col.trans, fill_split,
          fill_scaled, fill_chroma, fill.palette=NULL, theme,
          horiz, gap, prop, scale_y, 
          xlab, ylab, main,
          label.size, beside,
          rotate_x, offset,
          axis_fmt, axis_x_pre, axis_y_pre,
          break_x, sort_x,
          labels, labels_color, labels_cex, labels_digits,
          labels_position, labels_cut,
          xlab_adj, ylab_adj, bm.adj, lm.adj, tm.adj, rm.adj,
          pad_y_min, pad_y_max,
          legend_title, legend_position, legend_labels,
          legend_horiz, legend_size, legend_abbrev, legend_adj,
          add=NULL, x1=NULL, x2=NULL, y1=NULL, y2=NULL, out_size,
          digits_d=3, do_plot, use_plotly=FALSE, quiet, shiny, ...)

        if (!is.null(pdf_file)) {
          dev.off()
          if (!quiet) .showfile(pdf_file, "bar chart")
        }

        if (.is.integer(x[,i]) && nu <= 0 && !quiet)
          .ncat("bar chart", x.name, nu, 0)

        }  # end else
      }

      else cat("\n", names(x)[i], "appears to contain unique Names or IDs\n")
    }

    #else cat("\n", "--- ", names(x)[i], " --- is numerical, better to do a ",
             #"histogram\n\n", sep="")

  }  # each column in x

  options(suggest = sug.keep)

  if (is.null(pdf_file)) {  # no evaluation
    if (plot.i > 0) {
      if (is.null(options()$knitr.in.progress))
        .plotList(plot.i, plot.title)
    }
    else {
      cat("No categorical variables, so no bar charts.\n\n",
          "If you have integer variables that are categorical,\n",
          "   convert them to R factors.\n\n", sep="")
    }
  }

}

.reg4Pred <-
function(lm.out, 
         n.keep, digits_d, show_R,
         new.data, pred_sort, pred_rows, scatter_coef,
         in.data.frame, X1_new, X2_new, X3_new, X4_new, X5_new, X6_new) {

  nm <- all.vars(lm.out$terms)  # names of vars in the model
  n.vars <- length(nm)
  n.pred <- n.vars - 1L
  n.obs <- nrow(lm.out$model)

  tx <- character(length = 0)

# --------------------
# prediction intervals
# --------------------
     
  if (show_R) {
    txt <- "predict(model, interval=\"prediction\")"
    tx[length(tx)+1] <- paste("> ", txt, sep="", "\n")
    txt <- "predict(model, interval=\"confidence\")"
    tx[length(tx)+1] <- paste("> ", txt, sep="", "\n")
    tx[length(tx)+1] <- .dash2(68)
  }

  if (!new.data) {
    c.int <- data.frame(predict(lm.out, interval="confidence"),
                        stringsAsFactors=TRUE)
    p.int <- suppressWarnings(predict(lm.out,
                                      interval="prediction", se.fit=TRUE))
    s.prederr <- sqrt(p.int$residual.scale^2 + p.int$se.fit^2)
    p.width <- p.int$fit[,"upr"] - p.int$fit[,"lwr"]
    out <- cbind(lm.out$model[nm[1]],
             p.int$fit[,"fit"], s.prederr, p.int$fit[,"lwr"],
             p.int$fit[,"upr"], p.width)
    if (n.pred > 0) out <- cbind(lm.out$model[c(nm[seq(2,n.vars)])], out)
    out <- data.frame(out, stringsAsFactors=TRUE)
  }
  else {
    Xnew.val <- list(X1_new)
    if (n.vars > 2) for (i in seq(2, n.pred)) {
      pp <- eval(parse(text=paste("X", toString(i),"_new",sep="")))
      Xnew.val <- c(Xnew.val, list(pp))
    }
    Xnew <- expand.grid(Xnew.val)
    if (n.pred > 0) for (i in seq_len(n.pred)) names(Xnew)[i] <- nm[i+1]
    c.int <- data.frame(predict(lm.out, interval="confidence", newdata=Xnew),
                        stringsAsFactors=TRUE)
    p.int <- predict(lm.out, interval="prediction", newdata=Xnew,
                                 se.fit=TRUE)
    s.prederr <- sqrt(p.int$residual.scale^2 + p.int$se.fit^2)
    p.width <- p.int$fit[,"upr"] - p.int$fit[,"lwr"]
    Ynew <- rep("", nrow(Xnew))  # Y becomes non-numeric placeholder
    out <- data.frame(Xnew, Ynew, p.int$fit[,"fit"], s.prederr,
                      p.int$fit[,"lwr"], p.int$fit[,"upr"],
                      p.width, stringsAsFactors=FALSE)
    names(out)[n.vars] <- nm[1]
  }

  if (pred_sort == "predint") {
    o <- order(out[,n.vars+3])  # lower bound of pred interval
    out <- out[o,]
  }

  names(out)[n.vars+1] <- "pred"
  names(out)[n.vars+2] <- "s_pred"
  names(out)[n.vars+3] <- "pi.lwr"
  names(out)[n.vars+4] <- "pi.upr"
  names(out)[n.vars+5] <- "width"

  # manually do calc for pi:upr to verify
  #tcut <- qt(.025, df=n.obs-n.vars, lower.tail=FALSE)
  #s.upper <- out$fitted + tcut*s.prederr
 
  # min and max of pred interval widths
  predmm <- numeric(length=2)
  predmm[1] <- min(out[,n.vars+5])
  predmm[2] <- max(out[,n.vars+5])

  min_row <- which(out[,n.vars+5] == min(out[,n.vars+5]))
  if (length(min_row) > 1) min_row <- min_row[1]
  min_nm <- rownames(out[min_row,])

  max.row <- which(out[,n.vars+5] == max(out[,n.vars+5]))
  if (length(max.row) > 1) max.row <- max.row[1]
  max.side <- (max.row < n.keep/2)
  max.nm <- rownames(out[max.row,])

  names(predmm) <- c(min_nm, max.nm)


  if (!new.data) {

    if (pred_rows == nrow(out)) {
      r <- seq_len(nrow(out))
      tx2 <- .prntbl(out[r,], digits_d, cc=NULL)
    }

    else {
      piece.rows <- round(pred_rows/3,0)
      if (piece.rows < 1) piece.rows <- 1
      pr2 <- floor(piece.rows/2)

      nr <- nrow(out)
      if (max.side)
        r1 <- max(max.row-pr2,1):min(max.row+pr2,nr)
      else
        r1 <- 1:min(piece.rows,nr)

      r2 <- max(min_row-pr2,1):min(min_row+pr2,nr)

      if (!max.side)
        r3 <- max(max.row-pr2,1):min(max.row+pr2,nr)
      else {
        r3 <- max(nr-(piece.rows-1),1):nr
      }

      r <- c(r1,r2,r3)
      b1 <- which(r == r2[1])
      b2 <- which(r == r3[1])
      tx2 <- .prntbl(out[r,], digits_d, brk=c(b1,b2), cc=NULL)
    }
  }

  else   # new data 
    tx2 <- .prntbl(out, digits_d, cc=NULL)   # prefer to have row.names=FALSE

  for (i in seq_along(tx2)) tx[length(tx)+1] <- tx2[i]


  p.int <- data.frame(cbind(p.int$fit[,"lwr"], p.int$fit[,"upr"]),
                      stringsAsFactors=TRUE)
  names(p.int) <- c("lwr", "upr")

  # need in 5Plot next
  return(list(cint=c.int, pint=p.int, out_predict=tx, predmm=predmm)) 
}

.reg1bckBasic <-
function(lm.out, dname="d", digits_d=NULL, show_R=FALSE, n.obs, n.keep,
         transf) {

  nm <- all.vars(lm.out$terms)  # names of vars in the model
  n.vars <- length(nm)
  n.pred <- n.vars - 1L

# ----------
# Background
# ----------

  tx <- character(length=0)

  if(show_R) {
    cv <- paste(nm[1]," ~ ", sep="")
    cv <- paste(cv, nm[2], sep="")
    if (n.vars > 2) for (i in seq(3, n.vars)) cv <- paste(cv, " + ", nm[i], "", sep="")
    tx[length(tx)+1] <- .dash2(68)
    tx[length(tx)+1] <- paste("> ", "lm.out <- lm(", cv, ")", sep="")
    tx[length(tx)+1] <- .dash2(68)
  }
  
  tx[length(tx)+1] <- paste("Data Frame: ", dname)  # not accurate from Model
  tx[length(tx)+1] <- ""

  for (i in seq_len(n.vars)) {
    txbck <- .varlist(n.pred, i, nm[i], "Predictor", n.obs, n.keep)
    for (j in seq_along(txbck)) tx[length(tx)+1] <- txbck[j]
  }

  if (!is.null(transf)) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("Data are", transf)
  }
  
  return(list(out_background=tx, n.vars=n.vars, n.obs=n.obs, n.keep=n.keep))

}

dn.plotly <- function(
  x, by = NULL,              # numeric x; optional grouping var
  x_name, by_name = NULL,    # names for finalize/hover/legend
  fill,                      # scalar or length-G color(s)
  x_lab, y_lab = "Density",  # axis labels
  main = NULL,
  ax, gridT1 = NULL, gridT2 = NULL,  # lessR axis helpers
  # KDE controls (bandwidth externally supplied)
  bw, adjust = 1,
  kernel = "gaussian",
  n = 512, from = NULL, to = NULL,
  full_curve = TRUE,
  fill_area = TRUE,          # TRUE: translucent fill; FALSE: lines only
  digits_d = 3,
  style_opts = .plotly_style()
) {


  # --- groups ------------------------------------------------------------
  if (is.null(by)) {
    groups <- "Series 1"; G <- 1L
  } else {
    if (is.factor(by)) groups <- levels(by) else groups <- unique(by[!is.na(by)])
    G <- length(groups)
  }

  # --- shared support ----------------------------------------------------
  xr <- range(x, finite = TRUE)
  if (full_curve) {
    all.ends <- numeric(0)
    for (g in seq_len(G)) {
      xg.tmp <- if (G == 1L) x else x[by == groups[g]]
      xg.tmp <- xg.tmp[is.finite(xg.tmp)]
      tmp <- stats::density(xg.tmp, bw = bw, adjust = adjust,
                            kernel = kernel, n = n)
      all.ends <- c(all.ends,
                    tmp$x[c(1L, length(tmp$x))])
    }
    if (is.null(from) || is.na(from)) from <- min(all.ends)
    if (is.null(to)   || is.na(to))   to   <- max(all.ends)
  } else {
    if (is.null(from) || is.na(from)) from <- xr[1L]
    if (is.null(to)   || is.na(to))   to   <- xr[2L]
  }
  if (to <= from) to <- from + max(abs(from) * 1e-4, 1e-6)
  if (n < 2) n <- 2

  xgrid <- seq(from, to, length.out = n)
  dx    <- xgrid[2L] - xgrid[1L]

  # --- sanity: at least 2 finite obs per group ---------------------------
  if (G == 1L) {
    n.ok <- sum(is.finite(x))
    if (n.ok < 2L)
      stop("Density requires at least 2 finite observations;\n",
           "found ", n.ok, ".", call. = FALSE)
  } else {
    for (g in seq_len(G)) {
      xg <- x[by == groups[g]]
      n.ok <- sum(is.finite(xg))
      if (n.ok < 2L)
        stop("Group '", groups[g], "' has ", n.ok,
             " finite observation", ifelse(n.ok == 1, "", "s"),
             "; density requires at least 2.", call. = FALSE)
    }
  }

  # --- densities per group -----------------------------------------------
  dens.list <- vector("list", G)
  ymax <- 0
  for (g in seq_len(G)) {
    xg <- if (G == 1L) x else x[by == groups[g]]
    xg <- xg[is.finite(xg)]

    d  <- stats::density(
      xg, bw = bw, adjust = adjust, kernel = kernel,
      n = n, from = from, to = to
    )

    # align to shared grid
    if (length(d$x) != length(xgrid) || any(abs(d$x - xgrid) > 1e-12)) {
      d$y <- approx(d$x, d$y, xout = xgrid, rule = 2)$y
      d$x <- xgrid
    }

    # cumulative % via trapezoid (for hover)
    cum <- c(0, cumsum((d$y[-1] + d$y[-length(d$y)]) * 0.5 * dx))
    if (cum[length(cum)] > 0) cum <- cum / cum[length(cum)]

    dens.list[[g]] <- list(x = d$x, y = d$y, cum = cum,
                           mn = mean(xg))
    ymax <- max(ymax, d$y, na.rm = TRUE)
  }

  # --- ticks / labels ----------------------------------------------------
  gridT1 <- ax$axT1 %||% gridT1 %||% pretty(c(from, to), n = 5)
  gridL1 <- ax$axL1 %||% format(gridT1, big.mark = ",", trim = TRUE)
  gridT2 <- ax$axT2 %||% gridT2 %||% pretty(c(0, ymax), n = 6)
  gridL2 <- ax$axL2 %||% format(gridT2, trim = TRUE)

  # --- colors / alpha ----------------------------------------------------
  alpha.fill <- .auto_opacity(G, "fill")
  # no fill competing, so make the lines fully opaque for clarity
  alpha.line <- if (fill_area) .auto_opacity(G, "lines") else 1
  fill.rgba  <- .maketrans_plotly(rep_len(fill, G), alpha = alpha.fill)
  line.rgba  <- .maketrans_plotly(rep_len(fill, G), alpha = alpha.line)

  # --- hover builder -----------------------------------------------------
  .hover <- function(xx, yy, cpct) {
    paste0(
      x_name, ": ", format(signif(xx, 6)),
      "<br>Density=", format(round(yy, 6), trim = TRUE),

      "<br>Cumulative %: ", formatC(100 * cpct, format = "f", digits = 1), "%"
    )
  }

  # --- widget & traces ---------------------------------------------------
  plt <- plotly::plot_ly(
    type       = "scatter",
    mode       = "lines",
    showlegend = G > 1
    # elementId removed — belongs on the widget, not on the trace
  )

  for (g in seq_len(G)) {
    d  <- dens.list[[g]]
    nm <- if (G > 1) groups[g] else NULL
    plt <- plotly::add_trace(
      plt,
      x = d$x, y = d$y, name = nm,
      line      = list(color = line.rgba[g], width = 1.4),
      fill      = if (fill_area) "tozeroy" else "none",
      fillcolor = if (fill_area) fill.rgba[g] else NULL,
      hoverinfo = "text",
      hovertext = if (!is.null(nm) && length(by_name))
        paste0(by_name, ": ", groups[g], "<br>", .hover(d$x, d$y, d$cum))
      else
        .hover(d$x, d$y, d$cum)
    )
    mn   <- d$mn
    y.mn <- approx(d$x, d$y, xout = mn, rule = 2)$y
    mean.line <- list(color = line.rgba[g], dash = "dash",
                      width = if (fill_area) 1.4 else 0.7)
    plt  <- plotly::add_trace(
      plt,
      x          = c(mn, mn),
      y          = c(0, y.mn),
      showlegend = FALSE,
      line       = mean.line,
      hoverinfo  = "skip"
    )
  }

  # --- axes & grids ------------------------------------------------------
  border.shapes <- plot_border()
  x.shapes      <- x_grid(gridT1)

  # lines only (no fill): add an x-axis baseline in neutral gray
  axis.shapes <- if (!fill_area)
    list(list(type = "line", xref = "paper", yref = "paper",
              x0 = 0, x1 = 1, y0 = 0, y1 = 0,
              line = list(color = .to_hex("gray50"), width = 1)))
  else list()

  ax.x <- axis_num(x_lab, ax$axT1, ax$axL1)
  ax.y <- axis_num(y_lab, ax$axT2, ax$axL2)

  ax.x$tickmode <- "array"; ax.x$tickvals <- gridT1; ax.x$ticktext <- gridL1
  ax.y$tickmode <- "array"; ax.y$tickvals <- gridT2; ax.y$ticktext <- gridL2
  ax.y$showgrid  <- TRUE
  ax.y$gridcolor <- .to_hex(style_opts$grid_col)
  ax.y$gridwidth <- 1
  ax.y$griddash  <- "dot"

  # nudge x-axis title up a bit (keeps font size unchanged)
  if (is.character(ax.x$title)) {
    ax.x$title <- list(text = ax.x$title, standoff = 10)
  } else if (is.list(ax.x$title)) {
    ax.x$title$standoff <- 10
  }
  ax.x$automargin <- TRUE

  plt <- plotly::layout(
    plt,
    xaxis = ax.x,
    yaxis = ax.y,
    shapes = c(x.shapes, border.shapes, axis.shapes),
    template = NULL
  )


  # --- background & legend -----------------------------------------------
  plt$x$layout$plot_bgcolor  <- .to_hex(style_opts$panel_fill)
  plt$x$layout$paper_bgcolor <- .to_hex(style_opts$window_fill)

  if (G > 1) {
    leg.border <- .to_hex(style_opts$legend_border)
    leg.bg     <- .to_hex(style_opts$window_fill)
    plt <- plotly::layout(plt, legend = list(
      title = list(
        text = if (length(by_name)) by_name else "",
        font = list(size = round(
          15 * getOption("lab_size", 1)))),
      font = list(size = round(
        16 * getOption("axis_size", 0.9))),
      bgcolor = leg.bg,
      bordercolor = leg.border,
      borderwidth = 1
    ))
  }

  # --- finalize ----------------------------------------------------------
  plt <- .finalize_plotly_widget(
    plt,
    kind = "density",
    x_name = x_name,
    by_name = if (G > 1) by_name else NULL,
    add_title = FALSE,
    nudge_viewer = (.allow.interactive() && !isTRUE(getOption("knitr.in.progress")))
  )

  invisible(plt)
}

piechart.plotly <- function(
  x, x_name, y_name, by_name = NULL, main = NULL,
  fill, border, opacity,
  hole,
  ncols = NULL,
  labels = c("%", "input", "prop", "off"),
  labels_position, labels_color,
  labels_size,
  labels_decimals,
  digits_d = 2,
  group_labels = TRUE,
  group_label_pos = c("below","above"),
  group_label_size = 14,
  group_label_gap = 0.05,
  theme = getOption("theme"),
  style_opts = .plotly_style()
) {

  group_label_pos <- match.arg(group_label_pos)
  labels <- match.arg(labels)

  # decimals for the numeric part of a slice label. NULL falls back
  # to digits_d, except for "prop", whose proportions digits_d
  # (0 for counts) would otherwise flatten to "0".
  lbl.d <- if (!missing(labels_decimals) && length(labels_decimals) &&
               !is.null(labels_decimals))
             as.integer(labels_decimals)
           else if (identical(labels, "prop")) 2L
           else as.integer(digits_d)

  # --- helpers ------------------------------------------------------------
  .pick_by_names_or_recycle <- function(v, needed_names, needed_len) {
    v <- as.character(v)
    nm <- names(v)
    if (!is.null(nm) && length(nm)) {
      out <- v[match(needed_names, nm)]
      if (anyNA(out)) {
        base <- if (length(v)) v else "black"
        out[is.na(out)] <- base[((which(is.na(out)) - 1L) %% length(base)) + 1L]
      }
      return(out)
    }
    if (!length(v)) return(rep("black", needed_len))
    rep_len(v, needed_len)
  }

  .pick_by_names <- function(v, needed_names, fallback = "gray80") {
    v <- as.character(v); nm <- names(v)
    if (!is.null(nm) && length(nm)) {
      out <- v[match(needed_names, nm)]
      out[is.na(out)] <- fallback
      return(out)
    }
    if (!length(v)) return(rep(fallback, length(needed_names)))
    rep_len(v, length(needed_names))
  }

  # Simulated panel bg for pie grid (helps in some Viewers)
  .add_panel_bg <- function(plt) {
    bg.plot  <- toupper(.to_hex(style_opts$panel_fill))
    bg.paper <- toupper(.to_hex(style_opts$window_fill))
    plt <- plotly::layout(plt, paper_bgcolor = bg.paper)
    shapes <- plt$x$layout$shapes %||% list()
    shapes <- Filter(function(s) {
      !(identical(s$type,"rect") && identical(s$xref,"paper") &&
        identical(s$yref,"paper") && identical(s$x0,0) && identical(s$y0,0) &&
        identical(s$x1,1) && identical(s$y1,1))
    }, shapes)
    bg.shape <- list(
      type="rect", xref="paper", yref="paper",
      x0=0, y0=0, x1=1, y1=1,
      fillcolor=bg.plot, line=list(width=0), layer="below"
    )
    plt$x$layout$shapes <- c(shapes, list(bg.shape))
    plt
  }

  title.size <- round(16 * getOption("main_size", 1))

  val.spec <- paste0(":.", max(0, as.integer(digits_d)), "f")

  # --- SINGLE PIE: 1D / named vector -------------------------------------
  if (is.null(dim(x)) || length(dim(x)) == 0L || length(dim(x)) == 1L) {

    slices <- names(x)
    values <- suppressWarnings(as.numeric(x))
    stopifnot(length(slices) == length(values))

    # fill/border
    fill.vec   <- .pick_by_names_or_recycle(fill, slices, length(slices))
    border.vec <- if (length(border) <= 1L) rep_len(as.character(border), length(slices))
                  else .pick_by_names_or_recycle(border, slices, length(slices))

    # label text
    label.mode <- labels
    fmt.num <- function(z) formatC(z, format = "f", digits = lbl.d)

    tot <- sum(values, na.rm = TRUE)
    num.str <- switch(label.mode,
      "%"     = paste0(fmt.num(100 * values / max(tot, 1e-12)), "%"),
      "prop"  = fmt.num(values / max(tot, 1e-12)),
      "input" = fmt.num(values),
      "off"   = rep("", length(values)),
      paste0(fmt.num(100 * values / max(tot, 1e-12)), "%")
    )
    text.vec <- if (identical(label.mode, "off")) slices else paste0(slices, "<br>", num.str)

    # inside/outside
    pos.in  <- if (!missing(labels_position) && length(labels_position))
                 tolower(as.character(labels_position[1])) == "in" else TRUE
    txt.pos <- if (pos.in) "inside" else "outside"

    base.size <- 12
    txt.size  <- round(base.size * 1.38 *
                   (if (!missing(labels_size) && length(labels_size))
                     labels_size else 1) *
                   getOption("axis_size", 0.9), 0)

    # --- opacity for fill -------------------------------------------------
    alpha.fill <- as.numeric(opacity)
    if (!is.finite(alpha.fill)) alpha.fill <- 1
    alpha.fill <- max(0, min(1, alpha.fill))
    fills.rgba <- .maketrans_plotly(fill.vec, alpha = alpha.fill)

    # auto text color if requested
    want.adjust <- is.null(labels_color) || identical(labels_color[1], "adjust")
    txt.colors  <- if (want.adjust) .auto_text_color(fills.rgba, bg = style_opts$panel_fill)
                   else rep(labels_color[1], length(fills.rgba))

    dom.y   <- c(0.03, 0.93)
    margins <- list(t = round(title.size * 2.2),
                    r = 20, b = 30, l = 20)

    grand.total <- tot
    overall.pct <- values / if (grand.total > 0) grand.total else 1

    plt <- plotly::plot_ly(
      type   = "pie",
      labels = slices,
      values = values,
      sort   = FALSE,
      direction = "clockwise",
      hole   = hole,
      domain = list(x = c(0, 1), y = dom.y),
      text         = text.vec,
      textinfo     = "text",
      textposition = txt.pos,
      insidetextorientation = "radial",
      textfont       = list(color = txt.colors, size = txt.size),
      insidetextfont = list(color = txt.colors, size = txt.size),
      outsidetextfont= list(color = txt.colors, size = txt.size),
      automargin     = !pos.in,
      marker = list(
        colors = fills.rgba,
        line   = list(color = "rgba(0,0,0,0)", width = 1)
      ),
      customdata = overall.pct,
      hovertemplate = paste0(
        x_name, ": %{label}",
        "<br>", y_name, ": %{value", val.spec, "}",
        "<br>% of total: %{customdata:.2%}",
        "<extra></extra>"
      ),
      showlegend = FALSE
    )

    # Defensive post-build tweaks
    built <- tryCatch(plotly::plotly_build(plt), error = function(e) {
      warning("piechart.plotly: plotly_build() failed. ",
              conditionMessage(e), call. = FALSE)
      NULL
    })
    if (!is.null(built) && length(built$x$data) >= 1L) {
      n.slices <- length(built$x$data[[1]]$labels %||% built$x$data[[1]]$values)
      bvec <- if (length(border.vec) == 1L) rep(border.vec[1], n.slices)
                  else rep_len(border.vec, n.slices)
      bvec <- .to_hex(bvec)
      built$x$data[[1]]$marker$line <- list(color = I(bvec), width = rep(1.6,
                                            n.slices))
      built$x$data[[1]]$marker$line$colorsrc <- NULL
      built$x$data[[1]]$marker$line$widthsrc <- NULL

      if (identical(txt.pos, "inside") && isTRUE(hole > 0.62)) {
        built$x$data[[1]]$hole <- 0.62
      }
      plt <- built
    }

    plt$x$layout$template    <- NULL
    plt$x$layout$uniformtext <- NULL
    plt <- plotly::layout(
      plt,
      uniformtext = list(minsize = 8, mode = "show"),
      margin = margins,
      title  = if (!is.null(main) && nzchar(main))
                 list(text = main, y = 0.94, yanchor = "top",
                      font = list(size = title.size))
               else NULL
    )

    if (!identical(toupper(.to_hex(style_opts$panel_fill)),  "#FFFFFF") ||
        !identical(toupper(.to_hex(style_opts$window_fill)), "#FFFFFF")) {
      plt <- .add_panel_bg(plt)
    }

    return(plt)
  }  # end 1D

  # --- GROUPED INPUT (2D): PIE GRID ---------------------------------------
  stopifnot(length(dim(x)) == 2L)
  x <- as.matrix(x)
  groups <- rownames(x)
  if (is.null(groups)) groups <- as.character(seq_len(nrow(x)))
  slices <- colnames(x)
  if (is.null(slices)) slices <- paste0(x_name, "_", seq_len(ncol(x)))
  grand.total <- sum(x, na.rm = TRUE)

  build.pie.grid <- function() {
    k  <- nrow(x)
    nc <- if (is.null(ncols) || ncols < 1)
              ceiling(sqrt(k)) else as.integer(ncols)
    nr <- ceiling(k / nc)

    alpha.fill <- as.numeric(opacity)
    if (!is.finite(alpha.fill)) alpha.fill <- 1
    alpha.fill <- max(0, min(1, alpha.fill))

    fmt.num <- function(z) formatC(z, format = "f", digits = lbl.d)
    label.mode <- tolower(labels[1])

    plt <- plotly::plot_ly()
    if (is.null(plt$x$layout$annotations)) plt$x$layout$annotations <- list()
    by.title <- if (length(by_name) && nzchar(by_name)) by_name else "Group"

    for (i in seq_len(k)) {
      j   <- i - 1L
      col <- j %% nc
      row <- j %/% nc
      x0 <- col / nc
      x1 <- (col + 1) / nc
      y0 <- 1 - (row + 1) / nr
      y1 <- 1 - row / nr

      shrink <- 0.92
      y.mid  <- (y0 + y1) / 2
      y.half <- (y1 - y0) * shrink / 2
      dom <- list(x = c(x0, x1), y = c(y.mid - y.half, y.mid + y.half))

      grp  <- groups[i]
      vals <- suppressWarnings(as.numeric(x[i, ]))
      vals[!is.finite(vals)] <- NA_real_

      val.sum     <- sum(vals, na.rm = TRUE)
      overall.pct <- vals / if (grand.total > 0) grand.total else 1

      num.str <- switch(label.mode,
        "%"     = paste0(fmt.num(100 * vals / max(val.sum, 1e-12)), "%"),
        "prop"  = fmt.num(vals / max(val.sum, 1e-12)),
        "input" = fmt.num(vals),
        "off"   = rep("", length(vals)),
        paste0(fmt.num(100 * vals / max(val.sum, 1e-12)), "%")
      )

      slice.labels <- slices
      text.vec <- if (label.mode == "off")
                      slice.labels else paste0(slice.labels, "<br>", num.str)

      pos.in   <- tolower((labels_position %||% "in")[1]) == "in"
      txt.pos  <- if (pos.in) "inside" else "outside"
      base.sz  <- 12
      txt.size <- round(base.sz * (labels_size %||% 1) *
                    getOption("axis_size", 0.9), 0)

      vals.sc <- vals; vals.sc[!is.finite(vals.sc)] <- 0
      is.seq.fill <- !identical(theme, "colors") &&
                     !identical(theme, "light")
      fills.this <- if (is.seq.fill && !length(names(fill)) &&
                        length(vals.sc) > 1L &&
                        diff(range(vals.sc)) > 0) {
        .maketrans_plotly(
          .scale.clr(vals.sc, fill = NULL, fill_split = 0,
                     fill_chroma = 75, theme = theme),
          alpha = alpha.fill)
      } else if (identical(theme, "colors") && !length(names(fill))) {
        .maketrans_plotly(
          .color_range("hues", length(vals.sc)),
          alpha = alpha.fill)
      } else {
        .maketrans_plotly(
          .pick_by_names(fill, slices, fallback = "#CCCCCC"),
          alpha = alpha.fill)
      }
      borders.this <- .pick_by_names(border, slices, fallback = "gray80")

      txt.colors <- if (!length(labels_color) || identical(labels_color[1],
                        "adjust")) {
        .auto_text_color(fills.this, bg = style_opts$panel_fill)
      } else {
        rep(labels_color[1], length(fills.this))
      }

      plt <- plotly::add_trace(
        plt,
        type         = "pie",
        labels       = slice.labels,
        values       = vals,
        name         = paste0(by.title, ": ", grp),
        legendgroup  = "pies",
        sort         = FALSE,
        direction    = "clockwise",
        hole         = hole,
        domain       = dom,
        text         = text.vec,
        textinfo     = "text",
        textposition = txt.pos,
        insidetextorientation = "radial",
        textfont        = list(color = txt.colors, size = txt.size),
        insidetextfont  = list(color = txt.colors, size = txt.size),
        outsidetextfont = list(color = txt.colors, size = txt.size),
        automargin      = !pos.in,
        marker = list(
          colors = fills.this,
          line   = list(color = borders.this, width = 1)
        ),
        customdata = overall.pct,
        hovertemplate = paste0(
          by.title, ": ", grp,
          "<br>", x_name, ": %{label}",
          "<br>", y_name, ": %{value", val.spec, "}",
          "<br>% of ", grp, ": %{percent}",
          "<br>% of total: %{customdata:.2%}",
          "<extra></extra>"
        ),
        showlegend = FALSE
      )

      if (isTRUE(group_labels) && hole > 0) {
        cx <- mean(dom$x); cy <- mean(dom$y)
        plt$x$layout$annotations <- c(
          plt$x$layout$annotations,
          list(list(
            x = cx, y = cy,
            xref = "paper", yref = "paper",
            text = grp,
            showarrow = FALSE,
            xanchor = "center", yanchor = "middle",
            font = list(size = group_label_size %||% 14, color = "#666666")
          ))
        )
      }
    } # end for i

    plt <- plotly::layout(plt, uniformtext = list(minsize = 10, mode = "show"))
    plt
  } # end build.pie.grid

  plt <- build.pie.grid()
  plt <- plotly::layout(
    plt,
    title  = if (!is.null(main) && nzchar(main))
               list(text = main, y = 0.94, yanchor = "top",
                    font = list(size = title.size))
             else NULL,
    margin = list(t = round(title.size * 2.2),
                  r = 20, b = 20, l = 20)
  )

  if (!identical(toupper(.to_hex(style_opts$panel_fill)),  "#FFFFFF") ||
      !identical(toupper(.to_hex(style_opts$window_fill)), "#FFFFFF")) {
    plt <- .add_panel_bg(plt)
  }

  return(plt)

} # end piechart.plotly

see <- function(data, n_row=min(nrow(data), 5), n_col=min(ncol(data), 8)) {

  d_nm <- deparse(substitute(data))

  cat("\n")
  h1 <- paste("First", n_row, "rows and first", n_col, "columns of", d_nm)
  cat(h1, "\n")
  .dash(nchar(h1))
  print(data[1:n_row, 1:n_col])

  cat("\n")
  h2 <- paste("Last", n_row, "rows and last", n_col, "columns of", d_nm)
  cat(h2, "\n")
  .dash(nchar(h2))
  print(data[(nrow(data)-n_row+1):nrow(data), (ncol(data)-n_col):ncol(data)])
}

.plt.bad <-
function (x.miss, y.miss, stat, breaks, bin_start, n_row, n_col,
          MD_cut, out_cut, fit_se, ...) {

  # check for inconsistent parameters
  
  if (x.miss) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Must specify at least one variable to analyze\n\n")
  }
  
  if (MD_cut > 0  &&  out_cut > 0) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Choose MD_cut or out_cut to specify outliers, but not both\n\n")
  }
  
  if (fit_se[1] > 0.999) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "fit_se now specified as the confidence level, between 0 and 1\n\n")
  }
  
  if (stat %in% c("mean","sd","deviation", "min","median","max") && y.miss) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Must specify a numeric y-variable from which to compute the\n ",
      " ", stat, " for each level of ", deparse(substitute(x)), "\n\n")
  }

  #if (values != "data"  &&  object == "sunflower") {
    #cat("\n"); stop(call.=FALSE, "\n","------\n",
      #"Sunflowers are only plotted for data\n\n")
  #}

  #if (method %in% c("spearman", "kendall")) {
    #cat("\n"); stop(call.=FALSE, "\n","------\n",
      #"The  method  parameter has another meaning for Plot\n\n",
      #"Compute a Spearman or Kendall correlation\n",
      #"  with the Correlation function\n\n")
  #}

  if (is.numeric(breaks) && !is.null(bin_start)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Choose only one option to specify a start value.\n",
      "Either choose the option  breaks  or the option  bin_start.\n\n")
  }

  if (!is.null(n_row)  &&  !is.null(n_col)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Only specify n_row or n_col, but not both\n\n",
      "From one of the values, the other value is calculated\n\n")
  }

}

Logit <-
function(my_formula, data=d, filter=NULL, ref_group=NULL,
         pt_size=0.9, transparency=0.8,
         digits_d=4, text_width=120,

         brief=getOption("brief"),

         res_rows=NULL, res_sort=c("cooks","rstudent","dffits","off"),
         pred=TRUE, pred_all=FALSE, prob_cut=0.5, cooks_cut=1,

         X1_new=NULL, X2_new=NULL, X3_new=NULL, X4_new=NULL,
         X5_new=NULL, X6_new=NULL,

         xlab=NULL, ylab=NULL,
         pdf_file=NULL, width=5, height=5, ...) {


  # produce actual argument, such as from an abbreviation, and flag if not exist
  res_sort <- match.arg(res_sort)

  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (length(dots) > 0) {
    change <- c("digits.d", "text.width", "res.rows", "res.sort", "pred.all",
                "cooks.cut", "X1.new", "X2.new", "X3.new", "X4.new",
                "X5.new", "X6.new", "pdf.file")
    for (i in seq_along(dots)) {
      if (names(dots)[i] %in% change) {
        pnm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(pnm, dots[[i]])
      }
    }
  }

  if (missing(my_formula)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify a model by listing it first or set according to:  my_formula\n\n")
  }

  # let deprecated mydata work as default
  dfs <- .getdfs()
  mydata.ok <- FALSE
  if (!is.null(dfs)) {
    if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
      d <- mydata
      df.name <- "mydata"
      mydata.ok <- TRUE
      options(dname = df.name)
    }
  }

  if (!mydata.ok) {
    df.name <- deparse(substitute(data))  # get name of data table
    options(dname = df.name)
  }

  if (!mydata.ok && !exists(df.name)) {
    txtC <- "Function Logit() requires the data exist in a data frame\n"
    if (df.name == "d")
      txtA <- ", the default data frame name, " else txtA <- " "
    txtB1 <- "Either create the data frame, such as with data.frame function,\n"
    txtB2 <- "  or specify the actual data frame with the parameter: data\n"
    txtB <- paste(txtB1, txtB2, sep="")
    cat("\n"); stop(call.=FALSE, "\n","------\n",
        txtC, "Data frame ", df.name, txtA, "does not exist\n\n", txtB, "\n")
  }

  # if a tibble, convert to data frame
  if (any(grepl("tbl", class(data), fixed=TRUE)))
    data <- data.frame(data)

  max_new <- 6

  old.opt <- options()
  on.exit(options(old.opt))

  options(width=text_width)

  if (brief) {
    if (is.null(res_rows)) res_rows <- 0
    pred <- FALSE
   }

  # convert character variables to factors (for DV)
  n_col <- apply(data, 2, function(x) sum(!is.na(x)))  # num values per variable
  nu.col <- apply(data, 2, function(x) length(unique(na.omit(x))))  # num unique
  fnu.col <- logical(length=ncol(data))  # logical, initial values to FALSE

  for (i in seq_len(ncol(data))) {
    if (is.character(data[,i]))
      if (nu.col[i] != n_col[i]) fnu.col[i] <- TRUE
  }
  data[fnu.col] <- lapply(data[fnu.col], as.factor)

  pre <- "> "
  line <- "--------------------------------------------------------------------\n"

  nm <- all.vars(my_formula)  # names of vars in the model
  n.vars <- length(nm)
  n.pred <- n.vars - 1

  if (!missing(filter)) {  # subset rows
    r <- eval(substitute(filter), envir=data, enclos=parent.frame())
    r <- r & !is.na(r)  # set missing for a row to FALSE
    if (!any(r)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "No rows of data with the specified value of\n",
        "filter = ", deparse(substitute(filter)), "\n\n")
    }
    data <- data[r,,drop=FALSE]
  }
  n.obs <- nrow(data)

  # evaluate expression terms, e.g., log(Years): each becomes a column
  #   of data named with the expression text, with the formula rewritten
  #   to reference the new columns
  fe <- .formula_expr(my_formula, data, parent.frame(), "Logit")
  my_formula <- fe$formula
  data <- fe$data
  nm <- all.vars(my_formula)
  n.vars <- length(nm)
  n.pred <- n.vars - 1

  collinear <- n.pred > 1

  # check response variable for two values, only 0 and 1 if numeric
  is.bin <- TRUE
  if (is.factor(data[,nm[1]])) {
     if (nlevels(data[,nm[1]]) != 2) is.bin  <- FALSE
  }
  else {  # numeric y with values 0 and 1
    vals <- unique(na.omit(data[, nm[1]]))
    if (any(!vals %in% c(0, 1))) is.bin <- FALSE
  }
  if (!is.bin) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Response variable: ", nm[1], "\n",
      "If numeric, can only have values of 0 or 1.\n",
      "If a factor, can only have two levels.\n\n")
  }

  if ( !is.null(X1_new)  &&  (n.pred) > max_new ) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "No new data for prediction if more than", max_new,
          "predictor variables.\n\n")
  }

  in.data.frame <- TRUE
  for (i in seq_len(n.vars)) {
    if (!(nm[i] %in% names(data))) {
      cat("\n\n\n>>> Note: ", nm[i], "is not in the data frame.\n")
      in.data.frame <- FALSE
    }
  }

  # reduce data to just model variables with no missing data
  data <- data[, c(nm), drop=FALSE]
  data <- data[complete.cases(data), , drop=FALSE]
  n.keep <- nrow(data)

  # check for all numeric vars (except Y)  in.data.frame <- TRUE
  numeric.all <- TRUE
  for (i in seq_len(n.pred) + 1L) {
    if (in.data.frame && !is.numeric(data[1,which(names(data) == nm[i])])) {
      cat("\n>>> Note: ", nm[i], "is not a numeric variable.\n")
      cat("           Indicator variables are created and analyzed.\n")
      numeric.all <- FALSE
    }
  }

  # if not all numeric, construct the indicator variables
  if (!numeric.all) {
    md <- data.frame(model.matrix(my_formula, data=data))
    md[,1] <- data[,nm[1]]
    names(md)[1] <- nm[1]
    data <- md
    rm(md)
    nm <- names(data)
    n.vars <- ncol(data)
    n.pred <- n.vars - 1
    my_formula <- DF2formula(data)

    # if true integer, then convert from type double to integer
    rows <- min(50, nrow(data))  # save some time scanning
    fnu.col <- logical(length=ncol(data))
    for (i in seq_len(ncol(data)))
      if (.is.integer(data[1:rows,i]))
        fnu.col[i] <- TRUE
     data[fnu.col] <- lapply(data[fnu.col], as.integer) # move to integer
  }

  # if a single pred, make sure to have a + slope
  if (is.factor(data[,nm[1]])) {
    lv1 <- levels(data[,nm[1]])[1]
    lv2 <- levels(data[,nm[1]])[2]
  } else {
    lv1 <- NULL
    lv2 <- NULL
  }
  if (n.pred==1) {
    if (is.numeric(data[,nm[2]])) {
      avg <- tapply(data[,nm[2]], data[,nm[1]], mean, na.rm=TRUE)
      if (avg[1] > avg[2])  # switch order 0 and 1 for response
        if (is.factor(data[,nm[1]]))
          data[,nm[1]] <- factor(data[,nm[1]], levels=c(lv2,lv1))
    }
  }  # end n.pred=1

  # second level of Y, nm[1], is the default reference group
  if (!is.null(ref_group)) {
    if (!is.factor(data[,nm[1]])) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Parameter  ref_group  only applies when the response is a factor.\n\n")
    }
    if (lv1 != ref_group  &&  lv2 != ref_group)  {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Values of response ", nm[1], ": ",
        levels(data[,nm[1]])[1], " ", levels(data[,nm[1]])[2], "\n",
        "You specified a non-existent value, ref_group = ", ref_group, "\n\n")
    }
    if (lv2 != ref_group)
      data[,nm[1]] <- factor(data[,nm[1]], levels=c(lv2,lv1))
  }


  # check new.data option for consistency
  new.data <- FALSE
  if ( (n.pred) <= max_new ) {
    for (i in seq_len(n.pred)) {
      pp <- eval(parse(text=paste("X", toString(i),"_new",sep="")))
      if (!is.null(pp)) new.data <- TRUE
    }
    if (new.data) for (i in seq_len(n.pred)) {
      pp <- eval(parse(text=paste("X", toString(i),"_new",sep="")))
      if (is.null(pp)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Specified new data values for one predictor variable,",
          " so do for all.\n\n")
      }
    }
  }

  # sort values of the one predictor variable for scatterplot
  #   so that the prediction/confidence intervals can be drawn
  if (n.pred == 1) {
    o <- order(data[,nm[2]])
    data <- data[o,]
  }


  # -----------------------------------------------------------
  # logit analysis
  #   all subsequent analysis done on data in model construct lm.out$model
  #   this model construct contains only model vars, with Y listed first
  lm.out <- glm(my_formula, data=data, family="binomial", ...)
  # -----------------------------------------------------------

  if (is.null(res_rows)) {
    if (n.keep < 20) res_rows <- n.keep else res_rows <- 20
  }
  if (res_rows == "all")
    res_rows <- n.keep  # res_rows="all" lists every case

  cat("\n")
  if (sys.nframe() == 1) {  # only accurate if not called from model
    cat("Data Frame: ", df.name, "\n\n")
  }

  for (i in seq_len(n.vars)) {
    txv <- .varlist(n.pred, i, nm[i], "Predictor", n.obs, n.keep)
    for (j in seq_along(txv)) cat(txv[j], "\n", sep="")
  }


  cat( "\n\n", "  BASIC ANALYSIS", "\n\n")

  cat("-- Estimated Model of", nm[1], "for",
      "the Logit of Reference Group Membership\n")

  # singularity check
  coef <- lm.out$coefficients
  if (anyNA(coef)) {
    bad <- names(coef)[which(is.na(coef))]
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Variable redundant with a prior predictor in the model: ", bad, "\n\n",
      "Delete that variable, or corresponding prior redundant variables,\n",
      "  from the model.\n\n")
  }

  sm <- summary(lm.out)
  sm1 <- sm$coefficients
  # conf intervals from standard errors, not confint.glm that requires MASS
  ci <- suppressMessages(confint.default(lm.out, level=0.95))
  smc <- cbind(sm1, ci)

  buf <- max(nchar(rownames(smc)))

  max.num <- integer(length=ncol(smc))
  for (icol in seq_len(ncol(smc))) {
    max.num[icol] <- 0
    for (i in seq_len(nrow(smc))) {
      ln.nm <- nchar(as.character(floor(smc[i,icol]))) + digits_d + 1
      if (ln.nm > max.num[icol]) max.num[icol] <- ln.nm
    }
    if (max.num[icol] < 9) max.num[icol] <- 9
  }

  est.lbl <- .fmtc("Estimate", max.num[1]+1)
  ste.lbl <- .fmtc("  Std Err", max.num[2]+2)
  t.lbl <-  "  z-value"
  p.lbl <-  "  p-value"
  lb.lbl <- .fmtc("Lower 95%", max.num[5]+3)
  ub.lbl <- .fmtc("Upper 95%", max.num[6]+3)
  cat("\n", rep(" ", buf), est.lbl, ste.lbl, t.lbl, p.lbl,
                           lb.lbl, ub.lbl, sep="", "\n")
  for (i in seq_len(nrow(smc))) {
    rlb <- .fmtc(rownames(smc)[i], buf)
    est <- .fmt(smc[i,1], digits_d, max.num[1])
    ste <- .fmt(smc[i,2], digits_d, max.num[2]+1)
    tvl <- .fmt(smc[i,3], 3, 8)
    pvl <- .fmt(smc[i,4], 3, 8)
    lb <- .fmt(smc[i,5], digits_d, max.num[5])
    ub <- .fmt(smc[i,6], digits_d, max.num[6])
    cat(rlb, est, ste, tvl, pvl, " ", lb, " ", ub, "\n")
  }

  # odds ratios and 95% CI
  OR <- coef(lm.out)
  orci <- exp(cbind(OR, ci))
  cat("\n\n")
  cat("-- Odds Ratios and Confidence Intervals\n\n")
  max.num <- 9
  OR.lbl <- .fmtc("Odds Ratio", max.num+1)
  lb.lbl <- .fmtc("Lower 95%", max.num+3)
  ub.lbl <- .fmtc("Upper 95%", max.num+3)
  cat(rep(" ", buf+2), OR.lbl, lb.lbl, ub.lbl, sep="", "\n")
  for (i in seq_len(nrow(orci))) {
    rlb <- .fmtc(rownames(orci)[i], buf)
    or.est <- .fmt(orci[i,1], digits_d, max.num)
    lb <- .fmt(orci[i,2], digits_d, max.num)
    ub <- .fmt(orci[i,3], digits_d, max.num)
    cat(rlb, " ", or.est, " ", lb, " ", ub, "\n")
  }

  # model fit
  cat("\n\n")
  cat("-- Model Fit\n")
  cat("\n")
  cat("    Null deviance:", .fmt(sm$null.deviance,3), "on",
      .fmti(sm$df.null), "degrees of freedom\n")
  cat("Residual deviance:", .fmt(sm$deviance,3),  "on",
      .fmti(sm$df.residual), "degrees of freedom\n\n")
  cat("AIC:", .fmt(sm$aic,3), "\n\n")
  cat("Number of iterations to convergence:", sm$iter, "\n\n")

  # collinearity
  if (collinear) {
    cat( "\n", "Collinearity", "\n", sep="")
    cat("\n")

    # need to run logistic reg on a numeric of Y to get usual
    if (is.factor(data[,nm[1]]))  {
      Y <- as.numeric(data[,nm[1]])
      m.f <- paste("Y ~", paste(.bt(nm[2:(n.pred+1)]), collapse=" + "))
      # check.names would mangle an expression column such as log(Years)
      m.d <- data.frame(Y, data, stringsAsFactors=TRUE,
                        check.names=FALSE)
    }
    else {
      m.f <- my_formula
      m.d <- data
    }

    r.out <- lm(as.formula(m.f), data=m.d)
    MSW <- anova(r.out)[n.vars,3]
    sterrs <- summary(r.out)$coefficients[,2]

    vif <- numeric(length = n.pred)
    tol <- numeric(length = n.pred)
    for (i in seq_len(n.pred)) {
      v <- var(r.out$model[i+1])
      vif[i] <- (v * (n.keep-1) * sterrs[i+1]^2) / MSW
      tol[i] <- 1 / vif[i]
    }

    out <- cbind(tol, vif)
    colnames(out) <- c("Tolerance", "      VIF")
    rownames(out) <- nm[-1]
    print(round(out,3))
  }

  if (res_rows > 0)
    .logit3Residual(lm.out, nm, df.name,
         n.vars, n.pred, n.obs, n.keep, digits_d, pre, line,
         res_sort, res_rows, cooks_cut)

  if (pred)  # also do the plotting here
    .logit4Pred(lm.out, nm, df.name, my_formula, brief, res_rows,
         n.vars, n.pred, n.obs, n.keep, pt_size, transparency,
         digits_d, pre, line,
         new.data, pred, pred_all, prob_cut,
         in.data.frame, X1_new,
         X2_new, X3_new, X4_new, X5_new, X6_new,
         xlab, ylab, pdf_file, width, height)
  # Also calls .logit5Confuse.R

  return(invisible(lm.out))

}

CountAll <-
function(x=d, quiet=FALSE, ...)  {

  manage.gr <- .graphman()  # see if graphics are to be managed
  if (manage.gr)
    cat("\n>>> Note: Must have pdf_file specified or run in RStudio.\n\n")


  # deparse/substitute must precede any local reassignment of x
  dname <- deparse(substitute(x))

  # let deprecated mydata work as default
  dfs <- .getdfs()
  if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
    x <- mydata
    dname <- "mydata"  # update after reassignment
  }

  options(dname = dname)

  if (missing(x)) {
    if (!exists(dname, where=.GlobalEnv)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Need to specify an existing data frame,\n",
        "or data frame  d  must exist.\n\n")
    }
  }
    
  if (!quiet) {
    cat("\n")
    .dash(25,"-")
    cat(format(Sys.time(), "%a %b %d, %Y at %H:%M"), "\n")
    .dash(25,"-")
  }

  if (!quiet) {
    cat("\n\n\n")
    .dash(37,"+")
    cat("Histogram for Each Numeric Variable\n")
    .dash(37,"+")
  }

  X(data=x, quiet=quiet, eval_df=FALSE, use_plotly=FALSE, ...)
  
  if (!quiet) {
    cat("\n\n\n")
    .dash(39,"+")
    cat("Bar Chart for Each Non-numeric Variable\n")
    .dash(39,"+")
  }
  Chart(data=x, quiet=quiet, eval_df=FALSE, use_plotly=FALSE,
           one_plot=FALSE, ...)
  
}

.plt.main <-
function(x, y, by=NULL,  # x and y dfs with vars x.call and y.call 
         cat.x=FALSE, cat.y=FALSE,
         object="point", stat="data",

         fill=getOption("pt_fill"),
         ts_area_fill="transparent",
         color=getOption("pt_color"),

         pt.trans=0, col.segment=getOption("segment_color"),

         xy_tics=TRUE,
         xlab=NULL, ylab=NULL, main=NULL, main_size=NULL, sub=NULL,
         rotate_x=0, rotate_y=0, offset=0.5, prop=FALSE,
         origin_x=NULL, origin_y=NULL,

         size=NULL, ln.width=1, shape=21, means=TRUE,
         segments=FALSE, segments_y=FALSE, segments_x=FALSE,
         segments_diff=FALSE,

         form="scatter", smooth_points=100, smooth_size=1,
         smooth_power=0.25, smooth_bins=128, hex_bins=30, hexbin_legend=TRUE,
         contour_n=8, contour_nbins=50, contour_points=FALSE,
         contour_legend=FALSE,

         radius=0.15, power=0.5, size_cut=TRUE,
         bbl.txt.col=getOption("bubble_text_color"),
         col.low=NULL, col.hi=NULL,

         ID=NULL, ID_color="gray50", ID_size=0.60, out_ind=NULL,
         out_fill, out_color, out_shape, out_shape.miss,

         fit.line="off", fit_power=1, fit_color="gray55",
         fit_lwd=getOption("fit_lwd"), fit_new=NULL,
         fit_se=1, se_fill="gray80", plot_errors=FALSE,
         span=0.75,

         ellipse=FALSE, ellipse_color="lightslategray",
         ellipse_fill="off", ellipse_lwd,

         run=FALSE, center_line="off", stack=FALSE,
         ts_unit=NULL, ts_agg="sum", do.agg=FALSE, ts_ahead=0,
         ts_fit=FALSE, n_date_tics=NULL,
         y.fit, y.hat, x.fit, x.hat, y.upr, y.lwr,
         mxf.x, mnf.y, mxf.y,

         freq.poly=FALSE, jitter_x=NULL, jitter_y=NULL,

         xlab.adj=0, ylab.adj=0,
         bm.adj=0, lm.adj=0, tm.adj=0, rm.adj=0,
         scale_x=NULL, scale_y=NULL, pad_x=c(0,0), pad_y=c(0,0),
         axis_fmt="K", axis_x_pre="", axis_y_pre="",
         legend_title=NULL, use_plotly=TRUE,

         add=NULL, x1=NULL, x2=NULL, y1=NULL, y2=NULL,
         add_size=NULL, add_lwd=1, add_lty="solid",
         add_color=NULL, add_fill=NULL, add_trans=NULL,

         quiet=FALSE, digits_d=NULL, style_opts = NULL, ...)  {




# preliminaries -----------------------------------------------------------

  fill_bg <- getOption("panel_fill")
  date.var <- .is.date(x[,1])
  if (is.null(size)) size <- 1
  size.pt <- size  # size is set in Plot.R, reduce a bit for here
  area_fill <- ts_area_fill
  theme <- getOption("theme")

  want.labels <- TRUE

  x.lv <- x[,1]
  y.lv <- y[,1]

# data structures dimensions ----------------------------------------------

  bubble1  <- length(unique(y[,1])) == 1
  unique.x <- length(unique(x[,1])) == length(x[,1])
  unique.y <- length(unique(y[,1])) == length(y[,1])
  n.by     <- if (is.null(by)) 1 else nlevels(by)
  do.ellipse <- ellipse[1] > 0

  # dimensions
  n.xcol <- ncol(x)
  n.ycol <- ncol(y)
  n.col <- max(n.xcol, n.ycol)
  nrows <- nrow(x)


# axis labels and title ---------------------------------------------------

  # size is a variable, these values passed to .plt.main
  # bubble.title=FALSE passed from .plt.bins to suppress title
  # bubble plot can be directly from object="point"

    main.lab <- NULL

  # get lab_x_size  lab_y_size    Synchronize with Plot() code, put in own sub
  lab_size <- getOption("lab_size")
  lab_x_size <- getOption("lab_x_size")
  lab_y_size <- getOption("lab_y_size")
  lab_x_size <- ifelse (is.null(lab_x_size), lab_size, lab_x_size)
  lab_y_size <- ifelse (is.null(lab_y_size), lab_size, lab_y_size)

  # get x.lab and y.lab
  if (date.var) xx.lab <- xlab
  if (want.labels) {
    gl <- .getlabels(xlab, ylab, main, lab_x_size=lab_x_size,
                     lab_y_size=lab_y_size)
    x.name <- gl$xn; x.lbl <- gl$xl; x.lab <- gl$xb
    y.name <- gl$yn; y.lab <- gl$yb
    if (is.null(main.lab)) main.lab <- gl$mb
    sub.lab <- gl$sb
    by.name <- getOption("byname")
  }
  else {
    x.lab <- xlab
    y.lab <- ylab
    if (is.null(main.lab)) main.lab <- main
    sub.lab <- sub
    x.name <- NULL
  }
  if (!is.null(x.lab)) if (n.xcol > 1  &&  substr(x.lab, 1, 2) == "c(")
      x.lab <- NULL  # e.g., get rid of == "c(Female, Male)"
  if (date.var && is.null(xx.lab)) x.lab <- ""

  # set title for bubble plot if proportions
  if (object == "bubble"  &&  prop  &&  is.null(main)  &&  cat.y) {
    main.lab <- paste("Percentage of", y.name, "\nwithin each level of", x.name)
    main <- "not null"
  }

  if (!is.null(x.name)) if (x.name == "Index") {
    if (n.ycol > 1) y.lab <- ""  # labels are on the legend
    if (!is.null(x.lbl)) y.lab <- paste(x.name, ": ", x.lbl, sep="")
  }

  
# all processing in terms of numeric variables ----------------------------

  # categorical variables x and/or y are converted to factors in Plot()
  # convert factors to numeric, save levels, so x and y are always numeric
  # x will always be a matrix
  x.lvl <- NULL; y.lvl <- NULL  # if remain null, then not factors
  y.frcst <- NULL
  nm.x <- names(x)
  if (cat.x) {
    x.lvl <- levels(x[,1])
    x <- as.matrix(as.integer(unclass(x[,1])))
  }
  else if (!date.var) {
    x <- as.matrix(x)
    colnames(x) <- nm.x

   }
  else {  # date.var
    if (n.by == 1)
      x.dates <- x[,1]  # save actual dates for later
    else {  # x-axis tics just for one level of by
      cnt <- sum(by == levels(by)[1])
      x.dates <- x[1:cnt,1]  # assumes by is sorted by level
    }

  if (ts_ahead > 0) x.dates <- c(x.dates, x.hat[,1])

   x <- as.matrix(x[,1], ncol=1)  # x to numeric version of dates
  }  # end if date.var

  # y to a matrix with 3 possibilities for y: cat.y, not date.var, date.var
  nm.y <- names(y)
  if (cat.y) {
    y.lvl <- levels(y[,1])  #  put into alphabetical order
    y <- as.matrix(as.integer(unclass(y[,1])))
  }
  else if (!date.var) {
    nm.y <- names(y)
    y <- as.matrix(y)
    colnames(y) <- nm.y
  }
  else {  # date.var
    y <- as.matrix(y)
  }

  # y decimal digits
  if (is.null(digits_d)) digits_d <- .max.dd(y[,1]) + 1
  options(digits_d=digits_d)

  if (n.col > 1) center_line <- "off"   # no center_line for multiple plots

  cleveland <- FALSE
  if (!cat.x && cat.y && unique.y  ||  !cat.y && cat.x && unique.x)
    cleveland <- TRUE

# get minimum and maximum values of x and y -------------------------------

  mx.x.val.ln <- 1
  mx.y.val.ln <- 1
  if (!date.var) {
    x.val <- x.lvl  # x.val is NULL if x is numeric, ignored
    y.val <- y.lvl  # y.val ignored if y is numeric
  }
  else {  # date.var
    x.val <- x[,1]
    y.val <- NULL
  }

  mn.x <- ifelse (cat.x, 1, min(x, na.rm=TRUE))
  if (ts_ahead > 0) {  # forecast margin adjustments
    mx.x <- mxf.x
    mx.y <- mxf.y
    mn.y <- mnf.y
  }
  else {
    mx.x <- ifelse (cat.x, length(x.lvl), max(x, na.rm=TRUE))
    mn.y <- ifelse (cat.y, 1, min(y, na.rm=TRUE))
    mx.y <- ifelse (cat.y, length(y.lvl), max(y, na.rm=TRUE))
  }


# set margins -------------------------------------------------------------

  # get max number of lines in x value labels
  if (cat.x) {
    stuff <- .get.val.ln(x.lvl, x.name)
    mx.x.val.ln <- stuff$mx.val.ln
  }

  # get max number of lines in y value labels
  if (cat.y  &&  y.name != "row.names"  && !cleveland) {
    stuff <- .get.val.ln(y.val, y.name)
    mx.y.val.ln <- stuff$mx.val.ln
  }

  # --------- get size of y-axis labels
  axis_y_size <- ifelse (is.null(getOption("axis_y_size")),
    getOption("axis_size"), getOption("axis_y_size"))

  if (cat.y) {  # y-axis labels are characters
    yv <- unlist(strsplit(y.val, "\n", fixed=TRUE))
    max.y.width <- max(strwidth(yv, units="inches", cex=axis_y_size))
    if (options("device") != "RStudioGD")  # not work in R, only RStudio
      max.y.width <- .09 * axis_y_size * max(nchar(yv))
  }
  else {  # y-axis labels are numeric
    prety <- pretty(c(mn.y, mx.y))
    ind <- which(nchar(prety) == max(nchar(prety)))[1]  # get largest nchar
    mx.num <-  ifelse (!prop, as.character(prety[ind]), .fmt(prety, 2))
    max.y.width <- max(strwidth(mx.num, cex=axis_y_size, units="inches"))
  }
  # --------

  margs <- .plt.marg(max.y.width, y.lab, x.lab, main.lab, sub.lab,
                rotate_x, mx.x.val.ln, mx.y.val.ln,
                lab_x_size=lab_x_size, lab_y_size=lab_y_size, 
                axis_y_pre=axis_y_pre)
  mm <- margs$lm  # left margin, lm is linear model
  tm <- margs$tm
  rm <- margs$rm 
  bm <- margs$bm
  n.lab_x.ln <- margs$n.lab_x.ln
  n.lab_y.ln <- margs$n.lab_y.ln

  # room in right margin for the vertical legend
  if (n.xcol > 1  ||  n.ycol > 1  ||  !is.null(by)) {
    rm <- rm - .025  # hack to reduce rm a bit
    if (n.xcol > 1) nm.v <- nm.x
    if (n.ycol > 1) nm.v <- nm.y
    if (!is.null(by)) nm.v <- by.name
    big.nm <- max(nchar(nm.v))  # nm.v could be a vector
    if (!is.null(legend_title)) {
      nm.lt <- nchar(legend_title)
      big.nm <- max(nm.lt, big.nm)
    }
    if (big.nm > 6) rm <- rm + (.05 * (big.nm - 6))
    if (n.ycol == 1) rm <- rm + .30  + (.65 * axis_y_size)
    if (axis_y_size > 1) if (!is.null(by)) rm <- rm + .1  # kludge
    if (length(size) > 1) rm <- rm - .76  # by and bubbles = too much rm
  }
    else rm <- rm - .06  # hack to reduce rm

  if (ts_ahead > 0)   # make room for vertical legend
    rm <- rm + getOption("axis_size")  # default is 0.75

  if (center_line != "off") rm <- rm + .4  # room for center_line label
  if (date.var) rm <- rm + 0.10  # make room: last axis date > last data value
  if ((options("device") != "RStudioGD")  &&  !is.null(by)) rm <- rm + .3

  if (date.var && n.by>1) rm <- rm - 0.05

  if (n.ycol>1 && date.var) {  # if not a time series, then no y label
#   mm <- mm + 0.25  # reduce size of plot in the left to make room for label
    ylab.adj <- ylab.adj + 0.2  # move label right when calling .axlabs()
  }

  if (!form %in% c("contour", "hexbin")) ylab.adj <- ylab.adj - 0.6

  if (n.ycol > 1) {
    rm <- rm + 0.80  # add right margin for legend
    if (max(nchar(colnames(y))) > 6) rm <- rm + 0.20
#   mm <- mm - .2  # kludge to reduce left margin
  }

  if (length(size) > 1)
    rm <- rm + 0.92  # add right margin for legend

  if (offset > 0.5) bm <- bm + (-0.05 + 0.2 * offset)  # offset kludge

  if (n.xcol>1  && !date.var  && !cleveland) {
    bm <- bm + 0.20  # allow for the bottom legend
    rm <- rm - 0.80  # kludge to remove superfluous right margin
  }

  if (form == "contour") {
    bm <- bm + .2
    mm <- mm + .2
  }

  # user manual adjustment
  bm <- bm + bm.adj
  mm <- mm + lm.adj
  tm <- tm + tm.adj
  rm <- rm + rm.adj

  orig.params <- par(no.readonly=TRUE)
  on.exit(par(orig.params))
  par(bg=getOption("window_fill"))
  par(mai=c(bm, mm, tm, rm))
  par(tcl=-0.28)  # axis tic length


# set-up region for coordinate system -------------------------------------

  # -----------------------
  # only with plot and form="n"
  # non-graphical parameters in ... Generate warnings when no plot

  # re-calibrate maximum of y-axis if stacking
  # wide format needs conversion to Long format to work properly
  if (stack  &&  n.ycol > 1) {  # data in wide format, one col for each y
    y.tot <- apply(y, 1, sum, na.rm=TRUE)
    mx.y <- max(y.tot)
  }
  if (stack  &&  (n.ycol == 1 &&  n.by > 1)) {  # data in tidy format
    for (i in 1:n.by) {
      if (i > 1) yo <- yl
      yl <- subset(y, by==levels(by)[i])
      if (i > 1) yl[,1] <- yl[,1] + yo[,1]
    }
    mx.y <- max(yl)
  }

  # get min and max of x and y
  if (!is.null(scale_x)) {
     if (length(scale_x) == 2) scale_x[3] <- par("xaxp")[3]
     mn.x <- min(mn.x, scale_x[1])
     mx.x <- max(mx.x, scale_x[2])
  }
  if (!is.null(scale_y)) {
     if (length(scale_y) == 2) scale_y[3] <- par("yaxp")[3]
     mn.y <- min(mn.y, scale_y[1])
     mx.y <- max(mx.y, scale_y[2])
  }

  # adjust margins for fit line, will be computing fit lines twice
  # more efficient to do all computations here, then plot fit line later
  # if multiple x or y variables, just first variable is checked
  if (fit.line!="off" && is.null(scale_y) && !cat.y && !date.var) {
    pf <- .plt.fit(x[,1], y[,1], fit.line, fit_power, fit_new, size,
                   span)  # fit line
    mn.yf <- min(pf$f.ln, na.rm=TRUE)  # f.ln are the fitted values
    mx.yf <- max(pf$f.ln, na.rm=TRUE)
    mn.y <- min(mn.y, mn.yf)
    mx.y <- max(mx.y, mx.yf)
  }

  if (!do.ellipse) {
    if (cat.x) {
      mn.x <- mn.x - .2
      mx.x <- mx.x + .2
    }
    if (cat.y) {
      mn.y <- mn.y - .2
      mx.y <- mx.y + .2
    }

    if (is.null(origin_x)) {  # set default for minimum x-value displayed
        origin_x <- mn.x
    }
    if (stat != "data" && (!all(y == 0))) mx.y <- mx.y + (.08 * (mx.y-mn.y))
    region <- matrix(c(origin_x, mx.x, mn.y, mx.y), nrow=2, ncol=2)
    ellipse.poly <- NULL
  }  # end no ellipse

  else {  # set plot with sufficient room for ellipse and data
    cxy <- cor(x[,1],y[,1], use="complete.obs")
    s.x <- sd(x[,1], na.rm=TRUE); s.y <- sd(y[,1], na.rm=TRUE)
    m.x <- mean(x[,1], na.rm=TRUE); m.y <- mean(y[,1], na.rm=TRUE)
    lvl <- max(ellipse)
    region <- ellipse(cxy, scale=c(s.x, s.y), centre=c(m.x, m.y), level=lvl)
    region <- rbind(region, c(mn.x, mn.y), c(mx.x, mx.y))
  }

  # revise min and max for x and y axes considering the ellipse
  mx.x <- max(region[,1])
  mn.x <- min(region[,1])
  mx.y <- max(region[,2])
  mn.y <- min(region[,2])

  # set y-axis origin for numeric variables
  if (!cat.y) {
    if (!is.null(origin_y)) {
      if (min(y, na.rm = TRUE) > 0) mn.y <- origin_y
      if (max(y, na.rm = TRUE) < 0) mx.y <- origin_y
    }
  }

  # add padding to x and y axes
  add.pad_lab <- FALSE
  if (all(pad_x == 0)) {  # pad extra for labels in 2-D plot
    if (!is.null(add))
      add.pad_lab <- ifelse ("labels" %in% add, TRUE, FALSE)
    if (add.pad_lab || (length(out_ind) > 0)) {
      if (all(pad_x == 0)) pad_x <- c(0.05, 0.05)
      if (all(pad_y == 0)) pad_y <- c(0.03, 0.03)
    }
  }

  # get plot region for coordinate system
  xp <- pretty(c(mn.x, mx.x))
  xP <- pad_x[2] * (xp[length(xp)] - xp[1])
  yp <- pretty(c(mn.y, mx.y))
  xN <- pad_x[1] * (xp[length(xp)] - xp[1])
  yP <- pad_y[2] * (yp[length(yp)] - yp[1])
  yN <- pad_y[1] * (yp[length(yp)] - yp[1])
  region <- rbind(region, c(mn.x-xN, mn.y-yN), c(mx.x+xP, mx.y+yP))


# set-up the coordinate system --------------------------------------------

  # filled.contour and hexbin do their own plot window
  if (!form %in% c("contour", "hexbin"))  
    base::plot(region, type="n", axes=FALSE, ann=FALSE, ...)
  rm(region)
  usr <- par("usr")

  
# axes ticks and labels axT1 and axT2 -------------------------------------

  # set axT1: x-axis tics and values, Date var uses x.zoo.dates, defined later
  if (cat.x)
    axT1 <- seq_along(x.lvl)   # mark category values
  else {  # numerical
    if (!date.var) {
      if (stat == "count") {
        if (mx.x <= 3)  # just want integers for count axis
          n.best <- 3
        else if (mx.x > 3  &&  mx.x < 100)
          n.best <- 4
        else
          n.best <- 5
        axT1 <- pretty(origin_x:mx.x, n=n.best)
      }
      else {  # stat != "count"
        if (is.null(scale_x))
          axT1 <- pretty(c(origin_x, x), eps.correct=0)  # numeric, so all tics
        else {
          if (!run)
            axT1 <- axTicks(1, axp=scale_x)
          else
            axT1 <- seq(scale_x[1], scale_x[2], by=scale_x[3])
        }
      }  # stat not "count"
    }  # end !date.var
  }  # end numerical

  # set axT2: y-axis tics and values
    if (segments_diff)
      axT2 <- 1:nrow(x)
  else if (cat.y)
    axT2 <- seq_along(y.lvl)
  else {
    if (is.null(scale_y))
      axT2 <- pretty(c(mn.y, mx.y))  # more extreme values than axTicks
    else
      axT2 <- axTicks(2, axp=scale_y)
  }

  if (bubble1) {  # 1-D scatter plot of categorical variable, MOVE to Chart()
    axT2 <- NULL
    y.val <- NULL
    y.lab <- ""
  }

  # axes value labels
  ax.info <- NULL  # defined inside xy_tics; guard for plotly paths

  if (xy_tics) {

    # adjust axis label from tick with mgp[2]
    # mgp does not work with rotate_x, see .axes()
    ax <- .axes_dim()  # get axis value parameters
    mgp2 <- -0.350 + (0.9 * ax$axis_x_size)

    my.mgp <- par("mgp")  # save to restore
    if (!form %in% c("contour", "hexbin")) {
      par(mgp = c(my.mgp[1], mgp2, my.mgp[3]))  # labels closer to axis
      adj <- .RSadj(axis_size=ax$axis_x_size); axis_x_size <- adj$axis_size

      if (!date.var) {  # call axis() for both axes
        if (segments_diff) {  # Cleveland dot plot
          if (n.xcol > 1) y.lvl <- rev(rownames(x))
          if (n.ycol > 1) x.lvl <- rev(rownames(x))
        }
        ax.info <- .axes(x.lvl, y.lvl, axT1, axT2,
              rotate_x=rotate_x, rotate_y=rotate_y, offset=offset, 
              axis_fmt=axis_fmt, axis_x_pre=axis_x_pre, axis_y_pre=axis_y_pre,
              ...)
      }  # end !date.var
    }  # end not contour or hexbin

    if (date.var) {  # date.var, y-axis
      ax.info <- .axes(NULL, y.val, NULL, axT2,
                       rotate_x=rotate_x, rotate_y=rotate_y, offset=offset,
                       y.only=TRUE,  # y-axis
                       axis_fmt=axis_fmt, axis_x_pre="no",
                       axis_y_pre=axis_y_pre, ...)

      # date.var, x-axis
      len.xtics <- length(x.dates)
      indices <- seq_along(x.dates)  # retain if num of data pts < n.tics
      step_range <- integer(50)

      if (ts_unit == "years") {
        x.zoo.dates <- format(x.dates, "%Y")
        n.tics <- ifelse (is.null(n_date_tics), 10, n_date_tics)
      }
      else if (ts_unit == "quarters") {
        x.zoo.dates <- as.character(zoo::as.yearqtr(x.dates))
        n.tics <- ifelse (is.null(n_date_tics), 9, n_date_tics)
        if (len.xtics >= 4*n.tics) {
          for (i in 1:50) step_range[i] <- 4*i
          tics_range <- ceiling(len.xtics / step_range)
          step <- step_range[which.min(abs(tics_range-n.tics))]
          indices <- seq(1, len.xtics, by=step)
        }
      }
      else if (ts_unit == "months") {
        x.zoo.dates <- as.character(zoo::as.yearmon(x.dates))
        n.tics <- ifelse (is.null(n_date_tics), 8, n_date_tics)
        if (len.xtics >= 12*n.tics) {
          for (i in 1:50) step_range[i] <- 12*i
          tics_range <- ceiling(len.xtics / step_range)
          step <- step_range[which.min(abs(tics_range-n.tics))]
          indices <- seq(1, length(x.dates), by=step)
        }
      }
      else {  # e.g., days
         x.zoo.dates <- as.character(x.dates)
         n.tics <- ifelse (is.null(n_date_tics), 7, n_date_tics)
      }

      # subset the indices to display for "years" and "days"
      if (ts_unit %in% c("years", "days")) {
        if (len.xtics >= n.tics) {
          step <- ceiling(len.xtics / n.tics)
          indices <- seq(1, len.xtics, by=step)
        }
      }

      # x.zoo.dates is the xts customized for char ts_unit date, Aug 2023
      # x.dates are the dates in Date format, e.g., 2023-08-01
      if (rotate_x == 0) {
        axis(1, x.zoo.dates, at=x.dates[indices], labels=x.zoo.dates[indices],
                  col=ax$axis_x_color, cex.axis=axis_x_size,
                  col.axis=ax$axis_x_text_color, ...)  # x-axis
      } else {  # rotate_x: draw ticks only, then add rotated text labels
        axis(1, at=x.dates[indices], labels=FALSE,
                  col=ax$axis_x_color, cex.axis=axis_x_size,
                  col.axis=ax$axis_x_text_color)
        usr <- par("usr")
        text(x=x.dates[indices], y=usr[3] - par("cxy")[2]/4.5,
             labels=x.zoo.dates[indices],
             pos=1, xpd=TRUE, cex=axis_x_size, col=ax$axis_x_text_color,
             srt=rotate_x, offset=offset)
      }
    }  # end date.var

    if (!form %in% c("contour", "hexbin")) par(mgp = my.mgp)  # restore back 
  }  # end xy_tics

  if (date.var) {  # create y.lab
    if (ts_unit != "unknown") {
      tu <- gsub("s$", "", ts_unit)
      if (tu == "days7") tu <- "days"
      substr(tu, 1, 1) <- toupper(substr(tu, 1, 1))
      if (do.agg) {
        if (ts_agg == "sum") show.agg <- "Total"
        if (ts_agg == "mean") show.agg <- "Mean"
      }
      else
        show.agg <- ""
      y.lab <- paste(show.agg, y.name, "by", tu)
    }
  }  # end date.var

  # axes labels
  if (!form %in% c("contour", "hexbin")) {
    .axlabs(x.lab, y.lab, main.lab, sub.lab,
           x.val, xy_tics, offset=offset,
           lab_x_size=lab_x_size, lab_y_size=lab_y_size, main_size,
           n.lab_x.ln, n.lab_y.ln, xlab.adj, ylab.adj, ...)
  }

# set-up plot background --------------------------------------------------

  if (date.var)
    .plt.bck(usr, x.dates[indices], axT2, do.h=!bubble1)
  else {
    if (!form %in% c("contour", "hexbin"))
      .plt.bck(usr, axT1, axT2, do.h=!bubble1)
  }


# set jitter for scatterplot with discrete levels -------------------------

#     do.jit <- FALSE
#     if (nrows < 100) {
#       if (max(table(x,y) > 1)) do.jit <- TRUE  # duplication
#     }

  if (object == "point") {
    # multiple sizes if n_bin>0
    if (size[1]>0 && n.xcol==1 && stat=="data") {
      if (is.null(jitter_x))  {  # ifelse() does not work
        if (length(unique(x[,1])) <= 14  &&  nrows > 14)
          jitter_x <- (diff(range(x[,1], na.rm=TRUE))) / 32
      }
      if (is.null(jitter_y))  {  # ifelse() does not work
        if (length(unique(y[,1])) <= 14  &&  nrows > 14)
          jitter_y <- (diff(range(y[,1], na.rm=TRUE))) / 32
      }
    }

    # for VBS need to set jitter, here only set if jitter is NULL
    if (is.null(jitter_x)) jitter_x <- 0
    if (is.null(jitter_y)) jitter_y <- 0

    # --- process jitter ---
    if (jitter_x > 0) {
      x.temp <- x[,1]
      x[,1] <- x[,1] + runif(length(x[,1]), -jitter_x, jitter_x)
    }
    if (jitter_y > 0) {
      y.temp <- y[,1]
      y[,1] <- y[,1] + runif(length(y[,1]), -jitter_y, jitter_y)
    }
  }


# plot points, lines (and area_fill) --------------------------------------

  # colors
  n.clrs <- max(n.col, n.by)

  ltype <- character(length=n.clrs)
  for (i in seq_along(ltype)) ltype[i] <- "solid"

  if (object == "point") {  # is point even if size=0, plotting just lines

    if (n.xcol == 1  &&  n.ycol == 1) {
      if (n.by <= 1) {  # pure single panel, data in wide format

        if (segments && ln.width>0)  # plot data line segments
            lines(x[,1], y[,1], col=color[1], lwd=ln.width, ...)
        if (area_fill[1] != "transparent") # fill area
          polygon(c(x[1], x, x[length(x)]), c(mn.y,y[,1],mn.y),
                  col=area_fill, border="transparent")


        if (ts_ahead > 0) {  # forecast
          h <- .get.h()
          if (getOption("theme") == "colors") h <- 0  # default is red
          if (!(getOption("theme") %in% c("gray", "white"))) {
                 if (h==0) {clr.f <- rgb(.6,0,0); clr.ft <- rgb(.6,0,0,.15)}
            else if (h==30) {clr.f <- rgb(.6,.3,0); clr.ft <- rgb(.6,.3,0,.15)} 
            else if (h==60) {clr.f <- rgb(.6,.6,0); clr.ft <- rgb(.6,.6,0,.15)} 
            else if (h==120) {clr.f <- rgb(0,.6,0); clr.ft <- rgb(0,.6,0,.15)} 
            else if (h==240) {clr.f <- rgb(0,.4,.6); clr.ft <- rgb(0,.4,.6,.15)} 
            else if (h==300) {clr.f <- rgb(.6,0,.4); clr.ft <- rgb(.6,0,.4,.15)} 
            trns.col <- .maketrans(clr.f, 0.25*256)
            poly.fill <- clr.ft
            pt.f.fill <- clr.f
            ln.f.col <- clr.f
          }
          else {  # gray or white background
            trns.col <- .maketrans("gray10", 0.35*256)
            poly.fill <- rgb(.5,.5,.5,.45)
            pt.f.fill <- "gray20"
            ln.f.col <- "black"
          }
          
          lines(x.fit[,1], y.fit[,1], col=trns.col, lwd=ln.width)
          lines(c(x.fit[nrow(x.fit),1], x.hat[1,1]),  # connect fit with hat
                c(y.fit[nrow(y.fit),1], y.hat[1,1]),
                col=trns.col, lwd=ln.width)
          f.size.pt <- ifelse (size.pt<0.5, .65, size.pt)
          points(x.hat[,1], y.hat[,1], pch=shape, bg=pt.f.fill, cex=f.size.pt)
          lines(x.hat[,1], y.hat[,1], col=ln.f.col, lwd=ln.width)
          lines(x.hat[,1], y.upr[,1], col=trns.col, lwd=ln.width)
          lines(x.hat[,1], y.lwr[,1], col=trns.col, lwd=ln.width)
          xx <- c(x.hat[,1], rev(x.hat[,1]))
          yy <- c(y.upr[,1], rev(y.lwr[,1]))
          polygon(xx, yy, border=NA, col=poly.fill)

          lgn.clr <- c(color[1], trns.col, ln.f.col)
          lgn.nm <- ifelse (nchar(y.name) < 6, y.name, "data")
          .plt.by.legend(c(lgn.nm, "model\nfit", "fore-\ncast"),
                         lgn.clr, lgn.clr, shp="lines", pt.trans, fill_bg,
                         usr, pt.size=size.pt, legend_title=legend_title)
        }  # end forecast
      }  # n.by is 1

      else {  # n.by > 1,  tidy format, all y data in same column
        for (i in 1:n.by) {  # only stack=TRUE makes sense
          xl <- x[by==levels(by)[i], , drop=FALSE]
          if (i > 1) yo <- yl
          yl <- y[by==levels(by)[i], , drop=FALSE]

          if (stack) {
            if (i == 1) {
              xx <- c(xl[1],xl,xl[length(xl)])
              yy <- c(min(yl[,1]),yl[,1],min(yl[,1]))
              if (fill[1] != "transparent")
                polygon(xx, yy, col=area_fill[1], border="transparent")
            }
            if (i > 1) {
              yl[,1] <- yl[,1] + yo[,1]
              xx <- c(c(xl[1],xl,xl[length(xl)]),
                    rev(c(xl[1],xl,xl[length(xl)])))
              yy <- c(c(min(yl[,1]),yl[,1],min(yl[,1])),
                         rev(c(min(yo[,1]),yo[,1],min(yo[,1]))))
              if (fill[1] != "transparent")
               polygon(xx, yy, col=area_fill[i], border="transparent")
            }
          }  # end stack

          if (segments && ln.width>0) {
            if (stack) ln.width <- 1  # no user option
            lines(xl, yl[,1], col=color[i], lty=ltype[i], lwd=ln.width, ...)
          }  # end ln.width > 0
        }
      }  # end n.by > 1
    }  # end n.xcol and n.ycol = 1

    if (n.ycol > 1) {
      for (i in 1:n.ycol) {
        if (stack) {  # polygons
          if (i == 1) { 
            xx <- c(x[1],x,x[length(x)])
            yy <- c(mn.y,y[,1],mn.y)  # starts at the scale_y setting
            if (fill[1] != "transparent")
              polygon(xx, yy, col=area_fill[1], border="transparent")
          }
          if (i > 1) {
            y[,i] <- apply(y[,(i-1):i], 1, sum, na.rm=TRUE)  # sum to stack
            xx <- c(c(x[1],x,x[length(x)]), rev(c(x[1],x,x[length(x)])))
            yy <- c(c(min(y[,i]),y[,i],min(y[,i])),
                       rev(c(min(y[,i-1]),y[,i-1],min(y[,i-1]))))
            if (fill[1] != "transparent")
              polygon(xx, yy, col=area_fill[i], border="transparent")
          }
        }  # end stack polygons

        if (segments && ln.width>0) {  # lines
          lines(x[,1], y[,i], col=color[i], lty=ltype[i], lwd=ln.width, ...)
        }  # end ln.width > 0

      }  # end i loop
    }  # end n.ycol > 1

    if (n.xcol > 1) {
      if (segments && ln.width>0) for (i in 1:n.xcol)
        lines(as.numeric(x.val),y[,1], col=fill[i], lwd=ln.width, ...)
    }


    if (is.null(by)) {


# smooth, contour, hexbin plot ------------------------------------------

      if (form == "smooth") {  # 2-D kernel density plot
        # grid lines only plot after the sp
        hue <- .get.h(getOption("theme"))  # get hue number from theme
        satur <- ifelse (getOption("theme") %in% c("gray", "white"), 0, 80)
        clr.den <- colorRampPalette(c(getOption("window_fill"),
                     hcl(hue, satur, 16)))
        if (!requireNamespace("KernSmooth", quietly=TRUE)) {
          stop("Package \"KernSmooth\" needed for this visualization\n",
               "Please install it:  install.packages(\"KernSmooth\")\n\n",
               call. = FALSE)
        }
        smoothScatter(x, y, nrpoints=smooth_points, nbin=smooth_bins,
                      transformation=function(x) x^(smooth_power),
                      colramp=clr.den, cex=smooth_size, add=TRUE)
      }
 
      else if (form == "hexbin") {
        if (!requireNamespace("hexbin", quietly=TRUE)) {
          stop("Package \"hexbin\" needed for this visualization\n",
               "Please install it:  install.packages(\"hexbin\")\n\n",
               call. = FALSE)
        }
        hc <- .getHC(getOption("pt_fill"))
          pt_hue   <- hc[1]
          pt_chroma <- hc[2]
          clr.hex <- colorRampPalette(c(
            hcl(pt_hue, pt_chroma * 0.3, 90),  # sparse — very light
            hcl(pt_hue, pt_chroma * 0.7, 50),  # mid
            hcl(pt_hue, pt_chroma,       15)   # dense — full color, dark
        ))
        hb <- hexbin::hexbin(x, y, xbins=hex_bins)
        # legend=0 suppresses hexbin's count-scale strip; 1.2 is its default
        # suppress default axes, then draw axis_fmt-formatted tick labels
        #   (e.g., 60K) in the returned hexViewport; ylab also drawn there
        #   because hexbin fixes it at -2 lines, under the tick labels
        ret <- hexbin::plot(hb, colramp=clr.hex, xlab=x.lab, ylab="",
                     main="", legend=if (hexbin_legend) 1.2 else 0,
                     xaxt="n", yaxt="n")
        hexbin::pushHexport(ret$plot.vp)
        xsc <- grid::current.viewport()$xscale
        ysc <- grid::current.viewport()$yscale
        axT1 <- pretty(xsc); axT1 <- axT1[axT1>=xsc[1] & axT1<=xsc[2]]
        ayT2 <- pretty(ysc); ayT2 <- ayT2[ayT2>=ysc[1] & ayT2<=ysc[2]]
        lbl.x <- .axis.format(axT1, axis_fmt, axis_x_pre, axis_y_pre="no")
        lbl.y <- .axis.format(ayT2, axis_fmt, axis_x_pre="no", axis_y_pre)
        # raw axis_size, as in the faceted hexbin: the .RSadj-inflated
        #   size overflows hexbin's fixed margins in plain R
        grid::grid.xaxis(at=axT1, label=lbl.x,
          gp=grid::gpar(cex=getOption("axis_size"),
                        col=ax$axis_x_text_color))
        grid::grid.yaxis(at=ayT2, label=lbl.y,
          gp=grid::gpar(cex=getOption("axis_size"),
                        col=ax$axis_y_text_color))
        grid::upViewport()
        # ylab anchored just inside the device edge, clear of tick labels
        grid::grid.text(y.lab, x=grid::unit(0.8, "lines"), rot=90,
          gp=grid::gpar(fontsize=16))  # matches hexbin xlab fontsize
      }

      else if (form == "contour") {
        ylab.adj <- ylab.adj - 0.75  # move y-axis title closer to axis
        .plt.contour(x, y,
           contour_n, contour_nbins, contour_points, size.pt[1],
           theme, scale_x, scale_y, pad_x, pad_y, x.lab, y.lab,
           ellipse, ellipse_color, ellipse_lwd,
           fit.line, fit_color, fit_lwd,
           axis_x_pre, axis_y_pre, axis_fmt, xlab.adj, ylab.adj,
           legend = contour_legend)
      }


# plot points, segments, means with no by --------------------------------- 

      else if (size.pt[1] > 0  &&  !segments_diff) {
        # plot points
        if (n.xcol == 1  &&  n.ycol == 1) {  # one x and one y variable
          if (length(out_ind) == 0)  # no outliers
            points(x[,1], y[,1], pch=shape, col=color[1], bg=fill[1],
                     cex=size.pt, ...)
          else {  # display outliers separately
            points(x[-out_ind,1], y[-out_ind,1],
               pch=shape, col=color[1], bg=fill[1], cex=size.pt, ...)
            points(x[out_ind,1], y[out_ind,1],
               pch=out_shape, col=out_color, bg=out_fill, cex=size.pt, ...)
            text(x[out_ind], y[out_ind], labels=ID[out_ind],
               pos=1, offset=0.4, col=ID_color, cex=ID_size)
          }
        }

        else if (n.ycol == 1) {  # one y
          for (i in 1:n.xcol) {  # one to many x's, Cleveland dots here
            points(x[,i], y[,1], pch=shape, col=color[i], bg=fill[i],
                   cex=size.pt, ...)
          }
        }

        else  if (n.xcol == 1) {  # one x
          for (i in 1:n.ycol) {  # one to many y's
              points(x[,1],y[,i], pch=shape, col=color[i], bg=fill[i],
                     cex=size.pt, ...)  # one x
          }
        }

        if (segments_y) {
          if (n.xcol == 1) # line segments from points to axis
            segments(x0=0, y0=y, x1=x, y1=y,
                     lty=1, lwd=.75, col=col.segment)
          else if (n.xcol == 2)  # Cleveland paired points
            segments(x0=x[,1], y0=y[,1], x1=x[,2], y1=y[,1],
                     lty=1, lwd=.75, col=col.segment)
        }

        if (!(stat %in% c("count", "prop", "%"))) {
          if (segments_x) {
            if (n.ycol == 1) # line segments from points to axis
              segments(y0=par("usr")[3], x0=x, y1=y, x1=x, lty=1, lwd=.75,
                       col=col.segment)
            else if (n.ycol == 2)  # line segments between points
              segments(y0=y[,1], x0=x[,1], y1=y[,2], x1=x[,1],
                       lty=1, lwd=.75, col=col.segment)
          }
        }
        else {  # stat is "count", etc.
          if (segments_x)
            if (n.xcol == 1)
              segments(y0=0, x0=x, y1=y, x1=x, lty=1, lwd=1, col=col.segment)
        }
        

# plot means --------------------------------------------------------------

        if (means  &&  stat == "data") {

        # get colors
          pch.avg <- ifelse (theme!="gray", 21, 23)
          bck.g <- ifelse (theme!="gray", rgb(130,90,70,
                          maxColorValue=255), "gray40")
          if (grepl(".black", theme, fixed=TRUE))
            bck.g <- "gray85"

          # restore un-jittered data
          if (jitter_x > 0) {
            x[,1] <- x.temp
            rm(x.temp)
          }
          if (jitter_y > 0) {
            y[,1] <- y.temp
            rm(y.temp)
          }

          m.lvl <- numeric(length = 0)

          # plot means for num y across levels of factor x
          if (cat.x && !cat.y && !unique.x) {
            for (i in seq_along(x.lvl))
              m.lvl[i] <- mean(y[x==i], na.rm=TRUE)
            abline(h=m.lvl, col="gray50", lwd=.5)
            points(m.lvl, pch=pch.avg, bg=bck.g, col=bck.g, cex=size.pt*1.5)
          }

          # plot means for num x across levels of factor y
          if (!cat.x && cat.y && !unique.y) {
            for (i in seq_along(y.lvl))
              m.lvl[i] <- mean(x[y==i], na.rm=TRUE)
            abline(v=m.lvl, col="gray50", lwd=.5)
            points(m.lvl, seq_len(length(y.lvl)), pch=pch.avg, bg=bck.g,
                   col=bck.g, cex=size.pt*1.5)
          }
        }  # end means

      }  # end size.pt[1] > 0  &&  !segments_diff

      else if (size.pt[1] > 0  &&  segments_diff) {  # paired dot plot

        paired_dot_plot <- function(x) {
          y.labels <- nrow(x):1
          segments(x0=x[, 1], y0=y.labels,
                   x1=x[, 2], y1=y.labels,
                   lty=1, lwd=0.75, col="black")

          points(x[, 1], y.labels, pch=shape,
                 col=color[1], bg=fill[1], cex=size.pt)
          points(x[, 2], y.labels, pch=shape,
                 col=color[2], bg=fill[2], cex=size.pt)
        }  # end paired_dot_plot()

        if (n.xcol > 1) paired_dot_plot(x)
        if (n.ycol > 1) paired_dot_plot(y)
      }  


# plot center line --------------------------------------------------------

      if (center_line != "off") {
        if (center_line == "mean") {
          m.y <- mean(y[,1], na.rm=TRUE)
          lbl <- " mean"
        }
        else if (center_line == "median") {
          m.y <- median(y[,1], na.rm=TRUE)
          lbl <- " median"
        }
        else if (center_line == "zero") {
          m.y <- 0
          lbl <- ""
        }

        abline(h=m.y, col="gray50", lty="dashed")  # draw center line
        mtext(lbl, side=4, cex=.7, col="gray50", las=2, at=m.y, line=0.1)

      }  # end center_line

      else
        m.y <- median(y[,1], na.rm=TRUE)

      # run chart (and attempted interaction chart)
      if (segments && n.xcol==1 && n.ycol==1 && !date.var) {
        for (j in 1:(nrow(x)-1)) {
          segments(x0=x[j,1], y0=y[j,1],
                   x1=x[j+1,1], y1=y[j+1,1],
                   lty="solid", lwd=ln.width, col=color[1])
        }
      }  # end segments
      x.lv <- x[,1]
      y.lv <- y[,1]
    }  # end is.null by


# by grouping variable ----------------------------------------------------

    else {
      clr <- character(n.by)

      if (length(color) == 1)
        for (i in 1:n.by) clr[i] <- color  # all levels get same color
      else
        clr <- color

      shp <- integer(n.by)
      if (length(shape) == 1)
        for (i in 1:n.by) shp[i] <- shape
      else
        shp <- shape
      # plot points and segments for each group
      for (i in 1:n.by) {
        x.lv <- subset(x, by==levels(by)[i])
        y.lv <- subset(y, by==levels(by)[i])
        if (size.pt > 0)
          points(x.lv, y.lv[,1], pch=shp[i], col=clr[i], bg=fill[i],
                 cex=size.pt, lwd=0.75, ...)

        # interaction means plot, ts without a date var and segments=TRUE
        if (segments && !stack && !date.var) {
          if (!is.null(ylab))  # thin line for ANOVA interaction plot
            if (grepl("Cell Means of", ylab, fixed=TRUE)) ln.width <- 0.75
          for (j in 1:(nrow(x.lv)-1)) {
            segments(x0=x.lv[j,1], y0=y.lv[j,1],
                     x1=x.lv[j+1,1], y1=y.lv[j+1,1],
                     lty="solid", lwd=ln.width, col=fill[i])  # not color[i]
          }
        }  # end segments
      }  # end 1:n.by

      # by legend
      if (size[1] == 0) shape <- "lines"
      if (fill[1] == "transparent") fill <- color
      if (stack) {  # default pt.size is 0
        point.size <- ifelse (size > 0, 2.5 * axis_x_size, 0)
        .plt.by.legend(levels(by), color, area_fill, shp=shape[1], pt.trans,
                       fill_bg, usr, pt.size=point.size,  # 22 is a rectangle
                       legend_title=legend_title)
      }
      else {  # not stack
        if (n.by > 1  &&  length(size) == 1)
          .plt.by.legend(levels(by), color, fill, shape, pt.trans,
                         fill_bg, usr, legend_title=legend_title)
      }
    }  # end by
    

# legend (more than 1 x or y) ---------------------------------------------

    if (fill[1] == "transparent") fill <- color

    if (n.xcol > 1) {
      if (!cleveland) {  # horizontal legend, on x-axis
        .plt.legend(colnms=colnames(x), horiz=TRUE,
                    color, fill, shape, fill_bg, usr,
                    lab_size=lab_x_size, pt.size=1.25, legend_title)
      }
      else {  # vertical legend
        point.size <- 1.25 * size.pt
        .plt.by.legend(colnames(x), color, fill, shp=shape[1], pt.trans,
                       fill_bg, usr, pt.size=point.size,  # 22 is a rectangle
                       legend_title=legend_title)
      }
    }

    if (n.ycol > 1) {  # vertical legend, on y-axis
      if (stack)  # ifelse form only returns the first value of the vector
        the.fill <- area_fill
      else
        the.fill <- fill
      .plt.legend(colnms=colnames(y), horiz=FALSE,
                  color, the.fill, shape, fill_bg, usr,
                  lab_size=lab_y_size, pt.size=1.25, legend_title)
    }

  }  # object is point


# bubble or sunflower plot  -----------------------------------------------

  else if ((object %in% c("bubble", "sunflower"))) {
    # colors
    if (is.null(col.low) || is.null(col.hi) || !bubble1) {
      if (fill[1] != "#46505A")  # default
        clr <- fill
      else
        clr <- getOption("bar_fill_cont")
      clr.color <- color
    }
    else {  # 1-var bubble plot and BPFM can have a color gradient
      color_palette <- colorRampPalette(c(col.low, col.hi))
      clr <- color_palette(length(unique(x)))
      clr.color <- "gray70"
    }

    # size is not a variable, do counts
    if (length(size) == 1) {  # MOVE to Chart()
      mytbl <- table(x, y)  # get the counts, all x-y combinations
      n.count <- nrow(mytbl) * ncol(mytbl)
      if (prop) {
        count <- numeric(length=n.count)
        if (cat.y)
          mytbl <- prop.table(mytbl, 1)
        else
          mytbl <- mytbl / sum(mytbl)
      }
      else
        count <- integer(length=n.count)

      # melt the table of counts to a data frame with xx, yy, count
      xx <- integer(length=n.count)
      yy <- integer(length=n.count)
      k <- 0
      for (i in seq_len(nrow(mytbl))) {
        for (j in seq_len(ncol(mytbl))) {
          k <- k + 1
          count[k] <- mytbl[i,j]
          if (count[k] == 0) count[k] <- NA  # 0 count not plotted
          xx[k] <- as.numeric(rownames(mytbl)[i])  # row names are factors
          yy[k] <- as.numeric(colnames(mytbl)[j])
        }
      }
      if (prop) count <- round(count, 2)

      # for categorical vars, size not a var
      if (object == "bubble") {
        .plt.bubble(xx, yy, count, radius, power, clr, clr.color,
                    size_cut, prop, bbl.txt.col, object, pt.trans)
      }
      else if (object == "sunflower") {
        cords <- data.frame(xx, yy, count, stringsAsFactors=TRUE)
        cords <- na.omit(cords)
        sunflowerplot(cords$xx, cords$yy, number=cords$count,
            seg.col=clr.color, col=clr,
            col.axis=getOption("axis_x_color"), add=TRUE)
      }

    }  # end length(size) == 1, counts

    # size is a variable (unless size is constant and bubble specified)
    else {
      for (i in 1:n.by) {
        if (is.null(by))
          d.sub <- data.frame(x=x[,1], y=y[,1], ind=rep(NA, nrow(x)), size=size)
        else
          d.sub <- data.frame(x=x[,1], y=y[,1], ind=by, size=size)
        if (!all(is.na(by))) d.sub <- d.sub[by==levels(by)[i], ]
        fill[i] <- .maketrans(fill[i], (1-pt.trans)*256)
        .plt.bubble(d.sub$x, d.sub$y, d.sub$size, radius, power, fill[i],
                    color[i], size_cut, prop, bbl.txt.col, object, pt.trans)
      }
      fill.bub.lgd <- ifelse (all(is.na(by)), fill, "gray70")  # by -> neutral
      .plt.sym.legend(size, fill=fill.bub.lgd, color="gray50", shape, usr,
                      radius, power, pt.trans)
      rm(d.sub)
    }
  }  # end bubble/sunflower


# ellipse option ----------------------------------------------------------

  if (do.ellipse) {
    ell_list <- setNames(vector("list", n.by), levels(by))  # for plt.plotly()

    for (i in 1:n.by) {
      if (n.by == 1) {  # one plot, all the data
          x.lv <- x[,1]
          y.lv <- y[,1]
      }
      else {  # multiple, pull out subset
        if (!is.null(by)) {  # multiple by plots
          ind <- which(by == levels(by)[i])
          x.lv <- x[ind]
          y.lv <- y[ind]
        }
        if (n.col > 1) {  # multiple variable plots
          if (n.xcol > 1) {
            x.lv <- x[,i]
            y.lv <- y[,1]
          }
          else {
            x.lv <- x[,1]
            y.lv <- y[,i]
          }
        }
        clr <- ifelse (length(color) == 1, color, color[i])
      }  # end multiple

      # ellipse stats
      cxy <- cor(x.lv, y.lv, use="pairwise.complete.obs")
      m.x <- mean(x.lv, na.rm=TRUE)
      m.y <- mean(y.lv, na.rm=TRUE)
      s.x <- sd(x.lv, na.rm=TRUE)
      s.y <- sd(y.lv, na.rm=TRUE)

      # build polygons for this slice (group or overall)
      ell_per_nm <- vector("list", length(ellipse))

      for (j in seq_along(ellipse)) {
        el <- ellipse::ellipse(cxy, scale = c(s.x, s.y),
                               centre = c(m.x, m.y), level = ellipse[j])
        # base R drawing (if you still want it)
        ln.type    <- "solid"
        col.border <- ifelse(n.by == 1, ellipse_color, clr)
        polygon(el, border=col.border, col=ellipse_fill,
                    lwd=ellipse_lwd, lty=ln.type)

        # close polygon for plotly and stash
        el <- rbind(el, el[1, , drop = FALSE])
        ell_per_nm[[j]] <- el
      }

      # single group (or no by): pass polygons directly
      # groups with the named list assignment
      if (is.null(by) || n.by <= 1L) {
        ellipse_region <- if (length(ellipse) == 1L) ell_per_nm[[1]]
                          else ell_per_nm
      }
      else {
        nm <- as.character(levels(by)[i])
        ell_list[[nm]] <- ell_per_nm
        ellipse_region <- ell_list
      }
    }  # ith group
  }  # do.ellipse

  else {
    ell_list <- NULL
    ellipse_region  <- NULL
    ellipse_lwd <- NULL
  }


# fit line option ---------------------------------------------------------

  f.ln <- double(0)
  if (fit.line != "off") {

    # if outliers noted then also do line w/o outliers
    fit.remove <- length(out_ind) > 0
    do.remove <- FALSE
    n.loops <- ifelse (n.by > 1, 1, as.numeric(fit.remove)+1)
    for (i.remv in 1:n.loops) {
      if (fit.remove) {
        fit_se[1] <- 0  # for line w/o outliers, no se band
        fit_lwd <- 1.5
        if (i.remv == 2) do.remove <- TRUE  # 2nd pass
      }

      mse.ln <- double(length=n.by)  # .ln is linear
      mse.nl <- double(length=n.by)  # .nl is nonlinear
      b0 <- double(length=n.by)
      b1 <- double(length=n.by)
      Rsq <- double(length=n.by)
      by.cat <- character(length=n.by)
      ind <- integer(0)

      for (i.by in 1:n.by) {  # double looping with i.remv and i

        if (n.by == 1) {  # one plot, all the data
          if (!date.var) {
            x.lv <- x[,1]

            y.lv <- y[,1]
          }
          else {  # date.var
            x.lv <- as.numeric(x.val)
            y.lv <- as.numeric(y[,i.by])
          }
          clr <- fit_color

          if (length(size) > 1)
            sz.lv <- size
          else
            sz.lv <- rep(size, length(x.lv))

        }  # end n.by = 1

        else {  # multiple by levels, pull out subset

          if (!is.null(by)) {  # multiple by plots
            x.lv <- subset(x, by==levels(by)[i.by])
            y.lv <- subset(y, by==levels(by)[i.by])
            ind <- c(ind, rep(levels(by)[i.by], length(x.lv)))
          }

          if (length(size) > 1)
            sz.lv <- size[which(by==levels(by)[i.by])]
          else
            sz.lv <- rep(size, length(x.lv))

          if (n.col > 1) {  # multiple variable plots
            if (n.xcol > 1) {
              x.lv <- x[,i.by]
              y.lv <- y[,1]
            }
            else {
              x.lv <- x[,1]
              y.lv <- y[,i.by]
            }
          }

          clr <- ifelse (length(color) == 1, color, color[i.by])
        }  # end multiple groups

        ln.type <- "solid"

        if (!is.null(out_ind)) if (do.remove) {
          x.lv <- x.lv[-out_ind]
          y.lv <- y.lv[-out_ind]
          ln.type <- ifelse (ln.type != "dashed", "dashed", "solid")
        }

        col.ln <- ifelse (n.clrs==1, fit_color, fill[i.by])

        pf <- .plt.fit(x.lv, y.lv, fit.line, fit_power, fit_new, sz.lv,
                       span)  # fit

        x.lv <- pf$x.lv  # x and y get reduced in .plt.fit if NA
        y.lv <- pf$y.lv
        fi.ln <- pf$f.ln  # fitted
        l.ln <- pf$l.ln  # linearized
        y.new <- pf$y.new  # computed from fitted function
        sz.lv <- pf$sz.lv 

        f.ln <- c(f.ln, fi.ln)

        if (i.remv == 1) {  # if outlier removal, only outlier line reported
          mse.ln[i.by] <- pf$mse.ln
          mse.nl[i.by] <- pf$mse.nl
          b0[i.by] <- pf$b0
          b1[i.by] <- pf$b1
          Rsq[i.by] <- pf$Rsq
        }

        if (n.by > 1)
          by.cat[i.by] <- levels(by)[i.by]

        # se bands about each eligible fit line
        if (!fit.line %in% c("exp", "quad", "log", "null")) {
          se.poly <- vector("list", length(fit_se))  # for plt.plotly()
          p.ln <- predict(l.ln, se=TRUE)
          nrows <- length(y.lv)
          sefit <- p.ln$se.fit
          for (j in seq_along(fit_se)) { # one or more prediction intervals 
            prb <- (1 + fit_se[j]) / 2   # upper tail: e.g. 0.975 for 95% CI
            up.ln <- fi.ln + (qt(prb, nrows-1) * sefit)
            dn.ln <- fi.ln - (qt(prb, nrows-1) * sefit)
            band <- cbind(c(x.lv, rev(x.lv)), c(up.ln, rev(dn.ln)))
            polygon(band, col=se_fill, border="transparent")
            se.poly[[j]] <- band  # for plt.plotly()
          }  # end for each se plot
        }
        else
          se.poly <- NULL

        # plot fit line(s) on top of se bands
        if (n.clrs == 2 && (fill[1] == fill[2]))
          ln.type <- ifelse(i.by == 2, "dashed", "solid")
        lines(x.lv, fi.ln, col=col.ln, lwd=fit_lwd, lty=ln.type)

        if (!("transparent" %in% clr)) {
          if (all(is.na(by)))
            g.temp <- data.frame(x.lv, y.lv, fi.ln,
              ind=rep(NA, length(x.lv)), sz.lv)
          else
            g.temp <- data.frame(x.lv, y.lv, fi.ln, levels(by)[i.by], sz.lv)
          names(g.temp)[3:5] <- c("f.ln", "ind", "size")
          if (i.by == 1)
            g <- g.temp
          else
            g <- rbind(g, g.temp)
        }

        # plot residuals option
        if (plot_errors) {
          red <- rgb(130,40,35, maxColorValue=255)
          pe.clr <- ifelse (theme %in% c("gray", "white"), "gray58", red)
          segments(y0=fi.ln, y1=y.lv, x0=x.lv, x1=x.lv,
                   col=pe.clr, lwd=1)
        }
      }  # ith group (clr)
    }  # fit.remove
    if (!quiet) cat ("\n")
  }  # end fit.line

  else {  # no fit.line
    se.poly <- NULL
    col.ln <- fit_color
    y.new <- NULL
    f.ln <- rep(NA, nrow(x))  # for plt.plotly()
    if (!is.null(by))
      ind <- by 
    else
      ind <- rep(NA, nrow(x)) 
  }


# annotations -------------------------------------------------------------

  if (!is.null(add)) {

    if (add[1] == "means") {
      add[1] <- "v_line"
      add[2] <- "h_line"
      x1 <- "mean_x"
      y1 <- "mean_y"
    }

    if (!is.null(x1)) {
      if (date.var) x1 <- julian(x1)  # dates to date serial numbers
      if (length(which(x1 == "mean_x")) > 0) {  # get mean of x if needed
        x1[which(x1 == "mean_x")] <- mean(x, na.rm=TRUE)
        x1 <- as.numeric(x1)
      }
    }
    if (!is.null(y1)) {
      if (length(which(y1 == "mean_y")) > 0) {  # get mean of y if needed
        y1[which(y1 == "mean_y")] <- mean(y, na.rm=TRUE)
        y1 <- as.numeric(y1)
      }
    }

    if (add[1] == "labels")
          text(x, y, labels=ID, pos=1, offset=0.4,
             pch=shape, col=getOption("add_color"), cex=getOption("add_size"))
        else
          .plt.add(add, x1, x2, y1, y2,
               add_size, add_lwd, add_lty, add_color, add_fill, add_trans)
  }  # end annotations
  

# interactive to plt.plotly() ----------------------------------------------

  # only consider eligible
  if (form!="contour" && form!="smooth" && length(shape)==1 &&
      n.xcol==1 && n.ycol==1 && !stack) {

    if (is.null(digits_d)) digits_d <- .max.dd(y[,1])

    if (use_plotly  &&  form=="scatter") {

    if (isTRUE(segments_x) || isTRUE(segments_y)) {  # dot plot

            cat_labels <- if (is.factor(x[,1])) levels(x[,1])[as.integer(x[,1])]
                          else as.character(x[,1])
            gridT1 <- ax.info$axT1
            gridT2 <- ax.info$axT2

            plt <- dot.plotly(
              x           = if (isTRUE(segments_x)) ax.info$axL1 else ax.info$axL2,
              y           = if (isTRUE(segments_x)) as.numeric(y[,1])
                            else                    as.numeric(x[,1]),
              orientation = if (isTRUE(segments_x)) "v" else "h",
              fill        = fill,
              border      = color,
              shape       = shape,
              pt.size     = size.pt,
              x_lab       = x.lab,
              y_lab       = y.lab,
              digits_d    = digits_d,
              pt_opacity  = 1 - pt.trans,
              gridT       = if (isTRUE(segments_x)) gridT2 else gridT1,
              style_opts  = style_opts %||% .plotly_style()
            )
        } else {


        if (fit.line == "off") {  # data not sorted
          if (length(x.lv) < nrow(x)) x.lv <- x[,1]
          if (length(y.lv) < nrow(y)) y.lv <- y[,1]
          g <- data.frame(x=x.lv, y=y.lv, f=f.ln, ind, size)
        }
        else {  # fit line, g already constructed
          names(g)[1:3] <- c("x", "y", "f")
          size <- g$size
        }

        if (date.var) {  # time series
          connect <- TRUE
          ax.info$axT1 <- as.numeric(x.dates[indices])
          ax.info$axL1 <- .format_date_labels(x.dates[indices], ts_unit)
        }

        else  # not time series
          connect <- FALSE

        if (run) connect <- TRUE
        if (segments) connect <- TRUE

        gridT1 <- ax.info$axT1
        gridT2 <- ax.info$axT2

        if (pt.trans == 0.1) pt.trans <- 0.05  # change default

        # build forecast bundle for plt.plotly() when applicable
        frcst_plotly <- NULL
        if (ts_ahead > 0 && date.var) {
          h <- .get.h()
          if (getOption("theme") == "colors") h <- 0
          if (!(getOption("theme") %in% c("gray", "white"))) {
                 if (h==0)   clr.f <- rgb(.6,0,0)
            else if (h==30)  clr.f <- rgb(.6,.3,0)
            else if (h==60)  clr.f <- rgb(.6,.6,0)
            else if (h==120) clr.f <- rgb(0,.6,0)
            else if (h==240) clr.f <- rgb(0,.4,.6)
            else if (h==300) clr.f <- rgb(.6,0,.4)
            else             clr.f <- rgb(.6,0,0)
            band.alpha <- 0.15
          } else {
            clr.f      <- "gray20"
            band.alpha <- 0.45
          }
          frcst_plotly <- list(
            x.fit      = as.numeric(x.fit[,1]),
            y.fit      = y.fit[,1],
            x.hat      = as.numeric(x.hat[,1]),
            y.hat      = y.hat[,1],
            y.upr      = y.upr[,1],
            y.lwr      = y.lwr[,1],
            clr.f      = clr.f,
            band.alpha = band.alpha
          )
        }  # end forecast

        # ensure y.lab honors passed ylab and not overwritten by y.name (".n")
        x.lab <- if (!is.null(xlab) && nzchar(xlab)) xlab else x.name
        y.lab <- if (!is.null(ylab)) ylab else y.name

        plt <- plt.plotly(
          x = g$x, y = g$y, by = g$ind, size = g$size, fit = g$f,
          by_name=by.name, n.by=n.by,
          fill=fill, border=color, shape=shape, pt.size=size.pt,
          x_lab=x.lab, y_lab=y.lab, main=main.lab,
          ax=ax.info, gridT1=gridT1, gridT2=gridT2,
          digits_d=digits_d, date.var=date.var,
          fit_color=fit_color, fit_lwd=fit_lwd, ln.type=1,
          connect=connect, ts_unit=ts_unit,
          power=power, radius.in=0.12, size.name=getOption("sizename"),
          ellipse_region=ellipse_region, ellipse_fill=ellipse_fill,
          ellipse_color=if (n.by <= 1L) ellipse_color else NULL,
          ellipse_lwd=ellipse_lwd,
          se.poly=se.poly, se_fill=se_fill,
          pt_opacity=1 - pt.trans,
          frcst=frcst_plotly,
          out_x      = if (length(out_ind) > 0) x[out_ind, 1] else NULL,
          out_y      = if (length(out_ind) > 0) y[out_ind, 1] else NULL,
          out_labels = if (length(out_ind) > 0) ID[out_ind]   else NULL,
          out_fill   = out_fill,
          out_color  = out_color,
          out_shape  = out_shape,
          ID_color   = ID_color,
          ID_size    = ID_size,
          style_opts = style_opts %||% .plotly_style()
        )
    }  # end else plt.plotly()

    if (.allow.interactive())
      .viewer_notice_once(plot_name="scatter", window_target="Both")

      if (.allow.interactive()) print(plt)  # show in Viewer
    }  # end use_plotly

  }  # end not eligible


# end, return -------------------------------------------------------------

  if (fit.line == "off") {
    mse.ln <- NULL;  mse.nl <- NULL;  b0 <- NULL;  b1 <- NULL;  Rsq <- NULL
    by.cat <- NULL
  }

  return(list(mse.ln=mse.ln, mse.nl=mse.nl, b0=b0, b1=b1, Rsq=Rsq,
              by.cat=by.cat, jitter_x=jitter_x, jitter_y=jitter_y,
              y.new=y.new))

}  # end plt.main

# debug cat
p <- function(x) {

  xstr <- deparse(substitute(x))
  cat(paste(xstr,":", sep=""), x, "\n")

}

pn <- function(x) {

  xstr <- deparse(substitute(x))
  cat("\n", paste(xstr,":", sep=""), x, "\n")
}


# -------------------------------------------------------------------------

# get maximum number of 0's to right of decimal point for variable x
#   that is less than 1, locate the significant digits
#   called only by .decdig
# Called from: hst.stats.R, zzz.R (internal: .decdig)
.lead0 <- function(x) {
  n.max.z <- 0
  dec.pt <- getOption("OutDec")

  for (i in 1:length(x)) {
    fx <- format(x[i])
    nc <- nchar(fx)
    loc <- regexpr(dec.pt, fx, fixed=TRUE)
    if (loc > -1) {  # there is a decimal point in the ith value
      n.z <- 0
      for (j.value in (loc+1):nc) {  # process one value
        if (substr(fx, j.value, j.value) == "0"  &&  x[i] < 1) {
          n.z <- n.z + 1
        }
        else
          break  # reached a non-0 value
      }
    if (n.z > n.max.z) n.max.z <- n.z
    }
  }
  return(n.max.z)
}


# get decimal digits to display for variable x, then apply
# Called from: pivot.R
.decdig <- function(x, digits_d=NULL) {
  dec.pt <- getOption("OutDec")
  ok <- is.finite(x)  # get rid of missing data
  x.var <- x[ok]  # evaluate digits on x.var w/o NA's
  loc.d <- regexpr(dec.pt, trimws(format(x.var)), fixed=TRUE)

  if (is.null(digits_d)) {
    if (all(loc.d == -1))  # no ., so integer with no decimal digits
       dgs <- 0
    else {
      lead0 <- .lead0(x.var)  # n of 0's to right of . for x < 1
      dgs <- ifelse (lead0>0, lead0+1, 3)  # 0's to right of .
      if (min(loc.d) > 2) dgs <- 3  # multiple digits to left of .
      x <- round(x, dgs)   # rounding removes trailing 0's
    }  # end decimal digits
  }  # end null digits_d

  else {  # digits_d has been set
    dgs <- ifelse (all(loc.d == -1), 0, digits_d)
    x <- round(x, dgs)
  }

  return(x)
}


# maximum number of decimal digits in the values of a variable
# takes much time, quite noticeable for large data sets, so restrict n
# Called from: bx.stats.R, Chart.R, cr.data.frame.R, hst.main.R, Model.R,
#              plt.forecast.R, plt.main.R, plt.txt.R, ss.numeric.R,
#              ttest.R, X.R, XY.R, zzz.R (internal)
.max.dd <- function(x) {

  max.dd <- 0
  n.reps <- min(200, length(x))
  for (i in 1:n.reps) {  # length(x) is number of data values
    if (!is.na(x[i])) {
      xc <- format(x[i])  # as.character(51.45-48.98) does not work
      ipos <- 0  # position of decimal point
      for (i in 1:nchar(xc)) if (substr(xc,i,i)==".") ipos <- i
      n.dec <- ifelse (ipos > 0, nchar(xc)-ipos, 0)  # n chars to right of .
      if (n.dec > max.dd) max.dd <- n.dec
    }
  }

  return(max.dd)
}


# round to specified number of digits, include trailing zeros
# Called from: package-wide (50+ R files; primary numeric-formatter)
.fmt <- function(k, d=getOption("digits_d"), w=0, j="right") {
  format(sprintf("%.*f", d, k), width=w, justify=j, scientific=FALSE)
}


# prettyNum(): display large number with separating commas, rounding to d
# digits: Total number of significant digits, affects rounding for large numbers
# nsmall: From format(), ensures at least this many decimal places in the output
# Called from: plt.forecast.R, plt.txt.R
.fmt_pn <- function(k, d=getOption("digits_d")) {
  prettyNum(k, big.mark=",", nsmall=d, format="f", scientific=FALSE)
}


# format(): display large number with separating commas, rounding to d
# provides consistent formatting for a vector of numbers
# Called from: plt.forecast.R, plt.txt.R, reg.1fitBasic.R
.fmt_cm <- function(k, d=getOption("digits_d")) {
  format(round(k, d+1), big.mark=",", nsmall=d, scientific=FALSE)
}


# truncate 1st character of number, rounding to d
# Called from: plt.bubble.R, zzz.R (internal: .fmt)
.fmt0 <- function(k, d=getOption("digits_d"), w=0) {
  a <- format(sprintf("%.*f", d, k), width=w, justify="right", scientific=FALSE)
  a <- substr(a,2,nchar(a))
  return(a)  # needed to return a without assigning, such as xx = .fmt0(x,3)
}


# right-adjust an integer, padded on the left with spaces according to w`
# Called from: details.R, logit.5Confuse.R, Logit.R, Nest.R, param.VBS.R,
#              prntbl.R, reg.1ancova.R, reg.1anvBasic.R, reg.2Relations.R,
#              reg.Kfold.R, ss.factor.R, ss.numeric.R, xNum.R, XY.R,
#              zzz.R (internal)
.fmti <- function(k, w=0) {
  format(sprintf("%i", k), width=w, justify="right")
}


# right-adjust a real number, padded on the left with spaces according to w`
# Called from: ANOVAz1.R, ANOVAz2.R, bc.main.R, bx.stats.R, corCFA.R,
#              details.R, dpmat.main.R, getColors.R, hst.stats.R,
#              logit.5Confuse.R, Logit.R, Nest.R, param.VBS.R, plt.MD.R,
#              prntbl.R, reg.1ancova.R, reg.1anvBasic.R,
#              reg.1modelBasic.R, reg.2Relations.R, reg.Kfold.R,
#              ss.factor.R, ss.numeric.R, ss.real.R, to.R, tt.2graph.R,
#              XY.R, zzz.R (internal)
.fmtc <- function(k, w=0, j="right") {
  format(sprintf("%s", k), width=w, justify=j)
}



# Called from: corRead.R, corReorder.R, corScree.R, CountAll.R, details.R,
#              logit.3Residual.R, logit.4Pred.R, logit.5Confuse.R,
#              Model.R, plt.txt.R, Read.R, rec.zmain.R, recode.R, see.R,
#              Subset.R, ttp2graph.R, zzz.R (internal)
.dash <- function(ndash, cc, newline=TRUE) {
  if (missing(cc)) cc <- "-"
  for (i in 1:(ndash)) cat(cc)
  if (newline) cat("\n")
}


# Called from: corCFA.R, cr.main.R, hst.stats.R, param.VBS.R, prntbl.R,
#              reg.1ancova.R, reg.1anvBasic.R, reg.1bckBasic.R,
#              reg.1modelBasic.R, reg.2Relations.R, reg.3txtResidual.R,
#              reg.4Pred.R, Regression.R, ss.factor.R, ss.real.R, XY.R,
#              zzz.R (internal: .dash)
.dash2 <- function(ndash, cc="-") {
  tx <- ""
  if (!is.null(cc)) for (i in 1:(ndash)) tx <- paste(tx, cc, sep="")
  return(tx)
}


# abbreviate column labels for cross-tab and related tables
# Called from: bc.main.R, dpmat.main.R, ss.factor.R, ss.real.R
.abbrev <- function(nms, mx.len=8) {

  if (max(nchar(nms)) > mx.len) {
    nms <- gsub("Strongly", "Strng", nms)
    nms <- gsub("Slightly", "Slght", nms)
    nms <- abbreviate(nms, mx.len)
  }

  # value returned is of type character
  return(nms)
}


# is date function
# Called from: plt.lattice.R, plt.main.R, XY.R
.is.date <- function(x) {
# check:  isdate <- class(x) %in% c("Date", "POSIXct", "POSIXlt")

  isdate <- ifelse("Date" %in% class(x), TRUE, FALSE)

  if (!isdate[1])  # an ordered factor has more than 1 class
    isdate <- ifelse(grepl("POSIX",  class(x), fixed=TRUE)[1], TRUE, FALSE)

  return(isdate)
}


# Called from: bc.data.frame.R, corReorder.R, corScree.R, ttest.R, X.R
.plotList <- function(plot.i, plot.title) {
  mxttl <- 0
  for (i in 1:plot.i)
    if (nchar(plot.title[i]) > mxttl) mxttl <- nchar(plot.title[i])
  mxttl <- mxttl + 8
  cat("\n")
  .dash(mxttl, newline=FALSE)
  for (i in 1:plot.i) {
    cat("\n", "Plot ", i,": ", plot.title[i], sep="")
  }
  cat("\n")
  .dash(mxttl, newline=FALSE)
  cat("\n\n")

}

# Called from: ANOVA.R, Regression.R
.plotList2 <- function(plot.i, plot.title) {
  tx <- character(length = 0)

  mxttl <- 0
  for (i in 1:plot.i)
    if (nchar(plot.title[i]) > mxttl) mxttl <- nchar(plot.title[i])
  mxttl <- mxttl + 8

  tx[length(tx)+1] <- .dash2(mxttl)
  for (i in 1:plot.i)
    tx[length(tx)+1] <- paste("Plot ", i,": ", plot.title[i], sep="")
  tx[length(tx)+1] <- .dash2(mxttl)

  return(tx)
}


# Called from: bc.data.frame.R, bc.main.R, Logit.R, pivot.R, plt.bins.R,
#              plt.txt.R, Read.R, Regression.R, XY.R, zzz_plotly.R,
#              zzz.R (internal)
.is.integer <- function(x, tol= .Machine$double.eps^0.5) {

  if (is.numeric(x)) {
    x <- na.omit(x)
    int.flg <- ifelse (abs(x-round(x)) < tol, TRUE, FALSE)  # each i of vector
    result.flg <- ifelse (all(int.flg), TRUE, FALSE)
  }
  else
    result.flg <- FALSE

  return(result.flg)
}


# function to process filter param values, especially categorical
# Called from: STL.R, zzz.R (internal: .apply_filter)
.filter <- function(txt) {

  if (substr(txt, 1, 1) == "\"") {  # parameter value is in quotes
    txt <- sub("include", "%in%", txt, fixed=TRUE)
    if (grepl(" exclude ", txt, fixed=TRUE))
      txt <- paste("!(", txt, ")", sep="")
    txt <- sub("exclude", "%in%", txt, fixed=TRUE)
    txt <- gsub("\"", "", txt, fixed=TRUE)  # remove the quotes
  }  # end expression in quotes

  return(txt)
}


# df.or.global() -------------------------------------------------------
# Determines whether a named variable should be read from the global
#   environment (data=NULL) or from a data frame
#
# Parameters
#   var.name  character  deparsed variable name (from deparse(substitute()))
#   df.name   character  deparsed data-frame name ("NULL" when data=NULL)
#   role      character  label for messages, e.g. "x", "by", "facet", "size"
#   fun.name  character  calling function name for the example in messages
#
# Returns
#   TRUE  if the variable should be read from the global environment
#   FALSE if it should be read from the data frame
#
# Side-effects
#   stop()    if variable is missing from wherever it should be
#   message() if variable looks like it was meant to be global but data=NULL
#             was not set (transition warning for users of old behaviour)

# Called from: Chart.R, Correlation.R, label.R, STL.R, SummaryStats.R,
#              ttest.R, values.R, X.R, XY.R,
#              zzz.R (internal: .resolve_named_var)
df.or.global <- function(var.name, df.name, role="x", fun.name="X") {

  # var.name is "NULL" when the argument was not supplied (deparse returns "NULL")
  # or genuinely NULL; nothing to resolve in either case
  if (is.null(var.name) || identical(var.name, "NULL"))
    return(invisible(df.name == "NULL"))

  in.global <- df.name == "NULL"

  if (!in.global && !is.null(var.name)) {

    var.in.global.env <- exists(var.name, envir=.GlobalEnv)
    df.exists         <- exists(df.name,  envir=.GlobalEnv)

    # Case 1: data frame doesn't exist but variable does — targeted stop
    if (var.in.global.env && !df.exists)
      stop(call.=FALSE, "\n------\n",
           "Variable '", var.name, "' (", role, ") exists in the global ",
           "environment\n",
           "  but no data frame '", df.name, "' was found.\n\n",
           "To use a global variable, add  data=NULL  to your call:\n",
           "  ", fun.name, "(", var.name, ", data=NULL)\n\n")

    # Case 2: both exist but variable is not in the data frame — soft warning
    if (var.in.global.env && df.exists &&
        !(var.name %in% names(get(df.name, envir=.GlobalEnv))))
      message("\n>>> Variable '", var.name, "' (", role, ") not found in ",
              "data frame '", df.name, "' but exists in the global ",
              "environment.\n",
              "    To use a global variable, add  data=NULL  to your call.\n",
              "    Example:  ", fun.name, "(", var.name, ", data=NULL)")
  }

  # Case 3: data=NULL but variable absent from global env — stop
  if (in.global && !is.null(var.name) &&
      !exists(var.name, envir=.GlobalEnv))
    stop(call.=FALSE, "\n------\n",
         "Variable '", var.name, "' not found.\n\n",
         "It is not in the global environment and no data frame was ",
         "specified.\n\n",
         "  To read a variable from a data frame, omit  data=NULL.\n",
         "  To use a global variable, ensure it is defined first.\n")

  invisible(in.global)
}


# ----- resolve a named variable to a vector -----------------------------
# Body of the get.col() closures used in X()'s and XY()'s facet-resolution
# blocks. Routes through df.or.global() for friendly error reporting and
# validates via .xcheck() before extracting from data; falls back to the
# caller's environment when data was NULL.
# Called from: X.R, XY.R (each as the body of a local get.col() closure)
.resolve_named_var <- function(nm, df.name, data, caller.env,
                               role = "x", fun.name = "X") {
  in.global <- df.or.global(nm, df.name,
                            role = role, fun.name = fun.name)
  if (!in.global) {
    .xcheck(nm, df.name, names(data))
    data[[nm]]
  } else {
    get(nm, envir = caller.env)
  }
}


# ----- apply the user-supplied `filter` expression to a data frame -------
# Body of the filter-subset block shared by Chart(), X(), and XY().
# The caller MUST do `deparse(substitute(filter))` and `parent.frame()`
# itself (NSE has to run in the caller's frame) and pass the results in.
# Called from: Chart.R, X.R, XY.R (shared filter-subset block)
.apply_filter <- function(data, filter_txt, caller_env,
                          x.in.global, quiet) {
  if (x.in.global) {
    cat("\n"); stop(call. = FALSE, "\n------\n",
      "Parameter  filter  not applicable if no data frame\n\n")
  }
  txt <- .filter(filter_txt)

  # label each row TRUE/FALSE: numeric → row indices; expression → predicate
  intYN <- try(eval(parse(text = txt), envir = caller_env), silent = TRUE)
  if (is.numeric(intYN)) {
    r <- rep(FALSE, nrow(data))
    r[intYN] <- TRUE
  } else {
    r <- eval(str2expression(txt), envir = data, enclos = caller_env)
    r <- r & !is.na(r)              # missing → FALSE
  }

  nr.before <- nrow(data)
  if (any(r))
    data <- data[r, , drop = FALSE]
  if (!quiet) {
    cat("\nfilter: ", txt, "\n-----\n")
    cat("Rows of data before filtering: ", nr.before, "\n")
    cat("Rows of data after filtering:  ", nrow(data), "\n\n")
  }
  data
}


# ----- is the argument a computational expression? ------------------------
# TRUE for a computational expression to evaluate, e.g., log(Salary),
# cut(rnorm(50)), d$x, d[,1:3].  FALSE for a bare name, a literal, and
# the column-specification forms c(Years, Pre), Years:Post, c(-Years),
# which continue through the existing column-index pipeline unchanged.
# Called from: Chart.R, X.R, XY.R
.is_expr_arg <- function(expr) {
  if (!is.call(expr)) return(FALSE)
  funs <- setdiff(all.names(expr), all.vars(expr))
  !all(funs %in% c("c", ":", "-"))
}


# ----- evaluate an expression argument for x / y / by / facet -------------
# data: the (possibly filtered) data frame when the expression references
# its columns, else NULL for caller-environment-only evaluation.
# Evaluation scope matches .apply_filter(): data frame first, then the
# caller's environment.  Returns the evaluated result (vector, factor, or
# data frame); friendly stop on failure or row-count mismatch.
# Called from: Chart.R, X.R, XY.R
.expr_eval <- function(expr, expr.name, data, caller.env,
                       role="x", fun.name="Chart") {
  val <- if (is.null(data))
           try(eval(expr, envir=caller.env), silent=TRUE)
         else
           try(eval(expr, envir=data, enclos=caller.env), silent=TRUE)
  if (inherits(val, "try-error")) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Could not evaluate the expression for  ", role, ":\n",
      "  ", expr.name, "\n\n",
      conditionMessage(attr(val, "condition")), "\n\n")
  }
  n.val <- NROW(val)  # rows of a data frame or matrix, else length
  if (!is.null(data)  &&  n.val != nrow(data)) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "The expression  ", expr.name, "  for  ", role, "\n",
      "  evaluates to ", n.val, " values, but the data frame has ",
      nrow(data), " rows\n\n")
  }
  val
}


# ----- backtick non-syntactic names for formula construction --------------
# A column created from an expression term, e.g., log(Years), needs
# backticks when a formula is rebuilt from column names with paste().
# Called from: Regression.R, Logit.R, reg.Kfold.R
.bt <- function(nms)
  ifelse(make.names(nms) == nms, nms, paste0("`", nms, "`"))


# ----- evaluate expression terms in a model formula -----------------------
# Each variable of the formula that is a call, e.g., log(Years), evaluates
# against the data frame, then the caller's environment, and becomes a
# column of data named with the expression text. The formula is rewritten
# to reference the new columns so that downstream analysis of
# data[, all.vars(formula)] proceeds as with plain variable names.
# Called from: Regression.R, Logit.R
.formula_expr <- function(my_formula, data, caller.env,
                          fun.name="Regression") {
  vars <- as.list(attr(terms.formula(my_formula, data=data),
                       "variables"))[-1L]
  calls <- Filter(is.call, vars)
  if (length(calls) == 0L)
    return(list(formula=my_formula, data=data))

  txts <- character(length=0)
  for (cl in calls) {
    txt <- paste(deparse(cl, width.cutoff=500L), collapse="")
    if (!(txt %in% txts)) {
      data[[txt]] <- .expr_eval(cl, txt, data, caller.env,
                                role="model term", fun.name=fun.name)
      txts <- c(txts, txt)
    }
  }

  subst <- function(e) {  # replace each expression term with its name
    if (is.call(e)) {
      txt <- paste(deparse(e, width.cutoff=500L), collapse="")
      if (txt %in% txts) return(as.name(txt))
      for (i in seq_along(e)[-1L])
        if (!is.null(e[[i]])) e[[i]] <- subst(e[[i]])
    }
    e
  }
  my_formula <- as.formula(subst(my_formula),
                           env=environment(my_formula))
  list(formula=my_formula, data=data)
}


# ----- aggregation function from stat name -------------------------------
# Build the per-group aggregator used across Chart()'s faceted dot path
# and the .hier/.radar/.build_plotly_tbl helpers. The caller's stat is
# already validated by match.arg() in Chart()/X()/XY() upstream, so no
# defensive branch for unknown names.
# Called from: Chart.R, zzz_plotly.R (.hier_color_resolve,
#              .hier_aggregate, .radar_aggregate, .build_plotly_tbl)
.stat_fun <- function(stat) {
  switch(tolower(stat %||% "sum"),
    mean   = function(z) mean(z,          na.rm = TRUE),
    sum    = function(z) sum(z,           na.rm = TRUE),
    median = function(z) stats::median(z, na.rm = TRUE),
    min    = function(z) min(z,           na.rm = TRUE),
    max    = function(z) max(z,           na.rm = TRUE),
    sd     = function(z) stats::sd(z,     na.rm = TRUE)
  )
}


# display label for a stat= value, the companion of .stat_fun()
# Called from: agg.R (.agg), Chart.R (multi-column y aggregation)
.stat_lbl <- function(stat) {
  switch(tolower(stat),
    sum       = "Sum",
    mean      = "Mean",
    sd        = "Standard Deviation",
    deviation = "Mean Deviation",
    min       = "Minimum",
    median    = "Median",
    max       = "Maximum")
}


# get list of data frames in global environment
# include both R data frames and tidyverse tibbles
# Called from: ANOVA.R, Chart.R, CountAll.R, details.R, Logit.R, Model.R,
#              Regression.R, rename.R, rescale.R, SummaryStats.R,
#              train_test.R, ttest.R, Write.R, X.R, XY.R,
#              zzz.R (internal: .nodf)
.getdfs <- function() {

  inGlb <- ls(name=.GlobalEnv)
  if (length(inGlb) > 0) {
    dfs <- character(length=0)
    k <- 0
    for (i in 1:length(inGlb)) {
      if (any(class(get(inGlb[i])) == "data.frame")) {
        k <- k + 1
        dfs[k] <- inGlb[i]
      }
    }
  }
  else
    dfs <- NULL

  return(dfs)
}


# Called from: ANOVA.R, Chart.R, Regression.R, rescale.R, SummaryStats.R,
#              ttest.R, X.R, XY.R
.nodf <- function(dname) {

  # see if df exists (d default), if x from data, not in style Env
  if (!exists(dname, where=.GlobalEnv)) {  # search Global and inside
    dfs <- .getdfs()  # list of data frames in style env
    txtA <- ifelse (dname == "d", ", the default data table name, ", " ")

    if ("D" %in% dfs)
      txtM <- paste("Because you have a data table called D,\n",
        " perhaps you meant to call it d, if so, just re-read \n",
        " into d instead of D")
    else
      txtM <- paste(
        "If a data table is not named the default d, then to\n",
        "  analyze the variables in that data table, in the function call\n",
        "  for the analysis specify the actual data table name with\n",
        "  the data option\n",
        "For the data table called ", dfs[1], "\n",
        "  add the following to your function call:  , data=", dfs[1], "\n\n",
        "Or, just re-read the data into the d data table\n\n", sep="")

    if (length(dfs) == 0) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "An analysis is of data values for one or more variables found\n",
        "  in a rectangular data table, with the data values for a \n",
        "  variable located in a column.\n\n",
        "You have not yet read data into a data table for analysis,\n",
        "  so the data table called ", dname, txtA, "is\n",
        "  not available for analysis.\n\n",
        "Read the data into an R data table with the Read function, usually\n",
        "  reading the data into an R data table called d.\n\n",
        "To read a data file on your computer system into the d data\n",
        "  table, in which you browse your file folders to locate the\n",
        "  desired date file, enter:\n",
        "     d <- Read(\"\")\n\n",
        "To specify a data table from your computer or the web, enter:\n",
        "     d <- Read(\"path name\") \n",
        "  or \n",
        "     d <- Read(\"web address\") \n",
        "In the web address include the http:// at the beginning\n",
        "  and also include the quotes around the web address.\n\n")
    }

    else if (length(dfs) == 1) {
      nm <- parse(text=paste("names(", dfs[1],")"))
      nm <- eval(nm)
      for (i in 1:length(nm)) nm[i] <- paste(nm[i], " ")
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Data table ", dname, txtA, "does not exist\n\n",
        "You have read data into one data table, ", dfs[1], ", but that\n",
        "  is not the data table ", dname, " that was to be analyzed\n\n",
        "Following are the names of the variables that are available\n",
        "  for analysis in the ", dfs[1], " data table\n\n",
        "  ", nm, "\n\n",
        txtM, "\n\n")
    }

    else if (length(dfs) > 1) {
      dts <- ""
      for (i in 1:length(dfs)) dts <- paste(dts, dfs[i])
      if (dname == "d") {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "Data table ", dname, txtA, "does not exist\n\n",
          "Data tables you read and/or created: ", dts, "\n\n",
          "Perhaps you have a data table that contains the variables\n",
          "  of interest to be analyzed, but it is not named ", dname, "\n",
          "Can specify the actual name with the data option\n",
          "For example, for a data table named ", dfs[1], "\n",
          "  add the following to your function call:  , data=", dfs[1], "\n\n",
          "Or, just re-read the data into the d data table\n\n")
        }
      else {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "Data table ", dname, txtA, "does not exist\n\n",
          "Perhaps you have a data table that contains the variables\n",
          "  of interest to be analyzed, but it is not named ", dname, "\n\n",
          "Data tables you have already read and/or created: ", dts, "\n\n",
          "Use an available data table, or read data into a new table\n\n")
      }
    }
  }
}


# Updated .in.global() -- now a pure expression validator only.
# Detection of whether a variable lives in global vs. a data frame has been
# removed: that is now determined solely by whether the caller set data=NULL
# (x.in.global <- df.name == "NULL").  The only job here is to stop early if
# the user passes an expression (e.g. rnorm(50), data[,1], df$x) where a
# plain variable name is required.
# Called from: Chart.R, SummaryStats.R, ttest.R, X.R, XY.R,
#              zzz.R (internal)
.in.global <- function(var.name, quiet) {
  if ((grepl("(", var.name, fixed=TRUE) ||
       grepl("[", var.name, fixed=TRUE) ||
       grepl("$", var.name, fixed=TRUE))
      && substr(var.name, 1, 1) != "c") {
    txtA <- paste("A referenced variable in a lessR function can only be\n",
                  "a variable name.\n\n", sep="")
    txtB <- "For example, this does not work:\n  > Histogram(rnorm(50))\n\n"
    txtC <- "Instead do this:\n  > Y <- rnorm(50)\n  > Histogram(Y)"
    cat("\n"); stop(call.=FALSE, "\n------\n", txtA, txtB, txtC, "\n")
  }
  invisible(NULL)  # no return value needed; callers no longer use it
}


# .xcheck() -- check that each variable name in var.name exists in the data
# frame dname whose column names are nms.  Unchanged logic; fixed:
#   - seq_along() replaces 1:length()
#   - scalar if/else replaces ifelse()
# Called from: Chart.R, Correlation.R, recode.R, Regression.R, rescale.R,
#              SummaryStats.R, ttest.R, values.R, X.R, XY.R,
#              zzz.R (internal: .resolve_named_var)
.quoted_varname <- function(x_name, arg_name) {
  if (startsWith(x_name, '"')) {
    nm <- gsub('"', '', x_name)
    stop(call. = FALSE, "\n------\n",
      "Variable name must not be in quotes.\n",
      "  Instead of  ", arg_name, "=\"", nm,
      "\"  write  ", arg_name, "=", nm, "\n\n")
  }
}


.xcheck <- function(var.name, dname, nms) {
  expr   <- parse(text=var.name)
  var.nm <- all.vars(expr)
  for (i in seq_along(var.nm)) {
    if (grepl("(", var.nm[i], fixed=TRUE) || grepl("[", var.nm[i], fixed=TRUE)) {
      txtA <- paste("A referenced variable in a lessR function can only be\n",
                    "a variable name\n\n", sep="")
      txtB <- paste("e.g., for the Histogram function, this does not work:\n",
                    "  > Histogram(rnorm(50))\n\n", sep="")
      txtC <- "Instead do this:\n  > Y <- rnorm(50)\n  > Histogram(Y)"
      cat("\n"); stop(call.=FALSE, "\n", "------\n", txtA, txtB, txtC, "\n\n")
    }
    ind <- which(nms == var.nm[i])
    if (length(ind) == 0) {
      dfs  <- .getdfs()
      txt1 <- ", the default name \n\n"
      txt2 <- "Either make sure to use the correct variable name, or\n"
      txt3 <- "specify the data table that contains the variable with: data=\n"
      txt  <- if (dname == "d") paste(txt1, txt2, txt3, sep="") else "\n"
      nm   <- paste(nms, " ")
      if (dname == "d")
        txtDef <- ", which is the default data table name\n"
      else
        txtDef <- ""
      if (length(dfs) == 1) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "You are attempting to analyze the variable ", var.nm[i], " in the\n",
          "  data table called ", dname, txtDef, "\n",
          "Unfortunately, variable ", var.nm[i], " does not exist in ", dname,
          "\n\n",
          "The following variables are currently in the ", dname,
          " data table,\n",
          "  available for analysis:\n\n", "  ", nm, "\n\n")
      }
      else if (length(dfs) > 1) {
        nm2 <- eval(parse(text=paste("names(", dfs[1], ")")))
        nm2 <- paste(nm2, " ")
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "You are attempting to analyze the variable ", var.nm[i], " in the\n",
          "  data table called ", dname, txtDef, "\n",
          "Unfortunately, variable ", var.nm[i], " does not exist in ",
          dname, "\n\n",
          "The following variables are currently in the ", dname,
          " data table,\n",
          "  available for analysis:\n\n",
          "  ", nm, "\n\n",
          "You do have another data table, but it is named ", dfs[1], "\n",
          "The following variables are currently in the ", dfs[1],
          " data table,\n",
          "  available for analysis:\n\n",
          "  ", nm2, "\n\n",
          "If a data table is not named the default d, then to\n",
          "  analyze the variables in that data table, in the function call\n",
          "  for the analysis specify the actual data table name with\n",
          "  the data option\n",
          "For the data table called ", dfs[1], "\n",
          "  add the following to your function call:  , data=", dfs[1],
          "\n\n", sep="")
      }
    }
  }
}



# see if cor matrix exists as stand-alone or embedded in list structure
# Called from: corEFA.R, corProp.R, corReflect.R, corReorder.R, corScree.R
.cor.exists <- function(cor.nm) {

  if (!grepl("$R", cor.nm, fixed=TRUE))  # no $R in name
    is.there <- cor.nm %in% ls(name=.GlobalEnv)

  else {
    nm <- sub("$R", "", cor.nm, fixed=TRUE)  # remove $R from name
    if (!(nm %in% ls(name=.GlobalEnv)))  # root list exists?
      is.there <- FALSE
    else
      is.there  <- exists("R", where=eval(parse(text=nm)))  #  R inside?
  }
  if (!is.there) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "No correlation matrix entered.\n\n",
      "No object called ", cor.nm, " exists.\n\n",
      "Either enter the correct name, or calculate with: Correlation()\n",
      "Or read the correlation matrix with: corRead()\n\n", sep="")
  }

}




# Called from: ANOVA.R, reg.1bckBasic.R
.varlist <- function(n.pred, ind, var.name, pred.lbl, n.obs, n.keep,
                      lvls=NULL) {
  tx <- character(length = 0)

  if (ind == 1)
    txt <- "Response Variable: "
  else {
    if (n.pred > 1)
      txt <- paste(pred.lbl, " Variable ", toString(ind-1), ": ", sep="")
    else
      txt <- paste(pred.lbl, " Variable: ", sep="")
  }
  if (pred.lbl == "Factor"  &&  ind > 1) tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste(txt, var.name, sep="")

  dname <- getOption("dname")

  if (dname %in% ls(name=.GlobalEnv))
    l <- attr(get(dname, pos=.GlobalEnv), which="variable.labels")
  else
    l <- NULL
  if (dname %in% ls(name=.GlobalEnv))
    myunits <- attr(get(dname, pos=.GlobalEnv), which="variable.units")
  else
    myunits <- NULL

  if (!is.null(l)) {
    lbl <- l[which(names(l) == var.name)]
    unt <- myunits[which(names(myunits) == var.name)]
    if (!is.null(unt)) if (nzchar(unt))  if(!is.na(unt))
      lbl <- paste(lbl, " (", unt, ")", sep="")
    if (!is.null(lbl))
      tx[length(tx)] <- paste(tx[length(tx)], ", ", as.character(lbl), sep="")
  }

  if (!is.null(lvls)) {
    tx2 <- "  Levels:"
    for (i in 1:length(lvls)) tx2 <- paste(tx2, lvls[i])
    tx[length(tx)+1] <- tx2
  }

  if (ind == n.pred+1) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("Number of cases (rows) of data: ", n.obs)
    tx[length(tx)+1] <- paste("Number of cases retained for analysis: ", n.keep)
  }

  return(tx)
}


# Called from: bx.stats.R, ss.factor.R, ss.numeric.R, X.R
.title2 <- function(x.name, y.name, x.lbl, y.lbl, isnullby, new.ln=FALSE) {
  txt1 <- x.name
  if (!is.null(x.lbl)) txt1 <- paste(txt1, ": ", x.lbl, sep="")

  if (isnullby) {
    txt1 <- if ("shiny" %in% .packages()) "Summary Stats" else x.name
    txt1 <- paste("---", txt1, "---")
    if (new.ln) txt1 <- paste(txt1, "\n", sep="")
  }
  else {
    txt2 <- y.name
    if (!is.null(y.lbl)) txt2 <- paste(txt2, ": ", y.lbl, sep="")
  }

  tx <- character(length=0)
  tx[length(tx)+1] <- txt1
  if (!isnullby) {
    tx[length(tx)+1] <- "\n  - by levels of - \n"
    tx[length(tx)] <- paste(tx[length(tx)], txt2, sep="")  # no leading blank
  }
  return(tx)
}


# get variable labels if they exist
# Called from: bar.lattice.R, bc.main.R, Chart.R, corCFA.R, cr.main.R,
#              dn.main.R, dpmat.main.R, hst.main.R, label.R, Model.R,
#              plt.lattice.R, plt.main.R, plt.txt.R, ss.data.frame.R,
#              ss.numeric.R, SummaryStats.R, tt.1group.R, tt.2group.R, X.R
.getlabels <- function(xlab=NULL, ylab=NULL, main=NULL, sub=NULL,
                       y.nm=FALSE, by.nm=FALSE, facet1.nm=FALSE,
                       lab_x_size=NULL, lab_y_size=NULL, labels=l,
                       graph.win=TRUE, flip=FALSE, ...) {

  if (graph.win) {
    fig.width <-  par("fin")[1]
    fig.ht <-  par("fin")[2]
    marg.x <- par("mai")[2] + par("mai")[4]
    axis_x <- fig.width - marg.x
    marg.y <- par("mai")[1] + par("mai")[3]
    axis_y <- fig.ht - marg.y
    cut.x <- 0.94 * axis_x
    cut.y <- 1.21 * axis_y  # multiplier empirically derived
  }
  else {  # do not open a graphics window if no plot
    cut.x <- 3.75
    cut.y <- 3.75
  }


  # strwidth function not working in regular R, lab_size has no affect
  regR <- FALSE
  in.RStudio <- ifelse (options("device") != "RStudioGD", FALSE, TRUE)
  in.knitr <- ifelse (is.null(options()$knitr.in.progress), FALSE, TRUE)
  if (!in.RStudio && !in.knitr) regR <- TRUE

  x.name <- getOption("xname")
  if (y.nm)
    y.name <- getOption("yname")  # y.name is specified
  else if (!by.nm && !facet1.nm)
    y.name <- getOption("yname")  # y.name by default
  else if (by.nm && !facet1.nm)
    y.name <- getOption("byname")
  else if (!by.nm && facet1.nm)
    y.name <- getOption("facet1name")

  x.lbl <- NULL
  y.lbl <- NULL

  # let deprecated mylabels work as default
  dfs <- .getdfs()
  mylabels.ok <- FALSE
  if (!is.null(dfs)) {
    if ("mylabels" %in% dfs  &&  !("l" %in% dfs)) {
      l <- mylabels
      l.name <- "mylabels"
      mylabels.ok <- TRUE
    }
  }
  if (!mylabels.ok)
    l.name <- deparse(substitute(labels))

  # l has row names, with 1st var as "label" and, if present, 2nd as "unit"
  if (l.name %in% ls(name=.GlobalEnv)) {
    l <- get(l.name, pos=.GlobalEnv)

    i.row <- which(row.names(l) == x.name)
    if (length(i.row) > 0) if (is.numeric(i.row))
      if (!is.na(l[i.row,1])) x.lbl <- l[i.row,1]

    i.row <- which(row.names(l) == y.name)
    if (length(i.row) > 0) if (is.numeric(i.row))
      if (!is.na(l[i.row,1])) y.lbl <- l[i.row,1]
  }

  else {  # labels embedded in data
    dname <- getOption("dname")  # not set for dependent option on tt
    if (!is.null(dname)) {
      if (dname %in% ls(name=.GlobalEnv)) {
        l <- attr(get(dname, pos=.GlobalEnv), which="variable.labels")
#       myunits <- attr(get(dname, pos=.GlobalEnv), which="variable.units")
      }
      else
        l <- NULL
    }
    else
      l <- NULL

    if (!is.null(l)) {
      x.lbl <- l[which(names(l) == x.name)]
      if (length(x.lbl) == 0) x.lbl <- NULL
      y.lbl <- l[which(names(l) == y.name)]
      if (length(y.lbl) == 0) y.lbl <- NULL
    }
  }  # end labels embedded in data

  # ------------------------
  # get x.lab
  st.nya <- ifelse (getOption("sub_theme") == "wsj", TRUE, FALSE)
  if (is.null(x.lbl) && is.null(xlab)) {
    x.lab <- x.name
  }
  else {
    if (!is.null(xlab))
      x.lab <- xlab  # xlab specified
    else if (!is.null(x.lbl))
      x.lab <- x.lbl
  }
  if (is.null(xlab)) if (st.nya) x.lab <- ""

  # get y.lab
  if (is.null(y.lbl) && is.null(ylab)) {
      y.lab <- y.name
  }
  else {
    if (!is.null(ylab))
      y.lab <- ylab  # ylab specified
    else if (!is.null(y.lbl))
      y.lab <- y.lbl
  }
  if (is.null(ylab)) if (st.nya) y.lab <- ""

  if (flip) {  # horiz=TRUE: swap display labels but NOT x.name
    temp <- ylab;  ylab <- xlab;  xlab <- temp
    temp <- y.lab;  y.lab <- x.lab;  x.lab <- temp
    temp <- y.lbl;  y.lbl <- x.lbl;  x.lbl <- temp
    temp <- lab_y_size;  lab_y_size <- lab_x_size;  lab_x_size <- temp
    # Intentionally one-sided: y.name takes old x.name so the by-axis
    # label shows the variable name in horiz orientation.  x.name is
    # NOT swapped because it is returned as gl$xn and used by callers
    # for data lookup (e.g. df[[x.name]]).  Swapping it to byname
    # (which may be NULL) would cause downstream crashes.
    y.name <- x.name
  }

  # ------------------------
  # x-axis and legend labels

  if ((!is.null(x.lbl) || !is.null(xlab)) && !st.nya) {
    # power.ttest: len > 1;  # add var name to label?
    if (length(x.lab) == 1  &&  !is.null(lab_x_size)  &&  graph.win) {
      var.nm <- ifelse (is.null(x.lbl) && !is.null(x.name), FALSE, TRUE)
      if (!is.null(xlab)) var.nm <- FALSE  # xlab is the complete label
      al <- .adjlbl(x.lab, lab_x_size, cut=cut.x, x.name, var.nm, units="inches")
      x.lab <- al$lab
    }
  }  # end get x.lab

  # ------------------------
  # y-axis and legend labels

    if (!is.null(y.lab)  &&  !st.nya) { # power.ttest: len > 1
    if (length(y.lab) == 1  &&  !is.null(lab_y_size)  &&  graph.win) {
      var.nm <- ifelse (is.null(y.lbl) && !is.null(y.name), FALSE, TRUE)
      if (!is.null(ylab)) var.nm <- FALSE  # ylab is the complete label
      al <- .adjlbl(y.lab, lab_y_size, cut=cut.y, y.name, var.nm, units="inches")
      y.lab <- al$lab
    }
  }  # end process y-axis label


  if (!missing(main)) {
    if (!is.null(main))
      main.lab <- main
    else
      main.lab <- NULL
  }
  else
    main.lab <- NULL

  if (!missing(sub)) {
    sub.lab <- ifelse (!is.null(sub), sub, NULL)
  }
  else
    sub.lab <- NULL

  return(list(xn=x.name, xl=x.lbl, xb=x.lab, yn=y.name, yl=y.lbl, yb=y.lab,
     mb=main.lab, sb=sub.lab, lab_x_size=lab_x_size, lab_y_size=lab_y_size))
}  # end .getlabels




# get the lines of the axis label, prefix with variable name
# Called from: zzz.R (internal: .getlabels)
.adjlbl <-
function(lab, labcex, cut, nm, var.nm, units) {

  # add variable name to label
  if (grepl("Count", lab, fixed=TRUE)) var.nm <- FALSE
  if (grepl("Proportion", lab, fixed=TRUE)) var.nm <- FALSE
  if (grepl("Alternative", lab, fixed=TRUE)) var.nm <- FALSE
  if (var.nm) {
    lab <- paste(nm, ": ", lab, sep="")
  }
  strw <- strwidth(lab, units=units, cex=labcex)
  n.lab_ln <- (strw %/% cut) + 1
  if (n.lab_ln < 1) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "No room for axis labels, increase the size of the plot window.\n\n")
  }

  if (strw > cut) {
    line <- character(length=n.lab_ln)
    s <- unlist(strsplit(lab, " "))
    il <- 1
    for (iw in 1:(length(s))) {
      if (strwidth(line[il], units=units, cex=labcex) > cut)
        il <- il + 1
      line[il] <- paste(line[il], s[iw])
    }
    # trim a possible trailing blank line
    if (line[n.lab_ln] == "") line <- line[1:(n.lab_ln-1)]

    if (length(line) == 1) {
      lab <- line
    }
    else if (length(line) == 2) {  # break label down the middle
      brk <- nchar(lab) %/% 2
      while (substr(lab,brk,brk) != " ") brk <- brk-1  # break at word boundary
      line1 <- substr(lab, 1, brk)
      line2 <- substr(lab, brk+1, nchar(lab))
      lab <- paste(line1, "\n",  line2)
    }
    else if (length(line) > 2) {  # use re-constructed lines
      lab <- ""
      for (i in 1:length(line)) {
        lab <- paste(lab, line[i])
        if (i < length(line)) lab <- paste(lab, "\n", sep="")
      }
    }
  }

  return(list(lab=lab))
}


# axis labels
# Called from: ANOVAz1.R, dn.main.R, dpmat.main.R, hst.main.R,
#              logit.4Pred.R, plt.main.R, reg.3resfitResidual.R,
#              reg.5ancova.R, reg.5Plot.R, ttp2graph.R
.axlabs <- function(x.lab, y.lab, main.lab, sub.lab,
                    x.val=NULL, xy_ticks=TRUE, offset=0.5,
                    lab_x_size=NULL, lab_y_size=NULL, main_size=NULL,
                    n.lab_x.ln=1, n.lab_y.ln=1, xlab_adj=0, ylab_adj=0,
                    ...) {
#   max.lbl <- max(nchar(axTicks(2)))

  lab_x_color <- ifelse(is.null(getOption("lab_x_color")),
    getOption("lab_color"), getOption("lab_x_color"))
  lab_y_color <- ifelse(is.null(getOption("lab_y_color")),
    getOption("lab_color"), getOption("lab_y_color"))

  if (is.null(lab_x_size)) {  # temp until all .axes calls provide lab_x_size
    lab_x_size <- ifelse(is.null(getOption("lab_x_size")),
      getOption("lab_size"), getOption("lab_x_size"))
  }
  if (is.null(lab_y_size)) {
    lab_y_size <- ifelse(is.null(getOption("lab_y_size")),
      getOption("lab_size"), getOption("lab_y_size"))
  }

  adj <- .RSadj(lab_size=lab_x_size); lab_x_size <- adj$lab_size
  adj <- .RSadj(lab_size=lab_y_size); lab_y_size <- adj$lab_size
  lblx.lns <- par("mar")[1] - 1.15

  lbly.lns <- par("mar")[2] - 1.2 - 0.4*(n.lab_y.ln - 1)

  regR <- FALSE  # regular R by itself adjustment
  in.RStudio <- ifelse (identical(getOption("device"),"RStudioGD"), TRUE, FALSE)
  in.knitr <- ifelse (!is.null(options()$knitr.in.progress), TRUE, FALSE)
  if (!in.RStudio && !in.knitr) regR <- TRUE
  if (regR) ylab_adj <- ylab_adj + .2 

  title(xlab=x.lab, line=lblx.lns-xlab_adj,
        col.lab=lab_x_color, cex.lab=lab_x_size)
  if (!is.null(sub.lab))
    title(sub=sub.lab, line=lblx.lns+1-xlab_adj, cex.sub=0.75,
          col.lab=lab_x_color, ...)
  title(ylab=y.lab, line=lbly.lns,
        col.lab=lab_y_color, cex.lab=lab_y_size)
  if (!is.null(main.lab)) {
    mc <- if (!is.null(main_size)) main_size
          else getOption("main_size", 1.1)
    title(main=main.lab, cex.main=mc,
          col.main=getOption("main_color"), ...)
  }
}


# get number of lines in value labels
# Called from: bc.main.R, plt.main.R
.get.val.ln <- function (val.lab, var.name) {

  ln.val <- integer(length=length(val.lab))

  for (i in seq_along(val.lab)) {
    if (!is.na(val.lab[i])) {
      val.lab[i] <- gsub(" ", "\n", val.lab[i])  # space to new line
      val.lab[i] <- gsub("~", " ", val.lab[i])  # ~ to space
      ln.br <- 0
      for (j in 1:nchar(val.lab[i]))
        if (substr(val.lab[i], j, j)=="\n") ln.br <- ln.br + 1
      ln.val[i] <- ln.br + 1
    }
    else
      val.lab[i] <- "<NA>"  # when y is given and a value of x is missing
  }
  mx.val.ln <- max(ln.val)  # largest number of value label lines

  if (is.infinite(mx.val.ln)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "No value labels, ", var.name, " not properly specified\n\n")
  }

  return(list(val.lab=val.lab, mx.val.ln=mx.val.ln))
}


# Called from: bc.main.R, dn.main.R, dpmat.main.R, hst.main.R,
#              logit.4Pred.R, plt.contour.R, plt.main.R, tt.1graph.R,
#              tt.2graph.R, zzz.R (internal)
.axes_dim <- function() {

  axis_x_color <- ifelse(is.null(getOption("axis_x_color")),
    getOption("axis_color"), getOption("axis_x_color"))
  axis_y_color <- ifelse(is.null(getOption("axis_y_color")),
    getOption("axis_color"), getOption("axis_y_color"))

  axis_x_lwd <- ifelse(is.null(getOption("axis_x_lwd")),
    getOption("axis_lwd"), getOption("axis_x_lwd"))
  axis_y_lwd <- ifelse(is.null(getOption("axis_y_lwd")),
    getOption("axis_lwd"), getOption("axis_y_lwd"))

  axis_x_lty <- ifelse(is.null(getOption("axis_x_lty")),
    getOption("axis_lty"), getOption("axis_x_lty"))
  axis_y_lty <- ifelse(is.null(getOption("axis_y_lty")),
    getOption("axis_lty"), getOption("axis_y_lty"))

  axis_x_size <- ifelse(is.null(getOption("axis_x_size")),
    getOption("axis_size"), getOption("axis_x_size"))
  adj <- .RSadj(axis_size=axis_x_size); axis_x_size <- adj$axis_size
  axis_y_size <- ifelse(is.null(getOption("axis_y_size")),
    getOption("axis_size"), getOption("axis_y_size"))
  adj <- .RSadj(axis_size=axis_y_size); axis_y_size <- adj$axis_size

  axis_x_text_color <- ifelse(is.null(getOption("axis_x_text_color")),
    getOption("axis_text_color"), getOption("axis_x_text_color"))
  axis_y_text_color <- ifelse(is.null(getOption("axis_y_text_color")),
    getOption("axis_text_color"), getOption("axis_y_text_color"))

  return(list(axis_x_color=axis_x_color, axis_y_color=axis_y_color,
              axis_x_lwd=axis_x_lwd, axis_y_lwd=axis_y_lwd,
              axis_x_lty=axis_x_lty, axis_y_lty=axis_y_lty,
              axis_x_size=axis_x_size, axis_y_size=axis_y_size,
              axis_x_text_color=axis_x_text_color,
              axis_y_text_color=axis_y_text_color))
}




# format axis labels, such as using "K" notation
# Called from: bar.lattice.R, bc.main.R, dn.main.R, hst.main.R,
#              plt.contour.R, plt.lattice.R, zzz.R (internal: .axes)
.axis.format <- function(axT, axis_fmt, axis_x_pre, axis_y_pre) {
  lbls <- na.omit(axT)  # Remove NA values

  if ("K" %in% axis_fmt) { # if values >= 1 billion, use scientific notation
    if (any(abs(axT) >= 1e9))
      lbls <- trimws(format(lbls, scientific = TRUE))
    else { # Safe "multiple of 100" check without %% (tolerance-based)
      is_mult_100 <- all(abs(axT / 100 - round(axT / 100)) < 1e-10)
      if (is_mult_100 && all(abs(axT)[abs(axT) > 0] > 1000))
        lbls <- trimws(paste0(lbls / 1000, "K"))
      else
        if (any(axT > 9999))  # do not want , if numbers < 10000, e.g. years
          lbls <- trimws(format(lbls, nsmall = 0, big.mark = ",",
                         decimal.mark = "."))
    }
  }

  if ("," %in% axis_fmt)
    lbls <- trimws(format(lbls, nsmall=0, big.mark=",", decimal.mark="."))

  if ("." %in% axis_fmt)
    lbls <- trimws(format(lbls, nsmall=0, big.mark=".", decimal.mark=","))

  if (axis_y_pre == "no") {
    if (nzchar(axis_x_pre)) 
      lbls=paste(axis_x_pre, lbls, sep="")
  }

  if (axis_x_pre == "no") {
    if (nzchar(axis_y_pre))
      lbls=paste(axis_y_pre, lbls, sep="")
  }

  # a numeric fall-through renders with floating-point noise in plotly,
  #   e.g., 11.2 as 11.200000000000001; as.character() gives the
  #   shortest representation, "11.2"
  if (is.numeric(lbls)) lbls <- as.character(lbls)

  return(lbls)
}


# Called from: ANOVA.R, Nest.R, Regression.R
.getdigits <- function(x, min_digits) {
  digits_d <- .max.dd(x) + 1
  if (digits_d < min_digits) digits_d <- min_digits
  return(digits_d)
}


# get axis() and text()
# Called from: ANOVAz1.R, bc.main.R, dn.main.R, dpmat.main.R, hst.main.R,
#              logit.4Pred.R, plt.main.R, reg.3resfitResidual.R,
#              reg.5ancova.R, reg.5Plot.R, tt.1graph.R, tt.2graph.R,
#              ttp2graph.R
.axes <- function(x.lvl, y.lvl, axT1, axT2,
         rotate_x=0, rotate_y=0, offset=0.5, 
         axis_fmt="K", axis_x_pre="", axis_y_pre="",
         y.only=FALSE, ...) {

  fnt <- ifelse (getOption("sub_theme") == "wsj", 2, 1) # bold
  usr <- par("usr")
  ax <- .axes_dim()  # get axis values parameters: color, lwd, lty, cex

  # x-axis
  # ------

  # numeric, uses axT1, axLn is the labels
  if (is.null(x.lvl)  &&  !is.null(axT1)) {
    if (!y.only) {  # do x axis in calling routine for time series
      axT1 <- axT1[which(axT1 >= usr[1]  &  axT1 <= usr[2])]
      axL1 <- .axis.format(axT1, axis_fmt, axis_x_pre, axis_y_pre="no")
      if (rotate_x==0) {  # mgp[2] for tic marks and value label separation
        axis(1, at=axT1, labels=axL1,
             col=ax$axis_x_color, col.axis=ax$axis_x_text_color,
             lwd=ax$axis_x_lwd, lty=ax$axis_x_lty, cex.axis=ax$axis_x_size)
      }
      else {  # rotate_x
        # text() for labels to achieve rotation with srt and offset
        # so par$mgp[2] does not work, instead adjust text(... y= ...)
        axis(1, at=axT1, labels=FALSE,
             col=ax$axis_x_color, col.axis=ax$axis_x_text_color,
             lwd=ax$axis_x_lwd, lty=ax$axis_x_lty, cex.axis=ax$axis_x_size)
        text(x=axT1, y=usr[3] - par("cxy")[2]/4.5, labels=axL1,
             pos=1, xpd=TRUE, cex=ax$axis_x_size, col=ax$axis_x_text_color,
             srt=rotate_x, offset=offset, font=fnt, ...)
      }  # end axis(), text()
    } # end not time series 
    else {
      axT1 <- NULL
      axL1 <- NULL
    }
  }  # end numeric

  # categorical, uses x.lvl
  else if (!is.null(x.lvl)) {
    axL1 <- x.lvl
    if (rotate_x==0) {  # mgp[2] for tic marks and value label separation active
      axis(1, at=axT1, labels=axL1,
           col=ax$axis_x_color, col.axis=ax$axis_x_color,
           lwd=ax$axis_x_lwd, lty=ax$axis_x_lty, cex.axis=ax$axis_x_size)
    }
    else {  # rotate_x
      axis(1, at=axT1, labels=FALSE, col=ax$axis_x_color,
          lwd=ax$axis_x_lwd, lty=ax$axis_x_lty)
      text(x=axT1, y=usr[3]- par("cxy")[2]/4.5, labels=axL1,
           pos=1, xpd=TRUE, cex=ax$axis_x_size, col=ax$axis_x_text_color,
           srt=rotate_x, offset=offset, font=fnt, ...)
    }
  }  # end categorical x

  else  # axT1 not processed  (bc just sends the numerical axis)
    axL1 <- NULL

  # y-axis
  # ------
  if (is.null(y.lvl)  &&  !is.null(axT2)) {  # numerical
    axT2 <- axT2[which(axT2 >= usr[3]  &  axT2 <= usr[4])]
    axL2 <- .axis.format(axT2, axis_fmt, axis_x_pre="no", axis_y_pre)
    axis(2, at=axT2, labels=FALSE, col=ax$axis_y_color,
        lwd=ax$axis_y_lwd, lty=ax$axis_y_lty)
    text(x=usr[1], y=axT2, labels=axL2,
         pos=2, xpd=TRUE, cex=ax$axis_y_size, col=ax$axis_y_text_color,
         srt=rotate_y, font=fnt, ...)
  }

  else if (!is.null(y.lvl)) {  # categorical
    axL2 <- y.lvl
    axis(2, at=axT2, labels=FALSE, col=ax$axis_y_color,
        lwd=ax$axis_y_lwd, lty=ax$axis_y_lty)
    text(x=usr[1], y=axT2, labels=axL2,
         pos=2, xpd=TRUE, cex=ax$axis_y_size, col=ax$axis_y_text_color,
         srt=rotate_y, font=fnt, ...)
  }

  else  # axT2 not processed  (bc just sends the numerical axis)
    axL2 <- NULL

  return(list(axT1=axT1, axL1=axL1, axT2=axT2, axL2=axL2))
}


# enlarge scale for R
# Called from: bar.lattice.R, bc.main.R, dn.main.R, dpmat.main.R,
#              hst.main.R, Model.R, plt.bubble.R, plt.by.legend.R,
#              plt.lattice.R, plt.main.R, plt.sym.legend.R, reg.5ancova.R,
#              reg.5Plot.R, tt.1graph.R, tt.1group.R, tt.2graph.R,
#              tt.2group.R, zzz.R (internal)
.RSadj <- function(radius=0.25, axis_size=NULL, cex.names=NULL, lab_size=NULL) {

  if (is.null(radius)) radius <- 0.25

  regR <- FALSE  # regular R by itself
  in.RStudio <- ifelse (options("device") == "RStudioGD", TRUE, FALSE)
  in.knitr <- ifelse (!is.null(options()$knitr.in.progress), TRUE, FALSE)
  if (!in.RStudio && !in.knitr) regR <- TRUE

  if (regR) {
    radius <- radius*1.6
  }

  if (!is.null(axis_size))
    size.axis <- ifelse (regR, axis_size*1.3, axis_size)
  else
    size.axis <- NULL

   if (!is.null(lab_size))
    size.lab <- ifelse (regR, lab_size*1.3, lab_size)
  else
   size.lab <- NULL

  return(list(radius=radius, axis_size=size.axis, lab_size=size.lab))
}


# Called from: ANOVAz1.R, ANOVAz2.R, bc.data.frame.R, Chart.R,
#              corReorder.R, corScree.R, logit.4Pred.R, prob_norm.R,
#              prob_tcut.R, prob_znorm.R, reg.3dnResidual.R,
#              reg.3resfitResidual.R, reg.5ancova.R, reg.5Plot.R,
#              reg.6mod.R, showColors.R, showPalettes.R, simCImean.R,
#              simCLT.R, simFlips.R, simMeans.R, STL.R, tt.1group.R,
#              tt.2group.R, ttest.R, ttestPower.R, Write.R, X.R, XY.R,
#              zzz.R (internal)
.showfile <- function(fname, txt) {
  dir.nm <- dirname(fname)

  if (dir.nm == ".") {  # no path name, just a file name
    if (getwd() == "/")
      workdir <- "top level (root) of your file system"
    else
      workdir <- getwd()
    txt.wrt <- "written at the current working directory"
  }
  else {
    workdir <- dir.nm
    txt.wrt <- "written" 
  }

  cat("\nThe", txt, txt.wrt, "\n")
  cat("       ", fname, " in:  ", workdir, "\n")
  cat("\n")
}


# Called from: ANOVA.R, corCFA.R, corEFA.R, Regression.R, X.R
.showfile2 <- function(fname, txt) {
  dir.nm <- dirname(fname)

  if (dir.nm == ".") {  # no path name, just a file name
    if (getwd() == "/")
      workdir <- "top level (root) of your file system"
    else
      workdir <- getwd()
    txt.wrt <- "written at the current working directory"
  }
  else {
    workdir <- dir.nm
    txt.wrt <- "written" 
  }

  tx <- c()
  tx[length(tx)+1] <- paste("\nThe", txt, txt.wrt)
  tx[length(tx)+1] <- paste("       ", fname, " in:  ", workdir)

  return(tx)
}


# Called from: param.VBS.R, X.R
# Bin a numeric vector into frequency counts, free of histogram-specific
# output. Single source for break construction, mirroring the inline logic in
# .hst.main() (which can adopt this helper later). Pass a numeric `breaks`
# vector to bin onto an existing set of breaks, so grouped data share bins.
# Returns mids, counts, breaks.
# Called from: freq_poly.plotly.R
.bin_counts <- function(x, breaks=NULL, bin_start=NULL, bin_width=NULL,
                        bin_end=NULL, x.name="x") {

  x <- x[is.finite(x)]

  # build breaks from user bin_start/bin_width/bin_end, else default Sturges
  if (is.null(breaks)) {
    if (!is.null(bin_width) || !is.null(bin_start) || !is.null(bin_end)) {
      if (is.null(bin_start))
        bin_start <- pretty(c(min(x), max(x)))[1]
      if (is.null(bin_width)) {
        h <- suppressWarnings(hist(x, plot=FALSE, breaks="Sturges"))
        bin_width <- h$breaks[2] - h$breaks[1]
      }
      if (is.null(bin_end)) bin_end <- max(x)
      if (bin_end < bin_start) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "bin_start: ", bin_start, "\n", "bin_end: ", bin_end, "\n",
          "bin_end is smaller than bin_start, make bin_end larger.\n\n")
      }
      breaks <- seq(bin_start, bin_end, bin_width)
      seq.end <- bin_end
      while (max(breaks) < bin_end) {
        seq.end <- seq.end + bin_width
        breaks <- seq(bin_start, seq.end, bin_width)
      }
    }
    else
      breaks <- "Sturges"
  }

  # for numeric breaks, every data value must fall within a bin
  if (is.numeric(breaks)) {
    if (min(x) < min(breaks) || max(x) > max(breaks)) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Range of the data for ", x.name, ": ", min(x), " to ", max(x), "\n",
        "Range of the specified bins: ", min(breaks), " to ", max(breaks),
        "\n\n",
        "Each data value must be in a bin.\n",
        "Extend the bin range by setting bin_start and/or bin_end.\n\n")
    }
  }

  h <- suppressWarnings(
         hist(x, breaks=breaks, plot=FALSE, include.lowest=TRUE))
  list(mids=h$mids, counts=h$counts, breaks=h$breaks)
}


.band.width <- function(x, bw_iter=25, details=FALSE, ...) {

  if (details) {
    cat("\n")
    cat("iterate for smoother density bandwidth (bw)\n")
    cat("flips: number of times densities change sign\n")
    cat("--------------------------------------------\n")
  }

  x <- na.omit(x)
  bw <- bw.nrd0(x)
  irep <- 0
  if (details)
    cat(irep, .fmtc(" ", 10) , "   bw: ", .fmt(bw,4), "\n", sep="")

  repeat {
    irep <- irep + 1
    d.gen <- suppressWarnings(density(x, bw, ...))  # no missing data
    xd <- diff(d.gen$y)

    flip <- 0
    for (j in 2:length(xd))
      if (sign(xd[j-1]) != sign(xd[j])) flip <- flip + 1
    if (flip > 1  &&  irep <= bw_iter) {
      bw <- 1.1 * bw
      if (details)
        cat(irep, "  flips:", .fmti(flip,3), "  bw: ", .fmt(bw,4), "\n", sep="")
    }
    else
      break
  }  # end repeat

  return(bw)
}


# see if manage graphics or just sequentially plot
# Called from: ANOVA.R, ANOVAz1.R, ANOVAz2.R, bc.data.frame.R,
#              corReorder.R, corScree.R, CountAll.R, cr.data.frame.R,
#              Regression.R, simCLT.R, tt.1group.R, tt.2group.R, ttest.R,
#              X.R
.graphman <- function() {
  in.RStudio  <- identical(Sys.getenv("RSTUDIO"),  "1")
  in.Positron <- identical(Sys.getenv("POSITRON"), "1")
  in.knitr    <- isTRUE(getOption("knitr.in.progress"))
  !in.RStudio && !in.Positron && !in.knitr
}


# manages the graphics system (not in RStudio or knitr)
# Called from: ANOVAz1.R, ANOVAz2.R, bc.data.frame.R, corReorder.R,
#              corScree.R, cr.data.frame.R, regPlot.R, Regression.R,
#              simCLT.R, tt.1group.R, tt.2group.R, X.R,
#              zzz.R (internal: .opendev)
.graphwin <- function(wnew=1, d.w=NULL, d.h=NULL) {
  dl <- dev.list()
  dl2 <- dl[which(dl==2)]  # device #2
  dl.more <- dl[which(dl>2)]  # devices larger than #2

  # remove all open windows past device 2
  if (length(dl.more) > 0) {
    min_dd <- dl.more[which(dl.more==min(dl.more))]
    max.dd <- dl.more[which(dl.more==max(dl.more))]
    for (i in min_dd:max.dd) dev.off(which=i)
  }

  off.two <- ifelse (length(dl2) == 0, TRUE, FALSE)

  # open graphics windows
  # if not already present, generate a null window for #2 and then remove
  if (off.two) wnew <- wnew + 1
    for (i in 1:wnew) {
      if (is.null(d.w) && is.null(d.h))
        dev.new()
      else if (is.null(d.w))  # BPFM and 1 cat var have reduced height only
        dev.new(height=d.h)
      else
        dev.new(width=d.w, height=d.h)
    }
  if (off.two) dev.off(which=2)

}


# Called from: bc.data.frame.R, Chart.R, corCFA.R, corProp.R,
#              corReflect.R, logit.4Pred.R, prob_norm.R, prob_tcut.R,
#              prob_znorm.R, simCImean.R, simFlips.R, simMeans.R,
#              tt.1group.R, tt.2group.R, ttestPower.R, X.R, XY.R
.opendev <- function(pdf_file, width, height) {

  if (is.null(pdf_file)) {
    in.RStudio  <- identical(Sys.getenv("RSTUDIO"),  "1")
    in.Positron <- identical(Sys.getenv("POSITRON"), "1")
    in.knitr    <- isTRUE(getOption("knitr.in.progress"))
    # no par() capture/restore here: a full par() restore on the fresh,
    #   still plot-less device flips par("new") to TRUE, which later
    #   restores replay as a "calling par(new=TRUE) with no plot" warning
    if (!in.RStudio && !in.Positron && !in.knitr)
      .graphwin(1, d.w=width, d.h=height)
  }
  else  # windows puts a blank first page without onefile=FALSE
    pdf(file=pdf_file, width=width, height=height, onefile=FALSE)

}


# num.cat var is integer with small number of unique values
# Called from: bc.data.frame.R, Chart.R, hst.main.R, ss.data.frame.R,
#              SummaryStats.R, X.R
.is.num.cat <- function(x, n_cat=10, max.n=100) {

  x <- sort(unique(na.omit(x)))
  nu.x <- length(x)

  # limit the sample size for the integer test
  if (.is.integer(sample(x, size=min(max.n,length(x))))  &&  nu.x<=n_cat) {
    eq.int <- TRUE
    d.x <- diff(x)  # check for equal intervals
    if (nu.x > 2) {
      for (i in 2:(length(x)-1)) {
        if ((abs(d.x[i-1] - d.x[i]) > 0.0000000001)) eq.int <- FALSE
      }
      status <- eq.int  # num.cat var has equal intervals
    }
    else
      status <- TRUE

  }
  else
    status <- FALSE

  return(status)

}


# Called from: bc.data.frame.R, SummaryStats.R, X.R
.ncat <- function(analysis, x.name, nu, n_cat, brief=FALSE) {

  cat("\n")
  cat(">>> ", x.name, " has only only ", nu, " equally spaced unique ",
      "integer values <= n_cat=", n_cat, "\n",
      "    so treat as categorical, convert to an R factor\n", sep="")

  if (!brief)
    cat("    For numeric, set n_cat smaller than ", nu,
        " with ", analysis, " or globally with  style", sep="")

  cat("\n")

}


# reorder fill, etc. to match the level order of the grouping factor by.call
# Called from: X.R, XY.R
.align_vector <- function(vec, by.call) {
  vec_name <- deparse(substitute(vec))

  if (!is.factor(by.call)) stop("by.call must be a factor")

  by_levels <- levels(by.call)

  # for named vec, reorder to match factor levels
  if (!is.null(names(vec))) {
    if (!all(by_levels %in% names(vec))) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "All levels of  by  must be named in", sQuote(vec_name))
    }
    vec <- vec[by_levels]
  }

  # for unnamed vec, assume user provided it in level order;
  # length 1 recycles across all levels
  if (length(vec) == 1L) {
    vec <- rep(vec, length(by_levels))
  } else if (length(vec) != length(by_levels)) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Length of", sQuote(vec_name),
      "must match number of levels in by.call")
  }

  unname(vec)
}



# Called from: plt.contour.R, zzz.R (internal: .heatmap)
.corcolors <- function() {

  fill_low <- NULL
  fill_hi <- NULL

  thm <- (getOption("theme"))
  if (is.null(fill_low) && is.null(fill_hi)) {
    if (thm %in% c("colors", "dodgerblue", "blue", "lightbronze")) {
      fill_low <- "browns"
      fill_hi <- "blues"
      hmcols <- getColors(fill_low, fill_hi, l=c(10,90), n=100, output=FALSE)
    }
    if (thm %in% c("purple")) {
      fill_low <- "olives"
      fill_hi <- "purples"
      hmcols <- getColors(fill_low, fill_hi, l=c(10,90), n=100, output=FALSE)
    }
    else if (thm %in% c("darkred", "red", "rose", "slatered")) {
      fill_low <- "turquoises"
      fill_hi <- "reds"
      hmcols <- getColors(fill_low, fill_hi, l=c(10,90), n=100, output=FALSE)
    }
    else if (thm %in% c("darkgreen", "green")) {
      fill_low <- "violets"
      fill_hi <- "greens"
      hmcols <- getColors(fill_low, fill_hi, l=c(10,90), n=100, output=FALSE)
    }
    else if (thm %in% c("gold", "brown", "sienna", "orange")) {
      fill_low <- "blues"
      fill_hi <- "browns"
      hmcols <- getColors(fill_low, fill_hi, l=c(10,90), n=100, output=FALSE)
    }
    else if (thm %in% c("gray", "white", "light")) {
      fill_low <- "white"
      fill_hi <- "black"
      hmcols <- colorRampPalette(c("white", "gray75", "black"))(100)
    }
  }
  else if (is.null(fill_low) || is.null(fill_hi)) {
    fill_low <- "white"
    fill_hi <- "gray20"
    hmcols <- colorRampPalette(c("white", "gray75", "black"))(100)
  }

  return(list(fill_low=fill_low, fill_hi=fill_hi, hmcols=hmcols))
}


# Called from: corCFA.R, corProp.R, corReflect.R, corReorder.R,
#              cr.data.frame.R
.heatmap <- function(R, NItems, main, bm=NULL, rm=NULL, diag=NULL,
                     pdf_file=NULL, width=NULL, height=NULL) {

  if (!is.null(diag)) {
    for (i in 1:NItems) R[i,i] <- diag
    cat("\nNote: To provide more color separation for off-diagonal\n",
        "      elements, the diagonal elements of the matrix for\n",
        "      computing the heat map are set to 0.\n", sep="")
  }

  axis_x_size <- ifelse(is.null(getOption("axis_x_size")),
      getOption("axis_size"), getOption("axis_x_size"))
  axis_y_size <- ifelse(is.null(getOption("axis_y_size")),
      getOption("axis_size"), getOption("axis_y_size"))

  cnm <- colnames(R)
  max.num <- max(nchar(cnm))
  mrg <- 1.3 + .38*max.num
  if (is.null(bm)) bm <- mrg
  if (is.null(rm)) rm <- mrg
  if (axis_x_size > 1) bm <- bm + .5  # hack
  if (axis_y_size > 1) rm <- rm + .5

  cc <- .corcolors()  # get divergent color scale from color theme

  if (!is.null(pdf_file))
    pdf(file=pdf_file, width=width, height=height)

  heatmap(R[1:NItems,1:NItems], Rowv=NA, Colv="Rowv", symm=TRUE,
    col=cc$hmcols, margins=c(bm,rm), main=main,
    cexRow=axis_x_size+.2, cexCol=axis_y_size+.2)

  if (!is.null(pdf_file)) {  # terminate pdf graphics
    dev.off()
    .showfile(pdf_file, "heat map")
    cat("\n\n")
  }
}


# get rgb color from a color name with specified transparency
# Called from: bc.main.R, bubble.plotly.R, dn.main.R, dn.plotly.R,
#              dot.plotly.R, dpmat.main.R, Flows.R, getColors.R,
#              hs.plotly.R, hst.main.R, logit.4Pred.R, piechart.plotly.R,
#              plt.add.R, plt.bubble.R, plt.by.legend.R, plt.colors.R,
#              plt.lattice.R, plt.main.R, plt.mat.R, plt.plotly.R,
#              plt.sym.legend.R, radar.plotly.R, reg.5Plot.R, style.R,
#              X.R, XY.R, zzz_plotly.R
.maketrans <- function(col.name, trans.level) {
  sapply(col.name, function(clr) {
    rgb.vals <- grDevices::col2rgb(clr)
    r <- rgb.vals[1]; g <- rgb.vals[2]; b <- rgb.vals[3]
    grDevices::rgb(r, g, b, alpha = trans.level, maxColorValue = 256)
  }, USE.NAMES = FALSE)
}


# from theme, get the associated sequential, divergent or hues palette name
# Called from: ANOVAz2.R, bc.main.R, bubble.plotly.R, Chart.R, dn.main.R,
#              Flows.R, plt.colors.R, plt.fill.R, reg.5ancova.R, X.R
.get_fill <- function(theme=getOption("theme"), seq.pal=FALSE, diverge=FALSE) {

  if (!diverge) {
    # for ordinal variables, or color theme not default, get sequential palette
    # for not ordinal and default color theme, qualitative palette
    if (theme == "colors") {
      clrs <- ifelse (seq.pal, "blues", "hues")
    }
    else if (theme %in% c("gray", "white")) clrs <- "grays"
    else if (theme %in% c("lightbronze", "dodgerblue", "blue")) clrs <- "blues"
    else if (theme %in% c("gold", "brown", "sienna")) clrs <- "browns"
    else if (theme == "orange") clrs <- "rusts"
    else if (theme %in% c("darkred", "red", "rose", "slatered")) clrs <- "reds"
    else if (theme %in% c("darkgreen", "green")) clrs <- "greens"
    else if (theme == "purple") clrs <- "violets"
    else clrs <- "blues"
  }

  else {  # divergent palette
    if ((theme %in% c("gray", "white"))) {
      clrs <- c("grays", "grays")
    }
    else if ((theme %in% c("hues", "lightbronze", "dodgerblue", "blue",
                            "gold", "brown", "sienna", "orange")))
      clrs <- c("browns", "blues")
    else if ((theme %in% c("darkred", "red", "rose", "slatered")))
      clrs <- c("turquoises", "reds")
    else if ((theme %in% c("darkgreen", "green", "purple")))
      clrs <- c("violets", "greens")
    else
      clrs <- c("browns", "blues")
  }

  return(clrs)
}


# see if fill or color is a predefined palette
# Called from: bc.main.R, X.R, XY.R, zzz.R (internal: .color_range)
.is.palette <- function(fillclr) {
  if (fillclr == "magma") fillclr <- "plasma"

  # names of color palettes generated by getColors
  nmC <- c("reds", "rusts", "browns", "olives", "greens", "emeralds",
          "turquoises", "aquas", "blues", "purples", "violets", "magentas",
          "grays", "hues")
  nmR <- c("rainbow", "heat", "terrain")
  nmV<- c("viridis", "cividis", "plasma", "spectral")
  nmO<- c("Okabe-Ito")
  nmD<- c("distinct")
  nmW<- c("BottleRocket1", "BottleRocket2", "Rushmore1",
          "Royal1", "Royal2", "Zissou1", "Darjeeling1", "Darjeeling2",
          "Chevalier1", "FantasticFox1", "Moonrise1", "Moonrise2",
          "Moonrise3", "Cavalcanti1", "GrandBudapest1", "GrandBudapest2",
          "IsleofDogs1", "IsleofDogs2")
  nmT <- c("Tableau")
  nm <- c(nmC, nmR, nmV, nmO, nmD, nmW, nmT)

  return(fillclr %in% nm)
}


# from a pre-defined color palette name, generate the palette without scaling
# if not a palette name, then return the name, i.e., do nothing
# typically used to convert color name to a color, such as from from get_fill()
# Called from: ANOVAz2.R, bar.lattice.R, bc.main.R, bubble.plotly.R,
#              Chart.R, dn.main.R, Flows.R, plt.colors.R, plt.fill.R,
#              style.R, X.R, zzz_plotly.R (.hier_color_resolve)
.color_range <- function(fill, n.clr) {

  # fill is a function such as hcl or is a named vector
  if (is.call(fill) || is.name(fill)) {
    clrs <- eval(fill)
  }

  # or evaluate the character string fill
  else {
    if (!is.null(fill[1])) {
      if (fill[1] == "colors") fill[1] <- "hues"   # new names
      if (fill[1] == "yellows")  fill[1] <- "browns"

      if (.is.palette(fill[1]))
        clrs <- getColors(fill[1], n=n.clr, output=FALSE)  # sequential palette
      else
        clrs <- fill  # not an identified name of a color range
      if (fill[1]=="grays" && n.clr==2) # Cleveland 2-var dot plot of difference
        clrs <- c("gray62", "gray40")

      if (length(fill) == 2) {  # divergent
        if (.is.palette(fill[2]))
          clrs <- getColors(fill[1], fill[2], n=n.clr, output=FALSE)
      }
    }  # fill[1] not NULL

    else  # fill[1] is NULL
      clrs <- NULL
  }

  return(clrs)
}


# get the hue according to the color theme
# Called from: bc.main.R, plt.main.R, zzz.R (internal: .scale.clr)
.get.h <- function(theme=getOption("theme")) {

       if (theme %in% c("gray", "white")) h <- 0  # any value for h works
  else if (theme %in% c("colors", "lightbronze", "dodgerblue", "blue")) h <- 240
  else if (theme %in% c("gold", "brown", "sienna")) h <- 60
  else if (theme == "orange") h <- 30
  else if (theme %in% c("darkred", "red", "rose", "slatered")) h <- 0
  else if (theme %in% c("darkgreen", "green")) h <- 120
  else if (theme == "purple") h <- 300
  else h <- 240

  return(h)
}

# get hue and chroma from an R rgb color name
# Called from: plt.main.R, zzz.R (internal: .scale.clr)
.getHC <- function(rgb.nm) {
  rgb1 <- t(grDevices::col2rgb(rgb.nm) / 255)  # rgb color from R color name
  luv  <- grDevices::convertColor(rgb1, from="sRGB", to="Luv")
# L <- luv[,"L"]
  u <- luv[,"u"]
  v <- luv[,"v"]
  c <- sqrt(u^2 + v^2)
  h <- (atan2(v, u) * 180 / pi) %% 360
  setNames(c(hue=h, chroma=c), c("hue","chroma"))
}


# get rgb color from R color name
# Called from: style.show.R, zzz_plotly.R
.to_rgb <- function(color) {

  clr <- color[1]  # box_fill is qualitative color scale

  if (is.null(color))
    rgb_color <- "NULL"
  else {  # preserve color name if it exists
    if (!(color[1] %in% colors()))
      rgb_color <- col2rgb(clr, alpha=TRUE)
    else
      rgb_color <- clr
  }
  return(rgb_color)
}


# initial attempt at sequential scaling of fill color
# Called from: Chart.R, X.R
.getColC <- function(x, chroma=55, fill_name) {

  if (getOption("theme") %in% c("gray", "white")) chroma <- 0

  if (!grepl(".v", fill_name, fixed=TRUE)) {
    xp <- pretty(x)
    xp.mn <- min(xp)
    xp.mx <- max(xp)
    xp.rn <- xp.mx - xp.mn

    x.nrm <- (x - xp.mn) / xp.rn

    lum <- 100 - (100*x.nrm)  # scale each value, light to dark flip
    expn <- (82 + (2 * length(x))) / 100
    if (expn > .96) expn <- .96  # hack
    lum <- (lum**expn) + 9  # compress, which darkens, then lighten a bit
    cc <- hcl(h=.get.h(), c=chroma, l=lum)
    clr <- cc
  }
  return(clr)
}

# better, more general scaling function
# fill_scaled is TRUE when called
# Called from: bc.main.R
.scale.clr <- function(x, fill, fill_split, fill_chroma, theme) {
  n.fill <- ifelse (is.null(fill), 0, length(fill))
  # rescale absolute distance from midpoint
  x.dist <- abs(x - fill_split)
  mx.xd <- max(x.dist)
  x.normed <- x.dist / mx.xd
  lum.range <- 27 + ((1-x.normed)*53)
  if (n.fill == 0 || n.fill > 2) {  # hue and chroma by defaulting to theme
    if (theme %in% c("gray", "white")) {
      chroma <- 0
      hue <- 0  # arbitrary
    }
    else {
      chroma <- fill_chroma
      hue <- .get.h(theme)
    }
    n.fill <- 1  # treat as single-color sequential
  }  # end not fill

  else if (n.fill == 1) {  # hue and chroma from fill name
    hc <- .getHC(fill)
    hue <- hc[1]
    chroma <- hc[2]
  }

  if (n.fill < 2)
    fill <- hcl(h=hue, c=chroma, l=lum.range)

  else if (n.fill == 2) {  # length of fill is 2, so divergent scale
    hc <- .getHC(fill[1])
    hue1 <- hc[1]
    chroma1 <- ifelse (hue1=="black", 0, hc[2])
    if (chroma1 > 100) chroma1 <- 100
    hc <- .getHC(fill[2])
    hue2 <- hc[1]
    chroma2 <- ifelse (hue2=="black", 0, hc[2])
    if (chroma2 > 100) chroma2 <- 100

    # need a sequential scale if only one who is black, chroma=0
    if ((chroma1!=0 && chroma2!=0) || (chroma1==0 && chroma2==0))
      fill <- colorspace::diverging_hcl(n=length(lum.range),
         h=c(hue1, hue2), c=c(chroma1,chroma2), l=lum.range, fixup=TRUE)
    else
      fill <- colorspace::sequential_hcl(
        n=length(lum.range), h=hue2, c=c(chroma1, chroma2), l=lum.range)
  }

  else {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "With  fill_scaled  specify one or two fill colors,\n",
      "  for either a sequential or a divergent color palette.\n\n")
  }

  return(fill)
}  # end scale.clrs()


# Resolve a getColors(...) call to a concrete palette of length n.
# fill.name  — deparse(substitute(fill)) captured at function entry
# n          — desired palette length, from caller's chart context
# Called from: Chart.R, X.R, XY.R
.resolve_getColors_n <- function(fill.name, n) {
  gc.args   <- substr(fill.name, 11, nchar(fill.name) - 1)
  has_n     <- grepl("(^|,)\\s*n\\s*=", gc.args)
  has_output <- grepl("output", fill.name, fixed = TRUE)
  n_arg      <- if (has_n) "" else paste0(", n=", n)
  output_arg <- if (has_output) "" else ", output=FALSE"
  txt        <- paste0("fill <- getColors(", gc.args, n_arg, output_arg, ")")
  eval(parse(text = txt))
}


# Called from: piechart.plotly.R
.auto_text_color <- function(cols, bg = "white", threshold = 0.5) {
  # cols: vector of hex ("#RRGGBB"), rgba("r,g,b,a"), or R color names
  # bg:   fallback if col2rgb fails
  # threshold: luminance cutoff for black/white switch

  parse_one <- function(col) {
    col <- as.character(col)

    if (grepl("^rgba?\\(", col)) {
      # rgba(r,g,b,...) form
      nums <- suppressWarnings(as.numeric(strsplit(gsub("[rgba() ]",
                               "", col), ",")[[1]]))
      r <- nums[1]; g <- nums[2]; b <- nums[3]
    } else {
      # try normal R color or hex
      rgb <- tryCatch(
        grDevices::col2rgb(col)[, 1],
        error = function(e) grDevices::col2rgb(bg)[, 1]
      )
      r <- rgb[1]; g <- rgb[2]; b <- rgb[3]
    }

    # normalize to [0,1]
    r <- r/255; g <- g/255; b <- b/255

    # linearize (sRGB companding)
    lin <- function(u) ifelse(u <= 0.03928, u/12.92, ((u+0.055)/1.055)^2.4)
    rL <- lin(r); gL <- lin(g); bL <- lin(b)

    # relative luminance
    L <- 0.2126*rL + 0.7152*gL + 0.0722*bL

    if (is.na(L)) "black" else if (L < threshold) "white" else "black"
  }

  vapply(cols, parse_one, character(1))
}


# Called from: style.show.R
.to_num <- function(k, d=1, w=0) {
  if (!is.null(k))
    val <- format(sprintf("%.*f", d, k), width=w, justify="right",
                  scientific=FALSE)
  else
    val <- "NULL"
  return(val)
}


# Called from: style.show.R
.to_str <- function(cc) {
  if (is.null(cc)) cc <- "NULL"
  return(cc)
}


# Called from: style.R
.to256 <- function(trans_level)
   trn <- (1-getOption(trans_level))*256

# Called from: style.R
.to256n <- function(trans_level)
   trn <- (1-trans_level) * 256


# change class call to class character
# otherwise length > 1, make a single character string
# Called from: av.Rmd.R, Chart.R, corFA_Rmd.R, dist.Rmd.R, dn.main.R,
#              dpmat.main.R, hst.stats.R, param.VBS.R, plt.txt.R,
#              Read.R, reg.Rmd.R, Regression.R, XY.R
.fun_call.deparse <- function(fun_call) {

  fc.d <- deparse(fun_call)
  if (length(fc.d) > 1) {  # multiple lines
    fc <- fc.d[1]
    for (i in 2:length(fc.d)) fc <- paste(fc, fc.d[i], sep="")
  }
  else
    fc <- fc.d

  fc <- sub("     ", " ", fc, fixed=TRUE)
  fc <- sub("    ", " ", fc, fixed=TRUE)
  fc <- sub("  ", " ", fc, fixed=TRUE)

  return(fc)
}


# get the value for a specified function argument
# Called from: av.Rmd.R, corFA_Rmd.R, dist.Rmd.R, reg.Rmd.R
.get.arg <- function(argm, fc) {

  loc <- regexec(argm, fc)
  strt1 <- loc[[1]]  # beginning of argument
  if (strt1 > 0) {
    j <- strt1
    while (substr(fc, start=j, stop=j) != "\"") j <- j + 1
    strt <- j
    j <- j + 1  # first " after ,
    while (substr(fc, start=j, stop=j) != "\"") j <- j + 1
    stp <- j  # second " after ,
    value <- substr(fc, start=strt, stop=stp)
  }
  else
    value <- ""

  return(value)
}


# remove argument and character value from a function call
# Called from: av.Rmd.R, corFA_Rmd.R, dist.Rmd.R, dpmat.main.R,
#              param.VBS.R, plt.txt.R, reg.Rmd.R, XY.R
.rm.arg <-  function(argm, fc) {

  loc <- regexec(argm, fc)[[1]]  # beginning of argument

  if (loc > 0) {

    first.arg <- ifelse (substr(fc, loc-1, loc-1) == "(", TRUE, FALSE)

    j <- loc
    if (!first.arg)  # is not first argument, start at preceding comma
      while (substr(fc, start=j, stop=j) != ",") if (j > 0) j <- j - 1
    strt <- j  #  closing parentheses or comma before argument

    while (substr(fc, start=j, stop=j) != "\"") if (j < 1000) j <- j + 1
    j <- j + 1  # first " after ,
    while (substr(fc, start=j, stop=j) != "\"") if (j < 1000) j <- j + 1
    stp <- j  # second " after ,

    if (first.arg) stp <- stp + 2  # remove trailing comma and space

    remv <- substr(fc, start=strt, stop=stp)
    fc_new <- sub(remv, "", fc, fixed=TRUE)

  }

  return(fc_new)
}


# remove argument and logical value from a function call
# Called from: plt.txt.R
.rm.arg.l <-  function(argm, fc) {

  loc <- regexec(argm, fc)[[1]]  # beginning of argument

  if (loc > 0) {

    first.arg <- ifelse (substr(fc, loc-1, loc-1) == "(", TRUE, FALSE)

    j <- loc
    if (!first.arg)  # is not first argument, start at preceding comma
      while (substr(fc, start=j, stop=j) != "," &&
             substr(fc, start=j, stop=j) != "")
         if (j < 1000) j <- j + 1
    stp <- j  #  closing parentheses or comma before argument
    if (first.arg) stp <- stp + 2  # remove trailing comma and space
    strt <- loc - 1

    remv <- substr(fc, start=strt, stop=stp)
    fc_new <- sub(remv, "", fc, fixed=TRUE)
    fc_new <- sub(",,", "", fc_new, fixed=TRUE)  # hack

  }

  return(fc_new)
}


# remove x=  and y= for suggestions for XY
# Called from: dpmat.main.R, param.VBS.R, plt.txt.R, XY.R
.rm.arg.2 <-  function(argm, fc) {

  fc <- sub(",,", ",", fc, fixed=TRUE)

  fc1 <- gsub(argm, "", fc, fixed=TRUE)  # remove all argm from fc
  fc2 <- gsub(",", ", ", fc1, fixed=TRUE)  # each , goes to , space
  fc3 <- gsub("  ", " ", fc2, fixed=TRUE)
  fc3 <- gsub(") #", ")  #", fc3, fixed=TRUE)  # restore blank before #

  if (grepl("(", argm, fixed=TRUE)) fc3 <- gsub("XY", "XY(", fc3)
  fc3 <- gsub("((", "(", fc3, fixed=TRUE)
  fc3 <- sub(", ,", ",", fc3, fixed=TRUE)

  return(fc3)
}


# remove argument and non-string value from a function call
# Called from: reg.Rmd.R
.rm.arg.ns <-  function(argm, fc) {

  loc <- regexec(argm, fc)[[1]]  # beginning of argument

  if (loc > 0) {

    first.arg <- ifelse (substr(fc, loc-1, loc-1) == "(", TRUE, FALSE)

    j <- loc
    if (!first.arg)  # is not first argument, start at preceding comma
      while (substr(fc, start=j, stop=j) != ",") if (j > 0) j <- j - 1
    strt <- j  #  closing parentheses or comma before argument

    dlm <- c(",", ")")

    j <- j + 1
    while (!(substr(fc, start=j, stop=j) %in% dlm))
      if (j < 1000) j <- j + 1

    stp <- j  # got a "," or a ")"
    stp <- stp - 1  # retain the "," or ")"

    if (first.arg) stp <- stp + 2  # remove trailing comma and space

    remv <- substr(fc, start=strt, stop=stp)
    fc_new <- sub(remv, "", fc, fixed=TRUE)

  return(fc_new)
  }
}


# Called from: plt.forecast.R, STL.R
.toFmtDate <- function(x.date, ts_unit) {
  if (ts_unit == "months")
    x.date <- as.character(zoo::as.yearmon(x.date))
  else if (ts_unit == "quarters")
    x.date <- as.character(zoo::as.yearqtr(x.date))
  else if (ts_unit == "years")
    x.date <- as.character(format(x.date, "%Y"))
  else
    x.date <- as.character(x.date)
}


# A base-R resolver for x, y, by, facet1, facet2, ID that supports the common forms:
# 	•	bare name: by = Gender
# 	•	character name: by = "Gender"
# 	•	numeric index: by = 3
# 	•	expression: by = cut(Age, 5) or by = interaction(Sex, Dept)
# 	•	missing / NULL

# It also lets you request coercion (e.g., make by/facets factors).

# The .resolve_one() approach works cleanly even when by = NULL (or facet1, facet2, ID, etc. are omitted). The helper is designed to always return the same shape of result, with present = FALSE if the argument was missing or NULL.

#  rby <- .resolve_one(data, by, want = "factor")
#  by.name <- rby$name; by.call <- rby$value


`%||%` <- function(a,b) if (is.null(a) || !length(a)) b else a

# want: "auto","factor","numeric","character","logical","no"
# Called from: bubble.plotly.R, Chart.R, Flows.R, hier.plotly.R,
#              plt.plotly.R, radar.plotly.R, reg.3txtResidual.R,
#              reg.Rmd.R, ss.pivot.R, X.R, XY.R, zzz_plotly.R
.resolve <- function(data, arg,
                     want = c("auto","factor","numeric","character","logical","no")) {
  want <- match.arg(want)
  out  <- list(present = FALSE, name = NULL, value = NULL)
  if (missing(arg) || is.null(arg)) return(out)

  expr <- substitute(arg)

  if (is.data.frame(data)) {
    if (is.character(arg) && length(arg) == 1L && arg %in% names(data)) {
      val <- data[[arg]]; nm <- arg
    } else if (is.numeric(arg) && length(arg) == 1L && is.finite(arg) &&
               arg >= 1 && arg <= ncol(data)) {
      val <- data[[arg]]; nm <- names(data)[arg] %||% paste0("V", arg)
    } else {
      # Evaluate inside a data mask; base functions available; no global leakage
      data_env <- list2env(data, parent = baseenv())
      val <- try(eval(expr, envir = data_env), silent = TRUE)
      if (inherits(val, "try-error")) return(out)
      nm <- deparse(expr, nlines = 1)
    }
  } else {
    # data = NULL → resolve in caller/global env
    val <- try(eval(expr, envir = parent.frame(), enclos = baseenv()), silent = TRUE)
    if (inherits(val, "try-error")) {
      if (is.character(arg) && length(arg) == 1L &&
          exists(arg, envir = parent.frame(), inherits = TRUE)) {
        val <- get(arg, envir = parent.frame(), inherits = TRUE); nm <- arg
      } else return(out)
    } else nm <- deparse(expr, nlines = 1)
  }

  val <- switch(want,
    auto      = val,
    factor    = if (is.factor(val)) val else factor(val),
    numeric   = suppressWarnings(as.numeric(val)),
    character = as.character(val),
    logical   = as.logical(val),
    no        = val
  )

  out$present <- TRUE; out$name <- nm; out$value <- val; out
}


# Called from: X.R, XY.R
.vbs_summary_table <- function(x_vec, grp_vec, grp.label, digits_d = NULL) {

  .vbs_stats <- function(z) {
    z <- z[!is.na(z)]
    c(
      n      = length(z),
      Mean   = mean(z),
      Median = median(z),
      SD     = stats::sd(z),
      IQR    = stats::IQR(z),
      Min    = min(z),
      Max    = max(z)
    )
  }

  ## ---- grouped vs ungrouped ----
  if (!is.null(grp_vec)) {
    tmp_list <- tapply(x_vec, grp_vec, .vbs_stats)
    mat      <- do.call(rbind, tmp_list)     # groups x stats
    grp_vals <- names(tmp_list)
  } else {
    mat      <- rbind(.vbs_stats(x_vec))     # 1 x stats
    grp_vals <- grp.label
  }

  ## Build data frame first
  res <- data.frame(
    grp = grp_vals,
    mat,
    row.names        = NULL,
    check.names      = FALSE,
    stringsAsFactors = FALSE
  )
  names(res)[1] <- grp.label

  ## ---- Apply .fmt() if digits_d specified ----
  # n is a count — always integer regardless of digits_d
  if ("n" %in% names(res))
    res[["n"]] <- .fmt(res[["n"]], d = 0)

  if (!is.null(digits_d)) {
    num_cols <- vapply(res, is.numeric, logical(1))
    num_cols[1] <- FALSE   # don't format the group label column
    if ("n" %in% names(res)) num_cols["n"] <- FALSE  # already done

    res[, num_cols] <- lapply(
      res[, num_cols, drop = FALSE],
      function(col) .fmt(col, d = digits_d)
    )
  }

  ## Convert to character array for output
  tx <- .df_char(res)
  class(tx) <- "out"
  tx
}


# convert a data frame to a character array preserving spacing for class output
# Called from: zzz.R (internal: .vbs_summary_table)
.df_char <- function(df) {
  # Format each column
  formatted <- lapply(df, function(col) {
    if (is.numeric(col)) {
      # Determine max number of decimal places
      decimals <- sapply(col, function(x) {
        if (is.na(x)) return(0)
        parts <- strsplit(format(x, scientific=FALSE), ".", fixed=TRUE)[[1]]
        if (length(parts) == 2) nchar(parts[2]) else 0
      })
      max_dec <- max(decimals, na.rm=TRUE)
      out <- formatC(col, format="f", digits=max_dec)
    } else {
      out <- as.character(col)
    }
    # Make NA values explicit
    out[is.na(col)] <- "NA"
    out
  })

  # Build character data frame
  char_df <- as.data.frame(formatted, stringsAsFactors=FALSE)

  # Compute column widths
  widths <- mapply(function(col, name) {
    vals <- c(name, col)
    max(nchar(vals, type="width"), na.rm=TRUE)
  }, char_df, names(char_df))

  # Pad each column
  padded <- mapply(function(col, w) {
    format(col, width=w, justify="right")
  }, char_df, widths, SIMPLIFY=FALSE)

  # Format headers
  headers <- mapply(function(name, w) format(name, width=w, justify="right"),
                    names(df), widths, USE.NAMES=FALSE)

  # Combine rows
  rows <- do.call(paste, c(padded, sep="  "))
  header_row <- paste(headers, collapse="  ")

  return(c(header_row, rows))
}


# common style parameters passed directly to Chart(), X(), or XY() land
#   in ... and would otherwise be silently ignored: stop with a pointer
#   to style()  --  called from the dots processing of those functions
.style.trap <- function(nms) {

  sty.par <- c("axis_size", "axis_x_size", "axis_y_size",
    "axis_color", "axis_x_color", "axis_y_color", "axis_text_color",
    "lab_size", "lab_x_size", "lab_y_size",
    "lab_color", "lab_x_color", "lab_y_color",
    "main_size", "main_color",
    "panel_fill", "panel_color", "window_fill",
    "grid_color", "grid_lwd", "grid_lty",
    "bar_fill", "bar_color", "pt_fill", "pt_color")

  bad <- intersect(nms, sty.par)
  if (length(bad) > 0) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Parameter  ", bad[1], "  is a style parameter, set with the\n",
      "  style() function before the visualization, where it applies\n",
      "  to all subsequent visualizations until changed\n\n",
      "  e.g.,  style(", bad[1], "=...)\n\n",
      "Enter   style(show=TRUE)  to see all the style parameters\n",
      "Enter   ?style  to view the help file\n\n")
  }
}

.av.Rmd <-
function(nm, dname, fun_call, d) {

  explain <- TRUE
  results <- TRUE

  fncl <- .fun_call.deparse(fun_call) 
  fc <- .rm.arg("Rmd", fncl) 

  if (explain) show <- "" else show <- ", echo=FALSE"

  n.vars <- length(nm)
  n.pred <- n.vars - 1
  Y <- nm[1]
  pred <- character(length=0)
  for (i in 1:n.pred) pred[i] <- nm[i+1]
  X <- xAnd(pred)

  if (n.pred == 2) {
    if (grepl("*", fc, fixed=TRUE)) bet.grp  <- TRUE else bet.grp <- FALSE
    if (grepl("+", fc, fixed=TRUE)) wth.grp  <- TRUE else wth.grp <- FALSE
  }




  tx <- character(length = 0)

  tx[length(tx)+1] <- "---"
  tx[length(tx)+1] <- "output:"
  tx[length(tx)+1] <- "  html_document:"
  tx[length(tx)+1] <- "    fig_height: 4.5"
  tx[length(tx)+1] <- "    fig_width: 5.5"

  tx[length(tx)+1] <- "---"


  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "***"

  v <- packageVersion("lessR")
  tx[length(tx)+1] <- paste(
"_", format(Sys.time(), "%a %b %d, %Y at %H:%M"), " &nbsp; with ",
"lessR version ", v, "_",
sep="")

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "***"



  tx[length(tx)+1] <- paste("# ANOVA of ", Y, sep="")


  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "```{r, echo=FALSE}"
  tx[length(tx)+1] <- "suppressPackageStartupMessages(library(lessR))  # load lessR"
  tx[length(tx)+1] <- "```"


  tx[length(tx)+1] <- paste(
"The purpose of this analysis is the analysis of variance of ",
"values of the variable ", Y, " for different levels of the values ",
"of ", X, ".", 
 sep="")



  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## The Data"

  rdcall <- getOption("read.call")
  if (is.null(rdcall)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
       "To generate a knitr output file, first read the data for this\n",
       "analysis with the lessR function Read.\n\n")
  }

  tx[length(tx)+1] <- "Read the data with the `lessR` function `Read`."
  ref <- .get.arg("ref", rdcall)
  if (ref %in% c("Employee", "Reading", "Cars93", "Jackets", "Learn", "Mach4")) {
    ref  <- paste(ref, "\"", ", format=\"lessR", sep="")
    tx[length(tx)+1] <- paste(
"Here read from a data file included with the `lessR` package.",
sep="")
  }

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
  tx[length(tx)+1] <- paste(dname, " <- ", rdcall, sep="")
  tx[length(tx)+1] <- "```"

  tx[length(tx)+1] <- paste(
"Data from the following variables are available for analysis: ",
"`r xAnd(names(", dname, "))`. ",
sep="")





  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## Analysis of Variance"

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste(
"Obtain the analysis with the `lessR` function `ANOVA`.",
sep="")


  if (n.pred == 1) {
    tx[length(tx)+1] <- paste(
"This is a one-way ANOVA of ", Y, " with treatment factor ", X, ".",
 sep="")
}

  if (n.pred == 2) {
    if (bet.grp)
      tx[length(tx)+1] <- paste(
"This is a two-way between groups ANOVA of ", Y, " with ", 
"treatment factors ", X, ".",
sep="")
    else
      tx[length(tx)+1] <- paste(
"This is a randomized blocks ANOVA of ", Y, " with one treatment ",
"factor, ", pred[1], ", ",
"and one blocking factor, ", pred[2], ".",
 sep="")
}

  locTRUE <- regexec("graphics = TRUE", fc)
  if (locTRUE == -1) {
    loc <- regexec("graphics = FALSE", fc)
    if (loc == -1) fc <- sub(")$", ", graphics = FALSE)", fc)
  }

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
  tx[length(tx)+1] <- paste("a <- ", fc, sep="")
  tx[length(tx)+1] <- "```"

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "### Background"

  if (explain) tx[length(tx)+1] <- paste(
"The output begins with a specification of the variables ",
"in the model and a brief description of the data. ",
sep="")

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"a$out_background" 
    tx[length(tx)+1] <- "```"
  }




  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "### Descriptive Statistics"

    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste(
"For this sample of data, ",
"the first part of the output provides the descriptive statistics ",
"of ", Y, " for ",
"the different levels of ", X,
".",
sep="")

  if (n.pred == 1) {
    tx[length(tx)+1] <- "```{r, echo=FALSE}"
    tx[length(tx)+1] <-"a$out_descriptive" 
    tx[length(tx)+1] <- "```"
  }

  if (n.pred == 2) {

    if (bet.grp) {

      tx[length(tx)+1] <- paste(
"First, the number of data values in each cell. ",
sep="")

      tx[length(tx)+1] <- "```{r, echo=FALSE}"
      tx[length(tx)+1] <-"a$out_cell.n" 
      tx[length(tx)+1] <- "```"

    tx[length(tx)+1] <- paste(
"The mean of cell in the design follows. ",
sep="")

      tx[length(tx)+1] <- "```{r, echo=FALSE}"
      tx[length(tx)+1] <-"a$out_cell.means" 
      tx[length(tx)+1] <- "```"

    }

    tx[length(tx)+1] <- paste(
"The marginal means of each row and column assist in interpreting ",
"any main effects. ",
sep="")

      tx[length(tx)+1] <- "```{r, echo=FALSE}"
      tx[length(tx)+1] <-"a$out_marginals" 
      tx[length(tx)+1] <- "```"

    tx[length(tx)+1] <- paste(
"The mean of all the data, the grand mean, follows. ",
sep="")

      tx[length(tx)+1] <- "```{r, echo=FALSE}"
      tx[length(tx)+1] <-"a$out_gm" 
      tx[length(tx)+1] <- "```"

    tx[length(tx)+1] <- paste(
"Consider also the variation in each cell, assessed by the ",
"standard deviation. ",
sep="")

      tx[length(tx)+1] <- "```{r, echo=FALSE}"
      tx[length(tx)+1] <-"a$out_cell.sd" 
      tx[length(tx)+1] <- "```"

  }





  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "### Summary Table"

  if (explain) tx[length(tx)+1] <- paste("\n",
"The analysis of variance (ANOVA) partitions this total ",
"sum of squares for ", Y, " into the residual variability, ",
"$\\sum e^2_i$, and the ",
"sum of squares for ", X, ". The ANOVA table ",
"displays these sources of variation. ",
sep="")

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"a$out_anova" 
    tx[length(tx)+1] <- "```"
  }


  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "### Effects"

  if (explain) tx[length(tx)+1] <- paste("\n",
"The ANOVA summary table provides the significance test ",
"for ", X, ", in terms of its relationship with ", Y, ". This test ",
"shows if the effect likely exists or not. ",
"Also of interest is the extent of the effect. ",
sep="")

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"a$out_effects" 
    tx[length(tx)+1] <- "```"
  }





  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "### Pairwise Differences"

  if (explain) tx[length(tx)+1] <- paste("\n",
"A significant effect shows if ", X, " impacts ", Y, ". ",
"But do all levels of ", X, " impact ", Y, " or just some? ",
"Answer the question by examining the pairwise comparisons, ",
"adjusted for the overall level of significance. ",
"These tests are the search for Honestly Significant Differences, ",
"HSD.",
sep="")

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"a$out_hsd" 
    tx[length(tx)+1] <- "```"
  }



  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "### Residuals"

  if (explain) tx[length(tx)+1] <- paste("\n",
"ANOVA is a kind of regression analysis. ",
"As such, individual data values can be compared to their predicted ", 
"values, which for ANOVA are the corresponding cell means. ",
"The difference between obtained and predicted is the residual. ",
sep="")

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"a$out_res" 
    tx[length(tx)+1] <- "```"
  }

  return(tx)

}

.reg3txtResidual <-
function(lm.out, cook, digits_d=NULL, res_sort="cooks", n_res_rows=NULL,
         show_R=FALSE) {

  nm <- all.vars(lm.out$terms)  # names of vars in the model
  n.vars <- length(nm)
  n.pred <- n.vars - 1L
  n.keep <- nrow(lm.out$model)
  
  tx <- character(length = 0)

# ----------------------------------------------
# text output

  if (show_R) {
    tx[length(tx)+1] <- .dash2(68)
    tx[length(tx)+1] <- paste("> ", "fitted(model)", sep="", "\n")
    tx[length(tx)+1] <- paste("> ", "resid(model)", sep="", "\n")
    tx[length(tx)+1] <- paste("> ", "rstudent(model)", sep="", "\n")
    tx[length(tx)+1] <- paste("> ", "dffits(model)", sep="", "\n")
    tx[length(tx)+1] <- paste("> ", "cooks.distance(model)", sep="", "\n")
    tx[length(tx)+1] <- .dash2(68)
  }

  tx[length(tx)+1] <- paste("-- Data, Fitted, Residual, Studentized Residual,",
                      "Dffits, Cook's Distance")
  if (res_sort == "cooks")
    tx[length(tx)+1] <- "   [sorted by Cook's Distance]"
  if (res_sort == "rstudent")  
    tx[length(tx)+1] <- "   [sorted by Studentized Residual, ignoring + or - sign]"
  if (res_sort == "dffits")  
    tx[length(tx)+1] <- "   [sorted by dffits, ignoring + or - sign]"
  # resolve "all" to the actual row count
  if (identical(n_res_rows, "all")) n_res_rows <- n.keep
  n_res_rows <- min(as.integer(n_res_rows), n.keep)

  if (n_res_rows < n.keep)
    txt <- "rows of data, or do n_res_rows=\"all\"]"
  else
    txt <- "]"
  tx[length(tx)+1] <- paste("   [n_res_rows = ", n_res_rows, ", out of ", n.keep, " ", txt, sep="")


  fit <- lm.out$fitted.values
  res <- lm.out$residuals
  #cook <- cooks.distance(lm.out)
  
  # text output
  out <- data.frame(fit, res, rstudent(lm.out), dffits(lm.out), cook,
                    stringsAsFactors=TRUE)
  out <- data.frame(lm.out$model[nm[1]], out, stringsAsFactors=TRUE)
  if (n.pred > 0) out <- data.frame(lm.out$model[c(nm[seq(2,n.vars)])], out)

  #out <- data.frame(out)
  names(out)[n.vars+1] <- "fitted"
  names(out)[n.vars+2] <- "resid"
  names(out)[n.vars+3] <- "rstdnt"
  names(out)[n.vars+4] <- "dffits"
  names(out)[n.vars+5] <- "cooks"
  if (res_sort != "off") {
    if (res_sort == "cooks") {
      o <- order(out$cooks, decreasing=TRUE)
      clmn <- 0L
    }
    if (res_sort == "rstudent") {
      o <- order(abs(out$rstdnt), decreasing=TRUE)
      clmn <- 2L
    }
    if (res_sort == "dffits") {
      o <- order(abs(out$dffits), decreasing=TRUE)
      clmn <- 1L
    }
    out <- out[o,]
  }

  tx2 <- .prntbl(out[seq_len(n_res_rows),], digits_d)
  for (i in seq_along(tx2)) tx[length(tx)+1] <- tx2[i]

  num <- min(5L, n_res_rows)
  if (res_sort != "off") {
    label.top <- character(length=num)
    out_top <- numeric(length=num)
    for (i in seq_len(num)) {
      label.top[i] <- rownames(out)[i]
      out_top[i] <- out[i,(ncol(out)-clmn)]
    }
      names(out_top) <- label.top
  }
  else
    out_top <- NA

  return(list(out_residuals=tx, resid.max=out_top))

}

# ----- low-level pretty-printer for data frames / matrices ---------------
# Takes a data frame or matrix, returns a character vector of formatted
# lines — the caller displays with cat(tx, sep="\n").
#
# Handles column-width sizing, multi-row column headers when names are long
# row/column-group boundary lines (`bnd`), row-break ellipsis(`brk`), 
# and correlation-specific tweaks (cors=TRUE: no leading zero, 1.00 → 100).
.prntbl <- function(x, digits_d=2, cut=0, cc="-", cors=FALSE,
                    brk=NULL, bnd=NULL, v1.nm=NULL, v2.nm=NULL,
                    from_efa=FALSE) {

# brk: ... replaces rows not printed
# bnd: boundary between groups

  max.ch <- ifelse (cors, 3, 0)  # max char per column, 0 is not applicable

  # width of column 1
  max.c1 <- 0
  for (i in 1:nrow(x)) {
    c1 <- nchar(rownames(x)[i])
    if (c1 > max.c1) max.c1 <- c1
  }
  if (!is.null(v2.nm)) if (nchar(v2.nm) > max.c1) max.c1 <- nchar(v2.nm)
  max.c1 <- max.c1 + 2

  # widths of variable names
  colnm.w <- integer(length=ncol(x))
  for (i in 1:ncol(x))
    colnm.w[i] <- nchar(colnames(x)[i])

  # width of columns
  max.ln <- integer(length=ncol(x))
  for (j in 1:ncol(x)) {
    if (is.numeric(x[,j])) {
      c.val <- 0
      for (i in 1:nrow(x)) {
        i.val <- nchar(formatC(x[i,j], digits=digits_d, format="f"))
        if (i.val > c.val) c.val <- i.val
      }
    }
    else {
      c.val <- 0
      for (i in 1:nrow(x)) {
        i.val <- nchar(as.character(x[i,j]))
        if (i.val > c.val) c.val <- i.val
      }
    }
    if (!cors)
      max.ln[j] <- max(colnm.w[j], c.val) + 1
    else {
      max.ln[j] <- max(colnm.w[j], 4)
      if (max.ch > 0) max.ln[j] <- max.ch
      if (max.ln[j] > 4) max.ln[j] <- max.ln[j] + 1
    }
    if (max.ln[j] < 4) max.ln[j] <- 4
  }

  tx <- character(length = 0)
  if (!is.null(cc))
    tx[length(tx)+1] <- .dash2(sum(max.ln)+max.c1, cc=cc)

  # matrix for potentially multi-row column names
  if (max.ch > 0) {
    nr.ind.lbl <- integer(length=ncol(x))
    for (i in 1:ncol(x))
      nr.ind.lbl[i] <- ((nchar(colnames(x)[i]) + (max.ch-1)) %/% max.ch)

    nr.lbl <- max(nr.ind.lbl)  # n_row of labels
    col.nm <- matrix(nrow=nr.lbl, ncol=ncol(x))
    for (i in 1:nrow(col.nm)) {
      for (j in 1:ncol(col.nm)) {
        srt <- ((i-1)*max.ch) + 1
        stp <- srt + (max.ch - 1)
        col.nm[i,j] <- substr(colnames(x)[j], srt, stp)
      }
    }
  }
  else {
    nr.lbl <- 1
    col.nm <- matrix(nrow=1, ncol=ncol(x))
    for (j in 1:ncol(col.nm)) col.nm[1,j] <- colnames(x)[j]
  }
  # for each row, shift down value if next row is "", repeat
  if (nr.lbl > 1) {
    for (k in 2:nrow(col.nm)) {  # repeat for each row
      for (i in 2:nrow(col.nm)) {
        for (j in 1:ncol(col.nm)) {
          if (nchar(col.nm[i,j]) == 0) {
            col.nm[i,j] <- col.nm[i-1,j]
            col.nm[i-1,j] <- ""
          }
        }
      }
    }
  }

  blnk <- format("", width=max.c1-1)
  if (!is.null(v1.nm)) tx[length(tx)+1] <- paste(blnk, v1.nm)
  # write col labels
  for (i in 1:nr.lbl) {  # for each row of column labels
    if (is.null(v2.nm))
      tx[length(tx)+1] <- format("", width=max.c1)
    else
      tx[length(tx)+1] <- paste(" ", v2.nm,
           format("", width=max.c1-nchar(v2.nm)-2), sep="")
    for (j in 1:ncol(x)) {
      wd <- max.ln[j]
      tx[length(tx)] <- paste(tx[length(tx)], .fmtc(col.nm[i,j], w=wd), sep="")
      if (!is.null(bnd)) if (j %in% bnd)
        if (i == nr.lbl)
          tx[length(tx)] <- paste(tx[length(tx)], "|", sep="")
        else
          tx[length(tx)] <- paste(tx[length(tx)], " ", sep="")
    }
  }
  if (!is.null(bnd))
    tx[length(tx)+1] <- .dash2(sum(max.ln)+max.c1+length(bnd), cc=" ")

  # factor vars to char vars
  if (is.data.frame(x)) {
    i.col <- sapply(x, is.factor)
    x[i.col] <- lapply(x[i.col], as.character)
  }

  # write values
  for (i in 1:nrow(x)) {
    if (i %in% brk) tx[length(tx)+1] <- "..."
    rwnm <- paste(" ", rownames(x)[i])
    if (is.null(v2.nm))
      tx[length(tx)+1] <- format(rwnm, width=max.c1, justify="right")
    else
      tx[length(tx)+1] <- format(rwnm, width=max.c1-1, justify="right")

    for (j in 1:ncol(x)) {
      if (is.integer(x[i,j]))
        tx[length(tx)] <- paste(tx[length(tx)], .fmti(x[i,j],
                                w=max.ln[j]), sep="")

      else if (is.numeric(x[i,j])) {
        wd <- max.ln[j]
        if (cors) {
          if (max.ln[j] > 5) wd <- max(6, max.ln[j]+1) + 1
          else wd <- max(6, max.ln[j]+1)
          cs <- .fmt(x[i,j], d=digits_d, w=wd)
          cs <- sub("0.", "", cs, fixed=TRUE)
          cs <- sub(" 1.00", "100", cs, fixed=TRUE)
        }
        else
          cs <- .fmt(x[i,j], d=digits_d, w=wd)
        wd2 <- ifelse (!from_efa, wd-2, wd)
        if (abs(x[i,j]) < cut) cs <- paste(rep(" ", wd2), collapse="")
        tx[length(tx)] <- paste(tx[length(tx)], cs, sep="")
        if (!is.null(bnd)) if (j %in% bnd)
          tx[length(tx)] <- paste(tx[length(tx)], "|", sep="")
      }

      else if (is.character(x[i,j]))
        tx[length(tx)] <- paste(tx[length(tx)], .fmtc(x[i,j], w=max.ln[j]),
                                sep="")
    }

    if (!is.null(bnd)) if (i %in% bnd)
      tx[length(tx)+1] <- .dash2(sum(max.ln)+max.c1+length(bnd), cc="-")
  }

  return(tx)

}

.plt.contour <-
function(x, y, contour_n, contour_nbins, contour_points, size.pt,
         theme, scale_x, scale_y, pad_x, pad_y, x.lab, y.lab,
         ellipse, ellipse_color, ellipse_lwd, fit.line, fit_color, fit_lwd,
         axis_x_pre, axis_y_pre, axis_fmt, xlab.adj, ylab.adj,
         legend = FALSE) {

  # save the graphics state ONCE, before filled.contour() does layout()
  old.par <- par(no.readonly = TRUE)
  on.exit({
    # drop read-only params that cause warnings after filled.contour/layout
    ro <- c("cin","cra","csi","cxy","din","page")
    par(old.par[setdiff(names(old.par), ro)])
  }, add = TRUE)

  # -------------------------------------------------------------------------
  # colors
  if (theme %in% c("white", "gray", "light")) {
    clrs <- colorRampPalette(c("white",
      gray.colors(contour_n, rev = TRUE, start = 0.20, end = 0.92)))
  } else {
    sc <- .corcolors()
    clrs <- colorRampPalette(c("white", getColors(sc$fill_hi)))
  }

  # remove missing
  good <- complete.cases(x, y)
  x <- x[good]
  y <- y[good]

  # KDE — extend grid beyond data so contours are not clipped at data edges
  x_ext <- diff(range(x)) * 0.12
  y_ext <- diff(range(y)) * 0.12
  dens <- MASS::kde2d(x, y, n = contour_nbins,
                      lims = c(range(x) + c(-x_ext, x_ext),
                               range(y) + c(-y_ext, y_ext)))
  dz   <- dens$z / sum(dens$z)

  # 95% mass threshold
  z_sorted    <- sort(as.vector(dz), decreasing = TRUE)
  z_cum       <- cumsum(z_sorted)
  z_idx       <- which(z_cum >= 0.95)[1]
  z_threshold <- z_sorted[z_idx]

  # contour-derived ranges
  mask      <- dz >= z_threshold
  x_idx     <- which(apply(mask, 1, any))
  y_idx     <- which(apply(mask, 2, any))
  xlim_cont <- range(dens$x[x_idx])
  ylim_cont <- range(dens$y[y_idx])

  # ellipse-derived ranges
  mu    <- c(mean(x), mean(y))
  Sigma <- cov(cbind(x, y))
  ellipse.pts <- ellipse::ellipse(Sigma, centre = mu, level = 0.95)
  ellipse.trunc <- ellipse.pts[
    ellipse.pts[, 1] >= min(x) & ellipse.pts[, 1] <= max(x) &
      ellipse.pts[, 2] >= min(y) & ellipse.pts[, 2] <= max(y),
  ]

  # full data ranges
  data_xlim <- range(x)
  data_ylim <- range(y)

  # decide x — use union of data range and ellipse/contour range;
  # when the kde grid covers the full data range, use the full grid
  # extent so contours are not clipped
  if ((xlim_cont[1] > data_xlim[1]) || (xlim_cont[2] < data_xlim[2])) {
    if (nrow(ellipse.trunc) > 0)
      x.lim <- range(c(data_xlim, range(ellipse.trunc[, 1])))
    else
      x.lim <- data_xlim
  } else {
    x.lim <- range(dens$x)
  }

  # decide y
  if ((ylim_cont[1] > data_ylim[1]) || (ylim_cont[2] < data_ylim[2])) {
    if (nrow(ellipse.trunc) > 0)
      y.lim <- range(c(data_ylim, range(ellipse.trunc[, 2])))
    else
      y.lim <- data_ylim
  } else {
    y.lim <- range(dens$y)
  }

  # axis limits + ticks
  if (is.null(scale_x)) {
    x.marginL <- diff(x.lim) * pad_x[1]
    x.marginR <- diff(x.lim) * pad_x[2]
    x.lim     <- x.lim + c(-x.marginL, x.marginR)
    axT1      <- pretty(x.lim, eps.correct = 0)
  } else {
    x.lim <- scale_x[1:2]
    axT1  <- axTicks(1, axp = scale_x)
  }
  lbl.x <- .axis.format(axT1, axis_fmt, axis_x_pre, axis_y_pre = "no")

  if (is.null(scale_y)) {
    y.marginL <- diff(y.lim) * pad_y[1]
    y.marginR <- diff(y.lim) * pad_y[2]
    y.lim     <- y.lim + c(-y.marginL, y.marginR)
    ayT2      <- pretty(y.lim, eps.correct = 0)
  } else {
    y.lim <- scale_y[1:2]
    ayT2  <- axTicks(2, axp = scale_y)
  }
  lbl.y <- .axis.format(ayT2, axis_fmt, axis_x_pre = "no", axis_y_pre)

  # -------------------------------------------------------------------------
  # plot
  ax <- .axes_dim()

  # buffer for y label
  ticks <- ayT2[ayT2 >= y.lim[1] & ayT2 <= y.lim[2]]
  if (length(ticks) == 0) ticks <- ayT2  # fallback: avoid max(integer(0))
  ticks <- .axis.format(ticks, axis_fmt, axis_x_pre = "no", axis_y_pre)
  mnv   <- max(nchar(ticks))
  buf.y <- -0.8 + 0.32 * mnv

  if (contour_points) {
    x.lim[2] <- x.lim[2] + .015 * diff(x.lim)
    y.lim[2] <- y.lim[2] + .015 * diff(y.lim)
  }

  # shared: axes, labels, and data overlays (used by both branches)
  .draw_overlays <- function() {
    par(mgp = c(3.5, .5, 0), tcl = -.28)
    axis(1, at = axT1, labels = lbl.x,
         cex.axis = ax$axis_x_size * 1.1,
         col.axis = ax$axis_x_text_color)
    axis(2, at = ayT2, labels = lbl.y, las = 1,
         cex.axis = ax$axis_y_size * 1.1,
         col.axis = ax$axis_y_text_color)
    lab.cex <- getOption("lab_size") * 1.2
    title(xlab = x.lab, line = 2.3 + xlab.adj, cex.lab = lab.cex)
    title(ylab = y.lab, line = 3.5 + ylab.adj + buf.y, cex.lab = lab.cex)
    if (contour_points) {
      point.args <- list(pch = 21, cex = size.pt,
                         bg = "#00000044", col = "white", lwd = .2)
      do.call(points, c(list(x = x, y = y), point.args))
    }
    if (ellipse[1] > 0) {
      for (j in seq_along(ellipse)) {
        e <- ellipse::ellipse(Sigma, centre = mu,
                              level = ellipse[j], npoints = 100)
        lines(e, col = ellipse_color, lwd = ellipse_lwd)
      }
    }
    if (fit.line != "off") {
      pf <- .plt.fit(x, y, fit.line = fit.line, fit_power = 0,
                     fit_new = NULL, sz.lv = length(x))
      lines(pf$x.lv, pf$f.ln, col = fit_color, lwd = fit_lwd)
    }
  }

  if (legend) {
    filled.contour(
      dens$x, dens$y, dens$z,
      xlim = x.lim, ylim = y.lim,
      nlevels = contour_n,
      color.palette = clrs,
      plot.axes = .draw_overlays(),
      key.axes  = axis(4, cex.axis = ax$axis_y_size * 1.1)
    )
  } else {
    lv <- seq(min(dens$z), max(dens$z), length.out = contour_n + 1)
    par(mar = c(4.0, 4 + buf.y, 1.2, 0.4))
    plot.new()
    plot.window(xlim = x.lim, ylim = y.lim)
    .filled.contour(dens$x, dens$y, dens$z,
                    levels = lv, col = clrs(contour_n))
    .draw_overlays()
    box()
  }

  # on.exit() will restore the sane par() for us
}

.plt.add <- 
function(add, x1, x2, y1, y2,
         add_size, add_lwd, add_lty, add_color, add_fill, add_trans, ...) { 

  n.obj <- length(add)
  n.clr <- length(add_color)
  n.fll <- length(add_fill)
  n.lty <- length(add_lty)
  n.lwd <- length(add_lwd)
  n.cex <- length(add_size)
  n.trn <- length(add_trans)
  i.clr <- 0;  i.fll <- 0;  i.lty <- 0;  i.lwd <- 0;  i.cex <- 0;  i.trn <- 0
  x1i <- 0;  x2i <- 0;  y1i <- 0;  y2i <- 0;  # coordinate indexes

  usr <- par("usr") 

  for (i in 1:n.obj) {

    i.clr <- i.clr + 1;  if (i.clr > n.clr) i.clr <- 1
    i.fll <- i.fll + 1;  if (i.fll > n.fll) i.fll <- 1
    i.lty <- i.lty + 1;  if (i.lty > n.lty) i.lty <- 1
    i.lwd <- i.lwd + 1;  if (i.lwd > n.lwd) i.lwd <- 1
    i.cex <- i.cex + 1;  if (i.cex > n.cex) i.cex <- 1
    i.trn <- i.trn + 1;  if (i.trn > n.trn) i.trn <- 1

    # if specified, add transparency to a color
    if (add_trans[i.trn] > 0) {  # fill only
      if (add[i] %in% c("rect", "point"))
        add_fill[i.fll] <- .maketrans(add_fill[i.fll], (1-add_trans[i.trn])*256)
    }

    geom <- c("rect", "line", "v_line", "h_line", "arrow", "point") 
    if (!(add[i] %in% geom)) {  # text
      if (n.obj == 1) {
        xx <- x1; yy <- y1  # same object, multiple locations
      }  
      else {
        x1i <- x1i + 1;  y1i <- y1i + 1
        xx <- x1[x1i];  yy <- y1[y1i]  # multiple objects, multiple locations
      }
      text(xx, yy, labels=add[i], cex=add_size[i.cex], col=add_color[i.clr], ...)
    }

    else if (add[i] == "v_line") {
      if (n.obj == 1)
        xx <- x1  # same object, mult locations 
      else {
        x1i <- x1i + 1
        xx <- x1[x1i]  # multiple objects, multiple locations
      }
      segments(xx, usr[3], xx, usr[4], col=add_color[i.clr],
               lwd=add_lwd[i.lwd], lty=add_lty[i.lty], ...)
    }

    else if (add[i] == "h_line") {
      y1i <- y1i + 1
      yy <- y1[y1i]  # multiple objects, multiple locations
      if (n.obj == 1) yy <- y1  # same object, multiple locations
      segments(usr[1], yy, usr[2], yy, col=add_color[i.clr],
               lwd=add_lwd[i.lwd], lty=add_lty[i.lty], ...)
    }

    else if (add[i] %in% c("line", "rect", "arrow")) {  # 4 coordinates
      if (n.obj == 1) {
        xx1 <- x1;  yy1 <- y1;  xx2 <- x2;  yy2 <- y2;
      } 
      else {
        x1i <- x1i + 1;  x2i <- x2i + 1;  y1i <- y1i + 1;  y2i <- y2i + 1
        xx1 <- x1[x1i];  xx2 <- x2[x2i];  yy1 <- y1[y1i];  yy2 <- y2[y2i]
      }
      if (add[i] == "line")
        segments(xx1, yy1, xx2, yy2, col=add_color[i.clr],
                 lwd=add_lwd[i.lwd], lty=add_lty[i.lty], ...)
      if (add[i] == "rect")
        rect(xx1, yy1, xx2, yy2, border=add_color[i.clr], col=add_fill[i.fll],
             lwd=add_lwd[i.lwd], lty=add_lty[i.lty], ...)
      if (add[i] == "arrow")
        arrows(xx1, yy1, xx2, yy2, col=add_color[i.clr], 
             lwd=add_lwd[i.lwd], lty=add_lty[i.lty], ...)
    }

    else if (add[i] %in% c("point")) {  # 2 coordinates
      if (n.obj == 1) {
        xx1 <- x1;  yy1 <- y1;
      } 
      else {
        x1i <- x1i + 1; y1i <- y1i + 1;
        xx1 <- x1[x1i]; yy1 <- y1[y1i];
      }
      points(xx1, yy1, col=add_color[i.clr], bg=add_fill[i.fll],
                       cex=add_size[i.cex], pch=21)
    }

  }  # end i in 1:n.obj

} 

factors <-
function (x, levels, labels=NULL, data=d, ordered=FALSE,
          new=FALSE, suffix="_f", var_labels=FALSE, ...) {

  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (!is.null(dots)) if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] %in% c("var.labels")) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
      }
    }
  }

  if (var_labels) new <- TRUE
  if (missing(levels) && var_labels) levels <- NULL
  if (is.null(labels)) labels <- as.character(levels)

  # get ind, the indices of selected variables in the data frame
  data.vars <- as.list(seq_along(data))
  names(data.vars) <- names(data)
  ind <- eval(substitute(x), envir=data.vars, parent.frame())

  n_col <- ncol(data)
  n_row <- nrow(data)

  # create new variables for factor versions
  if (new) {
    n.add <- length(ind)

    # get old names + new names
    new.names <- paste(names(data)[ind], suffix, sep="")
    all.names <- c(names(data), new.names)

    if (!var_labels) { # do the conversion to factors
      # get old df + new df
      new.mat <- matrix(nrow=nrow(data), ncol=n.add)
      data <- cbind(data, new.mat)
      names(data) <- all.names

      # convert
      new.i.start <- n_col + 1
      new.i.end <- n_col + n.add
      data[, new.i.start:new.i.end] <-
      lapply(data[, ind, drop=FALSE], factor,
             levels=levels, labels=labels, ordered=ordered)
    }
  }  # end new

  # replace existing values
  else {
    if (!var_labels) {
      data[, ind] <-
        lapply(data[, ind, drop=FALSE], factor,
               levels=levels, labels=labels, ordered=ordered)
    }
  }  # end replace existing


  # copy the variable labels to the newly created .f vars
  if (var_labels) {

    l.name <- "l"
    if (exists(l.name, where=.GlobalEnv)) {
      l <- get(l.name, pos=.GlobalEnv)
    }
    else {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
                      "No l data frame available.\n\n")
    }

    nm.vars <- names(data)[ind]
    new.lbls <- l[nm.vars, , drop=FALSE]  # drop=FALSE prevents matrix→vector collapse

    new.mat2 <- data.frame(matrix(nrow=n.add, ncol=1), stringsAsFactors=FALSE)
    names(new.mat2) <- "label"

    row.start <- n_col + 1
    row.end <- n_col + n.add
    rownames(new.mat2)[seq_len(n.add)] <- all.names[(row.start):(row.end)]
    new.mat2[, 1] <- if (length(dim(new.lbls)) >= 2) new.lbls[, 1] else as.character(new.lbls)
    new.labels <- rbind(l, new.mat2)
  }

  if (!var_labels)
    return(data)
  else
    return(new.labels)

}

# convert numbers 1 through 12 to words
# round off to integer larger values
xNum <- function(x) {
 
  x <- as.integer(round(x,0))

       if (x == 0) num.c <- "none"
  else if (x == 1) num.c <- "one"
  else if (x == 2) num.c <- "two"
  else if (x == 3) num.c <- "three"
  else if (x == 4) num.c <- "four"
  else if (x == 5) num.c <- "five"
  else if (x == 6) num.c <- "six"
  else if (x == 7) num.c <- "seven"
  else if (x == 8) num.c <- "eight"
  else if (x == 9) num.c <- "nine"
  else if (x == 10) num.c <- "ten"
  else if (x == 11) num.c <- "eleven"
  else if (x == 12) num.c <- "twelve"
  else num.c <- .fmti(x)

  return(num.c)
}

.plt.mat <-
function(x, cor.coef=TRUE, fit="loess",
         col_fill=getOption("pt_fill"), col_color=getOption("pt_color"),
         col.fit=getOption("fit_color"), col.bg=getOption("panel_fill"),
         col.box=getOption("panel_color"),
         col_trans=getOption("trans_pt_fill"),
         pt.size=pt.size, size.miss=size.miss) {


  panel.smooth <- function(x, y, fit.line=fit, pch=par("pch"), cex=.76,
    col.pt=col_color, col.smooth=col.fit, span=2/3, iter=3, ...) {

    my.usr <- par("usr")          
    rect(my.usr[1], my.usr[3], my.usr[2], my.usr[4], col=col.bg, border=col.box)
    cex.adj <- ifelse(size.miss, 0.80 - 0.048*n.var, pt.size)
    points(x, y, pch=21, col=col.pt, bg=col_fill, cex=cex.adj)

    ok <- is.finite(x) & is.finite(y)
    if (any(ok)) {
      if (fit.line %in% c("loess", "lm")) {
        yo <- order(x[ok])  # need to order x, then have y follow
        x[ok] <- sort(x[ok])
        y[ok] <- y[ok][yo]
        if (fit.line == "loess") {
          l.ln <- loess(y[ok] ~ x[ok])
          lines(lowess(x[ok], y[ok], f=span, iter=iter), col=col.smooth, ...)
        }
        else if (fit.line == "lm") {
          l.ln <- lm(y[ok] ~ x[ok])
          lines(x[ok], fitted(l.ln), col=col.smooth, ...)
        }
        f.ln <- fitted(l.ln, ...)
        p.ln <- predict(l.ln, se=TRUE) # get standard errors
        prb <- (1 - 0.95) / 2 # 0.95 confidence level
        up.ln <- f.ln + (qt(prb,length(x[ok])-1) * p.ln$se.fit)
        dn.ln <- f.ln - (qt(prb,length(x[ok])-1) * p.ln$se.fit)
        polygon(c(x[ok], rev(x[ok])), c(dn.ln, rev(up.ln)),
          col=getOption("se_fill"), border="transparent") #
      }
    }
  }


  panel.cor <- function(x, y, ...) {
    my.usr <- par("usr"); on.exit(par(usr = my.usr))
    rect(my.usr[1], my.usr[3], my.usr[2], my.usr[4], col=col.bg, border=col.box)
    par(usr=c(0, 1, 0, 1))
    r <- cor(x, y)
    txt <- .fmt(r, 2)
    # maybe use par("fin")[1] / n.var to get size of each cell
    cex.adj <- 1.6 - (0.065*n.var)  # adjust size of displayed r   # 1.274
    text(0.5, 0.5, txt, cex=cex.adj, col="black")  # or cex=cex.cor * r
  }


  text.diag <- function(x, y, nm, ...) {  # nm from calling routine
    my.usr <- par("usr")          
    rect(my.usr[1], my.usr[3], my.usr[2], my.usr[4], col=getOption("se_fill"),
         border=col.box)
    cex.adj <- 1.6 - (0.065*n.var)  # adjust size of displayed var name
    text(0.5, 0.5, nm, cex=cex.adj, col=getOption("lab_color"))
  }

  # -----
  # begin

  if (is.logical(fit)) if (fit) fit <- "loess"

  if (getOption("sub_theme") == "black")
     col_color <- getOption("lab_color")

  n.var <- ncol(x)

  par(bg=getOption("window_fill"))

  if (!is.null(col_trans))
    col_fill <- .maketrans(col_fill, (1-col_trans)*256)

  if (cor.coef)  # no missing data
    pairs(na.omit(x), lower.panel=panel.smooth, upper.panel=panel.cor,
      text.panel=text.diag)
  else
    pairs(na.omit(x), panel=panel.smooth, text.panel=text.diag)

}

.mimm <- function(R, LblCut, NVC, NF, Iter) {

      NItems <- NVC

  # Compute item-factor and fac-fac covariances by calculating sums.
  #   First calculate the item-fac covariances in I <- 1..NItems by summing
  #   within-cluster columns. Once these are computed, calculate the
  #   factor-factor covariances in I <- NItems+1..NF part of first loop by
  #   applying the same formula to the recently computed item-factor
  #   covariances.

  # R[L,I): at this point these are covariances, not correlations.
  # L: ordinal position of the Jth fac in the list of items and factors.

      for (I in 1:(NItems+NF)) {
        for (J in 1:NF) {
          L <- NItems + J
          R[I,L] <- 0.0
          for (K in LblCut[J,1]:LblCut[J,2])
            R[I,L] <- R[I,L] + R[I,K]
          R[L,I] <- R[I,L]
        }
      }

  # Compute coefficient alpha for each group.
  # N: Number of items in the Jth group.
  # R[L,L): Jth factor variance, computed in previous paragraph.
  # DSum: sum of the diagonal of the Jth group.
  # RMean: mean of the off-diagonal correlations of Jth group.
      
      Alpha <- numeric(length=NF)

      for (J in 1:NF) {
        L <- NItems + J
        N <- LblCut[J,2] - LblCut[J,1] + 1
        if (N == 1)
          Alpha[J] <- 1.0
        else {
          DSum <- 0.0
          for (I in LblCut[J,1]:LblCut[J,2]) {
            DSum <- DSum + R[I,I]
          }
          XN <- as.numeric(N)
          RMean <- (R[L,L]-DSum) / (XN*(XN-1.0))
          Alpha[J] <- (XN*RMean) / ((XN-1)*RMean+1.0)
        }
      }

  # Compute communalities of the Jth group by iterating.
  # Iter: Number of iterations.
  # OldFF: Factor variance at the beginning of current iteration.
  # OldII: Communality at the beginning of current iteration.

      if (Iter >= 0) {

        for (J in 1:NF) {
          if (Alpha[J] > 0) {
            for (It in 1:Iter) {
              L <- NItems + J
              OldFF <- R[L,L]
              R[L,L] <- 0.0
              for (I in LblCut[J,1]:LblCut[J,2]) {
                OldII <- R[I,I]
                R[I,I] <- R[I,L]**2 / OldFF
                R[I,L] <- R[I,L] + (R[I,I] - OldII)
                R[L,L] <- R[L,L] + R[I,L]
              }
            }
          }
        }

      }

  # Standardize the item-factor and factor-factor covariances.
  # Since the items are already standardized, item-factor covariances are
  #   standardized by dividing by FacSD. This is accomplished in a loop
  #   as well as beginning the standardization of the factor-factor
  #   covariances.  The second division by the remaining FacSD for the
  #   factor-factor covariances is accomplished in a following loop.

      for (J in 1:NF) {
        L <- NItems + J
        FacSD <- sqrt(R[L,L])
        for (I in 1:L) {
          R[I,L] <- R[I,L] / FacSD
          R[L,I] <- R[I,L]
        }
        for (I in J:NF) {
          LI <- NItems + I
          R[L,LI] <- R[L,LI] / FacSD
          R[LI,L] <- R[L,LI]
        }
      }

  # Compute the Joreskog (1971) reliability coef, which is Omega.
  # Omega uses each items communality as a reliability estimate.
  # Alpha assumes equal item reliabilities.

      Omega <- numeric(length=NF)
      for (IFac in 1:NF) {
        FI <- NItems + IFac
        SumLam <- 0
        SumUnq <- 0
        for (J in LblCut[IFac,1]:LblCut[IFac,2]) {
          Lam <- R[FI,J]
          Unique <- 1 - Lam**2
          SumLam <- SumLam + Lam
          SumUnq <- SumUnq + Unique
        }
        Omega[IFac] <- (SumLam**2) / (SumLam**2 + SumUnq)
        if (Iter == 0) Omega[IFac] <- 1.0
      }

  return(list(R=R, Alpha=Alpha, Omega=Omega))

}

reshape_long <-
  function(data, transform, group="Group", response="Response", ID="ID",
           prefix=ID, sep="", shape=c("rect", "square"), reverse_y=NULL) {
 
  shape <- match.arg(shape)
  group.miss <- missing(group)
 
  # if a tibble, convert to data frame
  df.name <- deparse(substitute(data))  # is NULL if from shiny
  if (exists(df.name, envir=parent.frame())) {
    if (any(grepl("tbl", class(data), fixed=TRUE)))
      data <- data.frame(data)
  }

  if (shape == "rect") {
    if (is.null(ID)) ID <- "xxQ7q"

    data.vars <- as.list(seq_along(data))
    names(data.vars) <- names(data)
    ind <- eval(substitute(transform), envir=data.vars, parent.frame())
    # ind is integer when transform is a range (e.g. sup1:sup4) because data.vars
    # maps names to column positions; but a literal character vector passes through
    # eval() unchanged, so use it directly rather than subscripting names(data) by name
    if (is.character(ind))
      trns <- ind
    else
      trns <- names(data)[ind]

    dl <- reshape(data, direction="long", idvar=ID,
                    timevar=group, varying=trns,
                    v.names=response, times=trns)

    row.names(dl) <- seq_len(nrow(dl))

    if (ID == "xxQ7q")
      dl[,"xxQ7q"] <- NULL
    else {
      if (!is.null(prefix)) {
        ind <- which(names(dl) == ID)
        sp <- sep
        dl[,ind] <- paste(prefix, sp, dl[,ind], sep="") 
        # reorder with ID var first
        old.ind <- seq_len(ncol(dl))
        new.ind <- setdiff(old.ind, ind)
        new.ind <- c(ind, new.ind) 
        dl <- dl[,new.ind]
      }
    }
  }

  else { # shape is "square"

    var1 <- ifelse (group.miss, "Row", paste(group, 1, sep=""))
    var2 <- ifelse (group.miss, "Col", paste(group, 2, sep=""))

    dl <- as.data.frame(as.table(data))
    names(dl) <- c(var1, var2, response)

    # factor levels preserve original matrix order
    dl[,2] <- factor(dl[,2], levels = colnames(data))

    # reverse_y: reverse row-factor levels so the first row appears at the top
    # of a y-axis (which runs bottom-to-top). Defaults TRUE for square shape
    # because the primary use-case is a heat map, but can be set to FALSE.
    if (is.null(reverse_y)) {
      reverse_y <- TRUE
      message("reshape_long: for shape=\"square\", row levels are reversed by ",
              "default so the first row appears at the top of a heat map y-axis.\n",
              "  Set reverse_y=FALSE to keep the original row order.")
    }
    if (reverse_y)
      dl[,1] <- factor(dl[,1], levels = rev(rownames(data)))
    else
      dl[,1] <- factor(dl[,1], levels = rownames(data))
  }

  return(dl)

}

pivot <-
function(data, compute, variable, by=NULL, by_cols=NULL, filter=NULL,
         show_n=TRUE, na_by_show=TRUE, na_group_show=TRUE, na_remove=TRUE,
         out_names=NULL, sort=NULL, sort_var=NULL,  
         table_prop=c("none", "all", "row", "col"), table_long=NULL,
         factors=TRUE, q_num=4, digits_d=NULL, quiet=getOption("quiet")) {

  # -----------------------------------------------------------
  # ---- preliminaries

  table_prop <- match.arg(table_prop)

  by.miss <- missing(by)
  if (missing(variable)) {  # variable not present as a parameter value
    by.expr <- substitute(by)

    if (is.call(by.expr) && identical(by.expr[[1]], as.name("c"))) { # by=c(...)
      by.vars <- as.list(by.expr)[-1L]
      if (length(by.vars) == 1) {  # c(X) is identical to bare X
        table_long <- FALSE
        variable <- deparse(by.vars[[1]])
        by <- NULL
      } else {
        variable <- deparse(by.vars[[1]])
        by <- as.call(c(as.name("c"), by.vars[-1]))
        if (is.null(table_long)) table_long <- TRUE
      }
    }
    else {  # by is a single name
      table_long <- FALSE
      variable <- deparse(by.expr)
      by <- NULL
    }
    by.miss <- is.null(by)
  }

  else {  # variable is present as a parameter value
    var.nm <- deparse(substitute(variable))
    if (substr(var.nm, 1,2) != "c("  &&  !grepl(":", var.nm)) {  # only do 1 var
      if (!is.numeric(data[[var.nm]])) {
        stop("The variable to aggregate (pivot) must now be numeric.\n\n",
             "All categorical variables such as ", var.nm, " now should be\n",
             "  specified as part of parameter by: by=", var.nm,"\n",
             "If there is no numeric variable to aggregate, then ignore.\n\n")
      }
    }
  }

  if (is.null(table_long)) table_long <- TRUE

  # define functions
  # length(x) is count_n(x) + count_NA(x)
  count_n <- function(x) sum(!is.na(x))
  count_NA <- function(x) sum(is.na(x))
 
  # if a tibble, convert to data frame
  if (any(grepl("tbl", class(data), fixed=TRUE)))
    data <- data.frame(data)

  # subset any specified rows of input data frame
  if (!missing(filter)) {  # subset rows
    r <- eval(substitute(filter), envir=data, enclos=parent.frame())
    r <- r & !is.na(r)  # set missing for a row to FALSE
    if (!any(r)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "No rows of data with the specified value of\n",
        "filter = ", deparse(substitute(filter)), "\n\n")
    }
    data <- data[r,,drop=FALSE]
  }

  # -----------------------------------------------------------
  # ---- identify the compute functions, variables, and by variables

  # -----------------
  # compute functions

  # value of compute must be a recognized object, such as a function
  # cmpt.vc <- eval(parse(text=nm.cmp))  # access functions from their names
  raw.cmp <- deparse(substitute(compute))  # recognized as class function
  n.cmp <- length(compute)  # n of compute functions, not including quantile

  if (n.cmp == 1)
    nm.cmpt <- raw.cmp
  else {
    raw.cmp <- substr(raw.cmp, 3, nchar(raw.cmp)-1)  # remove "c(", ")"
    nm.cmpt <- unlist(strsplit(raw.cmp, ",", fixed=TRUE))  # get each function
    nm.cmpt <- gsub(" ", "", nm.cmpt, fixed=TRUE)  # remove spaces
  }

  qflag <- FALSE
  if ("quantile" %in% nm.cmpt) {  # remove and process quantile separately
    qflag <- TRUE
    n.cmp <- n.cmp - 1
    if (n.cmp > 0) {
      ipos <- which(nm.cmpt %in% "quantile")
      nm.cmpt <- nm.cmpt[-ipos]  # remove from name list
      compute <- compute[-ipos]  # remove from function list
    }
  }

  tflag <- FALSE
  to_tabu <- FALSE
  if ("table" %in% nm.cmpt) {  # remove and process table separately
    if (!table_long) {
      tflag <- TRUE
      n.cmp <- n.cmp - 1
      if (n.cmp > 0) {
        ipos <- which(nm.cmpt %in% "table")
        nm.cmpt <- nm.cmpt[-ipos]  # remove from name list
        compute <- compute[-ipos]  # remove from function list
      }
    }
    else {
      to_tabu <- TRUE
      nm.cmpt <- "tabulate"  # retain  tabulate  when table_long
      n.cmp <- 1
    }
  }

  # abbreviation dictionary for function names, first 13 require numeric var
  fun.vec <- c("sum", "mean", "mdn", "min", "max", "sd", "var", "IQR", "mad",
               "", "", "skew", "kurt", "tbl", "tbl")
  names(fun.vec) <- c("sum", "mean", "median", "min", "max",
                      "sd", "var", "IQR", "mad", "range", "quantile",
                      "skew", "kurtosis", "table", "tabulate")
  user_def <- logical(length=length(nm.cmpt)) 
  for (i in seq_along(user_def)) {
    if (!(nm.cmpt[i] %in% names(fun.vec))) {
      user_def[i] <- TRUE 
      if (!quiet) cat("User defined function (or typing error):", nm.cmpt[i],
                      "\n\n")
    }
  }

  # ---------
  # variables

  data.vars <- as.list(seq_along(data))
  names(data.vars) <- names(data)

  # get index of variable(s)
  # if variable is a variable that contains the name instead of the
  #  name directly, then ind.var.d is not the index but the name, 
  # which is then assessed on the data frame to identify its column, index
  ind.var.d <- eval(substitute(variable), envir=data.vars, parent.frame())
  if (!is.numeric(ind.var.d))  # ind.var.d is a var name, not a col index
    ind.var.d <- which(names(data) == ind.var.d)
  n.var <- length(ind.var.d)  # n of variables
  nm.var.d <- names(data)[ind.var.d]
  if (n.var == 1 && is.factor(data[,nm.var.d]))  # factors listed first can crash analysis
    data[,nm.var.d] <- as.character(data[,nm.var.d])
  if (is.null(out_names)) {
    out_names <- character(length=length(nm.cmpt) * length(nm.var.d))
    k <- 0
    for (i in seq_along(nm.cmpt)) {  # for each function
      for (j in seq_along(nm.var.d)) {  # for each var to aggregate
        k <- k + 1
          if (!user_def[i]) 
            out_names[k] <- paste(nm.var.d[j], "_", fun.vec[nm.cmpt[i]], sep="")
          else
            out_names[k] <- paste(nm.var.d[j], "_", nm.cmpt[i], sep="")
      }
    }
  }  # end is.null out_names

  # ------- 
  # by vars

  if (!by.miss || nm.cmpt[1] == "tabulate") {
    # get indices of by variable(s)
    x <- str2lang(deparse(substitute(by)))  # char string to type calls
    ind.r.by <- eval(substitute(x), envir=data.vars, parent.frame())
    if (!is.numeric(ind.r.by))
      ind.r.by <- which(names(data) == ind.r.by)
    nm.row.by <- names(data)[ind.r.by]

    if (by.miss)
      ind.r.by <- ind.var.d  # for tabulate, do not have variables

    # save original variable types of by vars because aggregate makes factors
    n.r.by <- length(ind.r.by)
    cls <- character(length=n.r.by)
    for (i in seq_len(n.r.by)) cls[i] <- class(data[,ind.r.by[i]])

    # get indices of by_cols variable(s)
    if (!missing(by_cols)) {
      x <- str2lang(deparse(substitute(by_cols)))  # char string to type calls
      ind.c.by <- eval(substitute(x), envir=data.vars, parent.frame())
      n.c.by <- length(ind.c.by)
      nm.col.by <- names(data)[ind.c.by]
    }
    else {
      ind.c.by <- NULL
      n.c.by <- 0
    }

    # collapse by variables to a single by for aggregation into long form
    n.by <- n.r.by + n.c.by
    ind.by <- c(ind.r.by, ind.c.by)

    # convert by variables to factors
    exc <- if (na_group_show) "" else NA
    if (n.by > 1) {
      data[, ind.by] <- lapply(data[, ind.by], factor, exclude=exc)
      by.vars <- as.list(data[, ind.by])
    }
    else {
      data[, ind.by] <- factor(data[, ind.by], exclude=exc)
      by.vars <- list(data[, ind.by])
      names(by.vars) <- names(data)[ind.r.by]
    }
    if (to_tabu)  # append the pivot variable for table() over the by vars
      ind.by <- c(ind.by, ind.var.d)
  }  # end by is specified or tabulate

  else {
    n.by <- 0
    n.c.by <- 0
  }

  # ------------
  # Not Possible

  if (n.c.by > 0) {
    if (n.cmp > 1)  {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Cannot have more than 1 compute function for making a table.\n\n")
    }
    if (n.var > 1)  {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Cannot have more than 1 variable to aggregate for making a table.\n\n")
    }
  }

  num.cmpt <- nm.cmpt %in% names(fun.vec)[seq_len(13)]
  are.num <- logical(length(ind.var.d))
  for (i in seq_along(ind.var.d))
    if (is.numeric(data[,ind.var.d[i]])) are.num[i] <- TRUE
  if (!all(are.num) && any(num.cmpt))  {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specified computations: ", nm.cmpt, "\n",
      "Not all specified variables are numeric: ", nm.var.d, "\n\n")
  }
  if (tflag && n.cmp > 0 && by.miss)  {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Cannot have more than one statistic specified\n",
      "  when computing a frequency table over all the data.\n\n")
  }
  if (tflag && n.c.by>0)  {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Cannot specify a  by_cols  parameter value, ", nm.col.by, ",\n",
      "  when using table to compute a frequency table. The values\n",
      "  of the variable listed first goes across the columns.\n\n")
  }
  if (tflag && n.var > 1)  {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Cannot have more than one variable to aggregate\n",
      "  when computing a frequency table.\n\n")
  }
  if (n.c.by > 2)  {
    nms.c <- ""
    for (i in seq_len(n.c.by)) nms.c <- paste(nms.c, names(data)[ind.c.by[i]])
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specified column  by  variables: ", nms.c, "\n",
      "Only two column  by  variables permitted\n\n")
  }
  if (n.var > 1 && n.cmp > 1 && n.by > 0)  {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Cannot have multiple compute functions, multiple variables, \n",
      "  and do aggregation with a by variable. Choose two of the three\n\n")
  }
  if (!is.null(sort)) {
    if (!(sort %in% c( "+", "-"))) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Parameter  sort  can only be \"+\" or \"-\"\n\n")
    }
  }


  # -------------------------------------------
  # ------- no aggregation, all the data ------

  # if table over all the data, then a single freq dist
  if (by.miss && nm.cmpt[1] == "table") {
    exc <- if (na_group_show) "ifany" else "no"
    tbl <- table(data[,ind.var.d], useNA=exc)
    a <- data.frame(tbl)
    names(a)[1] <- nm.var.d[1]
    names(a)[which(names(a) == "Freq")] <- "n"
    prp <- a$n / sum(tbl)
    a$Prop <- .decdig(prp, digits_d)
    return(a) 
  }

  if (by.miss && nm.cmpt[1] != "tabulate") {
    a <- NULL
    out <- double(length=n.cmp)
    if (n.cmp > 0) {
      # one of compute or variable, output same format as with by vars, 1-line

      if (!(n.cmp>1 && n.var>1)) {
        for (i in seq_len(n.var)) {
          n <- count_n(data[,nm.var.d[i]])
          na <- count_NA(data[,nm.var.d[i]])
          for (j in seq_len(n.cmp)) {
            txt <- paste("data[,", ind.var.d[i], "], na.rm=na_remove", sep="")
            f.call <- paste(nm.cmpt[j], "(", txt, ")", sep="")
            out[j] <- eval(parse(text=f.call))  # evaluate compute function
            a.l <- length(a)
            if (j==1) {  # first (possibly only) compute function
                a <- c(a, n, na, out[j])
                names(a)[a.l+1] <- paste(nm.var.d[i], "_n" ,sep="")
                names(a)[a.l+2] <- paste(nm.var.d[i], "_na", sep="")
                names(a)[a.l+3] <- out_names[i]
            }
            else {  # j > 1, so multiple compute functions
              a <- c(a, out[j])
              names(a)[a.l+1] <- out_names[j]
            }
          }  # end j
        }  # end i

        a <- as.matrix(a)  # turn vector a into a data frame
        a <- data.frame(t(a))
        row.names(a)[1] <- ""
      }  # end just one of compute or variables

      # do both multiple computes and multiple variables with tabular format
      else {  
        for (i in seq_len(n.var)) {
          n <- count_n(data[,nm.var.d[i]])
          na <- count_NA(data[,nm.var.d[i]])
          txt <- paste("data[,", ind.var.d[i], "], na.rm=na_remove", sep="")
          for (j in seq_len(n.cmp)) {
            f.call <- paste(nm.cmpt[j], "(", txt, ")", sep="")
            out[j] <- eval(parse(text=f.call))  # evaluate compute function
          }  # end j
            a <- data.frame(rbind(a, c(n, na, out)))  # a has multiple rows
        }  # end i

        names(a) <- c("n", "na", nm.cmpt)
        row.names(a) <- nm.var.d
      }
    }  # end n.cmp > 0

    if (qflag) {  # do quantiles here
      for (i in seq_len(n.var)) {
        n <- count_n(data[,nm.var.d[i]])
        na <- count_NA(data[,nm.var.d[i]])
        a2 <- quantile(data[,nm.var.d[i]], na.rm=na_remove,
                       probs=seq(0,1,1/q_num))
        a2 <- c(n, na, a2)
        a2 <- data.frame(t(a2))
        names(a2)[n.by+1] <- "_n"
        names(a2)[n.by+2] <- "_na"
        if (i == 1)
          aq <- a2
        else
          aq <- rbind(aq, a2)
      }
      for (i in seq_along(names(aq))) {   # delete ending . in var names
        nm <- names(aq)[i]
        if (substr(nm, nchar(nm), nchar(nm)) == ".")
          names(aq)[i] <- substr(nm, 1, nchar(nm)-1)
      }
      qc <- (n.by + 3):ncol(aq)  # quantile cols only, skip _n/_na names
      names(aq)[qc] <- gsub("X", "p", names(aq)[qc], fixed=TRUE)
      row.names(aq) <- nm.var.d

    # quant and non-quant done separately, here set final a
      if (n.cmp == 0)
        a <- aq
      else 
        a <- cbind(a, aq[,3:ncol(aq)])
    }

    if (!show_n) {
      not.n <- which(grepl("_n$", names(a)))
      not.n <- c(not.n, which(grepl("_na$", names(a))))
      a <- a[,-not.n]
    }
       
    # round, leaves true integers (1.00) displayed as an integer (1)
    for (i.col in seq_len(ncol(a)))
      a[,i.col] <- .decdig(a[,i.col], digits_d)

    # sort
    if (!is.null(sort)) {
      direction <- sort != "+"
      if (!is.null(sort_var)) {
        if (is.numeric(sort_var))
          s.col <- sort_var
        else {
          s.col <- which(names(a) == sort_var)
          if (length(s.col) == 0)
            stop(call.=FALSE, "\n------\n",
                 "sort_var \"", sort_var, "\" not found in column names.\n\n")
        }
      }
      else
        s.col <- ncol(a)  # s.col is the number of the sort column
      a <- a[order(a[[s.col]], decreasing=direction), ]
    }
    if (length(nm.var.d) == 1) {
      names(a) <- gsub(nm.var.d, "", names(a), fixed=TRUE)
      names(a) <- gsub("_", "", names(a), fixed=TRUE)
    }
    return(a)
  }  # no by specified and not tabulate


  # ------------------------------------------
  # --------------- tabulate -----------------

    if (nm.cmpt[1] == "tabulate") {
      use_na <- if (!na_by_show) "no" else "ifany"
      a <- table(data[, ind.by], useNA=use_na)
      if (n.c.by != 0) {
        if (table_prop == "all") a <- proportions(a)
        if (table_prop == "row") a <- proportions(a, 1)
        if (table_prop == "col") a <- proportions(a, 2)
        if (!is.null(digits_d)) a <- round(a, digits_d)
      }
      else
        a <- as.data.frame(a)
      names(a)[ncol(a)] <- "n"

      return(a)
    }

  # ------------------------------------------
  # --------------- aggregate ----------------

  # aggregate over a numerical variable (by vars become factors)
  # na.action is the NA parameter for aggregate, but does not work the
  #   same as na.rm, which is used here and is a parameter of mean(), etc.   
  if (n.cmp == 1) {
    if (qflag || tflag) 
      a <- aggregate(data[,ind.var.d], by=by.vars, drop=FALSE, FUN=compute[[1]],
                     na.rm=na_remove)  # compute for a cell even if missing
    else
      a <- aggregate(data[,ind.var.d], by=by.vars, drop=FALSE, FUN=compute,
                     na.rm=na_remove)  # compute for a cell even if missing
    if (n.var == 1)
      names(a)[ncol(a)] <- nm.var.d[1]
  }

  else if (n.cmp > 1) { 
    # do the 1st computation
    a <- aggregate(data[,ind.var.d], by=by.vars, drop=FALSE, FUN=compute[[1]],
                   na.rm=na_remove)  # compute for a cell even if a missing
    # do the remaining computations
    for (i in seq(2L, n.cmp)) {
      ac <- aggregate(data[,ind.var.d], by=by.vars, drop=FALSE,
               FUN=compute[[i]], na.rm=na_remove)
      names(ac)[ncol(ac)] <- paste(names(ac)[ncol(ac)], i, sep="")  # no dups
      a <- merge(a, ac, by=names(by.vars), sort=FALSE)
    }
  }

  n <- aggregate(data[,ind.var.d], by=by.vars, drop=FALSE, FUN=count_n)
  if (ncol(n) == 2) names(n)[2] <- nm.var.d[1]  # 1 var, aggregate names x
  n_NA <- aggregate(data[,ind.var.d], by=by.vars, drop=FALSE, FUN=count_NA)
  if (ncol(n_NA) == 2) names(n_NA)[2] <- nm.var.d[1]
  # merge columns to form complete aggregate data frame: a
  # pull by vars and aggregated var from original a
  if (n.cmp > 0) {
    a <- merge(a, n, by=names(by.vars), sort=FALSE)
    a <- merge(a, n_NA, by=names(by.vars), sort=FALSE)
  }
  else
    a <- merge(n, n_NA, by=names(by.vars), sort=FALSE)

  # if there is a non-quantile computation function
  if (n.cmp > 0) {
    if (length(ind.by) == 1)
      names(a)[1] <- names(data)[ind.r.by]

    # Dates never go to factors
    for (i in seq_len(n.r.by))
      if (cls[i] == "Date") a[,i] <- as.Date(as.character(a[,i]))

    if (!factors) {  # retain original variable type of by vars
      for (i in seq_len(n.r.by)) {
        if (cls[i] == "character") a[,i] <- as.character(a[,i])
        if (cls[i] == "integer") a[,i] <- as.integer(as.character(a[,i]))
        if (cls[i] == "logical") a[,i] <- as.logical(as.character(a[,i]))
      }
    }

    a2 <- a[, 1:n.by, drop=FALSE]  # temp, start by var(s) in the first col(s)

    if (n.cmp == 1) {
      col.val <- matrix(, nrow=0, ncol=3)
      for (i in seq_len(n.var)) {  # identify variables in a
        if (n.var == 1)  # by position
          col.val <- rbind(col.val, c(n.by+1,n.by+2,n.by+3))  # next 3 cols
        else  # by name, agg structure includes names
          col.val <- rbind(col.val, 
                           which(grepl(nm.var.d[i], names(a), fixed=TRUE)))
      }
      # add columns to temp a2 data frame
      for (i in seq_len(n.var)) {
         a2 <- cbind(a2, a[, col.val[i,2:3]])
         a2 <- cbind(a2, a[, col.val[i,1]])
      }
      a <- a2

      k <- n.by
      for (i in seq_len(n.var)) {  # for each variable, cover n, na, aggregated stat

        if (n.var==1) { 
          names(a)[k+1] <- "n"
          names(a)[k+2] <- "na"
        }
        else {
          names(a)[k+1] <- paste(nm.var.d[i], "_n", sep="")
          names(a)[k+2] <- paste(nm.var.d[i], "_na", sep="")
        }
          names(a)[k+3] <- nm.var.d[i]
        k <- k + 3
      }
    }  # end n.cmp==1

    else {  # n.cmp > 1 and n.var == 1
      a2 <- cbind(a2, a[, (ncol(a)-1):ncol(a)])
      a2 <- cbind(a2, a[, (n.by+1):(n.by+n.cmp)])
      a <- a2

      k <- n.by
      names(a)[k+1] <- "n"
      names(a)[k+2] <- "na"
      for (i in seq_len(n.cmp)) {
        names(a)[k+2+i] <- nm.var.d[1]  # all agg vars get the var name
      }
    }  # end n.cmp > 1 and n.var==1

      ind.var <- which(names(a) %in% names(data)[ind.var.d])  # variables in a
      names(a)[ind.var] <- out_names
  }  # end n.cmp>0

  # table computation
  if (tflag) {
    out_names <- NULL  # does not apply to a table where the names are levels

    # get _n and _na variables
    a1 <- aggregate(data[,ind.var.d], by=by.vars, drop=FALSE, FUN=count_n)
    a2 <- aggregate(data[,ind.var.d], by=by.vars, drop=FALSE, FUN=count_NA)
    amd1 <- merge(a1, a2, by=names(by.vars), sort=FALSE)
    names(amd1)[n.by+1] <- "_n"  # uniform _n/_na so 598 removal catches both
    names(amd1)[n.by+2] <- "_na"

    # calculate the freqs level by level of the aggregation variable
    lvl <- sort(unique(data[,ind.var.d]))
    for (i in seq_along(lvl)) {
      dtmp <- data[data[,ind.var.d]==lvl[i], , drop=FALSE]  # lvl[i] subset
      if (n.by > 1)
        by.v <- as.list(dtmp[,ind.by])
      else
        by.v <- list(dtmp[,ind.by])
      names(by.v) <- nm.row.by
      a2 <- aggregate(dtmp[,ind.var.d], by=by.v, drop=FALSE, FUN=count_n)
      names(a2)[ncol(a2)] <- lvl[i]
      for (j in seq_len(nrow(a2)))
        if (is.na(a2[j,ncol(a2)])) a2[j,ncol(a2)] <- 0
      if (i == 1)
        amd2 <- a2  # 1st level of by variable
      else
        amd2 <- merge(amd2, a2, by=names(by.vars), sort=FALSE)
    }
    amd <- merge(amd2, amd1, by=names(by.vars), sort=FALSE) 
    
    if (table_prop %in% c("all", "row", "col")) {
      nca <- ncol(amd)
      ll <- length(lvl)

      dp <- amd[, (n.by+1):(n.by+ll), drop=FALSE]  # pull out freq table
      tdb <- as.matrix(dp)

      if (table_prop == "all") tdb <- proportions(tdb)
      if (table_prop == "row") tdb <- proportions(tdb,1)
      if (table_prop == "col") tdb <- proportions(tdb,2)

      # if no row or col entries, proportions leaves a NaN, so make 0
      tdb <- replace(tdb, is.nan(tdb), 0)

      if (!quiet) {
        txt <- if (table_prop == "col") "column" else table_prop
        cat("\nProportions computed over", txt, "cells\n\n")
      }
      amd <- cbind(amd[, seq_len(n.by), drop=FALSE], tdb,
                   amd[, (n.by+ll+1):nca, drop=FALSE])  # replace freqs with props
    }  # end table_prop

    if (n.cmp == 0) {  # table is only computation: show bare n, na
      names(amd)[names(amd) == "_n"]  <- "n"
      names(amd)[names(amd) == "_na"] <- "na"
      a <- amd
    }
    else {  # more than just table already processed
      not.n <- which(grepl("_n$", names(amd)))
      not.n <- c(not.n, which(grepl("_na$", names(amd))))
      amd <- amd[,-not.n]  # remove what will be redundant columns
      a <- cbind(a,amd[(n.by+1):ncol(amd)])
    }
    if (is.factor(data[,ind.var.d]))
      names(a)[(n.by+3):ncol(a)] <- levels(data[,ind.var.d])
  }  # end tflag


  # quantile computation
  if (qflag) {
    by_i <- 1 / q_num
    aq <- aggregate(data[,ind.var.d], by=by.vars, drop=FALSE, FUN=quantile,
                   probs=seq(0,1,by_i), na.rm=na_remove) 
    am <- as.matrix(aq)  # convert aggregation to a data frame
    amd <- data.frame(am)
    nm.v <- nm.var.d[1]
    qc <- (n.by + 1):ncol(amd)  # quantile cols only, not by-var names
    names(amd)[qc] <- gsub("x.", "p", names(amd)[qc], fixed=TRUE)
    for (i in seq_along(names(amd))) {   # delete ending . in var names
      nm <- names(amd)[i]
      if (substr(nm, nchar(nm), nchar(nm)) == ".")
        names(amd)[i] <- substr(nm, 1, nchar(nm)-1)
    }
    amd[] <- lapply(amd[], type.convert, as.is=TRUE)  # recover true var types
    if (n.cmp == 0) {  # quantile is only specified compute function
      ss <- merge(n, n_NA, by=names(by.vars), sort=FALSE)
      a <- merge(ss, amd, by=names(by.vars), sort=FALSE)
      names(a)[n.by+1] <- paste(nm.v, "_n", sep="")
      names(a)[n.by+2] <- paste(nm.v, "_na", sep="")
    }
    else {  # more than just quantiles already processed
      a <- cbind(a,amd[(n.by+1):ncol(amd)])
    }
  }  # end qflag


  # ----- post-computation processing -----
  # ---------------------------------------

  # missing by variables data: set NA for _n, _na to 0 or remove if specified
  if (!("n" %in% names(a)))  # multi var names the column "var_n", not "n"
    n_ind <- which(grepl("_n$", names(a)))
  else
    n_ind <- which(names(a) == "n")
  if (!("na" %in% names(a)))  # single var names the column "na", not "var_na"
    na_ind <- which(grepl("_na$", names(a)))
  else
    na_ind <- which(names(a) == "na")
  ind0 <- logical(nrow(a))  # initializes to FALSE
  for (i in seq_len(nrow(a))) {
    for (j in seq_along(n_ind)) {
      if (is.na(a[i,n_ind[j]])) a[i,n_ind[j]] <- 0
    }
    for (j in seq_along(na_ind)) {
      if (is.na(a[i,na_ind[j]])) {
        a[i,na_ind[j]] <- 0
        ind0[i] <- TRUE
      }
    }
  }  # end seq_len(nrow(a))
  if (!na_by_show) a <- a[!ind0,]

  # drop n_ and na_ columns if specified
  if (!show_n) {
    not.n <- c(n_ind, na_ind)
    a <- a[,-not.n]
  }

  # get decimal digits to display column by column
  ind.var <- seq(n.by+1, ncol(a))
  for (i.col in ind.var)
    a[,i.col] <- .decdig(a[,i.col], digits_d)

  # sort if specified
  if (!is.null(sort)) {
    direction <- sort != "+"
    if (!is.null(sort_var)) {
      if (is.numeric(sort_var))
        s.col <- sort_var
      else {
        s.col <- which(names(a) == sort_var)
        if (length(s.col) == 0)
          stop(call.=FALSE, "\n------\n",
               "sort_var \"", sort_var, "\" not found in column names.\n\n")
      }
    }
    else
      s.col <- ncol(a)  # s.col is the number of the sort column
    a <- a[order(a[[s.col]], decreasing=direction), ]
  }

  # --- option to reshape long form a to wide form ---
  # --------------------------------------------------

  # function to abbreviate col headings for constructing a table (not a df)
  abrev <- function (x, room) {  # preserve a space, abbreviate if needed
    has.space <- grepl(" ", x, fixed=TRUE)
    if (has.space) x <- sub(" ", "`", x, fixed=TRUE) 
    x <- abbreviate(x, room-2)
    if (has.space) x <- sub("`", " ", x, fixed=TRUE) 
    return(x)
  }

  if (n.c.by > 0) {

    nm.var.a <- names(a)[ind.var]  # preserve original names

    # delete variables _n and _na
    if ("n" %in% names(a))
      n.ind <- which(names(a) == "n")
    else
      n.ind <- which(grepl("_n$", names(a)))
    if ("na"  %in% names(a))
      miss.ind <- which(names(a) == "na")
    else
      miss.ind <- which(grepl("_na$", names(a)))
    a <- a[, -c(n.ind, miss.ind)]

    # re-reference pivot variables in aggregated data frame a
    i.v <- which(names(a) %in% nm.var.a)
    i.r <- which(names(a) %in% nm.row.by)
    i.c <- which(names(a) %in% nm.col.by)

    # first column by variable
    if (n.c.by == 1) {
      i1.r <- i.r
      i1.c <- i.c
    }
    else if (n.c.by == 2) {
      i1a.r <- i.r
      i1b.r <- i.c[1]  # move first col by var to the row by
      i1.r <- c(i1a.r, i1b.r)
      i1.c <- i.c[2]
    }

    # convert a data frame to reshaped w data frame
    # reshape only works on one col by variable at a time
    # reshape adds verbose variable names
    w <- reshape(a, direction="wide", idvar=names(a)[i1.r],
                    timevar=names(a)[i1.c], v.names=names(a)[i.v])
   # second column by variable
    if (n.c.by == 2) {
      i2.r <- i.r
      i2.c <- i.c[1]
      w <- reshape(w, direction="wide", idvar=names(a)[i2.r],
                      timevar=names(a)[i2.c])
    }
    rownames(w) <- c()  # remove row names
    # drop cols with all NA
    # current set up is for complete crossing of all levels
    # if drop all NA cols, need to have separate levels 2 for each level 1
    # no_col_na: dropping all-NA columns disabled; kept for future use

  # headings
  # move reshaped data frame w to a kable character vector
  # --------

    # if var by_cols names larger than by row name, pad with "|"
    mx <- max(nchar(names(a)[i.c]))
    nm.r1 <- names(a)[i.r[1]]
    if (nchar(nm.r1) < mx) {
      dff <- mx - nchar(nm.r1)
      buf <- paste(rep("|", dff), sep="", collapse="")
      nm.buf <- paste(names(a)[i.r[1]], buf, sep="")
      names(w)[1] <- nm.buf
    }

    # convert reshaped w to kable k, vector of lines of characters
    # remove all by names from w, get " -" locations from kable
    for (i in seq(n.r.by+1, length(names(w)))) names(w)[i] <- " "
    k <- knitr::kable(w, format="pandoc", caption=" ", align="r")
    # get starting positions of columns for labels from k --- line
    g <- gregexpr(" -", k[4], fixed=TRUE)
    g <- unlist(g)

    # get line of blank chars to fill later, including 1st by col name
    nc <- nchar(k[4])
    ln1 <- paste(rep(" ", nc), sep="", collapse="")
    ln1 <- paste(" ", names(a)[i.c[1]], ln1, sep="")

    # fill level labels for one by_cols var
    if (n.c.by == 1) {
      c1.nm <- names(a)[i.c[1]]
      substr(ln1, 2, 2 + nchar(c1.nm)) <- c1.nm
      lvl1 <- levels(a[,i.c[1]])

      for (i in seq_len(max(0L, length(lvl1) - 1L))) {
        room <- g[i+1]-g[i]
        if (nchar(lvl1[i]) > room-1)
          lvl1[i] <- abrev(lvl1[i], room)
      }

      for (i in seq_along(lvl1)) {
        if (is.na(lvl1[i])) lvl1[i] <- "NA" 
        start <- g[n.r.by + (i-1)] + 1
        stop <- start + nchar(lvl1[i])
        room <- stop - start
        substr(ln1, start, stop) <- lvl1[i]
      }
    }

    # two by_cols vars
    else if (n.c.by == 2) {
      lvl1 <- levels(a[,i.c[1]])
      lvl2 <- levels(a[,i.c[2]])

      for (i in seq_len(max(0L, length(lvl2) - 1L))) {  # stop one short: last needs no room check
        room <- g[i+1]-g[i]
        if (is.na(lvl2[i])) lvl2[i] <- "NA" 
        if (nchar(lvl2[i]) > room-1)
          lvl2[i] <- abrev(lvl2[i], room)
      }

      # line with labels for first by_cols var (1st level line)
      # for each lvl1 item, skip lvl2 cols for placement
      for (i in seq_along(lvl1)) {
        if (is.na(lvl1[i])) lvl1[i] <- "NA" 
        start <- g[n.r.by + (i-1)*length(lvl2)] + 1
        stop <- start + nchar(lvl1[i])
        substr(ln1, start, stop) <- lvl1[i]
      }

      ln2 <- paste(rep(" ", nc), sep="", collapse="")  # blank line
      ln2 <- paste(" ", names(a)[i.c[2]], ln2, sep="") # add var name

      # line with labels for second by_cols var
      c2.nm <- names(a)[i.c[2]]
      substr(ln2, 2, 2 + nchar(c2.nm)) <- c2.nm
      for (k in seq_along(lvl1)) {
        for (i in seq_along(lvl2)) {
          if (is.na(lvl2[i])) lvl2[i] <- "NA" 
          start <- g[n.r.by + (k-1)*length(lvl2) + (i-1)] + 1
          stop <- start + nchar(lvl2[i])
          substr(ln2, start, stop) <- lvl2[i]
        }
      }
    }  # end n.c.by == 2

    # caption, with added blank line
    cpt <- paste(nm.cmpt[1], "of", names(data)[ind.var.d], "\n")
    w <- knitr::kable(w, format="pandoc", caption=cpt, align="r")

    if (n.c.by == 1)  # set second line of table w
      w[2] <- ln1
    else
      w[2] <- paste(ln1, "\n", ln2, sep="")

    # clear any "|" padding that may be present
    for (i in seq_len(nchar(w[3])))
      if (substr(w[3],i,i) == "|") substr(w[3],i,i) <- " "

    # when knitr processing, wrap kable table with "```"
    if (!is.null(options()$knitr.in.progress)) {
      w[1] <- paste("```", "\n", w[1], sep="")
      w[length(w)] <- paste(w[length(w)], "\n", "```", sep="")
    }
    a <- w
  }  # end n.c.by > 0
  # ------------------------------------------

  # display constant (single-valued) columns from the drilled-down data
  # data <- na.omit(data)  # remove missing data for comparison of values
  nm <- character(length=ncol(data))
  k <- 0
  for (i in seq_len(ncol(data))) {  # identify constant (single-valued) columns
    if (length(unique(data[,i])) == 1) {
      k <- k + 1
      nm[k] <- names(data)[i]  # name of the constant-valued variable
    }
  }
  nm.TF <- (names(data) %in% nm[seq_len(k)])  # TRUE for each constant column
  if (any(nm.TF)) {
    for (i in seq_len(ncol(data))) {
      if (nm.TF[i]) if (is.numeric(data[[i]]) && !.is.integer((data[[i]])))
        nm.TF[i] <- FALSE  # drop numeric vars that are not integers
    }
    for (i in seq_len(ncol(data))) {
      dval <- data[1,i]
      if (class(data[1,i]) == class(Sys.Date()))  # == "Date" is flagged no
        dval <- as.character(data[1,i])
      if (is.factor(data[1,i])) dval <- as.character(data[1,i])
      if (nm.TF[i])
        cat(names(data)[i], ": ", dval, sep="", "\n")
    }
    cat("\n")
  }

  return(a)
}

.plt.bck <-
function(usr, gridT1, gridT2, do.v=TRUE, do.h=TRUE) {

  # background color
  rect(usr[1], usr[3], usr[2], usr[4],
       col=getOption("panel_fill"), border="transparent")

  # grid lines
  grid_x_color <- ifelse(is.null(getOption("grid_x_color")),
    getOption("grid_color"), getOption("grid_x_color"))
  grid_y_color <- ifelse(is.null(getOption("grid_y_color")),
    getOption("grid_color"), getOption("grid_y_color"))

  grid_x_lwd <- ifelse(is.null(getOption("grid_x_lwd")),
    getOption("grid_lwd"), getOption("grid_x_lwd"))
  grid_y_lwd <- ifelse(is.null(getOption("grid_y_lwd")),
    getOption("grid_lwd"), getOption("grid_y_lwd"))

  grid_x_lty <- ifelse(is.null(getOption("grid_x_lty")),
    getOption("grid_lty"), getOption("grid_x_lty"))
  grid_y_lty <- ifelse(is.null(getOption("grid_y_lty")),
    getOption("grid_lty"), getOption("grid_y_lty"))

  if (do.h)
    abline(h=gridT2, col=grid_y_color, lwd=grid_y_lwd, lty=grid_y_lty)

  if (do.v)
    abline(v=gridT1, col=grid_x_color, lwd=grid_x_lwd, lty=grid_x_lty)

  # box around plot
  rect(usr[1], usr[3], usr[2], usr[4],
    col="transparent", border=getOption("panel_color"),
    lwd=getOption("panel_lwd"), lty=getOption("panel_lty"))
}

X <- function(x=NULL, data=d, filter=NULL,

    by=NULL,
    facet=NULL, n_row=NULL, n_col=NULL, aspect="fill",

    form = c("histogram", "freq_poly", "density",
             "violin", "box", "strip", "bs", "vbs"), # violin, box, strip

    stat=c("count", "proportion"),

    theme=getOption("theme"),
    fill=getOption("bar_fill_cont"),
    color=getOption("bar_color_cont"),
    transparency=getOption("trans_bar_fill"),
    area_fill="on",  # freq_poly: fill under each polygon; "off" for lines only

    counts=FALSE,
    bin_start=NULL, bin_width=NULL, bin_end=NULL, breaks="Sturges",

    cumulate=c("off", "on", "both"), reg="snow2",

    show_histogram=TRUE,
    bandwidth=NULL, kind=c("general", "normal", "both"),
    full_curve=TRUE,
    fill_normal=NULL, fill_hist=getOption("se_fill"),
    color_normal="gray20", line_width=NULL,
    x_pt=NULL, y_axis=FALSE,
    rug=FALSE, color_rug="black", size_rug=0.5,

    vbs_plot="vbs", vbs_ratio=0.9, bw=NULL, bw_iter=10,
    violin_fill=getOption("violin_fill"),
    box_fill=getOption("box_fill"),
    pt_size=NULL,
    vbs_pt_fill="black",
    vbs_mean=FALSE, fences=FALSE, k=1.5, box_adj=FALSE, a=-4, b=3,
    jitter_x=NULL, jitter_y=NULL,

    ID="row.name", ID_size=0.60,
    out_cut=0, out_shape="circle", out_size=1,

    xlab=NULL, ylab=NULL, main=NULL, sub=NULL,
    lab_adjust=c(0,0), margin_adjust=c(0,0,0,0),

    rotate_x=getOption("rotate_x"), rotate_y=getOption("rotate_y"),
    offset=getOption("offset"),
    scale_x=NULL,
    axis_fmt=c("K", ",", ".", ""), axis_x_pre="", axis_y_pre="",
    font_size=1,

    add=NULL, x1=NULL, y1=NULL, x2=NULL, y2=NULL,

    quiet=getOption("quiet"), do_plot=TRUE,
    use_plotly=getOption("lessR.use_plotly"),
    pdf_file=NULL, width=6.5, height=6,
    digits_d=NULL, Rmd=NULL,

    eval_df=NULL, fun_call=NULL, ...) {


  # limit actual argument to alternatives, perhaps abbreviated
  cumulate <- match.arg(cumulate)
  stat <- match.arg(stat)
  form <- match.arg(form)
  kind <- match.arg(kind)
  if (is.null(fun_call)) fun_call <- match.call(expand.dots=TRUE)
  if (nzchar(axis_fmt[1])) axis_fmt <- match.arg(axis_fmt)

  if (font_size != 1) {
    .fs_main   <- getOption("main_size", 1.1)
    .fs_lab    <- getOption("lab_size",  1.0)
    .fs_axis   <- getOption("axis_size", 0.76)
    .fs_axis_x <- getOption("axis_x_size")
    .fs_axis_y <- getOption("axis_y_size")
    options(main_size = .fs_main * font_size,
            lab_size  = .fs_lab  * font_size,
            axis_size = .fs_axis * font_size)
    if (!is.null(.fs_axis_x))
      options(axis_x_size = .fs_axis_x * font_size)
    if (!is.null(.fs_axis_y))
      options(axis_y_size = .fs_axis_y * font_size)
    on.exit({
      options(main_size = .fs_main,
              lab_size  = .fs_lab,
              axis_size = .fs_axis)
      if (!is.null(.fs_axis_x)) options(axis_x_size = .fs_axis_x)
      if (!is.null(.fs_axis_y)) options(axis_y_size = .fs_axis_y)
    }, add = TRUE)
  }

  # collected plotly style options, passed down to plotly internals so they
  # don't reach into getOption() themselves
  style.opts <- .plotly_style()

  darkred <- "\033[38;5;88m"   # 256-color "dark red"
  reset   <- "\033[0m"

  if (stat == "density") {
    message("The new and future way to request a density plot\n",
            "  is with the form parameter: ",
            darkred, "form = \"density\"", reset, ".\n",
            "This setting is done for you now but in the future\n",
            "  the stat alternative for this setting will be dropped.\n\n")
    form <- "density"
  }

  proportion <- stat == "proportion"   # old signal
  trans <- transparency

  fill.miss <- missing(fill)
  box.fill.miss <- missing(box_fill)
  violin.fill.miss <- missing(violin_fill)
  trans.miss <- missing(transparency)
  color.miss <- missing(color)
  out.size.miss <- missing(out_size)
  n.col.miss <- missing(n_col)
  n.row.miss <- missing(n_row)
  out.shape.miss <- missing(out_shape)
  vbs.plot.miss <- missing(vbs_plot)
  by.miss <- missing(by)
  facet.miss <- missing(facet)

  # differentiate from later use of deparse(substitute(fill))
  user.fill.name <- deparse(substitute(fill))

  # a rug, or rug styling, implies a density plot
  if (!missing(color_rug)  ||  !missing(size_rug)) rug <- TRUE
  if (rug && form != "density") form <- "density"

  if (theme != getOption("theme")) {
    old_theme <- getOption("theme")
    style(theme)
    on.exit(style(old_theme), add=TRUE)
    style.opts <- .plotly_style()  # re-capture under new theme
    if (font_size != 1) {  # style() reset font sizes; re-scale
      options(main_size = getOption("main_size", 1.1) * font_size,
              lab_size  = getOption("lab_size",  1.0) * font_size,
              axis_size = getOption("axis_size", 0.76) * font_size)
      .new_x <- getOption("axis_x_size")
      .new_y <- getOption("axis_y_size")
      if (!is.null(.new_x)) options(axis_x_size = .new_x * font_size)
      if (!is.null(.new_y)) options(axis_y_size = .new_y * font_size)
    }
    sty <- style(theme, reset=FALSE)
    if (fill.miss) fill <- sty$bar$bar_fill_cont
    if (color.miss) color <- sty$bar$bar_color_cont
    if (trans.miss) trans <- sty$bar$trans_fill
    if (violin.fill.miss) violin_fill <- sty$VBS$violin_fill
    if (box.fill.miss) box_fill <- sty$VBS$box_fill
  }

  # Plotly renders the interactive histogram/density, but not a faceted plot
  #   (base R / lattice), so do not announce Plotly when faceting
  if (!quiet && use_plotly && (form %in% c("histogram", "density")) &&
      is.null(substitute(facet))) {
    txt <- "[Interactive plot from the Plotly R package (Sievert, 2020)]"
    cat(txt, "\n\n")
  }

  breaks.miss <- missing(breaks)
  bw.miss <- missing(bandwidth)


  # ------------ Old Stuff ----------------------------------

  # Check for deprecated parameter names using the unevaluated call —
  # must use match.call() not names(list(...)) to avoid evaluating
  # expressions like rows=(Gender=="M") in the wrong environment.
  .mc_nms <- names(match.call())
  if ("facet1" %in% .mc_nms || "facet2" %in% .mc_nms) {
    stop(call. = FALSE, "\n------\n",
         "The arguments 'facet1' and 'facet2' are replaced.\n",
         "Please use 'facet' instead.\n",
         "For two facets, specify:  facet = c(Var1, Var2)\n\n")
  }
  if ("rows" %in% .mc_nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  rows  has been removed.\n",
         "Use  filter  instead, e.g., filter = (Age > 30)\n\n")
  }
  if ("n_cat" %in% .mc_nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  n_cat  has been removed.\n",
         "Convert categorical integer variables to factors instead:\n",
         "  e.g., d$Item1 <- factor(d$Item1)\n\n")
  }

  # a dot in a parameter name to an underscore and more
  dots <- list(...)
  .style.trap(names(dots))

  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] == "type") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
            "Parameter  type  renamed  form\n\n")
      }
      if (names(dots)[i] == "dn.hist") show_histogram <- dots[[i]]
      if (names(dots)[i] == "fill_gen") fill <- dots[[i]]
      if (names(dots)[i] == "fill_nrm") fill_normal <- dots[[i]]
      if (names(dots)[i] == "color_nrm") color_normal <- dots[[i]]
      if (length(grep(".", names(dots)[i], fixed=TRUE)) > 0) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
      }
    }
  }

  # ---------------------------------------------------------


  if (!breaks.miss  &&  (form == "density"))  {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "When plotting density, parameter  breaks  does not apply.\n",
      "Bins must be equal width; instead use bin_start and bin_width.\n\n")
  }


  # frequency polygon. Single group (no by): delegate to XY() before any side
  #   effects here, such as opening a graphics device or writing an Rmd file.
  #   XY() renders the base R polygon and, by default, the plotly version too
  #   (as bar charts do). Grouped (by=) frequency polygons are plotly only,
  #   handled in the variable loop below via freq_poly.plotly().
  if (form == "freq_poly"  &&  facet.miss) {  # faceted freq poly: base-R grid

    if (!missing(by)  &&  !use_plotly) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "A grouped frequency polygon with  by  requires plotly.\n",
        "Set  use_plotly=TRUE  (the default).\n\n")
    }

    if (missing(by)) {  # single group
      # base R static polygon via XY(); the interactive plotly is rendered
      #   below in the variable loop by freq_poly.plotly(), so area_fill
      #   applies and the single polygon matches the grouped (by=) version
      cl <- fun_call
      cl[[1L]] <- as.name("XY")   # X(...) -> XY(...)
      cl$form  <- NULL            # drop visualization selector
      cl$form  <- NULL            # drop deprecated selector alias, if used
      cl$area_fill <- NULL        # XY uses ts_area_fill, not area_fill
      cl[["use_plotly"]] <- FALSE # base R here; plotly via freq_poly.plotly

      nm <- names(cl)
      if (is.null(nm)) nm <- character(length(cl))

      # map X's stat -> XY's stat_x
      if ("stat" %in% nm && !("stat_x" %in% nm)) {
        cl[["stat_x"]] <- cl[["stat"]]
        cl[["stat"]]   <- NULL
      }

      # default for freq poly is count if user didn't supply anything
      if (!("stat_x" %in% names(cl)))
        cl[["stat_x"]] <- "count"

      invisible(eval.parent(cl))  # render base R, print text output

      # without plotly, base R is the whole plot; otherwise fall through to
      #   the variable loop for the interactive freq_poly.plotly()
      if (!use_plotly) return(invisible())
    }
    # fall through to freq_poly.plotly() in the variable loop
  }

  fill[which(fill == "off")] <- "transparent"
  color[which(color == "off")] <- "transparent"

  xlab.adj <- lab_adjust[1];   ylab.adj <- lab_adjust[2]
  tm.adj <- margin_adjust[1];  rm.adj <- margin_adjust[2]
  bm.adj <- margin_adjust[3];  lm.adj <- margin_adjust[4]

  .param.old(..., fun.name = "X")


  # --------- data frame stuff

  data.d <- missing(data)

  # let deprecated mydata work as default
  dfs <- .getdfs()
  mydata.ok <- FALSE
  if (!is.null(dfs)) {
    if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
      d <- mydata
      rm(mydata)
      df.name <- "mydata"
      mydata.ok <- TRUE
      options(dname = df.name)
    }
  }

  # get name of data table
  if (!mydata.ok) {
    df.name <- deparse(substitute(data))
    options(dname = df.name)
  }

  shiny <- FALSE
  if (!is.null(sys.call(-1)))  # is NULL when called directly from R console
    if (sys.call(-1) == "renderPlot()") {  # from shiny, user or interact()
      shiny <- TRUE
      data <- eval(substitute(data), envir=parent.frame())
    }

  # if a tibble, convert to data frame
  if (!shiny) {
    if (exists(df.name, envir=.GlobalEnv)) {
      if (any(grepl("tbl", class(data), fixed=TRUE)))
        data <- data.frame(data)
    }
  }
  else  { # no check for existence of df.name
    if (any(grepl("tbl", class(data), fixed=TRUE)))
      data <- data.frame(data)
  }

  x.name <- deparse(substitute(x), width.cutoff = 120L)
  if (length(x.name) > 1L)
    x.name <- if (!is.null(xlab) && length(xlab)==1L && nzchar(xlab))
                  xlab else "x"
  options(xname = x.name)

  # classify x: a computational expression evaluates directly, with a
  # data-column reference resolved from the data frame, then the
  # caller's environment; tryCatch avoids forcing the data=d promise
  x.expr    <- substitute(x)
  x.is.expr <- !missing(x) && .is_expr_arg(x.expr)
  x.uses.df <- FALSE
  if (x.is.expr)
    x.uses.df <- df.name != "NULL" && length(all.vars(x.expr)) > 0L &&
                 any(all.vars(x.expr) %in%
                     tryCatch(names(data), error=function(e) character(0)))

  if (!x.is.expr) {
    if (!(shiny && df.name == "NULL")) .in.global(x.name, quiet)
    x.in.global <- if (shiny && df.name == "NULL") TRUE
                   else df.or.global(x.name, df.name, role="x",
                                     fun.name="X")
  }
  else
    x.in.global <- !x.uses.df

  if (!x.in.global) {
    # force evaluation (not lazy) if data not specified, relies on default d
    if (data.d) {
      if (!mydata.ok) .nodf(df.name)  # check to see if df exists
      # the 1.201 comes from Shiny, need to reset
      # l.cex and l.axc are set in interact() before shiny run
      if (getOption("lab_size") == 1.201) {
       if (getOption("l.cex") != 1.201) {
          style(lab_size=getOption("l.cex"))
          style(axis_size=getOption("l.axc"))
        }
        else
          style()
      }
    }
  }

  # respect a caller-supplied eval_df, e.g., CountAll() passes FALSE
  if (is.null(eval_df)) eval_df <- !x.in.global



# subset filter -------------------------------------------------------

  if (!missing(filter))
    data <- .apply_filter(data,
                          deparse(substitute(filter)),
                          parent.frame(),
                          x.in.global, quiet)


  # -----------------------------------------------------------
  # establish if a data frame, if not then identify variable(s)
  # x can be missing entirely, with a data frame passed instead
  # if x a vector, then x.name not in data, but also not in global

  if (!missing(x)) {

    # x is a computational expression, evaluate directly
    if (x.is.expr) {
      val <- .expr_eval(x.expr, x.name, if (x.uses.df) data else NULL,
                        parent.frame(), role="x", fun.name="X")
      if (is.data.frame(val))
        data.x <- val
      else {
        if (!is.numeric(val)) {
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "A histogram is only computed from a numeric variable\n",
            "To tabulate the values of a categorical variable:\n\n",
            "  Chart(", x.name, ", stat=\"count\")\n\n", sep="")
        }
        data.x <- data.frame(val)
        names(data.x) <- x.name  # after data.frame(): no name mangling
      }
    }

    # x not in global env, in df, specify data= forces to data frame
    else if (!x.in.global) {
      if (eval_df) {
        if (!mydata.ok) .nodf(df.name)  # does data frame container exist?
        .xcheck(x.name, df.name, names(data))  # x-vars in df?
      }
      data.vars <- as.list(seq_along(data))
      names(data.vars) <- names(data)

      ind <- eval(substitute(x), envir=data.vars)  # col num of each var
      if (!("list" %in% class(data))) {
        data.x <- data[, ind]
        if (length(ind) == 1) {  # x is 1 var
          if (!is.numeric(data.x)) {
            cat("\n"); stop(call.=FALSE, "\n------\n",
              "A histogram is only computed from a numeric variable\n",
              "To tabulate the values of a categorical variable:\n\n",
              "  Chart(", x.name, ", stat=\"count\")\n\n", sep="")
          }
          data.x <- data.frame(data.x)
          names(data.x) <- x.name
        }
      }
      else {  # class of data is "list"
        data.x <- data.frame(data[[ind]], stringsAsFactors=TRUE)
        names(data.x) <- x.name
      }
    }  # end x not in global

    # x is in the global environment (vector or data frame)
    else {
      if (is.data.frame(x))  # x a data frame
        data.x <- x
      else {  # x a vector in global, already checked by .in.global()
        if (!is.function(x))
          data.x <- data.frame(x, stringsAsFactors=TRUE)  # x is 1 var
        else
          data.x <- data.frame(eval(substitute(data$x)), stringsAsFactors=TRUE)
        names(data.x) <- x.name
      }
    }  # x is in global
  }

  # evaluate by
  #------------
  # cannot directly evaluate is.null(by) if by is present as a variable
  # so instead process as below to either get by.call or it is NULL
  # can get by.name
  if (!missing(by)) {

    # get variable name before potential call of data$x
    by.name <- paste(deparse(substitute(by), width.cutoff=120L),
                     collapse="")
    .quoted_varname(by.name, "by")

    # X() permits only one  by  variable, e.g., by=c(V1, V2) is not allowed
    by.expr <- substitute(by)
    if (is.call(by.expr) && identical(by.expr[[1L]], as.name("c"))) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Only one  by  variable is permitted, but more than one specified:\n",
        "  by = ", by.name, "\n",
        "  Additional grouping variables are not permitted, as the resulting\n",
        "  visual clutter compromises interpretability.\n",
        "  To display a second grouping variable, use  facet.\n\n")
    }

    options(byname = by.name)

    if (.is_expr_arg(by.expr)) {  # by is a computational expression
      uses.df <- df.name != "NULL" &&
                 any(all.vars(by.expr) %in%
                     tryCatch(names(data),
                              error=function(e) character(0)))
      by.call <- .expr_eval(by.expr, by.name,
                            if (uses.df) data else NULL,
                            parent.frame(), role="by", fun.name="X")
      if (!missing(x)  &&  length(by.call) != nrow(data.x)) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "x has ", nrow(data.x), " values, but the  by  expression\n",
          "  ", by.name, "  yields ", length(by.call), " values\n\n")
      }
    }
    else {
      # get conditions and check for data existing
      by.in.global <- df.or.global(by.name, df.name, role="by",
                                   fun.name="X")

      if (!by.in.global) {
        if (eval_df)
          .xcheck(by.name, df.name, names(data))
        by.call <- eval(substitute(data$by))
      }
      else {  # vars that are function names get assigned to global
        by.call <- by
        if (is.function(by.call)) by.call <- eval(substitute(data$by))
      }
    }
    by.call <- factor(by.call)

    n.by <- length(unique(by.call))
  }  # end having by
  else {
    n.by <- 1  # i.e., just one group
    by.call <- NULL
    by.name <- NULL
  }


# --- resolve facet --------------------------------------------------

  # Initialize legacy internal vars
  facet1.call <- facet2.call <- NULL
  facet1.name <- facet2.name <- NULL
  facet1.miss <- facet2.miss <- TRUE

  if (!missing(facet)) {
    facet.expr <- substitute(facet)
    facet.vars <- all.vars(facet.expr)
    caller.env <- parent.frame()

    if (.is_expr_arg(facet.expr)) {  # a computational expression
      f.name <- paste(deparse(facet.expr, width.cutoff=120L),
                      collapse="")
      uses.df <- df.name != "NULL" &&
                 any(facet.vars %in%
                     tryCatch(names(data),
                              error=function(e) character(0)))
      v <- .expr_eval(facet.expr, f.name,
                      if (uses.df) data else NULL,
                      caller.env, role="facet", fun.name="X")
      facet1.call <- droplevels(factor(v))
      facet1.name <- f.name
      facet1.miss <- FALSE
      if (!missing(x)  &&  length(facet1.call) != nrow(data.x)) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "x has ", nrow(data.x), " values, but the  facet  expression\n",
          "  ", f.name, "  yields ", length(facet1.call), " values\n\n")
      }
    }
    else {

    get.col <- function(nm)
      .resolve_named_var(nm, df.name, data, caller.env,
                         role = "facet", fun.name = "X")

    # Resolve symbols to factors
    fac.list <- lapply(facet.vars, function(nm) {
      v <- get.col(nm)
      if (!is.factor(v)) v <- factor(v)
      droplevels(v)
    })

    # Map into legacy internal vars
    if (length(fac.list) >= 1L) {
      facet1.call <- fac.list[[1L]]
      facet1.name <- facet.vars[1L]
      facet1.miss <- FALSE
    }
    if (length(fac.list) >= 2L) {
      facet2.call <- fac.list[[2L]]
      facet2.name <- facet.vars[2L]
      facet2.miss <- FALSE
    }
    if (length(fac.list) > 2L) {
      message("`facet` has ", length(fac.list),
              " variables; using the first two: ",
              paste(facet.vars[1:2], collapse = ", "), ".")
      fac.list   <- fac.list[1:2]
      facet.vars <- facet.vars[1:2]
    }
    }  # end facet is variable name(s), not an expression
  }


  # evaluate ID  (for VBS)
  #------------
  get.ID <- FALSE
  if (!is.null(add)) if (add[1] == "labels") get.ID <- TRUE
  if (out_cut > 0) get.ID <- TRUE

  if (get.ID) {
    # ID.name is the actual var name if specified directly,
    #  or the name of the var that contains the var name
    ID.name <- deparse(substitute(ID))
    ID.name <- gsub("\"", "", ID.name)  # remove extra quotes if "row.name"
    if (ID.name == "row.name") ID.name <- "row.names"
    if (!x.in.global) {
  # if x is in a data frame, then in the function call it is a name
  # if x is in global, then in the function its name is a variable direct
  # ID.col is the actual var column if specified directly,
  #  or the var name if a variable that contains the name was entered
      if (ID.name != "row.names") {
        # data.vars only built when x was specified and is in the data frame
        if (!exists("data.vars", inherits=FALSE)) {
          data.vars <- as.list(seq_along(data))
          names(data.vars) <- names(data)
        }
        ID.col <- eval(substitute(ID), envir=data.vars, parent.frame())
        if (!is.numeric(ID.col)) {
          ID.col <- which(names(data) == ID.col)
          ID.name <- names(data)[ID.col]
        }
      .xcheck(ID.name, df.name, names(data))  # var exists in data frame?
      ID.call <- data[, ID.col]
      }  # end not row.names
      else  # ID is row.names
        ID.call <- row.names(data)
    } # end !x.in.global

    else {  # in global
      ID.call <- eval(substitute(ID), parent.frame())
    }
  }  # end get.ID

  else  # no ID to get
    ID.call <- NULL

# ---- resolve pt_size (NULL, numeric value, or a variable in data) ----
  # Same pattern as XY() — avoid forcing the lazy promise on a bare name
  # like `Pre` that lives in the data frame, not in the calling environment.
  if (!missing(pt_size)) {
    size.name <- deparse(substitute(pt_size))
    if (size.name == "NULL") {
      pt_size <- NULL
    } else {
      suppressWarnings(size.num <- as.numeric(size.name))
      if (is.na(size.num)) {
        # variable name — caller frame first (Shiny pre-evaluated case)
        if (exists(size.name, envir=parent.frame(), inherits=TRUE) &&
            is.numeric(get(size.name, envir=parent.frame(),
                            inherits=TRUE))) {
          pt_size <- get(size.name, envir=parent.frame(), inherits=TRUE)
        } else {
          in.global <- df.or.global(size.name, df.name,
                                    role="pt_size", fun.name="X")
          if (!in.global) {
            data.vars <- as.list(seq_along(data))
            names(data.vars) <- names(data)
            size.col <- eval(substitute(pt_size), envir=data.vars)
            pt_size  <- data[, size.col]
            if (!is.numeric(pt_size)) {
              cat("\n"); stop(call.=FALSE, "\n------\n",
                "Variable ", size.name, " must be numeric\n\n",
                "Perhaps use: by=", size.name, "\n\n")
            }
          }
        }
      }
      # else: numeric constant — pt_size is already that value
    }
  }

  # -----------------------------------------------------------
  # -----------  x, y, by, and facet variables established ----
  # -----------------------------------------------------------

  Trellis <- !facet.miss

  if (Trellis && form=="histogram") {
    if (do_plot) {
      if (fill.miss) {
        if (theme == "colors")
          fill <- rgb(150,170,195, maxColorValue=255)
        else
          fill <- .color_range(.get_fill(theme), 1)
      }
      .bar.lattice(data.x[,1], facet1.call, facet2.call, n_row, n_col,
             aspect, proportion, fill, color, trans, size.pt=NULL,
             xlab, ylab, main, rotate_x, offset,
             axis_fmt, axis_x_pre, axis_y_pre,
             width, height, pdf_file,
             segments_x=NULL, breaks, bin_start, bin_width, bin_end,
             T.type="hist", quiet)
    }
    return(invisible(NULL))
  }


  if (!missing(x)) data <- data.x

  # set up graphics
  manage.gr <- .graphman()  # manage graphics?
  if (manage.gr) {
    i.win <- 0
    for (i in 1:ncol(data)) {
      if (is.numeric(data[,i])  &&  !.is.num.cat(data[,i], 0))
        i.win <- i.win + 1
    }
    .graphwin(i.win, d.w=width, d.h=height)
    open.win <- 2
  }
  plot.i <- 0  # keep track of generated graphics
  plot.title  <- character(length=0)

  # no suggestions if multiple variables
  if (ncol(data) > 1) {
    sug <- getOption("suggest")
    options(suggest = FALSE)
  }

# evaluate specified fill (NULL, numeric constant, or a variable) ---------
  if (!color.miss && !is.null(by.call)) {
    if (!.is.palette(color[1]))
      color  <- .align_vector(color, by.call)  # convert named color to legacy
  }
  if (!fill.miss) {
    if (length(user.fill.name) == 1) {
      if (exists(df.name, where=.GlobalEnv))
        in.df <- user.fill.name %in% names(data)
      else
        in.df <- FALSE
    }
    else in.df <- FALSE

    # only works for y given, not tabulated
    if (in.df) {  # fill is a variable
    # need to aggregate cat var x and set fill.val to those limited values
    # currently, fill.val consists of all data values of variable fill
      fill.val <- eval(substitute(data$fill))  # fill is a variable in data
      fill <- .getColC(fill.val, fill_name=user.fill.name)
    }

    n.fill <- ifelse (by.miss, 12, n.by)  # 12 is an arbitrary hack
    if (.is.palette(fill[1])) {
      fill <- .color_range(fill, n.fill)
    }

    # evaluate getColors at the time of the function call
    # re-evaluate here by setting fill with the specified value of n
    if (substr(user.fill.name[1], 1, 9) == "getColors") {
      n.clr <- if (!is.null(by.call)) n.by else 2  # 2 specifies endpoints
      fill <- .resolve_getColors_n(user.fill.name, n.clr)
    }
  }  # end !fill.miss

  else {
    if (is.null(by.call)) {
      if (theme == "colors")
        fill <- rgb(150,170,195, maxColorValue=255)
      else
        fill <- getOption("bar_fill_cont")
    }
    else
      fill <- .color_range(.get_fill(theme), n.by)
  }


  for (i in 1:ncol(data)) {  # data only contains data to be analyzed
    nu <- length(unique(na.omit(data[,i])))

    x.name <- names(data)[i]
    options(xname = x.name)

    plt.word <- switch(form, histogram = "Histogram",
                       density = "Density", "VBS plot")

    if (is.numeric(data[,i])) {
      # let 1 variable go through, even if num.cat
      if (ncol(data) == 1  ||  !.is.num.cat(data[,i], 0)) {

      # track the generated graphics across multiple variables
      if (ncol(data) > 1) {
        plot.i <- plot.i + 1
        plot.title[plot.i] <- paste(plt.word, " of ", x.name, sep="")
        if (manage.gr) {
          open.win <- open.win + 1
          dev.set(which = open.win)
        }
      }

      # a faceted freq poly is a base-R grid here, so it needs a device like
      #   histogram/density; a non-faceted freq poly had its device (and pdf)
      #   handled by the XY() delegation above
      fp.facet <- form == "freq_poly" && !facet.miss

      if (!is.null(pdf_file)  &&  (form != "freq_poly" || fp.facet)) {
        if (!grepl(".pdf", pdf_file))
          pdf_file <- paste(pdf_file, ".pdf", sep="")
        pdf(file=pdf_file, width=width, height=height, onefile=FALSE)
      }
      else {
        # VBS plots: .plt.lattice opens its own graphics device
        if (df.name != "NULL"  &&  do_plot  &&  # not dev.new for shiny
            (form %in% c("histogram", "density") || fp.facet))
          .opendev(pdf_file, width, height)
      }

      txkfl <- ""
      if (!is.null(Rmd)) {
        if (!grepl(".Rmd", Rmd)) Rmd <- paste(Rmd, ".Rmd", sep="")
        txknt <- .dist.Rmd(x.name, df.name, fun_call, digits_d)
        cat(txknt, file=Rmd, sep="\n")
        txkfl <- .showfile2(Rmd, "R Markdown instructions")
      }  # end R Markdown

      ssstuff <- .ss.numeric(data[,i], digits_d=digits_d, brief=TRUE)
      txss <- ssstuff$tx


    # drop all rows with any missing data across x, y, by, and size -----------

    # 1) Build a temporary data frame that contains all relevant columns
      df <- data

      if (!is.null(by.call) && length(by.call) > 0L)
        df$..by <- by.call

      if (!is.null(facet1.call) && length(facet1.call) > 0L)
        df$..facet1 <- facet1.call

      if (!is.null(facet2.call) && length(facet2.call) > 0L)
        df$..facet2 <- facet2.call  # fixed name

      # 2) Compute complete cases, then delete rows with an NA
      cc <- stats::complete.cases(df)

      # 3) Delete rows with missing data
      if (!all(cc)) {
        data <- data[cc, , drop = FALSE]

        if (!is.null(by.call) && length(by.call) > 0L)
          by.call <- by.call[cc]

        if (!is.null(facet1.call) && length(facet1.call) > 0L)
          facet1.call <- facet1.call[cc]

        if (!is.null(facet2.call) && length(facet2.call) > 0L)
          facet2.call <- facet2.call[cc]
      }

      rm(df)


# histogram ---------------------------------------------------------------

    if (form == "histogram") {

      digits.d <- if (is.null(digits_d)) .max.dd(data[,i]) else digits_d
      # process plotly and by=1 Plots
      stuff <- .hst.main(data[,i], by.call, by.name, n.by,
          fill, color, trans, reg,
          rotate_x, rotate_y, offset,
          breaks, bin_start, bin_width,
          bin_end, proportion, counts, cumulate, xlab, ylab, main, sub,
          xlab.adj, ylab.adj, bm.adj, lm.adj, tm.adj, rm.adj,
          add, x1, x2, y1, y2,
          scale_x, axis_fmt, axis_x_pre, axis_y_pre, use_plotly,
          digits.d, quiet, do_plot, fun_call=fun_call,
          style_opts=style.opts, ...)

      txsug <- stuff$txsug
      if (is.null(txsug)) txsug <- ""
      txdst <- stuff$ttx
      if (is.null(txdst)) txdst <- ""

      txotl <- .bx.stats(data[,i])$txotl
      if (txotl[1] == "") txotl <- "No (Box plot) outliers"

      if (ncol(data) > 1  &&  !quiet) { # for var range, print text output
        class(txss) <- "out"
        class(txdst) <- "out"
        class(txotl) <- "out"
        output <- list(out_ss=txss, out_freq=txdst, out_outliers=txotl)
        class(output) <- "out_all"
        print(output)
      }



      # n.by == 1: full structured return (histogram-specific)
      if (n.by == 1 && ncol(data) == 1) {
        output <- list(form="Histogram",
          call=fun_call,
          out_suggest=txsug, out_ss=txss, out_outliers=txotl, out_freq=txdst,
          out_file=txkfl,
          bin_width=stuff$bin_width, n_bins=stuff$n.bins,
          breaks=stuff$breaks,
          mids=stuff$mids, counts=stuff$counts, prop=stuff$prop,
          cumulate=stuff$counts_cum, cprop=stuff$prop_cum)
        class(output) <- "out_all"
        if (!quiet) print(output)

        stuff <- list(out_suggest=txsug, out_summary=txss,
                out_freq=txdst, out_outliers=txotl,
                bin_width=stuff$bin_width, n_bins=stuff$n.bins,
                breaks=stuff$breaks, mids=stuff$mids,
                counts=stuff$counts, prop=stuff$prop,
                cumulate=stuff$counts_cum, cprop=stuff$prop_cum)

        if (!is.null(pdf_file)) {
          dev.off()
          if (!quiet && df.name!="NULL") .showfile(pdf_file, "Histogram")
        }
        if (use_plotly && isTRUE(getOption("knitr.in.progress"))
            && !isTRUE(quiet)) {
          plt.last <- getOption("lessR.last_plotly", NULL)
          if (inherits(plt.last, "htmlwidget")) print(plt.last)
        }
        return(invisible(stuff))
      }  # end n.by == 1
      # n.by >= 2: fall through to shared grouped-stats block
    } # end histogram


# density -----------------------------------------------------------------

    else if (form == "density") {
      if (bw.miss) bandwidth <- .band.width(data[,i], ...)  # band width

      clr <- getOption("theme")  # color theme not used except monochrome

      if (fill.miss) {
          fill <- rgb(80,150,200, alpha=80, maxColorValue=255)
        if (clr == "gray" ||
           (getOption("theme") == "gray"  &&
            getOption("sub_theme") == "black")) {
          fill <- rgb(.5,.5,.5, .5)
        }
      }
      else {  # add some transparency to a named color
        for (i.clr in seq_along(fill)) {
          if (fill[i.clr] %in% colors()) {
            fg.rgb <- col2rgb(fill[i.clr])
            fill[i.clr] <- rgb(fg.rgb[1], fg.rgb[2], fg.rgb[3],
                                alpha=80, maxColorValue=255)
          }
        }
      }

      if (missing(fill_normal)) {
          fill_normal <- rgb(250,210,230, alpha=80, maxColorValue=255)
        if (clr == "gray" ||
           (getOption("theme") == "gray"  &&
            getOption("sub_theme") == "black")) {
          fill_normal <- ifelse (kind %in% c("normal", "both"),
                                 rgb(.75,.75,.75, .5), "transparent")
        }
      }
      else {  # add some transparency to a named color
        if (fill_normal %in% colors()) {
          fg.rgb <- col2rgb(fill_normal)
          fill_normal <- rgb(fg.rgb[1], fg.rgb[2], fg.rgb[3],
                              alpha=80, maxColorValue=255)
        }
      }

      x.min <- NULL
      x.max <- NULL
      if (!is.null(scale_x)) {
        x.min <- scale_x[1]
        x.max <- scale_x[2]
      }

      # area_fill toggles filling the space under the density curve
      dn.area <- !(area_fill[1] %in% c("off", "transparent"))

      # faceted density: base-R panel grid with a shared x-range and density
      #   scale, reusing the single-plot density estimation and styling
      if (!facet1.miss) {
        if (do_plot)
          .plt.dist.facet(data[,i], facet1.call, facet2.call,
            facet1.name, facet2.name, render="density",
            bandwidth=bandwidth, kind=kind, histo=show_histogram,
            fill_hist=fill_hist, col_nrm=color_normal, fill_nrm=fill_normal,
            col_gen=color, fill_gen=fill, lwd=line_width,
            rug=rug, color_rug=color_rug, size_rug=size_rug,
            full_curve=full_curve, theme=theme, x.min=x.min, x.max=x.max,
            axis_fmt=axis_fmt, axis_x_pre=axis_x_pre, axis_y_pre=axis_y_pre,
            x.lab=if (!is.null(xlab)) xlab else x.name, y_axis=y_axis,
            n_row=n_row, n_col=n_col, quiet=quiet)
        if (!is.null(pdf_file)) {
          dev.off()
          if (!quiet && df.name!="NULL") .showfile(pdf_file, "Density")
        }
        return(invisible(NULL))
      }

      # need this for dn.plotly even if not for Plots window
      stuff <- .dn.main(data[,i], by.call, by.name, n.by,
            bandwidth, kind, show_histogram, theme,
            bin_start, bin_width, fill.miss,
            fill_hist, color_normal, color,
            fill_normal, fill, line_width,
            rotate_x, rotate_y, offset,
            axis_fmt, axis_x_pre, axis_y_pre,
            x_pt, xlab, main, sub, y_axis, x.min, x.max,
            rug, color_rug, size_rug,
            use_plotly, quiet, full_curve=full_curve,
            fncl=fun_call, style_opts=style.opts, do_plot=do_plot,
            fill_area=dn.area, ...)

      if (n.by == 1) {  # stat output
        txdst <- stuff$tx  # should be named txbw

        txotl <- .bx.stats(data[,i])$txotl
        if (txotl[1] == "") txotl <- "No (Box plot) outliers"

        txsug <- stuff$txsug

        class(txdst) <- "out"
        class(txotl) <- "out"
        class(txsug) <- "out"

        output <- list(form="Density",
          out_suggest=txsug, out_stats=txdst,
          out_ss=txss, out_outliers=txotl,
          out_file=txkfl,
          bw=stuff$bw, n=stuff$n, n_miss=stuff$n.miss)

        class(output) <- "out_all"
        if (!quiet) print(output)

        if (.allow.interactive())
          .viewer_notice_once(plot_name="density plot", window_target="Both")

        # with multiple variables, continue the loop to the next variable
        if (ncol(data) == 1) {
          if (!is.null(pdf_file)) {
            dev.off()
            if (!quiet && df.name!="NULL") .showfile(pdf_file, "Density")
          }
          return(invisible(output))
        }
      }  # end n.by is 1

    }  # end density


# freq_poly (plotly) ------------------------------------------------------

    else if (form == "freq_poly") {  # plotly only; base graphics via XY above

      # fill is the per-group line/area color; if off/transparent fall back
      #   to the theme palette so the lines stay visible and distinct
      fill_off <- length(fill) == 1L && fill[1] == "transparent"
      fp.fill <- if (fill.miss || fill_off) .color_range(.get_fill(theme), n.by)
                 else                       .color_range(fill, n.by)

      # area_fill toggles filling the space under each polygon
      fp.area <- !(area_fill[1] %in% c("off", "transparent"))

      # X's stat is count/proportion/density; density is not a freq poly stat
      fp.stat <- if (stat == "density") "count" else stat

      # faceted freq poly: base-R panel grid with shared bins and count scale
      if (!facet1.miss) {
        if (do_plot)
          .plt.dist.facet(data[,i], facet1.call, facet2.call,
            facet1.name, facet2.name, render="freq_poly",
            col_gen=fp.fill[1], fill_gen=fp.fill[1], lwd=line_width,
            fill_area=fp.area, stat=fp.stat,
            breaks=if (breaks.miss) NULL else breaks,
            bin_start=bin_start, bin_width=bin_width, bin_end=bin_end,
            theme=theme, axis_fmt=axis_fmt,
            axis_x_pre=axis_x_pre, axis_y_pre=axis_y_pre,
            x.lab=if (!is.null(xlab)) xlab else x.name,
            n_row=n_row, n_col=n_col, quiet=quiet)
        if (!is.null(pdf_file)) {
          dev.off()
          if (!quiet && df.name!="NULL") .showfile(pdf_file, "Frequency Polygon")
        }
        return(invisible(NULL))
      }

      plt <- freq_poly.plotly(
        x         = data[, i],  by = by.call,
        x_name    = x.name,     by_name = by.name,
        fill      = fp.fill,    fill_area = fp.area,
        x_lab     = if (!is.null(xlab)) xlab else x.name,
        stat      = fp.stat,
        breaks    = if (breaks.miss) NULL else breaks,
        bin_start = bin_start, bin_width = bin_width, bin_end = bin_end,
        digits_d  = if (is.null(digits_d)) 3 else digits_d,
        style_opts = style.opts)

      if (do_plot && .allow.interactive()) print(plt)

      # for by=, print summary stats here; for a single group the text
      #   output was already printed by the base R XY() call above
      if (n.by > 1) {
        txotl <- .bx.stats(data[, i])$txotl
        if (txotl[1] == "") txotl <- "No (Box plot) outliers"
        class(txss) <- "out"; class(txotl) <- "out"
        output <- list(form="Frequency Polygon",
          out_ss=txss, out_outliers=txotl)
        class(output) <- "out_all"
        if (!quiet) print(output)
      }

      if (ncol(data) == 1) return(invisible())
    }  # end freq_poly


# ---- shared grouped-stats output for histogram and density (n.by >= 2) ----
    if (form %in% c("histogram", "density") && n.by >= 2) {
      if (.allow.interactive()) {
        target <- if (n.by == 2) "Both" else "Viewer"
        .viewer_notice_once(
          plot_name = if (form == "histogram") "histogram" else "density plot",
          window_target = target)
      }

      # descriptive statistics by group, only computed for this output
      desc.stats <- .ss.pivot(
        x = data[, i],
        by = by.call,
        data       = data,
        x.name     = x.name,
        by.name    = by.name,
        print_result = FALSE
      )

      cat(x.name, "by", by.name, "\n\n")
      print(desc.stats, row.names = FALSE)

      # n.by == 2: also offer/run the t-test
      if (n.by == 2) {
        cat("\nFor inferential analysis of the mean difference:\n")
        message("> ttest(", x.name, " ~ ", by.name, ")\n")

        df.small <- data.frame(data[, i], by.call)
        names(df.small) <- c(x.name, by.name)

        calls <- sys.calls()
        top <- calls[[1L]]; fun <- top[[1L]]
        if (identical(fun, quote(X)) || identical(fun, as.name("X"))) {
          tmp.name <- ".lessR_ttest_df"
          assign(tmp.name, df.small, envir = parent.frame())
          on.exit(if (exists(tmp.name, envir=parent.frame()))
                    rm(list=tmp.name, envir=parent.frame()), add = TRUE)
          frm <- reformulate(by.name, response = x.name)
          tt.call <- bquote(
            lessR::ttest(.(frm), data=.(as.name(tmp.name)),
                         quiet=TRUE, graph=TRUE, line_chart=FALSE,
                         area_fill=.(area_fill)))
          eval(tt.call, envir = parent.frame())
        }
      } else {
        cat("\n")
      }

      # with multiple variables, continue the loop to the next variable
      if (ncol(data) == 1) {
        if (!is.null(pdf_file)) {
          dev.off()
          show <- if (form == "histogram") "Histogram" else "Density"
          if (!quiet && df.name!="NULL") .showfile(pdf_file, show)
        }
        return(invisible(NULL))
      }
    }


# VBS ---------------------------------------------------------------------

    else if (form %in% c("vbs", "bs", "violin", "box", "strip")) {

      # resolve the plot components: violin, box, strip points
      # vbs_plot is deprecated; when supplied it overrides form
      vbs_plot <- tolower(vbs_plot)
      if (vbs.plot.miss)
        vbs_plot <- switch(form, violin="v", box="b", strip="s", form)
      violin <- grepl("v", vbs_plot, fixed=TRUE)
      box    <- grepl("b", vbs_plot, fixed=TRUE)

        lx <- length(data[,i])
        iter.details <- !missing(bw_iter)
        n.ux <- length(unique(data[,i]))
      txt <- ifelse (!is.null(facet1.call),
                     "[Trellis (facet)", "[Violin/Box/Scatterplot")
      if (!quiet)
        cat(paste(txt, "graphics from Deepayan Sarkar's lattice package]\n\n"))

      # total number of facets
      n.facet1 <- length(levels(facet1.call))
      n.facet2 <- ifelse (facet2.miss, 1, length(levels(facet2.call)))
      n.lvl <- n.facet1 * n.facet2
      ord.by.call <- is.ordered(facet1.call)

      # n.lvl == 0 when facet1.call is NULL (no facets); single-panel default
      if (box.fill.miss  &&  vbs_plot == "b"  &&  n.lvl == 0)
          box_fill <- getOption("box_fill")
      else if (grepl("b", vbs_plot))
          box_fill <- .plt.fill(box_fill, box.fill.miss, ord.by.call,
                                n.facet1, n.lvl, theme)

      if (violin.fill.miss  &&  vbs_plot == "v") {
        if (n.lvl == 0) {
          if (theme != "gray")
            violin_fill <- getOption("box_fill")
          else
            violin_fill <- "gray75"
        }
        else {
          if (theme != "gray")
            violin_fill <- .plt.fill(box_fill, box.fill.miss, ord.by.call,
                                  n.facet1, n.lvl, theme)
          else
            for (i.lvl in seq_len(n.lvl)) violin_fill[i.lvl] <- "gray75"
        }
      }
      else {
        if (!violin.fill.miss)  # otherwise specified value
          violin_fill <- .plt.fill(violin_fill, violin.fill.miss, ord.by.call,
                                   n.facet1, n.lvl, theme)
        else
          for (i.lvl in seq_len(n.lvl)) violin_fill[i.lvl] <- violin_fill[1]
      }

        if (n.by > 1) {
          if (color.miss) {
            if (getOption("theme") %in% c("gray", "white"))
              pt.color <- getColors("grays", n=n.by)
            else
              pt.color <- getColors("hues", n=n.by, l=40)
          }
          else
            pt.color <- color
          for (i.by in 1:n.by) {
            if (fill.miss) {
              if (getOption("theme") %in% c("gray", "white"))
                pt.fill <- getColors("grays", n=n.by)
              else
                pt.fill <- getColors("hues", n=n.by, l=40)
            }
            else
              pt.fill <- fill
            pt.fill[i.by] <- .maketrans(pt.fill[i.by], (1-trans)*256)
            if (box.fill.miss)
              box_fill[i.by] <- .maketrans(box_fill[i.by], 0.6*256)
          }
        }  # n.by > 1
        else {  # n.by is 0 or 1
          if ("black" %in% vbs_pt_fill) {
            if (fill.miss) pt.fill <- "black"
            if (trans.miss) pt.trans <- 0.1
            if (color.miss) pt.color <- "black"
          }
          else if ("default" %in% vbs_pt_fill) {
            if (fill.miss) pt.fill <- "black"
            if (trans.miss) pt.trans <- getOption("trans_pt_fill")
            if (color.miss) pt.color <- "black"
          }
          else {
            if (fill.miss) pt.fill <- vbs_pt_fill
            if (trans.miss) pt.trans <- getOption("trans_pt_fill")
            if (color.miss) pt.color <- getOption("pt_color")
          }
          # user-specified values apply regardless of vbs_pt_fill
          if (!fill.miss)  pt.fill  <- fill
          if (!trans.miss) pt.trans <- trans
          if (!color.miss) pt.color <- color
          if (pt.trans > 0  &&  pt.fill[1] != "transparent")
            pt.fill <- .maketrans(pt.fill, (1-pt.trans)*256)
        }  # end n.by is 0 or 1

        # grayscale
        if (getOption("sub_theme") == "black") {
          if (fill.miss) pt.fill <- "black"
          if (color.miss) pt.color <- "black"
        }

        if (df.name == "NULL"  &&  out_size == 1) out.size.miss <- TRUE
        k.iqr <- k   # k is a function name, so do not use internally

        # get some VBS parameters, including: pt_size, jitter, bw
        # ss.numeric called there
        output <- NULL
        VBS <- .param.VBS(data[,i], ID.call, facet1.call, facet1.miss,
                by.call, by.miss, bw, bw.miss, bw_iter, iter.details,
                lx, n.ux, k.iqr, box_adj, a, b,
                x.name, facet1.name, by.name, vbs_plot,
                n.col.miss, n.row.miss,
                size = pt_size, out_size = out_size, out_size.miss = out.size.miss,
                jitter_x=jitter_x, jitter_y=jitter_y,
                bin = FALSE, breaks = "Sturges", bin_start = NULL,
                bin_width = NULL, bin_end = NULL,
                proportion, digits_d, quiet, fun_call, ...)

        if (is.null(pt_size)) {
          pt.size <- VBS$pt.size
        } else if (length(pt_size) > 1) {
          # vector pt_size: rescale to a usable cex range for lattice
          rng <- range(pt_size, na.rm=TRUE)
          if (diff(rng) > 0)
            pt.size <- 0.5 + 2.5 * (pt_size - rng[1]) / diff(rng)
          else
            pt.size <- rep(1.5, length(pt_size))
        } else {
          pt.size <- pt_size  # user-supplied scalar
        }

        # grayscale: only now that pt.size is known
        if (theme %in% c("gray", "white"))
          if (any(pt.size > 0.4)) if (out.shape.miss) out_shape <- 23
        pt.out.size <- VBS$out_size
        jitter_y <- VBS$jitter_y
        jitter_x <- VBS$jitter_x
        bw <- VBS$bw
        adj.bx.ht <- VBS$adj.bx.ht

        output$out_stats <- VBS$output  # text output
        if (!quiet) {
          cat("\n")
          print(output$out_stats)
        }

      if (!is.null(jitter_x)) if (jitter_x > 0)  # not available in stripplot
        data[,i] <- jitter(data[,i], factor=jitter_x)

      # no strip component, so no plotted points
      if (!grepl("s", vbs_plot, fixed=TRUE)) pt.size <- 0

      # n_col is null for X(x), X(x, by=), X(x, facet=)
      if (n.col.miss && n.row.miss && !is.null(facet1.call))
        n_col <- 1  # default n_col for Trellis


# pivot tables ------------------------------------------------------------

      x_vec <- data[[ x.name ]]   # e.g., data[["Salary"]]
      group.vars <- character(0)

      if (!quiet) cat("\n\n---------- Summary Statistics for", x.name)

      if (!by.miss) {
        group.vars <- c(group.vars, by.name)
        out.by <- .vbs_summary_table(
          x_vec    = x_vec,
          grp_vec  = by.call,
          grp.label = by.name,
          digits_d  = .max.dd(x_vec)
        )
        if (!quiet) {
          cat("\n\n")
          print(out.by)
        }
      }

      if (!facet.miss) {
          # facet.vars already limited to at most two variables
          facet.calls <- list(facet1.call, facet2.call)[seq_along(facet.vars)]
          out.facet <- vector("list", length(facet.vars))

          for (.fi in seq_along(facet.vars)) {
            group.vars <- c(group.vars, facet.vars[.fi])
            out.facet[[.fi]] <- .vbs_summary_table(
              x_vec     = x_vec,
              grp_vec   = facet.calls[[.fi]],
              grp.label = facet.vars[.fi],
              digits_d  = .max.dd(x_vec)
            )
            if (!quiet) {
              cat("\n\n")
              print(out.facet[[.fi]])
            }
          }  # end .fi
        }

      if (length(group.vars) == 0) {
        out.all <- .vbs_summary_table(
          x_vec  = x_vec,
          grp_vec = NULL,
          grp.label = x.name,
          digits_d  = .max.dd(x_vec)
        )
        if (!quiet) {
          cat("\n\n")
          print(out.all)
        }
      }


# do the plot -------------------------------------------------------------

      options(facet1name=facet1.name)

      # vary strip-point shape across by groups, as XY() does; one shape if
      #   no by variable
      vbs.shape <- if (!is.null(by.call))
                     .plt.shapes("vary", out_shape, n.by=n.by)$shape
                   else
                     "circle"

      if (do_plot)
      .plt.lattice(
        x = data[,i], y = NULL,
        facet1 = facet1.call, facet2 = facet2.call, by = by.call,
        adj.bx.ht = adj.bx.ht,
        object = "point",
        n_row = n_row, n_col = n_col, asp = aspect,

        fill = pt.fill, area_fill = "transparent", color = pt.color,
        panel_fill = getOption("panel_fill"),
        panel_color = getOption("panel_color"),

        size.pt = pt.size, size.ln = line_width,

        xlab = xlab, ylab = ylab, main = main,
        shape = vbs.shape,
        lab_size = getOption("lab_size"), axis_size = getOption("axis_size"),

        lvl = 0, ellipse_color = NULL, ellipse_lwd = NULL,

        fit.ln = "off", fit_power = 1,
        fit_color = NULL, fit_lwd = NULL, fit_se = NULL,

        plot_errors = FALSE,
        origin = NULL,
        jitter = jitter_y,

        violin = violin, violin_fill = violin_fill,
        box = box, box_fill = box_fill,

        bw = bw, vbs_ratio = vbs_ratio, box_adj = box_adj,
        a = a, b = b, k.iqr = k.iqr,
        fences = fences, vbs_mean = vbs_mean,

        out_shape = out_shape, out_size = pt.out.size,
        out_fill = getOption("out_fill"),
        out_color = getOption("out_color"),
        out2_fill = getOption("out2_fill"),
        out2_color = getOption("out2_color"),

        ID = ID.call, out_cut = out_cut, ID_color = "black", ID_size = ID_size,

        axis_fmt = axis_fmt, axis_x_pre = axis_x_pre, axis_y_pre = axis_y_pre,

        rotate_x = rotate_x, rotate_y = rotate_y,

        x_n_axis_skip = 0, y_n_axis_skip = 0,

        width = width, height = height, pdf_file = pdf_file,
        T.type = "cont",
        quiet = quiet, ...
      ) 

      # reset for next analysis
      options(xname=NULL)
      options(yname=NULL)
      options(facet1name=NULL)
      options(facet2name=NULL)
      options(byname=NULL)

    }  # end vbs


    } # end ncol(data) ---------

    else {  # numeric categorical variable, no plot
      if (!quiet) .ncat(plt.word, x.name, nu, 0)
    }

    }  # is.numeric(data[,i])
  }  # end for i from 1 to ncol

  if (ncol(data) > 1) {
    options(suggest = sug)
    if (is.null(pdf_file)  &&  plot.i > 0)
      if (is.null(options()$knitr.in.progress))
        .plotList(plot.i, plot.title)
  }

}

# plot legend for by variables
.plt.by.legend <-
function(mylevels, color, fill, shp, trans_pts, col.bg, usr,
         pt.size=1.25, pt.lwd=0.5, legend_size=NULL,
         legend_abbrev=NULL, legend_adj=0, legend_title=NULL) {

  par(xpd=NA)  # allow drawing outside of plot region

  n.levels <- length(mylevels)
  if (is.null(legend_title))
    legend_title <- getOption("byname")

  if (is.null(legend_abbrev))
    legend_labels <- mylevels
  else {
    if (!is.null(mylevels))
      legend_labels <- abbreviate(mylevels, legend_abbrev)
  }
  legend_title_size <- 1.1 * legend_size

  # abbreviate title if too large
  if (!is.null(legend_abbrev))
    legend_title  <- abbreviate(legend_title, legend_abbrev)
  mx.ch <- max(c(max(nchar(legend_labels)), nchar(legend_title)-2))

  ll <- legend(0,0, legend=legend_labels, title=legend_title, cex=.7,
               pt.cex=pt.size, pt.lwd=pt.lwd, plot=FALSE)

  size <- (par("cxy")/par("cin"))  # 1 inch in user coordinates

  # vertical adjustment
  axis_vert <- usr[4] - usr[3]
  lgnd.vhalf <- (ll$rect$h) / 2
  axis_cntr <- axis_vert / 2  + usr[3]
  ytop <- axis_cntr + lgnd.vhalf  # user coordinate of legend top

  # horizontal adjustment
  epsilon <- (size[1] - ll$rect$w) / 2
  if (epsilon < 0) epsilon <- .04  # do not have label overlap plot
  xleft <- usr[2] + epsilon - .01 # usr[2] user coordinate of right axis
  if (mx.ch > 7) xleft <- xleft - .02  # shift legend left a bit

  if (trans_pts > 0.85) {  # points too light, reduce legend transparency
    legend_fill <- integer(length=n.levels)
    for (i in 1:n.levels) legend_fill[i] <- .maketrans(color[i],.7)
  }
  else
    legend_fill <- fill

  the.clr <- getOption("lab_color")

  yi <- 0.95

  if (is.null(legend_size)) {
    axis_x_size <- ifelse(is.null(getOption("axis_x_size")),
      getOption("axis_size"), getOption("axis_x_size"))
    adj <- .RSadj(axis_size=axis_x_size); axis_x_size <- adj$axis_size
    legend_size <- axis_x_size
  }
  legend_size <- 1.1 * legend_size
  legend_title_size <- 1.1 * legend_size

  # fill=length(legend_labels):1  puts the legend labels in the correct
  #   order, but only for inflexible boxes that cannot be resized with pt.cex
  if (length(pt.size) == 1) if (pt.size == 0) pt.size <- 1.2
  if (shp[1] != "lines")
    legend(xleft+legend_adj, ytop, legend=legend_labels, title=legend_title,
           pch=shp, horiz=FALSE, cex=legend_size, pt.cex=pt.size, pt.lwd=pt.lwd,
           title.cex=legend_title_size,
           bg=col.bg, col=color, pt.bg=fill,
           text.col=the.clr, y.intersp=yi, bty="n")
  else {  # for plotting data and forecast
    xleft <- usr[2] + epsilon/4
    legend(xleft+legend_adj, ytop+ll$rect$h, legend=legend_labels,
           title=legend_title, cex=legend_size,
           pt.cex=pt.size, pt.lwd=pt.lwd,
           title.cex=legend_title_size,
           bg=col.bg, col=color, pt.bg=fill,
           text.col=the.clr, bty="n",
           lty="solid", lwd=2.5, y.intersp=1.7, seg.len=1.25)
    }

  par(xpd=FALSE)  # cancel drawing outside of plot region (need for RStudio)

}

.reg2Relations <-
function(lm.out, n.keep,
         collinear, subsets, best_sub, max.sublns,
         in.data.frame, sterrs, MSW) {

  nm <- all.vars(lm.out$terms)  # names of vars in the model
  n.vars <- length(nm)
  n.pred <- n.vars - 1L
  n.obs <- nrow(lm.out$model)

  # Correlations among the model variables are no longer reported as a
  # text matrix.  They are shown visually in the scatterplot matrix, with
  # the coefficients in the upper triangle (see the  scatter_coef  option).

  # -------------------------
  # collinearity

  txcln <- ""
  if (collinear) {
    tx <- character(length = 0)

    if (is.null(options()$knitr.in.progress)) {
      tx[length(tx)+1] <- "-- Collinearity"
      tx[length(tx)+1] <- ""
    }

    vif <- numeric(length = 0)
    tol <- numeric(length = 0)
    for (i in seq_len(n.pred)) {
      v <- var(lm.out$model[i+1])
      vif[i] <- (v * (n.keep-1) * sterrs[i+1]^2) / MSW
      tol[i] <- 1 / vif[i]
    }

    out <- cbind(tol, vif)
    colnames(out) <- c("Tolerance", "      VIF")
    rownames(out) <- nm[seq(2L, length(nm))]

    txcln <- .prntbl(out, 3, cc=NULL)
    for (i in seq_along(txcln)) tx[length(tx)+1] <- txcln[i]

    txcln <- tx
  } 

    else {  # !collinear
      vif <- NA
      tol <- NA
    }

  # -------------------------
  # all possible subsets of predictor variables    
  txsbs <- ""
  if (subsets) {
    tx <- character(length = 0)

    if (is.null(options()$knitr.in.progress)) {
      tx[length(tx)+1] <- "-- Best Subset Regression Models"
      if (n.pred > 5)
        tx[length(tx)+1] <- "up to 10 subsets of each number of predictors"
      tx[length(tx)+1] <- ""
    }

    X <- data.frame(lm.out$model[nm[seq(2,n.vars)]])
    Y <- lm.out$model[[nm[1]]]  # atomic vector for leaps
    lp.out <- leaps(X, Y, method=best_sub)  # leaps function
    md <- lp.out$which  # md is logical
    rownames(md) <- seq_len(nrow(md))  # matrix md does not have proper row names
    # gives 0, 1
    if (best_sub == "adjr2") {
      models <- data.frame(md, lp.out$adjr2, lp.out$size-1)
      names(models) <- c(names(X), "R2adj", "X's")
      mod.srt <- models[order(models$R2adj, decreasing=TRUE),]

    }
    else {
      models <- data.frame(md, lp.out$Cp, lp.out$size-1)
      names(models) <- c(names(X), "   Cp", "X's")
      mod.srt <- models[order(models$'   Cp', decreasing=FALSE),]
    }
    best_sub <- if (best_sub == "adjr2") "R2adj" else best_sub
    names(mod.srt)[ncol(mod.srt)-1L] <- paste("   ", best_sub, sep="")
    lines <- min(max.sublns, nrow(mod.srt))

    # width of data columns
    max.ln <- integer(length=ncol(X))
    for (i in seq_len(ncol(X))) {
      ln.nm <- nchar(colnames(X)[i])
      max.ln[i] <- ln.nm + 1
      if (max.ln[i] < 4) max.ln[i] <- 4L
    }

    tx[length(tx)+1] <- ""  # build the line of variable names
    for (i in seq_len(n.pred)) {
      if (i <= n.pred) ww <- max.ln[i]
      tx[length(tx)] <- paste(tx[length(tx)],
          .fmtc(names(mod.srt)[i], w=ww), sep="")
      nms <- tx[length(tx)]
    }
    for (i in seq_len(2L)) {
      if (i == 1) ww <- 9L
      if (i == 2) ww <- 7L
      tx[length(tx)] <- paste(tx[length(tx)], .fmtc(names(mod.srt)[n.pred+i],
                              w=ww), sep="")
    }
    for (i in seq_len(lines)) {
      if (lines > 40) if (i %% 30 == 0) tx[length(tx)+1] <- nms
      tx[length(tx)+1] <- ""
      for (j in seq_len(n.pred))
        tx[length(tx)] <- paste(tx[length(tx)], .fmti(mod.srt[i,j],
          w=max.ln[j]), sep="")
      tx[length(tx)] <- paste(tx[length(tx)], .fmt(mod.srt[i,n.pred+1],
          d=3, w=8)) # R2adj
      tx[length(tx)] <- paste(tx[length(tx)], .fmti(mod.srt[i,n.pred+2],
          w=6))  # num X's
    }

    if (nrow(mod.srt) > max.sublns)
      tx[length(tx)+1] <- paste(
        "\n>>> Only first", lines, "of", nrow(mod.srt), "rows printed\n",
        "   To indicate more, add subset=n, where n is the number of lines")

    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("[based on Thomas Lumley's leaps function",
                        "from the leaps package]")

    txsbs <- tx
  }  # end subsets

  return(list(out_collinear=txcln, out_subsets=txsbs, tol=tol, vif=vif))

}

# create an R time series programmatically
.tsMake <- function (x.date, y, ts_unit) {

  intervals <- diff(x.date)

  # Determine the frequency based on intervals of adjacent dates
  # the head(..., n=-1) includes all but the last data value
  if (all(head(intervals == 1, -1))) {
    if (ts_unit == "days7")
      frequency <- 7  # Daily data across the week
    else
      frequency <- 365  # Daily data across the year
  } else if (all(head(intervals >= 28 & intervals <= 31, -1))) {
    frequency <- 12  # Monthly data
  } else if (all(head(intervals == 7, -1))) {
    frequency <- 52  # Weekly data
  } else if (all(head(intervals >= 80 & intervals <= 100, -1))) {
    frequency <- 4  # Quarterly data
  } else if (all(head(intervals >= 365, -1))) {
    frequency <- 1  # Yearly data
  } else {
    tbl <- table(intervals)
    tbl.df <- data.frame(Interval=as.numeric(names(tbl)), Counts=as.vector(tbl))
    message("\nData are not spaced at regular date intervals.\n")
    print(tbl.df)
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Forecasting here requires dates spaced at regular intervals:\n",
      "daily, monthly, weekly, quarterly, or yearly data.\n\n",
      "Perhaps aggregate the data at a larger time interval with\n",
      "parameter  ts_unit  such as ts_unit=\"quarters\".\n\n")
  }

  # Convert the start date to appropriate start values for ts()
  start_date <- as.Date(min(x.date))
  if (frequency %in% c(7, 365)) {
    start_year <- as.numeric(format(start_date, "%Y"))
    start_day <- as.numeric(format(start_date, "%j"))
    ts_start <- c(start_year, start_day)
  } else if (frequency %in% c(52, 12)) {
    start_year <- as.numeric(format(start_date, "%Y"))
    start_month <- as.numeric(format(start_date, "%m"))
    ts_start <- c(start_year, start_month)
  } else if (frequency == 4) {
    start_year <- as.numeric(format(start_date, "%Y"))
    start_quarter <- (as.numeric(format(start_date, "%m")) - 1) %/% 3 + 1
    ts_start <- c(start_year, start_quarter)
  } else if (frequency == 1) {
    start_year <- as.numeric(format(start_date, "%Y"))
    ts_start <- c(start_year, 1)
  }

  # Create the time series object of y
  if (is.data.frame(y))
    y.ts <- ts(y[,1], start=ts_start, frequency=frequency)
  else
    y.ts <- ts(y, start=ts_start, frequency=frequency)
  return(y.ts)
}

.plt.marg <- function(max.y.width, y.lab, x.lab, main, sub,
                  rotate_x=0, mx.x.val.ln=1, mx.y.val.ln=1,
                  lab_x_size=0.95, lab_y_size=0.95, max.x.width=NULL,
                  axis_y_pre="") {
# not processing sub at this time

  # top margin
  tm <- 0.05  # old is 0.15
  if (!is.null(main)) tm <- tm + .25
  # if (options("device") == "RStudioGD") {
    # tm <- ifelse(.Platform$OS == "windows", tm-.15, 0)
  # }

  # right margin
  rm <- 0.15

  # bottom margin
  n.lab_x.ln <- 0  # in case x.lab is null
  if (!is.null(x.lab)) {
    if (x.lab != "") {
      strn <- unlist(gregexpr("\n", x.lab, fixed=TRUE))
      if (strn[1] == -1) strn <- NULL  # return of -1 means no \n
      n.lab_x.ln <- length(strn) + 1
    }
    else  # such as from default for time series
      n.lab_x.ln <- -0.6 + (.1 * lab_x_size)
  }

  ln.ht <- par('cin')[2] * lab_x_size * par('lheight')  # lin ht inches

  # rotate_x==90 and horiz=TRUE not compatible, leads to NULL max.x.width
  if (rotate_x != 90  ||  is.null(max.x.width))
    bm <- ((n.lab_x.ln + mx.x.val.ln) * .70 * ln.ht) + 0.30  # inches
  else
    bm <- max.x.width + (ln.ht * n.lab_x.ln) + 0.28
  bm <- bm + (-0.035 +(.055* n.lab_x.ln))
  tm <- ifelse (is.null(main), tm+.05, tm+.25)  #  adjust tm for increased bm
  if (rotate_x != 0) bm <- bm + .15
  if (lab_x_size > 1.1) bm <- bm + .04  # actually should be axis_size

  # left margin
  n.lab_y.ln <- 0  # in case y.lab is null
  if (!is.null(y.lab)) {
    if (y.lab != "") {
      strn <- unlist(gregexpr("\n", y.lab, fixed=TRUE))
      if (strn[1] == -1) strn <- NULL  # return of -1 means no \n
      n.lab_y.ln <- length(strn) + 1
    }
  }
  mm <- max.y.width + 0.30
  if (max.y.width < .10) mm <- mm + .03
  if (lab_y_size > 1) mm <- mm + .10
  if (nzchar(axis_y_pre)) mm <- mm + .14*length(axis_y_pre)
  if (!is.null(y.lab)) mm <- mm + (n.lab_y.ln * .18 * lab_y_size)

  return(list(lm=mm, tm=tm, rm=rm, bm=bm,
              n.lab_x.ln=n.lab_x.ln, n.lab_y.ln=n.lab_y.ln))
}

showColors <- 
function(file="colors.pdf", color=NULL) {

  if (!is.null(color)) file <- paste("colors.", color, ".pdf", sep="")
  pdf(file=file)

  old.par <- par(no.readonly = TRUE)  # save all modifiable settings
  on.exit(par(old.par))
  par(mfrow=c(5,6), mgp=c(0,1,0))
  
  if (is.null(color))
    clr <- colors()
  else
    clr <- grep(color, colors(), value = TRUE)
    
  h <- 1
  for (i in 1:length(clr))
    barplot(h, col=clr[i], main=clr[i], sub=toString(col2rgb(clr[i])), 
       cex.main=.95, axes=FALSE, border=NA)
  
  dev.off()
  .showfile(file, "file of R colors")
  
}

reshape_wide <-
  function(data, widen, response, ID, prefix=NULL, sep="_", ...) {

  # capture unquoted parameter names as strings first
  ID <- deparse(substitute(ID))
  widen <- deparse(substitute(widen))
  response <- deparse(substitute(response))

  # apply dot alias AFTER deparse so we get the caller's string, not "widen"
  dots <- list(...)
  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] == "group") widen <- as.character(dots[[i]])
    }
  }
 
  # if a tibble, convert to data frame
  df.name <- deparse(substitute(data))  # is NULL if from shiny
  if (exists(df.name, envir=parent.frame())) {
    if (any(grepl("tbl", class(data), fixed=TRUE)))
      data <- data.frame(data)
  }

    
  # note: extra columns beyond ID, widen, response are dropped here
  data <- data[, c(ID, widen, response)]
  dw <- reshape(data, direction="wide",
                idvar=ID, timevar=widen, v.names=response,
                sep=sep)

  sep.nm <- sep
  pattern <- paste(response, sep.nm, sep="")

  if (is.null(prefix)) {
    if (!is.numeric(data[, widen]))
      prefix <- FALSE
    else
      prefix <- TRUE
  }

  if (!prefix)
    names(dw) <- gsub(pattern, "", names(dw), fixed=TRUE)

  return(dw)
}

.reg3resfitResidual <-
function(lm.out, cook, cooks_cut,
         pdf=FALSE, width=5, height=5, manage.gr=FALSE) {

  fit <- lm.out$fitted.values
  res <- lm.out$residuals
  # get largest Cook's distance
  max.cook <- max(cook, na.rm=TRUE)
  if (max.cook < cooks_cut) {
    cooks_cut <- floor(max.cook*100)/100
    sub.lab <- paste("Point with largest Cook's Distance of",
                     .fmt(max.cook,2), "is labeled")
  }
  else
    sub.lab <- paste("Points with Cook's Distance >",
                     cooks_cut, "are labeled")


  # pdf graphics option
  go.pdf <- pdf  # save before grDevices::pdf() would shadow the name
  if (go.pdf) {
    pdf_file <- "RegResidFitted.pdf"
    grDevices::pdf(file=pdf_file, width=width, height=height)
  }

  # keep track of the plot in this routine
  plt.i <- 0L
  plt.title  <- character(length=0)

  plt.i <- plt.i + 1L
  plt.title[plt.i] <- "Residuals vs Fitted Values"

  # plot of residuals vs fitted
  ord <- order(fit)
  fit.ord <- fit[ord]
  res_ord <- res[ord]

  bm <- .9; tm <- .25;  rm <- .25
  # get left margin to adapt to size of axis numbers
  ctitle <- ""
  max.width <- strwidth(as.character(max(pretty(res_ord))), units="inches")
  margs <- .plt.marg(max.width, y.lab="Residuals", x.lab="Fitted Values", main=ctitle, sub=NULL)
  lm <- margs$lm
  par(bg=getOption("window_fill"))

  orig.params <- par(no.readonly=TRUE)
  on.exit(par(orig.params))
  par(mai=c(bm, lm, tm, rm))


  plot(fit.ord, res_ord, type="n", axes=FALSE, ann=FALSE)

  usr <- par("usr")
  rect(usr[1], usr[3], usr[2], usr[4],
       col=getOption("panel_fill"), border=getOption("panel_color"))

  abline(v=axTicks(1), col=getOption("grid_x_color"),
         lwd=getOption("grid_lwd"), lty=getOption("grid_lty"))
  abline(h=axTicks(2), col=getOption("grid_y_color"),
         lwd=getOption("grid_lwd"), lty=getOption("grid_lty"))

  .axes(NULL, NULL, axTicks(1), axTicks(2))

  main.lab <- NULL
  x.label <- "Fitted Values"
  y.label <- "Residuals"
  .axlabs(x.label, y.label, main.lab, sub.lab, lab_x_size=0.9, lab_y_size=0.9,
          xlab_adj=1.4)
  fill <- getOption("pt_fill")
  color <- getOption("pt_color")
  points(fit.ord, res_ord, pch=21, col=color, bg=fill, cex=0.76)
  abline(h=0, lty="dotted", lwd=1.5, col=getOption("bar_fill_cont"))
  lines(lowess(fit.ord, res_ord, f=.9), col=getOption("pt_color"))
  res_c <- res[which(cook >= cooks_cut)]
  fit.c <- fit[which(cook >= cooks_cut)]
  if (length(fit.c) > 0) {
    points(fit.c, res_c, col=color, pch=19)
    text(fit.c, res_c, names(fit.c), pos=1, cex=.8)
  }

  if (go.pdf) {
    dev.off()
    .showfile(pdf_file, "residuals vs. fitted plot")
  }

  return(list(i=plt.i, ttl=plt.title))

}

recode <-
function(old_vars, new_vars=NULL, old, new, data=d,
         quiet=getOption("quiet"), ...) {

  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (length(dots) > 0) {
    change <- c("new.vars", "old.vars")
    for (i in seq_along(dots)) {
      if (names(dots)[i] %in% change) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
      }
    }
  }

  if (missing(old_vars)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the variable to be recoded by listing it\n",
      "first or set according to:  old_vars\n\n")
  }

  if (missing(old)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the values of the variable to be recoded with:  old\n\n")
  }

  if (missing(new)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the new values of the recoded variable with:  new\n\n")
  }


  my.vars <- as.list(seq_along(data))
  names(my.vars) <- names(data)  # vars is ordinal position of variables in d
  vars <- eval(substitute(old_vars), envir=my.vars, enclos=parent.frame())

  if (!is.null(new_vars)) {
    old_vars.len <- 
      length(eval(substitute(old_vars), envir=my.vars, enclos=parent.frame()))
    new_vars.len <-
       length(eval(substitute(new_vars), envir=my.vars, enclos=parent.frame()))
    if (old_vars.len != new_vars.len) { 
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Number of specified existing variables: ", old_vars.len, "\n",
        "Number of specified transformed variables: ", new_vars.len, "\n\n",
        "The same number of variables must be specified for both\n",
        "existing and transformed variables.\n\n")
    }
  }

  for (ivar in seq_along(vars)) {
    if (is.factor(data[,vars[ivar]])) { 
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Variable to recode is a factor: ", names(data)[vars[ivar]], "\n",
        "Doing this recode would remove the factor attribute.\n\n",
        "Instead, recode with the levels argument of the function: factor.\n",
        "Enter  ?recode  and see last example to illustrate.\n\n")
    }
  }

  # get data frame name
  dname <- deparse(substitute(data))

  if (!quiet) {
    cat("\n")
    .dash(56)
    cat("First four rows of data to recode for data frame:", dname, "\n")
    .dash(56)
    print(head(data[, vars, drop=FALSE], n=4))
    cat("\n")
  } 

  for (ivar in seq_along(vars)) {
    # get actual variable name before potential call of data$x
    x.name <- names(my.vars)[vars[ivar]]
    options(xname = x.name)

    # Under new convention: data=NULL means global env; recode requires
    # a data frame
    if (dname == "NULL") {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Only variables in a data frame are processed.\n",
          "Set  data=  to the name of the data frame.\n\n")
    }

    # see if variable exists in data frame, if x not in style Env or
    # function call
    .xcheck(x.name, dname, names(data))

    x.call <- as.vector(eval(substitute(data[,vars[ivar]])))

    n.obs <- nrow(data)
    new.x <- .rec.main(x.call, x.name, new_vars[ivar], old, new, ivar,
                        n.obs, dname, quiet)

    # insert transformation into data
    new.var <- new_vars[ivar]
    nm <- names(data)
    if (is.null(new.var))
      data[, which(nm == x.name)] <- new.x
    else {
      data <- cbind(data, new.x)
      names(data) <- c(nm, new.var)
    }

  }  # recode loop

  if (!quiet) {
    nn <- length(new_vars)
    new.index <- integer(length=nn)
    if (nn > 0) for (i in seq_len(nn))
      new.index[i] <- which(names(data)==new_vars[i])
    cat("\n\n")
    .dash(48)
    cat("First four rows of recoded data\n")
    .dash(48)
    print(head(data[, c(vars, new.index), drop=FALSE], n=4))
    cat("\n")
  } 
 
  invisible(data)

}

corReflect <- 
function (R=mycor, vars,
          main=NULL, heat_map=TRUE, bottom=NULL,right=NULL, 
          pdf_file=NULL, width=5, height=5, ...) {


  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (!is.null(dots)) if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (length(grep(".", names(dots)[i], fixed=TRUE)) > 0) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
      }
    }
  }

  if (!("matrix" %in% class(R))) { # R is a matrix, can be called indirectly
    # cor matrix:  mycor as class out_all, mycor$R, or stand-alone matrix
    cor.nm <- deparse(substitute(R))
    .cor.exists(cor.nm)  # see if matrix exists in one of the 3 locations
    if ("out_all" %in% class(R))    # R 4.0 results in two values: matrix, array
      R <- eval(parse(text=paste(cor.nm, "$R", sep="")))  # go to $R
  }

  # translate variable names into column positions
  vars.all <- as.list(seq_along(as.data.frame(R)))
  names(vars.all) <- names(as.data.frame(R))
  vars.num <- eval(substitute(vars), vars.all, parent.frame())

  NVOld <- as.integer(nrow(R))
  NVC <- as.integer(length(vars.num))

  Label <- as.integer(as.vector(vars.num))

  for (LL in 1:NVC) {
    for (J in 1:NVOld) {
      if (Label[LL] != J) {
        R[J,Label[LL]] <- -R[J,Label[LL]]
        R[Label[LL],J] <- R[J,Label[LL]]
      }
    }
  }

  if (heat_map) {
    if (is.null(main)) main <- "With Reflected Item Coefficients"
    .opendev(pdf_file, width, height)  # set up graphics
    .heatmap(R, NVOld, main, bottom, right, diag=0,
               pdf_file, width, height)
  }

  cat("\n")
  return(invisible(R))
}

.logit4Pred <-
function(lm.out, nm, d, my_formula, brief, res_rows,
         n.vars, n.pred, n.obs, n.keep, pt_size, transparency,
         digits_d, pre, line,
         new.data, pred, pred_all, prob_cut, 
         in.data.frame, X1_new, 
         X2_new, X3_new, X4_new, X5_new, X6_new,
         xlab, ylab, pdf_file, width, height, ...) {


  # ----------
  # prediction
  # ----------

  for (i.cut in 1:length(prob_cut)) {

    # if length of prob_cut > 1, additional values for confusion matrix only
    # p.cut  for pred output, equal to prob_cut if only 1 value
    # prob_cut for confusion matrices
    if (i.cut == 1) {

      if (length(prob_cut) == 1)
        p.cut <- prob_cut[1]
      else
        p.cut <- 0.5
    }
    else
      p.cut <- prob_cut[i.cut]

    # get output pred table, with label
    if (!new.data) {
      p.int <- data.frame(predict(lm.out, type="response", se.fit=TRUE))


      # classify
      label <- integer(length=nrow(p.int))
      for (irow in 1:nrow(p.int))
        label[irow] <- ifelse (p.int$fit[irow] < p.cut, 0, 1)
      out <- cbind(lm.out$model[c(nm[-1], nm[1])], label,
                   p.int$fit, p.int$se.fit)
    }  # end !new.data

    else {  # new data
      Xnew.val <- list(X1_new)
      if (n.vars > 2) for (i in 2:(n.pred)) {
        pp <- eval(parse(text=paste("X", toString(i),"_new",sep="")))
        Xnew.val <- c(Xnew.val, list(pp))
      }
      Xnew <- expand.grid(Xnew.val)
      for (i in 1:(n.pred)) names(Xnew)[i] <- nm[i+1]

      p.int <- data.frame(predict(lm.out, type="response",
                          se.fit=TRUE, newdata=Xnew))

      # classify
      label <- integer(length=nrow(p.int))
      for (i in 1:nrow(p.int))
        label[i] <- ifelse (p.int$fit[i] < p.cut, 0, 1)

      Ynew <- character(length=nrow(Xnew))  # blank Y column for new data
      out <- cbind(Xnew, Ynew, label, p.int$fit,p.int$se.fit)
    }

    # display pred output only if on first iteration of prob_cut
    if (i.cut == 1) {
     
      cat("\n\n", "  PREDICTION", "\n\n")

      cat("Probability threshold for classification ",
          levels(lm.out$model[,nm[1]])[2], ":", " ", p.cut, "\n\n", sep="")

      if (is.factor(lm.out$model[,nm[1]]))
        cat(" 0: ", levels(lm.out$model[,nm[1]])[1], "\n",
            " 1: ", levels(lm.out$model[,nm[1]])[2], "\n", sep="")
      cat("\n")

      cat("Data, Fitted Values, Standard Errors\n")
      cat("   [sorted by fitted value]\n")
      if (n.keep > 50 && pred_all == FALSE && !new.data) 
        cat("   [pred_all=TRUE to see all intervals displayed]\n")

      names(out)[n.vars+1] <- "label"
      names(out)[n.vars+2] <- "fitted"
      names(out)[n.vars+3] <- "std.err"
      out <- data.frame(out, stringsAsFactors=TRUE)
      # sort by fitted value to find cases close to the 0.5 threshold
      o <- order(out[,n.vars+2])
      out <- out[o,]

      .dash(68)
      if (n.keep < 25  || pred_all == TRUE || new.data)
        print(out, digits=digits_d)
      else {
        print(out[1:4,], digits=digits_d)
        cat("\n... for the rows of data where fitted is close to 0.5 ...\n\n")
        i.mid <- which.min(abs(0.5-sort(p.int$fit)))  # need out sorted by fit
        if (i.mid < 3) i.mid <- 3              # lower bound guard
        if (i.mid > n.keep - 2) i.mid <- n.keep - 2  # upper bound guard
        print(out[(i.mid-2):(i.mid+2),], digits=digits_d)
        cat("\n... for the last 4 rows of sorted data ...\n\n")
        print(out[(n.keep-3):n.keep,], digits=digits_d)
      }
      .dash(68)

      if (!new.data) {
        cat("\n\n")
        cat("----------------------------\n")
        cat("Specified confusion matrices\n")
        cat("----------------------------\n")
        cat("\n")
      }
    }  # end (i.cut == 1)  # pred output


    # confusion matrix, based on prob_cut directly
    if (i.cut > 1) cat("\n\n")
    if (!new.data) {
      if (n.vars == 2) {
        b0 <- lm.out$coefficients[1]
        b1 <- lm.out$coefficients[2]
        x.cut <- (log(prob_cut[i.cut] / (1-prob_cut[i.cut])) - b0) / b1
      }
      else
        x.cut <- NULL
      .logit5Confuse(lm.out, out, n.vars, nm, prob_cut[i.cut], x.cut)
    }
    else  # new.data
      cat("\n\nWith X1_new, etc., no confusion matrix.\n")

  }  # end (i.cut in 1:length(prob_cut))


  # graphics
  if (pred && n.pred==1 && !is.factor(lm.out$model[,nm[2]]) && is.null(X1_new)){

    .opendev(pdf_file, width, height)

    x.values <- lm.out$model[,nm[2]]

    if (!is.factor(lm.out$model[,nm[1]])) 
      lm.out$model[,nm[1]] <- factor(lm.out$model[,nm[1]], levels=0:1)

    y.values <- as.numeric(lm.out$model[,nm[1]])
    min.y <- min(y.values, na.rm=TRUE)
    if (is.null(xlab))
       x.lab <- nm[2]
    else
       x.lab <- xlab
    
    if (is.null(ylab))
       y.lab <- paste("Probability ", nm[1], " = ",
                      levels(lm.out$model[,nm[1]])[2], sep="")
    else
       y.lab <- ylab
    for (i in 1:length(y.values))
      y.values[i] <- ifelse (y.values[i]==min.y, 0, 1) 
 
    # set margins
    max.width <- strwidth(as.character(max(pretty(y.values))), units="inches")
    
    margs <- .plt.marg(max.width, y.lab=y.lab, x.lab=x.lab, main=NULL, sub=NULL)
    lm <- margs$lm+0.2;  tm <- margs$tm;  rm <- margs$rm;  bm <- margs$bm+0.1

    nc <- max(nchar(levels(lm.out$model[,nm[1]])))
    rm <- rm + .076*nc + 0.18

    orig.params <- par(no.readonly=TRUE)
    on.exit(par(orig.params))
    par(bg=getOption("window_fill"))
    par(mai=c(bm, lm, tm, rm))

    # plot
    plot(x.values,y.values, type="n", axes=FALSE, ann=FALSE,
         ylim=c(-.10,1.10), ...)
    usr <- par("usr")

    min.x <- min(x.values, na.rm=TRUE)
    max.x <- max(x.values, na.rm=TRUE)
    .plt.bck(usr, pretty(c(min.x, max.x)), seq(0,1,.2))
    .axes(NULL, NULL, axTicks(1), axTicks(2))

    # right axis, two values of response variable
    ax <- .axes_dim()
    axis(4, at=c(0,1), labels=FALSE,
         col=ax$axis_y_color, lwd=ax$axis_y_lwd, lty=ax$axis_y_lty) 
    text(x=usr[2]+0.07, y=c(0,1), labels=levels(lm.out$model[,nm[1]]),
         pos=4, xpd=TRUE, cex=ax$axis_y_size, col=ax$axis_y_text_color)

    .axlabs(x.lab, y.lab, labels=FALSE, main.lab=NULL, sub.lab=NULL, 
            cex.lab=getOption("lab_size"), cex.main=1.0, ...) 

    fill <- getOption("pt_fill")
    fill <- .maketrans(fill, (1-transparency)*256)
    color <- getOption("pt_color")
    if (n.vars == 2  &&  length(prob_cut) == 1) {
      pc <- prob_cut[1]
      segments(usr[1], pc, usr[2], pc, col="gray35", lty="dashed", lwd=0.5)  
      segments(x.cut, usr[3], x.cut, usr[4], col="gray35", lty="dashed", lwd=0.5)  
    }
    points(x.values, y.values, pch=21, col=color, bg=fill, cex=pt_size)
    ord <- order(x.values)
    lines(x.values[ord], p.int$fit[ord], col=color, lwd=2)

    if (!is.null(pdf_file)) {
      dev.off()
      .showfile(pdf_file, "fitted values and scatter plot")
    }
  }  # end sigmoid plot

  else {  # scatterplot matrix for multiple regression
    if (in.data.frame) {

      .opendev(pdf_file, width, height)

      panel2.smooth <- function (x, y, pch=par("pch"), cex=.9,
        col.pt=getOption("pt_color"), col.smooth=getOption("bar_color"),
        span=2/3, iter=3, ...) 
      {
          usr <- par("usr")          
          rect(usr[1], usr[3], usr[2], usr[4],
               col=getOption("border_fill"), border=getOption("border_color"))
          points(x, y, pch=pch, col=col.pt, bg=getOption("pt_fill"), cex=cex)

          ok <- is.finite(x) & is.finite(y)
          if (any(ok)) 
            lines(lowess(x[ok], y[ok], f=span, iter=iter), col=col.smooth, ...)
      }
      pairs(lm.out$model[c(nm)], panel=panel2.smooth)

      if (!is.null(pdf_file)) {
        dev.off()
        .showfile(pdf_file, "scatter plot matrix")
      }
    }
    else {
      cat("\n\n>>> No scatterplot matrix reported because not all variables are ")
      cat("in the data frame.\n")
    }
  }  # end scatterplot matrix

}

.panel.bwplot <-
function (x, y, box.ratio=1, vbs_size=box.ratio/(1 + box.ratio),
    horizontal=TRUE, alpha=trellis.par.get("box.dot")$alpha,
    fill=box.rectangle$fill, varwidth=FALSE,
    vbs_mean=FALSE, mean_color="darkred", fences=FALSE,
    notch=FALSE, notch.frac=0.5, ...,
    levels.fos=if (horizontal) sort(unique(y)) else sort(unique(x)),
    stats=boxplot.stats, k.iqr=1.5, a=3, b=4,
    do.out=TRUE, identifier="bwplot") {

    stats.nm <- deparse(substitute(stats))

#   requireNamespace(lattice, quietly=TRUE)  # lattice function panel.number()

    x <- as.numeric(x)
    y <- as.numeric(y)  # could be a factor, need numeric version

    # trellis.par.get("box.rectangle")
    box.rectangle <- trellis.par.get("box.rectangle")
    box.umbrella <- trellis.par.get("box.umbrella")
    plot.symbol <- trellis.par.get("plot.symbol")
    fontsize.points <- trellis.par.get("fontsize")$points

    if (!notch)
      notch.frac <- 0

    if (horizontal) {
      if (stats.nm == "boxplot.stats")
        blist <- tapply(x, factor(y, levels=levels.fos), stats,
          coef=k.iqr, do.out=do.out)
      if (stats.nm == "adjboxStats")
        blist <- tapply(x, factor(y, levels=levels.fos), stats,
          coef=k.iqr, a=a, b=b, do.out=do.out)
      blist.stats <- t(sapply(blist, "[[", "stats"))
      blist.out <- lapply(blist, "[[", "out")
      blist.height <- vbs_size
      if (varwidth) {
          maxn <- max(table(y))
          blist.n <- sapply(blist, "[[", "n")
          blist.height <- sqrt(blist.n/maxn) * blist.height
      }
      blist.conf <- if (notch)
          t(sapply(blist, "[[", "conf"))
      else blist.stats[, c(2, 4), drop=FALSE]
      xbnd <- cbind(blist.stats[, 3], blist.conf[, 2], blist.stats[, 4],
         blist.stats[, 4], blist.conf[, 2], blist.stats[, 3],
         blist.conf[, 1], blist.stats[, 2], blist.stats[, 2],
         blist.conf[, 1], blist.stats[, 3])
      ytop <- levels.fos + blist.height/2
      ybot <- levels.fos - blist.height/2
      ybnd <- cbind(ytop - notch.frac * blist.height/2, ytop,
          ytop, ybot, ybot, ybot + notch.frac * blist.height/2,
          ybot, ybot, ytop, ytop, ytop - notch.frac * blist.height/2)
      xs <- cbind(xbnd, NA_real_)
      ys <- cbind(ybnd, NA_real_)

      # box
      # col parameter specifies fill, only accepts one color, ignores others
      # panel.xxx is basically a do-loop, iterating over panels
       panel.polygon(t(xs), t(ys), lwd=box.rectangle$lwd,
          lty=box.rectangle$lty, col=fill[panel.number()],
          alpha=box.rectangle$alpha,
          border=box.rectangle$col,
          identifier=paste(identifier, "box", sep="."))

      # stems
      panel.segments(
          c(blist.stats[, 2], blist.stats[, 4]), rep(levels.fos, 2),
          c(blist.stats[, 1], blist.stats[, 5]), rep(levels.fos, 2),
          col=box.umbrella$col, alpha=box.umbrella$alpha,
          lwd=box.umbrella$lwd, lty=box.umbrella$lty,
          identifier=paste(identifier, "whisker", sep="."))

      # whiskers
      panel.segments(
          c(blist.stats[, 1], blist.stats[, 5]), levels.fos - blist.height/2,
          c(blist.stats[, 1], blist.stats[, 5]), levels.fos + blist.height/2,
          col=box.umbrella$col, alpha=box.umbrella$alpha,
          lwd=box.umbrella$lwd, lty=box.umbrella$lty,
          identifier=paste(identifier, "cap", sep="."))

       if (fences) {
           iqr <- blist.stats[, 4] - blist.stats[, 2]
           m.c <- ifelse(stats.nm == "adjboxStats", mc(x, na.rm=TRUE), 0)
            if (m.c >= 0) {  # equations from ?adjboxStats
              lo30 <- blist.stats[, 2] - 2 * k.iqr * exp(a*m.c) * iqr
              lo15 <- blist.stats[, 2] - k.iqr * exp(a*m.c) * iqr
              up15 <- blist.stats[, 4] + k.iqr * exp(b*m.c) * iqr
              up30 <- blist.stats[, 4] + 2 * k.iqr * exp(b*m.c) * iqr
            }
            else {  # m.c < 0
              lo30 <- blist.stats[, 2] - 2 * k.iqr * exp(-b*m.c) * iqr
              lo15 <- blist.stats[, 2] - k.iqr * exp(-b*m.c) * iqr
              up15 <- blist.stats[, 4] + k.iqr * exp(-a*m.c) * iqr
              up30 <- blist.stats[, 4] + 2 * k.iqr * exp(-a*m.c) * iqr
            }

        s.th <- getOption("sub_theme")
        th <- getOption("theme")
        fence_color <- ifelse (th %in% c("gray", "white") || s.th=="black",
                              "gray85", "darkred")
#       fence_color <- ifelse (s.th == "black", "gray85", box.umbrella$col)
        panel.segments(
            c(lo15, up15), levels.fos - blist.height/2,
            c(lo15, up15), levels.fos + blist.height/2,
            col=fence_color, alpha=box.umbrella$alpha,
            lwd=1.5, lty="solid",
#           lwd=box.umbrella$lwd, lty="dotted",
            identifier=paste(identifier, "cap", sep="."))
      }  # end fences

      panel.segments(  # median
          blist.stats[, 3], levels.fos - blist.height/2,
          blist.stats[, 3], levels.fos + blist.height/2,
          lwd=box.rectangle$lwd, lty=box.rectangle$lty,
          col=box.rectangle$col, alpha=alpha,
          identifier=paste(identifier, "dot", sep="."))

      if (vbs_mean) {
        mx <- mean(x, na.rm=TRUE)
        panel.segments(  # mean
            mx, levels.fos - blist.height/2,
            mx, levels.fos + blist.height/2,
            lwd=2, lty=box.rectangle$lty,
            col=mean_color, alpha=alpha,
            identifier=paste(identifier, "dot", sep="."))
      }

    }  # end horizontal

}

# need to manually adjust the size of y downward because x is a subset
# cannot call panel.xyplot directly because formal arg y has mult args
.panel.stripplot <-
function (x, y, jitter_data=FALSE, factor=0.5, amount=NULL,
    horizontal=TRUE, groups=NULL,  ..., identifier="stripplot") {

    panel.xyplot(x=x, y=y[1:length(x)], jitter.x=jitter_data && !horizontal,
        jitter.y=jitter_data && horizontal, factor=factor,
        amount=amount, horizontal=horizontal,
        ..., identifier=identifier)
}


# for .bar.lattice
# panel.densityplot with an added line for panel.xyarea, parameters fill, color
#panel.dnFill <-
#function (x, fill, color, darg=list(n=512), plot.points="jitter", ref=FALSE,
    #groups=NULL, weights=NULL, jitter_amount=0.01 * diff(current.panel.limits()$ylim),
    #type="p", ..., identifier="density")
#{
    #if (ref) {
        #reference.line <- trellis.par.get("reference.line")
        #panel.abline(h=0, col=reference.line$col, lty=reference.line$lty,
            #lwd=reference.line$lwd, identifier=paste(identifier,
                #"abline"))
    #}
    #if (!is.null(groups)) {
        #panel.superpose(x, darg=darg, plot.points=plot.points,
            #ref=FALSE, groups=groups, weights=weights,
            #panel.groups=panel.densityplot, jitter_amount=jitter_amount,
            #type=type, ...)
    #}
    #else {
        #switch(as.character(plot.points), `TRUE`=panel.xyplot(x=x,
            #y=rep(0, length(x)), type=type, ..., identifier=identifier),
            #rug=panel.rug(x=x, start=0, end=0, x.units=c("npc",
                #"native"), type=type, ..., identifier=paste(identifier,
                #"rug")), jitter=panel.xyplot(x=x, y=jitter(rep(0,
                #length(x)), amount=jitter_amount), type=type,
                #..., identifier=identifier))
        #density.fun <- function(x, weights, subscripts=TRUE,
            #darg, ...) {
            #do.call("density", c(list(x=x, weights=weights[subscripts]),
                #darg))
        #}
        #if (sum(!is.na(x)) > 1) {
            #h <- density.fun(x=x, weights=weights, ..., darg=darg)
            #lim <- current.panel.limits()$xlim
            #id <- h$x > min(lim) & h$x < max(lim)
            #panel.lines(x=h$x[id], y=h$y[id], col=color, ..., identifier=identifier)
            #panel.xyarea(x=h$x[id], y=h$y[id], col=fill, ..., identifier=identifier)
        #}
    #}
#}

.hier.plotly <- function(
  nd = NULL,               # pre-aggregated node table (non-faceted call)
  nd_byfac = NULL,         # named list of nd tables, one per facet level
  x_name = "X", by_name = "Group", facet_name = "Facet",
  type = "sunburst",
  stat_label = NULL,       # hover-text label for the statistic
  non_additive = FALSE,    # TRUE for mean/median/etc.; controls label fmt
  n_levels = 1L,           # depth: 1 = no by-grouping; 2+ = nested
  has_y    = TRUE,         # was y supplied? affects title layout & digits
  fill_vec = NULL,         # pre-resolved hex vec keyed by top.level (Chart)
  fill_vec_byfac = NULL,   # per-facet hex vec (Chart, faceted only)
  border = NULL,
  digits_d = NULL,
  facet_opts = .plotly_facet_opts(),
  main = NULL,
  title_x = NULL,
  show_labels = TRUE,
  labels = c("input", "%", "prop", "off"),
  labels_position = c("in", "out"),
  labels_color = "white",
  labels_size  = 0.75,
  ...
) {

  # local aliases for the dot-named internals used downstream
  non.additive <- isTRUE(non_additive)
  stat.label   <- stat_label

  title.size <- round(16 * getOption("main_size", 1))
  sub.size   <- round(13 * getOption("main_size", 1))


# add trace function ------------------------------------------------------

  make.trace <- function(p, nd, domain_xy) {
    if (non.additive && isTRUE(digits_d == 0)) digits_d <- digits_d + 2  # mean, etc.

    digits <- if (is.null(digits_d)) 2L else max(0L, as.integer(digits_d))
    fmt.spec <- paste0("%{customdata.stat:,.", digits, "f}")

    # Use texttemplate (accesses customdata on all nodes including parents with
    # values=0) rather than textinfo+text (treemaps suppress text on value=0 nodes).
    # "prop" also needs texttemplate to display raw proportion (not percentage).
    use.template <- show_text && (
      (non.additive && !identical(labels, "off")) ||
      identical(labels, "prop") ||
      identical(labels, "input")
    )

    txtinfo <- if (!show_text) "none"
               else switch(labels,
                 "input" = "none",   # value drawn via texttemplate below
                 "%"     = "label+percent root",
                 "prop"  = "none",   # handled by texttemplate below
                 "off"   = "label",  # label name only, no value/stat
                 "label"
               )

    texttemplate.str <- if (!use.template) NULL
      else if (identical(labels, "prop"))
        "%{label}<br>%{percentRoot:.3f}"                      # raw proportion
      else
        paste0("%{label}<br>", fmt.spec)                      # stat value

    stat.line <- paste0(
      stat.label, ": %{customdata.stat:,.", digits, "f}"
    )

    pct.parent.line <- if (non.additive) ""
                       else "% of parent: %{percentParent:.2%}"

    hover.lines <- c(
      "%{customdata.meta}",
      stat.line,
      pct.parent.line,
      "% of total: %{percentRoot:.2%}"
    )

    hover <- paste(hover.lines[nzchar(hover.lines)], collapse = "<br>")
    hover <- paste0(hover, "<extra></extra>")

    # map top-level category -> color, then inherit down the tree
    # use fill.vec's own names so per-facet overrides (fill_vec_byfac)
    # keep their own ordering rather than borrowing the global top.levels
    col.map   <- setNames(as.character(fill.vec), names(fill.vec))
    node.cols <- unname(col.map[as.character(nd$root)])
    node.cols[is.na(node.cols)] <- unname(col.map[1L])  # fallback if any NA

    n.nodes <- length(nd$ids)
    marker <- list(
      colors = node.cols,
      line   = list(
        color = I(rep(border.hex, n.nodes)),
        width = I(rep(1,          n.nodes))
      )
    )

    plt.out <- plotly::add_trace(
      p,
      type             = type,
      ids              = nd$ids,
      labels           = nd$labels,
      parents          = nd$parents,
      values           = nd$values,
      customdata       = nd$customdata,
      domain           = list(x = domain_xy$x, y = domain_xy$y),
      branchvalues     = "remainder",
      textinfo         = txtinfo,
      texttemplate     = texttemplate.str,
      textfont         = list(size = label.fsize, color = labels_color),
      hovertemplate    = hover,
      marker           = marker
    )
    plt.out
  }  # end make.trace()


# begin analysis ----------------------------------------------------------

  labels          <- match.arg(labels)
  labels_position <- match.arg(labels_position)

  # final flag that controls text on/off for nodes
  # "off" still shows label only — show_text stays TRUE for all label values
  show_text <- isTRUE(show_labels)

  # simple font scaling (same base as other lessR plotlys)
  base.font   <- 18
  label.fsize <- base.font * labels_size *
                   getOption("axis_size", 0.9)


# aggregated node tables (nd / nd_byfac), non.additive, stat.label all
# come pre-built from Chart() via .hier_aggregate(). No data prep here.


# assign colors ----------------------------------------------------------
# Colors arrive pre-resolved from Chart() via .hier_color_resolve(). The
# names of fill_vec are the top-level categories in their final (sorted)
# display order. Per-facet remapping is supplied separately by Chart.

  fill.vec   <- fill_vec
  top.levels <- names(fill.vec)

  # border color, one color for all nodes; consistent with prior behavior
  border.hex <- .to_hex(if (is.null(border)) "white" else border[1L])


# start plot & set base colorway (still used by Plotly defaults) ----------

  p <- plotly::plot_ly()
  p <- plotly::layout(p, colorway = fill.vec)

title_x <- if (is.null(title_x)) {
  if (identical(type, "icicle")) {
    if (!is.null(nd_byfac))  0.50
    else if (n_levels > 1L)  0.64
    else                     0.71
  }
  else 0.50
} else {
  as.numeric(title_x)
}


# -------------------------------------------------------------------------
# non-faceted -------------------------------------------------------------

  if (is.null(nd_byfac)) {
    dom.y.top <- if (identical(type, "sunburst")) 0.95 else 1
    p <- make.trace(p, nd, list(x = c(0, 1), y = c(0, dom.y.top)))

    ttl.text <- main

    # For treemaps, plotly's built-in title expands the top margin based on
    # label font size, squeezing the chart unpredictably. Instead, use an
    # annotation positioned in paper coordinates — full control, no side effects.
    if (type %in% c("treemap", "icicle") && !is.null(ttl.text)) {
      # two-line titles (non.additive with y) need more top space
      has.sub <- grepl("<br>", ttl.text, fixed = TRUE)
      t.px    <- if (has.sub) round(title.size * 2.4)
                 else          round(title.size * 2.1)

      # single annotation with yanchor="bottom" keeps both lines above y=1,
      # entirely in the top margin — never overlaps the treemap "All" rectangle.
      if (has.sub) {
        parts    <- strsplit(ttl.text, "<br>", fixed = TRUE)[[1]]
        ttl.text <- paste0(
          "<span style=\"font-size:16px\">", parts[1], "</span>",
          "<br>",
          "<span style=\"font-size:13px\">", parts[2], "</span>"
        )
      }
      title.anns <- list(list(
        text      = ttl.text,
        x        =title_x, xref="paper", xanchor="center",
        y        =1,       yref="paper", yanchor="bottom",
        showarrow=FALSE,
        font     =list(size=title.size)
      ))

      p <- plotly::layout(p,
        margin     =list(t=t.px, b=8, l=20, r=20),
        annotations = title.anns
      )
    } else {
      p <- plotly::layout(
        p,
        margin = list(
          t = round(title.size * 2.0),
          b = 8,
          l = 20,
          r = if (identical(type, "icicle")) 30 else 20
        ),
        title = list(
          text = ttl.text,
          font = list(size = title.size),
          x = title_x,
          xanchor = "center",
          y = if (!has_y) 0.97 else 1.00,
          yanchor = "top"
        )
      )
    }

    # Ensure unique htmlwidget id (REQUIRED for knitting)
    if (is.null(p$elementId)) {
      p$elementId <- paste0(
        "lessr-hier-",
        format(Sys.time(), "%Y%m%d%H%M%OS3"),
        "-",
        sample.int(1e5, 1)
      )
    }

    return(p)
  }



# -------------------------------------------------------------------------
# faceted -----------------------------------------------------------------

  # facet level order is set by Chart()/.hier_aggregate() via nd_byfac names
  fac.levels <- names(nd_byfac)
  n.fac      <- length(fac.levels)

  # gaps are literal; facet_size scales each panel within its grid cell
  # (the shared rule in .plotly_make_domains_grid, matching .radar.plotly)
  gx <- max(0, as.numeric(facet_opts$gap_x))
  gy <- max(0, as.numeric(facet_opts$gap_y))

  # per-type domain and annotation tweaks
  if (type == "treemap") {
    dom_adj <- function(d) {
      span <- d$y[2] - d$y[1]
      new.y0 <- max(0, d$y[1] - 0.06)
      new.y1 <- new.y0 + span
      if (new.y1 > 1) { new.y1 <- 1; new.y0 <- new.y1 - span }
      list(x = d$x, y = c(new.y0, new.y1), row = d$row, col = d$col)
    }
    ann_adj <- function(i, a, d) {
      a$y <- min(d$y[2] - 0.025, 0.99); a$x <- mean(d$x); a
    }
    rev_dom <- TRUE
  } else if (type == "icicle") {
    dom_adj <- function(d) {
      span <- d$y[2] - d$y[1] * 1.12   # lengthen span a bit
      new.y1 <- max(0, d$y[2] - 0.10)
      new.y0 <- max(0, new.y1 - span)
      if (new.y1 > 1) { new.y1 <- 1; new.y0 <- new.y1 - span }
      list(x = d$x, y = c(new.y0, new.y1), row = d$row, col = d$col)
    }
    ann_adj <- function(i, a, d) {
      a$y <- min(d$y[2] + 0.02, 0.99)
      a$x <- a$x + 0.10; a$xanchor <- "right"; a$yref <- "paper"; a
    }
    rev_dom <- FALSE
  } else {  # sunburst
    dom_adj <- function(d) {
      span <- d$y[2] - d$y[1]
      new.y1 <- min(1, d$y[2] - 0.06)
      new.y0 <- max(0, new.y1 - span)
      list(x = d$x, y = c(new.y0, new.y1), row = d$row, col = d$col)
    }
    ann_adj <- function(i, a, d) {
      a$y <- min(d$y[2] - 0.025, 0.99); a$x <- mean(d$x); a
    }
    rev_dom <- FALSE
  }

  lay <- .plotly_facet_layout(
    n_fac           = n.fac,
    facet_levels    = fac.levels,
    facet_name      = facet_name,
    n_col_max       = facet_opts$n_col_max,
    gap_x           = gx, gap_y = gy,
    facet_size      = facet_opts$facet_size,
    domain_adjust   = dom_adj,
    reverse_domains = rev_dom,
    y_base          = facet_opts$title_y_base,
    y_row_shift     = facet_opts$title_row_shift,
    yanchor         = "bottom",
    ann_adjust      = ann_adj
  )
  domains <- lay$domains
  ann     <- lay$annotations


# add traces for each facet -----------------------------------------------

  for (i in seq_along(fac.levels)) {
    fac.lab <- fac.levels[i]
    nd      <- nd_byfac[[fac.lab]]

    # per-facet luminance remap is supplied by Chart() via fill_vec_byfac
    if (!is.null(fill_vec_byfac) && !is.null(fill_vec_byfac[[fac.lab]]))
      fill.vec <- fill_vec_byfac[[fac.lab]]

    # domain order is already reversed for treemap by .plotly_facet_layout(),
    # so straight indexing here works for all three types
    if (nrow(nd) > 0L)
      p <- make.trace(p, nd, domains[[i]])
  }

  ttl.text <- main

  # if two-line title, render subtitle smaller than main line
  if (!is.null(ttl.text) && grepl("<br>", ttl.text, fixed = TRUE)) {
    parts    <- strsplit(ttl.text, "<br>", fixed = TRUE)[[1]]
    ttl.text <- paste0(
      "<span style=\"font-size:", title.size, "px\">",
      parts[1], "</span>",
      "<br>",
      "<span style=\"font-size:", sub.size, "px\">",
      parts[2], "</span>"
    )
  }


  # Plot --------------------------------------------------------------------

  t.margin <- round(title.size * 2.8)

  p <- plotly::layout(
    p,
    annotations = ann,
    margin = list(
      t = if (identical(type, "treemap")) t.margin - 5 else t.margin,
      b = 8,
      l = if (identical(type, "icicle")) 0.00 else 10,
      r = if (identical(type, "icicle")) 30 else 20
    ),
    title = list(
      text = ttl.text,
      font = list(size = title.size),
      x = if (identical(type, "icicle")) 0.55 else title_x,
      xanchor = "center"
    )
  )

  # plotly auto-expands the top margin based on trace label font sizes —
  # lock it back to the intended value after layout is built
  if (!is.null(p$x$layout$margin))
    p$x$layout$margin$t <- t.margin

  p$elementId <- paste0(
    "lessr-hier-",
    format(Sys.time(), "%Y%m%d%H%M%OS3"),
    "-",
    sample.int(1e5, 1)
  )

  p   # last expression returned
}

.plt.colors <-
function(object, nn_col, n.by, segments, theme, fill, fill.miss,
            color, color.miss, area_fill, area_fill.miss, trans, stack,
            n.ycol, n.y_var, ord.by.call, run, size.pt) {

  n.clrs <- max(nn_col, n.by)  # n_col goes to lattice

  ### area fill
  ### ---------

  if (segments) {

    # fill can substitute for area_fill if no points
    if (!fill.miss && area_fill.miss && all(size.pt==0)) {
      area_fill <- fill
      area_fill.miss <- FALSE
      fill.miss <- TRUE
    }

    if (!is.null(area_fill) && area_fill[1] == "on") {  # "on" only applies to one value
      if (n.y_var == 1)
        area_fill <- getOption("violin_fill")
      else
        area_fill <- .get_fill()
    }

    if (!("transparent" %in% area_fill)) {
      if (!stack && n.ycol > 1)  {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Filling a color for the areas under multiple curves only\n",
          "  meaningful if the curves are stacked on each other,\n",
          "  so set:  stack=TRUE.\n\n")
      }
    }

    if (n.clrs > 1) {
      if (!run) {  # area_fill for multiple run plots not meaningful
        if ("transparent" %in% area_fill) {
          qual_pal <- ifelse (theme %in% c("gray", "white"), "grays", "hues")
          area_fill <- getColors(qual_pal, n=n.clrs, output=FALSE)
        }
        else
          area_fill <- .color_range(area_fill, n.clrs)  # interpret blues, etc
      }


      color <- .plt.fill(color, color.miss, ord.by.call, n.clrs, n.clrs, theme)

      if (object=="both"  &&  color.miss  &&  all(area_fill!="transparent")) {
        color <- area_fill
        color.miss <- FALSE
      }
    }  # end n.clrs > 1

    if ((trans > 0)) {  # default fill trans is 0.1
       if (!is.null(area_fill) && area_fill[1] != "transparent") {
         # only expand to n.clrs colors if not already done above
         if (n.clrs <= 1 || run)
           area_fill <- .color_range(area_fill, n.clrs)
         area_fill <- .maketrans(area_fill, (1-trans)*256)
       }
    }

  }  # end segments  --- area_fill


  ### fill and color
  ### --------------

  # with multiple colors and either just fill or color specified,
  #   need both fill and color to be the same unless one is "transparent"
  if (n.clrs > 1) {
    if (fill.miss && !color.miss) {
      if (!("transparent" %in% color)) {
        fill <- color
        fill.miss <- FALSE
      }
    }
    if (!fill.miss && color.miss) {
      if (!("transparent" %in% fill)) {
        color <- fill
        color.miss <- FALSE
      }
    }
  }

  nmC <- c("reds", "rusts", "browns", "olives", "greens", "emeralds",
          "turquoises", "aquas", "blues", "purples", "violets",
          "magentas", "grays")
  nmR <- c("rainbow", "heat", "terrain")
  nmV<- c("viridis", "cividis", "plasma", "spectral")
  nmO<- c("Okabe-Ito")
  nmD<- c("distinct")
  nmT <- c("Tableau")
  nm <- c(nmC, nmR, nmV, nmO, nmD, nmT)

  # set pt_fill
  color_done <- FALSE
  if (fill.miss) {
    if (n.clrs == 1)
      pt_fill <- getOption("pt_fill")
    else
      pt_fill <- .color_range(.get_fill(), n.clrs)
  }
  else {
    if (!(fill[1] %in% c("hues", nm)))  # if a by var, then length(fill) > 1
      pt_fill <- fill
    else {
      pt_fill <- .color_range(fill, n.clrs)
      pt_color <- rep("transparent", n.clrs)
      color_done <- TRUE
    }
  }

  if (trans > 0)  # default fill trans is 0.1
    pt_fill <- .maketrans(pt_fill, (1-trans)*256)

  # set pt_color, could also be line color if time series
  if (!color_done) {
    if (color.miss) {
      if (n.clrs == 1)
        pt_color <- getOption("pt_color")
      else
        pt_color <- .color_range(.get_fill(), n.clrs)  # see if range
    }
    else
      pt_color <- color
  }

  return(list(pt_fill=pt_fill, pt_color=pt_color, area_fill=area_fill))

}

prob_norm <- 
function(lo=NULL, hi=NULL, mu=0, sigma=1, nrm_color="black", 
         fill_nrm="grey91", fill_int="slategray3", 
         ylab="", y_axis=FALSE, z=TRUE, axis_size=.9,
         pdf_file=NULL, width=5, height=5, ...) { 


  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (!is.null(dots)) if (length(dots) > 0) {
    change <- c("nrm.color", "fill.nrm", "fill.int",
                "y.axis", "axis.size", "pdf.file")
    for (i in 1:length(dots)) {
      if (names(dots)[i] %in% change) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
        get(nm)
      }
    }
  }

  if (!is.null(lo) & !is.null(hi)) { 
    if (lo > hi) { 
      cat("\n"); stop(call.=FALSE, "\n","------\n",
      "lo = ", lo, " cannot be larger than hi= ", hi, ".", "\n\n")
    }
  }

  if (sigma <= 0) { 
    cat("\n"); stop(call.=FALSE, "\n","------\n",
    "Sigma, the population standard deviation, must be larger than zero.\n\n")
  }

  dots <- list(...)  # check for deprecated parameters
  if (length(dots) > 0) {
    for (i in 1:length(dots)) {
      if (substr(names(dots)[i], 1, 4) == "col.") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "options that began with the abbreviation  col  now begin with  ",
          "color \n\n")
      if (names(dots)[i] == "mag")  axis_size <- dots[[i]]
      }
    }
  }

  if (!is.null(pdf_file))
    if (!grepl(".pdf", pdf_file)) pdf_file <- paste(pdf_file, ".pdf", sep="")
 
  if (mu==0  && sigma==1) z <- FALSE
 
  if (is.null(lo)) {
    lo <- mu - sigma*10
    lo.lbl <- "..."
  }
  else
    lo.lbl <- as.character(lo)
  if (is.null(hi)) {
    hi <- mu + sigma*10
    hi.lbl <- "..."
  }
  else hi.lbl <- as.character(hi)  

  
  # normal density curve
  .opendev(pdf_file, width, height)

  orig.params <- par(no.readonly=TRUE)
  par(mar=c(3,2,1.75,2), mgp=c(1,.5,0))


  min_x <- mu - 4*sigma
  max.x <- mu + 4*sigma
  cuts <- seq(min_x,max.x,sigma)
  x <- seq(min_x, max.x, length=200)
  d.nrm <- dnorm(x,mu,sigma)
  plot(x, d.nrm, type="l", col=nrm_color, axes=FALSE, xlab="", ylab="", ...)
  polygon(c(min_x,x,max.x), c(0,d.nrm,0), col=fill_nrm)

  axis(side=1, at=cuts, cex.axis=axis_size)
  if (z) axis(side=1, at=cuts, cex.axis=axis_size, line=1.5,
              labels=-4:4, lwd=0, lwd.ticks=0)
  if (y_axis) {
    axis(side=2, cex.axis=axis_size)
    if (ylab == "") ylab="Normal Density"
    title(ylab=ylab)
  }

  # plot an interval
  y.lo <- dnorm(lo, mu, sigma)
  y.hi <- dnorm(hi, mu, sigma)
  xsub <- x[x>lo & x<hi]
  ysub <- d.nrm[x>lo & x<hi]
  polygon(c(lo,xsub,hi), c(0,ysub,0), col=fill_int)
  
  # prob of interval
  prob <- pnorm(hi, mean=mu, sd=sigma) - pnorm(lo, mean=mu, sd=sigma)
  
  # decorate
  lbl1 <- paste(" Prob =", toString(signif(prob, 4)))
  lbl2 <- paste(" for Y from", lo.lbl, "to", hi.lbl)
  title(main=paste(lbl1,lbl2), ...)
  lbl3 <- bquote(paste(mu, "=", .(mu), "  ", sigma, "=", .(sigma)))
  if (z) title(sub=lbl3, line=4, ...) else title(sub=lbl3, ...)

  # terminate pdf graphics system
  par(orig.params)        
  if (!is.null(pdf_file)) {
    dev.off()
    .showfile(pdf_file, "Normal curve probability")
  }

  cat("Probability: ", prob, "\n")
  return(invisible(prob))

}

ttest <-
function(x=NULL, y=NULL, data=d, filter=NULL, paired=FALSE,

         n=NULL, m=NULL, s=NULL, mu=NULL,
         n1=NULL, n2=NULL, m1=NULL, m2=NULL, s1=NULL, s2=NULL,

         Ynm="Y", Xnm="X", X1nm="Group1", X2nm="Group2", xlab=NULL,

         brief=getOption("brief"), digits_d=NULL, conf_level=0.95,
         alternative=c("two_sided", "less", "greater"),
         mmd=NULL, msmd=NULL, Edesired=NULL,

         show_title=TRUE, full_curve=TRUE, bw1="bcv", bw2="bcv", pt_size=0.8,
         fill=NULL, area_fill="on",

         graph=TRUE, line_chart=FALSE, quiet=getOption("quiet"),
         width=5, height=5, pdf_file=NULL, ...)  {

  # area_fill="off"/"transparent" draws density curves as lines only (plotly)
  fill_area <- !(area_fill[1] %in% c("off", "transparent"))


tt.setup <-
function(x, y=NULL, ...) {

  # keep track of generated graphics from tt.setup
  plot.i <- 0
  plot.title  <- character(length=0)

  cat("\n")
  if (missing(y))
    no.y <- TRUE
  else
    if (is.null(y)) no.y <- TRUE else no.y  <- FALSE
  if (is.null(n1) && no.y) two.gp <- FALSE else two.gp <- TRUE
  if (is.null(n) && is.null(n1)) from.data <- TRUE else from.data <- FALSE

  if (!from.data) graph <- FALSE

  if (is.null(digits_d)) {
    if (from.data) digits_d <- .max.dd(x)
    else {
      digits_d <- 0
      if (!is.null(m)) if (.max.dd(m) > digits_d) digits_d <- .max.dd(m)
      if (!is.null(s)) if (.max.dd(s) > digits_d) digits_d <- .max.dd(s)
      if (!is.null(m1)) if (.max.dd(m1) > digits_d) digits_d <- .max.dd(m1)
      if (!is.null(m2)) if (.max.dd(m2) > digits_d) digits_d <- .max.dd(m2)
      if (!is.null(s1)) if (.max.dd(s1) > digits_d) digits_d <- .max.dd(s1)
      if (!is.null(s2)) if (.max.dd(s2) > digits_d) digits_d <- .max.dd(s2)
    }
    digits_d <- digits_d + 1
    if (digits_d < 3) digits_d <- 3
  }
  options(digits_d=digits_d)
  if (digits_d > 10) {
    cat("\nThese data contain", digits_d, "significant digits.\n")
    cat("Perhaps specify less digits to display with the  digits_d ",
        " parameter.\n\n")
  }

  if (two.gp) {
    options(yname=Ynm)

    if (from.data) {

      if ( (length(x) < 2) || (length(y) < 2) )  {
       cat("\n"); stop(call.=FALSE, "\n","------\n",
         "Need at least two cases (observations) per sample.\n\n")
      }

      if ( !is.null(mmd) && !is.null(msmd) )  {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
         "Specify only one of mmd and msmd as one implies the other.\n\n")
      }

      # Always put the group with the largest mean first
      if (mean(x, na.rm=TRUE) > mean(y, na.rm=TRUE))
        plt2 <- .TwoGroup(x, y, n1, n2, m1, m2, s1, s2, from.data,
          Ynm, Xnm, X1nm, X2nm, brief, digits_d,
          conf_level, alternative, mmd, msmd, Edesired, bw1, bw2,
          graph, xlab, line_chart, show_title,
          full_curve=full_curve, quiet, pdf_file, width, height,
          fill=fill, fill_area=fill_area)
      else {  # switch
        Xtmp <- X2nm
        X2nm <- X1nm
        X1nm <- Xtmp
        plt2 <- .TwoGroup(y, x, n1, n2, m1, m2, s1, s2, from.data,
          Ynm, Xnm, X1nm, X2nm, brief, digits_d,
          conf_level, alternative, mmd, msmd, Edesired, bw1, bw2,
          graph, xlab, line_chart, show_title,
          full_curve=full_curve, quiet, pdf_file, width, height,
          fill=fill, fill_area=fill_area)
      }

      if (!is.null(plt2$i)) {
        for (i in (plot.i+1):(plot.i+plt2$i))
          plot.title[i] <- plt2$ttl[i-plot.i]
        plot.i <- plot.i + plt2$i
      }


    }  # end from data

    else {  # from stats
      .TwoGroup(y, x,
         n1, n2, m1, m2, s1, s2, from.data,
         Ynm, Xnm, X1nm, X2nm, brief, digits_d, conf_level,
         alternative, mmd, msmd, Edesired, bw1, bw2,
         graph=FALSE, xlab=NULL, line_chart=FALSE,
         full_curve=full_curve, quiet=quiet, fill=fill, fill_area=fill_area)
    }
  }  # end two group

  else { # one group, including paired

    if (from.data) {
      if (!paired)
        Ynm <- x.name
      else {
        Ynm <- "Difference"
        mu <- 0
        options(df.name=NULL)
      }

      options(yname=x.name)
      plt1 <- .OneGroup(x, Ynm, mu, n=NULL, m=NULL, s=NULL, brief, bw1,
         from.data, conf_level, alternative, digits_d, mmd, msmd,
         Edesired, paired, graph, xlab, line_chart, show_title, quiet,
         full_curve=full_curve, pdf_file, width, height,
         fill=fill, ...)

    if (!is.null(plt1$i)) {
        for (i in (plot.i+1):(plot.i+plt1$i))
          plot.title[i] <- plt1$ttl[i-plot.i]
        plot.i <- plot.i + plt1$i
      }
    }  # end from data

    else  # from stats
       .OneGroup(x, Ynm, mu, n, m, s, brief, bw1,
         from.data, conf_level, alternative, digits_d, mmd, msmd,
         Edesired, paired, graph, xlab, line_chart, show_title, quiet,
         full_curve=full_curve, pdf_file, width, height,
         fill=fill, ...)
  }  # end one group

  # return number of plots to main
  if (plot.i > 0) return(list(i=plot.i, ttl=plot.title))

}  # end tt.setup


#-----------------------------------
# BEGIN
#-----------------------------------
  alternative <- match.arg(alternative)

  # a dot in a parameter name to an underscore; also handle deprecated mu0
  dots <- list(...)
  if (!is.null(dots)) if (length(dots) > 0) {
    change <- c("digits.d", "conf.level", "show.title", "line.chart",
                "pdf.file")
    for (i in seq_along(dots)) {
      if (names(dots)[i] %in% change) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
        get(nm)
      }
      if (names(dots)[i] == "mu0") mu <- dots[[i]]
    }
  }

  # let deprecated mydata work as default
  dfs <- .getdfs()
  mydata.ok <- FALSE
  if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
    d <- mydata
    mydata.ok <- TRUE
  }

  if (missing(x)  &&  missing(n)  &&  missing(n1)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Must specify a variable to analyze, or provide summary stats.\n\n")
  }

  if (!is.null(Edesired) && conf_level != 0.95) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Edesired calculation only applies to 95% confidence level.\n\n")
  }

  # keep track of generated graphics
  plot.i <- 0
  plot.title  <- character(length=0)

  # get actual variable name before potential call of data$x, could be NULL
  if (!missing(x))
    x.name <- paste(deparse(substitute(x), width.cutoff=120L),
                    collapse="")
  else
    x.name <- NULL
  if (!missing(y))
    y.name <- paste(deparse(substitute(y), width.cutoff=120L),
                    collapse="")

  if (!is.null(x.name)) {
    dfs <- .getdfs()
    mydata.ok <- FALSE
    if (!is.null(dfs)) {
      if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
        d <- mydata
        df.name <- "mydata"
        mydata.ok <- TRUE
        options(dname = df.name)
      }
    }
    if (!mydata.ok) {
      df.name <- deparse(substitute(data))   # get name of data table
      options(dname = df.name)
    }
  }
  else
    df.name <- NULL

  if (!is.null(x.name)) if (exists(x.name, where=.GlobalEnv)) {
    if (is.data.frame(x)) {
      nm <- names((eval(substitute(x))))
      txt <- ifelse(length(nm)>1, "one of those variables", "that variable")
      nm2 <- ""
      for (j in seq_along(nm)) nm2 <- paste(nm2, nm[j])
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "The argument to the ttest function you specified, ", df.name, ", is\n",
        "a data table, not a variable. A data table contains the data values\n",
        "for one or more variables. This data table references the variables:\n\n",
         "  ", nm2, "\n\n",
        "Perhaps you meant to analyze ", txt, ".\n\n")
    }
  }

  if (!missing(filter)) {  # subset rows
    r <- eval(substitute(filter), envir=data, enclos=parent.frame())
    r <- r & !is.na(r)  # set missing for a row to FALSE
    if (!any(r)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "No rows of data with the specified value of\n",
        "filter = ", deparse(substitute(filter)), "\n\n")
    }
    data <- data[r,,drop=FALSE]
  }

  # get conditions and check for data existing
  if (!is.null(x.name)) {

    # if a tibble, convert to data frame
    if (exists(df.name, envir=parent.frame())) {
      if (any(grepl("tbl", class(data), fixed=TRUE)))
        data <- data.frame(data)
    }

    is.frml <- grepl("~", x.name)

    # classify x and y: a computational expression evaluates directly
    x.is.expr <- !is.frml && .is_expr_arg(substitute(x))
    y.is.expr <- !missing(y) && .is_expr_arg(substitute(y))

    if (is.frml) if (!mydata.ok) .nodf(df.name)  # check to see if df exists
    from.data <- x.name != "NULL"
    in.style <- if (x.is.expr) TRUE
                else df.or.global(x.name, df.name, role="x",
                                  fun.name="ttest")
    if (!missing(y) && !y.is.expr)
      .in.global(y.name, quiet=TRUE)  # stop if expression

    # see if the variable exists in the data frame
    if (from.data && !in.style && !is.frml && !x.is.expr)
      .xcheck(x.name, df.name, names(data))

    # evaluate expression arguments to vectors; a plain-name companion
    #   variable resolves from the data frame, then the caller's
    #   environment
    if (x.is.expr || y.is.expr) {
      caller.env <- parent.frame()
      res.arg <- function(e, e.name, is.e, role) {
        if (is.e) {
          uses.df <- df.name != "NULL" && length(all.vars(e)) > 0L &&
                     any(all.vars(e) %in%
                         tryCatch(names(data),
                                  error=function(x) character(0)))
          .expr_eval(e, e.name, if (uses.df) data else NULL,
                     caller.env, role=role, fun.name="ttest")
        }
        else if (df.name != "NULL" &&
                 e.name %in% tryCatch(names(data),
                                      error=function(x) character(0)))
          data[[e.name]]
        else
          get(e.name, envir=caller.env)
      }
      x <- res.arg(substitute(x), x.name, x.is.expr, "x")
      if (!missing(y))
        y <- res.arg(substitute(y), y.name, y.is.expr, "y")
      in.style <- TRUE  # analyze the evaluated vectors directly
    }
  }

  else {
    is.frml <- FALSE
    from.data <- FALSE
    in.style <- FALSE
  }


  # --------------------------
  # do analysis with  tt.setup
  # plt is the returned number of plots generated

  if (in.style || is.frml || from.data) {

    if (in.style) {
      if (is.function(x))  # var names that are R functions get assigned to style
        plt <- tt.setup(eval(substitute(data$x)), Ynm=x.name, ...)  # 1-group
      else {  # not a function name
        if (!missing(y))
           y.l <- length(y)
        else
           y.l <- 0
        if (!paired)
          if (y.l == 0) {  # 1-group
            plt <- tt.setup(x, ...)
            data <- data.frame(x, stringsAsFactors=TRUE)
          }
          else  {# 2-group
            plt <- tt.setup(x, y,  ...)
            data <- data.frame(x, y, stringsAsFactors=TRUE)
          }
        else {  # paired
          if (length(x)!=length(y))  {
            cat("\n"); stop(call.=FALSE, "\n","------\n",
               "The two columns of data values must be the same size.\n\n")
          }
          diff <- y - x
          plt <- tt.setup(diff, ...)
          data <- data.frame(x, y, stringsAsFactors=TRUE)
        }
      }
    }

    else if (is.frml) {
      # evaluate expression terms, e.g., log(Salary) ~ Gender: each
      #   becomes a column of data named with the expression text, with
      #   the formula rewritten to reference the new columns
      fe <- .formula_expr(x, data, parent.frame(), "ttest")
      x <- fe$formula
      data <- fe$data
      f <- .tt.formula(x, y, data, ...)  # formula
      x <- f$x;  y <- f$y;  Ynm <- f$Ynm;  Xnm <- f$Xnm
      X1nm <- f$X1nm;  X2nm <- f$X2nm
      plt <- tt.setup(x, y, ...)
    }

    else if (from.data) {
      if (!is.numeric((eval(substitute(data$x))))) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "The variable to analyze must be numeric\n\n",
          "The problem is that ", x.name, " does not have numeric values\n",
          "The first value of  ", x.name, "  is ", data[1,x.name],
          ", which is not numeric\n\n")

      }
      if (!missing(y)) {
        y.l <- length(eval(substitute(data$y)))
        if (!is.numeric((eval(substitute(data$y))))) {
          cat("\n"); stop(call.=FALSE, "\n","------\n",
            "Variables separated by a comma must both be numeric\n\n",
            "Perhaps use a tilde, ~, instead of a comma with a\n",
            "  numeric response variable before the tilde and after the\n",
            "  tilde a grouping variable with exactly two unique values\n\n")
        }
      }
      else
         y.l <- 0
      if (!paired) {
        if (y.l == 0)  # 1-group
          plt <- tt.setup(eval(substitute(data$x)), ...)
        else  # 2-group
          plt <- tt.setup(eval(substitute(data$x)), eval(substitute(data$y)),
                          ...)
      }
      else {   # paired
        diff <- eval(substitute(data$y)) - eval(substitute(data$x))
        plt <- tt.setup(diff, ...)
      }
    }

    if (!is.null(plt$i)) {
      for (i in (plot.i+1):(plot.i+plt$i)) plot.title[i] <- plt$ttl[i-plot.i]
      plot.i <- plot.i + plt$i
    }
  }  # in.style || is.frml || from.data

  else
    tt.setup(...)  # analysis from stats

  # --------------------------


  if (paired) {  # scatter plot of both variables, need both vars so do here
    manage.gr <- .graphman()

    if (is.null(pdf_file)) {
      if (manage.gr) {
        if (!line_chart)
          dev.set(which=4)
        else
          dev.set(which=5)
      }
    }
    else
      pdf(file="PairedScatterPlot.pdf", width=width, height=height)

    if (in.style) {
      x.values <- x
      y.values <- y
    }
    else {
      x.values <- eval(substitute(data$x))
      y.values <- eval(substitute(data$y))
    }

    plot.i <- plot.i + 1
    plot.title[plot.i] <- "Differences from Equality"

    # construct x.call
    x.call <- data.frame(x.values, y.values, stringsAsFactors=TRUE)
    names(x.call) <- c(x.name, y.name)
    x.call <- data.matrix(x.call, rownames.force=FALSE)

    # construct y.call, need unique values for Cleveland dot plot
    is.unique <- logical(ncol(data))  # initialed to FALSE
    for(i in seq_len(ncol(data)))
      if ((length(data[,i])==length(unique(data[,i]))) && !is.numeric(data[,i]))
        is.unique[i] <- TRUE
    unq <- which(is.unique)[1]  # choose 1st non-num variable with unique values
    if (!is.na(unq))
      y.call <- factor(data[, unq[1]])
    else { # no non-num var with unique values, so go to row.names
      if (row.names(data)[1] != "1")
        y.call <- factor(row.names(data))
      else
        y.call <- factor(row.names(data), levels=seq_len(nrow(data)))  # proper sort
    }

    # Cleveland two-variable dot plot
    theme <- getOption("theme")
    qual_pal <- ifelse (theme %in% c("gray", "white"), "grays", "hues")
    pt_fill <- getColors(qual_pal, n=2, output=FALSE)
    pt_color <- getColors(qual_pal, n=2, output=FALSE)
    .plt.main(data.frame(x.call, stringsAsFactors=TRUE),
              data.frame(y.call, stringsAsFactors=TRUE), cat.y=TRUE,
              fill=pt_fill, color=pt_color,
              shape=21, size=pt_size, ylab="", segments_y=TRUE,
              use_plotly=FALSE)

    if (!is.null(pdf_file)) {
      dev.off()
      .showfile("PairedScatterPlot.pdf", "scatter plot with changes from diagonal")
      cat("\n\n")
    }

  }  # end paired


  if (!paired) cat("\n")

  if (is.null(options()$knitr.in.progress))
    if (plot.i > 1) .plotList(plot.i, plot.title)  # list plots generated

  if (is.frml) {
    if (mean(x, na.rm=TRUE) > mean(y, na.rm=TRUE))
      return(invisible(list(value1=X1nm, group1=x, value2=X2nm, group2=y)))
    else
      return(invisible(list(value1=X2nm, group1=y, value2=X1nm, group2=x)))
  }

}

.plt.forecast <-
function(x, y, by=NULL, exog.df=NULL, ts_new_x=NULL,
         ts_unit=NULL, ts_ahead=0, ts_method=NULL,
         ts_fitted=FALSE, ts_source="fable", n_date_tics=NULL,
         ts_trend=NULL, ts_seasons=NULL, ts_error=NULL,
         ts_alpha=NULL, ts_beta=NULL, ts_gamma=NULL, ts_PI=0.95,
         digits_d=getOption("digits_d"), quiet=getOption("quiet"))  {


  nd <- .max.dd(y[,1])

  if (is.null(digits_d)) digits_d <- .max.dd(y[,1]) + 1
  n.d <- digits_d - 1
  if (n.d <= 2) n.d <- 3

  x.name <- getOption("xname")
  y.name <- names(y)

  # get x.dates, a superset of x.fit for HoltWinters()
  n.by <- ifelse (is.null(by), 0, nlevels(by))
  if (n.by == 0)
    x.dates <- x[,1]  # save actual dates as a vector
  else  # x-axis tics just for one level of by
    x.dates <- x[by == levels(by)[1], 1]

  # when computing x.hat, need the +1 and [-1] to not duplicate last x value
  hold.days7 <- ifelse (ts_unit == "days7", TRUE, FALSE)
  if (hold.days7) ts_unit <- "days"
  x.hat <- seq.Date(x[nrow(x),1], by=ts_unit, length.out=ts_ahead+1)[-1]
  if (hold.days7) ts_unit <- "days7"

  # create time series for stl() for lm and HoltWinters()
  y.ts <- .tsMake(x.dates, y, ts_unit)
  freq <- frequency(y.ts)
  min.2per <- nrow(y) >= (2 * freq)  # evaluate seasonality eligibility
  if (!is.null(ts_seasons)) if (ts_seasons!="N") {
    if (ts_unit == "years")
      message("Seasonal effects are not possible with annual data.")
    else if (!min.2per)
      message("\nSeasonal effects over a year of aggregated data are \n",
              "usually limited to monthly or quarterly data. Usually\n",
              "need two years worth of data to estimate seasonality.\n")
    if (ts_unit=="years" || !min.2per) ts_seasons <- "N"
  }  # end no seasons


  # fable
  # -----
  if (ts_source == "fable")  { 

    .check.packages()  # do needed packages exist?
    .valid.params(ts_method, ts_error, ts_trend, ts_seasons)  # valid params?

    if (!quiet) {
      txt <- "Hyndman and Athanasopoulos's, fpp3 packages]"
      cat("[with functions from", txt, "\n",
          "  -- standard reference: https://otexts.com/fpp3/\n")
    }

    decomp.frm <- NULL  # only passed to Plot() if ts_fitted=TRUE
    out_report <- NULL  # report(fit) implicitly displayed, no need to save 

    # create base data frame, then to tsibble
    d.data <- data.frame(x = x, y = y, check.names = FALSE)
    if (!is.null(exog.df) && ncol(exog.df) > 0)  # add any exog preds
      d.data <- cbind(d.data, exog.df)
    index.var <- names(d.data)[1]
    tsbl <- .to_tsbl(d.data, ts_unit) # index <date>, <week> <mth>, <qtr>, <int>

    # model components
    rhs_terms <- c()
    if (ts_method == "es") {
      if (!is.null(ts_error)) {
        if (ts_error != "N") {
          term <- paste0("error('", ts_error, "'")
          if (!is.null(ts_alpha)) term <- paste0(term, ", alpha = ", ts_alpha)
          term <- paste0(term, ")")
          rhs_terms <- c(rhs_terms, term)
        }
      }
      if (!is.null(ts_trend)) {
        if (ts_trend != "N") {
          term <- paste0("trend('", ts_trend, "'")
          if (!is.null(ts_beta)) term <- paste0(term, ", beta = ", ts_beta)
          term <- paste0(term, ")")
          rhs_terms <- c(rhs_terms, term)
        }
      }
      if (!is.null(ts_seasons)) {
        if (ts_seasons != "N") {
          term <- paste0("season('", ts_seasons, "'")
          if (!is.null(ts_gamma)) term <- paste0(term, ", gamma = ", ts_gamma)
          term <- paste0(term, ")")
          rhs_terms <- c(rhs_terms, term)
        }
      }
    }  # end es
    else if (ts_method == "lm") {
      if (!is.null(ts_trend)) {
        if (ts_trend != "N")
          rhs_terms <- c(rhs_terms, "trend()")
      }
      if (!is.null(ts_seasons)) {
        if (ts_seasons != "N")
          rhs_terms <- c(rhs_terms, "season()")
      }
      if (!is.null(exog.df))
        rhs_terms <- c(rhs_terms, names(exog.df))
    }  # end lm


    # Fit model
    # ----------
    empty_rhs <- is.null(rhs_terms) || length(rhs_terms) == 0L

    if (ts_method == "es") {
      # ----- ETS -----
      if (empty_rhs) {
        fit <- fabletools::model(
          tsbl, ets = do.call(fable::ETS, list(as.name(y.name)))
        )
        fml <- paste(y.name, " [with no specifications]")  # for display only
      }
      else {
        fml <- stats::as.formula(
          paste(y.name, "~", paste(rhs_terms, collapse = " + "))
        )
        fit <- fabletools::model(tsbl, ets = fable::ETS(fml))
      }

    }
    else if (ts_method == "lm") {
      # ----- TSLM -----
      if (empty_rhs) {
        fml <- stats::as.formula(paste(y.name, "~ 1"))
      } else {
        fml <- stats::as.formula(
          paste(y.name, "~", paste(rhs_terms, collapse = " + "))
        )
      }
      fit <- fabletools::model(tsbl, tslm = fable::TSLM(fml))
    }

    # extract the ets model object to check for a NULL model fit
    if (ts_method == "es") {
      model_obj <- fit$ets[[1]]
      model_str <- capture.output(print(model_obj$model))
      if (any(grepl("null_mdl", model_str))) {
        stop(paste(
          'Model fitting failed. Simplify the model such as,\n',
          '      ts_trend="N" and ts_season="N", or use more data.\n\n'
        ), call. = FALSE)
      }
    }

    # display specified and estimated models
    if (ts_method == "es") {
      actual_model_string <- format(fit$ets[[1]])
      components <- gsub("ETS\\(|\\)", "", actual_model_string)
      parts <- strsplit(components, ",")[[1]]
      names(parts) <- c("error", "trend", "season")
      formula_terms <- c()
      formula_terms <- c(formula_terms,
                           paste0('error("', parts["error"], '")'))
      if (parts["trend"] != "N")
        formula_terms <- c(formula_terms,
                           paste0('trend("', parts["trend"], '")'))
      if (parts["season"] != "N")
        formula_terms <- c(formula_terms,
                           paste0('season("', parts["season"], '")'))
      actual_model_expr <- paste0(y.name, " ~ ",
                                  paste(formula_terms, collapse=" + "))
    }
    else if (ts_method == "lm")
      actual_model_expr <- paste(deparse(fit$tslm[[1]]$model$formula),
                                 collapse=" ")

    if (!quiet) {
      cat("\nSpecified model\n---------------\n")
      if (empty_rhs) {
        if (ts_method=="es")
          cat("  ", fml, "\n")
        else if (ts_method=="lm")
          cat("  ", deparse(fml), 
              " [consider adding terms: ts_trend and ts_seasons]\n")
      }
      else 
        cat("  ", deparse(fml), "\n")
      cat("The specified model is only suggested.\n",
          "It may differ from the estimated model.\n\n", sep="")

      cat("Model to be estimated\n---------------------\n")
      cat(actual_model_expr, "\n")
      cat("\n")
    }

    # deconstruct fit instead of rely upon report(fit) to better
    #   order the components 
    if (ts_method == "lm") {
      aug    <- as.data.frame(fabletools::augment(fit)) # decomposition
      resids <- aug$.resid
      MSE    <- mean(resids^2, na.rm = TRUE)
      coefs <- as.data.frame(fabletools::tidy(fit))

      if (!quiet) { 
        cat("Estimated model\n---------------\n")

        model_name <- toupper(coefs$.model[1])
        response_name <- colnames(aug)[3]

        cat(sprintf("Model: %s\n", model_name))
        cat(sprintf("Series: %s\n", response_name))

        df_resid <- sum(!is.na(aug$.resid)) - nrow(coefs)
        t_crit <- qt(0.975, df_resid)
        lower <- coefs$estimate - t_crit * coefs$std.error
        upper <- coefs$estimate + t_crit * coefs$std.error

        unit_label <- sub("s$", "", ts_unit)  # specify the proper unit
        coefs_disp <- coefs  # local copy for display only
        coefs_disp$term <- gsub("season\\(\\)year", unit_label, coefs_disp$term)
        coef_mat <- cbind(
          Estimate     = coefs_disp$estimate,
          "Std. Error" = coefs_disp$std.error,
          "t-value"    = coefs_disp$statistic,
          "p-value"    = round(coefs_disp$p.value, 5),
          "Lower 95%"  = lower,
          "Upper 95%"  = upper
        )
        rownames(coef_mat) <- coefs_disp$term
        cat("\n")
  #     printCoefmat(coef_mat, P.values = FALSE, has.Pvalue = FALSE)

        fmt <- data.frame(
          Estimate     = formatC(coef_mat[,1], format="f", digits=digits_d),
          "Std. Error" = formatC(coef_mat[,2], format="f", digits=digits_d),
          "t-value"    = formatC(coef_mat[,3], format="f", digits=digits_d),
          "p-value"    = formatC(coef_mat[,4], format="f", digits=4),
          "Lower 95%"  = formatC(coef_mat[,5], format="f", digits=digits_d),
          "Upper 95%"  = formatC(coef_mat[,6], format="f", digits=digits_d),
          check.names = FALSE
        )
        rownames(fmt) <- rownames(coef_mat)
        print(fmt, right = TRUE)

        cat("\nModel fit statistics\n--------------------\n")
        gof <- as.data.frame(fabletools::glance(fit))

        cat("Residuals:\n")
        rq <- quantile(resids, probs=c(0, 0.25, 0.5, 0.75, 1), na.rm=TRUE)
        names(rq) <- c("Min", "1Q", "Median", "3Q", "Max")
        print(rq, digits = 4)

        n <- sum(!is.na(resids))
        p <- nrow(coefs)
        df_resid <- n - p
        df_model <- p - 1
        sigma <- gof$sigma
        f_stat <- gof$statistic
        f_pval <- round(gof$p_value, 5)

        cat("\n")
        cat(sprintf("Residual standard error: %.3f on %d degrees of freedom\n",
            sigma, df_resid))
        if (!empty_rhs) {  # no R2 for the null model
          cat(sprintf("Multiple R-squared: %.4f,\tAdjusted R-squared: %.4f\n",
              gof$r_squared, gof$adj_r_squared))
          cat(sprintf("F-statistic: %.2f on %d and %d DF, p-value: %.5f\n",
              f_stat, df_model, df_resid, f_pval))
        }
      } # end !quiet
    }  # end method="lm"

    else if (ts_method == "es") {
      if (!quiet) {
        cat("\nModel analysis\n--------------\n")
        fabletools::report(fit)
      }
      m <- fit$ets[[1]]
      MSE <- m$fit$fit$MSE
    }

    if (!quiet) {
      cat("\nMean squared error of fit to data: ", .fmt_pn(MSE,3))
      cat("\nRoot mean squared error (RMSE) fit:", .fmt_pn(sqrt(MSE),3), "\n\n")
    }

    # get x.fit and y.fit
    fitted.tbl <- fabletools::augment(fit)
    index.var <- tsibble::index_var(fitted.tbl)

    x.fit <- as.character(fitted.tbl[[index.var]])
    if (ts_unit %in% c("days", "days7")) {
      x.fit <- zoo::as.Date(x.fit)  # if already ISO: "2024-01-01"
    }
    else if (ts_unit == "weeks") {
      x.fit <- as.Date(tsibble::yearweek(x.fit))
    }
    else if (ts_unit == "months") {
      yearmon_obj <- zoo::as.yearmon(x.fit, format = "%Y %b")
      x.fit <- zoo::as.Date(yearmon_obj)
    }
    else if (ts_unit == "quarters") {
      yearqtr_obj <- zoo::as.yearqtr(x.fit, format = "%Y Q%q")
      x.fit <- zoo::as.Date(yearqtr_obj)
    }
    else if (ts_unit == "years") { # e.g., 2026 to Date ("2026-01-01")
      x.fit <- zoo::as.Date(paste0(as.character(x.fit), "-01-01"))
    }

    y.fit <- fitted.tbl[[".fitted"]]

  
    # forecast
    # --------
    if (is.null(exog.df)) {
      frcst <- fabletools::forecast(fit, h = ts_ahead)
    } else {
      # ts_new_x may or may not include the date index column; if it
      # does, convert directly, else generate the future index here
      if (names(ts_new_x)[1] == names(d.data)[1])
        future.tsbl <- .to_tsbl(ts_new_x, ts_unit)
      else
        future.tsbl <- .generate_future_df(d.data, ts_unit, ts_ahead,
                                           ts_new_x)
      frcst <- fabletools::forecast(fit, new_data = future.tsbl)
    }

    # prediction interval at level ts_PI
    mu    <- vapply(frcst[[y.name]], mean, numeric(1))
    sigma <- sqrt(vapply(frcst[[y.name]], distributional::variance,
                  numeric(1)))
    z <- qnorm((1 + ts_PI) / 2)  # two-sided z-score
    y.lwr <- mu - z * sigma
    y.upr <- mu + z * sigma

    # get x.hat and y.hat
    x.hat <- frcst[[2]]
    if (ts_unit == "years" && is.numeric(x.hat)) {
      x.hat <- as.Date(paste0(x.hat, "-01-01"))
    }
    else
      x.hat <- zoo::as.Date(x.hat)

    y.hat <- frcst$.mean
  }  # end fable


  # classic
  # -------
  else if (ts_source == "classic") {

    # HoltWinters
    # -----------
    if (ts_method == "es") {

      if (!is.null(ts_trend)) {
        if (!ts_trend %in% c("A", "N")) {
          stop("\n------\n",
               'HoltWinters() only supports "A" for additive trend\n',
               'or "N" for no trend.\n\n')
        }
      }
      if (!is.null(ts_seasons)) {
        if (!ts_seasons %in% c("A", "M", "N")) {
          stop("\n------\n",
               'HoltWinters() only supports "A" for additive, "M" for\n',
               'multiplicative, or "N" for no seasonality.\n\n')
        }
      }

      if (!is.null(ts_trend))
        do.trend <- ifelse (ts_trend == "A", TRUE, FALSE)
      else
        do.trend <- FALSE
      if (!is.null(ts_seasons))
        do.seasons <- ifelse (ts_seasons %in% c("A","M"), TRUE, FALSE)
      else
        do.seasons <- FALSE

      bet <- NULL
      if (do.trend) {
        if (!is.null(ts_beta)) bet <- ts_beta
      }
      else  # "N"
        bet <- FALSE

      seasonal <- "additive"  # default
      gam <- NULL
      if (do.seasons) {
        if (ts_seasons == "A") {
          seasonal <- "additive"
          if (!is.null(ts_gamma)) gam <- ts_gamma
        }
        else if (ts_seasons == "M") {
          seasonal <- "multiplicative"
          if (!is.null(ts_gamma)) gam <- ts_gamma
        }
      } else {
        gam <- FALSE  # suppress seasonality estimation
      }

      # fit the data
      alp <- if (!is.null(ts_alpha)) ts_alpha else NULL
      fit <- HoltWinters(y.ts, alpha=alp, beta=bet, gamma=gam,
                         seasonal=seasonal)
      colnames(fit$fitted)[1] <- "fitted"
      yf <- tsExtract(fit$fitted[,1], x.name)
      x.fit <- yf$x.dates
      y.fit <- yf$y

      alpha.f <- fit$alpha;  beta.f <- fit$beta;  gamma.f <- fit$gamma

      coefs <- fit$coefficients
      if (names(coefs)[1] == "a") names(coefs)[1] <- "b0"
      if (length(coefs) > 1)
        if (names(coefs)[2] == "b") names(coefs)[2] <- "b1"

      # predict with prediction intervals
      y.pred <- predict(fit, n.ahead=ts_ahead,
                        prediction.interval=TRUE, level=ts_PI)  # mts
      width <- y.pred[, "upr"] - y.pred[, "lwr"]
      y.pred <- cbind(y.pred, width=width)

      # get predicted values and PI from each individual time series
      y.ahead <- tsExtract(y.pred[,1], x.name)
      y.hat <- y.ahead$y
      xhw.hat <- y.ahead$x.dates
      x.pred1 <- x.dates[length(x.dates)]
      if (ts_unit=="weeks")
        x.hat <- seq.Date(from=x.pred1+7, by="week", length.out=length(xhw.hat))
      y.ahead <- tsExtract(y.pred[,2], x.name)
      y.upr <- y.ahead$y
      y.ahead <- tsExtract(y.pred[,3], x.name)
      y.lwr <- y.ahead$y

      # compute MSE
      n.param <- 1
      if (is.numeric(beta.f)) n.param <- n.param + 1
      if (is.numeric(gamma.f)) n.param <- n.param + 1
      MSE <- fit$SSE / (length(x.fit) - n.param)

      # if !trend then no b1, if !seasons then no s1, etc.
      # smoothing parameter output for exponential smoothing forecast
      tx <- character(length = 0)
      tx[length(tx)+1] <- "Smoothing Parameters"
      tx[length(tx)+1] <- paste(" alpha:", .fmt_cm(alpha.f,n.d))
      if (is.numeric(beta.f))
        tx[length(tx)] <- paste(tx[length(tx)], " beta:", .fmt_cm(beta.f,n.d))
      if (is.numeric(gamma.f))
        tx[length(tx)] <- paste(tx[length(tx)], " gamma:", .fmt_cm(gamma.f,n.d))
      tx[length(tx)+1] <- ""
      txparam <- tx

      decomp.frm <- NULL
    } # end HW


    # Linear Regression with Seasonality
    # ----------------------------------
    else if (ts_method == "lm") {

     if (!is.null(ts_trend)) {
       if (!ts_trend %in% c("A", "N")) {
          stop("\n------\n",
               'Enter either "A" for additive trend or "N" for no trend.\n\n')
        }
      }
      if (!is.null(ts_seasons)) {
        if (!ts_seasons %in% c("A", "N")) {
          stop("\n------\n",
             'Enter either "A" for additive seasons or "N" for no seasons.\n\n')
        }
      }

      x.fit <- x.dates
      decomp.frm <- NULL
   
      if (!is.null(ts_trend))
        do.trend <- ifelse (ts_trend == "A", TRUE, FALSE)
      else
        do.trend <- FALSE
      if (!is.null(ts_seasons))
        do.seasons <- ifelse (ts_seasons == "A", TRUE, FALSE)
      else
        do.seasons <- FALSE

      # decompose the time series with stl()
      if (do.seasons) {
        decomp <- stl(y.ts, s.window="periodic")
        if (do.trend)  # de-seasonalize
          y.trend <- decomp$time.series[,"trend"] +
                     decomp$time.series[,"remainder"]
        else
          y.trend <- decomp$time.series[,"remainder"] + mean(y[,1])
      }  # end do.seasons
      else {  # no seasonal analysis
        if (do.trend)
          y.trend <- y[,1]
        else
          y.trend <- rep(mean(y[,1], na.rm=TRUE), length(y[,1]))
      }

      # fit linear regression on (usually) deseasonalized data
      x.seq <- 1:length(y.trend)
      fit <- lm(y.trend ~ x.seq)
      y.fit.trend <- fit$fitted.values  # reg fitted y.trend values
      coefs <- fit$coefficients
      names(coefs) <- c("b0", "b1")

      # forecast
      if (do.seasons) {
        # get seasonal indices of data, start at the next season
        n.cycles <- length(y[,1]) / freq
        season.ind <- rep(1:freq, ceiling(n.cycles))[1:length(y[,1])]
        last_index <- tail(season.ind, 1)
        start.ind <- (last_index %% freq) + 1

        # get seasonal indices of forecast
        new.ind <- (start.ind + seq_len(ts_ahead) - 1) %% freq
        new.ind[new.ind == 0] <- freq  # replace 0

        # map seasonal effects to forecasted indices
        y.seas.eff <- as.numeric(decomp$time.series[,"seasonal"])
        for (i in 1:freq) {
          coefs[length(coefs)+1] <- y.seas.eff[i]
          names(coefs)[length(coefs)] <- paste0("s", i, sep="")
        }
        new.seas.eff <- y.seas.eff[new.ind]
      }  # end if no seasons

      else {  # no seasonal effects analyzed
        new.seas.eff <- double(length=ts_ahead)  # 0 by default
        y.seas.eff <- double(length=length(y[,1]))
      }

      y.fit <- y.fit.trend + y.seas.eff[1:length(y.fit.trend)]  # trend+seasonal
      y.fit <- data.frame(y.fit)
      SSE <- sum((y[,1] - y.fit[,1])^2)
      n.param.lm <- 2 + ifelse(do.seasons, freq, 0)  # freq seasonal effects
      MSE <- SSE / (nrow(y) - n.param.lm)

      # y.hat from trend and (usually) seasonality plus prediction intervals
      new.x.seq <- seq(max(x.seq)+1, by=1, length.out=ts_ahead)  # future times
      y.hat <- (coefs[1] + coefs[2]*new.x.seq) + new.seas.eff

      # usual formula for std error with MSE, here from trend and seasonality
      x_mean <- mean(x.seq)
      Sxx <- sum((x.seq - x_mean)^2)
      se_forecast <- sqrt(MSE * (1 + 1/nrow(y) + (new.x.seq-x_mean)^2 / Sxx))

      # get prediction intervals
      t.crit <- qt((1 + ts_PI)/2, df = nrow(y) - n.param.lm)
      half.width <- t.crit * se_forecast
      y.lwr <- as.vector(y.hat) - half.width
      y.upr <- as.vector(y.hat) + half.width

      out_report <- NULL
      txparam <- NULL
    }  # end ts_method=="lm"


    tx <- character(length = 0)
    if (!getOption("suggest")) tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("Mean squared error of fit to data:",
                              .fmt_cm(MSE, n.d+2))
    txerr <- tx

    tx <- character(length = 0)
    tx[length(tx)+1] <- "Coefficients for Linear Trend"
    if (!is.null(ts_seasons)) if (ts_seasons!="N") {
        tx[length(tx)] <- paste(tx[length(tx)], "and Seasonality")
    }
    tx[length(tx)+1] <- " "
    for (i in 1:length(coefs)) {
      if (names(coefs)[i] %in% c("s1", "s7"))
        tx[length(tx)+1] <- " "
      tx[length(tx)] <- paste(tx[length(tx)],
        names(coefs)[i], ": ", .fmt_cm(coefs[i], digits_d+1), "  ", sep="")
    }
    tx[length(tx)+1] <- ""
    txcoef <- tx

    out_report <- c(txparam, txerr, "", txcoef)
  }  # end classic
  # --------------


  # Output data frame with data + fitted values
  if (ts_fitted) {

    xc <- .toFmtDate(x[,1], ts_unit)  # e.g., 2020-01-01 to 2020 Q1

    # Convert numeric vectors to character and pad for no data values
    if (ts_source == "classic") {
      if (ts_method == "es") {

        diff.df <- length(x.dates) - length(x.fit)
        x.fit <- x.dates[(diff.df+1) : length(x.dates)]  # es drops first  dates
        xc.fit <- x.dates
        if (ts_unit == "months")   # display monthly fit
          xc.fit <- as.character(zoo::as.yearmon(xc.fit))
        else if (ts_unit == "quarters")  # display quarterly fit
          xc.fit <- as.character(zoo::as.yearqtr(xc.fit))
        else if (ts_unit == "years")  # display annual fit
          xc.fit <- as.character(format(xc.fit, "%Y"))

        fdf <- as.data.frame(fit$fitted) # do a df instead of a multivariate ts 
        pad <- rep("", nrow(x) - nrow(fdf))
        fitted_chr <- c(pad, as.character(.fmt(fdf[,1],nd)))
        level_chr  <- c(pad, as.character(.fmt(fdf[,2],nd)))
        out_fitted <- data.frame(
          date=xc.fit,
          y=y[,1],
          fitted=fitted_chr,
          level=level_chr
        )
        names(out_fitted)[1:2] <- c(x.name, y.name)

        if (do.trend) {
          trend_chr  <- c(pad, as.character(.fmt(fdf$trend,nd)))
          out_fitted <- cbind(out_fitted, trend=trend_chr)
        }
        if (do.seasons) {
          seasons_chr  <- c(pad, as.character(.fmt(fdf$season,nd)))
          out_fitted <- cbind(out_fitted, season=seasons_chr)
        }
        res <- residuals(fit)          # stats::residuals.HoltWinters
        res_chr  <- c(pad, as.character(.fmt(res,nd)))
        out_fitted <- cbind(out_fitted, error=res_chr)
      }  # end classic fit HW

      else if (ts_method == "lm") {
        out_fitted <- data.frame(
          date=x.fit,  # x.fit already in correct date format
          y=y[,1],
          fitted=y.fit[,1],
          error=y[,1]-y.fit[,1]
        )
        names(out_fitted)[1:2] <- c(x.name, y.name)
      }  # end lm
    }  # end classic fit

    else if (ts_source == "fable") { # fable fit

      if (ts_method == "es") {
        cmp <- fabletools::components(fit)
        out <- capture.output(print(cmp, n = 1))
        formula_line <- grep("^#\\s*:", out, value = TRUE)
        if (length(formula_line) > 0)
          frm <- sub("^#\\s*:\\s*", "", formula_line)
        else
          frm <- NA_character_
        decomp.frm <- paste("\nDecomposition formula:\n", frm, "\n\n")
        n.pad <- nrow(cmp) - nrow(fitted.tbl)
        xc <- c(rep(NA, n.pad), xc)
        y.fit.pad <- c(rep(NA, n.pad), y.fit)
        y <- data.frame(y.name = c(rep(NA, n.pad), y[,1]))
      } 

      else if (ts_method == "lm") {
        cmp <- data.frame(fitted = fitted.tbl$.fitted,
                      resid = fitted.tbl$.resid)
        decomp.frm <- "TSLM only provides fitted and residuals.\n\n"
      }

      out_fitted <- data.frame(date=xc, y=y[,1])
        names(out_fitted) <- c(x.name, y.name)

        if (ts_method == "es") {
          out_fitted <- cbind(out_fitted, fitted=y.fit.pad)
          out_fitted <- cbind(out_fitted, level=cmp$level)
          if (!is.null(ts_trend)) {
            if (ts_trend != "N")
              out_fitted <- cbind(out_fitted, trend=cmp$slope)
          }
          if (!is.null(ts_seasons)) {
            if (ts_seasons != "N")
              out_fitted <- cbind(out_fitted, season=cmp$season)
          }
          out_fitted <- cbind(out_fitted, error=cmp$remainder)

          # Replace NAs with blanks across all columns of out_fitted
          out_fitted[] <- lapply(out_fitted, function(col) {
            if (is.numeric(col)) 
              ifelse(is.na(col), "", as.character(.fmt(col, nd)))
            else
              ifelse(is.na(col), "", col)
          })
        }  # end es fit
      else if (ts_method == "lm")
        out_fitted <- cbind(out_fitted, cmp)
    }  # end fable fit
  } # end fitted

  else  # not fitted
    out_fitted <- NULL



  # Results
  # -------

  # Output data frame of forecasts
  xc.hat <- .toFmtDate(x.hat, ts_unit)  # e.g., 2020-01-01 to 2020 Q1
  y.frcst <- data.frame(
    date=xc.hat,
    predicted=as.vector(y.hat),
    lower=y.lwr,
    upper=y.upr,
    width=y.upr-y.lwr
  )
  names(y.frcst) <- c(x.name, "predicted", "lower", "upper", "width")

  x.fit <- data.frame(x.fit)
  y.fit <- data.frame(y.fit)
  x.hat <- data.frame(x.hat); names(x.hat) <- "x.dates"
  y.hat <- data.frame(y.hat)
  y.lwr <- data.frame(y.lwr);  names(y.lwr) <- y.name
  y.upr <- data.frame(y.upr);  names(y.upr) <- y.name


  # margin adjustments for plot
  # ---------------------------
  mn.x <- min(as.numeric(x.hat[,1]))
  mx.x <- max(as.numeric(x.hat[,1]))
  mx.y <- max(max(y, na.rm=TRUE), max(y.fit, na.rm=TRUE),
              max(y.upr, na.rm=TRUE), max(y.hat, na.rm=TRUE))
  mn.y <- min(min(y, na.rm=TRUE), min(y.fit, na.rm=TRUE),
              min(y.lwr, na.rm=TRUE), min(y.hat, na.rm=TRUE))

  return(list(y.fit=y.fit, y.hat=y.hat, y.frcst=y.frcst,
              x.fit=x.fit, x.hat=x.hat,
              y.upr=y.upr, y.lwr=y.lwr,
              mn.x=mn.x, mx.x=mx.x, mn.y=mn.y, mx.y=mx.y,
              out_fitted=out_fitted,
              out_decomp=decomp.frm, out_report=out_report))
}

.plt.fit <-
function(x.lv, y.lv, fit.line, fit_power, fit_new, sz.lv, span=0.75) {

# Need to implement  xlog  and xylog

  digits_d <- getOption("digits_d")

  b00 <- NULL
  b11 <- NULL
  Rsqq <- NULL
  ok <- is.finite(x.lv) & is.finite(y.lv)
  if (any(ok)) {
    x.lv <- x.lv[ok]
    y.lv <- y.lv[ok]
    od <- order(x.lv)
    x.lv <- x.lv[od]
    y.lv <- y.lv[od]
    if (length(sz.lv) > 1) sz.lv <- sz.lv[od]
    

    # fit line
    # ---------------------------------------
    y.new <- NULL  # new values of y computed from fit_new
    if (!is.null(fit_new)) n.new <- length(fit_new)

    # l.ln: loess or linear fit, including of transformed data
    if (fit.line == "loess")
      l.ln <- loess(y.lv ~ x.lv, span=span)
    else if (fit.line == "lm")
      l.ln <- lm(y.lv ~ x.lv)
    else if (fit.line == "null")
      l.ln <- lm(y.lv ~ 1)

    # f.ln: fitted values, either directly or from back transformation
    if (fit.line %in% c("loess", "lm", "null"))
      f.ln <- fitted(l.ln)
    if (fit.line %in% c("lm", "null")) {
      b00 <- l.ln$coefficients[1] 
      b11 <- l.ln$coefficients[2] 
      Rsqq <- summary(l.ln)$r.squared
      if (!is.null(fit_new)) 
        y.new <- round(b00 + (b11*fit_new), digits_d)  # linear reg
    }

    if (fit.line %in% c("quad", "power")) {  # quad model
      if (fit.line == "quad") {
        l.ln <- lm(sqrt(y.lv) ~ x.lv)
        fit_power <- 2
      }
      else
        l.ln <- lm((y.lv^(1/fit_power)) ~ x.lv)
      b00 <- l.ln$coefficients[1]
      b11 <- l.ln$coefficients[2]
      f.ln <- (b00 + (b11*x.lv))^fit_power
      if (!is.null(fit_new)) 
        y.new <- round((b00 + (b11*fit_new))^fit_power, digits_d)
    }

    if (fit.line == "exp") {  # exponential model
      if (any(y.lv < 0))
        message("\n>>>  Negative values of Y dropped, no log(Y).\n")
#           fi <- which(y.lv < 0)
#           if (length(fi) > 0) {
#             y.lv <- y.lv[-fi]
#             x.lv <- x.lv[-fi]
#           }
      if (all(y.lv <= 0)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "All values of Y are non-positive, cannot take log(Y)\n\n")
      }
      # log(neg y) generates a NaN, which reduces data for lm
      #  but does not hurt the exp function back transform
      if (fit_power == 1) {
        l.ln <- lm(log(y.lv) ~ x.lv)
      }
      else {
        l.ln <- lm(log(y.lv^(1/fit_power)) ~ x.lv)
      }
      b00 <- l.ln$coefficients[1]
      b11 <- l.ln$coefficients[2]
      f.ln <- exp(b00 + (b11*x.lv))
      ok <- is.finite(f.ln)
      if (length(ok) > 0) {
        f.ln <- f.ln[ok]
        x.lv <- x.lv[ok]
      }
      if (!is.null(fit_new)) 
        y.new <- round(exp(b00 + (b11*fit_new)), digits_d)
    }

    if (fit.line == "log") {  # logarithmic model
#           if (any(y.lv == 0))
#             message("\n>>> 0 value of log(y) is undefined.\n")
#           fi <- which(y.lv == 0)  # no log, BUT taking exp
#           if (length(fi) > 0) {
#             y.lv <- y.lv[-fi]
#             x.lv <- x.lv[-fi]
#           }
      if (fit_power == 1) {
        y.exp <- exp(y.lv)
        if (any(is.infinite(y.exp))) {
          cat("\n"); stop(call.=FALSE, "\n","------\n",
            "Some values of y too large for exp(y). Rescale.\n\n")
        }
        l.ln <- lm(y.exp ~ x.lv)
      }
      else
        l.ln <- lm(exp(y.lv^(1/fit_power)) ~ x.lv)
      b00 <- l.ln$coefficients[1]
      b11 <- l.ln$coefficients[2]
      f.ln <- log(b00 + (b11*x.lv))
      if (any(is.nan(f.ln))) {
        message("\n>>> Warning: ",
          "Some values of log() back transformation not defined.\n\n")
      }
      if (!is.null(fit_new)) 
        y.new <- round(log(b00 + (b11*fit_new)), digits_d)
    }
    # ---------------------------------------

    Rsqq <- summary(l.ln)$r.squared

    # linear MSE
    e.ln <- l.ln$residuals
    sse <- sum(e.ln^2)
    mse.ln <- sse / (length(e.ln) - 2)  # 1 pred var

    # nonlinear MSE
    e.nl <- y.lv - f.ln
    sse <- sum(e.nl^2)
    mse.nl <- sse / (length(e.nl) - 2)  # 1 pred var

    b0 <- ifelse (is.null(b00), NA, b00) 
    b1 <- ifelse (is.null(b11), NA, b11) 
    Rsq <- ifelse (is.null(Rsqq), NA, Rsqq) 
  }  # end any(ok)

  return(list(x.lv=x.lv, y.lv=y.lv, f.ln=f.ln, l.ln=l.ln,
              mse.ln=mse.ln, mse.nl=mse.nl, b0=b0, b1=b1, Rsq=Rsq,
              y.new=y.new, sz.lv=sz.lv))
}

xW <- function(x, w=90, indent=5) {

  n.lines <- (nchar(x) + (w-1)) %/% w

  spc <- paste(rep(" ", indent), collapse = "")

  b <- gregexpr(" ", x, fixed=TRUE)[[1]]

  y <- ""
  stop <- 0
  for (i in 1:n.lines) {
    start <- stop + 1
    if (i < n.lines) {
      k <- 1
      while (!any(b >= i*w-k)) k <- k+1 
      stop <- b[which(b>=(i*w-k))[1]]
    }
    else
      stop <- nchar(x)
    y <- paste(y, substr(x, start, stop), sep="")
    if (i < n.lines) y <- paste(y, "\n", spc, sep="") 
  }

  return(y)
}

print.out_all <- function(x, ...) {

  n.out <- 0
  for (ilist in 1:length(x)) {
    if (substr(names(x[ilist]),1,4) == "out_") {  # then print component

      n.out <- n.out + 1
      if (nzchar(x[ilist])) {
        if (n.out == 1) {
#         if (is.null(options()$knitr.in.progress)) cat("\n")
        }
        else 
          cat("\n")

        if (substr(names(x[ilist]),5,9) != "title") {
          if (!is.data.frame(x[[ilist]]))
            for (i in 1:length(x[[ilist]])) cat(x[[ilist]][i], "\n")
          else  # a data frame
            print(x[[ilist]], row.names=FALSE)  # first done plt.txt, #402
        }  # not a title
        else  # a title
          cat(x[[ilist]], "\n") 

      }  # end nzchar()
    }  # end out_ condition
  }  # end ilist loop
}

.bx.stats <-
function(x, ID=NULL, k.iqr=1.5, box_adj=FALSE, a=-4, b=3, digits_d=2, ...) {      

  x.name <- getOption("xname")

  tx=""
  if (is.null(digits_d)) {
    digits_d <- .max.dd(x) + 1
    if (digits_d == 1) digits_d <- 2
  }
  options(digits_d=digits_d)


  # summarize data
  if (!box_adj)
    bv <- boxplot.stats(x, coef=k.iqr)
  else
    bv <- robustbase::adjboxStats(x, coef=k.iqr, a=a, b=b)

  lo.whisker <- bv$stats[1]
  hi.whisker <- bv$stats[5]

  if (is.null(ID))
    ID <- character(length=length(x))

  # ----------------------------
  # outliers
  outliers <- bv$out
  n.out <- length(outliers)

  tx <- character(length = 0)

  if (length(outliers>0) && length(unique(na.omit(x)>3))) {

    tx[length(tx)+1] <- " "
    tx[length(tx)+1] <- paste("--- Outliers ---     from the box plot:", n.out)

    ind.lo <- which(x < lo.whisker)  # lower outliers
    if (length(ind.lo) > 0) {
      x.lo <- x[ind.lo]
      ID.lo <- ID[ind.lo]
      lo.len <- length(x.lo)
      ord <- order(x.lo, decreasing=FALSE)
      x.lo <- x.lo[ord]
      ID.lo <- ID.lo[ord] 
      xc.lo <- character(length=length(x.lo))
      for (i in 1:length(x.lo)) xc.lo[i] <- .fmt(x.lo[i], d=digits_d-1)  
      ID.lo <- as.character(ID.lo)
      max.lo <- max(nchar(xc.lo))
      max.ID.lo <- max(nchar(as.character(ID.lo)))
    }
    else {
      xc.lo <- ""
      max.lo <- 0
      ID.lo <- "    "
      max.ID.lo <- 5
      lo.len <- 0
    }
    
    ind.hi <- which(x > hi.whisker)  # upper outliers
    if (length(ind.hi) > 0) {
      x.hi <- x[ind.hi]
      hi.len <- length(x.hi)
      ID.hi <- ID[ind.hi]
      ord <- order(x.hi, decreasing=TRUE)
      x.hi <- x.hi[ord]
      ID.hi <- ID.hi[ord] 
      xc.hi <- character(length=length(x.hi))
      for (i in 1:length(x.hi)) xc.hi[i] <- .fmt(x.hi[i], d=digits_d-1)  
      max.hi <- max(nchar(xc.hi))
      max.ID.hi <- max(nchar(as.character(ID.hi)))
    }
    else {
      xc.hi <- ""
      max.hi <- 0
      ID.hi <- "   "
      max.ID.hi <- 5
      hi.len <- 0
    }

    max.list <- 18   # max number of lines of outlier output
    n.lines <- min(max(lo.len, hi.len), max.list)
    ID.hi <- as.character(ID.hi)
    for (i in 1:n.lines) {
      if (i > lo.len) {
        length(xc.lo) <- length(xc.lo) + 1
        xc.lo[length(xc.lo)] <- ""
        ID.lo[length(xc.lo)] <- ""
      }
      if (i > hi.len) {
        length(xc.hi) <- length(xc.hi) + 1
        xc.hi[length(xc.hi)] <- ""
        ID.hi[length(xc.hi)] <- ""
      }
    }

    adj <- nchar("Small") - max.ID.lo
    buf <- ifelse (adj > 0, 3-adj, 3) 
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste(
         .fmtc("Small", max.ID.lo, "left"), .fmtc("", max.lo), .fmtc("", buf),
         .fmtc("Large", max.ID.hi, "left"))
    tx[length(tx)+1] <- paste(
         .fmtc("-----", max.ID.lo, "left"), .fmtc("", max.lo), .fmtc("", buf),
         .fmtc("-----", max.ID.hi, "left"))
    for (i in 1:n.lines)
      tx[length(tx)+1] <- paste(
         .fmtc(ID.lo[i], max.ID.lo, "left"), .fmtc(xc.lo[i], w=max.lo),  "   ",
         .fmtc(ID.hi[i], max.ID.hi, "left"), .fmtc(xc.hi[i], w=max.hi))

    if (max(lo.len, hi.len) > n.lines)
      tx[length(tx)+1] <- paste("\n+", n.out-max.list, "more outliers")

  }  # end there were outliers

  else
    tx <- "No (Box plot) outliers"

  txotl <- tx


  # -----------------------------
  # stats

  # first the title with any variable labels
  txlbl <- .title2(x.name, y.name=NULL, x.lbl=NULL, y.lbl=NULL, isnullby=TRUE)
  if (length(txlbl) > 1) if (substr(txlbl[2],1,1) ==  "\n")
    txlbl[2] <- sub("\n", "", txlbl[2])
  tx <- txlbl

  n <- sum(!is.na(x))
  n.miss <- sum(is.na(x))
  mn <- .fmt(min(x, na.rm=TRUE))
  lw <- .fmt(bv$stats[1], digits_d)
  lh <- .fmt(bv$stats[2], digits_d)
  md <- .fmt(bv$stats[3], digits_d)
  uh <- .fmt(bv$stats[4], digits_d)
  uw <- .fmt(bv$stats[5], digits_d)
  mx <- .fmt(max(x, na.rm=TRUE), digits_d) 
  IQR <- .fmt(IQR(x, na.rm=TRUE), digits_d)
  avg <- .fmt(mean(x, na.rm=TRUE), digits_d)
  std <- .fmt(sd(x, na.rm=TRUE), digits_d)
  mc <- .fmt(robustbase::mc(x, na.rm=TRUE, doScale=FALSE), digits_d)

  tx <- character(length = 0)
  tx <- txlbl
  tx[length(tx)+1] <- paste("Present:", n)
  tx[length(tx)+1] <- paste("Missing:", n.miss)
  tx[length(tx)+1] <- paste("Total  :", length(x))
  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste("Mean         :", avg)
  tx[length(tx)+1] <- paste("Stnd Dev     :", std)
  tx[length(tx)+1] <- paste("IQR          :", IQR)
  tx[length(tx)+1] <- paste("Skew         :", mc, "  [medcouple, -1 to 1]")
  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste("Minimum      :", mn)
  tx[length(tx)+1] <- paste("Lower Whisker:", lw) 
  tx[length(tx)+1] <- paste("1st Quartile :",
     .fmt(quantile(x, na.rm=TRUE)[2], digits_d))
  #tx[length(tx)+1] <- paste("Lower Hinge  :", lh) 
  tx[length(tx)+1] <- paste("Median       :", md) 
  tx[length(tx)+1] <- paste("3rd Quartile :",
     .fmt(quantile(x, na.rm=TRUE)[4], digits_d))
  #tx[length(tx)+1] <- paste("Upper Hinge  :", uh) 
  tx[length(tx)+1] <- paste("Upper Whisker:", uw) 
  tx[length(tx)+1] <- paste("Maximum      :", mx )
  txstat <- tx

  return(list(txotl=txotl, txstat=txstat))

}

regPlot <-
function(out, type, d.ancova, digits_d=NULL, pred.intervals=TRUE,
         res_sort=c("cooks","rstudent","dffits","off"),
         n_res_rows=NULL, cooks_cut=1, scatter_coef=NULL,
         pdf=FALSE, width=5, height=5, manage.gr=FALSE, ...) {


  if (!identical(getOption("device"), "RStudioGD")  &&
      is.null(options()$knitr.in.progress))
    .graphwin(1)

    # Regression() output object stores fitted values as 'fitted', but
    # the plot helpers read 'fitted.values' (the lm/glm field name)
    if (is.null(out$fitted.values)) out$fitted.values <- out$fitted


    # need: out$residuals
    if (type == 2) .reg3dnResidual(out, pdf, width, height, manage.gr)

    # need: out$fitted.values, out$residuals
    if (type == 3) .reg3resfitResidual(out, out$cooks.distance, cooks_cut,
                   pdf=FALSE, width=5, height=5, manage.gr=FALSE)


    # need: out$model (the data)
    if (type == 1) {

    #nm <- all.vars(out$terms)  # names of vars in the model
    nm <- all.vars(out$formula)
    n.vars <- length(nm)
    n.pred <- n.vars - 1

    in.data.frame <- TRUE
    for (i in 1:n.vars) {
      if (!(nm[i] %in% names(out$model))) {
        cat("\n\n\n>>> Note: ", nm[i], "is not in the data frame.\n")
        in.data.frame <- FALSE
      }
    }

    # check for all numeric vars  in.data.frame <- TRUE
    numeric.all <- TRUE
    for (i in 1:n.vars) {
      if (in.data.frame &&
        !is.numeric(out$model[1,which(names(out$model) == nm[i])])) {
          cat("\n\n\n>>> Note: ", nm[i], "is not a numeric variable.\n")
          numeric.all <- FALSE
        }
      }

    if (pred.intervals) {
      data <- out$model
      if (n.pred == 1) {
        o <- order(data[,nm[2]], decreasing=FALSE)
        data <- data[o,]
      }
      r2.out <- lm(out$formula, data=data)
      c.int <- data.frame(predict(r2.out, interval="confidence"),
                          stringsAsFactors=TRUE)
      p.int <- data.frame(suppressWarnings(predict(r2.out,
                          interval="prediction")), stringsAsFactors=TRUE)
    }
    else {
      c.int <- NULL
      p.int <- NULL
      n_pred_rows <- 0
    }

    if (!is.null(scatter_coef))
      s.c <- scatter_coef
    else
      s.c <- TRUE


    if (is.null(d.ancova))
      .reg5Plot(out, n_res_rows=NULL, n_pred_rows=NULL,
           scatter_coef=s.c, X1_new=NULL,
           in.data.frame, c.int, p.int,
           digits_d=getOption("digits_d"),
           pdf=FALSE, width=5, height=5, manage.gr=FALSE, ...)
    else
      .reg5ancova(out, d.ancova, digits_d=getOption("digits_d"),
                  pdf=FALSE, width=5, height=5, manage.gr=FALSE, ...)
    } # end type == 1

}

.reg3dnResidual <-
function(lm.out, pdf=FALSE, width=5, height=5, manage.gr=FALSE, ...) {

  # pdf graphics option
  go.pdf <- pdf  # save before base::pdf() would shadow the name
  if (go.pdf) {
    pdf_file <- "RegResiduals.pdf"
    grDevices::pdf(file=pdf_file, width=width, height=height)
  }

  # keep track of the plot in this routine
  plt.i <- 0L
  plt.title  <- character(length=0)

  plt.i <- plt.i + 1L
  plt.title[plt.i] <- "Distribution of Residuals"

  lab_size <- getOption("lab_size")
  on.exit(options(lab_size=lab_size), add=TRUE)
  options(lab_size=0.9)

  # frequency distribution of residuals
  .dn.main(lm.out$residuals, 
    fill_hist=getOption("se_fill"),
    col.nrm="gray40", col.gen="gray40", fill.miss=TRUE,
    fill_nrm="transparent", fill_gen="transparent",
    xlab="Residuals", use_plotly=FALSE, quiet=TRUE)

  if (go.pdf) {
    dev.off()
    .showfile(pdf_file, "residuals plot")
  }

  return(invisible(list(i=plt.i, ttl=plt.title)))

}

.format_date_labels <- function(dates, ts_unit) {
  # ts_unit is unknown if x is a time series to begin with
  ts_unit <- match.arg(ts_unit, c("years","quarters","months","weeks", 
                                  "days","days7", "unknown"))
  switch(ts_unit,
    years    = format(dates, "%Y"),
    quarters = paste0(format(dates, "%Y"), " ", quarters(dates)),
    months   = format(dates, "%b %Y"),
    weeks    = format(dates, "%d %b %Y"),
    days     = format(dates, "%d %b %Y"),
    days7    = format(dates, "%d %b %Y")
  )
}


.check.packages <- function() {

  required_pkgs <- c("tsibble", "fable", "fabletools")

  quiet_require <- function(pkg) {
    suppressMessages(
      suppressPackageStartupMessages(
        requireNamespace(pkg, quietly = TRUE)
      )
    )
  }

  missing <- required_pkgs[!vapply(required_pkgs, quiet_require, logical(1))]

  if (length(missing)) {
    stop("To use ts_source = \"fable\" to forecast\n\n",
         "Please install:\n",
         paste0("  install.packages(\"", missing, "\")", collapse = "\n"),
         call. = FALSE)
  }

  # Optional: pre-load quietly (so later :: calls don’t trigger messages)
  invisible(lapply(required_pkgs, quiet_require))

  invisible(TRUE)
}


.valid.params <- function(ts_method, ts_error, ts_trend, ts_seasons) {
  if (ts_method == "es") {
    if (!is.null(ts_error)) {
      if (!ts_error %in% c("A", "M")) {
        stop("\n------\n",
             'ts_error can only be "A" (additive) or "M" (multiplicative).\n\n',
             call. = FALSE)
      }
    }
    if (!is.null(ts_trend)) {
      if (!ts_trend %in% c("N", "A", "M", "Ad", "Md")) {
        stop("\n------\n",
             'Specify  ts_trend  only as "N" (none), "A" (additive),\n',
             '"M" (multiplicative), "Ad" (damped additive),\n',
             '"Md" (damped multiplicative).\n\n', call. = FALSE)
      }
    }
    if (!is.null(ts_seasons)) {
      if (!ts_seasons %in% c("N", "A", "M")) {
        stop("\n------\n",
             'Specify  ts_seasons  only as "N" (none), "A" (additive),\n',
             'or "M" (multiplicative).\n\n', call. = FALSE)
      }
    }
  }  # end es

  else if (ts_method == "lm") {
    if (!is.null(ts_trend)) {
      if (!ts_trend %in% c("N", "A")) {
        stop("\n------\n",
             'Specify  ts_trend  only as "N" (none) or "A" (additive),\n',
             'for linear regression models.\n\n', call. = FALSE)
      }
    }
    if (!is.null(ts_seasons)) {
      if (!ts_seasons %in% c("N", "A")) {
      stop("\n------\n",
           'Specify  ts_seasons  only as "N" (none) or "A" (additive),\n',
           'for linear regression models.\n\n', call. = FALSE)
      }
    }
  }  # end lm
}


.to_tsbl <- function(df, ts_unit) {
  # df: data frame where first column is the index (date/time) variable
  # ts_unit: one of "days", "weeks", "months", "quarters", "years"
  
  # Name of the first column (index variable)
  index.var <- names(df)[1]
  
  # Convert index to correct type
  if (ts_unit == "weeks") {
    df[[index.var]] <- tsibble::yearweek(df[[index.var]])
  } 
  else if (ts_unit == "months") {
    df[[index.var]] <- tsibble::yearmonth(df[[index.var]])
  } 
  else if (ts_unit == "quarters") {
    df[[index.var]] <- tsibble::yearquarter(df[[index.var]])
  } 
  else if (ts_unit == "years") {
    df[[index.var]] <- as.integer(format(df[[index.var]], "%Y"))
  }
  # "days" assumed to already be Date
  
  # Convert to tsibble using Base R as.symbol()
  tsibble::as_tsibble(df, index = as.symbol(index.var))
}


.generate_future_df <- function(train.df, ts_unit, ts_ahead, predictors.df) {
  index.var <- names(train.df)[1]
  last_index <- train.df[[index.var]][nrow(train.df)]
  
  # Generate base future index sequence
  if (ts_unit == "weeks") {
    future_index <- seq(last_index + 7, by=7, length.out = ts_ahead)
  } else if (ts_unit == "months") {
    future_index <- seq(as.Date(last_index)+31, by="1 month",
                        length.out=ts_ahead)
  } else if (ts_unit == "quarters") {
    future_index <- seq(as.Date(last_index)+92, by="3 months",
                        length.out=ts_ahead)
  } else if (ts_unit == "years") {
    future_index <- seq(as.Date(last_index)+365, by="1 year",
                        length.out=ts_ahead)
  } else {
    future_index <- seq(as.Date(last_index)+1, by=1, length.out=ts_ahead)
  }
  
  # Adjust predictors.df row count if needed
  if (nrow(predictors.df) < ts_ahead) {
    stop("\n------\n",
         "The `ts_new_x` data frame has fewer rows than `ts_ahead`.\n",
         "Please provide future values for all forecast periods.\n",
         call. = FALSE)
  }
  if (nrow(predictors.df) > ts_ahead) {
    predictors.df <- predictors.df[1:ts_ahead, , drop=FALSE]
  }
  
  # Combine with predictors
  df.future <- data.frame(index=future_index, predictors.df, check.names=FALSE)
  names(df.future)[1] <- index.var
  
  # Match index type to training data
  if (ts_unit == "weeks") {
    df.future[[index.var]] <- tsibble::yearweek(df.future[[index.var]])
  } else if (ts_unit == "months") {
    df.future[[index.var]] <- tsibble::yearmonth(df.future[[index.var]])
  } else if (ts_unit == "quarters") {
    df.future[[index.var]] <- tsibble::yearquarter(df.future[[index.var]])
  } else if (ts_unit == "years") {
    df.future[[index.var]] <- as.integer(format(df.future[[index.var]], "%Y"))
  }
  
  df.future
}

.OneGroup  <-
function(Y, Ynm, mu=NULL, n=NULL, m=NULL, s=NULL, brief, bw1,
         from.data, conf_level, alternative, digits_d, mmd, msmd,
         Edesired, paired, graph, xlab, line_chart, show_title, quiet,
         full_curve=TRUE, pdf_file, width, height, fill=NULL, ...) {

  # get lab_x_size  lab_y_size
  lab_size <- getOption("lab_size")
  lab_x_size <- getOption("lab_x_size")
  lab_x_size <- ifelse(is.null(lab_x_size), lab_size, lab_x_size)
  adj <- .RSadj(lab_size=lab_x_size); lab_x_size <- adj$lab_size

  # get variable labels if exist plus axes labels
  gl <- .getlabels(xlab=NULL, ylab=xlab, main=NULL, lab_x_size=lab_x_size,
                   graph.win=FALSE)  # # graphics window not yet set-up
  x.name <- gl$yn; x.lbl <- gl$yl; x.lab <- gl$yb
  main.lab <- gl$mb
  sub.lab <- gl$sb

  # get variable label if exists (redundant with above
  gl <- .getlabels(graph.win=FALSE)  # graphics window not yet set-up
  y.lbl <- gl$yl
  if ( (!is.null(y.lbl))  && !quiet) {
    cat("Response Variable:  ", Ynm, ", ", as.character(y.lbl), sep="", "\n")
    cat("\n")
  }

  if (!brief && !quiet) cat("\n------ Describe ------\n\n")

  if (from.data) {
    n <- sum(!is.na(Y))
    n.miss <- sum(is.na(Y))
    Y <- na.omit(Y)
    m <- mean(Y)
    s <- sd(Y)
    v <- var(Y)
  }
  else {
    v <- s^2
  }

  clpct <- paste(toString(round((conf_level)*100, 2)), "%", sep="")

  dig.smr.d <- ifelse (from.data, digits_d, digits_d - 1)

  if (!quiet) {
    if (Ynm != "Y") cat(Ynm,  ": ", sep="")
    if (from.data) cat(" n.miss = ", n.miss, ",  ", sep="") 
    cat("n = ", n, ",   mean = ", .fmt(m, dig.smr.d), 
        ",  sd = ", .fmt(s, dig.smr.d), sep="", "\n")

    if
      (brief) cat("\n")
    else  {
      if (from.data) {

        cat("\n\n------ Normality Assumption ------\n\n")
        # Normality
        if (n > 30) {
          cat("Sample mean assumed normal because n > 30, so no test needed.",
              sep="", "\n")
        }
        else {
          cat("Null hypothesis is a normal distribution", sep="")
          if (Ynm != "Y") cat(" of ", Ynm, ".", sep="") else cat(".")
          cat("\n")
          if (n > 2 && n < 5000) {
            nrm1 <- shapiro.test(Y)
            W.1 <- round(nrm1$statistic,min(4,digits_d+1))
            p.val1 <- round(nrm1$p.value,min(4,digits_d))
            cat(nrm1$method, ":  W = ", W.1, ",  p-value = ", p.val1,
                sep="", "\n")
          }
          else
            cat("Sample size out of range for Shapiro-Wilk normality test.",
                "\n")
        }  
      } 
    }

    if (!brief) cat("\n\n------ Infer ------\n\n")
  }  # end !quiet

  # t-test
  if (alternative == "two_sided")
    alt <- "two.sided"
  else
    alt <- alternative


  if (!is.null(mu)) m.dist <- m - mu
  df <- n - 1
  sterr <- s * sqrt(1/n)
  if (alternative == "two_sided")
    tcut <- qt((1-conf_level)/2, df=df, lower.tail=FALSE)
  else if (alternative == "less")
    tcut <- qt(1-conf_level, df=df, lower.tail=FALSE)
  else if (alternative == "greater")
    tcut <- qt(1-conf_level, df=df, lower.tail=FALSE)

  if (from.data) {
    if (!is.null(mu)) mu.null <- mu else mu.null <- 0
    ttest <- t.test(Y, conf.level=conf_level, alternative=alt, mu=mu.null)
    df <- ttest$parameter
    lb <- ttest$conf.int[1]
    ub <- ttest$conf.int[2]
    E <- (ub-lb)/2
    if (!is.null(mu)) {
      tvalue <- ttest$statistic
      pvalue <- ttest$p.value
    }
  }  # end from.data
  else {
    E <- tcut * sterr
    lb <- m - E
    ub <- m + E
    if (!is.null(mu)) {
      tvalue <- m.dist/sterr
      if (alternative == "two_sided")
        pvalue <- 2 * pt(abs(tvalue), df=df, lower.tail=FALSE)
      else if (alternative == "less")
        pvalue <- pt(tvalue, df=df, lower.tail=TRUE)
      else if (alternative == "greater")
        pvalue <- pt(tvalue, df=df, lower.tail=FALSE)
    }
  }     
  # difference from mu and standardized mean difference
  if (!is.null(mu)) {
    mdiff <- m - mu
    smd <- abs(mdiff/s)
  }

  if (!quiet) {
    cat("t-cutoff for ", clpct, " range of variation: tcut = ", .fmt(tcut,3), "\n") 
    cat("Standard Error of Mean: SE = ", .fmt(sterr), "\n\n")

    if (!is.null(mu)) {
    if (alt != "two.sided") 
      cat("\nAlternative hypothesis: Population mean difference is", alt, 
          "than", mu, "\n")
      cat("Hypothesized Value H0: mu =", mu, "\n")
      txt <- "Hypothesis Test of Mean:  t-value = "
      cat(txt, .fmt(tvalue,3), ",  df = ", df, ",  p-value = ", .fmt(pvalue,3),
          sep="", "\n\n")
    }
    cat("Margin of Error for ", clpct, " Confidence Level:  ", .fmt(E),
        sep="", "\n")
    txt <- " Confidence Interval for Mean:  "
    cat(clpct, txt, .fmt(lb), " to ", .fmt(ub), sep="", "\n")

    # difference from mu and standardized mean difference
    if (!is.null(mu)) {
      if (!brief) cat("\n\n------ Effect Size ------\n\n") else cat("\n")
      cat("Distance of sample mean from hypothesized:  " , .fmt(mdiff), "\n",
          "Standardized Distance, Cohen's d:  ", .fmt(smd),
          sep="", "\n")
    }

    # needed sample size from Edesired
    if (!is.null(Edesired)) {
      zcut <- qnorm((1-conf_level)/2)
      ns <- ((zcut*s)/Edesired)^2 
      n.needed <- ceiling(1.132*ns + 7.368) 
      cat("\n\n------ Needed Sample Size ------\n\n")
      if (Edesired > E) {
        cat("Note: Desired margin of error,", .fmt(Edesired), 
           "is worse than what was obtained,", .fmt(E), "\n\n") 
      }
      cat("Desired Margin of Error: ", .fmt(Edesired), "\n")
      cat("\n")
      cat("For the following sample size there is a 0.9 probability of obtaining\n")
      cat("the desired margin of error for the resulting 95% confidence interval.\n")
      cat("-------\n")
      cat("Needed sample size: ", n.needed, "\n")
      cat("\n")
      cat("Additional data values needed: ", n.needed-n, "\n")
    }
  }  # end !quiet


  # graphs
  if (graph) {

    # keep track of the number of plots in this routine, see if manage graphics
    plt.i <- 0
    plt.title  <- character(length=0)
    manage.gr <- .graphman()
 
    if (is.null(pdf_file)) {
      if (manage.gr) {
        n.win <- 1
        if (paired) n.win <- n.win + 1
        if (line_chart) n.win <- n.win + 1
        if (n.win > 0) {
          .graphwin(n.win, width, height)
          i.win <- 2   # start first graphics window on 3
          orig.params <- par(no.readonly=TRUE)
          on.exit(par(orig.params))
        }
      }
    }

    if (line_chart) {
      if (!is.null(pdf_file))
        pdf(file=paste("LineChart_",Ynm,".pdf",sep=""), width=width, height=height)

      if (manage.gr) {
        i.win <- i.win + 1 
        dev.set(which=i.win)
      }

      plt.i <- plt.i + 1
      plt.title[plt.i] <- paste("Sequentially Plotted Data for", Ynm)

      Y.df = data.frame(Y)
      x.df <- data.frame(1:nrow(Y.df))
      .plt.main(x.df, Y.df, segments=TRUE, size=.9,
                xlab="Index", ylab=NULL, main=plt.title[plt.i],
                use_plotly=FALSE)

      if (!is.null(pdf_file)) {
        dev.off()
        .showfile(paste("LineChart_", Ynm, ".pdf", sep=""),
                  paste("line chart of", Ynm))
      }

    }


    if (!is.null(mu)) {

      if (manage.gr) {
        i.win  <- i.win + 1 
        dev.set(which=i.win)
      }

      plt.i <- plt.i + 1
      plt.title[plt.i] <- "One-Group Plot"

      if (paired) x.lab <- "Differences of Matched Pairs"

      if (!is.null(pdf_file)) {
        if (!grepl(".pdf", pdf_file))
          pdf_file <- paste(pdf_file, ".pdf", sep="")
        .opendev(pdf_file, width, height)
      }

      .OneGraph(Y, bw1, Ynm, digits_d, brief,
           n, m, mu, mdiff, s, smd, mmd, msmd,
           clpct, tvalue, pvalue, ub, lb, x.lab, alt,
           show_title, full_curve=full_curve, quiet,
           fill=fill)

      if (!is.null(pdf_file)) {
        dev.off()
        .showfile(pdf_file, paste("density plot of", Ynm))
      }
    }

    else {  # mu=NULL: CI only — show density

      if (manage.gr) {
        i.win <- i.win + 1
        dev.set(which=i.win)
      }

      plt.i <- plt.i + 1
      plt.title[plt.i] <- "Density Plot"

      if (!is.null(pdf_file)) {
        if (!grepl(".pdf", pdf_file))
          pdf_file <- paste(pdf_file, ".pdf", sep="")
        .opendev(pdf_file, width, height)
      }

      if (!grepl("gray", getOption("theme"))) {
        clr.v  <- .color_range(.get_fill(), 1)[1]
        c1     <- as.vector(col2rgb(clr.v) / 255)
        col.1  <- rgb(c1[1], c1[2], c1[3])
        col.1d <- rgb(c1[1], c1[2], c1[3], alpha=.2)
      } else {
        col.1  <- rgb(.40, .40, .40)
        col.1d <- rgb(.40, .40, .40, .20)
      }
      col.tx <- getOption("lab_color")
      if (!is.null(fill)) {
        c1 <- as.vector(col2rgb(fill[1]) / 255)
        col.1  <- rgb(c1[1], c1[2], c1[3])
        col.1d <- rgb(c1[1], c1[2], c1[3], alpha=.2)
      }

      dYA   <- suppressWarnings(density(Y, bw1))
      min.x <- min(dYA$x)
      max.x <- max(dYA$x)
      max.y <- max(dYA$y) * 1.1

      xl <- if (length(x.lab) == 1) x.lab else x.lab[4]
      if (nchar(xl) > 52) xl <- paste(substr(xl, 1, 50), "...")

      orig.params <- par(no.readonly=TRUE)
      on.exit(par(orig.params), add=TRUE)
      par(bg=getOption("window_fill"))
      par(mar=c(4.1, 1.5, 4, .4), mgp=c(3, .6, 0), cex=.8)

      plot.new()
      plot.window(xlim=c(min.x, max.x), ylim=c(0, max.y))
      ax <- .axes_dim()
      axT1 <- pretty(c(min.x, max.x))
      .axes(NULL, NULL, axT1, NULL)
      box(col=getOption("panel_color"))
      adj <- .RSadj(axis_size=ax$axis_x_size)
      title(xlab=xl, col.lab=col.tx, cex.lab=adj$axis_size * 1.2)

      polygon(c(min(dYA$x), dYA$x, max(dYA$x)),
              c(0, dYA$y, 0), col=col.1d, border=NA)
      segments(min(dYA$x), 0, max(dYA$x), 0, col=col.1)
      lwd.b <- if (.Platform$OS == "windows") 2 else 1.75
      lines(dYA, col=col.1, lty="solid", lwd=lwd.b)
      y.m <- approx(dYA$x, dYA$y, xout=m)$y
      lines(c(m, m), c(0, y.m), lty="solid", lwd=.85,
            col="gray50")

      if (show_title) {
        mtext("One-Group Density Plot", side=3, line=2.4,
              font=2, col=col.tx)
        mtext(bquote(paste("  n=", .(n),
          "  m=", .(.fmt(m, digits_d)),
          "  s=", .(.fmt(s, digits_d)))),
          side=3, line=1.2, cex=.9, adj=0, col=col.tx)
        mtext(bquote(paste(
          "  ", .(clpct), " CI:  ",
          .(.fmt(lb, 3)), " to ", .(.fmt(ub, 3)))),
          side=3, line=0.1, cex=.9, adj=0, col=col.tx)
      }

      if (.allow.interactive()) {
        plt <- suppressWarnings(dn.plotly(
          x          = Y,
          x_name     = Ynm,
          fill       = col.1,
          x_lab      = xl,
          y_lab      = "Density",
          ax         = NULL,
          bw         = bw1,
          full_curve = full_curve,
          style_opts = .plotly_style()
        ))
        print(plt)
      }

      if (!is.null(pdf_file)) {
        dev.off()
        .showfile(pdf_file, paste("density plot of", Ynm))
      }
    }

    return(list(i=plt.i, ttl=plt.title))
  }  # end if graph

}  # End One Group

Merge <-
function(data1, data2, by=NULL, quiet=getOption("quiet"), ...) {

  if (missing(data1)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify first data frame (table) to merge:  data1\n\n")
  }

  if (missing(data2)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify second data frame (table) to merge:  data2\n\n")
  }

  dname1 <- deparse(substitute(data1))
  dname2 <- deparse(substitute(data2))


  # do the merge
  if (by == "rows") {
    if (!identical(names(data1), names(data2))) { 
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "To do a vertical merge, both data sets must have the same variables.",
        "\n\n")
    }
    l <- attr(data1, which="variable.labels") # save variable labels
    myunits <- attr(data1, which="variable.units") # save variable units
    type <- "vertical"
    data <- rbind(data1, data2)
  }

  else {
    type <- "horizontal"
    l1 <- attr(data1, which="variable.labels") # save variable labels
    l2 <- attr(data2, which="variable.labels") # save variable labels
    myunits1 <- attr(data1, which="variable.units") # save variable units
    myunits2 <- attr(data2, which="variable.units") # save variable units
    data <- merge(data1, data2, by=by, ...)
    l <- c(l1, l2)
    myunits <- c(myunits1, myunits2)
  }


  # restore any variable labels, units
  if (!is.null(l)) attr(data, which="variable.labels") <- l
  if (!is.null(myunits)) attr(data, which="variable.units") <- myunits

  return(data)

}

corScree <- 
function (R=mycor, 
          main=NULL, pdf=FALSE, width=5, height=5, ...) {

  if (!("matrix" %in% class(R))) { # R is a matrix, can be called indirectly
    # cor matrix:  mycor as class out_all, mycor$R, or stand-alone matrix
    cor.nm <- deparse(substitute(R))
    .cor.exists(cor.nm)  # see if matrix exists in one of the 3 locations
    if ("out_all" %in% class(R))    # R 4.0 results in two values: matrix, array
      R <- eval(parse(text=paste(cor.nm, "$R", sep="")))  # go to $R
  }
  else
    cor.nm <- "Correlation Matrix"
  
  # extract eigenvectors
  eig <- eigen(R, symmetric=TRUE, only.values=TRUE)
  ev <- eig$values

  # manage graphics
  # ---------------
  # see if graphics are to be managed (not needed for RStudio)
  manage.gr <- .graphman()

  # if manage, set up graphics system for 2 windows default
  if (!pdf) {
    if (manage.gr) {
      .graphwin(2)
      dev.set(which=3)
    }
  }
  else { 
    pdf_file <- "Scree.pdf"
    pdf(file=pdf_file, width=width, height=height)
  }

  if (getOption("theme") == "gray" ||
     (getOption("theme") == "white"  &&  getOption("sub_theme") == "black"))
    col.ln <- getOption("bar_fill_cont")
  else
    col.ln <- getOption("bar_color_cont")

  # keep track of generated graphics
  plot.i <- 0
  plot.title  <- character(length=0)

  plot.i <- plot.i + 1
  plot.title[plot.i] <- "Eigenvalues"
  # ---------------

  # scree plot
  ev.df = data.frame(ev)
  x.df <- data.frame(seq_len(nrow(ev.df)))
  .plt.main(x.df, ev.df, segments=TRUE, size=.9,
            xlab="Index", ylab="Eigenvalues", main=main,
            use_plotly=FALSE)

  # manage graphics
  # ---------------
  if (pdf) {
    dev.off()
    .showfile(pdf_file, "scree chart")
  }

  if (!pdf) {
    if (manage.gr) {
      dev.set(which=4) 
    }
  }
  else { 
    pdf_file <- "ScreeDiff.pdf"
    pdf(file=pdf_file, width=width, height=height)
  }

  plot.i <- plot.i + 1
  plot.title[plot.i] <- "Differences of Successive Eigenvalues"
  # ---------------

  # differences scree plot
  ev.diff <- -diff(ev)
  ev.diff.df = data.frame(ev.diff)
  x.df <- data.frame(seq_len(nrow(ev.diff.df)))
  .plt.main(x.df, ev.diff.df, segments=TRUE, size=.9,
            xlab="Index", ylab="Differences of Successive Eigenvalues",
             main=main)

# does not work, maybe because using .lc.main instead of .plt.main
#  n.dregs <- 5
#  l.dregs <- length(ev.diff)
#  i.start <- l.dregs-n.dregs
#  dregs <- numeric(length=n.dregs)
#  for (i in 1:n.dregs) dregs[i] <- ev.diff[i+i.start] 
#  abline(h=mean(dregs), col="red", lwd=1)

  # manage graphics
  # ---------------
  if (pdf) {
    dev.off()
    .showfile(pdf_file, "scree difference chart")
    cat("\n\n")
  }
  # ---------------

  cat("\n")
  cat("Eigenvalues of", cor.nm, "\n")
  .dash(15+nchar(cor.nm))
  cat(round(ev, 3))
  cat("\n")

  cat("\n")
  cat("Differences of Successive Eigenvalues of", cor.nm, "\n")
  .dash(41+nchar(cor.nm))
  cat(round(ev.diff, 3))
  cat("\n")

  if (is.null(options()$knitr.in.progress))
    .plotList(plot.i, plot.title)

  cat("\n")

}

.reg1ancova <-
function(lm.out, d.ancova, digits_d=NULL, show_R=FALSE) {

  nm <- all.vars(lm.out$terms)  # names of vars in the model
  nm.a <- names(d.ancova)
  n.vars <- length(nm)
  n.pred <- n.vars - 1L
  n.obs <- nrow(lm.out$model)
  d <- digits_d

  # identify the grouping variable and the covariate
  if (is.numeric(d.ancova[,nm.a[2]]) && is.factor(d.ancova[,nm.a[3]])) {
    x.cat <- 3
    x.cont <- 2
  } else if (is.numeric(d.ancova[,nm.a[3]]) && is.factor(d.ancova[,nm.a[2]])) {
    x.cat <- 2
    x.cont <- 3
  } else {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "ANCOVA requires one numeric and one factor predictor.\n",
      "Could not identify the grouping and covariate columns.\n\n")
  }
  lvl <- levels(d.ancova[,nm.a[x.cat]])
  tbl <- table(d.ancova[,nm.a[x.cat]])

  # ANOVA: term-level Type II sums of squares, each term
  #   adjusted for the other, the factor as one df=k-1 term;
  #   sequential anova() provides each adjusted SS as its
  #   second-entered term, and the full-model Residuals row
  y.v <- d.ancova[,nm.a[1]]
  cont.v <- d.ancova[,nm.a[x.cont]]
  cat.v <- d.ancova[,nm.a[x.cat]]
  a.cont <- anova(lm(y.v ~ cat.v + cont.v))  # row 2: cont | cat
  a.cat <- anova(lm(y.v ~ cont.v + cat.v))   # row 2: cat | cont
  smc <- rbind(a.cont[2,], a.cat[2:3,])
  rownames(smc) <- c(nm.a[x.cont], nm.a[x.cat], "Residuals")
  n.terms <- nrow(smc) - 1
  nt1 <- n.terms + 1

  tx <- character(length=0)

  tx[length(tx)+1] <- "-- Analysis of Variance"
  tx[length(tx)] <-  paste(tx[length(tx)],
                          "from Type II Sums of Squares")
  tx[length(tx)+1] <- ""

  if (show_R) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- .dash2(68)
    tx[length(tx)+1] <- paste("> ","anova(model)", "\n",sep="")
    tx[length(tx)+1] <- .dash2(68)
  }

  # width of column 1
  max.c1 <- max(nchar("Model"), nchar(nm))
  for (i in seq_len(nt1)) {
    c1 <- nchar(rownames(smc)[i])
    if (c1 > max.c1) max.c1 <- c1 
   }

  # width of data columns
  max.ln <- integer(length=4)
  for (i in 1:4) {
    ln.nm <- nchar(colnames(smc)[i])
    max.ln[i] <- ln.nm + 1
    for (j in seq_len(nrow(smc))) {
      xjc <- .fmt(smc[j,i], d=digits_d)
      if (nchar(xjc) > max.ln[i]) max.ln[i] <- nchar(xjc)
    }
    max.ln[i] <- max.ln[i] + 1L
    if (max.ln[i] < 9L) max.ln[i] <- 9L
  }

  # header
  df.lbl <- .fmtc("     df", max.ln[1]+1)
  SS.lbl <- .fmtc(" Sum Sq", max.ln[2]+1)
  MS.lbl <- .fmtc("Mean Sq", max.ln[3]+1)
  fv.lbl <- .fmtc("F-value", max.ln[4]+1)
  tx[length(tx)+1] <- paste(eval(format("", width=max.c1-5)), df.lbl, SS.lbl,
                             MS.lbl, fv.lbl, "   p-value", sep="")

  # predictors (terms, including interactions)
  if (n.pred >= 1) {
    for (i in seq_len(n.terms)) {
      rlb <- .fmtc(rownames(smc)[i], max.c1)
      df <- .fmti(smc[i,1], max.ln[1]-5)
      SS <- .fmt(smc[i,2], digits_d, max.ln[2])
      MS <- .fmt(smc[i,3], digits_d, max.ln[3])
      fv <- .fmt(smc[i,4], digits_d, max.ln[4])
      pv <- .fmt(smc[i,5], 3, 9)
      tx[length(tx)+1] <- paste(rlb, df, SS, MS, fv, pv)
    } 
  }


  # Residuals
  rlb <- .fmtc(rownames(smc)[nt1], max.c1, j="left")
  df <- .fmti(smc[nt1,1], max.ln[1]-5)
  SS <- .fmt(smc[nt1,2], digits_d, max.ln[2])
  MS <- .fmt(smc[nt1,3], digits_d, max.ln[3])
  MSW <- smc[nt1,3]
  tx[length(tx)+1] <- paste(rlb, df, SS, MS) 

  rsd <- c(smc[nt1,1], smc[nt1,2], smc[nt1,3])
  names(rsd) <- c("df", "ss", "ms")

  # Total SS is not meaningful for Type II ANOVA
  # Type II SS are partial sums of squares - each effect is calculated after
  #   adjusting for all other effects at the same level or lower in the
  #   hierarchy, but not for higher-order interactions involving that effect.
  # Each Type II SS represents variation explained by that effect after
  #   accounting for the other effects.
  tot <- NA

  return(list(out_anova=tx, mdl="", rsd=rsd, tot=tot, MSW=MSW))

}

XY <- function(x, y, data=d, filter=NULL,

    by=NULL,
    facet=NULL, n_row=NULL, n_col=NULL, aspect="fill",

    form=c("scatter", "smooth", "contour", "hexbin"),

    theme=getOption("theme"),
    fill=NULL, color=NULL,
    transparency=getOption("trans_pt_fill"),

    enhance=FALSE, means=TRUE,
    pt_size=NULL, pt_size_cut=NULL, pt_shape="circle", line_width=1.5,
    segments=FALSE, segments_y=FALSE, segments_x=FALSE,

    sort=c("0", "-", "+"),
    jitter_x=NULL, jitter_y=NULL,

    ID="row.name", ID_size=0.60,
    MD_cut=0, out_cut=0, out_shape="circle", out_size=1,

    fit=c("off","loess", "lm", "ls", "null", "exp", "quad",
          "power", "log"),
    fit_power=1, fit_se=0.95,
    fit_color=getOption("fit_color"), fit_lwd=getOption("fit_lwd"),
    fit_new=NULL, plot_errors=FALSE, ellipse=0,
    ellipse_fill=getOption("ellipse_fill"),
    ellipse_color=getOption("ellipse_color"),
    ellipse_lwd=getOption("ellipse_lwd"),

    ts_unit=NULL, ts_ahead=0, ts_method=c("es", "lm"),
    ts_source=c("fable", "classic"), ts_agg=c("sum", "mean"),
    ts_NA=NULL, ts_format=NULL, ts_fitted=FALSE, ts_PI=.95,
    ts_trend=NULL, ts_seasons=NULL, ts_error=NULL,
    ts_alpha=NULL, ts_beta=NULL, ts_gamma=NULL, ts_new_x=NULL,
    ts_stack=FALSE, ts_area_fill="transparent", ts_area_split=0,
    ts_n_x_tics=NULL,
    show_runs=FALSE,
    center_line=c("off", "mean", "median", "zero"),

    radius=NULL, power=0.5, low_fill=NULL, hi_fill=NULL,

    smooth_points=100, smooth_size=1,
    smooth_power=0.25, smooth_bins=128, hex_bins=30, hexbin_legend=TRUE,
    n_bins=1,
    contour_n=20, contour_nbins=50, contour_points=FALSE,
    contour_legend=FALSE,

    bin=FALSE, bin_start=NULL, bin_width=NULL, bin_end=NULL,
    breaks="Sturges", cumulate=FALSE,

    xlab=NULL, ylab=NULL, main=NULL, sub=NULL,
    label_adjust=c(0,0), margin_adjust=c(0,0,0,0),  # top, right, bottom, left
    pad_x=c(0,0), pad_y=c(0,0),

    scale_x=NULL, scale_y=NULL, origin_x=NULL, origin_y=NULL,

    rotate_x=getOption("rotate_x"), rotate_y=getOption("rotate_y"),
    offset=getOption("offset"),
    axis_fmt=c("K", ",", ".", ""), axis_x_prefix="", axis_y_prefix="",
    font_size=1,
    xy_ticks=TRUE, n_axis_x_skip=0, n_axis_y_skip=0,

    legend_title=NULL,

    add=NULL, x1=NULL, y1=NULL, x2=NULL, y2=NULL,

    quiet=getOption("quiet"), do_plot=TRUE,
    use_plotly=getOption("lessR.use_plotly"),
    pdf_file=NULL, width=6.5, height=6,
    digits_d=NULL,

    smooth=FALSE,
    stat=c("mean", "sum", "sd", "deviation", "min", "median", "max"),
    stat_x=c("count", "proportion", "%"),

    eval_df=NULL, fun_call=NULL, ...) {


  # y is required unless stat_x set, the freq_poly delegation from X()
  if (missing(y)  &&  missing(stat_x)) {
    if (tryCatch(is.ts(x), error = function(e) FALSE)) {
      stop(call.=FALSE, "\n------\n",
        "x is a time series (class ts).\n",
        "First extract the date and value vectors with tsExtract(),\n",
        "then pass them to XY().\n\n")
    } else {
      stop(call.=FALSE, "\n------\n",
        "Argument y is required.\n",
        "For the distribution of a single variable, use X().\n\n")
    }
  }

  if (is.null(fun_call)) fun_call <- match.call()

  if (nzchar(axis_fmt[1])) axis_fmt <- match.arg(axis_fmt)
  form <- match.arg(form)

  if (font_size != 1) {
    .fs_main   <- getOption("main_size", 1.1)
    .fs_lab    <- getOption("lab_size",  1.0)
    .fs_axis   <- getOption("axis_size", 0.76)
    .fs_axis_x <- getOption("axis_x_size")
    .fs_axis_y <- getOption("axis_y_size")
    options(main_size = .fs_main * font_size,
            lab_size  = .fs_lab  * font_size,
            axis_size = .fs_axis * font_size)
    if (!is.null(.fs_axis_x))
      options(axis_x_size = .fs_axis_x * font_size)
    if (!is.null(.fs_axis_y))
      options(axis_y_size = .fs_axis_y * font_size)
    on.exit({
      options(main_size = .fs_main,
              lab_size  = .fs_lab,
              axis_size = .fs_axis)
      if (!is.null(.fs_axis_x)) options(axis_x_size = .fs_axis_x)
      if (!is.null(.fs_axis_y)) options(axis_y_size = .fs_axis_y)
    }, add = TRUE)
  }

  # collected plotly style options, passed down to plotly internals so they
  # don't reach into getOption() themselves
  style.opts <- .plotly_style()

  ts_agg <- match.arg(ts_agg)
  ts_method <- match.arg(ts_method)
  ts_source <- match.arg(ts_source)
  # "dot" is undocumented but supported — routes to the Trellis dot chart
  # path (Base R, with facet support) until Chart() gains its own facet dots
  dot.type <- identical(form, "dot")
  if (dot.type) form <- "scatter"  # satisfies match.arg; overridden below

  stat.miss <- missing(stat)
  if (stat[1] != "data") stat <- match.arg(stat)  # if condition for shiny
  stat.x.miss <- missing(stat_x)
  stat_x <- match.arg(stat_x)

  trans.miss <- missing(transparency)
  trans <- transparency

  output <- NULL
  out_fitted <- NULL
  out_y.frcst <- NULL

  # Plotly renders only the interactive scatter/line form; the density and
  #   hexbin forms are static (base R / lattice), as is any faceted plot
  if (!quiet && use_plotly &&
      !(form %in% c("smooth", "contour", "hexbin")) &&
      is.null(substitute(facet))) {
    txt <- "[Interactive chart from the Plotly R package (Sievert, 2020)]"
    cat(txt, "\n")
  }

  if (!stat.miss && !stat.x.miss) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Cannot specify both parameters:  stat  and  stat_x\n\n")
  }
  y.miss <- missing(y)
  if (!stat.x.miss && !y.miss) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Use parameter  stat to aggregate numerical variable y.\n",
      "Parameter  stat_x  is only for the categorical variable x.\n\n")
  }
  if (stat.miss) stat <- "data"  # no aggregation
  if (stat.miss  &&  !stat.x.miss) stat <- stat_x

  if (!missing(contour_n) || !missing(contour_nbins) ||
      !missing(contour_points) || !missing(contour_legend))
    form <- "contour"

  if (!is.null(ts_unit)) {
    valid.units <- c("days", "weeks", "months", "quarters", "years", "days7")
    if (!(ts_unit %in% valid.units)) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Invalid value for parameter ts_unit. Valid values:\n",
        "  \"days\", \"weeks\", \"months\", \"quarters\", \"years\", \"days7\"
        \n\n")
    }
  }

  if (!is.null(ts_error) && is.logical(ts_error)) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Parameter  ts_error  now set to  'A' (additive) or ",
        "'M' (multiplicative).\n Enter  ?Plot  to view the details.\n\n")
    }

  if (!is.null(ts_trend) && is.logical(ts_trend)) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Parameter  ts_trend  now set to  'A' (additive) or ",
        "'M' (multiplicative).\n Enter  ?Plot  to view the details.\n\n")
    }

  if (!is.null(ts_seasons) && is.logical(ts_seasons)) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Parameter  ts_seasons  now set to  'A' (additive) or ",
        "'M' (multiplicative).\n Enter  ?Plot  to view the details.\n\n")
    }

  if (!is.null(ts_unit)  &&  !is.null(substitute(facet))) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Parameter  ts_unit  does not yet apply to facet plots.\n\n")
  }

  if (form %in% c("smooth", "contour", "hexbin")  &&
      !is.null(substitute(by))) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Parameter  by  is active only for a scatter plot, form=\"scatter\".\n\n")
  }

  if (form %in% c("contour", "smooth", "hexbin")  &&  !is.null(add)) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Parameter  add  not active for ", form, " plots.\n\n")
  }

  if (is.logical(fit[1])) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Now specify a value for  fit  such as \"loess\" or \"lm\".\n\n")
  }

  if (fit[1] %in% c("xlog", "xylog")) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Parameters  xlog  and  xylog  not yet implemented.\n\n")
  }
  if (smooth) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Parameter  smooth  is now the value of parameter  form.\n",
      "  because  \"contour\"  is now another value of  form.\n",
      "Now enter: form=\"smooth\"  or  form=\"contour\"\n\n")
  }

  fit.ln <- ifelse (!missing(fit), match.arg(fit), "off")
  if (fit.ln == "ls") fit.ln <- "lm"  # least squares synonym

  if (!is.null(fit_new))
    fit_new <- base::sort(fit_new)  # ensure ascending order of fit_new


# old stuff ---------------------------------------------------------------

  # Check for deprecated parameter names using the unevaluated call —
  # must use match.call() here, not names(list(...)), because expressions
  # like rows=(Gender=="M") would be evaluated in the caller's environment
  # before list(...) is reached, causing "object not found" errors.
  .mc_nms <- names(match.call())
  if ("facet1" %in% .mc_nms || "facet2" %in% .mc_nms) {
    stop(call. = FALSE, "\n------\n",
         "The arguments 'facet1' and 'facet2' are replaced.\n",
         "Please use 'facet' instead.\n",
         "For two facets, specify:  facet = c(Var1, Var2)\n\n")
  }
  if ("rows" %in% .mc_nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  rows  has been renamed.\n",
         "Use  filter  instead, e.g., filter = (Age > 30)\n\n")
  }
  if ("area_fill" %in% .mc_nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  area_fill  has been renamed to  ts_area_fill.\n\n")
  }
  if ("n_cat" %in% .mc_nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  n_cat  has been removed.\n",
         "Convert categorical integer variables to factors instead:\n",
         "  e.g., d$Item1 <- factor(d$Item1)\n\n")
  }
  if ("value_labels" %in% .mc_nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  value_labels  has been removed.\n",
         "Convert categorical integer variables to factors instead:\n",
         "  e.g., d$Item1 <- factor(d$Item1, levels=1:3,\n",
         "         labels=c(\"Disagree\", \"Neutral\", \"Agree\"))\n\n")
  }
  if ("size" %in% .mc_nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  size  has been renamed to  pt_size.\n\n")
  }
  if ("size_cut" %in% .mc_nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  size_cut  has been renamed to  pt_size_cut.\n\n")
  }
  if ("shape" %in% .mc_nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  shape  has been renamed to  pt_shape.\n\n")
  }

  # a dot in a parameter name to an underscore and more
  dots <- list(...)
  .style.trap(names(dots))

  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] == "type") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
            "Parameter  type  renamed  form\n\n")
      }
      if (names(dots)[i] == "lty") {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "Parameter  lty  renamed to  line_type\n\n")
      }
      if (names(dots)[i] == "lwd") {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "Parameter  lwd  renamed to  line_width\n\n")
      }
      if (names(dots)[i] == "ts_PIlevel") {
        ts_PI <- dots[[i]]
        message("\nParameter  ts_PIlevel  is now named  ts_PI\n")
      }
      if (names(dots)[i] == "stack") {
        ts_stack <- dots[[i]]
        message("\nParameter  stack  is now named  ts_stack\n")
      }
      if (names(dots)[i] == "sort_yx") {
        sort <- dots[[i]]
        message("\nParameter  sort_yx  is now named  sort\n")
      }
      if (names(dots)[i] == "lab_adjust") {
        label_adjust <- dots[[i]]
        message("\nParameter  lab_adjust  is now named  label_adjust\n")
      }
      if (names(dots)[i] == "stat_yx") stat <- dots[[i]]
      if (names(dots)[i] == "smooth_exp") smooth_power <- dots[[i]]
      if (names(dots)[i] == "area_origin") ts_area_split <- dots[[i]]
      if (grepl(".", names(dots)[i], fixed=TRUE)) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
      }
    }
  }

  if (!is.null(x1)) if ("mean.x" %in% x1) x1 <- "mean_x"
  if (!is.null(y1)) if ("mean.y" %in% y1) y1 <- "mean_y"
  if (!is.null(add)) if ("h.line" %in% add[1])  add[1] <- "h_line"
  if (!is.null(add)) if ("v.line" %in% add[1])  add[1] <- "v_line"

  if ("on" %in% fill) fill <- getOption("violin_fill")
  if ("on" %in% ts_area_fill) ts_area_fill <- getOption("violin_fill")

  # Note: stat is both object (dot plot) and statistic

  # limit actual argument to alternatives, perhaps abbreviated
  sort <- match.arg(sort)

  cl.miss <- missing(center_line)
  center_line <- match.arg(center_line)

  data.do <- stat == "data"

  proportion <- FALSE  # old signal, not used for stat_x="proportion"

  if (plot_errors)
    if (fit.ln == "off") fit.ln <- "lm"

  if (length(pad_x) == 1) {  # only the first element of pad_x specified
    temp <- pad_x
    pad_x <- double(length=2)
    pad_x[1] <- temp
    pad_x[2] <- temp
  }
  if (length(pad_y) == 1) {
    temp <- pad_y
    pad_y <- double(length=2)
    pad_y[1] <- temp
    pad_y[2] <- temp
  }

  cat.x <- FALSE;  cat.y <- FALSE

 if (is.null(fill))
    pt.fill <- getOption("pt_fill")
  else
    pt.fill <- fill
  pt.color <- color
  bbl.txt.col <- getOption("bubble_text_color")
  segment_color <- getOption("segment_color")
  ID_color <- getOption("ID_color")

  se_fill <- getOption("se_fill")

  out_fill <- getOption("out_fill")
  out_color <- getOption("out_color")
  out2_fill <- getOption("out2_fill")
  out2_color <- getOption("out2_color")

  panel_fill <- getOption("panel_fill")
  panel_color <- getOption("panel_color")

  lab_size <- getOption("lab_size")  # NOT passed to .plt.main
  axis_size <- getOption("axis_size")
  main_size <- getOption("main_size")

  add_size <- getOption("add_size")
  add_lwd <- getOption("add_lwd")
  add_lty <- getOption("add_lty")
  add_color <- getOption("add_color")
  add_fill <- getOption("add_fill")
  add_trans <- getOption("add_trans")

  if (theme != getOption("theme")) {  # not the current theme
    old_theme <- getOption("theme")
    style(theme)
    on.exit(style(old_theme), add=TRUE)
    style.opts <- .plotly_style()  # re-capture under new theme
    if (font_size != 1) {  # style() reset font sizes; re-scale
      options(main_size = getOption("main_size", 1.1) * font_size,
              lab_size  = getOption("lab_size",  1.0) * font_size,
              axis_size = getOption("axis_size", 0.76) * font_size)
      .new_x <- getOption("axis_x_size")
      .new_y <- getOption("axis_y_size")
      if (!is.null(.new_x)) options(axis_x_size = .new_x * font_size)
      if (!is.null(.new_y)) options(axis_y_size = .new_y * font_size)
    }
    sty <- style(theme, reset=FALSE)
    trans <- sty$pt$trans_fill
    fill <- sty$pt$fill
    pt.fill <- sty$pt$fill
    pt.color <- sty$pt$fill  # just solid color points
    ellipse_fill <- sty$ellipse$fill
    se_fill <- sty$se_fill
  }

  # missing function only reliable if arg not modified, so capture
  x.miss         <- missing(x)
  by.miss        <- missing(by)
  facet.miss     <- missing(facet)
  size.miss      <- missing(pt_size)
  shape.miss     <- missing(pt_shape)
  radius.miss    <- missing(radius)
  fill.miss      <- missing(fill)
  if (is.null(fill)) fill.miss <- TRUE  # shiny sets fill at NULL if by var
  color.miss     <- missing(color)
  ts.area.fill.miss  <- missing(ts_area_fill)
  seg.miss       <- missing(segments)
  seg.y.miss     <- missing(segments_y)
  seg.x.miss     <- missing(segments_x)
  ellipse.miss   <- missing(ellipse)
  fit.miss       <- missing(fit)
  fit.se.miss    <- missing(fit_se)
  MD.miss        <- missing(MD_cut)
  out.size.miss  <- missing(out_size)
  out.shape.miss <- missing(out_shape)
  n.col.miss     <- missing(n_col)
  n.row.miss     <- missing(n_row)
  add.miss       <- missing(add)
  ylab.miss      <- missing(ylab)

  fill.name <- deparse(substitute(fill))

  # "off" substitutes for official value of "transparent"
  fill[which(fill == "off")] <- "transparent"
  color[which(color == "off")] <- "transparent"
  ellipse_color[which(ellipse_color == "off")] <- "transparent"
  ellipse_fill[which(ellipse_fill == "off")] <- "transparent"
  add_fill[which(add_fill == "off")] <- "transparent"
  add_color[which(add_color == "off")] <- "transparent"

  if (enhance) {
    if (ellipse.miss) ellipse <- 0.95
    if (MD.miss) MD_cut <- 6
    if (add.miss) add <- "means"
    if (fit.miss) fit.ln <- "lm"
  }

  # initialise pt_size here so ts_stack can set it before the eval block
# pt_size <- NULL

  # default point size for a stacked time series
  if (ts_stack) {
    if (size.miss) pt_size <- 0
    size.miss <- FALSE
  }

  # presume text output to the console, could turn off at end of function
  outp <- TRUE

  xlab.adj <- label_adjust[1]; ylab.adj <- label_adjust[2]
  tm.adj <- margin_adjust[1];  rm.adj <- margin_adjust[2]
  bm.adj <- margin_adjust[3];  lm.adj <- margin_adjust[4]

  date.var <- FALSE  # default is not a date variable for x
  freq.poly <- FALSE  # default is not a frequency polygon

  if (!fit.se.miss) if (missing(fit))  fit.ln <- "loess"
  if (fit.se.miss && plot_errors) fit_se <- 0  # default for plot_errors
  if (!by.miss && fit.se.miss && fit.ln!="off") fit_se <- 0  # default for by

  # any bin parameter activates bins for VBS plot, or freq.poly=TRUE
  if (!missing(breaks)  ||  !missing(bin_start)  ||  !missing(bin_width)  ||
      !missing(bin_end))
    bin <- TRUE

  # set object
  if (!missing(radius) || !missing(power)) {
    object <- "bubble"  # any bubble parameter activates a bubble plot
  }
  else
    object <- "point"

  # ------
  # see if dated or inconsistent parameter values
  .param.old(..., fun.name = "XY")
  .plt.bad(x.miss, y.miss, stat, breaks, bin_start, n_row, n_col,
           MD_cut, out_cut, fit_se, ...)

  # if x is in a data frame, then in the function call it is a name
  # if x is in global, then in the function its name is a variable direct


# data frame stuff --------------------------------------------------------

  data.d <- missing(data)

  # let deprecated mydata work as default
  dfs <- .getdfs()
  mydata.ok <- FALSE
  if (!is.null(dfs)) {
    if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
      d <- mydata
      rm(mydata)
      df.name <- "mydata"
      mydata.ok <- TRUE
      options(dname = df.name)
    }
  }

  # get name of data table
  if (!mydata.ok) {
    df.name <- deparse(substitute(data))
    options(dname = df.name)
  }

  shiny <- FALSE
  if (!is.null(sys.call(-1)))  # is NULL when called directly from R console
    if (sys.call(-1) == "renderPlot()") {  # from shiny, user or interact()
      shiny <- TRUE
      data <- eval(substitute(data), envir=parent.frame())
    }

  # if a tibble, convert to data frame
  if (!shiny) {
    if (exists(df.name, envir=.GlobalEnv)) {
      if (any(grepl("tbl", class(data), fixed=TRUE)))
        data <- data.frame(data)
    }
  }
  else  # no check for existence of df.name
    if (any(grepl("tbl", class(data), fixed=TRUE)))
      data <- data.frame(data)

  x.name <- deparse(substitute(x), width.cutoff = 120L)
  if (length(x.name) > 1L)
    x.name <- if (!is.null(xlab) && length(xlab)==1L && nzchar(xlab))
                xlab else "x"
  options(xname = x.name)

  if (x.name != ".Index") {  # not a run chart
    run <- FALSE
  }
  else {  # run chart, create x as sequence of integers from 1
    run <- TRUE
    options(xname="Index")
  }

  # classify x: a computational expression evaluates directly, with a
  # data-column reference resolved from the data frame, then the
  # caller's environment; tryCatch avoids forcing the data=d promise
  x.expr    <- substitute(x)
  x.is.expr <- !missing(x) && .is_expr_arg(x.expr)
  x.uses.df <- FALSE
  if (x.is.expr)
    x.uses.df <- df.name != "NULL" && length(all.vars(x.expr)) > 0L &&
                 any(all.vars(x.expr) %in%
                     tryCatch(names(data), error=function(e) character(0)))

  if (!x.is.expr) {
    if (!(shiny && df.name == "NULL")) .in.global(x.name, quiet)
    x.in.global <- if (shiny && df.name == "NULL") TRUE
                   else df.or.global(x.name, df.name, role="x",
                                     fun.name="XY")
  }
  else
    x.in.global <- !x.uses.df

  if (!x.in.global) {
    # force evaluation (not lazy) if data not specified, relies on default d
    if (data.d) {
      if (!mydata.ok) .nodf(df.name)  # check to see if df exists
      # the 1.201 comes from Shiny, need to reset
      # l.cex and l.axc are set in interact() before shiny analysis
      if (getOption("lab_size") == 1.201) {
       if (getOption("l.cex") != 1.201) {
          style(lab_size=getOption("l.cex"))
          style(axis_size=getOption("l.axc"))
        }
        else
          style(quiet=TRUE)
      }
    }
  }

  # respect a caller-supplied eval_df
  if (is.null(eval_df)) eval_df <- !x.in.global


# subset filter -----------------------------------------------------------

  if (!missing(filter))
    data <- .apply_filter(data,
                          deparse(substitute(filter)),
                          parent.frame(),
                          x.in.global, quiet)


# process x variable ------------------------------------------------------

  # process row.names if specified, is now LEGACY, should be in Chart()
  if (x.name %in% c("row_names", "row.names")) {
    # retain order of row names, otherwise will be alphabetical
    x.call <- data.frame(factor(row.names(data), levels=row.names(data)))
    if (is.null(xlab)) xlab <- ""  # unless specified, drop the axis label
    cat.x <- TRUE
  }

  # x is a computational expression, evaluate directly
  else if (x.is.expr) {
    val <- .expr_eval(x.expr, x.name, if (x.uses.df) data else NULL,
                      parent.frame(), role="x", fun.name="XY")
    x.call <- as.data.frame(val)
    if (ncol(x.call) == 1L) names(x.call) <- x.name
  }

  # x not in global env, in df, specify data= forces to data frame
  else if (!x.in.global) {
    if (eval_df) {
      if (!mydata.ok) .nodf(df.name)  # check to see if df exists
      if (x.name != ".Index")
        .xcheck(x.name, df.name, names(data))  # stop if x an expression
    }

    if (!run) {  # not a run chart
      data.vars <- as.list(seq_along(data))
      names(data.vars) <- names(data)
      x.col <- eval(substitute(x), envir=data.vars)  # col num of each var

      if (!("list" %in% class(data))) {
        x.call <- data[, x.col]
        x.call <- data.frame(x.call)
      }
      else {  # class of data is "list"
         x.call <- data.frame(data[[x.col]])
      }
      if (is.numeric(x.col))
        names(x.call) <- names(data.vars)[x.col]
      else
        names(x.call) <- x.col  # if x a vector, x.col can return names
    }
    else {  # run chart, create x as sequence of integers from 1
      x.call <- data.frame(seq_len(nrow(data)))
      names(x.call) <- "Index"
    }
  }  # end x in df

  # x is in the global environment (vector or data frame)
  else if (is.data.frame(x)) {  # x a global data frame: analyze its columns
    x.call <- as.data.frame(x)  # drop any tibble class; keep column names
  }

  else if (is.ts(x)) {
    stop(call.=FALSE, "\n------\n",
      "x is a time series (class ts).\n",
      "First extract the date and value vectors with tsExtract(),\n",
      "then pass them to XY().\n\n")
  }

  else {  # x is a not ts vector in global
    if (!is.function(x))
      x.call <- data.frame(x)  # x is 1 var
    else  # x is 1 var
      x.call <- data.frame(eval(substitute(data$x)))
    names(x.call) <- x.name
  }

  n.xvar <- ncol(x.call)  # number of x-variables

  cat.x <- is.character(x.call[,1]) || is.factor(x.call[,1])

  # get x.call data to be analyzed into x.call, except for BPFM
  BPFM <- FALSE
  spmat <- FALSE


# see if convert to variable of type Date ---------------------------------

  if (n.xvar == 1) { # one x variable, a vector of cat or num values

    if (grepl("POSIX",  class(x.call[,1]), fixed=TRUE)[1])
      x.call[,1] <- as.Date(x.call[,1])
    date.var <- .is.date(x.call[,1])

    # if sequence of integer years, then convert to type Date
    if (.is.integer(x.call[,1])  &&  !run) {
      diff1 <- all(diff(x.call[,1]) == 1)  # see if consecutive years
      yr.range <- all(x.call[,1] >= 10 & x.call[,1] <= 9999)  # range for yrs
      if (diff1 && yr.range) {
        x.call[,1] <- as.Date(paste0(x.call[,1], "-01-01"))  # to Date
        date.var <- TRUE
        if (!quiet)
          message("\n>>> Note: Variable ", x.name, " assumed ",
                  "to be annual years\n",
                  "Converted to a type Date variable\n",
                  "If forecasting, there will be no seasonality.\n\n")
      }
    }

    # if x.call[,1] has char string values, see if convert to type Date
    if (is.character(x.call[1,1])) {
      if (!is.null(ts_format))  # specify the date format
        x.call[,1] <- as.Date(x.call[,1], format=ts_format)
      else  # see if a date, and if so, infer the date format
        x.call <- date.infer(x.call, quiet)
    }

    if (.is.date(x.call[1,1])) {
     cat.x <- FALSE  # is.char x.call[1,1]
     date.var <- TRUE
    }

    if (cat.x && run) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "A run chart applies only to continuous variables\n",
        x.name, " is a categorical variable\n\n")
    }

  }  # end n.xvar == 1

  # more than one x-variable
  else {
    # no y, see if eligible for BPFM where all selected vars are cat
    # multiple lines of a continuous x-variable also can occur
      is.cat <- logical(length=ncol(x.call))
      is.nmb <- logical(length=ncol(x.call))
      for (i in seq_len(ncol(x.call))) {  # variables all categorical?
        is.string <- is.factor(x.call[,i]) || is.character(x.call[,i])
        is.cat[i] <- is.string
        is.nmb[i] <- is.numeric(x.call[,i])
      }  # end for

      if (all(is.cat)) {
        BPFM <- TRUE
        cat.x <- TRUE
      }
      else if (all(is.nmb)) {
        BPFM <- FALSE
        cat.x <- FALSE
      }
      else {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "Multiple x-variables must all be numeric or all R factors\n\n")
      }


# --- scatterplot matrix detection -----------------------------------

    same.xy.expr <- FALSE
    if (!y.miss) {  # compare *expressions* exactly as typed by the user
      same.xy.expr <- identical(substitute(x), substitute(y))
    }

    if (!y.miss && same.xy.expr && all(is.nmb)) {  # do a scatterplot matrix
      spmat <- TRUE
      # by design, a scatterplot matrix supports neither by nor facet: its
      #   points are small, so group colors from by would not be
      #   distinguishable, and faceting would require multiple large matrices
      if (!by.miss || !facet.miss) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "A scatterplot matrix does not support  by  or  facet.\n",
          "Its many small points make group colors from  by  hard to\n",
          "  distinguish, and faceting would require multiple large\n",
          "  matrices. Both are omitted by design.\n\n")
      }
    }
    else {
      if (y.miss && all(is.nmb)) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "Scatterplot matrices in lessR have a new interface.\n",
          "  Old shortcut:  XY(Salary, Age, Years)\n",
          "  New syntax:    XY(x = c(Salary, Age, Years),\n",
          "                    y = c(Salary, Age, Years))\n\n",
          "The y-missing shortcut is deprecated. Specify the\n",
          "same vector of numeric variables for both x= and y=.\n")
      }
    }

  }  # end more than 1 x-variable


  if (!is.factor(x.call[,1])) if (cat.x) x.call[,1] <- factor(x.call[,1])

  if (!BPFM)
    nrows <- if (is.matrix(x.call[,1])) nrow(x.call[,1]) else length(x.call[,1])
  else
    nrows <- nrow(x.call)

  # date and run chart settings
  if (date.var || run) {  # points and line segments
    object <- "point"
    if (seg.miss) segments <- TRUE
  }
  if (run) {
    if (cl.miss) center_line <- "default"
    if (fill.miss) fill <- "gray20"
    if (color.miss) color <- "gray60"
  }  # end run


  #-----------
  # evaluate y
  if (!y.miss) {
    # get actual variable name before potential call of y.call
    y.name <- deparse(substitute(y))
    if (length(y.name) > 1L)
      y.name <- if (!is.null(ylab) && length(ylab)==1L && nzchar(ylab)) ylab
                else "y"
    options(yname = y.name)

    # classify y as a computational expression, as for x
    y.expr    <- substitute(y)
    y.is.expr <- .is_expr_arg(y.expr)
    y.uses.df <- FALSE
    if (y.is.expr)
      y.uses.df <- df.name != "NULL" &&
                   length(all.vars(y.expr)) > 0L &&
                   any(all.vars(y.expr) %in%
                       tryCatch(names(data),
                                error=function(e) character(0)))

    in.global <- if (shiny && df.name == "NULL") TRUE
                 else if (y.is.expr) !y.uses.df
                 else df.or.global(y.name, df.name, role="y", fun.name="XY")

    # row.names deprecated in favor of row_names
    if (deparse(substitute(y)) %in% c("row_names", "row.names")) {
      # retain order of row names, otherwise will be alphabetical
      y.call <- factor(row.names(data), levels=row.names(data))
      if (is.null(ylab)) ylab <- ""  # unless specified, drop the axis label
      cat.y <- TRUE
      y.call <- data.frame(y.call)
    }


    # y is a computational expression, evaluate directly
    else if (y.is.expr) {
      val <- .expr_eval(y.expr, y.name, if (y.uses.df) data else NULL,
                        parent.frame(), role="y", fun.name="XY")
      y.call <- as.data.frame(val)
      if (ncol(y.call) == 1L) names(y.call) <- y.name
      if (!is.null(x.call)  &&  nrow(y.call) != nrow(x.call)) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "x has ", nrow(x.call), " values, but the  y  expression\n",
          "  ", y.name, "  yields ", nrow(y.call), " values\n\n")
      }
    }

    # y not in global env, in df, specify data= forces to data frame
    else if (!in.global) {
      if (eval_df) .xcheck(y.name, df.name, names(data))  # var in df?
      data.vars <- as.list(seq_along(data))  # even if only a single var
      names(data.vars) <- names(data)  # all data in data frame
      y.col <- eval(substitute(y), envir=data.vars)  # col num selected vars

      if (!("list" %in% class(data))) {
        y.call <- data[, y.col]
        y.call <- data.frame(y.call)
      }
      else  # class of data is "list"
        y.call <- data.frame(data[[y.col]])

      if (is.numeric(y.col))
        names(y.call) <- names(data.vars)[y.col]
      else
        names(y.call) <- y.col
    }  # end not global y

    # y is a data frame in the global env (vector or data frame)
    else if (is.data.frame(y)) { # y a data frame
        y.call <- as.data.frame(y)  # drop any tibble class
    }

    else {  # y a vector in global
      if (!is.function(y))
        y.call <- data.frame(y, stringsAsFactors=TRUE)  # y is 1 var
      else  # y is 1 var
        y.call <- data.frame(eval(substitute(data$y)), stringsAsFactors=TRUE)
      names(y.call) <- y.name
    }

    n.yvar <- ncol(y.call)  # number of y-variables

    if (ncol(y.call) == 1) {  # y is one variable
      if (is.character(y.call[,1]) || is.factor(y.call[,1])) cat.y <- TRUE
      if (!is.factor(y.call[,1])) if (cat.y) y.call[,1] <- factor(y.call[,1])
    }
    else {  # 2 or more y vars
      cat.y <- FALSE  #  multiple y-vars must be numerical
      if (ylab.miss) ylab <- NULL  # use legend instead
      y.call <- data.frame(y.call)
    }
    # if specified, change y NA's to 0 or other specified numerical value
    if (!is.null(ts_NA))
      y.call[is.na(y.call)] <- ts_NA  # reference entire data frame

  }  # end y not missing

  else { # missing y
    y.call <- NULL
    n.yvar <- 0
  }  # end missing y

  if (ts_ahead > 0 && n.yvar > 1) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Can only do a forecast for a single y-variable\n\n")
  }

  if (!is.null(y.call) && !is.numeric(y.call[,1]) && run) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Run chart only applies to a numerical variable\n\n")
  }


  # ---------------------------------
  # ellipse, fit line stop conditions
  if (ellipse[1] > 0) {
    many.y <- FALSE
    if (!y.miss) if (is.matrix(y.call)) many.y <- TRUE
    if ((ncol(x.call)>1 || many.y)  ||  cat.x  ||  cat.y) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "An ellipse only applies to a scatterplot of two, ",
        "continuous variable\n\n")
    }
    if (y.miss) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Need a y-variable to compute an ellipse\n\n")
    }
  }

  if (y.miss && (fit.ln != "off") && n.xvar == 1 && (!date.var && !run)) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "A fit line requires a  y  variable.\n\n")
  }

  if (!facet.miss && cat.x && cat.y) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Parameter  facet  does not work with bubble plots,\n",
      "  that is, with non-numeric categorical variables for  x  and  y.\n\n")
  }


  # ---------------------------------------
  # ---------------------------------------
  # master control funnel for analysis type
  # ---------------------------------------
  lx <- length(x.call[,1])
  n.ux <- length(unique(x.call[,1]))
  x.unique <- n.ux == lx
  y.unique <- if (!is.null(y.call))
    length(unique(y.call[,1])) == length(y.call[,1])
  else
    FALSE

  # get Trellis and T.type
  fnl <- .plt.funnel(data.do, n.xvar, y.miss, cat.x, cat.y, run, date.var,
                     facet.miss, y.unique,
                     x.name=x.name, y.name=y.name,
                     facet.name=if (!facet.miss) deparse(substitute(facet))
                                else NULL)
  Trellis <- fnl$Trellis
  T.type <- fnl$T.type  # needed only for Trellis

  # a facet= would otherwise flip Trellis on and route these to the generic
  #   lattice scatter path; contour/smooth have their own base-R faceted grid,
  #   and hexbin has its own lattice paneling (.plt.hexbin.facet), so keep all
  #   three off the generic Trellis path
  if (form %in% c("contour", "smooth", "hexbin")) Trellis <- FALSE

  # type="dot" requested: force Trellis dot chart path regardless of data shape
  if (dot.type) {
    Trellis <- TRUE
    T.type  <- "dot"
  }

  # end master control funnel
  # -------------------------

  if (is.logical(ellipse))
    ellipse <- if (ellipse) 0.95 else 0.00
  if (ellipse[1] > 0  &&  !Trellis  &&  !quiet  &&  df.name != "NULL") {
    if (!use_plotly) cat("\n")
    txt <- "[Ellipse with Murdoch and Chow's function ellipse"
    cat(txt, "from their ellipse package]\n\n")
  }


  # evaluate by
  #------------
  # cannot directly evaluate is.null(by) if by is present as a variable
  # so instead process as below to either get by.call or it is NULL
  # can get by.name

  do.by <- TRUE
  if (by.miss)
    do.by <- FALSE
  else {
    by.name <- paste(deparse(substitute(by), width.cutoff=120L),
                     collapse="")
    # XY() permits only one  by  variable, e.g., by=c(V1, V2) is not allowed
    by.expr <- substitute(by)
    if (is.call(by.expr) && identical(by.expr[[1L]], as.name("c"))) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Only one  by  variable is permitted, but more than one specified:\n",
        "  by = ", by.name, "\n",
        "  Additional grouping variables are not permitted, as the resulting\n",
        "  visual clutter compromises interpretability.\n",
        "  To display a second grouping variable, use  facet.\n\n")
    }
    if (by.name == "NULL")
      do.by <- FALSE  # specified by=NULL in call, including shiny
    # classify by as a computational expression, as for x
    by.is.expr <- .is_expr_arg(by.expr)
    by.uses.df <- FALSE
    if (by.is.expr) {
      by.uses.df <- df.name != "NULL" &&
                    length(all.vars(by.expr)) > 0L &&
                    any(all.vars(by.expr) %in%
                        tryCatch(names(data),
                                 error=function(e) character(0)))
      by.in.global <- !by.uses.df
    }
    else {
      by.in.global <- df.or.global(by.name, df.name, role="by",
                                   fun.name="XY")
      if (by.in.global) if (is.null(by))
        do.by <- FALSE
    }
  }

  if (do.by)  {  # a by var
    options(byname = by.name)

    # see if var exists in data frame, if x not in global Env or function call
    if (!missing(x) && !by.in.global && !by.is.expr)
      .xcheck(by.name, df.name, names(data))

    if (by.is.expr) {  # by is a computational expression
      by.call <- .expr_eval(by.expr, by.name,
                            if (by.uses.df) data else NULL,
                            parent.frame(), role="by", fun.name="XY")
      if (!is.null(x.call)  &&  length(by.call) != nrow(x.call)) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "x has ", nrow(x.call), " values, but the  by  expression\n",
          "  ", by.name, "  yields ", length(by.call), " values\n\n")
      }
    }
    else if (!by.in.global) {  # get variable's values from data frame col(s)
      data.vars <- as.list(seq_along(data))  # even if only a single var
      names(data.vars) <- names(data)  # all var names in data frame
      by.col <- eval(substitute(by), envir=data.vars)  # col num selected vars
      by.call <- data[, by.col]  # values are original labels here
    }
    else {  # vars that are function names get assigned to global
      by.call <- by
      if (is.function(by.call)) by.call <- eval(substitute(data$by))
    }

   # need by to be a factor
   # .plt.by.legend, plt.main #818, needs levels(by)
    if (!is.factor(by.call)) by.call <- factor(by.call)
    by.unq <- length(unique(by.call))

#   if (shape.miss) pt_shape <- "vary"  # default: vary shapes across by groups
    if (!shape.miss && !is.null(by.call) && pt_shape[1]!="vary")
      pt_shape  <- .align_vector(pt_shape, by.call)  # named shape to unnamed
    shp <- .plt.shapes(pt_shape, out_shape, n.by=by.unq)
    pt_shape <- shp$shape
    out_shape <- shp$out_shape
  }  # end a by var

  else {   # process shapes (without a by var)
    if (pt_shape[1] == "sunflower")
      object <- "sunflower"
    else {  # get numeric code for shape, check for bad shapes
      shp <- .plt.shapes(pt_shape, out_shape)
      pt_shape <- shp$shape
      out_shape <- shp$out_shape
    }
    by.call <- NULL
    by.miss <- TRUE  # just need is.null(by.call) from here forward
  }

  n.by <- if (is.null(by.call)) 0 else nlevels(by.call)

  # already converted to Date if needed, now sort if needed
  if (date.var && !is.null(by.call)) {
    # by from an expression is not a column of data, so check by.call
    is.sorted <- if (by.name %in% names(data))
                   all(order(data[[by.name]]) == seq_len(nrow(data)))
                 else
                   all(order(by.call) == seq_along(by.call))
    if (!is.sorted) {  # then sort by by.call
      ix <- order(by.call)
      x.call <- data.frame(x.call[ix,]);  names(x.call) <- x.name
      y.call <- data.frame(y.call[ix,]);  names(y.call) <- y.name
      by.call <- by.call[ix]
    }
  }

  if (!by.miss) {
    if (all(is.na(by.call))) { # x a data frame
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "All values of  by  are missing. You need some data.\n\n")
    }
  }


# --- resolve facet --------------------------------------------------

  # Initialize legacy internal vars
  facet1.call <- facet2.call <- NULL
  facet1.name <- facet2.name <- NULL
  facet1.miss <- facet2.miss <- TRUE

  if (!missing(facet)) {
    facet.expr <- substitute(facet)
    facet.vars <- all.vars(facet.expr)

    if (.is_expr_arg(facet.expr)) {  # a computational expression
      f.name <- paste(deparse(facet.expr, width.cutoff=120L),
                      collapse="")
      uses.df <- df.name != "NULL" &&
                 any(facet.vars %in%
                     tryCatch(names(data),
                              error=function(e) character(0)))
      v <- .expr_eval(facet.expr, f.name,
                      if (uses.df) data else NULL,
                      parent.frame(), role="facet", fun.name="XY")
      facet1.call <- droplevels(factor(v))
      facet1.name <- f.name
      facet1.miss <- FALSE
      if (!is.null(x.call)  &&
          length(facet1.call) != nrow(x.call)) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "x has ", nrow(x.call), " values, but the  facet  expression\n",
          "  ", f.name, "  yields ", length(facet1.call), " values\n\n")
      }
    }
    else {
    if (length(facet.vars) == 0L) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Parameter  facet  names a categorical variable for its panels.\n\n")
    }
    caller.env <- parent.frame()

    get.col <- function(nm)
      .resolve_named_var(nm, df.name, data, caller.env,
                         role = "facet", fun.name = "XY")

    # Resolve symbols to factors
    fac.list <- lapply(facet.vars, function(nm) {
      v <- get.col(nm)
      if (is.numeric(v)  &&  length(unique(v)) > 25) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "Parameter  facet  requires a categorical variable, but  ", nm,
          "\n  is numeric with ", length(unique(v)), " unique values.\n",
          "\nIf  ", nm, "  is categorical, convert it to an R factor:\n",
          "  d$", nm, " <- factor(d$", nm, ")\n\n")
      }
      if (!is.factor(v)) v <- factor(v)
      droplevels(v)
    })

    # Map into legacy internal vars
    if (length(fac.list) >= 1L) {
      facet1.call <- fac.list[[1L]]
      facet1.name <- facet.vars[1L]
      facet1.miss <- FALSE
    }
    if (length(fac.list) >= 2L) {
      facet2.call <- fac.list[[2L]]
      facet2.name <- facet.vars[2L]
      facet2.miss <- FALSE
    }
    if (length(fac.list) > 2L) {
      message("`facet` has ", length(fac.list),
              " variables; using the first two: ",
              paste(facet.vars[1:2], collapse = ", "), ".")
      fac.list   <- fac.list[1:2]
      facet.vars <- facet.vars[1:2]
    }
    }  # end facet names categorical variable(s), not the x/y vector
  }

  # a facet= with a vector of x (or y) variables panels the multi-series
  #   overlay by the facet variable(s), drawn by the facet-series dispatch
  #   below, so keep it off the generic lattice scatter path
  if (!date.var  &&  !run  &&  !facet1.miss  &&
      (ncol(x.call) > 1  ||  (!is.null(y.call) && ncol(y.call) > 1)))
    Trellis <- FALSE


  # evaluate size (NULL, numeric constant, or a variable)
  # internally called 'size' from here forward
  #--------------

  if (!missing(pt_size)) {
    size.name <- deparse(substitute(pt_size))
    if (size.name == "NULL") {
      size.miss <- TRUE
    }
    else {
      suppressWarnings(size.num <- as.numeric(size.name))
      if (is.na(size.num)) {
        # Check caller frame first — handles Shiny pre-evaluated vectors
        # (e.g. size_val defined in renderPlot) without forcing evaluation
        # of a bare variable name like Pre that lives in the data frame.
        if (exists(size.name, envir=parent.frame(), inherits=TRUE) &&
            is.numeric(get(size.name, envir=parent.frame(),
                           inherits=TRUE))) {
          pt_size <- get(size.name, envir=parent.frame(), inherits=TRUE)
        } else {
          in.global <- df.or.global(size.name, df.name, role="pt_size",
                                    fun.name="XY")
          if (!in.global) {
            data.vars <- as.list(seq_along(data))
            names(data.vars) <- names(data)
            size.col <- eval(substitute(pt_size), envir=data.vars)
            pt_size <- data[,size.col]
            if (!is.numeric(pt_size)) {
              cat("\n"); stop(call.=FALSE, "\n------\n",
                "Variable ", size.name, " must be numeric\n\n",
                "Perhaps use: by=", size.name, "\n\n")
            }
            options(sizename = size.name)
          }  # end not global
        }  # end else data frame lookup
      }  # end is.na(size.num)

      if (is.null(pt_size[1])) size.miss <- TRUE
      if (length(pt_size) > 1) {
        object <- "bubble"
        options(sizename = size.name)
      }
    }  # end size.name not "NULL"
  }  # end pt_size specified

  if (is.null(pt_size_cut)) {
    if (length(pt_size) > 1)
      pt_size_cut <- 2
    else
      pt_size_cut <- if (cat.x) 1 else 2
  }


  # evaluate ID
  #------------
  get.ID <- FALSE
  if (!is.null(add)) if (add[1] == "labels") get.ID <- TRUE
  if (MD_cut>0 || out_cut>0) get.ID <- TRUE

  if (get.ID) {
    # ID.name is the actual var name if specified directly,
    #  or the name of the var that contains the var name
    ID.name <- deparse(substitute(ID))
    ID.name <- gsub("\"", "", ID.name)  # remove extra quotes if "row.name"
    if (ID.name == "row.name") ID.name <- "row.names"
    if (!x.in.global) {
  # if x is in a data frame, then in the function call it is a name
  # if x is in global, then in the function its name is a variable direct
  # ID.col is the actual var column if specified directly,
  #  or the var name if a variable that contains the name was entered
      if (ID.name != "row.names") {
        # data.vars only built when x was specified and is in the data frame
        if (!exists("data.vars", inherits=FALSE)) {
          data.vars <- as.list(seq_along(data))
          names(data.vars) <- names(data)
        }
        ID.col <- eval(substitute(ID), envir=data.vars, parent.frame())
        if (!is.numeric(ID.col)) {
          ID.col <- which(names(data) == ID.col)
          ID.name <- names(data)[ID.col]
        }
      .xcheck(ID.name, df.name, names(data))  # var exists in data frame?
      ID.call <- data[, ID.col]
      }  # end not row.names
      else  # ID is row.names
        ID.call <- row.names(data)
    } # end !x.in.global

    else {  # in global
      ID.call <- eval(substitute(ID), parent.frame())
    }
  }  # end get.ID

  else  # no ID to get
    ID.call <- NULL


  # -----------  x, y, by, size, and ID variables established -------
  # -----------------------------------------------------------------

  if (missing(height)  ||  is.null(height)) {
    if (is.null(y.call)  &&  !BPFM
        &&  data.do  &&  object != "point"  &&  !.is.date(x.call))
      height <- if (is.null(main)) 4 else 4.6  # narrow for 1-D dot plot
    else
      height <- 6

    if (BPFM)  # more than 7 variables, make plot extra long
      height <- height + ((ncol(x.call) - 7) * 0.5)
  }

  if (is.null(width)) width <- 6.5  # the formal default, if NULL passed
  if (!is.null(by.call)) width <- width + .85  # wider plot

  # ---------------------------------
  #  manage regular-R or PDF graphics
  #  for Trellis, .plt.lattice plots to and closes the pdf device opened
  #  here, but .bar.lattice does not support direct pdf output
  pdf.trellis <- Trellis  &&  do_plot  &&
                 T.type %in% c("cont", "cont_cont", "cont_cat")
  if (!is.null(pdf_file)) {
    if (!Trellis  ||  pdf.trellis) {
      if (!grepl(".pdf", pdf_file))
        pdf_file <- paste(pdf_file, ".pdf", sep="")
      pdf(file=pdf_file, width=width, height=height, onefile=FALSE)
    }
  }
  else {
    if (!Trellis  &&  df.name != "NULL")  # not dev.new for shiny
        .opendev(pdf_file, width, height)
  }


# drop rows with missing data across x, y, by, facet, and size ------------

  if (!date.var) {  # except for time series
    if (!spmat) {  # not a scatterplot matrix
      # 1) Build a temporary data frame that contains all relevant columns
      df <- data.frame(x.call)
      if (!is.null(y.call)) df <- cbind(df, y.call)
      if (!is.null(by.call)) df$..by <- by.call
      if (!is.null(facet1.call)) df$..facet1 <- facet1.call
      if (!is.null(facet2.call)) df$..facet2 <- facet2.call
      if (!is.null(pt_size) && length(pt_size) > 1) df$..size <- pt_size

      # 2) Compute complete cases
      cc <- stats::complete.cases(df)

      # 3) Delete rows with missing data
      if (!all(cc)) {
        x.call <- x.call[cc, , drop = FALSE]
        if (!is.null(y.call)) y.call <- y.call[cc, , drop = FALSE]
        if (!is.null(by.call)) by.call <- by.call[cc]
        if (!is.null(facet1.call)) facet1.call <- facet1.call[cc]
        if (!is.null(facet2.call)) facet2.call <- facet2.call[cc]
        if (!is.null(pt_size) && length(pt_size) > 1) pt_size <- pt_size[cc]
      }

      rm(df)
    }
  }


# set object and values where needed --------------------------------------

  # prep 1-variable bubble plot
  # y.call to 0   >> Move all no y to X()
  if (is.null(y.call)  &&  cat.x  &&  n.xvar == 1  &&  data.do) {
    y.call <- data.frame(rep(0, nrow(x.call)), stringsAsFactors=TRUE)
    cat.y <- FALSE
    object <- "bubble"
    if (is.null(low_fill)) low_fill <- "gray20"
    if (is.null(hi_fill)) hi_fill <- "gray20"
  }
  # if numeric x is sorted with equal intervals, set as line chart
  #   unless doing a fit line as only want one line
  # x.call does not exist for BPFM
  if (!cat.x && fit.ln=="off") {
    if (is.numeric(x.call[,1]) && nrows>2) {
      if (object == "point") {
        eq.int <- !any(is.na(x.call[,1]))
        if (eq.int) {
          d.x <- diff(x.call[,1])  # only look at first x-variable
          for (i in 2:(length(d.x)))
            if ((abs(d.x[i-1] - d.x[i]) > 0.0000000001)) {
              eq.int <- FALSE
              break
            }
          rm(d.x)
        }  # also no y missing
        if (!is.unsorted(x.call) && eq.int && sum(is.na(y.call))==0) {
          if (is.null(pt_size)) pt_size <- 0  # by default, line w/o points
          if (seg.miss) segments <- TRUE
        }
      }
    }
  }

  if (object == "point") {  # see if bubble plot, already set if size a var
    if (!y.miss) {
      if (data.do) if (cat.x && cat.y) object <- "bubble"
    }
    else {
      if (data.do) object <- if (cat.x) "bubble" else "point"
      if (BPFM) object <- "bubble"  # BPFM
    }
  }

  pt.trans <- trans
  if (object == "bubble"  &&  trans.miss) pt.trans <- 0.4

  if (!stat.x.miss) n.yvar <- 1

  if (y.miss  &&  !date.var  &&  object != "bubble" && !stat.x.miss) {

    if (!cat.x) {  # freq polygon

      ssstuff <- .ss.numeric(x.call[,1], digits_d=digits_d, brief=TRUE)

      # get x.call binned  values and corresponding y.call count values
      # do the actual freq poly in .plt.main
      # do not do a histogram (do_plot=FALSE)
      hist.cumul <- ifelse(cumulate, "on", "off")
      reg <- "snow2"  # applies to cumulative histogram
      digits_d <- .max.dd(x.call[,1])
      h <- .hst.main(x.call[,1], by=NULL, by.name=NULL, n.by=1,
         pt.fill, pt.color, pt.trans, reg,
         rotate_x, rotate_y, offset,
         breaks, bin_start, bin_width, bin_end,
         proportion, counts=NULL, hist.cumul,
         xlab, ylab, main, sub,
         bm.adj=0, lm.adj=0, tm.adj=0, rm.adj=0,
         axis_fmt="K", axis_x_pre="", axis_y_pre="",
         use_plotly=FALSE, digits_d=NULL,
         quiet=FALSE, do_plot=FALSE, fun_call=NULL, ...)

      x.call <- h$mids
      y.call <- h$counts
      if (stat_x == "count")
        ylab <- paste("Count of", x.name)
      else if (stat_x == "%") {
        y.call <- (y.call / sum(y.call)) * 100
        ylab <- paste("Percentage of", x.name)
      }
      else {
        y.call <- y.call / sum(y.call)
        ylab <- paste("Proportion of", x.name)
      }

      # last assignment of object, now determined
      object <- "point"  # do freq poly as a line chart
      segments <- TRUE
      freq.poly <- TRUE  # need to indicate fill possibility
      center_line <- "off"  # not meaningful here

      cat.y <- FALSE

      txsug <- ""
      if (getOption("suggest")) {
        txsug <- ">>> Suggestions  or  enter: style(suggest=FALSE)"

        fncl <- .fun_call.deparse(fun_call)
        fncl <- gsub(")$", "", fncl)  # get function call less closing )
        fncl <- gsub(" = ", "=", fncl)

        fc <- ""
        if (!grepl("pt_size", fncl))
          fc <- paste(fc, ", pt_size=0", sep="")
        if (nzchar(fc)) {
          fc <- gsub(" = ", "=", fc)
          fc <- paste(fncl, fc, ")   # just line segments, no points", sep="")
          txsug <- paste(txsug, "\n", fc, "\n", sep="")
        }

        bw.new <- pretty((x.call[2] - x.call[1]) / 1.5)  # arbitrary new bw
        fc <- ""
        if (!grepl("bin_width", fncl))
          fc <- paste(fc, ", bin_width=", as.character(bw.new[1]), sep="")
        if (nzchar(fc)) {
          fc <- paste(fncl, fc, ") ", sep="")
          txsug <- paste(txsug, fc, sep="")
        }

        txsug <- .rm.arg.2(" x=", txsug)
      }

      txss <- ssstuff$tx  # stats output before reduce data

      txdst <- h$ttx
      if (is.null(txdst)) txdst <- ""

      bx <- .bx.stats(x.call)
      txotl <- bx$txotl

      class(txsug) <- "out"
      class(txss) <- "out"
      class(txdst) <- "out"
      class(txotl) <- "out"
      output <- list(out_suggest=txsug, out_ss=txss, out_freq=txdst,
                     out_outliers=txotl)
      class(output) <- "out_all"
      if (!quiet) print(output)

      x.call <- data.frame(x.call, stringsAsFactors=TRUE)
      y.call <- data.frame(y.call, stringsAsFactors=TRUE)
    }  # end freq polygon

    else {  # cat.x
      # just x variable, so set y.call to plot points for count and prop
      if (stat_x %in% c("count", "proportion", "%")) {

        if (Trellis) {  # follow dot plot format and do horizontal plot
          cat.y <- FALSE
          if (seg.x.miss) segments_x <- TRUE
          if (ylab.miss) {
            ylab <- ifelse (stat == "count", "Count of",
                    ifelse (stat == "%", "Percentage of", "Proportion of"))
            ylab <- paste(ylab, x.name)
          }
          x.call <- data.frame(x.call, stringsAsFactors=TRUE)
        }  # end if Trellis

        else {  # not Trellis, so manually flip to match dot plot style
          cat.x <- FALSE
          if (seg.y.miss) segments_y <- TRUE
          if (stat == "count")
            xlab <- "Count of"
          else if (stat == "proportion")
            xlab <- "Proportion of"
          else
            xlab <- "Percentage of"
          xlab <- paste(xlab, x.name)
          ylab <- NULL
          frq <- table(x.call)
          if (stat == "proportion") frq <- frq / sum(frq)
          if (stat == "%") frq <- (frq / sum(frq)) * 100
          if (is.factor(x.call))  # preserve ordering, will lose order attribute
            y.call <- factor(names(frq), levels=levels(x.call))
          else
            y.call <- factor(names(frq))
          cat.y <- TRUE
          options(yname=x.name)
          y.call <- data.frame(y.call, stringsAsFactors=TRUE)
          x.call <- data.frame(as.vector(frq), stringsAsFactors=TRUE)
        }
      }  # end values in
    }  # end cat.x

  }  # end is null y.call


  # ----------------------------------------------------------------
  # object now determined: "point", "bubble", or "sunflower"

  # flag unsorted data for time series
  if (date.var) {

    b.name <- NULL
    sort.flag <- NULL
    if (!is.null(by.call)) if (!is.null(by.name)) {
      b.name <- by.name
      sort.flag <- !is.unsorted(by.call)
    }
    if (!is.null(facet1.call)) if (!is.null(facet1.name)) {
      b.name <- facet1.name
      sort.flag <- !is.unsorted(facet1.call)
    }

    # is.unsorted() flags sorted but in descending order
    if (df.name != "NULL") {  # by var not detected at first with shiny
      if (is.null(b.name)) {  # no by or facet variable
        if (is.unsorted(x.call[,1])) {
          message(">>> Note\n",
            "The  Date  variable is not sorted in Increasing Order.\n\n",
            "For a data frame named d, enter: \n    ",
             paste("d <- order_by(d, ", x.name, ")", sep=""), "\n",
            "Maybe you have a  by  variable with repeating Date values?\n",
          "Enter  ?order_by  for more information and examples.\n\n")
        }
      }
      else {  # a by or facet variable
        if (!sort.flag) {
          message(">>> Warning\n",
            "The  by  variable is not sorted in Increasing Order.\n\n",
            "For a data frame named d, enter: \n    ",
            paste("d <- order_by(d, by=c(", b.name, ", ", x.name, "))",
                sep=""), "\n",
                "Enter  ?order_by  for more information and examples.\n\n")
        }
      }  # end else
    } # end df.name not "NULL"
  }  # end date.var

  # bubble size
  if (radius.miss)
    radius <- ifelse (length(pt_size) > 1, .12, .22)

  # size of points
  if (size.miss)  # pt.size not set yet
    pt.size <- 1.00
  else  # size had been set
    pt.size <- pt_size

  if (size.miss) {  # pt.size is a scaler
    if (object=="point" && segments) {  # pts and lines specified
      pt.size <- 0.85 * pt.size  # default pt size when segments specified
      if (!("transparent" %in% ts_area_fill))
        pt.size[1] <- 0  # default no points if area shown
      else if (nrows > 50) {
        pt.size <- .75 - 0.002*nrows
        if (pt.size < 0.10) pt.size <- 0
      }
    }  # end point and segments
  }

  n.xcol <- ncol(x.call)
  if (y.miss && !run) n.xcol <- 1
  n.ycol <- if (y.miss) 0 else ncol(y.call)
  nn.col <- max(n.xcol, n.ycol)  # n_col goes into lattice, do not change

  # a vector of x (or y) variables, but not a scatterplot matrix, which is
  #   handled earlier. The bivariate-density forms need a single x and a
  #   single y, and by= is not meaningful across a vector of x variables.
  if (!spmat) {
    if ((n.xcol > 1 || n.ycol > 1) &&
        form %in% c("smooth", "contour", "hexbin")) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "A  ", form, "  plot displays the joint density of a single\n",
        "  continuous  x  and a single continuous  y, so it does not\n",
        "  accept a vector of  x  or  y  variables.\n\n")
    }
    if (n.xcol > 1 && !by.miss) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Parameter  by  is not meaningful with a vector of  x  variables,\n",
        "  which already occupy the color (series) dimension of the plot.\n\n")
    }
  }

  if (substr(fill.name[1], 1, 9) == "getColors") {
    if (!fill.miss && !is.null(by.call))
      fill <- .resolve_getColors_n(fill.name, n.by)
    else if (!fill.miss && !quiet) {
      message("Note: multi-color fill ignored without by=. ",
              "Use by= to map gradient across groups, or set fill= ",
              "to a single color.")
    }
  }

  ord.by.call <- is.ordered(by.call)
  if (!fill.miss && !is.null(by.call)) {
    if (!.is.palette(fill[1]))
      fill  <- .align_vector(fill, by.call)  # named fill to legacy unnamed
  }
  if (!color.miss && !is.null(by.call)) {
    if (!.is.palette(color[1]))
      color  <- .align_vector(color, by.call)  # convert named color to legacy
  }

  # scatterplot matrix has no by= grouping, so all points share one color;
  #   multiple x/y columns must not be read as multiple color groups
  n.col.clr <- if (spmat) 1 else nn.col
  fc <- .plt.colors(object, n.col.clr, n.by, segments, theme, fill, fill.miss,
          color, color.miss, ts_area_fill, ts.area.fill.miss, trans, ts_stack,
          n.ycol, n.yvar, ord.by.call, run, pt.size)

  # assign fills and colors
  pt.fill <- fc$pt_fill
  pt.color <- fc$pt_col
  ts_area_fill <- fc$area_fill


  # ------------------------------------------------
  # analysis
  # ------------------------------------------------

  txstats <- NULL  # remains NULL if stat analysis (e.g., mean) does not occur

  # Trellis plot
  # ------------
  if (Trellis) {
    if (T.type %in% c("cont", "cont_cont", "cont_cat")) {

      if (!quiet)
        cat("[Trellis (facet) graphics from Deepayan Sarkar's",
            "lattice package]\n\n")

      n.facet1 <- length(levels(facet1.call))

      if (!y.miss) {
        if (xor(cat.x, cat.y)  &&  n.facet1 > 1) {
          cont.nm <- if (cat.x) y.name else x.name  # the continuous variable
          cat.nm  <- if (cat.x) x.name else y.name  # the categorical variable
          fname <- if (!is.null(facet2.name))
                     paste0("c(", facet1.name, ", ", facet2.name, ")")
                   else facet1.name
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "XY() requires a continuous  x  and a continuous  y.\n",
            "For a faceted distribution of the continuous  ", cont.nm,
            "  across\n  the levels of the categorical  ", cat.nm,
            ", use  X()  with a  by  variable:\n",
            "  X(", cont.nm, ", by=", cat.nm, ", facet=", fname, ")\n\n")
        }
      }

      # VBS plots (a single numeric variable) now processed by X()
      # e.g., y.miss=FALSE,  Plot(Years, Salary, facet1=Gender)
      adj.bx.ht <- nrows  # just to adjust box height
      if (size.miss) pt.size <- pt.size * .8

      if (!is.null(jitter_x)) if (jitter_x > 0)  # not available in stripplot
        x.call[,1] <- jitter(x.call[,1], factor=jitter_x)

      # n_col is null for XY(x), XY(x, by=), XY(x, facet=)
      if (n.col.miss && n.row.miss && !is.null(facet1.call))
        n_col <- 1  # default n_col for Trellis

      options(facet1name=facet1.name)
      if (do_plot)
      .plt.lattice(x.call[,1], if (!is.null(y.call)) y.call[,1] else NULL,
                   facet1.call, facet2.call, by.call,
                   adj.bx.ht, object, n_row, n_col, aspect,
                   pt.fill, ts_area_fill, pt.color, panel_fill, panel_color,
                   pt.size, line_width,
                   xlab, ylab, main, pt_shape, lab_size, axis_size,
                   max(ellipse), ellipse_color, ellipse_lwd,
                   fit.ln, fit_power, fit_color, fit_lwd, fit_se,
                   plot_errors, ts_area_split, jitter_y,
                   violin=FALSE, violin_fill=getOption("violin_fill"),
                   box=FALSE, box_fill=getOption("box_fill"),
                   bw=NULL, vbs_ratio=0.9, box_adj=FALSE, a=-4, b=3,
                   k.iqr=1.5, fences=FALSE, vbs_mean=FALSE,
                   out_shape, out_size,
                   out_fill, out_color, out2_fill, out2_color,
                   ID.call, out_cut, ID_color, ID_size,
                   axis_fmt, axis_x_prefix, axis_y_prefix,
                   rotate_x, rotate_y, n_axis_x_skip, n_axis_y_skip,
                   width, height, pdf_file, T.type, quiet, ...)


# pivot tables ------------------------------------------------------------

      if (!date.var && !run) {  # no time vars

        x_vec <- x.call[[ x.name ]]   # e.g., data[["Salary"]]
        group.vars <- character(0)

        if (!quiet) cat("\n---------- Summary Statistics for", x.name)

        if (!by.miss) {
          group.vars <- c(group.vars, by.name)
          out.by <- .vbs_summary_table(
            x_vec    = x_vec,
            grp_vec  = by.call,
            grp.label = by.name,
            digits_d  = .max.dd(x_vec)
          )
          if (!quiet) {
            cat("\n\n")
            print(out.by)
          }
        }

        if (!facet.miss) {
          # Use facet1.call/facet2.call which were updated by the cc NA filter,
          #   not fac.list which still holds the original pre-filter data.
          facet.calls <- list(facet1.call, facet2.call)[seq_along(facet.vars)]
          out.facet <- vector("list", length(facet.vars))
          for (.fi in seq_along(facet.vars)) {
            group.vars <- c(group.vars, facet.vars[.fi])
            out.facet[[.fi]] <- .vbs_summary_table(
              x_vec     = x_vec,
              grp_vec   = facet.calls[[.fi]],
              grp.label = facet.vars[.fi],
              digits_d  = .max.dd(x_vec)
            )
            if (!quiet) {
              cat("\n\n")
              print(out.facet[[.fi]])
            }
          }
        }

        if (length(group.vars) == 0) {
          out.all <- .vbs_summary_table(
            x_vec  = x_vec,
            grp_vec = NULL,
            grp.label = x.name,
            digits_d  = .max.dd(x_vec)
          )
          if (!quiet) {
            cat("\n\n")
            print(out.all)
          }
        }
      }  # end pivot tables with no time vars

      if (do_plot  &&  .allow.interactive()) {
        .viewer_notice_once(plot_name = form, window_target = "Plots")
      }
    }  # end T.type != "dot

    else {  # bar plot

      if (seg.x.miss) segments_x <- TRUE
      if (do_plot)
      .bar.lattice(x.call[,1], facet1.call, facet2.call, n_row, n_col, aspect,
                   proportion, pt.fill, pt.color,
                   pt.trans, pt.size, xlab, ylab, main,
                   rotate_x, offset,
                   axis_fmt, axis_x_prefix, axis_y_prefix,
                   width, height, pdf_file,
                   segments_x, breaks=NULL, T.type,
                   quiet=quiet, ...)
    }


  }  # end Trellis


  # ------------------
  # scatterplot matrix
  else if (spmat) {
    if (do_plot) {
      bckg <- ifelse(panel_fill=="transparent",
                     getOption("window_fill"), panel_fill)
      .plt.mat(x.call, fit=fit.ln, col_fill=pt.fill, col_color=pt.color,
                       col.bg=bckg, col_trans=pt.trans,
                       pt.size=pt.size, size.miss=size.miss)
    }
  }

  # ------------------
  # faceted contour or smooth density: base-R panel grid, shared density scale
  else if (form %in% c("contour", "smooth")  &&  !facet1.miss) {
    if (do_plot) {
      xlb <- if (!is.null(xlab) && nzchar(xlab)) xlab else x.name
      ylb <- if (!is.null(ylab) && nzchar(ylab)) ylab else y.name
      .plt.contour.facet(x.call[,1], y.call[,1],
         facet1.call, facet2.call, facet1.name, facet2.name,
         contour_n, contour_nbins, contour_points, pt.size[1],
         getOption("theme"), scale_x, scale_y, pad_x, pad_y, xlb, ylb,
         ellipse, ellipse_color, ellipse_lwd, fit.ln, fit_color, fit_lwd,
         axis_x_prefix, axis_y_prefix, axis_fmt, n_row, n_col, quiet,
         render = form, smooth_power = smooth_power,
         smooth_points = smooth_points, smooth_bins = smooth_bins,
         main = main)
    }
  }

  # ------------------
  # faceted hexbin: hexbin's native lattice paneling, one shared count legend
  else if (form == "hexbin"  &&  !facet1.miss) {
    if (do_plot) {
      xlb <- if (!is.null(xlab) && nzchar(xlab)) xlab else x.name
      ylb <- if (!is.null(ylab) && nzchar(ylab)) ylab else y.name
      .plt.hexbin.facet(x.call[,1], y.call[,1],
         facet1.call, facet2.call, facet1.name, facet2.name,
         hex_bins, hexbin_legend, xlb, ylb, n_row, n_col, aspect, quiet,
         axis_fmt = axis_fmt, axis_x_pre = axis_x_prefix,
         axis_y_pre = axis_y_prefix)
    }
  }

  # ------------------
  # facet= with a vector of x (or y) variables: the multi-series overlay
  #   repeated across the panels of the facet variable(s), each panel the
  #   full overlay for one facet level, all panels on a common scale
  else if (nn.col > 1  &&  !facet1.miss) {
    if (do_plot) {
      if (!quiet)
        cat("[Trellis (facet) graphics from Deepayan Sarkar's",
            "lattice package]\n\n")
      if (n.xcol > 1) {
        ylb <- if (!is.null(ylab) && nzchar(ylab)) ylab else y.name
        .plt.facet.series(x.call, y.call[,1], ylb, "x",
           facet1.call, facet2.call,
           pt.fill, pt.color, pt.size, pt_shape,
           fit.ln, fit_lwd, n_row, n_col, aspect)
      }
      else {
        xlb <- if (!is.null(xlab) && nzchar(xlab)) xlab else x.name
        .plt.facet.series(y.call, x.call[,1], xlb, "y",
           facet1.call, facet2.call,
           pt.fill, pt.color, pt.size, pt_shape,
           fit.ln, fit_lwd, n_row, n_col, aspect)
      }
    }
  }

  else if (n_bins > 1) {  # bin the x-axis, compute mean or median of y by bin

    if (stat.miss) stat <- "mean"
    if (seg.miss) segments <- TRUE
    if (size.miss) pt.size <- 1.1
    if (is.null(digits_d)) digits_d <- 3
    nm.x <- x.name
    nm.y <- y.name
    # size is NULL if not specified
    .plt.bins(x.call[,1], y.call[,1], nm.x, nm.y, stat, n_bins,
              segments=segments, size=pt_size, digits_d, scale_x, scale_y,
              fill=pt.fill, color=pt.color, trans=pt.trans,
              quiet=quiet)
    use_plotly <- FALSE
  }

  # all the other analyses
  # ----------------------

  else {
    if (stat %in% c("sum", "mean", "sd", "deviation", "min", "median", "max")) {

      means <- FALSE
      if (seg.x.miss) segments_x <- TRUE

      if (!missing(y) && cat.y) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
        y.name, " is not numerical, so cannot compute its mean\n\n")
      }

      # compute stats text before reducing data, printed later if !quiet
      if (!missing(y)) {
        options(yname = x.name)  # reverse order of x and y for .ss.numeric
        options(xname = y.name)
        stats <- .ss.numeric(y.call[,1], by=x.call[,1],
                             digits_d=digits_d, brief=TRUE, y.name=x.name)
        txstats <- stats$tx
        options(xname = x.name)  # reverse back
        options(yname = y.name)
      }
      else  {  # y is missing, so counts
        stats <- .ss.factor(x.call, digits_d=digits_d, x.name=x.name,
                            brief=TRUE)
        txstats <- stats$counts
      }

      class(txstats) <- "out"

    # set up new x.call and y.call for stats
    # only does overall stat, so not applicable if a by parameter
      stat.out <- .agg(x.call[,1], y.call[,1], stat=stat, y.name=y.name)
      ylab <- stat.out$ylab

      x.call <- data.frame(x.call=stat.out$out$x, stringsAsFactors=TRUE)
      y.call <- data.frame(y.call=stat.out$out$y)
    }  # end stat transform


    # ----------------------------------------------------
    # ----------------------------------------------------
    # 2-variable scatter plot
    # bubble plot for 1-variable (y.call=0) and 2-variable
    # line chart

    if ((!is.null(y.call) || date.var) &&
        object %in% c("point", "bubble", "sunflower")) {

      # Cleveland dot plot
      if (object == "point"  &&  data.do) {
        if (!cat.x && cat.y && y.unique) {
          if (seg.y.miss) if (y.unique && cat.y) segments_y <- TRUE
          if (is.null(origin_x)) origin_x <- 0
        }
        if (cat.x && !cat.y && x.unique) {
          if (seg.x.miss) if (x.unique && cat.x) segments_x <- TRUE
          if (is.null(origin_y)) origin_y <- 0
        }
      }

      # sort y by x option for 1 var Cleveland dot plot
      srt.dwn <- sort == "-"  # TRUE = descending
      if (sort != "0") {
        if (n.xvar == 1) {  # one x-variable
          if (cat.x && !cat.y && x.unique) {
            x.vals <- as.character(x.call[,1])  # factor to char vec
            y.vals <- y.call[,1]  # Extract numeric vector from df
            ord <- order(y.vals, decreasing=srt.dwn)
            x.sort <- x.vals[ord]
            x.call[,1] <- factor(x.sort, levels=x.sort)
            y.call[,1] <- y.vals[ord]
          }
          if (!cat.x && cat.y && y.unique) {
            y.vals <- as.character(y.call[,1])  # factor to char vec
            x.vals <- x.call[,1]  # Extract numeric vector from df
            ord <- order(x.vals, decreasing=srt.dwn)
            y.sort <- y.vals[ord]
            y.call[,1] <- factor(y.sort, levels=y.sort)
            x.call[,1] <- x.vals[ord]
          }
        }
      }  # end 1 x var sort

      # for Cleveland paired-dot plot, two x-vars
      # sort by diffs AND print differences, y must be cat
      segments_diff <- n.xvar == 2 && ncol(x.call) == 2 && cat.y && y.unique

      txdif <- NULL
      if (segments_diff) {

        # compute diffs and a single ordering
        difs <- x.call[, 2] - x.call[, 1]
        ord  <- order(difs, decreasing = srt.dwn)

        x.call <- x.call[ord, , drop = FALSE]
        y.call <- y.call[ord, , drop = FALSE]
        difs   <- difs[ord]

        # printed output table now in the same order as the plot
        tx <- character(0)

        dd <- .max.dd(c(x.call[, 1], x.call[, 2])) + 1L
        if (dd > getOption("digits")) dd <- getOption("digits")

        ny   <- nrow(y.call)
        mx.i <- nchar(as.character(ny))
        mx.d <- max(nchar(.fmt(difs, dd)))
        y.labels <- as.character(y.call[, 1])
        mx.f <- max(5L, nchar(y.labels), na.rm = TRUE)

        tx[length(tx) + 1L] <- paste(.fmtc("n", mx.i), " ",
                                     .fmtc(" diff", mx.d), "  Row", sep = "")
        tx[length(tx) + 1L] <- .dash2(mx.i + mx.d + mx.f + 2L, "-")

        if (ny <= 20L)
          rng <- 1:ny
        else
          rng <- c(1:10, (ny - 9L):ny)

        # for the printed list to match the visual "top of plot first",
        # print from last row to first row
        for (i in 1:ny) {
          k <- ny - (i - 1L)
          if (i %in% rng) {
            txt <- paste(.fmti(i, mx.i), .fmt(difs[k], dd, mx.d), y.labels[k])
            tx[length(tx) + 1L] <- txt
          }
        }

        txdif <- tx  # displayed later in .plt.txt
      }  # end two var Cleveland dot plot

      # bigger point for scatterplot of stats (instead of data)
      if (!data.do  &&  object == "point")
        if (is.null(pt_size)) pt.size <- 1.25

      # outlier analysis, need before .plt.main
      outlpts <- NULL
      out_outliers <- ""
      if (!y.miss && !Trellis)
        if (n.xvar==1 && n.yvar==1
             && is.numeric(x.call[,1]) && is.numeric(y.call[,1]))
        if (MD_cut > 0  ||  out_cut > 0) {
          otl <- .plt.MD(x.call[,1], y.call[,1], ID.call, MD_cut, out_cut)
          out_outliers <- otl$tx  # descriptive text
          outlpts <- otl$outlpts  # the outliers
      }

      if (!is.null(y.call)) {
        if (nrow(x.call) != nrow(y.call))  {
          cat("\n"); stop(call.=FALSE, "\n-----\n",
            "number of elements in x: ", nrow(x.call), "\n",
            "number of elements in y: ", nrow(y.call), "\n\n",
            "The number of elements must be equal, probably\n",
            "  have variables from user workspace so maybe\n",
            "  use the  remove function, e.g., remove(x)\n\n")
        }
      }

      # by default display center_line only if runs about a mean
      if (run  &&  center_line == "default") {
        y.clean <- y.call[complete.cases(y.call), 1]  # converts df to vector
        m <- mean(y.clean)
        n.change <- 0
        for (i in 1:(length(y.clean)-1))
          if ((y.clean[i+1] > m) != (y.clean[i] > m)) n.change <- n.change+1
        if (n.change/(length(y.clean)-1) < .15)
          center_line <- "off"
        else
          center_line <- "median"
      }


# if x is a Date variable -------------------------------------------------

      #   if not specified, get the existing ts_unit
      #   if specified, may need to aggregate the values of y.call over x.call
      if (date.var) {
        if (!quiet) {
          txt <- "Ryan, Ulrich, Bennett, and Joy's xts package]"
          cat("[with functions from", txt, "\n")
          if (!(ts_source=="fable" && ts_ahead > 0)) cat("\n")
        }

        tsdata <- .plt.time(x.call, y.call, by.call, x.name, n.by,
                            ts_unit, ts_agg)
        ts_unit <- tsdata$ts_unit
        x.call <- tsdata$x.call
        y.call <- tsdata$y.call
        by.call <- tsdata$by.call
        do.agg <- tsdata$do.agg
      }
      else
        do.agg <- FALSE

      # forecast
      # --------
      if (ts_ahead > 0) {
        if (ts_unit=="unknown") {
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "ts_unit: ", ts_unit, "\n",
            "Cannot forecast without a consistent time unit.\n\n")
        }
        if (any(is.na(y.call))) {
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "Missing values not allowed for a variable for which\n",
            "  to forecast future values.\n\n")
        }

      # process any exogenous variables
      exog.df <- NULL  # default: no exogenous variables
      if (!is.null(ts_new_x)) {  # df of future values of exogenous variables
        exog.names <- names(ts_new_x)
        missing.vars <- setdiff(exog.names, names(data)) # all exog vars exist
        if (length(missing.vars) > 0) {
          stop("\n------\n",
               "The following exogenous variables are not in existing data:\n",
               paste(missing.vars, collapse = ", "), "\n\n",
               "Please ensure all specified columns are in the input data.\n",
               call. = FALSE)
        }
        # keep only exogenous predictors except index and y variable
        drop.names <- c(x.name, y.name)
        exog.df <- data[setdiff(exog.names, drop.names)]
      }

      f.out <- .plt.forecast(x.call, y.call, by.call,
          exog.df, ts_new_x,
          ts_unit, ts_ahead, ts_method, ts_fitted, ts_source, ts_n_x_tics,
          ts_trend, ts_seasons, ts_error,
          ts_alpha, ts_beta, ts_gamma, ts_PI, digits_d, quiet)

        y.fit <- f.out$y.fit;  y.hat <- f.out$y.hat
        x.fit <- f.out$x.fit;  x.hat <- f.out$x.hat
        y.upr <- f.out$y.upr;  y.lwr <- f.out$y.lwr
        mx.x <- f.out$mx.x;  mn.y <- f.out$mn.y;  mx.y <- f.out$mx.y
        out_y.frcst <- f.out$y.frcst
        out_decomp <- f.out$out_decomp
        out_fitted <- f.out$out_fitted
        out_report <- f.out$out_report
      }  # end forecast

      else {  # no forecast
        y.fit <- NULL;  y.hat <- NULL
        x.fit <- NULL;  x.hat <- NULL
        y.upr <- NULL;  y.lwr <- NULL
        mx.x <- NULL;  mn.y <- NULL;  mx.y <- NULL
        out_y.frcst <- NULL; out_decomp <- NULL
        out_fitted <- NULL; out_report <- NULL
      }

      # see if set origin of x-axes to 0
      if (is.null(origin_x)) {
        x.all <- unlist(x.call)
        numr <- all(is.numeric(x.all))
        if (numr) {
          if (all(x.all < 0)) x.all <- -x.all  # account for - values
          min.x <- min(x.all, na.rm=TRUE)
          max.x <- max(x.all, na.rm=TRUE)

          if (!date.var) {
            if (min.x > 0) {  # all + or all - which were converted to +
              rng <- max.x - min.x
              prp <- rng / min.x
              if (prp > 2.40) origin_x <- 0  # 2.40 cutoff is a heuristic
            }
          }
        }  # end numr
        remove(x.all)
      }  # end is null origin_x

      else if (!date.var) {  # validate the user-supplied origin_x
        x.all <- unlist(x.call)
        if (all(is.numeric(x.all))) {
          min.x <- min(x.all, na.rm=TRUE)
          if (origin_x > min.x) {
            cat("\n"); stop(call.=FALSE, "\n------\n",
              "Minimum value of x: ", min.x, "\n",
              "Value you set for origin_x: ", origin_x, "\n",
              "origin_x cannot be larger than the minimum x data value.\n\n")
          }
        }
        remove(x.all)
      }

      mse.ln <- NULL;  mse.nl <- NULL;  by.cat <- NULL;  y.new <- NULL

      # m out, mostly the visualization, sometimes some stats

      if (do_plot)  {
        m.out <- .plt.main(
          x=x.call, y=y.call, by=by.call,
          cat.x=cat.x, cat.y=cat.y,
          object=object, stat=stat,

          fill=pt.fill,
          ts_area_fill=ts_area_fill,
          color=pt.color,
          pt.trans=pt.trans,
          col.segment=segment_color,

          xy_tics=xy_ticks,
          xlab=xlab, ylab=ylab, main=main, main_size=main_size, sub=sub,
          rotate_x=rotate_x, rotate_y=rotate_y,

          offset=offset, prop=proportion,
          origin_x=origin_x, origin_y=origin_y,

          size=pt.size, ln.width=line_width, shape=pt_shape, means=means,

          segments=segments, segments_y=segments_y, segments_x=segments_x,
          segments_diff=segments_diff,

          form=form,
          smooth_points=smooth_points, smooth_size=smooth_size,
          smooth_power=smooth_power, smooth_bins=smooth_bins,
          hex_bins=hex_bins, hexbin_legend=hexbin_legend,

          contour_n=contour_n,
          contour_nbins=contour_nbins, contour_points=contour_points,
          contour_legend=contour_legend,

          radius=radius, power=power, size_cut=pt_size_cut,
          bbl.txt.col=bbl.txt.col,

          col.low=low_fill, col.hi =hi_fill,

          ID=ID.call, ID_color=ID_color, ID_size=ID_size, out_ind=outlpts,

          out_fill=out_fill, out_color=out_color,
          out_shape=out_shape, out_shape.miss=out.shape.miss,

          fit.line=fit.ln, fit_power=fit_power, fit_color=fit_color,
          fit_lwd=fit_lwd, fit_new=fit_new,

          fit_se=fit_se, se_fill=se_fill,
          plot_errors=plot_errors,

          ellipse=ellipse,
          ellipse_color=ellipse_color,
          ellipse_fill=ellipse_fill,
          ellipse_lwd=ellipse_lwd,

          run=run, center_line=center_line, stack=ts_stack,

          ts_unit=ts_unit, ts_agg=ts_agg, do.agg=do.agg,
          ts_ahead=ts_ahead, ts_fit=ts_fitted,
          n_date_tics=ts_n_x_tics,

          y.fit=y.fit, y.hat=y.hat,
          x.fit=x.fit, x.hat=x.hat,
          y.upr=y.upr, y.lwr=y.lwr,

          mxf.x=mx.x, mnf.y=mn.y, mxf.y=mx.y,

          freq.poly=freq.poly,
          jitter_x=jitter_x, jitter_y=jitter_y,

          xlab.adj=xlab.adj, ylab.adj=ylab.adj,
          bm.adj=bm.adj, lm.adj=lm.adj, tm.adj=tm.adj, rm.adj=rm.adj,

          scale_x=scale_x, scale_y=scale_y,
          pad_x=pad_x, pad_y=pad_y,

          axis_fmt=axis_fmt,
          axis_x_pre=axis_x_prefix, axis_y_pre=axis_y_prefix,

          legend_title=legend_title,
          use_plotly=use_plotly,

          add=add,
          x1=x1, x2=x2, y1=y1, y2=y2,
          add_size=add_size, add_lwd=add_lwd, add_lty=add_lty,
          add_color=add_color, add_fill=add_fill, add_trans=add_trans,

          quiet=quiet, digits_d=digits_d, style_opts=style.opts, ...
        )

        if (fit.ln != "off") {
          b0 <- m.out$b0;  b1 <- m.out$b1
          mse.ln <- m.out$mse.ln;  Rsq <- m.out$Rsq;  mse.nl <- m.out$mse.nl
          by.cat <- m.out$by.cat
          y.new <- m.out$y.new
        }

      # build text output even when quiet so the stats are returned;
      # printing of the result is gated by quiet at the end of the function
      {
        txjit <- NULL
        if (!is.null(jitter_x) && !is.null(jitter_y)) {
          if (jitter_x != 0  ||  jitter_y != 0) {  # show jitter
            tx <- character(length = 0)
            tx[length(tx)+1] <- "Some Parameter values (can be manually set)"
            tx[length(tx)+1] <- .dash2(55)
            tx[length(tx)+1] <- paste("size:", .fmt(pt.size,2),
                " size of plotted points")
            if (!is.null(jitter_y)) if (jitter_y != 0)
              tx[length(tx)+1] <- paste("jitter_y:", .fmt(jitter_y,2),
                " random vertical movement of points")
            if (!is.null(jitter_x)) if (jitter_x != 0)
              tx[length(tx)+1] <- paste("jitter_x:", .fmt(jitter_x,2),
                " random horizontal movement of points")
            txjit <- tx
          }
        }

        #  radius, power values in the analysis
        txbub <- NULL
        if (object == "bubble") {   # move to .plt.txt
          tx <- character(length = 0)
          tx[length(tx)+1] <- "Some Parameter values (can be manually set)"
          tx[length(tx)+1] <- .dash2(55)
          tx[length(tx)+1] <- paste("radius:", .fmt(radius,2),
              "   size of largest bubble")
          tx[length(tx)+1] <- paste("power:", .fmt(power,2),
              "    relative bubble sizes")
          txbub <- tx
        }

        if (n_bins == 1) {  # if binning, .plt.bins does its own output

          # NULL when no fit computed; inherits=FALSE so that a user
          # object of the same name in the global env is not picked up
          if (!exists("Rsq", inherits=FALSE)) Rsq <- NULL
          if (!exists("b0", inherits=FALSE))  b0  <- NULL
          if (!exists("b1", inherits=FALSE))  b1  <- NULL
          # .plt.txt prints some run-chart output directly, so capture
          # and discard its console output when quiet
          if (quiet)
            invisible(capture.output(
              o <- .plt.txt(x.call, y.call, stat, object, cat.x, cat.y,
                date.var, xlab, ylab, fit.ln, n.by, mse.ln, mse.nl,
                b0, b1, Rsq, fit_new, y.new, by.cat,
                center_line, run, show_runs,
                proportion, pt_size, radius, digits_d, fun_call)))
          else
            o <- .plt.txt(x.call, y.call, stat, object, cat.x, cat.y,
              date.var, xlab, ylab, fit.ln, n.by, mse.ln, mse.nl,
              b0, b1, Rsq, fit_new, y.new, by.cat,
              center_line, run, show_runs,
              proportion, pt_size, radius, digits_d, fun_call)

          # cumulate existing output pieces from o into final output
          output <- NULL

          if (getOption("suggest"))
            if (ts_ahead==0) output <- list(out_suggest=o$out_suggest)

          if (!is.null(txdif))
            output$out_dif <- txdif

          if (!is.null(outlpts)) {
            class(outlpts) <- "out"  # MD outliers
            output$outlpts <- outlpts
          }
          if (length(out_outliers) > 1)  # source is here
            output$out_outliers <- out_outliers
          if (length(o$out_outliers) > 1)  # source is .plt.txt
            output$out_outliers <- o$out_outliers

          if (!is.null(o$out_stats) && any(nzchar(o$out_stats))) {
            output$out_stats <- o$out_stats
          }

          if (!is.null(txstats))  # from stat option earlier in this file
            output$out_txt <- txstats

          if (!is.null(o$out_y.new)) {  # a data frame, not the usual tx
            if (all(nzchar(o$out_y.new))) {
              output$out_y.new <- o$out_y.new  # leave a df for print.out_all()
            }
          }

          if (length(o$out_reg) == 1) {
            if (nzchar(o$out_reg))
              output$out_reg <- o$out_reg
          }
          else if (length(o$out_reg) > 1)  # by activated
            output$out_reg <- o$out_reg

          if (!is.null(o$out_XV)) if (length(o$out_XV) > 1)
            output$out_XV <- o$out_XV


          if (!is.null(txjit)) {
            class(txjit) <- "out"  # jitter parameter
            output$out_jitter <- txjit
          }

          if (!is.null(txbub)) {
            class(txbub) <- "out"  # bubble plot parameters
            output$out_bubble <- txbub
          }

          if (!is.null(out_report)) {
            class(out_report) <- "out"
            output$out_report <- out_report
          }

          if (!is.null(output)) class(output) <- "out_all"
        }  # end n_bins==1
      }  #  end text output

    }  #  end do_plot

    else {  # no plot
      output <- NULL
    }

  }  # end all other analyses
  # -------------------------


  # display text output from XY() unless turned off
  # T.type is the type of Trellis plot, otherwise is NULL

    if (n_bins == 1  &&  Trellis) {  # only VBS output is processed here
      if (!(T.type %in% c("cont", "cont_cat"))) outp <- FALSE
    }
    if (n.xvar > 1  &&  y.miss) outp <- FALSE  # scatterplot matrix

    if (ts_ahead > 0  &&  !is.null(out_decomp)) class(out_decomp) <- "out"

    if (outp  &&  !quiet) {
      if (!is.null(output)) print(output)  # output what exists till now

      if (ts_ahead > 0) {  # did a forecast
        if (!is.null(out_decomp)) print(out_decomp)
        if (!is.null(out_fitted)) {
          fitted.title <- "\nFitted\n------\n"
          class(fitted.title) <- "out"
          print(fitted.title)
          print(out_fitted)
          cat("\n")
        }
        if (!is.null(out_y.frcst)) {
          frcst.title <- "Forecast\n--------\n"
          class(frcst.title) <- "out"
          print(frcst.title)
          print(out_y.frcst)
          cat("\n")
        }
      }  # end ts_ahead > 0
    }  # end outp

    # make forecast results retrievable from the returned object
    if (ts_ahead > 0) {
      if (!is.null(out_decomp))  output$out_decomp   <- out_decomp
      if (!is.null(out_fitted))  output$out_fitted   <- out_fitted
      if (!is.null(out_y.frcst)) output$out_forecast <- out_y.frcst
      if (!is.null(output) && !inherits(output, "out_all"))
        class(output) <- "out_all"
    }

  }  # end all the other analyses

  # terminate pdf graphics system if used
  # for Trellis, .plt.lattice closes the pdf device that it plots to
  if (!is.null(pdf_file)) {
    if (!Trellis) dev.off()
    if ((!Trellis || pdf.trellis)  &&  !quiet  &&  df.name != "NULL")
      .showfile(pdf_file, "Plot")
  }

  # reset for next analysis
  options(xname=NULL)
  options(yname=NULL)
  options(facet1name=NULL)
  options(facet2name=NULL)
  options(byname=NULL)

  if (!is.null(output)) return(invisible(output))  # to stored object
}

.TwoGraph <-
function(YA, YB, bw1, bw2, Ynm, Xnm, X1nm, X2nm, y.lbl, digits_d, brief,
         n1, m1, s1, n2, m2, s2, df, mdiff, sw, smd, mmd, msmd,
         clpct, tvalue, pvalue, ub, lb, x.lab, alt, show_title,
         full_curve=TRUE, quiet=FALSE, fill=NULL, fill_area=TRUE) {

  dYA <- suppressWarnings(density(YA, bw1))
  dYB <- suppressWarnings(density(YB, bw2))

  if (!brief  && !quiet) {
    cat("\n\n------ Graphics Smoothing Parameter ------\n\n")
    mytitle <- "Density bandwidth for "
    cat(mytitle, Xnm, " ", X1nm, ": ", .fmt(dYA$bw,digits_d), sep="", "\n")
    cat(mytitle, Xnm, " ", X2nm, ": ", .fmt(dYB$bw,digits_d), sep="", "\n")
  }

  # colors
  if (!grepl("gray", getOption("theme"))) {
    col.1 <- rgb(.63,.46,.15)
    col.m1 <- rgb(.71,.65,.65)
    col.1t <- rgb(.63,.46,.15, alpha=.7)
    col.1d <- rgb(.63,.46,.15, alpha=.2)
    col.2 <- rgb(.49,.56,.69)
    col.m2 <- rgb(.69,.69,.75)
    col.2t <- rgb(.49,.56,.69, alpha=.7)
    col.2d <- rgb(.49,.56,.69, alpha=.2)
  }
  else {
    col.1 <- rgb(.40,.40,.40)
    col.m1 <- rgb(.40,.40,.40)
    col.1t <- rgb(.40,.40,.40, alpha=.7)
    col.1d <- rgb(.40,.40,.40, alpha=.2)
    col.2 <- rgb(.40,.40,.40)
    col.m2 <- rgb(.40,.40,.40)
    col.2t <- rgb(.40,.40,.40, alpha=.7)
    col.2d <- rgb(.40,.40,.40, alpha=.2)
  }

  if (!is.null(fill)) {
    c1 <- as.vector(col2rgb(fill[1]) / 255)
    col.1  <- rgb(c1[1], c1[2], c1[3])
    col.1t <- rgb(c1[1], c1[2], c1[3], alpha = .7)
    col.1d <- rgb(c1[1], c1[2], c1[3], alpha = .2)
    if (length(fill) >= 2) {
      c2 <- as.vector(col2rgb(fill[2]) / 255)
      col.2  <- rgb(c2[1], c2[2], c2[3])
      col.2t <- rgb(c2[1], c2[2], c2[3], alpha = .7)
      col.2d <- rgb(c2[1], c2[2], c2[3], alpha = .2)
    }
  }

  # values needed for graph
  if (full_curve) {
    min.x <- min(min(dYA$x), min(dYB$x))
    max.x <- max(max(dYA$x), max(dYB$x))
  } else {
    min.x <- min(min(YA, na.rm = TRUE), min(YB, na.rm = TRUE))
    max.x <- max(max(YA, na.rm = TRUE), max(YB, na.rm = TRUE))
  }
  max.y <- max(max(dYA$y),max(dYB$y))  # max y coordinate
  max.y <- max.y+.1*max.y  # allow room in graph region for d info

  col.tx <- getOption("lab_color")
  col.ln <- getOption("bar_color")


  # ------------------------------
  # plot: set up coordinate system
  orig.params <- par(no.readonly=TRUE)
  on.exit(par(orig.params))
  par(bg=getOption("window_fill"))
  par(mar=c(4.1,1.5,8,.4), mgp=c(3,.6,0), cex=.8, cex.axis=1.1, cex.lab=1.35)

  plot.new()
  plot.window(xlim=c(min.x,max.x), ylim=c(0,max.y))

  ax <- .axes_dim()  # get axis value parameters
  # hack because otherwise axis_size at 0.75 default is too small
  cx <- getOption("axis_size")
  options(axis_size=1)

  adj <- .RSadj(axis_size=ax$axis_x_size); axis_x_size <- adj$axis_size * 1.2
  axT1 <- pretty(c(min.x, max.x))
  .axes(NULL, NULL, axT1, NULL)
  box(col=getOption("panel_color"))
  if (nchar(y.lbl) > 50) y.lbl <- paste(substr(y.lbl,1,50), "...")
  title(xlab=y.lbl, col.lab=col.tx, cex.lab=axis_x_size*1.1)

  # restore axis_size for other routines
  options(axis_size=cx)
  options(axis_x_size=cx)

  xleft <- par("usr")[1]  # left side of graph
  xright <- par("usr")[2]  # right side of graph
  ybot <- par("usr")[3]  # bottom of graph
  ytop <- par("usr")[4]  # height of graph

  # vertical line for each mean
  lines(c(m1,m1), c(0,ytop), lty="solid", lwd=.85, col=col.m1)
  lines(c(m2,m2), c(0,ytop), lty="solid", lwd=.85, col=col.m2)

  # curve areas
  polygon(c(min(dYA$x),dYA$x,max(dYA$x)), c(0,dYA$y,0), col=col.1d, border=NA)
  polygon(c(min(dYB$x),dYB$x,max(dYB$x)), c(0,dYB$y,0), col=col.2d, border=NA)

  # bottom border of density curve  
  segments(min(dYA$x), 0, max(dYA$x), 0, col=col.1)
  segments(min(dYB$x), 0, max(dYB$x), 0, col=col.2)

  # density curves
  lwd.border <- 1.75
  if (.Platform$OS == "windows") lwd.border <- 2
  lines(dYA, col=col.1t, lty="solid", lwd=lwd.border)
  lines(dYB, col=col.2t, lty="solid", lwd=lwd.border)

  # minimum mean difference of practical importance
  col.e <- getOption("lab_color")  # color for effect
  if (!is.null(mmd) || !is.null(msmd)) {
    if (!is.null(mmd)) msmd <- mmd / sw
    else if (!is.null(msmd)) mmd <- msmd * sw
    mid <- (m1 + m2) / 2
    lr <- mid + .5*mmd  # line right
    ll <- mid - .5*mmd  # line left
    lines(c(lr,lr), c(ybot+.44*max.y,ytop-.44*max.y), lty="solid", lwd=1, col=col.e)
    lines(c(ll,ll), c(ybot+.44*max.y,ytop-.44*max.y), lty="solid", lwd=1, col=col.e)
    text(mid, ybot+.41*max.y, label=toString(round(mmd,2)), col=col.e)
    text(mid, ytop-.375*max.y, label=toString(round(msmd,2)), col=col.e)
    text(mid, ybot+.38*max.y, label="mmd", col=col.e)
    text(mid, ytop-.41*max.y, label="msmd", col=col.e)
  }

  # legends with descriptive stats (m1 > m2)
  textR <- paste(Xnm,X1nm)
  nR <- n1
  mR <- .fmt(m1,digits_d)
  sR <- .fmt(s1,digits_d)
  col.R <- col.1
  aR <- 45

  textL <- paste(Xnm,X2nm)
  nL <- n2
  mL <- .fmt(m2,digits_d)
  sL <- .fmt(s2,digits_d)
  col.L <- col.2
  aL <- -45

  # legends
  col.lgnd <- getOption("lab_color")
  cex.lgnd <- 1.1

  ladj <- xleft + .02*(max.x-min.x)
  # legend("topleft", legend = textL, fill=col.L, density=20, angle=aL, bty="n",
      # text.col=col.lgnd, cex=cex.lgnd)
  text(ladj, ytop-.05*max.y, label=c(paste(Xnm,X2nm)),
      adj=0, col=col.lgnd, cex=cex.lgnd)
  text(ladj, ytop-.115*max.y, label=bquote(paste("n = ", .(nL))),
      adj=0, col=col.lgnd, cex=cex.lgnd)
  text(ladj, ytop-.170*max.y, label=bquote(paste("m = ", .(.fmtc(mL,digits_d)))),
      adj=0, col=col.lgnd, cex=cex.lgnd)
  text(ladj, ytop-.225*max.y, label=bquote(paste("s = ", .(.fmtc(sL,digits_d)))),
      adj=0, col=col.lgnd, cex=cex.lgnd)

  radj <- xright - .02*(xright-xleft)
  # legend("topright", legend = textR, fill=col.R, density=20, angle=aR, bty="n",
      # text.col=col.lgnd, cex=cex.lgnd)
  text(radj, ytop-.05*max.y, label=c(paste(Xnm,X1nm)),
      adj=1, col=col.lgnd, cex=cex.lgnd)
  text(radj, ytop-.115*max.y, label=bquote(paste("n = ", .(nR))),
      adj=1, col=col.lgnd, cex=cex.lgnd)
  text(radj, ytop-.170*max.y, label=bquote(paste("m = ", .(.fmtc(mR,digits_d)))),
      adj=1, col=col.lgnd, cex=cex.lgnd)
  text(radj, ytop-.225*max.y, label=bquote(paste("s = ", .(.fmtc(sR,digits_d)))),
      adj=1, col=col.lgnd, cex=cex.lgnd)

  # scale for s-pooled, d, mdiff at top of graph
  mlow <- min(m1, m2)
  mhi  <- max(m1, m2)
  col.d.unit <- "gray50"
  # connect first seg to top
  segments(mlow, max.y-.01*max.y, mlow, ytop, lwd=1, col=col.d.unit) 
  # provide at least 2 labeled d units on sd scale at top
  max.i <- max(ceiling(abs(smd)), 2)
  last.coord.x <- mlow  # initialise; overwritten each loop iteration
  for (i in 0:max.i) {  # sd scale at top
    x.i <- mlow+i*sw
    # sd units
    segments(x.i, max.y+.025*max.y, x.i, ytop, col=col.d.unit, lwd=1)
    # d units counted
    text(x.i, max.y+.01*max.y, labels=i, col=col.tx)
    # horiz bar connects endpoints
    segments(mlow, ytop, x.i, ytop, col=col.d.unit, lwd=3)
    last.coord.x <- x.i
  }
  # connect last seg to top
  segments(last.coord.x, max.y+.025*max.y, last.coord.x, ytop, lwd=1, col=col.d.unit)
  # print d value towards top
  text((m1+m2)/2, ytop-.07*max.y, label=.fmt(smd), col=col.d.unit, cex=.9)
  # horiz bar connects means
  segments(mlow, ytop-.09*max.y, mhi, ytop-.09*max.y, col=col.d.unit, lwd=1)
  # print d towards top
  text((m1+m2)/2, ytop-.11*max.y, label="smd", col=col.d.unit, cex=.9)

  # print mdiff value towards bottom  
  text((m1+m2)/2, ybot+.11*max.y, label=.fmt(mdiff, digits_d), col=col.d.unit, cex=.9)
  # horiz bar connects means
  segments(mlow, ybot+.09*max.y, mhi, ybot+.09*max.y, col=col.d.unit, lwd=1)
  # print diff towards bottom
  text((m1+m2)/2, ybot+.07*max.y, label="diff", col=col.d.unit, cex=.9)

  # title area, above graph
  if (show_title) {
    mtext(paste("Two-Group Plot with Means"), side=3, line=6.6, font=2,
          col=col.tx)
    mtext(paste("Compare",Ynm,"for",Xnm,X1nm,"and",X2nm), side=3, line=5.5,
          font=3, cex=.9, col=col.tx)
    txt <- ifelse (alt == "two.sided", "", " One-tailed")
    classic <- paste(txt, "Classic t-test of 0 Mean Diff:")
    mtext(bquote(paste(" ", .(classic), "   t = ", .(.fmt(tvalue,3)), 
      ",  df = ", .(df), ",   p-value = ", .(.fmt(pvalue,3)))), side=3, 
      line=3.8, cex=.9, adj=0, col=col.tx)
    mtext(bquote(paste("  ",.(clpct), " Confidence Interval for Mean Difference:  ",
      .(.fmt(lb,3)), " to ", .(.fmt(ub,3)))), side=3, line=2.75, cex=.9,
      col=col.tx, adj=0)
    mtext(bquote(paste("s-within")), side=3, line=.7,
          at=(mlow+(last.coord.x))/2, col=col.d.unit, cex=.9)
    mtext(bquote(paste(.(round(sw,2)))), side=3, line=-0.1,
          at=(mlow+(last.coord.x))/2, col=col.d.unit, cex=.9)
  }

  if (.allow.interactive()) {
    by.plt <- factor(
      c(rep(X1nm, length(YA)), rep(X2nm, length(YB))),
      levels = c(X1nm, X2nm)
    )
    plt <- suppressWarnings(dn.plotly(
      x          = c(YA, YB),
      by         = by.plt,
      x_name     = Ynm,
      by_name    = Xnm,
      fill       = c(col.1, col.2),
      x_lab      = y.lbl,
      y_lab      = "Density",
      ax         = NULL,
      bw         = bw1,
      full_curve = full_curve,
      fill_area  = fill_area,
      style_opts = .plotly_style()
    ))
    print(plt)
  }

}

simCLT <- 
function(ns, n, p1=0, p2=1, seed=NULL,
         dist=c("normal", "uniform", "lognormal", "antinormal"),
         fill="lightsteelblue3", n_display=0, digits_d=3, 
         subtitle=TRUE, pop=TRUE, 
         main=NULL, pdf=FALSE, width=5, height=5, ...) {


  dots <- list(...)
  if (!is.null(dots$type)) {
    message("\nThe argument 'type' is deprecated in simCLT().\n",
            "Please use 'dist' instead, e.g. simCLT(..., dist = 'normal').\n")
    dist <- dots$type
    dots$type <- NULL
  }

  dist <- match.arg(dist)

  if (missing(ns)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the number of samples, each of a given size, with:  ns\n\n")
  }

  if (missing(n)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the size of each sample, the number of data values, with:  n\n\n")
  }

  manage.gr <- .graphman()
  if (!pdf) {
    if (manage.gr) {
      .graphwin(2)
      dev.set(which=3)
    }
  }
  else { 
    pdf_file <- "SimPopulation.pdf"
    pdf(file=pdf_file, width=width, height=height)
  }

  digits_d <- 3
  max.ln <- 8
   
  # data generation and plot population
  if (!is.null(seed)) set.seed(seed)

  if (dist == "normal") {
    mu <- p1
    sigma <- p2
    data.raw <- rnorm(ns*n, mu, sigma)

    if (pop) {
      prob_znorm(mu=mu, sigma=sigma, xlab="Normal Population", 
                 r=0.535, g=0.610, b=0.704)
    }
  }  # end dist is normal


  if (dist == "uniform") {
    min <- p1
    max <- p2
    mu <- (min + max) / 2
    sigma <- (max - min) / sqrt(12)
    data.raw <- runif(ns*n, 0, 4)

    if (pop) { 
      x.min <- min - 2
      x.max <- max + 2
      x <- seq(x.min, x.max, length=500)
      y <- dunif(x, min, max)
      plot.new()
      plot.window(xlim=range(x), ylim=c(0, max(y)+.1))
      if (max-min < 10) axis(1, at=seq(x.min, x.max, by=1)) else axis(1)
      usr <- par("usr")
      rect(usr[1], usr[3], usr[2], usr[4], col="ghostwhite", border="black")
      polygon(c(min, x, max), c(0, y, 0), col=fill, border="black")
      if (subtitle) 
        txt <- paste("min=", toString(0), " max=", toString(x.max), sep="") 
      else txt=""  
      title(xlab="Uniform Population", sub=txt)  
    }
  }  # end dist is uniform


  if (dist == "lognormal") {
    meanlog <- p1
    sdlog <- p2
    varlog <- sdlog^2
    mu <- exp(meanlog + varlog/2)
    sigma <- mu * sqrt(exp(varlog) - 1)
    pop.skew <- (exp(varlog) + 2) * sqrt(exp(varlog) - 1)
    pop.med <- exp(meanlog)
    data.raw <- rlnorm(ns*n, meanlog, sdlog)

    if (pop) {
      x.max <- ceiling(mu + 4*sigma)
      x <- seq(0, x.max, length=500)
      y <- dlnorm(x, meanlog=meanlog, sdlog=sdlog)
      plot.new()
      plot.window(xlim = range(x), ylim = range(y))
      axis(1)
      usr <- par("usr")
      rect(usr[1], usr[3], usr[2], usr[4], col="ghostwhite", border="black")
      polygon(c(0, x, x.max), c(0, y, 0), col="lightsteelblue3", border="black")
      if (subtitle) 
        txt <- paste("meanlog=", toString(meanlog), " sdlog=",
                     toString(sdlog), sep="") 
      else txt=""  
      title(xlab="Lognormal Population", sub=txt)
    }
  }  # end dist is lognormal


  if (dist == "antinormal") {

    if (!requireNamespace("triangle", quietly=TRUE)) {
      stop("Package \"triangle\" needed for these simulations\n",
           "Please install it:  install.packages(\"triangle\")\n\n",
           call. = FALSE)
    }

    if (p1 != 0) { 
      cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Minimum value of anti-normal distribution must be 0.\n\n")
    }
    x.max <- p2

    mu <- x.max / 2
    sigma <- NULL 
    data.raw <- numeric(length=0)
    for (i in 1:(ns*n))
      if (runif(1) < 0.5) 
        data.raw[i] <- triangle::rtriangle(1, a=0, b=x.max/2, c=0+.01)
      else 
        data.raw[i] <- triangle::rtriangle(1, a=x.max/2, b=x.max, c=x.max-.01)

    if (pop) {
      x1 <- seq(0, x.max/2, length=250)
      y1 <- triangle::dtriangle(x1, a=0, b=x.max/2, c=0+.01) # triangle function
      plot.new()
      plot.window(xlim = c(0 - .5, x.max + .5), ylim = c(0, max(y1) + .1))
      axis(1)
      usr <- par("usr")
      rect(usr[1], usr[3], usr[2], usr[4], col="ghostwhite", border="black")
      lines(x1,y1)
      polygon(c(0, x1, x.max/2), c(0, y1, 0), col="lightsteelblue3",
              border="black")
      x2 <- seq(x.max/2, x.max, length=250)
      y2 <- triangle::dtriangle(x2, a=x.max/2, b=x.max, c=x.max-.01)
      lines(x2,y2)
      polygon(c(x.max/2, x2, x.max), c(0, y2, 0), col="lightsteelblue3",
              border="black")
      if (subtitle) 
        txt <- paste("min=", toString(0), " max=", toString(x.max), sep="") 
      else txt=""  
      title(xlab="Anti-Normal Population", sub=txt)
    }
  }  # end dist is "antinormal" 

  if (pdf) {
    dev.off()
    .showfile(pdf_file, "population distribution")
  }

  if (!pdf) {
    if (manage.gr) {
      dev.set(which=4) 
    }
  }
        

  cat("\n")
  cat("Population mean, mu :", mu, "\n")
  if (!is.null(sigma)) cat("Pop std dev, sigma  :", sigma, "\n")
  if (dist == "lognormal") {
    cat("Population skew:     ", pop.skew, "\n")
    cat("Population median:   ", pop.med, "\n")
  }
  cat("\n")
  cat("Number of samples   :", sprintf("%i", ns), "\n")
  cat("Size of each sample :", n, "\n")


  # data analysis
  cat("\n")
  mx <- mean(data.raw)
  sx <- sd(data.raw)
  cat("Mean of the data:", mx, "\n")
  cat("Std Dev of the data:", sx, "\n")
  data.byrep <- matrix(data.raw, nrow=ns, ncol=n)

  Ymean <- apply(data.byrep, 1, mean)
  Ysd <- apply(data.byrep, 1, sd)

  if (!is.null(getOption("theme"))) colors <- getOption("theme")
  else colors="blue"

  if (!pdf) 
    dev.set(which=4) 
  else { 
    pdf_file <- "SimSample.pdf"
    pdf(file=pdf_file, width=width, height=height)
  }

  .dn.main(Ymean, kind="normal", xlab="", 
         fill_hist=fill, 
         col.nrm="black", col.gen="black",
         fill_nrm="transparent", fill_gen="transparent",
         use_plotly=FALSE,
         quiet=TRUE, pdf_file=NULL)
  if (subtitle) 
    txt <- paste(toString(sprintf("%i", ns)),
                 "samples, each of size", toString(n), "from", dist)
  else txt=""
  title(xlab="Sample Mean", sub=txt)

  if (pdf) {
    dev.off()
    .showfile(pdf_file, "sample distribution")
    cat("\n\n")
  }

  cat("\nAnalysis of Sample Means\n")
  cat("   Mean:", .fmt(mean(Ymean), digits_d, w=max.ln), "\n")
  cat("Std Dev:", .fmt(sd(Ymean), digits_d, w=max.ln), "\n")
  cat("\n")
  cat("Observed 95% range of Sample Mean\n", 
      "   Original Units:",  quantile(Ymean, prob=c(.025,.975)),"\n")
  if (dist != "antinormal") se <- sigma /sqrt(n) else se <- sx / sqrt(n)
  z <- (Ymean-mu) / se
  if (dist == "antinormal") cat("   Estimated from Data,")
  cat("  Standard Errors:",  quantile(z, prob=c(.025,.975)),"\n")

  if (n_display > 0)
    for(i in 1:n_display) 
      cat("\nSample", toString(i), "\n",
          "Mean:", sprintf("%.*f", digits_d, Ymean[i]), "\n",
          "Rounded Data Values:", .fmt(data.byrep[i,], digits_d), "\n")

  cat("\n")

}

VariableLabels <-
function(x, value=NULL, quiet=getOption("quiet")) {

  missx <- ifelse (missing(x), TRUE, FALSE) 
  if (!missx) {
    x.name <- deparse(substitute(x))
    options(xname = x.name)
  }
  else
    x.name <- NULL

  # extract labels/units from a data frame
  if (!is.null(x.name)) if (exists(x.name, where=.GlobalEnv)) { 
    if (is.data.frame(x)) {
      label <- attr(get(x.name, pos=.GlobalEnv), which="variable.labels")
      unit <- attr(get(x.name, pos=.GlobalEnv), which="variable.units")
      mylbl <- cbind(label, unit)
      l <- as.data.frame(mylbl, stringsAsFactors=FALSE,
                                row.names=names(label))
      if (!is.null(unit)) for (i in 1:nrow(l))
        if (is.na(l[i,2])) l[i,2] <- ""
      if (ncol(l) == 1) names(l) <- "label"
      if (ncol(l) == 2) names(l) <- c("label", "unit")
      if (is.null(mylbl))
        cat("\nNo variable labels present in the data file\n\n")
      return(l)
    }
  }

  # l: modify existing or add new row
  mylbYN <- ifelse (exists("l", where=.GlobalEnv), TRUE, FALSE) 
  if (mylbYN && !missx && !is.null(value)) {
    if (length(l[which(row.names(l) == x.name), 1]) > 0) {
      l[which(row.names(l) == x.name), 1] <- value
    }
    else {
      nr <- nrow(l)
      l[nr + 1, 1] <- value
      row.names(l)[nr + 1] <- x.name
    }
  return(l)
  }


  # display only or read from external file
  # --------------------------------------- 

  frm.cnsl <- FALSE
  if (!missx) 
    if (exists(x.name, where=.GlobalEnv))
      if (grepl("\n", x, fixed=TRUE)) frm.cnsl <- TRUE  # from console

  fmt <- "none"  # see if x is a file reference
  if (!is.null(x.name)) {
    if (grepl(".csv", x.name)) fmt <- "csv"
    if (grepl(".xlsx", x.name)) fmt <- "Excel"
  }

  # display only
  if (!frm.cnsl  &&  fmt=="none" && is.null(value)) {
    if (missx && is.null(x.name)) {  # display all labels
      cat("\n")
      for (i in 1:nrow(l))
        cat(row.names(l)[i], ": ", l[i,], "\n", sep="")
    }
    else {  # display existing label
      lbl <- l[which(row.names(l) == x.name), 1]
      if (is.null(lbl)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
        "The variable label does not exist for variable: ", x.name, "\n\n")
      }
      cat("\n")
      cat(x.name, ": ", lbl, "\n", sep="")
    }
  }

  # assign labels to vars in a data frame and return data frame
  else {

    # get labels
    if (fmt == "none")  {  # no external file, read from console
      l <- read.csv(text=x, row.names=1,
                    header=FALSE, stringsAsFactors=FALSE)
      if (ncol(l) == 1) names(l) <- "label"
      if (ncol(l) == 2) names(l) <- c("label", "unit")
    }
    else if (fmt == "csv") {  # x is a file name
      l <- read.csv(x, row.names=1,
                           header=FALSE, stringsAsFactors=FALSE)
      if (ncol(l) == 1) names(l) <- "label"
      if (ncol(l) == 2) names(l) <- c("label", "unit")
    }
    else {
      l <- as.data.frame(read.xlsx(x, colNames=FALSE), stringsAsFactors=TRUE)
      l <- as.data.frame(l, row.names=l[,1], stringsAsFactors=TRUE)
      l <- l[, -1, drop=FALSE]  # keep as a data frame with drop
      if (ncol(l) == 1) names(l) <- "label"
      if (ncol(l) == 2) names(l) <- c("label", "unit")
    }

  return(l)
  }

  cat("\n")

}

.plt.shapes <-
function(shape, out_shape, n.by=NULL) {

  # there is a level if a by variable

  bad.shape <- NULL

  shapes.nm <- c("circle", "square", "diamond", "triup", "tridown")
  shapes.pnt <- c("+", "*", "#", "%", "!", "=", "-", "&", "$",
                 "?", "|", ">", "<", "@", ".", "/", ";", ":")
  shapes.dgt <- as.character(0:9)
  shapes.all <- c(shapes.nm, 0:19, letters, LETTERS, shapes.pnt, shapes.dgt)

  if (!is.null(n.by)) {
    # shiny does not get here, shape is never missing, from Plot #771
    if (unique(n.by) > length(shapes.all)) {
      cat("\n")
      stop(call.=FALSE, "\n","------\n",
      "Only ", length(shapes.all), " unique shapes to display\n",
      "You specified a  by  variable with ", unique(n.by), " levels\n\n")
    }

    if (shape[1] == "vary") {
      more <- c(8, 7, 9, 10, 12:14, 11, letters, LETTERS, shapes.pnt)
      shapes.by <-  c("triup", "tridown", "circle", "square", "diamond", more)
      shape <- integer(length(n.by))
      shape <- shapes.by[1:n.by]
    }
  }

  # convert named shape to its numeric code, if needed
  if (!is.numeric(shape[1])) {
    num.flag <- FALSE
    for (i in 1:length(shape)) {
      if (!(shape[i] %in% shapes.all)) {
        bad.shape <- shape[i]
      }
      else if (shape[i] %in% shapes.nm) {
        shape[i] <- which(shape[i] == shapes.nm) + 20  # still char
        num.flag <- TRUE
      }
      else if (shape[i] %in% LETTERS) {
        shape[i] <- which(LETTERS == shape[i]) + 64
        num.flag <- TRUE
      }
      else if (shape[i] %in% letters) {
        shape[i] <- which(letters == shape[i]) + 96
        num.flag <- TRUE
      }
    }
    if (num.flag) {
      shape <- as.numeric(shape)
    }
  }
  else
    num.flag <- TRUE

  if (!is.numeric(out_shape[1])) {
    # convert named out_shape to its numeric code, if needed
    num.flag <- FALSE
    if (!(out_shape %in% shapes.all))
      bad.shape <- out_shape
    else {
      if (out_shape %in% shapes.nm) {  # outlier point
        out_shape <- which(out_shape == shapes.nm) + 20
        num.flag <- TRUE
      }
    }
  }
  else
    num.flag <- TRUE

  if (num.flag) out_shape <- as.numeric(out_shape)

  if (!is.null(bad.shape)) {
    message("\nValid shapes")
    message("------------")
    for (j in 1:length(shapes.nm)) message(shapes.nm[j])
    message("all uppercase and lowercase letters")
    message("all digits")
    message("+ * # % ! = - & $ ? | < > @")
    cat("\n")
    stop(call.=FALSE, "\n","------\n",
    "Not a valid shape: ", bad.shape, "\n\n")
  }

  return(list(shape=shape, out_shape=out_shape))

}

ttestPower <- 
function(n=NULL, s=NULL, n1=NULL, n2=NULL, s1=NULL, s2=NULL, 
         mmd=NULL, msmd=NULL, mdp=.8, mu=NULL, 
         pdf_file=NULL, width=5, height=5, ...) {

  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (length(dots) > 0) {
    change <- c("pdf.file")
    for (i in seq_along(dots)) {
      if (names(dots)[i] %in% change) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
      }
    }
  }
      
  cat("\n")
  
  # for all null arguments, pick up values from previous smd.t
  if (sum(sapply(list(n1, n2), is.null)) == 2) {  # n1 and n2 both NULL
    if (exists("n1", envir=.GlobalEnv, inherits=FALSE) &&
        exists("n2", envir=.GlobalEnv, inherits=FALSE)) {
      n1 <- get("n1", envir=.GlobalEnv, inherits=FALSE)
      n2 <- get("n2", envir=.GlobalEnv, inherits=FALSE)
    } 
    else {
      if (is.null(n)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Need to specify sample size, either n or n1 and n2.\n\n")
      }
    }
    if (is.null(s) && is.null(s1) && is.null(s2)) { 
          cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Need to specify a sample standard deviation, s,\n",
          "or two standard deviations, s1 and s2.\n\n")
    }
  }
  
  if ( (is.null(n)) && (is.null(n1)) && (is.null(n2)) ) { 
        cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Need to specify either a common sample size for both groups, n,\n",
        "or specify both group sample sizes, n1 and n2, from which\n",
        "the within-group or pooled standard deviation, sw, is computed.\n\n")
  }

  if ( (is.null(s)) && (is.null(s1)) && (is.null(s2)) ) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Need to specify either a single standard deviation, s, \n",
        "or specify two group standard deviations, s1 and s2, plus a\n",
        "common sample size n or individual sample sizes n1 and n2, from which\n",
        "the within-group standard deviation is computed.\n\n")
  }

  if ( (mdp < 0)  || (mdp > 1) ) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Minimum desired power, mdp, must be between 0 and 1.\n\n")
  }

  if ( !is.null(mmd) && !is.null(msmd) ) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Specify only one of mmd and msmd as one implies the other.\n\n")
  }

  if ( (!is.null(n1) && !is.null(n2)) && !is.null(mu) ) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Indicated two samples with n1 and n2 but only a single sample with mu.\n\n")
  }
  
  
  cat("------------------------------------------------------------\n")
  if (is.null(mu)) {
    mytype <- "two.sample"
    cat("Power Curve Analysis for Independent Groups t-test\n")
  }
  else {
    mytype <- "one.sample"
    cat("Power Curve Analysis for One Sample t-test\n")
    cat("------------------------------------------------------------\n")
    cat("mu =", mu, "\n")
  }
  
  # power curve for two groups, assuming mean difference of 0
  if (mytype == "two.sample") {
    cat("------------------------------------------------------------\n")
    
    # n1, n2 and n all should be set
    if (!is.null(n)) { 
      cat("\n", "Sample size: n = ", n, sep="")
      n1 <- n;  n2 <- n 
    }
    else {
      if ( !is.null(n1) && !is.null(n2) ) {
        n = 2 / ( 1/n1 + 1/n2 )  # harmonic mean
        cat("\n", "Sample sizes: n1 = ", n1, " and n2 = ", n2, sep="")
        cat("\n", "Harmonic mean of the two sample sizes: n = ", n, sep="", "\n")
      }
    }
        
    # within-group standard deviation	(need n1 and n2)
    if (is.null(s)) {
      if (is.null(s1) || is.null(s2)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Must provide both s1 and s2 (or just s) to compute the pooled SD.\n\n")
      }
      df1 <- n1 - 1
      df2 <- n2 - 1
      ssq <- (df1*s1^2 + df2*s2^2) / (df1 + df2)
      s <- sqrt(ssq)
      cat("\n", "Equal Group Variances Assumed", sep="", "\n")
    }
    cat("\n", "Within-group (pooled) Standard Deviation:  sw = ", s, sep="", "\n")
    
    mytitle <- "Power Curve for Independent Groups t-test"
    myxlab <- bquote(paste("Alternative Values of ", mu[1] - mu[2]))
    H0 <- 0
  }
  
  # power values for a single sample, triggered by nonzero mu
  else {
    mytitle <- "Power Curve for One Sample t-test"
    myxlab <- bquote(paste("Alternative Values of ", mu))
    H0 <- mu
  }
  cat("------------------------------------------------------------\n")
  
  # get value of mmd if msmd supplied
  if ( !is.null(mmd) || !is.null(msmd) ) {
    if (!is.null(mmd)) msmd <- mmd / s
    else if (!is.null(msmd)) mmd <- msmd * s
  }
  

  # set up graphics system
  .opendev(pdf_file, width, height)
  
  .ttp2graph(myxlab, mytitle, n, s, mdp, mmd, msmd, mytype, H0, ...)

  if (!is.null(pdf_file)) .showfile(pdf_file, "power curve")

  cat("\n")
    
}

order_by <-
function(data=d, by, direction=NULL, quiet=getOption("quiet"), ...) {


  if (missing(by)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the variables to sort by first listing the data frame\n",
      "or preceding the variables with:  by\n\n")
  }

  # if a tibble, convert to data frame
  df.name <- deparse(substitute(data))  # the data frame name, or "NULL"
  if (exists(df.name, envir=parent.frame())) {
    if (any(grepl("tbl", class(data), fixed=TRUE)))
      data <- data.frame(data)
  }

  data.vars <- as.list(seq_along(data))
  names(data.vars) <- names(data)

  if (!quiet) {
    cat("\nSort Specification\n")
  }

  # do special keywords: row.names, random
  if (deparse(substitute(by)) == "row.names") {
    ord <- "order(row.names(data)"

    if (!is.null(direction)) {
      if (length(direction) != 1) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Sorting by row.names takes exactly one direction value (+ or -).\n",
          "Number of direction values supplied: ", length(direction), "\n\n")
      }
      if (direction[1] == "+") txt <- "ascending"
      else if (direction[1] == "-") txt <- "descending"
      else {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Value of direction, the sort direction specification: ", direction[1],
        "\n\n",
        "Permissible values are + for ascending and - for descending.\n\n")
      }
    }
    else 
      txt <- "ascending"

    ord.txt <- "decreasing=FALSE"
    if (txt == "descending") ord.txt <- "decreasing=TRUE"
    ord <- paste(ord, ",", ord.txt, ",...)", sep="")
    if (!quiet) cat(" ", "row.names", "-->", txt, "\n")
  }  # end row.names

  else if (deparse(substitute(by)) == "random") {
    if (!quiet) cat(" ", "random\n")
    n.obs <- nrow(data)
    rand.rows <- sample(seq_len(n.obs), size=n.obs, replace=FALSE)
    ord <- paste("order(", "rand.rows", ", ...)", sep="")
  }  # end sort random

  else {  # sort variable(s)

    # columns to sort
    by.col <- eval(substitute(by), envir=data.vars, enclos=parent.frame())
    n.sort <- length(by.col)

    if (!is.null(direction)) {
      if (n.sort != length(direction)) { 
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Number of specified variables to sort: ", n.sort, "\n",
        "Number of + and - signs to indicate direction of sort: ", 
          length(direction), "\n\n",
        "The same number of values must be specified for both\n",
        "the list of values and the list of the sort direction.\n\n")
      }
    }
    else
      direction <- rep("+", n.sort)

    # validate direction values
    for (i in seq_len(n.sort)) {
      if (!(direction[i] %in% c("+", "-"))) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Value of direction, the sort direction specification: ",
          direction[i], "\n\n",
          "Permissible values are + for ascending and - for descending.\n\n")
      }
    }

    # console output
    if (!quiet) {
      for (i in seq_len(n.sort)) {
        nm <- names(data)[by.col[i]]
        txt <- if (direction[i] == "+") "ascending" else "descending"
        cat(" ", nm, "-->", txt, "\n")
      }
    }

    # construct the call to the order function
    ord <- ""
    for (i in seq_len(n.sort)) {  # xtfrm() needed for factors
      ord <- paste(ord, direction[i], 
                   "xtfrm(data[,by.col[", toString(i),"]])", sep="")
      if (i < n.sort) ord <- paste(ord, ",", sep="")
        
    }
    # forward ... to order() as the other branches do; empty ... is a no-op
    ord <- paste("order(", ord, ", ...)", sep="")
  }  # end sort variables


  # do the sort
  o <- eval(parse(text=ord))
  d <- data[o, , drop=FALSE]

  if (!quiet) cat("\n")
  return(d)

}

xRow <- function(x) {

  x.name <- names(x[])

  x.num <- suppressWarnings(as.numeric(x.name)) 

  for (i in 1:length(x))
    if (!is.na(x.num[i])) x.name[i] <- paste("Row", x.name[i])

  return(x.name)

}

.bcParamValid <-
function (y.miss, by.miss, facet.miss, Trellis, sort,
          fill_split, fill_scaled, fill_chroma, theme,
          fill.miss, labels_position, stat.miss) {


  if (Trellis  &&  sort != "0") {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Sort not applicable to Trellis plots\n\n")
  }

  if (!fill_scaled  &&  !is.null(fill_split)  &&  !fill.miss) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "fill_split assigns its own color based on the theme\n",
      "  either drop  fill_split  or drop  fill  parameter values\n\n")
  }

  if (fill_scaled  &&  !by.miss) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "fill_scaled only applies if no  by  variable\n\n")
  }

  if (!(labels_position %in% c("in", "out"))) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "labels_position  must be set to \"in\", \"out\"\n\n")
  }

  if (!stat.miss && Trellis) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Only the original data work with Trellis plots,",
      " no data aggregation with parameter stat.",
      " Use  by  instead of  facet.\n\n")
  }

}

.param.VBS <-
function(x, ID, facet1, facet1.miss, by0, by.miss,
       bw, bw.miss, bw_iter, iter.details, lx, n.ux,
       k.iqr, box_adj, a, b,
       x.name, facet1.name, by.name, vbs_plot,
       n_col.miss, n_row.miss,
       size, out_size, out_size.miss,
       jitter_x, jitter_y,
       bin=FALSE, breaks=NULL, bin_start=NULL, bin_width=NULL,
       bin_end=NULL, proportion=NULL,
       digits_d, quiet, fun_call=NULL, ...) {


.get.dup <- function(mc.w, x.name, lvl) {
  tx <- character(length = 0)

  # header
  max.lvl <- if (length(lvl) > 0) max(nchar(lvl)) else 0
  buf <- ifelse (max.lvl - 5 >= 0, max.lvl - 4, 0)
  h1 <- "Level"
  for (i in 1:buf) h1 <- paste0(h1, " ", collapse="")
  h0 <- gsub("Level", "    ", h1, fixed=TRUE)
  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste(h0, "Max Dupli-")
  tx[length(tx)+1] <- paste(h1, "cations   Values")
  tx[length(tx)+1] <- .dash2(30)

  # display repetitions
  for (i in seq_len(ncol(frq))) {  # frq is the freq table, x (rows) with facet1 (cols)
    max_f.col <- max(frq[,i])
#     x.val <- rownames(frq)[which(frq[,i]==max_f.col) %% nrow(frq)]
    x.val <- rownames(frq)[which(frq[,i]==max_f.col)]
    txt <- ""
    if (length(x.val) > 8) {
      x.val <- x.val[1:8]
      txt <- " ..."
    }
    x.val <- paste0(x.val, collapse=" ")  # convert char to num
    lvl.c <- .fmtc(lvl[i], max(max.lvl,6), j="left")
    if (max_f.col > 1)  # replications
      tx[length(tx)+1] <- paste(lvl.c, "    ", .fmti(max_f.col,3),
        "     ", x.val, txt, sep="")
    else
      tx[length(tx)+1] <- paste(lvl.c, "     0" )  # no reps
  }

  txrep <- tx
  class(txrep) <- "out"
  return(txrep)
}

# display current parameter values
.get.param <- function(size, jitter_y, jitter_x, bw) {
  tx <- character(length = 0)
  tx[length(tx)+1] <- "\n---------- Parameter values (can be manually set)\n"
  if (grepl("s", vbs_plot)) {
    if (length(size) == 1)
       tx[length(tx)+1] <- paste("size:",.fmt(pt.size, 2),
        "     size of plotted points")
    if (length(size) == 1)
      tx[length(tx)+1] <- paste("out_size:", .fmt(out_size,2),
        " size of plotted outlier points")
    tx[length(tx)+1] <- paste("jitter_y:", .fmt(jitter_y,2),
        "random vertical movement of points")
    tx[length(tx)+1] <- paste("jitter_x:", .fmt(jitter_x,2),
        " random horizontal movement of points")
  }
  if (grepl("v", vbs_plot))
    tx[length(tx)+1] <- paste("bw:" , .fmt(bw,2),
      "      set bandwidth higher for smoother edges")
  txprm <- tx
  class(txprm) <- "out"
  return(txprm)
}



# BEGIN
# -----

ceil.n <- 1001  # ceiling of unique x's to look for replicated values

if (is.null(by0)) by.name <- ""
if (is.null(facet1)) facet1.name <- ""

# suggestions
if (getOption("suggest") && !quiet) {
  # function call for suggestions
  fncl <- .fun_call.deparse(fun_call)
  fncl <- gsub(")$", "", fncl)  # get function call less closing )
  fncl <- gsub(" = ", "=", fncl)

  txsug <- ">>> Suggestions"

  fc <- paste("X(", x.name, sep="")

  txts <- character(length=3)
  cmts <- character(length=3)
  if (!grepl("out_cut", fncl)) {
    txts[1] <- ", out_cut=2"
    cmts[1] <- "Label two outliers ..."
  }
  if (!grepl("fences", fncl)) {
    txts[2] <- ", fences=TRUE"
    if (cmts[1] == "") cmts[2] <- "Show inner fences"
  }
  if (!grepl("vbs_mean", fncl)) {
    txts[3] <- ", vbs_mean=TRUE"
    if (cmts[2] == "") cmts[3] <- " Show mean"
  }

  if (any(txts[1:3] != "")) {
    txts[4] <- ", type=\"vbs\""
    txsug <- paste(txsug, "\n", fc, txts[1], txts[2], txts[3], txts[4], ") # ",
      cmts[1], cmts[2], cmts[3], sep="")
  }

  if (!grepl("box_adj", fncl)) {
    txt <- ", box_adj=TRUE, type=\"vbs\")  # Adjust whiskers for asymmetry"
    txsug <- paste(txsug, "\n", fc, txt, sep="")
  }

  if (nlevels(facet1) == 2  ||  nlevels(by0) == 2) {
    nm <- ifelse (nlevels(facet1) == 2, facet1.name, by.name)
    txt1 <- paste("ttest(", x.name, " ~ ", nm, ")", sep="")
    txt2 <- "  # Add the data parameter if not the d data frame"
    txsug <- paste(txsug, "\n", txt1, txt2, sep="")
  }

  if (nlevels(facet1) > 2  ||  nlevels(by0) > 2) {
    nm <- ifelse (nlevels(facet1) > 2, facet1.name, by.name)
    txt1 <- paste("ANOVA(", x.name, " ~ ", nm, ")", sep="")
    txt2 <- "  # Add the data parameter if not the d data frame"
    txsug <- paste(txsug, "\n", txt1, txt2, sep="")
  }

  txsug <- .rm.arg.2(" x=", txsug)
  txsug <- .rm.arg.2("(x=", txsug)
  txsug <- .rm.arg.2(" y=", txsug)

  class(txsug) <- "out"

  if (nzchar(txsug)) {
    output <- list(out_suggest=txsug)
    class(output) <- "out_all"
    print(output)
  }

}

if (!is.factor(x)) if (bw.miss)
  bw <- .band.width(na.omit(x), bw_iter, iter.details, ...) # initial bw
rep.prop <- (lx - n.ux) / lx


# -------
# ONE VAR VBS plot: # no facet1 (nor facet2) and no by, so x by itself
if (facet1.miss && by.miss) {
  # box plot outliers, stats
  bx <- .bx.stats(x, ID, k.iqr, box_adj, a, b, digits_d)
  txbox <- bx$txstat
  txotl <- bx$txotl
  class(txbox) <- "out"
  class(txotl) <- "out"
  txgrp <- ""

  # check for repetitions of x values (as a single variable)
  # mx.c, max category, is max number of values of a value of x
  if (length(unique(x)) < ceil.n) {
    frq <- as.matrix(table(x))
    mx.c <- ifelse (n.ux == lx, 0, max(table(x)))
    if (mx.c > 1)
      txrep <- .get.dup(mx.c, x.name, lvl=colnames(frq))
    else
      txrep <- "Number of duplicated values: 0"
    reps <- rep.prop > 0.15  &&  mx.c > (.10*lx)
   }
   else {
      txrep <- ""
      reps <- FALSE
      mx.c <- 0
   }

  iqr <- IQR(x, na.rm=TRUE)
  mx <- max(x, na.rm=TRUE)
  mn <- min(x, na.rm=TRUE)
  rt <- iqr / (mx - mn)  # ratio (rt) of IQR to range, eval compression

  if (is.null(size)) {
    if (!reps)
      pt.size <- ifelse (lx < 2535,  # at this value both equations equal
        1.096 - 0.134*log(lx), 0.226 - 0.023*log(lx))
    else
      pt.size <- 0.842 - 0.109*log(mx.c)
    if (pt.size < 0.01) pt.size <- ifelse (lx < 25000, 0.015, 0.006)
    if (rt < 0.18) pt.size <- (0.147 + 4.490*rt) * pt.size  # decrease size
  }
  else
    pt.size <- size  # assign user specified value

  if (out_size.miss) out_size <- 0.58 + 0.40*pt.size

  if (is.null(jitter_x)) jitter_x <- 1.1 * (1-exp(-0.03*mx.c))
  if (is.null(jitter_y)) {
    if (!reps)
       jitter_y <- ifelse (lx <= 10000,
                       -1.644 + 0.579*log(lx), -16.567 + 2.163*log(lx))
    else
       jitter_y <- -0.722 + 0.845*log(mx.c)
    jy.adj <- ifelse (rt < 0.18, 0.882 - 4.864*rt, 0)
    jitter_y <- jitter_y + (jy.adj * jitter_y)   # increases jitter
  }

  if (grepl("v", vbs_plot) || grepl("s", vbs_plot))
    txprm <- .get.param(size, jitter_y, jitter_x, bw)
  else
    txprm <- ""

  # get freq table for discrete, before jitter, not all x are unique
  txdst <- ""
  if (bin) {
    h <- .hst.main(x, breaks=breaks, bin_start=bin_start,
       bin_width=bin_width, bin_end=bin_end, prop=proportion,
       axis_fmt="K", axis_x_pre="", axis_y_pre="",
       quiet=quiet, fun_call=NULL, do_plot=FALSE, ...)
    txdst <- h$ttx
    class(txdst) <- "out"
  }

  if (n.ux < 9  &&  n.ux < length(x)) {  # x is discrete
    ssstuff <- .ss.factor(x, x.name=x.name, digits_d=digits_d, ...)
    txttl <- ssstuff$title
    txfrq <- ssstuff$counts
    txXV <- ssstuff$chi
    class(txttl) <- "out"
    class(txfrq) <- "out"
    class(txXV) <- "out"
    output <- list(type="VBS_Plot", call=fun_call,
      out_title=txttl, out_text=txfrq, out_freq=txdst, out_XV=txXV,
      out_tx=txbox, out_outliers=txotl, out_parm=txprm)
    class(output) <- "out_all"
    adj.bx.ht <- ifelse(lx < 1000, lx, 3*lx)
    return(list(bw=bw, pt.size=pt.size, jitter_y=jitter_y, jitter_x=jitter_x,
                adj.bx.ht=adj.bx.ht, out_size=out_size, output=output))
  }
  else {  # no freq table for not discrete variable

  if (!bin) txdst <- ""  # no freq distribution from histogram

  output <- list(type="Violin/Box/ScatterPlot",
    call=fun_call,
    out_tx=txbox, out_outliers=txotl, out_freq=txdst,
    out_rep=txrep, out_parm=txprm)

  class(output) <- "out_all"
  adj.bx.ht <- ifelse(lx < 1000, lx, 3*lx)  # adjust the height of the box
  return(list(bw=bw, pt.size=pt.size, jitter_y=jitter_y, jitter_x=jitter_x,
              adj.bx.ht=adj.bx.ht, out_size=out_size, output=output))
  }

}  # end one var

# -------
# Group Vars: x-variable with by and/or facet categorical variables
else {

  if (facet1.miss && !by.miss) facet1 <- by0
  frq <- table(x, facet1)
  n.lvl <- nlevels(facet1)
  lvl <- levels(facet1)

  # max number of repetitions for a value of x within a Ycat category
  # more jitter_x?
  mc.w <- max(frq)  # max category within, largest cell size
  rep.t <- integer(length=ncol(frq))
  for (i in seq_len(ncol(frq))) {
    rep.t[i] <- 0
    for (j in seq_len(nrow(frq)))
      if (frq[j,i] > 1) rep.t[i] <- rep.t[i] + (frq[j,i] - 1)
  }
  rep.max <- max(rep.t)
  if (length(unique(x)) < ceil.n)
    txrep <- .get.dup(mc.w, x.name, lvl)
  else
    txrep <- ""

  b.name <- ifelse(by.miss, facet1.name, by.name)

  mx.c <- max(tapply(x, facet1, length))
  # Threshold is 5% of n (vs 10% for one-var) because within-group cells
  # are smaller, so even moderate repetition is more visually significant.
  reps <- rep.prop > 0.15  &&  mc.w > (.05 * lx)

  # continuous variable with a categorical variable
  if (!reps) {  # reps-cat
    if (is.null(size))
      pt.size <- 0.926 - 0.108*log(mx.c) - 0.023*n.lvl
    else
      pt.size <- size  # assign user specified value
    if (any(pt.size < 0.025)) pt.size <- 0.025  # pt.size can be a vector

    if (out_size.miss) out_size <- 0.58 + 0.40*pt.size

    if (is.null(jitter_y)) {
      jitter_y <-  -1.221 + 0.576*log(mx.c) + 0.032*n.lvl
      if (jitter_y < 0.5) jitter_y <- 0.5
    }
    if (is.null(jitter_x)) jitter_x <- 0  # no horizontal jitter for non-reps group
    if (grepl("v", vbs_plot) || grepl("s", vbs_plot))
      txprm <- .get.param(size, jitter_y, jitter_x, bw)
    else
      txprm <- ""  # summary stats in out_grp
    output <- list(out_rep=txrep, out_parm=txprm)
  }  # end !reps

  # discrete, numerical variable with a categorical variable
  else {  # discrete-cat, facet1, yields the same
    if (!facet1.miss) {
      mx.c <- max(table(x, facet1))
    }

    if (is.null(size))
      pt.size <- 0.72 - 0.124*log(mc.w)
    else
      pt.size <- size  # assign user specified value
    if (any(pt.size < 0.025)) pt.size <- 0.025

    if (out_size.miss) out_size <- 0.58 + 0.40*pt.size

    if (is.null(jitter_y)) {
      jitter_y <-  -8 + 2.012*log(rep.max) + 0.9*n.lvl
        if (jitter_y < 1.0) jitter_y <- 1.0
    }
    if (is.null(jitter_x)) jitter_x <- 0.086 + 0.141*log(mx.c)
    if (jitter_x < 0) jitter_x <- 0
    if (grepl("v", vbs_plot) || grepl("s", vbs_plot))
      txprm <- .get.param(size, jitter_y, jitter_x, bw)
    else
      txprm <- ""

    if (n.ux < 9) {  # get x stats before jitter
      ssstuff <- .ss.factor(x, by=facet1,
                            x.name=x.name, y.name=facet1.name, ...)
      txfrq <- ssstuff$txfrq
      txXV <- ssstuff$txXV
      class(txfrq) <- "out"
      class(txXV) <- "out"
      output <- list(out_text=txfrq, out_XV=txXV,
         out_rep=txrep, out_parm=txprm)
    }
    else  # 9 or more levels
      output <- list(out_rep=txrep, out_parm=txprm)

    }
  }  # end two.var

  class(output) <- "out_all"

  adj.bx.ht <- ifelse(lx < 1000, lx, 3*lx)  # adjust the height of the box

  return(list(bw=bw, pt.size=pt.size, jitter_y=jitter_y, jitter_x=jitter_x,
              adj.bx.ht=adj.bx.ht, out_size=out_size, output=output))

}

.ss.pivot <- function(
  x, by = NULL,
  data,                         # REQUIRED data frame
  x.name = NULL,                # label for x (e.g., "Salary")
  by.name = NULL,               # label for by,  ignored if by is missing
  compute    = c(mean, median, sd, IQR, min, max),
  out_names  = c("Mean","Median","SD","IQR","Min","Max"),
  show_n     = TRUE,
  digits_d   = NULL,
  quiet      = isTRUE(getOption("quiet")),
  header     = TRUE,            # print header line
  print_result = TRUE,          # print table/header here (otherwise silent)
  debug      = FALSE
) {


  if (!is.data.frame(data)) stop("`data` must be a data frame.", call. = FALSE)

  pe      <- parent.frame()
  x_expr  <- substitute(x)
  by_expr <- substitute(by)

  # helper: is a symbol that also names a column in df?
  is_name_in_df <- function(e, df) is.symbol(e) && (deparse(e) %in% names(df))

  # --- detect x label ---
  x_disp <- if (!is.null(x.name) && nzchar(x.name)) x.name else deparse(x_expr)

  # --- initial (symbolic) by-missing test (no evaluation yet) ---
  by_missing <- missing(by) || is.null(by_expr)

  # PROBE the runtime value if not obviously missing
  by_val <- NULL
  if (!by_missing) {
    by_val <- try(eval(by_expr, envir = data, enclos = pe), silent = TRUE)
    if (inherits(by_val, "try-error"))
      by_val <- try(eval(by_expr, envir = pe), silent = TRUE)  # already try()
    # If it evaluates to NULL or length 0, treat as missing-by
    if (!inherits(by_val, "try-error") && (is.null(by_val) ||
        length(by_val) == 0)) {
      by_missing <- TRUE
      by_val <- NULL
    }
  }

  # by label (resolved only if grouped)
  by_disp <- if (!by_missing) {
    if (!is.null(by.name) && nzchar(by.name)) by.name else deparse(by_expr)
  } else ""

  # --- Build DF and symbols for pivot() ---
  if (is_name_in_df(x_expr, data)) {
    DF    <- data
    x_sym <- x_expr
  } else {
    x_vals <- try(eval(x_expr, envir = data, enclos = pe), silent = TRUE)
    if (inherits(x_vals, "try-error"))
      x_vals <- try(eval(x_expr, envir = pe), silent = TRUE)
    if (!nzchar(x_disp)) x_disp <- "Value"
    if (is.data.frame(x_vals)) {
      DF <- x_vals
    } else {
      DF <- data.frame(x_vals, check.names = TRUE)
      names(DF) <- x_disp
    }
    x_sym <- as.name(x_disp)
  }

  # ensure numeric aggregated variable
  x_nm <- deparse(x_sym)
  if (!is.numeric(DF[[x_nm]]))
    DF[[x_nm]] <- suppressWarnings(as.numeric(DF[[x_nm]]))
  if (!is.numeric(DF[[x_nm]]))
    stop("Aggregated variable `", x_nm,
         "` must be numeric after coercion.", call. = FALSE)

  # if grouping, ensure BY is a symbol/column in DF
  if (!by_missing) {
    if (is_name_in_df(by_expr, DF)) {
      by_sym <- by_expr
    } else {
      # use probed value (already evaluated); if not available, evaluate now
      if (is.null(by_val) || inherits(by_val, "try-error")) {
        by_val <- try(eval(by_expr, envir = data, enclos = pe), silent = TRUE)
        if (inherits(by_val, "try-error")) by_val <- eval(by_expr, envir = pe)
      }
      if (length(by_val) != nrow(DF))
        stop("`by` length (", length(by_val),
             ") must match number of rows (", nrow(DF), ").", call. = FALSE)
      if (!nzchar(by_disp)) by_disp <- "Group"
      # a non-syntactic display name, e.g., the expression cut(Years, 2),
      # re-parses as a call inside pivot() via str2lang(deparse(by)), so
      # add the column under a syntactic name; the first column of the
      # result is relabeled to by.name below
      by_int <- if (identical(make.names(by_disp), by_disp)) by_disp
                else ".by.group"
      DF[[by_int]] <- by_val
      by_sym <- as.name(by_int)
    }
  }

  compute_call <- substitute(compute)

  if (isTRUE(debug)) {
    cat("\n--- PIVOT SANITY CHECK ---\n")
    cat("Columns:         ", paste(names(DF), collapse = ", "), "\n")
    cat("Variable symbol: ", x_nm, "  (x.name:", x_disp, ")\n")
    if (by_missing) cat("By:              <none>\n")
    else cat("By symbol:       ", deparse(by_sym), "  (by.name:", by_disp,
             ")\n")
    cat("Compute:         ", paste(deparse(compute_call), collapse = " "), "\n")
    cat("--------------------------\n\n")
  }

  # --- Build pivot() call safely ---
  if (by_missing) {
    pv_call <- substitute(
      lessR::pivot(
        data      = DF_,
        compute   = COMP_,
        variable  = VAR_,
        out_names = OUT_,
        show_n    = SHOW_,
        digits_d  = DIG_,
        quiet     = QUIET_
      ),
      list(
        DF_    = DF,
        COMP_  = compute_call,
        VAR_   = x_sym,
        OUT_   = out_names,
        SHOW_  = show_n,
        DIG_   = digits_d,
        QUIET_ = quiet
      )
    )
  } else {
    pv_call <- substitute(
      lessR::pivot(
        data      = DF_,
        compute   = COMP_,
        variable  = VAR_,
        by        = BY_,
        out_names = OUT_,
        show_n    = SHOW_,
        digits_d  = DIG_,
        quiet     = QUIET_
      ),
      list(
        DF_    = DF,
        COMP_  = compute_call,
        VAR_   = x_sym,
        BY_    = by_sym,
        OUT_   = out_names,
        SHOW_  = show_n,
        DIG_   = digits_d,
        QUIET_ = quiet
      )
    )
  }

  res <- eval(pv_call)
  # --- Header & labeling / printing control ---
  if (print_result && isTRUE(header)) {
    if (by_missing) {
      cat(x_disp, "\n\n")
    } else {
      cat(x_disp, "  by  ", by_disp, "\n\n")
    }
  }

  # For grouped case: ensure displayed first column label = by.name
  # (if provided)
  if (!by_missing && !is.null(by.name) && nzchar(by.name) &&
      inherits(res, "data.frame")) {
    names(res)[1] <- by.name
  }

  if (print_result) {
    if (is.character(res)) {
      cat(paste(res, collapse = "\n"), "\n")
    } else if (inherits(res, "data.frame")) {
      print(res, row.names = FALSE)
    } else {
      print(res)
    }
  }

  invisible(res)
}

.cr.main <-
function(x, y, brief, ...) {

  # get variable labels if exist
  gl <- .getlabels()
  x.name <- gl$xn; x.lbl <- gl$xl;
  y.name <- gl$yn; y.lbl <- gl$yl

  if (!is.factor(x)) {

    ct <- cor.test(x,y, ...)

    if (ct$method == "Pearson's product-moment correlation") {
      c.type <- "pearson" 
      sym <- "r"
    }
    else if (ct$method == "Spearman's rank correlation rho") {
      c.type <- "spearman" 
      sym <- names(ct$estimate)
    }
    else if (ct$method == "Kendall's rank correlation tau") {
      c.type <- "kendall" 
      sym <- names(ct$estimate)
    }
    if (c.type == "pearson") sym.pop <- "Correlation" else sym.pop <- sym

    if (ct$alternative == "two.sided")
      h.txt <- "not equal to"
    else if (ct$alternative == "less")
      h.txt <- "less than"
    else if (ct$alternative == "greater")
      h.txt <- "greater than"

    tvalue <-  round(ct$statistic, 3)
    df <-  ct$parameter
    pvalue <-  round(ct$p.value, 3)
    coef <- round(ct$estimate, 3)
    null <- ct$null.value
    if (c.type == "pearson") {
      lb <- round(ct$conf.int[1], 3)
      ub <- round(ct$conf.int[2], 3)
      clpct <- "95%"
    }

    # background
    tx <- character(length = 0)
    if (!brief) {
      txt <- paste("Correlation Analysis for Variables", x.name, "and", y.name)
      tx[length(tx)+1] <- txt
      tx[length(tx)+1] <- " "
#     tx[length(tx)+1] <- .dash2(nchar(txt))
    }

    tx[length(tx)+1] <- paste("\n>>>", ct$method)

    if (!is.null(x.lbl) || !is.null(y.lbl)) {
      tx[length(tx)+1] <- ""
      if (!is.null(x.lbl))
        tx[length(tx)+1] <- paste(x.name, ": ", as.character(x.lbl), sep="")
      else
        tx[length(tx)+1] <- paste(x.name)
      if (!is.null(y.lbl))
        tx[length(tx)+1] <- paste(y.name, ": ", as.character(y.lbl), sep="")
      else
        tx[length(tx)+1] <- paste(y.name)
    }
   
      n.pair <- sum(!is.na(x - y))  # number of points after pairwise deletion
      tx[length(tx)+1] <- ""
      tx[length(tx)+1] <- paste("Number of paired values with neither",
        "missing, n =", n.pair)

    if (!brief) {
      n.del <- sum(is.na(x - y))  # number of pairwise deleted observations
      tx[length(tx)+1] <- paste("Number of cases (rows of data) deleted:",
        n.del)
    }

    txb <- tx

    # descriptive
    tx <- character(length = 0)
    if (!brief) {
      if (c.type == "pearson") {
        covr <- cov(x, y, use="pairwise.complete.obs")
        tx[length(tx)+1] <- paste("Sample Covariance: s =", .fmt(covr,3))
      tx[length(tx)+1] <- ""
      }
      tx[length(tx)+1] <- paste("Sample Correlation: ", sym, " = ",
        .fmt(ct$estimate,3), sep="")
    }
    else
      tx[length(tx)+1] <- paste("Sample Correlation of ", x.name, " and ",
        y.name, ": ", sym, " = ", .fmt(ct$estimate,3), sep="")

    txd <- tx


    # inferential
    tx <- character(length = 0)

    mytitle <- paste("Hypothesis Test of 0 ", sym.pop, ":  t = ", sep="")
    tx[length(tx)+1] <- paste(mytitle, .fmt(tvalue,3), ",  df = ", df,
        ",  p-value = ", .fmt(pvalue,3), sep="")

    if (c.type == "pearson") {
      tx[length(tx)+1] <- paste(clpct," Confidence Interval for Correlation:  ",
           .fmt(lb,3), " to ", .fmt(ub,3), sep="")
    }
    else {
      df <- NA; lb <- NA; ub <- NA
    }

    txi <- tx

  }

  return(list(txb=txb, txd=txd, txi=txi,
    r=round(ct$estimate,3), tvalue=round(ct$statistic,3),
    df=df, pvalue=round(ct$p.value,3), lb=lb, ub=ub))

}

Model <-
function(my_formula, data=d, brief=getOption("brief"), xlab=NULL, ...) {


  if (missing(my_formula)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify a model by listing it first or set according to:  my_formula\n\n")
  }

  # let deprecated mydata work as default
  dfs <- .getdfs()
  if ("mydata" %in% dfs  &&  !("d" %in% dfs)) d <- mydata

  dname <- deparse(substitute(data))  # get data frame name for cor before sort
  options(dname = dname)

  nm <- all.vars(my_formula)  # names of vars in the model
  n.vars <- length(nm)
  n.pred <- n.vars - 1

  if (n.pred < 1) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify at least one predictor variable in the model.\n\n")
  }

  in.data <- nm %in% names(data)
  if (!all(in.data)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Variable(s) in the model but not in the data frame ", dname, ": ",
      paste(nm[!in.data], collapse=", "), "\n\n")
  }

  # classify each variable in the model as categorical or numerical
  var.type <- character(length=n.vars)
  n.unique <- integer(length=n.vars)
  for (i in 1:n.vars) {
    v <- data[[nm[i]]]
    if (is.numeric(v)) var.type[i] <- "num"
    else if (is.factor(v) || is.character(v) || is.logical(v))
      var.type[i] <- "cat"
    else var.type[i] <- "other"
    n.unique[i] <- length(unique(na.omit(v)))
  }

  if (any(var.type == "other")) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Variable(s) in the model not categorical or numerical: ",
      paste(nm[var.type == "other"], collapse=", "), "\n\n")
  }

  if (n.unique[1] < 2) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "The response variable ", nm[1], " needs at least two unique\n",
      "values to model.\n\n")
  }

  all.preds.cat <- all(var.type[2:n.vars] == "cat")

  # route on the analytic structure of the model's variables

  if (var.type[1] == "cat") {  # categorical response

    if (n.unique[1] == 2) {
      cat("\n")
      .dash(60)
      cat("The response variable ", nm[1], " is categorical with two\n",
          "categories, so run Logit Regression analysis.\n", sep="")
      .dash(60)
      cat("\n")
      invisible(Logit(my_formula, data, brief=brief, xlab=xlab, ...))
    }

    else {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "The response variable ", nm[1], " is categorical with more than\n",
        "two categories. Models of a multi-category response are not\n",
        "supported.\n\n")
    }
  }

  else {  # numerical response

    y.vals <- na.omit(data[[nm[1]]])

    if (all(y.vals %in% c(0,1))) {  # binary response
      cat("\n")
      .dash(60)
      cat("Run Logit Regression analysis to account for\n",
          "binary response variable ", nm[1], ".\n", sep="")
      .dash(60)
      cat("\n")
      invisible(Logit(my_formula, data, brief=brief, xlab=xlab, ...))
    }

    else if (n.unique[1] == 2) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "The response variable ", nm[1], " is binary, but a numeric\n",
        "binary response can only have values of 0 or 1.\n\n",
        "Use recode() to transform the existing values to 0's and 1's.\n\n")
    }

    else if (all.preds.cat) {

      if (n.pred == 1  &&  n.unique[2] == 2) {  # t-test
        cat("\n")
        .dash(60)
        cat("Predictor variable, ", nm[2], ", has exactly two values.\n",
            "Run the t-test function to compare the corresponding\n",
            "group means of response variable ", nm[1], ".\n", sep="")
        .dash(60)
        cat("\n")
        # ttest() detects a formula from deparse(substitute(x)), so pass
        # the formula value in a re-built call for the tilde to be visible
        tt.cl <- match.call()
        tt.cl[[1L]] <- as.name("ttest")
        names(tt.cl)[names(tt.cl) == "my_formula"] <- "x"
        tt.cl$x <- my_formula
        invisible(eval(tt.cl, parent.frame()))
      }

      else {  # ANOVA
        cat("\n")
        .dash(60)
        cat("Run the ANOVA function to compare the corresponding \n",
            "group means of response variable ", nm[1], ".\n", sep="")
        .dash(60)
        invisible(ANOVA(my_formula, data, brief=brief, ...))
      }
    }  # all preds are categorical

    else {  # numerical or mixed numerical/categorical predictors
      cat("\n")
      .dash(60)
      cat("Run Regression analysis to account for response variable ",
          nm[1], ".\n", sep="")
      .dash(60)
      cat("\n")
      invisible(Regression(my_formula, data, brief=brief, ...))
    }

  }  # dv is numerical

}

.plt.hexbin.facet <-
function(x, y, facet1, facet2, facet1.name, facet2.name,
         hex_bins, hexbin_legend, x.lab, y.lab, n_row, n_col, aspect, quiet,
         axis_fmt = "K", axis_x_pre = "", axis_y_pre = "") {

  # hexbinplot's constructor rejects aspect="fill", but lattice's update()
  #   accepts it, so build with a placeholder and set the real aspect after.
  #   The XY default "fill" lets each panel expand to fill its cell, so the
  #   columns are not left narrow; hexagons stretch uniformly, preserving the
  #   count-to-color encoding.  A numeric aspect or "xy" (banking) is honored.
  asp <- if (is.numeric(aspect)) aspect
         else if (identical(aspect, "xy")) "xy"
         else "fill"

  if (!requireNamespace("hexbin", quietly = TRUE)) {
    stop("Package \"hexbin\" needed for this visualization\n",
         "Please install it:  install.packages(\"hexbin\")\n\n",
         call. = FALSE)
  }

  # panel-strip label:  VarName = "level"  (quote non-numeric levels only),
  #   matching the faceted contour/smooth forms
  .lab.lv <- function(nm, lv) {
    q <- ifelse(is.na(suppressWarnings(as.numeric(lv))),
                paste0('"', lv, '"'), lv)
    paste0(nm, " = ", q)
  }

  if (!is.factor(facet1)) facet1 <- factor(facet1)
  facet1 <- droplevels(facet1)
  facet1 <- factor(facet1, labels = .lab.lv(facet1.name, levels(facet1)))

  # -------------------------------------------------------------------------
  # color ramp from pt_fill, identical to the single hexbin plot
  hc <- .getHC(getOption("pt_fill"))
  pt_hue <- hc[1]; pt_chroma <- hc[2]
  clr.hex <- colorRampPalette(c(
    hcl(pt_hue, pt_chroma * 0.3, 90),   # sparse  — very light
    hcl(pt_hue, pt_chroma * 0.7, 50),   # mid
    hcl(pt_hue, pt_chroma,       15)))  # dense   — full color, dark

  # -------------------------------------------------------------------------
  # conditioning formula and panel layout (lattice layout is c(cols, rows))
  d <- data.frame(x = x, y = y, ..f1 = facet1)
  if (is.null(facet2)) {
    ff <- y ~ x | ..f1
    k <- nlevels(facet1)
    if (!is.null(n_col))      lay <- c(n_col, ceiling(k / n_col))
    else if (!is.null(n_row)) lay <- c(ceiling(k / n_row), n_row)
    else { nc <- ceiling(sqrt(k)); lay <- c(nc, ceiling(k / nc)) }
  }
  else {  # two facets: cols = facet1 levels, rows = facet2 levels
    if (!is.factor(facet2)) facet2 <- factor(facet2)
    facet2 <- droplevels(facet2)
    facet2 <- factor(facet2, labels = .lab.lv(facet2.name, levels(facet2)))
    d$..f2 <- facet2
    ff <- y ~ x | ..f1 * ..f2
    lay <- c(nlevels(facet1), nlevels(facet2))
  }

  # -------------------------------------------------------------------------
  # lessR lattice styling (mirrors .plt.lattice)
  panel_color <- getOption("panel_color")
  panel_frame_color <- ifelse(panel_color == "transparent",
                              "gray30", panel_color)

  # common x/y bin bounds for every panel: makes the panels comparable and
  #   avoids a degenerate range error when a facet cell has too few (or all
  #   identical) points to define its own bounds
  xbnds <- range(x, na.rm = TRUE)
  ybnds <- range(y, na.rm = TRUE)

  # axis_fmt-formatted tick labels (e.g., 60K), matching the other forms
  axT1 <- pretty(xbnds)
  ayT2 <- pretty(ybnds)
  lbl.x <- .axis.format(axT1, axis_fmt, axis_x_pre, axis_y_pre = "no")
  lbl.y <- .axis.format(ayT2, axis_fmt, axis_x_pre = "no", axis_y_pre)

  p <- hexbin::hexbinplot(ff, data = d, xbins = hex_bins, colramp = clr.hex,
    xbnds = xbnds, ybnds = ybnds, aspect = 1,  # placeholder; reset below
    colorkey = hexbin_legend, layout = lay, as.table = TRUE,
    xlab = list(label = x.lab, cex = getOption("lab_size"),
                col = getOption("lab_color")),
    ylab = list(label = y.lab, cex = getOption("lab_size"),
                col = getOption("lab_color")),
    scales = list(col = getOption("axis_text_color"),
                  cex = getOption("axis_size"),
                  x = list(at = axT1, labels = lbl.x),
                  y = list(at = ayT2, labels = lbl.y)),
    par.strip.text = list(cex = getOption("axis_size"),
                          col = getOption("strip_text_color")),
    par.settings = list(
      background = list(col = getOption("window_fill")),
      panel.background = list(col = getOption("panel_fill")),
      # extra right padding so the "Counts" legend title is not truncated
      layout.widths = list(right.padding = 3),
      axis.line = list(col = panel_frame_color,
                       lty = getOption("axis_lty"),
                       lwd = getOption("axis_lwd")),
      strip.border = list(col = getOption("strip_color"), lwd = 1),
      strip.background = list(col = getOption("strip_fill"))))

  p <- update(p, aspect = asp)  # "fill" allowed here, not in the constructor
  print(p)
}

# Frequency polygon, plotly rendering. One overlaid polygon per by-group.
# Modeled on dn.plotly(); binning via .bin_counts(), so this function carries
# no dependency on the histogram code path.
# Called from: X.R
freq_poly.plotly <- function(
  x, by = NULL,                  # numeric x; optional grouping var
  x_name, by_name = NULL,        # names for hover/legend
  fill,                          # scalar or length-G color(s)
  x_lab, y_lab = NULL,           # axis labels (y derived from stat if NULL)
  main = NULL,
  ax = NULL, gridT1 = NULL, gridT2 = NULL,  # lessR axis helpers
  stat = "count",                # "count", "proportion", or "%"
  fill_area = TRUE,              # TRUE: translucent fill; FALSE: lines only
  breaks = NULL, bin_start = NULL, bin_width = NULL, bin_end = NULL,
  digits_d = 3,
  style_opts = .plotly_style()
) {

  # --- groups ------------------------------------------------------------
  if (is.null(by)) {
    groups <- "Series 1"; G <- 1L
  } else {
    if (is.factor(by)) groups <- levels(by)
    else               groups <- unique(by[!is.na(by)])
    G <- length(groups)
  }

  # --- shared breaks across all groups -----------------------------------
  # bins computed once over all data so every group's polygon is comparable
  full <- .bin_counts(x, breaks=breaks, bin_start=bin_start,
                      bin_width=bin_width, bin_end=bin_end, x.name=x_name)
  shared.breaks <- full$breaks
  mids <- full$mids

  # --- per-group counts on the shared breaks -----------------------------
  poly.list <- vector("list", G)
  ymax <- 0
  for (g in seq_len(G)) {
    xg <- if (G == 1L) x else x[by == groups[g]]
    xg <- xg[is.finite(xg)]
    b  <- .bin_counts(xg, breaks=shared.breaks, x.name=x_name)
    yv <- b$counts
    if (stat == "proportion") yv <- yv / sum(yv)        # within-group
    else if (stat == "%")     yv <- (yv / sum(yv)) * 100 # within-group
    poly.list[[g]] <- list(x = mids, y = yv)
    ymax <- max(ymax, yv, na.rm = TRUE)
  }

  # close the polygon at zero: one bin-width step beyond first/last midpoint
  step <- if (length(mids) > 1) mids[2L] - mids[1L] else 1

  # --- y label from stat -------------------------------------------------
  if (is.null(y_lab))
    y_lab <- switch(stat,
      "proportion" = paste("Proportion of", x_name),
      "%"          = paste("Percentage of", x_name),
                     paste("Count of", x_name))

  # --- ticks / labels ----------------------------------------------------
  gridT1 <- ax$axT1 %||% gridT1 %||% pretty(range(mids), n = 5)
  gridL1 <- ax$axL1 %||% format(gridT1, big.mark = ",", trim = TRUE)
  gridT2 <- ax$axT2 %||% gridT2 %||% pretty(c(0, ymax), n = 6)
  gridL2 <- ax$axL2 %||% format(gridT2, trim = TRUE)

  # --- colors / alpha ----------------------------------------------------
  alpha.fill <- .auto_opacity(G, "fill")
  alpha.line <- .auto_opacity(G, "lines")
  fill.rgba  <- .maketrans_plotly(rep_len(fill, G), alpha = alpha.fill)
  line.rgba  <- .maketrans_plotly(rep_len(fill, G), alpha = alpha.line)
  # vertex points (lines-only mode): line color at full opacity
  pt.rgba    <- .maketrans_plotly(rep_len(fill, G), alpha = 1)

  # --- hover builder -----------------------------------------------------
  .hover <- function(xx, yy) {
    paste0(
      x_name, ": ", format(signif(xx, 6)),
      "<br>", y_lab, ": ", format(round(yy, digits_d), trim = TRUE)
    )
  }

  # --- widget & traces ---------------------------------------------------
  plt <- plotly::plot_ly(type = "scatter", mode = "lines", showlegend = G > 1)

  for (g in seq_len(G)) {
    p  <- poly.list[[g]]
    nm <- if (G > 1) groups[g] else NULL
    xx <- c(p$x[1L] - step, p$x, p$x[length(p$x)] + step)
    yy <- c(0, p$y, 0)
    # lines only: mark the vertices, but not the two zero-closing endpoints
    pt.size <- if (fill_area) NULL
               else c(0, rep(7.5, length(p$x)), 0)
    plt <- plotly::add_trace(
      plt,
      x = xx, y = yy, name = nm,
      mode      = if (fill_area) "lines" else "lines+markers",
      line      = list(color = line.rgba[g], width = 2.2),
      marker    = if (fill_area) NULL
                  else list(color = pt.rgba[g], size = pt.size,
                            line = list(width = 0)),
      fill      = if (fill_area) "tozeroy" else "none",
      fillcolor = if (fill_area) fill.rgba[g] else NULL,
      hoverinfo = "text",
      hovertext = if (!is.null(nm) && length(by_name))
        paste0(by_name, ": ", groups[g], "<br>", .hover(xx, yy))
      else
        .hover(xx, yy)
    )
  }

  # --- axes & grids ------------------------------------------------------
  border.shapes <- plot_border()
  x.shapes      <- x_grid(gridT1)

  ax.x <- axis_num(x_lab, gridT1, gridL1)
  ax.y <- axis_num(y_lab, gridT2, gridL2)

  ax.x$tickmode <- "array"; ax.x$tickvals <- gridT1; ax.x$ticktext <- gridL1
  ax.y$tickmode <- "array"; ax.y$tickvals <- gridT2; ax.y$ticktext <- gridL2
  ax.y$showgrid  <- TRUE
  ax.y$gridcolor <- .to_hex(style_opts$grid_col)
  ax.y$gridwidth <- 1
  ax.y$griddash  <- "dot"

  if (is.character(ax.x$title)) {
    ax.x$title <- list(text = ax.x$title, standoff = 10)
  } else if (is.list(ax.x$title)) {
    ax.x$title$standoff <- 10
  }
  ax.x$automargin <- TRUE

  plt <- plotly::layout(
    plt,
    xaxis = ax.x,
    yaxis = ax.y,
    shapes = c(x.shapes, border.shapes),
    template = NULL
  )

  # --- background & legend -----------------------------------------------
  plt$x$layout$plot_bgcolor  <- .to_hex(style_opts$panel_fill)
  plt$x$layout$paper_bgcolor <- .to_hex(style_opts$window_fill)

  if (G > 1) {
    leg.border <- .to_hex(style_opts$legend_border)
    leg.bg     <- .to_hex(style_opts$window_fill)
    plt <- plotly::layout(plt, legend = list(
      title = list(
        text = if (length(by_name)) by_name else "",
        font = list(size = round(15 * getOption("lab_size", 1)))),
      font = list(size = round(16 * getOption("axis_size", 0.9))),
      bgcolor = leg.bg,
      bordercolor = leg.border,
      borderwidth = 1
    ))
  }

  # --- finalize ----------------------------------------------------------
  plt <- .finalize_plotly_widget(
    plt,
    kind = "freq_poly",
    x_name = x_name,
    by_name = if (G > 1) by_name else NULL,
    add_title = FALSE,
    nudge_viewer = (.allow.interactive() &&
                    !isTRUE(getOption("knitr.in.progress")))
  )

  invisible(plt)
}

.plt.time <- function(x.call, y.call, by.call, x.name, n.by,
                      ts_unit, ts_agg="sum") {

  ts_truncate <- function(x.call, y.call, ts_unit) {

    end_of_period <- function(dd, unit) {
      y <- as.integer(format(dd, "%Y"))
      m <- as.integer(format(dd, "%m"))

      if (unit == "weeks") {
        wd <- as.integer(strftime(dd, "%u"))  # 1=Mon ... 7=Sun
        dd + (7L - wd)

      } else if (unit == "months") {
        first_next <- as.Date(sprintf("%04d-%02d-01",
                                      y + (m == 12L),
                                      ifelse(m == 12L, 1L, m + 1L)))
        first_next - 1L

      } else if (unit == "quarters") {
        q <- ((m - 1L) %/% 3L) + 1L
        end_m <- q * 3L
        first_next <- as.Date(sprintf("%04d-%02d-01",
                                      y + (end_m == 12L),
                                      ifelse(end_m == 12L, 1L, end_m + 1L)))
        first_next - 1L

      } else if (unit == "years") {
        as.Date(sprintf("%04d-12-31", y))

      } else {  # days
        dd
      }
    }

    stopifnot(is.data.frame(x.call), ncol(x.call) == 1L)
    d <- x.call[[1L]]
    stopifnot(inherits(d, "Date"))

    units <- c("days", "weeks", "months", "quarters", "years")
    if (!ts_unit %in% units) {
      stop("ts_unit must be one of: ", paste(units, collapse = ", "))
    }

    # days: nothing to truncate
    if (ts_unit == "days") {
      return(list(x = x.call, y = y.call, keep = rep(TRUE, length(d))))
    }

    # group key for target unit
    yr <- as.integer(format(d, "%Y"))
    mo <- as.integer(format(d, "%m"))
    g_target <- switch(
      ts_unit,
      "years"    = paste0(yr),
      "quarters" = paste0(yr, "-Q", ((mo - 1L) %/% 3L) + 1L),
      "months"   = paste0(yr, "-", sprintf("%02d", mo)),
      "weeks"    = paste0(format(d, "%G"), "-W", format(d, "%V"))
    )

    # last observed date determines whether final target period is complete
    max_d    <- max(d, na.rm = TRUE)
    end_last <- end_of_period(max_d, ts_unit)

    keep <- rep(TRUE, length(d))
    if (max_d < end_last) {
      last_g <- g_target[which.max(d)]
      keep[g_target == last_g] <- FALSE
    }

    list(
      x = x.call[keep, , drop = FALSE],
      y = y.call[keep, , drop = FALSE],
      keep = keep
    )
  }


  # begin Analysis --------------------------------------------------------

  # from STL() that passes vectors, not dfs
  if (!is.data.frame(x.call)) x.call <- data.frame(x.call)
  if (!is.data.frame(y.call)) y.call <- data.frame(y.call)

  # get existing ts_unit (evaluate 1st by level if by is present)
  if (is.null(by.call)) {
    d <- sort(unique(x.call[[1L]]))
  } else {
    lv1 <- if (is.factor(by.call)) levels(by.call)[1L]
            else sort(unique(by.call))[1L]
    d <- sort(unique(x.call[by.call == lv1, 1L]))
  }

  # ---- positive day gaps
  intervals <- as.integer(diff(d))
  intervals <- intervals[intervals > 0L]

  missing_periods <- FALSE
  tu_exist <- "unknown"

  # 1 handle trivial / very short series
  if (length(d) <= 1L || length(intervals) == 0L) {
    tu_exist <- "days"

  } else { # 2 Fine units from typical gap (median robust)
    gap <- as.integer(stats::median(intervals))

    if (gap == 1L) {
      tu_exist <- "days"

    } else if (gap == 7L) { # is a weekly series or irregular?
      p14 <- mean(intervals == 14L)

      # If lots of 14s (or more like biweekly), treat as unknown (irregular)
      if (p14 >= 0.40 || abs(gap - 14L) < abs(gap - 7L)) {
        tu_exist <- "unknown"

      } else {
        tu_exist <- "weeks"
      }

    } else { # 3 Coarse units from calendar structure (allow missing)
      dd <- as.Date(d)
      yr <- as.integer(format(dd, "%Y"))
      mo <- as.integer(format(dd, "%m"))
      da <- as.integer(format(dd, "%d"))

      # precompute indices
      yi <- yr
      qi <- yr * 4L + ((mo - 1L) %/% 3L + 1L)  # year-quarter index
      mi <- yr * 12L + mo                      # year-month index

      # YEARS: same month/day each year; at most one per year; allow missing
      if (tu_exist == "unknown") {
        same_md <- (length(unique(mo)) == 1L) &&
                   (length(unique(da)) == 1L)

        if (same_md && !any(duplicated(yi))) {
          yi_u <- sort(unique(yi))
          tu_exist <- "years"
        }
      }

      # Quarters: one obs per quarter; anchored quarter months; allow missing
      if (tu_exist == "unknown") {
        med_gap <- stats::median(intervals)
        plausible_quarterly <- med_gap >= 60L && med_gap <= 122L

        if (plausible_quarterly && !any(duplicated(qi))) {
          qi_u <- sort(unique(qi))
          tu_exist <- "quarters"
        }
      }

      # Months: one obs per month; allow missing months.
      # Auto-detect requires evidence of monthly intent (anchored day).
      if (tu_exist == "unknown") {
        if (!any(duplicated(mi))) {

          anchored_month <-
            (length(unique(da)) == 1L) ||  # same day-of-month each month
            all(da == 1L) ||               # always month start
            all(da >= 28L) ||              # near month-end (28/29/30/31)
            all(da <= 3L)                  # near month-start window

          if (anchored_month) {
            mi_u <- sort(unique(mi))
            tu_exist <- "months"
          } else {
            # leave tu_exist as "unknown" in auto mode
          }
        }
      }
    }
  }


  # does data support aggregation level?
  t.units <- c("unknown", "days", "weeks", "months", "quarters", "years")
  t.units <- factor(t.units, levels = t.units, ordered = TRUE)

  do.agg <- FALSE
  hold.unit <- FALSE

  if (!is.null(ts_unit)) {
    hold.unit <- (ts_unit == "days7")
    if (hold.unit) ts_unit <- "days"

    # Only enforce "cannot ask for finer than data" when tu_exist is known
    if (tu_exist != "unknown" &&
        which(t.units == ts_unit) < which(t.units == tu_exist)) {
      stop("Resolution of data is  ", tu_exist, "\n",
           "Requested data for ", ts_unit, " is not available\n\n",
           call. = FALSE)
    } else {
      do.agg <- TRUE
    }
  }

  # option: aggregate date variable by specified ts_unit
  if (!is.null(ts_unit) && do.agg) {

    # define the aggregation function: aggfun()
    if (ts_agg == "sum") {
      aggfun <- function(x) colSums(x)  # leave na.rm=FALSE to have NA agg
    } else if (ts_agg == "mean") {
      aggfun <- function(x) colMeans(x)
    }

    if (is.null(by.call)) {  # aggregate all data
      res <- ts_truncate(x.call, y.call, ts_unit = ts_unit)
      x.call <- res$x
      y.call <- res$y

      d.xts <- xts::xts(y.call[, seq_len(ncol(y.call))],
                        order.by = x.call[, 1])
      names(d.xts) <- names(y.call)

      ep <- xts::endpoints(d.xts, on = ts_unit)
      da.xts <- xts::period.apply(d.xts[, ], INDEX = ep, FUN = aggfun)

      # move dates from end of period to beginning of period
        if (ts_unit == "years") {
          zoo::index(da.xts) <- as.Date(format(zoo::index(da.xts), "%Y-01-01"))
        } else if (ts_unit == "quarters") {
          idx <- zoo::as.yearqtr(zoo::index(da.xts))
          zoo::index(da.xts) <- zoo::as.Date(idx)
        } else if (ts_unit == "months") {
          zoo::index(da.xts) <- as.Date(format(zoo::index(da.xts), "%Y-%m-01"))
        }

      x.call <- data.frame(zoo::index(da.xts))
      names(x.call)[1] <- x.name
      y.call <- data.frame(zoo::coredata(da.xts))

    } else {  # aggregate separately for each level of by, join
      x.cl <- data.frame(date = as.Date(character(0)))  # always 1 column
      y.cl <- y.call[0L, , drop = FALSE]
      by.cl <- data.frame(byc = factor(character(0), levels = levels(by.call)))
      by.cl <- by.cl[-1, ]

      for (k in seq_len(n.by)) {
        xl <- x.call[by.call == levels(by.call)[k], , drop = FALSE]
        yl <- y.call[by.call == levels(by.call)[k], , drop = FALSE]

        # truncate trailing partial target periods within each group
        es <- ts_truncate(xl, yl, ts_unit = ts_unit)
        xl <- es$x
        yl <- es$y
        if (nrow(xl) == 0L) next

        d.xts <- xts::xts(yl[, seq_len(ncol(yl))], order.by = xl[, 1])
        names(d.xts) <- names(y.call)

        ep <- xts::endpoints(d.xts, on = ts_unit)
        da.xts <- xts::period.apply(d.xts[, ], INDEX = ep, FUN = aggfun)

        if (ts_unit == "years") {
          zoo::index(da.xts) <- as.Date(format(zoo::index(da.xts), "%Y-01-01"))
        } else if (ts_unit == "quarters") {
          idx <- zoo::as.yearqtr(zoo::index(da.xts))
          zoo::index(da.xts) <- zoo::as.Date(idx)
        } else if (ts_unit == "months") {
          zoo::index(da.xts) <- as.Date(format(zoo::index(da.xts), "%Y-%m-01"))
        }

        x.c <- data.frame(date = zoo::index(da.xts))
        y.c <- as.data.frame(zoo::coredata(da.xts))
        by.c <- data.frame(byc = rep(levels(by.call)[k], nrow(x.c)))

        x.cl <- rbind(x.cl, x.c)
        y.cl <- rbind(y.cl, y.c)
        by.cl <- rbind(by.cl, by.c)
      }

      names(x.cl)[1] <- x.name
      x.call <- x.cl
      y.call <- y.cl
      by.call <- factor(by.cl[, 1, drop = TRUE])  # redundant, but safety
    }

  } else # ts_unit not specified: use inferred unit, no aggregation
      ts_unit <- tu_exist

  # check for gaps in the final (possibly aggregated) series
  if (ts_unit != "unknown") {
    if (is.null(by.call)) {
      d_final <- sort(unique(x.call[[1L]]))
    } else {
      lv1 <- levels(by.call)[1L]
      d_final <- sort(unique(x.call[by.call == lv1, 1L]))
    }

    if (length(d_final) > 1L) {
      yr_f <- as.integer(format(d_final, "%Y"))
      mo_f <- as.integer(format(d_final, "%m"))

      missing_periods <- switch(ts_unit,
        "days"    = ,
        "days7"   = any(diff(as.integer(d_final)) > 1L),
        "weeks"   = any(diff(as.integer(d_final)) > 7L),
        "months"  = any(diff(yr_f * 12L + mo_f) > 1L),
        "quarters"= any(diff(yr_f * 4L + ((mo_f - 1L) %/% 3L) + 1L) > 1L),
        "years"   = any(diff(yr_f) > 1L),
        FALSE
      )
    }
  }

  if (missing_periods)
    message("There are gaps in the dates, so that there are not regular\n",
            "intervals between all the dates.")

  if (hold.unit) ts_unit <- "days7"

  return(list(
    x.call = x.call,
    y.call = y.call,
    by.call = by.call,
    ts_unit = ts_unit,
    do.agg = do.agg
  ))
}

Regression <-
function(my_formula, data=d, filter=NULL,
         digits_d=NULL,

         Rmd=NULL, Rmd_browser=TRUE,
         Rmd_format=c("html", "word", "pdf", "odt", "none"),
         Rmd_data=NULL, Rmd_custom=NULL, Rmd_dir=path.expand("~/reg"),
         Rmd_labels=FALSE,
         results=getOption("results"), explain=getOption("explain"),
         interpret=getOption("interpret"), code=getOption("code"),

         text_width=120, brief=getOption("brief"), show_R=FALSE,
         plot_errors=FALSE,

         n_res_rows=NULL, res_sort=c("cooks","rstudent","dffits","off"),
         n_pred_rows=NULL, pred_sort=c("predint", "off"),
         subsets=NULL, best_sub=c("adjr2", "Cp"), cooks_cut=1,

         scatter_coef=TRUE, mod=NULL, mod_transf=c("center", "z", "none"),

         X1_new=NULL, X2_new=NULL, X3_new=NULL, X4_new=NULL,
         X5_new=NULL, X6_new=NULL,

         kfold=0, seed=NULL,
         new_scale=c("none", "z", "center", "0to1", "robust"),
         scale_response=FALSE,

         quiet=getOption("quiet"), bubble_plot=NULL,
         graphics=TRUE, size=NULL, pdf=FALSE, width=6.5, height=6.5,
         refs=FALSE,

         n_cat=getOption("n_cat"), # old

         fun_call=NULL, ...) {


  options(lessR.interactive = FALSE)

  if (!missing(n_cat)) {
    message(">>> Parameter  n_cat  will no longer work in the future.\n",
             "    Better to convert a categorical integer variable to ",
             "an R factor.\n\n",
             "Eg: d$Item1 <- factor(d$Item1, levels=1:3,",
                 "labels=c(\"Disagree\", \"Neutral\", \"Agree\", \n")
  }

  # produce actual argument, such as from an abbreviation, flag if not exist
  res_sort <- match.arg(res_sort)
  pred_sort <- match.arg(pred_sort)
  new_scale <- match.arg(new_scale)
  best_sub <- match.arg(best_sub)
  mod_transf <- match.arg(mod_transf)

  mod.mis <- missing(mod)

  old.opt <- options()
  on.exit(options(old.opt))

  options(width=text_width)

  # allow for more than one value, so cannot use match.arg
  # then all 5 get selected, then default to "html"
  if (missing(Rmd_format)  &&  length(Rmd_format) == 5) Rmd_format <- "html"

  # a dot in a parameter name to an underscore
  dots <- list(...)  # dot-to-underscore conversion and deprecated parameter check
  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (any(grepl(".", names(dots)[i], fixed=TRUE))) {
        pnm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(pnm, dots[[i]])
     }
    }
  }

  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] == "res_rows") n_res_rows <- dots[[i]]
      if (names(dots)[i] == "pred_rows") n_pred_rows <- dots[[i]]
      if (names(dots)[i] == "standardize") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "standardized  parameter  no longer used\n\n",
          "Instead use  recode=\"z\" . Also have \"0to1\" and\n",
          "  \"robust\" (median and IQR replace mean and sd) options.\n")
      }
      if (names(dots)[i] == "knitr.file") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "knitr.file  no longer used\n",
          "Instead use  Rmd  for R Markdown file\n\n")
      }
      if (names(dots)[i] == "quiet") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "quiet  option not available for Regression\n\n")
      }
    }
  }


  if (is.null(fun_call)) fun_call <- match.call()

  if (missing(my_formula)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify a model by listing it first or specify with:  my_formula\n\n")
  }

  if (!is.null(Rmd) && brief) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "To create an R Markdown File requires the full version of Regression\n\n")
  }

  # let deprecated mydata work as default
  dfs <- .getdfs()
  mydata.ok <- FALSE
  if (!is.null(dfs)) {
    if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
      d <- mydata
      df.name <- "mydata"
      mydata.ok <- TRUE
      options(dname = df.name)
    }
  }

  if (!mydata.ok) {
    df.name <- deparse(substitute(data))  # get name of data table
    options(dname = df.name)
  }

  # if a tibble, convert to data frame
  if (any(grepl("tbl", class(data), fixed=TRUE)))
    data <- data.frame(data)

  max_new <- 6

  if (brief) {
    if (is.null(n_res_rows)) n_res_rows <- 0L
    if (is.null(n_pred_rows) && is.null(X1_new)) n_pred_rows <- 0L
  }
  relate <- !brief

  if (kfold > 0) {
    graphics <- FALSE
    relate <- FALSE
    n_res_rows <- 0
    n_pred_rows <- 0
  }

  if (!mydata.ok) .nodf(df.name)  # does data frame exist?

  nm <- all.vars(my_formula)  # names of vars in the model
  n.vars <- length(nm)
  n.pred <- n.vars - 1L  # n.pred==0 means null model, y ~ 1

  if (!missing(filter)) {  # subset rows
    r <- eval(substitute(filter), envir=data, enclos=parent.frame())
    r <- r & !is.na(r)  # set missing for a row to FALSE
    if (!any(r)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "No rows of data with the specified value of\n",
        "filter = ", deparse(substitute(filter)), "\n\n")
    }
    data <- data[r,,drop=FALSE]
  }
  n.obs <- nrow(data)

  # evaluate expression terms, e.g., log(Years): each becomes a column
  #   of data named with the expression text, with the formula rewritten
  #   to reference the new columns
  fe <- .formula_expr(my_formula, data, parent.frame(), "Regression")
  my_formula <- fe$formula
  data <- fe$data
  nm <- all.vars(my_formula)
  n.vars <- length(nm)
  n.pred <- n.vars - 1L

  predictors <- nm[-1]

  # do variables nm exist in df.name?
  .xcheck(nm, df.name, names(data))

  if(n.pred > 1) {
    collinear <- TRUE
    if (is.null(subsets)) subsets <- TRUE
  }
  else {
    collinear <- FALSE
    subsets <- FALSE
  }

  # set digits_d
  if (is.null(digits_d)) digits_d <- .getdigits(data[,nm[1]], 3)
  options(digits_d=digits_d)

  in.data.frame <- TRUE
  for (i in seq_len(n.vars)) {
    if (!(nm[i] %in% names(data))) {
      cat("\n\n\n>>> Note: ", nm[i], "is not in the data frame.\n")
      in.data.frame <- FALSE
    }
  }

  # sort values of the one predictor variable for scatterplot
  #   so that the prediction/confidence intervals can be drawn
  if (n.pred == 1)
    data <- data[order(data[,nm[2]]), ]

  # reduce data to just model variables with no missing data
  data <- data[, c(nm), drop=FALSE]
  data <- data[complete.cases(data), , drop=FALSE]
  n.keep <- nrow(data)

  # for ancova to work, the variable must be non-numeric or a factor
  ancova <- FALSE  # ancova for one cont and one cat predictors
  if (n.pred == 2) {
  # non-numeric, non-factor concert to factor
    for (i.pred in seq(2, n.pred + 1)) {
      if (!is.numeric(data[,nm[i.pred]])) {
        if (!is.factor(data[,nm[i.pred]]))
          data[,nm[i.pred]] <- as.factor(data[,nm[i.pred]])
      }
    }
    if (is.numeric(data[,nm[2]]) && is.factor(data[,nm[3]]))
      ancova <- TRUE
    if (is.numeric(data[,nm[3]]) && is.factor(data[,nm[2]]))
      ancova <- TRUE
  }
  if (ancova)
    d.ancova <- data  # save original 3 cols of data for ancova
  else
    d.ancova <- NULL

  # check for all numeric vars in data.frame <- TRUE
  numeric.all <- TRUE
  for (i in seq_len(n.vars)) {
    if (in.data.frame && !is.numeric(data[1,which(names(data) == nm[i])])) {
      cat("\n>>> ", nm[i], "is not numeric.",
                 "Converted to indicator variables.\n")
      numeric.all <- FALSE
    }
  }

  # if not all numeric, construct the indicator variables
  if (!numeric.all) {
    md <- data.frame(model.matrix(my_formula, data=data))
    md[,1] <- data[,nm[1]]
    names(md)[1] <- nm[1]
    data <- md
    rm(md)
    nm <- names(data)
    n.vars <- ncol(data)
    n.pred <- n.vars - 1
    my_formula <- DF2formula(data)

    # if true integer, then convert from type double to integer
    rows <- min(50, nrow(data))  # save some time scanning
    fnu.col <- logical(length=ncol(data))
    for (i in seq_len(ncol(data)))
      if (.is.integer(data[1:rows,i]))
        fnu.col[i] <- TRUE
     data[fnu.col] <- lapply(data[fnu.col], as.integer) # move to integer
  }

  if (nrow(data) < n.pred + 2) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Need more than ", nrow(data), " rows of data.\n\n", sep="")
  }

  if (!is.null(X1_new)  &&  (n.pred > max_new)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "No new data for prediction if more than", max_new,
          "predictor variables.\n\n")
  }

  if (!is.numeric(data[,nm[1]])) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Response variable, ", nm[1], ", must be numeric.\n\n", sep="")
  }

  # check new.data option for consistency
  new.data <- FALSE
  if (n.pred > 0  &&  n.pred <= max_new) {
    for (i in seq_len(n.pred)) {
      pp <- eval(parse(text=paste("X", toString(i), "_new", sep="")))
      if (!is.null(pp)) new.data <- TRUE
    }
    if (new.data) for (i in seq_len(n.pred)) {
      pp <- eval(parse(text=paste("X", toString(i), "_new", sep="")))
      if (is.null(pp)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Specified new data values for one predictor variable,\n",
          " so do for all.\n\n")
      }
    }
  }

  # rescale option (if not K-Fold, do in reg.zKfold.R)
  transf <- NULL  # string to label output in .reg1bckBasic
  if (new_scale != "none") {
    if (new_scale == "z") transf <- "Standardized"
    if (new_scale == "center") transf <- "Centered"
    if (new_scale == "0to1") transf <- "Min-Max (0 to 1)"
    if (new_scale == "robust") transf <- "Robust Version of Standardized"
      if (kfold == 0) {
        i.start <- if (scale_response) 1L else 2L
        for (i in seq(i.start, n.vars))  {  # do not rescale y
          unq.x <- length(unique(data[,nm[i]]))
          if (unq.x > 2  &&  is.numeric(data[,nm[i]]))
            data[,nm[i]] <- rescale(data[,nm[i]], data=NULL,
                                    kind=new_scale, digits_d)
        }
      cat("\nRescaled Data, First Six Rows\n")
      print(data[seq_len(min(6, nrow(data))), nm])
      cat("\n")
      }
  }

  # moderator variable option
  if (!mod.mis) {

    if (n.pred > 2) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Parameter  mod  currently only works with 2 predictor variables.\n\n")
    }

    w.nm <- deparse(substitute(mod))
    w.ind <- which(names(data) == w.nm)

    if (!is.numeric(data[,w.ind])) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Variable for parameter  mod  must be numeric.\n\n")
    }

    data <- na.omit(data)  # lm() default, process data here that lm processes

    # scale the two predictor variables
    if (mod_transf != "none") {
      is.z <- (mod_transf == "z")
      for (i in seq_len(2))
        data[,nm[1+i]] <- scale(data[,nm[1+i]], center=TRUE, scale=is.z)
     }

    # name the new interaction variable
    x.nm <- ifelse (nm[2]==w.nm, nm[3], nm[2])
    xy.nm <- paste(w.nm, ".", x.nm, sep="")
    nm <- c(nm, xy.nm)

    # create new interaction variable
    new.col <- ncol(data) + 1
    data[, new.col] <- data[,nm[2]] * data[,nm[3]]
    names(data)[new.col] <- xy.nm

    # create the new regression model with the added interaction term
    my_formula <- as.formula(paste(.bt(nm[1]), "~",
                                   paste(.bt(nm[2:4]), collapse="+")))
    n.vars <- length(nm)
    n.pred <- n.vars - 1L

  }  # end mod


  # keep track of generated graphic, see if manage graphics
  if (graphics) {
    plot.i <- 0L
    plot.title  <- character(length=0)
    manage.gr <- .graphman()
  }



  # --------------------------------------------------------
  # OLS regression analysis
  # --------------------------------------------------------
  #   lmo: lm out
  #   all analysis done on data in model construct lmo$model
  lmo <- lm(my_formula, data=data, ...)
  # --------------------------------------------------------

  if (lmo$rank < n.vars) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
       "The attempted solution is singular. Too much linear dependence.\n\n")
  }

  # singularity check
  coef <- lmo$coefficients
  if (anyNA(coef)) {
    bad <- names(coef)[which(is.na(coef))]
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Variable redundant with a prior predictor in the model: ", bad, "\n\n",
      "Delete that variable, or corresponding prior redundant variables,\n",
      "  from the model.\n\n")
  }


  # -----------------------------------
  if (kfold == 0) {
    i.which <- 3

    title_bck <- "\n  BACKGROUND"
    bck <- .reg1bckBasic(lmo, df.name, digits_d, show_R, n.obs, n.keep,
                         transf)

    title_basic <- "\n  BASIC ANALYSIS"
    est <- .reg1modelBasic(lmo, digits_d, show_R)

    n.y <- sum(!is.na(data[,nm[1]]))  # counts non-NA values
    if (!ancova) {
      anv <- .reg1anvBasic(lmo, digits_d, show_R)
      ss.tot <- anv$tot["ss"]  # already computed
    }
    else {
      anv <- .reg1ancova(lmo, d.ancova, digits_d, show_R)
      ss.tot <- var(data[,nm[1]], na.rm = TRUE) * (n.y - 1)  # Type II ANVOVA
    }

    sy <- sqrt(ss.tot / (n.y-1))
    fit <- .reg1fitBasic(lmo, ss.tot, sy, digits_d, show_R)

    txkfl <- ""
    title_kfold <- paste("\n  K-FOLD CROSS-VALIDATION", sep="")
    m_se <- NA;  m_MSE <- NA;  m_Rsq <- NA

    title_rel <- "\n  RELATIONS AMONG THE VARIABLES"
    rel <- list()  # allow for rel not being processed and returned
    tol <- NA; vif <- NA  # defined here in case relate=FALSE or n.pred==0
    if (relate  &&  n.pred > 0) {
      max.sublns <- 50
      if (subsets > 1) {
        max.sublns <- subsets
        subsets <- TRUE
      }
      rel <- .reg2Relations(lmo, n.keep,
           collinear, subsets, best_sub, max.sublns,
           in.data.frame, est$sterrs, anv$MSW)
      if (is.vector(rel$tol)) tol <- round(rel$tol,3) else tol <- NA
      if (is.vector(rel$vif)) vif <- round(rel$vif,3) else vif <- NA
    }
    else { # not relate or n.pred == 0
      rel$out_collinear <- "";  rel$out_subsets <- ""
      rel$tol <- NA; rel$vif <- NA
    }

    title_res <- "\n  RESIDUALS AND INFLUENCE"
    if (is.null(n_res_rows)) n_res_rows <- if (n.keep < 20) n.keep else 20
    if (n_res_rows == "all") n_res_rows <- n.keep  # turn off resids if no res

    if (n_res_rows > 0) {

      cook <- round(cooks.distance(lmo), 5)
      res <- .reg3txtResidual(lmo, cook, digits_d, res_sort, n_res_rows,
                              show_R)
      if (!is.na(res$resid.max[1])) resid.max <- round(res$resid.max,3)

      if (graphics  &&  n.pred > 0) {
        if (!pdf && manage.gr) {  # set up graphics system outside of RStudio
          # 2 residual plots (devices 3,4) + scatterplot/matrix (device 5)
          .graphwin(3, width, height)
        }

        if (manage.gr && !pdf) dev.set(which=i.which)
        plt <- .reg3dnResidual(lmo, pdf, width, height, manage.gr, ...)
        if (plt$i > 0)
          for (i in seq(plot.i+1, plot.i+plt$i)) plot.title[i] <- plt$ttl[i-plot.i]
        plot.i <- plot.i + plt$i


        i.which <- i.which + 1
        if (manage.gr && !pdf) dev.set(which=i.which)
        fr <- .reg3resfitResidual(lmo, cook, cooks_cut,
                   pdf, width, height, manage.gr)
        if (fr$i > 0)
          for (i in seq(plot.i+1, plot.i+fr$i)) plot.title[i] <- fr$ttl[i-plot.i]
        plot.i <- plot.i + fr$i
      } # graphics

    }  # end n_res_rows > 0
    else {
      res <- list()
      res$out_residuals <- ""
      resid.max <- NA
      cook <- NA
    }

    if (is.null(n_pred_rows)) n_pred_rows <- if (n.keep < 25) n.keep else 10
    if (n_pred_rows == "all") n_pred_rows <- n.keep  # no preds if n_pred_rows=0

    a <- "\n  PREDICTION ERROR"
    if (n_pred_rows > 0) {
      a <- paste(a, "\n\n-- Data, Predicted, Standard Error of Prediction,",
                          "95% Prediction Intervals")
      a <- paste(a, "\n   [sorted by lower bound of prediction interval]")
      if (n_pred_rows < n.keep  &&  !new.data)
        a <- paste(a, "\n   [to see all intervals add n_pred_rows=\"all\"]")
      a <- paste(a, "\n", .dash2(46))
    }
    title_pred <- a

    if (n_pred_rows>0 || !is.null(X1_new)) {  # if requested, do X1_new, etc.
      prd <- .reg4Pred(lmo,
           n.keep, digits_d, show_R,
           new.data, pred_sort, n_pred_rows, scatter_coef,
           in.data.frame, X1_new, X2_new, X3_new, X4_new, X5_new, X6_new)
    }
    else {
      prd <- list()
      prd$out_predict <- ""
      prd$predmm <- NA
    }

  }  # end kfold==0
  # -----------------------------------

  else {
    title_kfold <- paste("\n  ", kfold, "-FOLD CROSS-VALIDATION", sep="")

    Kfld <- .regKfold(data[,nm], my_formula, kfold, new_scale, scale_response,
                      nm, predictors, n.vars,
                      n.keep, seed, digits_d, show_R)
    txkfl <- Kfld$tx
    m_se <- Kfld$m_se; m_MSE <- Kfld$m_MSE; m_Rsq <- Kfld$m_Rsq
  }

  # Plot scatterplot, maybe ANCOVA info
  txmdl <- ""
  if (graphics) {
    if (manage.gr && !pdf) {
      if (n_res_rows > 0  &&  n.pred > 0)
        i.wh <- 5  # already did two plots
      else {
        .graphwin(1, width, height)  #  only plot is a scatterplot
        i.wh <- 3
      }
      dev.set(which=i.wh)
    }

    if (!ancova) {
      ancovaOut <- .reg5Plot(lmo, n_res_rows, n_pred_rows, scatter_coef,
         X1_new, in.data.frame, prd$cint, prd$pint,
         plot_errors, digits_d, size, pdf, width, height, bubble_plot,
         manage.gr, quiet, ...)
    }
    else {
      ancovaOut <- .reg5ancova(lmo, d.ancova, digits_d,
                               pdf, width, height, manage.gr, quiet, ...)
      txmdl <- ancovaOut$txmdl
      if (ancovaOut$i > 0)
        for (i in seq(plot.i+1, plot.i+ancovaOut$i))
          plot.title[i] <- ancovaOut$ttl[i-plot.i]
      plot.i <- plot.i + ancovaOut$i
    }
  }  # end graphics

  title_mod <- ""
  if (!mod.mis && graphics) {

    if (manage.gr && !pdf)  # set up graphics system
        .graphwin(4, width, height)

    title_mod <- "\n  MODERATION ANALYSIS"

    mo <- .reg6mod(lmo, w.nm, x.nm, digits_d, pdf, width, height, manage.gr)

    if (manage.gr && !pdf)
      i.which <- i.which + 1

    if (mo$i > 0)
      for (i in seq(plot.i+1, plot.i+mo$i)) plot.title[i] <- mo$ttl[i-plot.i]
    plot.i <- plot.i + mo$i

  }  # end mod
  else {
    mo <- list()
    mo$out_mod <- ""
  }


  # ----------
  # References
  # ----------
  txref <- ""
  tx <- character(length = 0)
  if (refs) {
    tx[length(tx)+1] <- "\n  REFERENCES"

    tx[length(tx)+1] <- paste("\n",
        "Function Regression() is from David Gerbing's lessR package.\n",
        "  To obtain the reference: Enter citation(\"lessR\")")
    tx[length(tx)+1] <- paste("\n",
        "Best model subset analysis is from Thomas Lumley's leaps function\n",
        "in his package leaps.\n",
        "  To obtain the reference: Enter citation(\"leaps\")")
    tx[length(tx)+1] <- paste("\n",
        "All analyses based on R.\n",
        "  To obtain the reference: Enter citation()")
    txref <- tx
  }


  # R Markdown
  txRmd <- ""
  txWeb <- ""
  txWrd <- ""
  txpdf <- ""
  txodt <- ""
  txrtf <- ""
  if (!is.null(Rmd)) {

    # get some (generally) unique values for each pred to demo X1_new ...
    new.val <- matrix(nrow=n.pred, ncol=2, byrow=TRUE)
    if (n.pred <= max_new  &&  is.null(X1_new)) {
      for (i in seq_len(n.pred)) {
        v <- sort(data[,nm[i+1]])

        # get new lower value
        min_v <- min(v, na.rm=TRUE)
        test.v <- round(quantile(v, probs=.25)[1])
        while(test.v %in% v)
          if (test.v > min_v) test.v <- test.v - 1 else break
        new.val[i,1] <- if (test.v == min_v) round(test.v-1) else round(test.v)
        if (min_v==0  &&  test.v==0) new.val[i,1] <- 0  # don't go neg here

        # get new upper value
        max.v <- max(v, na.rm=TRUE)
        test.v <- round(quantile(v, probs=.75)[1])
        while(test.v %in% v)
          if (test.v < max.v) test.v <- test.v + 1 else break
        new.val[i,2] <- if (test.v == max.v) round(test.v+1) else round(test.v)
      }
    }  # new.val

    # generate and write Rmd file
# in case want to move an r output structure to .reg.Rmd
#   r <- c(bck, anv, est, fit, rel, res, prd)
#   vars <- all.vars(my_formula)
#   r$vars <- vars

    txknt <- .reg.Rmd(nm, df.name, fun_call, n_res_rows, n_pred_rows,
        res_sort, d.ancova, digits_d, results, explain, interpret, code,
        est$pvalues, tol, resid.max, X1_new, new.val,
        Rmd_data, Rmd_custom, Rmd_dir, Rmd_labels)
    if (!grepl(".Rmd", Rmd, fixed=TRUE)) Rmd <- paste(Rmd, ".Rmd", sep="")
    cat(txknt, file=Rmd, sep="\n")  # Rmd is now file of markdown instructions
    txRmd <- .showfile2(Rmd, "R Markdown file")

    if (!requireNamespace("rmarkdown", quietly=TRUE)) {
      stop("Package \"rmarkdown\" needed for this regression output\n",
           "Please install it:  install.packages(\"rmarkdown\")\n\n",
           call. = FALSE)
    }
    if (rmarkdown::pandoc_available()) {
      Rmd_format <- tolower(Rmd_format)

      # render Rmd R markdown to current working dir for each specified doc type
      for (i in seq_along(Rmd_format)) {
        if (Rmd_format[i] != "none") {
          Rmd_format[i] <- paste(Rmd_format[i], "_document", sep="")
          rmarkdown::render(Rmd, quiet=TRUE, output_format=Rmd_format[i])
        }
        do_Web <- grepl("html", Rmd_format[i])
        do_Wrd <- grepl("word", Rmd_format[i])
        do_pdf <- grepl("pdf", Rmd_format[i])
        do_odt <- grepl("odt", Rmd_format[i])
        do_rtf <- grepl("rtf", Rmd_format[i])
        if (do_Web) {
          fname <- sub("Rmd", "html", Rmd, fixed=TRUE)
          txWeb <- .showfile2(fname, "rendered HTML file for a web browser")
          if (Rmd_browser) browseURL(fname)
        }
        if (do_Wrd) {
          fname <- sub("Rmd", "docx", Rmd, fixed=TRUE)
          txWrd <- .showfile2(fname, "rendered MS Word file")
        }
        if (do_pdf) {
          fname <- sub("Rmd", "pdf", Rmd, fixed=TRUE)
          txpdf <- .showfile2(fname, "rendered pdf file")
        }
        if (do_odt) {
          fname <- sub("Rmd", "odt", Rmd, fixed=TRUE)
          txodt <- .showfile2(fname, "rendered odt file")
        }
        if (do_rtf) {
          fname <- sub("Rmd", "rtf", Rmd, fixed=TRUE)
          txrtf <- .showfile2(fname, "rendered rtf file")
        }
      }
    }  # is pandoc
    else {
      message("\n",
      "R Markdown (Rmd) file created\n",
      "However, need  pandoc  installed to render web, Word, or pdf output\n",
      "<< Re-run analysis in RStudio, which makes the process automatic >>\n",
      "Otherwise can download from pandoc.org and run manually\n\n")
    }
  }  # end Rmd not null

  # display list of plots if more than 1
  txplt <- ""
  if (graphics) {
    if (plot.i > 1) txplt <- .plotList2(plot.i, plot.title)
    if (manage.gr && n.pred > 0) dev.set(which=2)  # reset graphics for standard R functions
  }

  # suggestion for Rmd option
  txsug <- ""
  if (getOption("suggest")) {
    # function call for suggestions
    fncl <- .fun_call.deparse(fun_call)
    fncl <- gsub("\\)$", "", fncl)  # get function call less closing )
    fncl <- gsub(" = ", "=", fncl)
    fncl <- gsub("reg.brief", "reg", fncl)

    fc <- ""
    if (!grepl("Rmd", fncl)) {
      txsug <- ">>> Suggestion\n"
      fc <- paste(fc, ", Rmd=\"eg\"", sep="")
      if (nzchar(fc)) {
        fc <- paste(fncl, fc, ") ", sep="")
        txsug <- paste(txsug,
           "# Create an R markdown file for interpretative output ",
           "with  Rmd = \"file_name\"\n", sep="")
        txsug <- paste(txsug, fc, sep="")
      }
    }
  }

  if (kfold == 0) {
    class(txsug) <- "out"
    class(title_bck) <- "out"
    class(bck$out_background) <- "out"
    class(title_kfold) <- "out"
    class(txkfl) <- "out"
    class(title_basic) <- "out"
    class(est$out_estimates) <- "out"
    class(fit$out_fit) <- "out"
    class(anv$out_anova) <- "out"
    class(title_mod) <- "out"
    class(mo$out_mod) <- "out"
    class(title_rel) <- "out"
    class(rel$out_collinear) <- "out"
    class(rel$out_subsets) <- "out"
    class(title_res) <- "out"
    class(res$out_residuals) <- "out"
    class(title_pred) <- "out"
    class(prd$out_predict) <- "out"
    class(txplt) <- "out"
    class(txmdl) <- "out"
    class(txref) <- "out"
    class(txRmd) <- "out"
    class(txWrd) <- "out"
    class(txpdf) <- "out"
    class(txodt) <- "out"
    class(txrtf) <- "out"

    output <- list(
      out_suggest=txsug,

      call=fun_call, formula=my_formula, vars=nm,

      out_title_bck=title_bck, out_background=bck$out_background,

      out_title_basic=title_basic, out_estimates=est$out_estimates,
      out_fit=fit$out_fit, out_anova=anv$out_anova,

      out_title_mod=title_mod, out_mod=mo$out_mod,

      out_mdls=txmdl,

      out_title_kfold=title_kfold, out_kfold=txkfl,

      out_title_rel=title_rel,
      out_collinear=rel$out_collinear, out_subsets=rel$out_subsets,

      out_title_res=title_res, out_residuals=res$out_residuals,
      out_title_pred=title_pred, out_predict=prd$out_predict,

      out_ref=txref, out_Rmd=txRmd, out_Word=txWrd, out_pdf=txpdf,
                     out_odt=txodt, out_rtf=txrtf, out_plots=txplt,
      n.vars=bck$n.vars, n.obs=bck$n.obs, n.keep=n.keep,
      coefficients=est$estimates, sterrs=est$sterrs, tvalues=est$tvalues,
      pvalues=est$pvalues, cilb=est$cilb, ciub=est$ciub,
      anova_model=anv$mdl, anova_residual=anv$rsd, anova_total=anv$tot,
      se=fit$se, resid_range=fit$range,
      Rsq=fit$Rsq, Rsqadj=fit$Rsqadj, PRESS=fit$PRESS, RsqPRESS=fit$RsqPRESS,
      m_se=m_se, m_MSE=m_MSE, m_Rsq=m_Rsq,
      tolerances=rel$tol, vif=rel$vif,
      resid.max=resid.max, pred_min_max=prd$predmm,
      residuals=lmo$residuals, fitted=lmo$fitted,
      cooks.distance=cook, model=lmo$model, terms=lmo$terms
    )
  }

  # kfold > 0
  else {
    class(txkfl) <- "out"
    output <- list(out_title_kfold=title_kfold, out_kfold=txkfl)
  }


  # -----------------------------
  class(output) <- "out_all"

  return(output)

}

showPalettes <-
function(palette=c("sequential", "hues", "viridis", "wesanderson"),
         n=12, border="transparent", file=NULL) {

  palette <- match.arg(palette)

  if (is.null(file)) file <- paste(palette, ".pdf", sep="")
  pdf(file=file)

  old.par <- par(no.readonly = TRUE)
  on.exit({
    par(old.par)
    dev.off()
  }, add=TRUE)

  if (border == "off") border <- "transparent"

  pal <- function(nm, col) {
    plot(0, 0, type="n", xlim=c(0, 1), ylim=c(0, 1),
         axes=FALSE, xlab=nm, ylab="")
    rect(0:(n-1)/n, 0, 1:n/n, 1, col=col, border=border)
  }

  if (palette == "sequential") {
    par(mfrow=c(5,1), mgp=c(0,0,0))
    pal("reds",       getColors("reds",       n=n))
    pal("rusts",      getColors("rusts",      n=n))
    pal("browns",     getColors("browns",     n=n))
    pal("olives",     getColors("olives",     n=n))
    pal("greens",     getColors("greens",     n=n))
    pal("emeralds",   getColors("emeralds",   n=n))
    pal("turquoises", getColors("turquoises", n=n))
    pal("aquas",      getColors("aquas",      n=n))
    pal("blues",      getColors("blues",      n=n))
    pal("purples",    getColors("purples",    n=n))
    pal("violets",    getColors("violets",    n=n))
    pal("magentas",   getColors("magentas",   n=n))
    pal("grays",      getColors("grays",      n=n))
  }

  if (palette == "hues") {
    # 16 qualitative palettes: c x l grid of {20,40,60,80}
    par(mfrow=c(4,4), mgp=c(0,0,0), mar=c(2,1,1,1))
    c_vals <- c(20, 40, 60, 80)
    l_vals <- c(20, 40, 60, 80)
    for (c_val in c_vals) {
      for (l_val in l_vals) {
        label <- paste0("c=", c_val, ", l=", l_val)
        pal(label, getColors("hues", n=n, c=c_val, l=l_val))
      }
    }
  }

  if (palette == "viridis") {
    par(mfrow=c(5,1), mgp=c(0,0,0))
    pal("viridis",  getColors("viridis",  n=n))
    pal("cividis",  getColors("cividis",  n=n))
    pal("plasma",   getColors("plasma",   n=n))
    pal("spectral", getColors("spectral", n=n))
  }

  if (palette == "wesanderson") {
    if (!requireNamespace("wesanderson", quietly=TRUE)) {
      stop("Package \"wesanderson\" needed for these colors\n",
           "Please install it:  install.packages(\"wesanderson\")\n\n",
           call. = FALSE)
    }
    par(mfrow=c(5,1), mgp=c(0,0,0))
    pal("BottleRocket1",  getColors("BottleRocket1",  n=n))
    pal("BottleRocket2",  getColors("BottleRocket2",  n=n))
    pal("Rushmore1",      getColors("Rushmore1",      n=n))
    pal("Rushmore",       getColors("Rushmore",       n=n))
    pal("Royal1",         getColors("Royal1",         n=n))
    pal("Royal2",         getColors("Royal2",         n=n))
    pal("Zissou1",        getColors("Zissou1",        n=n))
    pal("Darjeeling1",    getColors("Darjeeling1",    n=n))
    pal("Darjeeling2",    getColors("Darjeeling2",    n=n))
    pal("Chevalier1",     getColors("Chevalier1",     n=n))
    pal("FantasticFox1",  getColors("FantasticFox1",  n=n))
    pal("Moonrise1",      getColors("Moonrise1",      n=n))
    pal("Moonrise2",      getColors("Moonrise2",      n=n))
    pal("Moonrise3",      getColors("Moonrise3",      n=n))
    pal("Cavalcanti1",    getColors("Cavalcanti1",    n=n))
    pal("GrandBudapest1", getColors("GrandBudapest1", n=n))
    pal("GrandBudapest2", getColors("GrandBudapest2", n=n))
    pal("IsleofDogs1",    getColors("IsleofDogs1",    n=n))
    pal("IsleofDogs2",    getColors("IsleofDogs2",    n=n))
  }

  .showfile(file, "file of R colors")
}

.<-
  function (x, ...) {  # return selected row or column indices

  random <- function (n) {  # random selection of rows
    n.obs <- nrow(data)
    n.obs_new <- ifelse (n > 1, n, round(n*n.obs,0))
    rand.rows <- sample(1:n.obs, size=n.obs_new, replace=FALSE)
  }

  # not necessarily the full col expression if there is a , in the col string
  x.call <- deparse(substitute(x))  # expressions passed to ., row or col

  sc <- sys.calls()
  scu <- unlist(sc)  # all function calls that lead to x, many in .Rmd
  f.call <- as.character(scu[[length(sc)-2]])  # full d[ ] function call
  df <- f.call[2]   # data frame name from full d[ ] call
  x.r <- f.call[3]  # function call for rows from full d[ ] call
  x.c <- f.call[4]  # function call for cols from full d[ ] call

  # correct for user mistake in x.r of only one = sign
  # this is evaluated for columns also, presumably no = signs there
  if (nchar(x.call) == 0) {  # happens with only one = sign
    n.eq <- length(unlist(gregexpr("=", x.r, fixed=TRUE)))
    if (n.eq == 1) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
         "Need two equal signs == for logical equality.\n\n")
    }
  }

  data <- get(df, envir=parent.frame())
  xdt <- data  # not work if data is a function name, so work on copy
  df <- paste("xdt", "$", sep="")

  # select rows, expression precedes the , in originating d[ ] call
  not.flag <- FALSE
  if (substr(x.r, 3, 3) == "!" || x.r == ".(!rows)") {  # needed for literal !rows
    not.flag <- TRUE
    if (x.r ==  ".(!rows)") x.r = ".(rows)"
  }

  # need to strip x.r down to xcall which does not contain . and !
  if (!not.flag || grepl("rows", x.r, fixed=TRUE)) {
    x.r <- substr(x.r, 3, nchar(x.r))    # remove leading .(
    x.r <- substr(x.r, 1, nchar(x.r)-1)  # remove trailing )
  }
  else {
    x.r <- substr(x.r, 5, nchar(x.r))    # remove leading .(!(
    x.r <- substr(x.r, 1, nchar(x.r)-2)  # remove trailing )
  }
  if (x.r == "rows") x.r <- eval(parse(text=x.r))
  if (!grepl("rows", x.r, fixed=TRUE))
    x.rr <- ifelse(!not.flag,  x.r, paste("!(", x.r, ")" , sep=""))
  else
    x.rr <- x.r

  # see if process rows
  if (x.call %in% c(x.rr, "rows", "!rows")) {  # select rows
    x <- x.r  # character string of the logical expression for rows
    # problem is that a name could be a subset of another name
    #   so add an initial " " for whole name to later be extracted
   x <- paste(" ", x, sep="")  
    # proceed through all xdt names, when a match add "xdt$" to the name in x
    for (i in 1:length(names(xdt))) {  # see if a variable is specified
      # is the variable name in xdt in the x logical expression for rows?
      # position of ith variable name that is followed by a non-alphabetic char
      ind <- gregexpr(paste(" ", names(xdt)[i], "[^a-zA-Z]", sep=""), x)
      n <- unlist(ind)  # starting position of matche(s), -1 if no match
#cat(i," name=", names(xdt)[i], "  x=\'",x,"\'  start=",
#    n, " length=", attr(ind[[1]],which="match.length"), "\n")
      if (any(n>0)) {  # in x, prefix specified variable name with df=xdt$
        for (j in 1:length(n)) {  # variable name can occur more than once
          ind2 <- gregexpr(paste(" ", names(xdt)[i], "[^a-zA-Z]", sep=""), x)
          np <- unlist(ind2)
          pre <- substr(x, 1, np-1)
          post <- substr(x, np, nchar(x))
          x <- paste(pre, df, post, sep="")
          x <- gsub("$ ", "$", x, fixed=TRUE) # get rid of extra inserted " "
        }
      }  # end any(n > 0)
    }
    # x is either a logical expression or a function (e.g. random)
    if (not.flag) x <- paste("!(", x, ")", sep="")
    if (!grepl("random(", x.r, fixed=TRUE))
      x <- paste("which(", x, ")", sep="")  # expression to select rows
    rn <- row.names(xdt[eval(parse(text=x)),])
    return(rn)  # selected rows
  }

  # select columns, expression follows the , in originating d[ ] call
  if (x.call == "cols") {
     x.c <- eval(parse(text=x.call))  # evaluate cols
     x.c <- paste(".(", x.c, ")", sep="")  # as if read directly
  }
  if (grepl(x.call, x.c, fixed=TRUE)  ||  x.call=="cols") {  # x.call to ,
    if (substr(x.c, 1, 1) == "-")  # base R Extract handles the -
      x.c <- substr(x.c, 2, nchar(x.c))  # remove the -.
    substr(x.c, 1, 1) <- "c"  # replace . with combine function c
    x <- str2lang(x.c)  # transform character string to type calls
    xdt.vars <- as.list(seq_along(xdt))
    names(xdt.vars) <- names(xdt)
    return(eval(x, envir=xdt.vars))  # selected column index numbers
  }

}

style <-
function(
  theme=c("colors", "lightbronze", "dodgerblue", "darkred", "gray",
      "gold", "darkgreen", "blue", "red", "rose", "slatered", "green",
      "purple", "sienna", "brown", "orange", "white", "light"),
  sub_theme=c("default", "black", "wsj"),
  set=NULL, get=FALSE, reset=TRUE,

  window_fill=getOption("window_fill"),
  panel_fill=getOption("panel_fill"),
  panel_color=getOption("panel_color"),
  panel_lwd=getOption("panel_lwd"),
  panel_lty=getOption("panel_lty"),

  fill=NULL,
  bar_fill=getOption("bar_fill"),
  bar_fill_discrete=getOption("bar_fill_discrete"),
  bar_fill_cont=getOption("bar_fill_cont"),
  trans=NULL,
  trans_bar_fill=getOption("trans_bar_fill"),
  color=NULL,
  bar_color=getOption("bar_color"),
  bar_color_cont=getOption("bar_color_cont"),
  bar_color_discrete=getOption("bar_color_discrete"),
  labels=getOption("labels"),
  labels_color=getOption("labels_color"),
  labels_size=getOption("labels_size"),
  labels_digits=getOption("labels_digits"),
  labels_position=getOption("labels_position"),

  pt_fill=getOption("pt_fill"),
  trans_pt_fill=getOption("trans_pt_fill"),
  pt_color=getOption("pt_color"),
  se_fill=getOption("se_fill"),
  ellipse_fill=getOption("ellipse_fill"),
  ellipse_color=getOption("ellipse_color"),
  ellipse_lwd=getOption("ellipse_lwd"),
  fit_color=getOption("fit_color"),
  fit_lwd=getOption("fit_lwd"),
  bubble_text_color=getOption("bubble_text_color"),
  segment_color=getOption("segment_color"),
  ID_color=getOption("ID_color"),
  out_fill=getOption("out_fill"),
  out_color=getOption("out_color"),
  out2_fill=getOption("out2_fill"),
  out2_color=getOption("out2_color"),

  violin_fill=getOption("violin_fill"),
  violin_color=getOption("violin_color"),
  box_fill=getOption("box_fill"),
  box_color=getOption("box_color"),

  axis_color=getOption("axis_color"),
  axis_x_color=getOption("axis_x_color"),
  axis_y_color=getOption("axis_y_color"),
  axis_lwd=getOption("axis_lwd"),
  axis_x_lwd=getOption("axis_x_lwd"),
  axis_y_lwd=getOption("axis_y_lwd"),
  axis_lty=getOption("axis_lty"),
  axis_x_lty=getOption("axis_x_lty"),
  axis_y_lty=getOption("axis_y_lty"),
  axis_size=getOption("axis_size"),
  axis_x_size=getOption("axis_x_size"),
  axis_y_size=getOption("axis_y_size"),
  axis_text_color=getOption("axis_text_color"),
  axis_x_text_color=getOption("axis_x_text_color"),
  axis_y_text_color=getOption("axis_y_text_color"),
  rotate_x=getOption("rotate_x"),
  rotate_y=getOption("rotate_y"),
  offset=getOption("offset"),

  lab_color=getOption("lab_color"),
  lab_x_color=getOption("lab_x_color"),
  lab_y_color=getOption("lab_y_color"),
  lab_size=getOption("lab_size"),
  lab_x_size=getOption("lab_x_size"),
  lab_y_size=getOption("lab_y_size"),
  main_color=getOption("main_color"),
  main_size=getOption("main_size"),

  grid_color=getOption("grid_color"),
  grid_x_color=getOption("grid_x_color"),
  grid_y_color=getOption("grid_y_color"),
  grid_lwd=getOption("grid_lwd"),
  grid_x_lwd=getOption("grid_x_lwd"),
  grid_y_lwd=getOption("grid_y_lwd"),
  grid_lty=getOption("grid_lty"),
  grid_x_lty=getOption("grid_x_lty"),
  grid_y_lty=getOption("grid_y_lty"),

  strip_fill=getOption("strip_fill"),
  strip_color=getOption("strip_color"),
  strip_text_color=getOption("strip_text_color"),

  add_fill=getOption("add_fill"),
  add_trans=getOption("add_trans"),
  add_color=getOption("add_color"),
  add_size=getOption("add_size"),
  add_lwd=getOption("add_lwd"),
  add_lty=getOption("add_lty"),

  n_cat=getOption("n_cat"),
  suggest=getOption("suggest"),
  notes=getOption("notes"),
  quiet=getOption("quiet"),
  brief=getOption("brief"),
  lessR.use_plotly=getOption("lessR.use_plotly"),

  results=getOption("results"), explain=getOption("explain"),
  interpret=getOption("interpret"), document=getOption("document"),
  code=getOption("code"),

  width=120, show=FALSE, ...) {

  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] == "values.cex")  labels_size <- dots[[i]]
      else if (grepl(".", names(dots)[i], fixed=TRUE)) {
        pnm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(pnm, dots[[i]])
      }
    }
  }

  if (nargs() == 0) {
     theme <- "colors"
     miss_theme <- FALSE
     if (!quiet) cat("theme set to \"colors\"\n\n")
  }
  else {
    miss_theme <- missing(theme)
  }
  if (miss_theme)
    theme <- getOption("theme")
  else
    theme <- match.arg(theme)

  # reset: make change with new options, usually TRUE, but could be ...
  # set: save current options, get: get current options
  if (show || get) reset <- FALSE


  miss_set <- missing(set)
  miss_tr.bar_fill <- missing(trans_bar_fill)

  # only change these persistent behavior options when explicitly
  # requested, either as the argument or via a set= list; otherwise a
  # theme change resets them (via .onLoad) and would silently flip a
  # session-wide setting the user did not ask to change
  quiet_specified   <- !missing(quiet)   || !miss_set
  brief_specified   <- !missing(brief)   || !miss_set
  suggest_specified <- !missing(suggest) || !miss_set
  notes_specified   <- !missing(notes)   || !miss_set
  quiet_prior   <- getOption("quiet")
  brief_prior   <- getOption("brief")
  suggest_prior <- getOption("suggest")
  notes_prior   <- getOption("notes")

  miss_sub_theme <- missing(sub_theme)
  if (sub_theme[1] == "colors") {
  cat("\n"); stop(call.=FALSE, "\n","------\n",
      "\"colors\" now a theme, the default theme\n\n")
  }
  sub_theme <- match.arg(sub_theme)

  # check for deprecated parameters (dots captured above)
  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] == "colors") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
            "option  colors  is renamed  theme\n\n")
      }
      if (names(dots)[i] == "ghost") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
            "invoke option  ghost  as style(sub_theme=\"black\")\n\n")
      }
      if (names(dots)[i] == "gray.black") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
            "now invoke style(\"gray\", sub_theme=\"black\")\n\n")
      }
      # cex parameters renamed to size (e.g., axis_cex -> axis_size)
      if (grepl("_cex$", names(dots)[i])) {
        new_nm <- sub("_cex$", "_size", names(dots)[i])
        warning("'", names(dots)[i], "' is renamed '", new_nm,
                "' -- please update your call.\n", call.=FALSE)
      }
    }
  }

  # ------------------------------------------------
  # restore values according to previously saved  set
  if (!is.null(set)) {

    theme <- set$theme
    sub_theme <- set$sub_theme

    window_fill <- set$window_fill
    panel_fill <- set$panel$fill
    panel_color <- set$panel$color
    panel_lwd <- set$panel$lwd
    panel_lty <- set$panel$lty

    bar_fill <- set$bar$fill
    bar_fill_discrete <- set$bar$bar_fill_discrete
    bar_fill_cont <- set$bar$bar_fill_cont
    trans_bar_fill <- set$bar$trans_fill
    bar_color <- set$bar$color
    bar_color_cont <- set$bar$bar_color_cont

    labels <- set$bar$labels
    labels_color <- set$bar$labels_color
    labels_size <- set$bar$labels_size
    labels_digits <- set$bar$labels_digits
    labels_position <- set$bar$labels_position

    pt_fill <- set$pt$fill
    trans_pt_fill <- set$pt$trans_fill
    pt_color <- set$pt$color
    out_fill <- set$pt$out_fill
    out_color <- set$pt$out_color
    out2_fill <- set$pt$out2_fill
    out2_color <- set$pt$out2_color

    violin_fill <- set$VBS$violin_fill
    violin_color <- set$VBS$violin_color
    box_fill <- set$VBS$box_fill
    box_color <- set$VBS$box_color

    ellipse_fill <- set$ellipse$fill
    ellipse_color <- set$ellipse$color
    ellipse_lwd <- set$ellipse$lwd

    fit_color <- set$fit_color
    fit_lwd <- set$fit_lwd
    se_fill <- set$se_fill
    bubble_text_color <- set$bubble_text_color
    segment_color <- set$segment_color
    ID_color <- set$ID_color

    axis_color <- set$axis$color
    axis_x_color <- set$axis_x$color
    axis_y_color <- set$axis_y$color
    axis_lwd <- set$axis$lwd
    axis_x_lwd <- set$axis_x$lwd
    axis_y_lwd <- set$axis_y$lwd
    axis_lty <- set$axis$lty
    axis_x_lty <- set$axis_x$lty
    axis_y_lty <- set$axis_y$lty
    axis_size <- set$axis$cex
    axis_x_size <- set$axis_x$cex
    axis_y_size <- set$axis_y$cex
    axis_text_color <- set$axis$text_color
    axis_x_text_color <- set$axis_x$text_color
    axis_y_text_color <- set$axis_y$text_color
    rotate_x <- set$rotate$x
    rotate_y <- set$rotate$y
    offset <- set$rotate$offset

    lab_color <- set$lab$color
    lab_x_color <- set$lab_x$color
    lab_y_color <- set$lab_y$color
    lab_size <- set$lab$cex
    lab_x_size <- set$lab_x$cex
    lab_y_size <- set$lab_y$cex
    main_color <- set$main$color
    main_size <- set$main$cex

    grid_color <- set$grid$color
    grid_x_color <- set$grid_x$color
    grid_y_color <- set$grid_y$color
    grid_lwd <- set$grid$lwd
    grid_x_lwd <- set$grid_x$lwd
    grid_y_lwd <- set$grid_y$lwd
    grid_lty <- set$grid$lty
    grid_x_lty <- set$grid_x$lty
    grid_y_lty <- set$grid_y$lty

    strip_fill <- set$strip$fill
    strip_color <- set$strip$color
    strip_text_color <- set$strip$text_color

    add_fill <- set$add$fill
    add_trans <- set$add$trans
    add_color <- set$add$color
    add_size <- set$add$cex
    add_lwd <- set$add$lwd
    add_lty <- set$add$lty

    n_cat <- set$n_cat
    suggest <- set$suggest
    notes <- set$notes
    quiet <- set$quiet
    brief <- set$brief
    lessR.use_plotly <- set$lessR.use_plotly

    results <- set$output$results
    explain <- set$output$explain
    interpret <- set$output$interpret
    document <- set$output$document
    code <- set$output$code
  }  # end not null set


  # reset all parameters to start-up condition for new theme
  if (reset) {
    if (!miss_theme) {
      suppressPackageStartupMessages(.onLoad())
      bar_fill <- getOption("bar_fill")
      theme <- match.arg(theme)
      options(theme=theme)
      options(trans_bar_fill=0.10)
      options(trans_pt_fill=0.10)
    }
    else if (miss_set)
      theme <- getOption("theme")

    if (!miss_sub_theme)
      options(sub_theme=sub_theme)
    else
      sub_theme <- getOption("sub_theme")
  }


  # inheritance
  if (!missing(trans)) {
    trans_pt_fill <- trans
    trans_bar_fill <- trans
  }
  if (!missing(fill)) {
    pt_fill <- fill
    bar_fill <- fill
  }
  if (!missing(color)) {
    pt_color <- color
    bar_color <- color
  }
  if (!missing(axis_color)) {
    axis_x_color <- axis_color
    axis_y_color <- axis_color
  }
  if (!missing(axis_size)) {
    axis_x_size <- axis_size
    axis_y_size <- axis_size
  }
  if (!missing(lab_color)) {
    lab_x_color <- lab_color
    lab_y_color <- lab_color
  }
  if (!missing(lab_size)) {
    lab_x_size <- lab_size
    lab_y_size <- lab_size
  }
  if (!missing(grid_color)) {
    grid_x_color <- grid_color
    grid_y_color <- grid_color
  }
  if (!missing(grid_lwd)) {
    grid_x_lwd <- grid_lwd
    grid_y_lwd <- grid_lwd
  }
  if (!missing(grid_lty)) {
    grid_x_lty <- grid_lty
    grid_y_lty <- grid_lty
  }

  # "off" is "transparent"
  bar_fill[which(bar_fill == "off")] <- "transparent"
  bar_fill_discrete[which(bar_fill_discrete == "off")] <- "transparent"
  bar_fill_cont[which(bar_fill_cont == "off")] <- "transparent"
  pt_fill[which(pt_fill == "off")] <- "transparent"
  bar_color_discrete[which(bar_color_discrete == "off")] <- "transparent"
  bar_color_cont[which(bar_color_cont == "off")] <- "transparent"
  pt_color[which(pt_color == "off")] <- "transparent"
  violin_fill[which(violin_fill == "off")] <- "transparent"
  violin_color[which(violin_color == "off")] <- "transparent"
  box_fill[which(box_fill == "off")] <- "transparent"
  box_color[which(box_color == "off")] <- "transparent"
  se_fill[which(se_fill == "off")] <- "transparent"
  ellipse_fill[which(ellipse_fill == "off")] <- "transparent"
  ellipse_color[which(ellipse_color == "off")] <- "transparent"
  if (panel_fill == "off") panel_fill <- "transparent"
  if (!is.null(grid_x_color))
    if (grid_x_color == "off") grid_x_color <- "transparent"
  if (!is.null(grid_y_color))
    if (grid_y_color == "off") grid_y_color <- "transparent"
  if (grid_lwd == "off") grid_lwd <- 0
  if (grid_lty == "off") grid_lty <- "blank"
  if (window_fill == "off") window_fill <- "white"
  if (panel_color == "off") panel_color <- "transparent"
  if (panel_lwd == "off") panel_lwd <- 0
  if (panel_lty == "off") panel_lty <- "blank"
  if (lab_color == "off") lab_color <- "transparent"
  if (main_color == "off") main_color <- "transparent"
  if (!is.null(axis_x_color))
    if (axis_x_color == "off") axis_x_color <- "transparent"
  if (!is.null(axis_y_color))
    if (axis_y_color == "off") axis_y_color <- "transparent"
  if (!is.null(lab_x_color))
    if (lab_x_color == "off") lab_x_color <- "transparent"
  if (!is.null(lab_y_color))
    if (lab_y_color == "off") lab_y_color <- "transparent"
  if (segment_color == "off") segment_color <- "transparent"
  if (ID_color == "off") ID_color <- "transparent"
  if (out_fill == "off") out_fill <- "transparent"
  if (out_color == "off") out_color <- "transparent"
  if (out2_fill == "off") out2_fill <- "transparent"
  if (out2_color == "off") out2_color <- "transparent"
  if (bubble_text_color == "off") bubble_text_color <- "transparent"
  add_color[which(add_color == "off")] <- "transparent"
  add_fill[which(add_fill == "off")] <- "transparent"

  # see if a pre-defined color range, if not return the calling color
  if (length(bar_fill) == 0) bar_fill <- getOption("bar_fill_discrete")
  bar_fill <- .color_range(bar_fill, 24)
  if (length(bar_color) == 0) bar_color <- getOption("bar_color_discrete")
  bar_color <- .color_range(bar_color, 24)
  if (length(pt_fill) == 0) pt_fill <- getOption("pt_fill")
  pt_fill <- .color_range(pt_fill, 24)
  if (length(pt_color) == 0) pt_color <- getOption("pt_color")
  pt_color <- .color_range(pt_color, 24)
  if (length(add_fill) == 0) add_fill <- getOption("add_fill")
  add_fill <- .color_range(add_fill, 24)
  if (length(add_color) == 0) add_color <- getOption("add_color")
  add_color <- .color_range(add_color, 24)

  # default transparency levels
  if (reset) {
    if (!is.null(trans_bar_fill))
      options(trans_bar_fill=trans_bar_fill)
    if (!is.null(trans_pt_fill))
      options(trans_pt_fill=trans_pt_fill)

    if (!is.null(bar_fill)) {
      if (bar_fill[1] == "transparent")
        options(bar_fill = bar_fill)
      else
        options(bar_fill = .maketrans(bar_fill, .to256("trans_bar_fill")))
    }
    if (!is.null(pt_fill)) {
      if (pt_fill[1] == "transparent")
        options(pt_fill = pt_fill)
      else
        options(pt_fill = .maketrans(pt_fill, .to256("trans_pt_fill")))
    }
  }


  # only run if theme is specified, resets all parameters

  # set colors
  if (theme == "colors") {clr1 <- "dodgerblue3"; clr2 <- "steelblue4"}
  if (theme == "lightbronze") {clr1 <- rgb(247,242,230, maxColorValue=255)}
  if (theme == "dodgerblue") {clr1 <- "dodgerblue3"; clr2 <- "steelblue4"}
  if (theme == "darkred") {clr1 <- "darkred"; clr2 <- rgb(80,0,0,
           maxColorValue=256)}
  if (theme == "slatered") {clr1 <- rgb(.64,.34,.39); clr2 <- "darkred"}
  if (theme == "gray") {clr1 <- "gray25"}
  if (theme == "gold") {clr1 <- "goldenrod3"; clr2 <- "goldenrod4"}
  if (theme == "darkgreen") {
    clr1 <- "darkgreen"; clr2 <- rgb(0,80,0,maxColorValue=256)
  }
  if (theme == "blue") {clr1 <- "royalblue1"; clr2 <- "royalblue4"}
  if (theme == "red") {clr1 <- "firebrick3"; clr2 <- "firebrick4"}
  if (theme == "rose") {clr1 <- "rosybrown3"; clr2 <- "rosybrown4"}
  if (theme == "green") {clr1 <- "darkgreen"; clr2 <- "darkseagreen4"}
  if (theme == "purple") {clr1 <- "purple1"; clr2 <- "purple4"}
  if (theme == "sienna") {clr1 <- "sienna3"; clr2 <- "sienna4"}
  if (theme == "brown") {clr1 <- "rosybrown4"; clr2 <- "rosybrown3"}
  if (theme == "orange") {clr1 <- "orange"; clr2 <- "orange3"}
  if (theme == "white") {clr1 <- "white"; clr2 <- "black"}
  if (theme == "light") {clr1 <- "white"; clr2 <- "black"}

  if (!miss_theme) {  # process the theme colors

    # defaults already restored by .onLoad() in the reset block above;
    # empty branch keeps "colors" out of the generic theme block below
    if (theme == "colors") {
    }

    else if (theme == "white") {
      window_fill = "white"
      panel_fill = "white"
      bar_fill = "white"
      bar_fill_cont = "white"
      bar_fill_discrete = "white"
      bar_color_discrete = "black"
      bar_color_cont = "black"
      labels_color = "black"
      pt_fill = "white"
      pt_color = "black"
      bubble_text_color = "black"
      ellipse_fill = .maketrans("gray55", 55)
      ellipse_color = "black"
      fit_color = "gray15"
      violin_fill = "white"
      violin_color = "black"
      box_fill = "white"
      box_color = "black"
      se_fill = .maketrans("gray10", 40)
      grid_color = "gray85"
      out_fill = "black"
      out_color = "black"
      out2_fill = "gray25"
      out2_color = "gray25"
    }

    else if (theme == "gray") {
      window_fill = "white"
      panel_fill = "white"
      bar_fill = .maketrans("gray25", .to256("trans_bar_fill"))
      bar_fill_discrete = .maketrans("gray35",.to256("trans_bar_fill"))
      bar_fill_cont = .maketrans("gray35", .to256("trans_bar_fill"))
      bar_color_discrete = "gray60"
      bar_color_cont = "gray60"
      pt_fill = "gray42"
      trans_pt_fill = 0.10
      pt_color = "gray42"
      violin_fill=.maketrans("gray50", 40)
      violin_color = "gray15"
      box_fill="gray65"
      box_color = "gray15"
      ellipse_fill = .maketrans("gray35", 15)
      fit_color = "black"
      se_fill = .maketrans("gray10", 40)
      segment_color = "gray20"
      grid_color = "gray85"
      ID_color = "black"
      out_fill = "black"
      out_color = "black"
      out2_fill = "black"
      out2_color = "black"
    }

    else if (theme == "lightbronze") {
      window_fill = rgb(247,242,230, maxColorValue=255)
      panel_fill = rgb(247,242,230, maxColorValue=255)
      #panel_fill = "transparent"
      panel_color = rgb(222,217,205, maxColorValue=255)
      #bar_fill = .maketrans("gray50", .to256("trans_bar_fill")))  # 230
      bar_fill = rgb(123,140,150, maxColorValue=255)
      bar_fill_cont = rgb(123,140,150, maxColorValue=255)
      bar_fill_discrete = rgb(123,140,150, maxColorValue=255)
      bar_color_discrete = "transparent"
      bar_color_cont = rgb(126,144,168, maxColorValue=255)
      pt_fill = rgb(70,80,90, maxColorValue=255)
      trans_pt_fill = 0.10
      pt_color = rgb(70,80,90, maxColorValue=255)
      se_fill = .maketrans("gray10", 40)
      violin_fill = "#7485975A"
#     violin_fill = rgb(144,165,175, maxColorValue=255)
      violin_color = "gray15"
      box_fill = .maketrans("gray15", 170)
      box_color = "gray15"
      ellipse_fill = .maketrans("gray50", 50)
      strip_fill = .maketrans("gray55", 50)
      fit_color = "gray15"
      main_color = "gray15"
      lab_color = "gray15"
      axis_color = "gray15"
      axis_text_color = "gray15"
      segment_color = "gray50"
      strip_color = "gray55"
      strip_text_color = "gray15"
      ellipse_color = "gray15"
      bubble_text_color = rgb(247,242,230, maxColorValue=255)
      grid_color = rgb(222,217,205, maxColorValue=255)
      ID_color = "gray15"
      trans_bar_fill = 0
      trans_pt_fill = 0
    }

    else if (theme == "light") {
      se_fill = rgb(229,229,248,170,maxColorValue=255)
      ellipse_color = rgb(103,103,176,maxColorValue=255)
      ellipse_fill = "transparent"
      out_fill = rgb(193,36,36,maxColorValue=255)
      out_color = rgb(193,36,36,maxColorValue=255)
      pt_fill = rgb(60,170,225,maxColorValue=255)
      pt_color = rgb(70,78,161,maxColorValue=255)
      grid_color = rgb(229,229,248,150,maxColorValue=255)
      fit_color = "gray50"
    }

    else {  # process the other theme colors

      window_fill = "white"
      panel_fill = "grey99"
      bar_fill = .maketrans(clr1, .to256("trans_bar_fill"))
      violin_fill = "#7485975A"
#     violin_fill = .maketrans(clr1, 30)
      violin_color = "gray15"
      box_fill = .maketrans(clr1, 160)  # larger number, more opaque
#     box_fill = .maketrans(clr1, 65)
      box_color = "gray15"
      bar_fill_discrete = .maketrans(clr1, .to256("trans_bar_fill"))
      bar_fill_cont = .maketrans(clr1, .to256("trans_bar_fill"))
      bar_color_discrete = clr2
      bar_color_cont = clr2
      pt_fill <- clr1
      pt_color = clr2
      se_fill = .maketrans(clr1, 40)
      ellipse_fill = .maketrans(clr1, 15)
      if (ellipse_color[1] != "transparent")
        ellipse_color = .maketrans(clr1, 200)
      segment_color = clr1
      bubble_text_color = "black"
      strip_fill = .maketrans(clr1, 55)
      strip_color = clr2
      strip_text_color = clr2
      ID_color = "gray50"
    }
  }  # not miss theme


  # sub_theme
  if (!miss_sub_theme) {

    if (sub_theme == "default") {
      panel_fill = "grey95"
      if (theme == "white") panel_fill = "white"
      window_fill = "white"
      grid_x_color = "white"
      grid_y_color = "white"
      lab_color = "black"
      main_color = "black"
    }

    else if (sub_theme == "wsj")  {
      if (!(theme %in% c("gray", "white"))) {
        window_fill = rgb(247,242,230, maxColorValue=255)
        panel_fill = rgb(247,242,230, maxColorValue=255)
      }
      else {
        window_fill = "gray93"
        panel_fill = "gray93"
      }
  #   window_fill = getOption("panel_fill")
      panel_color = "transparent"
      axis_y_color = "transparent"
      gxs <- if (getOption("window_fill") == "#040404") "white" else "#040404"
      grid_y_color = gxs
      grid_x_color = "transparent"
      grid_lty = "dotted"
      grid_lwd = 1
    }

    else if (theme == "gray"  &&  sub_theme == "black") {
      window_fill = "gray10"
      panel_fill = "gray10"
      panel_color = "gray80"
      trans_bar_fill = 0.0
      trans_pt_fill = 0.1
      bar_fill = .maketrans("gray58", .to256("trans_bar_fill"))
      bar_fill_discrete =
        .maketrans("gray58", .to256("trans_bar_fill"))
      bar_fill_cont =
        .maketrans("gray58", .to256("trans_bar_fill"))
      bar_color_discrete = "gray20"
      bar_color_cont = "gray20"
      pt_fill = .maketrans("gray75", .to256("trans_pt_fill"))
      pt_color = "gray90"
      violin_fill = "gray80"
      violin_color = "gray15"
      box_fill = .maketrans("gray15", 180)
      box_color = "gray15"
      ellipse_fill = .maketrans("gray55", 65)
      fit_color = "gray75"
      se_fill = .maketrans("gray55", 65)
      ID_color = "gray90"
      strip_color = .maketrans(clr1, .to256n(0.40))
      strip_text_color = "gray85"
      segment_color = "gray65"
      lab_color = "gray85"
      main_color = "gray85"
      axis_color = "gray85"
      axis_x_color = "gray85"
      axis_y_color = "gray85"
      axis_text_color = "gray85"
      grid_color = "gray25"
      add_color = "gray55"
      labels_color = "gray85"
    }

    else if (sub_theme == "black") {

      window_fill = rgb(.015,.015,.015)
      panel_fill = rgb(.015,.015,.015)
      violin_fill = "gray80"
      violin_color = "gray15"
      grid_color = "gray35"
      ID_color = "white"
      panel_color = "gray80"
      segment_color = "gray65"
      lab_color = "gray85"
      main_color = "gray85"
      axis_x_color = "gray85"
      axis_y_color = "gray85"
      axis_text_color = "gray85"
      add_color = "gray55"
      labels_color = "gray85"
      strip_text_color = "white"
      fit_color <- if (theme == "light") "gray40" else "gray75"

      if (theme == "colors") {
        ellipse_color <- "gray75"
        se_fill <- rgb(240,240,240, alpha=45, maxColorValue=256)
        pt_fill <- "royalblue1"
        pt_color <- "royalblue1"
      }

      strip_color = .maketrans(clr1, .to256n(0.40))
      strip_text_color = "gray65"
      if (theme == "orange") {
        if (miss_tr.bar_fill) trans_bar_fill = .05
        bar_fill_discrete = rgb(139,69,0, alpha=.to256("trans_bar_fill"),
              maxColorValue=256)
        bar_fill_cont = rgb(139,69,0, alpha=.to256("trans_bar_fill"),
              maxColorValue=256)
        pt_fill = rgb(139,69,0, alpha=.to256("trans_pt_fill"),
              maxColorValue=256)
        bar_color_discrete = "orange4"
        bar_color_cont = "orange4"
        pt_color = rgb(139,69,0, maxColorValue=256)
        ellipse_fill = rgb(249,99,2, alpha=45, maxColorValue=256)
#       fit_color = rgb(209,87,3, maxColorValue=256)
        segment_color = rgb(249,99,2, maxColorValue=256)
        ID_color = "orange4"
      }
    }

  }  # end not miss sub_theme

  if (show) {
    .style.show()
  }


  # set the options
  if (reset) {

    options(theme = theme)
    options(sub_theme = sub_theme)

    options(bar_fill = bar_fill)
    options(bar_fill_discrete = bar_fill_discrete)
    options(bar_fill_cont = bar_fill_cont)
    options(bar_color = bar_color)
    options(bar_color_discrete = bar_color_discrete)
    options(bar_color_cont = bar_color_cont)
    options(pt_fill = pt_fill)
    options(pt_color = pt_color)
    options(trans_bar_fill = trans_bar_fill)
    options(trans_pt_fill = trans_pt_fill)

    options(labels=labels)
    options(labels_color=labels_color)
    options(labels_size=labels_size)
    options(labels_digits=labels_digits)
    options(labels_position=labels_position)

    options(window_fill=window_fill)
    options(panel_fill=panel_fill)
    options(panel_color=panel_color)
    options(panel_lwd=panel_lwd)
    options(panel_lty=panel_lty)

    options(violin_fill=violin_fill)
    options(violin_color=violin_color)
    options(box_fill=box_fill)
    options(box_color=box_color)
    options(ellipse_fill=ellipse_fill)
    options(ellipse_color=ellipse_color)
    options(ellipse_lwd=ellipse_lwd)
    options(fit_color=fit_color)
    options(fit_lwd=fit_lwd)
    options(se_fill=se_fill)
    options(segment_color=segment_color)
    options(ID_color=ID_color)
    options(out_fill=out_fill)
    options(out_color=out_color)
    options(out2_fill=out2_fill)
    options(out2_color=out2_color)
    options(bubble_text_color=bubble_text_color)

    options(grid_color=grid_color)
    options(grid_x_color=grid_x_color)
    options(grid_y_color=grid_y_color)
    options(grid_lwd=grid_lwd)
    options(grid_x_lwd=grid_x_lwd)
    options(grid_y_lwd=grid_y_lwd)
    options(grid_lty=grid_lty)
    options(grid_x_lty=grid_x_lty)
    options(grid_y_lty=grid_y_lty)

    options(lab_color=lab_color)
    options(lab_x_color=lab_x_color)
    options(lab_y_color=lab_y_color)
    options(lab_size=lab_size)
    options(lab_x_size=lab_x_size)
    options(lab_y_size=lab_y_size)
    options(main_color=main_color)
    options(main_size=main_size)
    options(axis_color=axis_color)
    options(axis_x_color=axis_x_color)
    options(axis_y_color=axis_y_color)
    options(axis_lwd=axis_lwd)
    options(axis_x_lwd=axis_x_lwd)
    options(axis_y_lwd=axis_y_lwd)
    options(axis_lty=axis_lty)
    options(axis_x_lty=axis_x_lty)
    options(axis_y_lty=axis_y_lty)

    options(axis_size=axis_size)
    options(axis_x_size=axis_x_size)
    options(axis_y_size=axis_y_size)
    options(axis_text_color=axis_text_color)
    options(axis_x_text_color=axis_x_text_color)
    options(axis_y_text_color=axis_y_text_color)
    options(rotate_x=rotate_x)
    options(rotate_y=rotate_y)
    options(offset=offset)

    options(add_fill=add_fill)
    options(add_trans=add_trans)
    options(add_size=add_size)
    options(add_lwd=add_lwd)
    options(add_lty=add_lty)
    options(add_color=add_color)

    options(strip_fill=strip_fill)
    options(strip_color=strip_color)
    options(strip_text_color=strip_text_color)

    options(quiet=if (quiet_specified) quiet else quiet_prior)
    options(brief=if (brief_specified) brief else brief_prior)
    options(lessR.use_plotly=lessR.use_plotly)
    options(n_cat=n_cat)
    options(suggest=if (suggest_specified) suggest else suggest_prior)
    options(notes=if (notes_specified) notes else notes_prior)
    options(width=width)

    options(results=results)
    options(explain=explain)
    options(interpret=interpret)
    options(document=document)
    options(code=code)
  }

  # ---------------------------------------
  # create list of current parameter values
  # create sub-lists

  panel <- list(
    fill = panel_fill,
    color = panel_color,
    lwd = panel_lwd,
    lty = panel_lty
  )


  bar <- list(
    fill = bar_fill,
    bar_fill_discrete = bar_fill_discrete,
    bar_fill_cont = bar_fill_cont,
    trans_fill = trans_bar_fill,
    color = bar_color,
    bar_color_cont = bar_color_cont,
    labels = labels,
    labels_color = labels_color,
    labels_size = labels_size,
    labels_digits = labels_digits,
    labels_position = labels_position
  )

  pt <- list(
    fill = pt_fill,
    trans_fill = trans_pt_fill,
    color = pt_color,
    out_fill=out_fill,
    out_color=out_color,
    out2_fill=out2_fill,
    out2_color=out2_color
  )

  VBS <- list(
    violin_fill = violin_fill,
    violin_color = violin_color,
    box_fill = box_fill,
    box_color = box_color
  )

  ellipse <- list(
    fill = ellipse_fill,
    color = ellipse_color,
    lwd = ellipse_lwd
  )

  axis <- list(
    color = axis_color,
    lwd = axis_lwd,
    lty = axis_lty,
    cex = axis_size,
    text_color = axis_text_color
  )
  axis_x <- list(
    color = axis_x_color,
    lwd = axis_x_lwd,
    lty = axis_x_lty,
    cex = axis_x_size,
    text_color = axis_x_text_color
  )
  axis_y <- list(
    color = axis_y_color,
    lwd = axis_y_lwd,
    lty = axis_y_lty,
    cex = axis_y_size,
    text_color = axis_y_text_color
  )

  rotate <- list(
    x = rotate_x,
    y = rotate_y,
    offset = offset
  )

  lab <- list(
    color = lab_color,
    cex = lab_size
  )
  lab_x <- list(
    color = lab_x_color,
    cex = lab_x_size
  )
  lab_y <- list(
    color = lab_y_color,
    cex = lab_y_size
  )

  main <- list(
    color = main_color,
    cex = main_size
  )

  grid <- list(
    color = grid_color,
    lwd = grid_lwd,
    lty = grid_lty
  )
  grid_x <- list(
    color = grid_x_color,
    lwd = grid_x_lwd,
    lty = grid_x_lty
  )
  grid_y <- list(
    color = grid_y_color,
    lwd = grid_y_lwd,
    lty = grid_y_lty
  )

  strip <- list(
    fill = strip_fill,
    color = strip_color,
    text_color = strip_text_color
  )

  add <- list(
    fill = add_fill,
    trans = add_trans,
    color = add_color,
    cex = add_size,
    lwd = add_lwd,
    lty = add_lty
  )

  output <- list(
    results = results,
    explain = explain,
    interpret = interpret,
    document = document,
    code = code
  )


  # create main list
  gp <- list(
    theme = theme,
    sub_theme = getOption("sub_theme"),

    window_fill = getOption("window_fill"),
    panel = panel,

    bar = bar,
    pt = pt,

    VBS = VBS,
    ellipse = ellipse,

    fit_color = getOption("fit_color"),
    fit_lwd = getOption("fit_lwd"),
    se_fill = se_fill,
    bubble_text_color = getOption("bubble_text_color"),
    segment_color = getOption("segment_color"),
    ID_color=getOption("ID_color"),

    axis = axis,
    axis_x = axis_x,
    axis_y = axis_y,
    rotate = rotate,

    lab = lab,
    lab_x = lab_x,
    lab_y = lab_y,
    main = main,

    grid = grid,
    grid_x = grid_x,
    grid_y = grid_y,

    strip = strip,

    add = add,

    n_cat = getOption("n_cat"),
    suggest = getOption("suggest"),
    notes = getOption("notes"),
    quiet = getOption("quiet"),
    brief = getOption("brief"),
    lessR.use_plotly = getOption("lessR.use_plotly"),

    output = output

  )

  return(invisible(gp))

}

.ttp2graph <-
function(myxlab, mytitle, n, s, mdp, mmd, msmd, mytype, H0, ...) {
  
  # configure range of deltas (need n)
  pp <- power.t.test(n=n, sd=s, power=.9999, type=mytype)
  if (!is.null(mmd)) { 
    xmax <- max(pp$delta,mmd)
    xmin <- min(-pp$delta,-mmd)
  }
  else {
    xmax <- pp$delta
    xmin <- -pp$delta
  }
  mydeltas <- seq(xmin,xmax,length=100)
  xmax <- H0 + xmax
  xmin <- H0 + xmin 
  rm(pp)

  # power curve
  mypower <- power.t.test(n=n, sd=s, delta=mydeltas, type=mytype)
  x.values <- H0+mydeltas
  y.values <- mypower$power

  plot(x.values, y.values, type="n", axes=FALSE, ann=FALSE, ylim=c(0,1.1))

  usr <- par("usr")
  rect(usr[1], usr[3], usr[2], usr[4],
       col=getOption("panel_fill"), border=getOption("panel_color"))

  abline(v=axTicks(1), col=getOption("grid_x_color"),
         lwd=getOption("grid_lwd"), lty=getOption("grid_lty"))
  abline(h=axTicks(2), col=getOption("grid_y_color"),
         lwd=getOption("grid_lwd"), lty=getOption("grid_lty"))

  .axes(NULL, NULL, axTicks(1), axTicks(2), col.axis="gray30")

  main.lab <- NULL
  sub.lab <- NULL
  x.label <- myxlab
  y.label <- "Power"
  .axlabs(x.label, y.label, main.lab, sub.lab, cex.lab=0.85) 

  col_fill <- getOption("pt_fill")
  col_color <- getOption("pt_color")
  lines(x.values, y.values, col=col_color, lwd=1.5)

  abline(h=0, lwd=.5, col="gray50")
  # custom title (2 lines)
  mtext(mytitle, side=3, line=2.5, cex=1.0, font=2)
  if (abs(n - round(n)) > 0.000001)
    dgt.n <- 3
  else  # n is an integer
    dgt.n <- 0
  mtext(paste("n=", .fmt(n,dgt.n), ", s=", .fmt(s,4), sep=""),
               side=3, line=1, font=3, cex=0.9)

  # delta for a power of mdp, default is 0.8
  clr <- getOption("theme")
  if (clr != "gray") col80 <- "firebrick4" else col80 <- "gray20"
  if (mdp != 0) {
    pp <- power.t.test(n=n, sd=s, power=mdp, type=mytype)
    del.hi <- H0 + pp$delta
    del.lo <- H0 - pp$delta
    lines(c(del.hi, del.hi), c(0,mdp), lwd=.5, col=col80)
    arrows(del.hi, mdp, xmax, mdp, lwd=.5, col=col80, length=.15, angle=20)
    lines(c(del.lo, del.lo), c(0,mdp), lwd=.5, col=col80)
    arrows(del.lo, mdp, xmin, mdp, lwd=.5, col=col80, length=.15, angle=20)
    text(del.hi, mdp+.033, labels="    Powerful", col=col80, cex=.85, adj=0)
    text(del.lo, mdp+.033, labels="Powerful    ", col=col80, cex=.85, adj=1)
  
  del.diff <- del.hi - H0
  if (mytype == "two.sample") lbl <- "\nMean difference "
  if (mytype == "one.sample") lbl <- "\nDifference of mu from mu0 "
  cat(lbl, "to achieve power of ", mdp, ": Diff = ", .fmt(del.diff,3), 
      sep="", "\n\n")
  rm(pp)
  .dash(70)
  }
  
  # for when the minimum meaningful difference, mmd, is provided
  if (!is.null(mmd)) {
    if (mytype == "two.sample") lbl <- "the two means"
    if (mytype == "one.sample") lbl <- "mu and mu0"
    cat("Minimum meaningful difference of ", lbl, ": mmd\n", sep="")
    .dash(70)
    
    if (!is.null(msmd))
      cat("Provided standardized value is msmd = ", msmd, "\n")
  
    if (clr != "gray") {
      colmmd <- rgb(112,128,144,40, maxColorValue=255)  # slategray base
      colbrd <- rgb(112,128,144,80, maxColorValue=255)
      coltrv <- rgb(97,129,129, maxColorValue=255)  # darkslategray
    }
    else {
      colmmd <- rgb(128,128,128,60, maxColorValue=255) 
      colbrd <- rgb(128,128,128,80, maxColorValue=255) 
      coltrv <- rgb(115,115,115, maxColorValue=255)
    }    

    # power for mmd
    d.hi <- H0 + mmd
    d.lo <- H0 - mmd
    pp <- power.t.test(n=n, sd=s, delta=mmd, type=mytype)
    rect(d.lo, 0, d.hi, pp$power, lwd=.25, col=colmmd, density=-10, border=colbrd)
    lines(c(d.hi, d.hi), c(0, 1.05), lwd=.5, col=coltrv, lty="longdash")
    lines(c(d.lo, d.lo), c(0, 1.05), lwd=.5, col=coltrv, lty="longdash")
    if (d.hi < xmax) {
      arrows(d.hi, 1.05, xmax, 1.05, lwd=.5, col=coltrv, length=.15, angle=20, lty=5)
      arrows(d.lo, 1.05, xmin, 1.05, lwd=.5, col=coltrv, length=.15, angle=20, lty=5)
    }
    text(d.hi, 1.08, labels="    Meaningful", col=coltrv, cex=.85, adj=0)
    text(H0, 1.02, labels="Trivial", col=coltrv, cex=.85)
    text(d.lo, 1.08, labels="Meaningful    ", col=coltrv, cex=.85, adj=1)
    
    p.out <- round(pp$power,3)
    txt <- ", for mmd of "
    if (mytype == "two.sample") 
      lbl <- paste("Given n = ", round(n,3), " and sw = ", .fmt(s,4), txt, sep="")
    if (mytype == "one.sample")
      lbl <- paste("Given n = ", n, " and s = ", .fmt(s,4), txt, sep="")
    cat(lbl, mmd, ": Power = ", p.out, sep="", "\n")
    if (mdp != 0) {
      if (del.hi > mmd+H0) {
        .dash(70)
        lbl <- ">>> Note: Meaningful differences, from "
        cat(lbl, d.hi, " to ", .fmt(del.hi,3), ", have Power < ", mdp, "\n",
            sep="")
      }
      else {
        .dash(70)
        lbl <- ">>> Note: Trivial differences, from "
        cat(lbl, .fmt(del.hi,3), " to ", mmd+H0, ", have Power > ", mdp,
            ".\n", sep="")
        cat(">>> Note: All meaningful differences have Power > ", mdp, "\n", sep="")
      }
      .dash(70)
      rm(pp)
    
      # n needed to achieve a power of mdp=0.8 for mmd
      pp <- power.t.test(sd=s, delta=mmd, power=mdp, type=mytype)
      n.out <- ceiling(pp$n)
      txt <- ", needed n to achieve power= "
      if (mytype == "two.sample") lbl <- paste("Given sw = ", .fmt(s,4), txt,
          sep="")
      if (mytype == "one.sample") lbl <- paste("Given s = ", .fmt(s,4), txt, sep="")
      cat(lbl, mdp, " for mmd of ", mmd, ": n = ", n.out, sep="", "\n")
      if (mytype == "two.sample") cat("Sample size n applies to *each* group", "\n")
      rm(pp)
    }
    
    .dash(70)

  }

}

# need d as global because data=d in function def does not
#  have a value assigned to d, d <- mydata does do that, even if conditional
#  generates a Note
if (getRversion() >= "3.6.0")
  globalVariables(c("d", "mydata", "l", "mylabels", "mycor"))

## zzz.R  — lessR startup ----------------------------------------------------


.onAttach <- function(libname, pkgname) {
  packageStartupMessage(
    "\n",
    "lessR 4.5.6                          feedback: gerbing@pdx.edu \n",
    "--------------------------------------------------------------\n",
    "> d <- Read(\"\")  Read data file, many formats available, e.g., Excel\n",
    "  d is the default data frame, data= in analysis routines optional\n",
    "\n",
    "Find examples of reading, writing, and manipulating data, graphics,\n",
    "testing means and proportions, regression, factor analysis,\n",
    "customization, forecasting, and aggregation to pivot tables.\n",
    "  Enter: browseVignettes(\"lessR\")\n",
    "\n",
    "Although most previous function calls still work, most\n",
    "visualization functions are now reorganized to three functions:\n",
    paste0(
      "   Chart(): form = \"bar\", \"pie\", \"radar\", \"bubble\", \"dot\",\n",
      "                   \"sunburst\", \"treemap\", \"icicle\"\n"
    ),
    "   X(): form=\"histogram\", \"density\", \"vbs\", and more\n",
    paste0(
      "   XY(): form=\"scatter\", \"contour\", \"smooth\", \"hexbin\"\n"
    ),
    "There is also Flows() for Sankey flow diagrams.\n",
    "\n",
    "View lessR updates, now including modern time series forecasting.\n",
    "  Enter: news(package=\"lessR\"), or ?Chart, ?X, or ?XY\n",
    "\n",
    "Interactive data analysis for constructing visualizations.\n",
    "  Enter: interact()\n"
  )
}


.onLoad <- function(libname, pkgname) {

  if (requireNamespace("conflicted", quietly = TRUE)) {
    conflicted::conflict_prefer("style",    "lessR", quiet=TRUE)
    conflicted::conflict_prefer("STL",      "lessR", quiet=TRUE)
    conflicted::conflict_prefer("order_by", "lessR", quiet=TRUE)
    conflicted::conflict_prefer("recode",   "lessR", quiet=TRUE)
    conflicted::conflict_prefer("rename",   "lessR", quiet=TRUE)
  }

  options(theme    = "colors")
  options(sub_theme = "default")

  options(panel_fill  = "white")
  options(window_fill = getOption("panel_fill"))
  options(panel_color = "gray45")
  options(panel_lwd   = 1.0)
  options(panel_lty   = "solid")

  options(bar_fill = NULL)
  options(bar_fill_discrete =
    c("#4398D0","#B28B2A","#5FA140","#D57388","#9A84D6","#00A898",
      "#C97E5B","#909711","#00A3BA","#D26FAF","#00A76F","#BD76CB"))
  options(bar_fill_cont      = rgb(150,170,195, maxColorValue=255))
  options(trans_bar_fill     = 0.10)
  options(bar_color          = rgb(132,150,175, maxColorValue=255))
  options(bar_color_discrete = "transparent")
  options(bar_color_cont     = rgb(132,150,175, maxColorValue=255))

  options(pt_fill       = rgb(50,78,92, maxColorValue=255))
  options(trans_pt_fill = 0.10)
  options(pt_color      = rgb(50,78,92, maxColorValue=255))

  options(out_fill   = "firebrick4")
  options(out_color  = "firebrick4")
  options(out2_fill  = "firebrick2")
  options(out2_color = "firebrick2")

  options(violin_fill  = "#7485975A")
  options(violin_color = "gray15")
  options(box_fill     = rgb(65,155,210, maxColorValue=255))
  options(box_color    = "gray15")
  options(line_color   = "gray15")

  options(bubble_text_color = "#F7F2E6")
  options(ellipse_fill      = "#92806F28")
  options(ellipse_color     = "gray20")
  options(ellipse_lwd       = 1)

  options(se_fill   = "#1A1A1A19")
  options(fit_color = rgb(92,64,50, maxColorValue=255))
  options(fit_lwd   = 2)

  options(heat          = "gray30")
  options(segment_color = "gray40")
  options(ID_color      = "gray50")

  options(main_color = "gray15")
  options(main_size   = 1.16)
  options(lab_color  = "gray15")  # axis titles
  options(lab_x_color = NULL)
  options(lab_y_color = NULL)
  options(lab_size     = 1.05)
  options(lab_x_size   = NULL)
  options(lab_y_size   = NULL)

  options(axis_color   = "gray15")  # tick labels
  options(axis_x_color = NULL)
  options(axis_y_color = NULL)
  options(axis_lwd     = 1)
  options(axis_x_lwd   = NULL)
  options(axis_y_lwd   = NULL)
  options(axis_lty     = "solid")
  options(axis_x_lty   = NULL)
  options(axis_y_lty   = NULL)
  options(axis_size     = 0.80)
  options(axis_x_size   = NULL)
  options(axis_y_size   = NULL)
  options(axis_text_color   = "gray20")
  options(axis_x_text_color = NULL)
  options(axis_y_text_color = NULL)
  options(rotate_x = 0)
  options(rotate_y = 0)
  options(offset   = 0.5)

  options(grid_color   = "gray85")
  options(grid_x_color = NULL)
  options(grid_y_color = NULL)
  options(grid_lwd     = 0.5)
  options(grid_x_lwd   = NULL)
  options(grid_y_lwd   = NULL)
  options(grid_lty     = "solid")
  options(grid_x_lty   = NULL)
  options(grid_y_lty   = NULL)

  options(strip_fill       = "#7F7F7F37")
  options(strip_color      = "gray40")
  options(strip_text_color = "gray15")

  options(add_fill  = "#D9D9D920")
  options(add_trans = 0.0)
  options(add_color = "gray10")
  options(add_size   = 1.00)
  options(add_lwd   = 0.5)
  options(add_lty   = "solid")

  options(n_cat   = 1)
  options(suggest = TRUE)
  options(note    = TRUE)
  options(quiet   = FALSE)
  options(brief   = FALSE)

  options(lessR.use_plotly = TRUE)
  options(explain   = TRUE)
  options(interpret = TRUE)
  options(results   = TRUE)
  options(document  = TRUE)
  options(code      = TRUE)

  options(out.signifstars = FALSE)
  options(scipen          = 30)

  options(mc_doScale_quiet = TRUE)
}

# ---- Drop casewise missing across x, y, by, facet -----------------------
# Called from: Chart.R

.drop_casewise_missing <- function(x.call = NULL,
                                   y.call = NULL,
                                   by.call = NULL,
                                   facet.call = NULL) {
  # Build a combined data.frame of all columns we care about
  blocks <- list()

  if (!is.null(x.call)) {
    # vector, matrix, or data.frame
    x_df <- as.data.frame(x.call)
    blocks[["x"]] <- x_df
  }

  if (!is.null(y.call)) {
    blocks[["y"]] <- data.frame(..y = y.call)
  }

  if (!is.null(by.call)) {
    # vector, matrix, or data.frame (incl. cbind(Gender, Plan))
    by_df <- as.data.frame(by.call)
    blocks[["by"]] <- by_df
  }

  if (!is.null(facet.call)) {
    # vector, matrix, or data.frame (incl. two facet vars)
    facet_df <- as.data.frame(facet.call)
    blocks[["facet"]] <- facet_df
  }

  if (!length(blocks)) return(NULL)

  df <- do.call(cbind, blocks)
  stats::complete.cases(df)
}



# ===== Chart() plotly sub-functions (moved from zzz_plotly.R) =====


# Helper: build plotly chart title from main/main.miss + variable names
# Returns: character string (auto-built), user-supplied string, or NULL
.build_chart_title <- function(main, main.miss, x_name=NULL, by_name=NULL,
                                facet_name=NULL, y_name=NULL, stat=NULL) {

  if (!is.null(y_name) && y_name == "Count") y_name <- NULL

  if (!main.miss && !is.null(main))
    main[1]                          # user supplied a title
  else if (main.miss)
    .plotly_build_title(             # auto-build from variable names
      x_name     = x_name,
      by_name    = by_name,
      facet_name = facet_name,
      y_name     = y_name,
      stat       = stat
    )
  else
    NULL                             # main=NULL explicitly supplied — no title
}


# Helper: reshape Chart()'s tidy (x.call, y.call, by.call) into the table
# shape piechart.plotly / bubble.plotly want to render. Returns:
#   - 1-D named numeric vector (no by.call)
#   - 2-D matrix with dimnames list(by=, x=) (by.call supplied)
.build_plotly_tbl <- function(x.call, y.call, by.call) {

  if (is.null(y.call)) {
    # counts — tabulate row occurrences
    if (is.null(by.call))
      return(xtabs(~ x.call, drop.unused.levels = FALSE))
    else
      return(xtabs(~ by.call + x.call, drop.unused.levels = FALSE))
  }

  # y already aggregated to one value per (by, x) cell — just reshape
  if (is.null(by.call)) {
    return(setNames(as.numeric(y.call), as.character(x.call)))
  }
  by.fac <- if (is.factor(by.call)) droplevels(by.call)
            else factor(by.call, levels = unique(by.call))
  x_fac  <- if (is.factor(x.call))  droplevels(x.call)
            else factor(x.call, levels = unique(x.call))
  tbl    <- xtabs(as.numeric(y.call) ~ by.fac + x_fac,
                  drop.unused.levels = TRUE)
  dimnames(tbl) <- list(by = levels(by.fac), x = levels(x_fac))
  tbl
}


.build_xtab <- function(x, y = NULL, by = NULL, facet = NULL,
                        stat = NULL, is.agg = FALSE, digits_d = 2) {
  # construct summary table x.tbl from x, optional by / facet and optional y

  # resolve stat function
  STAT <- tolower(stat %||% "sum")
  stat_fun <- switch(
    STAT,
    mean   = function(z) mean(z,          na.rm = TRUE),
    sum    = function(z) sum(z,           na.rm = TRUE),
    median = function(z) stats::median(z, na.rm = TRUE),
    min    = function(z) min(z,           na.rm = TRUE),
    max    = function(z) max(z,           na.rm = TRUE),
    sd     = function(z) stats::sd(z,     na.rm = TRUE),
    stop("Unsupported stat: '", stat, "'. Use mean, sum, median, min, max, or sd.")
  )

  ## helper: coerce a generic grouping object (vector, matrix, data.frame, list)
  ## into a data.frame with at least one column, or NULL
  to_group_df <- function(obj, prefix = "g") {
    if (is.null(obj)) return(NULL)

    if (is.data.frame(obj))
      df <- obj
    else if (is.matrix(obj))
      df <- as.data.frame(obj)
    else if (is.list(obj) && !is.atomic(obj)) # list of equal-length vectors
      df <- as.data.frame(obj)
    else   # single vector
      df <- data.frame(obj)

    if (is.null(colnames(df)))
      colnames(df) <- paste0(prefix, seq_len(ncol(df)))

    df
  }  # end to_group_df()

  ## ------------------------------------------------------------
  ## 1) RAW DATA: build table from x / y / groupings
  ## ------------------------------------------------------------
  if (!is.agg) {

    by_df    <- to_group_df(by,    prefix = "by")
    facet_df <- to_group_df(facet, prefix = "facet")

    # combine all grouping columns (by + facet); may be NULL
    if (is.null(by_df) && is.null(facet_df))
      group_df <- NULL
    else if (is.null(by_df))
      group_df <- facet_df
    else if (is.null(facet_df))
      group_df <- by_df
    else
      group_df <- cbind(by_df, facet_df)

    if (is.null(y)) {  # counts
      if (is.null(group_df)) {
        # simple one-way table of x
        x.tbl <- xtabs(~ x, drop.unused.levels = FALSE)
      }
      else {
        # multi-way table over all grouping columns + x
        df <- data.frame(group_df, x = x)
        form <- reformulate(c(names(group_df), "x"))
        x.tbl <- xtabs(form, data = df, drop.unused.levels = FALSE)
      }

    }
    else {  # numeric summary
      if (is.null(group_df)) {  # numeric y summarized by x only
        agg <- tapply(as.numeric(y), x, stat_fun)
        x.tbl <- agg[!is.na(names(agg))]
      } else {
        df   <- data.frame(group_df, x = x, y = as.numeric(y))
        grps <- c(lapply(names(group_df), function(nm) df[[nm]]), list(x = df$x))
        agg  <- tapply(df$y, grps, stat_fun)
        if (identical(STAT, "sum")) agg[is.na(agg)] <- 0
        x.tbl <- agg
      }
    }
  }  # end !is.agg

  else {
    ## ------------------------------------------------------------
    ## 2) ALREADY AGGREGATED DATA: treat x as table / vector
    ## ------------------------------------------------------------
    if (is.null(y)) {
      # x is (or should be) already in table-like form
      if (is.table(x))
        x.tbl <- x
      else
        x.tbl <- as.table(x)
    }
    else {
      # aggregated y supplied explicitly; restore to table form
      # here we assume caller has already shaped x/y/by/facet as needed
      by_df    <- to_group_df(by,    prefix = "by")
      facet_df <- to_group_df(facet, prefix = "facet")

      if (is.null(by_df) && is.null(facet_df)) {
        agg <- tapply(as.numeric(y), x, stat_fun)
        x.tbl <- agg[!is.na(names(agg))]
      }
      else {
        if (is.null(by_df) && !is.null(facet_df)) {
          group_df <- facet_df
        }
        else if (!is.null(by_df) && is.null(facet_df)) {
          group_df <- by_df
        }
        else
          group_df <- cbind(by_df, facet_df)
        df <- data.frame(group_df, x = x, y = y)
        form <- reformulate(c(names(group_df), "x"), response = "y")
        x.tbl <- xtabs(form, data = df, drop.unused.levels = FALSE)
      }
    }
  }

  x.tbl
}


# ----- dot-plot origin/gridT chooser ------------------------------------
# Choose a chart-friendly origin and pretty tick positions for a dot plot's
# value axis. Returns list(origin=., gridT=.). Called once by Chart() per
# dot-plot call; dot.plotly() then renders against the supplied values.
#
# vals      : numeric vector of plotted values (NAs allowed; ignored)
# origin_in : user-supplied origin (NULL = auto-choose)
# is_counts : TRUE forces count-style behavior (origin defaults to 0,
#             no nudge-below-first-tick); NULL = infer from vals (TRUE
#             when all finite values are non-negative integers)
.dot_origin_grid <- function(vals, origin_in = NULL, is_counts = NULL) {
  fv <- vals[is.finite(vals)]

  if (length(fv) == 0L) {
    return(list(
      origin = if (is.null(origin_in)) 0 else origin_in,
      gridT  = pretty(c(0, 1))
    ))
  }

  if (is.null(is_counts))
    is_counts <- all(fv >= 0) && all(fv == floor(fv))

  origin <- origin_in
  if (is.null(origin)) {
    if (is_counts) {
      origin <- 0
    } else {
      fv2  <- if (all(fv < 0)) -fv else fv
      mn.v <- min(fv2); mx.v <- max(fv2)
      if (mn.v > 0 && (mx.v - mn.v) / mn.v <= 2.40)
        origin <- mn.v
    }
  }
  gridT <- pretty(c(if (!is.null(origin)) origin else min(fv), fv))
  # nudge one step below first tick for continuous data, not counts
  if (is.null(origin_in) && !is_counts && length(gridT) > 1L) {
    step   <- gridT[2L] - gridT[1L]
    origin <- gridT[1L] - step
    gridT  <- pretty(c(origin, fv))
  }
  list(origin = origin, gridT = gridT)
}


# ----- print the summary table behind a pie or bubble chart --------------
# High-level DISPATCHER for the text output that accompanies Chart()'s
# pie/bubble plots. Takes a 1-D / 2-D table from .build_plotly_tbl() and
# decides what kind of summary to print:
#   - count tables (y was NULL)  → delegates to .ss.factor() and prints
#                                  title + frequencies + chi-square test
#                                  via the "out_all" S3 class
#   - numeric stat tables        → just base print(x.tbl)
#   - 3+ dimensional tables      → labeled cat() + print(x.tbl)
# Returns nothing; side-effect is console output.
.print_chart_summary <- function(x.tbl, x_name, x.lbl = NULL,
                                 by_name = NULL, y_name = NULL,
                                 stat = NULL, digits_d = 2) {

  # helper: is this table "count-like"? (y was NULL, so caller passes y_name = "Count")
  is.count <- is.null(y_name) || identical(y_name, "Count")

  nd <- length(dim(x.tbl))

  if (is.count) {  # x.tbl is count-like values
    # --- 1D / 2D paths still get the .ss.factor treatment ----------------
    if (is.null(dim(x.tbl))) {
      # 1D: named vector of counts -> coerce to table with dimname "x"
      dn <- list(names(x.tbl))
      x.tbl <- as.table(array(unname(x.tbl),
                              dim       = length(x.tbl),
                              dimnames  = dn))
      names(dimnames(x.tbl)) <- "x"
      nd <- 1L
    }
    else {
      # Already has dims: if first dim has no name, call it "x"
      dn_names <- names(dimnames(x.tbl))
      if (is.null(dn_names) || !nzchar(dn_names[1L])) {
        dn_names <- if (is.null(dn_names)) character(nd) else dn_names
        dn_names[1L] <- "x"
        names(dimnames(x.tbl)) <- dn_names
      }
    }

    if (nd <= 2L) {
      # Use existing .ss.factor summaries for 1D or 2D counts
      stats <- .ss.factor(
        x.tbl,
        by    = NULL,
        brief = TRUE,
        digits_d = digits_d,
        x_name, by_name, x.lbl=NULL, y.lbl = NULL
      )

      ## >>> changed logic here: key off nd, not by_name <<<
      if (nd == 1L) {
        # 1D counts
        title <- stats$title
        freq  <- stats$counts
        test  <- stats$chi
      } else {  # nd == 2L
        # 2D counts (including facet-only case)
        title <- stats$txttl
        freq  <- stats$txfrq
        test  <- stats$txXV
      }
      ## <<< end change <<<

      class(title) <- "out"
      class(freq)  <- "out"
      class(test)  <- "out"

      output <- list(
        out_title  = title,
        out_counts = freq,
        out_chi    = test
      )
      class(output) <- "out_all"
      print(output)
    }
    else {
      # 3+ dimensional count table: just print the multiway table
      cat("\nMulti-way count table:\n\n")
      print(x.tbl)
    }

  } else {
    # --------------------------------------------------------------------
    # NOT counts: display numeric summary table
    # --------------------------------------------------------------------
    has_by <- !is.null(by_name)

    # For 1D/2D numeric tables, preserve old printing behavior
    if (nd <= 2L) {
      if (has_by) {
        # Ensure dimnames have (by_name, x_name)
        dimnames(x.tbl) <- setNames(dimnames(x.tbl), c(by_name, x_name))
      }

      x.t <- x.tbl
      attributes(x.t) <-
        attributes(x.tbl)[c("dim", "dimnames", "names", "row.names", "class")]
      if (!is.null(names(dimnames(x.t)))) names(dimnames(x.t)) <- NULL

      print(x.t)  # a table
    }
    else {
      # 3+ dimensional numeric table: print as-is
      cat("\nMulti-way numeric summary table:\n\n")
      print(x.tbl)
    }
  }

  cat("\n")  # space after all the text output
}

# --------
# BarChart
# --------

library(shiny)
library(lessR)
library(openxlsx)

clr.one <- list(
  "slategray3", "dodgerblue3", "cornflowerblue", "steelblue", "darkblue",
  "pink2", "red3", "firebrick2", "darkred",
  "violetred", "mediumorchid", "purple3",
  "darkorange2", "salmon", "orange3", "sienna", "rosybrown", 
  "wheat3", "goldenrod2", "khaki", "yellow2",
  "darkseagreen2", "springgreen3", "seagreen4", "darkgreen",
  "black", "gray45", "slategray4", "gray75", "snow3", "gray95",
  "lavender", "ivory2", "aliceblue", "white"
)

clr.edge <- list(
  "off", "black", "gray50", "gray75", "white", "ivory", 
  "darkblue", "darkred", "darkgreen", "rosybrown2", "bisque", 
  "slategray2", "aliceblue", "thistle1", "coral", "gold"
)

clr.qual <- c("hues", "Okabe-Ito", "viridis")

clr.seq <- list(
  "reds", "rusts", "browns", "olives", "greens",
  "emeralds", "turquoises", "aquas", "blues", "purples", "violets",
  "magentas", "grays"
)

addResourcePath("shiny_dir", system.file("shiny_apps", package = "lessR"))

ui <- fluidPage(
  tags$head(tags$link(rel = "stylesheet", href = "shiny_dir/styles.css")),

  tabsetPanel(

    tabPanel("Data",
      titlePanel(div("Upload a text (.csv, .txt) or Excel file", id = "hp")),

      sidebarLayout(
        sidebarPanel(

          radioButtons("fType", HTML("<h5 class='soft'>Format</h5>"), 
                       c("Excel" = "Excel", "Text" = "Text")),
          conditionalPanel(condition = "input.fType == 'Text'",
            radioButtons("sep", HTML("<h5 class='soft'>Separator</h5>"),
                         c(Comma = ",", Semicolon = ";", Tab = "\t"), ","),
            radioButtons("decimal", HTML("<h5 class='soft'>Decimal</h5>"),
                         c("Point" = ".", "Comma" = ","))
          ),

          radioButtons("fSource", HTML("<h5 class='soft'>Source</h5>"), 
                       c("Local" = "local", "Web" = "web")),
          conditionalPanel(condition = "input.fSource == 'local'",
            fileInput("myFile", "Locate your data file",
                      accept = c(".csv", ".txt", ".xlsx", ".xlsm"))
          ),
          conditionalPanel(condition = "input.fSource == 'web'",
            textInput("myURL", "Web address of data file"),
            actionButton("submitURL", "Submit")
          ),

          textOutput("ncols"),
          textOutput("nrows"),
          uiOutput("d.radio")

        ),  # end sidebarPanel

        mainPanel(
          tableOutput("d.table"),
          tags$style(type = "text/css", "#d.table {font-size: .95em;}")
        )

      )  # end sidebarLayout
    ),  # end tabPanel 1


    tabPanel("BarChart",
      pageWithSidebar(
        titlePanel(""),

        sidebarPanel(
          selectInput("x.col", "x Variable", ""),

          checkboxInput("do_by", div("by variable", class = "view"), FALSE),
          conditionalPanel(condition = "input.do_by == true",
            selectInput("by.col", "by Variable", "", selected = ""),
            selectInput("myFill2", "fill",
              choices = list("Qualitative" = clr.qual, "Sequential" = clr.seq)),
            checkboxInput("myBeside", "beside", value = FALSE),
            checkboxInput("my100", "stack100", value = FALSE)
          ),

          tags$hr(),
          checkboxInput("do_y", div("y variable", class = "view"), FALSE),
          conditionalPanel(condition = "input.do_y == true",
            selectInput("y.col", "y Variable", "", selected = ""),
            uiOutput("radio_stats")  # only if not a summary table
          ),

          tags$hr(),
          checkboxInput("do_geom", div("Bars", class = "view"), FALSE),
          conditionalPanel(condition = "input.do_geom == true",
            conditionalPanel(condition = "input.do_by == false",
              selectInput("myFill", "fill",
                choices = list("Qualitative" = clr.qual,
                               "Constant" = clr.one, "Sequential" = clr.seq))),
            selectInput("myColor", label = "color", choices = clr.edge),
            sliderInput("myTrans", label = "transparency", min = 0, max = 1,
                        value = 0),
            selectInput("mySort", "sort", choices = list("0", "+", "-")),
            checkboxInput("myHoriz", "horiz", value = FALSE)
          ),

          tags$hr(),
          checkboxInput("do_labels", div("Labels", class = "view"), FALSE),
          conditionalPanel(condition = "input.do_labels == true",
            selectInput("myLabels", "labels",
                        choices = list("%", "input", "off")),
            selectInput("myLabelsColor", "labels_color",
               choices = list("white", "gray", "darkgray", "black",
                              "red", "green3")),
            conditionalPanel(condition = "input.do_by == false",
              selectInput("myLabelsPos", "labels_position",
                 choices = list("in", "out"))
            ),
            sliderInput("myLabelsSize", "labels_size",
                        min = 0, max = 2, value = 0.9, step = 0.1)
          ),

          tags$hr(),
          checkboxInput("do_pdf", div("Save", class = "view"), FALSE),
          conditionalPanel(condition = "input.do_pdf == true",
            sliderInput("w", "width (inches):", min = 3, max = 20, value = 8),
            sliderInput("h", "height (inches):", min = 3, max = 20, value = 6),
            checkboxInput("do_cmt", "include comments in R file", TRUE),
            actionButton(inputId = "btn_pdf", "Save"),
            tags$p(div("Save pdf file and R code file",
                  style = "margin-top:.25em; margin-bottom"))
          ),

          tags$hr(),
          checkboxInput("do_help", div("Help", class = "view"), FALSE)

        ),  # end sidebarPanel

        mainPanel(
          plotOutput("myPlot"),
          verbatimTextOutput("summary"),
          plotOutput("saved_plot"), 
          textOutput("help")
        )

      )  # end pageWithSidebar
    )  # end tabPanel 2
  )  # end tabsetPanel
)  # end fluidPage 


server <- function(input, output, session) {

  v <- reactiveValues()

  # select categorical variables from read data frame
  # unlike the other interactive apps, need to adapt to input summary table
  the.vars <- function(data, cats = TRUE) {

    lu.x <- sapply(data, function(x) { length(unique(x)) }) 
    is.cat <- logical(length = ncol(data))
    nr <- min(nrow(data), 500)
    for (i in 1:ncol(data)) {
      is.cat[i] <- is.character(data[1:nr, i]) || is.factor(data[1:nr, i])
      # numeric var is.cat if 10 or less unique values but not a summary tbl
      if (is.numeric(data[1:nr, i]) && lu.x[i] < 11)
        if (nrow(data) > lu.x[i] && ncol(data) > 2) is.cat[i] <- TRUE 
    }

    if (all(!is.cat)) {
      message("A bar chart displays the values of a categorical variable.\n",
              "Categorical variables have non-numeric values or, if numeric,\n",
              "  defined here as 10 or fewer unique values.\n\n",
              "There are no categorical variables in this data set.")
      stopApp()
    }

    if (cats)
      return(names(data)[is.cat])
    else
      return(names(data)[!is.cat])
  }


  # ------- Read and Display Data -----------
  # -----------------------------------------

  # process the URL for reading from the web
  theURL <- eventReactive(input$submitURL, {
    input$myURL
  })

  data <- reactive({
    if (input$fSource == "local") {
      shiny::req(input$myFile)
      myPath <- input$myFile$datapath
      theRead <- input$myFile$name
    }
    if (input$fSource == "web") {
      url <- theURL()
      if (!grepl("^https?://", url))
        url <- paste("https://", url, sep = "")
      myPath <- url
      theRead <- myPath
    }
      
    shiny::req(myPath)
    if (input$fType == "Excel") { 
      if (grepl(".xlsx", myPath, fixed = TRUE)) {
        d <- read.xlsx(myPath)
      }
      else {
        message("\n>>> Excel file must have file type of .xlsx <<<\n\n")
        stopApp()
      }
    }
    if (input$fType == "Text") { 
      if ((grepl(".csv", myPath, fixed = TRUE)) ||
          (grepl(".txt", myPath, fixed = TRUE))) {
        d <- read.csv(myPath, sep = input$sep, dec = input$decimal,
                      na.strings = "")  # default is NOT a blank char missing
      }
      else {
        message("\n>>> Text file must have file type of .csv or .txt <<<\n\n")
        stopApp()
      }       
    }  # end fType is "Text"

    updateSelectInput(session, inputId = "x.col", label = "x variable",
                      choices = c("Select a categorical variable" = "",
                                  the.vars(d, cats = TRUE)))
    
    return(d)
  })  # end reactive()


  output$nrows <- renderText({
    shiny::req(data())
    paste("Number of data rows:", nrow(data()))
  })
  output$ncols <- renderText({
    shiny::req(data())
    paste("Number of variables:", ncol(data()))
  })

  output$d.radio <- renderUI({
    shiny::req(data())
    if (nrow(data()) > 10)
      radioButtons("d.radio", HTML("<h5 class='soft'>Rows to display</h5>"),
                   c("First 10" = "head", "Last 10" = "tail",
                     "Random 10" = "random", "All" = "all"))
  })

  output$d.table <- renderTable({
    if (is.null(input$d.radio)) {
      data()
    }
    else {
      nr <- min(11, nrow(data()))
      if (nr == 11) {
        if (input$d.radio == "all")
          data()
        else if (input$d.radio == "head")
          head(data(), n = 10)
        else if (input$d.radio == "tail")
          tail(data(), n = 10)
        else if (input$d.radio == "random") { 
          dd <- data()
          dd[sample(nrow(dd), min(10, nrow(dd))), ]
        }
      }
    }
  }, striped = TRUE)  # end renderTable

  # -----------------------------------------


  observeEvent(input$do_by, {
    shiny::updateSelectInput(
      session, inputId = "by.col", label = "by variable",
      choices = c("Select a categorical variable" = "",
                  the.vars(data(), cats = TRUE))
    )
  })


  observeEvent(input$do_y, {
    shiny::updateSelectInput(
      session, inputId = "y.col", label = "y variable",
      choices = c("Select a numerical variable" = "",
                  names(data())[sapply(data(), is.numeric)])
    )
  })

  output$radio_stats <- renderUI({
    shiny::req(input$do_y)

    x.name <- input$x.col
    shiny::req(x.name)
    x <- data()[, x.name]
    unq.x <- length(unique(x))
    smry.tbl <- ifelse(unq.x == length(x) && ncol(data()) == 2, TRUE, FALSE)

    shiny::req(!smry.tbl)  # stat makes no sense for summary table data
    radioButtons("statType", "stat", 
                 c("sum" = "sum", "mean" = "mean", "deviation" = "deviation",
                   "sd" = "sd", "min" = "min", "median" = "median",
                   "max" = "max"), selected = "mean")
  })

  # ----------------------------------------

  get.ax.nm <- function(nm, in.stat, smry.tbl) {

    a <- ""
    if (!is.null(in.stat)) {
      if (in.stat == "sum")  a <- "Sum"
      if (in.stat == "mean") a <- "Mean"
      if (in.stat == "sd")   a <- "Standard Deviation"
      if (in.stat == "deviation")  a <- "Mean Deviation"
      if (in.stat == "min")  a <- "Minimum"
      if (in.stat == "median") a <- "Median"
      if (in.stat == "max")  a <- "Maximum"
    }

    axis.name <- " "
    if (!smry.tbl) {
      axis.name <- ifelse(nchar(a) > 0, paste(a, "of", nm), " ")
    }
    else
      axis.name <- nm  # summary table

    return(axis.name)
  }


  # ------------- The BarChart --------------
  # -----------------------------------------

  output$myPlot <- renderPlot({

    x.name <- input$x.col
    shiny::req(x.name)
    x <- data()[, x.name]
    unq.x <- length(unique(x))
    smry.tbl <- ifelse(unq.x == length(x) && ncol(data()) == 2, TRUE, FALSE)

    y <- NULL
    in.stat <- NULL
    y.name <- ""
    if (input$do_y) {
      y.name <- input$y.col
      shiny::req(y.name)
      y <- data()[, y.name]
      in.stat <- input$statType
    }

    if (nchar(y.name) == 0) 
      axis.name <- paste("Count of", x.name)
    else
      axis.name <- get.ax.nm(y.name, in.stat, smry.tbl)

    in.fill <- input$myFill
    by.name <- ""
    by <- NULL
    lt <- ""   # legend_title should not be NULL
    if (input$do_by) {  # a by variable
      by.name <- input$by.col
      shiny::req(by.name)
      by <- data()[, by.name]
      in.fill <- input$myFill2  # color range selection
      lt <- by.name
    }
    v$by.name <- by.name
     
    ## ---- Call Chart() depending on y and by presence ----

    if (input$do_y && input$do_by) {
      v$b <- Chart(
        x, y, by = by, data = NULL,
        type = "bar",
        stat  = in.stat,
        fill  = in.fill,
        color = input$myColor,
        transparency = input$myTrans,
        sort  = input$mySort,
        horiz = input$myHoriz,
        stack100 = input$my100,
        beside   = input$myBeside,
        labels          = input$myLabels,
        labels_color    = input$myLabelsColor,
        labels_size     = input$myLabelsSize,
        labels_position = input$myLabelsPos,
        xlab = x.name,
        ylab = axis.name,
        legend_title = lt,
        quiet = TRUE
      )
      v$plt <- recordPlot()

    } else if (input$do_y && !input$do_by) {
      v$b <- Chart(
        x, y, data = NULL,
        type = "bar",
        stat  = in.stat,
        fill  = in.fill,
        color = input$myColor,
        transparency = input$myTrans,
        sort  = input$mySort,
        horiz = input$myHoriz,
        stack100 = input$my100,
        beside   = input$myBeside,
        labels          = input$myLabels,
        labels_color    = input$myLabelsColor,
        labels_size     = input$myLabelsSize,
        labels_position = input$myLabelsPos,
        xlab = x.name,
        ylab = axis.name,
        legend_title = lt,
        quiet = TRUE
      )
      v$plt <- recordPlot()

    } else if (!input$do_y && input$do_by) {
      v$b <- Chart(
        x, by = by, data = NULL,
        type = "bar",
        fill  = in.fill,
        color = input$myColor,
        transparency = input$myTrans,
        sort  = input$mySort,
        horiz = input$myHoriz,
        stack100 = input$my100,
        beside   = input$myBeside,
        labels          = input$myLabels,
        labels_color    = input$myLabelsColor,
        labels_size     = input$myLabelsSize,
        labels_position = input$myLabelsPos,
        xlab = x.name,
        ylab = axis.name,
        legend_title = lt,
        quiet = TRUE
      )
      v$plt <- recordPlot()

    } else {
      v$b <- Chart(
        x, data = NULL,
        type = "bar",
        fill  = in.fill,
        color = input$myColor,
        transparency = input$myTrans,
        sort  = input$mySort,
        horiz = input$myHoriz,
        stack100 = input$my100,
        beside   = input$myBeside,
        labels          = input$myLabels,
        labels_color    = input$myLabelsColor,
        labels_size     = input$myLabelsSize,
        labels_position = input$myLabelsPos,
        xlab = x.name,
        ylab = axis.name,
        legend_title = lt,
        quiet = TRUE
      )
      v$plt <- recordPlot()
    }

    ## ---- Build code string (user R code) ----

    p_fill  <- in.fill == "hues"
    p_color <- input$myColor == "off"
    p_trans <- input$myTrans == 0
    p_horiz <- input$myHoriz == FALSE
    p_sort  <- input$mySort == "0"
    p_100   <- input$my100 == FALSE
    p_beside <- input$myBeside == FALSE
    p_labels <- input$myLabels == "%"
    p_labels_color <- input$myLabelsColor == "white"
    p_labels_position <- input$myLabelsPos == "in"
    p_labels_size <- input$myLabelsSize == 0.9
    p_stat <- is.null(in.stat)
      
    txt <- ifelse(input$do_y, ", y=", "")
    out <- paste("Chart(", x.name, txt, y.name, sep = "")
      
    txt <- ifelse(input$do_by, ", by=", "")
    out <- paste(out, txt, by.name, sep = "")

    if (!p_fill)  out <- paste(out, ", fill=\"", in.fill, "\"", sep = "")
    if (!p_color) out <- paste(out, ", color=\"", input$myColor, "\"", sep = "")
    if (!p_trans) out <- paste(out, ", transparency=", input$myTrans, sep = "")
    if (!p_horiz) out <- paste(out, ", horiz=", input$myHoriz, sep = "")
    if (!p_sort)  out <- paste(out, ", sort=\"", input$mySort, "\"", sep = "")
    if (!p_100)   out <- paste(out, ", stack100=", input$my100, sep = "")
    if (!p_beside) out <- paste(out, ", beside=", input$myBeside, sep = "")
    if (!p_labels) out <- paste(out, ", labels=\"", input$myLabels, "\"", sep = "")
    if (!p_labels_color) out <- paste(out, ", labels_color=\"", 
                                      input$myLabelsColor, "\"", sep = "")
    if (!p_labels_position) out <- paste(out, ", labels_position=\"", 
                                         input$myLabelsPos, "\"", sep = "")
    if (!p_labels_size) out <- paste(out, ", labels_size=", 
                                     input$myLabelsSize, sep = "")
    if (!p_stat && input$do_y) out <- paste(out, ", stat=\"", in.stat, "\"", sep = "")

    # always explicit about type
    out <- paste(out, ", type=\"bar\")", sep = "")
    cat(out)
    v$code <- out  # save the code for a pdf file
  })  # end renderPlot


  # print stats
  output$summary <- renderPrint({

    x.name <- input$x.col
    shiny::req(x.name)
    shiny::req(v$b)

    x <- data()[, x.name]
    unq.x <- length(unique(x))
    smry.tbl <- ifelse(unq.x == length(x) && ncol(data()) == 2, TRUE, FALSE)
    shiny::req(!smry.tbl)  # otherwise a summary table, no stats to do
    
    b <- v$b
    if (!input$do_y) {
      out2 <- c(b$out_miss, " ", b$out_count, " ", b$out_chi)
      if (input$my100) out2 <- c(out2, " ", b$out_col)
    }
    else {
      y.name <- input$y.col
      shiny::req(y.name)
      cat("Summary Statistics\n", "------------------\n", sep = "")
      stats <- c("mean", "sd", "min", "median", "max")
      pv <- do.call(
        pivot,
        list(
          data = data(),
          compute = stats,
          variable = as.name(y.name),
          by = as.name(x.name),
          quiet = TRUE
        )
      )
      k <- 3L  # Keep cols 1:3 (Type, n, na), rename rest with just the stats
      names(pv)[seq_len(k + length(stats))] <- c(names(pv)[seq_len(k)], stats)
      print(pv, print.gap = 2)
      out2 <- b$out_y
    }
    cat("\n"); for (i in seq_along(out2)) cat(out2[i], "\n")
  })


  # clicking on the Save button generates a pdf file 
  plotInput <- eventReactive(input$btn_pdf, {

    code <- v$code

    x.name <- input$x.col
    shiny::req(x.name)
    x <- data()[, x.name]
    unq.x <- length(unique(x))
    smry.tbl <- ifelse(unq.x == length(x) && ncol(data()) == 2, TRUE, FALSE)

    y <- NULL
    in.stat <- NULL
    y.name <- ""
    if (input$do_y) {
      y.name <- input$y.col
      shiny::req(y.name)
      y <- data()[, y.name]
      in.stat <- input$statType
    }

    if (nchar(y.name) == 0) 
      axis.name <- paste("Count of", x.name)
    else
      axis.name <- get.ax.nm(y.name, in.stat, smry.tbl)

    in.fill <- input$myFill
    by.name <- ""

    by <- NULL
    lt <- ""   # legend_title here too
    if (input$do_by) {  # a by variable
      by.name <- input$by.col
      shiny::req(by.name)
      by <- data()[, by.name]
      in.fill <- input$myFill2  # color range selection
      lt <- by.name
    }

    pdf.fname <- paste("bc_", x.name, by.name, ".pdf", sep = "")
    pdf.path <- file.path(path.expand("~"), pdf.fname)

    # styles before re-set in interact() were saved
    style(lab_cex = getOption("l.cex"))
    style(axis_cex = getOption("l.axc"))

    ## ---- Chart() call for saved plot, mirroring the four cases ----

    pdf(pdf.path, width = as.numeric(input$w), height = as.numeric(input$h))

    pdf(pdf.path, width = as.numeric(input$w), height = as.numeric(input$h))
    shiny::req(!is.null(v$plt))
    replayPlot(v$plt)
    dev.off()

    # reset back to shiny setting
    style(lab_cex = 1.201, axis_cex = 1.011, suggest = FALSE)

    # R code
    r.fname <- paste("bc_", x.name, by.name, ".r", sep = "")
    r.path <- file.path(path.expand("~"), r.fname)
    cat("\n")
    message("---------------------------------------------")
    cat("Files written to folder:", path.expand("~"), "\n")
    message("---------------------------------------------")
    cat("pdf file: ", pdf.fname, "\n")
    cat("R code file: ", r.fname, "\n")
    message("---------------------------------------------")
    cat("\n")

    if (input$fSource == "web") {
      url <- theURL()
      if (!grepl("^https?://", url))
        url <- paste("https://", url, sep = "")
    }

    read.path <- ifelse(input$fSource == "local", input$myFile$name, url)
    read.code <- paste("d <- Read(\"", read.path, "\")", sep = "")
    is.local <- !grepl("http://", read.path, fixed = TRUE)

    if (input$do_cmt)
      cat("# The # symbol indicates a comment rather than an R instruction\n\n",
          "# Begin the R session by loading the lessR functions ",
          "from the library\n", sep = "", file = r.path)
    cat("library(\"lessR\")\n\n", file = r.path, append = TRUE)

    if (input$do_cmt) {
      cat("# Read your data into an R data table, the data frame, here d",
          "\n", sep = "", file = r.path, append = TRUE)
      if (is.local)
        cat("# To browse for the data file, include nothing between the quotes",
            "\n", sep = "", file = r.path, append = TRUE)
    }
    if (is.local && input$do_cmt)
      cat("d <- Read(\"\")\n\n", file = r.path, append = TRUE)

    if (is.local && input$do_cmt) {
      cat("# For security, the path to your data file is not available\n",
          "# You can replace PATHtoFILE in the following with the path\n",
          "# Remove the # sign in the first column and delete the previous ",
          "Read()\n", sep = "", file = r.path, append = TRUE)
      read.path <- file.path("PATHtoFILE", read.path) 
      read.code <- paste("# d <- Read(\"", read.path, "\")", sep = "")
    }
    cat(read.code, "\n\n", file = r.path, append = TRUE)

    if (input$do_cmt)
      cat("# When you have your data table, do the bar chart analysis of a\n",
          "#   categorical variable in the data table\n",
          "# d is the default data frame name, so no need to specify\n",
          sep = "", file = r.path, append = TRUE)
    cat(code, "\n\n", file = r.path, append = TRUE)

    anlys <- "Chart()"
    if (input$do_cmt)
      cat("# If accessing data with a name other than d, must add  data=NAME\n",
          paste("#   to the", anlys, "call, where NAME is the name of your",
                "data frame"), "\n",
          sep = "", file = r.path, append = TRUE)
  })
  output$saved_plot <- renderPlot({ plotInput() })


  # access web page help file
  observeEvent(input$do_help, {
    fp <- system.file("shiny_apps/help/BarChart.html", package = "lessR")
    browseURL(fp)
  }, ignoreInit=TRUE)
  output$help <- renderText({ "" })

}  # end server

shinyApp(ui, server)

.cr.data.frame <-
function(x, miss, show, digits_d,
         heat_map, fill_low, fill_hi, main, bottom, right, quiet, 
         pdf_file, width, height, ...)  {

  if (!is.null(digits_d) && digits_d<1) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",      
        "\n>>> digits d is ", digits_d,  " and must be at least 1.\n")
  }

  if (miss == "pairwise") miss_type <- "pairwise.complete.obs"
  else if (miss == "listwise") miss_type <- "complete.obs"
  else if (miss == "everything") miss_type <- "everything"

  max.digits <- 0
  dig.warning <- FALSE

  # check for valid numeric variables and get largest decimal digits
  not.num <- integer(length=ncol(x))
  i.not <- 0
  for (i in 1:ncol(x)) {

    x.name <- names(x)[i]
    options(xname = x.name)  # sets for each variable   WHY???

    if (!is.numeric(x[,i])) {
      i.not <- i.not + 1
      not.num[i.not] <- i
    }

    if (is.null(digits_d)) {
      digits_d <- .max.dd(x[,i]) + 1 
      if (digits_d < 2) digits_d <- 2
      if (digits_d > max.digits  &&  !dig.warning) max.digits <- digits_d
      if (digits_d > 10  &&  !dig.warning) {
        cat("\nThese data values contain ", digits_d, " decimal digits.\n",
            "To enhance the readability of the output, only 4 decimal digits\n",
            "are displayed.  To customize, use the digits_d  parameter.\n",
            "Example for Variables Y and X:  > cr(Y, by=X, digits_d=3)\n\n",
            sep="")
        dig.warning <- TRUE
        max.digits <- 4
      }
    }
  }  # column check for numeric variables

  # remove non-numeric variables from data frame, background
  tx <- character(length = 0)
  if (i.not > 0) {
    tx[length(tx)+1] <- paste("The following non-numeric variables are deleted",
        "from the analysis")
    for (i in 1:i.not) tx[length(tx)+1] <- paste(i, ". ", names(x)[not.num[i]],
      sep="")
    x <- x[, -not.num[1:i.not]]
    if (is.null(dim(x))) { 
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "A correlation matrix requires at least 2 variables.\n\n")
    }
  }
  
  # compute correlations
  if (!is.null(digits_d)) max.digits <- digits_d
  crs <- round(cor(x, use=miss_type, ...), digits=max.digits)  # cor matrix

  n.vars <- nrow(crs)
  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste("The correlation matrix contains",
    n.vars, "variables")
  txb <- tx


  # missing values
  tot.miss <- sum(is.na(x))
  if (!quiet) {
    if (tot.miss == 0) 
      cat("\n>>> No missing data\n\n")
    else {
      cat("\nMissing data deletion: ", miss, "\n")
      if (show != "missing")
        cat("Rerun with  show=\"missing\"  for more information.\n\n")
    }
  }

  tx <- character(length = 0)

  if (miss == "listwise") 
    tx[length(tx)+1] <- paste("   Sample size after deleted rows:",
      sum(complete.cases(x)), "\n")

  else if (miss == "pairwise") {
    n <- as.integer(crs)
    n <- matrix(n, nrow=n.vars)
    dimnames(n) <- dimnames(crs)
    for (i in 1:n.vars) {
      for (j in 1:n.vars) {
        n[i,j] <- sum(!is.na(x[i] - x[j]))  # non-missing values
      }
    }
    options(xname = "Missing Data Analysis")
    if (tot.miss != 0) {

      .ss.factor(as.vector(n), brief=TRUE, x.name=" ")  # x.name KLUDGE
      if (show == "missing") {
        txn <- .prntbl(n, 2, cc=" ")
        for (i in 1:length(txn)) tx[length(tx)+1] <- txn[i]
      }
    }
  }  # end pairwise
  txm <- tx


  # cor matrix
  tx <- character(length = 0)
  tx[length(tx)+1] <- paste("Correlation Matrix")
  txcrs <- .prntbl(crs, 2, cc=" ")
  for (i in 1:length(txcrs)) tx[length(tx)+1] <- txcrs[i]
  txc <- tx


  if (heat_map  ||  !is.null(pdf_file)) {

    # heat map
    if (is.null(pdf_file)) {
      manage.gr <- .graphman()  # manage graphics?
      if (manage.gr) {
        .graphwin(1)
        dev.set(which=3) 
      }
    }

    .heatmap(crs[1:ncol(crs),1:ncol(crs)], nrow(crs), main=main,
               bm=NULL, rm=NULL, diag=0,
               pdf_file=pdf_file, width=width, height=height)
  }

  return(list(txb=txb, txm=txm, txc=txc, R=crs))
}

.corfa.Rmd <-
function(mimm, nm.mimm=NULL, dname, fun_call, n.inds, n_factors, iter, item_cor,
         explain, results) {

  fncl <- .fun_call.deparse(fun_call) 
  fc <- .rm.arg("Rmd", fncl) 

  # set parameters
  d <- 3

  if (explain) show <-  "" else show <- ", echo=FALSE"
  

  tx <- character(length = 0)

  tx[length(tx)+1] <- "---"
  #tx[length(tx)+1] <- "title: \"Factor Analysis\""
  tx[length(tx)+1] <- "output:"
  tx[length(tx)+1] <- "  html_document:"
  tx[length(tx)+1] <- "    fig_height: 4.5"
  tx[length(tx)+1] <- "    fig_width: 5.5"

  tx[length(tx)+1] <- "---"


  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "***"

  v <- packageVersion("lessR")
  tx[length(tx)+1] <- paste(
"_", format(Sys.time(), "%a %b %d, %Y at %H:%M"), " &nbsp; with ",
"lessR version ", v, "_",
sep="")

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "***"


  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "# Confirmatory Factor Analysis "

  tx[length(tx)+1] <- paste(
    "The purpose of this analysis is to identify the factors that underlie ", 
    "the observed variables, the items.",
    sep="")

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
  tx[length(tx)+1] <- "suppressPackageStartupMessages(library(lessR))  # load lessR"
  tx[length(tx)+1] <- "```"




  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## The Data"

  rdcall <- getOption("read.call")
  if (is.null(rdcall)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
       "To generate a knitr output file, first read the data\n",
       "with the lessR function Read.\n\n")
  }

  if (explain && !is.null(dname)) {
    tx[length(tx)+1] <- paste("Read the data with the `lessR` ",
"function `Read`. ")
    ref <- .get.arg("ref", rdcall)  # only works for Read, not rd or rd.brief
    if (ref %in% c("Employee", "Reading", "Cars93", "Jackets", "Learn", "Mach4")) {
      ref  <- paste(ref, "\"", ", format=\"lessR", sep="")
      tx[length(tx)+1] <- paste(
"Here read from a data file included with the `lessR` package.",
sep="")
    }
  }

  if (results && !is.null(dname)) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <- xW(paste(dname, " <- ", rdcall, sep=""))
    tx[length(tx)+1] <- "```"
  }

  if (!is.null(dname)) tx[length(tx)+1] <- paste(
"Data from the following variables are available for analysis: ",
"`r xAnd(names(", dname, "))`. ",
sep="")



  if (explain) tx[length(tx)+1] <- paste("\n",
"The analysis proceeds from the correlations. ",
sep="")


  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <- paste("mycor <- cr(", dname, ")", sep="")
    tx[length(tx)+1] <- "```"
  }





  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## Specified Model"

  loc <- regexec("heat_map = FALSE", fc)
  if (loc == -1) fc <- sub(")$", ", heat_map=FALSE)", fc)

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    if (!is.null(mimm))
      tx[length(tx)+1] <- paste(nm.mimm, " <- \"", format(mimm), "\"")
    tx[length(tx)+1] <- xW(paste("c <-", fc), 85)
    tx[length(tx)+1] <- "```"
  }

  if (explain) tx[length(tx)+1] <- paste(
"The output begins with a specification of the variables, the items, ",
"in the model and the content of each item if available. ",
"Each set of items forms a scale, scored as an unweighted composite. ",
"Corresponding to each observed scale score is an underlying factor. ",
sep="")

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"c$out_labels" 
    tx[length(tx)+1] <- "```"
  }







  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## Scale Reliability"


  if (explain) tx[length(tx)+1] <- paste(
"Reliability is of the composite, the unweighted total score, ",
"for each scale. Alpha assumes equal item reliabilities.",
sep="")

  if (explain  &&  iter>0) tx[length(tx)+1] <- paste(
"The more generally preferred ", 
"Omega uses each indicator\'s communality in the computation of reliability. ",
sep="")

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"c$out_reliability" 
    tx[length(tx)+1] <- "```"
  }







  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## Solution"

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"c$out_indicators" 
    tx[length(tx)+1] <- "```"
  }


    if (explain && item_cor) tx[length(tx)+1] <- paste(
"* _Item Correlation_: Correlation of two items with each other\n",
"* _Communality_, in the diagonal of the item correlations: Proportion",
"of the correlation of an item with itself that is due only to ",
"its underlying factor ",
sep="")

    tx[length(tx)+1] <- paste(
"* _Factor Loading_: Correlation of an item with a factor\n",
"* _Pattern Coefficient_: Regression coefficient of an item on its, ",
"  underlying factor, a special case of a factor loading\n",
"* _Factor Correlation_: Correlation of two factors with each other ",
sep="")

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"c$out_solution" 
    tx[length(tx)+1] <- "```"
  }






  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## Residuals"

    tx[length(tx)+1] <- paste(
"Difference between an item correlation and its value imposed ",
"by the estimated multiple indicator measurement model. ",
sep="")

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"c$out_residuals" 
    tx[length(tx)+1] <- "```"
  }


  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"c$out_res_stats" 
    tx[length(tx)+1] <- "```"
  }




  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## lavaan Code"

    tx[length(tx)+1] <- paste(
"lavaan code for confirmatory factor analysis of the model, ",
"fully standardized, maximum likelihood solution. ",
sep="")

  if (results) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
    tx[length(tx)+1] <-"c$out_lavaan" 
    tx[length(tx)+1] <- "```"
  }

  return(tx)

}

# ----- shared helpers (private to dot.plotly) ---------------------------
# Used by the three dot.plotly paths (paired, faceted, single-series).

# Convert numeric shape codes to plotly symbol names and pre-compute
# the per-point marker geometry. Returns a list with symbol/px/color/border.
.dot_marker_style <- function(shape, pt.size, fill, border, pt_opacity) {
  symbol <- switch(as.character(shape),
    "21"="circle","22"="square","23"="diamond",
    "24"="triangle-up","25"="triangle-down","circle"
  )
  px <- as.numeric(pt.size) * 10
  if (!is.finite(px) || px <= 0) px <- 5
  list(
    symbol = symbol,
    px     = px,
    color  = .maketrans_plotly(fill[1], alpha = pt_opacity),
    border = .to_hex(border[1])
  )
}

# Assemble the marker= list a plotly scatter trace expects.
# Pass color_override to use a per-series color (paired dot).
.dot_marker_list <- function(ms, n, color_override = NULL) {
  list(
    symbol   = ms$symbol,
    size     = rep(ms$px, n),
    sizemode = "diameter",
    color    = color_override %||% ms$color,
    opacity  = 1,
    line     = list(color = ms$border, width = 1)
  )
}

# Add a markers trace. cats/vals are placed on x/y per orientation
# ("v" = cats on x; "h" = cats on y).
.dot_marker_trace <- function(plt, cats, vals, marker, orientation,
                              hover.tmpl = NULL, name = NULL,
                              showlegend = FALSE) {
  if (orientation == "v") { xv <- cats; yv <- vals }
  else                    { xv <- vals; yv <- cats }
  args <- list(plt, type = "scatter", mode = "markers",
               x = xv, y = yv, marker = marker,
               showlegend = showlegend, inherit = FALSE)
  if (!is.null(hover.tmpl)) args$hovertemplate <- hover.tmpl
  if (!is.null(name))       args$name          <- name
  do.call(plotly::add_trace, args)
}

# Add an NA-separated lines trace for the origin→value stems.
# cats/vals MUST be pre-filtered to finite values. seg.start is the
# axis position where each stem begins (caller decides the policy).
.dot_segment_trace <- function(plt, cats, vals, seg.color,
                               orientation, seg.start) {
  n <- length(vals)
  if (n == 0L) return(plt)
  if (orientation == "v") {
    seg.x <- as.vector(rbind(cats, cats, NA))
    seg.y <- as.vector(rbind(rep(seg.start, n), vals, NA_real_))
  } else {
    seg.x <- as.vector(rbind(rep(seg.start, n), vals, NA_real_))
    seg.y <- as.vector(rbind(cats, cats, NA))
  }
  plotly::add_trace(plt,
    type       = "scatter", mode = "lines",
    x          = seg.x, y = seg.y,
    line       = list(color = seg.color, width = 1),
    hoverinfo  = "skip",
    showlegend = FALSE,
    inherit    = FALSE
  )
}

# Build the numeric (value) axis spec. Sets range from origin_x + gridT
# and optionally applies axis/text colors.
.dot_val_axis <- function(label, gridT, origin_x,
                          axis_color = NULL, text_color = NULL) {
  ax <- axis_num(label, gridT, NULL)
  if (!is.null(origin_x) && !is.null(gridT)) {
    step <- if (length(gridT) > 1L) gridT[2L] - gridT[1L] else 0
    ax$range     <- c(min(origin_x, min(gridT)), max(gridT) + step)
    ax$autorange <- FALSE
  }
  if (!is.null(axis_color)) {
    ax$linecolor <- .to_hex(axis_color)
    ax$tickcolor <- .to_hex(axis_color)
  }
  if (!is.null(text_color))
    ax$tickfont$color <- .to_hex(text_color)
  ax
}

# Build the category axis spec, freezing the order to the supplied cats.
.dot_cat_axis <- function(label, cats) {
  c(
    axis_cat(label),
    list(
      categoryorder = "array",
      categoryarray = cats,
      tickmode      = "array",
      tickvals      = cats,
      ticktext      = cats
    )
  )
}

# Shared plotly layout title= spec for the dot chart.
.dot_title <- function(main) {
  if (is.null(main)) NULL
  else list(text = main, x = 0.5, xanchor = "center",
            y = 0.98, yanchor = "top",
            font = list(size = round(
              16 * getOption("main_size", 1))))
}


dot.plotly <- function(
  x,                     # category labels (vector) or paired-dot data frame
  y,                     # numeric values (vector or data frame for paired)
  orientation = "v",     # "v" = vertical (cats on x-axis)
                         # "h" = horizontal (cats on y-axis)
  fill, border, shape, pt.size,
  x_lab = "",            # x-axis label
  y_lab = "",            # y-axis label
  digits_d = 2,
  pt_opacity = 0.95,
  gridT = NULL,          # tick positions for grid lines on the value axis
  origin_x = NULL,       # x-axis origin; NULL = auto (from gridT min)
  height = NULL,         # plot height in inches; NULL lets plotly auto-size
  facet = NULL,          # factor vector: one facet level per observation
                         # (cats/vals MUST already be aggregated + sorted)
  facet_name = NULL,     # display name for the facet variable
  facet_opts = .plotly_facet_opts(),  # n_row/n_col read here (grid layout)
  main = NULL,           # chart title (faceted path only)
  segments_x = TRUE,     # draw segment from origin to each dot (horizontal orientation)
  segments_y = TRUE,     # draw segment from origin to each dot (vertical orientation)
  style_opts = .plotly_style()
) {

  # internal aliases preserve descriptive names throughout the function body
  cats <- x
  vals <- y
  title.size <- round(16 * getOption("main_size", 1))

  # ---- paired dot plot (vals is a data frame with 2+ columns) -------------
  # Layout: single panel, cats on y, values on x (orientation "h").
  # Each y-column becomes a series with its own marker color + legend entry.
  if (is.data.frame(vals)) {
    cats.all      <- as.character(cats)
    n             <- length(cats.all)
    ms            <- .dot_marker_style(shape = 21, pt.size = pt.size,
                                       fill = fill, border = border,
                                       pt_opacity = pt_opacity)
    seg.color.hex <- .to_hex(style_opts$segment_color)
    axis.x.clr    <- style_opts$axis_x_color %||% style_opts$axis_color
    axis.text.clr <- style_opts$axis_text_color

    plt <- plotly::plot_ly()
    for (si in seq_len(ncol(vals))) {
      vals.si <- as.numeric(vals[[si]])
      clr     <- .maketrans_plotly(fill[si], alpha = pt_opacity)
      if (isTRUE(segments_x))
        plt <- .dot_segment_trace(plt, cats.all, vals.si, seg.color.hex,
                                  "h", seg.start = origin_x)
      plt <- .dot_marker_trace(plt, cats.all, vals.si,
        marker      = .dot_marker_list(ms, length(vals.si),
                                       color_override = clr),
        orientation = "h",
        name        = names(vals)[si],
        showlegend  = TRUE)
    }

    val.ax <- .dot_val_axis(x_lab, gridT, origin_x,
                            axis_color = axis.x.clr,
                            text_color = axis.text.clr)
    cat.ax <- .dot_cat_axis(y_lab, cats.all)

    plt <- plotly::layout(plt,
      xaxis    = val.ax,
      yaxis    = cat.ax,
      shapes   = c(x_grid(gridT), plot_border()),
      margin   = list(
                   t = if (!is.null(main)) round(title.size * 2.2) else 30),
      title    = .dot_title(main),
      legend   = list(font = list(size = round(
                   16 * getOption("axis_size", 0.9)))),
      template = NULL
    )
    plt$x$layout$plot_bgcolor  <- .to_hex(style_opts$panel_fill)
    plt$x$layout$paper_bgcolor <- .to_hex(style_opts$window_fill)

    plt <- .finalize_plotly_widget(plt, kind = "sp",
      x_name = x_lab, by_name = "", add_title = FALSE,
      nudge_viewer = (.allow.interactive() &&
                      !isTRUE(getOption("knitr.in.progress"))))

    return(invisible(plt))
  }

  # ---- faceted dot plot ---------------------------------------------------
  # Layout: subplot grid of single panels; each panel is one facet level.
  # Per-panel segment start is clamped at-or-below panel min so dots never
  # sit to the left of (or below) their stem.
  if (!is.null(facet)) {
    fac.char   <- as.character(facet)
    fac.levels <- sort(unique(fac.char[!is.na(fac.char)]))
    n.fac      <- length(fac.levels)

    ms            <- .dot_marker_style(shape, pt.size, fill, border,
                                       pt_opacity)
    # color keyed by category name so hues match across facet panels
    cat.levels <- unique(as.character(cats[!is.na(cats)]))
    col.map    <- setNames(
                    .maketrans_plotly(.to_hex(rep_len(fill,
                                                      length(cat.levels))),
                                      alpha = pt_opacity),
                    cat.levels)
    seg.color     <- .to_hex(style_opts$segment_color)
    axis.x.clr    <- style_opts$axis_x_color %||% style_opts$axis_color
    axis.text.clr <- style_opts$axis_text_color

    val.fmt  <- .get.tick.fmt(vals[is.finite(vals)], digits_d)
    val.spec <- if (nzchar(val.fmt)) paste0(":", val.fmt) else ""
    if (orientation == "v") {
      cat.label <- if (nzchar(x_lab)) x_lab else "Category"
      val.label <- if (nzchar(y_lab)) y_lab else "Value"
      hover.tmpl <- paste0(cat.label, ": %{x}<br>",
                           val.label, ": %{y", val.spec, "}",
                           "<extra></extra>")
    } else {
      cat.label <- if (nzchar(y_lab)) y_lab else "Category"
      val.label <- if (nzchar(x_lab)) x_lab else "Value"
      hover.tmpl <- paste0(val.label, ": %{x", val.spec, "}<br>",
                           cat.label, ": %{y}",
                           "<extra></extra>")
    }
    draw.seg <- if (orientation == "h") isTRUE(segments_x)
                else                    isTRUE(segments_y)

    panels <- vector("list", n.fac)
    for (i in seq_along(fac.levels)) {
      fac.lab <- fac.levels[i]
      keep    <- fac.char == fac.lab & !is.na(fac.char)
      cats.i  <- as.character(cats[keep])
      vals.i  <- as.numeric(vals[keep])
      fin     <- is.finite(vals.i)

      pnl <- plotly::plot_ly()
      if (any(fin) && draw.seg) {
        # never above the panel's data minimum — avoid backward stems
        panel.min <- min(vals.i[fin], na.rm = TRUE)
        seg.start <- if (!is.null(origin_x)) min(origin_x, panel.min)
                     else                    0L
        pnl <- .dot_segment_trace(pnl, cats.i[fin], vals.i[fin], seg.color,
                                  orientation, seg.start)
      }
      pnl <- .dot_marker_trace(pnl, cats.i, vals.i,
        marker      = .dot_marker_list(ms, length(vals.i),
                        color_override = unname(col.map[cats.i])),
        orientation = orientation,
        hover.tmpl  = hover.tmpl)

      val.lbl <- if (orientation == "h") x_lab else y_lab
      cat.lbl <- if (orientation == "h") y_lab else x_lab
      val.ax <- .dot_val_axis(if (i == 1L) val.lbl else "", gridT, origin_x,
                              axis_color = axis.x.clr,
                              text_color = axis.text.clr)
      cat.ax <- .dot_cat_axis(cat.lbl, cats.i)

      pnl <- plotly::layout(pnl,
        xaxis    = if (orientation == "h") val.ax else cat.ax,
        yaxis    = if (orientation == "h") cat.ax else val.ax,
        template = NULL)
      pnl$x$layout$plot_bgcolor  <- .to_hex(style_opts$panel_fill)
      pnl$x$layout$paper_bgcolor <- .to_hex(style_opts$window_fill)
      panels[[i]] <- pnl
    }

    n.col.use <- facet_opts$n_col %||% min(n.fac, 3L)
    n.row.use <- ceiling(n.fac / n.col.use)

    plt <- plotly::subplot(panels,
      nrows  = n.row.use, shareX = TRUE, shareY = FALSE,
      titleX = TRUE, titleY = FALSE, margin = 0.06)

    # subplot() assigns domains automatically; extract them and hand to the
    # shared facet-layout helper so annotation formatting matches hier/radar.
    sub.domains <- lapply(seq_along(fac.levels), function(i) {
      sfx  <- if (i == 1L) "" else as.character(i)
      xax  <- plt$x$layout[[paste0("xaxis", sfx)]]
      yax  <- plt$x$layout[[paste0("yaxis", sfx)]]
      list(x = xax$domain %||% c(0, 1),
           y = yax$domain %||% c(0, 1))
    })
    ann <- .plotly_facet_layout(
      facet_levels = fac.levels,
      facet_name   = if (!is.null(facet_name) && nzchar(facet_name))
                       facet_name else "",
      domains      = sub.domains,
      yanchor      = "bottom",
      ann_adjust   = function(i, a, d) {
        a$y <- min(d$y[2] + 0.04, 0.99); a
      }
    )$annotations
    # bare-label panels (facet_name was empty) — drop the leading ": "
    if (is.null(facet_name) || !nzchar(facet_name))
      ann <- lapply(seq_along(ann), function(i) {
        ann[[i]]$text <- fac.levels[i]; ann[[i]]
      })

    plt <- plotly::layout(plt,
      annotations = ann,
      margin      = list(
                      t = if (!is.null(main)) round(title.size * 2.2) else 40,
                      b = 8, l = 20, r = 20),
      showlegend  = FALSE,
      title       = .dot_title(main),
      paper_bgcolor = .to_hex(style_opts$window_fill)
    )

    plt <- .finalize_plotly_widget(plt, kind="sp",
      x_name=x_lab, by_name="",
      add_title=FALSE,
      nudge_viewer=(.allow.interactive() &&
                    !isTRUE(getOption("knitr.in.progress"))))

    return(invisible(plt))
  }

  # ---- single-series dot plot ---------------------------------------------
  # Layout: single panel, vertical or horizontal orientation.
  pt_opacity <- max(0, min(1, as.numeric(pt_opacity[1])))
  if (!is.finite(pt_opacity)) pt_opacity <- 0.95

  cats <- as.character(cats)
  vals <- as.numeric(vals)

  # align lengths: ax.info$axL* may carry extra padding ticks beyond the data
  cats <- cats[seq_along(vals)]

  # Keep all categories on the axis — including those with NA vals — so that
  # e.g. row_names with missing y shows all names, just no dot for missing.
  # Remove only rows where the category label itself is NA.
  keep.cats <- !is.na(cats)
  cats <- cats[keep.cats]
  vals <- vals[keep.cats]
  cats.all <- cats   # full list for categoryarray

  if (length(cats) == 0L) return(plotly::plot_ly())

  ms        <- .dot_marker_style(shape, pt.size, fill, border, pt_opacity)
  seg.color <- .to_hex(style_opts$segment_color)

  # hover template — cat is %{x} or %{y} depending on orientation
  val.fmt  <- .get.tick.fmt(vals, digits_d)
  val.spec <- if (nzchar(val.fmt)) paste0(":", val.fmt) else ""
  if (orientation == "v") {
    cat.label <- if (nzchar(x_lab)) x_lab else "Category"
    val.label <- if (nzchar(y_lab)) y_lab else "Value"
    hover.tmpl <- paste0(cat.label, ": %{x}<br>",
                         val.label, ": %{y", val.spec, "}<extra></extra>")
  } else {
    cat.label <- if (nzchar(y_lab)) y_lab else "Category"
    val.label <- if (nzchar(x_lab)) x_lab else "Value"
    hover.tmpl <- paste0(val.label, ": %{x", val.spec, "}<br>",
                         cat.label, ": %{y}<extra></extra>")
  }

  plt <- plotly::plot_ly()
  # segments first so dots sit on top
  draw.seg <- if (orientation == "h") isTRUE(segments_x)
              else                    isTRUE(segments_y)
  if (draw.seg) {
    fin <- is.finite(vals)
    plt <- .dot_segment_trace(plt, cats[fin], vals[fin], seg.color,
                              orientation,
                              seg.start = origin_x %||% 0L)
  }
  # one palette color per category, same hues as the bar chart
  pt.cols <- .maketrans_plotly(.to_hex(rep_len(fill, length(vals))),
                               alpha = pt_opacity)
  plt <- .dot_marker_trace(plt, cats, vals,
    marker      = .dot_marker_list(ms, length(vals),
                                   color_override = pt.cols),
    orientation = orientation,
    hover.tmpl  = hover.tmpl)

  # axes: grid lines run perpendicular to the value axis
  grid.shapes <- if (!is.null(gridT)) {
    if (orientation == "v") y_grid(gridT) else x_grid(gridT)
  } else list()
  cat.ax <- .dot_cat_axis(if (orientation == "v") x_lab else y_lab, cats.all)
  val.ax <- .dot_val_axis(if (orientation == "h") x_lab else y_lab,
                          gridT, origin_x)

  if (orientation == "h") {
    plt <- plotly::layout(plt,
      xaxis    = val.ax, yaxis = cat.ax,
      shapes   = c(grid.shapes, plot_border()),
      margin   = list(l = 70,
                      t = if (!is.null(main)) round(title.size * 2.2) else 30),
      title    = .dot_title(main),
      template = NULL)
  } else {
    plt <- plotly::layout(plt,
      xaxis    = cat.ax, yaxis = val.ax,
      shapes   = c(grid.shapes, plot_border()),
      margin   = list(
                   t = if (!is.null(main)) round(title.size * 2.2) else 30,
                   b = 12),
      title    = .dot_title(main),
      template = NULL)
  }

  if (!is.null(height)) plt$height <- as.integer(height * 96L)

  plt$x$layout$plot_bgcolor  <- .to_hex(style_opts$panel_fill)
  plt$x$layout$paper_bgcolor <- .to_hex(style_opts$window_fill)

  if (is.null(plt$x$layout$margin)) plt$x$layout$margin <- list()
  b.default <- plt$x$layout$margin$b %||% 40
  plt$x$layout$margin$b <- max(b.default, if (nzchar(x_lab)) 60 else 0)

  plt <- .finalize_plotly_widget(
    plt,
    kind         = "sp",
    x_name       = x_lab,
    by_name      = "",
    add_title    = FALSE,
    nudge_viewer = TRUE
  )

  invisible(plt)
}

Prop_test <-
function (variable=NULL, success=NULL, by=NULL, data=d,
          n_succ=NULL, n_fail=NULL, n_tot=NULL, n_table=NULL,
          Yates=FALSE, pi=NULL, digits_d=3, ...) {

  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (length(dots) > 0) {
    for (i in seq_along(dots))
      if (names(dots)[i] == "p0") pi <- dots[[i]]
    dots[["p0"]] <- NULL  # do not forward the old name to the test functions
  }

  # length(x) is count_n(x) + count_NA(x)
  count_n <- function(x) sum(!is.na(x))
  count_NA <- function(x) sum(is.na(x))

  # classify analysis by (a) if data or freqs and (b) by type
  # ---------------------------------------------------------
  # data or not
  do_data <- is.null(n_succ) && is.null(n_tot) && is.null(n_table) 

  # type of analysis
  p1 <- FALSE  # analyze a single proportion
  pm <- FALSE  # compare proportions over groups
  gf <- FALSE  # goodness-of-fit
  ct <- FALSE  # cross-tabs independence
  # ---------------------------------------------------------

  # option to provide raw data from which to compute proportion information
  # two potential variables: variable and by
  # variable is required if entering data
  if (do_data) {
    data.vars <- as.list(seq_along(data))
    names(data.vars) <- names(data)
    ind.var <- eval(substitute(variable), envir=data.vars, parent.frame())
    nm.var <- names(data)[ind.var]
    if (!missing(by)) {
      null_by <- FALSE    
      ind.grp <- eval(substitute(by), envir=data.vars, parent.frame())
      nm.grp <- names(data)[ind.grp]
    }
    else
      null_by <- TRUE

    # discover the type of do_data analysis
    if (!is.null(success) && null_by) p1 <- TRUE
    if (!is.null(success) && !null_by) pm <- TRUE
    if (is.null(success) && null_by) gf <- TRUE
    if (!is.null(n_table)) ct <- TRUE
    if (is.null(success) && !null_by) ct <- TRUE
  }  # end do_data

  # provide proportion information directly
  else {
    if (!is.null(n_succ) && (is.null(n_tot) && is.null(n_fail)))  {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "When providing the number of successes, need the\n",
        "  corresponding number of trials, n_tot, or failures, n_fail.\n\n")
    }
    miss.n_table <- ifelse (is.null(n_table), TRUE, FALSE)

    if (!is.null(n_fail)) n_tot <- n_succ + n_fail
    if (length(n_succ) == 1 && !is.null(n_tot)) p1 <- TRUE
    if (length(n_succ) > 1 && !is.null(n_tot)) pm <- TRUE
    if (is.null(n_succ) && miss.n_table) gf <- TRUE
    if (!is.null(n_table)) ct <- TRUE
  }


  # --------------
  # one proportion
  if (p1) {  

    if (do_data) {
      n_NA <- count_NA(data[,ind.var])
      n_tot <- count_n(data[,ind.var])
      n_succ <- sum(data[,ind.var] == success, na.rm=TRUE)
    }

    if (is.null(pi)) pi <- 0.5
    out <- do.call(binom.test, c(list(n_succ, n_tot, p=pi), dots))
    p.sample <- .fmt(out$estimate, digits_d)
    alt <- out$alternative

    cat("\n")
    cat(paste("<<<", out$method, "of a proportion", "\n\n"))
    if (do_data) {
      cat("variable:", nm.var, "\n")
      cat("success:", success, "\n")
      cat("\n")
    }
    cat("------ Describe ------\n\n")
    if (do_data) cat("Number of missing values:", n_NA, "\n")
    cat("Number of successes:", out$statistic, "\n")
    cat("Number of failures:", n_tot - n_succ, "\n")
    cat("Number of trials:", out$parameter, "\n")
    cat("Sample proportion:", p.sample, "\n")
    cat("\n")

    cat("------ Infer ------\n\n")
    if (alt != "two.sided") 
      cat("Alternative hypothesis: Population proportion is", alt, "than",
          pi, "\n")
    cat("Hypothesis test for null of ", pi, ", p-value: ",
        .fmt(out$p.value, digits_d), sep="", "\n")
    cat("95% Confidence interval:", .fmt(out$conf.int[1], digits_d), "to",
        .fmt(out$conf.int[2], digits_d), "\n")

    return(invisible(out))
  }  # end p1


  # --------------------
  # multiple proportions
  if (pm) {

    if (do_data) {
      # if more than 2 levels, reduce to 2 levels
      if (length(unique(data[,ind.var])) > 2) {  
        for (i in 1:nrow(data))
          data[i,ind.var] <- ifelse (data[i,ind.var]==success, success, "fail")
      }

      # two-column table, Successes and Failures
      tbl <- table(data[,ind.grp], data[,ind.var]) 

      # if needed, re-order the two tbl columns, success in 1st column
      ind <- which(colnames(tbl) == success)
      if (length(ind) == 1 && ind != 1) {
        tbln <- tbl
        tbln[,1] = tbl[,2,drop=FALSE]
        tbln[,2] = tbl[,1,drop=FALSE]
        colnames(tbln)[1] = colnames(tbl)[2]
        colnames(tbln)[2] = colnames(tbl)[1]
        tbl <- tbln
      }
    }  # end do data

    else {  # construct the table from given proportion info
      n_fail <- n_tot - n_succ
      m <- matrix(c(n_succ, n_fail), byrow=FALSE, ncol=2)
      if (is.null(names(n_succ)))
        rn <-  1:nrow(m)
      else
        rn <- names(n_succ)
      dimnames(m) <- list(rn, c("Success", "Fail"))
      tbl <- as.table(m)
    }

    # do the analysis
    out <- do.call(prop.test, c(list(tbl, correct=Yates), dots))
    names(out$estimate) <- rownames(tbl)

    cat("\n")
    cat(paste("<<<", out$method, "\n\n"))
    if (do_data) {
      cat("variable:", nm.var, "\n")
      cat("success:", success, "\n")
      cat("by:", nm.grp, "\n")
    }

    cat("\n")
    cat("--- Description")
    ns <- .fmt(tbl[,1], 0)
    nt <- .fmt(rowSums(tbl), 0)
    vals <- t(.fmt(out$estimate, digits_d))
    vals <- as.vector(vals)
    m <- matrix(c(ns, nt, vals), byrow=TRUE, ncol=length(ns))
    k <- data.frame(m)
    names(k) <- names(out$estimate)
    nm1 <- paste("n_", success, sep="")
    row.names(k) <- c(nm1, "n_total", "proportion")
    k <- kable(k, format="pandoc", align="r")
    print(k)

    cat("\n")
    cat("--- Inference\n\n")
    cat("Chi-square statistic:", .fmt(out$statistic, digits_d), "\n")
    cat("Degrees of freedom:", .fmt(out$parameter, 0), "\n")
    cat("Hypothesis test of equal population proportions: p-value = ",
        .fmt(out$p.value,digits_d), sep="", "\n")

    return(invisible(out))
  }


  # ---------------
  # goodness-of-fit
  if (gf) {

    if (do_data) {
      tbl <- table(data[,ind.var])
      nms <- names(tbl)
    }
    else {
      tbl <- n_tot
      if (is.null(names(n_tot)))
        nms <-  1:length(n_tot)
      else
        nms <- names(n_tot)
    }

    # do the analysis
    out <- do.call(chisq.test, c(list(tbl), dots))

    obs <- .fmt(out$observed, 0)
    exp <- .fmt(out$expected, digits_d)
    res <- .fmt(out$residuals, digits_d)
    std <- .fmt(out$stdres, digits_d)

    cat("\n")
    cat(paste("<<<", out$method, "\n\n"))
    if (do_data)
      cat("variable:", nm.var, "\n")

    cat("\n")
    cat("--- Description")
    m <- matrix(c(obs,exp,res,std), byrow=TRUE, ncol=length(tbl))
    k <- data.frame(m)
    names(k) <- nms
    row.names(k) <- c("observed", "expected", "residual", "stdn res")
    k <- kable(k, format="pandoc", align="r")
    print(k)

    cat("\n")
    cat("--- Inference\n\n")
    cat("Chi-square statistic:", .fmt(out$statistic, digits_d), "\n")
    cat("Degrees of freedom:", .fmt(out$parameter, 0), "\n")
    cat("Hypothesis test of equal population proportions: p-value = ",
        .fmt(out$p.value,digits_d), sep="", "\n")

    return(invisible(out))
  }  # end gf


  # -----------------------
  # cross-tabs independence
  if (ct) {

    if (do_data) {
      tbl <- table(data[,ind.grp], data[,ind.var])
      names(attributes(tbl)$dimnames) <- c(nm.grp, nm.var)

      cat("variable:", nm.var, "\n")
      cat("by:", nm.grp, "\n")
    }  # end do_data

    else {  # freq input
      # read the cross-tab table
      if (nchar(n_table) == 0) {
        n_table <- file.choose()
        cat("File: ", n_table, "\n\n")
      }
      if (grepl(".csv$", n_table) || grepl(".txt$", n_table)) 
        tbl <- read.csv(n_table, header=FALSE)
      else if (grepl(".xlsx$", n_table)) 
        tbl <- openxlsx::read.xlsx(n_table)
      else if (grepl("FreqTable99$", n_table)) { 
        f.nm <- "dataFreqTable99.rda"
        path.name <- paste(find.package("lessR"), "/data/",  f.nm, sep="")
        x.env <- new.env()  # scratch environment
        load(path.name, envir=x.env)
        dname <- "dataFreqTable99"
        tbl <- get(dname, pos=x.env)
      }
      else {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Frequency table file must be of file type\n",
          "  .csv for a Comma Separated Value text file or\n",
          "  .xlsx for an Excel file.\n\n")
      }
      suppressWarnings(names(tbl) <- rep("", ncol(tbl)))
    }  # end freq input

    # analysis
    out <- do.call(chisq.test, c(list(tbl, correct=Yates), dots))

    n.cases <- sum(rowSums(tbl))
    min_rc <- min(nrow(tbl)-1, ncol(tbl)-1)
    V <- sqrt(out$statistic / (min_rc * n.cases))
    txt <- ifelse(out$parameter == 1, " (phi)", "")
    txt <- paste("Cramer\'s V", txt, ":", sep="")

    obs <- .fmt(out$observed, 0)
    exp <- .fmt(out$expected, digits_d)
    res <- .fmt(out$observed - out$expected, digits_d)  # raw residual
    std <- .fmt(out$stdres, digits_d)

    k <- data.frame(row.names=1:(nrow(tbl)*ncol(tbl)))
    k[,1] <- rep(1:nrow(tbl), ncol(tbl))
    k[,2] <- rep(1:ncol(tbl), each=nrow(tbl))
    k[,3] <- obs; k[,4] <- exp;  k[,5] <- res;  k[,6] <- std
    names(k) <- c("Row", "Col", "Observed", "Expected", "Residual", "Stnd Res")
    k <- k[order(k[,1]),]  # display by row

    cat("\n")
    cat(paste("<<<", out$method, "\n\n"))

    cat("--- Description\n\n")
    if (do_data)
      print(addmargins(tbl))
    else {
      cat("Cell Frequencies")
      print(tbl, row.names=FALSE)
    }
    cat("\n", txt, .fmt(V,3), "\n\n")
    print(k, row.names=FALSE)

    cat("\n")
    cat("--- Inference\n\n")
    cat("Chi-square statistic:", .fmt(out$statistic, digits_d), "\n")
    cat("Degrees of freedom:", .fmt(out$parameter, 0), "\n")
    cat("Hypothesis test of independence: p-value = ",
        .fmt(out$p.value,digits_d), sep="", "\n")

    return(invisible(out))

  }  # end ct

}

  skew <- function(x, na.rm=TRUE) {
  # skewness:  adjusted Fisher-Pearson standardized moment coefficient

    if (na.rm) x <- na.omit(x)
    n <- length(x)

    if (n > 2) {

      m <- mean(x)
      s <- sd(x)

      g1 <- sum(((x-m) / s)^3)

      sk.coef <- n / ((n-1)*(n-2))
      sk <- sk.coef * g1
    }

    else
      sk <- NA

    return(sk)

  }

.logit3Residual <-
function(lm.out, nm, d,
         n.vars, n.pred, n.obs, n.keep, digits_d, pre, line,
         res_sort, res_rows, cooks_cut) {
  
    cat( "\n", "  ANALYSIS OF RESIDUALS AND INFLUENCE", "\n")

    # for the logit model, R's rstudent() returns the standardized
    #   Pearson residual, pearson / sqrt(1 - hat), not the
    #   Studentized residual of a linear model
    cat("Data, Fitted, Residual, Standardized Pearson Residual, Dffits,",
        "Cook's Distance\n")
    if (res_sort == "cooks") cat("   [sorted by Cook's Distance]\n")
    if (res_sort == "rstudent")
      cat("   [sorted by Standardized Pearson Residual,",
          "ignoring + or - sign]\n")
   if (res_sort == "dffits")  
      cat("   [sorted by dffits, ignoring + or - sign]\n")
    txt <- "cases (rows) of data]"
    cat("   [res_rows = ", res_rows, " out of ", n.keep, " ", txt, sep="", "\n")
    .dash(68)

    fit <- fitted(lm.out)
    res <- residuals(lm.out, type="response")
    cook <- cooks.distance(lm.out)
    
    out <- cbind(fit, res, rstudent(lm.out), dffits(lm.out), cook)
    out <- cbind(lm.out$model[c(nm[-1], nm[1])], out)
    out <- data.frame(out, stringsAsFactors=TRUE)
    names(out)[n.vars+1] <- "P(Y=1)"
    names(out)[n.vars+2] <- "residual"
    names(out)[n.vars+3] <- "rstudent"
    names(out)[n.vars+4] <- "dffits"
    names(out)[n.vars+5] <- "cooks"
    if (res_sort != "off") {
      o <- seq_len(nrow(out))  # default: no reorder; overwritten below
      if (res_sort == "cooks") o <- order(out$cooks, decreasing=TRUE)
      if (res_sort == "rstudent") o <- order(abs(out$rstudent),
        decreasing=TRUE)
      if (res_sort == "dffits") o <- order(abs(out$dffits),
        decreasing=TRUE)
      out <- out[o,]
    }
    print(out[seq_len(min(res_rows, nrow(out))),], digits=digits_d)
    .dash(68)

}

.dpmat.main <-   # BPFM (even for just 1 row)
function(x, l, sort_type,  # no y variable
         fill, color, col.bg,
         trans, shape_pts, col.box, 
         col.low, col.hi,
         xy_ticks, xlab, ylab, main, sub, cex,

         radius, power, size_cut, txt_color="black",
         bm.adj, lm.adj, tm.adj, rm.adj,
         rotate_x, rotate_y, offset, quiet,
         do_plot, fun_call=NULL, ...)  {

  col.area <- fill  # kludge
  size.txt <- getOption("axis_size")

  # if exist, get axes labels
  gl <- .getlabels(xlab, ylab, main)
  x.lab <- gl$xb
  y.lab <- gl$yb
  main.lab <- gl$mb
  sub.lab <- gl$sb

  n.var <- ncol(x)

  # get the response categories for each variable
  #   but if numeric or character, are encoded as character
  # if 1st row from table misses first numeric values, 
  #   union does not preserve numeric order
  # if responses are defined from a factor, then order preserved
  resp <- NULL
  for (i in seq_len(n.var)) {
    tbl <- table(x[,i])
    resp <- union(resp,names(tbl))
  }
  n.resp <- length(resp)

  # if responses are numeric encoded as chars, do a numeric sort
  x.resp <- NULL
  if (suppressWarnings(all(!is.na(as.numeric(as.character(resp)))))) {
    x.resp <- as.numeric(as.character(resp))
    x.resp <- base::sort(x.resp)
    resp <- as.character(x.resp)
  }

  # get the frequencies for each response, including 0
  frq <- NULL
  frq.i <- integer(length=n.resp)
  names(frq.i) <- resp
  for (i in seq_len(n.var)) {
    tbl <- table(x[,i])   
    for (j in seq_along(frq.i)) frq.i[j] <- 0
    for (j in seq_along(frq.i))
      if (names(frq.i)[j] %in% names(tbl))
        frq.i[j] <- tbl[which(names(tbl) == names(frq.i)[j])]
    frq <- c(frq, frq.i)
  }

  # frequency table
  mytbl <- matrix(frq, nrow=n.resp, ncol=n.var)
  rownames(mytbl) <- names(frq.i)
  colnames(mytbl) <- names(x)
  mytbl <- t(mytbl)  # rows are variables, cols are responses

  # calculate weighted means of each variable
  w <- integer(length=n.resp)
  if (!is.null(x.resp))
    w <- x.resp  # use existing integer codes
  else
    w <- seq_len(n.resp)
  m <- integer(length=n.var)
  for (i in seq_len(n.var)) m[i] <- round(weighted.mean(w, mytbl[i,]), 3)
  if (sort_type != "0") {
    srt.dwn <- sort_type == "-"
    m.o <- order(m, decreasing=srt.dwn)
    mytbl <- mytbl[m.o,]
    m <- m[m.o]
  }
  else
    m.o <- seq_len(n.var)
    
  # melt the table to a data frame
  k <- 0
  n.count <- nrow(mytbl) * ncol(mytbl)
  xx <- integer(length=n.count)
  yy <- integer(length=n.count)
  count <- integer(length=n.count)
  for (i in seq_len(nrow(mytbl))) {
    for (j in seq_len(ncol(mytbl))) {
      k <- k + 1
      count[k] <- mytbl[i,j]
      xx[k] <- j
      yy[k] <- i
    }
  }
  cords <- data.frame(xx, yy, count, stringsAsFactors=TRUE)

  cnt <- cords$count  # 0 plots to a single pixel, so remove
  for (i in seq_along(cnt)) if (cnt[i]==0) cnt[i] <- NA

  if (do_plot) {
    # set margins
    y.lvl <- rownames(mytbl)
    max.width <- strwidth(y.lvl[which.max(nchar(y.lvl))], units="inches")
  
    # here keep same bm if 1 or 2 line x labels
    margs <- .plt.marg(max.width, y.lab, x.lab, main, rotate_x) 
    bm <- margs$bm
    lm <- margs$lm
    tm <- margs$tm
    rm <- margs$rm
  
    # user manual adjustment
    bm <- bm + bm.adj
    lm <- lm + lm.adj
    tm <- tm + tm.adj
    rm <- rm + rm.adj

    bm <- bm + 0.15
    if (rotate_x > 0) bm <- bm + 0.15
   
    orig.params <- par(no.readonly=TRUE)
    on.exit(par(orig.params))
    
    par(bg=getOption("window_fill"))
    par(mai=c(bm, lm, tm, rm))
    par(tcl=-0.28)  # axis tic length

    # set up plot area
    plot(cords$xx, cords$yy, type="n", axes=FALSE, ann=FALSE, 
         xlim=c(.5, n.resp+.5), ylim=c(.5, n.var+.5))

    # axis, axis ticks, value labels
    x.lvl <- colnames(mytbl)
    x.lvl <- gsub(" ", "\n", x.lvl)

    .plt.bck(par("usr"), axTicks(1), seq_len(n.var))

    # adjust axis label from tick with mgp[2]
    # mgp does not work with rotate_x, see .axes()
    my.mgp <- par("mgp")  # save to restore
    ax <- .axes_dim()  # get axis value parameters
    mgp2 <- 0.250 + (1.05 * ax$axis_x_size)
    par(mgp = c(my.mgp[1], mgp2, my.mgp[3]))  # labels closer to axis
    adj <- .RSadj(axis_size=ax$axis_x_size); axis_x_size <- adj$axis_size

    .axes(x.lvl, y.lvl, seq_along(x.lvl), seq_len(n.var),
          rotate_x=rotate_x, rotate_y=rotate_y, offset=offset, ...)

    .axlabs(x.lab, y.lab, main.lab, sub.lab,
            xy_ticks=TRUE, offset=offset, ...) 

    # colors
    if (is.null(col.low) || is.null(col.hi))
      clr <- fill
    else {
      color_palette <- colorRampPalette(c(col.low, col.hi))
      clr <- color_palette(n.resp)
    }

    # bubbles
    # KLUDGE, trans default can be 0, so add some, need a lighter gray instead
    if (!is.null(trans)) {
      if (trans < 0.1) trans <- trans + .2
      trans_pts <- trans
      for (i in seq_along(clr)) clr[i] <- .maketrans(clr[i], (1-trans_pts)*256)
    }

    # scale for regular R or RStudio
    nch <- nchar(as.character(max(cords$count)))
    if (is.null(radius)) {
      radius <- -.35 + (.2*nch)
      if (radius < .22) radius <- .22
    }
    adj <- .RSadj(radius)
    radius <- adj$radius

    sz <- cnt**power 
    symbols(cords$xx, cords$yy, circles=sz, bg=clr, 
            fg=color, inches=radius, add=TRUE, ...)

    # counts
    if (size_cut) { 
      max.c <- max(cnt, na.rm=TRUE)  # do not display count if bubble is too small
      min_bubble <- (power/2.5) * max.c
      for (i in seq_along(cnt))
        if (!is.na(cnt[i])) if (cnt[i] <= min_bubble) cnt[i] <- NA
      text(cords$xx, cords$yy, cnt, cex=size.txt, col=txt_color)
    }
  }  # end do_plot


  # ------------
  # text output

  if (!quiet) {
  
    if (getOption("suggest")) {
      # function call for suggestions
      fncl <- .fun_call.deparse(fun_call) 
      fncl <- gsub(")$", "", fncl)  # get function call less closing ) 
      fncl <- gsub(" = ", "=", fncl)
    }  # display suggestions
    
    txsug <- ""
    if (getOption("suggest")) {
      txsug <- ">>> Suggestions"
      fc <- ""
      if (!grepl("radius", fncl))
        fc <- paste(fc, ", radius=0.3", sep="")
      if (nzchar(fc)) {
        fc <- paste(fncl,  fc, ") ", sep="")
        txsug <- paste(txsug,"\n", fc, sep="")
      }
            
      txsug <- .rm.arg.2(" x=", txsug) 
    }

    # display variable labels
    txlbl <- ""
    if (!is.null(l)) {
      l <- l[rownames(mytbl),]  # l is a data frame
      tx <- character(length = 0)
      tx[length(tx)+1] <- ">>> Labels"
      for (i in seq_along(rownames(mytbl))) {
        if (is.data.frame(l)) 
          ml <- l[i,]
        else
          ml <- l[i]
        if (!is.na(ml))
          tx[length(tx)+1] <- paste(rownames(mytbl)[i], ": ", ml, sep="")
      }
      txlbl <- tx
    }

    # display frequencies and means of each variable
    txttl <- "Frequencies of Responses by Variable"
    tx <- character(length = 0)
    mx.chr <- max(nchar(colnames(mytbl)))
    mx.len <- 8
    if (mx.chr > mx.len) {
      c.nm <- colnames(mytbl)
      colnames(mytbl) <- .abbrev(colnames(mytbl), mx.len)
    }
    myt <- addmargins(mytbl, margin=2)
    txtbl <- .prntbl(myt, 0, cc=NULL)
    for (i in seq_along(txtbl)) tx[length(tx)+1] <- txtbl[i]
    mx <- max(nchar(m))
    txtbl[1] <- paste(txtbl[1], .fmtc("Mean", w=mx+1))
    for (i in seq_len(n.var)) txtbl[i+1] <- paste(txtbl[i+1], .fmt(m[i],3,w=mx+1))
    if (mx.chr > mx.len) {
      txtbl[n.var+2] <- ""
      txtbl[n.var+3] <- ""
      txtbl[n.var+4] <- "Unabbreviated labels"
      txtbl[n.var+5] <- "--------------------"
      txtbl[n.var+6] <- paste(c.nm, sep="", collapse="\n")
    }
    strt <- if (mx.chr > mx.len) 7 else 2
    if (is.null(x.resp)) {
      txtbl[n.var+strt] <- ""
      txtbl[n.var+strt+1] <- paste("Computation of the mean based on coding",
                                   "response categories from 1 to", n.resp)
    }
    myt <- cbind(myt, m[m.o])
    colnames(myt)[n.resp+2] <- "Mean"    
    txfrq <- txtbl
   
    class(txsug) <- "out"
    class(txlbl) <- "out"
    class(txttl) <- "out"
    class(txfrq) <- "out"
    
    if (nzchar(txsug))
      output <- list(out_suggest=txsug,
                     out_labels=txlbl, txout_title=txttl, out_freq=txfrq)
    else
      output <- list(out_labels=txlbl, txout_title=txttl, out_freq=txfrq)
                     
    class(output) <- "out_all"
    print(output)
    
  }  # end !quiet

}

savePlotly <- function(obj = NULL, file = NULL, open = TRUE,
                       selfcontained = TRUE, libdir = NULL) {
  if (is.null(obj)) obj <- getOption("lessR.last_plotly", NULL)
  if (is.null(obj))
    stop("No recent Plotly chart found. Run a chart first or pass an object.")

  if (!inherits(obj, "htmlwidget")) {
    if (inherits(obj, "plotly")) obj <- plotly::plotly_build(obj)
    else stop("The object is not a Plotly/htmlwidget chart.")
  }

  kind  <- attr(obj, "lessR_kind")
  if (is.null(kind) || !nzchar(kind)) kind <- "plotly"
  xname <- attr(obj, "lessR_xname")
  if (is.null(xname)) xname <- ""
  bynm  <- attr(obj, "lessR_byname")
  if (is.null(bynm))  bynm  <- ""

  # Fallback: parse title like "X by Y"
  if (!nzchar(xname) || !nzchar(bynm)) {
    ttl <- attr(obj, "lessR_title")
    if (is.null(ttl) && !is.null(obj$x$layout$title)) {
      raw <- obj$x$layout$title
      ttl <- if (is.list(raw) && !is.null(raw$text))
               raw$text else as.character(raw)
    }
    ttl_plain <- trimws(gsub("<[^>]+>", "", `%||%`(ttl, ""), perl = TRUE))
    parts <- strsplit(ttl_plain, "\\s+by\\s+", perl = TRUE)[[1]]
    if (length(parts) == 2L) {
      if (!nzchar(xname)) xname <- parts[1]
      if (!nzchar(bynm))  bynm  <- parts[2]
    } else if (!nzchar(xname)) {
      xname <- ttl_plain
    }
  }

  # Robust cleanup: strip any trailing "chart", then sanitize
  normalize_name <- function(s) {
    s <- trimws(s)
    s <- sub("(?i)\\s+chart\\s*$", "", s, perl = TRUE)  # "Years chart" -> "Years"
    s <- gsub("[^A-Za-z0-9]+", "", s)                       # collapse to safe tokens
    s <- sub("(?i)chart$", "", s, perl = TRUE)              # "Yearschart"  -> "Years"
    if (!nzchar(s)) "" else s
  }

  kind_s  <- gsub("[^A-Za-z0-9]+", "", kind)
  xname_s <- normalize_name(xname)
  bynm_s  <- normalize_name(bynm)

  tag <- if (nzchar(bynm_s)) paste0(xname_s, "_", bynm_s) else xname_s

  # Build parts while avoiding duplicate "plotly"
  parts <- c("plotly", if (nzchar(kind_s) && tolower(kind_s) != "plotly") kind_s, tag)
  parts <- parts[nzchar(parts)]

  base <- paste(parts, collapse = "_")
  if (!nzchar(base)) base <- "plotly_chart"  # final fallback

  if (is.null(file) || is.na(file) || !nzchar(file)) {
    file <- file.path(getwd(), paste0(base, ".html"))
  }

  if (!isTRUE(selfcontained) && is.null(libdir))
    warning("selfcontained=FALSE with libdir=NULL: dependency files will be written ",
            "relative to the output file; ensure that location is writable.",
            call. = FALSE)
  htmlwidgets::saveWidget(obj, file, selfcontained = selfcontained,
                          libdir = libdir, background = "white")

  abs_path <- tryCatch(normalizePath(file, winslash = "/", mustWork = TRUE),
                       error = function(e) file)
  cat("Plotly chart saved to:\n  ", abs_path, "\n", sep = "")
  if (isTRUE(open)) utils::browseURL(abs_path)
  invisible(abs_path)
}

# plot legend for size variables, i.e., bubbles
.plt.sym.legend <-
function(size, fill, color, shp, usr, radius, power, bub.alpha) {

  min.size <- min(size, na.rm=TRUE)
  max.size <- max(size, na.rm=TRUE)
  raw.vals <- seq(min.size, max.size, length.out=3)  # 3 evenly spaced values
  mylevels <- round(raw.vals)

  par(xpd=NA)  # allow drawing outside of plot region

  ll <- legend(0,0, legend=mylevels, title=getOption("sizename"), cex=.7,
               pt.cex=1.25, pt.lwd=0.5, plot=FALSE)

  size.inch <- (par("cxy")/par("cin"))  # 1 inch in user coords for x and y axes

  epsilon <- (size.inch[1] - ll$rect$w) / 2   # x size
  if (epsilon < 0) epsilon <- .04  # do not have label overlap plot

  nch <- nchar(getOption("sizename"))
  hz.buf <- ifelse (nchar(getOption("sizename")) < 13, 1.4, 4.7)
  hz.buf <- -2.23 + (0.467*nch)
  hz.buf <- 1.544 + (0.00014*(nch^3.8))

  axis_vert <- usr[4] - usr[3]  # range of y-axis in user coords
  xleft <- usr[2] + epsilon*hz.buf # usr[2] user coordinate of right axis
  lgnd.vhalf <- (ll$rect$h) / 2
  axis_cntr <- axis_vert / 2  + usr[3]
  ytop <- axis_cntr + lgnd.vhalf  # user coordinate of legend top

  # scale for regular R or RStudio
  adj <- .RSadj(radius=radius)  # reg R multiply by 1.6
  radius <- adj$radius

  x.coords <- rep(xleft, 3)  # in user coordinates
  y.coords <- (ytop + size.inch[2]*.30) + (ll$text$y * 1.8)  # y size

  fill.alpha <- fill
#  fill.alpha <- .maketrans(fill, bub.alpha)  # wipes out all fill color
  sz <- mylevels**power  # radius unscaled for all the points
  symbols(x.coords, y.coords, circles=sz, inches=radius,
          fg=color, bg=fill.alpha, add=TRUE)

  # labels text and title
  x.offset <- strwidth("00") * 1.2 
  text(x.coords + x.offset, y.coords, labels=mylevels, adj=0,
       cex=getOption("axis_size")*.95)
  text(xleft+(x.offset/1.25), max(y.coords) + strheight("X")*2,
       labels=getOption("sizename"), cex=getOption("lab_size")*.9)

  par(xpd=FALSE)  # cancel drawing outside of plot region (need for RStudio)
}

.dn.main <- 
function(x, by=NULL, by.name=NULL, n.by=1, 
         bw="nrd0", kind="both",
         histo=TRUE, theme=getOption("theme"), bin_start=NULL, bin_width=NULL,
         fill.miss=FALSE, fill_hist, col.nrm, col.gen,
         fill_nrm, fill_gen, lwd=NULL,
         rotate_x=0, rotate_y=0, offset=0.5, 
         axis_fmt="K", axis_x_pre="", axis_y_pre="",
         x.pt=NULL, xlab=NULL, main=NULL, sub=NULL,
         y_axis=FALSE, x.min=NULL, x.max=NULL,
         band=FALSE, color_rug="gray40", size_rug=0.5,
         full_curve=TRUE,
         use_plotly=TRUE, quiet, fncl=NULL, style_opts = NULL,
         do_plot=TRUE, fill_area=TRUE, ...)  {
  

  if (!is.null(x.pt)) {
    y_axis <- TRUE
    kind <- "general"
  }


# estimate the histogram and/or curves ------------------------------------

  # no missing data
  n <- sum(!is.na(x))
  n.miss <- sum(is.na(x))
  if (n.miss > 0) x <- na.omit(x)

  # get breaks from user supplied bin width and/or supplied start value
  # otherwise, breaks="Sturges by default
  # copied from histogram
  if (!is.null(bin_width)  || !is.null(bin_start)) {
    if (is.null(bin_start))
       bin_start <- pretty(range(x, na.rm=TRUE))[1]
    if (is.null(bin_width)) {
      h <- hist(x, plot=FALSE, breaks="Sturges")
      bin_width <- h$breaks[2]-h$breaks[1]
    }
    max.x <- max(x, na.rm = TRUE)
    seq.end <- max.x
    breaks <- seq(bin_start, seq.end, bin_width)
    while (max(breaks) < max.x) {
      seq.end <- seq.end + bin_width
      breaks <- seq(bin_start, seq.end, bin_width)
    }
  }
  else
    breaks="Sturges"

  if (is.null(main)) {
    orig.params <- par(no.readonly=TRUE)
    on.exit(par(orig.params))
    par(mar=c(4,4,2,2)+0.1)
  }

  # histogram calculations, no plot
  h <- hist(x, plot=FALSE, breaks)
 
  # general density curve, no plot
  # suppress warnings about possible graphic parameters
  d.gen <- suppressWarnings(density(x, bw, ...))

  # min and max x coordinates for graph (honour user-supplied values)
  if (is.null(x.min))
    x.min <- if (full_curve) min(d.gen$x) else min(x, na.rm = TRUE)
  if (is.null(x.max))
    x.max <- if (full_curve) max(d.gen$x) else max(x, na.rm = TRUE)
  
  # normal density curve, no plot
  xx <- seq(x.min, x.max, length=200)
  d.nrm <- dnorm(xx, mean(x), sd(x))

  # max y coordinate for graph
  # need to estimate all three objects in all cases: re-work
  y.max <- max(max(d.nrm), max(d.gen$y), max(h$density))


# set up plot area --------------------------------------------------------

  # plot parameters
  col.bg <- getOption("panel_fill")
  col.box <- getOption("panel_color")

  axis_size <- getOption("axis_size")
  col.axis <- getOption("axis_text_color")

  # get lab_x_size  lab_y_size
  lab_size <- getOption("lab_size")
  lab_x_size <- getOption("lab_x_size")
  lab_x_size <- ifelse(is.null(lab_x_size), lab_size, lab_x_size)
  adj <- .RSadj(lab_size=lab_x_size); lab_x_size <- adj$lab_size

  # get variable labels if exist plus axes labels
  gl <- .getlabels(xlab, ylab=NULL, main, lab_x_size=lab_x_size) 
  x.name <- gl$xn; x.lbl <- gl$xl; x.lab <- gl$xb
  main.lab <- gl$mb
  sub.lab <- gl$sb

if (n.by == 1  &&  do_plot) {

  # set margins
  if (band)  # rug, allow for more rug room
    y.min <- -0.02 * max(d.gen$y)  # make room for the rug
  else
    y.min <- 0
  margs <- .plt.marg(0, y.lab=NULL, x.lab, main, sub, lab_x_size=lab_x_size)
  lm <- margs$lm
  tm <- margs$tm
  rm <- margs$rm
  bm <- margs$bm
 
  if (y_axis) lm <- lm + 0.6  # allow extra room for densities

  orig.params <- par(no.readonly=TRUE)
  on.exit(par(orig.params), add=TRUE)  

  par(bg=getOption("window_fill"))
  par(mai=c(bm, lm, tm, rm))

  
  # set up coordinate space
  plot(h, border="transparent", freq=FALSE,
     xlim=c(x.min,x.max), ylim=c(y.min,y.max),
     axes=FALSE, ann=FALSE, xlab=NULL, ylab=NULL, main=NULL, ...)

  # adjust axis label from tick with mgp[2]
  # mgp does not work with rotate_x, see .axes()
  my.mgp <- par("mgp")  # save to restore
  ax <- .axes_dim()  # get axis value parameters
  mgp2 <- -0.350 + (0.9 * ax$axis_x_size)
  par(mgp = c(my.mgp[1], mgp2, my.mgp[3]))  # labels closer to axis
  adj <- .RSadj(axis_size=ax$axis_x_size); axis_x_size <- adj$axis_size

  # axis, axis ticks
  par(tcl=-0.28)  # axis tic length
  if (!y_axis)
    ax.info <- .axes(x.lvl=NULL, y.lvl=NULL, axTicks(1), NULL,
          rotate_x=rotate_x, rotate_y=rotate_y, offset=offset,
          axis_fmt=axis_fmt, axis_x_pre=axis_x_pre, axis_y_pre="no", ...)
  else
    ax.info <- .axes(x.lvl=NULL, y.lvl=NULL, axTicks(1), axTicks(2),
          rotate_x=rotate_x, rotate_y=rotate_y, offset=offset,
          axis_fmt=axis_fmt, axis_x_pre=axis_x_pre, axis_y_pre=axis_y_pre, ...)

  # axis value labels
  if (!y_axis) y.lab="" else y.lab="Density"
  .axlabs(x.lab, y.lab=y.lab, main.lab, sub.lab,
          xy_ticks=TRUE, offset=offset, ...) 

  # colored background for plotting area
  usr <- par("usr")
  rect(usr[1], usr[3], usr[2], usr[4], col=col.bg, border=col.box,
    lwd=getOption("panel_lwd"), lty=getOption("panel_lty"))
  

# plot the objects --------------------------------------------------------


    # plot the previously computed histogram
    if (histo)
      plot(h, add=TRUE, freq=FALSE, col=fill_hist, border="transparent")

    # plot the previously estimated normal curve
    if (kind == "normal" || kind == "both") {
      lwd.nrm <- if (!is.null(lwd)) lwd else ifelse(fill_nrm == "transparent", 1.35, 1)
      polygon(c(x.min,xx,x.max), c(0,d.nrm,0), col=fill_nrm,
              border=col.nrm, lwd=lwd.nrm)
    }

    # plot the previously computed general curve
    if (kind == "general" || kind == "both") {
      lwd.gen <- if (!is.null(lwd)) lwd else ifelse(fill_gen == "transparent", 1.35, 1)
      fill_gen <- .maketrans(fill_gen, 100)
      polygon(d.gen, col=fill_gen, border=col.gen, lwd=lwd.gen)
    }

    # plot the rug option
    if (band) rug(x, col=color_rug, lwd=size_rug, ticksize=0.05)
   
    # plot the optional bar about a chosen point for general curve only
    if (!is.null(x.pt)  &&  kind == "general") {
      d <- d.gen
      y.pt <- d$y[which.min(abs(x.pt-d$x))]
      xbeg <- x.pt - 0.5
      xend <- x.pt + 0.5
      xsub <- d$x[d$x > xbeg & d$x < xend]
      ysub <- d$y[d$x > xbeg & d$x < xend]
      txt <- paste("Density =", .fmt(y.pt,3), "at x =", .fmt(x.pt, 2))
      title(main=txt)
      polygon(c(xbeg, xsub, xend), c(0, ysub, 0), col="lightsteelblue")
      if (min(x) > 0) left <- -2*min(x) else left <- 2*min(x) 
      lines(c(left,x.pt), c(y.pt,y.pt), col="darkblue", lwd = 0.5)
      lines(c(x.pt,x.pt), c(0,y.pt), col="darkblue", lwd = 0.5)
    }
}  # end n.by=1



# text output -------------------------------------------------------------

  tx <- character(length = 0)
  if (getOption("suggest")) {

    # function call for suggestions
    fncl <- .fun_call.deparse(fncl) 
    fncl <- gsub(")$", "", fncl)  # get function call less closing ) 
    fncl <- gsub(" = ", "=", fncl)

    tx[length(tx)+1] <- ">>> Suggestions"
      tx[length(tx)+1] <- "bin_width: set the width of each bin"
    txt <- "  # histogram only"
    tx[length(tx)+1] <- paste("X(", getOption("xname"), ", type=\"histogram\"",
       ")", txt, sep="")      
    txt <- "  # Violin/Box/Scatterplot (VBS) plot"
    tx[length(tx)+1] <- paste("X(", getOption("xname"), ", type=\"vbs\"", 
                              ")", txt, sep="")      
  }
  txsug <- tx
  if (length(txsug) == 0) txsug <- ""

  tx <- character(length = 0)

  tx[length(tx)+1] <- paste( "--- Bandwidth ---",
         "     for general curve:", .fmt(d.gen$bw,4), "\n")

  W <- NA_character_; p.val <- NA_character_
  if (kind == "normal" || kind == "both") {
    digits_d <- 3
    if (n > 2 && n < 5000) {
      nrm <- shapiro.test(x)
      W <- .fmt(nrm$statistic,min(4,digits_d+1))
      p.val <- .fmt(nrm$p.value,min(4,digits_d+1))
      tx[length(tx)+1] <- " "
      tx[length(tx)+1] <- paste("Null hypothesis is a normal population")
      tx[length(tx)+1] <- paste(nrm$method, ":  W = ", W, ",  p-value = ",
        p.val, sep="")
    }
    else 
      tx[length(tx)+1] <- paste("Sample size out of range for Shapiro-Wilk",
                          " normality test.")
  }


# plotly ------------------------------------------------------------------

  if (use_plotly  &&  do_plot) {

    if (fill.miss) {  # this should already be determined
      if (n.by == 1)
        fill <- fill_gen
      else {
        fill     <- .color_range(.get_fill(theme), n.by)
        fill_gen <- fill
      }
    }
    else  # evaluate if a pre-defined range such as "blues"
      fill_gen <- .color_range(fill_gen,  n.by)

#   rng.y <- range(d.gen$y)
#   ax.info <- .axes(x.lvl=NULL, y.lvl=NULL, pretty(range(x)), pretty(rng.y),
#         rotate_x=rotate_x, rotate_y=rotate_y, offset=offset,
#         axis_fmt=axis_fmt, axis_x_pre=axis_x_pre, axis_y_pre=axis_y_pre, ...)
#   axT1 <- pretty(range(x))
#   axL1 <- .axis.format(axT1, axis_fmt, axis_x_pre, axis_y_pre="no")
#   axT2 <- pretty(rng.y)
#   axL2 <- .axis.format(axT2, axis_fmt, axis_x_pre="no", axis_y_pre)
#   ax <- list(axT1=axT1, axL1=axL1, axT2=axT2, axL2=axL2)


    # Drop groups with fewer than 2 finite observations
    tbl <- table(by)
    drop_groups <- names(tbl)[tbl < 2]

    if (length(drop_groups)) {
      message("Groups with fewer than 2 observations removed: ",
              paste(drop_groups, collapse = ", "))
      keep <- !(by %in% drop_groups)
      x  <- x[keep]
      by <- by[keep]
    }

    plt <- dn.plotly(
      x          = x,
      by         = by,
      x_name     = x.name,
      by_name    = by.name,
      fill       = fill_gen,
#     border     = col.gen,
      x_lab      = x.lab,
      y_lab      = "Density",
      ax         = if (n.by == 1) ax.info else NULL,
      gridT1     = NULL,
      gridT2     = NULL,
      bw         = bw,
      full_curve = full_curve,
      fill_area  = fill_area,
      style_opts = style_opts %||% .plotly_style()
    )

    if (.allow.interactive()) print(plt)
  }

# --- final return from dn.main() --------------------------------------------
return(list(
  tx      = tx,
  txsug   = txsug,
  bw      = d.gen$bw,
  n       = n,
  n.miss  = n.miss,
  W       = W,
  pvalue  = p.val
))

} 

ANOVA <-
function(my_formula, data=d, filter=NULL,
         brief=getOption("brief"), digits_d=NULL,
         Rmd=NULL, jitter_x=0.4,
         res_rows=NULL, res_sort=c("zresid", "fitted", "off"),
         quiet=getOption("quiet"), 
         graphics=TRUE, pdf=FALSE, width=5, height=5,
         fun_call=NULL, ...) {


  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (grepl(".", names(dots)[i], fixed=TRUE)) {
        pnm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(pnm, dots[[i]])
      }
    }
  }

  if (is.null(fun_call)) fun_call <- match.call()

  res_sort <- match.arg(res_sort)

  if (missing(my_formula)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify a model by listing it first or set according to:  my_formula\n\n")
  }

  # check for deprecated parameters
  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] == "knitr.file") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "knitr.file  no longer used\n",
          "Instead use  Rmd  for R Markdown file\n\n")
      }
    }
  }

  # let deprecated mydata work as default
  dfs <- .getdfs()
  mydata.ok <- FALSE
  if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
    d <- mydata
    df.name <- "mydata"
    mydata.ok <- TRUE
    options(dname = df.name)
  }

  if (!mydata.ok) {
    df.name <- deparse(substitute(data))  # get name of data table
    options(dname = df.name)
  }

  # if a tibble, convert to data frame
  if (exists(df.name, envir=parent.frame())) {
    if (any(grepl("tbl", class(data), fixed=TRUE)))
      data <- data.frame(data)
  }

  op <- options()  # save current options to reset at end
  on.exit(options(op), add=TRUE)

  if (!exists(df.name)) {
    txtC <- "Function ANOVA requires the data exist in a data frame\n"
    if (df.name == "d")
      txtA <- ", the default data frame name, " else txtA <- " "
    txtB1 <- "Either create the data frame, such as with data.frame function, or\n"
    txtB2 <- "  specify the actual data frame with the parameter: data\n"
    txtB <- paste(txtB1, txtB2, sep="")
    cat("\n"); stop(call.=FALSE, "\n","------\n",
        txtC, "Data frame ", df.name, txtA, "does not exist\n\n", txtB, "\n")
  }

  nm <- all.vars(my_formula)  # names of vars in the model
  # a term may also be an expression, e.g., log(Salary) ~ cut(Years, 3),
  #   evaluated by aov() directly, so count model terms, not variables
  trm <- as.list(attr(terms.formula(my_formula), "variables"))[-1L]
  n.vars <- length(trm)
  n.pred <- n.vars - 1

  # ANOVA analyzes one or two factors (see the help file)
  if (n.pred < 1  ||  n.pred > 2) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "ANOVA analyzes one or two factors:\n",
      "  one-way between groups:    Y ~ X\n",
      "  one-way randomized blocks: Y ~ X + Blocks\n",
      "  two-way between groups:    Y ~ X1 * X2\n\n",
      "For more complex designs, use the standard R function aov\n\n")
  }
  if (n.pred == 2) {  # two factors must be crossed (*) or blocked (+)
    rhs <- as.character(my_formula)[3]
    if (!grepl("*", rhs, fixed=TRUE)  &&  !grepl("+", rhs, fixed=TRUE)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "For two factors, separate the names in the model with\n",
        "  *  for a two-way between groups design, or\n",
        "  +  for a randomized blocks design (blocking factor second)\n\n")
    }
  }

  if (!missing(filter)) {  # subset rows
    r <- eval(substitute(filter), envir=data, enclos=parent.frame())
    if (!any(r, na.rm=TRUE)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "No filter of data with the specified value of\n",
        "filter = ", deparse(substitute(filter)), "\n\n")
    }
    r <- r & !is.na(r)  # set missing for a row to FALSE
    data <- data[r,,drop=FALSE]
  }
  n.obs <- nrow(data)

  in.data.frame <- TRUE
  for (i in seq_along(nm)) {
    if (!(nm[i] %in% names(data))) {
      cat("\n\n\n>>> Note: ", nm[i], "is not in the data frame.\n")
      in.data.frame <- FALSE
    }
  }
  if (!in.data.frame) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "All variables in the model must be in the data frame\n",
      "  (see the Note above)\n\n")
  }

  if (n.pred > 0) for (i in seq(2, n.vars)) {  # all IVs must be factors
      if (is.symbol(trm[[i]])) {  # expression terms evaluate in aov()
        nms <- which(names(data) == as.character(trm[[i]]))
        if (in.data.frame && !is.factor(data[ , nms])) {
          data[ ,nms] <- as.factor(data[ ,nms])
        }
      }
    }

  # ANOVA
  #   all analysis done on data in model construct av.out$model
  #   this model construct contains only model vars, with Y listed first
  # assign("av.out", aov(my_formula, data=data), pos=.GlobalEnv)
  if (!mydata.ok) .nodf(df.name)
  av.out <- aov(my_formula, data=data)

  # model-frame names carry the term labels, e.g., cut(Years, 3), so
  #   downstream indexing works for expression terms as well
  nm <- names(av.out$model)

  # an expression term for a factor must evaluate to a factor
  if (n.pred > 0) for (i in seq(2, n.vars)) {
    if (!is.symbol(trm[[i]]) && !is.factor(av.out$model[,i])) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "The expression  ", nm[i], "  must produce a factor for ANOVA.\n",
        "Enclose it in a function that yields categories, such as\n",
        "  cut()  or  factor().\n\n")
    }
  }

  n.keep <- nrow(av.out$model)

  if (is.null(digits_d))
    digits_d <- .getdigits(av.out$model[,nm[1]], 2)


# ----------
# Background
# ----------

  title_bck <- "\n  BACKGROUND"

  tx <- character(length=0)

  if (sys.nframe() == 1) {  # only accurate if not called from model
    tx[length(tx)+1] <- paste("Data Frame: ", df.name)
    tx[length(tx)+1] <- ""
  }

  for (i in seq_len(n.vars)) {
    tx2 <- .varlist(n.pred, i, nm[i], "Factor", n.obs,
                     n.keep, levels(av.out$model[,nm[i]]))
    for (j in seq_along(tx2)) tx[length(tx)+1] <- tx2[j]
  }

  txbck <- tx


# --------
# Analysis
# --------

  # keep track of generated graphics
  if (graphics) {
    plot.i <- 0L
    plot.title  <- character(length=0)
  }

  if (n.pred == 1)  {

    plt1 <- .ANOVAz1(av.out, av.out$model[,nm[1]], av.out$model[,nm[2]],
        nm, n.keep, jitter_x, digits_d, brief, graphics, pdf, width, height)
    title_des <- plt1$title_des
    txdes <- plt1$txdes
    title_basic <- plt1$title_basic
    txanv <- plt1$txanv
    txeft <- plt1$txeft
    title_tukey <- plt1$title_tukey
    txhsd <- plt1$txhsd
    pv <- plt1$pv
    if (graphics) {
      for (i in seq_len(plt1$i)) plot.title[plot.i+i] <- plt1$ttl[i]
      plot.i <- plot.i + plt1$i
    }
  }

  if (n.pred == 2) {
    balance <- !is.list(replications(my_formula, data=data))
    plt2 <- .ANOVAz2(av.out, av.out$model[,nm[1]], av.out$model[,nm[2]],
        av.out$model[,nm[3]], nm, digits_d, brief, as.character(my_formula)[3],
        balance, graphics, pdf, width, height)
    txbck2 <- plt2$txbck2
    title_des <- plt2$title_des
    for (i in seq_along(txbck2)) txbck[length(txbck)+1] <- txbck2[i]
    txcn <- plt2$txcn
    txcm <- plt2$txcm
    txmm <- plt2$txmm
    txgm <- plt2$txgm
    txcs <- plt2$txcs
    title_basic <- plt2$title_basic
    txanv <- plt2$txanv
    txeft <- plt2$txeft
    title_tukey <- plt2$title_tukey
    txhsd <- plt2$txhsd
    if (graphics) {
      for (i in seq_len(plt2$i)) plot.title[plot.i+i] <- plt2$ttl[i]
      plot.i <- plot.i + plt2$i
    }
  }

  # residuals
  txres <- ""
  title_res <- "\n  RESIDUALS"
  res <- NULL
  fit <- NULL
  if (!brief) {

    if (is.null(res_rows))
      if (n.keep < 20) res_rows <- n.keep else res_rows <- 20
    if (res_rows == "all") res_rows <- n.keep

    fit <- fitted(av.out)
    res <- residuals(av.out)

    if (res_rows == 0)  # res_rows=0 disables the residuals display
      title_res <- ""
    else {
      tx <- character(length=0)

      tx[length(tx)+1] <- "Fitted Values, Residuals, Standardized Residuals"
      if (res_sort == "zresid")
        tx[length(tx)+1] <-
          "   [sorted by Standardized Residuals, ignoring + or - sign]"
      if (res_sort == "fitted")
        tx[length(tx)+1] <- "   [sorted by Fitted Value, ignoring + or - sign]"
      if (res_rows < n.keep)
        txt <- "cases (rows) of data, or res_rows=\"all\"]"
      else
        txt="]"
      tx[length(tx)+1] <- paste("   [res_rows = ", res_rows, ", out of ",
                                n.keep, " ", txt, sep="")

      sres <- rstandard(av.out)
      out <- cbind(av.out$model[c(nm[seq(2,n.vars)],nm[1])], fit, res, sres)
      out <- data.frame(out)
      names(out)[n.vars+1] <- "fitted"
      names(out)[n.vars+2] <- "residual"
      names(out)[n.vars+3] <- "zresid"

      if (res_sort != "off") {
        if (res_sort == "zresid") o <- order(abs(out$zresid), decreasing=TRUE)
        if (res_sort == "fitted") o <- order(abs(out$fitted), decreasing=TRUE)
        out <- out[o,]
      }
      names(out)[n.vars+3] <- "z-resid"
      for (i in seq_len(n.vars+3))
        if (is.numeric(out[,i])) if (!is.integer(out[,i])) {
          if (digits_d > 2) dec.digits <- digits_d-1 else dec.digits <- digits_d
          out[,i] <- .fmt(out[,i],dec.digits)
        }
      tx2 <- .prntbl(out[seq_len(res_rows),], digits_d)
      for (i in seq_along(tx2)) tx[length(tx)+1] <- tx2[i]

      txres <- tx
    }
  }  # end !brief

# pairwise.t.test(d$Steady, d$TrtA)
# power.anova.test(groups=4, n=8, between.var=16.33, within.var=2.179)

  options(op)  # restore options going into reg

  # display list of plots if more than 1
  txplt <- ""
  if (graphics) {
    if (plot.i > 1) txplt <- .plotList2(plot.i, plot.title)
    dev.set(which=2)  # reset graphics window for standard R functions
  }

  # R Markdown
  txkfl <- ""
  if (!is.null(Rmd)) {
    if (!grepl(".Rmd", Rmd, fixed=TRUE)) Rmd <- paste(Rmd, ".Rmd", sep="")
    txknt <- .av.Rmd(nm, df.name, fun_call, digits_d)
    cat(txknt, file=Rmd, sep="\n")
    txkfl <- .showfile2(Rmd, "R Markdown instructions")
  }

  class(title_bck) <- "out"
  class(txbck) <- "out"
  class(title_des) <- "out"
  if (n.pred == 1)
    class(txdes) <- "out"
  if (n.pred == 2) {
    class(txcn) <- "out"
    class(txcm) <- "out"
    class(txmm) <- "out"
    class(txcs) <- "out"
    class(txgm) <- "out"
  }
  class(title_basic) <- "out"
  class(txanv) <- "out"
  class(txeft) <- "out"
  class(title_tukey) <- "out"
  class(txhsd) <- "out"
  class(title_res) <- "out"
  class(txres) <- "out"
  class(txplt) <- "out"


  if (n.pred == 1)  {
    output <- list(
      call=fun_call, formula=my_formula,

      out_title_bck=title_bck, out_background=txbck,

      out_title_des=title_des,
      out_descriptive=txdes,

      out_title_basic=title_basic,
      out_anova=txanv, out_effects=txeft,

      out_title_tukey=title_tukey,
      out_hsd=txhsd,

      out_title_res=title_res, out_res=txres,

      out_plots=txplt,

      n_vars=n.vars, n_obs=n.obs, n_keep=n.keep, p_value=pv,
      residuals=res, fitted=fit
    )
  }

  if (n.pred == 2)  {
    output <- list(
      call=fun_call, formula=my_formula,

      out_title_bck=title_bck, out_background=txbck,

      out_title_des=title_des,
      out_cell.n=txcn, out_cell.means=txcm, out_marginals=txmm,
      out_gm=txgm, out_cell.sd=txcs,

      out_title_basic=title_basic,
      out_anova=txanv, out_effects=txeft,

      out_title_tukey=title_tukey,
      out_hsd=txhsd,

      out_title_res=title_res, out_res=txres,

      out_plots=txplt,

      n_vars=n.vars, n_obs=n.obs, n_keep=n.keep,
      residuals=res, fitted=fit
    )
  }

  class(output) <- "out_all"

  if (!quiet)
    return(output)
  else
    invisible(output)

}

# aliases.R — legacy entry points (soft-deprecated) ---------------------------
# - Keep only historically existing public aliases.
# - Forward to Chart(), X(), or XY() exactly as today.
# - Emit a once-per-session deprecation message that suggests the new call.
# - No hard deprecations; everything still works.


# one-time deprecation message helper -------------------------------------
.lessR_deprec_env <- new.env(parent = emptyenv())

## cache for "seen" flags (once-per-session)
if (!exists(".lessR_deprec_env", inherits = FALSE)) {
  .lessR_deprec_env <- new.env(parent = emptyenv())
}

.deprecate_once <- function(old_name, new_suggest) {
  # Allow users to silence these messages globally
  if (isTRUE(getOption("lessR.silence_deprec", FALSE))) return(invisible(NULL))

  key <- paste0("seen_", old_name)  # identify the string that triggered message

  if (!isTRUE(.lessR_deprec_env[[key]])) {
    msg <- sprintf(
      paste0(
        "lessR visualizations are now unified over just three core functions:\n",
        "  - Chart() for pivot tables, such as bar charts. More info: ?Chart\n",
        "  - X() for a single variable x, such as histograms. More info: ?X\n",
        "  - XY() for scatterplots of two variables, x and y. More info: ?XY\n",
        "\n",
        "%s is deprecated, though still working for now.\n",
        "Please use %s going forward."
      ),
      old_name, new_suggest
    )
    message(msg)
    .lessR_deprec_env[[key]] <- TRUE
  }

  invisible(NULL)
}


# Chart() aliases (legacy)-------------------------------------------------

BarChart <- function(...) {
  .deprecate_once("BarChart()", 'Chart(..., form = "bar")')
  Chart(..., form = "bar")
}

PieChart <- function(...) {
  .deprecate_once("PieChart()", 'Chart(..., form = "pie")')
  Chart(..., form = "pie")
}

pc <- function(...) {
  .deprecate_once("pc", 'Chart(..., form = "pie")')
  Chart(..., form = "pie")
}


# X() aliases (legacy)-----------------------------------------------------

Histogram <- function(...) {
  .deprecate_once("Histogram()", 'X(..., form = "histogram")')
  X(fun_call = match.call(), form = "histogram", ...)
}

hs <- function(...) {
  .deprecate_once("hs()", 'X(..., form = "histogram")')
  X(fun_call = match.call(), form = "histogram", ...)
}

Density <- function(...) {
  .deprecate_once("Density()", 'X(..., form = "density")')
  X(fun_call = match.call(), form = "density", ...)
}

BoxPlot <- function(...) {
  .deprecate_once("BoxPlot()", 'X(..., form = "box")')
  X(fun_call = match.call(), form = "box", ...)
}

bx <- function(...) {
  .deprecate_once("bx()", 'X(..., form = "box")')
  X(fun_call = match.call(), form = "box", ...)
}

ViolinPlot <- function(...) {
  .deprecate_once("ViolinPlot()", 'X(..., form = "violin")')
  X(fun_call = match.call(), form = "violin", ...)
}

vp <- function(...) {
  .deprecate_once("vp()", 'X(..., form = "violin")')
  X(fun_call = match.call(), form = "violin", ...)
}


# XY() aliases (legacy)----------------------------------------------------

Plot <- function(...) {
  .deprecate_once("Plot()", "X(...) or XY(...)")
  
  # Capture the call expression
  call_expr <- match.call()
  call_args <- as.list(call_expr)[-1]  # Remove function name
  arg_names <- names(call_args)
  
  # Check if the first argument is unnamed
  first_unnamed <- is.null(arg_names) || arg_names[1] == ""
  
  # Check for y argument
  has_second     <- length(call_args) >= 2
  second_unnamed <- has_second && (is.null(arg_names) || arg_names[2] == "")
  has_y <- (first_unnamed && second_unnamed) ||
           (!is.null(arg_names) && "y" %in% arg_names)
  
  # facet1 / facet2 rewriting
  if (!is.null(arg_names)) {
    has_facet1 <- "facet1" %in% arg_names
    has_facet2 <- "facet2" %in% arg_names
    
    if (has_facet1 && has_facet2) {
      facet1_value <- call_args[["facet1"]]
      facet2_value <- call_args[["facet2"]]
      call_args[["facet"]] <- call(quote(c), facet1_value, facet2_value)
      call_args[["facet1"]] <- NULL
      call_args[["facet2"]] <- NULL
    } else if (has_facet1) {
      names(call_args)[which(arg_names == "facet1")] <- "facet"
    }
  }
  
  # --- 2-argument case → always XY() ---
  if (has_y) {
    new_call <- as.call(c(quote(XY), call_args))
    return(eval(new_call, envir = parent.frame()))
  }
  
  # --- One-argument case: decide between Chart() and X() ---
  
  # Extract x expression
  x_expr <- if (first_unnamed) {
    call_args[[1]]
  } else if ("x" %in% arg_names) {
    call_args[["x"]]
  } else {
    call_args[[1]]
  }
  
  # Try evaluating x
  x_value <- tryCatch(eval(x_expr, envir = parent.frame()),
                           error = function(e) NULL)
  
  # If not found, look in data frame d
  if (is.null(x_value) && exists("d", envir = parent.frame())) {
    d <- get("d", envir = parent.frame())
    if (is.data.frame(d) && is.name(x_expr) &&
        as.character(x_expr) %in% names(d)) {
          x_value <- d[[as.character(x_expr)]]
    }
  }
  
  # Is x categorical?
  is_categorical <- FALSE
  if (!is.null(x_value))
    is_categorical <- is.factor(x_value) || is.character(x_value)
  
  # --- NEW BEHAVIOR HERE ---
  # If categorical → Chart(..., form="bubble")
  if (is_categorical) {
    call_args$form <- quote("bubble")   # <-- ONLY CHANGE
    new_call <- as.call(c(quote(Chart), call_args))
    return(eval(new_call, envir = parent.frame()))
  }

  # Otherwise numeric → X(..., form="vbs")
  call_args$form <- quote("vbs")
  new_call <- as.call(c(quote(X), call_args))
  eval(new_call, envir = parent.frame())
}


ScatterPlot <- function(...) {
  .deprecate_once("ScatterPlot", 'XY(..., form = "scatter")')
  XY(fun_call = match.call(), form = "scatter", ...)
}

sp <- function(...) {
  .deprecate_once("sp", 'XY(..., form = "scatter")')
  XY(fun_call = match.call(), form = "scatter", ...)
}


# legacy aliases ----------------------------------------------------------

av <-
function(...)

  ANOVA(...)

av_brief <-
function(..., brief=TRUE)

  ANOVA(..., brief=TRUE)

ca <-
function(...)

  CountAll(...)

cfa <-
function(...)

  corCFA(fun_call=match.call(), ...)

cr <-
function(...)

  Correlation(...)

cr_brief <-
function(..., brief=TRUE)

  cr(..., brief=TRUE)

cp <-
function(...)

  corProp(...)


db <-
function(..., brief=TRUE)

 details(..., brief=TRUE)

efa <-
function(...)

  corEFA(...)

lr <-
function(...)

  Logit(...)

model <-
function(...)

  Model(...)

mrg <-
function(...)

  Merge(...)


nt <-
function(...)

  Nest(...)

prop <-
function(...)

  Prop_test(...)


rd_lbl <-
function(..., var_labels=TRUE)

  Read(..., var_labels=TRUE, fun_call=match.call())

rd.cor <-
function(...)

  corRead(...)

rd <-
function(...)

  Read(..., fun_call=match.call())

Read2 <- 
function(..., sep=";", dec=",") 
         
  Read(..., fun_call=match.call(), sep=";", dec=",")


reg <-
function(...)

  Regression(fun_call=match.call(), ...)


reg_brief <-
function(..., brief=TRUE)

  Regression(..., fun_call=match.call(), brief=TRUE)

reord <-
function(...)

  corReorder(...)

reflect <-
function(...)

  corReflect(...)

ss <-
function(...)

  SummaryStats(...)

tt <-
function(...)

  ttest(...)

tt_brief <-
function(...)

 ttest(..., brief=TRUE)

ttp  <-
function(...) {

  ttestPower(...)

}


vl <-
function(...)

  VariableLabels(...)

wrt <-
function(...)

  Write(...)

wrt_r <-
function(..., format="R")

  Write(..., format="R")

wrt_x <-
function(..., format="Excel")

  Write(..., format="Excel")

.rec.main <-
function(x, x.name, new.var, old, new, ivar, n.obs, dname, quiet) {

  n.values <- length(old)

  miss_old <- FALSE
  if (!is.null(old)) if (old[1] == "missing") miss_old <- TRUE

  miss_new <- FALSE
  if (!is.null(new)) {
    if (new[1] != "missing") {
      if (n.values != length(new)) { 
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "The same number of values must be specified for both\n",
        "old and new values_\n\n")
      }
    }
    else {
      for (i in 1:n.values) new[i] <- "missing"
      miss_new <- TRUE
    }
  }

  # text output
  if (!quiet) {

    if (ivar == 1) {
      cat("\nRecoding Specification\n")
      .dash(22)
      for (i in 1:n.values) cat("  ", old[i], "-->", new[i], "\n")
      cat("\n")
      if (miss_new)
        cat("\nR represents missing data with a NA for 'not assigned'.\n\n")
      cat("Number of cases (rows) to recode:", n.obs, "\n")
      if (is.null(new.var))
        cat("\nReplace existing values of each specified variable",
            ", no value for option: new.var\n", sep="")
    }
    cat("\n")

    old.unique <- sort(unique(x))
    n.unique <- length(old.unique)
    cat("---  Recode:", x.name, "---------------------------------\n")
    
    if ("numeric" %in% class(x))  # R 4.0 results in two values: matrix, array
      cat("Unique values of", x.name, "in the data:", old.unique, "\n")
    else if ("factor" %in% class(x))
      cat("Unique values of", x.name, "in the data:", levels(x), "\n")
    cat("Number of unique values of", x.name, "in the data:", n.unique, "\n")

    # check to ensure that all values to recode exist in the data
    for (i in 1:n.values) {
      is.in <- FALSE
      for (j in 1:n.unique) 
        if (old[i] == old.unique[j]) is.in <- TRUE 
      if (!is.in) {
      cat(">>> Note: A value specified to recode, ", old[i], 
        ", is not in the data.\n\n", sep="")
      }
    }

    cat("Number of values of", x.name, "to recode:", n.values, "\n")

    if (!is.null(new.var)) cat("Recode to variable:", new.var, "\n")
  }  # end text 

  if ("factor" %in% class(x)) x <- as.character(x)

  new.x <- x

  # the recode
  for (i in 1:n.values) {
    for (j in 1:n.obs) {
      if (!miss_old) {
        if (!is.na(new.x[j])) 
          if (x[j] == old[i]) new.x[j] <- ifelse (!miss_new, new[i], NA)
      } 
      else  # miss_old
        if (is.na(new.x[j])) new.x[j] <- new[1]
    } 
  }

  # new values are consistent with their type
  new.x <- type.convert(new.x, as.is=TRUE)

  return(new.x)
 
}

.hst.main <-
function(x, by=NULL, by.name=NULL, n.by=1,
       fill=NULL, color=NULL, trans=NULL, col.reg=NULL,
       rotate_x=NULL, rotate_y=NULL, offset=NULL,
       breaks, bin_start, bin_width, bin_end,
       prop, counts=NULL, cumulate="off",
       xlab=NULL, ylab=NULL, main=NULL, sub=NULL,
       xlab_adj=NULL, ylab_adj=NULL,
       bm.adj=NULL, lm.adj=NULL, tm.adj=NULL, rm.adj=NULL,
       add=NULL, x1=NULL, x2=NULL, y1=NULL, y2=NULL,
       scale_x=NULL, axis_fmt="K", axis_x_pre="", axis_y_pre="",
       use_plotly=TRUE, digits_d=NULL, quiet=FALSE,
       do_plot=TRUE, fun_call=NULL, style_opts = NULL, ...) {


  # get variable labels if exist plus axes labels
  if (is.null(ylab)) {
    was.null <- TRUE
    ylab <- ifelse (!prop, "Count of", "Proportion of")
    if (cumulate != "off") ylab <- paste("Cumulative", ylab)
  }
  else
    was.null <- FALSE

  lab_size <- getOption("lab_size")
  lab_x_size <- getOption("lab_x_size")
  lab_y_size <- getOption("lab_y_size")
  lab_x_size <- ifelse(is.null(lab_x_size), lab_size, lab_x_size)
  adj <- .RSadj(lab_size=lab_x_size); lab_x_size <- adj$lab_size
  lab_y_size <- ifelse(is.null(lab_y_size), lab_size, lab_y_size)
  adj <- .RSadj(lab_size=lab_y_size); lab_y_size <- adj$lab_size


  gl <- .getlabels(xlab, ylab, main, lab_x_size=lab_x_size,
                   lab_y_size=lab_y_size)
  x.name <- gl$xn; x.lbl <- gl$xl
  x.lab <- gl$xb
  y.lab <- ifelse (was.null, paste(gl$yb, x.name), gl$yb)
  main.lab <- gl$mb
  sub.lab <- gl$sb

  num.cat.x <- .is.num.cat(x, 7)
  if (num.cat.x) {
    if (is.null(bin_width)) bin_width <- 1
    if (is.null(bin_start)) bin_start <- min(x, na.rm=TRUE) - .5
  }

  # get breaks from user supplied bin width and/or supplied start value
  if (!is.null(bin_width)  || !is.null(bin_start) || !is.null(bin_end)) {
    if (is.null(bin_start))
      bin_start <- pretty(c(min(x, na.rm = TRUE), max(x, na.rm = TRUE)))[1]
    if (is.null(bin_width)) {
      h <- suppressWarnings(hist(x, plot=FALSE, breaks="Sturges"))
      bin_width <- h$breaks[2]-h$breaks[1]
    }
    max.x <- max(x, na.rm=TRUE)
    if (is.null(bin_end)) bin_end <- max.x
    if (bin_end < bin_start) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "bin_start: ", bin_start, "\n",
        "bin_end: ", bin_end, "\n",
        "bin_end is smaller than bin_start, make bin_end larger.\n\n")
    }
    breaks <- seq(bin_start, bin_end, bin_width)
    seq.end <- bin_end
    while (max(breaks) < bin_end) {
      seq.end <- seq.end + bin_width
      breaks <- seq(bin_start, seq.end, bin_width)
    }
  }

  # for user supplied bins, from seq function or bin_start,
  #   make sure entire data range is spanned
  if (is.numeric(breaks)) {
    cc <- cut(x, breaks, dig.lab=6, ...)   # replace each data value with its bin
    labs <- levels(cc)  # get list of unique bins, ordered
    bins <- cbind(lower = as.numeric( sub("\\((.+),.*", "\\1", labs) ),
          upper = as.numeric( sub("[^,]*,([^]]*)\\]", "\\1", labs) ))
    bin_min <- min(bins)
    bin_max <- max(bins)
    n.under <- length(x[which(x<bin_min)])
    n.over <- length(x[which(x>bin_max)])
    if (n.under+n.over > 0) {
      txt.u <- "";  txt.o <- "";  txt.nu <- "";  txt.no <- ""
      if (length(breaks) > 3)
        txt.c <- paste("Specified bin cut-points: ", bin_min, breaks[2], "...",
          breaks[length(breaks)-1], bin_max, "\n\n")
      else
        txt.c <- paste("Range of the specified bins: ", bin_min,
          " to ", bin_max, "\n", sep="")
      if (n.under > 0)
        txt.u <- paste("Data values too small to fit in the bins: ",
          x[which(x<bin_min)], "\n\n")
      if (n.over > 0)
        txt.o <- paste("Data values too large to fit in the bins: ",
          x[which(x>bin_max)], "\n\n")
      txt <- "To fix this problem, extend the bin range "
      if (n.under > 0)
        txt.nu <- paste(txt, "below ", bin_min, "\n", sep="")
      if (n.over > 0)
        txt.no <- paste(txt, "above ", bin_max, "\n", sep="")
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Range of the data for ", x.name, ": ", min(x, na.rm=TRUE), " to ",
            max(x, na.rm=TRUE), "\n",
        txt.c,
        txt.u,
        txt.o,
        "Each data value must be in a bin\n",
        txt.nu,
        txt.no, "\n",
        "Extend the bin range by setting bin_start and rerun\n\n")
    }
  }


  # calculate but do not plot the histogram
  # arguments in ... for plotting instructions generate warnings with no plot
  # input: breaks are Sturgis, etc. or numeric
  # output: h$breaks for the actual bins and h$counts for the y-values
  h <- suppressWarnings(hist(x, plot=FALSE, breaks, labels=counts, ...))

  # relative frequency histogram option
  # sum = n non-NA, length may include NAs
  if (prop) h$counts <- h$counts/sum(h$counts)

  # cumulative histogram option
  if (cumulate != "off") {
    old.counts <- h$counts
    h$counts <- cumsum(h$counts)
  }

  if (do_plot){
    if(n.by == 1) {

      # set margins
      max.width <- strwidth(as.character(max(pretty(h$counts))), units="inches")

      margs <- .plt.marg(max.width, y.lab, x.lab, main.lab, sub.lab, rotate_x)
      lm <- margs$lm
      tm <- margs$tm
      rm <- margs$rm
      bm <- margs$bm
      n.lab_x.ln <- margs$n.lab_x.ln
      n.lab_y.ln <- margs$n.lab_y.ln

      if (lab_x_size > 1.1) bm <- bm + (.10*lab_x_size)  # kludge
      if (lab_y_size > 1.1) lm <- lm + (.10*lab_y_size)

      if (offset > 0.5) bm <- bm + (-0.05 + 0.2 * offset)  # offset kludge

      # user manual adjustment here
      bm <- bm + bm.adj
      lm <- lm + lm.adj
      tm <- tm + tm.adj
      rm <- rm + rm.adj

      orig.params <- par(no.readonly=TRUE)
      on.exit(par(orig.params))
      par(bg=getOption("window_fill"))
      par(mai=c(bm, lm, tm, rm))
      par(tcl=-0.28)  # axis tick length

      # set up plot
      plot(h, freq=TRUE, axes=FALSE, ann=FALSE, ...)

      # get gridT1 and gridT2 - to draw grid lines
      if (is.null(scale_x))
        vx <- h$breaks
      else {
        if (length(scale_x) == 2) scale_x[3] <- par("xaxp")[3]
        vx <- axTicks(1, axp=scale_x)
      }
      gridT1 <- seq(vx[1], vx[length(vx)], vx[2]-vx[1])

      vy <- pretty(h$counts)
      gridT2 <- seq(vy[1], vy[length(vy)], vy[2]-vy[1])

      # plot background, axT1 and axT2 for grid lines
      .plt.bck(par("usr"), gridT1, gridT2)

      # adjust axis label from tick with mgp[2]
      # mgp does not work with rotate_x, see .axes()
      my.mgp <- par("mgp")  # save to restore
      ax <- .axes_dim()  # get axis value parameters
      mgp2 <- -0.350 + (0.9 * ax$axis_x_size)
      par(mgp = c(my.mgp[1], mgp2, my.mgp[3]))  # labels closer to axis
      adj <- .RSadj(axis_size=ax$axis_x_size); axis_x_size <- adj$axis_size

      # axis, axis ticks (different from grid lines)
      ax.info <- .axes(x.lvl=NULL, y.lvl=NULL,
            axTicks(1, axp=scale_x), axTicks(2),
            rotate_x=rotate_x, rotate_y=rotate_y, offset=offset,
            axis_fmt=axis_fmt, axis_x_pre=axis_x_pre, axis_y_pre=axis_y_pre,
            ...)

      # axis labels
      .axlabs(x.lab, y.lab, main.lab, sub.lab,
              xy_ticks=TRUE, offset=offset,
              lab_x_size=lab_x_size, lab_y_size=lab_y_size, main_size=NULL,
              n.lab_x.ln=n.lab_x.ln, n.lab_y.ln=n.lab_y.ln,
              xlab_adj=xlab_adj, ylab_adj=ylab_adj, ...)

      # see if apply a pre-defined color range
      n.bins <- length(h$counts)

      # fill.clr is for the static (base R) histogram — must be pre-interpolated
      # to n.bins colors. fill stays as-is for plotly, which interpolates itself
      if (length(fill) > 1)
        fill.clr <- grDevices::colorRampPalette(fill)(n.bins)
      else
        fill.clr <- fill

      # bar transparency
      if (!is.null(trans)) if (trans > 0)
        for (i in seq_along(fill.clr))
          fill.clr[i] <- .maketrans(fill.clr[i], (1-trans)*256)

      # plot the histogram
      plot(h, add=TRUE, col=fill.clr, border=color, freq=TRUE,
           labels=counts, ...)
      if (cumulate == "both") {
        h$counts <- old.counts
        plot(h, add=TRUE, col=col.reg, freq=TRUE)
      }

      # annotations
      if (!is.null(add)) {

        add_size <- getOption("add_size")
        add_lwd <- getOption("add_lwd")
        add_lty <- getOption("add_lty")
        add_color <- getOption("add_color")
        add_fill <- getOption("add_fill")
        add_trans <- getOption("add_trans")

        .plt.add (add, x1, x2, y1, y2,
                  add_size, add_lwd, add_lty, add_color, add_fill, add_trans)
      }
    }  # end n.by is 1
  }  # end do.plot
 

#------------
# text output
#------------

  mx.dd <- .max.dd(x)
  stats <- .hst.stats(h, length(x), mx.dd, fun_call)

  txsug=stats$txsug
  tx=stats$tx
  bin_width=stats$bin_width
  n.bins=stats$n.bins
  prop=stats$prop
  cum.c=stats$countscum
  cum.p=stats$prop_cum


# plotly ------------------------------------------------------------------

  # Interactive console: option is not set → returns NULL
  # While knitting: knitr sets it → returns TRUE
  if (isTRUE(getOption("knitr.in.progress")))
    use_plotly <- FALSE

  if (use_plotly) {  # not in knitr

    axT1 <- pretty(range(x))
    axL1 <- .axis.format(axT1, axis_fmt, axis_x_pre, axis_y_pre="no")
    axT2 <- pretty(c(0, max(h$counts)))
    axL2 <- .axis.format(axT2, axis_fmt, axis_x_pre="no", axis_y_pre)
    ax <- list(axT1=axT1, axL1=axL1, axT2=axT2, axL2=axL2)

    # get gridT1 and gridT2 - to draw grid lines
    if (is.null(scale_x))
      vx <- h$breaks
    else {
      if (length(scale_x) == 2) scale_x[3] <- par("xaxp")[3]
      vx <- axTicks(1, axp=scale_x)
    }
    gridT1 <- seq(vx[1], vx[length(vx)], vx[2]-vx[1])
    vy <- pretty(h$counts)
    gridT2 <- seq(vy[1], vy[length(vy)], vy[2]-vy[1])

    plt <- hs.plotly(
      x       = x,
      by      = by,        # may be NULL
      x_name  = x.name,
      by_name = by.name,   # may be NULL
      breaks  = h$breaks,
      freq    = TRUE,
      fill    = fill,
      border  = color,
      x_lab   = x.lab,
      y_lab   = y.lab,
      ax      = ax,
      gridT1  = gridT1,
      gridT2  = gridT2,
      position = "overlay",
      style_opts = style_opts %||% .plotly_style()
    )

    if (.allow.interactive()) {
      .viewer_notice_once(plot_name = "histogram", window_target = "Both")
      print(plt)
    }
  }  # end use_plotly


  # ALWAYS return stats list
  return(list(
    txsug=txsug, ttx=tx, bin_width=bin_width, n.bins=n.bins,
    breaks=h$breaks, mids=h$mids, counts=h$counts, prop=prop,
    counts_cum=cum.c, prop_cum=cum.p
  ))

}

.logit5Confuse <-
function(lm.out, out, n.vars, nm, prob_cut, x.cut) {

  # confusion matrix
  # force a 2x2 table even when every case is classified into one group,
  # else table() returns 2x1 and the tbl[ ,2] references go out of bounds
  y.lvls <- if (is.factor(out[,n.vars])) levels(out[,n.vars]) else c(0, 1)
  yf <- factor(out[,n.vars], levels=y.lvls)
  lf <- factor(out[,n.vars+1], levels=c(0, 1))
  tbl <- table(yf, lf)

  hit0 <- tbl[1,1]; hit1 <- tbl[2,2]
  mis0 <- tbl[1,2]; mis1 <- tbl[2,1]
  per0 <- if ((hit0 + mis0) > 0) hit0 / (hit0 + mis0) else NA_real_
  per1 <- if ((hit1 + mis1) > 0) hit1 / (hit1 + mis1) else NA_real_
  hitT <- hit0 + hit1
  tot0 <- tbl[1,1] + tbl[1,2]
  tot1 <- tbl[2,1] + tbl[2,2]
  totG <- tot0 + tot1
  perT <- hitT / totG
  per0G <- tot0 / totG
  per1G <- tot1 / totG
  ln <- nchar(nm[1])

  cat("Probability threshold for predicting ",
      levels(lm.out$model[,nm[1]])[2], ":", " ", prob_cut, "\n", sep="")
  if (!is.null(x.cut))
    cat("Corresponding cutoff threshold for ", nm[2], ": ", round(x.cut, 3),
        sep="",  "\n")
  cat("\n")
  cat(.fmtc(" ",ln+8), "Baseline         Predicted", "\n")
  .dash(51)
  cat(.fmtc(" ",ln+7), "Total  %Tot        0      1  %Correct", "\n")
  .dash(51)
  cat(.fmtc(" ",ln), "  1  ", .fmti(tot1,6), .fmt(100*per1G,1,5), " ",
      .fmti(mis1,6), .fmti(hit1,6), "   ",
      .fmt(100*per1,1), "\n")
  cat(.fmtc(nm[1],ln), "  0  ", .fmti(tot0,6), .fmt(100*per0G,1,5), " ",
      .fmti(hit0,6), .fmti(mis0,6), "   ",
      .fmt(100*per0,1), "\n")
  .dash(51)
  cat(.fmtc(" ",ln), "Total", .fmti(totG,6), .fmtc(" ",25),
      .fmt(100*perT,1), "\n")
  cat("\n")

  accuracy <- ((hit0 + hit1) / (hit0 + hit1 + mis0 + mis1)) * 100
  recall <- ((hit1) / (hit1 + mis1)) * 100
  precision <- ((hit1) / (hit1 + mis0)) * 100
  cat("Accuracy:", .fmt(accuracy,2), "\n")
  cat("Sensitivity:", .fmt(recall,2), "\n")
  cat("Precision:", .fmt(precision,2), "\n")
  cat("\n")

}

ViolinPlot <-
function(...) {

  vp_fill <- getOption("violin_fill")
  do.sub <- FALSE

  #  allow fill parameter to pass to violin_fill
  lst <- as.list(match.call()) 
  if (!is.null(names(lst))) {  # at least one named argument
    for (i in 1:length(lst)) {
      if (names(lst[i]) == "fill") {
        vp_fill <- lst[[i]]
        do.sub <- TRUE
      }
    }
  }

  if (!do.sub)
    Plot(fun_call=match.call(), vbs_plot="v",  ...)
  else
    Plot(fun_call=match.call(), vbs_plot="v", violin_fill=vp_fill, ...)

}

Flows <- function(
  # data
  value,                 # weights
  stage1,                # left column
  stage2,                # middle column
  stage3 = NULL,         # optional right column; if NULL -> 2-stage
  data = d,
  # appearance
  title = NULL,
  fill = NULL,
  link_alpha = 0.55,
  nodes_gray = FALSE,    # plotly default: sources colored, others gray
  neutral_gray = "gray80",
  border_gray  = "gray60",
  lift_y = 0,            # positive lifts diagram upward; negative lowers
  labels_size = 1.00,    # relative text size
  digits_d = 0           # decimals in hover
) {

  # ----- capture argument names from the call -----
  mc <- match.call(expand.dots = FALSE)
  get_name <- function(arg_expr)
    if (is.symbol(arg_expr)) as.character(arg_expr)
    else if (is.character(arg_expr)) arg_expr[1]
    else as.character(arg_expr)

  stage1_name <- get_name(mc$stage1)
  stage2_name <- get_name(mc$stage2)
  stage3_name <- if (!is.null(mc$stage3)) get_name(mc$stage3) else NULL
  value_name  <- get_name(mc$value)

  # ----- resolve data and columns -----
  if (!is.null(data)) {
    stopifnot(is.data.frame(data))
    need <- c(stage1_name, stage2_name, value_name)
    if (!all(need %in% names(data)))
      stop("Columns not found in `data`: ",
           paste(setdiff(need, names(data)), collapse = ", "), call. = FALSE)
    if (!is.null(stage3_name) && !(stage3_name %in% names(data)))
      stop("Column not found in `data`: ", stage3_name, call. = FALSE)
    stage1 <- data[[stage1_name]]
    stage2 <- data[[stage2_name]]
    stage3 <- if (!is.null(stage3_name)) data[[stage3_name]] else NULL
    value  <- data[[value_name]]
  } else {
    pe <- parent.frame()
    stage1 <- get(stage1_name, envir = pe)
    stage2 <- get(stage2_name, envir = pe)
    stage3 <- if (!is.null(stage3_name)) get(stage3_name, envir = pe) else NULL
    value  <- get(value_name,  envir = pe)
  }

  # ----- ensure desired order via factor levels (preserve first-seen order)
  if (!is.factor(stage1)) stage1 <- factor(stage1, levels = unique(stage1))
  if (!is.factor(stage2)) stage2 <- factor(stage2, levels = unique(stage2))
  if (!is.null(stage3) && !is.factor(stage3))
    stage3 <- factor(stage3, levels = unique(stage3))

  # ordered labels from factor levels
  sources <- levels(stage1)
  mids    <- levels(stage2)
  dests   <- if (is.null(stage3)) character(0) else levels(stage3)

  # ----- nodes (keep order; do NOT sort/unique again) -----
  nodes <- c(sources, mids, dests)
  # 0-based positional helpers — safe when the same label appears in
  # multiple stages (name-based lookup via setNames breaks in that case)
  pos_src  <- function(x) match(as.character(x), sources) - 1L
  pos_mid  <- function(x) nA + match(as.character(x), mids) - 1L
  pos_dest <- function(x) nA + nB + match(as.character(x), dests) - 1L

  # ----- theme colors -----
  neutral_gray <- .to_hex(neutral_gray)
  border_gray  <- .to_hex(border_gray)
  ARROW <- "\u2192"

  # ----- links (aggregate values) -----
  L1 <- aggregate(value, list(stage1, stage2), sum)
  names(L1) <- c("a","b","val")
  links1 <- data.frame(
    source  = pos_src(L1$a),
    target  = pos_mid(L1$b),
    value   = L1$val,
    src_key = as.character(L1$a),
    stringsAsFactors = FALSE
  )
  if (length(dests)) {
    L2 <- aggregate(value, list(stage1, stage2, stage3), sum)
    names(L2) <- c("a","b","c","val")
    links2 <- data.frame(
      source  = pos_mid(L2$b),
      target  = pos_dest(L2$c),
      value   = L2$val,
      src_key = as.character(L2$a),
      stringsAsFactors = FALSE
    )
    links <- rbind(links1, links2)
  } else {
    links <- links1
  }

  # ----- layout positions for nodes (x,y coordinates) -----
  nA <- length(sources); nB <- length(mids); nC <- length(dests)
  xA <- rep(0.02, nA)
  xB <- rep(if (nC) 0.50 else 0.98, nB)
  xC <- if (nC) rep(0.98, nC) else numeric(0)
  node_x <- c(xA, xB, xC)
  y_even <- function(n) if (n <= 1) 0.5 else seq(0.1, 0.9, length.out = n)
  node_y <- c(y_even(nA), y_even(nB), if (nC) y_even(nC) else numeric(0))

# colors: sources get palette, others neutral, unless nodes_gray=TRUE -----
  n.x   <- nA
  theme <- getOption("theme")
  fill.vec <- if (is.null(fill))
    .color_range(.get_fill(theme), n.x)
  else
    .color_range(fill, n.x)
  pal_sources <- .to_hex(fill.vec)
  names(pal_sources) <- sources

  link_color <- .maketrans_plotly(pal_sources[links$src_key], link_alpha)
  node_color <- if (isTRUE(nodes_gray)) {
    rep(neutral_gray, length(nodes))
  } else {
    c(unname(pal_sources), rep(neutral_gray, nB + nC))
  }
  node_line <- list(color = border_gray, width = 1)

  # ----- title text -----
  ttl <- if (!is.null(title) && nzchar(title)) {
    sprintf("<b>%s</b>", title)
  } else if (length(dests)) {
    sprintf("<b>%s %s %s %s %s</b>",
            stage1_name, ARROW, stage2_name, ARROW, stage3_name)
  } else {
    sprintf("<b>%s %s %s</b>", stage1_name, ARROW, stage2_name)
  }

# ----- adaptive vertical domain (always honor lift_y; shrink height as needed) -----
  height_base  <- 0.94   # normal chart height
  height_min   <- 0.80   # minimum height under extreme lift/compression
  compress_per <- 0.50   # shrink factor per unit |lift_y|
  base_y1      <- 0.02   # baseline lower margin

  # shrink height smoothly as |lift_y| grows (helps across Viewer/Zoom/Export)
  h_req <- height_base - compress_per * abs(lift_y)
  h     <- max(height_min, min(height_base, h_req))

  # requested domain based on lift
  y1 <- base_y1 + lift_y
  y2 <- y1 + h

  # ensure the plot always fits in [0,1]; if needed, shrink further to fit
  if (y2 > 1) {
    y2 <- 1
    y1 <- max(0, y2 - h)
    if (y1 < base_y1 + lift_y) {
      y1 <- base_y1 + lift_y
      y2 <- 1
      h  <- y2 - y1
      if (h < 0.20) { y2 <- 1; h <- 0.20; y1 <- y2 - h }
    }
  }
  if (y1 < 0) {
    y1 <- 0
    y2 <- min(1, h)  # h already >= height_min; use full height from bottom
    if ((y2 - y1) < 0.20) { y2 <- 0.20; h <- 0.20 }  # enforce minimum
  }

  y_dom   <- c(y1, y2)
  title_y <- min(0.98, y_dom[2] + 0.03)  # title slightly above chart top

  # ----- build plotly -----
  fmt_val <- sprintf("%%{value:,.%df}", digits_d)

  plt <- plotly::plot_ly(
    type = "sankey",
    arrangement = "fixed",
    domain = list(x = c(0, 1), y = y_dom),
    node = list(
      label = nodes,
      color = node_color,
      x = node_x, y = node_y,
      pad = 12, thickness = 16,
      line = node_line,
      hovertemplate = "%{label}<extra></extra>",
      font = list(size = 25 * labels_size, family = "Arial", color = "black")
    ),
    link = list(
      source = links$source,
      target = links$target,
      value  = links$value,
      color  = link_color,
      hovertemplate = paste0(
        "%{source.label} ", ARROW, " %{target.label}",
        "<br>", value_name, ": ", fmt_val, "<extra></extra>"
      )
    )
  )

  plt <- plotly::layout(
    plt,
    title = list(
      text = ttl,
      x = 0.5, y = title_y, xanchor = "center", yanchor = "top",
      font = list(size = 18 * labels_size, family = "Arial", color = "black")
    ),
    margin = list(t = 90, r = 30, b = 30, l = 30),
    font = list(size = 15 * labels_size, family = "Arial", color = "black"),
    template = NULL
  )

  # finalize / cache
  plt <- plotly::plotly_build(plt)
  plt <- .finalize_plotly_widget(
    plt,
    kind = if (length(dests)) "sankey3" else "sankey2",
    x_name = stage1_name,
    by_name = if (length(dests)) paste(stage2_name, ARROW, stage3_name) else stage2_name,
    add_title = is.null(title) || !nzchar(title),
    nudge_viewer = FALSE
  )

  # re-apply title in case helper overwrote style/position
  plt <- plotly::layout(
    plt,
    title = list(
      text = ttl,
      x = 0.5, y = title_y, xanchor = "center", yanchor = "top",
      font = list(size = 18 * labels_size, family = "Arial", color = "black")
    )
  )

  if (interactive()) print(plt)
  invisible(plt)
}

.reg5ancova <-
function(lm.out, d.ancova, digits_d, 
         pdf=FALSE, width=5, height=5, manage.gr=FALSE, quiet, ...) {
         
  nm <- all.vars(lm.out$terms)  # names of vars in the model
  nm.a <- names(d.ancova)
  n.vars <- length(nm)
  n.pred <- n.vars - 1L
  b0 <- lm.out$coefficients[1]

  # pdf graphics option
  go.pdf <- pdf  # save before grDevices::pdf() would shadow the name
  if (go.pdf) {
    pdf_file <- "RegScatterplot.pdf"
    grDevices::pdf(file=pdf_file, width=width, height=height)
  }
  # keep track of the plot in this routine
  plt.i <- 0L
  plt.title  <- character(length=0)

  # identify the grouping variable and the covariate
  if (is.numeric(d.ancova[,nm.a[2]]) && is.factor(d.ancova[,nm.a[3]])) {
    x.cat <- 3
    x.cont <- 2
  } else if (is.numeric(d.ancova[,nm.a[3]]) && is.factor(d.ancova[,nm.a[2]])) {
    x.cat <- 2
    x.cont <- 3
  } else {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "ANCOVA requires one numeric and one factor predictor.\n",
      "Could not identify the grouping and covariate columns.\n\n")
  }
  lvl <- levels(d.ancova[,nm.a[x.cat]])


  # Set up plot
  # -----------
  x.values <- d.ancova[,nm.a[x.cont]]
  y.values <- d.ancova[,nm.a[1]]
  y.min <- min(y.values)
  y.max <- max(y.values)

  plt.i <- plt.i + 1L
  plt.title[plt.i] <- "Scatterplot and Least-Squares Lines"
             
  # scale for regular R or RStudio
  axis_size <- 0.76
  radius <- 0.22
  adj <- .RSadj(radius, axis_size, lab_size=getOption("lab_size"))
  radius <- adj$radius
  size.lab <- getOption("lab_size")
  cex.txt <- getOption("axis_size")
  
  # size of points
  size.pt <- ifelse (.Platform$OS == "windows", 0.85, 0.70)

  # set margins
  max.width <- strwidth(as.character(max(pretty(y.values))), units="inches")
  margs <- .plt.marg(max.width, y.lab=nm[1], x.lab=nm[2], main=NULL, sub=NULL)
  lm <- margs$lm;  tm <- margs$tm;  rm <- margs$rm;  bm <- margs$bm
  
  big.nm <- max(nchar(lvl))
  if (big.nm > 6) rm <- rm + (.05 * (big.nm - 6))
  rm <- rm + .30  + (.65 * getOption("axis_size"))  # better if axis_y_size

  par(bg=getOption("window_fill"))
  orig.params <- par(no.readonly=TRUE)
  on.exit(par(orig.params))
  par(mai=c(bm, lm, tm, rm))

  plot(x.values, y.values, type="n", axes=FALSE, ann=FALSE)
  usr <- par("usr")

  axT1 <- axTicks(1)  # numeric, so all the ticks
  .plt.bck(usr, axT1, axTicks(2))
  .axes(NULL, NULL, axT1, axTicks(2))

  theme <- getOption("theme")
  .axlabs(x.lab=nm[x.cont], y.lab=nm[1], main.lab=NULL, sub.lab=NULL)
  clr <- .get_fill(theme)
  fill <- getColors(clr, n=length(lvl))
  color <- getColors(clr, n=length(lvl))

  # Plot legend
  # -----------
  pts_trans <- 0
  shp <- 21
  fill_bg <- "transparent"
  options(byname = nm.a[x.cat])
  .plt.by.legend(lvl, color, fill, shp, pts_trans, fill_bg, usr)
    
  # Plot points
  # -----------
  n.iter <- nlevels(d.ancova[,nm.a[x.cat]])

  for (i in seq_len(n.iter)) {
    ind <- which(d.ancova[,nm.a[x.cat]] == lvl[i])

    points(x.values[ind], y.values[ind],
           pch=21, col=color[i], bg=fill[i], cex=size.pt)
  }  # end 1:n.iter

  # Plot Lines
  # ----------
  coefs <- lm.out$coefficients
  n.lvl <- nlevels(d.ancova[,nm.a[x.cat]])
  b.slope <- ifelse (x.cont == 2, coefs[2], coefs[1+n.lvl])
  if (x.cat == 2)
    b.cat <- coefs[2:n.lvl] 
  else
    b.cat <- coefs[3:(1+(n.lvl))] 

  # also gather separate equation for each line
  tx <- character(length = 0)
  for (i.coef in 0:length(b.cat)) {
    if (i.coef == 0)
      b00 <- b0  # y-intercept of the model
    else
      b00 <- b0 + b.cat[i.coef]  # intercept of one reg line
    abline(b00, b.slope, col=fill[i.coef+1], lwd=1.5)
    tx[length(tx)+1] <- paste("Level ",lvl[i.coef+1], ": y^_", nm.a[1],
        " = ", .fmt(b00, digits_d), " + ", .fmt(b.slope, digits_d),
        "(x_", nm.a[x.cont], ")", sep="")
  }
  txeqs <- tx

  if (go.pdf) {
    if (dev.cur() > 1) {
      dev.off()
      .showfile(pdf_file, "scatterplot")
      cat("\n\n")
    }
  }

  # Generate ancova text output
  # ---------------------------
  tx <- character(length = 0)
  title_eqs <- paste("\n  MODELS OF", nm[1], "FOR LEVELS OF", nm.a[x.cat])

  # test interaction
  tx[1] <- "-- Test of Interaction"
  tx[length(tx)+1] <- " "

  nm.a <- names(d.ancova)
  lm2.out <- lm(d.ancova[,nm.a[1]] ~ 
                d.ancova[,nm.a[2]] * d.ancova[,nm.a[3]])
  a.tbl <- anova(lm2.out)
  a <- round(a.tbl[3,], 3)  # 3rd row is interaction row
  a.int <- paste(nm.a[2], ":", nm.a[3],
                 "  df: ", a[1,1], "  df resid: ", a.tbl[nrow(a.tbl),1],
                 "  SS: ", a[1,2], "  F: ",  a[1,4], "  p-value: ", a[1,5],
                 sep="") 

  # generate the equation for each group
  tx[length(tx)+1] <- a.int 
  tx[length(tx)+1] <- " "
  tx[length(tx)+1] <- paste(
      "-- Assume parallel lines, no interaction of", nm.a[x.cat], "with",
      nm.a[x.cont], "\n")
  n.levels <- length(unique(na.omit(d.ancova[,nm.a[x.cat]])))
  for (i.level in seq_len(n.levels))
    tx[length(tx)+1] <- txeqs[i.level]

  tx[length(tx)+1] <- " "
  tx[length(tx)+1] <- "-- Visualize Separately Computed Regression Lines"
  tx[length(tx)+1] <- paste("\n", "Plot(", nm.a[x.cont], ", ", nm[1],
       ", by=", nm.a[x.cat], ", fit=\"lm\")", sep="")   
  txmodels <- tx


  return(invisible(list(i=plt.i, ttl=plt.title, txmdl=txmodels)))
}

getColors <-
function(pal=NULL, end_pal=NULL,
         n=12, h=0, h2=NULL, c=NULL, l=NULL, transparency=0,
         in_order=NULL, fixup=TRUE, power=NULL,
         shape=c("rectangle", "wheel"), radius=0.9, border="lightgray",
         main=NULL, labels=NULL, labels_cex=0.8, lty="solid",
         output=NULL, quiet=getOption("quiet"), ...) {


  # a dot in a parameter name to an underscore
  n.miss <- missing(n)
  dots <- list(...)
  if (length(dots) > 0) {
    change <- c("end.pal", "in.order", "labels.cex")
    for (i in seq_along(dots)) {
      if (names(dots)[i] %in% change) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
      }
    }
  }

  shape <- match.arg(shape)

  h.miss <- missing(h)
  l.miss <- missing(l)
  c.miss <- missing(c)

  main.miss <- missing(main)
  if (!is.null(main)) if (!main.miss) if (main=="" || main==" ") main <- NULL

  output.miss <- missing(output)

  # default output is FALSE unless a direct manual call from the console
  # for Markdown files, need to set OUTPUT=TRUE if a direct call
  if (output.miss)
    output <- sys.nframe() == 1

  if (!is.null(end_pal) && length(pal) > 1) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "To specify a sequence of colors, only specify one beginning color\n\n")
  }

  if (is.null(in_order))
    in_order <- shape == "wheel"  # for a wheel do in order

  if (!missing(h2)  &&  !isTRUE(in_order)) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
       "h2 only applies to generate a straight sequence of HCL colors\n",
       "  so in_order must be TRUE\n\n")
  }

  if (border %in% c("off", "transparent")) border <- NA

  # default color scale
  ln.c <- length(c)
  ln.l <- length(l)
  if (is.null(pal) && is.null(end_pal) && ln.c<=1 && ln.l<=1) {
    if (getOption("theme") %in% c("gray", "white"))
      pal <- "grays"
    else
      pal <- "hues"
  }

  if (!is.null(pal[1]))
    if (pal[1] == "yellows") pal[1] <- "browns"  # as of 3.7.7
  if (!is.null(end_pal))
    if (end_pal[1] == "yellows") end_pal[1] <- "browns"

  if (!is.null(pal)) if (pal[1] == "magma") pal[1] <- "plasma"  # approx magma

  nm <- c("reds", "rusts", "browns", "olives", "greens", "emeralds",
          "turquoises", "aquas", "blues", "purples", "violets",
          "magentas", "grays")
  nmV<- c("viridis", "cividis", "plasma", "spectral")
  nmO<- c("Okabe-Ito")
  nmD<- c("distinct")
  nmW<- c("BottleRocket1", "BottleRocket2", "Rushmore1", "Rushmore",
          "Royal1", "Royal2", "Zissou1", "Darjeeling1", "Darjeeling2",
          "Chevalier1", "FantasticFox1", "Moonrise1", "Moonrise2",
          "Moonrise3", "Cavalcanti1", "GrandBudapest1", "GrandBudapest2",
          "IsleofDogs1", "IsleofDogs2")
  nmR <- c("rainbow", "heat", "terrain",
           "rainbow_hcl", "heat_hcl", "terrain_hcl")
  nmT <- c("Tableau")


  # set kind of analysis: qualitative, sequential, divergent, or manual
  # -------------------------------------------------------------------

  if (!is.null(pal)) {  # at least one color specified

    if (pal[1] %in% nm) {
      kind <- "sequential"
    if (!is.null(end_pal[1])) if (end_pal[1] %in% nm)
      kind <- "divergent"
    }
    else if (pal[1] %in% nmR)
      kind <- "seq.R"
    else if (pal[1] == "hues")
      kind <- "qualitative"
    else if (pal[1] %in% nmV)
      kind <- "viridis"
    else if (pal[1] %in% nmO)
      kind <- "oi"
    else if (pal[1] %in% nmW)
      kind <- "wes"
    else if (pal[1] %in% nmD)
      kind <- "distinct"
    else if (pal[1] %in% nmT)
      kind <- "Tableau"

    else {  # pal[1] not in any nm vector
      if (is.null(end_pal))  # no ending color specified
        kind <- "manual.q"  # manual qualitative sequence
      else
        kind <- "manual.s"  # manual sequential sequence
    }
  }  # end pal is not null

  else {  # is.null pal -- defaults
    if (length(c) > 1  ||  length(l) > 1)  # multiple chroma or luminance
      kind <- "sequential"
    else
      kind <- "qualitative"
  }


  # misc
  # ----

  # set default value of labels
  if (is.null(labels))
    labels <- kind == "qualitative"

  # set hcl hue for pre-defined color sequence
  if (!is.null(pal)) {
    if (pal[1] %in% nm) {
      if (pal[1] == "reds") h <- 0
      if (pal[1] == "rusts") h <- 30
      if (pal[1] == "browns") h <- 60
      if (pal[1] == "olives") h <- 90
      if (pal[1] == "greens") h <- 120
      if (pal[1] == "emeralds") h <- 150
      if (pal[1] == "turquoises") h <- 180
      if (pal[1] == "aquas") h <- 210
      if (pal[1] == "blues") h <- 240
      if (pal[1] == "purples") h <- 270
      if (pal[1] == "violets") h <- 300
      if (pal[1] == "magentas") h <- 330
      if (pal[1] == "grays") {
        c <- 0
        c.miss <- FALSE
      }
      if (is.null(end_pal)) pal <- NULL
    }
    if (!is.null(end_pal)) {
      if (end_pal[1] %in% nm) {
      if (end_pal[1] == "reds") h2 <- 0
      if (end_pal[1] == "rusts") h2 <- 30
      if (end_pal[1] == "browns") h2 <- 60
      if (end_pal[1] == "olives") h2 <- 90
      if (end_pal[1] == "greens") h2 <- 120
      if (end_pal[1] == "emeralds") h2 <- 150
      if (end_pal[1] == "turquoises") h2 <- 180
      if (end_pal[1] == "aquas") h2 <- 210
      if (end_pal[1] == "blues") h2 <- 240
      if (end_pal[1] == "purples") h2 <- 270
      if (end_pal[1] == "violets") h2 <- 300
      if (end_pal[1] == "magentas") h2 <- 330
      if (end_pal[1] == "grays") {
          c <- 0
          c.miss <- FALSE
        }
        pal <- NULL
      }
    }
  }


  # -----------------
  # set color palette

  lbl <- character(length=n)

  # qualitative HCL colors at constant c and l
  if (kind == "qualitative") {
    if (!h.miss) if (length(h) > 1) n <- length(h)
    if (is.null(h2)) h2 <- h + (360 * (n - 1) / n)
    if (n <= 24) {
      if (!in_order) { # mixed hues
        h <- c(240,60,120,0,275,180,30,90,210,330,150,300)
        h <- c(h, h+15)  # 12 hues + 12 offset = 24 unique colors
      }
      else  # in_order
        h <- seq(h, h2, length=n)  # vary hue systematically
    }
    else {  # n too big
      h <- seq(h, h2, length=n)  # the hcl hues
      if (!in_order) {
         o <- sample.int(n)
         h <- h[o]
      }
    }

    h[which(h >= 360)] <- h[which(h >= 360)] - 360
    h[which(h < 0)] <- h[which(h < 0)] + 360

    if (c.miss) c <- 65
    if (l.miss) l <- 60
    pal <- hcl(h, c, l, fixup=fixup)[1:n]  # generate the colors
    lbl <- .fmt(h, 0)
    ttl <- paste("HCL Color Palette for\n",
                 "Chroma=", c, " Luminance=", l)
  }  # end qualitative

  # sequential HCL color palette
  else if (kind == "sequential") {
    if (c.miss)
      c <- c(35, 75)
    else
      if (length(c) == 1L) c <- c(c, c)  # constant chroma across gradient
    txt.c <- .fmt(c[1], 0)
    if (length(c) > 1)
      txt.c <- paste(txt.c, " to ", .fmt(c[2],0), sep="")

    l.dk <- 35 - (3*n)  # darkest color
    if (l.dk < 14) l.dk <- 14  # any darker and the hue is no longer true
    l.lt <- 52 + (5*n)  # lightest color
    if (l.lt > 92) l.lt <- 92
    if (l.miss)
      l <- c(l.lt, l.dk)
    else
      if (length(l) == 1L) l <- c(l, l)  # constant luminance across gradient
    txt.l <- .fmt(l[1], 0)
    if (length(l) > 1)
      txt.l <- paste(txt.l, " to ", .fmt(l[2],0), sep="")

    if (is.null(power)) power <- 1
    pal <- colorspace::sequential_hcl(n, h=h, c.=c, l=l, power=power,
                          fixup=fixup, alpha=1)
    ttl <- paste("Sequential Colors for\n", "h=", .fmt(h,0),
                  ", c=", txt.c, ",  l=", txt.l, sep="")
  }

  # divergent HCL color palette
  else if (kind == "divergent") {
    h <- c(h, h2)
    txt.h <- .fmt(h[1],0)
    if (length(h) > 1)
      txt.h <- paste(txt.h, " to ", .fmt(h[2],0), sep="")

    if (c.miss) c <- 50
    txt.c <- .fmt(c,0)
    if (length(c) > 1)
      txt.c <- paste(txt.c, " to ", .fmt(c[2],0), sep="")

    if (l.miss) l <- c(30,80)
    txt.l <- .fmt(l[1],0)
    if (length(l) > 1)
      txt.l <- paste(txt.l, " to ", .fmt(l[2],0), sep="")

    if (is.null(power)) power <- 0.75
    pal <- colorspace::diverging_hcl(n, h=h, c=c, l=l, power=power,
                       fixup=fixup, alpha=1)
    ttl <- paste("Divergent Colors for\n", "h=", txt.h,
                  ", c=", txt.c, ",  l=", txt.l, sep="")
  }

  # viridis sequence
  else if (kind == "viridis") {
    ttl <- paste("Viridis Style Color Palette for:", pal[1], "\n")
    pal <- hcl.colors(n, palette = pal[1])
  }

  # Okabe-Ito colors
  else if (kind == "oi") {
    ttl <- paste("Okabe-Ito Colors Palette", pal[1], "\n")
    pal <- palette.colors(n=9, palette="Okabe-Ito", alpha=1)[2:9]  # skip leading black
    pal <- c(pal, "#000000FF")  # append black at the end
    if (n.miss) n <- 9
    if (n <= 9)
      pal <- pal[1:n]
    else {
      print(pal[1:9])
      cat("\n"); stop(call.=FALSE, "\n------\n",
         "Only 9 Okabe-Ito colors available.\n",
         "Can start with a vector of the above 9 colors, then add more.\n\n")
    }
  }

 # Tableau colors
  else if (kind == "Tableau") {
    ttl <- paste("Tableau Qualitative Colors Palette", pal[1], "\n")
    pal <- c("#4E79A7", "#F28E2B", "#E15759", "#76B7B2", "#59A14F",
             "#EDC949", "#AF7AA1", "#FF9DA7", "#9C755F", "#BAB0AC")
    if (n.miss) n <- 10
    if (n <= 10)
      pal <- pal[1:n]
    else {
      print(pal[1:10])
      cat("\n"); stop(call.=FALSE, "\n------\n",
         "Only 10 Tableau colors available.\n",
         "Can start with a vector of the above 10 colors, then add more.\n\n")
    }
  }

  # Wes Anderson sequence
  else if (kind == "wes") {
    if (!requireNamespace("wesanderson", quietly=TRUE)) {
      stop("Package \"wesanderson\" needed for these colors\n",
           "Please install it:  install.packages(\"wesanderson\")\n\n",
           call. = FALSE)
    }
    ttl <- paste("A Wes Anderson Color Palette for:", pal[1], "\n")
    pal <- wesanderson::wes_palette(pal[1], n, type="continuous")
  }

# pre-specified distinct colors
  else if (kind == "distinct") {
    ttl <- paste("Colors Palette", pal[1], "\n")
    pal <- c(
             "goldenrod2", "gray45", "yellowgreen", "orchid3", "skyblue",
             "darkgray", "lightcoral", "navajowhite4", "cyan3", "darkorange3",
             "maroon3", "mediumaquamarine", "royalblue1", "mistyrose4",
             "thistle3")
    if (n <= 15)
      pal <- pal[1:n]
    else {
      print(pal[1:15])
      cat("\n"); stop(call.=FALSE, "\n------\n",
         "Only 15 distinct colors available.\n",
         "Can start with a vector of the above 15 colors, then add more.\n\n")
    }
  }

  # custom color sequence
  else if (kind == "manual.s") {
    color_palette <- colorRampPalette(c(pal, end_pal))
    pal <- color_palette(n)
    ttl <- "Custom Color Sequence"
  }

  # user specified multiple colors
  else if (kind == "manual.q") {
    n <- length(pal)
    ttl <- ""
  }

  else if (kind == "seq.R") {
    if (is.null(l)) l <- 60
    if (is.null(c)) c <- 65

    if (pal == "rainbow") {
      pal <- rainbow(n)
      ttl <- "Rainbow Colors"
    }
    else if (pal == "terrain") {
      pal <- terrain.colors(n)
      ttl <- "Terrain Colors"
    }
    else if (pal == "heat") {
      pal <- heat.colors(n)
      ttl <- "Heat Colors"
    }
    else if (pal == "rainbow_hcl") {
      pal <- colorspace::rainbow_hcl(n, l=l, c=c)
      ttl <- "Rainbow HCL Colors"
    }
    else if (pal == "terrain_hcl") {
      pal <- colorspace::terrain_hcl(n, l=l, c.=c)
      ttl <- "Terrain HCL Colors"
    }
    else if (pal == "heat_hcl") {
      pal <- colorspace::heat_hcl(n, l=l, c.=c)
      ttl <- "Heat HCL Colors"
    }
  }

  # set lbl except for hcl which provides the hues
  if (lbl[1] == "") lbl <- pal

  if (transparency > 0)
   for (i in seq_along(pal)) pal[i] <- .maketrans(pal[i], (1-transparency)*256)

  # --------------------
  # plot and text output
  if (output) {

    # ----
    # plot

    # ttl is constructed, the default title if main not specified
    if (main.miss)
      main.lab <-  ttl
    else
      main.lab <- main  # could be NULL

    if (!labels) lbl <- NA

    par(bg=getOption("panel_fill"))

    if (shape == "wheel") {
      top <- if (is.null(main.lab)) 0.2 else 0.7
      par(mai=c(.1, 0, top, 0))

      # pie() sets up its own square coordinate system via plot.window(asp=1)
      pie(rep(1, length(pal)), col=pal, radius=radius, labels=lbl,
          border=border, lty=lty, cex=labels_cex)
    }  # end wheel

    else if (shape == "rectangle")  {
      top <- if (is.null(main.lab)) 0.2 else 0.5
      par(mai=c(.1, .1, top, .1))
      if (labels) {
        if (kind == "qualitative") {
          rotate_x <- 0
          bm <- 0.05
          bm.tx <- 0
        }
        else {
          rotate_x <- 90
          bm <- 0.24
          bm.tx <- 0.10
        }
      }  # end label
      else {
        rotate_x <- 0
        bm <- 0
        bm.tx <- 0
      }

      plot(0, 0, type="n", xlim=c(0, 1), ylim=c(0, 1), axes=FALSE,
           xlab="", ylab="")
      rect(0:(n-1)/n, bm, 1:n/n, 1, col=pal, border=border)
      text(0:(n-1)/n + 1/(2*n), bm.tx, labels=lbl[1:n], srt=rotate_x,
           cex=labels_cex)
    }  # end rectangle

    if (!is.null(main.lab))
      title(main=main.lab, cex.main=getOption("main_size"),
            col.main=getOption("main_color"), ...)


    # -----------
    # text output

    if (!quiet) {
      mc <- max(nchar(na.omit(pal)))
      cat("\n")
      if (kind %in% c("qualitative", "sequential")) {  # HCL colors
        if (kind == "sequential") {
          hh <- h[1]  # h a scalar here (except for grays)
          h <- rep(hh, n)
        }
        cat("      h    hex      r    g    b\n")
        cat("-------------------------------\n")
        for (i in seq_along(pal))
              cat(.fmt(i,0,w=2), " ", .fmt(h[i],0, w=3), pal[i],
                  .fmt(col2rgb(pal[i])[1],0,w=4),
                  .fmt(col2rgb(pal[i])[2],0,w=4),
                  .fmt(col2rgb(pal[i])[3],0,w=4),"\n")
      }

      else {  # no single hue column (divergent, wes, distinct, manual, ...)
        cat("  color    r    g    b\n")
        cat("----------------------\n")
          for (i in seq_along(pal))
            cat(.fmtc(pal[i], w=mc, j="left"),
                .fmt(col2rgb(pal[i])[1],0,w=4), .fmt(col2rgb(pal[i])[2],0,w=4),
                .fmt(col2rgb(pal[i])[3],0,w=4),"\n")
      }
    }
    cat("\n")
  }  # do output

  return(invisible(pal))
}

corEFA <- 
function (R=mycor, n_factors, rotate=c("promax", "varimax", "none"), 
          min_loading=.2, sort=TRUE, ...) {


  # a dot in a parameter name to an underscore
  dots <- list(...)
  change <- c("n.factors", "min.loading")
  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] %in% change) {
        pnm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(pnm, dots[[i]])
      }
    }
  }
  dots_clean <- dots[!names(dots) %in% change]

  cl <- match.call()

  rotate <- match.arg(rotate)

  if (missing(n_factors)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the number of factors with:  n_factors=\n\n")
  }

  if (!("matrix" %in% class(R))) { # R is a matrix, can be called indirectly
    # cor matrix:  mycor as class out_all, mycor$R, or stand-alone matrix
    cor.nm <- deparse(substitute(R))
    .cor.exists(cor.nm)  # see if matrix exists in one of the 3 locations
    if ("out_all" %in% class(R))  # R 4.0 results in two values: matrix, array
      R <- eval(parse(text=paste(cor.nm, "$R", sep="")))  # go to $R 
  }

  title_efa <- "  EXPLORATORY FACTOR ANALYSIS"

  txer <- ""
  if (is.null(options()$knitr.in.progress)) {
    tx <- character(length = 0)
    tx[length(tx)+1] <- "Extraction: maximum likelihood"
    if (n_factors > 1)  tx[length(tx)+1] <- paste("Rotation:", rotate)
    txer <- tx
  }

  # EFA
  fa2 <- do.call(factanal,
    c(list(covmat=R, factors=n_factors, rotation="none"), dots_clean))
  if (rotate=="none" || n_factors==1) ld <- as.matrix(fa2$loadings)

  if (n_factors>1  &&  rotate!="none") {
    if (rotate == "promax") rtt <- promax(loadings(fa2))
    if (rotate == "varimax") rtt <- varimax(loadings(fa2))
    ld <- loadings(rtt)
  }

  n.ind <- nrow(ld)

  # sort option
  # mx: # factor with highest factor loading for each item
  if (sort) {
    mx <- max.col(abs(ld))  
    ld <- ld[order(mx), ]  # group items on same factor together

    fn <- max.col(abs(ld))  # each item, factor with its highest loading
    ld <- data.frame(cbind(fn, ld))

    ld.new <- matrix(nrow=0, ncol=1+n_factors)
    for (i in seq_len(n_factors)) {
      lf <- ld[ld$fn==i,]  # extract items for ith factor
      ord <- order(abs(lf[[i+1]]), decreasing=TRUE)
      lf <- lf[ord,]
      ld.new <- rbind(ld.new,lf)  # preserves row names 
    }
    ld <- ld.new[,-1]  # remove fn column
  }

  # print loadings
  # from_efa lets .prntbl adjust column widths differently 
  tx <- character(length = 0)
  tx[length(tx)+1] <- paste("Loadings (except -", min_loading, " to ",
     min_loading, ")", sep="") 
  txld <- .prntbl(ld, digits_d=3, cut=min_loading, from_efa=TRUE)
  for (i in seq_along(txld)) tx[length(tx)+1] <- txld[i]
  txld <- tx

  # print sum of squares by factor
  vx <- colSums(ld^2)
  varex <- rbind(`SS loadings` = vx)
  varex <- rbind(varex, `Proportion Var` = vx/n.ind)
  if (n_factors > 1) 
    varex <- rbind(varex, `Cumulative Var` = cumsum(vx/n.ind))
  tx <- character(length = 0)
  tx[length(tx)+1] <- "Sum of Squares"
  txss <- .prntbl(varex, 3)
  for (i in seq_along(txss)) tx[length(tx)+1] <- txss[i]
  txss <- tx


  title_cfa <- "  CONFIRMATORY FACTOR ANALYSIS CODE"

  # generate the MIMM code
  FacItems <- integer(length=n.ind)  # factor with highest loading for item
  Fac <- integer(length=n.ind)
  n.Fact <- integer(length=n_factors)

  for (i in seq_len(n.ind)) {
    max.ld <- 0
    FacItems[i] <- 0
    for (j in seq_len(n_factors)) {
      if (abs(ld[i,j]) > max.ld  &&  abs(ld[i,j]) > min_loading) {
        max.ld <- abs(ld[i,j])
        FacItems[i] <- j
      }
    }
  }


  tx <- character(length = 0)

  tx[length(tx)+1] <- "MeasModel <- "
  for (i.fact in seq_len(n_factors)) {
    n.Fact[i.fact] <- 0
    k <- 0
    for (j.item in seq_len(n.ind)) if (FacItems[j.item] == i.fact) {
      k <- k + 1
      Fac[k] <- j.item
      n.Fact[i.fact] <- n.Fact[i.fact] + 1
    }
    if (i.fact == 1)
      tx[length(tx)+1] <- "\""
    else
      tx[length(tx)+1] <- " "
    tx[length(tx)] <- paste(
      tx[length(tx)], "  F", as.character(i.fact), " =~ ", sep="")
    if (n.Fact[i.fact] > 0) {
      for (i in seq_len(n.Fact[i.fact])) {
        tx[length(tx)] <- paste(tx[length(tx)], rownames(ld)[Fac[i]], sep="")
        if (i < n.Fact[i.fact])
          tx[length(tx)] <- paste(tx[length(tx)], " + ", sep="")
      }
    }
    if (i.fact == n_factors) tx[length(tx)] <- paste(tx[length(tx)], "\n\"")
  }

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "fit <- lessR::cfa(MeasModel)\n"

  tx[length(tx)+1] <- "library(lavaan)"
  tx[length(tx)+1] <- "fit <- lavaan::cfa(MeasModel, data=d)"
  tx[length(tx)+1] <- "summary(fit, fit.measures=TRUE, standardized=TRUE)"
  txcfa <- tx


  # report any deleted items
  deleted <- integer(length=n.ind)
  del.count <- 0
  for (i.item in seq_len(n.ind)) if (FacItems[i.item] == 0) {
    del.count <- del.count + 1
    deleted[del.count] <- i.item
  }

  txdel <- ""
  tx <- character(length = 0)
  if (del.count > 0) {
    tx[length(tx)+1] <- paste("Deletion threshold: min_loading = ", 
        min_loading, sep="")
    tx[length(tx)+1] <- "Deleted items: "
    for (i.item in seq_len(del.count))
      tx[length(tx)] <- paste(tx[length(tx)], rownames(ld)[deleted[i.item]],
                              " ", sep="")
    txdel <- tx
  }


  class(title_efa) <- "out"
  class(txer) <- "out"
  class(txld) <- "out"
  class(txss) <- "out"
  class(title_cfa) <- "out"
  class(txcfa) <- "out"
  class(txdel) <- "out"

  output <- list(
    out_title_efa=title_efa, out_type=txer, out_loadings=txld, out_ss=txss,
    out_title_cfa=title_cfa, out_cfa_code=txcfa,
    out_deleted=txdel,

    converged=fa2$converged, n_factors=n_factors, ss_factors=vx,
    loadings=ld, call=cl)

  class(output) <- "out_all"
  return(output)

}

# -----------
# Scatterplot
# -----------

library(shiny)
library(lessR)
library(openxlsx)

clr.one <- list(
  "#324E5C", "dodgerblue3", "cornflowerblue", "steelblue", "darkblue",
  "pink2", "red3", "firebrick2", "darkred",
  "violetred", "mediumorchid", "purple3",
  "darkorange2", "salmon", "orange3", "sienna", "rosybrown", 
  "wheat3", "goldenrod2", "khaki", "yellow2",
  "darkseagreen2", "springgreen3", "seagreen4", "darkgreen",
  "black", "gray45", "slategray4", "gray75", "snow3", "gray95",
  "lavender", "ivory2", "aliceblue", "white")

clr.edge <- list("off", "black", "gray50", "gray75", "white", "ivory", 
  "darkblue", "darkred", "darkgreen", "rosybrown2", "bisque", 
  "slategray2", "aliceblue", "thistle1", "coral", "gold")

clr.qual <- c("hues", "Okabe-Ito", "viridis")

clr.seq <- list("reds", "rusts", "browns", "olives", "greens",
  "emeralds", "turquoises", "aquas", "blues", "purples", "violets",
  "magentas", "grays")

clr.fit <- c("#5C4032", clr.one[2:length(clr.one)])

addResourcePath("shiny_dir", system.file("shiny_apps", package="lessR"))


ui <- fluidPage(
  tags$head(tags$link(rel="stylesheet", href="shiny_dir/styles.css")),

  tabsetPanel(

    tabPanel("Data",
      titlePanel(div("Upload a text (.csv, .txt) or Excel file", id="hp")),

      sidebarLayout(
        sidebarPanel(

          radioButtons("fType", HTML("<h5 class='soft'>Format</h5>"), 
                       c("Excel"="Excel", "Text"="Text")),
          conditionalPanel(condition="input.fType == 'Text'",
            radioButtons("sep", HTML("<h5 class='soft'>Separator</h5>"),
                         c(Comma=",", Semicolon=";", Tab="\t"), ","),
            radioButtons("decimal", HTML("<h5 class='soft'>Decimal</h5>"),
                         c("Point"=".", "Comma"=",")),
          ),

          radioButtons("fSource", HTML("<h5 class='soft'>Source</h5>"), 
                       c("Local"="local", "Web"="web")),
          conditionalPanel(condition="input.fSource == 'local'",
            fileInput("myFile", "Locate your data file",
                      accept=c(".csv", ".txt", ".xlsx", ".xlsm")),
          ),
          conditionalPanel(condition="input.fSource == 'web'",
            textInput("myURL", "Web address of data file"),
            actionButton("submitURL", "Submit")
          ),

          textOutput("nrows"),
          textOutput("ncols"),
          uiOutput("d.show"),

        ),  # end sidbarPanel

        mainPanel(
          tableOutput("d.table"),
          tags$style(type="text/css", "#d.table {font-size: .95em;}")
        )

      )  # end sidbarLayout
    ),  # end tabPanel 1


    tabPanel("Scatterplot",
      pageWithSidebar(
        titlePanel(""),

        sidebarPanel(
          selectInput('x.col', 'x Variable', ""),
          selectInput('y.col', 'y Variable', "", selected=""),

          checkboxInput("do_by", div("by variable", class="view"), FALSE),
          conditionalPanel(condition="input.do_by == true",
            selectInput("by.col", "by Variable", "", selected=""),
            selectInput("myFill_by", "fill",
              choices=list("Qualitative"=clr.qual, "Sequential"=clr.seq)),
          ),

          checkboxInput("do_size", div("size variable", class="view"), FALSE),
          conditionalPanel(condition="input.do_size == true",
            selectInput('size.col', 'size Variable', "", selected=""),
          ),

          tags$hr(),
          checkboxInput("do_geom", div("Points", class="view"), FALSE),
          conditionalPanel(condition="input.do_geom == true",
            conditionalPanel(condition="input.do_by == false",
              selectInput("myFill", "fill", choices=clr.one),
              selectInput("myColor", label="color", choices=clr.edge),
            ),
            sliderInput("myTrans", "transparency", min=0, max=1, value=0),
            conditionalPanel(condition="input.do_size == false",
              sliderInput("mySize", "size", min=0.0, max=5, value=1.25,
                          step=0.25)),
            conditionalPanel(condition="input.do_size == false",
              selectInput("myShape", "shape",
              choices=list("circle", "square", "diamond", "triup", "tridown")),
            ),
          ),

          tags$hr(),
          checkboxInput("do_FlEO", 
                        div("Line, Ellipse, Outliers", class="view"), FALSE),
          conditionalPanel(condition="input.do_FlEO == true",
            conditionalPanel(condition="input.do_by == false",
              checkboxInput("myEnhance", "enhance", value=FALSE),
              checkboxInput("myAddMeans", "add=\"means\"", value=FALSE),
            ),
            selectInput("myFit", "fit",
              choices=list("off", "loess", "lm", "exp", "quad", "null")),
            conditionalPanel(condition="input.myFit != 'off'",
              checkboxInput("myErrors", "plot_errors", value=FALSE),
              conditionalPanel(condition="input.do_by == false",
                selectInput("myFitClr", "fit_color", choices=clr.fit),
              ),
              sliderInput("myFitSE", "fit_se", min=0, max=0.99, value=0.95),
            ),
            sliderInput("myEllipse", "ellipse", min=0, max=0.99, value=0),
            conditionalPanel(condition="input.do_by == false",
              sliderInput("myMDcut", "MD_cut", min=0, max=15, value=0),
              conditionalPanel(condition="input.myMDcut > 0",
                selectInput('ID.col', 'ID variable', "", selected=""),
              ),
            ),
          ),

          tags$hr(),
          checkboxInput("do_jitter", div("Jitter", class="view"), FALSE),
          conditionalPanel(condition="input.do_jitter == true",
            sliderInput("myJitx", "jitter_x", min=0, max=1000, value=0,
                        step=0.5),  # need the max value set from data
            sliderInput("myJity", "jitter_y", min=0, max=1000, value=0,
                        step=0.5),
          ),

          tags$hr(),
          checkboxInput("do_rotate", div("Rotate Labels", class="view"), FALSE),
          conditionalPanel(condition="input.do_rotate == true",
            sliderInput("myRttx", "rotate_x", min=0, max=90, value=0, step=10),
            sliderInput("myRtty", "rotate_y", min=0, max=90, value=0, step=10),
            sliderInput("myOff", "offset", min=0, max=4, value=0.5, step=0.25),
          ),

          tags$hr(),
          checkboxInput("do_pdf", div("Save", class="view"), FALSE),
          conditionalPanel(condition="input.do_pdf == true",
            sliderInput("w", "width (inches):", min=3, max=20, value=8),
            sliderInput("h", "height (inches):", min=3, max=20, value=6),
            checkboxInput("do_cmt", "include comments in R file", TRUE),
            actionButton(inputId="btn_pdf", "Save"),
            tags$p(div("Save pdf file and R code file",
                  style="margin-top:.25em; margin-bottom:0em;")),
          ),

          tags$hr(),
          checkboxInput("do_help", div("Help", class="view"), FALSE),

        ),  # end sidebarPanel

        mainPanel(
          plotOutput('myPlot'),
          verbatimTextOutput("summary"),
          plotOutput("saved_plot"), 
          textOutput("help")
        )

      )  # end pageWithSidebar
    )  # end tabPanel 2
  )  # end tabsetPanel
)  # end fluidPage 



server <- function(input, output, session) {

  v <- reactiveValues()
  v$add <- NULL


  # ------- Read and Display Data -----------
  # -----------------------------------------

  # process the URL for reading from the web
  theURL <- eventReactive(input$submitURL, {
    input$myURL
  })

  data <- reactive({
    if (input$fSource == "local") {
      shiny::req(input$myFile)
      myPath <- input$myFile$datapath
      theRead <- input$myFile$name
    }
    if (input$fSource == "web") {
      url <- theURL()
      if (!grepl("^https?://", url))
        url <- paste("https://", url, sep="")
      myPath <- url
      theRead <- myPath
    }
      
    shiny::req(myPath)
    if (input$fType == "Excel") { 
      if (grepl(".xlsx", myPath, fixed=TRUE)) {
        d <- read.xlsx(myPath, detectDates=TRUE)
      }
      else {
        message("\n>>> Excel file must have file type of .xlsx <<<\n\n")
        stopApp()
      }
    }
    if (input$fType == "Text") { 
      if ((grepl(".csv", myPath, fixed=TRUE)) ||
          (grepl(".txt", myPath, fixed=TRUE))) {
        d <- read.csv(myPath, sep=input$sep, dec=input$decimal,
                      na.strings="")  # default is NOT a blank char missing
      }
      else {
        message("\n>>> Text file must have file type of .csv or .txt <<<\n\n")
        stopApp()
      }       
    }  # end fType is "Text"

    shiny::updateSelectInput(session, inputId="x.col", label="x variable",
                      choices=c("Select a variable"="", names(d)))
    shiny::updateSelectInput(session, inputId="y.col", label="y variable",
                      choices=c("Select a variable"="", names(d)))
    
    return(d)
  })  # end reactive()


  output$nrows <- renderText({
    shiny::req(data())
    paste("Number of data rows:", nrow(data()))
  })
  output$ncols <- renderText({
    shiny::req(data())
    paste("Number of variables:", ncol(data()))
  })

  output$d.show <- renderUI({
    shiny::req(data())
    if (nrow(data()) > 10)
      radioButtons("d.show", HTML("<h5 class='soft'>Rows to display</h5>"),
                   c("First 10"="head", "Last 10"="tail", "Random 10"="random",
                     "All"="all"))
  })


  output$d.table <- renderTable({
    if (is.null(input$d.show)) 
      data()
    else {
      nr <- min(11, nrow(data()))
      if (nr == 11) {
        if (input$d.show == "all")
          data()
        else if (input$d.show == "head")
          head(data(), n=10)
        else if (input$d.show == "tail")
          tail(data(), n=10)
        else if (input$d.show == "random") { 
          dd <- data()
          dd[sample(nrow(dd), min(10, nrow(dd))), ]
        }
      }
    }
  }, striped=TRUE)  # end renderTable

  # -----------------------------------------


  observeEvent(input$do_by, {

    d <- data()
    is.cat <- sapply(d, function(x) {
      lu.x <- length(unique(x))
      (is.character(x) || is.factor(x) || lu.x < 11) && (lu.x < nrow(d))
    })

    if (all(!is.cat)) {
      message("A  by  variable partitions values of a categorical variable.\n",
              "Categorical variables have non-numeric values or, if numeric,\n",
              "  defined here as 10 or fewer unique values.\n\n",
              "No categorical variables are present in this data set.")
      stopApp()
    }

    the.cats <- names(d)[is.cat]
    shiny::updateSelectInput(session, inputId="by.col", label="by variable",
                        choices=c("Select a categorical variable"="", the.cats))
  })


  observeEvent(input$do_size, {
    d <- data()
    shiny::updateSelectInput(session, inputId="size.col", label="size variable",
                        choices=c("Select a numerical variable"="",
                        names(d)[sapply(d, is.numeric)]))
  })


  observeEvent(input$myMDcut, {
    shiny::req(input$myMDcut > 0)

    d <- data()
    is.unique <- sapply(d, function(x) {
      l.x <- length(x)
      lu.x <- length(unique(x))
      l.x == lu.x
    })

    if (all(!is.unique)) {
      message("An  ID  variable must have unique values.\n",
              "No variables have unique values in this data set.")
      stopApp()
    }

    the.unique <- c("row.name", names(d)[is.unique])
    shiny::updateSelectInput(session, inputId="ID.col", label="ID variable",
                        choices=c("Var with unique values"="", the.unique),
                        selected="row.name")
  })


  # ------------ Enhance and Add ------------
  # -----------------------------------------

  observeEvent(input$myAddMeans, {
    if (input$myAddMeans)
      v$add <- "means"
    else
      v$add <- NULL    
  })


  observeEvent(input$myEnhance, {
    if (input$myEnhance) {
      v$add <- "means"
      add.val <- TRUE
    }
    else {
      v$add <- NULL
      add.val <- FALSE
    }
    updateCheckboxInput(session, inputId="myAddMeans", "add=\"means\"",
        value=add.val)

    elp.val <- ifelse (input$myEnhance, 0.95, 0)
    updateSliderInput(session, inputId="myEllipse", "ellipse",
         min=0, max=0.99, value=elp.val)

    fit.val <- ifelse (input$myEnhance, "lm", "off")
    updateSelectInput(session, inputId="myFit", "fit", 
         choices=list("off", "loess", "lm", "exp", "quad", "null"),
         selected=fit.val)
    if (!input$do_by) {
      MDc.val <- ifelse (input$myEnhance, 6, 0)
      updateSliderInput(session, inputId="myMDcut", "MD_cut",
           min=0, max=15, value=MDc.val)
    }
  })
 


  # ------------ The Scatterplot ------------
  # -----------------------------------------

  output$myPlot <- renderPlot({
    x.name <- input$x.col
    shiny::req(x.name)
    x <- data()[, x.name]

    y.name <- input$y.col
    shiny::req(y.name)
    y <- data()[, y.name]

    in.fill <- input$myFill
    in.shp  <- input$myShape

    by <- NULL
    lt <- NULL  # legend_title

    # by-variable logic + shape mapping
    if (input$do_by) {  # a by variable
      by.name <- input$by.col
      shiny::req(by.name)
      by <- data()[, by.name]
      in.fill <- input$myFill_by  # color range selection

      # still map to numeric, but we won't pass shape to XY() when by is present
      if (in.shp == "circle") in.shp <- 21
      if (in.shp == "square") in.shp <- 22
      if (in.shp == "diamond") in.shp <- 23
      if (in.shp == "triup")   in.shp <- 24
      if (in.shp == "tridown") in.shp <- 25

      lt <- by.name
    }

    in.size <- input$mySize   # constant value of size from slider
    if (input$do_size) {  # size variable
      shiny::req(input$size.col)
      in.size <- data()[, input$size.col]
    }
    if (!input$do_size) in.size <- 1.4 * in.size  # scale up, as with axes

    in.fit <- input$myFit
    in.elp <- input$myEllipse
    in.add <- v$add 

    if (input$do_by) {  # choose MD then by var
      in.MD <- 0
      in.ID <- row.names(data())
      if (input$myEnhance) {
        in.fit <- "off" 
        in.elp <- 0
        in.add <- NULL
      }
    }
    else {
      in.MD <- input$myMDcut 
      if (nchar(input$ID.col) != 0) {
        if (input$ID.col != "row.name")
          in.ID <- data()[, input$ID.col]
        else
          in.ID <- row.names(data())
      }
      else
        in.ID <- row.names(data())
    }

    ## ---- Call XY() (scatter) depending on by presence ----
    v$x <- x; v$y <- y; v$by <- by
    v$x.name <- x.name; v$y.name <- y.name

    pt_size_val <- as.numeric(in.size[1])  # scalar path
    if (input$do_size) pt_size_val <- in.size  # vector path, already extracted

    if (input$do_by) {
      v$stats <- XY(
        x, y, by = by, data = NULL,
        type = "scatter",
        fill  = in.fill,
        # no color when by is present; XY will choose colors per group
        transparency = input$myTrans,
        pt_size = pt_size_val,
        # no shape when by is present; XY aligns shapes internally as needed
        plot_errors = input$myErrors,
        fit        = in.fit,
        fit_color  = input$myFitClr,
        fit_se     = input$myFitSE,
        ellipse    = in.elp,
        MD_cut     = in.MD,
        ID         = in.ID,
        add        = in.add,
        enhance    = input$myEnhance,
        jitter_x   = input$myJitx,
        jitter_y   = input$myJity,
        rotate_x   = input$myRttx,
        rotate_y   = input$myRtty,
        offset     = input$myOff,  
        xlab = x.name,
        ylab = y.name,
        legend_title = lt,
        quiet = TRUE
      )
      v$plt <- recordPlot() 

    } else {
      v$stats <- XY(
        x, y, data = NULL,
        type = "scatter",
        fill  = in.fill,
        color = input$myColor,
        transparency = input$myTrans,
        pt_size = pt_size_val,
        shape = in.shp,
        plot_errors = input$myErrors,
        fit        = in.fit,
        fit_color  = input$myFitClr,
        fit_se     = input$myFitSE, 
        ellipse    = in.elp,
        MD_cut     = in.MD,
        ID         = in.ID,
        add        = in.add, 
        enhance    = input$myEnhance,
        jitter_x   = input$myJitx,
        jitter_y   = input$myJity,
        rotate_x   = input$myRttx,
        rotate_y   = input$myRtty,
        offset     = input$myOff,  
        xlab = x.name,
        ylab = y.name,
        legend_title = lt,
        quiet = TRUE
      )
      v$plt <- recordPlot()
    }

    # defaults for code string
    p_fill <- ifelse (!input$do_by, in.fill == "#324E5C",
                                   in.fill == "hues")
    p_color <- input$myColor == "off" || input$do_by
    p_trans <- input$myTrans == 0
    p_by <- input$do_by == FALSE
    p_size <- input$mySize==1.25 && length(in.size)==1
    p_shape <- input$myShape == "circle" || input$do_by  # no shape arg for by
    p_errors <- input$myErrors == FALSE
    p_fit <- in.fit == "off"
    p_fitclr <- input$myFitClr == getOption("fit_color")
    p_fitse <- input$myFitSE == 0.95
    p_ellipse <- in.elp == 0
    p_MDcut <- in.MD == 0
    p_ID <- nchar(input$ID.col)==0 || input$ID.col=="row.name" || in.MD==0
    p_jitx <- input$myJitx == 0
    p_jity <- input$myJity == 0
    p_add <- is.null(in.add)

    # all enhance default settings must be TRUE for enhance to be TRUE
    p_enhance <- FALSE
    if (input$myEnhance && in.MD > 0 && !is.null(v$add)) {
      if (input$myFit=="lm" && input$myEllipse==0.95
          && input$myMDcut==6 && v$add=="means")
        p_enhance <- TRUE
      else
        p_enhance <- FALSE
    }

    out <- paste("XY(", x.name, ", ", y.name, sep="")

    if (!p_fill) out <- paste(out, ", fill=\"", in.fill, "\"", sep="")
    if (!p_color) out <- paste(out, ", color=\"", input$myColor, "\"", sep="")
    if (!p_trans) out <- paste(out, ", transparency=", input$myTrans, sep="")
    if (!p_by && input$do_by)
      out <- paste(out, ", by=", by.name, sep="")
    if (!p_size) {
      sz.out <- ifelse (length(in.size)==1, input$mySize, input$size.col)
      out <- paste(out, ", size=", sz.out, sep="")
    }
    if (!p_shape && !input$do_by)
      out <- paste(out, ", shape=\"", input$myShape, "\"", sep="")
    if (!p_errors) out <- paste(out, ", plot_errors=", input$myErrors, sep="")
    if (!p_fitclr) out <- paste(out, ", fit_color=\"", input$myFitClr,
                                "\"", sep="")
    if (!p_fitse) out <- paste(out, ", fit_se=", input$myFitSE, sep="")
    if (!p_jitx) out <- paste(out, ", jitter_x=", input$myJitx, sep="")
    if (!p_jity) out <- paste(out, ", jitter_y=", input$myJity, sep="")

    if (!p_enhance) {
      if (!p_fit) out <- paste(out, ", fit=\"", in.fit, "\"", sep="")
      if (!p_ellipse) out <- paste(out, ", ellipse=", in.elp, sep="")
      if (!p_MDcut) out <- paste(out, ", MD_cut=", in.MD, sep="")
      if (!p_add) out <- paste(out, ", add=\"", in.add, "\"", sep="")
    }
    else
      out <- paste(out, ", enhance=", p_enhance, sep="")

    if (!p_ID) out <- paste(out, ", ID=\"", input$ID.col, "\"", sep="")

    out <- paste(out, ", type=\"scatter\")", sep="")
    cat(out, "\n")
    v$code <- out  # save the code for a pdf file
  })  # end renderPlot


  # print stats
  output$summary <- renderPrint({
    shiny::req(v$stats)
    if (!is.null(v$stats)) print(v$stats)
  })


  # clicking on the Save button generates a pdf file 
  plotInput <- eventReactive(input$btn_pdf, {

    code <- v$code

    x.name <- input$x.col
    shiny::req(x.name)
    x <- data()[, x.name]

    y.name <- input$y.col
    shiny::req(y.name)
    y <- data()[, y.name]

    in.fill <- input$myFill

    by <- NULL
    lt <- NULL  # legend_title
    if (input$do_by) {  # a by variable
      by.name <- input$by.col
      shiny::req(by.name)
      by <- data()[, by.name]
      in.fill <- input$myFill_by  # color range selection
      lt <- by.name
    }

    in.size <- input$mySize   # constant value of size from slider
    if (input$do_size) {  # see if proceed with size is a variable
      shiny::req(input$size.col)
      in.size <- data()[, input$size.col]
    }
    if (!input$do_size) in.size <- 1.4 * in.size  # match renderPlot scaling
     
    pdf.fname <- paste("plot_", x.name, y.name, ".pdf", sep="")
    pdf.path <- file.path(path.expand("~"), pdf.fname)

    in.fit <- input$myFit
    in.elp <- input$myEllipse
    in.add <- v$add 
    if (input$do_by) {  # choose MD then by var
      in.MD <- 0
      in.ID <- row.names(data())
      if (input$myEnhance) {
        in.fit <- "off" 
        in.elp <- 0
        in.add <- NULL
      }
    }
    else {
      in.MD <- input$myMDcut 
      if (nchar(input$ID.col) != 0) {
        if (input$ID.col != "row.name")
          in.ID <- data()[, input$ID.col]
        else
          in.ID <- row.names(data())
      }
      else
        in.ID <- row.names(data())
    }

    # styles before re-set in interact() were saved
    style(lab_cex=getOption("l.cex"))
    style(axis_cex=getOption("l.axc"))

    # ---- pdf for saved plot ----
    pdf(pdf.path, width=as.numeric(input$w), height=as.numeric(input$h))
    shiny::req(!is.null(v$plt))
    replayPlot(v$plt)
    dev.off()

    # reset back to shiny setting
    style(lab_cex=1.201, axis_cex=1.011, suggest=FALSE)

    # R code
    r.fname <- paste("plot_", x.name, y.name, ".r", sep="")
    r.path <- file.path(path.expand("~"), r.fname)
    cat("\n")
    message("---------------------------------------------")
    cat("Files written to folder:", path.expand("~"), "\n")
    message("---------------------------------------------")
    cat("pdf file: ", pdf.fname, "\n")
    cat("R code file: ", r.fname, "\n")
    message("---------------------------------------------")
    cat("\n")

    if (input$fSource == "web") {
      url <- theURL()
      if (!grepl("^https?://", url))
        url <- paste("https://", url, sep="")
    }

    read.path <- ifelse (input$fSource == "local", input$myFile$name, url)
    read.code <- paste("d <- Read(\"", read.path, "\")", sep="")
    is.local <- !grepl("http://", read.path, fixed=TRUE)

    if (input$do_cmt)
      cat("# The # symbol indicates a comment rather than an R instruction\n\n",
          "# Begin the R session by loading the lessR functions ",
          "from the library\n", sep="", file=r.path)
    cat("library(\"lessR\")\n\n", file=r.path, append=TRUE)

    if (input$do_cmt) {
      cat("# Read your data into an R data table, the data frame, here d",
          "\n", sep="", file=r.path, append=TRUE)
      if (is.local)
        cat("# To browse for the data file, include nothing between the quotes",
            "\n", sep="", file=r.path, append=TRUE)
    }
    if (is.local && input$do_cmt)
      cat("d <- Read(\"\")\n\n", file=r.path, append=TRUE)

    if (is.local && input$do_cmt) {
      cat("# For security, the path to your data file is not available\n",
          "# You can replace PATHtoFILE in the following with the path\n",
          "# Remove the # sign in the first column and delete the previous ",
          "Read()\n", sep="", file=r.path, append=TRUE)
      read.path <- file.path("PATHtoFILE", read.path) 
      read.code <- paste("# d <- Read(\"", read.path, "\")", sep="")
    }
    cat(read.code, "\n\n", file=r.path, append=TRUE)

    if (input$do_cmt)
      cat("# When you have your data table, do the scatterplot analysis of\n",
          "#   two variables in the data table\n",
          "# d is the default data frame name, so no need to specify\n",
          sep="", file=r.path, append=TRUE)
    cat(code, "\n\n", file=r.path, append=TRUE)

    anlys <- "XY()"
    if (input$do_cmt)
      cat("# If accessing data with a name other than d, must add  data=NAME\n",
          paste("#   to the", anlys, "call, where NAME is the name of your",
          "data frame"), "\n", sep="", file=r.path, append=TRUE)

  })
  output$saved_plot <- renderPlot({ plotInput() })


  # access web page help file
  observeEvent(input$do_help, {
    if (input$do_help) {
      fp <- system.file("shiny_apps/help/ScatterPlot.html", package="lessR")
      browseURL(fp)
    }
  }, ignoreInit=TRUE)
  output$help <- renderText({ "" })

}  # end server

shinyApp(ui, server)

Chart <- function(x=NULL, y=NULL, data=d, filter=NULL,

        by=NULL,
        facet=NULL, n_row=NULL, n_col=NULL, aspect="fill",

        form=c("bar", "radar", "bubble", "dot", "pie", "icicle", "treemap"),

        hole=0.65,  # pie chart
        radius=0.50, power=0.5,  # bubble chart
        segments_x=NULL, segments_y=NULL,
        pt_size=1, origin_x=NULL, origin_y=NULL, # dot chart

        stat=c("mean", "sum", "sd", "deviation", "min", "median", "max"),
        stat_x=c("count", "proportion"),

        horiz=FALSE, sort=c("0", "-", "+"),
        beside=FALSE, stack100=FALSE,
        gap=NULL, scale_y=NULL, one_plot=NULL,

        theme=getOption("theme"),
        fill=NULL,
        color=getOption("bar_color_discrete"),
        transparency=getOption("trans_bar_fill"),
        fill_split=NULL, fill_scaled=FALSE, fill_chroma=75,

        labels=c("%", "input", "prop", "off"),
        labels_position=c("in","out"),
        labels_color="white",
        labels_size=0.90,
        labels_decimals=NULL,
        labels_cut=NULL,

        xlab=NULL, ylab=NULL, main=NULL, sub=NULL,
        lab_adjust=c(0,0), margin_adjust=c(0,0,0,0),
        pad_y_min=0, pad_y_max=0,

        rotate_x=getOption("rotate_x"), rotate_y=getOption("rotate_y"),
        break_x=NULL, offset=getOption("offset"),
        axis_fmt=c("K", ",", ".", ""), axis_x_pre="", axis_y_pre="",
        font_size=1, label_max=100,

        legend_title=NULL, legend_position="right_margin",
        legend_labels=NULL, legend_horiz=FALSE,
        legend_size=NULL, legend_abbrev=10, legend_adjust=0,

        add=NULL, x1=NULL, y1=NULL, x2=NULL, y2=NULL,

        quiet=getOption("quiet"), do_plot=TRUE,
        use_plotly=getOption("lessR.use_plotly"),
        pdf_file=NULL, width=6.5, height=6,
        digits_d=NULL,

        eval_df=NULL, fun_call=NULL, ...) {


  if (is.null(fun_call)) fun_call <- match.call()

  if (font_size != 1) {
    .fs_main   <- getOption("main_size", 1.1)
    .fs_lab    <- getOption("lab_size",  1.0)
    .fs_axis   <- getOption("axis_size", 0.76)
    .fs_axis_x <- getOption("axis_x_size")
    .fs_axis_y <- getOption("axis_y_size")
    options(main_size = .fs_main * font_size,
            lab_size  = .fs_lab  * font_size,
            axis_size = .fs_axis * font_size)
    if (!is.null(.fs_axis_x))
      options(axis_x_size = .fs_axis_x * font_size)
    if (!is.null(.fs_axis_y))
      options(axis_y_size = .fs_axis_y * font_size)
    on.exit({
      options(main_size=.fs_main, lab_size =.fs_lab, axis_size=.fs_axis)
      if (!is.null(.fs_axis_x)) options(axis_x_size = .fs_axis_x)
      if (!is.null(.fs_axis_y)) options(axis_y_size = .fs_axis_y)
    }, add = TRUE)
  }

  # collected plotly style options, passed down to plotly internals so they
  # don't reach into getOption() themselves
  style.opts <- .plotly_style()

  mc <- match.call()
  .mc.nms <- names(mc)
  y.is.named <- "y" %in% .mc.nms

  # Note: if fill contains getColors() call, fill already evaluated
  fill.name <- deparse(substitute(fill))

  if (length(form) == 1 && form == "sunburst")
    form <- "pie"
  else
    form <- match.arg(form)

  stat.miss <- missing(stat)
  if (stat.miss) stat <- NULL
  if (!is.null(stat[1])) stat <- match.arg(stat)  # if condition for shiny
  stat_x <- match.arg(stat_x)

  options(xname = NULL)
  options(yname = NULL)
  options(byname = NULL)

  if ("facet2" %in% .mc.nms) {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "parameter  facet2  not applicable to Chart\n\n")
  }

  facet.miss <- missing(facet)

  if (!is.null(pdf_file) && form != "bar") {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Saving PDF files only works for bar charts.\n\n")
  }

  if (form != "dot") {
    if (!quiet && use_plotly && !(form == "bar" && !facet.miss)) {
      txt <- "[Interactive chart from the Plotly R package (Sievert, 2020)]"
      cat(txt, "\n\n")
    }
  }

  labels_size.miss <- missing(labels_size)
  if (!facet.miss && labels_size.miss) labels_size <- .85


# old stuff ---------------------------------------------------------------

  # Check for removed parameters. Uses .mc.nms (names(match.call())) defined
  # at the top of the function — avoids evaluating expressions prematurely.
  if ("rows" %in% .mc.nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  rows  has been removed.\n",
         "Use  filter  instead, e.g., filter = (Age > 30)\n\n")
  }
  if ("n_cat" %in% .mc.nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  n_cat  has been removed.\n",
         "Convert categorical integer variables to factors instead:\n",
         "  e.g., d$Item1 <- factor(d$Item1)\n\n")
  }
  if ("value_labels" %in% .mc.nms) {
    stop(call. = FALSE, "\n------\n",
         "Parameter  value_labels  has been removed.\n",
         "Convert categorical integer variables to factors instead:\n",
         "  e.g., d$Item1 <- factor(d$Item1, levels=1:3,\n",
         "         labels=c(\"Disagree\", \"Neutral\", \"Agree\"))\n\n")
  }

  if (fill.name == "(count)") {
    message(">>> Now set to TRUE the more general parameter:  fill_scale.\n\n")
    fill <- NULL
  }

  dots <- list(...)
  .style.trap(names(dots))
  n.values <- 0
  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] == "type") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
            "Parameter  type  renamed  form\n\n")
      }
      if (grepl("values", names(dots)[i], fixed=TRUE)) {
        n.values <- n.values + 1
        if (n.values == 1)
          message(">>> Parameters  values, values_color, etc. now ",
                  "renamed to:  labels, labels_color, etc.\n",
                  "    Old parameter names will stop working in the future.\n")
        if (names(dots)[i] == "values") labels <- dots[[i]]
        if (names(dots)[i] == "values_color") labels_color <- dots[[i]]
        if (names(dots)[i] == "values_size") labels_size <- dots[[i]]
        if (names(dots)[i] == "values_digits") labels_decimals <- dots[[i]]
        if (names(dots)[i] == "values_position") labels_position <- dots[[i]]
        if (names(dots)[i] == "values_cut") labels_cut <- dots[[i]]
      }
      if (names(dots)[i] == "addtop") pad_y_max <- dots[[i]]
      if (names(dots)[i] == "add_top") pad_y_max <- dots[[i]]
      if (names(dots)[i] == "stat_yx") {
        stat <- dots[[i]]
        stat.miss <- FALSE
      }
      if (grepl(".", names(dots)[i], fixed=TRUE)) {
        pnm <- gsub(".", "_", names(dots)[i], fixed=TRUE)  # dot to _
        assign(pnm, dots[[i]])
      }
    }
  }

  if (!is.null(stat) && stat[1] == "proportion") {
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "now use parameter  stat_x  for \"proportion\" \n",
      "  \"proportion\" only applies when there is no y numeric variable\n\n")
  }

  # validate stat set from legacy stat_yx, which bypasses match.arg above
  if (!is.null(stat))
    stat <- match.arg(stat, c("mean", "sum", "sd", "deviation",
                              "min", "median", "max"))


  Trellis <- !facet.miss && form == "bar"


# set variables -----------------------------------------------------------

  trans <- transparency

  if (fill_scaled  &&  is.null(fill_split)) fill_split <- 0

  if (nzchar(axis_fmt[1])) axis_fmt <- match.arg(axis_fmt)

  fill.miss <- missing(fill)
  color.miss <- missing(color)
  transparency.miss <- missing(transparency)
  horiz.miss <- missing(horiz)
  y.miss <- missing(y)
  by.miss <- missing(by)
  main.miss <- missing(main)
  theme.miss <- missing(theme)
  hier.type <- form %in% c("treemap", "icicle") ||
               (form == "pie" && !by.miss)
  for (i in seq_along(color)) if (color[i] == "off") color[i] <- "transparent"

  sort.miss <- missing(sort)
  sort <- match.arg(sort)
  labels.miss <- missing(labels)
  labels <- match.arg(labels)
  labels_position <- match.arg(labels_position)


# set some parameter values -----------------------------------------------

  # if theme is set locally
  if (!theme.miss) {
    old_theme <- getOption("theme")
    if (theme != old_theme) {
      style(theme)
      on.exit(style(old_theme), add=TRUE)
      style.opts <- .plotly_style()  # re-capture under new theme
      if (font_size != 1) {  # style() reset font sizes; re-scale
        options(main_size = getOption("main_size", 1.1) * font_size,
                lab_size  = getOption("lab_size",  1.0) * font_size,
                axis_size = getOption("axis_size", 0.76) * font_size)
        .new_x <- getOption("axis_x_size")
        .new_y <- getOption("axis_y_size")
        if (!is.null(.new_x)) options(axis_x_size = .new_x * font_size)
        if (!is.null(.new_y)) options(axis_y_size = .new_y * font_size)
      }
    }
    sty <- style(theme, reset=FALSE)
    if (fill.miss && !hier.type && form != "radar") {
      if (theme == "colors")
        fill <- rgb(150,170,195, maxColorValue=255)
      else
        fill <- sty$bar$bar_fill_discrete
    }
    if (color.miss) color <- sty$bar$color
    if (transparency.miss) trans <- sty$bar$trans_fill
    if (is.null(trans)) trans <- 0.1  # kludge, should not be NULL
  }

  proportion <- stat_x[1] == "proportion"

  if (horiz) sort <- switch(sort, "+" = "-", "-" = "+", "0" = "0")

  if (missing(break_x))
    break_x <- !horiz && rotate_x == 0

  xlab.adj <- lab_adjust[1];   ylab.adj <- lab_adjust[2]
  tm.adj <- margin_adjust[1];  rm.adj <- margin_adjust[2]
  bm.adj <- margin_adjust[3];  lm.adj <- margin_adjust[4]

  lm.adj <- lm.adj + .1  # pull these margins back a bit for bc
  bm.adj <- bm.adj + .1

  if (missing(labels_color)) {
    labels_color <- "white"
    if (labels_position == "out") labels_color <- getOption("axis.text.color")
  }

  # ensure valid parameter values
  # exception: fill=c(lo, hi) with fill_split is user-defined divergent scale —
  # pass fill.miss=TRUE to the validator so it doesn't block this combination
  fill.miss.valid <- fill.miss ||
                    (!fill.miss && !is.null(fill_split) && length(fill) == 2L)
  .bcParamValid(y.miss, by.miss, facet.miss, Trellis, sort,
                fill_split, fill_scaled, fill_chroma, theme,
                fill.miss.valid, labels_position, stat.miss)



# data frame stuff --------------------------------------------------------

  data.d <- missing(data)

  # let deprecated mydata work as default
  dfs <- .getdfs()
  mydata.ok <- FALSE
  if (!is.null(dfs)) {
    if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
      d <- mydata
      rm(mydata)
      df.name <- "mydata"
      mydata.ok <- TRUE
      options(dname = df.name)
    }
  }

  # get name of data table
  # df.name is NULL if from shiny interact(), not from user-written shiny code
  if (!mydata.ok) {
    df.name <- deparse(substitute(data))
    options(dname = df.name)
  }

  shiny <- FALSE
  if (!is.null(sys.call(-1)))  # is NULL when called directly from R console
    if (sys.call(-1) == "renderPlot()") {  # from shiny, user or interact()
      shiny <- TRUE
      data <- eval(substitute(data), envir=parent.frame())
    }

  # if a tibble, convert to data frame
  if (!shiny) {
    if (exists(df.name, envir=.GlobalEnv)) {
      if (any(grepl("tbl", class(data), fixed=TRUE)))
        data <- data.frame(data)
    }
  }
  else  # no check for existence of df.name
    if (any(grepl("tbl", class(data), fixed=TRUE)))
      data <- data.frame(data)

  x.name <- deparse(substitute(x), width.cutoff = 120L)
  # deparse of a vector (e.g. from Shiny with data=NULL) produces multiple strings
  # use xlab as the display name instead, falling back to "x"
  if (length(x.name) > 1L)
    x.name <- if (!is.null(xlab) && nzchar(xlab)) xlab else "x"
  options(xname = x.name)

  # classify x: a computational expression evaluates directly, with a
  # data-column reference resolved from the data frame, then the
  # caller's environment; tryCatch avoids forcing the data=d promise
  x.expr    <- substitute(x)
  x.is.expr <- !missing(x) && .is_expr_arg(x.expr)
  x.uses.df <- FALSE
  if (x.is.expr)
    x.uses.df <- df.name != "NULL" && length(all.vars(x.expr)) > 0L &&
                 any(all.vars(x.expr) %in%
                     tryCatch(names(data), error=function(e) character(0)))

  # validate x.name is not an expression; global iff user set data=NULL
  # skip validation when called from Shiny with pre-extracted vectors (data=NULL)
  if (!x.is.expr) {
    if (!is.null(x.name) && !(shiny && df.name == "NULL"))
      .in.global(x.name, quiet)
    x.in.global <- if (shiny && df.name == "NULL") TRUE
                   else df.or.global(x.name, df.name, role="x",
                                     fun.name="Chart")
  }
  else
    x.in.global <- !x.uses.df
  if (!x.in.global) {
    # force evaluation (not lazy) if data not specified, relies on default d
    if (data.d) {
      if (!mydata.ok) .nodf(df.name)  # check to see if df exists
      # the 1.201 comes from Shiny, need to reset
      # l.cex and l.axc are set in interact() before shiny run
      if (getOption("lab_size") == 1.201) {
       if (getOption("l.cex") != 1.201) {
          style(lab_size=getOption("l.cex"))
          style(axis_size=getOption("l.axc"))
        }
        else
          style()
      }
    }
  }

  # respect a caller-supplied eval_df, here and again for y below
  eval_df.user <- eval_df
  eval_df <- if (is.null(eval_df.user)) !x.in.global else eval_df.user


# subset filter -----------------------------------------------------------

  if (!missing(filter))
    data <- .apply_filter(data, deparse(substitute(filter)),
                          parent.frame(), x.in.global, quiet)


# establish if a data frame, otherwise identify variable(s)----------------
  # x can be missing entirely, with a data frame passed instead
  # if x a vector, then x.name not in data, but also not in global

  x.call <- NULL

  if (x.name == "NULL") x.name <- ""    # 271, if x NULL, then x.name is "NULL"
  if (x.name %in% c("row_names", "row.names")) {
    # retain order of row names, otherwise will be alphabetical
    x.call <- factor(row.names(data), levels=row.names(data))
    if (is.null(xlab)) xlab <- ""  # unless specified, drop the axis label
  }

  else if (!missing(x)) {

    # x is a computational expression, evaluate directly
    if (x.is.expr) {
      val <- .expr_eval(x.expr, x.name, if (x.uses.df) data else NULL,
                        parent.frame(), role="x", fun.name="Chart")
      if (is.data.frame(val))
        data <- val   # mirrors the global data frame branch below
      else
        x.call <- val
    }

    else if (!x.in.global) {
      if (eval_df) {
        if (!mydata.ok) if (!shiny) .nodf(df.name)  # check to see if df exists
        .xcheck(x.name, df.name, names(data))  # x-vars in df?
      }

      data.vars <- as.list(seq_along(data))
      names(data.vars) <- names(data)
      ind <- eval(substitute(x), envir=data.vars)  # col num of each var
      if (length(ind) > 1) data <- data[, ind]  # x a vars list, no by vars
      if (length(ind) == 1) x.call <- eval(substitute(data$x))  # x is 1 var
    }

    else {  # x is in the global environment (vector, matrix or data frame)
      if (is.data.frame(x))  # x a data frame
        data <- x
      else {  # x a vector or matrix in global
        if (exists(x.name, envir=.GlobalEnv)) if (is.matrix(x)) {
          x.name <- xlab
          xlab <- NULL
          by.name <- legend_title
          options(xname = x.name)
          options(byname = by.name)
        }
        x.call <- x
        if (is.function(x.call)) x.call <- eval(substitute(data$x))
      }
    }

    # if read from console with text parameter can insert extra space at front
    if (is.factor(x.call)) {
      if (nchar(levels(x.call)[1]) > 5)
        levels(x.call) <- trimws(levels(x.call), which="left")
    }
    else if (is.character(x.call)) {
      if (nchar(x.call[1]) > 5) x.call <- trimws(x.call, which="left")
    }
  }  # !missing x


  # -------------------------------------------------
  # -------------------------------------------------
  # x is a single var, not a data frame or a var list
  if (!is.null(x.call)) {


# --- resolve `by`, which can be a vector ---------------------------------

    # shared helper: retrieve column from data frame or global environment
    caller.env <- parent.frame()
    get.col <- function(nm) {
      if (df.name != "NULL") {
        .xcheck(nm, df.name, names(data))
        return(data[[nm]])
      } else {
        return(get(nm, envir = caller.env))
      }
    }

    by.v.raw <- NULL  # pre-coercion by values, for categorical validation

    if (!by.miss) {
      by.expr <- substitute(by)
      by.vars <- all.vars(by.expr)
      by.name <- NULL  # default; set below, but by may resolve to NULL

      if (.is_expr_arg(by.expr)) {  # by is a computational expression
        by.name <- paste(deparse(by.expr, width.cutoff=120L),
                         collapse="")
        uses.df <- df.name != "NULL" &&
                   any(by.vars %in%
                       tryCatch(names(data),
                                error=function(e) character(0)))
        by.call <- .expr_eval(by.expr, by.name,
                              if (uses.df) data else NULL,
                              parent.frame(), role="by",
                              fun.name="Chart")
        by.v.raw <- by.call
        if (!is.factor(by.call)) by.call <- factor(by.call)
        if (length(by.call) != length(x.call)) {
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "x has ", length(x.call), " values, but the  by  ",
            "expression\n",
            "  ", by.name, "  yields ", length(by.call),
            " values\n\n")
        }
      }
      else if (length(by.vars) == 0L) {
        # already-evaluated object (rare); coerce to factor
        by.call <- try(eval(by.expr, envir = parent.frame()), silent = TRUE)
        if (inherits(by.call, "try-error")) by.call <- NULL
        if (!is.null(by.call))
          by.v.raw <- if (is.data.frame(by.call)) by.call[[1]] else by.call
        if (!is.null(by.call) && !is.data.frame(by.call)) {
          if (!is.factor(by.call)) by.call <- factor(by.call)
          by.name <- deparse(by.expr)
        } else if (is.data.frame(by.call)) {
          for (nm in names(by.call))
            if (!is.factor(by.call[[nm]]))
                by.call[[nm]] <- factor(by.call[[nm]])
          by.name <- paste(names(by.call), collapse = " - ")
        }
      }
      else if (length(by.vars) == 1L) {
        by.call <- get.col(by.vars[1])
        by.v.raw <- by.call
        if (!is.factor(by.call)) by.call <- factor(by.call)
        by.name <- by.vars[1]
      }
      else {
        # multiple by variables only apply to the hierarchical charts:
        #   pie/sunburst, treemap, and icicle
        if (!hier.type) {
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "Only one  by  variable is permitted for a  ", form, "  chart,\n",
            "  as the resulting visual clutter compromises interpretability.\n",
            "  Multiple  by  variables apply only to the hierarchical charts --\n",
            "  pie/sunburst, treemap, and icicle -- where they define the\n",
            "  levels of the hierarchy.\n\n")
        }
        # vector of by's -> data.frame of factors
        by.df <- lapply(by.vars, get.col)
        by.v.raw <- by.df[[1]]
        by.df <- lapply(by.df, function(v)
                        if (is.factor(v)) droplevels(v) else factor(v))
        by.call <- as.data.frame(by.df, check.names = FALSE)
        names(by.call) <- by.vars
        by.name <- paste(by.vars, collapse = " - ")
      }
      options(byname = by.name)

      if (labels_position == "out"  &&  !beside) {
        stop(call.=FALSE, "\n------\n",
          "labels_position=\"out\" not meaningful for a  by  variable\n",
          "  without beside=TRUE\n\n")
      }
    }  # end not by.miss 

    else {
      by.call <- NULL
      by.name <- NULL
    }

    if (form == "dot" && !is.null(by.call)) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "The  by  variable is not meaningful for dot charts. Do a bar chart.\n\n")
    }


# --- resolve y ------------------------------------------------------

  y.name <- deparse(substitute(y), width.cutoff = 120L)  # can be NULL
  if (length(y.name) > 1L) y.name <- paste(y.name, collapse="")

  # classify y as a computational expression, as for x
  y.expr    <- substitute(y)
  y.is.expr <- !missing(y) && .is_expr_arg(y.expr)
  y.uses.df <- FALSE
  if (y.is.expr)
    y.uses.df <- df.name != "NULL" && length(all.vars(y.expr)) > 0L &&
                 any(all.vars(y.expr) %in%
                     tryCatch(names(data), error=function(e) character(0)))

  # process row.names if specified, applicable to form="dot"
  if (y.name %in% c("row_names", "row.names")) {
    # retain order of row names, otherwise will be alphabetical
    y.call <- data.frame(factor(row.names(data), levels=row.names(data)))
    if (is.null(ylab)) ylab <- ""  # unless specified, drop the axis label
  }

  else {
    # validate y.name is not an expression; global iff user set data=NULL
    if (!y.is.expr) {
      if (!is.null(y.name) && !(shiny && df.name == "NULL"))
        .in.global(y.name, quiet)
      y.in.global <- if (shiny && df.name == "NULL") TRUE
                     else df.or.global(y.name, df.name, role="y",
                                       fun.name="Chart")
    }
    else
      y.in.global <- !y.uses.df
    eval_df <- if (is.null(eval_df.user)) !y.in.global else eval_df.user

    # if not missing, then must be aggregated data
    if (!missing(y)) {  # assign y.call from data or from global

      if (y.is.expr) {  # y is a computational expression
        y.call <- .expr_eval(y.expr, y.name,
                             if (y.uses.df) data else NULL,
                             parent.frame(), role="y",
                             fun.name="Chart")
      }
      else {
      # see if var exists in data frame, if y not in global Env or fun call
      if (eval_df) .xcheck(y.name, df.name, names(data))
      if (!y.in.global) {
        data.vars <- as.list(seq_along(data))
        names(data.vars) <- names(data)
        y.ind <- eval(substitute(y), envir = data.vars)
        if (length(y.ind) > 1L) {
          y.call <- data[, y.ind, drop = FALSE]   # multi-column: data frame
        } else {
          y.call <- eval(substitute(data$y))       # single column: vector
        }
      } else {  # vars that are function names get assigned to global
        y.call <- y
        if (is.function(y.call)) y.call <- eval(substitute(data$y))
      }
      }  # end y is a variable name, not an expression
      if (is.null(digits_d)) digits_d <- .max.dd(
        if (is.data.frame(y.call)) unlist(y.call) else y.call)
    }  # end !missing(y)

    else {
      y.lab <- "Count"
      y.call <- NULL
      if (is.null(digits_d)) digits_d <- 0  # y will be counts
    }
  }  # end !row_name

  # normalize: if y was missing or y=NULL, set y.name to actual NULL
  # (deparse produces the string "NULL" which fails is.null() checks downstream)
  if (missing(y)) y.name <- NULL
  options(yname = y.name)


# --- resolve facet --------------------------------------------------

  facet.call <- NULL
  facet.name <- NULL

  if (!missing(facet)) {
    facet.expr <- substitute(facet)
    facet.vars <- all.vars(facet.expr)

    if (.is_expr_arg(facet.expr)) {  # a computational expression
      facet.name <- paste(deparse(facet.expr, width.cutoff=120L),
                          collapse="")
      uses.df <- df.name != "NULL" &&
                 any(facet.vars %in%
                     tryCatch(names(data),
                              error=function(e) character(0)))
      v <- .expr_eval(facet.expr, facet.name,
                      if (uses.df) data else NULL,
                      parent.frame(), role="facet", fun.name="Chart")
      facet.call <- droplevels(factor(v))
      if (!is.null(x.call)  &&
          length(facet.call) != length(x.call)) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "x has ", length(x.call), " values, but the  facet  ",
          "expression\n",
          "  ", facet.name, "  yields ", length(facet.call),
          " values\n\n")
      }
    }
    else if (length(facet.vars) == 1L) {
      # single facet variable — resolve to a factor vector
      v <- get.col(facet.vars[1L])
      facet.call <- if (is.factor(v)) droplevels(v) else factor(v)
      facet.name <- facet.vars[1L]
    } else {
      # multiple facet variables — resolve to a data frame of factors
      fac.list <- lapply(facet.vars, function(nm) {
        v <- get.col(nm)
        if (!is.factor(v)) v <- factor(v)
        droplevels(v)
      })
      facet.call <- as.data.frame(fac.list, stringsAsFactors = FALSE)
      names(facet.call) <- facet.vars
      facet.name <- paste(facet.vars, collapse = ", ")
    }

    # use the legacy option name expected by .bar.lattice()
    options(facet1name = facet.name)
  }

  # save pre-aggregation data for .hier.plotly() hover tooltips —
  # done once here after all four variables are resolved, before any aggregation
  if (form %in% c("pie", "icicle", "treemap")) {
    x.raw     <- x.call
    by.raw    <- by.call
    y.raw     <- y.call
    facet.raw <- facet.call
    # Multiple by= variables define hierarchy levels (kept as a data frame),
    # but multiple facet= variables define the panel grid, not extra levels.
    # Flatten to one interaction factor here -- same " / " convention used
    # for the radar/dot facet paths -- so .hier_aggregate() builds one panel
    # per combination instead of mangling the data frame.
    if (is.data.frame(facet.raw))
      facet.raw <- factor(apply(facet.raw, 1, paste, collapse = " / "))
  }


# ------------------------------------------------------------
# -----------  x, y, by, and facet variables established -----
# ------------------------------------------------------------

# suggestions -------------------------------------------------------------

    txsug <- ""
    if (getOption("suggest") && !quiet  && form != "dot") {
      # function call, with last ) removed for suggestions
      fncl <- .fun_call.deparse(fun_call)  # class call to class character
      fncl <- gsub(")$", "", fncl)  # get function call less closing )
      fncl <- gsub(" = ", "=", fncl)
      txsug <- ">>> Suggestions  or  enter: style(suggest=FALSE)"

      if (!is.null(by.call)) {
        by.sug <- if (grepl(" - ", by.name, fixed=TRUE))
                    paste0("c(", gsub(" - ", ", ", by.name, fixed=TRUE), ")")
                  else by.name
        fc <- paste("Chart(", x.name, ", by=", by.sug, sep="")
      } else
        fc <- paste("Chart(", x.name, sep="")

      if (!grepl("radar", fncl)) {
        txt <- ", form=\"radar\""  # many options"
        cmt <- "  # Plotly radar chart"
        txsug <- paste(txsug, "\n", fc, txt, ")", cmt, "\n", sep="")
      }

      if (!grepl("treemap", fncl)) {
        txt <- ", form=\"treemap\""  # many options"
        cmt <- "  # Plotly treemap chart"
        txsug <- paste(txsug, fc, txt, ")", cmt, "\n", sep="")
      }

      if (!grepl("pie", fncl)) {
        txt <- ", form=\"pie\""  # many options"
        cmt <- "  # Plotly pie/sunburst chart"
        txsug <- paste(txsug, fc, txt, ")", cmt, "\n", sep="")
      }

      if (!grepl("icicle", fncl)) {
        txt <- ", form=\"icicle\""  # many options"
        cmt <- "  # Plotly icicle chart"
        txsug <- paste(txsug, fc, txt, ")", cmt, "\n", sep="")
      }

      if (!grepl("bubble", fncl)) {
        txt <- ", form=\"bubble\""  # many options"
        cmt <- "  # Plotly bubble chart"
        txsug <- paste(txsug, fc, txt, ")", cmt, "\n", sep="")
      }

      txsug <- paste(txsug, "\n")

      class(txsug) <- "out"
      print(txsug)
    }  # end suggest


  # is a numerical, continuous variable in the second or by position?
  n.by <- if (is.null(by.call)) 0
          else if (is.data.frame(by.call)) nrow(unique(by.call))
               else length(unique(by.call))


  # numeric (pre-coercion) variable in the by position; by.call is a factor
  if (!is.null(by.call) && is.numeric(by.v.raw) && !y.is.named) {
    if (!stat.miss && y.miss) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Parameter  stat  requires a numerical y-variable to transform.\n\n",
        "Perhaps you have a numerical variable that you wish to transform.\n",
        "If so, then you now need to provide the label:  y = ", by.name, "\n\n",
        "Or, if the variable is the 2nd categorical variable in the analysis\n",
        "  then label as:  by = ", by.name, "\n")
    }
  }


# not pre-aggregated data -------------------------------------------------

    n.x <- length(unique(x.call))
    lx <- if (is.data.frame(x.call)) nrow(x.call) else length(x.call)
    if (is.null(by.call))
      is.agg <- n.x >= lx
    else {
      lby.u <- if (is.data.frame(by.call)) nrow(unique(by.call))
               else length(unique(by.call))
      lby <- if (is.data.frame(by.call)) nrow(by.call) else length(by.call)
      is.agg <- n.x * lby.u >= lby
    }

  # set labels default for aggregated data 
    if (labels.miss && (!stat.miss || is.agg))
        labels <- if (beside) "%" else "input"


## ---- Missing data removal: x, y, by (possibly multi-column), facet ----

    # Save the full x.call and y.call before filtering — dot charts display
    # all category labels on the axis, with no dot where y is missing.
    x.call.all <- x.call
    y.call.all <- y.call

    # flatten multi-variable facet to a single interaction vector before
    # casewise missing removal — .drop_casewise_missing expects a vector
    if (is.data.frame(facet.call)) {
      facet.call <- factor(apply(facet.call, 1, paste, collapse = " / "))
    }

    # For multi-column y, collapse to a single logical NA-indicator vector
    # so .drop_casewise_missing() never sees a data frame — avoids tibble
    # recycling errors that occur when dplyr/tibble is loaded in session.
    y.for.cc <- if (is.data.frame(y.call) && ncol(y.call) > 1L)
      rowSums(is.na(y.call)) > 0  # TRUE where any column has NA
    else
      y.call

    cc <- .drop_casewise_missing(  # build data frame with relevant vars
      x.call    = x.call,
      y.call    = y.for.cc,
      by.call   = by.call,
      facet.call= facet.call
    )

    if (!is.null(cc) && !all(cc)) {

      # x.call: vector OR matrix/data.frame
      if (!is.null(x.call)) {
        if (is.matrix(x.call) || is.data.frame(x.call)) {
          x.call <- x.call[cc, , drop = FALSE]
        } else {
          x.call <- x.call[cc]
        }
      }

      # y.call: vector OR data.frame (multi-column y)
      if (!is.null(y.call)) {
        if (is.matrix(y.call) || is.data.frame(y.call)) {
          y.call <- y.call[cc, , drop = FALSE]
        } else {
          y.call <- y.call[cc]
        }
      }

      # by.call: vector OR matrix/data.frame
      if (!is.null(by.call)) {
        if (is.matrix(by.call) || is.data.frame(by.call)) {
          by.call <- by.call[cc, , drop = FALSE]
        } else {
          by.call <- by.call[cc]
        }
      }

      # facet.call: vector OR matrix/data.frame
      if (!is.null(facet.call)) {
        if (is.matrix(facet.call) || is.data.frame(facet.call)) {
          facet.call <- facet.call[cc, , drop = FALSE]
        } else {
          facet.call <- facet.call[cc]
        }
      }
    }

    # recompute n.x after casewise NA removal — used downstream by radar polygon
    # check, fill color count, and dot chart fill range
    n.x <- length(unique(x.call))


# check conditions when a y variable is present ---------------------------

    if (!is.null(y.call)) {  # a y variable present

      # y is the numerical variable that the chart aggregates, and it
      # is the second parameter, so a second CATEGORICAL variable
      # entered positionally lands here. Name  by  rather than
      # report a categorical variable as numerical.
      y.num <- if (is.data.frame(y.call))
                 all(vapply(y.call, is.numeric, logical(1)))
               else
                 is.numeric(y.call)
      if (!y.num) {
        cat("\n"); stop(call.=FALSE, "\n------\n",
          "Parameter  y  is the numerical variable that the chart\n",
          "aggregates, but  y = ", y.name, "  is categorical.\n\n",
          "To stratify by a second categorical variable, specify  by:\n",
          "    by = ", y.name, "\n\n")
      }

      if (is.agg) {  # a summary table
        if (!stat.miss) { # stat specified but data already aggregated
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "The data are a summary table, so do not specify a value of\n",
            "  stat  as the data aggregation has already been done\n\n")
        }
        if (sum(is.na(x.call)) > 0 ||
              sum(is.na(by.call)) > 0 ||
              sum(is.na(y.call)) > 0)   {
            cat("\n"); stop(call.=FALSE, "\n------\n",
              "When reading a summary table, missing data not allowed.\n\n")
        }
      }  # is a summary table
      else {
        # require stat for a numeric y on raw data, as for every other form;
        # a dot plot with a multi-column (paired) y is exempt, as paired
        # values are displayed directly and never aggregated
        paired.dot <- form == "dot" &&
                      is.data.frame(y.call) && ncol(y.call) > 1L
        if (!is.agg && stat.miss && !paired.dot) {
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "The data are not a summary (pivot) table, and you have a ",
            "numerical variable,\n",
            "    y = ", y.name, "\n",
            "so need to specify a value of  stat  to define the aggregation of\n",
            y.name, ", such as stat=\"mean\".\n\n")
        }
      }  # end is not a summary table
    }  # a y variable


# evaluate specified fill (NULL, numeric constant, or a variable) ---------

  if (!is.null(fill)) {
    if (length(fill.name) == 1) {
      if (exists(df.name, envir=.GlobalEnv))
        in.df <- fill.name %in% names(data)
      else
        in.df <- FALSE
    }
      else in.df <- FALSE
    # only works for y given, not tabulated
    if (in.df) {  # fill is a variable
    # need to aggregate cat var x and set fill.val to those limited values
    # currently, fill.val consists of all data values of variable fill
      fill.val <- data[[fill.name]]  # fill is a variable in data
      fill <- .getColC(fill.val, fill_name=fill.name)
      if (sort != "0") {
        srt.dwn <- sort == "-"
        fill <- fill[order(fill.val, decreasing=srt.dwn)]
      }
    }

    # evaluate getColors at the time of the function call
    # re-evaluate here by setting fill with the specified value of n
    if (substr(fill.name[1], 1, 9) == "getColors") {
      n.clr <- if (n.by > 0) n.by else max(n.x, 1)
      fill <- .resolve_getColors_n(fill.name, n.clr)
    }
  }  # end fill is present

  fill.palette <- if (is.null(fill)) .get_fill(theme)
                  else gsub("\"", "", fill.name)  # strip deparse quotes
  seq.pals <- c("grays", "reds", "rusts", "browns", "olives",
                "greens", "emeralds", "turquoises", "aquas", "blues",
                "purples", "violets", "magentas", "terrain")
  is.seq.fill <- tolower(fill.palette) %in% seq.pals ||
                 theme %in% c("gray", "white")
  if ((is.null(fill) || !theme.miss) && !hier.type) {
    if (n.by == 0) {
      if (theme.miss) fill <- NULL  # bc_main sets theme, no luminance gradient 
    } else if (is.seq.fill && n.by > 0) {
      # sequential with by=: n.by colors spanning full range, lighter at bottom
      fill <- rev(.color_range(.get_fill(theme), n.by))
    } else if (form == "bar" && beside && n.by > 0) {
      # beside bar with by=: one color per by-level, not per x-level
      fill <- .color_range(.get_fill(theme), n.by)
    } else {
      fill <- .color_range(.get_fill(theme), max(n.x, n.by))
    }
  }


# Trellis plots for bar plots ---------------------------------------------

  if (Trellis) {

    # facet2 not currently available
    if (do_plot)
      .bar.lattice(x.call, facet.call, facet2=NULL, n_row, n_col, aspect,
                   proportion, fill, color, trans, size.pt=NULL,
                   xlab, ylab, main, rotate_x, offset,
                   axis_fmt, axis_x_pre, axis_y_pre,
                   width, height, pdf_file,
                   segments_x=NULL, breaks=NULL,
                   bin_start=NULL, bin_width=NULL, bin_end=NULL,
                   T.type="bar", quiet)

    # do_plot=FALSE: nothing else applies, do not fall through to the
    # non-faceted bar chart analysis
    return(invisible(NULL))
  }


# set up pdf_file if needed -----------------------------------------------

  if (!is.null(pdf_file)) {
    if (!grepl(".pdf", pdf_file, fixed=TRUE))
      pdf_file <- paste(pdf_file, ".pdf", sep="")
    pdf(file=pdf_file, width=width, height=height, onefile=FALSE)
  }
  else {
    # only open a graphics device for bar charts, other forms use plotly widgets
    if (form == "bar" && df.name != "NULL")
        .opendev(pdf_file, width, height)
  }


# stat aggregation: y is present with raw data and stat not NULL ----------

  if (!is.agg) {
    if (!is.null(stat) && !is.null(y.call)) {  # y with stat

      ## ----- console stats BEFORE reducing data -------------------------
      if (!quiet) {
        txout <- ""
        ## only show the one-way numeric summary when there is
        ## truly only one variable (no by, no facet)
        if (is.null(by.call) && is.null(facet.call) &&
            !is.data.frame(y.call) && !is.matrix(y.call)) {
          options(yname = x.name)  # reverse x and y names, .ss.numeric
          options(xname = y.name)

          stats <- .ss.numeric(y.call, by = x.call, digits_d = digits_d,
                               brief = TRUE, y.name = x.name)
          txout <- stats$tx

          options(xname = x.name)  # reverse back
          options(yname = y.name)
        }

        class(txout) <- "out"
        output <- list(out_txt = txout)
        class(output) <- "out_all"
        print(output)
      }  # end !quiet


      ## ----- aggregate --------------------------------------------------
      is.agg <- TRUE

      # multi-column y (e.g. y=c(Pre,Post)): aggregate each column separately
      if (is.data.frame(y.call) && ncol(y.call) > 1L) {
        if (!is.null(by.call))
          stop(call.=FALSE, "\n------\n",
            "Multiple y variables combined with by= is not supported.\n",
            "Use a single y variable with by=, or omit by=.\n\n")
        if (!is.null(facet.call))
          stop(call.=FALSE, "\n------\n",
            "Multiple y variables combined with facet= is not supported.\n",
            "Use a single y variable with facet=, or omit facet=.\n\n")
        # wide result, one aggregated column per y variable, so done
        # here rather than in .agg(), which returns a single structure
        x.grp <- if (is.data.frame(x.call)) x.call[, 1L] else x.call
        if (stat == "deviation") {
          agg.df <- as.data.frame(
            lapply(y.call, function(col) {
              grp.means <- tapply(col, x.grp, mean, na.rm=TRUE)
              grp.means - mean(grp.means, na.rm=TRUE)
            })
          )
        }
        else {
          agg.df <- as.data.frame(
            lapply(y.call, function(col) tapply(col, x.grp, .stat_fun(stat)))
          )
        }
        x.call <- factor(rownames(agg.df), levels=rownames(agg.df))
        y.call <- agg.df
        if (is.null(ylab)) ylab <- paste(.stat_lbl(stat), "of",
                                         paste(names(agg.df), collapse=" & "))
      } else {
        # .agg() returns by-var as "by.var", facet-var as "facet.var"
        # capture original by/facet names
        #  before aggregation replaces by.call/facet.call
        by.names.original <- if (is.null(by.call)) character(0L)
                             else if (is.data.frame(by.call)) names(by.call)
                             else by.name
        facet.names.original <- if (is.null(facet.call)) character(0L)
                                else if (is.data.frame(facet.call)) 
                                         names(facet.call)
                                else facet.name
        stat.out <- .agg(x.call, y.call, by.call, facet.call, stat, y.name)
        out <- stat.out$out  # aggregated data

        if (is.null(ylab)) ylab <- stat.out$ylab

      # table already printed above
      if (is.null(by.call) && is.null(facet.call)) {  # out has only x, y
        x.call <- out$x
        y.call <- out$y
      }

      else {  # by.call or facet.call present, out has grouping columns
        # build: y ~ group_cols + x

        ## all grouping columns (by + facet) are everything except x,y
        grp.cols <- setdiff(names(out), c("x", "y"))

        if (!quiet) cat("Summary Table for", ylab, "\n\n")

        if (!length(grp.cols)) {
          x.tbl.print <- xtabs(y ~ x, data = out)
        } else {
          fmla  <- reformulate(c(grp.cols, "x"), response = "y")
          x.tbl.print <- xtabs(fmla, data = out)
        }

        x.lbl <- .getlabels(main=main, lab_size=getOption("lab_size"))$xl
        if (!quiet) {
          .print_chart_summary(
            x.tbl    = x.tbl.print,
            x_name   = x.name,
            x.lbl    = x.lbl,
            by_name  = by.name,  # label string, not the columns
            y_name   = y.name,
            stat     = stat,
            digits_d = digits_d
          )
        }

        ## ----- Update x.call / by.call / facet.call / y.call ----------------
        ## After aggregation, downstream plotting should see the *reduced* data.

        x.call <- out[["x"]]
        y.call <- out[["y"]]

        by.cols    <- intersect(grp.cols, c(by.names.original, "by.var"))
        facet.cols <- intersect(grp.cols, c(facet.names.original, "facet.var"))

        # restore original names if .agg() canonicalized them
        if ("by.var" %in% names(out) && length(by.names.original) == 1L)
          names(out)[names(out) == "by.var"] <- by.names.original
        if ("facet.var" %in% names(out) && length(facet.names.original) == 1L)
          names(out)[names(out) == "facet.var"] <- facet.names.original

        # re-resolve cols after rename so downstream sees original names
        grp.cols   <- setdiff(names(out), c("x", "y"))
        by.cols    <- intersect(grp.cols, by.names.original)
        facet.cols <- intersect(grp.cols, facet.names.original)

        ## by.call: NULL, vector, or data.frame depending on how many by vars
        if (!length(by.cols))
          by.call <- NULL
        else if (length(by.cols) == 1L)
          by.call <- out[[by.cols[1L]]]
        else
          by.call <- out[by.cols]

        ## facet.call: NULL, vector, or data.frame depending on how many facets
        if (!length(facet.cols))
          facet.call <- NULL
        else if (length(facet.cols) == 1L)
          facet.call <- out[[facet.cols[1L]]]
        else
          facet.call <- out[facet.cols]
      }
      }  # end single-column y stat aggregation
  }  # y is present for original data and stats not NULL


# else do table stats of counts -------------------------------------------

  else if (form != "bar") {  # do table of counts, done in bc.main for bar
    gl <- .getlabels(main=main, lab_size=getOption("lab_size"))
    x.name <- gl$xn; x.lbl <- gl$xl

    if (!quiet) {
      # build the 1-D / 2-D table strictly for console output & hover
      x.tbl.print <- .build_xtab(
        x        = x.call,
        y        = y.call,
        by       = if (!is.null(by.call)) by.call else facet.call,
        facet    = NULL,
        stat     = stat,
        is.agg   = is.agg,
        digits_d = digits_d
      )

      if (length(dim(x.tbl.print)) < 3) { # by not a vector
        .print_chart_summary(  # print 1-D or 2-D, in zzz_plotly
          x.tbl   = x.tbl.print,
          x_name  = x.name,
          x.lbl   = x.lbl,
          by_name = if (!is.null(by.call)) by.name
                    else if (!is.null(facet.call)) facet.name
                    else NULL,
          y_name  = "Count",
          stat    = stat,
          digits_d = digits_d
        )
      }
    }  # end !quiet
  }  # end need to aggregate
  }  # end if (!is.agg)


# begin processing designated chart form ----------------------------------


  if (form == "bar") {
    bc <- .bc.main(x.call, y.call, by.call, stack100,
          fill, color, trans,
          fill_split, fill_scaled, fill_chroma, fill.palette, theme,
          horiz, gap, proportion, scale_y,
          xlab, ylab, main,
          label_max, beside,
          rotate_x, offset, 
          axis_fmt, axis_x_pre, axis_y_pre,
          break_x, sort,
          labels, labels_color, labels_size, labels_decimals,
          labels_position, labels_cut,
          xlab.adj, ylab.adj, bm.adj, lm.adj, tm.adj, rm.adj,
          pad_y_min, pad_y_max,
          legend_title, legend_position, legend_labels,
          legend_horiz, legend_size, legend_abbrev, legend_adjust,
          add, x1, x2, y1, y2, 80, do_plot, use_plotly, quiet,
          shiny, digits_d, style_opts=style.opts, ...)

    if (!is.null(pdf_file)) {
      dev.off()
      if (!quiet) .showfile(pdf_file, "BarChart")
    }

    return(invisible(bc))
  }


# Hierarchical chart -------------------------------------------------------

  else if (form %in% c("treemap", "icicle") ||
          (form == "pie" && !is.null(by.call))) {
    if (form == "pie") form <- "sunburst"

    # y.name should probably be distinguished from the title, which
    #   it is here, e.g., y.name is "Mean of Sales"
    ttl <- .build_chart_title(main, main.miss, x.name, by.name,
                              facet.name, y.name, stat)

    # aggregate once; .hier.plotly() just renders
    hier.agg <- .hier_aggregate(
      x = x.raw, by = by.raw, y = y.raw, facet = facet.raw,
      stat = stat,
      x_name = x.name, by_name = by.name,
      facet_name = facet.name, y_name = y.name,
      digits_d = digits_d
    )

    # resolve hex colors (uses raw data, not aggregated)
    hier.cols <- .hier_color_resolve(
      x = x.raw, y = y.raw, facet = facet.raw,
      fill = fill, fill.palette = fill.palette,
      theme = theme, stat = stat
    )

    plt <- .hier.plotly(
      nd             = hier.agg$nd,
      nd_byfac       = hier.agg$nd_byfac,
      x_name         = x.name, by_name = by.name, facet_name = facet.name,
      form           = form,
      stat_label     = hier.agg$stat.label,
      non_additive   = hier.agg$non.additive,
      n_levels       = hier.agg$n_levels,
      has_y          = hier.agg$has_y,
      fill_vec       = hier.cols$fill_vec,
      fill_vec_byfac = hier.cols$fill_vec_byfac,
      border         = NULL,
      digits_d       = digits_d,
      facet_opts     = .plotly_facet_opts(),
      main           = ttl,
      labels         = labels, labels_position = labels_position,
      labels_color   = labels_color, labels_size = labels_size,
      style_opts     = style.opts
    )

    if (.allow.interactive() && !isTRUE(getOption("knitr.in.progress")))
      print(plt)

    return(invisible(plt))
  }


  else if (form == "pie") {  # plain pie, no by, maybe facet

    # facet= on a plain pie is treated as nesting levels for a sunburst
    facet.ttl <- NULL   # the pie grid re-uses  by  to group the panels,
                        # but the variable is still a facet, so the title
                        # reads "across", not "by"
    if (is.null(by.call) && !facet.miss) {  # by already shown to not exist
      facet.ttl  <- facet.name
      by.name    <- facet.name
      options(byname = by.name)
      by.call    <- facet.call    # use the facet as the by for aggregation
      facet.name <- NULL
      facet.call <- NULL
    }

    x.tbl <- .build_plotly_tbl(x.call, y.call, by.call)

    if (is.null(by.call) && fill.miss) {
      pie.vals <- as.numeric(x.tbl)
      n.slices <- length(pie.vals)
      if (theme != "colors" && n.slices > 1L &&
          diff(range(pie.vals)) > 0) {
        fill <- setNames(
          .scale.clr(pie.vals, fill=NULL,
            fill_split=0, fill_chroma=75, theme=theme),
          names(x.tbl))
      } else if (theme == "colors") {
        fill <- setNames(
          .color_range("hues", n.slices), names(x.tbl))
      }
    }

    ttl <- .build_chart_title(
             main, main.miss, x.name,
             if (is.null(facet.ttl)) by.name else NULL,
             if (is.null(facet.ttl)) facet.name else facet.ttl,
             y.name, stat)

    plt <- piechart.plotly(
      x = x.tbl, x_name = x.name, y_name = y.name, by_name = by.name,
      main = ttl,
      fill = fill, border = color, opacity = 1 - trans,
      theme = theme,
      hole = hole, ncols = NULL,
      labels = labels, labels_position = labels_position,
      labels_color = labels_color, labels_size = labels_size,
      labels_decimals = labels_decimals,
      digits_d = digits_d,
      style_opts = style.opts
    )

    plt <- .finalize_plotly_widget(
      plt,
      kind         = "pie",
      x_name       = x.name,
      by_name      = if (!is.null(by.call)) by.name else NULL,
      add_title    = FALSE,
      nudge_viewer = (.allow.interactive() &&
                      !isTRUE(getOption("knitr.in.progress")))
    )

    if (.allow.interactive() && !isTRUE(getOption("knitr.in.progress")))
      print(plt)

    return(invisible(plt))
  }


# Bubble chart -----------------------------------------------------------

  else if (form == "bubble") {

    if (color.miss) color <- "black"
    # gray theme with no user fill: uniform gray30 so size alone encodes magnitude
    fill.bub <- if (fill.miss && identical(theme, "gray")) "gray30" else fill

    # faceting is only available for the 1-D bubble (categorical x, no by)
    if (!is.null(facet.call) && !is.null(by.call)) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "The  facet  option for bubble plots applies only to a single\n",
        "  categorical variable (no  by  variable).\n\n")
    }

    # build per-facet 1-D tables — one panel per facet level, all carrying
    # the full set of x categories so the panels stay aligned
    facet.tbls <- NULL
    if (!is.null(facet.call)) {
      fac.f   <- factor(facet.call)
      x.fac   <- if (is.factor(x.call)) droplevels(x.call) else factor(x.call)
      facet.tbls <- lapply(levels(fac.f), function(lv) {
        idx <- which(as.character(fac.f) == lv)
        .build_plotly_tbl(factor(x.call[idx], levels = levels(x.fac)),
                          if (is.null(y.call)) NULL else y.call[idx], NULL)
      })
      names(facet.tbls) <- levels(fac.f)
    }

    x.tbl <- .build_plotly_tbl(x.call, y.call, by.call)

    # build title unless user explicitly supplied main=
    ttl <- .build_chart_title(main, main.miss, x.name, by.name,
                              facet.name, y.name, stat)


    plt <- bubble.plotly(
      x = x.tbl, x_name = x.name, y_name = y.name, by_name = by.name,
      x_lab = if (!is.null(xlab)) xlab else x.name,
      y_lab = if (!is.null(ylab)) ylab
              else if (is.null(by.call)) "" else by.name,
      main = ttl,
      fill = fill.bub, border = color, opacity = 1 - trans,
      power = power, radius = radius,
      digits_d = digits_d,
      labels = labels, labels_position = labels_position,
      labels_size = labels_size, labels_color = labels_color,
      labels_decimals = labels_decimals,
      facet_tbls = facet.tbls, facet_name = facet.name,
      facet_opts = .plotly_facet_opts(),
      style_opts = style.opts
    )

    plt <- .finalize_plotly_widget(
      plt,
      kind         = "bubble",
      x_name       = x.name,
      by_name      = if (!is.null(by.call)) by.name else NULL,
      add_title    = FALSE,
      nudge_viewer = (.allow.interactive() &&
                      !isTRUE(getOption("knitr.in.progress")))
    )

    if (.allow.interactive() && !isTRUE(getOption("knitr.in.progress")))
      print(plt)

    return(invisible(plt))
  }


# Radar chart -------------------------------------------------------------

  else if (form == "radar") {

      if (n.x < 3) {  # Axes must define a polygon
        stop("\n\n",
          "radar(): The first categorical variable (x) must have at least ",
          "3 levels to form a polygon. ",
          "Found ", n.x, " levels for ", x.name, "."
        )
      }
      if (n.by == 1) {  # Must have at least two groups to compare
        stop("\n\n",
          "radar(): The second categorical variable (by) must have at least ",
          "2 levels to define multiple polygons. ",
          "Found ", n.by,  " levels for ", by.name, "."
        )
      }

      # stop when any cell is empty:
      # not working now because NA's cause by.call and x.call different lengths
      if (!is.null(by.call)) {

        # ensure x is a vector
        xv <- if (is.data.frame(x.call)) x.call[[1L]] else x.call
        ok <- complete.cases(by.call, xv)

        tbl <- table(by.call[ok], xv[ok], useNA = "no")

        if (any(tbl == 0L)) {
          zeros <- which(tbl == 0L, arr.ind = TRUE)
          print(tbl)

          stop("\n\n",
               "radar(): One or more cells are missing, with 0 entries.\n",
               "Radar polygons assume each group has a value at every axis.\n",
               "Here, ", nrow(zeros), "  cells were found with count=0.\n\n",
               "Use a larger sample, reduce the number of levels,\n",
               " or choose a different chart.\n")
        }
      }

      if (transparency.miss && !is.null(by.call))
        trans <- 0.4

      ttl <- .build_chart_title(main, main.miss, x.name, by.name,
                                facet.name, y.name, stat)

      # aggregate once here; radar.plotly just renders
      radar.agg <- .radar_aggregate(
        x = x.call, by = by.call, facet = facet.call, y = y.call,
        stat = stat, y_name = y.name
      )
      # resolve fill once to exactly n.by colors
      fill.radar <- .color_range(fill %||% .get_fill(theme),
                                 max(radar.agg$n.by, 1L))

      plt <- .radar.plotly(
        agg          = radar.agg,
        x_name       = x.name,
        by_name      = by.name,
        facet_name   = facet.name,
        main         = ttl,
        fill         = fill.radar,
        border       = color,
        opacity      = 1 - trans,
        digits_d     = digits_d,
        # facet layout controls (defaults shared with .hier.plotly)
        facet_opts  = .plotly_facet_opts(),
        style_opts  = style.opts
      )

    if (.allow.interactive() && !isTRUE(getOption("knitr.in.progress")))
      print(plt)

    return(invisible(plt))
    }


# Chart(x=, y=, ...,  form="dot") -> dot.plotly() directly ---------------

  else if (form == "dot") {

      # ---- shared dot.plotly() parameters from Chart()'s resolved state ----
      dot.border  <- getOption("pt_color")
      dot.shape   <- 21
      dot.size    <- pt_size  # default pt_size=1 → px = 10 pixels
      dot.opacity <- 1 - getOption("trans_pt_fill")
      # default fill from theme palette, same hues as the bar chart;
      # sequential-palette themes get the bar's single discrete color,
      # not a light-to-dark range (skip if a local theme= already set fill)
      if (fill.miss && is.null(fill)) {
        pal <- .get_fill(theme)
        fill <- if (identical(pal, "hues"))
                  .color_range(pal, max(n.x, n.by))
                else
                  style(theme, reset = FALSE)$bar$bar_fill_discrete
      }

      if (is.null(segments_x)) segments_x <- TRUE
      if (is.null(segments_y)) segments_y <- TRUE


      # ---- paired dot plot: x=Person (cat), y=c(Before, After) (numeric df) -
      # Kept as a separate dot.plotly() call: paired layout uses a data frame
      # for vals (signaling paired-line geometry in dot.plotly), with unique
      # row-mean sorting and label arrangement that don't fit the single-series
      # path. No facet support.
      if (is.data.frame(y.call) && ncol(y.call) > 1L) {
        if (!is.null(facet.call))
          stop(call.=FALSE, "\n------\n",
            "Multiple y variables (paired dot chart) combined\n",
            " with facet= is not supported.\n\n")

        cats.vec <- as.character(x.call)

        # apply sort= — order rows by row mean across all series
        if (sort != "0") {
          row.means <- rowMeans(as.matrix(y.call), na.rm = TRUE)
          ord       <- order(row.means, decreasing = (sort == "-"))
          cats.vec  <- cats.vec[ord]
          y.call    <- y.call[ord, , drop = FALSE]
        }

        x.lab.dot <- if (!is.null(xlab)) xlab else ""
        og <- .dot_origin_grid(
          na.omit(unlist(y.call)),
          origin_in = origin_x
        )
        origin_x  <- og$origin
        # paired-dot needs a numeric origin_x downstream (rep() with NULL fails)
        if (is.null(origin_x)) origin_x <- 0
        gridT.dot <- og$gridT

        plt <- dot.plotly(
          x          = cats.vec,
          y          = y.call,        # data frame → paired path in dot.plotly()
          fill       = fill[seq_len(min(ncol(y.call), length(fill)))],
          border     = dot.border,
          shape      = dot.shape,
          pt.size    = dot.size,
          x_lab      = x.lab.dot,
          y_lab      = x.name,
          digits_d   = digits_d,
          pt_opacity = dot.opacity,
          gridT      = gridT.dot,
          origin_x   = origin_x,
          height     = NULL,
          main       = .build_chart_title(main, main.miss, x.name, by.name,
                                          facet.name, y.name, stat),
          segments_x = segments_x,
          segments_y = segments_y,
          style_opts = style.opts
        )

        if (.allow.interactive() && !isTRUE(getOption("knitr.in.progress")))
          print(plt)
        return(invisible(plt))
      }

      # ---- single-series dot plot (faceted or not) ------------------------
      # One unified preparation path, one dot.plotly() call. Both branches
      # aggregate here (via .agg) as needed; dot.plotly() just renders.

      x.is.cat   <- is.factor(x.call) || is.character(x.call)
      has.dupes  <- x.is.cat && anyDuplicated(x.call) > 0L
      needs.agg  <- !is.agg && (has.dupes || (!is.null(stat) && !is.null(y.call)))
      is.faceted <- !is.null(facet.call)

      # ---- prepare cats.vec, vals.vec, all.vals (for axis range) ----------
      if (is.faceted) {
        # aggregate (if needed) and sort per facet; dot.plotly() just renders
        fac.chr    <- as.character(facet.call)
        fac.levels <- base::sort(unique(fac.chr[!is.na(fac.chr)]))

        # the main stat block has already reduced the data when both y and
        # stat are present (is.agg), so aggregate here only the raw counts
        # of x when there is no y
        stat.use <- if (!is.agg && !is.null(stat)) stat
                    else if (is.null(y.call)) "sum"  # sum of 1's: count
                    else NULL

        if (!is.null(stat.use)) {
          y.use <- if (!is.null(y.call)) as.numeric(y.call)
                   else rep(1L, length(fac.chr))
          agg.out <- .agg(as.character(x.call), y.use, facet=fac.chr,
                          stat=stat.use)$out
        }

        cats.lst <- vals.lst <- fac.lst <-
          vector("list", length(fac.levels))
        for (k in seq_along(fac.levels)) {
          lv <- fac.levels[k]

          if (!is.null(stat.use)) {  # aggregated rows for this facet panel
            sub <- agg.out[agg.out$facet.var == lv, , drop=FALSE]
            sub <- sub[order(as.character(sub$x)), , drop=FALSE]
            c.i <- as.character(sub$x)
            v.i <- as.numeric(sub$y)
          }
          else {  # data already reduced upstream, or raw passthrough
            keep <- fac.chr == lv & !is.na(fac.chr)
            c.i  <- as.character(x.call[keep])
            v.i  <- as.numeric(y.call[keep])
          }

          if (sort != "0" && length(c.i) == length(v.i)) {
            ord <- order(v.i, decreasing = (sort == "-"),
                         na.last = TRUE)
            c.i <- c.i[ord]; v.i <- v.i[ord]
          }

          cats.lst[[k]] <- c.i
          vals.lst[[k]] <- v.i
          fac.lst[[k]]  <- rep(lv, length(c.i))
        }

        cats.vec       <- unlist(cats.lst, use.names = FALSE)
        vals.vec       <- unlist(vals.lst, use.names = FALSE)
        facet.arg      <- unlist(fac.lst,  use.names = FALSE)
        facet.name.arg <- facet.name
        all.vals       <- vals.vec
        x.lab.dot      <- if (!is.null(xlab)) xlab
                          else if (!is.null(y.call)) y.name
                          else paste("Count of", x.name)
      } else {
        # non-faceted: aggregate here
        facet.arg      <- NULL
        facet.name.arg <- NULL

        if (needs.agg) {
          if (is.null(y.call)) {
            agg <- table(x.call)
            agg <- if (sort != "0")
                     base::sort(agg, decreasing = (sort == "-"))
                   else
                     agg[base::sort(names(agg))]  # alphabetical
            cats.vec  <- names(agg)
            vals.vec  <- as.integer(agg)
            x.lab.dot <- if (!is.null(xlab)) xlab
                         else paste("Count of", x.name)
          } else {
            stat.use  <- if (!is.null(stat)) stat else "mean"
            stat.out  <- .agg(x.call, y.call, NULL, NULL, stat.use, y.name)
            cats.vec  <- as.character(stat.out$out$x)
            vals.vec  <- as.numeric(stat.out$out$y)
            x.lab.dot <- if (!is.null(xlab)) xlab else stat.out$ylab
          }
        } else {
          # already aggregated / unique
          if (is.null(y.call)) {
            cat("\n"); stop(call.=FALSE, "\n------\n",
              "Need to specify a numerical variable for y, y=NAME\n\n")
          }
          if (x.is.cat) {
            # When stat aggregation was done upstream, x.call/y.call already
            # hold the reduced aggregated data. x.call.all/y.call.all only
            # apply for pre-aggregated input data where some categories may
            # have NA values.
            if (!is.null(stat)) {
              cats.vec <- as.character(x.call)
              vals.vec <- as.numeric(y.call)
            } else {
              # pre-aggregated: use .all so all category labels appear on the
              # axis; dot.plotly() skips points where vals is NA.
              cats.vec <- as.character(x.call.all)
              vals.vec <- as.numeric(y.call.all)
            }
            x.lab.dot <- if (!is.null(ylab)) ylab else y.name
          } else {
            # x numeric, y categorical → horizontal
            cats.vec  <- as.character(y.call)
            vals.vec  <- as.numeric(x.call)
            x.lab.dot <- if (!is.null(xlab)) xlab else x.name
          }
        }

        # apply sort= to aggregated category/value vectors
        if (sort != "0" && length(cats.vec) == length(vals.vec)) {
          ord <- order(vals.vec, decreasing = (sort == "-"), na.last = TRUE)
          cats.vec <- cats.vec[ord]
          vals.vec <- vals.vec[ord]
        }
        all.vals <- vals.vec
      }

      # ---- resolve orientation and axis labels ----------------------------
      # Default: categories on x-axis (vertical), matching bar chart convention.
      # horiz=TRUE flips to horizontal (categories on y-axis).
      # Exception: x numeric + y categorical always stays vertical.
      if (!x.is.cat && !is.null(y.call)) {
        orientation <- "v"
        x.lab.arg   <- if (!is.null(xlab)) xlab else x.name
        y.lab.arg   <- x.lab.dot
      } else if (horiz) {
        orientation <- "h"
        x.lab.arg   <- if (!is.null(xlab)) xlab else x.lab.dot
        y.lab.arg   <- if (!is.null(ylab)) ylab else x.name
      } else {
        orientation <- "v"
        x.lab.arg   <- if (!is.null(xlab)) xlab else x.name
        y.lab.arg   <- if (!is.null(ylab)) ylab else x.lab.dot
      }

      # ---- compute origin.val and gridT.dot via shared helper -------------
      og <- .dot_origin_grid(
        all.vals,
        origin_in = if (orientation == "h") origin_x else origin_y,
        # force count semantics when y is missing (Chart-only knowledge)
        is_counts = if (is.null(y.call)) TRUE else NULL
      )
      origin.val <- og$origin
      gridT.dot  <- og$gridT

      # ---- single dot.plotly() call ---------------------------------------
      plt <- dot.plotly(
        x           = cats.vec,
        y           = vals.vec,
        orientation = orientation,
        fill        = fill,
        border      = dot.border,
        shape       = dot.shape,
        pt.size     = dot.size,
        x_lab       = x.lab.arg,
        y_lab       = y.lab.arg,
        digits_d    = digits_d,
        pt_opacity  = dot.opacity,
        gridT       = gridT.dot,
        origin_x    = origin.val,
        height      = NULL,
        facet       = facet.arg,
        facet_name  = facet.name.arg,
        main        = .build_chart_title(main, main.miss, x.name, by.name,
                                         facet.name, y.name, stat),
        segments_x  = segments_x,
        segments_y  = segments_y,
        style_opts  = style.opts
      )

      if (.allow.interactive() && !isTRUE(getOption("knitr.in.progress")))
        print(plt)
      return(invisible(plt))
    }


  }  # end x is a single var
  # ------------------------
  # ------------------------
  # x is a data frame or var list of multiple variables
  else {

    if (!by.miss || !facet.miss) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "by and facet variables not available for multiple x variables\n\n")
    }

    if (!(form %in% c("bar", "bubble"))) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "Multiple x variables only available for form=\"bar\"\n",
        "  or form=\"bubble\"\n\n")
    }

    if (form == "bubble") {  # vector bubble, BPFM

      # get labels just for subset data matrix
      attr.labels <- attr(data, which="variable.labels")
      nm <- names(x.call)
      mylabs <- character(length=length(nm))
      mylabs <- ifelse(nm %in% names(attr.labels),
                       attr.labels[nm], "not available")
      if (all(mylabs == "not available")) mylabs <- NULL

      if ("l" %in% ls(name=.GlobalEnv)) mylabs <- get("l", pos=.GlobalEnv)

      if (is.null(xlab)) xlab <- ""  # suppress x-axis label if not specified

    if (is.null(fill)) fill <- getOption("bar_fill_cont")
    if (transparency.miss) trans <- 0.4

    .dpmat.main(
      x=data[, , drop = FALSE], l=mylabs,
      sort_type=sort,

      fill=fill, color=getOption("pt_color"), col.bg=getOption("panel_fill"),
      trans=trans, shape_pts="bubble", col.box=getOption("panel_color"),
      col.low=NULL, col.hi=NULL,

      xy_ticks=TRUE,
      xlab=xlab, ylab=ylab, main=main, sub=sub, cex=1,

      radius=radius, power=power,
      size_cut=1,
      txt_color=getOption("bubble_text_color"),

      bm.adj=0, lm.adj=0, tm.adj=0, rm.adj=0,

      rotate_x=rotate_x, rotate_y=rotate_y, offset=offset, quiet=quiet,

      do_plot=do_plot, fun_call=fun_call,
      ...)
    }  # end vector bubble

    else if (form == "bar") {  # vector bar

    if (is.null(one_plot)) {  # see if one_plot was specified
      one_plot <- TRUE

      mx.ln <- 0  # get variable with the most unique responses
      for (i in seq_len(ncol(data))) {
        ln <- length(na.omit(unique(data[,i])))
        if (ln > mx.ln) {
          ind <- i
          mx.ln <- ln
        }
      }
      uq <- na.omit(unique(data[,ind]))  # first largest set of responses
      uq.ln <- length(uq)  # length of largest set

      # all elements of smaller response set should be in full response set
      for (i in seq_len(ncol(data))) {
        if (length(setdiff(na.omit(unique(data[,i])), uq)) > 0) {
          one_plot <- FALSE
          break;
        }
      }
    }  # end determine one_plot

    # one_plot all x's stacked on a single plot, like a BPFM for bars
    if (one_plot) {
      y.call <- NULL
      by.call <- NULL
      if (is.null(legend_title)) legend_title <- "Responses"
      options(byname = "Responses")
      if (is.null(xlab)) xlab <- ""
      if (is.null(ylab)) ylab <- ""
      if (labels_size.miss) labels_size <- 0.8 - (0.008 * ncol(data))
      if (sort.miss) sort <- "+"
      if (horiz.miss) horiz <- TRUE

      if (color.miss) color <- "transparent"

      # if fill not specified, define divergent palette and get colors
      if (fill.miss) {
        fill <- .get_fill(theme, diverge=TRUE)  # get divergent color names
        fill <-.color_range(fill, uq.ln)  # translate color names to colors
      }  # end fill.miss

      # evaluate getColors at the time of the function call
      # re-evaluate here by setting fill with the specified value of n
      else if (substr(fill.name[1], 1, 9) == "getColors")
        fill <- .resolve_getColors_n(fill.name, uq.ln)

      else  # not fill=getColors(...) but color names were specified
        fill <-.color_range(fill, uq.ln)  # translate color names to colors

      if (!is.null(pdf_file)) {
        if (!grepl(".pdf", pdf_file, fixed=TRUE))
          pdf_file <- paste(pdf_file, ".pdf", sep="")
        pdf(file=pdf_file, width=width, height=height, onefile=FALSE)
      }
      else {
        if (df.name != "NULL")  # not dev.new for shiny
            .opendev(pdf_file, width, height)
      }

      bc <- .bc.main(data, y.call, by.call, stack100,
            fill, color, trans,
            fill_split, fill_scaled, fill_chroma, fill.palette, theme,
            horiz, gap, proportion, scale_y,
            xlab, ylab, main,
            label_max, beside,
            rotate_x, offset,
            axis_fmt, axis_x_pre, axis_y_pre,
            break_x, sort,
            labels, labels_color, labels_size, labels_decimals,
            labels_position, labels_cut,
            xlab.adj, ylab.adj, bm.adj, lm.adj, tm.adj, rm.adj,
            pad_y_min, pad_y_max,
            legend_title, legend_position, legend_labels,
            legend_horiz, legend_size, legend_abbrev, legend_adjust,
            add, x1, x2, y1, y2, 80, do_plot, use_plotly=FALSE,
            quiet, shiny, digits_d, style_opts=style.opts, ...)

      if (!is.null(pdf_file)) {
        dev.off()
        if (!quiet) .showfile(pdf_file, "BarChart")
      }
    }  # end one_plot


    # --------------------------------
    # analyze each x column separately

    else {
      bc.data.frame(data, stack100,
        fill, color, trans, fill_split,
        fill_scaled, fill_chroma, theme,
        horiz, gap, proportion, scale_y,
        xlab, ylab, main,
        label_max, beside,
        rotate_x, offset, 
        axis_fmt, axis_x_pre, axis_y_pre,
        break_x, sort,
        labels, labels_color, labels_size, labels_decimals,
        labels_position, labels_cut,
        xlab.adj, ylab.adj, bm.adj, lm.adj, tm.adj, rm.adj,
        pad_y_min, pad_y_max,
        legend_title, legend_position, legend_labels,
        legend_horiz, legend_size, legend_abbrev, legend_adjust,
        80, do_plot, use_plotly=FALSE, quiet,
        digits_d, shiny, pdf_file, width, height, ...)
    }
  }
  } # end

}

STL <- function(x, y=NULL, data=d, filter=NULL,
                ts_format=NULL, ts_unit=NULL, ts_agg=c("sum","mean"),
                show_range=FALSE, robust=FALSE, quiet=FALSE, do_plot=TRUE,
                pdf_file=NULL, width=6.5, height=6) {
  ts_agg <-  match.arg(ts_agg)

  x.name <- deparse(substitute(x))
  y.name <- deparse(substitute(y))

  df.name <- deparse(substitute(data))
  options(dname = df.name)

  # subset filter
  if (!missing(filter)) {
    txt <- .filter(deparse(substitute(filter)))
    r <- eval(str2expression(txt), envir=data, enclos=parent.frame())
    r <- r & !is.na(r)  # set missing for a row to FALSE
    nr.before <- nrow(data)
    if (any(r))
      data <- data[r,,drop=FALSE]
    if (!quiet) {
      cat("filter: ",  txt, "\n-----\n")
      cat("Rows of data before filtering: ", nr.before, "\n")
      cat("Rows of data after filtering:  ", nrow(data), "\n\n")
    }
  }  # end filter

  x.in.global <- df.or.global(x.name, df.name, role="x", fun.name="STL")

  if (!x.in.global)  {
    data.vars <- as.list(seq_along(data))
    names(data.vars) <- names(data)

    ind <- eval(substitute(x), envir=data.vars)  # col num of x var
    x.date <- data[, ind, drop=FALSE]

    # see if x.date has char string values to convert to type Date
    if (is.character(x.date[1,1])) {
      if (!is.null(ts_format))  # specify the date format
        x.date[,1] <- as.Date(x.date[,1], format=ts_format)
      else  # see if a date, and if so, infer the date format
        x.date <- date.infer(x.date, quiet)
    }

    is_ordered <- all(diff(x.date[,1]) >= 0) 
    if (!is_ordered) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "The date variable, ", x.name, ", must be ordered across all data.\n\n",
        "Perhaps you have multiple groups of ", y.name, ".\n",
        "If so, use the parameter  filter  to focus on just one group.\n\n")
    }

    ind <- eval(substitute(y), envir=data.vars)  # col num of y var
    y.data <- data[, ind]

    #   if not specified, get the existing ts_unit
    #   if specified, aggregate the values of y.data over x
    tsdata <- .plt.time(x.date, y.data, by.call=NULL, x.name, n.by=0,
                        ts_unit, ts_agg)
    ts_unit <- tsdata$ts_unit
    x.date <- tsdata$x.call[,1]
    y.data <- tsdata$y.call[,1]
    y.ts <- .tsMake(x.date, y.data, ts_unit)  # convert data to ts form

    is_ts <- FALSE
  }  # end x is not in global

  else if (is.ts(x)) {
    is_ts <- TRUE
    y.ts <- x
    tsPull <- tsExtract(x)
    y.data <- tsPull$y
    y.name <- tsPull$y.name
  }

  else {  # data=NULL but x is a global object that is not a time series
    cat("\n"); stop(call.=FALSE, "\n------\n",
      "With  data=NULL, the variable  ", x.name, "  must be a time series\n",
      "  (ts) object. Otherwise, read the data into a data frame and\n",
      "  specify the date and value variables.\n\n")
  }

  # compute components
  decomp <- stl(y.ts, s.window="periodic", robust=robust)

  # set up pdf_file if needed
  if (do_plot && !is.null(pdf_file)) {
    if (!grepl("\\.pdf$", pdf_file))
      pdf_file <- paste(pdf_file, ".pdf", sep="")
    grDevices::pdf(file=pdf_file, width=width, height=height, onefile=FALSE)
  }

  if (do_plot)
    plot(decomp, col.range="lightgoldenrod")

  if (do_plot && !is.null(pdf_file)) {
    dev.off()
    if (!quiet) .showfile(pdf_file, "STL decomposition")
  }

  # extract components from the stl() decomposition
  seasonal <- decomp$time.series[, "seasonal"]
  trend <- decomp$time.series[, "trend"]
  error <- decomp$time.series[, "remainder"]

  if (!quiet) {

    # calculate the range of y and of each component
    range.y <- diff(range(y.data, na.rm=TRUE))
    range.seasonal <- diff(range(seasonal, na.rm=TRUE))
    range.trend <- diff(range(trend, na.rm=TRUE))
    range.error <- diff(range(error, na.rm=TRUE))

    # calculate the variance of y and of each component
    var.y <- var(y.data, na.rm = TRUE)
    var.seasonal <- var(seasonal, na.rm =TRUE)
    var.trend <- var(trend, na.rm=TRUE)
    var.error <- var(error, na.rm=TRUE)

    # calculate the proportion of variance explained by each component
    prop.seasonal <- var.seasonal / var.y
    prop.trend <- var.trend / var.y
    prop.error <- var.error / var.y

    # display the results
    cat("\nTotal variance of ", y.name, ": ", var.y, "\n", sep="")
    cat("Proportion of variance for components:\n")
    cat("  seasonality ---", .fmt(prop.seasonal,3), "\n")
    cat("  trend ---------", .fmt(prop.trend, 3), "\n")
    cat("  remainder -----", .fmt(prop.error, 3), "\n")

    if (show_range) {
      cat("\nRange of ", y.name, ": ", range.y, "\n", sep="")
      cat("Range of components:\n")
      cat("  seasonality ---", .fmt(range.seasonal,3), "\n")
      cat("  trend ---------", .fmt(range.trend, 3), "\n")
      cat("  remainder -----", .fmt(range.error, 3), "\n")
    }

    cat("\n")

  }  # end !quiet

  # output data structure
  te <- tsExtract(trend)
  if (!is_ts)
    de <- .toFmtDate(te[[1]], ts_unit)  # e.g., 2020-01-01 to 2020 Q1
  else
    de <- te[[1]]
  te <- as.numeric(te[[2]])   # trend component
  se <- tsExtract(seasonal)
  se <- as.numeric(se[[2]])   # seasonal component
  ee <- tsExtract(error)
  ee <- as.numeric(ee[[2]])   # error component
  out <- data.frame(de, y.data, te, se, ee)
  if (is_ts) {
    x.name <- "date"
    y.name <- "data"  # not recovered
  }
  names(out) <- c(x.name, y.name, "trend", "season", "error")
  return(invisible(out))

}

.plt.facet.series <-
function(series.data, shared, shared.lab, on,
         facet1, facet2,
         pt_fill, pt_color, pt_size, shape,
         fit, fit_lwd, n_row, n_col, aspect) {

  # the multi-series overlay of the columns of series.data plotted against
  #   the single shared variable, repeated across the panels of the facet
  #   variable(s): each panel displays the full overlay for one facet level
  #   (or combination of levels), with all panels on a common scale
  # on="x": the series are on the x-axis with the shared variable on y
  # on="y": the series are on the y-axis with the shared variable on x
  k  <- ncol(series.data)
  nm <- names(series.data)
  n  <- nrow(series.data)

  dd <- data.frame(
    value  = unlist(series.data, use.names = FALSE),
    shared = rep(shared, k),
    series = factor(rep(nm, each = n), levels = nm),
    f1     = rep(facet1, k))
  two.facets <- !is.null(facet2)
  if (two.facets) dd$f2 <- rep(facet2, k)

  # layout: default a single column of panels, as with the generic facet
  #   path; lattice takes c(cols, rows)
  n.pan <- nlevels(dd$f1) * (if (two.facets) nlevels(dd$f2) else 1L)
  if (!is.null(n_col))      lay <- c(n_col, ceiling(n.pan / n_col))
  else if (!is.null(n_row)) lay <- c(ceiling(n.pan / n_row), n_row)
  else if (!two.facets)     lay <- c(1, n.pan)
  else                      lay <- NULL  # lattice default two-facet grid

  asp <- if (is.numeric(aspect)) aspect
         else if (identical(aspect, "xy")) "xy" else "fill"

  cond <- if (two.facets) "f1 + f2" else "f1"
  ser.lab <- paste(nm, collapse=", ")
  if (on == "x") {                     # the series are on the x-axis
    ff <- stats::as.formula(paste("shared ~ value |", cond))
    x.lab <- ser.lab;  y.lab <- shared.lab
  } else {                             # the series are on the y-axis
    ff <- stats::as.formula(paste("value ~ shared |", cond))
    x.lab <- shared.lab;  y.lab <- ser.lab
  }
  scl <- list(col = getOption("axis_text_color"),
              cex = getOption("axis_size"))

  # per-panel overlay of the series, each series's optional fit line drawn
  #   in that series's color
  pan.grp <- function(x, y, col.symbol, ...) {
    lattice::panel.xyplot(x, y, col.symbol = col.symbol, ...)
    if (fit != "off"  &&  sum(is.finite(x) & is.finite(y)) > 2) {
      if (fit == "loess")
        lattice::panel.loess(x, y, col = col.symbol, lwd = fit_lwd)
      else if (fit %in% c("lm", "ls"))
        lattice::panel.lmline(x, y, col = col.symbol, lwd = fit_lwd)
    }
  }
  pan <- function(x, y, groups, subscripts, ...)
    lattice::panel.superpose(x, y, groups = groups,
                             subscripts = subscripts,
                             panel.groups = pan.grp, ...)

  panel_color <- getOption("panel_color")
  frame_color <- ifelse(panel_color == "transparent", "gray30", panel_color)
  lab.spec <- function(lab) if (is.null(lab)) NULL else
    list(label = lab, cex = getOption("lab_size"),
         col = getOption("lab_color"))

  p <- lattice::xyplot(ff, data = dd, groups = dd$series,
    scales = scl, layout = lay, as.table = TRUE, aspect = asp,
    xlab = lab.spec(x.lab), ylab = lab.spec(y.lab),
    panel = pan,
    auto.key = list(space = "top", columns = min(k, 3L), points = TRUE),
    par.strip.text = list(cex = getOption("axis_size"),
                          col = getOption("strip_text_color")),
    par.settings = list(
      background = list(col = getOption("window_fill")),
      panel.background = list(col = getOption("panel_fill")),
      superpose.symbol = list(col = pt_color, fill = pt_fill,
                              pch = shape, cex = pt_size),
      axis.line = list(col = frame_color,
                       lty = getOption("axis_lty"),
                       lwd = getOption("axis_lwd")),
      strip.border = list(col = getOption("strip_color"), lwd = 1),
      strip.background = list(col = getOption("strip_fill"))))

  print(p)
}

.plt.bins <-
function(x, y, nm.x, nm.y, stat, n_bins=6,
         segments=TRUE, size, digits_d=3, scale_x, scale_y, 
         fill=getOption("pt_fill"), color=getOption("pt_color"),
         trans=getOption("trans_pt_fill"),
         quiet=FALSE) {


  # -------- Conditions

  if (!(stat %in% c("mean", "median")))  {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Parameter  stat  can only take two values for binning: \n",
      "  mean   and   median\n\n")
  }

  if (!is.numeric(x) || !is.numeric(y))  {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Both variables must be numeric\n\n")
  }

  nx.unq <- length(unique(x))
  if (nx.unq < n_bins)  # too many bins
    message("You specified ", n_bins, " bins",
            ", but only ", nx.unq, " values of ", nm.x, "\n",
            "Empty bins will appear in the solution\n\n")

  if (is.na(n_bins) || n_bins < 2)  {  # not enough bins
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Need at least two bins set by  n_bins\n\n")
  }


  # -------- Process

  # get x-bins and midpoints, based on R cut() but allows format="f"
  nb <- as.integer(n_bins + 1)
  rx <- range(x, na.rm = TRUE)
  dx <- rx[2] - rx[1]
  bns <- seq.int(rx[1L], rx[2L], length.out=nb)  # bns is a vector
  bns[c(1L, nb)] <- c(rx[1L] - dx/1000, rx[2L] + dx/1000)  # extend range
  bins <- cbind(bns[1:nb-1], bns[2:nb])  # bins is a matrix
  midpt <- bins[,1] + (bins[,2] - bins[,1]) / 2
  bins = cbind(bins, midpt)

  # get labels
  ch.br <- formatC(bns, digits=digits_d, width=1L, format="f")
  labs <- paste0("(", ch.br[-nb], ",", ch.br[-1L], "]")
  substr(labs[1], 1, 1) <- "["  # indicate first bin is closed [ and ]

  # get mean or median of y for each x-bin
  n <- integer(length=nrow(bins))
  m <- double(length=nrow(bins))
  for (i in 1:nrow(bins)) {
    lower <- bins[i,1]
    upper <- bins[i,2]
    # only need y's; [x... ] returns T, F, NA; if x[i]=NA, y[i]=NA
    # each x[i]=NA gets in each y.sub, NA behaves like T instead of F
    # x[i]=NA triggers a y[i]=NA and a y[i] by itself can be NA
    y.sub <- na.omit(y[x > lower & x <= upper]) # select, drop all NA's 
    n[i] <- length(y.sub)
    if (stat == "mean")
      m[i] <- mean(y.sub, na.rm=TRUE)
    else if (stat == "median")
      m[i] <- median(y.sub, na.rm=TRUE)
  }

  # plot
  dbin <- data.frame(cbind(bins[,3], m))  # .plt.main input is data frames
  d.x <- dbin[,1, drop=FALSE]  # midpt
  d.y <- dbin[,2, drop=FALSE]  # mean or median
  if (is.null(size)) {
    den <- max(n, na.rm=TRUE) / 10  # scaling factor so max pt.size is around 10
    size <- (n/den)^.6
  }
  .plt.main(d.x, d.y, xlab=nm.x, ylab=paste(stat, "of", nm.y), 
            segments=segments, fill=fill, color=color, size=size, 
            pt.trans=trans, scale_x=scale_x, scale_y=scale_y,
            use_plotly=FALSE)


  # -------- Output Tables

  if (!quiet) {
    # global summary stats
    n.pres <- c(length(na.omit(x)), length(na.omit(y)))
    n.miss = c(length(x)-length(na.omit(x)), length(y)-length(na.omit(y)))
    dx <-  ifelse (.is.integer(x), 0, digits_d)
    dy <-  ifelse (.is.integer(y), 0, digits_d)
    min.x = c(.fmt(min(x, na.rm=TRUE), dx), .fmt(min(y, na.rm=TRUE), dy))
    max.x = c(.fmt(max(x, na.rm=TRUE), dx), .fmt(max(y, na.rm=TRUE), dy))
    mean.x = c(.fmt(mean(x, na.rm=TRUE), digits_d),
               .fmt(mean(y, na.rm=TRUE), digits_d))
    d.smr <- data.frame(rbind(n.pres, n.miss, min.x, max.x, mean.x))
    names(d.smr) <- c(nm.x, nm.y)
    rownames(d.smr)[rownames(d.smr) == "n.pres"] <- "n"
    rownames(d.smr)[rownames(d.smr) == "min.x"] <- "min"
    rownames(d.smr)[rownames(d.smr) == "max.x"] <- "max"
    rownames(d.smr)[rownames(d.smr) == "mean.x"] <- "mean"
    cpt="Summary Stats"
    smr <- knitr::kable(d.smr, format="pandoc", digits=2, caption=cpt,
                        align="r")
    class(smr) <- "out"

    # bin summary stats
    m <- .fmt(m, digits_d)
    midpt <- .fmt(midpt, digits_d)
    d.tbl <- data.frame(rbind(labs, n, midpt, m))
    rownames(d.tbl)[rownames(d.tbl) == "labs"] <- "bin"
    rownames(d.tbl)[rownames(d.tbl) == "m"] <- stat
    names(d.tbl) <- gsub("X", "bin_", names(d.tbl), fixed=TRUE)
    d.tbl <- t(d.tbl)
    row.names(d.tbl) <- 1:nrow(d.tbl)
    cpt <- paste(stat, "of", nm.y, "for levels of", nm.x)
    w <- knitr::kable(d.tbl, format="simple", digits=2, caption=cpt, align="r",
                      row.names=TRUE, escape=FALSE, booktabs=TRUE)
    w <- c("",w)
    class(w) <- "out"

    output <- list(out_b1="", out_stats=smr, out_w=w)
    class(output) <- "out_all"
    print(output)
  }  # end if !quiet

}

.param.old <-
function (..., fun.name = "") {

  # check for dated parameters no longer used
  dots <- list(...)
  
  if (!is.null(dots)) if (length(dots) > 0) {

    for (i in 1:length(dots)) {

#     if (grepl("fill", names(dots)[i], fixed=TRUE)  ||
#         grepl("color_", names(dots)[i], fixed=TRUE)) {
#       cat("\n"); stop(call.=FALSE, "\n","------\n",
#         "The parameter list for this function is much shortened by moving\n",
#         "most color and related style attributes to function:  style\n\n",
#         "Example: Here set the theme to gold with a fill color of ",
#         "\"powerderblue\"\n\n",
#         "style(\"gold\", fill=\"powderblue\")\n\n",
#         "Enter   style(show=TRUE)  to see all the options\n",
#         "Enter   ?style  to view the help file\n\n")
#     }

      # --- X()-specific deprecated args ---
      if (fun.name == "X") {
        if (names(dots)[i] == "density") {
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "Now enter:  form=\"density\" in place of density=TRUE\n\n")
        }
      }

      # --- XY()-specific deprecated args ---
      if (fun.name == "XY") {
        if (substr(names(dots)[i], 1, 5) == "time_") {
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "Parameters that begin with \"time_\" now begin with \"ts_\"\n\n")
        }
        if (substr(names(dots)[i], 1, 3) == "es_") {
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "Parameters that begin with \"es_\" now begin with \"ts_\"\n\n")
        }
        if (names(dots)[i] == "run") {
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "Parameter dropped: run. Specify the 1st variable, the x-variable,\n",
            "  as .Index to automatically create the index variable.\n",
            "  e.g., Plot(.Index, Y), where Y is the variable to plot\n\n")
        }
        if (names(dots)[i] %in% c("vbs_plot", "vbs_ratio", "bw", "bw_iter",
              "violin_fill", "box_fill", "vbs_pt_fill", "vbs_mean",
              "fences", "k", "box_adj", "a", "b")) {
          cat("\n"); stop(call.=FALSE, "\n------\n",
            "Parameter  ", names(dots)[i], "  no longer applies to XY().\n",
            "VBS (violin/box/scatter) plots of a single variable are now\n",
            "  obtained from X(), which provides these parameters,\n",
            "  e.g., X(Salary, form=\"vbs\")\n\n")
        }
      }

      # --- shared deprecated args ---
      if (grepl("stroke", names(dots)[i], fixed=TRUE)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "stroke  replaced with:  color\n",
          "e.g., ellipse_color  instead of  ellipse.stroke\n\n",
          "Also, now modify via function:  style\n\n",
          "Example: style(\"gold\", color=\"powderblue\")\n\n",
          "Enter   style(show=TRUE)  to see all the options\n",
          "Enter   ?style  to view the help file\n\n")
      }

      if (grepl("col.", names(dots)[i], fixed=TRUE)) 
        if (names(dots)[i] != "col.names"  &&
            names(dots)[i] != "col.main"  &&
            names(dots)[i] != "col.lab"  &&
            names(dots)[i] != "col.sub") {
          cat("\n"); stop(call.=FALSE, "\n","------\n",
            "color options dropped the  col. prefix\n",
            "eg., fill, instead of col_fill\n\n",
          "Also, now can modify fill and related colors\n",
          "  with function:  style\n\n")
      }

      if (names(dots)[i] %in% c("tm.adj", "rm.adj", "bm.adj", "lm.adj")) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Now use margin_adj vector: top, right, bottom, left\n",
          "e.g., margin_adj=c(.5,0,0,0) moves top margin in 0.5 in \n\n")
      }
      if (names(dots)[i] %in% c("xlab_adj", "ylab_adj")) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Now use lab_adj vector: xlab, ylab\n",
          "e.g., lab_adj=c(.5,0) moves x-axis label in 0.5 in \n\n")
      }

      if (names(dots)[i] == "area") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  area=TRUE  renamed  fill=\"on\" or area_fill=\"on\"\n\n")
      }

      if (names(dots)[i] == "ref") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  ref  renamed  from  or  to  for Read and Write\n\n")
      }

      if (names(dots)[i] == "prop") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  prop  renamed  stack100 for two variables\n",
          "and  stat_x=\"proportion\"  for one variable\n\n")
      }

      if (names(dots)[i] == "proportion") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  proportion  renamed  stat_x=\"proportion\" \n\n")
      }

      if (names(dots)[i] == "band") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  band  renamed  rug\n\n")
      }

      if (names(dots)[i] == "gen_color") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  gen_color  renamed  color_gen\n\n")
      }

      if (names(dots)[i] == "nrm_color") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  nrm_color  renamed  colr.nrm\n\n")
      }

      if (names(dots)[i] == "legend_loc") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  legend_loc  renamed  legend_position\n\n")
      }

      if (names(dots)[i] == "values_pos") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  values_pos  renamed  values_position\n\n")
      }

      if (names(dots)[i] == "values_cex") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  values_cex  renamed  labels_size\n\n")
      }

      if (names(dots)[i] == "sort_x") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  sort_x  renamed  sort\n\n")
      }
      
      if (grepl("colors", names(dots)[i], fixed=TRUE) &&
          names(dots[i]) != "labels_color") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "colors option removed because the fill parameter\n",
          "  and getColors function offer more functionality\n\n")
      }

      if (grepl("rotate", names(dots)[i], fixed=TRUE)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Use the style function for rotate_x, rotate_y, offset\n\n")
      }
      if (grepl("fit.line", names(dots)[i], fixed=TRUE)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "fit.line options dropped the  .line suffix\n",
          "use  fit, instead of fit.line\n\n")
      }
      if (grepl("by.group", names(dots)[i], fixed=TRUE)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "by.group option is now just  by, its original meaning\n",
          "use  facet1  and  facet2  for 1 and 2 variable Trellis graphics\n\n")
      }
      if (names(dots)[i] %in% c("x.start","x.end","y.start","y.end")) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "x.start, x.end, y.start, and y.end no longer used\n\n",
          "Instead use the standard R xlim and ylim parameters,\n",
          "such as xlim=c(0,40) to specify from 0 to 40. Same for ylim\n\n")
      }
      if (names(dots)[i] == "hist.counts") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  hist.counts  renamed  values\n\n")
      }
      if (names(dots)[i] == "line_chart") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  line_chart  renamed  run\n\n")
      }
      if (names(dots)[i] == "rotate.values") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Rotation of the axis labels can now be applied to both axes\n\n",
          "option  rotate.values  renamed  rotate_x or rotate_y\n\n")
      }
      if (names(dots)[i] == "line_width") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  line_width  renamed  lwd\n\n")
      }
      if (names(dots)[i] == "bubble_size") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  bubble_size  renamed  radius\n\n")
      }
      if (names(dots)[i] == "bubble_scale") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  bubble_scale  renamed  power\n\n")
      }
      if (names(dots)[i] == "bubble_text") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  bubble_text  is now modified in function:  style\n\n")
      }
      if (names(dots)[i] == "size.out") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  size.out  renamed  out_size\n\n")
      }
      if (names(dots)[i] == "shape.out") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  shape.out  renamed  out_shape\n\n")
      }
      if (names(dots)[i] == "topic") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  topic  renamed  values\n\n")
      }
      if (names(dots)[i] == "kind") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  kind  is no longer active\n\n")
      }
      if (names(dots)[i] == "object") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  object  is no longer active\n\n",
          "use line_chart=TRUE to get a line chart\n",
          "set size=0 to remove points from the plot\n\n")
      }
      if (names(dots)[i] == "auto") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  auto  renamed  enhance\n\n")
      }
      if (names(dots)[i] == "values") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  values  renamed  stat\n\n")
      }
      if (names(dots)[i] == "smooth_trans") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  smooth_trans  renamed  smooth_exp\n\n")
      }
      if (names(dots)[i] == "knitr.file") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "knitr.file  no longer used\n",
          "Instead use  Rmd  for R Markdown file\n\n")
      }
      if (names(dots)[i] == "diag") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "diag  option no longer available\n\n")
      }
      if (names(dots)[i] == "low_color") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  low_color  renamed  low_fill\n\n")
      }
      if (names(dots)[i] == "fill_ellipse") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  fill_ellipse  renamed  ellipse_fill\n\n")
      }
      if (names(dots)[i] == "color_ellipse") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  color_ellipse  renamed  ellipse_color\n\n")
      }
      if (names(dots)[i] == "color_fit") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  color_fit  renamed  fit_color\n\n")
      }
      if (names(dots)[i] == "lwd.fit") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  lwd.fit  renamed  fit_lwd\n\n")
      }
      if (names(dots)[i] == "se.fit") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  se.fit  renamed  fit_se\n\n")
      }
      if (names(dots)[i] == "box") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  box  renamed  panel_color\n\n")
      }
      if (names(dots)[i] == "bg") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  bg  renamed  panel_fill\n\n")
      }
      if (names(dots)[i] == "axes") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "option  axes  renamed  axis_text_color\n\n")
      }
      if (names(dots)[i] == "boxplot") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Now use  violin  instead of boxplot\n\n")
      }
      if (names(dots)[i] == "addtop")   # BarChart
        cat("\naddtop  is now a multiplicative factor instead of additive\n\n")

      if (names(dots)[i] == "count.levels") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Now use  count.labels  instead of count.levels\n\n")
      }
    }
  }
}

.format_date_labels <- function(dates, ts_unit) {
  # ts_unit is unknown if x is a time series to begin with
  ts_unit <- match.arg(ts_unit, c("years","quarters","months","weeks", 
                                  "days","days7", "unknown"))
  switch(ts_unit,
    years    = format(dates, "%Y"),
    quarters = paste0(format(dates, "%Y"), " ", quarters(dates)),
    months   = format(dates, "%b %Y"),
    weeks    = format(dates, "%d %b %Y"),
    days     = format(dates, "%d %b %Y"),
    days7    = format(dates, "%d %b %Y")
  )
}


.check.packages <- function() {

  required_pkgs <- c("tsibble", "fable", "fabletools")

  quiet_require <- function(pkg) {
    suppressMessages(
      suppressPackageStartupMessages(
        requireNamespace(pkg, quietly = TRUE)
      )
    )
  }

  missing <- required_pkgs[!vapply(required_pkgs, quiet_require, logical(1))]

  if (length(missing)) {
    stop("To use ts_source = \"fable\" to forecast\n\n",
         "Please install:\n",
         paste0("  install.packages(\"", missing, "\")", collapse = "\n"),
         call. = FALSE)
  }

  # Optional: pre-load quietly (so later :: calls don’t trigger messages)
  invisible(lapply(required_pkgs, quiet_require))

  invisible(TRUE)
}


.valid.params <- function(ts_method, ts_error, ts_trend, ts_seasons) {
  if (ts_method == "es") {
    if (!is.null(ts_error)) {
      if (!ts_error %in% c("A", "M")) {
        stop("\n------\n",
             'ts_error can only be "A" (additive) or "M" (multiplicative).\n\n',
             call. = FALSE)
      }
    }
    if (!is.null(ts_trend)) {
      if (!ts_trend %in% c("N", "A", "M", "Ad", "Md")) {
        stop("\n------\n",
             'Specify  ts_trend  only as "N" (none), "A" (additive),\n',
             '"M" (multiplicative), "Ad" (damped additive),\n',
             '"Md" (damped multiplicative).\n\n', call. = FALSE)
      }
    }
    if (!is.null(ts_seasons)) {
      if (!ts_seasons %in% c("N", "A", "M")) {
        stop("\n------\n",
             'Specify  ts_seasons  only as "N" (none), "A" (additive),\n',
             'or "M" (multiplicative).\n\n', call. = FALSE)
      }
    }
  }  # end es

  else if (ts_method == "lm") {
    if (!is.null(ts_trend)) {
      if (!ts_trend %in% c("N", "A")) {
        stop("\n------\n",
             'Specify  ts_trend  only as "N" (none) or "A" (additive),\n',
             'for linear regression models.\n\n', call. = FALSE)
      }
    }
    if (!is.null(ts_seasons)) {
      if (!ts_seasons %in% c("N", "A")) {
      stop("\n------\n",
           'Specify  ts_seasons  only as "N" (none) or "A" (additive),\n',
           'for linear regression models.\n\n', call. = FALSE)
      }
    }
  }  # end lm
}


.to_tsbl <- function(df, ts_unit) {
  # df: data frame where first column is the index (date/time) variable
  # ts_unit: one of "days", "weeks", "months", "quarters", "years"
  
  # Name of the first column (index variable)
  index.var <- names(df)[1]
  
  # Convert index to correct type
  if (ts_unit == "weeks") {
    df[[index.var]] <- tsibble::yearweek(df[[index.var]])
  } 
  else if (ts_unit == "months") {
    df[[index.var]] <- tsibble::yearmonth(df[[index.var]])
  } 
  else if (ts_unit == "quarters") {
    df[[index.var]] <- tsibble::yearquarter(df[[index.var]])
  } 
  else if (ts_unit == "years") {
    df[[index.var]] <- as.integer(format(df[[index.var]], "%Y"))
  }
  # "days" assumed to already be Date
  
  # Convert to tsibble using Base R as.symbol()
  tsibble::as_tsibble(df, index = as.symbol(index.var))
}


.generate_future_df <- function(train.df, ts_unit, ts_ahead, predictors.df) {
  index.var <- names(train.df)[1]
  last_index <- train.df[[index.var]][nrow(train.df)]
  
  # Generate base future index sequence
  if (ts_unit == "weeks") {
    future_index <- seq(last_index + 7, by=7, length.out = ts_ahead)
  } else if (ts_unit == "months") {
    future_index <- seq(as.Date(last_index)+31, by="1 month",
                        length.out=ts_ahead)
  } else if (ts_unit == "quarters") {
    future_index <- seq(as.Date(last_index)+92, by="3 months",
                        length.out=ts_ahead)
  } else if (ts_unit == "years") {
    future_index <- seq(as.Date(last_index)+365, by="1 year",
                        length.out=ts_ahead)
  } else {
    future_index <- seq(as.Date(last_index)+1, by=1, length.out=ts_ahead)
  }
  
  # Adjust predictors.df row count if needed
  if (nrow(predictors.df) < ts_ahead) {
    stop("\n------\n",
         "The `ts_new_x` data frame has fewer rows than `ts_ahead`.\n",
         "Please provide future values for all forecast periods.\n",
         call. = FALSE)
  }
  if (nrow(predictors.df) > ts_ahead) {
    predictors.df <- predictors.df[1:ts_ahead, , drop=FALSE]
  }
  
  # Combine with predictors
  df.future <- data.frame(index=future_index, predictors.df, check.names=FALSE)
  names(df.future)[1] <- index.var
  
  # Match index type to training data
  if (ts_unit == "weeks") {
    df.future[[index.var]] <- tsibble::yearweek(df.future[[index.var]])
  } else if (ts_unit == "months") {
    df.future[[index.var]] <- tsibble::yearmonth(df.future[[index.var]])
  } else if (ts_unit == "quarters") {
    df.future[[index.var]] <- tsibble::yearquarter(df.future[[index.var]])
  } else if (ts_unit == "years") {
    df.future[[index.var]] <- as.integer(format(df.future[[index.var]], "%Y"))
  }
  
  # return a tsibble so forecast(new_data=) accepts it
  tsibble::as_tsibble(df.future, index = as.symbol(index.var))
}

Transform <-
  function(data=d, quiet=getOption("quiet"), ...) {


  message("This function is deprecated, instead use base R  transform\n",
          "or just enter the transformation formula directly\n",
          "Example,  d$Xsq <- d$X^2\n",
          "  to create a squared version of Variable X in the d data frame\n")

  # save variable labels (NULL if no labels) 
  l <- attr(data, which="variable.labels")

  # transformations done here into vector e, e[1] the first trans, etc.
  e <- eval(substitute(list(...)), data, parent.frame())

  n.tvars <- length(e)
  n.obs <- nrow(data)

  if (!quiet) {
    dname <- deparse(substitute(data))

    cat("\n")
    cat("Number of variables of", dname, "to transform:", n.tvars, "\n")
    cat("Number of cases (rows) of ", dname, ": ", n.obs, "\n", sep="")

    trs.all <- deparse(substitute(list(...)))[[1]]
    trs.all <- substr(trs.all, 6, nchar(trs.all)-1)
    no.break <- FALSE
    if (grepl("factor", trs.all)) no.break <- TRUE
    if (grepl("cut", trs.all)) no.break <- TRUE
    if (!no.break) {
      trs <- as.vector(strsplit(trs.all, ",")[[1]])
      if (n.tvars > 1) for (i in 2:n.tvars) trs[i] <- substr(trs[i], 2, nchar(trs[i]))
    }
    else
      trs <- trs.all  # displayed later if only one transformation
  }

  # vector of positions of existing vars in data, NA if not existing
  inx <- match(names(e), names(data))

  if (!quiet) {
    cat("\n")
    cat("Transformation\n")
    for (i in 1:n.tvars) {
      if (!is.na(inx[i]))
        txt <- "rewrite existing"
      else
        txt <- "      create new"
      cat(txt, "variable: ", names(e)[i], "\n")
    }
  }

  # logical vector, TRUE if transformed var already exists, otherwise FALSE
  existing <- !is.na(inx)

  # inx[existing], e[existing] gives only positions of existing vars in data
  # corresponding FALSE values of existing are deleted
  # add existing var transformations to data
  if (any(existing))   # at least one existing var transformed
    data[inx[existing]] <- e[existing]

  # add new var transformations to data
  if (!all(existing))  # at least one new var created
    data <- do.call("data.frame", c(list(data), e[!existing]))
 
  # restore any variable labels
  if (!is.null(l)) attr(data, which="variable.labels") <- l

  return(data)

}

.plt.funnel <-
function (data.do, n.x_var, y.miss, cat.x, cat.y, run, date.ts, facet1.miss,
          y.unique, x.name=NULL, y.name=NULL, facet.name=NULL) {

  # T.type specifies type of Trellis plot
  T.type <- NULL

  if (data.do  &&  n.x_var == 1) {
    if (y.miss) {  # y missing
      if (!cat.x) {  # continuous x
        if (!run && !date.ts) {  # not a run chart or ts
        Trellis <- TRUE
        T.type <- "cont"
       }
       else {  # run chart
          if (facet1.miss) {  # single panel
            Trellis <- FALSE
          }
          else {  # facet1 present
            Trellis <- TRUE
            T.type <- "cont_cont"
          }
        }
      }  # end !cat.x
      else {  # single cat variable
        if (facet1.miss)
          Trellis <- FALSE
        else {  # facet1 activated
          Trellis <- TRUE
          T.type <- "dot"
        }
      }
    }  # end y.miss

    else {  # y present
      if (!cat.x) {
        if (!cat.y) {  # two continuous vars
          if (facet1.miss)
            Trellis <- FALSE
          else {  # facet1 is set
            Trellis <- TRUE
            T.type <- "cont_cont"
          }
        }  # end !cat.y
        else {  # y is cat
          if (y.unique) {  # Cleveland
            if (facet1.miss)
              Trellis <- FALSE
            else {
              cat("\n"); stop(call.=FALSE, "\n","------\n",
                "Currently, Trellis plots not available for dot plots \n",
                "with unique values for the categorical variable\n\n")
            }
          }
          else {
            if (!facet1.miss) {
              Trellis <- TRUE  # cat-cont
              T.type <- "cont_cat"
            }
            else
              Trellis <- FALSE
          }
        }
      }
      else  {  # x is cat
        if (!cat.y) {  # y is num
          if (facet1.miss) {
            Trellis <- FALSE
          }
          else {
            cat("\n"); stop(call.=FALSE, "\n------\n",
              "XY() requires a continuous  x  and a continuous  y.\n",
              "For a faceted distribution of the continuous  ", y.name,
              "  across\n  the levels of the categorical  ", x.name,
              ", use  X()  with a  by  variable:\n",
              "  X(", y.name, ", by=", x.name, ", facet=", facet.name,
              ")\n\n")
          }
        }
        else { # y is cat
          Trellis <- FALSE
        }
      }  # x is cat
    }  # y present
  }  # end: data.do  &&  n.x_var == 1

  else {  # for all analysis of stat transformed data
    if (n.x_var == 1) {
      if (!cat.x) {
        Trellis <- FALSE
      }
      else {  # is cat.x
        if (facet1.miss) {
          Trellis <- FALSE
        }
        else {
          Trellis <- TRUE
          T.type <- "dot"
        }
      }  # end is cat.x
    }  # end n.x_var=1

    else {  # multiple x's
      Trellis <- FALSE
    }
  }

  return(list(Trellis=Trellis, T.type=T.type))

}

.tt.formula <-
function (my_formula, y=NULL, data, ...) {  # y=NULL accepted but unused; absorbed to avoid error if caller passes y=

  # data frame existence check
  dname <- deparse(substitute(data))
  if (!exists(dname, envir=.GlobalEnv)) {
    if (dname == "d") 
        txtA <- ", the default data frame name, " else txtA <- " "
      txtB1 <- "So either create data frame by reading with the Read function, or\n"
      txtB2 <- "  specify the actual data frame with the parameter: data\n"
      txtB <- paste(txtB1, txtB2, sep="")
      cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Data frame ", dname, txtA, "does not exist\n\n", txtB, "\n")
  }

  nm <- all.vars(my_formula)  # names of vars in the model

  # formula shape check
  if (length(nm) < 2) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Formula must be of the form:  response ~ grouping\n\n",
        "You supplied: ", deparse(my_formula), "\n\n")
  }

  # Y existence check
  if (!(nm[1] %in% names(data))) { 
    if (dname == "d") {
      txt1 <- ", the default name \n\n"
      txt2 <- "So either make sure you are using the correct variable name, or\n"
      txt3 <- "  specify the actual data frame with the parameter: data\n"
      txt <- paste(txt1, txt2, txt3, sep="")
    }
    else txt <- " "
    cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Response variable ", nm[1], " does not exist ",
        "in the data frame ", dname, txt, "\n\n")
  }

  # Y numeric check
  if (!is.numeric(data[, nm[1]])) {
    gu <- unique(na.omit(data[,nm[1]]))  # do not consider NA's
    if (length(gu) == 2) 
      txt <- paste(nm[1],
         " has two unique values, a property of the grouping variable,\n",
         "  the second variable listed, after the tilde, ~\n\n",
         "Maybe you switched the order of the intended response variable\n",
         "  and grouping variable\n\n", sep="")
    else
      txt <- ""
    cat("\n"); stop(call.=FALSE, "\n","------\n",
    "The t-test for the mean difference is of the form\n\n",
    "  ttest(response_variable ~ grouping_variable)\n\n",
    "The response variable is numeric and the grouping variable\n",
    "  has exactly two unique values, one for each group\n\n", 
    "You specified ", nm[1], " as the response variable, the 1st variable listed\n\n",
    "The response variable must have only numeric values\n",
    "The first value of ", nm[1], " is ", na.omit(data[,nm[1]])[1],
    ", which is not numeric\n\n",
    txt, sep="")

  }

  # X existence check
  if (!(nm[2] %in% names(data))) { 
    if (dname == "d") {
      txt1 <- ", the default name \n\n"
      txt2 <- "So either make sure you are using the correct variable name, or\n"
      txt3 <- "  specify the actual data frame with the parameter: data\n"
      txt <- paste(txt1, txt2, txt3, sep="")
    }
    else txt <- " "
    cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Grouping variable ", nm[2], " does not exist ",
        "in the data frame ", dname, txt, "\n\n")
  }

  # X levels = 2 check
  gu <- unique(na.omit(data[,nm[2]]))  # do not consider NA's
  if (length(gu) != 2) {
    gu.out <- paste(gu, collapse=" ")
    cat("\n"); stop(call.=FALSE, "\n","------\n",
    "The grouping variable for this analysis: ", nm[2], "\n\n",
    "Values of the grouping variable: ", gu.out, "\n",
    "Number of unique values: ", length(gu), "\n",
    "The grouping variable must have exactly two unique values\n\n",
    "Use ANOVA to analyze the means of more than two groups\n\n")
  }

  # split Y into two separate vectors
  # drop unused factor levels so split() only produces the two intended groups
  grp <- droplevels(as.factor(data[,nm[2]]))
  vectors <- split(data[,nm[1]], grp)

  # do the analysis  
  return(list(x=vectors[[1]], y=vectors[[2]], Ynm=nm[1],
         Xnm=nm[2], X1nm=names(vectors)[1], X2nm=names(vectors)[2]))

}

.plt.txt <-
function(x, y, stat, object, cat.x, cat.y, date.var,
       xlab, ylab, fit, n.by, mse.ln, mse.nl, b0, b1, Rsq,
       fit_new, y.new, by.cat,
       center_line, run, show_runs, prop, size, radius, digits_d,
       fun_call=NULL) {

  if (n.by == 0) n.by <- 1
  if (date.var) center_line <- "off"

  # x and y come across here in their natural state, within each data frame
  # a time series has dates for x and numeric for y, factors are factors, etc

  bubble1 <- ifelse (length(unique(y[,1])) == 1, TRUE, FALSE)  # 1-D bubble plot

  unique.x <- ifelse (length(unique(x[,1])) == length(x[,1]), TRUE, FALSE)
  unique.y <- ifelse (length(unique(y[,1])) == length(y[,1]), TRUE, FALSE)

  # all processing in terms of numeric variables
  # convert factors to numeric, save levels, so x and y are always numeric
  # x will always be a matrix
  x.lvl <- NULL; y.lvl <- NULL  # if remain null, then not factors

  # process x
  nm.x <- names(x)
  if (is.factor(x[,1])) {
    x.lvl <- levels(x[,1])
    x <- as.matrix(as.integer(x[,1]))
  }
  else if (!date.var) {
    x <- as.matrix(x)
    colnames(x) <- nm.x
  }

  # process y
  nm.y <- names(y)
  if (is.factor(y[,1])) {
    y.lvl <- levels(y[,1])
    y <- as.matrix(as.integer(y[,1]))

  }
  else if (!date.var) {
    y <- as.matrix(y)
    colnames(y) <- nm.y
  }

  # dimensions
  n.xcol <- ncol(x)
  n.ycol <- ncol(y)
  n_col <- max(n.xcol, n.ycol)
  nrows <- nrow(x)

  if (date.var) {
    x.val <- x[,1]
    x <- matrix(x.val, ncol=1)
  }

  if (is.null(x.lvl) && !is.null(y.lvl) && unique.y ||
      is.null(y.lvl) && !is.null(x.lvl) && unique.x) {
    cleveland <- TRUE
  }
  else
    cleveland <- FALSE

  gl <- .getlabels(xlab, ylab)  # this redoes if already a plot
  x.name <- gl$xn; x.lbl <- gl$xl; x.lab <- gl$xb
  y.name <- gl$yn; y.lbl <- gl$yl; y.lab <- gl$yb
  #by.name <- getOption("byname")

  # decimal digits
  if (is.null(digits_d)) {  # cat vars are only integers
    if (!cat.y) digits_d <- .max.dd(y[,1]) + 1
    else if (!cat.x) digits_d <- .max.dd(x[,1]) + 1
    else digits_d <- 2  # both categorical: no continuous values to inspect
  }
  if (digits_d < 3) digits_d <- 3
  options(digits_d=digits_d)

  size.pt <- ifelse (is.null(size), 1, size)  # dummy non-zero value

  if (n_col > 1) center_line <- "off"   # no center_line for multiple plots

  m.y <- mean(y[,1], na.rm=TRUE)

  if (center_line == "mean") {
    lbl <- " mean"
    lbl.cat <- "mean:"
  }
  else if (center_line == "median") {
    m.y <- median(y[,1], na.rm=TRUE)
    lbl <- " medn"
    lbl.cat <- "median:"
  }
  else if (center_line == "off") {
    m.y <- median(y[,1], na.rm=TRUE)  # run analysis still uses median
    lbl <- ""
    lbl.cat <- "median:"
  }
  else if (center_line == "zero") {
    m.y <- 0
    lbl <- ""
    lbl.cat <- "zero:"
  }


  # -----------
  # text output
  # -----------

  if (getOption("suggest")) {
    # function call, with last ) removed for suggestions
    fncl <- .fun_call.deparse(fun_call)  # class call to class character
    fncl <- gsub(")$", "", fncl)  # get function call less closing )
    fncl <- gsub(" = ", "=", fncl)
  }

  if (stat == "data") {
      txsug <- ""

    if (date.var) {
      if (getOption("suggest")) {
        txsug <- "\n>>> Suggestions  or  enter: style(suggest=FALSE)"

        if (x.name != y.name)
          fc <- paste("XY(", x.name, ", ", y.name, sep="")
        else
          fc <- paste("XY(", x.name, sep="")

        if (!grepl("ts_ahead", fncl)) {
          txt <- ", ts_ahead=4)"
          cmnt <- "  # exponential smoothing forecast 4 time units"
          txsug <- paste(txsug, "\n", fc, txt, cmnt, sep="")
        }

        if (!grepl("ts_unit", fncl)) {
          txt <- ", ts_unit=\"years\")  # aggregate time by yearly sum"
          txsug <- paste(txsug, "\n", fc, txt, sep="")
        }

        if (!grepl("ts_agg", fncl)) {
          txt <- ", ts_unit=\"years\", ts_agg=\"mean\")"
          cmnt <- "  # aggregate by yearly mean"
          txsug <- paste(txsug, "\n", fc, txt, cmnt, sep="")
        }

        if (grepl("ts_ahead", fncl)  &&  !grepl("ts_seasons", fncl)) {
          txt <- ", ts_ahead=4, ts_seasons=FALSE)"
          cmnt <- "  # turn off exponential smoothing seasonal effect"
          txsug <- paste(txsug, "\n", fc, txt, cmnt, sep="")
        }
      }
    }  # end date.var


    if (object == "bubble") {
      if (getOption("suggest")) {
        txsug <- "\n>>> Suggestions  or  enter: style(suggest=FALSE)"
        fc <- ""
        smaller <- as.character(.fmt(radius / 1.5, 2))
        larger <- as.character(.fmt(radius * 1.5, 2))
        if (!grepl("bubble", fncl)) {
          if (!is.null(radius)) {
            if (radius >= 0.22) {
              fc <- paste(fc, ", radius=", smaller, sep="")
              txt <- "# smaller bubbles"
            }
            else {
              fc <- paste(fc, ", radius=", larger, sep="")
              txt <- "# larger bubbles"
            }
            if (nzchar(fc)) {
              fc <- paste(fncl, fc, ") ", sep="")
              fc <- paste(fc, txt, sep="")
              txsug <- paste(txsug, "\n", fc, sep="")
#               class(txsug) <- "out"
#               return(list(out_suggest=txsug))
            }
          }
        }
      }  # if suggest
    }  # end bubble

    if (object == "both") {  # line, run chart (object is "both")

      if (getOption("suggest")) {
        if (txsug == "")
          txsug <- "\n>>> Suggestions  or  enter: style(suggest=FALSE)"

        fc <- ""
        if (!grepl("size", fncl)  &&  size.pt > 0)
          fc <- paste(fc, ", size=0", sep="")
        if (nzchar(fc)) {
          fc <- gsub(" = ", "=", fc)
          fc <- paste(fncl, fc, ")   # just line segments, no points ")
          txsug <- paste(txsug, "\n", fc, sep="")
        }

        fc <- ""
        if (!grepl("lwd", fncl))
          fc <- paste(fc, ", lwd=0", sep="")
        if (nzchar(fc)) {
          fc <- gsub(" = ", "=", fc)
          if (size.pt > 0)
            txt <- "just points, no line segments"
          else {
            fc <- paste(fc, ", fill=\"on\"", sep="")
            txt <- "just area"
          }
          fc <- paste(fncl, fc, ")   # ", txt, sep="")
          txsug <- paste(txsug, "\n", fc, sep="")
        }

        fc <- ""
        if (!grepl("area_fill", fncl)  &&  (!grepl("stack", fncl)))
          fc <- paste(fc, ", area_fill=\"on\"", sep="")
        if (nzchar(fc)) {
          fc <- gsub(" = ", "=", fc)
          fc <- paste(fncl, fc, ")   # default color fill", sep="")
          txsug <- paste(txsug, "\n", fc, sep="")
        }

        txsug <- .rm.arg.2(" x=", txsug)
        txsug <- .rm.arg.2("(x=", txsug)
        txsug <- .rm.arg.2(" y=", txsug)

        class(txsug) <- "out"
        output <- list(out_suggest=txsug)
        class(output) <- "out_all"
        print(output)
      }  # end getOption suggest

      # analyze runs if a singly y
      if (run && n.ycol==1) {

        txss <- ""
        ssstuff <- .ss.numeric(y, digits_d=digits_d, x.name="*NONE*",
                               brief=TRUE)
        txss <- ssstuff$tx
        class(txss) <- "out"
        output <- list(out_ss=txss)
        class(output) <- "out_all"
        print(output)

        .dash(12); cat("Run Analysis\n"); .dash(12)
        run <- integer(length=0)  # length of ith run in run[i]
        n.runs <- 1  # total number of runs
        run[n.runs] <- 1
        line.out <- "    1"
        for (i in seq(2, nrow(y))) {  # find the runs
          if (y[i] != m.y) {  # throw out values that equal m.y
            if (sign(y[i]-m.y) != sign(y[i-1]-m.y)) {  # new run
              if (show_runs) {
                if (i == 2) cat("\n")
                buf <- ifelse (n.runs < 10,  "  ", " ")
                  if (run[n.runs] > 1)  # print only if run of size 2 or more
                    cat("size=", run[n.runs], "  Run", buf, n.runs, ":",
                      line.out, "\n", sep="")
              }
              line.out <- ""
              n.runs <- n.runs + 1
              run[n.runs] <- 0
            }
          }
          run[n.runs] <- run[n.runs] + 1
          buf <- ifelse (i < 10, "  ", " ")
          line.out <- paste(line.out, buf, i)
        }  # end find the runs
        if (run[n.runs] > 1)  # print only if run has at least 2 elements
          if (show_runs)
            cat("size=", run[n.runs], "  Run", buf, n.runs, ":", line.out,
                "\n", sep="")
        eq.ctr <- which(y==m.y)
        cat("\nTotal number of runs:", n.runs, "\n")
        txt <- "Total number of values that do not equal the "
        cat(txt, lbl.cat, " ", length(y)-length(eq.ctr), "\n", sep="")
        if (length(eq.ctr) != 0) {
          if (show_runs) {
            cat("\nValues ignored that equal the", lbl.cat, "\n")
            for (i in seq_along(eq.ctr))
              cat("    #", eq.ctr[i], " ", y[eq.ctr[i]], sep="", "\n")
            cat("Total number of values ignored:", length(eq.ctr), "\n")
          }
        }
        else {
          cat("Total number of values ignored that equal the", lbl.cat,
              length(eq.ctr), "\n")
        }

      }  # end analyze runs

      return()  # already did print(output) and cat()
    }  # end object is both


    # ---------------------------
    # contcont 2-way scatter plot
    # ---------------------------

    if (!cat.x  &&  !cat.y  &&
      object %in% c("point", "both")  && !run  && !date.var) {

      # suggestions
      # -----------
      txsug <- ""
      if (getOption("suggest")) {
        txsug <- "\n>>> Suggestions  or  enter: style(suggest=FALSE)"

        fc <- paste("XY(", x.name, ", ", y.name, sep="")

        if (!grepl("enhance", fncl)) {
          txt <- ", enhance=TRUE)  # many options"
          txsug <- paste(txsug, "\n", fc, txt, sep="")
        }

        if (runif(1) > 0.5) {
          if (!grepl("fill", fncl)) {
            txt <- ", fill=\"skyblue\")  # interior fill color of points"
            txsug <- paste(txsug, "\n", fc, txt, sep="")
          }
        }
        else {
          if (!grepl("color", fncl)) {
            txt <- ", color=\"red\")  # exterior edge color of points"
            txsug <- paste(txsug, "\n", fc, txt, sep="")
          }
        }

        if (!grepl("fit", fncl)) {
          txt <- ", fit=\"lm\", fit_se=c(.90,.99))  # fit line, stnd errors"
          txsug <- paste(txsug, "\n", fc, txt, sep="")
        }

        if (runif(1) > 0.5) {
          if (!grepl("out_cut", fncl)) {
            txt <- ", out_cut=.10)  # label top 10% from center as outliers"
            txsug <- paste(txsug, "\n", fc, txt, sep="")
          }
        }
        else {
          if (!grepl("MD_cut", fncl)) {
            txt <- ", MD_cut=6)"
            cmt <- "  # Mahalanobis distance from center > 6 is an outlier"
            txsug <- paste(txsug, "\n", fc, txt, cmt, sep="")
          }
        }

        if (grepl("by=", fncl)  &&  !grepl("shape", fncl)) {
          fc <- paste(fncl, ", shape=\"diamond\")", sep="")
          fc <- .rm.arg.2("(x=", fc)
          fc <- .rm.arg.2(" y=", fc)
          cmt <- "  # diamond for points"
          txsug <- paste(txsug, "\n", fc, cmt, sep="")
        }

#        if (!grepl("ellipse", fncl)) {
#          txt <- ", ellipse=0.95, add=\"means\")  # 0.95 ellipse with means"
#          txsug <- paste(txsug, "\n", fc, txt, sep="")
#        }

#         if (!grepl("smooth", fncl)) {
#           txt <- ", shape=\"diamond\")  # change plot character"
#           txsug <- paste(txsug, "\n", fc, txt, sep="")
#         }
      }  # end suggest

      blank <- ""
      class(blank) <- "out"  # a blank line when needed

      txreg <- ""
      txcor <- ""

      # output cor info if no fit line or lm fit only
      # ---------------------------------------------

      # Linear correlation for a linear analysis
      if (fit %in% c("off", "lm") && !date.var) {

        for (i in seq_len(n_col)) {
          class(txsug) <- "out"

          #  no output correlation if a by variable
          if (n.by == 1) {
            if (n.xcol > 1) {
              x.nm <- colnames(x)[i]
              x.nm <- paste("\nVariable:", x.nm, "with",  colnames(y)[1])
              class(x.nm) <- "out"
              if (exists("output"))
                output <- c(output, list(out_name=x.nm))
              else
                output <- list(out_name=x.nm)
              options(xname = colnames(x)[i])
              stuff <- .cr.main(x[,i], y[,1], brief=TRUE)
            }
            else {
              options(yname = colnames(y)[i])
              stuff <- .cr.main(x[,1], y[,i], brief=TRUE)
            }

            txbck <- stuff$txb
            txdsc <- stuff$txd
            txinf <- stuff$txi

            # txcor contains the basic correlational text output
            txcor <- c(txbck, txdsc, " ", txinf, " ")
          }  # end n.by is 1

        }  # end for i through n_col
      }  # end output cor info



      # output mse.ln, triggered by a non-lm fit line
      # ------------------------------------------

      # Create a y.new data frame with formatted numbers
      if (!is.null(y.new)) {
        if (.is.integer(fit_new))
          x1 <- format(fit_new, trim=TRUE)
        else
          x1 <- format(fit_new, nsmall=digits_d, trim=TRUE)
        x2 <- format(y.new, nsmall=digits_d, trim=TRUE)
        mx.x <- max(x[,1], na.rm=TRUE)
        txt <- "Prediction from beyond the data range"
        x3 <- ifelse(fit_new > mx.x, txt, " ")
        tx <- data.frame(x1,x2,x3)
        names(tx) <- c(nm.x, paste(nm.y, "_Fit", sep=""), " ")
        dfnew <- tx
      }
      else
       dfnew <- NULL

      if (!is.null(mse.ln)  &&  n.xcol == 1) {  # mse.ln not reported for all

        if (fit == "lm") {
          op1 <- ""
          op2 <- ""
        }

        if (fit == "quad") {
          op1 <- "sqrt()"
          op2 <- "square"

        }
        if (fit == "power") {
          op1 <- "the root of the\n   reciprocal of the power"
          op2 <- "of the power"
        }

        if (fit == "exp") {
          op1 <- "log()"
          op2 <- "exp()"
        }

        if (fit == "log") {
          op1 <- "exp()"
          op2 <- "log()"
        }

        if (fit %in% c("quad", "power", "exp", "log")) {
          msg <- paste("Regressed linearized data of transformed",
                      "data values of", nm.y, "with", op1, "\n")
        }
        else
          msg <- ""

        tx <- character(length=n.by)
        for (i in seq_len(n.by)) {
          by.name <- getOption("byname")
          if (i > 1) msg <- ""  # display title only at beginning
          if (n.by > 1) {
            if (fit %in% c("quad", "power", "exp", "log")) {
              msg <- paste("Regressed linearized data of transformed",
                          "data values of", nm.y, "with", op1, "\n")
            }
            tx[i] <- paste(msg, by.name, ": ", by.cat[i], "  ", sep="")
          }
          else
            tx[i] <- paste(msg, by.cat[i], "  ", sep="")
          mse.out <- .fmt_cm(mse.ln[i], d=digits_d)
          b0.pn <- .fmt(b0[i], digits_d)
          b1.pn <- .fmt(b1[i], digits_d)
          Rsq.pn <- .fmt(Rsq[i], 3)
          md.type <- ifelse (fit=="loess", "Loess", "Linear")
          if (!is.na(b1[i])) {  # linear function
            tx[i] <- paste(tx[i],
              "Line: b0 = ", b0.pn, "    b1 = ", b1.pn,
              "\n  ", md.type,  " Model MSE = ", mse.out, sep="")
              rsqu <- ifelse (is.na(Rsq[i]), "", paste("   Rsq =", Rsq.pn))
              tx[i] <- paste(tx[i], rsqu, "\n", sep="")
          }
          else {
            tx[i] <- paste(tx[i],
              " ", md.type, " Model MSE = ", mse.out, "\n", sep="")
          }

          if (!(fit %in% c("loess", "lm", "null"))) {
            msg <- paste("\nFit to the data with back transform",
                         op2, "of linear regression model")
            mse.out <- .fmt_pn(mse.nl[i], d=digits_d)
            tx[i] <- paste(tx[i], msg, "\n", "Model MSE =", mse.out, "\n\n")
          }

          # kludge, if removing outliers reg line info not correct,remove
          if (b0[i]==0 && b1[i]==0 && mse.ln[i]==0) tx <- ""
        }  # end for n.by

        txreg <- tx
      }  # end !is.null(mse.ln)

      class(txsug) <- "out"
      class(txcor) <- "out"
      class(txreg) <- "out"
      return(list(tipe="contcont", out_suggest=txsug,
                  out_stats=txcor, out_y.new=dfnew, out_reg=txreg))

    }  # end traditional 2-way scatter plot



      # --------------------------------
      # categorical var with numeric var for means plot or bubble-1D plot
      # now called from X(), not a XY() procedure
      # need to rework suggestions for X(x=cont, by=cat)

      else if ((cat.x && !cat.y && !unique.x) ||
               (!cat.x && cat.y && !unique.y)) {
        if (!bubble1) {  # means plot

          txsug <- ""
          if (getOption("suggest")) {
            # txsug <- "\n>>> Suggestions  or  enter: style(suggest=FALSE)"
            #
            # fc <- ""
            # if (!grepl("means", fncl))
            #   fc <- paste(fc, ", means=FALSE", sep="")
            # if (nzchar(fc)) {
            #   fc <- paste(fncl, fc, ") ", sep="")
            #   txsug <- paste(txsug, "\n", fc, "  # do not plot means", sep="")
            # }
            #
            # fc <- ""
            # if (!grepl("stat", fncl)) {
            #   fc <- paste(fc, ", stat=\"mean\"", sep="")
            #   if (grepl("means", fncl)) fncl <- .rm.arg.l("means", fncl)
            # }
            # if (nzchar(fc)) {
            #   fc <- paste(fncl, fc, ") ", sep="")
            #   txsug <- paste(txsug, "\n", fc, "  # only plot means", sep="")
            # }
            #
            # if (cat.x) {
            #   rv <- y.name
            #   pv <- x.name
            #   n.lvl <- length(unique(x))
            # }
            # else {
            #   rv <- x.name
            #   pv <- y.name
            #   n.lvl <- length(unique(y))
            # }
            # fnct <- ifelse(n.lvl == 2, "ttest", "ANOVA")
            # fc <- paste("\n", fnct, "(", rv, " ~ ", pv,
            #             ")  # inferential analysis", sep="")
            # txsug <- paste(txsug, fc, sep="")
            #
            # txsug <- .rm.arg.2(" x=", txsug)
            # txsug <- .rm.arg.2("(x=", txsug)
            # txsug <- .rm.arg.2(" y=", txsug)
          }  # end suggest

          # get stats
          if (cat.x && !cat.y) {
            if (!is.null(x.lvl))  # convert back to a factor if was one
              x.by <- factor(x, levels=1:length(x.lvl), labels=x.lvl)
            else
              x.by <- x
            options(yname = x.name)  # reverse order x and y for .ss.numeric()
            options(xname = y.name)
           stats <- .ss.numeric(y, by=x.by, digits_d=digits_d,
                                 brief=TRUE, y.name=x.name)
          }
          else if (!cat.x && cat.y) {
            if (!is.null(y.lvl))  # convert back to a factor if was one
              y.by <- factor(y, levels=1:length(y.lvl), labels=y.lvl)
            else
              y.by <- y
            stats <- .ss.numeric(x, by=y.by, digits_d=digits_d, brief=TRUE)
          }

          class(stats$tx) <- "out"
          return(list(tipe="catcont", out_stats=stats$tx, out_suggest=txsug))
        }  # !bubble_1

        else {  # 1-D bubble plot of a factor var, y just a constant

          txsug <- ""
          if (getOption("suggest")) {
            # txsug <- "\n>>> Suggestions  or  enter: style(suggest=FALSE)"
            #
            # fc <- ""
            # if (!grepl("color_low", fncl))
            #   fc <- paste(fc, ", color_low=\"lemonchiffon2\"", sep="")
            # if (!grepl("color_hi", fncl))
            #   fc <- paste(fc, ", color_hi=\"maroon3\"", sep="")
            # if (nzchar(fc)) {
            #   fc <- paste(fncl, fc, ") ", sep="")
            #   txsug <- paste(txsug, "\n", fc, sep="")
            # }
            #
            # fc <- paste("XY(", x.name,
            #        ", stat=\"count\")  # scatter plot of counts", sep="")
            # txsug <- paste(txsug, "\n", fc, sep="")
            #
            # txsug <- .rm.arg.2(" x=", txsug)
            # txsug <- .rm.arg.2("(x=", txsug)
          }  # end suggest

          if (!is.null(x.lvl))
            x.by <- factor(x, levels=1:length(x.lvl), labels=x.lvl)
          else
            x.by <- factor(x)

          stats <- .ss.factor(x.by, by=NULL, brief=TRUE, digits_d=NULL,
                              x.name, y.name, x.lbl, y.lbl)
          txttl <- stats$title
          counts <- stats$count
          chi <- stats$chi

          txsug <- " "
          class(txsug) <- "out"
          class(txttl) <- "out"
          class(counts) <- "out"
          class(chi) <- "out"

          output <- list(out_suggest=txsug, out_title=txttl,
                         out_counts=counts, out_chi=chi)
          class(output) <- "out_all"
          print(output)
        }  # else
      }  # end catcont


      # Cleveland dot plot
      else if (cleveland) {  # Rsq is from Chart, type="dot"
        txsug <- ""
        if (getOption("suggest")) {
          txsug <- "\n>>> Suggestions  or  enter: style(suggest=FALSE)"
          fc <- ""
          if (!grepl("sort", fncl)) {
            cmt <- "  # do not sort y-axis variable by x-axis variable"
            fc <- paste(fncl, ", sort=\"0\"", ")", cmt, "\n", sep="")
          }
          if (!grepl("segments_y", fncl)) {
            cmt <- "  # drop the line segments"
            fc <- paste(fc, fncl, ", segments_y=FALSE", ")", cmt, "\n", sep="")
          }
          if (!grepl("fill", fncl)) {
            cmt <- "  # red point interiors"
            fc <- paste(fc, fncl, ", fill=\"red\"", ")", cmt, "\n", sep="")
          }
          if (nzchar(fc)) {
            fncl <- .fun_call.deparse(fun_call)
            fncl <- gsub(")$", "", fncl)  # get function call less closing
            fncl <- gsub(" = ", "=", fncl)
            txsug <- paste(txsug, "\n", fc, sep="")

            txsug <- .rm.arg.2(" x=", txsug)
            txsug <- .rm.arg.2(" y=", txsug)
            txsug <- .rm.arg.2("(x=", txsug)
          }

          class(txsug) <- "out"
        }  # end suggest

        if (!is.null(y.lvl))
          # convert back to a factor if was one originally
          y.by <- factor(y, levels=1:length(y.lvl), labels=y.lvl)
        else
          y.by <- y

        tx <- ""
        for (i in seq_len(n.xcol)) {
          stats <- .ss.numeric(x[,i], digits_d=digits_d, brief=TRUE)
          tx[length(tx)+1] <- paste("---", colnames(x)[i], "---")
          for (j in 2:length(stats$tx)) tx[length(tx)+1] <- stats$tx[j]
          if (i < n.xcol) {
            tx[length(tx)+1] <- ""
            tx[length(tx)+1] <- ""
          }
        }
        txstats <- tx
        txotl <- ""
        txotl <- .bx.stats(x)$txotl
        if (txotl[1] == "") txotl <- "No (Box plot) outliers"

        class(txsug) <- "out"
        class(txstats) <- "out"
        class(txotl) <- "out"

        return(list(out_suggest=txsug, out_stats=txstats, out_outliers=txotl))
      }  # end Cleveland


      # ------------------------
      # categorical x and y vars
      # ------------------------

      else if (cat.x && cat.y) {
        txsug <- ""
        if (getOption("suggest")) {
          txsug <- "\n>>> Suggestions  or  enter: style(suggest=FALSE)"

          fc <- ""
          if (!grepl("size_cut", fncl))
            fc <- paste(fc, ", size_cut=FALSE", sep="")
          if (nzchar(fc)) {
            fncl <- .fun_call.deparse(fun_call)
            fncl <- gsub(")$", "", fncl)  # get function call less closing )
            fncl <- gsub(" = ", "=", fncl)
            fc <- paste(fncl, fc, ") ", sep="")
            txsug <- paste(txsug, "\n", fc, sep="")
          }

          fc <- ""
          if (!grepl("trans", fncl))
            fc <- paste(fc, ", trans=.8", sep="")
          if (!grepl("bg", fncl))
            fc <- paste(fc, ", bg=\"off\"", sep="")
          if (!grepl("grid", fncl))
            fc <- paste(fc, ", grid=\"off\"", sep="")
          if (nzchar(fc)) {
            fncl <- .fun_call.deparse(fun_call)
            fncl <- gsub(")$", "", fncl)  # get function call less closing )
            fncl <- gsub(" = ", "=", fncl)
            fc <- paste(fncl, fc, ") ", sep="")
            fc <- sub(",,", ",", fc, fixed=TRUE)  # hack
            txsug <- paste(txsug, "\n", fc, sep="")

          }

          fc <- paste("\nSummaryStats(", x.name, ", ", y.name,
                      ")  # or ss", sep="")

          txsug <- paste(txsug, fc, sep="")
          txsug <- .rm.arg.2(" x=", txsug)
          txsug <- .rm.arg.2("(x=", txsug)
          txsug <- .rm.arg.2(" y=", txsug)

        }

        if (!is.null(x.lvl))
          x.fac <- factor(x, levels=1:length(x.lvl), labels=x.lvl)
        else
          x.fac <- x[,1]
        if (!is.null(y.lvl))
          y.fac <- factor(y, levels=1:length(y.lvl), labels=y.lvl)
        else
          y.fac <- y[,1]

        stats <- .ss.factor(x.fac, y.fac, digits_d=3, brief=FALSE,
                            x.name, y.name, x.lbl, y.lbl)

        txttl <- stats$txttl
        txfrq <- stats$txfrq
        txXV <- stats$txXV

        class(txsug) <- "out"
        class(txttl) <- "out"
        class(txfrq) <- "out"
        class(txXV) <- "out"
        return(list(tipe="catcat",
                    out_title=txttl, out_suggest=txsug,
                    out_stats=txfrq, out_XV=txXV))
      }  # end catcat
#   }  # end object != "line"  &&  !run
  }  # end stat is data


  else {  # stat not data
    if (cat.x  &&  !cat.y  &&  object %in% c("point", "bubble")) {
      txsug <- ""
      if (getOption("suggest")) {
        txsug <- "\n>>> Suggestions  or  enter: style(suggest=FALSE)"

        fc <- ""
        if (!grepl("segments_x", fncl))
          fc <- paste(fc, ", segments_x=FALSE", sep="")
        if (nzchar(fc)) {
          fc <- paste(fncl, fc, ")  # just points", sep="")
          txsug <- paste(txsug, "\n", fc, sep="")
        }

        txsug <- .rm.arg.2(" x=", txsug)
        txsug <- .rm.arg.2("(x=", txsug)
        txsug <- .rm.arg.2(" y=", txsug)

        class(txsug) <- "out"
        if (nzchar(txsug))
          return(list(out_suggest=txsug))
      }  # end option suggest
    }
  }  # end stat not data
}

# extract dates and y-values from a ts object
tsExtract <- function(y.ts, x.name=NULL) {

  # function to convert output of time() to as.Date()
  frac.yr_to.date <- function(date.num, freq) {
    year <- floor(date.num)  # extract the year
    frac <- date.num - year  # fractional part

    leap.yr <-  # divisible by 4 but not 100, or divisible by 400 
      (year %% 4 == 0 & year %% 100 != 0) | (year %% 400 == 0)
    days.in.yr <- ifelse(leap.yr, 366, 365)
    
    if (freq %in% c(7, 365, 366)) {  # Daily data
      day.of.yr <- round(frac * days.in.yr) + 1
      return(as.Date(day.of.yr - 1, origin = paste0(year, "-01-01")))
    }
    if (freq == 52) {  # Weekly data
      day.of.yr <- round(frac * days.in.yr / 7) * 7 + 1
      return(as.Date(day.of.yr - 1, origin = paste0(year, "-01-01")))
    }
    if (freq == 12) {  # Monthly data, ts() does not account for uneven months
      month <- round(frac * 12) + 1
      if (month > 12) {
        month <- 1
        year <- year + 1
      }
      return(as.Date(paste0(year, "-", sprintf("%02d", month), "-01")))
    }
    if (freq == 4) {  # Quarterly data
      quarter <- floor(frac * 4) + 1
      month <- c(1, 4, 7, 10)[quarter]
      return(as.Date(paste0(year, "-", sprintf("%02d", month), "-01")))
    }
    if (freq == 1) {  # Yearly data
      return(as.Date(paste0(year, "-01-01")))
    }

    cat("\n"); stop(call.=FALSE, "\n------\n",
      "Unsupported frequency. Use one of the following frequencies:\n",
      "365(daily), 52(weekly), 12(monthly), 4(quarterly), or 1(yearly).\n\n")
  }  # end frac.yr_to.date


  # x: assign ts date values based on function frac.yr_to.date()
  freq <- frequency(y.ts)
  date.num <- as.numeric(time(y.ts))  # time() creates vector of ts times
  x.dates <- lapply(date.num, frac.yr_to.date, freq)
  x.dates <- as.Date(unlist(x.dates))  # Date vector

  # y: assign ts values, one column for each ts column
  # different data structures for univariate ts and multivariate ts
  nc <- ifelse(is.matrix(y.ts), ncol(y.ts), 1)
  if (nc == 1) {
    y <- as.numeric(y.ts)       # plain numeric vector
    y.name <- getOption("yname")
  }
  else {  # multivariate: return named data frame
    y <- as.numeric(y.ts[, 1])
    for (i in 2:nc) y <- cbind(y, as.numeric(y.ts[, i]))
    y <- data.frame(y)
    names(y) <- colnames(y.ts)
    y.name <- getOption("yname")
  }

  return(list(x.dates=x.dates, y=y, y.name=y.name))
}

rescale <-
function(x, data=d, kind="z", digits_d=3) {

  # let deprecated mydata work as default
  dfs <- .getdfs() 
  mydata.ok <- FALSE
  if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
    d <- mydata 
    mydata.ok <- TRUE
  }

  # get variable name before potential call of data$x
  x.name <- deparse(substitute(x))  # could be a vars list
  options(xname = x.name)

  data.null <- ifelse (is.null(data), TRUE, FALSE) 

  # let deprecated mydata work as default
  dfs <- .getdfs() 
  mydata.ok <- FALSE
  if ("mydata" %in% dfs  &&  !("d" %in% dfs)) {
    d <- mydata
    df.name <- "mydata"
    mydata.ok <- TRUE
    options(dname = df.name)
  }
  if (!mydata.ok) {
    df.name <- deparse(substitute(data))  # get name of data table
    options(dname = df.name)
  }
  
  x.in.df <- FALSE
  if (!data.null)
    if (exists(df.name, where=.GlobalEnv, inherits=FALSE))
      if (exists(x.name, where=data)) x.in.df <- TRUE
 
  # if a tibble convert to data frame
  if (df.name %in% ls(name=.GlobalEnv)) {  # tibble to df
   if (any(grepl("tbl", class(data), fixed=TRUE))) {
      data <- data.frame(data)
   }
  }


  # x not in global env, in df, specify data= forces to data frame
  if ((!exists(x.name, where=.GlobalEnv) && !data.null) || x.in.df) {
    .nodf(df.name)  # check to see if data frame container exists     
    .xcheck(x.name, df.name, names(data))  # var in df?, vars lists not checked
    all.vars <- as.list(seq_along(data))  # even if only a single var
    names(all.vars) <- names(data)  # all data in data frame
    ind <- eval(substitute(x), envir=all.vars)  # col num selected vars
    if (!("list" %in% class(data))) {
      x.call <- data[, ind]
      if (length(ind) == 1) {  # x is 1 var
        data <- data.frame(data, stringsAsFactors=TRUE)
        names(data) <- x.name
       }
    }
  }
  else  # x a vector, not in a data frame
    x.call <- x


  if (kind == "z")  {
    x.call <- round(scale(x.call, center=TRUE, scale=TRUE), digits_d)
  }

  else if (kind == "center")  {
    x.call <- round(scale(x.call, center=TRUE, scale=FALSE), digits_d)
  }
  
  else if (kind == "0to1") {
    mn.x <- min(x.call, na.rm=TRUE)
    mx.x <- max(x.call, na.rm=TRUE)
    x.call <- round((x.call - mn.x) / (mx.x - mn.x), digits_d)
  }

  else if (kind == "robust") {
    md.x <- median(x.call, na.rm=TRUE)
    IQR.x <- IQR(x.call, na.rm=TRUE)
    x.call <- round((x.call - md.x) / IQR.x, digits_d)
  }

  return(as.vector(x.call))

}

interact <-
function(app) {

# Thanks to
#   Dean Attali at https://deanattali.com/2015/04/21/r-package-shiny-app/

  if (!missing(app)) {
    app <- tolower(app)
    if (app == "barchart") app <- "BarChart"
    if (app == "bc") app <- "BarChart"
    if (grepl("bar", app)) app <- "BarChart"
    if (app == "histogram") app <- "Histogram"
    if (app == "hs") app <- "Histogram"
    if (grepl("hist", app)) app <- "Histogram"
    if (app == "scatterplot") app <- "ScatterPlot"
    if (app == "plot") app <- "ScatterPlot"
  }

  # locate all shiny app examples that exist, as folders in shiny_apps
# validApps <- list.files(system.file("shiny_apps", package="lessR"))
  validApps <- c("BarChart", "Histogram", "ScatterPlot")
  validAppsMsg <-
    paste0("Valid names (enclose in quotes):\n '",
           paste(validApps, collapse = "', '"), "'")

  # if an invalid example is given, throw an error
  if (missing(app) || !nzchar(app) || !app %in% validApps) {
    message(
      "Run  interact()  with a one of the following app names, such as: ",
      "interact(\"BarChart\")\n\n",
      validAppsMsg, "\n")
  }

  else { # find and launch the app
    #first save original settings to restore in the regular apps
    options(l.cex=getOption("lab_size"))
    options(l.axc=getOption("axis_size"))

    style(lab_size=1.201, axis_size=1.011, suggest=FALSE)
    appDir <- system.file("shiny_apps", app, package="lessR")
    shiny::runApp(appDir, display.mode="normal")
    # no return here to process any info after runApp() runs
    # Shiny now loaded
  }

}

.radar.plotly <- function(
  agg,                                 # output of .radar_aggregate()
  x_name, by_name, facet_name,         # for hover labels
  main = NULL,
  fill, border, opacity,
  digits_d = 2,
  facet_opts = .plotly_facet_opts(),
  style_opts = .plotly_style()
) {


# ----- angular ticks from factor levels ----------------------------------
.plotly_theta_from_levels <- function(x_levels) {
  K <- length(x_levels)
  if (!is.finite(K) || K < 1L) stop("x_levels must have length >= 1")
  seq(0, 360 - 360 / K, length.out = K)
}


# ----- apply per-facet polar layout blocks -------------------------------
.plotly_apply_polar_layout <- function(p, domains, theta_deg, x_labels, rmax) {
  lab.cex <- getOption("lab_size",  1.0)
  ax.cex  <- getOption("axis_size", 0.9)
  ang.font <- list(size = round(14.5 * lab.cex))  # outer, category labels
  rad.font <- list(size = round(16.0 * ax.cex))  # inner, numeric labels

  for (i in seq_along(domains)) {
    nm <- if (i == 1L) "polar" else paste0("polar", i)
    blk <- list(
      domain     = list(x = domains[[i]]$x, y = domains[[i]]$y),
      radialaxis = list(
        visible = TRUE, showline = TRUE,
        range = c(0, rmax * 1.08),
        tickfont = rad.font
      ),
      angularaxis = list(
        type = "linear", direction = "clockwise",
        rotation = 10, tickmode = "array",
        tickvals = theta_deg, ticktext = as.list(x_labels),
        tickfont = ang.font
      )
    )
    # dynamic-named layout arg: polar, polar2, polar3, ...
    p <- do.call(plotly::layout, c(list(p), setNames(list(blk), nm)))
  }
  p
}


  # Pre-aggregated bundle from Chart() / .radar_aggregate()
  r.tab     <- agg$r.tab
  facet.fac <- agg$facet.fac
  by.fac    <- agg$by.fac
  x.fac.out <- agg$x.fac.out
  rmax      <- agg$rmax
  n.fac     <- agg$n.fac
  n.by      <- agg$n.by
  y.label   <- agg$y.label

  title.size <- round(16 * getOption("main_size", 1))

  # ---- 4) Facet domains + annotations ----
  # gaps are literal; facet_size scales each panel within its grid cell
  # (the shared rule in .plotly_make_domains_grid, matching .hier.plotly)
  if (n.fac == 1L) {
    # single panel: use most of the available space but leave breathing room
    domains <- list(list(x = c(0.08, 0.95), y = c(0.05, 0.88)))
    ann     <- list()
  } else {
    lay <- .plotly_facet_layout(
      n_fac        = n.fac,
      facet_levels = levels(facet.fac),
      facet_name   = facet_name,
      n_col_max    = facet_opts$n_col_max,
      gap_x        = facet_opts$gap_x, gap_y = facet_opts$gap_y,
      facet_size   = facet_opts$facet_size,
      # compress panels: shift down and shrink so main title has clear space
      domain_adjust = function(d) {
        span <- (d$y[2] - d$y[1]) * 0.72
        new.y1 <- min(0.78, d$y[2] - 0.10)
        new.y0 <- max(0, new.y1 - span)
        list(x = d$x, y = c(new.y0, new.y1), row = d$row, col = d$col)
      },
      y_base       = facet_opts$title_y_base,
      y_row_shift  = facet_opts$title_row_shift,
      yanchor      = "bottom",
      ann_adjust   = function(i, a, d) {
        a$y <- min(d$y[2] + 0.12, 0.97); a
      }
    )
    domains <- lay$domains
    ann     <- lay$annotations
  }

  # ---- 5) Angular setup ----
  theta.deg    <- .plotly_theta_from_levels(levels(x.fac.out))
  theta.closed <- c(theta.deg, theta.deg[1])
  text.labels  <- c(levels(x.fac.out), levels(x.fac.out)[1])

  # ---- 6) Colors + opacity ----
  # fill arrives pre-resolved from Chart() as a length-n.by vector
  fill.vec <- rep_len(fill, n.by)

  cols.hex   <- .to_hex(fill.vec)
  fills.rgba <- .maketrans_plotly(cols.hex, alpha = opacity)

  # ---- 7) Build traces ----
  p <- plotly::plot_ly()
  val.spec <- paste0(":.", if (is.null(digits_d)) 0L
                           else max(0L, as.integer(digits_d)), "f")

  for (i in seq_along(facet.fac)) {
    fac <- facet.fac[i]
    subplot.name <- if (i == 1) "polar" else paste0("polar", i)
    show.leg <- (i == 1 && n.by > 1)

    for (j in seq_along(by.fac)) {
      r.j <- as.numeric(r.tab[fac, by.fac[j], ])
      r.closed <- c(r.j, r.j[1])

      p <- plotly::add_trace(
        p,
        type  = "scatterpolar",
        theta = theta.closed,
        thetaunit = "degrees",
        r     = r.closed,
        mode  = "lines+markers",
        line  = list(width = 1.5, color = cols.hex[j]),
        marker = list(size = 4, color = cols.hex[j]),
        fill  = "toself",
        fillcolor = fills.rgba[j],
        name  = as.character(by.fac[j]),
        text  = text.labels,
        hovertemplate = paste0(
          x_name, ": %{text}<br>",
          if (n.by  > 1) paste0(by_name,    ": ", by.fac[j], "<br>") else "",
          if (n.fac > 1) paste0(facet_name, ": ", fac,       "<br>") else "",
          y.label, ": %{r", val.spec, "}<extra></extra>"
        ),
        subplot = subplot.name,
        showlegend = show.leg
      )
    }
  }

  # ---- 8) Polar layout ----
  p <- .plotly_apply_polar_layout(
    p,
    domains   = domains,
    theta_deg = theta.deg,
    x_labels  = levels(x.fac.out),
    rmax      = rmax
  )

  # `ann` was built above by .plotly_facet_layout() (empty list when n.fac==1)

  # ---- 10) Final layout ----
  # When a legend is shown (n.by > 1) place it OUTSIDE the paper (x > 1) so
  # Plotly never auto-shifts the polar domain to avoid legend overlap.
  has.legend <- n.by > 1
  r.margin   <- if (has.legend) 110L else 20L
  l.margin   <- if (n.fac == 1L) 20L else r.margin  # left never needs legend space

p <- plotly::layout(
  p,
  title = list(
    text = main,
    x = 0.5, xanchor = "center",
    y = 0.97, yanchor = "top",
    font = list(size = title.size)
  ),
  margin = list(t = round(title.size * 2.2),
               b = 10, l = l.margin, r = r.margin),
  showlegend = has.legend,
  annotations = ann,
  legend = list(
    x = 1.02,
    xanchor = "left",
    y = 1.0,
    yanchor = "top",
    bordercolor = .to_hex(style_opts$panel_border),
    borderwidth = 1,
    title = list(
      font = list(size = round(
        16 * getOption("lab_size", 1)))),
    font = list(size = round(
      18 * getOption("axis_size", 0.9)))
  )
)

  # Finalize to ensure htmlwidget form + sizingPolicy + unique id
  p <- .finalize_plotly_widget(
    p,
    kind         = "radar",
    x_name       = x_name,
    by_name      = by_name,
    add_title    = FALSE,
    nudge_viewer = (.allow.interactive() && !isTRUE(getOption("knitr.in.progress"))),
    unique_element = TRUE
  )

  return(invisible(p))
}

rename <-
  function(data, from, to) {

  # get name of data table
  df.name <- deparse(substitute(data))

  # if a tibble convert to data frame
  dfs <- .getdfs()
  if (!is.null(dfs)) {
    if (df.name %in% dfs) {  # tibble to df
      if (any(grepl("tbl", class(data), fixed=TRUE))) {
        data <- data.frame(data)
      }
    }
  }

  # get existing, old variable name from its position in data frame
  data.vars <- as.list(seq_along(data))
  names(data.vars) <- names(data)
  ind.fr <- eval(substitute(from), envir=data.vars, parent.frame())
  nm.fr <- names(data)[ind.fr]

  # new variable name(s)
  # if converting a vector of names, then first element is "c", so remove
  nm.new <- sapply(substitute(to), deparse)
  nm.to <- character(length=0)
  if (length(nm.new) > 1)
    for (i in 2:length(nm.new)) nm.to[i-1] <- nm.new[i]
  else
    nm.to <- nm.new[1]

  if (length(ind.fr) > 0) {
  for(i in 1:length(ind.fr))
    names(data)[names(data) == nm.fr[i]] = nm.to[i]

  }

  cat("Change the following variable names for data frame", df.name, ":\n\n")
  for (i in 1:length(nm.fr))
    cat(nm.fr[i], "-->", nm.to[i], "\n")
  cat("\n")

  return(data)

}

.bc.main <-
function(x, y, by, stack100,
         fill, color, trans,
         fill_split, fill_scaled, fill_chroma, fill.palette, theme,
         horiz, gap, prop, scale_y,
         xlab, ylab, main,
         label_max, beside,
         rotate_x, offset,
         axis_fmt, axis_x_pre, axis_y_pre,
         break_x, sort,
         labels, labels_color, labels_size, labels_decimals,
         labels_pos, labels_cut,
         xlab_adj, ylab_adj, bm.adj, lm.adj, tm.adj, rm.adj,
         pad_y_min, pad_y_max,
         legend_title, legend_position, legend_labels,
         legend_horiz, legend_size, legend_abbrev, legend_adj,
         add, x1, x2, y1, y2, out_size, do_plot, use_plotly, quiet,
         shiny, digits_d, style_opts = NULL, ...) {


  multi <- ifelse (is.data.frame(x), TRUE, FALSE)
  is.ord <- ifelse (is.ordered(x) || is.ordered(by), TRUE, FALSE)

  if (stack100) prop <- TRUE
  if (!is.null(by)  &&  prop) stack100 <- TRUE  # prop deprecated

  # if x is integer, not labeled correctly, set to factor
  if (!is.data.frame(x))
    if (length(unique(x)) != length(x)) if (!is.factor(x)) x <- factor(x)

  if ( (is.table(x) || is.matrix(x)) && is.null(legend_title) ) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
    "Need to specify a value for:  legend_title\n\n")
  }

  # --------------------------------------
  # axis values, axis labels, legend setup

  # get axis_x_size, axis_y_size
  axis_x_size <- ifelse(is.null(getOption("axis_x_size")),
    getOption("axis_size"), getOption("axis_x_size"))
  axis_y_size <- ifelse(is.null(getOption("axis_y_size")),
    getOption("axis_size"), getOption("axis_y_size"))
# adj <- .RSadj(axis_size=axis_x_size); axis_x_size <- adj$axis_size
# adj <- .RSadj(axis_size=axis_y_size); axis_y_size <- adj$axis_size

  # get lab_x_size  lab_y_size
  lab_size <- getOption("lab_size")
  lab_x_size <- getOption("lab_x_size")
  lab_y_size <- getOption("lab_y_size")
  lab_x_size <- ifelse(is.null(lab_x_size), lab_size, lab_x_size)
  lab_y_size <- ifelse(is.null(lab_y_size), lab_size, lab_y_size)
# adj <- .RSadj(lab_size=lab_x_size); lab_x_size <- adj$lab_size
# adj <- .RSadj(lab_size=lab_y_size); lab_y_size <- adj$lab_size
# if (shiny) {  # only current use of arg: shiny
#   axis_x_size <- 1.08 * axis_x_size
#   axis_y_size <- 1.08 * axis_y_size
#   lab_x_size <- 1.15 * lab_x_size
#   lab_y_size <- 1.15 * lab_y_size
# }

  gl <- .getlabels(xlab, ylab, main, by.nm=TRUE, lab_x_size=lab_x_size,
                   lab_y_size=lab_y_size, flip=horiz)
  x.name <- gl$xn;  x.lbl <- gl$xl;  y.lbl <- gl$yl
  x.lab <- ifelse (horiz, gl$yb, gl$xb)
  main.lab <- gl$mb
  sub.lab <- gl$sb
  by.name <- y.lbl
  if (!is.null(by) || is.data.frame(x))
    by.name <- getOption("byname")
  ylab_keep <- ifelse (is.null(ylab), FALSE, TRUE)

  if (ylab_keep) {
      y.lab <- ylab
  }
  else {  # First part of y-axis label
    if (!is.vector(x)) {
      txt <- "Proportion"
      if (!is.null(by) && prop && !beside) {
        txt <- paste("Cell % within")
      }
      if (is.null(y))
         if (!prop) ylab <- "Count" else ylab <- txt
    }
    else {
      y.lab <- x.name
      if (length(unique(x)) != length(x)) x.lab <- ""
    }
  }

  if (is.null(ylab))
    done <- FALSE
  else
    done <- ifelse (grepl("of", ylab, fixed=TRUE), TRUE, FALSE)

  if (!ylab_keep) {
    if ((!prop || is.null(by)) && is.null(y) && !done &&
         !is.vector(x))
      y.lab <- paste(ylab, "of", x.name)
    if (!is.null(by)) {
      if (!beside) {
        txt <- paste(ylab, "of", x.name)
        y.lab <- ifelse (!prop,
                         txt, paste(ylab, x.name, "by", by.name))
      }
      else {
        if (!prop)
          y.lab <- "Count"
        else
          y.lab <- "Percentage"
      }
    }
    if (!is.null(y)) y.lab <- getOption("yname")
  }

  if (is.matrix(x)) {  # get the variable names as counts entered directly
    options(xname = x.lab)
    options(byname = legend_title)
  }

  # get legend title, l.lab
  if (!is.null(legend_title))
    l.lab <- legend_title
  else
    if (horiz) {
      if (!is.null(by)) if (exists("x.lbl")) {
        if (length(x.lbl) == 0)
          l.lab <-  by.name
        else
          l.lab <- paste(by.name, ": ", x.lbl, sep="")
      }
    }
    else {
      if (!is.null(by)) if (exists("y.lbl")) {
        if (length(y.lbl) == 0)
          l.lab <-  by.name
        else
          l.lab <- paste(by.name, ": ", y.lbl, sep="")
      }
    }


  # --------------------------
  # get missing, data entered?

  x.miss <- sum(is.na(x))
  by.miss <- NULL
  by.miss <- if (!is.null(by)) sum(is.na(by))

  # entered counts typically integers as entered but stored as type double
  # if names(x) or rownames(x) is null, likely data from sample and c functions
  # y is getting data values directly from a data frame with counts entered
  entered.pre <- FALSE
  if (!is.matrix(x) && !is.null(names(x))) entered.pre <- TRUE
  if (is.matrix(x) && !is.null(rownames(x))) entered.pre <- TRUE
  entered <- ifelse (!is.integer(x) && is.double(x) && entered.pre, TRUE, FALSE)

  if (is.null(by) && beside && !entered) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
    "beside=TRUE  is not valid for analysis of only one variable.\n\n")
  }


  # -------------------------------------------
  # get y variable, either directly or tabulate

  # y is provided, no tabulation
  if (!is.null(y)) {
    entered <- TRUE

    if (horiz) {
      tmp <- y.lab; y.lab <- x.lab;  x.lab <- tmp
    }

    if (is.null(by)) {  # no by variable
      yn <- getOption("yname")
      if (!is.numeric(y) > 0) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "y-values, those from the 2nd unlabeled variable, ", yn, ",",
          " must be\n", " numeric\n\n",
          "A  by  variable is categorical, with only several unique values\n",
          "It appears that ", yn, " is a by variable\n",
          "As of lessR 3.5.6 to specify a  by  variable in the function call\n",
          "  precede its name with:  by=", "\n\n")
      }

      if (anyDuplicated(names(x)) > 0) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "The data contain duplicated values of variable: ", x.name, "\n\n")
      }

      x.temp <- x
      x <- y
      names(x) <- x.temp
      x <- as.table(x)
      if (prop) {
        x.count <- x  # save table of counts for possible bar display
        x <- x/sum(x)
      }
    }

    else {  # a by variable, y already aggregated

      ## drop rows with any NA in x, by, or y
      keep <- !is.na(x) & !is.na(by) & !is.na(y)
      x_use  <- x[keep]
      by_use <- by[keep]
      y_use  <- y[keep]

      ## use factors so we get consistent, ordered levels
      x_fac  <- factor(x_use)
      by.fac <- factor(by_use)

      ## build a 2D table of aggregated values: rows = by, cols = x
      tab <- xtabs(y_use ~ by.fac + x_fac, drop.unused.levels = FALSE)

      # ensure dimnames reflect a specific level ordering)
      unq.x  <- levels(x_fac)
      unq.by <- levels(by.fac)
      tab <- tab[unq.by, unq.x, drop = FALSE]

      names(dimnames(tab)) <- c(by.name, x.name)
      x <- tab

      if (stack100) {  # x = tabulate for counts
        x.count <- x  # save the table for possible bar display
        x <- prop.table(x, 2)  # 100% within each x (column)
      }
    }
  }  # end y is present


  if (!entered) {  # so tabulate
    if (!is.data.frame(x)) { # a single x variable

      if (is.null(by)) {
        x.temp <- x  # save counts, to be restored for text output
        x <- table(x, dnn=NULL)
        if (prop) {
          x.count <- x  # save table of counts for possible bar display
          x <- x/sum(x)
        }
      }
      else {  # a by variable
        if (length(x) == length(by))
          x.temp <- table(by, x, dnn=c(by.name, x.name))
        else {
          cat("\n"); stop(call.=FALSE, "\n","------\n",
          x.name, " and ", by.name, " must be of the same size\n\n",
          "Size of ", x.name, ": ", length(x), "\n",
          "Size of ", by.name, ": ", length(by), "\n\n", sep="")
        }
        x <- x.temp
        if (stack100) {
            x.count <- x  # save table of counts for possible bar display
            x <-prop.table(x, 2)  #  100% within bar chart
        }
      }
    }   # end single x value

    else {  # x is a data frame, so combine x's
      if (!is.factor(x[,1])) {
        resp <- unique(x[,1])
        for (i in 2:ncol(x)) resp <- union(resp, unique(x[,i]))
        resp <- sort(resp)  # sort removes any NA
      }
      else {  # is factor
        resp <- levels(x[,1])
        for (i in 2:ncol(x)) resp <- union(resp, levels(x[,i]))
      }
      n.resp <-length(resp)
      frq <- matrix(nrow=n.resp, ncol=ncol(x))  # all elements NA
      frq <- apply(frq, c(1, 2), function(x) 0)
      rownames(frq) <- as.character(resp)
      colnames(frq) <- names(x)

      # maybe an x not has a value in full set
      for (i in 1:ncol(x)) {
        tblx.i <- table(x[,i])
        k <- 0
        for (j in 1:n.resp) {
          if (rownames(frq)[j] %in% names(table(x[,i]))) {
            k <- k + 1
            frq[j,i] <- tblx.i[k]
          }
        }
      }  # end col i of x

      x <- as.table(frq)
      if (is.numeric(resp))
        wt <- resp
      else
        wt <- 1:n.resp
      wm <- double(length=ncol(x))
      for (i in 1:ncol(x)) wm[i] <- weighted.mean(wt, x[,i])

      if (sort != "0") {
        srt.dwn <- ifelse (sort == "-", TRUE, FALSE)
        m.o <- order(wm, decreasing=srt.dwn)
        x <- x[,m.o]
        wm <- wm[m.o]
      }
    }  # x is a data frame
  }  # end !entered so tabulated


  if (prop) {
    if (any(is.nan(x))) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Some cells (frequencies) are zero\n",
        "Division to calculate proportions not possible\n",
        "Run analysis without  proportion  to identify the 0 cells\n\n")
    }
  }

  # ------------
  # sort options (x is numeric y)
  if (sort != "0") {
    srt.dwn <- ifelse (sort == "-", TRUE, FALSE)
    if (!is.matrix(x)) {
      x <- x[order(x, decreasing=srt.dwn)]
    }
    else {
      x.df <- as.data.frame.matrix(x, nrow=2)
      x.df <- x.df[order(apply(x.df, 2, sum), decreasing=srt.dwn)]
      x <- as.table(as.matrix(x.df))
    }
  }  # end sort

  n.levels <- ifelse (is.matrix(x), nrow(x), length(x))


# assign fill and color (edge) --------------------------------------------
  # assign fill
  if (!fill_scaled) {

    if (!is.null(fill_split)) {
      f.c <- character(length=2)
      if (!is.null(fill) && length(fill) == 2L) {
        # user-defined divergent scale: fill=c(lo_color, hi_color)
        f.c[1] <- fill[1]
        f.c[2] <- fill[2]
        fill <- NULL  # clear so value-proportional remap below can run
      } else {
        chroma <- ifelse (theme %in% c("gray", "white"), 0, 55)
        hue <- .get.h(theme)
        f.c[1] <- hcl(hue, chroma, l=30)
        f.c[2] <- hcl(hue, chroma, l=70)
      }
      fill_split_clr <- character(length=length(x))
      for (i in seq_along(x))
        fill_split_clr[i] <- ifelse(x[i] <= fill_split, f.c[1], f.c[2])
      fill <- fill_split_clr
    }

    if (is.null(fill)) {
      if (!is.null(by))   # need a sequential range if a by variable
        fill <- .color_range(.get_fill(theme), n.levels)
      else
        fill <- rep(getOption("bar_fill_discrete"), n.levels)  # uniform theme color
    }  # end missing fill

    # if specified fill is a sequence name like "reds", not a valid color name
    # so get convert the name to a sequential color palette
    if (length(fill) == 1L || .is.palette(fill[1L]))
      fill <- .color_range(fill, n.levels)

  }  # end no fill_scaled

  else {  # fill_scaled: luminance proportional to bar value
    # collapse expanded fill vector to 1-2 colors as .scale.clr expects
    if (!is.null(fill)) {
      fill_unique <- unique(fill)
      if (length(fill_unique) == 1L) fill <- fill_unique
      else if (length(fill_unique) > 2L) fill <- NULL
    }
    fill <- .scale.clr(x, fill, fill_split, fill_chroma, theme)
  }

  # transparency, need a valid color name here
  if (trans > 0)
    for (i in 1:length(fill)) fill[i] <- .maketrans(fill[i], (1-trans)*256)

  # assign color (edges)
  # by default, no color borders if a range
  if (identical(color, getOption("bar_color_discrete")))
    color <- "transparent"
  # see if apply a pre-defined color range to **color**
  col.clr <- .color_range(color, n.levels)  # see if range, NULL if not
  if (!is.null(col.clr)) color <- col.clr

# is.range.nm <- ifelse (length(.color_range(fill, n.clr=5)) > 1,
#                        TRUE, FALSE)
# if (!is.range.nm && !is.null(by) && !is.null(fill)) {
#   cat("\n"); stop(call.=FALSE, "\n------\n",
#     "For custom fill for a two-variable bar chart,\n",
#     " must specify a color range such as \"colors\" or \"grays\", \n\n")
# }


# preliminaries -----------------------------------------------------------

  add_top <- 0.05  # old version of pad_y_max, no longer a parameter
  if (length(labels_pos > 0))
    if (labels_pos == "out") add_top <- add_top + .06
  # a 2-D table is an instance of a matrix, a 1-D table is not
  max.y <- ifelse (is.matrix(x) && !beside,
                   max(colSums(x), na.rm=TRUE), max(x, na.rm=TRUE))
  max.y <- max.y + (add_top * max.y)

  if (any(x < 0, na.rm = TRUE)) {
    min.y <- ifelse (is.matrix(x) && !beside,
                     min(colSums(x), na.rm=TRUE), min(x, na.rm=TRUE))
    min.y <- min.y - abs(add_top * min.y)
  }
  else
    min.y <- 0

  # plotly keeps its own legend layout unless asked, so capture what
  # the user set before the base-graphics defaults below overwrite it
  legend_labels.user <- legend_labels
  legend_horiz.user  <- legend_horiz

  if (is.null(legend_labels)) legend_labels <- row.names(x)
  for (i in 1:length(legend_labels))
    legend_labels[i] <- gsub("~", " ", legend_labels[i], fixed=TRUE)
  if (beside) legend_horiz <- FALSE
  if (is.matrix(x) && !beside) legend_horiz <- TRUE

  # plotly keeps its own bar spacing unless the user set gap, so the
  # base-graphics default below does not shift every plotly bar chart
  gap.user <- gap

  if (is.null(gap)) {  # ifelse does not work here when gap is a vector
    if (!is.null(by) && beside)
      gap <- c(0.1,1)
    else
      gap <- 0.2
  }

  # get the names
  the.names <- integer(length=0)
  if (length(dim(x)) == 0)
    the.names <- names(x)
  else {
    if (is.null(by))  # ifelse does not work
      the.names <- rownames(x)
    else
      the.names <- colnames(x)
  }

  # set las.value for labels horiz or vertical
  las.value <- 1
  if (horiz  &&  max(nchar(the.names), na.rm=TRUE) > 5) las.value <- 0


# value labels -----------------------------------------------------------

  # val.lab: use names from x, by columns, or y names
  if (is.null(by))
    val.lab <- names(x)
  else
    val.lab <- colnames(x)
  if (length(val.lab) == 0) val.lab <- colnames(x)  # read matrix directly
  if (!is.null(names(y))) val.lab <- names(y)

  # for each value label, partition into mx.x.val.ln lines if (break_x)
  mx.x.val.ln <- 1
  if (!break_x) {
    for (i in seq_along(val.lab)) {
      if (!is.na(val.lab[i])) {
        val.lab[i] <- gsub(" ", "~", val.lab[i])  # ~ , so no \n
      }
    }
  }
  stuff <- .get.val.ln(val.lab, x.name)
  val.lab <- stuff$val.lab
  mx.x.val.ln <- stuff$mx.val.ln

  mx.y.val.ln <- 1

  if (is.null(y)) if (horiz) {  # switch
    temp <- x.lab;  x.lab <- y.lab;  y.lab <- temp
    temp <- mx.x.val.ln;  mx.x.val.ln <- mx.y.val.ln;  mx.y.val.ln <- temp
  }

  # set max.val.width to get max width of y-axis labels for lm adjustment
  lblval.y <- character(length=0)
  if (is.null(scale_y)) {
    prety <- max(pretty(c(min.y, max.y)))
    mx.num <-  ifelse (!prop, as.character(prety), .fmt(prety, 2))
    max.y.width <- max(strwidth(mx.num, cex=axis_y_size, units="inches"))

  }
  else {  # need scale to be defined to get y.coords, not done till later
    ax.num <- ifelse(horiz, 1, 2)  # location of numerical axis
    y.coords <- axTicks(ax.num, axp=scale_y)
    nd <- .max.dd(y.coords)
    if (nd > 2) nd <- 2  # only allow a few decimal digits
    for (i in 1: length(y.coords))
      lblval.y[i] <- as.character(.fmt(y.coords[i], nd))
    j <- which(nchar(lblval.y) == max(nchar(lblval.y)))[1]
    max.y.width <- max(strwidth(lblval.y[j], cex=axis_y_size, units="inches"))
  }

  max.x.width <- NULL
  if (horiz  ||  rotate_x == 90) {  # "y"-axis is categorical (i.e., x-axis)
  val.split <- unlist(strsplit(val.lab, "\n"))  # break into separate words
    if (horiz)
      max.y.width <- max(strwidth(val.split, cex=axis_x_size, units="inches"))
    else
      max.x.width <- max(strwidth(val.split, cex=axis_x_size, units="inches"))
    # strwidth not work in R w/o RStudio until barplot, plot.new not enough
    in.RStudio <- ifelse (options("device") == "RStudioGD", TRUE, FALSE)
    if (!in.RStudio) {  # 1st attempt, undoubtedly can be improved
      if (horiz)
        max.y.width <- max(nchar(val.split)) / (11 / axis_x_size)
      else
        max.x.width <- max(nchar(val.split)) / (11 / axis_x_size)
    }
  }


  if (do_plot) {

  # ----------------
  # set up plot area

  margs <- .plt.marg(max.y.width, y.lab, x.lab, main.lab, sub.lab,
                rotate_x, mx.x.val.ln, mx.y.val.ln,
                lab_x_size=lab_x_size, lab_y_size=lab_y_size, max.x.width)
  lm <- margs$lm
  tm <- margs$tm
  rm <- margs$rm
  bm <- margs$bm
  n.lab_x.ln <- margs$n.lab_x.ln
  n.lab_y.ln <- margs$n.lab_y.ln

  if (horiz)
    rm <- rm + 0.1  # sometimes the max axis value goes off the plot
  else
    if (offset > 0.5) bm <- bm + (-0.05 + 0.2 * offset)  # offset kludge

  if (!exists("byname"))
    byname <- getOption("byname")
  if (legend_position == "right_margin"  &&  (is.matrix(x))) {
    if (!is.null(legend_abbrev)) {
      byname  <- abbreviate(byname, legend_abbrev)
      if (!is.null(legend_labels))
        legend_labels <- abbreviate(legend_labels, legend_abbrev)
    }
    mx.ch <- max(c(max(nchar(legend_labels)), nchar(byname)-2))
    exp.coef <- 0.065 + 0.45 * axis_x_size
    rm <- rm + (.34 + (exp.coef * axis_x_size))
    rm <- rm + (0.04 + 0.036*mx.ch)  # legend also moves over
    if (mx.ch > 18) rm <- rm + ((mx.ch - 18) * .06)
  }

  if (legend_position == "top")
    tm <- tm + (.25 + (0.446 * lab_size))  # tm <- tm + .45

  # user manual adjustment
  bm <- bm + bm.adj
  lm <- lm + lm.adj
  tm <- tm + tm.adj
  rm <- rm + rm.adj

  orig.params <- par(no.readonly=TRUE)
  on.exit(par(orig.params))

  par(bg=getOption("window_fill"))
  par(mai=c(bm, lm, tm, rm))

#p(par("din")[1]-par("pin")[1])
  # new.scale to control bar width for small number of bars
  # set new.scale
  if ("numeric" %in% class(x)  &&  entered) x <- as.table(x)
  new.scale <- 0
  if (is.null(by)) if (nrow(x) <= 4) new.scale <- nrow(x)
  if (is.matrix(x)  &&  !beside) if (ncol(x) <= 4) new.scale <- ncol(x)
  if ("matrix" %in% class(x)  &&  entered) new.scale <- 0  # turned off for now
  # set width.bars, gap
  if (new.scale == 4) width.bars <- .17
  if (new.scale == 3) width.bars <- .22
  if (new.scale == 2) width.bars <- .28
  if (new.scale == 1) width.bars <- .30  # for only one category
  if (new.scale > 0) gap <- 0.246 + (0.687 * width.bars)

  yp <- pretty(c(min.y, max.y))
  y.adj_min <- pad_y_min * (yp[length(yp)] - yp[1])
  y.adj_max <- pad_y_max * (yp[length(yp)] - yp[1])
  min.y <- min.y - y.adj_min
  max.y <- max.y + y.adj_max

  # barplot run here only to establish usr coordinates, axTick values
  #  otherwise usr is just 0,1 for both axes
  # the barplot itself is not retained
  if (new.scale == 0) {
    if (!horiz)
      barplot(x, col="transparent", border="transparent",
        ylim=c(min.y,max.y), axisnames=FALSE,
        beside=beside, space=gap, axes=FALSE, ...)
    else
      barplot(x, col="transparent", border="transparent", horiz=TRUE,
        axisnames=FALSE,
        beside=beside, space=gap, axes=FALSE, xlim=c(min.y, max.y), ...)
  }
  else { # new.scale, need (0,1) limit on_cat axis for re-scale to work
    if (!horiz)
      barplot(x, col="transparent", border="transparent",
        ylim=c(min.y,max.y), axisnames=FALSE,
        beside=beside, space=gap, width=width.bars, xlim=c(0,1),
        axes=FALSE, ...)
    else {
      # when x is binary for a BPFM equivalent ylim may need extension
      x.coords <- barplot(x, col="transparent", border="transparent", horiz=TRUE,
        axisnames=FALSE,
        beside=beside, space=gap, width=width.bars, xlim=c(min.y, max.y),
        ylim=c(0,1), axes=FALSE, plot=FALSE, ...)
      up.lim <- ifelse (max(x.coords) > 1, max(x.coords) + .1, 1)
      barplot(x, col="transparent", border="transparent", horiz=TRUE,
        axisnames=FALSE,
        beside=beside, space=gap, width=width.bars, xlim=c(min.y, max.y),
        ylim=c(0,up.lim), axes=FALSE, ...)
    }
  }

  ax.num <- ifelse (horiz, 1, 2)  # location of numerical axis
  y.coords <- axTicks(ax.num, axp=scale_y)
  gridT <- axTicks(ax.num, axp=scale_y)  # axis ticks, grid lines are identical
  y.name <- getOption("yname")


  ## ----
  ## PLOT
  ## does stacked bar charts automatically if x is a 2-D matrix

   usr <- par("usr")  # used elsewhere as well; just use 1 y.coords next
  .plt.bck(usr, y.coords, y.coords, do.v=horiz, do.h=!horiz)

  # the bars
  # here plot only the bars and the background; x is the y-numbers here


  if (new.scale == 0)
    x.coords <- barplot(x, add=TRUE, col=fill, border=color,
          beside=beside, horiz=horiz, axes=FALSE, ann=FALSE, las=las.value,
          space=gap, axisnames=FALSE, ...)
  else
    x.coords <- barplot(x, add=TRUE, col=fill, border=color, beside=beside,
          horiz=horiz, axes=FALSE, ann=FALSE, las=las.value,
          space=gap, width=width.bars, xlim=c(0,1), axisnames=FALSE, ...)


  # display text labels of y-values on or above the bars
  # ----------------------------------------------------

  # plotly applies its own per-mode default, so pass on only a value
  # the user actually set; the base-graphics defaults resolved just
  # below would otherwise shift every interactive chart
  labels_decimals.user <- labels_decimals

  if (labels != "off") {
    if (is.null(labels_decimals)) {  # set labels_decimals
      if (labels == "input") labels_decimals <- 0
      if (labels == "%") labels_decimals <- 0
      if (labels == "prop") labels_decimals <- 2
      if (.is.integer(y)) labels_decimals <- 0
    }
  }

  # need n.levels for this evaluation
  if (labels == "eval.later") {  # labels not user-specified
    is.int <- TRUE
    if (!is.null(y)) if (!.is.integer(y)) is.int <- FALSE
    if (n.levels > 14  || !is.int)
      labels <- "off"
    else {
      labels <- getOption("values")
      if (labels != "off") if (!is.null(y)) labels <- "input"
    }
  }

  if (beside) {
     labels_size <- 0.85 * labels_size
     labels_cut <- 0.01
  }

    if (labels != "off") {

      if (is.null(labels_cut)) {
        labels_cut <- 0.028
        if ((prop && is.matrix(x)) || multi) labels_cut <- 0.040
      }

      # set type of the labels to display, x.txt

      if (!prop) {
        if (!multi)
          x.prop <- x/sum(x)
        else
          x.prop <- x/colSums(x)
        if (labels == "input")
          x.txt <- .fmt(x, labels_decimals)   # as.char not accurate for dec dig
        else if (labels == "%")
          x.txt <- paste(.fmt(x.prop * 100, labels_decimals), "%", sep="")
        else if (labels == "prop")
          x.txt <- .fmt(x.prop, labels_decimals)

        if (is.matrix(x))
            x.txt <- matrix(x.txt, nrow=nrow(x))

        if (labels_pos != "out") {
          if (is.null(by)) {
            if (is.null(y)) {
              for (i in 1:length(x.prop))
                x.txt[i] <- ifelse (x.prop[i] >= labels_cut, x.txt[i], "")
            }
          }
          else {  # by variable
            for (i in 1:nrow(x.prop)) for (j in 1:ncol(x.prop))
              x.txt[i,j] <- ifelse (x.prop[i,j] >= labels_cut, x.txt[i,j], "")
          }
        }
      }

      else {  # prop
        if (labels == "input")
          x.txt <- as.character(x.count)
        else if (labels == "%")
          x.txt <- paste(.fmt(x * 100, labels_decimals), "%", sep="")
        else if (labels == "prop")
          x.txt <- .fmt(x, labels_decimals)

        if (is.matrix(x))
            x.txt <- matrix(x.txt, nrow=nrow(x))

        if (labels_pos != "out") {
          if (is.null(by)) {
            for (i in 1:length(x))
              x.txt[i] <- ifelse (x[i] >= labels_cut, x.txt[i], "")
          }
          else {  # by variable
            # as.numeric & as.character convert table to vector: re-convert
            for (i in 1:nrow(x)) for (j in 1:ncol(x))
              x.txt[i,j] <- ifelse (x[i,j] >= labels_cut, x.txt[i,j], "")
          }
        }
      }

      # R text function sets cex at 1 if input value is 0
      if (labels_size == 0) labels_size <- 0.01

      # vertical bars
      if (!horiz) {
        if (!is.matrix(x)) { # 1 variable
          usr.y.inch <- diff(grconvertY(0:1, 'inches', 'user'))
          if (labels_pos == "in")
            ycrd <- x/2
          else {
            slope <- 0.0 + (0.15*labels_size)
            ycrd <- ifelse(x > 0, x + slope*usr.y.inch, x - slope*usr.y.inch)
          }
          text(x.coords, ycrd, labels=x.txt, col=labels_color, cex=labels_size)
        }  # no by
        else {  # 2 variables
          if (!beside) {
            for (i in 1:ncol(x)) {
              ycrd <- cumsum(x[,i]) - (x[,i] / 2)
              text(x.coords[i], ycrd, labels=x.txt[,i],
                   col=labels_color, cex=labels_size)
            }
          }  # end !beside
          else {  # beside
            usr.y.inch <- diff(grconvertY(0:1, 'inches', 'user'))
            if (labels_pos == "in")
              ycrd <- x/2
            else  # value.pos == "out"
              ycrd <- x + 0.10*usr.y.inch
            for (i in 1:ncol(x)) {
              text(x.coords[,i], ycrd[,i], labels=x.txt[,i],
                   col=labels_color, cex=labels_size)
            }
          }  # end beside
        }  # end 2 variables
      }  # end vertical bars

      # horiz bars
      else {
        if (!is.matrix(x)) {  # 1 variable
          usr.x.inch <- diff(grconvertX(0:1, 'inches', 'user'))
          if (labels_pos == "in")
            ycrd <- x/2
          else { # out, adjust for label font size
            slope <- 0.024 + (0.192*labels_size)
            ycrd <- ifelse(x > 0, x + slope*usr.x.inch, x - slope*usr.x.inch)
          }
          text(ycrd, x.coords, labels=x.txt, col=labels_color, cex=labels_size)
        }  # end no by
        else {  # by variable
          if (!beside) {  # stacked chart
          for (i in 1:ncol(x)) {  # each level of by
            ycrd <- cumsum(x[,i]) - (x[,i] / 2)
            text(ycrd, x.coords[i], labels=x.txt[,i],
               col=labels_color, cex=labels_size)
          }
        }
        else {  # beside chart
          usr.x.inch <- diff(grconvertX(0:1, 'inches', 'user'))
          if (labels_pos == "in")
            ycrd <- x/2
          else  # value.pos == "out"
            ycrd <- x + 0.17*usr.x.inch
            for (i in 1:ncol(x)) {
              text(ycrd[,i], x.coords[,i], labels=x.txt[,i],
                   col=labels_color, cex=labels_size)
            }
          }  # end beside
        }  # end by
      }  # end horiz bars

    }  # end display labels


    # y-axis is the numerical axis
    if (!horiz) las.value <- 1
    axis_y_color <- ifelse(is.null(getOption("axis_y_color")),
      getOption("axis_color"), getOption("axis_y_color"))
    axis_y_text_color <- ifelse(is.null(getOption("axis_y_text_color")),
      getOption("axis_text_color"), getOption("axis_y_text_color"))
    adj1 <- ifelse (!horiz, 0.5, -1.0)
    if (is.null(scale_y)) {  # if scale_y defined, can evaluate earlier
      if (!prop)
        lblval.y <- as.character(y.coords)
      else
        lblval.y <- .fmt(y.coords,2)
    }

    # adjust axis label from tick with mgp[2]
    # mgp does not work with rotate_x, see .axes()
    my.mgp <- par("mgp")  # save to restore
    ax <- .axes_dim()  # get axis value parameters
    mgp2 <- -0.350 + (0.9 * ax$axis_x_size)
    par(mgp = c(my.mgp[1], mgp2, my.mgp[3]))  # labels closer to axis
    adj <- .RSadj(axis_size=ax$axis_x_size); axis_x_size <- adj$axis_size

    par(tcl=-0.28)  # axis tick length

    # numerical axis
    if(!horiz)
        ax.info <- .axes(NULL, NULL, NULL, axT2=y.coords,
              rotate_x=rotate_x, offset=offset,
              axis_fmt=axis_fmt, axis_x_pre="no", axis_y_pre=axis_y_pre, ...)

    else
        ax.info <- .axes(NULL, NULL, axT1=y.coords, NULL,
              rotate_x=rotate_x, offset=offset,
              axis_fmt=axis_fmt, axis_x_pre=axis_x_pre, axis_y_pre="no", ...)

    # x-axis is the category value axis
    axis_x_color <- ifelse(is.null(getOption("axis_x_color")),
      getOption("axis_color"), getOption("axis_x_color"))
    axis_x_text_color <- ifelse(is.null(getOption("axis_x_text_color")),
      getOption("axis_text_color"), getOption("axis_x_text_color"))

    if (beside) x.coords <- apply(x.coords, 2, mean)  # one label per group
    if (!horiz) {
      usr.y.in <- diff(grconvertY(0:1, 'inches', 'user'))  # y user x.coords inch
      ax.value <- 1;  xx <- x.coords;  yy <- par("usr")[3] - (.15 * usr.y.in)
    }
    else {
      usr.x.in <- diff(grconvertX(0:1, 'inches', 'user'))  # x user x.coords inch
      ax.value <- 2;  xx <- par("usr")[1] - (.15 * usr.x.in);  yy <- x.coords
    }

    adj.x <- ifelse(!horiz, 0.5, 1.0)
    adj.y <- ifelse(!horiz, 1.0, 0.5)
    if (rotate_x == 0) {
      axis(ax.value, at=x.coords, labels=FALSE, col=axis_x_color, ...)
      text(x=xx, y=yy, labels=val.lab, adj=c(adj.x,adj.y),
           xpd=TRUE, cex=axis_x_size, col=axis_x_text_color, ...)
    }
    else if (rotate_x > 0  && rotate_x < 90) {
      axis(ax.value, at=x.coords, labels=FALSE, col=axis_x_color, ...)
      text(x=xx, y=yy, labels=val.lab, pos=1,  # pos needed for offset
           xpd=TRUE, cex=axis_x_size, col=axis_x_text_color,
           srt=rotate_x, offset=offset, ...)
    }
    else if (rotate_x == 90)  # 90 degrees rotate
      axis(ax.value, at=x.coords, labels=val.lab, col=axis_x_color,
           cex.axis=axis_x_size, las=2, ...)

    # title
    title(main=main.lab, cex.main=getOption("main_size"),
          col.main=getOption("main_color"))

    lab_x_color <- ifelse(is.null(getOption("lab_x_color")),
      getOption("lab_color"), getOption("lab_x_color"))

    # xlab positioning
    ln.ht.x <- par('cin')[2] * lab_x_size * par('lheight')  # line ht inches
    xlab_adj <- xlab_adj / ln.ht.x
    lblx.lns <- par("mar")[1] - 1.3   # par("mar")[1] is bm in lines
    title(xlab=x.lab, line=lblx.lns-xlab_adj, cex.lab=lab_x_size,
          col.lab=lab_x_color)

    # need sub.lab processing here

    # ylab positioning (based on .axlabs function)
    lab_y_color <- ifelse(is.null(getOption("lab_y_color")),
                          getOption("lab_color"), getOption("lab_y_color"))
    ln.ht.y <- par('cin')[2] * lab_y_size * par('lheight')  # line ht inches
    ylab_adj <- ylab_adj / ln.ht.y
    lm <- par("mar")[2]  # get current left margin in lines
    lbly.lns <- lm - (0.3 + 0.9*n.lab_y.ln*lab_y_size)
    if (!horiz) {  # y-axis labels
      lbl <- .axis.format(y.coords, axis_fmt, axis_x_pre, axis_y_pre="no")
      mx.ch <- max(nchar(lbl))  # move ylab closer
      if (mx.ch == 3) lbly.lns <- lbly.lns - 0.5  # would also prefer less lm
      if (mx.ch == 4) lbly.lns <- lbly.lns - 0.25
      if (mx.ch == 5) lbly.lns <- lbly.lns - 0.1
    }
    title(ylab=y.lab, line=lbly.lns-ylab_adj,
          cex.lab=lab_y_size, col.lab=lab_y_color)


    # ------------------------------------------------------
    # legend for two variable plot including variable labels

    if ( (!is.null(by) || is.matrix(x)) && !is.null(legend_position)) {

      col.bg <- getOption("panel_fill")
      col.txt <- ifelse (sum(col2rgb(col.bg))/3 > 80, "black", rgb(.97,.97,.97))

      # evaluate in bc.main, under color, when n.levels is known
      if (is.null(legend_size)) {
        if (legend_position == "top")
          legend_size <- getOption("lab_size")
        else
          legend_size <- axis_x_size
      }

      # default right_margin option location
      if (legend_position == "right_margin") {

        options(byname = getOption("byname"))
        trans_pts <- .6  # dummy value
        point.size <- 2.5 * axis_x_size
        .plt.by.legend(legend_labels, color, fill, shp=22, trans_pts,
                       col.bg, usr, pt.size=point.size, pt.lwd=0,
                       legend_size, legend_abbrev, legend_adj, legend_title)

      }  # end right margin

      # top option
      else if (legend_position == "top") {
        ll <- legend("top", legend=legend_labels, plot=FALSE,
               title=l.lab, xpd=NA, x.intersp=.15,
               fill=fill, border="transparent",
               horiz=legend_horiz, cex=legend_size, bty="n", text.col=col.txt)
        fct <- (-0.043 + (0.257 * lab_size))  # more cushion for large cex
        legend(ll$rect$left, usr[4]+(fct*(usr[4])), legend=legend_labels,
               title=l.lab, xpd=NA, x.intersp=.15, pt.cex=10,
               fill=fill, border="transparent",
               horiz=legend_horiz, cex=legend_size, bty="n", text.col=col.txt)
      }

      # everything else, not so consistent
      else
        legend(legend_position, legend=legend_labels, title=l.lab,
               fill=fill, border="transparent", x.intersp=.15,
               horiz=legend_horiz, cex=legend_size, bty="n", text.col=col.txt)

    } # end legend

    if (!is.null(add)) {

      add_size <- getOption("add_size")
      add_lwd <- getOption("add_lwd")
      add_lty <- getOption("add_lty")
      add_color <- getOption("add_color")
      add_fill <- getOption("add_fill")
      add_trans <- getOption("add_trans")

      .plt.add (add, x1, x2, y1, y2,
                add_size, add_lwd, add_lty, add_color, add_fill, add_trans)
    }

  }  # end do_plot


# text output -------------------------------------------------------------

  # The plotly render happens after this section, which restores x to
  # counts for the text tables, so keep the table as plotted here.
  # Keep its counts too: labels="input" displays them over the
  # proportions, as the base graphics path does above.
  x.plt <- x
  x.plt.count <- NULL
  if (prop) {
    x.plt.count <- x.count  # sort above reordered x, so realign
    x.plt.count <- if (length(dim(x)) == 2L)
      x.plt.count[rownames(x), colnames(x), drop=FALSE]
    else
      x.plt.count[names(x)]
  }

  if (prop) {
    if (is.null(y)) {
      if (!is.null(by) || is.matrix(x))
        x  <- x.temp
      else
        x <- table(x.temp)
    }
  }

  dd <- ifelse (is.null(digits_d), 3, digits_d)
  n_dim <- length(dim(x))
  stats <- ""

  if (multi) {

    # display variable labels
    txlbl <- ""
    l.name <- "l"
    if (exists(l.name, where=.GlobalEnv)) {
      mylabs <- get(l.name, pos=.GlobalEnv)
      mylabs <- mylabs[colnames(x),]
      if (!is.null(mylabs)) {
        tx <- character(length = 0)
        for (i in 1:length(colnames(x))) {
          if (is.data.frame(mylabs))
            ml <- mylabs[i,]
          else  # if a different l label frame exists, ml is NA
            ml <- mylabs[i]
          if (!is.na(ml))
            tx[length(tx)+1] <- paste(colnames(x)[i], ": ", ml, sep="")
        }
        tx[length(tx)+1] <- " "
        tx[length(tx)+1] <- "Variable Labels"
        txlbl <- rev(tx)
        blnk <- " "
      }
    }

    # display frequencies and means of each variable
    txttl <- "Frequencies of Responses by Variable"
    tx <- character(length = 0)
    mx.chr <- max(nchar(rownames(x)))
    mx.len <- 8
    if (mx.chr > mx.len) {
      c.nm <- rownames(x)
      rownames(x) <- .abbrev(rownames(x), mx.len)
    }
    x <- t(x)

    txtbl <- .prntbl(x, 0, cc=NULL)
    mx <- max(nchar(round(wm,2)))
    txtbl[1] <- paste(txtbl[1], " ", .fmtc("Mean", w=mx+1))
    n.var <- nrow(x)
    for (i in 1:n.var)
      txtbl[i+1] <- paste(txtbl[i+1], " ", .fmt(wm[i],3,w=mx+1))
     txtbl[2:length(txtbl)] <- rev(txtbl[2:length(txtbl)])

    if (mx.chr > mx.len) {
      txtbl[n.var+2] <- ""
      txtbl[n.var+3] <- ""
      txtbl[n.var+4] <- "Unabbreviated labels"
      txtbl[n.var+5] <- "--------------------"
      txtbl[n.var+6] <- paste(c.nm, sep="", collapse="\n")
    }
    strt <- ifelse (mx.chr > mx.len, 7, 2)
    if (is.null(resp)) {
      txtbl[n.var+strt] <- ""
      txtbl[n.var+strt+1] <- paste("Computation of the mean based on coding",
                                   "response categories from 1 to", n.var)
    }

    class(txtbl) <- "out"
    class(txttl) <- "out"
    output <- list(out_text=txlbl,
                   out_title=txttl, out_text=txtbl)

    class(output) <- "out_all"
    if (!quiet) print(output)

  }  # end multi


  # x is a table, could be real values or integers <0 if y is specified
  # no by variable, dim == 0 if x<-x.temp
  else if (n_dim == 1) {
    if (.is.integer(x)  &&  all(x >= 0)) {  # x is table of count-like values

      stats <- .ss.factor(x, by=NULL, brief=TRUE, digits_d=dd,
                          x.name, by.name, x.lbl, y.lbl, label_max,
                          x.miss, by.miss, out_size)
      if (!is.null(stats)) {
        txttl <- stats$title
        counts <- stats$count
        miss <- stats$miss
        chi <- stats$chi
        lbl <- stats$lbl

        class(txttl) <- "out"
        class(counts) <- "out"
        class(miss) <- "out"
        class(chi) <- "out"
        class(lbl) <- "out"
        output <- list(out_title=txttl, out_miss=miss,
                       out_lbl=lbl, out_counts=counts, out_chi=chi)
        class(output) <- "out_all"
        if (!quiet) print(output)
      }

    # names and order of components per documentation in BarChart.Rd
      stats$n_miss <- x.miss
      stats$p_value <- .fmt(stats$p_value, 3)
      names(stats) <- c("n_dim", "out_title", "out_counts", "out_miss",
                        "out_chi", "out_lbl", "freq", "freq_df", "prop",
                        "p_value", "n_miss")
      stats <- c(stats[2], stats[6], stats[3], stats[5], stats[4],
                 stats[1], stats[10], stats[8], stats[7], stats[9], stats[11])
    }  # end counts or count-like

    else {  # x (table from y) not count-like: not integer or values < 0

      stats <- .ss.real(x, by, digits_d=dd,
                   x.name, getOption("yname"), by.name, x.lbl, y.lbl, label_max)
      txtbl <- stats$txtbl
      class(txtbl) <- "out"
      output <- list(out_txt=txtbl, values=stats$values)

      class(output) <- "out_all"
      if (!quiet) print(output)
      names(stats) <- c("n_dim", "out_y", "values")
      stats <- c(stats[2], stats[1], stats[3])
    }

  }  # end if (n_dim == 1)

  # a by variable
  else {

    if (is.null(y) && .is.integer(x)) {

      # need brief=FALSE for row proportions
      stats <- .ss.factor(x, by, brief=FALSE, digits_d=dd,
                          x.name, by.name, x.lbl, y.lbl, label_max)
      txttl <- stats$txttl
      txfrq <- stats$txfrq
      txXV <- stats$txXV
      txlbl <- stats$txlbl

      class(txttl) <- "out"
      class(txfrq) <- "out"
      class(txXV) <- "out"
      class(txlbl) <- "out"
#     if (!prop)  # NOT working, props come out 0 or 1 from .ss.factor()
        output <- list(out_title=txttl, out_lbl=txlbl,
                       out_text=txfrq, out_XV=txXV)
#     else {
#       txrow <- stats$txrow
#       class(txrow) <- "out"
#       output <- list(out_title=txttl, out_text=txfrq,
#                      out_XV=txXV, out_row=txrow)
#     }
      class(output) <- "out_all"
      if (!quiet) print(output)

      names(stats) <- c("n_dim", "out_title", "out_lbl", "out_counts",
                        "out_chi", "out_prop", "out_row",
                        "out_col", "freq", "p_value")
      stats <- c(stats[2], stats[3], stats[4], stats[5], stats[6],
                 stats[7], stats[8], stats[1], stats[9], stats[10])
    }  # end is.null(y)

    else {  # y is present
      stats <- .ss.real(x, y, by, digits_d=dd, x.name,
                        y.name, by.name, x.lbl, y.lbl, label_max)

      names(stats) <- c("n_dim", "out_y")
      stats <- c(stats[2], stats[1])
    }
  }  # end a by variable


# use_plotly --------------------------------------------------------------

  if (use_plotly && do_plot) {
    y.name <- getOption("yname")
    if (is.null(y.name)) y.name <- "Count"
    if (y.name == "NULL") y.name <- "Count"

    # --- normalize shape for plotly ------------------------------------
    # 1-D: leave as-is
    if (length(dim(x.plt)) == 2L) {
      # we want: rows = by.levels, cols = x.levels
      rn <- rownames(x.plt)
      cn <- colnames(x.plt)

      # if row/col names are missing, rebuild from by.name/x.name
      if (is.null(rn)) rn <- paste0(by.name, "_", seq_len(nrow(x.plt)))
      if (is.null(cn)) cn <- paste0(x.name,  "_", seq_len(ncol(x.plt)))

      x.plt <- as.table(x.plt)
      dimnames(x.plt) <- list(rn, cn)
      names(dimnames(x.plt)) <- c(by.name, x.name)
    }

    plt <- .bc.plotly(
      x.plt, x.name, y.name, by.name, x.lab, y.lab,
      fill, color, opacity = NULL,
      beside, horiz,
      ax.info, gridT,
      digits_d, main=main,
      rotate_x=rotate_x, counts = x.plt.count,
      gap = gap.user, break_x = break_x,
      labels_decimals = labels_decimals.user,
      legend_title = legend_title, legend_position = legend_position,
      legend_labels = legend_labels.user,
      legend_horiz = legend_horiz.user,
      legend_size = legend_size, legend_abbrev = legend_abbrev,
      legend_adjust = legend_adj,
      labels = labels,
      labels_size = labels_size,
      labels_color = labels_color,
      style_opts = style_opts %||% .plotly_style()
    )

    if (.allow.interactive())
      .viewer_notice_once(plot_name = "bar chart", window_target = "Both")
    if (.allow.interactive())
      print(plt)
  }  #end use_plotly

  cat("\n")
  return(stats)

}

prob_znorm <- 
function(mu=0, sigma=1, color_border="gray10",
         r=.10, g=.34, b=.94, a=.20,
         xlab="", ylab="", main="", 
         y_axis=FALSE, z=TRUE, axis_size=.9,
         pdf_file=NULL, width=5, height=5, ...) {


# plot normal curve with integer SD lines
    
  if ( (r<0 || r>1)  ||  (g<0 || g>1)  || (b<0 || b>1)  ||  (a<0) || a>1) { 
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Values of r, g, b and a must all be between 0 and 1, inclusive.\n\n")
  }

  if (mu==0  && sigma==1) z <- FALSE

  xmin <- mu - 4*sigma
  xmax <- mu + 4*sigma

  cuts <- seq(xmin,xmax,sigma)

  color_sig <- rgb(r, g, b, a)
  #par(mar=c(3, 3, 1, 2), mgp=c(2,.6,0))

  # Normal Curve
  x <- seq(xmin, xmax, length=200)
  y <- dnorm(x ,mean=mu ,sd=sigma)

  orig.params <- par(no.readonly=TRUE)
  if (sys.nframe() == 1) { # no new window if called from sim.CLT
    .opendev(pdf_file, width, height)
#   par(mar=c(3,2,1.75,2), mgp=c(1,.5,0))
  }

  base::plot(x,y, type="l", lwd=2, col=color_border, axes=FALSE,
             xlab="", ylab="", main=main)
  if (z)
    title(xlab=xlab, line=3.5)
  else
    title(xlab=xlab)

  abline(h=0)
  axis(side=1, at=cuts, cex.axis=axis_size)
  if (z) axis(side=1, at=cuts, cex.axis=axis_size, line=1.5, labels=-4:4,
         lwd=0, lwd.ticks=0)
  if (y_axis) {
    axis(side=2, cex.axis=axis_size)
    if (ylab == "") ylab="Normal Density"
    title(ylab=ylab)
  }

  segments(mu, 0, mu, dnorm(mu, mean=mu, sd=sigma), col=color_border,
           lty="dotted")

  xsub <- x>(mu-3*sigma) & x<(mu+3*sigma)
  polygon(c(mu-3*sigma,x[xsub],mu+3*sigma), c(0,y[which(xsub)],0),
          col=color_sig, border=color_border, lty="dotted")

  xsub <- x>(mu-2*sigma) & x<(mu+2*sigma)
  polygon(c(mu-2*sigma,x[xsub],mu+2*sigma), c(0,y[which(xsub)],0),
          col=color_sig, border=color_border, lty="dotted")

  xsub <- x>(mu-sigma) & x<(mu+sigma)
  polygon(c(mu-sigma,x[xsub],mu+sigma), c(0,y[which(xsub)],0),
          col=color_sig, border=color_border, lty="dotted")

  # terminate pdf graphics system
  par(orig.params)        
  if (!is.null(pdf_file)) {
    dev.off()
    .showfile(pdf_file, "Normal curve probability")
  }

}

.reg6mod <-
function(lm.out, w.nm, x.nm, 
         digits_d, pdf=FALSE, width=5, height=5, manage.gr=FALSE, ...) {

  nm <- all.vars(lm.out$terms)  # names of vars in the model
  n.vars <- length(nm)
  n.keep <- nrow(lm.out$model)

  # pdf graphics option
  go.pdf <- pdf  # save before grDevices::pdf() would shadow the name
  if (go.pdf) {
    pdf_file <- "mod.pdf"
    grDevices::pdf(file=pdf_file, width=width, height=height)
  }

  # keep track of the plot in this routine
  plt.i <- 0L
  plt.title  <- character(length=0)

  plt.i <- plt.i + 1L
  plt.title[plt.i] <- "Moderator Variable Interaction Plot"

  max.width=.4
  margs <- .plt.marg(max.width, y.lab=nm[1], x.lab=nm[2], main=NULL, sub=NULL)
  lm.mar <- margs$lm
  tm <- margs$tm
  rm <- margs$rm + .85  # allow for legend
  bm <- margs$bm + .3

  par(bg=getOption("window_fill"))
  orig.params <- par(no.readonly=TRUE)
  on.exit(par(orig.params))
  par(mai=c(bm, lm.mar, tm, rm))

  tx <- character(length = 0)

  mn.x <- min(lm.out$model[, x.nm])
  mx.x <- max(lm.out$model[, x.nm])
  mn.y <- min(lm.out$model[, 1])
  mx.y <- max(lm.out$model[, 1])
  plot(c(mn.x,mx.x), c(mn.y,mx.y), type="n", xlab=x.nm, ylab=nm[1])

  x.ind <- which(names(lm.out$model) == x.nm)
  w.ind <- which(names(lm.out$model) == w.nm)
  b0 <- lm.out$coefficients[1]
  bx <- lm.out$coefficients[x.ind]
  bw <- lm.out$coefficients[w.ind]
  # locate interaction term by name (handles any predictor ordering)
  xw.nm <- names(lm.out$coefficients)
  xw.ind <- which(grepl(x.nm, xw.nm, fixed=TRUE) & grepl(w.nm, xw.nm, fixed=TRUE))
  bxw <- lm.out$coefficients[xw.ind]

  clr.u1 <- getColors("hues", n=2)[1]  # up 1 sd
  clr.0  <- "gray20"
  clr.d1 <- getColors("hues", n=2)[2]        # down 1 sd
  
  # wc is the constant value of mod W variable, 3 possibilities
  m.w <- mean(lm.out$model[, w.nm])
  s.w <- sd(lm.out$model[, w.nm])
  tx[length(tx)+1] <- paste("Mean of ", w.nm,": ", .fmt(m.w,digits_d), sep="")
  tx[length(tx)+1] <- paste("SD of   ", w.nm,": ", .fmt(s.w,digits_d), sep="")
  tx[length(tx)+1] <- ""

  wc <- m.w+s.w; b.0 <- b0 + bw*wc; b.1 <- bx + bxw*wc
  tx[length(tx)+1] <- paste("mean+1SD for ", w.nm,
         ":  b0=", round(b.0,digits_d), "  b1=", round(b.1,digits_d), sep="")
  abline(b.0, b.1, col=clr.u1, lwd=1.5)

  wc <- m.w; b.0 <- b0 + bw*wc; b.1 <- bx + bxw*wc
  tx[length(tx)+1] <- paste("mean     for ", w.nm,
         ":  b0=", round(b.0,digits_d), "  b1=", round(b.1,digits_d), sep="")
  abline(b.0, b.1, col=clr.0, lwd=1)

  wc <- m.w-s.w; b.0 <- b0 + bw*wc; b.1 <- bx + bxw*wc
  tx[length(tx)+1] <- paste("mean-1SD for ", w.nm,
         ":  b0=", round(b.0,digits_d), "  b1=", round(b.1,digits_d), sep="")
  abline(b.0, b.1, col=clr.d1, lwd=1.5)

  lbls <- c("+1SD", "Mean", "-1SD")
  text.cex <- ifelse(is.null(getOption("axis_x_size")),
                   getOption("axis_size"), getOption("axis_x_size"))
  if (text.cex > 0.99) text.cex <- .7  * text.cex
  clr <- c(clr.u1, clr.0, clr.d1)
  l.typ <- c("solid", "solid", "solid")

  .plt.legend(lbls, FALSE, clr, "transparent", "", rgb(.98,.98,.98), par("usr"), 
             legend_title=w.nm, lab_size=text.cex, line_type=l.typ)


  if (go.pdf) {
    dev.off()
    .showfile(pdf_file, "moderator interaction plot")
  }

  return(invisible(list(i=plt.i, ttl=plt.title, out_mod=tx)))

}

date.infer <- function (x.call, quiet) {


.charToDate <- function(char, punct, quiet) {

  txt <- character(length=4)
  txt[1] <- "\nTo see all possible formats, enter: ?strptime\n"
  txt[2] <- "Examples:  \"08/18/2024\" format is \"%m/%d/%Y\"\n"
  txt[3] <- "           \"18-08-24\"   format is \"%d-%m-%y\"\n"
  txt[4] <- "           \"August 18, 2024\" format is \"%B %d, %Y\"\n\n"

  dc <- strsplit(char, punct)  # Extract dc, date components
  c1 <- as.numeric(sapply(dc, function(x) x[1]))
  c2 <- as.numeric(sapply(dc, function(x) x[2]))
  c3 <- as.numeric(sapply(dc, function(x) x[3]))
  mx1 <- max(c1);  mx2 <- max(c2);  mx3 <- max(c3)
  unq1 <- length(unique(c1)); unq2 <- length(unique(c2))

  if (!is.na(mx1) && !is.na(mx2)) {  # non-numeric chars entered for a date
    fmt <- NULL

    # date format is correctly inferred if proper dates
    if (mx1 > 31)
      fmt <- paste("%Y", punct, "%m", punct, "%d", sep="")
    else if (mx1 > 12)
      fmt <- paste("%d", punct, "%m", punct, "%Y", sep="")
    else if (mx2 > 12)
      fmt <- paste("%m", punct, "%d", punct, "%Y", sep="")

    # guess at date format
    else if (unq2<=12 && (unq2 %in% c(2,4,12)))
      fmt <- paste("%d", punct, "%m", punct, "%Y", sep="")
    else if (unq1<=12 && (unq1 %in% c(2,4,12)))
      fmt <- paste("%m", punct, "%d", punct, "%Y", sep="")

    # allow for 2-digit year, is positioned  at 3rd component
    if (!is.null(fmt)) {
      if (substr(fmt,2,2) != "Y") {
        if (mx3 <= 99) fmt <- sub("Y", "y", fmt, fixed=TRUE)
       }
    }

    # obtain only valid dates
    dates <- try(as.Date(char, format=fmt), silent=FALSE)

    # process valid dates further to obtain the likely correct valid date
    if (!inherits(dates, "try-error") && all(!is.na(dates))) {  # no errors
        if (!quiet) {
          message("\nBest guess for the date format: ", fmt, "\n")
          message("Otherwise, specify with parameter: ts_format", txt, "\n")
        }
        return(dates)  # Return converted dates
    }
  }  # all chars numeric

  else {  # some non-numeric chars in at least one date
    message("\n"); stop(call.=FALSE, "\n------\n",
      "At least one date contains non-numeric characters\n",
      "  where there should be a number.\n")
  }

  # date not recognized
  # only way to get here is if date did not work
  message("\n"); stop(call.=FALSE, "\n------\n",
    "The date format could not be properly inferred.\n\n",
    "Specify the date format with:  ts_format", txt, "\n")
}  # end .charToDate


# BEGIN -------------------------------------------------------------------

  x11 <- x.call[1,1]

  n.ch <- nchar(x11)
  if (n.ch %in% 6:10) {
    isQ <- grepl("Q1|Q2|Q3|Q4", x11)
    isM <- grepl("Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec", x11)
    if (isM) {
      x.call[,1] <- gsub(" ", "", x.call[,1])  # remove all spaces
      year <- substr(x.call[,1], 1, 4)
      monthNm <- substr(x.call[,1], 5, 7)
      x.call[,1] <- as.Date(paste(year, monthNm, "01", sep="-"),
                             format="%Y-%b-%d")
    }
    else if (isQ) {  # convert dates entered as 2024 Q3 to R Date
      parts <- strsplit(gsub("\\s+", "", x.call[,1]), "Q")  # remove Q
      # Extract quarter, `[` is R extraction operator
      year <- as.numeric(sapply(parts, `[`, 1))  # 1st list element (year)
      quarter <- as.numeric(sapply(parts, `[`, 2))  # 2nd list element
      month <- 1 + (quarter - 1) * 3  # get month Q1=1, Q2=4, Q3=7, Q4=10
      x.call[,1] <- as.Date(paste(year, month, "01", sep="-"))  #to Date
    }  # end quarter
    else {  # see if numeric numeric date format
      punct <- " "  # see if there are two punctuation delimiters
      if (length(gregexpr("/", x11, fixed=TRUE)[[1]]) == 2) punct <- "/"
      if (length(gregexpr("-", x11, fixed=TRUE)[[1]]) == 2) punct <- "-"
      if (length(gregexpr(".", x11, fixed=TRUE)[[1]]) == 2) punct <- "."
      if (punct %in% c("/", "-", "."))   # only evaluate probable dates
        x.call[,1] <- .charToDate(x.call[,1], punct, quiet)
    }  # numeric date format
  }  # end n.ch is 6, 7, 8

  return(x.call)
}

ss.pivot <- function(
  x, by = NULL,
  data,                         # REQUIRED data frame
  x.name = NULL,                # label for x (e.g., "Salary")
  by.name = NULL,               # label for by,  ignored if by is missing
  compute    = c(mean, median, sd, IQR, min, max),
  out_names  = c("Mean","Median","SD","IQR","Min","Max"),
  show_n     = TRUE,
  digits_d   = NULL,
  quiet      = isTRUE(getOption("quiet")),
  header     = TRUE,            # print header line
  print_result = TRUE,          # print table/header here (otherwise silent)
  debug      = FALSE
) {


  if (!is.data.frame(data)) stop("`data` must be a data frame.", call. = FALSE)

  pe      <- parent.frame()
  x_expr  <- substitute(x)
  by_expr <- substitute(by)

  # helper: is a symbol that also names a column in df?
  is_name_in_df <- function(e, df) is.symbol(e) && (deparse(e) %in% names(df))

  # --- detect x label ---
  x_disp <- if (!is.null(x.name) && nzchar(x.name)) x.name else deparse(x_expr)

  # --- initial (symbolic) by-missing test (no evaluation yet) ---
  by_missing <- missing(by) ||
                is.null(by_expr) ||
                (is.symbol(by_expr) && identical(by_expr, quote(NULL)))

  # PROBE the runtime value if not obviously missing
  by_val <- NULL
  if (!by_missing) {
    by_val <- try(eval(by_expr, envir = data, enclos = pe), silent = TRUE)
    if (inherits(by_val, "try-error"))
      by_val <- try(eval(by_expr, envir = pe), silent = TRUE)  # already try()
    # If it evaluates to NULL or length 0, treat as missing-by
    if (!inherits(by_val, "try-error") && (is.null(by_val) ||
        length(by_val) == 0)) {
      by_missing <- TRUE
      by_val <- NULL
    }
  }

  # by label (resolved only if grouped)
  by_disp <- if (!by_missing) {
    if (!is.null(by.name) && nzchar(by.name)) by.name else deparse(by_expr)
  } else ""

  # --- Build DF and symbols for pivot() ---
  if (is_name_in_df(x_expr, data)) {
    DF    <- data
    x_sym <- x_expr
  } else {
    x_vals <- try(eval(x_expr, envir = data, enclos = pe), silent = TRUE)
    if (inherits(x_vals, "try-error"))
      x_vals <- try(eval(x_expr, envir = pe), silent = TRUE)
    if (!nzchar(x_disp)) x_disp <- "Value"
    if (is.data.frame(x_vals)) {
      DF <- x_vals
    } else {
      DF <- data.frame(x_vals, check.names = TRUE)
      names(DF) <- x_disp
    }
    x_sym <- as.name(x_disp)
  }

  # ensure numeric aggregated variable
  x_nm <- deparse(x_sym)
  if (!is.numeric(DF[[x_nm]]))
    DF[[x_nm]] <- suppressWarnings(as.numeric(DF[[x_nm]]))
  if (!is.numeric(DF[[x_nm]]))
    stop("Aggregated variable `", x_nm,
         "` must be numeric after coercion.", call. = FALSE)

  # if grouping, ensure BY is a symbol/column in DF
  if (!by_missing) {
    if (is_name_in_df(by_expr, DF)) {
      by_sym <- by_expr
    } else {
      # use probed value (already evaluated); if not available, evaluate now
      if (is.null(by_val) || inherits(by_val, "try-error")) {
        by_val <- try(eval(by_expr, envir = data, enclos = pe), silent = TRUE)
        if (inherits(by_val, "try-error")) by_val <- eval(by_expr, envir = pe)
      }
      if (length(by_val) != nrow(DF))
        stop("`by` length (", length(by_val),
             ") must match number of rows (", nrow(DF), ").", call. = FALSE)
      if (!nzchar(by_disp)) by_disp <- "Group"
      DF[[by_disp]] <- by_val
      by_sym <- as.name(by_disp)
    }
  }

  compute_call <- substitute(compute)

  if (isTRUE(debug)) {
    cat("\n--- PIVOT SANITY CHECK ---\n")
    cat("Columns:         ", paste(names(DF), collapse = ", "), "\n")
    cat("Variable symbol: ", x_nm, "  (x.name:", x_disp, ")\n")
    if (by_missing) cat("By:              <none>\n")
    else cat("By symbol:       ", deparse(by_sym), "  (by.name:", by_disp, ")\n")
    cat("Compute:         ", paste(deparse(compute_call), collapse = " "), "\n")
    cat("--------------------------\n\n")
  }

  # --- Build pivot() call safely ---
  pv_call <- NULL
  if (by_missing) {
    pv_call <- substitute(
      lessR::pivot(
        data      = DF_,
        compute   = COMP_,
        variable  = VAR_,
        out_names = OUT_,
        show_n    = SHOW_,
        digits_d  = DIG_,
        quiet     = QUIET_
      ),
      list(
        DF_    = DF,
        COMP_  = compute_call,
        VAR_   = x_sym,
        OUT_   = out_names,
        SHOW_  = show_n,
        DIG_   = digits_d,
        QUIET_ = quiet
      )
    )
  } else {
    pv_call <- substitute(
      lessR::pivot(
        data      = DF_,
        compute   = COMP_,
        variable  = VAR_,
        by        = BY_,
        out_names = OUT_,
        show_n    = SHOW_,
        digits_d  = DIG_,
        quiet     = QUIET_
      ),
      list(
        DF_    = DF,
        COMP_  = compute_call,
        VAR_   = x_sym,
        BY_    = by_sym,
        OUT_   = out_names,
        SHOW_  = show_n,
        DIG_   = digits_d,
        QUIET_ = quiet
      )
    )
  }

  if (is.null(pv_call)) stop("Internal error: pv_call not set.", call. = FALSE)

  res <- eval(pv_call)
  # --- Header & labeling / printing control ---
  if (print_result && isTRUE(header)) {
    if (by_missing) {
      cat(x_disp, "\n\n")
    } else {
      cat(x_disp, "  by  ", by_disp, "\n\n")
    }
  }

  # For grouped case: ensure displayed first column label = by.name (if provided)
  if (!by_missing && !is.null(by.name) && nzchar(by.name) &&
      inherits(res, "data.frame")) {
    names(res)[1] <- by.name
  }

  if (print_result) {
    if (is.character(res)) {
      cat(paste(res, collapse = "\n"), "\n")
    } else if (inherits(res, "data.frame")) {
      print(res, row.names = FALSE)
    } else {
      print(res)
    }
  }

  invisible(res)
}

.plt.bubble <-
function(x, y, size, radius, power, fill, color,
         size_cut, prop, bubble_text, object, pt.trans) {

  cords <- data.frame(x, y, size)
  cords <- na.omit(cords)

  # scale for regular R or RStudio
  adj <- .RSadj(radius=radius)  # reg R multiply by 1.6
  radius <- adj$radius

  fill.alpha <- fill
# fill.alpha <- .maketrans(fill, pt.trans)  # wipes out all fill color
  sz <- cords[,3]**power  # radius unscaled for all the points
  symbols(cords[,1], cords[,2], circles=sz, inches=radius,
          fg=color, bg=fill.alpha, add=TRUE)
  mxru <- max(sz)
  sz <- 2 * (sz/mxru) * radius  # scaled diameter


# text on the bubbles -----------------------------------------------------

  if (size_cut  &&  object == "bubble") {  

    # get q.ind before setting too small bubbles for text at NA
    if (size_cut > 1) {
      by.prob <- 1 / (size_cut - 1)
      bub.probs <- seq(0, 1, by.prob)
      qnt <- quantile(cords[,3], probs=bub.probs, type=3, na.rm=TRUE)
      qnt.TF <- logical(length(cords))
      for (i in 1:nrow(cords))  # 3rd column of cords is size
          qnt.TF[i] <- ifelse(cords[i,3] %in% qnt, TRUE, FALSE)
      q.ind <- which(qnt.TF)
    }
    else
      q.ind <- 1:nrow(cords)  # all bubbles get text

    # should get size of each amount just for those displayed (q.ind)
    sz.cex <- numeric(length=nrow(cords))
    for (i in 1:nrow(cords)) {
      sz.cex[i] <- getOption("axis_size")  # cex target for text size
      # target for text size
      sz.txt <- strwidth(cords[i,3], units="inches", cex=sz.cex[i])
      while ((sz.txt - sz[i]) > -.01) {
        if (sz.cex[i] > 0.45) {  # need cex larger than 0.45
          sz.cex[i] <- sz.cex[i] - 0.02
          sz.txt <- strwidth(cords[i,3], units="inches", cex=sz.cex[i])
        }
        else {
          cords[i,3] <- NA
          break;
        }
      }
      if (options("device") != "RStudioGD")
        sz.cex[i] <- sz.cex[i] * 1.3
    }

    # write bubble text
    if (!prop) {
      if (bubble_text != "transparent")
        text(cords[q.ind,1], cords[q.ind,2], labels=cords[q.ind,3],
            cex=sz.cex[q.ind], col=bubble_text)
    }
    else {
      crd <- .fmt0(cords[,3],2)
      for (j in 1:length(crd))
        if (grepl("NA", crd[j], fixed=TRUE)) crd[j] <- " "
      if (bubble_text != "transparent")
        text(cords[,1], cords[,2], crd, cex=sz.cex, col=bubble_text)
    }
  }  # end (size_cut  &&  object == "bubble")
}

.TwoGroup <-
function(YA, YB, n1, n2, m1, m2, s1, s2, from.data,
         Ynm, Xnm, X1nm, X2nm, brief, digits_d,
         conf_level, alternative, mmd, msmd, Edesired, bw1, bw2,
         graph, xlab, line_chart, show_title,
         full_curve=TRUE, quiet, pdf_file, width, height,
         fill=NULL, fill_area=TRUE, ...)  {
 
  if ( brief  &&  !quiet  &&  (!is.null(mmd) || !is.null(msmd)) ) { 
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "mmd and msmd do not work with the brief version.\n\n")
  }

  # get lab_x_size  lab_y_size
  lab_size <- getOption("lab_size")
  lab_x_size <- getOption("lab_x_size")
  lab_x_size <- ifelse(is.null(lab_x_size), lab_size, lab_x_size)
  adj <- .RSadj(lab_size=lab_x_size); lab_x_size <- adj$lab_size

  # get variable labels if exist plus axes labels
  gl <- .getlabels(xlab=NULL, ylab=xlab, main=NULL, lab_x_size=lab_x_size,
                   graph.win=FALSE)  # # graphics window not yet set-up
  x.name <- gl$yn; x.lbl <- gl$yl; x.lab <- gl$yb

  # get variable labels if exist
  options(xname = Xnm)
  options(yname = Ynm)
  gl <- .getlabels(graph.win=FALSE)  # graphics window not yet set-up
  x.lbl <- gl$xl
  y.lbl <- gl$yl
  if (is.null(y.lbl)) y.lbl <- Ynm

  if (!quiet) {
    cat("Compare", Ynm, "across", Xnm, "with levels", X1nm, "and", X2nm, "\n")
  # cat("--------------------------------------------------------------\n\n")

    if (!is.null(x.lbl))
      cat("Grouping Variable:  ", Xnm, ", ", as.character(x.lbl), sep="", "\n")
    else
      cat("Grouping Variable:  ", Xnm, sep="", "\n")
    if (Ynm != as.character(y.lbl))
      cat("Response Variable:  ", Ynm, ", ", as.character(y.lbl), sep="", "\n")
    else 
      cat("Response Variable:  ", Ynm, sep="", "\n")
    cat("\n")

    if (!brief)
       cat("\n------ Describe ------\n\n")
    else
      cat("\n --- Describe ---\n\n")
  }  # end !quiet


  if (from.data) {
    n1 <- sum(!is.na(YA))
    n2 <- sum(!is.na(YB))
    n1.miss <- sum(is.na(YA))
    n2.miss <- sum(is.na(YB))
    YA <- na.omit(YA)
    YB <- na.omit(YB)
    m1 <- mean(YA)
    m2 <- mean(YB)
    s1 <- sd(YA)
    s2 <- sd(YB)
    v1 <- var(YA)
    v2 <- var(YB)
  }
  else {
    v1 <- s1^2
    v2 <- s2^2
  }

  if (from.data) dig.smr.d  <- digits_d  else dig.smr.d <- digits_d - 1

  clpct <- paste(toString(round((conf_level)*100, 2)), "%", sep="")
  Xnmval <- paste(Xnm, X1nm)
  if (!quiet) {
    cat(Ynm, " for ", Xnmval, ":  ", sep="")
    if (from.data) cat("n.miss = ", n1.miss, ",  ", sep="")
    cat("n = ", n1, sep="")
    cat(",  mean = ", .fmt(m1,dig.smr.d), ",  sd = ", .fmt(s1,dig.smr.d),
        sep="", "\n")
  }  # end !quiet
  Xnmval <- paste(Xnm, X2nm)
  if (!quiet) {
    cat(Ynm, " for ", Xnmval, ":  ", sep="")
    if (from.data) cat("n.miss = ", n2.miss, ",  ", sep="")
    cat("n = ", n2, sep="")
    cat(",  mean = ", .fmt(m2,dig.smr.d), ",  sd = ", .fmt(s2,dig.smr.d),
        sep="", "\n")
    cat("\n")
  }  # end !quiet

  # sample mean difference
  mdiff <- m1 - m2
  if (!quiet)
    cat("Mean Difference of ", Ynm, ":  " , .fmt(mdiff), sep="", "\n")
  if (!brief) cat("\n")

# sw
  df1 <- n1 - 1
  df2 <- n2 - 1
  swsq <- (df1*v1 + df2*v2) / (df1 + df2)
  sw <- sqrt(swsq)
  if (!quiet)
    cat("Weighted Average Standard Deviation:  ", .fmt(sw), "\n")

  smd <- mdiff/sw
  if (brief && !quiet) 
    cat("Standardized Mean Difference of ", Ynm, ": ",
        .fmt(smd), sep="", "\n")

  if (!brief) {

    if (!quiet) {
      cat("\n\n------ Assumptions ------\n\n")

      cat("Note: These hypothesis tests can perform poorly, and the", "\n")
      cat("      t-test is typically robust to violations of assumptions.",
                 "\n")
      cat("      Use as heuristic guides instead of interpreting literally.",
          "\n\n")
    }  # end !quiet


    if (from.data) {
      if (!quiet) {

        # Normality
        cat("Null hypothesis, for each group, is a normal distribution of ",
            sep="")
        cat(Ynm, ".", sep="", "\n")
        if (n1 > 30) {
          cat("Group " , X1nm, ": ", sep="")
          cat("Sample mean assumed normal because n > 30, so no test needed.", 
              sep="", "\n")
        }
        else {
          cat("Group", X1nm, " ")
          if (n1 > 2 && n1 < 5000) {
            nrm1 <- shapiro.test(YA)
            W.1 <- nrm1$statistic
            p.val1 <- nrm1$p.value
            cat(nrm1$method, ":  W = ", .fmt(W.1,3), ",  p-value = ",
                .fmt(p.val1,3), sep="", "\n")
          }
        else
        cat("Sample size out of range for Shapiro-Wilk normality test.", "\n")
      }  
      if (n2 > 30) {
        cat("Group " , X2nm, ": ", sep="")
        cat("Sample mean assumed normal because n > 30, so no test needed.",
            sep="", "\n")
      }
      else {
        cat("Group", X2nm, " ")
        if (n2 > 2 && n2 < 5000) {
          nrm2 <- shapiro.test(YB)
          W.2 <- nrm2$statistic
          p.val2 <- nrm2$p.value
          cat(nrm2$method, ":  W = ", .fmt(W.2,3), ",  p-value = ",
              .fmt(p.val2,3), sep="", "\n")
        }
        else
          cat("Sample size out of range for Shapiro-Wilk normality test.", "\n")
      }  
      cat("\n")
    }  # end !quiet 
  } 

  # Homogeneity of Variance
  # Var Ratio
  if (v1 >= v2) {
    vratio <- v1/v2
      vr <- paste(.fmt(v1), "/", .fmt(v2), sep="")
      df.num <- df1
      df.den <- df2
  }
  else {
    vratio <- v2/v1
      vr <- paste(.fmt(v2), "/", .fmt(v1), sep="")
      df.num <- df2
      df.den <- df1
  }

  p.var <- pf(vratio, df1=df.num, df2=df.den)
  # adjust for two-sided test, results same as var.test{stats}
  p.var <- 2 * min(p.var, 1-p.var)

  if (!quiet) {
    cat("Null hypothesis is equal variances of ")
    cat(Ynm, ", homogeneous.", sep="", "\n")

    cat("Variance Ratio test:  F = ", vr, " = ", .fmt(vratio),
        ",  df = ", df.num, ";", 
        df.den, ",  p-value = ",  .fmt(p.var,3), sep="", "\n")
  }  # end !quiet

  if (from.data) { # Levene
    YAm <- abs(YA - median(YA))
      YBm <- abs(YB - median(YB))
      t.bf <- t.test(YAm, YBm, var.equal=TRUE)
      tvalue.bf <- t.bf$statistic
      df.bf <- t.bf$parameter
      pvalue.bf <- t.bf$p.value
      if (!quiet) {
        cat("Levene's test, Brown-Forsythe:  t = ", .fmt(tvalue.bf,3),
            ",  df = ", df.bf, sep="")
        cat(",  p-value = ", .fmt(pvalue.bf,3), sep="", "\n")
      }  # end !quiet
  }
}


  if (!quiet) {
    if (!brief)
      cat("\n\n------ Infer ------\n\n")
    else 
      cat("\n --- Infer ---\n\n")
  }  # end !quiet
  

  # t-test
  if (alternative == "two_sided")
    alt <- "two.sided"
  else
    alt <- alternative

  sterr <- sw * sqrt(1/n1 + 1/n2)
  df <- df1 + df2
  if (alternative == "two_sided")
    tcut <- qt((1-conf_level)/2, df=df, lower.tail=FALSE)
  else if (alternative == "less")
    tcut <- qt(1-conf_level, df=df, lower.tail=FALSE)
  else if (alternative == "greater")
    tcut <- qt(1-conf_level, df=df, lower.tail=FALSE)

  if (from.data) {
    ttest <- t.test(YA, YB, var.equal=TRUE, conf.level=conf_level,
                    alternative=alt)
    lb <- ttest$conf.int[1]
    ub <- ttest$conf.int[2]
    E <- (ub-lb) / 2
    tvalue <- ttest$statistic
    pvalue <- ttest$p.value
  }
  else {
    sterr <- sw * sqrt(1/n1 + 1/n2)
    E <- tcut*sterr
    lb <- mdiff-E
    ub <- mdiff+E
    tvalue <- mdiff/sterr
    if (alternative == "two_sided")
      pvalue <- 2 * pt(abs(tvalue), df=df, lower.tail=FALSE)
    else if (alternative == "less")
      pvalue <- pt(tvalue, df=df, lower.tail=TRUE)
    else if (alternative == "greater")
      pvalue <- pt(tvalue, df=df, lower.tail=FALSE)
  }

  if (!quiet) {
    if (!brief)
      cat("--- Assume equal population variances of", Ynm, "for each", Xnm,
          "\n\n")
    cat("t-cutoff for ", clpct, " range of variation: tcut = ", .fmt(tcut,3), "\n") 
    cat("Standard Error of Mean Difference: SE = ", .fmt(sterr), "\n")
   
    mytitle <- "\nHypothesis Test of 0 Mean Diff:  t-value = "
    if (alt != "two.sided") 
      cat("\nAlternative hypothesis: Population mean difference is", alt, 
          "than 0")
    cat(mytitle, .fmt(tvalue,3), ",  df = ", df, ",  p-value = ", .fmt(pvalue,3),
        sep="", "\n\n")
    cat("Margin of Error for ", clpct, " Confidence Level:  ", .fmt(E), sep="",
        "\n")
    cat(clpct," Confidence Interval for Mean Difference:  ", .fmt(lb), " to ",
        .fmt(ub), sep="", "\n\n")
  }  # end !quiet

  if (!brief) {
    k1 <- v1/n1
    k2 <- v2/n2
    df.ne <- ((k1 + k2)^2) / ((k1^2)/(n1-1) + (k2^2)/(n2-1))
    sterr.ne <- sqrt(k1 + k2)
    if (alternative == "two_sided")
      tcut.ne <- qt((1-conf_level)/2, df=df.ne, lower.tail=FALSE)
    else if (alternative == "less")
      tcut.ne <- qt(1-conf_level, df=df.ne, lower.tail=FALSE)
    else if (alternative == "greater")
      tcut.ne <- qt(1-conf_level, df=df.ne, lower.tail=FALSE)

    if (from.data) {
      ttne <- t.test(YA, YB, var.equal=FALSE, conf.level=conf_level,
                     alternative=alt)
      df.ne <- ttne$parameter
      lb.ne <- ttne$conf.int[1]
      ub.ne <- ttne$conf.int[2]
      E.ne <- (ub.ne-lb.ne)/2
      tvalue.ne <- ttne$statistic
      pvalue.ne <- ttne$p.value
    }
    else {
      E.ne <- tcut.ne*sterr.ne
      lb.ne <- mdiff-E.ne
      ub.ne <- mdiff+E.ne
      tvalue.ne <- mdiff / sterr.ne
    if (alternative == "two_sided")
      pvalue.ne <- 2 * pt(abs(tvalue.ne), df=df.ne, lower.tail=FALSE)
    else if (alternative == "less")
      pvalue.ne <- pt(tvalue.ne, df=df.ne, lower.tail=TRUE)
    else if (alternative == "greater")
      pvalue.ne <- pt(tvalue.ne, df=df.ne, lower.tail=FALSE)
    }

    if (!quiet) {
      cat("\n--- Do not assume equal population variances of", Ynm, "for each",
          Xnm, "\n\n")
      cat("t-cutoff: tcut = ", .fmt(tcut.ne,3), "\n") 
      cat("Standard Error of Mean Difference: SE = ", .fmt(sterr.ne), "\n")
      mytitle <- "\nHypothesis Test of 0 Mean Diff:  t = "
      cat(mytitle, .fmt(tvalue.ne,3), ",  df = ", .fmt(df.ne,3), 
          ", p-value = ", .fmt(pvalue.ne,3), sep="", "\n\n")
      cat("Margin of Error for ", clpct, " Confidence Level:  ", .fmt(E.ne),
          sep="", "\n")
      cat(clpct," Confidence Interval for Mean Difference:  ", .fmt(lb.ne),
          " to ", .fmt(ub.ne), sep="", "\n")
    }  # end !quiet

  }

  # mean difference and standardized mean difference
  if (!brief  && !quiet) {
    cat("\n\n------ Effect Size ------\n\n")
    cat("--- Assume equal population variances of", Ynm, "for each", Xnm,
        "\n\n")
    cat("Standardized Mean Difference of ", Ynm, ", ",
        "Cohen's d:  ", .fmt(smd), sep="", "\n")
  }  # end !quiet

  # MBESS function
  #cid <- ci.smd(smd=smd, n.1=n1, n.2=n2, conf_level=conf_level)  
  #deltaL <-cid$Lower.Conf.Limit.smd
  #deltaU <- cid$Upper.Conf.Limit.smd
  #if (!brief) cat("\n")
  #cat(clpct," Confidence Interval for smd:  ",
      #.fmt(deltaL), " to ", .fmt(deltaU), sep="", "\n")

  if (!brief) {
    if ( !is.null(mmd) || !is.null(msmd) ) {
      if (!is.null(mmd)) msmd <- mmd / sw
      else if (!is.null(msmd)) mmd <- msmd * sw
    }
  }

  if (!brief  && !quiet) {
    cat("\n\n------ Practical Importance ------\n\n")
    cat("Minimum Mean Difference of practical importance: mmd\n")
    if ( !is.null(mmd) || !is.null(msmd) ) {
      cat("Compare mmd =", .fmt(mmd,digits_d),
          " to the obtained value of md = ", .fmt(mdiff), "\n")
      cat("Compare mmd to the confidence interval for md: ", .fmt(lb), " to ", 
          .fmt(ub), "\n\n")
      cat("Minimum Standardized Mean Difference of practical importance: msmd\n")
      cat("Compare msmd = ", .fmt(msmd,digits_d),
          " to the obtained value of smd = ", .fmt(smd),"\n")
    }
    else {
      cat("Minimum Standardized Mean Difference of practical importance: msmd\n")
      cat("Neither value specified, so no analysis\n")
    }
  }

  # needed sample size from Edesired
  if (!is.null(Edesired)) {
    zcut <- qnorm((1-conf_level)/2)
    ns <- 2*((zcut*sw)/Edesired)^2 
    n.needed <- ceiling(1.099*ns + 4.863) 
    if (!quiet) {
      cat("\n\n------ Needed Sample Size ------\n\n")
      if (Edesired > E) {
        cat("Note: Desired margin of error,", .fmt(Edesired), 
           "is worse than what was obtained,", .fmt(E), "\n\n") 
      }
      cat("Desired Margin of Error: ", .fmt(Edesired), "\n")
      cat("\n")
      cat("For the following sample size there is a 0.9 probability of obtaining\n")
      cat("the desired margin of error for the resulting ", clpct, " confidence interval.\n")
      cat("-------\n")
      cat("Needed sample size per group: ", n.needed, "\n")
      cat("\n")
      cat("Additional data values needed Group 1: ", n.needed-n1, "\n")
      cat("Additional data values needed Group 2: ", n.needed-n2, "\n")
    }  # end !quiet
  }

  # graphs
  if (from.data && graph) {

    # keep track of the number of plots in this routine, see if manage graphics
    plt.i <- 0
    plt.title  <- character(length=0)
    manage.gr <- .graphman()

    if (is.null(pdf_file)) {
      if (manage.gr) {
        n.win <- ifelse (!line_chart, 1, 3)
        .graphwin(n.win, width, height)
        i.win <- 2   # start first graphics window on 3
        orig.params <- par(no.readonly=TRUE)
        on.exit(par(orig.params))
     }
    }

    if (line_chart) { 

      if (!is.null(pdf_file))
        pdf(file=paste("LineChart_",X1nm,".pdf",sep=""),
             width=width, height=height)

      if (manage.gr) {
        i.win <- i.win + 1 
        dev.set(which=i.win)
      }

      plt.i <- plt.i + 1
      plt.title[plt.i] <- paste("Sequentially Ordered Data:", paste(Xnm, X1nm))

      YA.df <- data.frame(YA)
      x.df <- data.frame(1:nrow(YA.df))
      .plt.main(x.df, YA.df, segments=TRUE, size=.85,
                center_line="median", fill=getOption("pt_fill"),
                xlab="Index", ylab=paste(Ynm,": ",X1nm, sep=""),
                main=plt.title[plt.i],
                use_plotly=FALSE)

      if (!is.null(pdf_file)) {
        dev.off()
        .showfile(paste("LineChart_", X1nm, ".pdf", sep=""),
                  paste("line chart of", X1nm))
      }

      if (manage.gr) {
        i.win <- i.win + 1 
        dev.set(which=i.win)
      }

      plt.i <- plt.i + 1
      plt.title[plt.i] <- paste("Sequentially Ordered Data:", paste(Xnm, X2nm))

      YB.df <- data.frame(YB)
      x.df <- data.frame(1:nrow(YB.df))
      .plt.main(x.df, YB.df, segments=TRUE, size=.85,
                center_line="median", fill=getOption("pt_fill"),
                xlab="Index", ylab=paste(Ynm,": ",X2nm, sep=""),
                main=plt.title[plt.i], use_plotly=FALSE)
 
      if (!is.null(pdf_file)) {
        dev.off()
        .showfile(paste("LineChart_", X2nm, ".pdf", sep=""),
                  paste("line chart of", X2nm))
      }
    }


    # two density graphs
    # prepare graphics window, dev or pdf

    if (!is.null(pdf_file))
      .opendev(pdf_file, width, height)
    else {
      if (manage.gr) {
        i.win  <- i.win + 1 
        dev.set(which=i.win)
      }
    }

    plt.i <- plt.i + 1
    plt.title[plt.i] <- "Two-Group Plot"

    .TwoGraph(YA, YB, bw1, bw2, Ynm, Xnm, X1nm, X2nm, y.lbl, digits_d, brief,
              n1, m1, s1, n2, m2, s2, df, mdiff, sw, smd, mmd, msmd,
              clpct, tvalue, pvalue, ub, lb, x.lab, alt, show_title,
              full_curve=full_curve, quiet, fill=fill, fill_area=fill_area)

    if (!quiet) cat("\n")

    if (!is.null(pdf_file)) {
      dev.off()
      .showfile(pdf_file, paste("density plots of", Ynm, "for both groups"))
    }

    return(list(i=plt.i, ttl=plt.title))
  }
} # End Two Group

to <-
function(prefix, until, from=1, same_size=TRUE, ...) {


  # to("m",20, same_size=FALSE)
  # paste("m", 1:20, sep="")

  if (missing(prefix)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the characters to precede each name with: prefix\n\n")
  }

  if (missing(until)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the last name generated in the sequence with:  until\n\n")
  }

  if (from > until) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
       "The value of  until  must be greater than the value of  from .\n\n")
  }

  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (!is.null(dots)) if (length(dots) > 0) {
    for (i in 1:length(dots)) {
      if (names(dots)[i] == "same.size") same_size <- dots[[i]] 
      }
  }

  cstr <- character(length=0)
  for (ichar in (from:until)) {

    inum <- ifelse (same_size, until, ichar)
    nc <- nchar(as.character(inum))

    cc <- as.character(.fmtc(ichar, w=nc))
    for (i in 1:nchar(cc)) if (substr(cc,i,i) == " ") substr(cc,i,i) <- "0"
    cc <- paste(prefix, cc, sep="")
    cstr <- paste(cstr, cc)
  }

  nc <- nchar(cstr)
  cstr2 <- character(length=0)
  for (i in 2:nc) cstr2 <- paste(cstr2, substr(cstr,i,i), sep="")
  cstr2 <- strsplit(cstr2, " ")[[1]]

  return(cstr2)

}

details <-
function(data=d, n_mcut=1, max_lines=30,
         miss_show=30, miss_zero=FALSE, miss_matrix=FALSE, var_labels=FALSE,
         brief=getOption("brief")) {

  # get name of data table
  dname <- deparse(substitute(data))  # from read is called data

  # if a tibble convert to data frame
  dfs <- .getdfs()
  if (!is.null(dfs)) {
    if (dname %in% dfs) {  # tibble to df
      if (any(grepl("tbl", class(data), fixed=TRUE))) {
        data <- data.frame(data)
      }
    }
  }

  # feedback regarding data
  n.var <- ncol(data)
  n.obs <- nrow(data)
  max_lines <- min(max_lines, nrow(data))  #  max_lines now actual lines

  n.miss_tot <- sum(is.na(data))

  nu <- integer(length=n.var)

  if (!brief) {
    cat("\n")
    .dash(58)
    cat("Dimensions:", n.var, "variables over", n.obs, "rows of data")

    cat("\n\n")
    if (n.obs >= 2) {
      cat("First two row names:", row.names(data)[1],"   ", 
          row.names(data)[2], "\n")
      cat("Last two row names: ", row.names(data)[n.obs-1],
          "   ", row.names(data)[n.obs], "\n")
    } else {
      cat("Only one row, row name:", row.names(data)[1], "\n")
    }
    .dash(58)
  }

    reg.fac <- FALSE
    for (i in seq_len(n.var))
      if (is.factor(data[,i])  &&  !is.ordered(data[,i]))
        reg.fac <- TRUE

    ord.fac <- FALSE
    for (i in seq_len(n.var)) if (is.ordered(data[,i])) ord.fac <- TRUE

    chr.flg <- FALSE
    for (i in seq_len(n.var)) if (is.character(data[,i])) chr.flg <- TRUE

    int.flg <- FALSE
    for (i in seq_len(n.var)) if (is.integer(data[,i])) int.flg <- TRUE
    
    dte.flg <- FALSE
    for (i in seq_len(n.var)) if (inherits(data[,i], "Date")) dte.flg <- TRUE

    num.flg <- FALSE
    for (i in seq_len(n.var)) if (is.double(data[,i])) num.flg <- TRUE


    cat("Data Types\n")
    .dash(60)
    if (reg.fac) cat("factor: Non-numeric categories, read as unordered",
        "categories\n")
    if (ord.fac) cat("ordfactor: Ordered, non-numeric categories\n")
    if (chr.flg) cat("character: Non-numeric data values\n")
    if (int.flg) cat("integer: Numeric data values, integers only\n")
    if (dte.flg) cat("Date: Date with year, month and day\n")
    if (num.flg) cat("double: Numeric data values with decimal digits\n")
    .dash(60)
  cat("\n")

  #if (any(is.na(d)))
    #cat("NA indicates a missing data value, Not Available\n")
  #cat("\n")

  max.char <- 0
  width.nm <- 0  # initialise here so units block can use it if labels absent
  for (i in seq_len(n.var)) {
    x.name <- names(data)[i]
    if (nchar(x.name) > max.char) max.char <- nchar(x.name)
  }
  pad  <- if (max.char > 7) max.char + 2 else max.char + (10 - max.char)
  pad2 <- if (max.char > 8) max.char - 8 else 0
  if (!brief) cat("\n")
  cat("   ")  # account for variable number in first two columns
  cat(.fmtc(" Variable",9+pad2), .fmtc(" ",pad2+(16-pad2)),
      .fmtc("Missing",7), .fmtc("Unique",7), "\n")
  cat("   ")
  cat(.fmtc("     Name",max.char+1), .fmtc("Type",8), .fmtc("Values",7),
      .fmtc("Values",7), .fmtc("Values",7), "  First and last values\n")
  .dash(90)

  colm.ID <- 0
  maybe.ID <- NULL
  for (i in seq_len(n.var)) {

    x.name <- names(data)[i]

    nu[i] <- length(unique(na.omit(data[,i])))

    n <- sum(!is.na(data[,i]))
    n.miss <- sum(is.na(data[,i]))

    the.class <- class(data[,i])[1]  # could be an ordered factor
    if ("ordered" %in% the.class) the.class <- "ordfactor"
    if ("numeric" %in% the.class) the.class <- "double"

    cat(.fmti(i,2), .fmtc(x.name,pad-1), .fmtc(the.class,9), .fmti(n,6),
        .fmti(n.miss,7), .fmti(nu[i],7))

    n1 <- as.character(data[1,i])  # the as.character is for cat of factors
    n2 <- if (n.obs >= 2) as.character(data[2,i]) else ""
    n3 <- if (n.obs >= 3) as.character(data[3,i]) else ""
    e3 <- if (n.obs >= 5) as.character(data[n.obs-2,i]) else ""
    e2 <- if (n.obs >= 4) as.character(data[n.obs-1,i]) else ""
    e1 <- if (n.obs >= 2) as.character(data[n.obs,i]) else ""
    bn2 <- "  ";  bn3 <- "  ";  be2 <- "  ";  be3 <- "  "
    tot.char <- nchar(paste(n1,n2,n3,e3,e2,e1))
    if (tot.char > 34) {
      n3 <- "";  e3 <- ""; bn3 <- ""; be3 <- "";
    }
    if (tot.char > 58) {
      n2 <- ""; e2 <- ""; bn2 <- ""; be2 <- ""
    }
    cat("   ", n1, bn2, n2, bn3, n3, " ... ", e3, be3,  e2, be2,  e1, sep="")
    cat("\n")

    if (nu[i]==n  &&  ((is.factor(data[,i])) || (is.character(data[,i])))) {
      maybe.ID <- x.name
      colm.ID <- i
    }
  }
  .dash(90)

  if (colm.ID > 0  &&  !var_labels) {
    cat("\n\n")
    txt <- maybe.ID
    cat(
"For the column ", txt, ", each row of data is unique. Are these values\n",
"a unique ID for each row? To define as a row name, re-read the data file\n",
"with the following setting added to your Read() statement: row_names=", 
        toString(colm.ID), sep="")
  }

  if (!brief) {
    num.cat <- FALSE
    n_cat.temp  <- getOption("n_cat")
    for (j in seq_len(n.var)) {
      if (is.double(data[,j]) && nu[j] <= n_cat.temp) num.cat <- TRUE
    }
    if (num.cat) {
      cat("\n\n")
      cat("Each of these variables has numeric values, but has less than ",
          n_cat.temp, "\n",
          "unique values. Perhaps these variables are categorical. Consider\n",
          "to transform each variable into a factor with the\n",
          "factor() function.\n", 
          "Or, specify a value for n_cat, ",
          "such as:  > style(n_cat=4)\n", sep="")
      .dash(63)
      for (j in seq_len(n.var)) if (is.double(data[,j]) && nu[j] <= n_cat.temp)
        cat(names(data)[j], "\n")
      .dash(63)
    }
    
    cat("\n\n")

    if (n.miss_tot > 0) {  # missing data exists
      cat("Missing Data Analysis\n")
      .dash(60)
      
#     cat("n.miss ", "Observation\n")
      bad <- integer(length=miss_show)
      n.lines <- 0
      i <- 0
      # miss_zero lowers the cutoff to include rows with no missing data
      mcut <- if (miss_zero) 0 else n_mcut
      while ( i<n.obs && n.lines>=0 ) {
        i <- i + 1
        n.miss <- sum(is.na((data)[i, ]))
        if ( (n.miss >= mcut) && (n.lines < miss_show) ) {
          n.lines <- n.lines + 1
#         cat(n.miss, "     ", row.names(data[i, ]), "\n")
          bad[n.lines] <- i 
        }
        if (n.lines == miss_show) {
          n.lines <- -1
          if (miss_zero)
            cat("\nMore data rows remain beyond the first ", miss_show, ".\n",
              " Increase the default value of miss_show=30 to show more",
              "rows of data.\n")
          else
            cat("\nMore data rows have at least this many missing values: ",
                n_mcut, "\n",
              " Specify n_mcut=2 to see those lines with at least",
              "2 missing values, etc.\n",
              " Or increase the default value of miss_show=30 to show more",
              "rows of data with missing values.\n")
        }
      }  # end while

      cat("Number of cells in the data table: ", n.var*n.obs,"\n")
      cat("Number of missing data values: ", n.miss_tot,"\n")
      cat("Proportion of missing data values: ",
           round(n.miss_tot/(n.var*n.obs), 3), "\n")
      if (n.lines > -1) {
        if (miss_zero)
          cat("Number of rows of data listed: ", n.lines,"\n")
        else
          cat("Number of rows of data with missing values: ", n.lines,"\n")
      }
      .dash(60)
      cat("\n")
      print(data[bad, ])
      .dash(60)
      cat("\n")

      if (miss_matrix) {
        cat("\n\nTable of Missing Values, 1 means missing\n")
        print(matrix(as.double(is.na(data)), nrow=n.obs, ncol=n.var,
        dimnames = list(row.names(data), names(data)) ))
      }
          
    }  # end missing data processing

    else cat("No missing data\n\n")
  }


  # feedback regarding variable labels
  if (brief) cat("\n")
  l <- attr(data, which="variable.labels")
  myunits <- attr(data, which="variable.units")

  if (!is.null(l)) {
    cat("\nVariable Names   Variable Labels\n")
    n_rows <- length(l)
    n.lines <- min(max_lines, n_rows)

    mx.nm <- 0
    for (i in seq_len(n.lines)) {  # width of var names
      if (!is.na(l[i])) if (nchar(names(l)[i]) > mx.nm)
        mx.nm <- nchar(names(l)[i])
    }
    width.nm <- mx.nm + 1

    mx.ln <- 0
    nc <- 0
    for (i in seq_len(n.lines)) {  # get width of largest line
      if (!is.na(l[i])) nc <- nchar(as.character(l[i]))
      if (nc > mx.ln) mx.ln <- mx.nm + nc
    }
    width.ln <- max(mx.ln, nchar("Variable Names  Variable Labels"))
    width.ln <- min(width.ln + 3, 80)

    .dash(width.ln)
    for (i in seq_len(n.lines)) {
      blanks <- paste(rep(" ", width.nm-nchar(names(l)[i])), collapse="")
      if (is.na(l[i])) l[i] <- ""
      cat(names(l)[i], blanks, l[i], "\n")
    }
    .dash(width.ln)

    if (n_rows > n.lines) {
      cat("To see all the variable labels set max_lines =", n_rows, "\n")
      .dash(64)
    }
  }
  #else
  #  cat("No variable labels\n")

    cat("\n")


  # feedback regarding variable units

  if (!is.null(myunits)) {
    cat("\nVariable Names   Variable Units\n")
    n.units <- length(myunits)
    n.lines <- min(max_lines, n.units)

    width.ln <- width.nm
    for (i in seq_len(n.lines))  # get width of largest line
      if (!is.na(myunits[i]))
        width.ln <- max(width.ln, width.nm + nchar(as.character(myunits[i])))
    width.ln <- max(width.ln, 1+nchar("Variable Names  Variable Units"))

    .dash(width.ln)
    for (i in seq_len(n.lines)) {
      blanks <- paste(rep(" ", 15-nchar(names(myunits)[i])), collapse = "")
      if (is.na(myunits[i])) myunits[i] <- ""
      cat(names(myunits)[i], blanks, myunits[i], "\n")
    }
    .dash(width.ln)
  }
  #else
  #  cat("No variable units\n")

  cat("\n")
}

train_test <-
  function(data, response=NULL, p_train=0.75, seed=NULL, matrix_out=FALSE) {

  # if a tibble convert to data frame
  df.name <- deparse(substitute(data))  # get name of data table
  dfs <- .getdfs()
  if (!is.null(dfs)) {
    if (df.name %in% dfs) {  # tibble to df
      if (any(grepl("tbl", class(data), fixed=TRUE))) {
        data <- data.frame(data)
      }
    }
  }

  n.rows <- 1:nrow(data)

  if (!is.null(seed)) set.seed(seed)
  train_index <- sample(n.rows, round(p_train*nrow(data)), replace=FALSE)
  test_index <- setdiff(n.rows, train_index)

  data.vars <- as.list(seq_along(data))  # locate response variable
  names(data.vars) <- names(data)
  ind <- eval(substitute(response), envir=data.vars, parent.frame())

  if (!is.null(ind)) {
    train_x <- data[train_index, -ind, drop=FALSE]
    train_y <- data[train_index, ind, drop=FALSE]

    test_x <- data[test_index, -ind, drop=FALSE]
    test_y <- data[test_index, ind, drop=FALSE]

    if (matrix_out) {
      train_x <- as.matrix(train_x)
      train_y <- as.matrix(train_y)
      test_x <- as.matrix(test_x)
      test_y <- as.matrix(test_y)
    }

    return(list(train_x=train_x, train_y=train_y, test_x=test_x, test_y=test_y))
  }

  else {  # no response variable, all variables treated equally
    train <- data[train_index, , drop=FALSE]
    test <- data[test_index, , drop=FALSE]
    if (matrix_out) {
      train <- as.matrix(train)
      test <- as.matrix(test)
    }
    return(list(train=train, test=test))
  }

}

.ANOVAz2 <- 
function(av.out, y.values, x1.values, x2.values, nm, digits_d, brief,
         delim, balance, graphics, pdf, width, height) {

  if (grepl("*", delim, fixed=TRUE)) bet.grp  <- TRUE else bet.grp <- FALSE
  if (grepl("+", delim, fixed=TRUE)) wth.grp  <- TRUE else wth.grp <- FALSE

  p <- length(unique(na.omit(x1.values)))
  if (bet.grp)
    q <- length(unique(na.omit(x2.values)))
  if (wth.grp) {
    n <- length(unique(na.omit(x2.values)))
    q <- 1
  }


  tx <- character(length = 0)

  tx[length(tx)+1] <- "" 
  if (bet.grp)
    tx[length(tx)+1] <- "Two-way Between Groups ANOVA"
  else if (wth.grp) {
    tx[length(tx)+1] <- "Randomized Blocks ANOVA"
    tx[length(tx)+1] <- paste("  Factor of Interest: ", nm[2])
    tx[length(tx)+1] <- paste("  Blocking Factor:    ", nm[3])
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste(
        "Note: For the resulting F statistic for", nm[2], 
        "to be distributed as F,\n",
        "     the population covariances of", nm[1], "must be spherical.")
  }

  txbck2 <- tx


  title_des <- "\n  DESCRIPTIVE STATISTICS "

  txcn <- ""
  txcm <- ""
  if (bet.grp) {

    n <- tapply(y.values,
          list(x1.values, x2.values), function(v) sum(!is.na(v)))
    n <- as.table(n)

    m <-  tapply(y.values, 
          list(x1.values, x2.values), mean, na.rm=TRUE)
    m <- as.table(m)

    if (!brief) {

      tx <- character(length = 0)
      if (is.null(options()$knitr.in.progress))
        tx[length(tx)+1] <- "-- Cell Sample Sizes"
      tx[length(tx)+1] <- ""
      if (balance) 
        tx[length(tx)+1] <- "Equal cell sizes, so balanced design"
      else {
        tx[length(tx)+1] <- "Unequal cell sizes, so unbalanced design" 
        tx[length(tx)+1] <- "ANOVA based on Type II Sums of Squares" 
      }
      tx[length(tx)+1] <- ""
      tx2 <- .prntbl(t(n), digits_d, cc=" ", v1.nm=nm[2], v2.nm=nm[3])
      for (i in seq_along(tx2)) tx[length(tx)+1] <- tx2[i]
      txcn <- tx

      tx <- character(length = 0)
      if (is.null(options()$knitr.in.progress)) {
        tx[length(tx)+1] <- "-- Cell Means"
      }
      tx2 <- .prntbl(t(m), digits_d, cc=" ", v1.nm=nm[2], v2.nm=nm[3])
      for (i in seq_along(tx2)) tx[length(tx)+1] <- tx2[i]
      txcm <- tx

    }  # !brief
  }  # bet.grp

  else {  # get means, a 2-d matrix, then table
    m <-  tapply(y.values, 
                 list(x1.values, x2.values), mean, na.rm=TRUE)
    m <- as.table(m)
  }

  # convert table of means to long form
  tx <- character(length = 0)
  if (is.null(options()$knitr.in.progress)) {
    tx[length(tx)+1] <- "-- Marginal Means"
    tx[length(tx)+1] <- ""
  }

  m <- data.frame(m)
  names(m) <- c(nm[2], nm[3], nm[1])

  tx[length(tx)+1] <- nm[2]
  m1 <- tapply(y.values, x1.values, mean, na.rm=TRUE)
  m1 <- data.frame(t(m1))
  tx2 <- .prntbl(m1, digits_d, cc= " ")  # 1st treatment horizontal dimension
  for (i in seq_along(tx2)) tx[length(tx)+1] <- tx2[i]
  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- nm[3]
  m2 <-  tapply(y.values, x2.values, mean, na.rm=TRUE)
  m2 <- data.frame(t(m2))
  tx2 <- .prntbl(m2, digits_d, cc= " ")  # 2nd treatment horizontal dimension
  for (i in seq_along(tx2)) tx[length(tx)+1] <- tx2[i]
  txmm <- tx

  tx <- character(length = 0)
  mg <- mean(y.values, na.rm=TRUE)
  if (is.null(options()$knitr.in.progress)) {
    tx[length(tx)+1] <- paste("-- Grand Mean:", round(mg, digits_d+1))
  }
  txgm <- tx

  tx <- character(length = 0)
  if (is.null(options()$knitr.in.progress)) {
    tx[length(tx)+1] <- "-- Cell Standard Deviations"
  }

  txcs <- ""
  if (bet.grp) {
    s <-  tapply(y.values, 
                 list(x1.values, x2.values), sd, na.rm=TRUE)
    s <- as.table(s)
    tx2 <- .prntbl(t(s), digits_d, cc=" ", v1.nm=nm[2], v2.nm=nm[3])
    for (i in seq_along(tx2)) tx[length(tx)+1] <- tx2[i]
    txcs <- tx
  }  # end between groups



  title_basic <- "\n  ANOVA"

  if(bet.grp) n.vars <- 4
  if(wth.grp) n.vars <- 3
  smc <- anova(av.out)

  tx <- character(length = 0)

  if (!balance && bet.grp) {
    av2.out <- aov(y.values ~ x2.values * x1.values)
    smc[1,] <- anova(av2.out)[2,]
  }
  if (is.null(options()$knitr.in.progress)) {
    tx[length(tx)+1] <- paste("-- Summary Table")
    if (!balance && bet.grp)
      tx[length(tx)] <- paste(tx[length(tx)], "from Type II Sums of Squares")
  }
  tx[length(tx)+1] <- ""

  buf <- max(nchar(rownames(smc)[seq_len(n.vars)]))
  max.num <- integer(length=0)
  for (icol in seq_len(3)) {
    max.num[icol] <- 0 
    for (i in seq_len(n.vars)) {
      ln.nm <- nchar(as.character(trunc(smc[i,icol]))) + digits_d + 2
      if (ln.nm > max.num[icol]) max.num[icol] <- ln.nm
    }
    if (icol != 1) if (max.num[icol] < 9L) max.num[icol] <- 9L 
  }

  df.lbl <- .fmtc("     df", max.num[1]+2)
  SS.lbl <- .fmtc(" Sum Sq", max.num[2]+1)
  MS.lbl <- .fmtc("Mean Sq", max.num[3]+1)
  if (bet.grp) 
    max.nm <- max(nchar(nm[2])+nchar(nm[3])+1, nchar("Residuals"))
  else
    max.nm <- max(nchar(nm[2]), nchar(nm[3]), nchar("Residuals"))
    
  tx[length(tx)+1] <- paste(format("", width=max.nm-5), df.lbl, SS.lbl, MS.lbl,
                                     "   F-value", "   p-value", sep="")
  for (i in seq_len(n.vars)) {
    rlb <- .fmtc(rownames(smc)[i], buf)
    df <- format(sprintf("%i", smc[i,1]), width=max.num[1]-4, justify="right")
    SS <- format(sprintf("%7.*f", digits_d, smc[i,2]), width=max.num[2],
                 justify="right")
    MS <- format(sprintf("%7.*f", digits_d, smc[i,3]), width=max.num[3],
                 justify="right")
    if (i < n.vars) {
      fv <- format(sprintf("%7.*f", digits_d, smc[i,4]), width=9,
                   justify="right")
      pv <- format(sprintf("%6.4f", smc[i,5]), width=9, justify="right")
      tx[length(tx)+1] <- paste(rlb, df, SS, MS, fv, pv) 
    }
    else
      tx[length(tx)+1] <- paste(rlb, df, SS, MS) 
  }

  txanv <- tx


  tx <- character(length = 0)

  if (is.null(options()$knitr.in.progress)) {
    tx[length(tx)+1] <- paste("-- Association and Effect Size")
    tx[length(tx)+1] <- ""
  }

  sm <- summary(av.out)
  FA <- sm[[1]][1,4]
  FB <- sm[[1]][2,4]
  if (bet.grp) {
    FAB <- sm[[1]][3,4]
    n <- round(1 / mean(1 / as.vector(n)))
  }

  omsq.A <- ((p-1)*(FA-1)) / ((p-1)*(FA-1) + n*p*q)
  if (bet.grp) omsq.B <- ((q-1)*(FB-1)) / ((q-1)*(FB-1) + n*p*q)
  if (wth.grp) intra.B <- (FB-1) / ((p-1)+(FB))
  if (bet.grp) omsq.AB <- ((p-1)*(q-1)*(FAB-1)) / ((p-1)*(q-1)*(FAB-1) + n*p*q)

  tx[length(tx)+1] <- paste("Partial Omega Squared for ", nm[2],
      ": ", .fmt(omsq.A, 3), sep="")
  if (bet.grp)
    tx[length(tx)+1] <- paste("Partial Omega Squared for ", nm[3],
        ": ", .fmt(omsq.B, 3), sep="")
  if (wth.grp)
    tx[length(tx)+1] <- paste("Partial Intraclass Correlation for ", nm[3],
        ": ", .fmt(intra.B, 3), sep="")
  if (bet.grp)
    tx[length(tx)+1] <- paste("Partial Omega Squared for ", nm[2], " & ", nm[3],
        ": ", .fmt(omsq.AB, 3), sep="")
  tx[length(tx)+1] <- ""

  if (omsq.A > 0) {
    fA.cohen <- sqrt( (omsq.A/(1-omsq.A)) )
    tx[length(tx)+1] <- paste("Cohen's f for ", nm[2], ": ",
                              .fmt(fA.cohen, 3), sep="")
  }
  if (bet.grp) {
    if(omsq.B > 0) {
      fB.cohen <- sqrt( (omsq.B/(1-omsq.B)) )
      tx[length(tx)+1] <- paste("Cohen's f for ", nm[3], ": ",
                                .fmt(fB.cohen, 3), sep="")
    }
    if (omsq.AB > 0) {
      fAB.cohen <- sqrt( (omsq.AB/(1-omsq.AB)) )
      tx[length(tx)+1] <- paste("Cohen's f for ", nm[2], "_&_", nm[3], ": ",
                                 .fmt(fAB.cohen, 3), sep="")
    }
  }
  if (wth.grp) {
    if (intra.B > 0) {
      fB.cohen <- sqrt( (intra.B/(1-intra.B)) )
      tx[length(tx)+1] <- paste("Cohen's f for ", nm[3], ": ",
                                .fmt(fB.cohen, 3), sep="")
    }
  }

  txeft <- tx


  txhsd <- ""
  title_tukey <- "\n TUKEY MULTIPLE COMPARISONS OF MEANS"
  if (!brief) {
    tx <- character(length = 0)

    HSD <- TukeyHSD(av.out)
    tx[length(tx)+1] <- paste("Family-wise Confidence Level:", 
                              attributes(HSD)$conf.level)
    tx[length(tx)+1] <- paste("\nFactor:", nm[2])

    txHSD <- .prntbl(HSD[[1]], digits_d)
    for (i in seq_along(txHSD)) tx[length(tx)+1] <- txHSD[i]

    if (bet.grp) {
      tx[length(tx)+1] <- paste("\nFactor:", nm[3])
      txHSD <- .prntbl(HSD[[2]], digits_d)  # second factor
      for (i in seq_along(txHSD)) tx[length(tx)+1] <- txHSD[i]
      tx[length(tx)+1] <- paste("\nCell Means")
      txHSD <- .prntbl(HSD[[3]], digits_d)  # interaction
      for (i in seq_along(txHSD)) tx[length(tx)+1] <- txHSD[i]
    }

    txhsd <- tx
  }


  # ------------------------------------
  # visualizations

  # keep track of the number of plots, see if manage graphics
  plt.i <- 0
  plt.title  <- character(length=0)
  if (graphics) {
    manage.gr <- .graphman()

    if (bet.grp) {

      # interaction plot
      if (!pdf) {
        if (manage.gr) {
          .graphwin(1)
          dev.set(which=3)
        }
      }
      else {
        pdf_file <- "ANOVA_Interaction.pdf"
        pdf(file=pdf_file, width=width, height=height)
      }

      plt.i <- plt.i + 1
      plt.title[plt.i] <- "Interaction Plot"

      # p is num of levels on x-axis
      # q is num of levels for legend, each curve
      options(byname = nm[3])
#     qual_pal <- if (getOption("theme") %in% c("gray", "white")) "grays" else "hues"
#     pt_fill <- getColors(qual_pal, n=q, output=FALSE)
      pt_fill <- .color_range(.get_fill(), q)  # see if range
      txt <- paste("Cell Means of", nm[1])
      .plt.main(m[,1,drop=FALSE], m[,3,drop=FALSE], by=m[,2], 
                fill=pt_fill, color=pt_fill, segments=TRUE,
                col.segment=pt_fill, cat.x=TRUE, xlab=nm[2], ylab=txt, size=1.5,
                use_plotly=TRUE)

      if (pdf) {
        dev.off()
        .showfile(pdf_file, "interaction plot")
      }
    }  # end bet.grp

    # data and fitted plots
    if (wth.grp) {

      fit.out <- data.frame(av.out$fitted.values)
      names(fit.out) <- "Fitted"
      m <- cbind(av.out$model, fit.out)
      nm.wth <- names(m)
      options(byname = nm.wth[3])
      options(yname = nm.wth[1])

      # one window per plot (data, fitted) when managing graphics
      if (!pdf  &&  manage.gr) .graphwin(2)

      # data values plot
      if (!pdf) {
        if (manage.gr) dev.set(which=3)
      }
      else {
        pdf_file <- "ANOVA_Data.pdf"
        pdf(file=pdf_file, width=width, height=height)
      }

      plt.i <- plt.i + 1
      plt.title[plt.i] <- "Data Values"

      .plt.main(m[,2,drop=FALSE], m[,1,drop=FALSE], by=m[,3], segments=TRUE,
              cat.x=TRUE, xlab=nm.wth[2], ylab=nm.wth[1],
              use_plotly=TRUE)

      if (pdf) {
        dev.off()
        .showfile(pdf_file, "Data values plot")
      }

      # fitted values plot
      if (!pdf) {
        if (manage.gr) dev.set(which=4)
      }
      else {
        pdf_file <- "ANOVA_Fitted.pdf"
        pdf(file=pdf_file, width=width, height=height)
      }

      plt.i <- plt.i + 1
      plt.title[plt.i] <- "Fitted Values"

      .plt.main(m[,2,drop=FALSE], m[,4,drop=FALSE], by=m[,3], segments=TRUE,
              cat.x=TRUE, xlab=nm.wth[2], ylab=nm.wth[4],
              use_plotly=TRUE)

      if (pdf) {
        dev.off()
        .showfile(pdf_file, "Fitted values plot")
      }

    }  # end within group

  }  # end grahpics

  return(list(
    txbck2=txbck2, 
    title_des=title_des, txcn=txcn, txcm=txcm, txmm=txmm, txgm=txgm, txcs=txcs,
    title_basic=title_basic,
    title_tukey=title_tukey,
    txanv=txanv, txeft=txeft, txhsd=txhsd,
    i=plt.i, ttl=plt.title))

} 

# VBS fill for box and violin, called from Plot()
.plt.fill <-
function(geom_clr, geom_clr.miss, ord.by.call, n.facet1, n.lvl, theme) {
# n.lvl <- n.facet1 * n.facet2

  n.gen <- ifelse (n.facet1 < n.lvl, n.facet1, n.lvl)
  if (n.gen == 0) n.gen <- 1

  if (geom_clr.miss) {
    if (!ord.by.call) {
      clr <- ifelse (theme == "colors", "hues", getOption("bar_fill"))
      if (clr == "hues")
        geom_clr <- getColors(clr, n=n.gen, output=FALSE)
      else
        for (i in 1:n.lvl) geom_clr[i] <- geom_clr[1]
    }
    else  # ordinal variable
      geom_clr <- .color_range(.get_fill(seq.pal=TRUE), n.lvl)  # ordinal
    geom_clr.miss <- FALSE
  }

  if (n.lvl == 0) n.lvl <- 1  # a hack, n.lvl==0 if no levels
  if (!geom_clr.miss  &&  n.lvl > 0)  {
    if (length(geom_clr) == 1)
       geom_clr <- .color_range(geom_clr, n.lvl)  # from "blues", etc.
    if (length(geom_clr) != n.lvl) {  # repeat facet1 fill for each facet2
      n.reps <- ceiling(n.lvl / length(geom_clr))
      x.fill <- rep(geom_clr, n.reps)
      geom_clr <- x.fill[1:n.lvl]
    }
  }

  return(geom_clr)
}

.plt.legend <-
function(colnms, horiz, color, fill, shape, box.bg, usr, lab_size=0.8,
         pt.size=1.25, legend_title=NULL, line_type="solid") {
# legend will have points or lines, shape="" for lines

  par(xpd=NA) 
  
  # text color
  the.clr <- getOption("lab_color")

  if (missing(lab_size)) {
    text.cex <- ifelse(is.null(getOption("axis_x_size")),
        getOption("axis_size"), getOption("axis_x_size"))
    text.cex <- 1.1 * text.cex
  }
  else
    text.cex <- lab_size
  text.cex <- .85 * text.cex
  if (text.cex < getOption("axis_size")) text.cex <- getOption("axis_size")
  legend_title_size <- 1.1 * text.cex

  if (horiz) {

    ll <- legend(0,0, legend=colnms, cex=.7, pt.cex=0.9,
                 horiz=TRUE, plot=FALSE)  # get coordinates
    size <- (par("cxy")/par("cin"))  # 1 inch in user coordinates, [2] is y 

    bm.user <- par("mai")[1] * size[2]  # size of bot margin in user coords
    # move down, /5 is for the existing line of axis numbers
    ytop <- usr[3] - (bm.user - (2.6 * bm.user/5))
    # ytop <- usr[3] - (bm.user - bm.user/5 + ll$rect$h) 

    axis_horiz <- usr[2] - usr[1]
    lgnd.hhalf <- (ll$rect$w) / 2
    xleft <- usr[1] + axis_horiz/2 - lgnd.hhalf

    legend(xleft, ytop, legend=colnms, horiz=TRUE, box.lwd=.5, 
           box.col="transparent", cex=text.cex, pt.cex=pt.size,
           title.cex=legend_title_size,
           pt.bg=fill, bg=box.bg,
           col=color, pch=shape, text.col=the.clr, title=legend_title) 
  }

  else {  # vertical

    ll <- legend(0,0, legend=colnms, cex=.7, pt.cex=0.9,
                 horiz, plot=FALSE)  # get coordinates
    size <- (par("cxy")/par("cin"))  # 1 inch in user coordinates 
    #dv <- ifelse (options("device") == "RStudioGD", 1, 3)
    epsilon <- (size[1] - ll$rect$w) / 2
    epsilon <- epsilon * .75

    axis_vert <- usr[4] - usr[3]
    xleft <- usr[2] + epsilon   # usr[2] user coordinate of right axis
    lgnd.vhalf <- ll$rect$h / 2
    axis_cntr <- axis_vert / 2  + usr[3]
    ytop <- axis_cntr + lgnd.vhalf  # user coordinate of legend top

#   xi <- ifelse (options("device") == "RStudioGD", 1.4, 1)
#   yi <- ifelse (options("device") == "RStudioGD", 1.4, 1)

    # display legend
    # lwd needed to draw a line
    # rev() function lists the stacked plots in the order they are plotted
    legend(xleft, ytop, legend=rev(colnms), horiz=FALSE, lwd=1.5, lty=line_type,
           box.lwd=.5, box.col="transparent", cex=text.cex, pt.cex=pt.size,
           title.cex=legend_title_size,
           pt.bg=rev(fill), bg=box.bg,
           col=rev(color), pch=shape, text.col=the.clr,
           x.intersp=1, y.intersp=1, title=legend_title) 
  }

  par(xpd=FALSE)  # cancel drawing outside of plot region (need for RStudio)

}

.stats <- function(x, y, by.var, facet.var = NULL, stat, y.name) {

  ## drop observations where the grouping variable x is NA
# keep <- !is.na(x)
# if (!all(keep)) {
#   x <- x[keep]
#   y <- y[keep]
#   if (!is.null(by.var))
#     by.var <- if (is.data.frame(by.var)) by.var[keep, , drop=FALSE]
#               else by.var[keep]
#   if (!is.null(facet.var))
#     facet.var <- if (is.data.frame(facet.var)) facet.var[keep, , drop=FALSE]
#                  else facet.var[keep]
# }


  ## helper: aggregate over x and possibly multiple by / facet columns
  ##   - if both by.var and facet.var are NULL: tapply result (named vector/array)
  ##   - otherwise: data.frame with columns x, <grouping cols>, y
  agg_wrapper <- function(FUN) {

    # no grouping beyond x: original behavior
    if (is.null(by.var) && is.null(facet.var)) {
      out <- tapply(y, x, FUN)
      return(out)
    }

    # build data.frame: x + (columns from by.var) + (columns from facet.var) + y
    df <- data.frame(x = x)

    # by.var can be vector, matrix, or data.frame
    if (!is.null(by.var)) {
      if (is.data.frame(by.var)) {
        df <- cbind(df, by.var)
      } else if (is.matrix(by.var)) {
        df <- cbind(df, as.data.frame(by.var))
      } else {
        df$by.var <- by.var
      }
    }

    # facet.var can be vector, matrix, or data.frame
    if (!is.null(facet.var)) {
      if (is.data.frame(facet.var)) {
        df <- cbind(df, facet.var)
      } else if (is.matrix(facet.var)) {
        df <- cbind(df, as.data.frame(facet.var))
      } else {
        df$facet.var <- facet.var
      }
    }

    df$y <- y

    out <- stats::aggregate(y ~ ., data = df, FUN = FUN)

    ## Ensure we have canonical column names "x" and "y"
    if (!("x" %in% names(out)))
      stop(".stats(): aggregated result must contain a column named 'x'.")
    if (!("y" %in% names(out)))
      stop(".stats(): aggregated result must contain a column named 'y'.")

    out
  }

  # -------------------------------------------------------------------
  # Apply the wrapper for each supported stat, same logic as before
  # -------------------------------------------------------------------
  if (stat == "sum") {
    ylab <- paste("Sum of", y.name)
    out  <- agg_wrapper(function(z) sum(z, na.rm = TRUE))
  }

  if (stat == "mean") {
    ylab <- paste("Mean of", y.name)
    out  <- agg_wrapper(function(z) mean(z, na.rm = TRUE))
  }

  if (stat == "sd") {
    ylab <- paste("Standard Deviation of", y.name)
    out  <- agg_wrapper(function(z) stats::sd(z, na.rm = TRUE))
  }

  if (stat == "deviation") {
    ylab <- paste("Mean Deviation of", y.name)
    if (is.null(by.var) && is.null(facet.var)) {
      out <- tapply(y, x, mean, na.rm = TRUE)
      out <- out - mean(out, na.rm = TRUE)
    } else {
      cat("\n"); stop(call. = FALSE, "\n","------\n",
        "deviation for stat not meaningful with a by or facet variable\n\n")
    }
  }

  if (stat == "min") {
    ylab <- paste("Minimum of", y.name)
    out  <- agg_wrapper(function(z) min(z, na.rm = TRUE))
  }

  if (stat == "median") {
    ylab <- paste("Median of", y.name)
    out  <- agg_wrapper(function(z) stats::median(z, na.rm = TRUE))
  }

  if (stat == "max") {
    ylab <- paste("Maximum of", y.name)
    out  <- agg_wrapper(function(z) max(z, na.rm = TRUE))
  }

  ## Same missing-value safeguard as before.
  if (sum(is.na(out)) > 0) { # y and a summary table, then no stat
    cat("\n"); stop(call. = FALSE, "\n","------\n",
      "The summary table of the transformed data has some missing\n",
      "   values, likely as a result of too few data values in\n",
      "   some cells to be able to calculate the specified statistic\n\n")
  }

  return(list(out = out, ylab = ylab))
}

corReorder <-
function (R=mycor, order=c("hclust", "chain", "manual", "as_is"),
          hclust_type=c("complete", "ward.D", "ward.D2", "single",
                          "average", "mcquitty", "median", "centroid"),
          dist_type=c("R", "dist"),
          n_clusters=NULL, vars=NULL, chain_first=0,
          heat_map=TRUE, dendrogram=TRUE, diagonal_new=TRUE,
          main=NULL, bottom=NULL, right=NULL, quiet=getOption("quiet"),
          pdf=FALSE, width=5, height=5, ...) {


  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (!is.null(dots)) if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (names(dots)[i] == "values.cex")  labels_size <- dots[[i]]
      if (grepl(".", names(dots)[i], fixed=TRUE)) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
        }
    }
  }

  order <- match.arg(order)
  hclust_type <- match.arg(hclust_type)
  dist_type <- match.arg(dist_type)


  if (!("matrix" %in% class(R))) { # R is a matrix, can be called indirectly
    # cor matrix:  mycor as class out_all, mycor$R, or stand-alone matrix
    cor.nm <- deparse(substitute(R))
    .cor.exists(cor.nm)  # see if matrix exists in one of the 3 locations
    if ("out_all" %in% class(R))    # R 4.0 results in two values: matrix, array
      R <- eval(parse(text=paste(cor.nm, "$R", sep="")))  # go to $R
  }

 
  # manage graphics
  # ---------------
  # see if graphics are to be managed (not needed for RStudio)
  manage.gr <- .graphman()

  # if manage, set up graphics system for 2 windows default
  if (!pdf) {
    if (manage.gr) {
      n.graphs <- ifelse (order == "hclust", 2, 1)  # for hclust, plot tree
      .graphwin(n.graphs)
      dev.set(which=3)
    }
  }
  else { 
    pdf_file <- ifelse (order == "hclust", "Dendrogram.pdf", "Reordered.pdf")
    pdf(file=pdf_file, width=width, height=height)
  }

  # keep track of generated graphics
  plot.i <- 0
  plot.title  <- character(length=0)
  # ---------------


  NVOld <- nrow(R)
  nvc <- as.integer(NVOld)
  Label <- integer(length=NVOld)

  if (!missing(vars)) order <- "manual"


  # -----
  # ORDER

  if (order == "manual") {
    # translate variable names into column positions
    vars.all <- as.list(seq_along(as.data.frame(R)))
    names(vars.all) <- names(as.data.frame(R))
    vars.num <- eval(substitute(vars), vars.all, parent.frame())
    Label <- as.integer(as.vector(vars.num))
  }

  else if (order == "hclust") {
    if (dist_type == "R")
      dst <- as.dist(1-R)
    else if (dist_type == "dist")
      dst <- as.dist(R)
    ord <- hclust(dst, method=hclust_type)
    Label <- ord$order  # indices of new order, ord$labels gives labels

    if (!is.null(n_clusters)) {
     clt <- sort(cutree(ord, k=n_clusters))
     ttl <- paste(as.character(n_clusters), " Cluster Solution", sep="")
     cat("\n", ttl, "\n")
     .dash(nchar(ttl) + 1)
     print(clt)
    }
  }

  else if (order == "as_is") { 
    diagonal_new <- FALSE
    Label <- 1:NVOld  # current indices
  }

  else if (order == "chain") {  # Hunter 1973

    i.first <- as.integer(chain_first)

    nv <- nvc

  # If i.first = 0 (default), best variable is chosen first
  # If i.first gt 0, i.first is the first variable chosen by user

    Label <- rep(0, nv)

  # i.first gives starting value
  # Find max sum sq variable for i.first if not user specified
    if (i.first == 0) {
      v.max <- 0.0
      for (i in 1:nv) {
        vt <- 0.0
        for (j in 1:nv) {
          vt <- vt + R[i,j]**2
        }
        if (vt > v.max) {
          v.max <- vt
          i.max <- i
        }
      }
      i.first <- i.max
    }

  # get Labels

    Label[1] <- i.first * 1000
    Label[i.first] <- Label[i.first] + 1

    for (i in 2:nv) {
      R.max <- 0.0
      k <- Label[i-1] %/% 1000
      for (j in 1:nv) {
        Lbctad <- Label[j] - (Label[j] %/% 1000) * 1000
        if (Lbctad == 0) {
          if (abs(R[k,j]) > R.max) {
            R.max <- abs(R[k,j])
            i.max <- j
          }
        }
      }
      Label[i.max] <- Label[i.max] + i
      Label[i] <- Label[i]+1000 * i.max
    }

    for (i in 1:nv) {
      Label[i] <- Label[i] %/% 1000
    }

    #vars.num <- Label  # derived vars.num (not user specified)
  }


  # -----------------------------
  # re-order R matrix
  R <- R[Label,Label]
  nv <- ncol(R)

  # save diagonal if change
  Rdiag <- double(length=nv)
  for (i in 1:nv) Rdiag[i] <- R[i,i]

  # diagonal is based on adjacent values
  if (diagonal_new) {
      R[1,1] <- R[1,2]
    if (nv > 2) {
      for (i in 2:(nv-1)) {
        R[i,i] <- (R[i,i-1] + R[i,i+1]) / 2
        R[i,i] <- round(R[i,i], 2)
      }
      R[nv,nv] <- R[nv,nv-1]
    }  # end > 2

  }


  # --------
  # graphics

  if (order == "hclust") {
    if (dendrogram) {
      if (pdf) {
        .showfile(pdf_file, "Cluster Dendrogram")
        pdf("Dendrogram.pdf", width=width, height=height)
        plot(ord, main="")
        dev.off()
      }
      else {
        plot.i <- plot.i + 1
        plot.title[plot.i] <- "Cluster Dendrogram"
        plot(ord, main="")
      }
    }
  }

  if (heat_map) {
    if (!pdf) {
      if (manage.gr) {
        dev.set(which=4) 
      }
    }

    plot.i <- plot.i + 1
    plot.title[plot.i] <- "Reordered Matrix" 
    if (pdf)
      pdf_file <- "ReorderedMatrix.pdf"
    else
      pdf_file <- NULL

    .heatmap(R, nrow(R), main, bottom, right, diag=NULL,
               pdf_file, width, height)
  }  # end heat map

  if (is.null(options()$knitr.in.progress)  &&  !pdf)
    .plotList(plot.i, plot.title)


  # restore diagonal if changed
  if (diagonal_new)
    for (i in 1:nv) R[i,i] <- Rdiag[i]


  # finish
  cat("\n")

  if (!quiet)
    return(R)
  else
    invisible(R)

}

.bc.plotly <-
function(x, x_name, y_name, by_name, x_lab, y_lab,
         fill, border, opacity = NULL,
         beside, horiz, ax, gridT, digits_d, main=NULL,
         rotate_x=0, gap=NULL, break_x=FALSE, counts=NULL,
         labels_decimals=NULL,
         legend_title=NULL, legend_position=NULL,
         legend_labels=NULL, legend_horiz=FALSE,
         legend_size=NULL, legend_abbrev=NULL, legend_adjust=0,
         labels=c("%", "input", "prop", "off"),
         labels_size = 12,
         labels_color = NULL,
         labels_autocontrast = TRUE,
         style_opts = .plotly_style()) {

  # did the caller actually supply labels= ?
  missing.labels <- missing(labels)

  labels <- match.arg(labels)
  title.size <- round(16 * getOption("main_size", 1))
  alpha.fill <- if (is.null(opacity)) 0.92 else as.numeric(opacity)

  # labels_size arrives as a Base R cex value (e.g. 0.75); convert to pixels
  # axis_size is already folded into labels_size upstream (Chart.R), so do not
  # multiply by it here — that double-scales when font_size is in effect.
  labels_size <- max(8, round(labels_size * 14))

  # Show % lines in hover only when data are counts (i.e., user did NOT
  # explicitly pass labels="input", which signals means / deviations).
  # missing.labels=TRUE covers the 1-D default path that overrides to "input"
  # for tabulated counts — percentages are still meaningful there.
  show.pct.hover <- missing.labels || labels != "input"

  .row_customdata <- function(a, b = NULL) {
    a <- as.numeric(a)
    if (is.null(b)) unname(lapply(a, function(z) c(z)))
    else {
      b <- as.numeric(b)
      unname(Map(function(z1, z2) c(z1, z2), a, b))
    }
  }

  .pick <- function(v, nm, i) {
    v   <- as.character(v)
    nms <- names(v)
    if (!is.null(nms) && nm %in% nms) return(v[[nm]])
    if (length(v) >= i) return(v[[i]])
    if (!length(v)) return("black")
    v[[ ((i - 1L) %% length(v)) + 1L ]]
  }

  .fmt_val <- function(v, d) .fmt(v, d = d)

  # where a named position puts the legend: x, y, xanchor, yanchor.
  # "right_margin" is the default, outside the panel; the rest are
  # the base legend() keywords, placed inside the panel as there.
  .legend_pos <- list(
    right_margin = list(1.02, 0.5,  "left",   "middle"),
    topleft      = list(0.02, 0.98, "left",   "top"),
    top          = list(0.50, 0.98, "center", "top"),
    topright     = list(0.98, 0.98, "right",  "top"),
    left         = list(0.02, 0.50, "left",   "middle"),
    center       = list(0.50, 0.50, "center", "middle"),
    right        = list(0.98, 0.50, "right",  "middle"),
    bottomleft   = list(0.02, 0.02, "left",   "bottom"),
    bottom       = list(0.50, 0.02, "center", "bottom"),
    bottomright  = list(0.98, 0.02, "right",  "bottom"))

  .abbrev <- function(txt) {
    if (is.null(legend_abbrev) || is.null(txt)) return(txt)
    abbreviate(txt, minlength=as.integer(legend_abbrev))
  }

  # decimals of the label text. NULL keeps each mode's own default,
  # which is what a direct call to .bc.plotly gets; Chart() supplies
  # a value whenever the user set labels_decimals.
  .lbl.d <- function(mode, fallback) {
    if (!is.null(labels_decimals)) as.integer(labels_decimals)
    else if (identical(mode, "%")) 0L
    else if (identical(mode, "prop")) 2L
    else fallback
  }

  # category labels for the categorical axis: a space becomes a line
  # break when break_x, and "~" is the non-breaking space that
  # survives it, the same rule as .get.val.ln() for base graphics
  .break_labels <- function(cats) {
    if (break_x) cats <- gsub(" ", "<br>", cats, fixed=TRUE)
    gsub("~", " ", cats, fixed=TRUE)
  }

  # barplot space= (gaps in multiples of bar width) as plotly's
  # bargap, the fraction of a category slot left empty. A slot holds
  # k bars, the gaps between them, and one between-group gap.
  # NULL leaves plotly's own default in place.
  # The within-group gap of a beside chart is plotly's bargroupgap,
  # which the R plotly package's schema does not recognize: setting
  # it warns on every build. So gap[1] is not applied here, and the
  # bars of a group keep plotly's own spacing.
  .bar_gaps <- function(gap, beside, k) {
    if (is.null(gap)) return(NULL)
    within  <- as.numeric(gap[1L])
    between <- as.numeric(gap[length(gap)])
    if (any(c(within, between) < 0)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Parameter  gap  cannot be negative\n\n")
    }
    if (!beside)
      return(list(bargap = between / (1 + between)))
    k <- max(1L, k)
    list(bargap = between / (k + (k - 1) * within + between))
  }

  # we'll capture the category order from the incoming data
  cat.vals <- NULL

  # ------------------ 1-D ------------------
  if (length(dim(x)) == 1L) {
    df <- setNames(data.frame(names(x), as.numeric(x), check.names = FALSE),
                   c(x_name, y_name))

    # the order of names(x) here already reflects any sort done upstream
    cat.vals <- as.character(df[[x_name]])

    # percentages come from the counts when the heights have already
    # been rescaled to proportions
    cnt.1d  <- if (is.null(counts)) df[[y_name]] else as.numeric(counts)
    total.n <- sum(cnt.1d, na.rm = TRUE)
    share   <- if (total.n > 0) cnt.1d / total.n else rep(NA_real_, nrow(df))

    # only force "input" when the user did NOT specify labels=
    if (missing.labels) {
      labels <- "input"
    }

    tick.fmt <- .get.tick.fmt(df[[y_name]], digits_d)

    pct.line <- if (show.pct.hover) "<br>% of total: %{customdata:.1%}" else ""

    hover <- if (!horiz)
      paste0(x_name, ": %{x}<br>",
             y_name, ": %{y:", tick.fmt, "}",
             pct.line, "<extra></extra>")
    else
      paste0(x_name, ": %{y}<br>",
             y_name, ": %{x:", tick.fmt, "}",
             pct.line, "<extra></extra>")

    fill.vec   <- .to_hex(rep_len(fill, nrow(df)))
    border.hex <- .to_hex(rep_len(border, nrow(df)))

    if (labels == "off") {
      txt <- rep("", nrow(df))
    } else if (labels == "input") {
      # over proportions, show the counts, as base graphics does
      txt <- .fmt_val(cnt.1d, .lbl.d("input",
               if (isTRUE(all(cnt.1d == round(cnt.1d)))) 0
               else digits_d))
    } else if (labels == "%") {
      txt <- sprintf(paste0("%.", .lbl.d("%", 0L), "f%%"), 100 * share)
    } else {  # "prop"
      txt <- sprintf(paste0("%.", .lbl.d("prop", 2L), "f"), share)
    }

    if (length(labels_color)) {
      txt.col <- rep_len(.to_hex(labels_color), nrow(df))
    } else if (isTRUE(labels_autocontrast)) {
      txt.col <- vapply(fill.vec, .contrast_text_for_hex, "")
    } else {
      txt.col <- NULL
    }

    plt <- plotly::plot_ly(
      type        = "bar",
      x           = if (!horiz) df[[x_name]] else df[[y_name]],
      y           = if (!horiz) df[[y_name]] else df[[x_name]],
      orientation = if (!horiz) NULL else "h",
      marker = list(
        color   = fill.vec,
        opacity = alpha.fill,
        line    = list(color = border.hex, width = 1)
      ),
      customdata       = .row_customdata(share),
      hovertemplate    = hover,
      text             = txt,
      textposition     = "inside",
      insidetextanchor = "middle",
      textfont         = list(size = labels_size, color = txt.col),
      cliponaxis       = FALSE
    )

  } else {
    # ------------------ 2-D ------------------
    if (is.table(x)) df <- as.data.frame(x)
    else if (is.matrix(x)) df <- as.data.frame(as.table(x))
    else stop("For 2-D input, x must be a table or matrix.")

    names(df) <- c(by_name, x_name, y_name)

    # preserve row/column order of the incoming table/matrix,
    # which upstream code may already have sorted by totals
    df[[by_name]] <- factor(df[[by_name]], levels = rownames(x))
    df[[x_name]]  <- factor(df[[x_name]],  levels = colnames(x))

    cat.vals <- levels(df[[x_name]])

    # mirror 1-D behaviour: default to showing input values, not percentages,
    # when the caller did not explicitly specify labels= (e.g. means/deviations)
    if (missing.labels) labels <- "input"

    # percentages come from the counts when the heights have already
    # been rescaled to proportions (stack100)
    df$cnt <- if (is.null(counts)) df[[y_name]]
              else as.numeric(as.data.frame(as.table(counts))[[3L]])

    total.n <- sum(df$cnt, na.rm = TRUE)
    df$share_total <- if (total.n > 0) df$cnt / total.n
                      else rep(NA_real_, nrow(df))

    x.totals <- tapply(df$cnt, df[[x_name]], sum, na.rm = TRUE)
    x.denom  <- as.numeric(x.totals[as.character(df[[x_name]])])
    df$share_within_x <- ifelse(x.denom != 0, df$cnt / x.denom, NA_real_)

    grp    <- df[[by_name]]
    groups <- levels(grp)

    # the key text: legend_labels renames the by levels, and
    # legend_abbrev shortens them, as in the base graphics legend
    key.names <- if (!is.null(legend_labels)) {
      if (length(legend_labels) != length(groups)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
        "legend_labels has ", length(legend_labels), " entries for ",
        length(groups), " levels of the  by  variable\n\n")
      }
      as.character(legend_labels)
    } else as.character(groups)
    key.names <- unname(.abbrev(key.names))

    tick.fmt <- .get.tick.fmt(df[[y_name]], digits_d)

    pct.lines_2d <- if (show.pct.hover)
      paste0("<br>% of ", x_name, ": %{customdata[1]:.1%}",
             "<br>% of total: %{customdata[0]:.1%}")
    else ""

    hover <- if (!horiz)
      paste0(
        x_name, ": %{x}<br>",
        by_name, ": %{fullData.name}<br>",
        y_name, ": %{y:", tick.fmt, "}",
        pct.lines_2d, "<extra></extra>"
      )
    else
      paste0(
        x_name, ": %{y}<br>",
        by_name, ": %{fullData.name}<br>",
        y_name, ": %{x:", tick.fmt, "}",
        pct.lines_2d, "<extra></extra>"
      )

    plt <- plotly::plot_ly()

    for (i in seq_along(groups)) {
      gname <- groups[i]
      rows  <- which(grp == gname)
      if (!length(rows)) next

      fill.i   <- .to_hex(.pick(fill, gname, i))
      border.i <- .to_hex(.pick(border, gname, i))

      cd.list <- .row_customdata(df$share_total[rows], df$share_within_x[rows])

      xv <- if (!horiz) df[[x_name]][rows] else df[[y_name]][rows]
      yv <- if (!horiz) df[[y_name]][rows] else df[[x_name]][rows]

      # a stack100 bar IS its within-x percentage, so that is what
      # "%" / "prop" report there, and "input" shows the counts
      shr <- if (is.null(counts)) df$share_total[rows]
             else df$share_within_x[rows]

      if (labels == "off") {
        txt <- rep("", length(rows))
      } else if (labels == "input") {
        cnt.i <- df$cnt[rows]
        txt <- .fmt_val(cnt.i, .lbl.d("input",
                 if (isTRUE(all(cnt.i == round(cnt.i)))) 0
                 else digits_d))
      } else if (labels == "%") {
        txt <- sprintf(paste0("%.", .lbl.d("%", 0L), "f%%"), 100 * shr)
      } else {  # "prop"
        txt <- sprintf(paste0("%.", .lbl.d("prop", 2L), "f"), shr)
      }

      if (length(labels_color)) {
        txt.col <- rep_len(.to_hex(labels_color), length(rows))
      } else if (isTRUE(labels_autocontrast)) {
        txt.col <- rep_len(.contrast_text_for_hex(fill.i), length(rows))
      } else {
        txt.col <- NULL
      }

      plt <- plotly::add_trace(
        plt,
        type        = "bar",
        x           = xv,
        y           = yv,
        orientation = if (!horiz) NULL else "h",
        name        = key.names[i],
        legendgroup = gname,
        marker = list(
          color   = fill.i,
          opacity = alpha.fill,
          line    = list(color = border.i, width = 1)
        ),
        customdata       = cd.list,
        hovertemplate    = hover,
        text             = txt,
        textposition     = "inside",
        insidetextanchor = "middle",
        textfont         = list(size = labels_size, color = txt.col),
        cliponaxis       = FALSE
      )
    }

    plt <- plotly::layout(
      plt,
      barmode = if (beside) "group" else "stack"
    )
  }

  # --- axes & background ------------------------------------------------
  border.shapes <- plot_border()

  # unique category order taken from incoming (potentially sorted) table
  cat.array <- unique(as.character(cat.vals))

  # tick labels wrap at their spaces when break_x; the bar
  # coordinates stay the raw category values
  cat.ticks <- list(
    tickmode = "array",
    tickvals = seq_along(cat.array) - 1L,
    ticktext = .break_labels(cat.array)
  )

  n.grp <- if (length(dim(x)) == 1L) 1L else nrow(x)
  bar.gaps <- .bar_gaps(gap, beside && length(dim(x)) > 1L, n.grp)

  if (horiz) {
    # categories along y-axis
    y.axis.cat <- c(
      axis_cat(x_lab),
      list(
        categoryorder = "array",
        categoryarray = cat.array
      ),
      cat.ticks
    )

    plt <- plotly::layout(
      plt,
      xaxis  = axis_num(y_lab, ax$axT2, ax$axL2),
      yaxis  = y.axis.cat,
      shapes = c(x_grid(gridT), border.shapes),
      template = NULL
    )
  } else {
    # categories along x-axis
    x.axis.cat <- c(
      axis_cat(x_lab),
      list(
        categoryorder = "array",
        categoryarray = cat.array,
        tickangle = -rotate_x
      ),
      cat.ticks
    )

    plt <- plotly::layout(
      plt,
      xaxis  = x.axis.cat,
      yaxis  = axis_num(y_lab, ax$axT1, ax$axL1),
      shapes = c(y_grid(gridT), border.shapes),
      template = NULL
    )
  }

  if (!is.null(bar.gaps))
    plt <- do.call(plotly::layout, c(list(plt), bar.gaps))

  plt <- plotly::layout(
    plt,
    plot_bgcolor  = .to_hex(style_opts$panel_fill),
    paper_bgcolor = .to_hex(style_opts$window_fill)
  )

  if (!is.null(by_name) && nzchar(by_name)) {
    leg.mult <- if (is.null(legend_size)) 1 else as.numeric(legend_size)
    leg.ttl  <- if (is.null(legend_title)) by_name else legend_title
    leg <- list(
      title = list(
        text = unname(.abbrev(leg.ttl)),
        font = list(size = round(
          15 * getOption("lab_size", 1) * leg.mult))),
      bgcolor     = "rgba(255,255,255,0.9)",
      bordercolor = "#CCCCCC",
      borderwidth = 1,
      font = list(size = round(
        16 * getOption("axis_size", 0.9) * leg.mult))
    )
    if (isTRUE(legend_horiz)) leg$orientation <- "h"
    if (!is.null(legend_position) &&
        !(legend_position %in% names(.legend_pos))) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
      "legend_position must be one of:\n  ",
      paste(names(.legend_pos), collapse=", "), "\n\n")
    }
    # "right_margin" is plotly's own outside-right placement, so
    # leave the layout alone there unless the legend is nudged
    if ((!is.null(legend_position) &&
         legend_position != "right_margin") ||
        (!is.null(legend_adjust) && legend_adjust != 0)) {
      pk <- if (is.null(legend_position)) "right_margin"
            else legend_position
      pv <- .legend_pos[[pk]]
      leg$x <- pv[[1]] + as.numeric(legend_adjust)
      leg$y <- pv[[2]]
      leg$xanchor <- pv[[3]]
      leg$yanchor <- pv[[4]]
    }
    plt <- plotly::layout(plt, legend = leg)
  }

  if (!is.null(main) && nzchar(main)) {
    plt <- plotly::layout(plt,
      title  = list(text = main, x = 0.5,
                    xanchor = "center", y = 0.99, yanchor = "top",
                    font = list(size = title.size)),
      margin = list(t = round(title.size * 2.2))
    )
  }

  plt <- .finalize_plotly_widget(
    plt,
    kind         = "barchart",
    x_name       = x_name,
    by_name      = by_name,
    add_title    = FALSE,
    nudge_viewer = TRUE
  )

  invisible(plt)
}

hs.plotly <- function(
  x, by = NULL,
  x_name, by_name = NULL,
  breaks,
  freq,
  fill, border,
  x_lab, y_lab,
  ax, gridT1, gridT2,
  digits_d = 2,
  position = c("overlay", "stack"),
  main = NULL,
  style_opts = .plotly_style()
) {


  position <- match.arg(position)

  # --- bin geometry ---
  left   <- breaks[-length(breaks)]
  right  <- breaks[-1L]
  mids   <- (left + right) / 2
  widths <- right - left
  right.closed <- isTRUE(attr(breaks, "right") %||% TRUE)
  n.bins <- length(mids)

  # --- groups ---
  if (is.null(by)) {
    groups <- "Series 1"
    G <- 1L
  } else {
    if (is.factor(by)) groups <- levels(by) else groups <- unique(by[!is.na(by)])
    G <- length(groups)
  }

  # --- counts per bin ---
  bins.fac <- cut(x, breaks, right = right.closed, include.lowest = TRUE)

  if (G == 1L) {
    y.vec <- as.integer(table(bins.fac))
    y.mat <- cbind(y.vec)
  } else {
    tab <- table(bins.fac, factor(by, levels = groups))
    y.mat <- unclass(tab)
  }

  # --- density (per group) ---
  if (!isTRUE(freq)) {
    for (g in seq_len(G)) {
      n.g <- sum(y.mat[, g])
      if (n.g > 0) y.mat[, g] <- y.mat[, g] / (n.g * widths)
    }
  }

  rng.txt <- paste0(
    if (right.closed) "(" else "[",
    format(signif(left, 6)), ", ", format(signif(right, 6)),
    if (right.closed) "]" else ")"
  )

  .hover.group <- function(yv) {
    if (isTRUE(freq)) {
      total.y <- sum(yv)
      share   <- if (total.y > 0) yv / total.y else rep(NA_real_, n.bins)
      cum.y   <- cumsum(yv)
      cum.pct <- if (total.y > 0) cum.y / total.y else rep(NA_real_, n.bins)
      y.fmt      <- format(round(yv, digits_d), trim = TRUE)
      cum.valfmt <- format(cum.y, trim = TRUE)
      pct.fmt    <- paste0(formatC(100 * share, format = "f", digits = 1), "%")
      cum.pctfmt <- paste0(formatC(100 * cum.pct, format = "f", digits = 1), "%")
      paste0(
        "Bin: ", rng.txt,
        "<br>", y_lab, ": ", y.fmt,
        "<br>% of total: ", pct.fmt,
        "<br>Cumulative: ", cum.valfmt,
        "<br>Cumulative %: ", cum.pctfmt
      )
    } else {
      amt     <- yv * widths
      total.y <- sum(amt)
      share   <- if (total.y > 0) amt / total.y else rep(NA_real_, n.bins)
      cum.y   <- cumsum(amt)
      cum.pct <- if (total.y > 0) cum.y / total.y else rep(NA_real_, n.bins)
      y.fmt      <- format(round(yv, digits_d), trim = TRUE)
      cum.valfmt <- format(round(cum.y, digits_d), trim = TRUE)
      pct.fmt    <- paste0(formatC(100 * share, format = "f", digits = 1), "%")
      cum.pctfmt <- paste0(formatC(100 * cum.pct, format = "f", digits = 1), "%")
      paste0(
        "Bin: ", rng.txt,
        "<br>", y_lab, ": ", y.fmt,
        "<br>% of total: ", pct.fmt,
        "<br>Cumulative (area): ", cum.valfmt,
        "<br>Cumulative %: ", cum.pctfmt
      )
    }
  }

  # colors
  alpha.fill <- .auto_opacity(
    k = if (G > 1) G else 1L,
    mode = if (G > 1 && position == "stack") "stack" else "overlay"
  )
  fill.rgba.grp  <- .maketrans_plotly(rep_len(fill,   G),     alpha = alpha.fill)
  border.hex.grp <- .to_hex(         rep_len(border, G))
  fill.rgba.bin  <- .maketrans_plotly(rep_len(fill,   n.bins), alpha = alpha.fill)
  border.hex.bin <- .to_hex(         rep_len(border, n.bins))

  # --- base widget (NO elementId here) ---
  plt <- plotly::plot_ly(
    type       = "bar",
    showlegend = G > 1
  )

  align.id <- "lessR.hs.align"

  for (g in seq_len(G)) {
    yv    <- y.mat[, g]
    hover <- .hover.group(yv)
    nm    <- if (G > 1) groups[g] else NULL

    plt <- plotly::add_trace(
      plt,
      x = mids,
      y = yv,
      name   = nm,
      width  = widths * 0.98,
      offset = 0,
      alignmentgroup = align.id,
      marker = if (G == 1) {
        list(
          color = fill.rgba.bin,
          line  = list(color = border.hex.bin, width = 1)
        )
      } else {
        list(
          color = fill.rgba.grp[g],
          line  = list(color = border.hex.grp[g], width = 1)
        )
      },
      hoverinfo = "text",
      hovertext = if (!is.null(nm) && length(by_name))
        paste0(by_name, ": ", groups[g], "<br>", hover) else hover
    )
  }

  # axes, grid, layout
  border.shapes <- plot_border()
  x.shapes      <- x_grid(gridT1)

  ax.x <- axis_num(x_lab, ax$axT1, ax$axL1)
  ax.y <- axis_num(y_lab, ax$axT2, ax$axL2)

  ax.y$showgrid  <- TRUE
  ax.y$gridcolor <- .to_hex(style_opts$grid_col)
  ax.y$gridwidth <- 1
  ax.y$griddash  <- "dot"

  plt <- plotly::layout(
    plt,
    xaxis    = ax.x,
    yaxis    = ax.y,
    shapes   = c(x.shapes, border.shapes),
    template = NULL,
    barmode  = if (G > 1 && position == "stack") "stack" else "overlay",
    bargap   = 0
  )

  plt$x$layout$plot_bgcolor  <- .to_hex(style_opts$panel_fill)
  plt$x$layout$paper_bgcolor <- .to_hex(style_opts$window_fill)

  if (G > 1) {
    leg.border <- .to_hex(style_opts$legend_border)
    leg.bg     <- .to_hex(style_opts$window_fill)
    plt <- plotly::layout(
      plt,
      legend = list(
        title = list(
          text = if (length(by_name)) by_name else "",
          font = list(size = round(
            15 * getOption("lab_size", 1)))),
        font = list(size = round(
          16 * getOption("axis_size", 0.9))),
        bgcolor = leg.bg,
        bordercolor = leg.border,
        borderwidth = 1
      )
    )
  }

  plt$x$layout$title <- NULL

  plt <- .finalize_plotly_widget(
    plt,
    kind        = "histogram",
    x_name      = x_name,
    by_name     = if (G > 1) by_name else NULL,
    add_title   = FALSE,
    nudge_viewer = (.allow.interactive() && !isTRUE(getOption("knitr.in.progress")))
  )

  invisible(plt)
}

.ss.factor <-
function(x, by=NULL, brief=FALSE, digits_d=NULL, x.name, y.name=NULL,
         x.lbl=NULL, y.lbl=NULL, label_max=20,
         x.miss=NULL, by.miss=NULL,
         out_size=NULL, is.smry_tbl=FALSE, ...)  {


.prnfreq <- function(x, type, max.ln, max.c1, n.dash, ttl, msg=FALSE) {
  tx <- character(length = 0)

  # title
  tx[length(tx)+1] <- ttl 
  tx[length(tx)+1] <- .dash2(n.dash)
  tx[length(tx)+1] <- ""

  # col labels
  if (!is.null(x.name))
    tx[length(tx)+1] <-  .fmtc(x.name, w=max.c1+3)
  tx[length(tx)+1] <- format(y.name, width=max.c1, justify="left")

  buf1 <- ifelse (type == "r", digits_d-3, 0)  # adjust for decimal digits
  for (i in seq_len(ncol(x)))
    tx[length(tx)] <- paste(tx[length(tx)], .fmtc(colnames(x)[i],
       w=max.ln[i]+buf1), sep="")

  # horizontal layout
  if (max(nchar(tx)) < getOption("width")) {

    # values
    for (i in seq_len(nrow(x))) {
      rwnm <- paste(" ", rownames(x)[i])
      tx[length(tx)+1] <-  format(rwnm, width=max.c1, justify="left")
      for (j in seq_len(ncol(x))) {
        if (type=="r") {
          tx[length(tx)] <- paste(tx[length(tx)],
             .fmt(x[i,j], d=digits_d, w=max.ln[j]+buf1), sep="")
        }
        else if (type=="i")
          tx[length(tx)] <- paste(tx[length(tx)], .fmti(x[i,j], w=max.ln[j]),
            sep="")
      }
    }
  }

  # vertical layout
  else {

    tx <- ""

    if (nrow(x) * (ncol(x)-1) > 50) { 
      if (msg  &&  getOption("note"))
        message("Table output is vertical to fit in window, but > 50 rows\n",
                "To view the complete table, save the output\n",
                "  to an object, e.g., b <- BarChart(...)\n",
                "  then b$freq\n")
    }

    else {  # write
        
      mx.cx <- max(nchar(x.name), max(nchar(colnames(x))))
      mx.c3 <- max(nchar(as.vector(apply(x, 1:2, function(v) .fmt(v, d=3))))) + 1
      by.name <- getOption("byname")

      tx[length(tx)+1] <- paste(
         .fmtc(x.name, w=mx.cx, j="left"),
         .fmtc(by.name, w=max.c1+1, j="left"),
         .fmtc("Count", w=mx.c3, j="right"))
        for (i in seq_len(ncol(x))) {
          for (j in seq_len(nrow(x))) {
             tx[length(tx)+1] <- paste(
                .fmtc(colnames(x)[i], w=mx.cx, j="left"), 
                .fmtc(rownames(x)[j], w=max.c1, j="left"))
               # .fmt(x[j,i], d=digits_d, w=max.ln-3))
          if (type=="r") {
            tx[length(tx)] <- paste(tx[length(tx)],
               .fmt(x[j,i], d=digits_d, w=mx.c3), sep="")
          }
          else if (type=="i")
            tx[length(tx)] <- paste(tx[length(tx)], .fmti(x[j,i], w=mx.c3),
              sep="")
          }  # end j
        }  # end i
      }  # write
    }  # end vertical layout

  return(tx)
}  # end .prnfreq


  # ---------------------------------
  # begin
  # ---------------------------------

  if (is.null(digits_d)) digits_d <- getOption("digits_d")

  # maximum number of output text columns
  c.nm <- NULL  # storage for full value labels when they are abbreviated

  # convert to table with variable names if needed 
  if (!is.table(x) && !is.matrix(x)) {  # bc could send a table or matrix
    if (is.null(by)) 
      x <- table(x, dnn=NULL)  # if missing data
    else
      x <- table(by, x, dnn=c(y.name, x.name)) 
  }

  # title only if one var and var labels
  txttl <- ""
  dims <- length(dim(x))
  if (dims == 1 || (!is.null(x.lbl) || !is.null(y.lbl))) {  #  one var or labels
    txttl <- .title2(x.name, y.name, x.lbl, y.lbl, is.null(by), new.ln=FALSE)
  }

  n.dim <- length(dim(as.table(x)))


  # two variables
  # print table, chi-square analysis
  # -------------------------------------
  if (n.dim == 2) {

    # potential abbreviation of column labels
    mx.chr <- max(nchar(colnames(x)))
    if (mx.chr > label_max) {
      c.nm <- colnames(x)  # store for later use
      colnames(x) <- .abbrev(colnames(x), label_max)
    }
    
    # use for returned output, x is a 2-way table
    freq_df <- data.frame(t(x), stringsAsFactors=TRUE)

    xx <- addmargins(x)

    # width of column 1
    if (!is.null(y.name))
      max.c1 <- nchar(y.name)
    else
      max.c1 <- 0
    for (i in seq_len(nrow(xx))) {
      c1 <- nchar(rownames(xx)[i])
      if (c1 > max.c1) max.c1 <- c1
    }
    max.c1 <- max.c1 + 2
    if (max.c1 < 5) max.c1 <- 5

    # width of data columns
    max.ln <- integer(length=0)
    for (i in seq_len(ncol(xx))) {
        ln.nm <- nchar(colnames(xx)[i])
        ln.vl <- max(nchar(as.character(xx[,i])))
        max.ln[i] <- max(ln.nm, ln.vl) + 1
        if (max.ln[i] < 4) max.ln[i] <- 4
    }

    # cell frequencies
    txfrq <- .prnfreq(xx, "i", max.ln, max.c1, n.dash=30,
                      ttl="Joint and Marginal Frequencies", msg=TRUE)

    tx <- character(length = 0)
    ch <- summary(as.table(x))
    if (!is.nan(ch$statistic)) {
      min_rc <- min(nrow(x)-1, ncol(x)-1)
      V <- sqrt(ch$statistic / (min_rc * ch$n.cases))
      txt <- ifelse(ch$parameter == 1, " (phi)", "") 
      txt <- paste("Cramer\'s V", txt, ":", sep="")
      tx[length(tx)+1] <- paste(txt, .fmt(V,3))
      tx[length(tx)+1] <- ""
      tx[length(tx)+1] <- paste("Chi-square Test of Independence:\n", 
          "     Chisq = ", .fmt(ch$statistic,3), ", df = ", ch$parameter,
          ", p-value = ", .fmt(ch$p.value,3), sep="")
      if (!ch$approx.ok) 
        tx[length(tx)+1] <- paste(">>> Low cell expected frequencies,",
            "chi-squared approximation may not be accurate")
      #tx[length(tx)+1] <- ""
    }
    else
      tx[length(tx)+1] <- paste(
          "Cross-tabulation table not well-formed, usually too many zeros\n",
          "Cramer's V and the chi-squared analysis not possible\n\n", sep="")
    txXV <- tx

    if (brief)
      return(list(n.dim=n.dim, txttl=txttl, txfrq=txfrq, txXV=txXV,
                  freq_df=freq_df, pvalue=ch$p.value))


# full analysis ------ when stack100=TRUE, proportions not correct, ignored

    nan.flag <- FALSE

    for (i in seq_len(ncol(xx))) {
      if (max.ln[i] < 6) max.ln[i] <- 6
    }

    # cell proportions and marginals
    xx <- round(addmargins(prop.table(x)),3)
    mx.ln <- max(max.ln)
    buf <- digits_d - 3  # 3 decimal digits already accounted for
    if (buf < max.c1) buf <- mx.ln - 4
    txprp <- .prnfreq(xx, "r", max.ln+buf, max.c1, n.dash=30,
                      ttl="Cell Proportions and Marginals")

    # cell proportions within each column
    x.col <- prop.table(x, margin=2)
    Sum <- numeric(ncol(x.col))
    for (i in seq_len(ncol(x.col))) {
      Sum[i] <- sum(x.col[,i])
      if (is.nan(Sum[i])) nan.flag <- TRUE
    }
    x.col2 <- round(rbind(x.col,Sum))
    names(dimnames(x.col2)) <- names(dimnames(x.col))
    buf <- digits_d - 3  # 3 decimal digits already accounted for
    mx.ln <- max(max.ln)
    if (buf < max.c1) buf <- mx.ln - 4
    txcol <- .prnfreq(x.col2, "r", max.ln+buf, max.c1, n.dash=35,
                      ttl="Cell Proportions within Each Column")

    # cell proportions within each row
    x.row <- prop.table(x, margin=1)
    Sum <- numeric(nrow(x.row))
    for (i in seq_len(nrow(x.row))) {
      Sum[i] <- sum(x.row[i,])
      if (is.nan(Sum[i])) nan.flag <- TRUE
    }
    x.row2 <- round(cbind(x.row,Sum),3)
    names(dimnames(x.row2)) <- names(dimnames(x.row))

    txrow <- .prnfreq(x.row2, "r", max.ln, max.c1, n.dash=32,
                      ttl="Cell Proportions within Each Row")

    if (nan.flag)
      cat("\nNote: NaN results from all values missing for that cell or margin.\n",
                 "     so any division to compute a proportion is undefined.\n")
      
    txlbl <- ""
    tx <- character(length = 0)
    if (!is.null(c.nm)) {
      tx[length(tx)+1] <- "Labels"
      tx[length(tx)+1] <- "--------------------"
      tx[length(tx)+1] <- paste(.fmtc(colnames(x), w=max(nchar(colnames(x))),
                                   j="left"), "  ", c.nm, sep="", collapse="\n")
      txlbl <- tx
    }

    # back to ss or ss data frame
    return(list(n.dim=n.dim, txttl=txttl, txlbl=txlbl, txfrq=txfrq,
                txXV=txXV, txprp=txprp, txcol=txcol, txrow=txrow,
                freq_df=freq_df, pvalue=ch$p.value))
    # end full analysis

  }  # end two variable


  # one variable
  else if (n.dim == 1) { 
    lnx <- length(names(x))
    if (lnx == sum(x)  &&  is.smry_tbl) {  # x is vector of counts, if unique
      if (length(x) > 100)
        cat("\nOnly the first 100 value out of", lnx, "listed.\n\n")
      nms <- character(length=0)
      for (i in seq_len(min(length(x), 100))) nms[i] <- names(x)[i]
      cat("\n")
      cat("Values:", nms, "\n")
      cat("\n",  #; stop(call.=FALSE, "\n","------\n",
          "All values for ", x.name, " are unique\n",
          "Perhaps a row ID instead of a variable for analysis\n",
          "If so, use  row.names=n  option for Read, where n refers to the ",
          "nth column\n\n", sep="")
      return(list(n.dim=1, title="", counts="", miss="", 
                  chi="", lbl="", freq=x, freq_df="", prop="",
                  pvalue=""))
    }
    # table not of unique values, so proceed

    # potential abbreviation of column labels
    #  if (is.na(names(x)[length(x)])) names(x)[length(x)] <- "missing"
    mx.chr <- max(nchar(names(x)))

    c.nm <- NULL
    if (mx.chr > label_max) {
      c.nm <- names(x)  # store for later use
      names(x) <- .abbrev(names(x), label_max)
    }

     max.ln <- integer(length=0)      
     for (i in seq_along(x)) {
       ln.nm <- nchar(names(x[i]))
       ln.vl <- nchar(as.character(x[i]))
       max.ln[i] <- max(ln.nm, ln.vl) + 1
       if (max.ln[i] < 6) max.ln[i] <- 6
     }

    tx <- character(length=0)

    tx[length(tx)+1] <- format("", width=13)
    w <- nchar(as.character(sum(x)))

    for (i in seq_along(x))  # level names + Total
      tx[length(tx)] <- paste(tx[length(tx)], .fmtc(names(x[i]), w=max.ln[i]))
    tx[length(tx)] <- paste(tx[length(tx)], .fmtc("Total", w=w+6))
    col.width <- nchar(tx[length(tx)])

    tx[length(tx)+1] <- "Frequencies: "
    for (i in seq_along(x))
      tx[length(tx)] <- paste(tx[length(tx)], .fmti(x[i], w=max.ln[i]))
    tx[length(tx)] <- paste(tx[length(tx)], .fmti(sum(x), w=w+6))

    tx[length(tx)+1] <- "Proportions: "
    sum.x <- sum(x)
    xp <- x / sum.x
    for (i in seq_along(x))
      tx[length(tx)] <- paste(tx[length(tx)], .fmt(xp[i], 3, max.ln[i]))
    tx[length(tx)] <- paste(tx[length(tx)], .fmtc("1.000", w=w+6))
    txcnt <- tx

    # potential vertical display
    max.clmns <- ifelse (is.null(out_size), getOption("width"), out_size)
    if (col.width > max.clmns) {
      mx.nm <- max(nchar(names(x)), nchar("Total"))
      mx.fr <- nchar(sum(x)) + 2
      tx <- character(length=0)
      xnm <- ifelse (nchar(x.name) > 13, .abbrev(x.name, 13), x.name)
      tx[length(tx)+1] <- .fmtc(xnm, w=mx.nm)
      tx[length(tx)] <- paste(tx[length(tx)], .fmtc("Count", w=mx.fr))
      tx[length(tx)] <- paste(tx[length(tx)], .fmtc("Prop", w=6))

      tx[length(tx)+1] <- .dash2(mx.nm + mx.fr + 9)
      for (i in seq_along(x)) {
        tx[length(tx)+1] <- .fmtc(names(x[i]), w=mx.nm)
        tx[length(tx)] <- paste(tx[length(tx)], .fmti(x[i], w=mx.fr)) 
        tx[length(tx)] <- paste(tx[length(tx)], .fmt(xp[i], 3, w=7)) 
      }
      tx[length(tx)+1] <- .dash2(mx.nm + mx.fr + 9)
      tx[length(tx)+1] <- .fmtc("Total", w=mx.nm)
      tx[length(tx)] <- paste(tx[length(tx)], .fmti(sum(x), w=mx.fr))
      tx[length(tx)] <- paste(tx[length(tx)],  .fmtc("1.000", w=7))
      txcnt <- tx
    }

    txmis <- NULL
    if (!is.null(x.miss)) {
      tx <- character(length = 0)
#     txt <- paste("Missing Values of ", x.name, ":", sep="")
      txt <- paste("Missing Values:")
      tx[length(tx)+1] <- paste(txt, x.miss) 
      txmis <- tx    
    }

    txchi <- ""
    txlbl <- ""
    ch <- NULL

    if (length(x) > 1) {  # length(x) is the number of levels of 1-D table x
        tx <- character(length = 0)
        ch <- suppressWarnings(chisq.test(x))  # provide own warning of small n
        tx[length(tx)+1] <- 
          "Chi-squared test of null hypothesis of equal probabilities"
        tx[length(tx)+1] <- paste("  Chisq = ", .fmt(ch$statistic,3), ", df = ",
          ch$parameter, ", p-value = ", .fmt(ch$p.value,3), sep="")
        if (any(ch$expected < 5)) 
          tx[length(tx)+1] <- paste(">>> Low cell expected frequencies,",
              "so chi-squared approximation may not be accurate", "\n")
        txchi <- tx

        txlbl <- ""
        tx <- character(length = 0)
        if (!is.null(c.nm)) {
          tx[length(tx)+1] <- "Unabbreviated labels"
          tx[length(tx)+1] <- "--------------------"
          tx[length(tx)+1] <- paste(c.nm, sep="", collapse="\n")
          txlbl <- tx
        }
    }

    freq_df <- data.frame(x)  #  a pivot result, two vars, Cats and Freq
    if (!is.null(x.name) && nzchar(x.name)) names(freq_df)[1] <- x.name

    return(list(n.dim=n.dim, title=txttl, counts=txcnt, miss=txmis, 
                chi=txchi, lbl=txlbl, freq=x, freq_df=freq_df, prop=xp,
                pvalue=if (!is.null(ch)) ch$p.value else NULL))
  }  # one variable

}

Nest <-
function(y, nested_model, full_model, method=c("lm", "logit"),
         data=d, digits_d=NULL, ...) {

  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (!is.null(dots)) if (length(dots) > 0) {
    change <- c("nested.model", "full.model", "digits.d")
    for (i in seq_along(dots)) {
      if (names(dots)[i] %in% change) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
      }
    }
  }

  method <- match.arg(method)

  my.vars <- as.list(seq_along(data))
  names(my.vars) <- names(data)


  # get response variable
  rv <- eval(substitute(y), envir=my.vars, enclos=parent.frame())
  y.name <-  names(my.vars)[rv]

  if (is.null(digits_d)) digits_d <- .getdigits(data[,y.name], 2)
  options(digits_d=digits_d) 

  if (method == "logit") {
    is.bin <- TRUE
    if (is.character(data[,y.name]))
      data[,y.name] <- factor(data[,y.name])
    if (is.factor(data[,y.name])) { 
      if (nlevels(data[,y.name]) != 2) is.bin  <- FALSE
    }
    else {
      for (i in seq_len(nrow(data)))
        if (!is.na(data[i,y.name]))
          if (data[i,y.name]!=0 && data[i,y.name]!=1) is.bin <- FALSE
     }
    if (!is.bin) { 
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Response variable: ", y.name, "\n",
        "If numeric, can only have values of 0 or 1.\n",
        "If a factor, can only have two levels.\n\n")
    }
  }

  # get nested model
  nest.vars <- eval(substitute(nested_model), envir=my.vars, enclos=parent.frame())
  n.pred <- length(nest.vars)
  x.name <- character(length=n.pred)
  for (ivar in seq_len(n.pred)) {
    x.name[ivar] <- names(my.vars)[nest.vars[ivar]]
  }
  xn.preds <- x.name[1]
  if (n.pred > 1)
    for(ivar in 2:n.pred) xn.preds <- paste(xn.preds, "+", x.name[ivar])

  n.formula <- as.formula(paste(y.name, "~", xn.preds))


  # get full model and analyze
  full.vars <- eval(substitute(full_model), envir=my.vars, enclos=parent.frame())
  full.vars <- union(nest.vars, full.vars)
  n.pred <- length(full.vars)

  x.name <- character(length=n.pred)

  for (ivar in seq_len(n.pred)) x.name[ivar] <- names(my.vars)[full.vars[ivar]]

  xf.preds <- x.name[1]
  if (n.pred > 1)
    for(ivar in 2:n.pred) xf.preds <- paste(xf.preds, "+", x.name[ivar])

  f.formula <- as.formula(paste(y.name, "~", xf.preds))


  # do the model comparison

  if (method=="lm") {
    lm.full <- lm(f.formula, data=data)
    lm.nest <- lm(n.formula, data=lm.full$model)
    av <- anova(lm.nest, lm.full)

    tx <- character(length = 0)

    models <- attr(av, "heading")[2]
    models <- sub("Model 1", "Reduced Model", models)
    models <- sub("Model 2", "Full Model   ", models)
    tx[length(tx)+1] <- models
    txtmdl <- tx

    tx <- character(length = 0)

    if (is.null(options()$knitr.in.progress)) {
      tx[length(tx)+1] <- "Analysis of Variance"
      tx[length(tx)+1] <- ""
    }

    max.c1 <- nchar("Residual")

    mr.df <- av$Df[2]; mr.ss <- av$`Sum of Sq`[2]; mr.ms <- mr.ss/mr.df
    mr.f <- av$F[2]; mr.p <- av$`Pr(>F)`[2]

    mf.df <- av$Res.Df[2]; mf.ss <- av$RSS[2]; mf.ms <- mf.ss/mf.df

    # width of columns
    d <- digits_d
    max.ln <- integer(4)
    max.ln[1] <- max(nchar(.fmti(mr.df)),nchar(.fmti(mf.df)),nchar("df"))
    max.ln[2] <- max(nchar(.fmt(mr.ss,d)),nchar(.fmt(mf.ss,d)),nchar("Sum Sq")) 
    max.ln[3] <- max(nchar(.fmt(mr.ms,d)),nchar("Mean Sq"))
    max.ln[4] <- nchar(.fmt(mr.p,d))
    max.ln <- max.ln + 2

    df.lbl <- .fmtc("     df", max.ln[1]+1)
    SS.lbl <- .fmtc(" Sum Sq", max.ln[2]+1)
    MS.lbl <- .fmtc("Mean Sq", max.ln[3]+1)
    fv.lbl <- .fmtc("F-value", max.ln[4]+3)
    tx[length(tx)+1] <- paste(eval(format("", width=max.c1+max.ln[1]-6)),
           df.lbl, SS.lbl, MS.lbl, fv.lbl, "   p-value", sep="")

    if (n.pred > 0) {
      rlb <- .fmtc("Tested", max.c1, j="left")

      md <- .fmti(mr.df, max.ln[1]) 
      ms <- .fmt(mr.ss, digits_d, max.ln[2])
      mm <- .fmt(mr.ms, digits_d, max.ln[3])
      mf <- .fmt(mr.f, digits_d, max.ln[4]+2)
      mp <- .fmt(mr.p, 3, 9) 

      tx[length(tx)+1] <- paste(rlb, md, ms, mm, mf, mp)

      tst <- c(mr.df, mr.ss, mr.ms, mr.f, mr.p)
      names(tst) <- c("df", "ss", "ms", "fvalue", "pvalue")

    # Residuals
    rlb <- .fmtc("Residual", max.c1, j="left")
    df <- .fmti(mf.df, max.ln[1])
    SS <- .fmt(mf.ss, digits_d, max.ln[2])
    MS <- .fmt(mf.ms, digits_d, max.ln[3])

    tx[length(tx)+1] <- paste(rlb, df, SS, MS) 

    rsd <- c(mf.df, mf.ss, mf.ms)
    names(rsd) <- c("df", "ss", "ms")

    tot <- NA

    txtbl <- tx

    }
  }  # end method="lm"

  else {
    lm.full <- suppressWarnings(glm(f.formula, data=data, family="binomial"))
    lm.nest <- suppressWarnings(glm(n.formula, data=lm.full$model, family="binomial"))
    av <- anova(lm.nest, lm.full, test="Chisq")

    tx <- character(length = 0)

    models <- attr(av, "heading")[2]
    models <- sub("Model 1", "Reduced Model", models)
    models <- sub("Model 2", "Full Model   ", models)
    tx[length(tx)+1] <- models
    txtmdl <- tx

    tx <- character(length = 0)

    if (is.null(options()$knitr.in.progress)) {
      tx[length(tx)+1] <- "Analysis of Deviance"
      tx[length(tx)+1] <- ""
    }

    max.c1 <- nchar("Residual")

    mr.df <- av$Df[2]; mr.dv <- av$`Deviance`[2]; mr.p <- av$`Pr(>Chi)`[2]
    mf.df <- av$`Resid. Df`[2]; mf.dv <- av$`Resid. Dev`[2];
    mt.df <- av$`Resid. Df`[1]; mt.dv <- av$`Resid. Dev`[1];

    # width of columns
    d <- digits_d
    max.ln <- integer(2)
    max.ln[1] <- max(nchar(.fmti(mr.df)),nchar(.fmti(mf.df)),nchar("df"))
    max.ln[2] <- nchar(.fmt(mr.dv,d)) + 2
    max.ln <- max.ln + 2

    df.lbl <- .fmtc("     df", max.ln[1]+1)
    dv.lbl <- .fmtc(" Deviance", max.ln[2]+1)
    tx[length(tx)+1] <- paste(eval(format("", width=max.c1-max.ln[1]+4)),
           df.lbl, dv.lbl, "   p-value", sep="")

    if (n.pred > 0) {
      rlb <- .fmtc("Tested", max.c1, j="left")

      md <- .fmti(mr.df, max.ln[1]) 
      dv <- .fmt(mr.dv, digits_d, max.ln[2])
      mp <- .fmt(mr.p, 3, 9) 

      tx[length(tx)+1] <- paste(rlb, md, dv, mp)

      tst <- c(mr.df, mr.dv, mr.p)
      names(tst) <- c("df", "dev", "pvalue")

    # Residuals
    rlb <- .fmtc("Residual", max.c1, j="left")
    df <- .fmti(mf.df, max.ln[1])
    dev <- .fmt(mf.dv, digits_d, max.ln[2])

    tx[length(tx)+1] <- paste(rlb, df, dev) 

    rsd <- c(mf.df, mf.dv)
    names(rsd) <- c("df", "dev")

    # Total
    rlb <- .fmtc("Total", max.c1, j="left")
    df <- .fmti(mt.df, max.ln[1])
    dev <- .fmt(mt.dv, digits_d, max.ln[2])

    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste(rlb, df, dev) 

    tot <- c(mt.df, mt.dv)
    names(tot) <- c("df", "dev")

    txtbl <- tx

    }

  }  # end method="logit"


  class(txtmdl) <- "out"
  class(txtbl) <- "out"
  
  output <- list(
    fun_call=match.call(), out_models=txtmdl, out_anova=txtbl,
    anova_tested=tst, anova_residual=rsd, anova_total=tot
  )

  class(output) <- "out_all"

  return(output)

}

# Plot quantiles, tails of normal and t for specified alpha
prob_tcut <- 
function(df, alpha=0.05, digits_d=3, y_axis=FALSE,
         fill="aliceblue", color_tail="palevioletred4",
         nrm_color=gray(.7), color_t=gray(.08),
         pdf_file=NULL, width=5, height=5, ...) {


  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (!is.null(dots)) if (length(dots) > 0) {
    change <- c("digits.d", "y.axis", "color.tail", "nrm.color",
                "color.t", "pdf.file")
    for (i in 1:length(dots)) {
      if (names(dots)[i] %in% change) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
        get(nm)
      }
    }
  }

  dots <- list(...)  # check for deprecated parameters
  if (length(dots) > 0) {
    for (i in 1:length(dots)) {
      if (substr(names(dots)[i], 1, 4) == "col.") {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "options that began with the abbreviation  col  now begin with  ",
          "color \n\n")
      }
    }
  }

  if (df < 2) { 
    cat("\n"); stop(call.=FALSE, "\n","------\n",
    "The parameter  df  must be 2 or larger.\n\n")
  }

  # set up plot 
  .opendev(pdf_file, width, height)

  orig.params <- par(no.readonly=TRUE)
  on.exit(par(orig.params))
  par(mar=c(4, 3, 1, 2), mgp=c(2,.6,0))

  xmin <- -5.5
  xmax <- 5.5

  x1min <- xmin
  x2max <- xmax

  tail.area <- alpha / 2


  #-------------
  # t Dist
  #-------------
  x <- seq(xmin,xmax,length=200)
  y <- dt(x, df=df)
  plot(x,y, type="n", ylim=c(0,.42), axes=FALSE, lwd=2, las=1, main="", 
       xlab="Standard Errors from Zero", ylab="")

  axis(side=1)
  if (y_axis) {
    axis(side=2)
    ylab="Density"
    title(ylab=ylab)
  }

  usr <- par("usr")
  rect(usr[1], usr[3], usr[2], usr[4], 
       col=rgb(249,249,252,maxColorValue=255), border="black")

  # curve and fill
  x1max <- qt(tail.area, df=df)
  x2min <- qt(tail.area, df=df, lower.tail=FALSE)
  lines(x,y, type="l", lwd=4, col=color_t, las=1, main="", xlab="z", ylab="")
  polygon(c(x1max,x,x2min), c(0,y,0), col=fill, border="transparent")
  # rgb(.91, .95, .98)

  # Left Tail
  x1max <- qt(tail.area, df=df)
  x <- seq(x1min,x1max,by=.01)
  y <- dt(x,df=df)
  polygon(c(x1min,x,x1max), c(0,y,0), col=color_tail, border=nrm_color)
  lines(c(x1max,x1max), c(0,.19), col=color_tail)
  text(x1max, .20, col=color_t, cex=1.1, .fmt(x1max, digits_d, w=5))

  # Right Tail
  x2min <- qt(1-tail.area, df=df)
  cutoff <- x2min
  x <- seq(x2min,x2max,by=.01)
  y <- dt(x,df=df)
  polygon(c(x2min,x,x2max), c(0,y,0), col=color_tail, border=nrm_color)
  lines(c(x2min,x2min), c(0,.19), col=color_tail)
  text(x2min, .20, col=color_t, cex=1.1, .fmt(x2min, digits_d, w=5))

  #-------------
  # Normal Dist
  #-------------
  x1max <- qnorm(tail.area)
  x2min <- qnorm(1-tail.area)
  x <- seq(xmin,xmax,length=200)
  y <- dnorm(x)
  lines(x,y, type="l", lwd=2, col=nrm_color, las=1, main="", xlab="z", ylab="")
  abline(h=0)

  # fill
  txtht <- 0.175
  rlbl <- paste(toString(round(100*(1-alpha),0)), "%", sep="")
  text(0, txtht, rlbl, cex=1.4, col=nrm_color)

  # Left Tail
  lines(c(x1max,x1max), c(0,.25), col=nrm_color)
  text(x1max, .26, col=nrm_color, cex=1.1, .fmt(x1max, digits_d, w=5))

  # Right Tail
  lines(c(x2min,x2min), c(0,.25), col=nrm_color)
  text(x2min, .26, col=nrm_color, cex=1.1, .fmt(x2min, digits_d, w=5))

  #-------------
  # Legend
  #-------------
  dflbl <- paste("t, df=",toString(df),sep="")
  legend("topright", c("Normal", dflbl), lwd=c(1,1.5),
    col=c(nrm_color,color_t), box.lwd=.5, cex=.75)


  # terminate pdf graphics system
  par(orig.params)        
  if (!is.null(pdf_file)) {
    dev.off()
    .showfile(pdf_file, "t-curve probability")
  }

  cat("Probability: ", cutoff, "\n")
  return(invisible(cutoff))

}

Correlation <-
function(x, y, data=d, # x can be a data frame, or variables in a data frame
         miss=c("pairwise", "listwise", "everything"),
         show=c("cor", "missing"),
         fill_low=NULL, fill_hi=NULL,
         brief=FALSE, digits_d=NULL, heat_map=TRUE,
         main=NULL, bottom=3, right=3, quiet=getOption("quiet"),
         pdf_file=NULL, width=5, height=5, ...) {


  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (length(dots) > 0) {
    for (i in 1:length(dots)) {
      if (length(grep(".", names(dots)[i], fixed=TRUE)) > 0) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
      }
    }
  }

  miss <- match.arg(miss)
  show <- match.arg(show)

  # replace older names with current name
  if (length(dots) > 0) {
    for (i in 1:length(dots)) {
      if (names(dots)[i] == "graphics")  heat_map <- dots[[i]]
      if (names(dots)[i] == "show_n") {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "New parameter  show  replaces  show_n.\n",
        "Obtain pairwise missing value counts with  show=\"missing\", \n\n")
    }
    }
  }
  
  x.name <- paste(deparse(substitute(x), width.cutoff=120L),
                  collapse="")
  options(xname = x.name)

  is.df <- FALSE  # is data frame
  df.ok <- FALSE  # data frame mode successfully established

  if (missing(y)) {  # is a data frame or a list of variables
    is.df <- TRUE
    if (missing(x)) {
      x.name <- "$"  # in case x is missing, i.e., data frame d
      if (missing(data)) data <- eval(substitute(d))
      df.ok <- TRUE
    }
    else if (.is_expr_arg(substitute(x))) {
      # expression, e.g., d[, 1:3]: a data frame result is the matrix
      #   to correlate; anything else falls to the stop below
      uses.df <- any(all.vars(substitute(x)) %in%
                     tryCatch(names(data),
                              error=function(e) character(0)))
      val <- .expr_eval(substitute(x), x.name,
                        if (uses.df) data else NULL,
                        parent.frame(), role="x", fun.name="Correlation")
      if (is.data.frame(val)) {
        data <- val
        df.ok <- TRUE
      }
    }

    else if ( (!grepl(":", x.name) && !grepl(",", x.name)) ) {
      # x must name a data frame in the global environment
      if (is.data.frame(x) && exists(x.name, where=.GlobalEnv)) {
        data <- x  # specified data name
        df.ok <- TRUE
      }
    }

    else {  # two variables
      all.vars <- as.list(seq_along(data))
      names(all.vars) <- names(data)
      # proceed here only if x.name is in data or is a list
      if ((x.name %in% names(all.vars)) || grepl(":", x.name)
            || grepl(",", x.name) ) {
        x.col <- eval(substitute(x), envir=all.vars, enclos=parent.frame())

        # if x is a variable list, create subset data frame
        if (length(x.col) > 1) {
          data <- data[, x.col]
          is.df <- TRUE
          df.ok <- TRUE
        }
      }
    }

    # x given but is not a data frame or variable list: too little
    if (!df.ok) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        x.name, " is not the name of a data frame, and no second\n",
        "variable was provided for a correlation.\n\n",
        "Correlate two variables with:  Correlation(x, y)\n",
        "Correlate a data frame with:  Correlation(mydata)\n\n")
    }
  }  # end missing y


  if (!is.df) {  # pairwise

    dname <- deparse(substitute(data))
    options(dname = dname)

    # classify x and y: a computational expression evaluates directly,
    #   with a data-column reference resolved from the data frame, then
    #   the caller's environment
    x.is.expr <- .is_expr_arg(substitute(x))
    y.is.expr <- .is_expr_arg(substitute(y))

    # get conditions and check for data existing
    is.frml <- ifelse (grepl("~", x.name), TRUE, FALSE)
    if (x.is.expr) {
      uses.df <- dname != "NULL" &&
                 any(all.vars(substitute(x)) %in%
                     tryCatch(names(data),
                              error=function(e) character(0)))
      x.call <- .expr_eval(substitute(x), x.name,
                           if (uses.df) data else NULL,
                           parent.frame(), role="x",
                           fun.name="Correlation")
    }
    else {
      in.global <- df.or.global(x.name, dname, role="x",
                                fun.name="Correlation")

      # see if the variable exists in data frame, if x not in global env
      if (!in.global) .xcheck(x.name, dname, names(data))

      if (in.global) x.call <- x else x.call <- eval(substitute(data$x))
    }

    # evaluate y
    # get actual variable name before potential call of data$x
    y.name <- paste(deparse(substitute(y), width.cutoff=120L),
                    collapse="")
    options(yname = y.name)

    if (y.is.expr) {
      uses.df <- dname != "NULL" &&
                 any(all.vars(substitute(y)) %in%
                     tryCatch(names(data),
                              error=function(e) character(0)))
      y.call <- .expr_eval(substitute(y), y.name,
                           if (uses.df) data else NULL,
                           parent.frame(), role="y",
                           fun.name="Correlation")
    }
    else {
      # get conditions and check for data existing
      in.global <- df.or.global(y.name, dname, role="y",
                                fun.name="Correlation")

      # see if var exists in data frame, if not in global env
      if (!in.global) .xcheck(y.name, dname, names(data))

      if (in.global) y.call <- y
      else y.call <- eval(substitute(data$y))
    }

    if ((x.is.expr || y.is.expr) &&
        length(x.call) != length(y.call)) {
      cat("\n"); stop(call.=FALSE, "\n------\n",
        "x yields ", length(x.call), " values, but  y  yields ",
        length(y.call), " values\n",
        "Correlation requires paired values of the two variables\n\n")
    }

  }  # x not data frame


  if (is.df) { 
    stuff <- .cr.data.frame(data, miss, show, digits_d,
                   heat_map, fill_low, fill_hi, main, bottom, right, quiet, 
                   pdf_file, width, height, ...) 

    txmis <- stuff$txm

    class(txmis) <- "out"

    if (show == "cor") {
      if (!quiet)
        return(stuff$R)
      else
        invisible(stuff$R)
      }
    else if (show == "missing") return(txmis)
  }

  else {  # pairwise
  
    if (!is.null(pdf_file)) {
      cat("\n");   warning(call.=FALSE, "\n","------\n",
        " To produce a scatter plot, pass a vector to:  Plot\n",
        " No heat map produced here and yet a pdf file is specified.\n\n",
         sep="")
     }

    stuff <- .cr.main(x.call, y.call, brief, ...) 
    txbck <- stuff$txb
    txdsc <- stuff$txd
    txinf <- stuff$txi

    class(txbck) <- "out"
    class(txdsc) <- "out"
    class(txinf) <- "out"

    output <- list(out_background=txbck, out_describe=txdsc,
      out_inference=txinf,
      r=stuff$r, tvalue=stuff$tvalue, df=stuff$df, pvalue=stuff$pvalue,
      lb=stuff$lb, ub=stuff$ub)

    class(output) <- "out_all"
    return(output)
  }  # end pairwise

}

.ss.numeric <-
function(x, by=NULL, digits_d=NULL, brief, y.name=NULL, facet1.nm=FALSE,
         x.name=NULL, ...) {

  # get variable labels if exist
  # graph.win=FALSE turns off call to par, so blank window in R not produced
  gl <- .getlabels(graph.win=FALSE)

  if (!is.null(gl$yn))  # from Plot(Salary, stat="count")
    y.name <- ifelse (is.null(y.name), gl$yn, y.name)  # sometimes need facet1.name

  if (is.null(x.name)) {
    x.name <- gl$xn
    x.lbl <- gl$xl
  }
  else  # option just for pc.main
    x.lbl <- NULL

  if (facet1.nm) {
    gl <- .getlabels(graph.win=FALSE, facet1.nm=TRUE)
  }
  y.lbl <- gl$yl

  max.char <- 0
  if (is.null(by))
    n.lines <- 1
  else {
    bu <- as.factor(unique(na.omit(by)))
    n.lines <- nlevels(bu)
    for (i in seq_len(nlevels(bu)))  # largest level name
      if (nchar(levels(bu)[i]) > max.char) max.char <- nchar(levels(bu)[i])
    vectors <- split(x, by)
  }

  if (is.null(digits_d)) {
    digits_d <- .max.dd(x) + 1
    if (digits_d == 1) digits_d <- 2
  }
  options(digits_d=digits_d)
# if (digits_d > 10) {
#   cat("\nThese data values contain ", digits_d, " decimal digits. To enhance\n",
#       "the readability of the output, only 4 decimal digits are\n",
#       "displayed.  To customize this setting, use the digits_d  parameter.\n",
#       "Example for Variables Y and X:  > ss(Y, by=X, digits_d=3)\n\n",
#       sep="")
#   digits_d <- 4
# }

  # get maximum chars in 1st three columns
  max.lv <- 0; max.n <- 0; max.nm <- 0
  if (n.lines > 1) {
    for (i in seq_len(n.lines)) {
      nch.lv <- nchar(as.character(levels(as.factor(by))[i]))
      nch.n <- nchar(as.character(sum(!is.na(vectors[[i]]))))
      nch.nm <- nchar(as.character(sum(is.na(vectors[[i]]))))
      if (nch.lv > max.lv) max.lv <- nch.lv
      if (nch.n > max.n) max.n <- nch.n
      if (nch.nm > max.nm) max.nm <- nch.nm
    }
  }
  else {
    if (max.lv < 3) max.lv <- 3
    max.n <- nchar(as.character(sum(!is.na(x))))
    max.nm <- nchar(as.character(sum(is.na(x))))
  }

  # get max.ln, maximum length of the individual fields
  # (this computes the mean and sd twice for each line, also for output)
  max.ln <- 0
  for (i in seq_len(n.lines)) {
    if (n.lines == 1)
      xx <- x
    else {
      lv <- levels(as.factor(by))[i]
      xx <- vectors[[i]]
    }
    m <- mean(xx, na.rm=TRUE)
    s <- sd(xx, na.rm=TRUE)
    if (is.na(s))
      n.ln <- nchar(as.character(round(m, digits_d))) + digits_d
    else
      n.ln <- max(nchar(as.character(round(m, digits_d))),
                  nchar(as.character(round(s, digits_d)))) + digits_d
    if (n.ln > max.ln) max.ln <- n.ln
  }
  if (max.ln < 5) max.ln <- max.ln + 1
  if (max.ln < 10) max.ln <- max.ln + 1

  tx <- character(length = 0)

  # ------
  # output

  # first the title with any variable labels
  txlbl <- .title2(x.name, y.name, x.lbl, y.lbl, is.null(by))
  if (length(txlbl) > 1) if (substr(txlbl[2],1,1) ==  "\n")
    txlbl[2] <- sub("\n", "", txlbl[2])
# txlbl[length(txlbl)+1] <- ""
  tx <- txlbl
  advance <- if (!is.null(x.name) && x.name != "*NONE*") 1L else 0L
  if (x.name == "*NONE*") tx <- ""
  # --------------------------------
  # the stats loop
  for (i in seq_len(n.lines)) {
    if (n.lines == 1) {
      xx <- x
      p.lv <- ""
    }
    else {
      lv <- levels(as.factor(by))[i]
      xx <- vectors[[i]]
      p.lv <- format(lv, width=max.char+1)
    }

    m <- NA; s <- NA; mn <- NA; mx <- NA; md <- NA
    sk <- NA; kt <- NA; q1 <- NA; q3 <- NA; qr <- NA
    # get the descriptive statistics
    n <- sum(!is.na(xx))
    n.miss <- sum(is.na(xx))
    xx <- na.omit(xx)
    if (n>0) m <- mean(xx)
    if (n>1) s <- sd(xx)

    # skewness:  adjusted Fisher-Pearson standardized moment coefficient
    sk <- skew(xx)

    # kurtosis
    kt <- kurtosis(xx)

    # order stats
    if (n > 0) {
      mn <- min(xx)
      q1 <- quantile(xx, probs=0.25)
      md <- median(xx)
      q3 <- quantile(xx, probs=0.75)
      mx <- max(xx)
      qr <- IQR(xx)
    }


    if (i == 1) { # heading labels
      if (max.ln < 4) max.ln <- max.ln + 2
      if (max.ln < 8) max.ln <- max.ln + 1
      nbuf <- ifelse (n.lines==1, 3, 5)

      n.lbl <- .fmtc("n", nchar(as.character(max.n))+nbuf+max.lv-2)
      miss_lbl <- .fmtc("miss", nchar(as.character(max.nm))+5)
      m.lbl <- .fmtc("mean", max.ln)
      s.lbl <- .fmtc("sd", max.ln)
      mn.lbl <- .fmtc("min", max.ln)
      md.lbl <- .fmtc("mdn", max.ln)
      mx.lbl <- .fmtc("max", max.ln)

      tx[length(tx)+1] <- ""
      if (brief)
        tx[length(tx)+advance] <- paste(n.lbl, miss_lbl, m.lbl, s.lbl, mn.lbl,
                                        md.lbl, mx.lbl)
      else {
        sk.lbl <- .fmtc("skew", max.ln)
        kt.lbl <- .fmtc("krts", max.ln)
        q1.lbl <- .fmtc("qrt1", max.ln)
        q3.lbl <- .fmtc("qrt3", max.ln)
        qr.lbl <- .fmtc("IQR", max.ln)
        tx[length(tx)+1] <- paste(n.lbl, miss_lbl, m.lbl, s.lbl, sk.lbl,
              kt.lbl, mn.lbl, q1.lbl, md.lbl, q3.lbl, mx.lbl, qr.lbl)
      }
    }  # end first line, labels

    # write values
    lvl <- .fmtc(p.lv, max.lv)
    n.c <- .fmti(n, max.n+1)
    miss_c <- .fmti(n.miss, max.nm+5)

    if (n == 0)
      tx[length(tx)+1] <- paste(lvl, n.c, miss_c)

    else if (n == 1) {
        m.c <- .fmt(m, digits_d, max.ln)
        tx[length(tx)+1] <- paste(lvl, n.c, miss_c, m.c)
    }
    else if (n > 1) {
      m.c <- .fmt(m, digits_d, max.ln)
      s.c <- .fmt(s, digits_d, max.ln)
      mn.c <- .fmt(mn, digits_d, max.ln)
      md.c <- .fmt(md, digits_d, max.ln)
      mx.c <- .fmt(mx, digits_d, max.ln)

      if (brief)
        tx[length(tx)+1] <- paste(lvl, n.c, miss_c, m.c, s.c, mn.c, md.c, mx.c)
      else {
        sk.c <- .fmt(sk, digits_d, max.ln)
        kt.c <- .fmt(kt, digits_d, max.ln)
        q1.c <- .fmt(q1, digits_d, max.ln)
        q3.c <- .fmt(q3, digits_d, max.ln)
        qr.c <- .fmt(qr, digits_d, max.ln)
        tx[length(tx)+1] <- paste(lvl, n.c, miss_c, m.c, s.c, sk.c, kt.c,
             mn.c, q1.c, md.c, q3.c, mx.c, qr.c)
      }
    }

  }  # for each line
  tx[length(tx)+1] <- ""

  if (n.lines == 1)
    return(list(txlbl=txlbl, tx=tx, n=n, n.miss=n.miss, m=m, s=s, sk=sk,
                kt=kt, mn=mn, q1=q1, md=md, q3=q3, mx=mx, qr=qr))
  else
    return(list(tx=tx))  # contains title with var labels and stats

}

.ss.real <-
function(x, y=NULL, by=NULL, digits_d=NULL, x.name, y.name=NULL, by.name=NULL,
         x.lbl=NULL, y.lbl=NULL, label_max=20, ...)  {


  n_dim <- length(dim(x))
  if (is.null(x.name)) x.name <- getOption("xname")
  if (is.null(y.name)) y.name <- getOption("yname")

  # -------------------------------------
  # two variables 
  if (n_dim == 2) { 

    # potential abbreviation of column labels
    mx.chr <- max(nchar(colnames(x)), na.rm=TRUE)
    if (mx.chr > label_max) {
      c.nm <- colnames(x)
      colnames(x) <- .abbrev(colnames(x), label_max)
    }

    # width of column 1
    if (!is.null(by.name))
      max.c1 <- nchar(by.name)
    else
      max.c1 <- 0
    for (i in seq_len(nrow(x))) {
      c1 <- nchar(rownames(x)[i])
      if (c1 > max.c1) max.c1 <- c1
    }
    max.c1 <- max.c1 + 2
    if (max.c1 < 5) max.c1 <- 5

    # width of data columns
    max.ln <- integer(length=0)
    for (i in 1:ncol(x)) {
      if (is.na(colnames(x)[i])) colnames(x)[i] <- "<NA>"
      ln.nm <- nchar(colnames(x)[i])
      ln.vl <- max(nchar(as.character(x[,i])))
      max.ln[i] <- max(ln.nm, ln.vl) + digits_d + 3
      if (max.ln[i] < 4) max.ln[i] <- 4
    }

    # print table
    tx <- character(length = 0)

    # title
    tx[length(tx)+1] <- paste("Summary Table of", y.name) 
    tx[length(tx)+1] <- .dash2(nchar(tx[length(tx)]))
    tx[length(tx)+1] <- ""

    # col labels (presume first horizontal layout)
    if (!is.null(x.name))
      tx[length(tx)+1] <-  .fmtc(x.name, w=max.c1+3)
    tx[length(tx)+1] <-  format(by.name, width=max.c1, justify="left")
    for (i in seq_len(ncol(x)))
      tx[length(tx)] <- paste(tx[length(tx)], .fmtc(colnames(x)[i], w=max.ln[i]),
        sep="")

    if (max(nchar(tx)) < getOption("width")) {  # horizontal layout

      for (i in 1:nrow(x)) {  # values
        rwnm <- paste(" ", rownames(x)[i])
        tx[length(tx)+1] <- format(rwnm, width=max.c1, justify="left")
        for (j in seq_len(ncol(x))) {
          tx[length(tx)] <- paste(tx[length(tx)], .fmt(x[i,j], d=digits_d,
                 w=max.ln[j]), sep="")
        }
      }
    }  # end horizontal

    else {  # vertical layout

      tx <- ""

      if (nrow(x) * (ncol(x)-1) > 20) { 
        message("Table output is vertical to fit in window, but > 20 rows\n",
                "To view the complete table, save the output\n",
                "  to an object, e.g., b <- BarChart(...)\n",
                "  then b$values\n")
      }

      else {  # write
# NEED to adjust width of .fmt(x[ ] ... )
        mx.cx <- max(nchar(x.name), max(nchar(colnames(x))))

        tx[length(tx)+1] <- paste(
           .fmtc(x.name, w=mx.cx, j="left"),
           .fmtc(by.name, w=max.c1+1, j="left"),
           getOption("yname"))
        for (i in seq_len(ncol(x))) {
          for (j in seq_len(nrow(x))) {
             tx[length(tx)+1] <- paste(
                .fmtc(colnames(x)[i], w=mx.cx, j="left"), 
                .fmtc(rownames(x)[j], w=max.c1, j="left"),
#               .fmt(x[j,i], d=digits_d, w=10))  # need to narrow w
                .fmt(x[j,i], d=digits_d, w=max.ln[i]-3))  # max.ln too wide
          }
        }
      }  # end write
    }  # end vertical

    return(list(n_dim=n_dim, txtbl=tx))

  }  # end two variable


  else {  # one variable

    # potential abbreviation of column labels
    mx.chr <- max(nchar(names(x)), na.rm=TRUE)
    if (mx.chr > label_max) {
      c.nm <- names(x)
      names(x) <- .abbrev(names(x), label_max)
    }

     names(x)[which(is.na(names(x)))] <- "<NA>"  # for y given, a missing x
     max.ln <- integer(length=0)      
     for (i in 1:length(x)) {
       ln.nm <- nchar(names(x[i]))
       ln.vl <- nchar(.fmt(x[i], d=digits_d))
       max.ln[i] <- max(ln.nm, ln.vl) + 1
       if (max.ln[i] < 6) max.ln[i] <- 6
     }

      tx <- character(length=0)

      tx <- " Plotted Values"
      tx[length(tx)+1] <- paste(" ", .dash2(nchar(tx)-1), sep="")

      # col labels
      tx[length(tx)+1] <- ""
      for (i in seq_along(x))
        tx[length(tx)] <- paste(tx[length(tx)], .fmtc(names(x[i]), w=max.ln[i]))

      if (max(nchar(tx)) < getOption("width")) {  # horizontal layout
        # values
        tx[length(tx)+1] <- ""
        for (i in seq_along(x))
          tx[length(tx)] <- paste(tx[length(tx)], .fmt(x[i], d=digits_d,
               w=max.ln[i]+1), sep="")
      }

      else {  # vertical

        tx <- ""

        mx.cx <- max(nchar(x.name), max(nchar(names(x))))
        mx.vl <- max(nchar(y.name), max(nchar(sapply(x, .fmt, d=digits_d))))

        tx[length(tx)+1] <- paste(
           .fmtc(x.name, w=mx.cx+1, j="left"),
           .fmtc(y.name, w=nchar(y.name)+1, j="left"))
        for (i in seq_along(x)) {
           tx[length(tx)+1] <- paste(
              .fmtc(names(x)[i], w=mx.cx, j="left"), 
              .fmt(x[i], d=digits_d, w=mx.vl+1))
        }

      }  # end vertical

      txtbl <- tx

    values <- data.frame(label=names(x), values=as.numeric(x),
                         stringsAsFactors=FALSE)
    return(list(n_dim=n_dim, txtbl=tx, values=values))

  }  # end one variable

}

label <- 
function(x, value=NULL, data=d) {

  x.name <- deparse(substitute(x)) 
  options(xname = x.name)

  # get data frame name
  dname <- deparse(substitute(data))
  options(dname = dname)

  if (nchar(x.name)>0) if (!exists(x.name, where=data)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
    "For data frame: ", dname, "\n",
    "This variable does not exist: ", x.name, "\n")
  }

  # get conditions and check for data existing

  # see if the data frame exists, if x not in style Env or function call
  in.global <- df.or.global(x.name, dname, role="x", fun.name="label")
  if (!in.global) {
    if (!exists(dname)) {
      if (dname == "d") 
        txtA <- ", the default data frame name, " else txtA <- " "
      txtB1 <- "Create the labels by reading with Read and labels option\n"
      txtB <- paste(txtB1, sep="")
      cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Data frame ", dname, txtA, "does not exist\n\n", txtB, "\n")
    }
  }

  if (is.null(value)) {  # display an existing label
    if (!is.null(x.name)) {
      gl <- .getlabels()
      lbl <- gl$xl
      if (is.null(lbl)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
        "The variable label does not exist for variable: ", x.name, "\n\n")
      }
      return(lbl)
    }
    else {
      l <- attr(data, which="variable.labels")
      for (i in 1:length(l))
        cat(names(l)[i], ": ", l[i], "\n", sep="")
       return(lbl)
    }
  }

  else {  # assign a label to a var in a data frame and return data frame
    l <- attr(data, which="variable.labels")
    lbl.len <- length(l)
    if (x.name %in% names(l)) { #cat("IS IN\n")
      lbl.index <- which(names(l) == x.name)
      indx <- lbl.index
    }
    else
      indx <- length(l) + 1
    l[indx] <- value
    names(l)[indx] <- x.name
    cat("\n")
    cat("Variable Name:",  names(l)[indx], "\n")
    cat("Variable Label:", l[indx], "\n")
    cat("\n")
    attr(data, which="variable.labels") <- l
    return(data) 
  }
  
  cat("\n")
}

.plt.lattice <-
function(x, y, facet1, facet2, by, adj.bx.ht, object, n_row, n_col, asp,
         fill, area_fill, color, panel_fill, panel_color,
         size.pt, size.ln,
         xlab, ylab, main, shape, lab_size, axis_size,
         lvl=0, ellipse_color=NULL, ellipse_lwd=NULL,
         fit.ln="off", fit_power=1, fit_color=NULL, fit_lwd=NULL, fit_se,
         plot_errors=FALSE, origin=NULL, jitter,
         violin, violin_fill, box, box_fill,
         bw, vbs_ratio, box_adj, a, b, k.iqr, fences, vbs_mean,
         out_shape, out_size,
         out_fill, out_color, out2_fill, out2_color,
         ID, out_cut, ID_color, ID_size,
         axis_fmt="K", axis_x_pre="", axis_y_pre="",
         rotate_x, rotate_y, x_n_axis_skip, y_n_axis_skip,
         width, height, pdf_file, T.type, quiet, ...) {


# function to reduce "pretty" tick locations from a numeric vector for lattice
# call the formatting function of the axis labels, .axis.format()
.sparse.labels <- function(x, ax, n.axis.skip, axis_fmt = NULL,
                                 axis_pre, label_fn = NULL) {
  at <- pretty(x)

  # define the default label function: identity if none supplied
  if (is.null(label_fn)) {
    if (ax=="x")
      label_fn <- function(z) .axis.format(z, axis_fmt, axis_pre, "no")
    if (ax=="y")
      label_fn <- function(z) .axis.format(z, axis_fmt, "no", axis_pre)
  }

  if (length(at) <= n.axis.skip) {  # us all axis labels
    labels <- label_fn(at)
  } 
  else {  # reduce
    keep_idx <- seq(1, length(at), by=n.axis.skip+1)  # skip
    # keep_idx <- round(seq(1, length(at), length.out=n.axis.lbl)) # keep num
    labels <- rep("", length(at))
    labels[keep_idx] <- label_fn(at[keep_idx])
  }

  list(at=at, labels=labels)
}

# -------------------------------------------------------------------------


  # Turn off warnings for this function ONLY
  old_warn <- options(warn = -1)
  on.exit(options(old_warn), add = TRUE)

  if (size.pt[1] == 0) object <- "line"
  size.ln <- size.ln + 0.5  # Trellis plot lines are narrower

  if (!is.null(area_fill)) if (area_fill == "on")
    area_fill <- getOption("violin_fill")

  # if applicable, open graphics window of specified dimensions
  # options("device") returns a function in RStudio, not the string "RStudioGD",
  # so the old string comparison was always TRUE -> in.RStudio always FALSE ->
  # dev.new() called every time, stacking orphan devices. Use env var instead.
  # Positron sets POSITRON=1; skip dev.new() there too (plots go to Plots pane).
  in.RStudio  <- identical(Sys.getenv("RSTUDIO"),  "1")
  in.Positron <- identical(Sys.getenv("POSITRON"), "1")
  in.knitr    <- isTRUE(getOption("knitr.in.progress"))
  # with a pdf_file, the caller already opened the pdf device, which
  # receives the plot and is closed below after the plot prints
  if (!in.RStudio && !in.Positron && !in.knitr && is.null(pdf_file))
    dev.new(width=width, height=height)

  grid_x_color <- ifelse(is.null(getOption("grid_x_color")),
    getOption("grid_color"), getOption("grid_x_color"))
  grid_y_color <- ifelse(is.null(getOption("grid_y_color")),
    getOption("grid_color"), getOption("grid_y_color"))

  grid_x_lwd <- ifelse(is.null(getOption("grid_x_lwd")),
    getOption("grid_lwd"), getOption("grid_x_lwd"))
  grid_y_lwd <- ifelse(is.null(getOption("grid_y_lwd")),
    getOption("grid_lwd"), getOption("grid_y_lwd"))

  grid_x_lty <- ifelse(is.null(getOption("grid_x_lty")),
    getOption("grid_lty"), getOption("grid_x_lty"))
  grid_y_lty <- ifelse(is.null(getOption("grid_y_lty")),
    getOption("grid_lty"), getOption("grid_y_lty"))

  axis_x_text_color <- ifelse(is.null(getOption("axis_x_text_color")),
    getOption("axis_text_color"), getOption("axis_x_text_color"))
  axis_y_text_color <- ifelse(is.null(getOption("axis_y_text_color")),
    getOption("axis_text_color"), getOption("axis_y_text_color"))

  axis_x_size <- ifelse(is.null(getOption("axis_x_size")),
    getOption("axis_size"), getOption("axis_x_size"))
  adj <- .RSadj(axis_size=axis_x_size); axis_x_size <- adj$axis_size

  axis_y_size <- ifelse(is.null(getOption("axis_y_size")),
    getOption("axis_size"), getOption("axis_y_size"))
  adj <- .RSadj(axis_size=axis_y_size); axis_y_size <- adj$axis_size

  lab_x_color <- ifelse(is.null(getOption("lab_x_color")),
    getOption("lab_color"), getOption("lab_x_color"))
  lab_y_color <- ifelse(is.null(getOption("lab_y_color")),
    getOption("lab_color"), getOption("lab_y_color"))

  # get lab_x_size  lab_y_size
  lab_size <- getOption("lab_size")
  lab_x_size <- getOption("lab_x_size")
  lab_y_size <- getOption("lab_y_size")
  lab_x_size <- ifelse (is.null(lab_x_size), lab_size, lab_x_size)
  adj <- .RSadj(lab_size=lab_x_size); lab_x_size <- adj$lab_size
  lab_y_size <- ifelse (is.null(lab_y_size), lab_size, lab_y_size)
  adj <- .RSadj(lab_size=lab_y_size); lab_y_size <- adj$lab_size

  is.y <- ifelse (!is.null(y), TRUE, FALSE)
  gl <- .getlabels(xlab, ylab, main, y.nm=is.y, lab_x_size=lab_x_size,
                     lab_y_size=lab_y_size, facet1.nm=TRUE)
  x.name <- gl$xn; x.lbl <- gl$xl; x.lab <- gl$xb
  date.var <- FALSE
  if (is.null(dim(x))) if (.is.date(x)) date.var <- TRUE
# if (date.var) x.lab <- NULL  # cannot delete the blank space, so do the label
  y.name <- gl$yn; y.lbl <- gl$yl;
  if (!is.null(gl$yb))
    y.lab <- ifelse (is.null(ylab), gl$yb, "")
  else
    y.lab <- ifelse(is.null(ylab), "", ylab)
  main.lab <- gl$mb
  sub.lab <- gl$sb

  col.bg <- ifelse(sum(col2rgb(panel_fill)) < 370, "transparent", panel_fill)

  n.groups <- ifelse (is.null(by), 1, nlevels(by))

  pt.fill <- fill
  pt.color <- color
  ltype <- character(length=n.groups)
  for (j in 1:n.groups) ltype[j] <- "solid"

  legend_title <- deparse(substitute(by, env=parent.frame()))
  leg.text.cex <- axis_size * 1.05
  leg.title.cex <- leg.text.cex * 1.14  # abbreviate only returns of type character
# BAD if (!is.null(by)) by <- factor(abbreviate(by, 5), levels(by))

  if (is.null(facet1) && is.null(facet2))
    n.panels <- 1
  else {
    n.panels <- ifelse (is.null(facet2), nlevels(facet1),
                        nlevels(facet1)*nlevels(facet2))
    if (n.panels == 0) n.panels <- 1

    if (T.type %in% c("cont", "cont_cont")) {
      if (is.null(n_col) && is.null(n_row)) {
        n_col <- ifelse (n.panels < 5, 1, 2)
        if ((T.type == "cont")  &&  !is.null(facet2)) {
          n_col <- length(unique(na.omit(facet1)))
          n_row <- length(unique(na.omit(facet2)))
        }
      }
    }
  }

  # customize layout cols and rows, only specify one
  # if n_col or n_row specified, compute the other
  if (n.panels > 1) {
    if (!is.null(n_row)  ||  !is.null(n_col)) {
      if (is.null(n_col)) n_col <- (n.panels %/% n_row) + (n.panels %% n_row>0)
      if (is.null(n_row)) n_row <- (n.panels %/% n_col) + (n.panels %% n_col>0)
    }
  }

  # move strip to left for a single column
  strp <- TRUE;  strp.lft <- FALSE
  if (!is.null(n_col)) {
    if (n_col == 1) {
      strp <- FALSE;  strp.lft <- TRUE
    }
  }
  if (is.null(facet1)) strp <- FALSE


  # ---------------------------------
  if (!date.var) {

    # perhaps print fewer axis tick labels, perhaps re-format labels
    if (!is.null(x)) 
      x.out <- .sparse.labels(x, ax="x", x_n_axis_skip, axis_fmt, axis_x_pre)
    if (!is.null(y)) 
      y.out <- .sparse.labels(y, ax="y", y_n_axis_skip, axis_fmt, axis_y_pre)

    if (T.type == "cont_cont") {  # cont - cont
      # set 1 or 2 conditioning variables
      if (is.null(facet2)) {
        p <- lattice::xyplot(y ~ x | facet1, groups=by,
          scales=list(
            x = list(at=x.out$at, labels=x.out$labels, tck=0.8),
            y = list(at=y.out$at, labels=y.out$labels, tck=0.8)
          ), ...)
      }
      else {  # facet2 is present
        p <- lattice::xyplot(y ~ x | facet1 * facet2, groups=by,
          xlim = range(x.out$at),
          ylim = range(y.out$at),
          scales=list(
            x = list(at=x.out$at, labels=x.out$labels, tck=0.8),
            y = list(at=y.out$at, labels=y.out$labels, tck=0.8)
          ), ...)
      }  # end facet2 is present
    }

# get boxplot with vbs_plot="b" instead
# -------------------------------------
#   else if (T.type == "con_cat") {  # cont - cat
#       jitter <- .4 * jitter
#       if (is.null(facet1)  &&  is.null(facet2)) {
#         p <- lattice::bwplot(y ~ x, groups=by,
#         scales=list(
#           x = list(at=x.out$at, labels=x.out$labels, tck=0.8),
#           y = list(at=y.out$at, labels=y.out$labels, tck=0.8)
#         ), ...)
#       }
#       else if (is.null(facet2)) {
#         p <- lattice::bwplot(y ~ x | facet1, groups=by,
#         scales=list(
#           x = list(at=x.out$at, labels=x.out$labels, tck=0.8),
#           y = list(at=y.out$at, labels=y.out$labels, tck=0.8)
#         ), ...)
#       }
#       else {  # facet2 is present
#         p <- lattice::bwplot(y ~ x | facet1 * facet2, groups=by,
#         scales=list(
#           x = list(at=x.out$at, labels=x.out$labels, tck=0.8),
#           y = list(at=y.out$at, labels=y.out$labels, tck=0.8)
#         ), ...)
#       }
#   }  # end con_cat

    else if (T.type == "cont") {  # cont, VBS plots, possibly over facets
      # set 0, 1 or 2 conditioning variables
      if (is.null(facet1)  &&  is.null(facet2)) {  # 0 cond var
        p <- lattice::stripplot(~ x, groups=by, subscripts=TRUE,
          scales=list(
            x = list(at=x.out$at, labels=x.out$labels, tck=0.8)
          ), ...)
        y.lab <- ""
      }
      else if (is.null(facet2)) {  # 1 cond var
        p <- lattice::stripplot(~ x | facet1, groups=by, subscripts=TRUE,
          scales=list(
            x = list(at=x.out$at, labels=x.out$labels, tck=0.8)
          ), ...)
        y.lab <- ifelse (is.null(ylab), getOption("facet1name"), ylab)
      }
      else  {  # 2 cond var
        p <- lattice::stripplot(~ x | facet1*facet2, groups=by, subscripts=TRUE,
          scales=list(
            x = list(at=x.out$at, labels=x.out$labels, tck=0.8)
          ), ...)
        y.lab <- ""
      }
    }  # end cont
  } # end not date.var

  else {  # x-variable is a Date
    if (!is.null(y)) 
      y.out <- .sparse.labels(y, ax="y", y_n_axis_skip, axis_fmt, axis_y_pre)

    if (T.type == "cont_cont") {  # cont - cont
      # set 1 or 2 conditioning variables
      if (is.null(facet2)) {
        p <- lattice::xyplot(y ~ x | facet1, groups=by,
          scales=list(
#           y=list(labels=.axis.format(pretty(y), axis_fmt, "no", axis_y_pre),
#                  at=pretty(y), tck=.8)
            y = list(at=y.out$at, labels=y.out$labels, tck=0.8)
          ), ...)
      }
      else {  # facet2 is present
        p <- lattice::xyplot(y ~ x | facet1 * facet2, groups=by,
          scales=list(
            y=list(labels=.axis.format(pretty(y), axis_fmt, "no", axis_y_pre),
                   at=pretty(y), tck=.8)
          ), ...)
      }
    }

    else if (T.type == "con_cat") {  # cont - cat
        jitter <- .4 * jitter
        if (is.null(facet1)  &&  is.null(facet2)) {
          p <- lattice::bwplot(y ~ x, groups=by,
            scales=list(
              y=list(labels=.axis.format(pretty(y), axis_fmt, "no", axis_y_pre),
                     at=pretty(y), tck=.8)
          ), ...)
        }
        else if (is.null(facet2)) {
          p <- lattice::bwplot(y ~ x | facet1, groups=by,
            scales=list(
              y=list(labels=.axis.format(pretty(y), axis_fmt, "no", axis_y_pre),
                     at=pretty(y), tck=.8)
            ), ...)
        }
        else {  # facet2 is present
          p <- lattice::bwplot(y ~ x | facet1 * facet2, groups=by,
          scales=list(
            y=list(labels=.axis.format(pretty(y), axis_fmt, "no", axis_y_pre),
                   at=pretty(y), tck=.8)
            ), ...)
        }
    }  # end con_cat

    else if (T.type == "cont") {  # cont
      # set 0, 1 or 2 conditioning variables
      if (is.null(facet1)  &&  is.null(facet2)) {  # 0 cond var
        p <- lattice::stripplot(~ x, groups=by, subscripts=TRUE,
          scales=list(
            x=list(labels=.axis.format(pretty(x), axis_fmt, axis_x_pre, "no"), 
                   at=pretty(x), tck=.8)
          ), ...)
        y.lab <- ""
      }
      else if (is.null(facet2)) {  # 1 cond var
        p <- lattice::stripplot(~ x | facet1, groups=by, subscripts=TRUE,
          scales=list(
            x=list(labels=.axis.format(pretty(x), axis_fmt, axis_x_pre, "no"), 
                   at=pretty(x), tck=.8)
          ), ...)
        y.lab <- ifelse (is.null(ylab), getOption("facet1name"), ylab)
      }
      else  {  # 2 cond var
        p <- lattice::stripplot(~ x | facet1 * facet2, groups=by,
                                subscripts=TRUE,
          scales=list(
            x=list(labels=.axis.format(pretty(x), axis_fmt, axis_x_pre, "no"), 
                   at=pretty(x), tck=.8)
          ), ...)
        y.lab <- ""
      }
    }  # end cont
  } # end is date.var

  p <- update(p, layout=c(n_col, n_row))

  if (length(levels(facet1)) == 1) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Need more than just one unique value for  facet1\n",
      "Unique values of facet1: ", levels(facet1),"\n\n")
  }
  if (xor(is.null(n_col), is.null(n_row))) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "If you specify  n_col  or  n_row  then \n",
      "  specify parameter  facet1  not parameter  by.\n\n")
  }


  # scale down the point size, grid line width for the multi-panel dot plots
  n.pnl <- length(levels(facet1))
  if (!is.null(facet2)) n.pnl <- n.pnl + length(levels(facet2))
  if (n.pnl > 3  &&  grid_x_lwd > 0.99) grid_x_lwd <- .5 * grid_x_lwd
  if (n.pnl > 3  &&  grid_y_lwd > 0.99) grid_y_lwd <- .5 * grid_y_lwd

  size.mult <- ifelse (n.pnl > 3, 0.70, 0.833)
  size.pt <- size.pt * size.mult
  # separate panels with a border even if turned off when only one plot
  panel_color <- getOption("panel_color")
  panel_frame_color <- ifelse(panel_color == "transparent",
                              "gray30", panel_color)

  # even if no axis in single plot, multi-panel needs an axis to separate
  # scales, as currently configured, does not separate values from the axis
  g.x_color <- grid_x_color
  if (g.x_color ==  "transparent") g.x_color <- grid_y_color
  g.y_color <- grid_y_color
  if (g.y_color ==  "transparent") g.y_color <- grid_x_color

  a.x.text_color <- axis_x_text_color
  if (a.x.text_color ==  "transparent") a.x.text_color <-axis_y_text_color
  a.y.text_color <- axis_y_text_color
  if (a.y.text_color ==  "transparent") a.y.text_color <- axis_x_text_color

  l.x_color <- lab_x_color
  if (l.x_color == "transparent") l.x_color <-lab_y_color
  l.y_color <- lab_y_color
  if (l.y_color == "transparent") l.y_color <- lab_x_color

  # separate the axis from the axis labels unless too many rows
  if (is.null(n_row)) n_row <- 1
  if (n_row < 7) {
    pad <- 2.08 - 0.56*log(n_row)
    p <- update(p,
         par.settings=list(
           layout_heights=list(axis_xlab_padding=pad)))
  }

  top.pad <- ifelse (is.null(main), 0, 1)
  if (!is.null(facet1)) top.pad <- 1
  axs.top <- ifelse (is.null(main), 0, 1)  # old: .5, 1

  # get full list of lattice parameters: trellis.par.get()
  #print(trellis.par.get("superimpose.symbol"))
  p <- update(p,
         strip=strp, strip.left=strp.lft, aspect=asp,
         par.strip.text=list(cex=axis_x_size, col=getOption("strip_text_color")),
         xlab=list(label=x.lab, cex=lab_x_size, col=l.x_color),
         ylab=list(label=y.lab, cex=lab_y_size, col=l.y_color),
         main=list(label=main.lab, cex=getOption("main_size", 1.1),
                   col=getOption("lab_color")),
         par.settings=list(
           background=list(col=getOption("window_fill")),
           panel.background=list(col=panel_fill),
           layout.heights=list(top.padding=top.pad, axis.top=axs.top),
           axis.line=list(col=panel_frame_color,
             lty=getOption("axis_lty"), lwd=getOption("axis_lwd")),
           strip.border=list(col=getOption("strip_color"), lwd=1),
           strip.background=list(col=getOption("strip_fill")),
           strip.color=list(col=getOption("strip_color")),  # ???
           plot.polygon=list(col=getOption("violin_color"),
             fill=violin_fill, lty="solid", lwd=1),
           plot.line=list(col=pt.color, lty="solid", lwd=1),
           plot.symbol=list(pch=shape, cex=size.pt, col=pt.color,
             fill=pt.fill),
           superpose.symbol=list(pch=shape, cex=size.pt,
             col=pt.color, fill=pt.fill),
           superpose.line=list(col=pt.color, lty=ltype)),
         scales=list(
           x = list(cex=axis_x_size, rot=rotate_x, col=a.x.text_color),
           y = list(cex=axis_y_size, rot=rotate_y, col=a.y.text_color))
  )

  if (T.type == "cont_cont") {

    # set legend
    if (n.groups > 1) {  # lattice groups is lessR by
      if (object %in% c("point", "both")) {
        p <- update(p,
             key=list(  # defines the properties of the legend
               space="right",
               text=list(levels(by), cex=leg.text.cex),  # by is a factor
               points=list(pch=shape, fill=fill, col=fill, cex=leg.title.cex),
               border="gray80", background=col.bg,
               title=legend_title, cex.title=leg.title.cex))
      }
      else {  # lines
        p <- update(p,
             key=list(
               cex=axis_x_size, space="right",
               text=list(levels(by)),  # by is always a factor at this point
               border="gray80", background=col.bg,
               lines=list(lwd=size.ln, col=fill),
               title=legend_title, cex.title=leg.title.cex))
      }
    }  # n.groups > 1

    # need to get working
    if (n.groups > 1 &&  fit.ln != "off")  {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "If by parameter used, then currently no fitted lines by group.\n\n")
    }

    p <- update(p,
        panel = function(x, y, ...) {

          panel.grid(h=0, v=-1, col=g.x_color,
                     lwd=grid_x_lwd, lty=grid_x_lty)
          panel.grid(h=-1, v=0, g.y_color,
                     lwd=grid_y_lwd, lty=grid_y_lty)

          if (length(x) > 0) {  # plot only if data for panel

            if (area_fill != "transparent")  # fill under the line
              panel.xyarea(x, y, origin=origin, col=area_fill)

            if (object == "point")
              tp <- "p"
            else if (object == "both")
              tp <- "b"
            else if (object == "line")
              tp <- "l"
            panel.xyplot(x, y, type=tp, col=pt.color, fill=pt.fill,
                         lwd=size.ln, ...)

            if (fit.ln != "off"  &&  n.groups == 1) {

              pf <- .plt.fit (x, y, fit.ln, fit_power, fit_new=NULL, sz.lv=1)

              x <- pf$x.lv  # x and y get reduced in .plt.fit if NA
              y <- pf$y.lv
              f.ln <- pf$f.ln
              l.ln <- pf$l.ln
              mse <- pf$mse
              b0 <- pf$b0
              b1 <- pf$b1
              Rsq <- pf$Rsq

              mse.pn <- prettyNum(mse, big.mark = ",", scientific = FALSE)
              Rsq.pn <- .fmt(Rsq, 3)
              b0.pn <- .fmt(b0, 3)
              b1.pn <- .fmt(b1, 3)
              if (!quiet) {
                cat("\n")
                if (panel.number() == 1) {
                  cat("Regression analysis of linearized", y.name, "values\n")
                  msg <- paste("Need back transformation of regression model",
                              "to compute predicted values\n\n")
                  cat(msg)
                }
              }
              facet1.name <- getOption("facet1name")
              panel.n <- panel.number()
              if (!quiet) cat(facet1.name, " ", panel.n, "  ",
                  "Line: b0 = ", b0.pn, "  b1 = ", b1.pn, "   ",
                  "Fit: MSE = ", mse.pn, "   Rsq = ", Rsq.pn,
                  sep="", "\n")

              if (fit.ln %in% c("exp", "log", "quad", "null"))
                fit_se[1] <- 0

              se_fill <- getOption("se_fill")
              nrows <- length(f.ln)
              for (j in 1:length(fit_se)) {
                p.ln <- predict(l.ln, se=TRUE)
                prb <- (1 - fit_se[j]) / 2
                up.ln <- f.ln + (qt(prb,nrows-1) * p.ln$se.fit)
                dn.ln <- f.ln - (qt(prb,nrows-1) * p.ln$se.fit)
                panel.polygon(c(x, rev(x)), c(up.ln, rev(dn.ln)),
                              col=se_fill, border="transparent")
              }  # end fit_se

              panel.lines(x, f.ln, col=fit_color, lwd=fit_lwd)

              if (plot_errors)
                panel.segments(y0=f.ln, y1=y, x0=x, x1=x, col="darkred", lwd=1)

            }  # end fit != "off"

            if (lvl > 0)
              panel.ellipse(x, y, center.cex=0,
                            level=lvl, col=ellipse_color, lwd=ellipse_lwd)

          }  # end length > 0
        }  # end panel function
      )  # end update

  }  # end cont_cont


  else if (T.type %in% c("con_cat", "cont")) {

    #myboxStats <- function(...)
      #if (!box_adj)
        #return(boxplot.stats(x))
      #else
        #return(adjboxStats(x, coef=k.iqr, a=a, b=b))

    if (fences) {  # make room for the fences with horizontal lengthening
      p <- update(p,
         prepanel=function(x=x) {

           num5 <- fivenum(x, na.rm=TRUE)
           q1 <- num5[2];  q3 <- num5[4];  iqr <- q3 - q1

           m.c <- ifelse (box_adj, mc(x, na.rm=TRUE), 0)
           if (m.c >= 0) {
             fnc.lwr <- q1 - (k.iqr * exp(a*m.c) * iqr)
             fnc.upr <- q3 + (k.iqr * exp(b*m.c) * iqr)
           }
           else {  # m.c < 0
             fnc.lwr <- q1 - (k.iqr * exp(-b*m.c) * iqr)
             fnc.upr <- q3 + (k.iqr * exp(-a*m.c) * iqr)
           }

           min_x <- min(x, fnc.lwr)
           max.x <- max(x, fnc.upr)

           list(xlim=c(min_x, max.x))
         }
       )
    }  # end fences

    if (n.groups > 1) {
      p <- update(p, 
           key=list(  # defines the properties of the legend
             space="top", columns=n.groups,
             text=list(levels(by), cex=leg.text.cex),
             points=list(pch=shape, fill=pt.fill, col=pt.color, cex=leg.title.cex),
             border="gray80", background=col.bg, padding.text=2,
             title=legend_title, cex.title=leg.title.cex))

      box_fill <- .maketrans(box_fill, 0.25*256)  # more trans box needed
    }


    p <- update(p,
          
        par.settings=list(  # col option does not work directly on panel.bwplot
          box.rectangle=list(fill=box_fill, lwd=2,
                             col=getOption("box_color")),
          box.umbrella=list(col=getOption("box_color"), lty="solid")
        ),

        panel=function(x=x, box.ratio, wID=ID, ...,
                       groups=groups, subscripts=subscripts) {

          panel.grid(h=0, v=-1, col=g.x_color, lwd=grid_x_lwd, lty=grid_x_lty)

          if (length(x) > 0) {  # plot only if data for panel

            jitter_data <- ifelse (jitter > 0, TRUE, FALSE)
            size.pt <- size.pt * 1.2  # lattice adjustment
            num5 <- fivenum(x, na.rm=TRUE)
            q1 <- num5[2]
            q3 <- num5[4]
            iqr <- q3 - q1
            fnc.in <- rep(NA_real_, 2)   # inner fences
            fnc.out <- rep(NA_real_, 2)  # outer fences

            m.c <- ifelse(box_adj, mc(x, na.rm=TRUE), 0)
            if (m.c >= 0) {
              fnc.in[1] <- q1 - (k.iqr * exp(a*m.c) * iqr)
              fnc.in[2] <- q3 + (k.iqr * exp(b*m.c) * iqr)
              fnc.out[1] <- q1 - (2 * k.iqr * exp(a*m.c) * iqr)
              fnc.out[2] <- q3 + (2 * k.iqr * exp(b*m.c) * iqr)
            }
            else {  # m.c < 0
              fnc.in[1] <- q1 - (k.iqr * exp(-b*m.c) * iqr)
              fnc.in[2] <- q3 + (k.iqr * exp(-a*m.c) * iqr)
              fnc.out[1] <- q1 - (2 * k.iqr * exp(-b*m.c) * iqr)
              fnc.out[2] <- q3 + (2 * k.iqr * exp(-a*m.c) * iqr)
            }

            if (violin && length(x)>1) {
              # to get a violin plot, cannot have y and facet1
              # just Plot(x) gives a VBS plot with no groups and only 1 panel
              # a giant do loop that iterates over groups, i.e., panel.number()
              vw <- ifelse (!is.null(y) && !is.null(facet1), FALSE, TRUE)
              vf <- ifelse (n.panels>1, violin_fill[panel.number()], violin_fill)
              panel.violin(x=x, ...,
                  col=vf,
                  border=getOption("violin_color"),
                  varwidth=vw, box.width=vbs_ratio, bw=bw)
            }

            if ((box || any(size.pt > 0)) && length(x) > 1) {

              n.lvl <- ifelse (is.null(facet1), 1, nlevels(facet1))
              n <- adj.bx.ht
              int <- ifelse (n <= 25000, 4.10 - 0.000065*n, 3.25 - 0.00003*n)
              denom <- int - 0.5*n.lvl
              if (denom < 1.5) denom <- 1.5

              if (box) {  # could just be a scatterplot with red outlier points
                if (!box_adj)  # did the panel.number() access in .panel.bwplot()
                  .panel.bwplot(x=x, ..., pch="|", vbs_mean=vbs_mean,
                      fences=fences,
                      box.ratio=vbs_ratio/denom, mean_color=out_fill,
                      stats=boxplot.stats, k.iqr=k.iqr, do.out=FALSE)
                else
                  .panel.bwplot(x=x, ...,  pch="|", vbs_mean=vbs_mean,
                      fences=fences,
                      box.ratio=vbs_ratio/denom, mean_color=out_fill,
                      stats=adjboxStats, k.iqr=k.iqr, a=a, b=b, do.out=FALSE)
             }

              # convert name such as "circle" to actual pch num, e.g., 21
              shp <- .plt.shapes(shape, out_shape)
              shape <- shp$shape
              out_shape <- shp$out_shape

              # plotting a subset of x requires adjusting y, in .panel.strip
              # identify extreme outliers, if any
              x.out <- which(x<fnc.out[1] | x>fnc.out[2])
              if (n.groups == 1) {
                x.out_clr <- 1
                fill_out <- out2_fill
              }
              else {  # if a by group, and plot regular colors to differentiate
                fill_out <- fill
                out2_color <- fill
              }

              # plot extreme outliers
#             .panel.stripplot(x=x[x.out],
              # suppress lattice's "longer object length is not a multiple
              # of shorter object length" — fires when by= produces a per-
              # group color vector whose length doesn't match the outlier
              # count; recycling is intentional here
              suppressWarnings(panel.stripplot(x=x[x.out],
                 cex=out_size, col=out2_color, fill=fill_out, pch=out_shape, ...))

              # identify outliers, if any
              x.out <- which(x>=fnc.out[1] & x<fnc.in[1] |
                              x>fnc.in[2] & x<=fnc.out[2])
              if (n.groups == 1) {
                x.out_clr <- 1
                fill_out <- out_fill
              }
              else {  # if a by group, and plot regular colors to differentiate
                fill_out <- fill
                out_color <- fill
              }

              # plot outliers
              # suppress lattice's length-recycling warning (see comment
              # at the prior panel.stripplot call above)
              suppressWarnings(panel.stripplot(x=x[x.out],
                 cex=out_size, col=out_color, fill=fill_out, pch=out_shape, ...))

              # label outliers
              if (out_cut > 0) {
                wwID <- wID[subscripts]

                ind.lo <- which(x < fnc.in[1])
                x.lo <- x[ind.lo]
                ID.lo <- wwID[ind.lo]
                ord <- order(x.lo, decreasing=FALSE)
                x.lo <- x.lo[ord]
                x.lo <- na.omit(x.lo[1:min(length(x.lo),out_cut)])
                ID.lo <- ID.lo[ord]
                ID.lo <- na.omit(ID.lo[1:min(length(ID.lo),out_cut)])

                ind.hi <- which(x > fnc.in[2])
                x.hi <- x[ind.hi]
                ID.hi <- wwID[ind.hi]
                ord <- order(x.hi, decreasing=TRUE)
                x.hi <- x.hi[ord]
                x.hi <- na.omit(x.hi[1:min(length(x.hi),out_cut)])
                ID.hi <- ID.hi[ord]
                ID.hi <- na.omit(ID.hi[1:min(length(ID.hi),out_cut)])

                x.out <- c(x.lo, x.hi)
                ID.lbl <- union(ID.lo, ID.hi)  # combine factors
                ix <- order(-abs(x.out))[1:out_cut]  # subset to largest abs

                panel.text(x.out[ix], y=1.08, labels=ID.lbl[ix],
                           col=ID_color, cex=ID_size, adj=0, srt=90)
              }
            }  # end box || size.pt > 0

            # regular or all (no box)  points
            if (any(size.pt > 0)) {
              s.pt <- ifelse (n.groups > 1, size.pt*1.2, size.pt)
              if (box) {
                x.out <- which(x>=fnc.in[1] & x<=fnc.in[2])
                if (n.groups == 1) {
                  x.out_clr <- 1
                  fill_out <- pt.fill
                }
                else {
                  x.out_clr <- as.numeric(groups[x.out])
                  fill_out <- pt.fill[x.out_clr]
                }
              }  # end box
              else  # all pts
                x.out <- 1:length(x)

              .panel.stripplot(x=x[x.out],   # in plt.panel.R
                 cex=s.pt, pch=shape, col=pt.color, fill=pt.fill,
                 jitter_data=jitter_data, factor=jitter, ...)
            }

          }  # end length(x) > 0
        }  # end panel function
      )  # end update
  }


  # display
  print(p)
  if (!is.null(pdf_file) && dev.cur() > 1L) dev.off()

}

# aggregate the values of a numerical variable y 
#   (a) over the categories of categorical variable x
#   (b) optionally crossed with by and facet variables
# stat: "sum", "mean", "sd", "deviation", "min", "median", "max"
#
# single output structure, regardless of analysis type
#   list(out, ylab)
#     out  : data frame with columns x, <any by/facet columns>, y,
#            one row per (x [, group]) combination
#            a by or facet passed as a vector appears in out as the
#            column "by.var" or "facet.var"
#     ylab : "<Stat label> of <y.name>" for the default y-axis label
#
# Called from: Chart.R, XY.R

.agg <- function(x, y, by=NULL, facet=NULL, stat, y.name=NULL) {

  if (is.data.frame(x)) x <- x[, 1L]

  ylab <- paste(.stat_lbl(stat), "of", y.name)

  if (stat == "deviation") {
    if (!is.null(by) || !is.null(facet)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "deviation for stat not meaningful with a by or facet variable\n\n")
    }
    out <- tapply(y, x, mean, na.rm=TRUE)
    # deviation of each group mean from the unweighted mean, that is, the
    # average of the group means (not the grand mean of all data values, so
    # each group counts equally regardless of its number of observations)
    out <- out - mean(out, na.rm=TRUE)
    out <- data.frame(x=factor(names(out)), y=as.vector(out))
  }

  else if (is.null(by) && is.null(facet)) {
    out <- tapply(y, x, .stat_fun(stat))
    out <- data.frame(x=factor(names(out)), y=as.vector(out))
  }

  else {  # build data frame: x + (columns from by) + (columns from facet) + y
    df <- data.frame(x = x)

    # by can be vector, matrix, or data frame
    if (!is.null(by)) {
      if (is.data.frame(by))
        df <- cbind(df, by)
      else if (is.matrix(by))
        df <- cbind(df, as.data.frame(by))
      else
        df$by.var <- by
    }

    # facet can be vector, matrix, or data frame
    if (!is.null(facet)) {
      if (is.data.frame(facet))
        df <- cbind(df, facet)
      else if (is.matrix(facet))
        df <- cbind(df, as.data.frame(facet))
      else
        df$facet.var <- facet
    }

    df$y <- y

    out <- stats::aggregate(y ~ ., data=df, FUN=.stat_fun(stat))

    # ensure canonical column names "x" and "y"
    if (!("x" %in% names(out)))
      stop(".agg(): aggregated result must contain a column named 'x'.")
    if (!("y" %in% names(out)))
      stop(".agg(): aggregated result must contain a column named 'y'.")
  }

  # NA/NaN, or +/-Inf from min/max of an all-missing cell, means the
  # statistic could not be computed for one or more cells
  if (any(!is.finite(out$y))) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "The summary table of the transformed data has some missing or\n",
      "   non-finite values, likely because some cells have too few\n",
      "   (or no) data values to compute the specified statistic\n\n")
  }

  return(list(out=out, ylab=ylab))
}

corProp <- 
function (R=mycor, 
          main=NULL, heat_map=TRUE, bottom=NULL, right=NULL, 
          pdf_file=NULL, width=5, height=5, ...) {


  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (!is.null(dots)) if (length(dots) > 0) {
    change <- c("heat.map", "pdf.file")
    for (i in seq_along(dots)) {
      if (names(dots)[i] %in% change) {
        nm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(nm, dots[[i]])
      }
    }
  }

  if (!("matrix" %in% class(R))) { # R is a matrix, can be called indirectly
    # cor matrix:  mycor as class out_all, mycor$R, or stand-alone matrix
    cor.nm <- deparse(substitute(R))
    .cor.exists(cor.nm)  # see if matrix exists in one of the 3 locations
    if ("out_all" %in% class(R))    # R 4.0 results in two values: matrix, array
      R <- eval(parse(text=paste(cor.nm, "$R", sep="")))  # go to $R
  }

  NVOld <- as.integer(nrow(R))

  NVC <- NVOld
  Diagon <- as.integer(0)
  Power <- as.integer(0)


  # Get the float version of Power, RPower
  RPower <- ifelse (Power == 0, 1.0, as.numeric(Power) / 100.0) 

  # Compute sum of squares for each column and store in Diag
  CP <- crossprod(R)
  Diag <- diag(CP)

  # Compute sum of cross-products and store in upper triangle.  Leave
  #    the correlations in the lower triangle with diagonal unchanged
  #    R[I,J) is the cross-product, R[J,I) is the original correlation

  for (I in 1:(NVC-1)) {
    for (J in (I+1):NVC) {
      R[I,J] <- 0
      for (K in 1:NVC) {
        if (I <= K) X1 <- R[K,I]
        if (I > K) X1 <- R[I,K]
        if (J <= K) X2 <- R[K,J]
        if (J > K) X2 <- R[J,K]
        R[I,J] <- R[I,J] + X1*X2
      }
    }
  }

  # Normalize cross products, i.e., obtain the proportionality coefs
  #   excluding the diagonal.  If the diagonal is ignored, Diagon<-0, then
  #   correspondingly reduce the appropriate sums of squares and
  #   cross-products

  for (I in 1:(NVC-1)) {
    for (J in (I+1):NVC) {
      if (Diagon == 0) {
        RII <- R[I,I]
        RJJ <- R[J,J]
        RJI <- R[J,I]
        D1 <- Diag[I] - (RII**2+RJI**2)
        D2 <- Diag[J] - (RJJ**2+RJI**2)
        R[I,J] <- R[I,J] - ((RII*RJI) + (RJJ*RJI))
      }
      else if (Diagon == 1) {
        D1 <- Diag[I]
        D2 <- Diag[J]
      }
      R[I,J] <- R[I,J] / (sqrt(D1*D2))
      R[I,J] <- R[I,J]**RPower
      R[J,I] <- R[I,J]
    }
  }

  # Set the diagonal to 1.OO
    for (I in 1:NVC) R[I,I] <- 1.00

  # assign names
  nm <- dimnames(R)[[1]]
  dimnames(R) <- list(nm, nm)


  if (heat_map) {
    if (is.null(main)) main <- "Item Proportionalities"
    .opendev(pdf_file, width, height)  # set up graphics
    .heatmap(R, NVOld, main, bottom, right, diag=0,
               pdf_file, width, height)
  }

  # finish
  cat("\n")
  return(invisible(round(R,2)))

}

corCFA <- 
function(mimm=NULL, R=mycor, data=d, fac.names=NULL, 

         Rmd=NULL, explain=getOption("explain"),
         results=getOption("results"),

         labels=c("include", "exclude", "only"),

         min_cor=.10, min_res=.05, iter=50, grid=TRUE, 

         resid=TRUE, item_cor=TRUE, sort=TRUE,

         main=NULL, heat_map=TRUE, bottom=NULL, right=NULL, 

         pdf_file=NULL, width=5, height=5,

         F1=NULL, F2=NULL, F3=NULL, F4=NULL, F5=NULL,
         F6=NULL, F7=NULL, F8=NULL, F9=NULL, F10=NULL,
         F11=NULL, F12=NULL, F13=NULL, F14=NULL, F15=NULL,
         F16=NULL, F17=NULL, F18=NULL, F19=NULL, F20=NULL,

         fun_call=NULL, ...) {


  # a dot in a parameter name to an underscore
  dots <- list(...)
  if (length(dots) > 0) {
    for (i in seq_along(dots)) {
      if (grepl(".", names(dots)[i], fixed=TRUE)) {
        pnm <- gsub(".", "_", names(dots)[i], fixed=TRUE)
        assign(pnm, dots[[i]])
      }
    }
  }

  if (exists(deparse(substitute(data)), where=.GlobalEnv, inherits=FALSE)) 
    dname <- deparse(substitute(data))
  else
    dname <- NULL

  if (is.null(fun_call)) fun_call <- match.call()

  labels <- match.arg(labels)

  if (!is.null(pdf_file))
    if (!grepl(".pdf", pdf_file, fixed=TRUE))
      pdf_file <- paste(pdf_file, ".pdf", sep="")

  if (is.null(dname)  &&  !is.null(Rmd)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Need to read from the data table (frame) to generate a Rmd_ \n\n")
  }


  df.name <- deparse(substitute(data))
  options(dname = df.name)

  # if a tibble, convert to data frame
  if (exists(df.name, envir=parent.frame())) {
    if (any(grepl("tbl", class(data), fixed=TRUE)))
      data <- data.frame(data)
  }

  NFmax <- 20


  # access R
  # translate variable names into column positions
  if (labels!="only") {
    NVOld <- as.integer(nrow(R))
    vars.all <- as.list(seq_along(as.data.frame(R)))
    names(vars.all) <- names(as.data.frame(R))
    nm <- dimnames(R)[[1]]
  }
  else {
    NVOld <- nrow(data)
    vars.all <- as.list(seq_along(data))
    names(vars.all) <- names(data)
    nm <- names(data)
  }


  if (!is.null(mimm)) {
    nm.mimm <- deparse(substitute(mimm))
    
    mimm_str <- ""  # strip blanks and tildes
    for (i in seq_len(nchar(mimm))) {
      s <- substr(mimm,i,i) 
      if (s!=" " && s!="~" ) mimm_str <- paste(mimm_str,s, sep="") 
    }

    mimm_lines <- strsplit(mimm_str, "\n")[[1]]  # split in factor = strings
    mimm_lines <- mimm_lines[which(nchar(mimm_lines)>0)]  # remove empty strings

    # split into sets of factor name and vars
    NF <- length(mimm_lines)
    fac.names <- character(length=NFmax)
    vars <- character(length=NFmax)
    for (i in 1:NF) {
      f <- strsplit(mimm_lines[i], "=")[[1]]
      fac.names[i] <- f[1]
      vars[i] <- gsub("+", ",", f[2], fixed=TRUE)
      vars[i] <- paste("c(", vars[i], ")", sep="")
    }

    F1n <- eval(parse(text=vars[1]), vars.all, parent.frame())
    F2n <- eval(parse(text=vars[2]), vars.all, parent.frame())
    F3n <- eval(parse(text=vars[3]), vars.all, parent.frame())
    F4n <- eval(parse(text=vars[4]), vars.all, parent.frame())
    F5n <- eval(parse(text=vars[5]), vars.all, parent.frame())
    F6n <- eval(parse(text=vars[6]), vars.all, parent.frame())
    F7n <- eval(parse(text=vars[7]), vars.all, parent.frame())
    F8n <- eval(parse(text=vars[8]), vars.all, parent.frame())
    F9n <- eval(parse(text=vars[9]), vars.all, parent.frame())
    F10n <- eval(parse(text=vars[10]), vars.all, parent.frame())
    F11n <- eval(parse(text=vars[11]), vars.all, parent.frame())
    F12n <- eval(parse(text=vars[12]), vars.all, parent.frame())
    F13n <- eval(parse(text=vars[13]), vars.all, parent.frame())
    F14n <- eval(parse(text=vars[14]), vars.all, parent.frame())
    F15n <- eval(parse(text=vars[15]), vars.all, parent.frame())
    F16n <- eval(parse(text=vars[16]), vars.all, parent.frame())
    F17n <- eval(parse(text=vars[17]), vars.all, parent.frame())
    F18n <- eval(parse(text=vars[18]), vars.all, parent.frame())
    F19n <- eval(parse(text=vars[19]), vars.all, parent.frame())
    F20n <- eval(parse(text=vars[20]), vars.all, parent.frame())

  }

  else {
    F1n <- eval(substitute(F1), vars.all, parent.frame())
    F2n <- eval(substitute(F2), vars.all, parent.frame())
    F3n <- eval(substitute(F3), vars.all, parent.frame())
    F4n <- eval(substitute(F4), vars.all, parent.frame())
    F5n <- eval(substitute(F5), vars.all, parent.frame())
    F6n <- eval(substitute(F6), vars.all, parent.frame())
    F7n <- eval(substitute(F7), vars.all, parent.frame())
    F8n <- eval(substitute(F8), vars.all, parent.frame())
    F9n <- eval(substitute(F9), vars.all, parent.frame())
    F10n <- eval(substitute(F10), vars.all, parent.frame())
    F11n <- eval(substitute(F11), vars.all, parent.frame())
    F12n <- eval(substitute(F12), vars.all, parent.frame())
    F13n <- eval(substitute(F13), vars.all, parent.frame())
    F14n <- eval(substitute(F14), vars.all, parent.frame())
    F15n <- eval(substitute(F15), vars.all, parent.frame())
    F16n <- eval(substitute(F16), vars.all, parent.frame())
    F17n <- eval(substitute(F17), vars.all, parent.frame())
    F18n <- eval(substitute(F18), vars.all, parent.frame())
    F19n <- eval(substitute(F19), vars.all, parent.frame())
    F20n <- eval(substitute(F20), vars.all, parent.frame())

    # get NF, number of factors
    NF <- 0
    for (i in 1:NFmax) {
      fnum <- eval(parse(text=paste("F", toString(i), "n", sep="")))
      if (!is.null(fnum)) NF <- NF + 1
    }
  }

  Label <- c(F1n,F2n,F3n,F4n,F5n,F6n,F7n,F8n,F9n,F10n,F11n,F12n,
             F13n,F14n,F15n,F16n,F17n,F18n,F19n,F20n)

  if (NF == 0) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Number of Factors: ", NF, "\n",
      "Need to specify some factors.", "\n\n",
      "For example, F1=c(...), F2=c(...), etc.\n\n")
  }

  if (!is.null(fac.names)) if (length(fac.names) < NF) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Only ", length(fac.names), " factor names entered for ", NF,
      " factors\n\n")
  }

  # widest factor name to display, now that any names embedded in a mimm
  # specification have been parsed into fac.names; default F1..FN labels
  # are not treated as names to display
  max.fname <- 0
  if (!is.null(fac.names)) {
    nms <- fac.names[seq_len(NF)]
    nms <- nms[nms != paste("F", seq_len(NF), sep="")]
    if (length(nms) > 0) max.fname <- max(nchar(nms))
  }

  # get the ordinal position of the first and last vars in Group i
  # get NItems
  LblCut <- matrix(nrow=NF, ncol=2)
  NItems <- 0
  for (i in 1:NF) {
    LblCut[i,1] <- NItems + 1
    cFac <- eval(parse(text=paste("F", toString(i), "n", sep="")))
    if (length(cFac) == 0) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Factor Number ", i, " has no items.\n",
          "Each factor must have at least one item.\n\n")
    }
    NItems <- NItems + length(cFac)
    LblCut[i,2] <- NItems
  }

  for (i in 1:NItems) {
    if (Label[i] > NVOld) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Number of items in correlation matrix: ", NVOld, "\n",
        "Item number in Factor specification: ", Label[i], "\n\n",
        "Specified item does not exist in this correlation matrix.\n\n")
    }
  }

  # display labels by factor if labels=="only"
  txlbl <- ""
  if (labels == "only") {
    tx <- character(length = 0)
    tx[length(tx)+1] <- ""

    for (i in 1:NF) {
      tx[length(tx)+1] <- paste("F", toString(i), sep="")
      if (max.fname > 0)
        tx[length(tx)] <- paste(tx[length(tx)], " - ", fac.names[i], sep="")
      tx[length(tx)+1] <- .dash2(30)
      for (j in LblCut[i,1]:LblCut[i,2]) {
        options(xname = nm[Label[j]])
        tx[length(tx)+1] <- paste(nm[Label[j]], ": ", .getlabels()$xl, sep="")
      }
      tx[length(tx)+1] <- ""
    }

    txlbl <- tx
    class(txlbl) <- "out"
    output <- list(out_labels=txlbl)
  }  # end labels only


  else { # proceed with the analysis

  # --------------------------------------------------------
  # re-order R matrix

  outR <- R[Label,Label]
  nm_new <- colnames(outR)

  # get width of largest variable (item) name
  cc <- as.character(dimnames(outR)[[1]])
  max.chr <- max(4, max(nchar(cc)))


  # --------------------------------------------------------
  # MIMM CFA

  # expand R matrix to include rows/cols for factors
  rr <- matrix(rep(0, NF*NItems), nrow=NF)
  cc <- matrix(rep(0, NF*(NItems+NF)), nrow=(NItems+NF))
  outR <- cbind(rbind(outR,rr),cc)

  # do CFA:  get R with factors, alpha, omega
  out <- .mimm(outR, LblCut, NItems, NF, iter)

  nmF <- character(length=NF)
  for (i in 1:NF) nmF[i] <- paste("F", toString(i), sep="")

  NVTot <- NItems + NF

  # assign factor names
  nm <- c(nm_new, nmF)
  dimnames(out$R) <- list(nm, nm)


  # --------------------------------------------------------
  # Sort within each group by the group factor loading

  if (sort) {

    # get new ordering, factor by factor
    pt <- numeric(length=NItems)
    newLabel <- numeric(length=NItems)
    for (ifac in 1:NF) {
      n1 <- LblCut[ifac,1]
      n2 <- LblCut[ifac,2]
      irow <- NItems + ifac
      for (j in n1:n2) pt[j] <- out$R[irow, j]
      o <- order(pt[n1:n2], decreasing=TRUE)
      for (i in 1:(n2-n1+1)) newLabel[n1-1+i] <- Label[n1-1+o[i]]
    }
    Label <- newLabel

    outR <- R[Label,Label]

    nm_new <- colnames(outR)

    # expand R matrix to include rows/cols for factors
    rr <- matrix(rep(0, NF*NItems), nrow=NF)
    cc <- matrix(rep(0, NF*(NItems+NF)), nrow=(NItems+NF))
    outR <- cbind(rbind(outR,rr),cc)

    # MIMM CFA
    out <- .mimm(outR, LblCut, NItems, NF, iter)

    nmF <- character(length=NF)
    if (is.null(fac.names))
      for (i in 1:NF) nmF[i] <- paste("F", toString(i), sep="")
    else
     for (i in 1:NF) nmF[i] <- fac.names[i]

    # assign names
    nm <- c(nm_new, nmF)
    dimnames(out$R) <- list(nm, nm)
  }

  # --------------------------------------------------------
  if (heat_map) {
    if (is.null(main)) main <- ""
    .opendev(pdf_file, width, height)  # set up graphics
    .heatmap(out$R, NItems, main, bottom, right, diag=NULL,
               pdf_file, width, height)
  }



  title_scales <- "  FACTOR / SCALE COMPOSITION"

  txlbl <- ""
  tx <- character(length = 0)

  anyLabels <- FALSE
  for (i in 1:NItems) {
    options(xname = nm_new[i])
    if (!is.null(.getlabels()$xl)) anyLabels <- TRUE
  }

  for (i in 1:NF) {
    tx[length(tx)+1] <- paste("F", toString(i), sep="")
    if (max.fname > 0)
      tx[length(tx)] <- paste(tx[length(tx)], " - ", fac.names[i], sep="")
    if (!anyLabels) { # horizontal
      for (j in LblCut[i,1]:LblCut[i,2])
      tx[length(tx)] <- paste(tx[length(tx)], " ", nm_new[j])
    }
    else {  # vertical with variable labels
      tx[length(tx)+1] <- .dash2(30)
      for (j in LblCut[i,1]:LblCut[i,2]) {   
        options(xname = nm_new[j])  # sets the variable name for the label
        tx[length(tx)+1] <- paste(nm_new[j], ": ", xW(.getlabels()$xl), sep="")
      }
    }
    if (i < NF) tx[length(tx)+1] <- ""
  }

  txlbl <- tx



  title_rel <- "  RELIABILITY ANALYSIS"

  txrel <- ""
  tx <- character(length = 0)

  if (iter > 0) {
    buf <- if (max.fname > 0) max.fname+6 else 3
    tx[length(tx)+1] <- paste(" Scale", paste(rep(" ", buf), collapse=""),
      "Alpha    Omega", sep="")
    tx[length(tx)+1] <- .dash2(23)
    if (max.fname > 0) tx[length(tx)] <- paste(tx[length(tx)],
      .dash2(max.fname+3), sep="")
  }
  else {
    tx[length(tx)+1] <- " Scale   Alpha"
    tx[length(tx)+1] <- .dash2(14)
  }
  for (i in 1:NF) {
    Fnm <- paste("F", as.character(i), sep="")
    tx[length(tx)+1] <- paste("  ", Fnm) 
    if (max.fname > 0)
      tx[length(tx)] <- paste(tx[length(tx)], " - ",
        .fmtc(fac.names[i], w=max.fname, j="left"), sep="")
    tx[length(tx)] <- paste(tx[length(tx)], " ", .fmt(out$Alpha[i],3, w=6))
    if (iter > 0)
      tx[length(tx)] <- paste(tx[length(tx)], " ", .fmt(out$Omega[i],3, w=6))
  }
  if (iter <= 0) out$Omega <- NULL
  txrel <- tx



  title_sol <- "  SOLUTION"

  txind <- ""
  tx <- character(length = 0)

  if (iter > 0 ) {
    buf <- max.chr - 4
    if (buf < 0) buf <- 0


    if (is.null(options()$knitr.in.progress))
       tx[length(tx)+1] <- paste('Indicator Analysis\n')
    tx[length(tx)+1] <- paste('Fac', ' Indi', .fmtc(" ",buf+1), 'Pat',
       '   Unique', ' Factors with which an indicator correlates too')
    tx[length(tx)+1] <- paste('tor', ' cator', .fmtc("",buf), 'tern', '  ness',
        '   highly, and other indicator diagnostics.')
    tx[length(tx)+1] <- .dash2(75)

    for (IFac in 1:NF) {
      tx[length(tx)+1] <- ""
      Fnm <- paste("F", as.character(IFac), sep="")

      for (Item in LblCut[IFac,1]:LblCut[IFac,2]) {
        Bad <- integer(length=0)
        Lam <- out$R[NItems+IFac,Item]
        Unique <- 1 - Lam**2

        if (Lam <= 0)
          unq <- "   xxxx"
        else
          unq <- .fmt(Unique,3,7)

        tx[length(tx)+1] <- paste(.fmtc(Fnm,3), .fmtc(nm_new[Item],max.chr),
              .fmt(Lam,3,7), unq, "   ")

        if (Lam>0 && Unique>0) {
          for (I in 1:NF)
            if (abs(out$R[NItems+I,Item]) > Lam) Bad[length(Bad)+1] <- I
          if (length(Bad) > 0) for (IBad in 1:length(Bad))
            tx[length(tx)] <- paste(tx[length(tx)], paste("F", Bad[IBad], " ",
                                    sep=""))
        }
        else if (Lam <= 0)
          tx[length(tx)] <- paste(tx[length(tx)],
                                  '** Negative Loading on Own Factor **')
        else if (Unique <= 0) {
          if (LblCut[IFac,2]-LblCut[IFac,1] > 0)
            tx[length(tx)] <- paste(tx[length(tx)], '** Improper Loading **')
          else
            tx[length(tx)] <- paste(tx[length(tx)],
                                    '** Factor Defined by Only One Item **')
        }

      }  # each item within a factor

    }  # each factor

    txind <- tx
  }


  # --------------------------------------------------------
  # Solution
  txsol <- ""
  tx <- character(length = 0)

  if (iter > 0) {
    if (is.null(options()$knitr.in.progress))
      tx[length(tx)+1] <- "Factor / Item Correlations \n"
  } else {
    if (is.null(options()$knitr.in.progress))
      tx[length(tx)+1] <- "Item-Scale and Scale-Scale Correlations\n"
  }

  # print the solution
  if(grid)
    boundary <- LblCut[,2]
   else
    boundary <-  NULL
  if (item_cor)
    txcrs <- .prntbl(out$R, 2, cut=min_cor, cc=NULL, cors=TRUE, bnd=boundary)
  else
    txcrs <- .prntbl(out$R[1:NVTot,(NItems+1):NVTot], 2, cut=min_cor,
                     cc=NULL, cors=TRUE, bnd=boundary)

  for (i in seq_along(txcrs)) tx[length(tx)+1] <- txcrs[i]
  txsol <- tx



  title_res <- "  RESIDUALS"

  txres <- ""
  txrst <- ""
  if (resid) {

    # get lambdas
    phi <- out$R[(NItems+1):(NItems+NF), (NItems+1):(NItems+NF)]
    lambda <- matrix(0, nrow=NItems, ncol=NF)
    iFac <- 1
    for (i in 1:NItems) {
      if (i > LblCut[iFac,2]) iFac <- iFac + 1 
      lambda[i, iFac] <- out$R[i, NItems+iFac]
    }

    # get predicted correlations
    estR <- lambda %*% phi %*% t(lambda)
    diag(estR) <- 1.0
    estR <- round(estR, 5)
    colnames(estR) <- row.names(out$R[1:NItems,1:NItems])
    rownames(estR) <- colnames(estR)

    # compute residuals
    resR <- out$R[1:NItems,1:NItems] - estR
    diag(resR) <- 0
    resR <- round(resR, 5)

    # get residuals matrix
    tx <- character(length=0)
    if (is.null(options()$knitr.in.progress))
      tx[length(tx)+1] <- "Item residuals\n"
    txcrs <- .prntbl(resR, 2, cut=min_res, cc=NULL, cors=TRUE, bnd=boundary)

    for (i in seq_along(txcrs)) tx[length(tx)+1] <- txcrs[i]
    txres <- tx


    tx <- character(length = 0)

    # sum of squares, sum of abs
    if (is.null(options()$knitr.in.progress))
      tx[length(tx)+1] <- "Residual summaries\n"

    tx[length(tx)+1] <- paste(.fmtc(" ", max.chr+2), "Sum of    Average", "\n",
        .fmtc(" ", max.chr+2), "Squares   Abs Value", "\n",
        .fmtc(" ", max.chr+2), "-------   ---------", sep="")

    cc <- as.character(dimnames(resR)[[1]])
    res_avg <- double(length=NItems)

    ssq.tot <- 0
    abv.all <- 0
    for (i in 1:NItems) {
      ssq <- 0
      abv <- 0
      for (j in 1:NItems) {
        ssq <- ssq + resR[i,j]^2
        abv <- abv + abs(resR[i,j])
        abv.all <- abv.all + abs(resR[i,j])
      }
      ssq.tot <- ssq.tot + ssq
      res_avg[i] <- abv / (NItems - 1)
      tx[length(tx)+1] <- paste(.fmtc(cc[i],max.chr), "  ", .fmt(ssq,3), "  ",
                                .fmt(res_avg[i],3))
    }
    abv.all.tot <- abv.all / (NItems^2 - NItems)
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("Total sum of squares for all items:", 
                              .fmt(ssq.tot,3), "\n")
    tx[length(tx)+1] <- paste("Root mean square residual for all items:", 
                              .fmt(sqrt(ssq.tot / (NItems^2 - NItems)),3), "\n")
    tx[length(tx)+1] <- paste("Average absolute residual w/o the diagonal:",
                              .fmt(abv.all.tot,3), "\n\n")

    txrst <- tx
  }
  else { # no residuals
    resR <- NULL
    estR <- NULL
  }



  title_lvn <- "  LAVAAN SPECIFICATION"
  txlvn <- ""

  if (iter > 0) {
    tx <- character(length = 0)

    if (is.null(mimm)) nm.mimm <- "MeasModel"

    tx[length(tx)+1] <- paste(nm.mimm, " <-")

    tx[length(tx)+1] <- paste("\"")
    for (i in 1:NF) {
      if (max.fname > 0) nmF[i] <- fac.names[i]
      tx[length(tx)+1] <- paste("   ", nmF[i], " =~", sep="")

      for (j in LblCut[i,1]:LblCut[i,2]) {
        if (j == LblCut[i,1])
          tx[length(tx)] <- paste(tx[length(tx)], " ", nm_new[j], sep="")
        else  
          tx[length(tx)] <- paste(tx[length(tx)], "+", nm_new[j])
      }
    }
    tx[length(tx)+1] <- paste("\"\n")

    tx[length(tx)+1] <- paste("library(lavaan)")
    tx[length(tx)+1] <- paste("fit <- lavaan::cfa(", nm.mimm, ", data=d,",
      " std.ov=TRUE, std.lv=TRUE)", sep="")
    tx[length(tx)+1] <- "summary(fit, fit.measures=TRUE)"
    tx[length(tx)+1] <- ""

    tx[length(tx)+1] <- "--------"
    tx[length(tx)+1] <- paste("The preceding code fits the model from",
      "data frame:  d")
    tx[length(tx)+1] <- paste("To access the correlation matrix",
      "directly without the data")
    tx[length(tx)+1] <- paste("  replace the parameter  data  with the",
      "parameters")
    tx[length(tx)+1] <- paste("        sample.cov  and  sample.nobs")
    tx[length(tx)+1] <- paste("  These names refer to the name of the input",
      "correlation matrix and sample size\n")
    txlvn <- tx
  }



  # R Markdown
  txkfl <- ""
  if (!is.null(Rmd)) {
    if (!grepl(".Rmd", Rmd, fixed=TRUE)) Rmd <- paste(Rmd, ".Rmd", sep="")
    txknt <- .corfa.Rmd(mimm, nm.mimm, dname, fun_call, NItems, NF,
                 iter, item_cor, explain, results)
    cat(txknt, file=Rmd, sep="\n")
    txkfl <- .showfile2(Rmd, "R Markdown instructions")
  }


  class(title_scales) <- "out"
  class(txlbl) <- "out"
  class(title_rel) <- "out"
  class(txrel) <- "out"
  class(title_sol) <- "out"
  class(txind) <- "out"
  class(txsol) <- "out"
  class(title_res) <- "out"
  class(txres) <- "out"
  class(txrst) <- "out"
  class(title_lvn) <- "out"
  class(txlvn) <- "out"
  class(txkfl) <- "out"

  output <- list(
    call=fun_call,

    out_title_scales=title_scales, out_labels=txlbl,
    out_title_rel=title_rel, out_reliability=txrel,
    out_title_solution=title_sol, out_indicators=txind, out_solution=txsol,
    out_title_residuals=title_res, out_residuals=txres, out_res_stats=txrst,
    out_title_lavaan=title_lvn, out_lavaan=txlvn,  out_Rmd=txkfl,

    ff.cor=out$R[(NItems+1):NVTot,(NItems+1):NVTot],
    if.cor=out$R[1:NItems,(NItems+1):NVTot],
    diag.cor=diag(out$R[1:NItems,1:NItems]),
    alpha=out$Alpha,
    omega=out$Omega,
    pred=estR,
    resid=resR
    )

  }  # proceed with analysis

  # --------------------------------------------------------
  # return

  class(output) <- "out_all"

  return(output)
}

.reg1fitBasic <-
function(lm.out, TotSS, sy, digits_d=3, show_R=FALSE) {

  nm <- all.vars(lm.out$terms)  # names of vars in the model
  n.vars <- length(nm)
  n.pred <- n.vars - 1L
  n.obs <- nrow(lm.out$model)

  tx <- character(length = 0)

  # model fit
  sm <- summary(lm.out)

  if (is.null(getOption("knitr.in.progress"))) {
    tx[length(tx)+1] <- "-- Model Fit"
    tx[length(tx)+1] <- ""
  }

  if (!is.null(sy)) {  # assigned NULL in reg.zKfold.R)
    tx[length(tx)+1] <- paste("Standard deviation of ", nm[1], ": ",
    .fmt_cm(sy,digits_d), sep="")
    tx[length(tx)+1] <- ""
  }

  se <- sm$sigma
  tx[length(tx)+1] <- paste("Standard deviation of residuals:  ",
                            .fmt_cm(se,digits_d),
                            " for df=", sm$df[2], sep="")

  tcut <- -qt(0.025, df=sm$df[2])
  res_range <- 2*tcut*se
  tx[length(tx)+1] <- paste("95% range of residuals:  ",
          .fmt_cm(res_range,digits_d),
          " = 2 * (", .fmt(tcut,3), " * ", .fmt_cm(se,digits_d), ")", sep="")

  # predicted residual sum of squares
  hat <- lm.influence(lm.out)$hat
  prs.terms <- residuals(lm.out) / (1 - hat)
  prs.terms[hat >= 1 - .Machine$double.eps * 100] <- NA  # guard: hat≈1 → near-zero denominator
  PRESS <- sum(prs.terms^2, na.rm=TRUE)
  RsqPRESS <- if (is.na(TotSS) || TotSS == 0) NA_real_ else 1 - (PRESS / TotSS)

  if (n.pred > 0) {
    pvl <- 1-pf(sm$fstatistic[1],sm$fstatistic[2],sm$fstatistic[3])
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste("R-squared:", .fmt(sm$r.squared,3),
      "   Adjusted R-squared:", .fmt(sm$adj.r.squared,3),
      "   PRESS R-squared:", .fmt(RsqPRESS,3))
    tx[length(tx)+1] <- paste("\n",
        "Null hypothesis of all 0 population slope coefficients:\n",
        "  F-statistic: ", .fmt(sm$fstatistic[1],3),
        "     df: ", sm$fstatistic[2], " and ", sm$fstatistic[3],
        "     p-value:", .fmt(pvl, 3, 7), sep="")
  }

  return(list(out_fit=tx, se=sm$sigma, range=res_range, Rsq=sm$r.squared,
    Rsqadj=sm$adj.r.squared, PRESS=PRESS, RsqPRESS=RsqPRESS))

}

.plt.contour.facet <-
function(x, y, facet1, facet2, facet1.name, facet2.name,
         contour_n, contour_nbins, contour_points, size.pt,
         theme, scale_x, scale_y, pad_x, pad_y, x.lab, y.lab,
         ellipse, ellipse_color, ellipse_lwd, fit.line, fit_color, fit_lwd,
         axis_x_pre, axis_y_pre, axis_fmt, n_row, n_col, quiet,
         render = "contour", smooth_power = 0.25, smooth_points = 100,
         smooth_bins = 128, main = NULL) {

  smooth <- render == "smooth"

  # save graphics state ONCE, restore on exit
  old.par <- par(no.readonly = TRUE)
  on.exit({
    ro <- c("cin", "cra", "csi", "cxy", "din", "page")
    par(old.par[setdiff(names(old.par), ro)])
  }, add = TRUE)

  # -------------------------------------------------------------------------
  # colors: contour uses the single-plot filled-band ramp; smooth uses the
  #   single-plot density ramp (window_fill -> theme hue) painted as a raster
  if (smooth) {
    hue <- .get.h(theme)
    satur <- ifelse(theme %in% c("gray", "white"), 0, 80)
    col.s <- colorRampPalette(c(getOption("window_fill"),
                                hcl(hue, satur, 16)))(256)
  } else {
    if (theme %in% c("white", "gray", "light")) {
      clrs <- colorRampPalette(c("white",
        gray.colors(contour_n, rev = TRUE, start = 0.20, end = 0.92)))
    } else {
      sc <- .corcolors()
      clrs <- colorRampPalette(c("white", getColors(sc$fill_hi)))
    }
    col.n <- clrs(contour_n)
  }
  n.grid <- if (smooth) smooth_bins else contour_nbins

  # -------------------------------------------------------------------------
  # build the panel grid: one contour per facet cell
  # build a panel label:  VarName = "level"  (quote non-numeric levels only,
  #   so an integer level reads as  Year = 2020,  not  Year = "2020")
  .lab.lv <- function(nm, lv) {
    q <- ifelse(is.na(suppressWarnings(as.numeric(lv))),
                paste0('"', lv, '"'), lv)
    paste0(nm, " = ", q)
  }

  if (!is.factor(facet1)) facet1 <- factor(facet1)
  lv1 <- levels(droplevels(facet1))

  if (!is.null(facet2)) {  # two facets: rows = facet2, cols = facet1
    if (!is.factor(facet2)) facet2 <- factor(facet2)
    lv2 <- levels(droplevels(facet2))
    nc <- length(lv1)
    nr <- length(lv2)
    # panels filled row-major: for each facet2 level (row), each facet1 (col)
    cells <- expand.grid(c1 = lv1, c2 = lv2, stringsAsFactors = FALSE)
    cells <- cells[order(match(cells$c2, lv2), match(cells$c1, lv1)), ]
    sel <- Map(function(a, b) which(facet1 == a & facet2 == b),
               cells$c1, cells$c2)
    labs <- paste0(.lab.lv(facet1.name, cells$c1), ", ",
                   .lab.lv(facet2.name, cells$c2))
  }
  else {  # one facet: near-square grid unless n_row / n_col supplied
    k <- length(lv1)
    if (!is.null(n_col)) { nc <- n_col; nr <- ceiling(k / nc) }
    else if (!is.null(n_row)) { nr <- n_row; nc <- ceiling(k / nr) }
    else { nc <- ceiling(sqrt(k)); nr <- ceiling(k / nc) }
    sel <- lapply(lv1, function(a) which(facet1 == a))
    labs <- .lab.lv(facet1.name, lv1)
  }

  # -------------------------------------------------------------------------
  # shared scale across all panels
  # common KDE grid + bandwidth so density (z) is comparable panel-to-panel
  good.all <- complete.cases(x, y)
  x.all <- x[good.all]; y.all <- y[good.all]

  x_ext <- diff(range(x.all)) * 0.12
  y_ext <- diff(range(y.all)) * 0.12
  kde.lims <- c(range(x.all) + c(-x_ext, x_ext),
                range(y.all) + c(-y_ext, y_ext))
  # smooth matches the single-panel smoothScatter() so the two are consistent:
  #   its kernel SD is (5-95% quantile spread)/25, and kde2d's h is 4x the
  #   kernel SD.  contour keeps the wider normal-reference bandwidth, the
  #   established look for density contours.
  if (smooth) {
    ss.bw <- function(v) diff(stats::quantile(v, c(0.05, 0.95),
                              na.rm = TRUE, names = FALSE)) / 25
    h.common <- 4 * c(ss.bw(x.all), ss.bw(y.all))
  } else {
    h.common <- c(MASS::bandwidth.nrd(x.all), MASS::bandwidth.nrd(y.all))
  }
  h.common[h.common <= 0] <- NA  # let kde2d pick if degenerate

  # per-panel KDE on the common grid; collect densities and global z range
  dens.list <- vector("list", length(sel))
  z.rng <- NULL  # grows to the global density range across drawn panels
  for (i in seq_along(sel)) {
    ok <- intersect(sel[[i]], which(good.all))
    if (length(ok) < 3) next  # too few points for a density
    xi <- x[ok]; yi <- y[ok]
    h.i <- h.common
    h.i[is.na(h.i)] <- c(MASS::bandwidth.nrd(xi),
                         MASS::bandwidth.nrd(yi))[is.na(h.i)]
    if (any(h.i <= 0)) next  # still degenerate (e.g., all points collinear)
    d <- MASS::kde2d(xi, yi, n = n.grid, lims = kde.lims, h = h.i)
    dens.list[[i]] <- d
    z.rng <- range(c(z.rng, d$z))
  }
  if (is.null(z.rng)) {
    cat("\n"); stop(call. = FALSE, "\n------\n",
      "No facet cell has enough data (>= 3 points) for a ",
      if (smooth) "smooth density." else "contour.", "\n\n")
  }
  # contour: shared band breaks; smooth: shared image() zlim (transformed,
  #   since the raster maps the smooth_power-transformed density to color)
  lv.z <- seq(z.rng[1], z.rng[2], length.out = contour_n + 1)
  zlim.s <- pmax(z.rng, 0) ^ smooth_power

  # shared plot limits across panels
  if (is.null(scale_x)) {
    x.lim <- range(x.all)
    x.lim <- x.lim + c(-diff(x.lim) * pad_x[1], diff(x.lim) * pad_x[2])
    axT1 <- pretty(x.lim, eps.correct = 0)
  } else {
    x.lim <- scale_x[1:2]; axT1 <- axTicks(1, axp = scale_x)
  }
  if (is.null(scale_y)) {
    y.lim <- range(y.all)
    y.lim <- y.lim + c(-diff(y.lim) * pad_y[1], diff(y.lim) * pad_y[2])
    ayT2 <- pretty(y.lim, eps.correct = 0)
  } else {
    y.lim <- scale_y[1:2]; ayT2 <- axTicks(2, axp = scale_y)
  }
  lbl.x <- .axis.format(axT1, axis_fmt, axis_x_pre, axis_y_pre = "no")
  lbl.y <- .axis.format(ayT2, axis_fmt, axis_x_pre = "no", axis_y_pre)

  # -------------------------------------------------------------------------
  # draw the grid
  ax <- .axes_dim()
  par(bg = getOption("window_fill"))
  main.ok <- !is.null(main) && nzchar(main[1])
  # outer margin for shared axis titles; top expands for a title if given
  par(oma = c(3.4, 4.6, if (main.ok) 2.4 else 0.7, 0.8))
  par(mfrow = c(nr, nc))
  par(mgp = c(3.5, 0.4, 0), tcl = -0.25)

  n.pan <- nr * nc
  for (i in seq_len(n.pan)) {
    row.i <- ((i - 1) %/% nc) + 1
    col.i <- ((i - 1) %% nc) + 1
    last.row <- row.i == nr
    first.col <- col.i == 1

    par(mar = c(0.6, 0.6, 1.5, 0.5))
    plot.new()
    plot.window(xlim = x.lim, ylim = y.lim)

    if (i <= length(sel) && !is.null(dens.list[[i]])) {
      d <- dens.list[[i]]
      if (smooth)
        image(d$x, d$y, d$z ^ smooth_power, col = col.s, zlim = zlim.s,
              add = TRUE, useRaster = TRUE)
      else
        .filled.contour(d$x, d$y, d$z, levels = lv.z, col = col.n)

      ok <- intersect(sel[[i]], which(good.all))
      xi <- x[ok]; yi <- y[ok]
      if (smooth) {
        # overplot the smooth_points least-dense points (smoothScatter's
        #   nrpoints), so sparse tails show individual observations
        if (smooth_points > 0) {
          ix <- pmin(pmax(findInterval(xi, d$x), 1L), length(d$x))
          iy <- pmin(pmax(findInterval(yi, d$y), 1L), length(d$y))
          take <- head(order(d$z[cbind(ix, iy)]), smooth_points)
          points(xi[take], yi[take], pch = 21, cex = size.pt,
                 bg = "#00000055", col = "white", lwd = 0.2)
        }
      }
      else if (contour_points)
        points(xi, yi, pch = 21, cex = size.pt,
               bg = "#00000044", col = "white", lwd = 0.2)
      if (ellipse[1] > 0 && length(ok) >= 3) {
        mu <- c(mean(xi), mean(yi)); Sig <- cov(cbind(xi, yi))
        for (j in seq_along(ellipse)) {
          e <- ellipse::ellipse(Sig, centre = mu, level = ellipse[j],
                                npoints = 100)
          lines(e, col = ellipse_color, lwd = ellipse_lwd)
        }
      }
      if (fit.line != "off" && length(ok) >= 3) {
        pf <- .plt.fit(xi, yi, fit.line = fit.line, fit_power = 0,
                       fit_new = NULL, sz.lv = length(xi))
        lines(pf$x.lv, pf$f.ln, col = fit_color, lwd = fit_lwd)
      }
    }

    if (last.row)
      axis(1, at = axT1, labels = lbl.x, cex.axis = ax$axis_x_size,
           col.axis = ax$axis_x_text_color)
    if (first.col)
      axis(2, at = ayT2, labels = lbl.y, las = 1,
           cex.axis = ax$axis_y_size,
           col.axis = ax$axis_y_text_color)
    if (i <= length(labs))
      title(main = labs[i], cex.main = getOption("lab_size") * 0.95,
            col.main = getOption("lab_color"), font.main = 1, line = 0.3)
    box(col = getOption("panel_color"))
  }

  # shared axis titles in the outer margin
  lab.cex <- getOption("lab_size") * 1.15
  mtext(x.lab, side = 1, outer = TRUE, line = 1.6, cex = lab.cex,
        col = getOption("lab_color"))
  mtext(y.lab, side = 2, outer = TRUE, line = 2.8, cex = lab.cex,
        col = getOption("lab_color"))
  if (main.ok)
    mtext(main, side = 3, outer = TRUE, line = 0.4, font = 2,
          cex = getOption("main_size", 1.1),
          col = getOption("main_color"))

  # on.exit() restores par
}

simCImean <- 
function(ns, n, mu=0, sigma=1, cl=0.95, seed=NULL, 
         show_data=FALSE, show_title=TRUE, 
         miss_only=FALSE, color_hit="gray40", color_miss="red",
         grid="grey90", ylim_bound=NULL, pause=FALSE,
         main=NULL, pdf_file=NULL, width=5, height=5, ...) {

  if (missing(ns)) {

    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the number of samples, each of a given size, with:  ns\n\n")
  }

  if (missing(n)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the size of each sample, the number of data values, with:  n\n\n")
  }

  if (sigma < 0) { 
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Standard deviation, sigma, cannot be negative.\n\n")
  }


  alpha <- 1 - cl
  tcut <- qt(1-alpha/2, df=n-1)
  clpct <- round((cl)*100, 2)

  # data generation
  if (!is.null(seed)) set.seed(seed)
  data.raw <- rnorm(ns*n, mu, sigma)
  max.Y <- max(data.raw)
  min.Y <- min(data.raw)
  data.byrep <- matrix(data.raw, ns, n)

  # summary stats
  Ymean <- apply(data.byrep, 1, mean)
  Ysd <- apply(data.byrep, 1, sd)

  # confidence intervals
  E = tcut * Ysd/sqrt(n)
  lb <- Ymean - E
  ub <- Ymean + E

  # performance
  miss <- sum((lb > mu) + (ub < mu))
  missrate <- round((miss/ns)*100, 2)

  # keep mu centered with symmetric upper and lower limits on y-axis
  if (is.null(ylim_bound)) {
    if (!show_data) {
      l <- min(lb)
      u <- max(ub)
    }
    else {
      l <- min.Y
      u <- max.Y
    }
    max.dev <- max( abs(mu-l), abs(u-mu) )
    l <- mu - max.dev
    u <- mu + max.dev
  }
  else {
    l <- mu - ylim_bound
    u <- mu + ylim_bound
  }


  # plot setup

  # set up graphics system
  if (!is.null(pdf_file)) {
    if (!grepl(".pdf", pdf_file)) pdf_file <- paste(pdf_file, ".pdf", sep="")
    .opendev(pdf_file, width, height)
  }

  orig.params <- par(no.readonly=TRUE)
  par(mar=c(2,2,1.75,2), mgp=c(1,.5,0))

  base::plot(lb, type = "n", ylim = c(l,u), xlab = "", ylab = "",
             cex.main=.95, cex.axis=.8)
  if (show_title) title(main = bquote(paste(mu, "=", .(mu), "  ", sigma, "=",
     .(sigma), "  ", "cl=", .(clpct), "%  n=", .(n))), cex.main=1)

  mtext(bquote(paste(" ", mu)), side=4, cex=1.5, col="darkslateblue", las=2)

  # color the plot region between the axes
  usr <- par("usr")
  rect(usr[1], usr[3], usr[2], usr[4], col="gray98", border="black")

  # grid lines
  vy <- pretty(c(usr[3],usr[4]))
  abline(h=seq(vy[1],vy[length(vy)],vy[2]-vy[1]), col=grid, lwd=.5)

   # directions
  if (pause) cat("\n>>> Press Enter to obtain the next sample <<< \n\n")

  # plot confidence intervals
  cat("\nSample", "  Mean", " StdDev", " StdErr", "  Error", "     LB",
       "     UB", "\n")
  abline(h=mu, col="darkslateblue", lwd=1.5) # horizontal centerline at mu
  digits_d <- 3
  max.ln <- 8
  for (i in 1:ns) {
    if (pause) return(invisible(readline()))
    if ( (mu>lb[i] && mu<ub[i]) ) linecol <- color_hit else linecol = color_miss
    if (show_data) points(rep(i,n), data.byrep[i,], pch=21, col="gray75",cex=.3)
    if ( !(miss_only && linecol==color_hit) ) {
      se <- Ysd[i]/sqrt(n)
      e <- tcut * se
      cat(format(i, width=5, justify="right", sep=""))
      cat(.fmt(Ymean[i], digits_d, w=max.ln))
      cat(.fmt(Ysd[i], digits_d, w=max.ln))
      cat(.fmt(se, digits_d, w=max.ln))
      cat(.fmt(E[i], digits_d, w=max.ln))
      cat(.fmt(lb[i], digits_d, w=max.ln))
      cat(.fmt(ub[i], digits_d, w=max.ln))
      if (linecol == "red")  cat("  *** MISS ***")
      if (!pause) cat("\n")
    }
    segments(i, lb[i], i, ub[i], col=linecol, lwd=1.5)
    segments(i-.2, Ymean[i], i+.2, Ymean[i], col=linecol, lwd=1)
    segments(i-.2, lb[i], i+.2, lb[i], col=linecol, lwd=1)
    segments(i-.2, ub[i], i+.2, ub[i], col=linecol, lwd=1)
  }
  if (pause) cat("\n")

  # terminate pdf graphics system
  par(orig.params)        
  if (!is.null(pdf_file)) {
    dev.off()
    .showfile(pdf_file, "simulated confidence intervals")
  }

  # output stats
  cat("\nStructure\n")
  cat("Population mean, mu :", mu, "\n")
  cat("Pop std dev, sigma  :", sigma, "\n")
  cat("Number of samples   :", ns, "\n")
  cat("Size of each sample :", n, "\n")
  cat("Confidence level    :", cl, "\n")


  cat("\nPerformance\n")
  cat("Number of Misses: ", miss, "\n")
  cat("Percent Misses  :", format(sprintf("%.*f", 2, missrate), width=5, justify="right", sep=""), "\n")

  digits_d <- digits_d + 1
  cat("\nAnalysis of Sample Means\n")
  cat("   Mean:", format(sprintf("%.*f", digits_d, mean(Ymean)), width=max.ln, justify="right", sep=""), "\n")
  cat("Std Dev:", format(sprintf("%.*f", digits_d, sd(Ymean)), width=max.ln, justify="right", sep=""), "\n")

  cat("\n")

}

Subset <-
function(rows, columns, data=d, holdout=FALSE,
    random=0, quiet=getOption("quiet"), ...) {

  message("This Subset() function is deprecated\n",
          "Instead use .() or base R subset()\n",
          "For more information, enter:  ?.")

  # save variable labels, units (NULL if no labels, units) 
  l <- attr(data, which="variable.labels")
  myunits <- attr(data, which="variable.units")

  dname <- deparse(substitute(data))

  n.vars <- ncol(data)
  n.obs <- nrow(data)

  if (!quiet) {
    cat("\n")
    .dash(17)
    cat("Before the subset\n")
    .dash(17)
    cat("\n")
    cat("Number of variables in ", dname, ": ", n.vars, "\n", sep="")
    cat("Number of cases (rows) in ", dname, ": ", n.obs, "\n\n", sep="")
    cat("First five rows of data for data frame:", dname, "\n")
    .dash(68)
    print(head(data, n=5))
    cat("\n")
  }

  # set rows parameter by a random selection
  if (random > 0) {
    if (!missing(rows)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "Cannot specify both rows, to retain or exclude, and random.\n\n")
    }
    if (random > 1)
      n.obs_new <- round(random,0)
    else
      n.obs_new <- round(random*n.obs,0)
    if (!quiet) {
      cat("\n")
      cat("Rows of data randomly extracted\n")
      .dash(42)
      if (random <= 1) cat("Proportion of randomly retained rows: ", random, "\n")
      cat("Number of randomly retained rows: ", n.obs_new, "\n")
    }
    rand.rows <- sample(1:n.obs, size=n.obs_new, replace=FALSE)
    rand.rows <- sort(rand.rows)
    rows <- logical(length=n.obs)  # initial default is FALSE
    j <- 1
    for (i in 1:n.obs) {
      if (i == rand.rows[j]) {
        rows[i] <- TRUE 
        if (j < length(rand.rows)) j <- j + 1
      }
    }
  }

  
  # r is the logical vector or row to retain
  # set r by default to all or by specification
  if (missing(rows))
    r <- TRUE  # retain all rows
  else {  # if numeric, read directly from rows
    r <- eval(substitute(rows), envir=data, enclos=parent.frame())

  if (all(!r)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "No rows of data would be retained.\n",
      "The specified value does not occur in these data.\n\n")
  }

    if (is.logical(r))
      r <- r & !is.na(r)  # set missing for a row to FALSE
  }

  if (is.numeric(r)) {
    if (length(rows) == 1) {
      if ((rows > 0)  &&  (rows < 1)) {
        cat("\n"); stop(call.=FALSE, "\n","------\n",
          "Behavior has changed from previous documentation.\n",
          "Now use this parameter to draw a random subset:  random\n\n")
      }
      else if (rows > 1) {
        cat("\n"); warning(call.=FALSE, "\n","------\n",
          "Behavior has changed from previous documentation.\n",
          "Now use this parameter to draw a random subset:  random\n\n",
          "Now specifying a single value for rows yields only that\n",
          "  row in the subset, which is OK if that is what is desired.\n",
          "  A negative value deletes the row.\n\n")
      }
    }
  }

  # evaluate columns
  if (missing(columns)) 
    vars <- TRUE  # retain all variables
  else {
    all.vars <- as.list(seq_along(data))
    names(all.vars) <- names(data)
    vars <- eval(substitute(columns), envir=all.vars, parent.frame())
 }

  # do the subset, including any variable labels to be dropped
  data.sub <- data[r, vars, drop=FALSE]
  # if no vars dropped, vars is TRUE, otherwise a char vector of names to retain
  if (!is.logical(vars) && !is.null(l)) {  
    # warning unless length(d) a multiple of length(vars)
    keep.index <- which(suppressWarnings(names(d) == vars))
    l <- l[keep.index]
  }

  if (!quiet) {
    cat("\n\n")
    .dash(16)
    cat("After the subset\n")
    .dash(16)
    cat("\n")
    cat("Number of variables ", ": ", ncol(data.sub), "\n", sep="")
    cat("Number of cases (rows) ", ": ", nrow(data.sub), "\n\n", sep="")
    cat( "\n")
    cat("First five rows of data ")
    cat( "\n")
    .dash(68)
    print(head(data.sub, n=5))
    cat( "\n")
  }

  if (holdout)  {
    data.hold <- data[!r, vars, drop=FALSE]
    cat("\n\n")
    cat("Holdout Sample\n")
    .dash(70)
    cat("Deleted Rows:", nrow(data.hold), "\n")
    cat("Copy and paste this code into R to create the holdout sample\n",
        "from the original, unmodified data frame:", dname, "\n\n")
    cat(paste(dname,".hold", sep=""), "<- Subset(\n")
    for (i in 1:nrow(data.hold)) {
      if (i > 1) cat ("| ") else cat("  ")
      cat("row.names(", dname, ")==\"", row.names(data.hold)[i], "\"\n", sep="")
    }
    cat(")\n")
  }
 
  # restore any variable units, labels
  # note:  variable labels for all variables of original data frame
  #        even if variables were deleted
  if (!is.null(l)) attr(data.sub, which="variable.labels") <- l
  if (!is.null(myunits)) attr(data.sub, which="variable.units") <- myunits

  return(data.sub)

}

.plt.dist.facet <-
function(x, facet1, facet2, facet1.name, facet2.name,
         render = "density",
         bandwidth = "nrd0", kind = "both", histo = TRUE,
         fill_hist = "transparent", col_nrm = "transparent",
         fill_nrm = "transparent", col_gen, fill_gen, lwd = NULL,
         rug = FALSE, color_rug = "gray40", size_rug = 0.5,
         full_curve = TRUE, theme = getOption("theme"),
         x.min = NULL, x.max = NULL,
         stat = "count", breaks = NULL, bin_start = NULL, bin_width = NULL,
         bin_end = NULL, fill_area = TRUE,
         axis_fmt = "K", axis_x_pre = "", axis_y_pre = "",
         x.lab = NULL, y_axis = FALSE, n_row = NULL, n_col = NULL, quiet) {

  freqpoly <- render == "freq_poly"
  if (freqpoly) y_axis <- TRUE  # counts / proportions are the point of the y

  # save graphics state ONCE, restore on exit
  old.par <- par(no.readonly = TRUE)
  on.exit({
    ro <- c("cin", "cra", "csi", "cxy", "din", "page")
    par(old.par[setdiff(names(old.par), ro)])
  }, add = TRUE)

  # panel-strip label:  VarName = "level"  (quote non-numeric levels only),
  #   matching the faceted contour/smooth/hexbin forms
  .lab.lv <- function(nm, lv) {
    q <- ifelse(is.na(suppressWarnings(as.numeric(lv))),
                paste0('"', lv, '"'), lv)
    paste0(nm, " = ", q)
  }

  # -------------------------------------------------------------------------
  # build the panel grid: one distribution per facet cell
  if (!is.factor(facet1)) facet1 <- factor(facet1)
  lv1 <- levels(droplevels(facet1))

  if (!is.null(facet2)) {  # two facets: rows = facet2, cols = facet1
    if (!is.factor(facet2)) facet2 <- factor(facet2)
    lv2 <- levels(droplevels(facet2))
    nc <- length(lv1); nr <- length(lv2)
    cells <- expand.grid(c1 = lv1, c2 = lv2, stringsAsFactors = FALSE)
    cells <- cells[order(match(cells$c2, lv2), match(cells$c1, lv1)), ]
    sel <- Map(function(a, b) which(facet1 == a & facet2 == b),
               cells$c1, cells$c2)
    labs <- paste0(.lab.lv(facet1.name, cells$c1), ", ",
                   .lab.lv(facet2.name, cells$c2))
  }
  else {  # one facet: near-square grid unless n_row / n_col supplied
    k <- length(lv1)
    if (!is.null(n_col))      { nc <- n_col; nr <- ceiling(k / nc) }
    else if (!is.null(n_row)) { nr <- n_row; nc <- ceiling(k / nr) }
    else { nc <- ceiling(sqrt(k)); nr <- ceiling(k / nc) }
    sel <- lapply(lv1, function(a) which(facet1 == a))
    labs <- .lab.lv(facet1.name, lv1)
  }

  # -------------------------------------------------------------------------
  # first pass: per-panel estimates, and the shared x-range / y-max so panels
  #   are directly comparable
  est <- vector("list", length(sel))
  y.max <- 0
  xr <- NULL

  if (freqpoly) {
    # common bins across panels so the counts are comparable
    xa <- x[is.finite(x)]
    if (!is.null(bin_width) || !is.null(bin_start)) {
      if (is.null(bin_start)) bin_start <- pretty(range(xa))[1]
      if (is.null(bin_width))
        bin_width <- diff(graphics::hist(xa, plot = FALSE)$breaks[1:2])
      end <- if (!is.null(bin_end)) bin_end else max(xa)
      brk <- seq(bin_start, end, bin_width)
      while (max(brk) < max(xa)) brk <- seq(bin_start, max(brk) + bin_width,
                                            bin_width)
    } else if (!is.null(breaks)) brk <- breaks
    else brk <- graphics::hist(xa, plot = FALSE, breaks = "Sturges")$breaks
    for (i in seq_along(sel)) {
      xi <- x[sel[[i]]]; xi <- xi[is.finite(xi)]
      if (length(xi) < 1) next
      h <- graphics::hist(xi, breaks = brk, plot = FALSE)
      val <- if (stat == "proportion") h$counts / sum(h$counts) else h$counts
      est[[i]] <- list(mids = h$mids, val = val, bw = diff(brk)[1])
      y.max <- max(y.max, max(val))
    }
    xr <- range(brk)
  }
  else {  # density
    for (i in seq_along(sel)) {
      xi <- x[sel[[i]]]; xi <- xi[is.finite(xi)]
      if (length(xi) < 2 || stats::sd(xi) == 0) next  # too few / no spread
      h     <- graphics::hist(xi, plot = FALSE, breaks = "Sturges")
      d.gen <- suppressWarnings(stats::density(xi, bw = bandwidth))
      est[[i]] <- list(xi = xi, h = h, d.gen = d.gen,
                       mean = mean(xi), sd = stats::sd(xi))
      y.max <- max(y.max, max(d.gen$y), if (histo) max(h$density) else 0)
      xr <- range(c(xr, if (full_curve) range(d.gen$x) else range(xi)))
    }
  }
  if (is.null(xr)) {
    cat("\n"); stop(call. = FALSE, "\n------\n",
      "No facet cell has enough data to plot.\n\n")
  }
  if (is.null(x.min)) x.min <- xr[1]
  if (is.null(x.max)) x.max <- xr[2]

  # normal curve also contributes to y-max (evaluated on the shared grid)
  if (!freqpoly && kind %in% c("normal", "both")) {
    xx <- seq(x.min, x.max, length = 200)
    for (i in seq_along(est)) if (!is.null(est[[i]])) {
      dn <- stats::dnorm(xx, est[[i]]$mean, est[[i]]$sd)
      y.max <- max(y.max, max(dn))
    }
  }

  axT1 <- pretty(c(x.min, x.max))
  lbl.x <- .axis.format(axT1, axis_fmt, axis_x_pre, axis_y_pre = "no")
  ayT2 <- pretty(c(0, y.max))
  lbl.y <- .axis.format(ayT2, axis_fmt, axis_x_pre = "no", axis_y_pre)

  # -------------------------------------------------------------------------
  # draw the grid
  ax <- .axes_dim()
  col.bg  <- getOption("panel_fill")
  col.box <- getOption("panel_color")
  par(bg = getOption("window_fill"))
  par(oma = c(3.4, if (y_axis) 4.6 else 2.4, 1.0, 0.8))
  par(mfrow = c(nr, nc))
  par(mgp = c(3.5, 0.4, 0), tcl = -0.25)

  fill_gen_tr <- .maketrans(fill_gen, 100)

  for (i in seq_len(nr * nc)) {
    row.i <- ((i - 1) %/% nc) + 1
    col.i <- ((i - 1) %%  nc) + 1
    last.row  <- row.i == nr
    first.col <- col.i == 1

    par(mar = c(0.6, 0.6, 1.5, 0.5))
    plot.new()
    plot.window(xlim = c(x.min, x.max), ylim = c(0, y.max))
    rect(par("usr")[1], par("usr")[3], par("usr")[2], par("usr")[4],
         col = col.bg, border = col.box)

    if (i <= length(est) && !is.null(est[[i]])) {
      e <- est[[i]]
      if (freqpoly) {
        # frequency polygon: bin values at midpoints, dropped to zero one bin
        #   beyond each end; optional fill under the line
        px <- c(e$mids[1] - e$bw, e$mids, e$mids[length(e$mids)] + e$bw)
        py <- c(0, e$val, 0)
        lwd.fp <- if (!is.null(lwd)) lwd else 1.35
        if (fill_area)
          polygon(px, py, col = fill_gen_tr, border = col_gen, lwd = lwd.fp)
        else
          lines(px, py, col = col_gen, lwd = lwd.fp)
      }
      else {
        if (histo)
          plot(e$h, add = TRUE, freq = FALSE, col = fill_hist,
               border = "transparent")
        if (kind %in% c("normal", "both")) {
          xx <- seq(x.min, x.max, length = 200)
          dn <- stats::dnorm(xx, e$mean, e$sd)
          lwd.nrm <- if (!is.null(lwd)) lwd
                     else if (fill_nrm == "transparent") 1.35 else 1
          polygon(c(x.min, xx, x.max), c(0, dn, 0), col = fill_nrm,
                  border = col_nrm, lwd = lwd.nrm)
        }
        if (kind %in% c("general", "both")) {
          lwd.gen <- if (!is.null(lwd)) lwd
                     else if (fill_gen == "transparent") 1.35 else 1
          polygon(e$d.gen, col = fill_gen_tr, border = col_gen, lwd = lwd.gen)
        }
        if (rug) rug(e$xi, col = color_rug, lwd = size_rug, ticksize = 0.05)
      }
    }

    if (last.row)
      axis(1, at = axT1, labels = lbl.x, cex.axis = ax$axis_x_size,
           col.axis = ax$axis_x_text_color)
    if (first.col && y_axis)
      axis(2, at = ayT2, labels = lbl.y, cex.axis = ax$axis_y_size,
           col.axis = ax$axis_y_text_color)
    if (i <= length(labs))
      title(main = labs[i], cex.main = getOption("lab_size") * 1.05,
            col.main = getOption("lab_color"), font.main = 1, line = 0.3)
    box(col = col.box)
  }

  # shared axis titles in the outer margin
  lab.cex <- getOption("lab_size") * 1.15
  mtext(x.lab, side = 1, outer = TRUE, line = 1.6, cex = lab.cex,
        col = getOption("lab_color"))
  if (y_axis) {
    y.lab <- if (!freqpoly) "Density"
             else if (stat == "proportion") "Proportion" else "Count"
    mtext(y.lab, side = 2, outer = TRUE, line = 2.8, cex = lab.cex,
          col = getOption("lab_color"))
  }

  # on.exit() restores par
}

.bar.lattice <-
function(x, facet1, facet2, nrows, ncols, asp, prop,
         fill, color,
         trans, size.pt, xlab, ylab, main,
         rotate_x, offset,
         axis_fmt, axis_x_pre, axis_y_pre,
         width, height, pdf_file,
         segments_x, breaks,
         bin_start=NULL, bin_width=NULL, bin_end=NULL,
         T.type, quiet) {


  if (!quiet)
    cat("[Trellis graphics from Deepayan Sarkar's lattice package]\n\n")

  panel_fill <- getOption("panel_fill")
  panel_color <- getOption("panel_color")

  grid_x_color <- getOption("grid_x_color")
  if (is.null(grid_x_color)) grid_x_color <- getOption("grid_color")
  grid_y_color <- getOption("grid_y_color")
  if (is.null(grid_y_color)) grid_y_color <- getOption("grid_color")

  grid_x_lwd <- getOption("grid_x_lwd")
  if (is.null(grid_x_lwd)) grid_x_lwd <- getOption("grid_lwd")
  grid_y_lwd <- getOption("grid_y_lwd")
  if (is.null(grid_y_lwd)) grid_y_lwd <- getOption("grid_lwd")

  grid_x_lty <- getOption("grid_x_lty")
  if (is.null(grid_x_lty)) grid_x_lty <- getOption("grid_lty")
  grid_y_lty <- getOption("grid_y_lty")
  if (is.null(grid_y_lty)) grid_y_lty <- getOption("grid_lty")

  axis_x_color <- getOption("axis_x_color")
  if (is.null(axis_x_color)) axis_x_color <- getOption("axis_color")
  axis_y_color <- getOption("axis_y_color")
  if (is.null(axis_y_color)) axis_y_color <- getOption("axis_color")
  # axis color is panel_color unless axis_color is changed from default
  theme <- getOption("theme")
  sub_theme <- getOption("sub_theme")
  if (sub_theme != "black")  {
     panel_color <- ifelse (axis_x_color != "gray15", axis_x_color, "#DED9CD")
     if (panel_color == "#DED9CD")
       panel_color <- ifelse (axis_y_color != "gray15", axis_y_color, "#DED9CD")
  }
  else {
     panel_color <- ifelse (axis_x_color != "gray55", axis_x_color, "gray55")
     if (panel_color == "gray55")
       panel_color <- ifelse (axis_y_color != "gray55", axis_y_color, "gray55")
  }

  axis_x_text_color <- getOption("axis_x_text_color")
  if (is.null(axis_x_text_color)) axis_x_text_color <- getOption("axis_text_color")
  axis_y_text_color <- getOption("axis_y_text_color")
  if (is.null(axis_y_text_color)) axis_y_text_color <- getOption("axis_text_color")

  axis_x_size <- getOption("axis_x_size")
  if (is.null(axis_x_size)) axis_x_size <- getOption("axis_size")
  adj <- .RSadj(axis_size=axis_x_size); axis_x_size <- adj$axis_size

  axis_y_size <- getOption("axis_y_size")
  if (is.null(axis_y_size)) axis_y_size <- getOption("axis_size")
  adj <- .RSadj(axis_size=axis_y_size); axis_y_size <- adj$axis_size

  lab_x_color <- getOption("lab_x_color")
  if (is.null(lab_x_color)) lab_x_color <- getOption("lab_color")
  lab_y_color <- getOption("lab_y_color")
  if (is.null(lab_y_color)) lab_y_color <- getOption("lab_color")


  # if applicable, open graphics window of specified dimensions
  in.RStudio <- identical(getOption("device"), "RStudioGD")
  in.knitr <- !is.null(options()$knitr.in.progress)
  if (!in.RStudio && !in.knitr) dev.new(width=width, height=height)

  # get variable labels if exist plus axes labels
  if (is.null(ylab)) {
    was.null <- TRUE
    ylab <- ifelse (!prop, "Count of", "Proportion of")
  }
  else
    was.null <- FALSE

  # get lab_x_size  lab_y_size
  lab_size <- getOption("lab_size")
  lab_x_size <- getOption("lab_x_size")
  lab_y_size <- getOption("lab_y_size")
  if (is.null(lab_x_size)) lab_x_size <- lab_size
  adj <- .RSadj(lab_size=lab_x_size); lab_x_size <- adj$lab_size
  if (is.null(lab_y_size)) lab_y_size <- lab_size
  adj <- .RSadj(lab_size=lab_y_size); lab_y_size <- adj$lab_size
  gl <- .getlabels(xlab, ylab, main, lab_x_size=lab_x_size,
                   lab_y_size=lab_y_size)
  x.name <- gl$xn; x.lbl <- gl$xl; x.lab <- gl$xb
  y.name <- gl$yn; y.lbl <- gl$yl
  y.lab <- ifelse (was.null, paste(gl$yb, x.name), gl$yb)
  main.lab <- gl$mb
  sub.lab <- gl$sb
  lab_x_size <- gl$lab_x_size
  lab_y_size <- gl$lab_y_size

  # lattice does horizontal bar or dot chart, so reverse axis labels
  if (T.type %in% c("bar", "dot")) {
    tmp.lab <- x.lab
    x.lab <- y.lab
    y.lab <- tmp.lab
    tmp.cex <- lab_x_size
    lab_x_size <- lab_y_size
    lab_y_size <- tmp.cex
    if (is.null(trans)) trans <- getOption("trans_pt_fill")
  }

  # ------------------------------------------------
  # calculate the histogram or bar chart or dot plot
  # set conditioning variables, facet1 and facet2

  h.type <- ifelse(prop, "percent", "count")  # histogram type
  #h.type <- "density"   # need to integrate density as a 3rd option
  if (T.type == "hist") {
    # derive breaks from bin_start/bin_width/bin_end if any are supplied
    if (!is.null(bin_width) || !is.null(bin_start) || !is.null(bin_end)) {
      if (is.null(bin_start))
        bin_start <- pretty(c(min(x, na.rm=TRUE),
                              max(x, na.rm=TRUE)))[1]
      if (is.null(bin_width)) {
        h <- suppressWarnings(hist(x, plot=FALSE, breaks="Sturges"))
        bin_width <- h$breaks[2] - h$breaks[1]
      }
      if (is.null(bin_end)) bin_end <- max(x, na.rm=TRUE)
      brks <- seq(bin_start, bin_end, bin_width)
      seq.end <- bin_end
      while (max(brks) < bin_end) {
        seq.end <- seq.end + bin_width
        brks <- seq(bin_start, seq.end, bin_width)
      }
      breaks <- brks
    }
    if (is.null(facet2))
      p <- lattice::histogram(~ x | facet1, type=h.type, breaks=breaks,
          scales=list(
            x = list(labels=.axis.format(pretty(x),
                                         axis_fmt, axis_x_pre, "no"),
                     at=pretty(x), tck=.8)
          ))
    else
      p <- lattice::histogram(~ x | facet1 * facet2, type=h.type,
          breaks=breaks,
          scales=list(
            x = list(labels=.axis.format(pretty(x),
                                         axis_fmt, axis_x_pre, "no"),
                     at=pretty(x), tck=.8)
          ))
    # see if there is a color range for fill, if so then get the colors
    # if breaks were possible, use unlist(p)$panel.args.common.breaks
    n.bar <- p$panel.args.common$nint
  }

  else if (T.type %in% c("bar", "dot")) {
    mytab <- table(x, facet1)
    if (prop) mytab <- prop.table(mytab, margin=2)
    mytabDF <- as.data.frame.table(mytab, responseName="Count")
    p <- lattice::barchart(x ~ Count | facet1, data = mytabDF,
          scales = list(
            x = list(labels=.axis.format(pretty(mytabDF$Count),
                                         axis_fmt, axis_x_pre, "no"),
                     at=pretty(mytabDF$Count), tck=.8)
          ))
    n.bar <- nrow(mytab)
  }

  # process a potential color range (such as "blues")
  clr <- NULL
  if (is.null(fill))  fill <- getOption("bar_fill_discrete")
  clr <- .color_range(fill, n.bar)  # if range, return colors
  fill <- clr  # NOTE:  somewhere  fill  is still being used instead of clr


  # customize layout cols and rows, need only specify one
  if (!is.null(nrows) ||  !is.null(ncols)) {
    n.panels <- ifelse (is.null(facet2), nlevels(facet1),
                                         nlevels(facet1)*nlevels(facet2))
    if (is.null(ncols)) ncols <- (n.panels %/% nrows) + (n.panels %% nrows > 0)
    if (is.null(nrows)) nrows <- (n.panels %/% ncols) + (n.panels %% ncols > 0)
    p <- update(p, layout=c(ncols, nrows))
  }

  # scale down the point size, grid line width for the multi-panel dot plots
  n.pnl <- nlevels(facet1)
  if (!is.null(facet2)) n.pnl <- n.pnl * nlevels(facet2)
  size.mult <- ifelse (n.pnl > 3, 0.70, 0.833)
  size.pt <- size.pt * size.mult
  if (n.pnl > 3 &&  grid_y_lwd > 0.99) grid_y_lwd <- .5 * grid_y_lwd

  # separate panels with a border even if turned off when only one plot
  panel_frame_color <- ifelse(panel_color == "transparent",
                              "gray50", panel_color)

  # even if no axis in single plot, multi-panel needs an axis to separate
  # scales, as currently configured, does not separate values from the axis
  g.x_color <- grid_x_color
  if (g.x_color ==  "transparent") g.x_color <- grid_y_color
  g.y_color <- grid_y_color
  if (g.y_color ==  "transparent") g.y_color <- grid_x_color

  a.x.text_color <- axis_x_text_color
  if (a.x.text_color ==  "transparent") a.x.text_color <-axis_y_text_color
  a.y.text_color <- axis_y_text_color
  if (a.y.text_color ==  "transparent") a.y.text_color <- axis_x_text_color

  l.x_color <- lab_x_color
  if (l.x_color == "transparent") l.x_color <-lab_y_color
  l.y_color <- lab_y_color
  if (l.y_color == "transparent") l.y_color <- lab_x_color

  # more physical space of the axis from the axis labels unless too many rows
  if (is.null(nrows)) nrows <- 1
  if (nrows < 7) {
    pad <- 2.08 - 0.56*log(nrows)
    p <- update(p,
         par.settings=list(
           layout_heights=list(axis_xlab_padding=pad)))
  }

  top.pad <- ifelse (is.null(main), 0, 1)
  if (!is.null(facet1)) top.pad <- 1
  axs.top <- ifelse (is.null(main), .5, 1)

  # move strip to left for a single column
  show_strip <- TRUE;  strip.lft <- FALSE
  if (!is.null(ncols)) if (ncols == 1)
    strip.lft <- TRUE

  # specify strip attributes
  strip = if (show_strip) {
    p <- update(p,
         strip = lattice::strip.custom(
           par.strip.text = list(
             cex=axis_x_size,
             col=getOption("strip_text_color"),
             bg=list(col=getOption("strip_fill")),
             strip.border=list(col=getOption("strip_color"), lwd=0.5),
             strip.left=strip.lft
      )))}
  else
    FALSE

  # specify general plot attributes
  p <- update(p,
         aspect=asp,
         xlab=list(label=x.lab, cex=lab_x_size, col=l.x_color),
         ylab=list(label=y.lab, cex=lab_y_size, col=l.y_color),
         main=list(label=main.lab, cex=getOption("main_size", 1.1),
                   col=getOption("lab_color")),
         par.settings=list(
           background=list(col=getOption("window_fill")),
           panel.background=list(col=panel_fill),
           layout_heights=list(top.padding=top.pad, axis_top=axs.top),
           axis_line=list(col=panel_frame_color,
             lty=getOption("axis_lty"), lwd=getOption("axis_lwd"))),
         scales=list(
           x = list(cex=axis_x_size, rot=rotate_x,
                    col=a.x.text_color),
           y = list(cex=axis_y_size, rot=getOption("rotate_y"),
                    col=a.y.text_color)),

         panel = function(x, y, ...) {
            panel.grid(h=0, v=-1, col=g.x_color,
                        lwd=grid_x_lwd, lty=grid_x_lty)
            if (T.type == "hist") {
              panel.grid(h=-1, v=0, col=g.y_color,
                         lwd=grid_y_lwd, lty=grid_y_lty)
              panel.histogram(x, col=fill, border=color, ...)
              #panel.dnFill(x, fill=rgb(.3,.3,.9,.2), color="darkblue",
                           #ref=TRUE, origin=0, ...)
              #panel.mathdensity(dmath = dnorm, col.line = "grey60",
                           #args = list(mean=mean(x),sd=sd(x)), ...)
            }
            else if (T.type == "dot") {
              if (segments_x) {
                panel.points(x, y, pch=21, cex=size.pt,
                   col=getOption("pt_fill"), fill=getOption("pt_fill"), ...)
                panel.segments(0, y, x, y, col=getOption("pt_fill"), ...)
              }
              else {
                panel.dotplot(x, y, type="p", col=color, fill=fill,
                   col.line=fill, ...)  # called from Plot
              }
            }
            else if (T.type == "bar")
              panel.barchart(x, y, col=fill, border=color, ...)
          }
        )


  # display
  # Note: programmatic PDF save is not reliable for lattice/trellis graphics
  # due to grid's internal device state. Use RStudio > Plots > Export > Save as PDF.
  if (!is.null(pdf_file))
    message("Writing directly to a PDF file does not work in this context.\n",
            "To save as PDF, use RStudio > Plots > Export > Save as PDF.")
  axis.text.old <- lattice::trellis.par.get("axis.text")
  lattice::trellis.par.set("axis.text",
    utils::modifyList(axis.text.old, list(cex=axis_x_size)))
  print(p)
  lattice::trellis.par.set("axis.text", axis.text.old)

  # text output
  if (!quiet) {

    if (T.type == "hist"  &&  is.null(facet2)) {
      stuff <- .ss.numeric(x, facet1, digits_d=getOption("digits_d"),
                           brief=TRUE, y.name=getOption("facet1name"))
      txsts <- stuff$tx
      class(txsts) <- "out"
      output <- list(out_stats=txsts)
      class(output) <- "out_all"
      print(output)
    }

    else if (T.type == "bar"  &&  is.null(facet2)) {
        stats <- .ss.factor(x, by=facet1, brief=TRUE, digits_d=getOption("digits_d"),
                            x.name=x.name, y.name=getOption("facet1name"),
                            x.lbl=x.lbl, y.lbl=y.lbl)
        if (!is.null(stats)) {
          txttl <- stats$txttl
          txfrq <- stats$txfrq
          txXV <- stats$txXV

          class(txttl) <- "out"
          class(txXV) <- "out"
          output <- list(out_ttl=txttl, out_frq=txfrq, out_chi=txXV)
          class(output) <- "out_all"
          print(output)
      }

    }
  }

  cat("\n")

}

.plt.MD <- 
function(x, y, ID, MD_cut, out_cut) {

  m.x <- mean(x, na.rm=TRUE)
  m.y <- mean(y, na.rm=TRUE)
  center <- c(m.x, m.y)
  cov.mat <- cov(matrix(c(x,y), ncol=2), use="complete.obs")

  dst <- numeric(length=length(x))
  for (i in 1:length(x))
    dst[i] <- mahalanobis(c(x[i], y[i]), center, cov.mat)

  if (MD_cut > 0)
    out_ind <- which(dst >= MD_cut)  # absolute threshold
  else if (out_cut > 0  && out_cut < 1)  # a proportion
    out_ind <- which(dst > quantile(dst, 1-out_cut, na.rm=TRUE))
  else if (out_cut >= 1)  { # a count
    out_cut <- min(sort(dst, decreasing=TRUE)[1:out_cut])
    out_ind <- which(dst >= out_cut)
  }


  tx <- character(length=0)

  n.lines <- length(out_ind) + 3  # 3 extra lines to compare MD
  ord <- order(dst, decreasing=TRUE)
  dst.srt <- dst[ord]
  ID.srt <- ID[ord]
  max.ID <- max(nchar(as.character(ID.srt)))
  max.MD <- max(nchar(.fmt(dst.srt, d=2)))
  tx[length(tx)+1] <- ">>> Outlier analysis with Mahalanobis Distance"
  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste(.fmtc("MD", max.MD), .fmtc(" ID", max.ID+1)) 
  tx[length(tx)+1] <- paste(.fmtc("-----", max.MD), .fmtc("-----", max.ID+1)) 
  for (i in 1:n.lines) {
    if (i == (length(out_ind)+1)  &&  length(out_ind) > 0)
      tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- paste(.fmt(dst.srt[i], 2, max.MD),
                              .fmtc(ID.srt[i], max.ID+1))
  }
  if (n.lines < length(x))
    tx[length(tx)+1] <- paste(.fmtc("...", max.MD-1), .fmtc("...", max.ID+2)) 

  return(list(tx.otl=tx, outlpts=out_ind))

}

.dist.Rmd <-
function(Y, dname, fun_call, d) {

  explain <- TRUE

  fncl <- .fun_call.deparse(fun_call) 
  fc <- .rm.arg("Rmd", fncl) 

  if (explain) show <- "" else show <- ", echo=FALSE"

  tx <- character(length = 0)

  tx[length(tx)+1] <- "---"
  tx[length(tx)+1] <- "output:"
  tx[length(tx)+1] <- "  html_document:"
  tx[length(tx)+1] <- "    fig_height: 4.5"
  tx[length(tx)+1] <- "    fig_width: 5.5"

  tx[length(tx)+1] <- "---"


  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "***"

  v <- packageVersion("lessR")
  tx[length(tx)+1] <- paste(
"_", format(Sys.time(), "%a %b %d, %Y at %H:%M"), " &nbsp; with ",
"lessR version ", v, "_",
sep="")

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "***"



  tx[length(tx)+1] <- paste("# Distribution of ", Y, sep="")


  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "```{r, echo=FALSE}"
  tx[length(tx)+1] <- "suppressPackageStartupMessages(library(lessR))  # load lessR"
  tx[length(tx)+1] <- "```"


  tx[length(tx)+1] <- paste(
"The purpose of this analysis is to examine the distribution of ",
"values of the variable ",
 Y, ".",
 sep="")

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## The Data"


  rdcall <- getOption("read.call")
  if (is.null(rdcall)) {
      cat("\n"); stop(call.=FALSE, "\n","------\n",
       "To generate a knitr output file, first read the data for this\n",
       "regression analysis with the lessR function Read.\n\n")
  }

  #ref <- .get.arg("ref", rdcall)
  #if (nchar(ref) == 0) {
      #cat("\n"); stop(call.=FALSE, "\n","------\n",
       #"To generate a knitr output file, need to specify a file name\n",
       #"to Read the data for this regression analysis.\n\n")
  #}


  tx[length(tx)+1] <- "First read the data."
  ref <- .get.arg("ref", rdcall)
  if (ref %in% c("Employee", "Reading", "Cars93", "Jackets", "Learn", "Mach4")) {
    ref  <- paste(ref, "\"", ", format=\"lessR", sep="")
    tx[length(tx)+1] <- paste(
"Here read from a data file included with the `lessR` package.",
sep="")
  }


  tx[length(tx)+1] <- paste("```{r", show, "}", sep="")
  tx[length(tx)+1] <- paste(dname, " <- ", rdcall, sep="")
  tx[length(tx)+1] <- "```"

  tx[length(tx)+1] <- paste(
"Data from the following variables are available for analysis: ",
"`r xAnd(names(", dname, "))`. ",
sep="")






  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## The Histogram"

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste(
"Obtain the histogram and related analyses with the `lessR` function ",
"`Histogram`. Can also use the abbreviation `hs`.",
sep="")
  tx[length(tx)+1] <- "```"
  tx[length(tx)+1] <- paste("h <- Histogram(", Y, ")", sep="")  # not run here (no {r})
  tx[length(tx)+1] <- "```"

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste(
"The first part of the output provides the descriptive statistics for ",
"this sample of data of ", Y, ".",
sep="")
  tx[length(tx)+1] <- "```{r, echo=FALSE}"
  tx[length(tx)+1] <- paste("s <- ss.brief(", Y, ")", sep="") 
  tx[length(tx)+1] <- "```"

  tx[length(tx)+1] <- "```{r, echo=FALSE}"
  tx[length(tx)+1] <-"s$out_stats" 
  tx[length(tx)+1] <- "```"

  tx[length(tx)+1] <- paste("\n",
"Of the `r s$n+s$n.miss` cases presented for analysis, `r s$n` are ",
"retained, so the number of deleted data values due to missing data ",
"is `r s$n.miss`. The sample mean of ", Y, " is `r xP(s$mean", d, ")` with ",
"a standard deviation of `r xP(s$sd", d, ")` ranging from ",
"`r xP(s$min", d, ")` to `r xP(s$max", d, ")`. ",
sep="")
  
  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "```{r, echo=FALSE}"
  tx[length(tx)+1] <- paste("h <- hs(", Y, ")", sep="")
  tx[length(tx)+1] <- "```"

  tx[length(tx)+1] <- paste("\n",
"The histogram presents a graphical display of the frequency of the ",
"different values of ", Y, " grouped into bins. The width of each bin is ",
"`r h$bin_width`.",
sep="")

  tx[length(tx)+1] <- paste("The tabular presentation of the distribution ", 
"lists the bins, the count of the values in each bin, the corresponding ",
"proportions and the cumulative counts and proportions.",
sep="")
  tx[length(tx)+1] <- "```{r, echo=FALSE}"
  tx[length(tx)+1] <-"h$out_freq" 
  tx[length(tx)+1] <- "```"

  tx[length(tx)+1] <- paste("The analysis of any variable should consider if ",
"outliers are present. Here the definition of an outlier is Tukey's ",
"from the boxplot, any value more than 1.5 interquartile ranges from ",
"the median.",
sep="")
  tx[length(tx)+1] <- "```{r, echo=FALSE}"
  tx[length(tx)+1] <-"h$out_outliers" 
  tx[length(tx)+1] <- "```"





  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## The Density Plot"

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste(
"Obtain the density plot and related analyses of ", Y,
" with the `lessR` function ",
"`Density`. Can also use the abbreviation `dn`.",
sep="")
  tx[length(tx)+1] <- "```{r}"
  tx[length(tx)+1] <- paste("Density(", Y, ", quiet=TRUE)", sep="")  # no stats
  tx[length(tx)+1] <- "```"





  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## The Box Plot"

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste(
"Obtain the box plot and related analyses of ", Y,
" with the `lessR` function ",
"`BoxPlot`. Can also use the abbreviation `bx`.",
sep="")
  tx[length(tx)+1] <- "```{r}"
  tx[length(tx)+1] <- paste("BoxPlot(", Y, ", quiet=TRUE)", sep="")  # no stats
  tx[length(tx)+1] <- "```"





  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- "## The Scatter Plot"

  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste(
"Obtain the 1-dimensional scatter plot and related analyses of ", Y,
" with the ",
"`lessR` function `ScatterPlot`. Can also use the abbreviation `sp`.",
sep="")
  tx[length(tx)+1] <- "```{r}"
  tx[length(tx)+1] <- paste("ScatterPlot(", Y, ", quiet=TRUE)", sep="")  # no stats
  tx[length(tx)+1] <- "```"

  return(tx)

}

values <-
function(x, data=d, ...) {

  # get actual variable name before potential call of data$x
  x.name <- deparse(substitute(x)) 

  # get data frame name
  dname <- deparse(substitute(data))

  # see if variable exists in the data frame, if x not in style Env or function call 
  in.global <- df.or.global(x.name, dname, role="x", fun.name="values")
  if (!missing(x) && !in.global) .xcheck(x.name, dname, names(data))

  if (!in.global)
    x.call <- eval(substitute(data$x))
  else {  # vars that are function names get assigned to style
    x.call <- x
    if (is.function(x.call)) x.call <- eval(substitute(data$x))
  }

  print(x.call, ...)

}

.reg1modelBasic <-
function(lm.out, digits_d=NULL, show_R=FALSE) {

  nm <- all.vars(lm.out$terms)  # names of vars in the model
  n.vars <- length(nm)
  n.pred <- n.vars - 1L
  n.obs <- nrow(lm.out$model)

  tx <- character(length = 0)


# --------------
# Basic Analysis
# --------------
 
# estimates, HTs 
  sm <- summary(lm.out)

  if (show_R) {
    tx[length(tx)+1] <- ""
    tx[length(tx)+1] <- .dash2(68)
    tx[length(tx)+1] <- "> summary(model)"
    tx[length(tx)+1] <- "> confint(model)"
    tx[length(tx)+1] <- .dash2(68)
  }

  # output: header
  if (is.null(options()$knitr.in.progress)) {
    tx[length(tx)+1] <- paste("-- Estimated Model for", nm[1])
    tx[length(tx)+1] <- ""
  }

  # model coefficients
  sm1 <- sm$coefficients
  sm2 <- confint(lm.out, level=0.95) 
  smc <- cbind(sm1, sm2)

  buf <- 0
  for (i in 1:nrow(sm$coefficients)) {  # allows for indicator variables
    lng.lbl <- nchar(rownames(smc)[i])
    if (lng.lbl > buf) buf <- lng.lbl 
   }

  max.num <- integer(length=6)
  for (icol in 1:6) {
    max.num[icol] <- max(nchar(as.character(floor(smc[,icol]))) + digits_d + 1)
    if (max.num[icol] < 9) max.num[icol] <- 9L 
  }

  # output: row labels
  est.lbl <- .fmtc("Estimate", max.num[1]+1)
  ste.lbl <- .fmtc("  Std Err", max.num[2]+2)
  t.lbl <-  "  t-value"
  p.lbl <-  "  p-value"
  lb.lbl <- .fmtc("Lower 95%", max.num[5]+3)
  ub.lbl <- .fmtc("Upper 95%", max.num[6]+3)
  tx[length(tx)+1] <- paste(format("", width=buf), est.lbl, ste.lbl,
                            t.lbl, p.lbl, lb.lbl, ub.lbl, sep="")

  # output: values row by row
  for (i in 1:(nrow(smc))) {
    rlb <- .fmtc(rownames(smc)[i], buf)
    est <- .fmt(smc[i,1], digits_d, max.num[1])
    ste <- .fmt(smc[i,2], digits_d, max.num[2]+1)
    tvl <- .fmt(smc[i,3], 3, 8)
    pvl <- .fmt(smc[i,4], 3, 8)
    lb <- .fmt(smc[i,5], digits_d, max.num[5])
    ub <- .fmt(smc[i,6], digits_d, max.num[6])
    tx[length(tx)+1] <- paste(rlb, est, ste, tvl, pvl, " ", lb, " ", ub)
  }

  return(list(out_estimates=tx, estimates=smc[,1], sterrs=smc[,2], tvalues=smc[,3],
     pvalues=round(smc[,4],3), cilb=smc[,5], ciub=smc[,6]))

}

corRead <-
function(from=NULL, var_names=NULL, ...) {

  cat("\n")

  if (!is.null(from))
    if (nchar(from) == 0) from <- NULL  #  "" to NULL

  if (is.null(from)) {
    from <- file.choose()
    .dash(64)
    cat("File: \n")
    cat("   ", from, "\n")
    .dash(64)
    cat("\n")
  }

  myc <- as.matrix(read.table(from, ...))

  if (!is.numeric(myc))
    stop("Correlation matrix must be numeric. The values read include ",
         "non-numeric data. Check that the file contains only coefficients, ",
         "with no variable names or row labels.", call.=FALSE)

  if (nrow(myc) != ncol(myc))
    stop("Correlation matrix must be square; read matrix is ",
         nrow(myc), " x ", ncol(myc), ".", call.=FALSE)

  if (!is.null(var_names)) {
    if (length(var_names) != ncol(myc))
      stop("var_names length (", length(var_names), ") must equal ",
           "number of variables (", ncol(myc), ").", call.=FALSE)
    colnames(myc) <- var_names
  } else
    colnames(myc) <- to("X", ncol(myc), same_size=FALSE)
  rownames(myc) <- colnames(myc)

  return(myc)

}

  kurtosis <- function(x, na.rm=TRUE) {
  # SAS implementation

    if (na.rm) x <- na.omit(x)
    n <- length(x)

    if (n > 3) {

      m <- mean(x)

      kt.sum <- 0
      for (j in 1:n)
        kt.sum <- kt.sum + ( (x[j]-m)^4 )  # 4th moment

      kt.coef1 <- (n*(n+1)) / ((n-1)*(n-2)*(n-3))
      kt.coef2 <- 3 * ( ((n-1)^2) / ((n-2)*(n-3)) )
      kt <- ( kt.coef1 * (kt.sum/(var(x)^2)) ) - kt.coef2
    }

    else
      kt <- NA

    return(kt)

  }

# insert  commas  and an  and  between the elements of a character vector  
xAnd <- function(x) {

  n <- length(x)
  lt <- x[1] 
  if (n > 1) {
    if (n > 2) for (i in 2:(n)) lt <- paste(lt, ", ", x[i], sep="")
    lt <- paste(lt, "and", x[n])
  }

  return(lt)
}

simMeans <- 
function(ns, n, mu=0, sigma=1, seed=NULL, 
         show_title=TRUE, show_data=TRUE, max_data=10, 
         grid="grey90", ylim_bound=NULL, pause=FALSE,
         sort=NULL, set_mu=FALSE, digits_d=2,
         main=NULL, pdf_file=NULL, width=5, height=5, ...) {


  if (missing(ns)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the number of samples, each of a given size, with:  ns\n\n")
  }

  if (missing(n)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the size of each sample, the number of data values, with:  n\n\n")
  }

  if (sigma < 0) { 
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Standard deviation, sigma, cannot be negative.\n\n")
  }

  if (is.null(sort)) if (pause) sort <- FALSE else sort <- TRUE

  if (set_mu) {
    mu <- sample(0:100, size=1)
    sigma <- sample(1:25, size=1)
  }
   
  if (!set_mu && !pause) {
    cat("\nPopulation mean, mu:", mu, "\n")
    cat("Pop std dev, sigma :", sigma, "\n")
  }
  cat("\nNumber of samples  :", ns, "\n")
  cat("Size of each sample:", n, "\n")
   
  # data generation
  if (!is.null(seed)) set.seed(seed)
  data.raw <- rnorm(ns*n, mu, sigma)
  data.rep <- matrix(data.raw, ns, n)

  # summary stats
  Ymean <- apply(data.rep, 1, mean)
  Ysd <- apply(data.rep, 1, sd)
  max.Y <- max(Ymean)
  min_Y <- min(Ymean)

  # sort
  if (sort) {
    o <- order(Ymean)
    Ymean <- Ymean[o]
    Ysd <- Ysd[o]
    data.rep <- data.rep[o,]
  }
  else o <- 1:ns

  # keep mu centered with symmetric upper and lower limits on y-axis
  if (is.null(ylim_bound)) {
    l <- min_Y
    u <- max.Y
    max.dev <- max( abs(mu-l), abs(u-mu) )
    l <- mu - max.dev
    u <- mu + max.dev
  }
  else {
    l <- mu - ylim_bound
    u <- mu + ylim_bound
  }


  # plot 

  # set up graphics system

  if (!is.null(pdf_file)) {
    if (!grepl(".pdf", pdf_file)) pdf_file <- paste(pdf_file, ".pdf", sep="")
    .opendev(pdf_file, width, height)
  }

  orig.params <- par(no.readonly=TRUE)
  par(mar=c(3,3,1.75,2), mgp=c(1.75,.5,0))

  base::plot(0, type = "n", xlim=c(1,ns), ylim = c(l,u),
             xlab="", ylab="Sample Mean", cex.main=.95, cex.axis=.8)

  # background color
  usr <- par("usr")
  rect(usr[1], usr[3], usr[2], usr[4],
       col=getOption("panel_fill"), border="transparent")

  # box around plot
  rect(usr[1], usr[3], usr[2], usr[4],
    col="transparent", border=getOption("panel_color"),
    lwd=getOption("panel_lwd"), lty=getOption("panel_lty"))

  # grid lines
  vx <- pretty(c(usr[1],usr[2]))
  vy <- pretty(c(usr[3],usr[4]))
  abline(v=seq(vx[1],vx[length(vx)],vx[2]-vx[1]), col=grid, lwd=.5)
  abline(h=seq(vy[1],vy[length(vy)],vy[2]-vy[1]), col=grid, lwd=.5)

  if (!set_mu && !pause) {
    if (show_title)
      title(main = bquote(paste(mu, "=", .(mu), "  ",
            sigma, "=", .(sigma), "  ", "  n=", .(n))), cex.main=1)
    mtext(bquote(paste(" ", mu)), side=4, cex=1.5, col="darkslateblue", las=2)
    abline(h=mu, col="darkslateblue", lwd=1.5) # horizontal centerline at mu
  }

  # directions
  if (pause) cat("\n>>> Press Enter to obtain the next sample <<< \n\n")

  # get maximum length of each field 
  max.ln <- 0
  for (i in 1:ns) {
    nc <- nchar(as.character(round(Ymean[i],3)))
    if (nc > max.ln) max.ln <- nc
  }
  max.ln <- max.ln + 2

  # output
  if (n <= max_data) maxd <- n else maxd <- max_data
  cat("\nSample", "  Mean   ", "  SD   ")
  if (show_data)
    for (i in 1:maxd)
      cat(format(toString(i), width=max.ln, justify="right", sep=""))
  cat("\n")

  if (!pause) {
    if (show_title)
      title(main = bquote(paste(mu, "=", .(mu), "  ",
            sigma, "=", .(sigma), "  ", "  n=", .(n))), cex.main=1)
    mtext(bquote(paste(" ", mu)), side=4, cex=1.5, col="darkslateblue", las=2)
    abline(h=mu, col="gray75", lwd=1.5) # horizontal centerline at mu
  }

  for (i in 1:ns) {
    if (pause) return(invisible(readline()))
    cat(format(o[i], width=5, justify="right", sep=""))
    cat(format(sprintf("%.*f", digits_d, Ymean[i]), width=max.ln,
               justify="right", sep=""))
    cat(format(sprintf("%.*f", digits_d, Ysd[i]), width=max.ln,
               justify="right", sep=""))
    cat("   ")
    if (show_data) for (j in 1:maxd) 
      cat(format(sprintf("%.*f", digits_d, data.rep[i,j]), width=max.ln,
          justify="right", sep=""))
    if (n > max_data) cat(" ...")
    cat("\n")
    points(i, Ymean[i], pch=21,
           col=getOption("pt_color"), bg=getOption("pt_fill"))
  }


  if (pause) cat("\n")

  cat("\nAnalysis of Sample Means\n")
  cat("   Mean:", format(sprintf("%.*f", digits_d, mean(Ymean)), width=max.ln,
      justify="right", sep=""), "\n")
  cat("Std Dev:", format(sprintf("%.*f", digits_d, sd(Ymean)), width=max.ln,
      justify="right", sep=""))
  cat("    Direct estimate of the standard error of the sample mean\n")

  if (pause) {
    mu <<- mu
    sigma <<- sigma 
  }

  cat("\n")

  par(orig.params)

  # terminate pdf graphics system
  if (!is.null(pdf_file)) {
    dev.off()
    .showfile(pdf_file, "mean plot")
  }

}

simFlips <-
function(n, prob=.5, seed=NULL,
         show_title=TRUE, show_flips=TRUE,
         grid="grey90", pause=FALSE,
         main=NULL, pdf_file=NULL, width=5, height=5, ...) {


  if (missing(n)) {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "Specify the number of flips with:  n\n\n")
  }

  if (!is.null(pdf_file))
    if (!grepl(".pdf", pdf_file)) pdf_file <- paste(pdf_file, ".pdf", sep="")

  # set up graphics system
  if (!is.null(pdf_file)) {
    if (!grepl(".pdf", pdf_file)) pdf_file <- paste(pdf_file, ".pdf", sep="")
    .opendev(pdf_file, width, height)
  }

  # plot the individual flips and the running mean
  orig.params <- par(no.readonly=TRUE)
  par(mar=c(3,3,1.5,3.5), mgp=c(1.75,.5,0))

  base::plot(0, type="n", xlim=c(1,n), ylim=c(0,1), xlab="Number of Flips", 
       ylab="Estimate", cex.lab=0.8, cex.axis=0.7)

  # color the plot region between the axes
  usr = par("usr")
  rect(usr[1], usr[3], usr[2], usr[4], col="ghostwhite", border="black")

  # grid lines
  vy <- pretty(c(usr[3],usr[4]))
  abline(h=seq(vy[1],vy[length(vy)],vy[2]-vy[1]), col=grid, lwd=.5)

  abline(h=prob, col="lightsteelblue", lwd=2)

  # do the n coin flips and calculate the running mean, ybar
  if (!is.null(seed)) set.seed(seed)
  flips = rbinom(n, 1, prob)  # flip one coin n times
  ybar <- cumsum(flips)/(1:n)

  if (!pause) {
    lines(ybar, type="l", lwd=3, col="gray40")
    if (show_flips) 
      points(1:n, flips, col="lightsteelblue", pch=23, bg="darkblue", cex=.7)
  }
  else {
    if (pause) cat("\n>>> Press Enter to obtain the next sample <<< \n\n")
    for (i in 1:(n)) {
      if (show_flips)
        points(i, flips[i], col="lightsteelblue", pch=23, bg="darkblue", cex=.7)
      return(invisible(readline()))
      segments(i, ybar[i], i+1, ybar[i+1], lwd=3, col="gray40")
    }

  }

  if (show_title) {
    mainlabel <- paste("Sample Mean after", toString(n), "Coin Flips:",
      toString(.fmt(ybar[n],3)), sep=" ")
    title(main=mainlabel, cex.main=.85)
  }
  n.heads <- sum(flips)
  mtext(bquote(paste(" ", mu, "=", .(prob))), side=4, cex=.85,
        col="darkslateblue", las=2, at=c(prob))
  mtext(bquote(paste(" ", .(n.heads), " Heads")), side=4, cex=.7, las=2, at=c(1))
  mtext(bquote(paste(" ", .(n-n.heads), " Tails")), side=4, cex=.7, las=2, at=c(0))

  # terminate pdf graphics system
  if (!is.null(pdf_file)) {
    dev.off()
    .showfile(pdf_file, "coin flips")
  }

}

.OneGraph <-
function(YA, bw1, Ynm, digits_d, brief,
         n1, m1, mu, mdiff, sw, smd, mmd, msmd,
         clpct, tvalue, pvalue, ub, lb, x.lab, alt, show_title,
         full_curve=TRUE, quiet=FALSE, fill=NULL) {

  dYA <- suppressWarnings(density(YA, bw1))

  if (!brief && !quiet) {
    cat("\n\n------ Graphics Smoothing Parameter ------\n\n")
    mytitle <- "Density bandwidth for "
    cat(mytitle, .fmt(dYA$bw,digits_d), sep="", "\n")
  }

  # values needed for graph
  if (full_curve) {
    min.x <- min(min(dYA$x), mu)
    max.x <- max(max(dYA$x), mu)
  } else {
    min.x <- min(min(YA, na.rm = TRUE), mu)
    max.x <- max(max(YA, na.rm = TRUE), mu)
  }
  max.y <- max(dYA$y)  # max y coordinate
  max.y <- max.y+.1*max.y  # allow room in graph region for d info

  # colors
  if (!grepl("gray", getOption("theme"))) {
    clr.v  <- .color_range(.get_fill(), 1)[1]
    c1     <- as.vector(col2rgb(clr.v) / 255)
    col.1  <- rgb(c1[1], c1[2], c1[3])
    col.1t <- rgb(c1[1], c1[2], c1[3], alpha = .7)
    col.1d <- rgb(c1[1], c1[2], c1[3], alpha = .2)
    col.m1 <- rgb(.71,.65,.65)
  }
  else {
    col.1  <- rgb(.40,.40,.40)
    col.1t <- rgb(.40,.40,.40, alpha = .7)
    col.1d <- rgb(.40,.40,.40, alpha = .2)
    col.m1 <- rgb(.40,.40,.40)
  }
# col.2 <- rgb(.49,.56,.69)
  col.2 <- "gray30"

  if (!is.null(fill)) {
    c1 <- as.vector(col2rgb(fill[1]) / 255)
    col.1  <- rgb(c1[1], c1[2], c1[3])
    col.1t <- rgb(c1[1], c1[2], c1[3], alpha = .7)
    col.1d <- rgb(c1[1], c1[2], c1[3], alpha = .2)
  }

  col.tx <- getOption("lab_color")
# col.ln <- getOption("bar_color")
  col.ln <- "gray50"


  # ------------------------------ 
  orig.params <- par(no.readonly=TRUE)
  on.exit(par(orig.params))
  par(bg=getOption("window_fill"))
  par(mar=c(4.1,1.5,8,.4), mgp=c(3,.6,0), cex=.8, cex.lab=1.2)

  plot.new()
  plot.window(xlim=c(min.x,max.x), ylim=c(0,max.y))

  ax <- .axes_dim()  # get axis value parameters
  adj <- .RSadj(axis_size=ax$axis_x_size); axis_x_size <- adj$axis_size * 1.2
  axT1 <- pretty(c(min.x, max.x))
  .axes(NULL, NULL, axT1, NULL)
# axis(1, col=getOption("axis_x_color"), col.axis=getOption("lab_color"),
#             cex.axis=axis_x_size)
  box(col=getOption("panel_color"))
  if (length(x.lab) == 1)
    xl <- x.lab
  else
    xl <- x.lab[4]  # variable labels have italics, multiple entries
  if (nchar(xl) > 52) xl <- paste(substr(xl,1,50), "...")
  title(xlab=xl, col.lab=col.tx, cex.lab=axis_x_size*1.2)

  ybot <- par("usr")[3]  # bottom of graph
  ytop <- par("usr")[4]  # height of graph

  # vertical line for mean
  lines(c(m1,m1), c(0,ytop), lty="solid", lwd=.85, col=col.m1)
  if (!grepl("gray", getOption("theme")))
    lines(c(mu,mu), c(0,ytop), lty="twodash", lwd=.85, col=col.2)
  else
    lines(c(mu,mu), c(0,ytop), lty="twodash", lwd=.85, col=col.1)

  # curve area
  polygon(c(min(dYA$x),dYA$x,max(dYA$x)), c(0,dYA$y,0), col=col.1d, border=NA) 

  # bottom border of density curve  
  segments(min(dYA$x), 0, max(dYA$x), 0, col=col.1)

  # density curve
  lwd.border <- 1.75
  if (.Platform$OS == "windows") lwd.border <- 2
  lines(dYA, col=col.1t, lty="solid", lwd=lwd.border)

  # minimum mean difference of practical importance
  col.e <- getOption("lab_color")  # color for effect
  if ( !is.null(mmd) || !is.null(msmd) ) {
    if (!is.null(mmd)) msmd <- mmd / sw
    else if (!is.null(msmd)) mmd <- msmd * sw
    mid <- (m1 + mu) / 2
    lr <- mid + .5*mmd  # line right
    ll <- mid - .5*mmd  # line left
    lines(c(lr,lr), c(ybot+.44*max.y,ytop-.44*max.y), lty="solid", lwd=2,
          col=col.e)
    lines(c(ll,ll), c(ybot+.44*max.y,ytop-.44*max.y), lty="solid", lwd=2,
          col=col.e)
    text(mid, ybot+.41*max.y, label=toString(.fmt(mmd,2)), col=col.e)
    text(mid, ytop-.41*max.y, label=toString(.fmt(msmd,2)), col=col.e)
    text(mid, ybot+.38*max.y, label="mmd", col=col.e)
    text(mid, ytop-.375*max.y, label="msmd", col=col.e)
  }

  # scale for s at top of graph
  mlow <- min(m1, mu)
  mhi  <- max(m1, mu)
  col.d.unit <- "gray50"
  # connect first seg to top
  segments(mlow, max.y-.01*max.y, mlow, ytop, lwd=1, col=col.d.unit) 
  # provide at least 2 labeled d units on sd scale at top
  max.i <- max(ceiling(abs(smd)), 2)
  last.coord.x <- mlow  # initialise; overwritten each loop iteration
  for (i in 0:max.i) {  # sd scale at top
    x.i <- mlow+i*sw
    # sd units
    segments(x.i, max.y+.025*max.y, x.i, ytop, col=col.d.unit, lwd=1)
    # d units counted
    text(x.i, max.y+.01*max.y, labels=i)
    # horiz bar connects endpoints
    segments(mlow, ytop, x.i, ytop, col=col.d.unit, lwd=3)
    last.coord.x <- x.i
  }
  # connect last seg to top
  segments(last.coord.x, max.y+.025*max.y, last.coord.x, ytop, lwd=1,
           col=col.d.unit)
  # print d value towards top
  text((m1+mu)/2, ytop-.07*max.y, label=.fmt(smd), col=col.d.unit, cex=.9)
  # horiz bar connects means
  segments(mlow, ytop-.09*max.y, mhi, ytop-.09*max.y, col=col.d.unit, lwd=1)
  # print d towards top
  text((m1+mu)/2, ytop-.11*max.y, label="d", col=col.d.unit, cex=.9)

  # print mdiff value towards bottom  
  text((m1+mu)/2, ybot+.11*max.y, label=.fmt(mdiff, digits_d), col=col.d.unit,
        cex=.9)
  # horiz bar connects means
  segments(mlow, ybot+.09*max.y, mhi, ybot+.09*max.y, col=col.d.unit, lwd=1)
  # print diff towards bottom
  text((m1+mu)/2, ybot+.07*max.y, label="diff", col=col.d.unit, cex=.9)

  # title area, above graph
  if (show_title) {
    mtext(paste("One-Group Plot with Mean and Null Mean"), side=3, line=6.6,
                font=2, col=col.tx)
    mtext(paste("Analyze",Ynm), side=3, line=5.4, font=3, cex=.9,
          col=col.tx)
    txt <- ifelse (alt == "two.sided", "", " One-tailed")
    classic <- paste(txt, "Classic t-test of mu: ")
    mtext(bquote(paste(" ", .(classic), .(mu), ":   t = ", .(.fmt(tvalue,3)), 
      ",  df = ", .(n1-1), ",   p-value = ", .(.fmt(pvalue,3)))), side=3, 
      line=3.7, cex=.9, adj=0, col=col.tx)
    mtext(bquote(paste("  ",.(clpct), " Confidence Interval for Mean:  ",
      .(.fmt(lb,3)), " to ", .(.fmt(ub,3)))), side=3, line=2.6, cex=.9, adj=0,
          col=col.tx)
    mtext(bquote(paste("  ", "n=", .(n1),
       "   m=", .(.fmt(m1, digits_d)),"   s=", .(.fmt(sw, digits_d)),
       "   d=", .(.fmt(smd, digits_d)))),
       side=3, line=1.3, cex=.9, adj=0, col=col.tx)
  }

  if (.allow.interactive()) {
    plt <- suppressWarnings(dn.plotly(
      x          = YA,
      x_name     = Ynm,
      fill       = col.1,
      x_lab      = xl,
      y_lab      = "Density",
      ax         = NULL,
      bw         = bw1,
      full_curve = full_curve,
      style_opts = .plotly_style()
    ))
    y.mu <- approx(dYA$x, dYA$y, xout=mu, rule=2)$y
    plt <- plotly::add_trace(plt,
      x          = c(mu, mu),
      y          = c(0, y.mu),
      showlegend = FALSE,
      line       = list(color=col.1, width=1.4, dash="dash"),
      hoverinfo  = "skip"
    )
    print(plt)
  }

}

.ss.data.frame <-
function(x, n_cat, brief, ...)  {

  for (i in 1:ncol(x)) {
    cat("\n\n")

    nu <- length(unique(na.omit(x[,i])))

    x.name <- names(x)[i]
    options(xname = x.name)

    if (is.numeric(x[,i]) && nu > n_cat) {
      stuff <- .ss.numeric(x[,i], brief=brief, ...)
      txsts <- stuff$tx
      txotl <- .bx.stats(x[,i])$txotl
      class(txsts) <- "out"
      class(txotl) <- "out"
      output <- list(out_stats=txsts, out_outliers=txotl)
      class(output) <- "out_all"
      print(output)
    }

    else if (is.factor(x[,i]) || is.character(x[,i]) ||
             (.is.num.cat(x[,i], n_cat))) {
      gl <- .getlabels()
      x.name <- gl$xn; x.lab <- gl$xb; x.lbl <- gl$xl
      stats <- .ss.factor(x[,i], x.name=x.name, x.lbl=x.lbl, ...)
      txttl <- stats$title
      counts <- stats$counts
      chi <- stats$chi
      class(txttl) <- "out"
      class(counts) <- "out"
      class(chi) <- "out"
      output <- list(out_title=txttl, out_counts=counts, out_chi=chi)
      class(output) <- "out_all"
      print(output)      

      if (is.numeric(x[,i]) && nu <= n_cat)
        cat("\n>>> Variable is numeric, but only has", nu, "<= n_cat =", n_cat, "levels,",
        "so treat as categorical.\n",
        "   To obtain the numeric summary, decrease  n_cat  to indicate a lower\n",
        "   number of unique values such as with function: set.\n", 
        "   Perhaps make this variable a factor with the R factor function.\n")
    }

    else cat("\n>>> The following type of variable not processed: ", 
             class(x[,i]), "\n")

  }

}

.ANOVAz1 <- 
function(av.out, y.values, x.values, nm, n.keep, jitter_x, digits_d,
         brief, graphics, pdf, width, height) {

  p <- length(unique(na.omit(x.values)))

  # cell stats
  n <- tapply(y.values, x.values, function(v) sum(!is.na(v)))
  m <- tapply(y.values, x.values, mean, na.rm=TRUE)
  s <- tapply(y.values, x.values, sd,   na.rm=TRUE)
  mn <- tapply(y.values, x.values, min,  na.rm=TRUE)
  mx <- tapply(y.values, x.values, max,  na.rm=TRUE)

  # get maximum chars in 1st three columns
  max.lv <- 0; max.n <- 0; max.m <- 0; max.s <- 0; max.mn <- 0; max.mx <- 0
  for (i in seq_len(p)) {
    nch.lv <- nchar(as.character(levels(x.values)[i]))
    nch.n <- nchar(as.character(n[i]))
    nch.m <- nchar(.fmt(m[i],digits_d))
    nch.s <- nchar(.fmt(s[i],digits_d))
    nch.mn <- nchar(.fmt(mn[i],digits_d))
    nch.mx <- nchar(.fmt(mx[i],digits_d))
    if (nch.lv > max.lv) max.lv <- nch.lv
    if (nch.n > max.n) max.n <- nch.n
    if (nch.m > max.m) max.m <- nch.m
    if (nch.s > max.s) max.s <- nch.s
    if (nch.mn > max.mn) max.mn <- nch.mn
    if (nch.mx > max.mx) max.mx <- nch.mx
  }

  title_des <- "\n  DESCRIPTIVE STATISTICS "

  tx <- character(length = 0)

  n.tx <- format("n", width=max.lv+max.n+2, justify="right", sep="")
  m.tx <- format("mean", width=max.m+2, justify="right", sep="")
  s.tx <- format("sd", width=max.s+2, justify="right", sep="")
  mn.tx <- format("min", width=max.mn+2, justify="right", sep="")
  mx.tx <- format("max", width=max.mx+2, justify="right", sep="")
  tx[length(tx)+1] <- paste(n.tx, m.tx, s.tx, mn.tx, mx.tx)

  for (i in seq_len(p)) {
    xval <- paste(format(levels(x.values)[i], width=max.lv, justify="left", sep="")) 
    nn <- format(n[i], width=max.n+1, justify="right", sep="") 
    mm <- format(sprintf("%.*f", digits_d, m[i]), width=max.m+2, justify="right") 
    ss <- format(sprintf("%.*f", digits_d, s[i]), width=max.s+2, justify="right") 
    mnn <- format(sprintf("%.*f", digits_d, mn[i]), width=max.mn+2, justify="right") 
    mxx <- format(sprintf("%.*f", digits_d, mx[i]), width=max.mx+2, justify="right") 
    tx[length(tx)+1] <- paste(xval, nn, mm, ss, mnn, mxx) 
  }

  mg <-  mean(y.values, na.rm=TRUE)
  tx[length(tx)+1] <- ""
  tx[length(tx)+1] <- paste("Grand Mean:", round(mg, digits_d+1))

  txdes <- tx


  title_basic <- "\n  ANOVA"

  tx <- character(length = 0)

  if (is.null(options()$knitr.in.progress)) {
    tx[length(tx)+1] <- paste("-- Summary Table for", nm[1])
    tx[length(tx)+1] <- ""
  }

  n.vars <- 2
  smc <- anova(av.out)

  # width of column 1
  max.c1 <- max(nchar("Residuals"), nchar(nm[2]))
  for (i in seq_len(n.vars)) {
    c1 <- nchar(rownames(smc)[i])
    if (c1 > max.c1) max.c1 <- c1 
  }

  # width of data columns
  max.ln <- integer(length=0)
  for (i in seq_len(4)) {
    ln.nm <- nchar(colnames(smc)[i])
    max.ln[i] <- ln.nm + 1
    for (j in seq_len(nrow(smc))) {
      xjc <- .fmt(smc[j,i], d=digits_d)
      if (nchar(xjc) > max.ln[i]) max.ln[i] <- nchar(xjc)
    }
    max.ln[i] <- max.ln[i] + 1L
    if (max.ln[i] < 9L) max.ln[i] <- 9L
  }

  df.lbl <- .fmtc("     df", max.ln[1]+1)
  SS.lbl <- .fmtc(" Sum Sq", max.ln[2]+1)
  MS.lbl <- .fmtc("Mean Sq", max.ln[3]+1)
  fv.lbl <- .fmtc("F-value", max.ln[4]+1)
  tx[length(tx)+1] <- paste(format("", width=max.c1-4), df.lbl, SS.lbl,
                             MS.lbl, fv.lbl, "   p-value", sep="")

  for (i in seq_len(n.vars)) {
    rlb <- .fmtc(rownames(smc)[i], max.c1, j="left")
    df <- format(sprintf("%i", smc[i,1]), width=max.ln[1]-4, justify="right")
    SS <- format(sprintf("%7.*f", digits_d, smc[i,2]), width=max.ln[2],
                 justify="right")
    MS <- format(sprintf("%7.*f", digits_d, smc[i,3]), width=max.ln[3],
                 justify="right")
    if (i < n.vars) {
      fv <- format(sprintf("%7.*f", digits_d, smc[i,4]), width=9,
                   justify="right")
      pv <- format(sprintf("%6.4f", smc[i,5]), width=9, justify="right")
      tx[length(tx)+1] <- paste(rlb, df, SS, MS, fv, pv)
    }
    else
      tx[length(tx)+1] <- paste(rlb, df, SS, MS)
    }

  sm <- summary(av.out)
  ssb <- sm[[1]][1,2]
  ssw <- sm[[1]][2,2]
  sst <- ssb + ssw
  msw <- sm[[1]][2,3]

  txanv <- tx


  tx <- character(length = 0)

  if (is.null(options()$knitr.in.progress)) {
    tx[length(tx)+1] <- paste("-- Association and Effect Size for", nm[1])
    tx[length(tx)+1] <- ""
  }

  rsq <- ssb / sst
  tx[length(tx)+1] <- paste("R Squared:", .fmt(rsq, 3))
  rsq.adj <-  1 - ( ((n.keep-1)/(n.keep-p)) * (1-rsq) )
  tx[length(tx)+1] <- paste("R Sq Adjusted:", .fmt(rsq.adj, 3))
  omsq <- (ssb - ((p-1)*msw)) / (sst + msw)
  tx[length(tx)+1] <- paste("Omega Squared:", .fmt(omsq, 3))
  if (omsq > 0) {
    tx[length(tx)+1] <- ""
    f.cohen <- sqrt( (omsq/(1-omsq)) )
    tx[length(tx)+1] <- paste("\nCohen's f:", .fmt(f.cohen, 3))
  }

  txeft <- tx

  # keep track of the number of plots for 2 windows, see if manage graphics
  plt.i <- 0
  plt.title  <- character(length=0)
  if (graphics) {
      manage.gr <- .graphman()
  }

  txhsd <- ""
  title_tukey <- "\n  TUKEY MULTIPLE COMPARISONS OF MEANS"
  if (!brief) {
    tx <- character(length = 0)

    HSD <- TukeyHSD(av.out, which=nm[2])
    tx[length(tx)+1] <- paste("Family-wise Confidence Level:",
                              attributes(HSD)$conf.level)
    txHSD <- .prntbl(HSD[[1]], digits_d)
    for (i in seq_along(txHSD)) tx[length(tx)+1] <- txHSD[i]

    txhsd <- tx


    if (graphics) {

      # get left margin size
      mnc <- max(nchar(levels(x.values)))  # 1st highest nchar
      wm.ind <- which.max(nchar(levels(x.values)))
      xv <- levels(x.values)[-wm.ind]
      mnc.xv <- max(nchar(xv))  # 2nd highest nchar
      tot <- mnc + mnc.xv
      lm <- 3.2 + (0.27 * tot)
      if (lm < 2.8) lm <- 2.8

      orig.params <- par(no.readonly=TRUE)
      on.exit(par(orig.params), add=TRUE)
      par(mar=c(5.1,lm,4.1,1.5))

      if (!pdf) { 
        if (manage.gr) dev.set(which=4) 
      }
      else { 
        pdf_file <- "ANOVA_HSD.pdf"
        pdf(file=pdf_file, width=width, height=height)
      }

      plt.i <- plt.i + 1
      plt.title[plt.i] <- "95% family-wise confidence level"

      plot(HSD, cex.axis=0.8, col.axis="gray30", las=1)

      if (pdf) {
        dev.off()
        .showfile(pdf_file, "Tukey HSD chart")
        tx[length(tx)+1] <- ""
      }
    }  # end graphics
  }  # !brief

  # scatterplot with cell means
  if (graphics) {
    if (!pdf) {
      if (manage.gr) {
        if (!brief) .graphwin(2) else .graphwin(1)
        dev.set(which=3)
      }
    }
    else { 
      pdf_file <- "ANOVA_Means.pdf"
      pdf(file=pdf_file, width=width, height=height)
    }

    plt.i <- plt.i + 1
    plt.title[plt.i] <- "Scatterplot with Cell Means"

    # set margins
    max.width <- strwidth(as.character(max(pretty(y.values))), units="inches")
    margs <- .plt.marg(max.width, y.lab=nm[1], x.lab=nm[2], main=NULL, sub=NULL)
    lm <- margs$lm + 0.075
    tm <- margs$tm
    rm <- margs$rm
    bm <- margs$bm + 0.1
    
    orig.params <- par(no.readonly=TRUE)
    on.exit(par(orig.params), add=TRUE)
    par(bg=getOption("window_fill"))
    par(mai=c(bm, lm, tm, rm))

    # scatter plot
    plot(x.values, y.values, type="n", axes=FALSE, ann=FALSE)
    axT1 <- seq_len(length(unique(x.values)))
    .plt.bck(par("usr"), axT1, axTicks(2))
    .axes(levels(x.values), NULL, axT1, axTicks(2))
    .axlabs(nm[2], nm[1], main.lab=NULL, sub.lab=NULL,
            xlab_adj=0.4, ylab_adj=.05) 
    xn.values <-  data.frame(  # factor to integer for jitter
        levels(x.values), seq_along(levels(x.values)), row.names=1)[x.values, 1]
    xn.values <- jitter(xn.values, factor=jitter_x)
    points(xn.values, y.values, pch=21, 
           col=getOption("pt_color"), bg=getOption("pt_fill"), cex=0.7)

    # plot cell means
    pch.avg <- if (getOption("theme")!="gray") 21 else 23
    bck.g <- if (getOption("theme")!="gray") rgb(140,90,70,
                    maxColorValue=255) else "gray40"
    if (grepl(".black", getOption("theme"), fixed=TRUE)) bck.g <- "gray85"
    m.lvl <- tapply(y.values, x.values, mean, na.rm=TRUE)
    abline(h=m.lvl, col="gray50", lwd=.5)
    points(m.lvl, pch=pch.avg, bg=bck.g, col="transparent", cex=1.3)

    if (pdf) {
      dev.off()
      .showfile(pdf_file, "scatterplot and means chart")
    }
  }  # graphics scatterplot

  pv <- smc[1,5]

  return(list(
    title_des=title_des, txdes=txdes,
    title_basic=title_basic,
    title_tukey=title_tukey,
    txanv=txanv, txeft=txeft, txhsd=txhsd, pv=pv,
    i=plt.i, ttl=plt.title))

}

.regKfold <-
function(data, my_formula, kfold, new_scale, scale_response, nm,
         predictors, n.vars, n.keep, seed, digits_d=NULL, show_R) {


  if (kfold < 2)  {
    cat("\n"); stop(call.=FALSE, "\n","------\n",
      "kfold must be 2 or larger.\n\n")
  }

  # create needed dummy variables
  data <- na.omit(data)
  d.new = data.frame(row.names=row.names(data))
  for (i in seq_len(ncol(data))) {
    nm.var <- names(data)[i]
    if (is.character(data[,i])) data[,i] <- factor(data[,i])  
    if (is.factor(data[,i])) {
      cnt <- data.frame(contrasts(data[,i]))
      rn <- rownames(cnt)
      for (i.nm in seq_along(names(cnt)))  # dummy vars
        names(cnt)[i.nm] <- paste(nm.var, "_", names(cnt)[i.nm], sep="")
      nm.dmm <- names(cnt)
      cnt <- cbind(x=rn, cnt) 
      names(cnt)[1] <- nm.var
      d.mrg <- merge(data, cnt, by=nm.var, all.x=TRUE)
      d.mrg <- d.mrg[, which(names(d.mrg) %in% nm.dmm), drop=FALSE]
      names(d.mrg) <- nm.dmm
     d.new <- cbind(d.new, d.mrg)
    }  # end is.factor
    else { 
      d.new[,ncol(d.new) + 1] <- data[,i]
      names(d.new)[ncol(d.new)] <- nm.var
    }
  }  # i in 1:ncol(data)


  # train/test split
  dd <- d.new  # store original in case rescaling each fold
  nm <- names(dd)

  tx <- character(length = 0)

  # training data indices
  t_n <- integer(length=kfold)
  t_se <- double(length=kfold)
  t_MSE <- double(length=kfold)
  t_Rsq <- double(length=kfold)

  # testing data indices
  k_n <- integer(length=kfold)
  k_se <- double(length=kfold)
  k_MSE <- double(length=kfold)
  k_Rsq <- double(length=kfold)

  # -------------------------------------------
  # training and testing analysis for each fold

  if (is.null(digits_d)) digits_d <- 3

  # build formula once from the dummy-expanded dd
  predictors <- names(dd)[2:ncol(dd)]
  prdt <- paste(.bt(predictors), collapse = "+")
  ex <- paste(.bt(names(dd)[1]), "~", prdt)
  my_formula <- as.formula(ex)

  # define folds on the basis of the remainders of the
  #   scrambled integers of the row numbers of the data
  if (!is.null(seed)) set.seed(seed)
  nk <- sample(seq_len(n.keep), n.keep, replace=FALSE) %% kfold

  for (i.fold in seq_len(kfold)) {
    train <- which(nk != (i.fold-1)) # combine all other folds
    test <- which(nk == (i.fold-1))  # one test fold

    # separate rescaling for train and test data
    if (new_scale != "none") {
      i.start <- ifelse (scale_response, 1, 2)
      for (j in i.start:n.vars)  {
        unq.x <- length(unique(dd[,nm[j]])) 
        if (unq.x > 2  &&  is.numeric(dd[,nm[j]])) {
          dd[train,nm[j]] <- rescale(dd[train,nm[j]], data=NULL,
                                  kind=new_scale, digits_d)
          dd[test,nm[j]] <- rescale(dd[test,nm[j]], data=NULL,
                                  kind=new_scale, digits_d)
        }
      }  # end for (j in i.start:n.vars)
    }  # end new_scale != "none"

    # training data analysis
    lm.sol <- lm(my_formula, data=dd[train, ])
    t_n[i.fold] <- nrow(lm.sol$model)
    anv.sol <- anova(lm.sol)
    t_MSE[i.fold] <- anv.sol[nrow(anv.sol),3]
    smry.sol <- summary(lm.sol)
    t_Rsq[i.fold] <- smry.sol$r.squared
    t_se[i.fold] <- smry.sol$sigma
    est <- smry.sol$coefficients[,1]
    coefs = as.matrix(est)
    
    # testing data analysis
    d_test = na.omit(dd[test, nm])
    k_n[i.fold] <- nrow(d_test)
    y <- d_test[, nm[1], drop=FALSE]
    y <- data.matrix(y)
    X <- d_test[, predictors, drop=FALSE]
    X <- data.matrix(cbind(1, X))

    if (nrow(coefs) != ncol(X))  {
      cat("\nMatrix of estimated coefficients in test data\n")
      colnames(coefs) <- "Coefficients"
      print(coefs)
      cat("\nVariable names:", colnames(X)[2:ncol(X)], "\n")
      cat("\n"); stop(call.=FALSE, "\n","------\n",
        "At least one variable has no test data.\n",
        "More variables than estimated coefficients.\n\n")
    }

    y_hat <- X %*% coefs
    SSE <- sum((y - y_hat)^2)
    denom <- nrow(y) - nrow(coefs)  # n_test - (p+1), matching actual coef count
    k_MSE[i.fold] <- if (denom > 0) SSE / denom else NA_real_
    k_se[i.fold] <- sqrt(k_MSE[i.fold])
    my <- mean(y)
    SSY <- sum((y - my)^2)
    k_Rsq[i.fold] <- 1 - (SSE / SSY)
  }  # end for (i.fold in 1:kfold)


  # ------------------------------------------
  # display result for each fold and the means

  # get column widths
  max.num <- integer(length=6)
  max.num[1] <- max(nchar(as.character(floor(t_se))) + digits_d + 1)
  max.num[2] <- max(nchar(as.character(floor(t_MSE))) + digits_d + 1)
  max.num[3] <- max(nchar(as.character(floor(t_Rsq))) + digits_d + 1)
  max.num[4] <- max(nchar(as.character(floor(k_se))) + digits_d + 1)
  max.num[5] <- max(nchar(as.character(floor(k_MSE))) + digits_d + 1)
  max.num[6] <- max(nchar(as.character(floor(k_Rsq))) + digits_d + 1)
  max.num[which(max.num < 6)] <- 6

  # heading labels
  buf <- .fmtc("", w = max.num[1] + max.num[2] + max.num[3] + 18)
  buf2 <- .fmtc("", w = max.num[1] + max.num[2] + max.num[3] + 13)
  buf3 <- .fmtc("", w = max.num[1] + max.num[2] + max.num[3] - 14) 
  buf4 <- .fmtc("", w = max.num[1] + max.num[2] + max.num[3] + 15)
  dash <- .fmtc("", w = max.num[4] + max.num[5] + max.num[6] + 6)
  dash <- gsub(" ", "-", dash, fixed=TRUE)

  tx[length(tx)+1] <- paste("       ",
       "Model from Training Data", buf3,
       "Applied to Testing Data", sep="")
  tx[length(tx)+1] <- paste(format("", width=7), dash, "   ", dash, sep="")

  t_se.lbl <- .fmtc("se", max.num[1]+1)
  t_MSE.lbl <- .fmtc("MSE", max.num[2]+1)
  t_Rsq.lbl <- .fmtc( "Rsq", max.num[3]+1)
  k_se.lbl <-  .fmtc("sp", max.num[4]+1)
  k_MSE.lbl <- .fmtc("MSE", max.num[5]+1)
  k_Rsq.lbl <- .fmtc("Rsq", max.num[6]+1)
  tx[length(tx)+1] <- paste("fold",
           "   n", t_se.lbl, t_MSE.lbl, t_Rsq.lbl,
           "     n", k_se.lbl, k_MSE.lbl, k_Rsq.lbl, sep="")

  # indices for the different folds
  mx.nch <- nchar(as.character(max(t_n)))
  for (i in seq_len(kfold)) {
    tx[length(tx)+1] <- paste(" ", i, "|", 
      .fmti(t_n[i], mx.nch),
      .fmt(t_se[i], digits_d, max.num[1]),
      .fmt(t_MSE[i], digits_d, max.num[2]),
      .fmt(t_Rsq[i], digits_d, max.num[3]), "|",
      .fmti(k_n[i], 3),
      .fmt(k_se[i], digits_d, max.num[4]),
      .fmt(k_MSE[i], digits_d, max.num[5]),
      .fmt(k_Rsq[i], digits_d, max.num[6]))
    }

  # mean testing results
  tm_se=mean(t_se)
  tm_MSE=mean(t_MSE)
  tm_Rsq=mean(t_Rsq)
  km_se=mean(k_se)
  km_MSE=mean(k_MSE)
  km_Rsq=mean(k_Rsq)

  tx[length(tx)+1] <- paste("     ", dash, "  ", dash)
  buf1 <- strrep(" ", mx.nch + 1)
  buf2 <- paste(buf1, "  ", sep="")
  tx[length(tx)+1] <- paste("Mean", buf1,
      .fmt(tm_se, digits_d, max.num[1]),
      .fmt(tm_MSE, digits_d, max.num[2]),
      .fmt(tm_Rsq,  digits_d, max.num[3]), buf2,
      .fmt(km_se, digits_d, max.num[4]),
      .fmt(km_MSE, digits_d, max.num[5]),
      .fmt(km_Rsq,  digits_d, max.num[6]))


  return(list(tx=tx, m_se=km_se, m_MSE=km_MSE, m_Rsq=km_Rsq))

}

---
title: "Introduction to lessR"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{intro}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  fig.width=5.5, fig.height=3,
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
library(lessR)
options(lessR.use_plotly = FALSE)
```

The vignette examples of using **lessR** became so extensive that the maximum R package installation size was exceeded. Find a limited number of examples below. Find many more vignette examples at:

[lessR examples](https://web.pdx.edu/~gerbing/lessR/examples/)


## Visualization Function Structure in lessR

- **`Chart()`**  
  Creates visualizations of *summarized* data, typically frequency or statistical tables from one or two categorical variables. Produces bar charts, pie charts, radar charts, stacked charts, and hierarchical displays such as sunburst and treemap diagrams. Use `Chart()` when each category or combination of categories corresponds to a numeric summary such as a count or a statistic.

- **`X()`**  
  Visualizes *a single raw variable*, numeric or categorical. Generates histograms, density curves, dot plots, boxplots, violin plots, and other univariate graphics directly from the observed data values.

- **`XY()`**  
  Displays *relationships between continuous variables*, one x-variable and one y-variable. Produces scatterplots, contour plots, line charts, bubble charts, time-series plots, and regression visualizations, with optional grouping and faceting.

Together, these three functions provide a unified and intuitive workflow: the structure of the input data—summarized table, single variable, or paired variables—naturally determines which visualization function to use, ensuring consistency and simplicity across all lessR graphics.


## Read Data

[more examples of reading and writing data files](https://web.pdx.edu/~gerbing/lessR/examples/ReadWrite.html)

Many of the following examples analyze data in the _Employee_ data set, included with **lessR**. To read an internal **lessR** data set, just pass the name of the data set to the **lessR** function `Read()`. Read the _Employee_ data into the data frame _d_. For data sets other than those provided by **lessR**, enter the path name or URL between the quotes, or leave the quotes empty to browse for the data file on your computer system. See the `Read and Write` vignette for more details.

```{r read}
d <- Read("Employee")
```

_d_ is the default name of the data frame for the **lessR** data analysis functions. Explicitly access the data frame with the `data` parameter in the analysis functions. 

As an option, also read the table of variable labels. Create the table formatted as two columns. The first column is the variable name and the second column is the corresponding variable label. Not all variables need be entered into the table. The table can be a `csv` file or an Excel file.

Read the file of variable labels into the _l_ data frame, currently the only permitted name. The labels will be displayed on both the text and visualization output. Each displayed label is the variable name juxtaposed with the corresponding label, as shown in the following output.

```{r labels}
l <- rd("Employee_lbl")
l
```

## Aggregation over Categories

[more examples of bar charts and pie charts](https://web.pdx.edu/~gerbing/lessR/examples/Chart.html)

Consider the categorical variable Dept in the Employee data table.  Use `Chart()` to tabulate and display the visualization of the number of employees in each department, here relying upon the default data frame (table) named _d_. Otherwise add the `data=` option for a data frame with another name.

```{r bcEx, fig.width=4, fig.height=3.5, fig.align='center', fig.cap="Bar chart of tablulated counts of employees in each department."}
Chart(Dept)
```

Specify a single fill color with the `fill` parameter, the edge color of the bars with `color`. Set the transparency level with `transparency`. Against a lighter background, display the value for each bar with a darker color using the `labels_color` parameter. To specify a color, use color names, specify a color with either its `rgb()` or `hcl()` color space coordinates, or use the **lessR** custom color palette function `getColors()`.

```{r fig.width=4, fig.height=3.75, fig.align='center'}
Chart(Dept, fill="darkred", color="black", transparency=.8,
         labels_color="black")
```

Use the `theme` parameter to change the entire color theme: "colors", "lightbronze", "dodgerblue", "slatered", "darkred", "gray", "gold", "darkgreen", "blue", "red", "rose", "green", "purple", "sienna", "brown", "orange", "white", and "light". In this example, changing the full theme accomplishes the same as changing the fill color. Turn off the displayed value on each bar with the parameter `labels` set to `off`. Specify a horizontal bar chart with base R parameter `horiz`.

```{r fig.width=4, fig.height=3.5, fig.align='center'}
Chart(Dept, theme="gray", labels="off", horiz=TRUE)
```

Or, select other perceptual forms, such as a ring chart version of a pie chart.

```{r fig.width=4, fig.height=3.5, fig.align='center'}
Chart(Dept, form="pie")
```

## Distribution

[more examples of histograms](https://web.pdx.edu/~gerbing/lessR/examples/X.html)

Consider the continuous variable _Salary_ in the Employee data table.  Use `X()` to tabulate and display the number of employees in each department, here relying upon the default data frame (table) named _d_, so the `data=` parameter is not needed.

```{r hs, fig.width=4, fig.height=3.5, fig.align='center', fig.cap="Histogram of tablulated counts for the bins of Salary."}
X(Salary)
```

By default, the `Histogram()` function provides a color theme according to the current, active theme. The function also provides the corresponding frequency distribution, summary statistics, the table that lists the count of each category, from which the histogram is constructed, as well as an outlier analysis based on Tukey's outlier detection rules for box plots.

Use the parameters `bin_start`, `bin_width`, and `bin_end` to customize the histogram.

Easy to change the color, either by changing the color theme with `style()`, or just change the fill color with `fill`. Can refer to standard R colors, as shown with **lessR** function `showColors()`, or implicitly invoke the **lessR** color palette generating function `getColors()`. Each 30 degrees of the color wheel is named, such as `"greens"`, `"rusts"`, etc, and implements a sequential color palette.

```{r binwidth, fig.width=4, fig.height=3.5, fig.align='center', fig.cap="Customized histogram."}
X(Salary, bin_start=35000, bin_width=14000, fill="reds")
```

Or, select other perceptual forms, such as an integrated violin/box/strip plot (VBS plot).

```{r, fig.width=4, fig.height=3.5, fig.align='center', fig.cap="VBS plot."}
X(Salary, form="vbs")
```


## Relation

[more examples of scatter plots and related](https://web.pdx.edu/~gerbing/lessR/examples/XY.html)

Specify an X and Y variable with the plot function to obtain a scatter plot. For two variables, both variables can be any combination of continuous or categorical. One variable can also be specified. A scatterplot of two categorical variables yields a bubble plot. Below is a scatterplot of two continuous variables. 

```{r sp, fig.width=4}
XY(Years, Salary)
```

Enhance the default scatterplot with parameter `enhance`. The visualization includes the mean of each variable indicated by the respective line through the scatterplot, the 95% confidence ellipse, labeled outliers, least-squares regression line with 95% confidence interval, and the corresponding regression line with the outliers removed. 

```{r spEnhance, fig.width=4}
XY(Years, Salary, enhance=TRUE)
```

Following is a scatterplot in the form of a bubble plot for two categorical variables.

```{r spBubble, fig.width=4}
Chart(JobSat, by=Gender, form="bubble")
```

Or, select other perceptual forms, such as a contour plot.

```{r spContour, fig.width=4}
XY(Years, Salary, form="contour")
```

And facet the contour plot.


```{r spContFacet, fig.width=4}
XY(Years, Salary, facet=Gender, form="contour")
```


## Means and Proportions

### Means
[more examples of t-tests and ANOVA](https://web.pdx.edu/~gerbing/lessR/examples/Means.html)

For the independent-groups t-test, specify the response variable to the left of the tilde, `~`, and the categorical variable with two groups, the grouping variable, to the right of the tilde.

```{r, fig.height=4.25, fig.width=5}
ttest(Salary ~ Gender)
```

Next, to analyze the operational efficiency of a weeping device, do the two way independent groups ANOVA analyzing the variable _breaks_ across levels of _tension_ and _wool_. Specify the second independent variable preceded by a `*` sign.

```{r fig.width=5}
ANOVA(breaks ~ tension * wool, data=warpbreaks)
```

For a one-way ANOVA, just include one independent variable. A randomized block design is also available.

### Proportions

[more examples of analyzing proportions](https://web.pdx.edu/~gerbing/lessR/examples/Proportions.html)

The analysis of proportions is of two primary types. 

- Focus on a single value of a categorical variable, termed a "success" when it occurs, for one or more samples of data. Analyze the resulting proportion of occurrence for a single sample, or for a test of _homogeneity_, compare proportions of successes across distinct data samples for a single variable.
- Compare the obtained proportions across the values of one or more categorical variables for a single sample. Applied to a single variable, the analysis is a _goodness-of-fit_. Or, evaluate a potential relationship between two categorical variables, a test of _independence_.

Here, just analyze the $\chi^2$ test of independence, which applies to two categorical variables. The first categorical variable listed in this example is the value of the parameter `variable`, the first parameter in the function definition, so does not need the parameter name. The second categorical variable listed must include the parameter name `by`. 

The question for the analysis is if the observed frequencies of _Jacket_ thickness and _Bike_ ownership sufficiently differ from the frequencies expected by the null hypothesis that we conclude the variables are related.

```{r}
d <- Read("Jackets")
Prop_test(Jacket, by=Bike)
```

## Regression Analysis

[more examples of regression and logistic regression](https://web.pdx.edu/~gerbing/lessR/examples/Regression.html)

The full output is extensive: Summary of the analysis, estimated model, fit indices, ANOVA, correlation matrix, collinearity analysis, best subset regression, residuals and influence statistics, and prediction intervals. The motivation is to provide virtually all of the information needed for a proper regression analysis.

```{r}
d <- Read("Employee", quiet=TRUE)
reg(Salary ~ Years + Pre)
```

As with several other **lessR** functions, save the output to an object with the name of your choosing, such as `r`, and then reference desired pieces of the output. View the names of those pieces from the manual, here obtained with `?reg`, or use the R names function, such as in the following example.

```{r}
r <- reg(Salary ~ Years + Pre)
names(r)
```

View any piece of output with the name of the output file, a dollar sign, and the specific name of that piece. Here, examine the fit indices.

```{r}
r$out_fit
```

These expressions could also be included in a markdown document that systematically reviews each desired piece of the output.

## Time Series and Forecasting

[more examples of run charts, time series charts, and forecasting](https://web.pdx.edu/~gerbing/lessR/examples/Time.html)

The time series plot, plotting the values of a variable cross time, is a special case of a scatterplot, potentially with the points of size 0 with adjacent points connected by a line segment. Indicate a time series by specifying the `x`-variable, the first variable listed, as a variable of type `Date`. Unlike Base R functions, `Plot()` automatically converts to `Date` data values as dates specified in a digital format, such as `18/8/2024` or related formats plus examples such as `2024 Q3` or `2024 Aug`. Otherwise, explicitly use the R function `as.Date()` to convert to this format before calling `Plot()` or pass the date format directly with the `ts_format` parameter.

`Plot()` implements time series forecasting based on trend and seasonality with either exponential smoothing or regression analysis, including the accompanying visualization. Time series parameters include:

- `ts_method`: Set at `"es"` for exponential smoothing, the default, or `"lm"` for linear model regression.
- `ts_unit`: The time unit, either as the natural occurring interval between dates in the data, the default, or aggregated to a wider time interval.
- `ts_ahead`: The number of time units to forecast into the future
- `ts_agg`: If aggregating the time unit, aggregate as the `"sum"`, the default, or as the `"mean"`. 
- `ts_PIlevel`: The confidence level of the prediction intervals, with 0.95 the default.
- `ts_format`: Provides a specific format for the date variable if not detected correctly by default. 
- `ts_seasons`: Set to `FALSE` to turn off seasonality in the estimated model.
- `ts_trend`: Set to `FALSE` to turn off trend in the estimated model.
- `ts_type`: Applies to exponential smoothing to specify additive or multiplicative seasonality, with additive the default.

In this `StockPrice` data file, the date conversion as already been done.


```{r}
d <- Read("StockPrice")
head(d)
```

We have the date as _Month_, and also have variables _Company_ and stock _Price_.

```{r}
d <- Read("StockPrice")
Plot(Month, Price, filter=(Company=="Apple"), ts_area_fill="on")
```


With the `by` parameter, plot all three companies on the same panel.

```{r}
Plot(Month, Price, by=Company)
```

Here, aggregate the mean by time, from months to quarters.


```{r}
Plot(Month, Price, ts_unit="quarters", ts_agg="mean")
```

`Plot()` implements exponential smoothing or linear regression with seasonality forecasting with accompanying visualization. Parameters include `ts_ahead` for the number of `ts_units` to forecast into the future, and `ts_format` to provide a specific format for the date variable if not detected correctly by default. Parameter `ts_method` defaults to `es` for exponential smoothing, or set to `lm` for linear regression. Control aspects of the exponential smoothing estimation and prediction algorithms with parameters `ts_level` (alpha), `ts_trend` (beta), `ts_seasons` (gamma), `ts_type` for additive or multiplicative seasonality, and `ts_PIlevel` for the level of the prediction intervals.

To forecast Apple's stock price, focus here on the last several years of the data, beginning with Row 400 through Row 473, the last row of data for apple. In this example, forecast ahead 24 months. Here, rely upon the default exponential smoothing estimation procedure from the `fpp3` ecosystem package `fable`.


```{r}
d <- d[400:473,]
Plot(Month, Price, ts_unit="months", ts_agg="mean", ts_ahead=24)
```

Next, implement the classic Holt-Winters exponential smoothing method from the Base~R function `Holt-Winters()`.

```{r}
Plot(Month, Price, ts_unit="months", ts_agg="mean", ts_ahead=24,
     ts_source="classic")
```


## Factor Analysis

[more examples of exploratory and confirmatory factor analysis](https://web.pdx.edu/~gerbing/lessR/examples/FactorAnalysis.html)

Access the lessR data set called `datMach4` for the analysis of 351 people to the Mach IV scale. Read the optional variable labels. Including the item contents as variable labels means that the output of the confirmatory factor analysis contains the item content grouped by factor.

```{r}
d <- Read("Mach4", quiet=TRUE)
l <- Read("Mach4_lbl", var_labels=TRUE)
```

Calculate the correlations and store in *R*.

```{r fig.width=3.5, fig.height=3.5}
R <- cr(m01:m20)
```

The correlation matrix for analysis is named R. The item (observed variable) correlation matrix is the numerical input into the confirmatory factor analysis.

Here, do the default two-factor solution with `"promax"` rotation. The default correlation matrix is *mycor*. The abbreviation for `corEFA()` is `efa()`.

``` {r}
efa(R, n_factors=4)
```


The confirmatory factor analysis is of multiple-indicator measurement scales, that is, each item (observed variable) is assigned to only one factor. Solution method is centroid factor analysis.

Specify the measurement model for the analysis in Lavaan notation. Define four factors: Deceit, Trust, Cynicism, and Flattery.

```{r}
MeasModel <- 
" 
   Deceit =~ m07 + m06 + m10 + m09 
   Trust =~ m12 + m05 + m13 + m01 
   Cynicism =~ m11 + m16 + m04 
   Flattery =~ m15 + m02 
"
```


## Pivot Tables

[more examples of pivot tables](https://web.pdx.edu/~gerbing/lessR/examples/pivot.html)

Aggregate with `pivot()`. Any function that processes a single vector of data, such as a column of data values for a variable in a data frame, and outputs a single computed value, the statistic, can be passed to `pivot()`. Functions can be user-defined or built-in. 

Here, compute the mean and standard deviation of each company in the StockPrice data set download it with **lessR**.

```{r}
d <- Read("StockPrice", quiet=TRUE)
pivot(d, c(mean, sd), Price, by=Company)
```

Interpret this call to `pivot()` as

- for data set _d_
- compute the mean and standard deviation 
- of variable _Price_ 
- for each _Company_

Select any two of the three possibilities for multiple parameter values: Multiple compute functions, multiple variables over which to compute, and multiple categorical variables by which to define groups for aggregation.


## Color Scales

[more examples of color scales](https://web.pdx.edu/~gerbing/lessR/examples/Customize.html)


Generate color scales with `getColors()`. The default output of `getColors()` is a color spectrum of 12 `hcl` colors presented in the order in which they are assigned to discrete levels of a categorical variable. For clarity in the following function call, the default value of the `pal` or _palette_ parameter is explicitly set to its name, `"hues"`.


```{r}
getColors("hues")
```

```{r echo=FALSE}
getColors("hues", output=TRUE)
```



__lessR__ provides pre-defined sequential color scales across the range of hues around the color wheel in 30 degree increments: `"reds"`, `"rusts"`, `"browns"`, `"olives"`, `"greens"`, `"emeralds"`, `"turqoises"`, `"aquas"`, `"blues"`, `"purples"`, `"biolets"`, `"magentas"`, and `"grays"`.


```{r}
getColors("blues")
```

```{r echo=FALSE}
getColors("blues", output=TRUE)
```


To create a divergent color palette, specify beginning and an ending color palettes, which provide values for the  parameters `pal` and `end_pal`, where `pal` abbreviates palette. Here, generate colors from rust to blue.

```{r}
getColors("rusts", "blues")


```{r echo=FALSE}
getColors("rusts", "blues", output=TRUE)
```

## Utilities

[examples of utility functions](https://web.pdx.edu/~gerbing/lessR/examples/utilities.html)

**lessR** provides several utility functions for recoding, reshaping, and rescaling data.

\name{savePlotly}
\alias{savePlotly}
\title{Save the last Plotly chart to a standalone HTML file}

\description{
Save a Plotly/htmlwidget chart to an HTML file. If no object is supplied,
\code{savePlotly()} uses the most recent Plotly chart generated by
\pkg{lessR} functions (cached in \code{options("lessR.last_plotly")}).
A sensible filename is auto-generated from chart metadata (e.g., \dQuote{pie},
variable names) or from the chart title if metadata are unavailable.
Optionally opens the saved file in your default web browser.
}

\usage{
savePlotly(obj = NULL, file = NULL, open = TRUE,
           selfcontained = TRUE, libdir = NULL)
}

\arguments{
  \item{obj}{A Plotly/htmlwidget object. If \code{NULL} (default), the function
    attempts to retrieve the last chart from \code{options("lessR.last_plotly")}.}
  \item{file}{Output path for the HTML file. If \code{NULL}, a filename is
    constructed in the current working directory using the chart kind and
    variables, e.g., \code{plotly_pie_Dept.html} or
    \code{plotly_pie_DeptGender.html}.}
  \item{open}{Logical. If \code{TRUE} (default), open the saved file in the
    system's default web browser.}
  \item{selfcontained}{Logical. Passed to \code{htmlwidgets::saveWidget()}.
    If \code{TRUE}, bundle all dependencies into a single HTML file.}
  \item{libdir}{Optional directory to copy widget dependencies when
    \code{selfcontained = FALSE}. Passed to \code{htmlwidgets::saveWidget()}.}
}

\details{
\code{savePlotly()} is designed for seamless export of interactive outputs
created by \pkg{lessR} Plotly functions When the
\code{obj} parameter is \code{NULL}, the function retrieves the most-recent
Plotly widget stored by lessR in \code{options("lessR.last_plotly")}.

If \code{file} is not provided, a filename is automatically derived from
attributes embedded in the widget (when available), specifically:
\itemize{
  \item \code{lessR_kind} (e.g., \dQuote{pie})
  \item \code{lessR_xname} (primary variable name)
  \item \code{lessR_byname} (grouping variable name, if any)
}
If those attributes are missing, the function falls back to parsing the plain
chart title (e.g., \dQuote{Gender by Dept}). Characters unsuitable for filenames
are removed.

The function prints the absolute path of the saved file to the console and
(invisibly) returns that path. Setting \code{open = TRUE} will launch the file
in your default browser after saving.
}

\value{
(Invisibly) returns the normalized file path of the saved HTML file (a character
scalar).
}

\section{Side Effects}{
\itemize{
  \item Prints a confirmation message with the save location.
  \item Optionally opens the saved HTML file in the default browser when
        \code{open = TRUE}.
}
}

\author{
David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})
}

\seealso{
\code{\link[htmlwidgets]{saveWidget}},
}

\examples{
## Not run: 

d <- Read("Employee")

if (interactive()) {
  # Basic usage with the most recent lessR Plotly chart
  PieChart(Dept, data=d)
  savePlotly()  # -> e.g., "plotly_pie_Dept.html"

  # Grouped example; filename reflects both variables
  PieChart(Dept, by=Gender, data=d)
  savePlotly()  # -> e.g., "plotly_pie_DeptGender.html"

  # Explicit object and custom path
  plt <- PieChart(Dept, data=d)
  savePlotly(plt, file=file.path(tempdir(), "my_dept_pie.html"), open=FALSE)

  # Non-selfcontained (assets in a side folder)
  savePlotly(plt, file="dept_pie.html", selfcontained=FALSE,
             libdir="dept_pie_libs")
  ## End(Not run)
  }
}

\note{
Requires the \pkg{htmlwidgets} package to be installed.
If no recent Plotly chart is available and \code{obj} is \code{NULL},
the function will error and prompt you to pass a chart or render one first.
}

\keyword{hplot}

\name{corRead}
\alias{corRead}
\alias{rd.cor}

\title{Read Specified Correlation Matrix}

\description{
Abbreviation: \code{rd.cor}

A wrapper for base~R \code{\link{read.table}}. Read a correlation matrix into R. All coefficients for each variable must be on one physical row.  No variable names are in the file to be read.
}

\usage{
corRead(from=NULL, var_names=NULL, \dots)

rd.cor(\dots)
}

\arguments{
  \item{from}{File reference, either omitted to browse for the data file,
        or a full path name or web URL, included in quotes.  A URL
        begins with \code{http://}.}
  \item{var_names}{The names of the variables in the matrix.}
  \item{\dots}{Parameter values for base R \code{\link{read.table}.}}
}

\details{
Read a correlation, or any square, matrix into R. All coefficients for each variable must be on one row.  No variable names are in the file to be read. The coefficients within each row, that is, for a single variable, are delimited by a white space, such as one or more blanks. 

The standard R function that reads the matrix is \code{\link{read.table}}.

By default the variables are named X1, X2, etc.  If the \code{var_names} option is invoked, then the specified names refer to the respective rows and columns of the matrix.  Here it may be convenient to name the variables with the \code{lessR} function \code{\link{to}}.

The alternative is to calculate the correlations from the data, such as with the \code{lessR} function \code{\link{Correlation}} or the standard R function \code{\link{cor}}.
}

\references{
Gerbing, D. W. (2014). R Data Analysis without Programming, Chapter 8, NY: Routledge.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Correlation}}, \code{\link{read.table}}.
}

\examples{
# browse for the data file because ref is omitted
# name the variables with the lessR function to
# mycor <- corRead(var_names=to("m",20))

# abbreviated form
# read a matrix with 4 variables and specify the names
# mycor <- rd.cor(var_names=c("m06","m07","m09","m10"))
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ correlation }

\name{simFlips}
\alias{simFlips}

\title{Pedagogical Binomial Simulation, Coin flips}

\description{
Simulate a sequence of coin flips.
}

\usage{
simFlips(n, prob=.5, seed=NULL,
         show_title=TRUE, show_flips=TRUE,
         grid="grey90", pause=FALSE,
         main=NULL, pdf_file=NULL, width=5, height=5, \dots)
}


\arguments{
  \item{n}{Size of each sample, that is, the number of trials or flips.}
  \item{prob}{Probability of a success on any one trial.}
  \item{seed}{Default seed is the R default. Enter a positive integer value
       to obtain a reproducible result, the same result for the same seed.}\cr

  \item{show_title}{Place a title on the graph that contains the parameter values_}
  \item{show_flips}{Plot the outcome of each flip.}
  \item{grid}{Color of the grid lines.}
  \item{pause}{Build the graph and the text output, pausing after each
        confidence interval.}
  \item{main}{Title of graph.}\cr

  \item{pdf_file}{Name of the pdf file to which graphics are redirected.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}\cr

  \item{\dots}{Other parameter values.} 
}


\details{
Generate and plot successive values of a Head or a Tail using standard R \code{\link{rbinom}} function.
}


\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\examples{
# 10 flips of a fair coin
simFlips(10, .5)

# set the seed for a reproducible result with the same seed
simFlips(10, .5, seed=43)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ binomial process }

\name{.}
\alias{.}

\title{Function . for Selecting Rows/Columns with base R Extract}

\description{

Using the base R \code{\link{Extract}} function, with the unobtrusive function name, \code{.}, express a subsetting operation as\cr
d[.(rows), .(cols)]\cr
for a less annoying experience. With \code{.} to express a logical criterion to select rows, do not append the data frame name and \code{$} to variable names in  expressions as otherwise required by  \code{\link{Extract}}. Can also do a random selection of rows. For columns, no need to quote variable names, can include variable ranges defined by a colon, :, and add \code{-} to exclude designated columns. Also does not list rows missing data when not requested as does \code{\link{Extract}}.
}

\usage{
.(x, \dots)

}

\arguments{
  \item{x}{Logical expression to subset rows or columns.}
  \item{\dots}{Allows multiple expressions when selecting columns.}`
}

\details{
Eliminates the need to prepend the data frame name and a dollar sign to each variable name in the specified logical expression to select rows. For columns, no quoting variables, allow variable ranges. 

Can create a character string called \code{rows} that expresses the logic of row selection. Can create a character string called \code{cols} that expresses the logic of column (variable) selection. To negate the \code{rows} expression, \code{.(!rows)}. Use \code{-.(cols)} to exclude designated variables. 

Select a random selection of rows with the containing function \code{random(n)}, where \code{n} is the specified number of random rows to select from the full data frame and \code{.n} is the proportion of random rows to select.
}

\value{
The row or columns names of the rows of data or columns of data that satisfy the specified logical conditions.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Extract}} \code{\link{subset}}.
}

\examples{
# see vignette

d <- Read("Employee", quiet=TRUE)

# no data frame name attached to variable names
#   as variables assumed in the data frame
d[.(Gender=="M" & Post>90), ]

# include first three rows and only the specified variables
# variable range permitted
d[1:3, .(Years:Salary, Post)]

#  include first three rows and delete the specified variables
d[1:3, -.(Years:Salary, Post)]

# select rows and columns
d[.(Gender=="M" & Post>90), .(Years:Salary, Post)]

# because of the default for the base R Extract function [ ],
# if only one variable retained,
# then add drop=FALSE to retain the result as a data frame
d[1:3, .(Salary), drop=FALSE]

# define character string arguments
cols <- "Gender:Salary, Post"
rows <- "Gender=='M' & Post>93"
d[.(rows), .(cols)]
# negate
d[.(!rows), -.(cols)]

# random selection of 4 rows, retain all variables
d[.(random(4)), ]
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{.}

\name{getColors}
\alias{getColors}

\title{Hue, Chroma, Luminance (HCL) Color Wheel or Specified Colors}

\description{

Generates color vectors, including HCL colors for qualitative and sequential color scales, and displays these internally generated as well as manually specified arbitrary colors. To avoid bias in comparing differently colored regions of a visualization, generates HCL colors by default with fixed values of chroma (saturation) and luminance (brightness) for a range of hues, by default ordered so that adjacent colors are as separated as possible. Also generates a sequence of HCL colors according to any chosen hue value in which implicit calls can vary chroma and luminance to Zeileis's et al. \code{sequential_hcl} function from Ihaka's et al. \code{colorspace} package, and also with pre-defined values such as \code{"blues"}. The function also processes any arbitrarily specified set of colors or colors generated from a custom range according to a beginning and ending specified color. The function also includes color palettes from the \code{viridis} and \code{wesanderson} packages.

In terms of workflow, use the function to select a set of colors from the resulting color rectangle/wheel. The function outputs the colors so that the function call can serve as an argument to parameters in other functions that require a sequence of one or more colors as input. The visualization of the color wheel or rectangle is not generated in this situation. After selecting the colors, pass to an argument for a visualization function such as for the \code{fill} parameter.
}

\usage{
  getColors(pal=NULL, end_pal=NULL,
         n=12, h=0, h2=NULL, c=NULL, l=NULL, transparency=0,
         in_order=NULL, fixup=TRUE, power=NULL,
         shape=c("rectangle", "wheel"), radius=0.9, border="lightgray",
         main=NULL, labels=NULL, labels_cex=0.8, lty="solid",
         output=NULL, quiet=getOption("quiet"), \dots)
}

\arguments{
  \item{pal}{Palette of specified colors to plot. If
  specified colors, then the following parameters are not relevant. Can also
  be pre-defined color sequences that trigger a sequence of colors from light to
  dark, such as \code{"blues"}, or \code{"distinct"} to maximize color
  separation.}
  \item{end_pal}{If specified, then generate a color continuum that begins at
   \code{pal} and ends at \code{end_pal}.}\cr

  \item{n}{Number of colors to display.}
  \item{h}{Beginning HCL hue, 0 to 360.}
  \item{h2}{Ending HCL hue, 0 to 360. Defaults to a value close to
       360. Requires \code{in_order} to be \code{FALSE}.}
  \item{c}{Value of HCL chroma (saturation). Respective default values
       for qualitative, sequential, and divergent scales are
       65, c(35,75), and 50.}
  \item{l}{Value of HCL luminance (brightness).
       Respective default values for qualitative, sequential, and
       divergent scales are 60, c(80,25), and c(40,70).}
  \item{transparency}{Transparency factor of the area of each slice from 0,
        no transparency to 1, full transparency.}
  \item{in_order}{If \code{TRUE}, orders the colors in order of their
        HCL hue values, the default for a "wheel". Otherwise maximizes
        the difference between adjacent colors hues to prepare for
        inclusion in visualizations with qualitative, discrete color scales.}
  \item{fixup}{R parameter name. If \code{TRUE}, then HCL values outside of
        the displayable RGB color space are transformed to fit into that space
        so as to display.}
  \item{power}{Power for generating a sequential or divergent HCL scale
       (via colorspace package) for potentially non-linear changes
       in chroma and luminance across the scale. Default for sequential is 1
       and for divergent 0.75.}\cr
   
  \item{shape}{Default is a \code{"rectangle"}, or specify a \code{"wheel"}.}
  \item{radius}{Size of wheel. Not applicable to the rectangular shape.}
  \item{border}{Color of the borders of each slice. Set to \code{"off"} or
       \code{"transparent"} to turn off.}\cr 
  
  \item{main}{Title. Unlike other \code{lessR} functions, there is a default
             title, turned off by explicitly setting to \code{NULL} or
             \code{""}.}
  \item{labels}{If \code{TRUE}, then displayed. For HCL qualitative scale,
       default is \code{TRUE}, otherwise \code{FALSE}}.
  \item{labels_cex}{Character expansion factor of labels relative to 1.}
  \item{lty}{Line type of the border.}\cr

  \item{output}{Default to produce text and graphics output when called
       directly from the console but not when called from a visualization
       function or a direct call in R Markdown, which requires
       \code{output=TRUE}.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default with
       \code{\link{style}} function.}
  \item{\dots}{Other parameter values.}
}


\details{

I. HCL COLORS\cr
Generate a palette of colors according to the parameter \code{pal} in the form of a character string vector of their names, and also as a color wheel if not called from another function. The default value (for all but grayscale or white color themes) of \code{pal} is \code{"hues"}, which generates a qualitative palette of the specified number, \code{n}, of discrete HCL colors at the same chroma and luminance, respective default values of 65 and 60. With constant chroma and luminance the HCL color space provides a palette of colors with the same gray-scale intensities if desaturated. That means no brightness bias for viewing different colors that represent different areas, such as in a bar chart of two variables, or a pie chart. The primary constraint is that the HCL color space is not in a one-to-one correspondence with the RGB color space of computer monitors, so some HCL colors are approximated (with the default setting of the \code{fixup} parameter set to \code{TRUE}).

For \code{"hues"}, the default, the hue values and associated colors are expressed as HEX and RGB values. The first 12 generated discrete colors are  blue (240), brown (60), green (120), red (0), purple (275), turquoise (180), rust (30), olive (90), aqua (210), mulberry (330), emerald (150), and violet (300).

To have the generated colors be in the sequential order of hues, set \code{in_order} to \code{TRUE}, the default when \code{shape} is set to \code{"wheel"}. For about up to five or six colors adjacent values are still reasonably well distinguished even if in sequential order of hue number in the hcl space.\cr

II. COLOR SEQUENCE\cr
A second possibility generates a sequence of colors according to the value of \code{n} from a given start color to an ending color. To specify a custom range, set \code{pal} as the value of the first color, and then \code{end_pal} as the value of the last color in the color range. The colors in the sequence may or may not be of the same hue.

Or, access implicit calls Zeileis (2009) \code{sequential_hcl} and \code{diverge_hcl} functions from the \code{colorspace} package to access pre-defined color ranges including \code{"grays"}, which is the default if the color theme is \code{"gray"} or  \code{"white"}. Other predefined sequences are shown in the following table. Also can invoke the standard R color ranges of \code{"heat"}, \code{"terrain"}, and \code{"rainbow"}, or, preferably, their \code{colorspace} equivalents: \code{"rainbow_hcl"}, \code{"heat_hcl"}, and \code{"terrain_hcl"}. 

Can specify any value of hue with \code{h}. Can also provide custom values of chroma (c) and luminance (l), with either one a range of values defined as a vector of two values. Default values are \code{c=100} and \code{l=c(75,35)}. That is, the color sequence is generated according to the given hue, \code{h}, with a chroma of 100 and luminance varying from 75 to the darker 45.

The predefined sequences consist of the following hues and color names, defined in 30 degree increments around the HCL color wheel. Visualize the color wheel with then discrete colors below with the lessR function \code{\link{getColors}}, specifically the function call \code{getColors(shape="wheel")}. Visualize sequential color scales for each of the colors below with the lessR function \code{\link{showPalettes}}.\cr

\tabular{lll}{
 colors \tab param \tab value\cr
----------- \tab ----- \tab -----\cr
\code{"reds"} \tab h \tab 0\cr
\code{"rusts"} \tab h \tab 30\cr
\code{"browns"} \tab h \tab 60\cr
\code{"olives"} \tab h \tab 90\cr
\code{"greens"} \tab h \tab 120\cr
\code{"emeralds"} \tab h \tab 150\cr
\code{"turquoises"} \tab h \tab 180\cr
\code{"aquas"} \tab h \tab 210\cr
\code{"blues"} \tab h \tab 240\cr
\code{"purples"} \tab h \tab 270\cr
\code{"violets"} \tab h \tab 300\cr
\code{"magentas"} \tab h \tab 330\cr
\code{"grays"} \tab c \tab 0\cr
----------- \tab ----- \tab -----\cr
}

The predefined color name can be provided as the first argument of the function call, that is, the value of \code{pal}, or the corresponding value of \code{h} (or \code{c} for gray scale) can be specified. The specifications are equivalent. To specify a divergent color scale, provide both the value of \code{pal} as the beginning value and the value of \code{end_pal} as the last value, such that both values are one of the pre-specified color ranges. In either situation, of sequential or divergent color scales, custom values of \code{c} and \code{l} can be provided.\cr


III. SPECIFIED COLORS\cr
The third possibility is to generate a color wheel from a specified set of color values. Set the value of \code{pal} according to the vector of these values. Specify the values with R color names (see the lessR function \code{\link{showColors}}), RGB values according to the \code{rgb} function or from related R color space functions such as \code{hcl}, or as hexadecimal codes.\cr

IV. OTHER INCLUDED COLOR PALETTES\cr
The following palettes are based on those from the viridis package: \code{"viridis"}, \code{"cividis"}, \code{"plasma"}, and \code{"spectral"}, though the palettes here are generated from the base R function \code{\link{hcl.colors}}. These palettes were developed to be more useable for varying types of color-blindness, as is the included palette \code{"Okabe-Ito"}. The Tableau default qualitative color palette is also included, identified by \code{"Tableau"}. 

Movie director Wes Anderson is known for is innovative color themes in his movies, which feature a combination of pastel colors and bold primary colors. The following palettes are from the wesanderson package, based the colors from his movies: "BottleRocket1", "BottleRocket2", "Rushmore1", "Rushmore", "Royal1", "Royal2", "Zissou1", "Darjeeling1", "Darjeeling2 ", "Chevalier1", "FantasticFox1", "Moonrise1", "Moonrise2", "Moonrise3", "Cavalcanti1", "GrandBudapest1", "GrandBudapest2", "IsleofDogs1", "IsleofDogs2". The generation of the corresponding palettes are with \code{type} set to \code{"continuous"} to generalize to palettes of any length. Note that this package is suggested, which means to use the package for the first time you will be prompted to install the package.

The palette \code{"distinct"} specifies a sequence of 20 colors manually chosen for the distinctiveness. The first five colors are from the qualitative sequence of \code{hcl} colors with \code{c=90} and \code{l=50}. To maximise color separation, the remaining 15 colors do not satisfy constance levels of \code{c} and \code{l}. Use such as for plotting with a \code{by} variable with up to 20 levels.

FUNCTION USAGE\cr
Use the function on its own, in which case the color rectangle/wheel visualization is generated as are the color values. The vector of color values may be saved in its own R object as the output of the function call. Or, use the function to set colors for other parameter values in other function calls. See the examples.
}

\value{
Colors are invisibly returned as a character string vector.
}

\references{
Gerbing, D. W. (2020). R Visualizations: Derive Meaning from Data, Chapter 10, NY: CRC Press.
}

\seealso{
\code{\link{hcl}}, \code{\link{palette.colors}}, \code{\link{hcl.colors}}, \code{\link{showColors}}
}


\examples{
# HCL color wheels/rectangles
#----------------------------
# set in_order to TRUE for hues ordered by their number

# color spectrum of 12 hcl colors presented in the order
#  in which they are assigned to discrete levels of a
#  categorical variable
getColors()

# color spectrum of 12 hcl colors ordered by hue from 0
#   by intervals of 360/12 = 30 degrees
getColors(in_order=TRUE)

# pastel hcl colors, set luminance to 85 from default of 50
getColors(in_order=TRUE, l=85)

# color wheel of 36 ordered hues around the wheel
getColors(n=36, shape="wheel", border="off")

# ggplot qualitative colors, here for 3 colors generated
#   in order of their hue numbers across the color wheel
#   starting at a hue of 15 degrees and luminance of 60
getColors(h=15, n=3, l=60, in_order=TRUE)


# HCL Qualitative Scale
# ---------------------
# default pre-defined 12 hcl colors that were manually reordered
#   so that adjacent colors achieve maximum separation
getColors()

# deep rich colors for HCL qualitative scale
getColors(c=90, l=45)


# HCL Sequential Scales
# ---------------------
# generate hcl blue sequence with c=60 and vary l
getColors("blues", labels=FALSE)

# generate yellow hcl sequence with varying chroma
getColors("browns", c=c(20,90), l=60)

# non-linear grayscale, more concentration of colors at the beginning
getColors("black", "white", n=24, power=0.75)

# generate custom hue color sequence close to colorbrewer Blues
# library(RColorBrewer)
# getColors(brewer.pal(6,"Blues"))
# compare, vary both l and c
getColors(h=230, n=6, l=c(96,30), c=c(5,80))

# a standard R color sequence
getColors("heat")

# from viridis
getColors("viridis", n=12)

# maximally distinct
getColors("distinct", n=15)


# HCL Divergent Scales
# --------------------
# seven colors from rust to blue
getColors("rusts", "blues", n=7)

# add a custom value of chroma, c, to make less saturated
getColors("rusts", "blues", n=7, c=45)


# Manual Specification of Colors
# ------------------------------
# individually specified colors
getColors(c("black", "blue", "red"))

# custom sequential range of colors
getColors(pal="aliceblue", end_pal="blue")


# Plots
# -----
d <- rd("Employee")

# default quantitative scale
Chart(Dept, fill=getColors())
# or with implicit call to getColors
Chart(Dept, fill="colors")
# or an implicit call with the blues
Chart(Dept, fill="blues")
# or explicit call
Chart(Dept, fill=getColors("blues"))

# custom hue with different chroma levels (saturations)
Chart(Dept, fill=getColors(h=230, c=c(20,60), l=60))

# custom hue with different luminance levels (brightness)
# if explicitly calling getColors need to also specify n
X(Salary, fill=getColors(h=230, c=60, l=c(90,30)))

# use the default qualitative viridis color scale
Chart(Dept, fill="viridis")
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ hcl }
\keyword{ color }

\name{xW}
\alias{xW}

\title{Text Processing: Wrap Words to Create New Lines From a Specified Line}

\description{Split a larger line into multiple lines by wrapping words with inserted line feeds. Primarily for internal use in text processing of \code{knitr} output. Not usually referenced by the user.
}

\usage{
xW(x, w=90, indent=5) 
}


\arguments{
  \item{x}{The character string to split into separate lines.}
  \item{w}{Maximum width of each line.}
  \item{indent}{Amount of spaces to indent lines after the first line.}
}

\details{
Input is a sentence. Output is the sentence word wrapped into multiple lines, each line up to the maximum width.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\examples{
xW("The quick brown fox jumped over the lazy dog's back.", w=30)
}

\name{showPalettes}
\alias{showPalettes}

\title{Display Color Palettes}

\description{
For each specified palette class, display each palette in the class as a strip of colors in a single multi-panel PDF file.
}

\usage{
showPalettes(palette=c("sequential", "hues", "viridis", "wesanderson"),
             n=12, border="transparent", file=NULL)
}


\arguments{
  \item{palette}{Name of the palette class to display, one of \code{"sequential"}, \code{"hues"}, \code{"viridis"}, or \code{"wesanderson"}. Default is \code{"sequential"}.}
  \item{n}{Number of colors per palette. Default is 12 colors.}
  \item{border}{Color of the border between color strips, or \code{"off"} for no border. Default is \code{"transparent"}.}
  \item{file}{Name of the PDF file to write. Default is the palette class name with a \code{.pdf} extension.}
}


\details{
Four palette classes are available:
\itemize{
  \item \code{"sequential"}: HCL sequential palettes for each of 12 hues across the HCL color wheel in 30-degree intervals, plus grayscale.
  \item \code{"hues"}: 16 qualitative palettes based on the HCL hue wheel, shown for all combinations of chroma and luminance from \code{c} \eqn{\in \{20, 40, 60, 80\}} and \code{l} \eqn{\in \{20, 40, 60, 80\}}, each labeled with its \code{c} and \code{l} values.
  \item \code{"viridis"}: The viridis, cividis, plasma, and spectral palettes.
  \item \code{"wesanderson"}: Palettes from the \pkg{wesanderson} package (which must be installed separately).
}
}


\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\examples{
# default: sequential HCL palettes
#showPalettes()

# hues palettes across c x l grid
#showPalettes("hues")

# viridis palettes, simulate continuity with many small color blocks
#showPalettes("viridis", n=500, border="off")
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ color }

\name{XY}
\alias{XY}
\alias{Plot}
\alias{ScatterPlot}
\alias{sp}

\title{Scatterplots including Time Series}

\description{

\code{lessR} introduces the concept of an \emph{analytic view} visualization function, in which the choice of visualization function directly reflects the structure of the data and the analyst's intent for understanding the data. The function \code{XY()} visualizes the joint distribution of two continuous variables,
or more generally the relationship among multiple variables, along with associated
summary statistics. The specific representation is selected with the
\code{form} argument:
\itemize{
  \item Scatterplot of points with \code{form="scatter"} (default)
  \item Smoothed scatterplot with \code{form="smooth"}
  \item Hexbin scatterplot with \code{form="hexbin"}
  \item Contour plot (2-dimensional density display) with \code{form="contour"}
}

For the standard scatterplot, stratification divides the data into groups
via the arguments \code{by} and \code{facet}. The \code{by} argument overlays
groups in a single coordinate system for direct comparison, while
\code{facet} produces coordinated small multiples on separate panels.
\code{XY()} requires continuous \code{x} and \code{y}. When the continuous
\code{x} is ordered in time, such as a date or an equal-interval sequence,
successive points are connected to form a time-series display. Relationships
between two categorical variables, such as bubble plots, are instead handled
by \code{\link{Chart}} with \code{form="bubble"} and a \code{by} variable.

When running in RStudio, static graphics are drawn in the \code{Plots}
window. When the default \code{use_plotly=TRUE}, the interactive
\pkg{plotly} version of the scatterplot (including time series) display is also drawn in the \code{Viewer} window.

A scatterplot displays the joint values of one or more variables as points
in an \(n\)-dimensional coordinate system, in which the coordinates of each
point are the values of \(n\) variables for a single observation (row of
data). With a common syntax, \code{XY(x, y, ...)} generates a family of
related 1- or 2-dimensional relationship plots, possibly enhanced with
fitted lines, ellipses, and outlier labeling. Categorical variables should
typically be defined as factors, and date variables should be stored as
\code{Date} objects. When \code{x} is of class \code{Date}, the display is
treated as a time-indexed series.

\code{XY()} therefore serves as the relationship-oriented counterpart to
\code{Chart()} (aggregated values) and \code{X()} (univariate distributions)
within the three-function visualization framework implemented in \pkg{lessR}.
}

\usage{
XY(

    # -------------------------------------------------------
    # Data from which to construct the plot for x- and y-axis
    x, y, data=d, filter=NULL,

    # ----------------------------------------------------
    # Stratification: Same (by) or separate panels (facet)
    by=NULL,
    facet=NULL, n_row=NULL, n_col=NULL, aspect="fill",

    # -----------------------------------
    # Geometric forms of relational plots
    form=c("scatter", "smooth", "contour", "hexbin"),


    # -------------------------------
    # Enhancements and customizations
    # -------------------------------

    # --------------------------------------------------------------------
    # Analogy of physical Marks on paper that create the points and labels
    # See  ?style  for more options with the  style()  function
    theme=getOption("theme"),
    fill=NULL, color=NULL,
    transparency=getOption("trans_pt_fill"),

    # -----------------------------------------------
    # Plotted points and any connecting line segments
    enhance=FALSE, means=TRUE,
    pt_size=NULL, pt_size_cut=NULL, pt_shape="circle", line_width=1.5,
    segments=FALSE, segments_y=FALSE, segments_x=FALSE,

    # ----------------------
    # Sort and jitter points
    sort=c("0", "-", "+"),
    jitter_x=NULL, jitter_y=NULL,

    # ----------------
    # Outlier analysis
    ID="row.name", ID_size=0.60,
    MD_cut=0, out_cut=0, out_shape="circle", out_size=1,

    # -------------------------------------------------
    # Fit line, confidence interval, confidence ellipse
    fit=c("off", "loess", "lm", "ls", "null", "exp", "quad",
          "power", "log"),
    fit_power=1, fit_se=0.95,
    fit_color=getOption("fit_color"), fit_lwd=getOption("fit_lwd"),
    fit_new=NULL, plot_errors=FALSE, ellipse=0,
    ellipse_fill=getOption("ellipse_fill"),
    ellipse_color=getOption("ellipse_color"),
    ellipse_lwd=getOption("ellipse_lwd"),

    # -----------------------------------------------------------------------
    # Time series and forecasting, plot x values sequentially [xDate, y or Y]
    ts_unit=NULL, ts_ahead=0, ts_method=c("es", "lm"),
    ts_source=c("fable", "classic"), ts_agg=c("sum", "mean"),
    ts_NA=NULL, ts_format=NULL, ts_fitted=FALSE, ts_PI=.95, 
    ts_trend=NULL, ts_seasons=NULL, ts_error=NULL, 
    ts_alpha=NULL, ts_beta=NULL, ts_gamma=NULL, ts_new_x=NULL,
    ts_stack=FALSE, ts_area_fill="transparent", ts_area_split=0,
    ts_n_x_tics=NULL,
    # Run chart (indicate with .Index for the name of the x-variable)
    show_runs=FALSE, center_line=c("off", "mean", "median", "zero"),

    # -----------
    # Bubble plot [xCategorical, or xCategorical and yCategorical]
    radius=NULL, power=0.5, low_fill=NULL, hi_fill=NULL,

    # -----------------------------------------------------------
    # Large data sets, smoothing, contours and binning  [x and y]
    smooth_points=100, smooth_size=1,
    smooth_power=0.25, smooth_bins=128, hex_bins=30, hexbin_legend=TRUE,
    n_bins=1,
    contour_n=20, contour_nbins=50, contour_points=FALSE,
    contour_legend=FALSE,

    # -----------------------------
    # Bins for a frequency polygon
    bin=FALSE, bin_start=NULL, bin_width=NULL, bin_end=NULL,
    breaks="Sturges", cumulate=FALSE,


    # ----------------------
    # Axes labels and values
    # ----------------------

    # -----------------------
    # Axis labels and spacing
    xlab=NULL, ylab=NULL, main=NULL, sub=NULL,
    label_adjust=c(0,0), margin_adjust=c(0,0,0,0),  # top, right, bottom, left
    pad_x=c(0,0), pad_y=c(0,0),

    # ---------------------
    # Axis values specified
    scale_x=NULL, scale_y=NULL, origin_x=NULL, origin_y=NULL,

    # ---------------------
    # Axis values formatted
    rotate_x=getOption("rotate_x"), rotate_y=getOption("rotate_y"),
    offset=getOption("offset"),
    axis_fmt=c("K", ",", ".", ""), axis_x_prefix="", axis_y_prefix="",
    font_size=1,
    xy_ticks=TRUE, n_axis_x_skip=0, n_axis_y_skip=0, 

    # ------
    # legend
    legend_title=NULL,


    # -------------
    # Miscellaneous
    # -------------

    # ----------------------------------------------------
    # Add one or more objects, text, or geometric figures
    add=NULL, x1=NULL, y1=NULL, x2=NULL, y2=NULL,

    # ---------------------------------------------
    # Output: turn off, to PDF file, decimal digits
    quiet=getOption("quiet"), do_plot=TRUE,
    use_plotly=getOption("lessR.use_plotly"),
    pdf_file=NULL, width=6.5, height=6,
    digits_d=NULL,

    # -------------------------------------------------------------
    # Deprecated, to be removed in future versions
    smooth=FALSE,
    stat=c("mean", "sum", "sd", "deviation", "min", "median", "max"),
    stat_x=c("count", "proportion", "\%"),

    # ---------------------------------
    # Other
    eval_df=NULL, fun_call=NULL, \dots)
}

\arguments{
  \item{x}{The \emph{variable} plotted on the \code{x}-axis.
        The \strong{data values} are continuous, either
        cross-sectional or a time series. If \code{x} is sorted with equal
        intervals separating the values, or is a time series, then by default
       the points are plotted sequentially and connected with line segments.
        If named \code{.Index}, a run chart is generated from the corresponding
        \code{y} variable. Can specify multiple \code{x}-variables or multiple
        \code{y}-variables as vectors, but not both.}
  \item{y}{The continuous \emph{variable} plotted on the vertical
        \code{y}-axis.}
  \item{data}{Data frame that contains one or both of \code{x} and
        \code{y}. Default data frame is \code{d}. Specify \code{NULL} if
        the variables for the analysis are in the global environment instead.}
  \item{filter}{A logical expression or a vector of integers that specify the
        row numbers to retain, defining a subset of rows of the data frame to
        analyze.}\cr

  \item{by}{A \emph{grouping variable}, a categorical variable that provides
        separate group profiles of the primary numeric variables \code{x}
        and \code{y} on the \emph{same} plot.
        Only one \code{by} variable is permitted, as the resulting visual clutter
        compromises interpretability. Stratification by \code{by}
        applies only to a scatter plot, \code{form="scatter"}, not to the
        \code{"smooth"}, \code{"contour"}, and \code{"hexbin"} forms.}
  \item{facet}{One categorical variable, or a vector of two categorical
        variables, providing a separate plot of the primary
        variable(s) \code{x} and \code{y} for each level of the variable or
        combination of two levels. Stratification by \code{facet} applies to
        the \code{"scatter"}, \code{"smooth"}, \code{"contour"}, and
        \code{"hexbin"} forms, each panel sharing a common scale so that the
        panels are directly comparable.\cr
        When \code{x} (or \code{y}) is a vector of variables, the
        multi-series overlay is repeated across the panels, such as
        \code{XY(c(Pre, Post), Salary, facet=Gender)}: each panel displays
        the full overlay for one level of the \code{facet} variable.}
  \item{n_row}{Optional specification for the number of rows
        in the facet layout, a multi-panel display.
        Specify \code{n_col} or \code{n_row}, but not both.}
  \item{n_col}{Optional specification for the number of columns in the
        facet layout. Specify \code{n_col} or \code{n_row}, but not both.
        The default is \code{1}.}
  \item{aspect}{Aspect ratio (height/width) of the panels, applied only to the
       lattice facet forms: scatter and hexbin. The default \code{"fill"} expands
       each panel to occupy the available space (here \code{"fill"} refers to
       filling space, not to the \code{fill} color argument). Set to \code{1}
       for square panels, or \code{"xy"} to bank line slopes toward an effective
       45 degrees. The base-R contour and smooth facets size their panels
       automatically and ignore \code{aspect}.}\cr

  \item{form}{The plotted geometric form.
        The default is \code{"scatter"} for a scatter plot.
        To summarize the bivariate density for two numeric variables, set to
        \code{"smooth"} for a \strong{smoothed density plot},
        \code{"hexbin"} for a hexbin plot, or \code{"contour"} for a
        \strong{contour plot}.}\cr

  \item{theme}{Color theme for this analysis. Make persistent across analyses
        with \code{\link{style}}.}
  \item{fill}{Fill color for the points.
        Can also be set via the lessR function \code{\link{getColors}}
        to select from a variety of color palettes. For points, the default is
        \code{pt_fill}; for the area under a line chart, \code{violin_fill}.
        For a line chart, set to \code{"on"} to use the default color.}
  \item{color}{Border color of the points or line color for a line plot.
        Can be a vector to customize the color for each point or a color
        range such as \code{"blues"} (see \code{\link{getColors}}).
        Default is \code{pt_color} from the lessR \code{\link{style}} function.}
  \item{transparency}{Transparency factor of the fill color of each point.
        Default is \code{trans_pt_fill} from the lessR \code{\link{style}}
        function, which is 0.1 for points. Bubbles have a default
        transparency of 0.3.}\cr

  \item{enhance}{For a two-variable scatterplot, if \code{TRUE},
        automatically add the 0.95 data ellipse,
        labels for outliers beyond a Mahalanobis distance of 6 from the
        ellipse center, the least squares line for all data,
        the least squares line for the data excluding outliers, and
        horizontal and vertical lines representing the means of the two
        variables.}
  \item{means}{If one variable is categorical (factor) and the other is
       continuous, then if \code{TRUE} the group means are plotted in the
       scatterplot by default. Also applies to a 1-D scatterplot.}
  \item{pt_size}{When set to a constant, the scaling factor for
        \strong{standard points} (not bubbles) or for a line, with default
        of 1.0 for points and 2.0 for a line.
       Set to 0 to suppress plotting of points. If \code{ts_area_fill} is
       used for a line chart, then the default is 0. When set to a variable,
       activates a bubble plot, with the size of each bubble further determined
       by the value of \code{radius}. Applies to the standard two-variable
       scatterplot.}
  \item{pt_size_cut}{For a bubble plot in which bubble sizes are defined by a
       \code{pt_size} variable, controls whether and how many bubble labels are
       shown. If \code{1} (or \code{TRUE}), show the value of the sizing
       variable for selected bubbles in the center of the bubbles, except
       when the bubble is too small. If \code{0} (or \code{FALSE}), no values
       are displayed. If a number greater than 1, display labels only for the
       indicated number of values (e.g., the maximum and minimum when set
       to \code{2}). The color of the displayed text is set by
       \code{bubble_text} from the \code{\link{style}} function.}
  \item{pt_shape}{Plot character(s). The default value is \code{"circle"}, with
       both a default exterior color and filled interior, explicitly specified
       by \code{"color"} and \code{"fill"}.
       Other possible values with fillable interiors
       are \code{"circle"}, \code{"square"}, \code{"diamond"},
       \code{"triup"} (triangle up), and \code{"tridown"} (triangle down),
       all uppercase and lowercase letters, all digits, and most punctuation
       characters. The integers 0–25 as defined by the base R
       \code{\link{points}} function also apply.}
  \item{line_width}{Width of the line segments that connect adjacent points,
        such as in time series plots. Set to 0 to remove line segments.}
  \item{segments}{Designed for interaction plots of means: connects each pair of
        successive points with a line segment. Pass a data frame of means,
        such as from \code{\link{pivot}}. To turn off connecting line segments
        for sorted, equal-interval data, set to \code{FALSE}. Currently,
        does not apply to Trellis plots.}
  \item{segments_y}{For one \code{x}-variable, draw a line segment from the
        \code{y}-axis to each plotted point. For two \code{x}-variables, the
        line segments connect the two points.}
  \item{segments_x}{Draw a line segment from the \code{x}-axis for each
        plotted point.}\cr

  \item{sort}{Sort the values of \code{y} by the values of \code{x}.
        Default \code{"0"} retains the
        original order, \code{"-"} sorts descending, and \code{"+"} sorts
        ascending. If \code{x} is a vector of two variables,
        sort by their difference.}
  \item{jitter_x}{Randomly perturb the plotted points of
       a scatterplot horizontally within the limits of the specified value,
       or set to \code{NULL} to rely upon the computed default value.}
  \item{jitter_y}{Vertical jitter. Defaults to \code{0}. Same interpretation
        as \code{jitter_x}.}\cr

  \item{ID}{Name of a variable that provides the \strong{labels for selected
       plotted points for outlier identification}, row names of the data frame
       by default. To label all points, use the \code{add} parameter
       (see below).}
  \item{ID_size}{Size of the plotted labels.
        Modify label text color with the \code{\link{style}} function
        parameter \code{ID_color}.}
  \item{MD_cut}{Mahalanobis distance cutoff to define an outlier in a
       two-variable scatterplot.}
  \item{out_cut}{Count or proportion of plotted points to label, in order of their
       distance from the center (means) of the univariate distribution or 
       scatterplot, sorted from most to least extreme.
       For two-variable plots, distance from the center is based on Mahalanobis
       distance.}
  \item{out_shape}{Shape of outlier points in a two-variable scatterplot.
        Modify fill color from the current \code{theme} with
        \code{out_fill} and \code{out2_fill} in \code{\link{style}}.}
  \item{out_size}{Size of outlier points in a two-variable
        scatterplot.}\cr

  \item{fit}{Type of \strong{best fit line}. Default is \code{"off"}.
        Options include \code{"loess"} for a non-linear smooth,
        \code{"lm"} for a linear least squares model (with synonym
        \code{"ls"}),
        \code{"null"} for the null (intercept-only) model,
        \code{"exp"} for exponential growth or decay,
        \code{"log"} for a logarithmic model,
        \code{"power"} for a general power model in conjunction with
        \code{fit_power}, and \code{"quad"} for a quadratic (power 2)
        model. If potential outliers are identified according to
        \code{out_cut}, a second (dashed) fit line is displayed based on
        the data \emph{excluding} those outliers.}
  \item{fit_power}{Power that describes the response \code{y} as a power
       function of the predictor \code{x}, required when
       \code{fit="power"}. Optionally, and experimentally, may apply
       to \code{fit="exp"}.}
  \item{fit_se}{Confidence level for the error band displayed around the
       line of best fit. Default is 0.95 when a fit line is specified,
       but is turned off when \code{plot_errors=TRUE}.
       Can be a vector to display multiple confidence bands.
       Set to 0 to suppress error bands.}
  \item{fit_color}{Color of the fit line.}
  \item{fit_lwd}{Line width of the fit line.}
  \item{fit_new}{When \code{fit} is set to a fitted curve such as
       \code{"lm"} or \code{"quad"}, predicted values are computed at the
       \code{x}-values supplied here.}
  \item{plot_errors}{If \code{TRUE}, plot line segments joining each point to
        the regression line (\code{"loess"} or \code{"lm"}), illustrating the
        size of the residuals.}
  \item{ellipse}{Confidence level of a data ellipse for a scatterplot
        of one \code{x}-variable and one \code{y}-variable according to the
        contours of the corresponding bivariate normal density.
        Specify the confidence level(s) as a single number or a vector of
        values between 0 and 1 to plot one or more ellipses.
        Ellipses are not available in the interactive \code{plotly} version.
        For Trellis graphics, only the maximum level is used, with one ellipse
        per panel. Modify fill and border colors with the \code{\link{style}}
        parameters \code{ellipse_fill} and \code{ellipse_color}.}
   \item{ellipse_fill}{Fill color of the ellipse.}
   \item{ellipse_color}{Edge color of ellipse.}
   \item{ellipse_lwd}{Line width of the ellipse.}\cr

  \item{ts_unit}{Time unit for plotting \strong{time series data} when \code{x}
  is of type \code{Date}. Default is to infer the unit from the observed date
  spacing. Specify \code{ts_unit} to override the inferred unit and, when
  requested, aggregate to a coarser unit. Valid values are \code{"days"},
  \code{"weeks"}, \code{"months"}, \code{"quarters"}, \code{"years"}, and
  \code{"days7"} (daily data with a 7-day seasonal cycle).}
  \item{ts_ahead}{Number of \code{ts_unit} steps ahead of the last time period
        to forecast.}
  \item{ts_method}{Forecasting method. Default is \code{"es"} for exponential
       smoothing models. Alternatively, choose \code{"lm"} for a least squares
       linear regression model that accounts for seasonality.}
  \item{ts_source}{Source of forecasting functions. Default is \code{"fable"}
        for access to \code{ETS()} and \code{TSLM()} from the \pkg{fable}
        package and related functions from the \pkg{fpp3} ecosystem, or
        \code{"classic"} for base R forecasting functions.}
  \item{ts_agg}{Function used to aggregate over time according to
        \code{ts_unit}. Default is \code{"sum"} with an option for
        \code{"mean"}.}
  \item{ts_NA}{By default, missing \code{y} values (\code{NA}) are not plotted,
        leaving gaps. Alternatively, specify a value, usually 0, to replace
        \code{NA} and plot that value (e.g., 0) at the corresponding date.
        Forecasting with missing data is not supported.}
  \item{ts_format}{Optional format string for \code{as.Date()} describing
        the values of the date variable on the \code{x}-axis, needed if the
        function cannot infer the date format. For example, the character
        string \code{"09/01/2024"} can be described by
        \code{"\%m/\%d/\%Y"}. See \code{details} for more information.}
  \item{ts_fitted}{If \code{TRUE} and \code{ts_ahead} is used for forecasting,
        display for each data point the fitted value, level, trend, and
        seasonal component.}
  \item{ts_PI}{Prediction interval level about the forecasted values,
       with default of \code{0.95}.}
  \item{ts_trend}{Trend parameter. Default value is \code{NULL}, allowing the
       procedure to choose the specification that yields the best-fitting
       model for the data. Values \code{"A"} and \code{"M"} indicate additive
       and multiplicative models, respectively. Specify \code{"N"} to omit
       the trend component. See the forecasting documentation for valid
       combinations of trend, season, and error.}
  \item{ts_seasons}{Seasonality parameter. See \code{ts_trend}.}
  \item{ts_error}{Error parameter. See \code{ts_trend}.}
  \item{ts_alpha}{Exponential smoothing level parameter. Sets the value for
       \code{HoltWinters()}, and acts as a suggestion for
       \code{ETS()} in the \code{"fable"} framework.}
  \item{ts_beta}{Exponential smoothing trend parameter. See \code{ts_alpha}.}
  \item{ts_gamma}{Exponential smoothing seasonal parameter. See \code{ts_alpha}.}
  \item{ts_new_x}{A data frame of predictor variable names and new values for
       predictor variables used for model fitting and forecasting.
       The number of rows of new data values determines the number of future
       time periods for which forecasts are generated.
       Currently applies only to the default \code{"fable"} linear model
       for \code{ts_method="lm"}.}
  \item{ts_stack}{If \code{TRUE}, multiple time plots are stacked on each other,
        with \code{area} set to \code{TRUE} by default.}
  \item{ts_area_fill}{Fill under line segments, if present.
       If \code{ts_stack} is \code{TRUE}, the default is a gradient from the
       default color range (e.g., \code{"blues"}).
       If not specified, and \code{fill} is set with no plotted points and
       \code{ts_area_fill} is not specified, then \code{fill} generally
       controls the area under the line segments.}
  \item{ts_area_split}{Applies only to a Trellis plot activated with \code{facet}.
       Value of \code{y} that defines a reference line splitting the filled
       area under the time series line. Values of \code{y} below this threshold
       lie below the reference line; values above lie above the line.}
  \item{ts_n_x_tics}{Suggested number of ticks for dates on the \code{x}-axis,
       overriding the default of approximately seven ticks.}
  \item{show_runs}{If \code{TRUE}, display the individual runs in the run analysis.
        Also sets \code{run} to \code{TRUE}. Customize the color of the line
        segments with \code{segments_color} via \code{\link{style}}.}
  \item{center_line}{Plots a dashed line through the middle of a run chart.
        Values are \code{"off"}, \code{"mean"}, \code{"median"}, and
        \code{"zero"}, which specify that the center line goes through the
        mean, median, or zero, respectively. When not specified, a
        \code{"median"} center line is displayed if the values frequently
        vary about the mean, otherwise no center line.
        Currently not supported for Trellis plots.}\cr


  \item{radius}{Scaling factor of the bubbles in a \strong{bubble plot}, which
        sets the radius of the largest displayed bubble in inches. To
        activate bubble scaling, set \code{pt_size} to a third variable, or
        for categorical variables (factors), the bubble sizes represent
        frequencies.}
  \item{power}{Relative scaling of bubble sizes. The default value of 0.5
        scales bubbles so that the area of each bubble is proportional to
        the corresponding sizing variable. A value of 1 scales bubble radii
        directly by the sizing variable, increasing the size differences
        between values.}
  \item{low_fill}{For a categorical variable and the resulting bubble plot,
        or a matrix of such plots, sets the low end of a color gradient
        for bubble fill.}
  \item{hi_fill}{For a categorical variable and the resulting bubble plot,
        or a matrix of such plots, sets the high end of a color gradient
        for bubble fill.}\cr

  \item{smooth_points}{Number of points superimposed on the density plot in
        the areas of lowest density to help identify outliers, thereby
        controlling how dark the smoothed display becomes.}
  \item{smooth_size}{Size of points superimposed on the density plot.
        Default value is 1, resulting in very small points.}
  \item{smooth_power}{Exponent of the function that maps the density scale to
        the color scale. Smaller values than the default of 0.25 yield
        darker plots.}
  \item{smooth_bins}{Number of bins in each direction for the density
        estimation.}
  \item{hex_bins}{Number of bins in each direction for the hexbin plot.}
  \item{hexbin_legend}{If \code{TRUE}, the default, display the color key
        (legend) that maps fill colors to the binned counts on the right side
        of the hexbin plot. Set to \code{FALSE} to suppress the legend.}
  \item{n_bins}{Number of bins for a single numeric
       \code{x}-variable when visualizing the mean or median of a
       numeric \code{y}-variable for each bin. Points are plotted
       as bubbles, with bubble size proportional to the bin sample size,
       unless \code{pt_size} is specified as a constant. Default is 1
       (no binning).}
  \item{contour_n}{Number of contour levels in a contour plot, with
       default of 20.}
  \item{contour_nbins}{Number of bins constructed for each of \code{x} and
        \code{y}, forming the 2D grid from which densities are estimated.}
  \item{contour_points}{If \code{TRUE}, plot the original scatterplot points
        in a light gray with white borders, representing the data from which
        the contour curves are estimated. Color is not affected by other
        color settings, but point size can be changed with \code{pt_size}.
        Default size is 0.72.}
  \item{contour_legend}{If \code{TRUE}, display the color key (legend) that
        maps fill colors to density values on the right side of the contour
        plot. Default is \code{FALSE} (legend suppressed).}\cr

  \item{bin}{If \code{values="count"},  display the frequency distribution for 
       a frequency polygon.}
  \item{bin_start}{Optional starting value of the bins for a
        \strong{frequency polygon}.}
  \item{bin_width}{Optional specified bin width. Also sets
        \code{bin=TRUE}.}
  \item{bin_end}{Optional value that lies within the last bin, so the
        actual endpoint of the last bin may be larger than the specified
        value.}
  \item{breaks}{Method for calculating bins, or an explicit
        specification of the bins, such as via \code{\link{seq}} or other
        options provided by \code{\link{hist}}. Also sets
        \code{bin=TRUE}.}
  \item{cumulate}{If \code{TRUE}, display a cumulative frequency polygon.}\cr

  \item{xlab, ylab}{\strong{Axis labels} for the \code{x}- and \code{y}-axes.
       If not specified, labels default to the corresponding variable labels
       (if present), otherwise to the variable names. If \code{xy_ticks} is
       \code{FALSE}, no \code{ylab} is displayed. Customize these and related
       parameters with options such as \code{lab_color} in
       \code{\link{style}}.}
  \item{main}{Label for the plot title. If corresponding variable labels
       exist, the title is set by default from those labels.}
  \item{sub}{Subtitle for the graph, below \code{xlab}. Not yet implemented.}
  \item{label_adjust}{Two-element vector (x-axis label, y-axis label) that
       adjusts the positions of axis labels in approximate inches.
       Positive values move labels away from the plot edge.
       Not applicable to Trellis graphics.}
  \item{margin_adjust}{Four-element vector (top, right, bottom, left)
       that adjusts plot margins in approximate inches.
       Positive values move the corresponding margin away from the plot edge.
       Can be used with \code{offset} to move axis values into the expanded
       margin space. Not applicable to Trellis graphics.}
  \item{pad_x}{Proportion of padding added to the left and right sides of the
       \code{x}-axis. Values range from 0 to 1 for each of the two elements.
       If only one element is specified, it is applied to both sides.}
  \item{pad_y}{Proportion of padding added to the bottom and top sides of the
       \code{y}-axis. Values range from 0 to 1 for each of the two elements.
       If only one element is specified, it is applied to both sides.}\cr

  \item{scale_x}{If specified, a vector of three values that define the
        numeric \code{x}-axis: starting value, ending value, and number
        of intervals.}
  \item{scale_y}{If specified, a vector of three values that define the
        numeric \code{y}-axis: starting value, ending value, and number
        of intervals.}
  \item{origin_x}{Origin of the \code{x}-axis. Default is the minimum value
       of \code{x}, except for time series plots and when \code{stat}
       is set to \code{"count"} or a related option, in which case the
       origin defaults to 0.}
  \item{origin_y}{Origin of the \code{y}-axis. Default is the minimum value
       of \code{y}, except for time series plots and when \code{stat}
       is set to \code{"count"} or a related option, in which case the
       origin defaults to 0.}\cr

  \item{rotate_x}{\strong{Rotation in degrees of the axis value labels} on
        the \code{x}-axis, usually to accommodate longer labels,
        typically used with \code{offset}. If set to 90, labels are
        perpendicular to the axis and a different placement algorithm is
        used so that \code{offset} is not needed.}
  \item{rotate_y}{Rotation in degrees of the axis value labels on
        the \code{y}-axis, usually to accommodate longer labels,
        typically used with \code{offset}.}
  \item{offset}{Spacing between axis value labels and the axis. Default
        is 0.5. Larger values (e.g., 1.0) create additional space for
        labels, especially when rotated. Can be used with
        \code{margin_adjust} to create additional margin space for axis
        labels and values.}\cr
  \item{axis_fmt}{Numeric format of axis labels for both axes. Default
        rounds thousands to \code{"K"} (e.g., 100000 becomes 100K).
        Alternatives include \code{","} to insert commas in large numbers
        with a decimal point, \code{"."} to insert periods, or \code{""}
        to turn off formatting.}
  \item{axis_x_prefix}{Prefix for axis labels on the \code{x}-axis,
        such as \code{"$"}.}
  \item{axis_y_prefix}{Prefix for axis labels on the \code{y}-axis,
        such as \code{"$"}.}
  \item{font_size}{Multiplicative scaling factor applied to the font sizes
        of the title (\code{main_size}), axis labels (\code{lab_size}), and
        axis value text (\code{axis_size}) simultaneously, preserving their
        relative proportions. Default is \code{1} (no scaling).}
  \item{xy_ticks}{Flag indicating whether tick marks and associated
        \strong{value labels} on the axes are displayed. To rotate axis values,
        use \code{rotate_x}, \code{rotate_y}, and \code{offset} (see
        \code{\link{style}}).}
  \item{n_axis_x_skip}{Particularly useful for Trellis or facet plots with
        many labels on the \code{x}-axis. Specifies the spacing for skipping
        labels. A value of 0 includes all labels (default). A value of 1
        skips every other label, 2 includes every third label, etc.
        Also consider \code{rotate_x}.}
  \item{n_axis_y_skip}{Same as \code{n_axis_x_skip} but applies to the
        \code{y}-axis.}\cr

  \item{legend_title}{Title of the legend for a multiple-variable \code{x}
       or \code{y} plot.}\cr

  \item{add}{\strong{Overlay one or more objects}, text or geometric figures,
       on the plot. Possible values include any text (first argument) or
       \code{"text"}; \code{"labels"} to label each point with the row name;
       and geometric objects \code{"rect"} (rectangle), \code{"line"},
       \code{"arrow"}, \code{"v_line"} (vertical line), and
       \code{"h_line"} (horizontal line).
       The value \code{"means"} draws vertical and horizontal lines at the
       respective means. Does not apply to Trellis graphics.
       Customize with parameters such as \code{add_fill} and \code{add_color}
       via \code{\link{style}}.}
  \item{x1}{First x-coordinate for each overlaid object; may be
       \code{"mean_x"}. Not used for \code{"h_line"}.}
  \item{y1}{First y-coordinate for each overlaid object; may be
       \code{"mean_y"}. Not used for \code{"v_line"}.}
  \item{x2}{Second x-coordinate for each object; may be \code{"mean_x"}.
       Used only for \code{"rect"}, \code{"line"}, and \code{"arrow"}.}
  \item{y2}{Second y-coordinate for each object; may be \code{"mean_y"}.
       Used only for \code{"rect"}, \code{"line"}, and \code{"arrow"}.}\cr

  \item{quiet}{If \code{TRUE}, suppress text output. Can change the system
       default with \code{\link{style}}.}
  \item{do_plot}{If \code{TRUE} (default), generate the plot.}
  \item{use_plotly}{If \code{TRUE} (default), draw a \code{plotly} interactive
        plot in the RStudio \code{Viewer} window in addition to the static plot
        in the \code{Plots} window. Not all options are available in the
        interactive version, but key options are supported.}
  \item{pdf_file}{If specified, direct PDF graphics to the given file name.}
  \item{width}{Width of the plot window in inches, default 5 except within
        RStudio, where the default maintains an approximately square plotting
        area.}
  \item{height}{Height of the plot window in inches, default 4.5 except for
        1-D scatterplots and when running in RStudio.}
  \item{digits_d}{Number of significant digits for each displayed summary
        statistic.}\cr

  \item{smooth}{\emph{Deprecated}. Now use parameter \code{form}.}
  \item{stat}{\emph{Deprecated}. Functionality moved to \code{Chart()}.
       Apply a \strong{specified aggregation} such as \code{"mean"} to the
       numerical \code{y} variable at each level of a categorical \code{x}
       variable. The resulting dot plot (Cleveland plot) is analogous to a
       bar chart but emphasizes position along a common scale.}
  \item{stat_x}{\emph{Deprecated}. If no \code{y} variable is specified,
        constructs a frequency
        polygon for \code{x} with access to \code{bin_width}. Either use the
        default \code{"count"} for each bin or \code{"proportion"}, also
        indicated by \code{\%}.}\cr

  \item{eval_df}{If \code{TRUE}, checks that variables exist in the supplied
        data frame. Default of \code{NULL} determines the setting
        automatically. Set to \code{FALSE} in Shiny or pipe workflows.}
  \item{fun_call}{Function call. Used with \pkg{knitr} to pass the function
        call when obtained from the abbreviated helper \code{sp}.}\cr

  \item{\dots}{Other parameters for non-Trellis graphics as recognized by
      base R functions \code{\link{plot}} and \code{\link{par}}, including
      \code{cex.main} for the size of the title,
      \code{col.main} for the color of the title,
      and \code{sub} and \code{col.sub} for a subtitle and its color.}
}


\details{
VARIABLES and TRELLIS PLOTS

There is at least one primary variable, \code{x}, which defines the horizontal
\code{x}-axis. A second primary variable, \code{y}, defines the vertical
\code{y}-axis. Either \code{x} or \code{y} (but not both simultaneously) may be
a vector of variables. The simplest usage—single \code{x} and \code{y}—produces
a single scatterplot on one panel. With \code{form="scatter"} this is a
standard point plot; alternative values such as \code{"smooth"} and
\code{"contour"} invoke 2-D kernel density and contour displays, respectively.

For numeric primary variables, multiple plots can appear on a single panel in
two ways. First, by defining groups with the \code{by} argument:
\code{by} identifies a categorical grouping variable, and a separate
scatterplot layer is drawn for each of its levels. Group levels are
distinguished by color and/or shape. By default, both colors and shapes vary
across groups, which also aids readability for color-blind viewers; for two
groups, a common pattern is a filled symbol for one group and a point
with transparent interior for the other.

Second, multiple numeric \code{x}-variables or multiple \code{y}-variables can
be supplied as a vector, which produces multiple series on the same panel. This
is commonly used for time series overlays and multi-series line plots.

Trellis graphics (facets), from Deepayan Sarkar's (2009) \code{lattice}
package, may also be used. A variable specified with \code{facet} is a
conditioning variable. A single \code{facet} variable produces one panel for
each of its levels; a length-two vector of facet variables produces one panel
for each cross-classified combination of their levels. Within each panel,
\code{x} and \code{y} are plotted as usual, and an additional grouping variable
specified with \code{by} may be applied to all panels. When \code{x} has at
most 1000 unique values, XY() can provide a brief diagnostic of the maximum
number of repeated values for each level of \code{facet}.

A vector of variables passed to \code{x} (or \code{y}) combines with
\code{facet}: the multi-series overlay is repeated across the panels, each
panel displaying the full overlay for one level (or combination of levels)
of the \code{facet} variable(s), with all panels on a common scale for
direct comparison. Because the multiple series already occupy the color
(series) dimension of the plot, \code{by} does not apply when \code{x} or
\code{y} is a vector.

Control the panel dimensions and the overall size of the Trellis display with
\code{width} and \code{height} for the graphics device, \code{n_row} and
\code{n_col} for the number of panels in each direction, and \code{aspect} for
the panel height-to-width ratio. The plot window is the active graphics device
(e.g., the standard R plotting window, RStudio \code{Plots} pane, or a pdf file
when \code{pdf_file} is specified).\cr

CATEGORICAL VARIABLES

Categorical variables have relatively few unique values and are recommended
to be often coded as factors. However, categorical variables may also be coded numerically, such as Likert responses from 1 to 5. The structuring arguments \code{by} and \code{facet} apply when at least one of \code{x} or \code{y} is numeric, but that numeric variable may represent either a truly continuous scale or a discrete Likert-type scale.

A continuous variable, including time, models an underlying continuous scale,
even though all continuous variables are necessarily measured at discrete
precision. The distinction from a categorical variable is the scale that the
values represent, not the finiteness of the recorded values. A date-valued
\code{x} is therefore a continuous variable, which is why the time-series
display of \code{XY()} requires no qualification beyond continuous \code{x}.

Scatterplots of Likert-type data can be challenging because the number of
possible joint values is small. For two five-point scales there are only 25
possible combinations, so many points overlap at the same coordinates. For such
situations, jittering, or dot/mean plots (using \code{stat}) may
provide clearer displays.

The relationship between two categorical variables is instead displayed with
\code{\link{Chart}}, specifying \code{form="bubble"} and a \code{by} variable,
which sizes each bubble by the joint frequency of the two categories.\cr

DATA

The default input data frame is \code{d}. Another data frame can be specified
with the \code{data} argument. Regardless of the name of the data frame,
variables can be referenced directly by name—no need to attach the data frame
or use \code{d$name}. Referenced variables may live in the data frame, the
global environment, or both. If \code{x} is a time series of class \code{ts}, first extract the date and value components with \code{\link{tsExtract}}, then pass them to \code{XY}.

The plotted values can be the raw data themselves, or summaries derived from
them. With a single numeric variable, counts or proportions can be plotted on
the \code{y}-axis, optionally after binning \code{x}. For a categorical
\code{x}-variable paired with a continuous \code{y}-variable, summary
statistics such as means can be plotted at each level of \code{x}. When
\code{x} is continuous and binning is desired, XY() uses the same binning
parameters as \code{\link{X}}, such as \code{bin_width}, to override
defaults. The \code{stat} parameter controls what is plotted (e.g.,
\code{"data"}, \code{"mean"}, \code{"median"}). By default, connecting line
segments are drawn, yielding a frequency polygon. Turn off line segments by
setting \code{line_width=0}.

The \code{filter} parameter subsets rows (cases) of the input data frame
according to a logical expression or a vector of integers specifying row
numbers to retain. Use standard R logical operators as described in
\code{\link{Logic}}—for example, \code{&} (and), \code{|} (or), and \code{!}
(not)—and relational operators as described in \code{\link{Comparison}} such as
\code{==} (equality), \code{!=} (not equal), and \code{>} (greater than). To
specify rows directly, create an integer vector using standard R syntax. See
\code{Examples}.\cr

VALUE LABELS\cr
\emph{Deprecated. Use \code{factor()} instead.}  

The \code{value_labels} option can override the axis tick labels with
user-supplied values. This is particularly useful for Likert-style data coded
as integers: for example, a data value \code{0} can be displayed as
\code{"Strongly Disagree"}. These labels apply to integer categorical variables
and to factor variables. Any spaces in a label are translated into line breaks
to improve readability.

In current workflows, the recommended approach is to define factors with the
desired labels directly, typically via \code{\link{factors}}, which allows
convenient creation of labeled factors for one or more variables in a single
statement.\cr

VARIABLE LABELS

Base R does not natively support variable labels, but lessR stores labels in
the data frame alongside the variables, typically created by
\code{\link{Read}} or \code{\link{VariableLabels}}. When variable labels
exist, XY() uses them by default for axis labels and in text output. Otherwise,
the variable names are used.\cr

TWO VARIABLE PLOT

With two variables specified, XY() behaves as follows. If the values of
\code{x} are unsorted, have unequal intervals, or there is missing data in
either variable, a standard scatterplot is produced (for \code{form =
"scatter"}). When \code{x} is sorted with equal intervals and there are no
missing values, the default display connects adjacent points with line
segments, yielding a function or time-series style plot.

Supplying multiple continuous \code{x}-variables against a single \code{y}, or
vice versa, produces multiple series on the same graph. The points for the
second series reuse the first series' color but with transparent fill; for more
series, additional colors from the current theme are used.\cr

SCATTERPLOT MATRIX

If \code{x} and \code{y} specify the same vector of continuous variables,
as in \code{XY(c(Years, Pre, Post), c(Years, Pre, Post))}, XY() generates
a scatterplot matrix. To specify the variable list once, store it as a
data frame subset and reference it for both \code{x} and \code{y}, as in
\code{vec <- d[, c("Years", "Pre", "Post")]} followed by
\code{XY(vec, vec, data=NULL)}.
The matrix adopts the current color theme.
Individual colors (e.g., \code{fill}, \code{color}) can be overridden. The
lower triangle shows the pairwise scatterplots, and the upper triangle shows
the corresponding correlation coefficients. By default a non-linear loess fit
line is added to each scatterplot; the \code{fit} parameter can be used to
request a linear least squares line instead, along with \code{fit_color} to set
its color.\cr

SIZE VARIABLE\cr
Specifying a numeric \code{pt_size} variable activates a bubble plot in which the
area of each bubble is determined by the corresponding value of \code{pt_size}
(modified by \code{radius} and \code{power}).

Shapes vary across groups by default. To set shapes explicitly, use
\code{pt_shape} and provide a vector of values (e.g., created with
\code{\link{c}}), one shape per level of the grouping variable in \code{by},
or set \code{pt_shape} to a single value (e.g., \code{"circle"}) to use the same
shape for all groups. To control colors, use \code{fill} with values for each
\code{by} level.

Beyond the named shapes such as \code{"circle"}, any single character (letters,
digits, \code{"+"}, \code{"*"}, \code{"#"}) may be used as a plotting symbol.
Within a single specification, either use standard named shapes or single
characters, but not both.\cr

SCATTERPLOT ELLIPSE

For a scatterplot of two numeric variables, the \code{ellipse} argument
requests one or more data ellipses, based on the contours of the corresponding
bivariate normal density. For a single \code{x}- and \code{y}-variable pair,
setting \code{ellipse} to a numeric value between 0 and 1 (e.g., 0.95) draws
the corresponding probability contour. A vector of values produces multiple
ellipses. XY() expands the axes as needed so that ellipses extending beyond the
range of the data remain fully visible. For Trellis graphics, only the largest
ellipse level is used (one ellipse per panel). Ellipse fill and border colors
are controlled via \code{ellipse_fill} and \code{ellipse_color} in
\code{\link{style}}.\cr

TIME CHARTS

See \url{https://web.pdx.edu/~gerbing/lessR/examples/Time.html} for additional
examples and explanation.


\subsection{Run Chart}{

When \code{x} is the special variable \code{.Index}, XY() produces a run chart
of \code{y}. The \code{y}-values are plotted against their index positions
(1, 2, …), and run-chart diagnostics such as center lines and runs analysis can
be displayed via the corresponding arguments.
}

\subsection{Time Series Defined with Dates}{

If \code{x} is of type \code{Date} or an R time-series object, XY() produces a
time series plot for each specified variable. Time-series data can be supplied
in \dQuote{long} format (a single column of values plus a date column) or in
\dQuote{wide} format (multiple time-series columns sharing a date index). XY()
will attempt to convert character string date values (e.g.,
\code{"08/18/1952"}) to \code{Date} via \code{as.Date()}, using default date
formats when possible.

XY() makes a reasonable attempt to decode common date formats, but some formats
(e.g., those with month names rather than numbers) may require an explicit
format string via \code{ts_format}. If the default conversion fails or is
ambiguous, specify the correct format using examples such as those in the
table below. Note that \code{ts_format} can always be provided for explicit
specification of the date format.\cr

\tabular{ll}{
Example Date \tab Format\cr
--------------------------- \tab ----------------- \cr
\code{"2022-09-01"} \tab \code{"\%Y-\%m-\%d"}\cr
\code{"2022/9/1"} \tab \code{"\%Y/\%m/\%d"}\cr
\code{"2022.09.01"} \tab \code{"\%Y.\%m.\%d"}\cr
\code{"09/01/2022"} \tab \code{"\%m/\%d/\%Y"}\cr
\code{"9/1/22"} \tab \code{"\%m/\%d/\%y"}\cr
\code{"September 1, 2022"} \tab \code{"\%B \%d, \%Y"}\cr
\code{"Sep 1, 2022"} \tab \code{"\%b \%d, \%Y"}\cr
\code{"20220901"} \tab \code{"\%Y\%m\%d"}\cr
--------------------------- \tab ----------------- \cr
}

XY() also converts character-string dates such as \code{"2024 Aug"} and
\code{"2024 Q1"}, interpreting three-letter month abbreviations and quarter
codes \code{Q1}--\code{Q4}.

\strong{Time unit and aggregation.}
The \code{ts_unit} argument controls the time unit used for plotting and, when
specified, can also be used to aggregate the series to a coarser time unit. By
default, XY() attempts to infer a regular time unit from the observed spacing
of the dates (see \sQuote{Detecting the Regularity of Dates}). You may specify
\code{ts_unit} to override the inferred unit, including treating irregular
dates as a regular unit for aggregation (for example, \code{ts_unit="weeks"}).
The special value \code{"days7"} retains daily observations but evaluates
seasonality on a 7-day cycle.

When aggregation is requested, the date index is aggregated with
\code{endpoints()} and \code{period.apply()} from the \code{xts} package. The
aggregation function is specified with \code{ts_agg}, default \code{"sum"},
with \code{"mean"} as a common alternative.
}

\subsection{Detecting the Regularity of Dates (ts_unit)}{

For time series operations, \pkg{lessR} attempts to infer the regularity of a
date variable from the observed sequence of dates. The inferred unit is
returned internally as \code{tu_exist} and is one of \code{"days"},
\code{"weeks"}, \code{"years"}, \code{"quarters"}, \code{"months"}, or
\code{"unknown"}.

The decision rules are:

\enumerate{

\item \strong{Pre-processing.}
Dates are sorted and reduced to unique values. When a grouping variable is
present, regularity is evaluated from the first level only (assuming dates are
already time-sorted within that level). Day gaps are computed as positive
differences between successive dates.

\item \strong{Trivial / short series.}
If there are fewer than two dates, or if no positive gaps are available, the
unit is set to \code{"days"}.

\item \strong{Fine units (gap-based).}
Let \code{gap} be the median of the positive day gaps (median is robust to
occasional missing dates).

\itemize{
  \item If \code{gap == 1}, then \code{tu_exist="days"}.
  \item If \code{gap == 7}, then the series is a \emph{candidate} weekly series.
  The gap pattern is further examined to distinguish a regular weekly series
  (primarily 7-day gaps, with only occasional longer gaps) from an irregular
  reporting schedule (for example, many 14-day gaps). If judged sufficiently
  weekly, then \code{tu_exist="weeks"}; otherwise \code{tu_exist="unknown"}.
}

\item \strong{Coarse units (calendar-based).}
If the unit is still \code{"unknown"} after the fine-unit checks, the dates are
examined for calendar structure. Let \code{year}, \code{month}, and \code{day}
denote the corresponding calendar fields.

\itemize{

  \item \strong{Years.}
  If there is at most one observation per year and all observations share the
  same month and day-of-month (for example, January 1 each year), then
  \code{tu_exist="years"}. Missing years are permitted.

  \item \strong{Quarters.}
  If there is at most one observation per calendar quarter (unique
  year--quarter combinations) \emph{and} the median day gap between
  observations falls in the range 60--122 days, then
  the existing time unit is deemed as "quarters"}. 
  The reporting month and day-of-month may
  vary across quarters, and missing quarters are permitted. The gap range
  excludes sparse or irregular series that happen to have at most one
  observation per quarter by chance.

  \item \strong{Months.}
If the time variable is a Date but the observations occur exactly once per calendar month with no duplicates within a month and the sequence of months is regular (missing months become explicit NAs if present), then lessR treats the series as monthly and converts the index accordingly.


  \item \strong{Missing periods.}
  When a regular unit is accepted (\code{"weeks"}, \code{"years"},
  \code{"quarters"}, or \code{"months"}), a flag \code{has_missing_periods} is set
  to \code{TRUE} if the sequence of inferred periods contains gaps (for example,
  a 14-day gap in an otherwise weekly series, or a missing month in an otherwise
  monthly series). If the series is classified as \code{"unknown"},
  \code{has_missing_periods} is not used.
  }
}

If the user explicitly specifies \code{ts_unit}, that value is used for
aggregation and modeling, overriding the inferred unit. In particular, a
user-specified \code{ts_unit="months"} may treat one observation per month as
monthly even if the reporting day varies across months, and a user-specified
\code{ts_unit="weeks"} may treat dates as weekly even if the inferred
regularity is \code{"unknown"}.

\subsection{Missing Data}{

For missing data, if a date is present but the corresponding \code{y}-value is
\code{NA}, the line is broken at that point (no segment is drawn). If both the
date and value are absent (the entire row is missing), the line connects the
nearest observed dates, spanning the gap in calendar time but skipping the
missing tick label. For example, if "2021-01-07" and "2021-01-09" are present
but "2021-01-08" is absent, the plot includes points for the 7th and 9th
connected by a line; the 8th does not appear on the axis.
}

\subsection{Forecasting}{

Forecasting is activated by setting \code{ts_ahead} to a positive integer. The
trend, seasonal, and error components for exponential smoothing and regression
models follow the \code{fable} conventions and are controlled by
\code{ts_trend}, \code{ts_seasons}, and \code{ts_error}. XY() supports four
forecasting engines: \code{ETS()} and \code{TSLM()} from \code{fable} via
\code{ts_source="fable"}, and classic \code{HoltWinters()} and regression
decomposition (\code{stl()} + \code{lm()}) via \code{ts_source="classic"}.
Multiplicative components require positive data. Additive trend is linear,
while multiplicative trend corresponds to exponential growth or decay; additive
and multiplicative seasonality scale the seasonal pattern differently as the
series level changes.

Exponential smoothing via \code{ETS()} (the default when
\code{ts_source="fable"}) generally provides flexible model specification
and often superior predictive performance compared to classic Holt–Winters.
For regression with seasonality, \code{TSLM()} and the \code{stl()}+\code{lm()}
approach both rely on least squares but handle seasonal structure differently.
Setting \code{ts_fitted=TRUE} provides fitted values and decomposed trend and
seasonal components for inspection.\cr
}


2-D KERNEL DENSITY

Set \code{form="smooth"} to invoke \code{\link{smoothScatter}} and display a
2-D kernel density estimate for large data sets. The display respects the
current theme. The \code{smooth_points} argument controls how many points from
low-density regions are superimposed, \code{smooth_bins} sets the number of
bins in each direction for density estimation, and \code{smooth_power}
controls the transformation from density scale to color scale. Larger
\code{smooth_power} values reduce saturation in low-density regions. These
arguments map directly to \code{nrpoints}, \code{nbin}, and
\code{transformation} in \code{\link{smoothScatter}}. Grid lines are disabled
by default for smooth density plots, but can be re-enabled via the appropriate
styling options (e.g., \code{grid_color} in \code{\link{style}}).

Alternatively, set \code{form="contour"} to plot contour lines of the
estimated bivariate density, with the level resolution controlled by
\code{contour_n} and \code{contour_nbins}.

Each of the \code{"smooth"}, \code{"contour"}, and \code{"hexbin"} forms also
supports \code{facet} for coordinated small multiples, and every panel shares a
common scale so the panels are directly comparable. Contour and smooth panels
share a common kernel-density grid, bandwidth, and set of color levels;
hexbin panels share a single count legend. Faceted contour and smooth plots are
drawn as a base-R panel grid, whereas faceted hexbin plots use the native
paneling of the \code{hexbin} package. So the density can be compared across
panels, a faceted smooth plot estimates the density with
\code{\link[MASS]{kde2d}} rather than with \code{\link{smoothScatter}}, so its
appearance differs slightly from the corresponding single, unfaceted plot.\cr

COLORS

A global color theme for \code{XY()} and other lessR graphics can be set with
\code{\link{style}} (e.g., \code{style(theme="lightbronze")}). The default
theme is \code{"lightbronze"}. A grayscale theme is available via
\code{"gray"}, and other themes (e.g., \code{"sienna"}, \code{"darkred"}) are
described in \code{\link{style}}. The \code{sub_theme="black"} option yields
a black background with partially transparent plotted colors.

Individual graphical elements (points, lines, panels, grid lines, etc.) can be
customized with additional \code{\link{style}} arguments, such as
\code{panel_fill}. For a subtle warm background, try
\code{panel_fill="snow"}; very light grays such as
\code{"gray99"} or \code{"gray97"} provide a neutral tone.  

For many color options, the value \code{"off"} is equivalent to
\code{"transparent"}, removing the corresponding fill or border.

See \code{\link{showColors}} for a display of all named R colors and their RGB
values.\cr

ANNOTATIONS

The \code{add} argument and its related coordinates (\code{x1}, \code{y1},
\code{x2}, \code{y2}) annotate the plot with text and geometric objects. Each
object type requires a specific set of coordinates, summarized below.
\code{x}-coordinates may take the special value \code{"mean_x"} and
\code{y}-coordinates may take \code{"mean_y"}.\cr

\tabular{lll}{
Value \tab Object \tab Required Coordinates\cr
----------- \tab ------------------- \tab -----------------------\cr
\code{"text"} \tab text \tab x1, y1\cr
\code{"point"} \tab point \tab x1, y1\cr
\code{"rect"} \tab rectangle \tab x1, y1, x2, y2\cr
\code{"line"} \tab line segment \tab x1, y1, x2, y2\cr
\code{"arrow"} \tab arrow \tab x1, y1, x2, y2\cr
\code{"v_line"} \tab vertical line  \tab x1\cr
\code{"h_line"} \tab horizontal line  \tab y1\cr
\code{"means"} \tab horizontal and vertical lines at the means \tab \cr
----------- \tab ------------------- \tab -----------------------\cr
}

The value of \code{add} specifies the object type. For a single object, provide
one value and its required coordinates. For multiple placements of the same
object, supply coordinate vectors. For multiple different objects, supply a
vector of \code{add} values and, for each coordinate argument (\code{x1},
\code{y1}, \code{x2}, \code{y2}), a vector whose elements correspond to the
sequence of objects in \code{add}.

Styling options such as \code{add_color}, \code{add_fill}, and transparency
may also be given as vectors, allowing different objects to have different
colors or other properties.\cr

PDF OUTPUT

To obtain pdf output, set \code{pdf_file} to a file name, optionally with
\code{width} and \code{height} to control device size. The pdf is written to
the current working directory, which can be explicitly set with
\code{\link{setwd}}.\cr

ADDITIONAL OPTIONS

Many commonly used graphical parameters from the base \code{R} function
\code{\link{plot}} are passed through by XY(), including:

\describe{
  \item{cex.main, col.lab, font.sub, etc.}{Settings for main/sub-titles and axis
        annotation; see \code{\link{title}} and \code{\link{par}}.}
  \item{main}{Main title of the graph; see \code{\link{title}}.}
  \item{xlim}{Limits of the \code{x}-axis, expressed as \code{c(x1, x2)}. Note
        that \code{x1 > x2} is allowed and produces a reversed axis.}
  \item{ylim}{Limits of the \code{y}-axis.}
}

VARIABLES AND EXPRESSIONS

A referenced variable in \code{XY} is by default a variable name (or
vector of variable names), resolved from the referenced data frame
(e.g., the default \code{d}) or, with \code{data=NULL}, from the user's
workspace (global environment). A vector of variable names retains its
column-selection meaning, as in the scatterplot matrix
\code{XY(c(Years, Pre, Post), c(Years, Pre, Post))}.

The variable arguments \code{x}, \code{y}, \code{by}, and \code{facet}
also accept expressions, evaluated first against the columns of the data
frame, then against the user's workspace. The expression text serves as
the variable label. For example:\cr

\preformatted{
    > XY(rnorm(50), rnorm(50))   # expressions, no data frame needed
    > XY(Years, log(Salary))     # Years, Salary resolved from d
    > XY(Years, Salary, by=cut(Pre, 2))  # expression as by variable}

An expression that references a column of the data frame must evaluate
to one value per row of the data frame.

For a scatterplot matrix, store the variable list once as a data frame
subset and reference it for both \code{x} and \code{y}:\cr

\preformatted{
    > vec <- d[, c("Years", "Pre", "Post")]
    > XY(vec, vec, data=NULL)    # same matrix as the c() form above}
}


\value{
The output may be assigned to an \code{R} object; otherwise it is printed directly
to the console. Each component appears only when the corresponding analytic option
is activated. For example, outlier identification must be enabled (e.g., via
\code{MD_cut}) for \code{out_outliers} to be included in the output.

To save the results, assign the output to an object, such as  
\code{p <- XY(Years, Salary)}.  
Use \code{names(p)} to view the available components, and access any one by
prefixing with \code{p$}, for example \code{p$out_stats}.  
Output can be viewed interactively at the console or inserted into R~Markdown
documents for reproducible reporting.

READABLE OUTPUT

\code{out_stats}: Correlational analysis.\cr
\code{out_outliers}: Mahalanobis Distance values for detected outliers.\cr
\code{out_frcst}: Forecasted values.\cr
\code{out_fitted}: Fitted values for the observed data.\cr
\code{out_coefs}: Linear and seasonal coefficients from forecasting models.\cr
\code{out_smooth}: Smoothing parameters from exponential smoothing models.\cr
\code{out_bubble}: Bubble-plot settings, including \code{radius} and \code{power}.\cr
\code{out_reg}: Regression statistics produced when \code{fit} is specified.\cr

STATISTICS

\code{outliers}: Row numbers corresponding to detected outliers.\cr
}


\references{
Murdoch, D, and  Chow, E. D. (2013).  \code{ellipse} function from the \code{ellipse} package.

Gerbing, D. W. (2023). R Data Analysis without Programming, 2nd edition, Chapter 10, NY: Routledge.

Gerbing, D. W. (2020). R Visualizations: Derive Meaning from Data, Chapter 5, NY: CRC Press.

Gerbing, D. W. (2021). Enhancement of the Command-Line Environment for use in the Introductory Statistics Course and Beyond, \emph{Journal of Statistics and Data Science Education}, 29(3), 251-266, https://www.tandfonline.com/doi/abs/10.1080/26939169.2021.1999871.

Hyndman, R. J., & Athanasopoulos, G. (2021). \emph{Forecasting: Principles and Practice} (3rd ed.). Melbourne, Australia: OTexts. Retrieved from https://otexts.com/fpp3/

Sarkar, Deepayan (2008) Lattice: Multivariate Data Visualization with R, Springer. http://lmdvr.r-forge.r-project.org/

Sievert, C. (2020). \emph{Interactive Web-Based Data Visualization with R, plotly, and shiny}. Chapman and Hall/CRC. URL: \url{https://plotly.com/r/}
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{\code{\link{X}}, \code{\link{Chart}}, \code{\link{style}},
\code{\link{tsExtract}}.
}


\examples{
# read the data
d <- rd("Employee", quiet=TRUE)
d <- d[.(random(0.6)),]  # less computationally intensive
dd=d

#---------------------------------------------------
# traditional scatterplot with two numeric variables
#---------------------------------------------------

# scatterplot with all defaults
XY(Years, Salary)
# or use Plot in place of XY, the older method

# an expression as a variable, evaluated against the data frame,
#   with the expression text as the variable label
XY(Years, log(Salary))

XY(Years, Salary, by=Gender, pt_size=2, fit="lm",
     fill=c(M="olivedrab3", W="gold1"),
     color=c(M="darkgreen", W="gold4"))

# maximum information, minimum input: scatterplot +
#  means, outliers, ellipse, least-squares lines with and w/o outliers
XY(Years, Salary, enhance=TRUE)

# extend x and y axes
XY(Years, Salary, scale_x=c(-10, 35, 10), scale_y=c(0,200000,10))

XY(Years, Salary, add="Hi", x1=c(12, 16, 18), y1=c(80000, 100000, 60000))

d <- factors(Gender, levels=c("M", "W"))
XY(Years, Salary, facet=Gender)
d <- dd

\donttest{

# just males employed more than 5 years
XY(Years, Salary, filter=(Gender=="M" & Years > 5))

# plot 0.95 data ellipse with the points identified that represent
#   outliers defined by a Mahalanobis Distance larger than 6
# save outliers into R object out
d[1, "Salary"] <- 200000
out <- XY(Years, Salary, ellipse=0.95, MD_cut=6)

# new shape and point size, no grid or background color
# then put style back to default
style(panel_fill="powderblue", grid_color="powderblue")
XY(Years, Salary, pt_size=2, pt_shape="diamond")
style()

# translucent data ellipses without points or edges
#  show the idealized joint distribution for bivariate normality
style(ellipse_color="off")
XY(Years, Salary, pt_size=0, ellipse=seq(.1,.9,.10))
style()

# bubble plot with size determined by the value of Pre
# display the value for the bubbles with values of  min, median and max
XY(Years, Salary, pt_size=Pre, pt_size_cut=3)

# variables in a data frame not the default d
# plot 0.6 and 0.9 data ellipses with partially transparent points
# change color theme to gold with black background
style("gold", sub_theme="black")
XY(eruptions, waiting, transparency=.5, ellipse=seq(.6,.9), data=faithful)

# scatterplot with two x-variables, plotted against Salary
# define a new style, then back to default
style(window_fill=rgb(247,242,230, maxColorValue=255),
  panel_fill="off", panel_color="off", pt_fill="black", transparency=0,
  lab_color="black", axis_text_color="black",
  axis_y_color="off", grid_x_color="off", grid_y_color="black",
  grid_lty="dotted", grid_lwd=1)
XY(c(Pre, Post), Salary)
style()

# increase span (smoothing) of the loess fit
#   from the default of 0.75 to 1.25
# display confidence intervals about best-fit line at
#   0.95 confidence level
XY(Years, Salary, fit="loess", span=1.25)

# 2-D kernel density (more useful for larger sample sizes)
XY(Years, Salary, form="smooth")
}

#------------------------------------------------------
# scatterplot matrix from a vector of numeric variables
#------------------------------------------------------

# with least squares fit line
XY(c(Salary, Years, Pre), c(Salary, Years, Pre), fit="lm")

# same matrix from a stored variable list, a data frame subset
vec <- d[, c("Salary", "Years", "Pre")]
XY(vec, vec, data=NULL)


#--------------------------------------------------------------
# Trellis graphics and by for groups with two numeric variables
#--------------------------------------------------------------

# Trellis plot with condition on 1-variable
# optionally re-order default alphabetical R ordering by converting
#   to a factor with lessR factors (which also does multiple variables)
# always save to the full data frame with factors
d <- factors(Gender, levels=c("M", "W"))
XY(Years, Salary, facet=Gender)
d <- Read("Employee", quiet=TRUE)

\donttest{

# all three by (categorical) variables
XY(Years, Salary, facet=c(Dept, Gender), by=Plan, n_axis_y_skip=1)

# vary both shape and color with a least-squares fit line for each group
style(color=c("darkgreen", "brown"))
XY(Years, Salary, facet=Gender, fit="lm", pt_shape=c("W","M"), pt_size=.8)
style("gray")

# compare the men and women Salary according to Years worked
#   with an ellipse for each group
XY(Years, Salary, by=Gender, ellipse=.50)
}


#--------------------------------------------------------------
# facet the bivariate density displays: contour, smooth, hexbin
#   each panel shares a common scale, so panels are comparable
#--------------------------------------------------------------

\donttest{
XY(Years, Salary, form="contour", facet=Gender)
XY(Years, Salary, form="smooth", facet=Gender)
XY(Years, Salary, form="hexbin", facet=Gender)

# suppress the shared count legend of the faceted hexbin
XY(Years, Salary, form="hexbin", facet=Gender, hexbin_legend=FALSE)
}


#--------------------------------------------------------------
# facet with a vector of x (or y) variables: the multi-series
#   overlay repeated across the panels of the facet variable
#--------------------------------------------------------------

\donttest{
# the Pre and Post overlay against Salary, one panel per Gender level
XY(c(Pre, Post), Salary, facet=Gender)

# the overlay on the y-axis instead: shared Years on the x-axis
XY(Years, c(Pre, Post), facet=Gender, fit="lm")
}



# time charts
#------------
# run chart, with default fill area
XY(.Index, Salary, ts_area_fill="on")

# two run charts in same panel
# or could do a multivariate time series
XY(.Index, c(Pre, Post))

# Trellis graphics run chart with custom line width, no points
XY(.Index, Salary, facet=Gender, line_width=3, pt_size=0)

# daily time series plot
# create the daily time series from R built-in data set airquality
#oz.ts <- ts(airquality$Ozone, start=c(1973, 121), frequency=365)
#XY(oz.ts, data=NULL)

# multiple time series plotted from dates and stacked
# black background with translucent areas, then reset theme to default
style(sub_theme="black", color="steelblue2", transparency=.55,
  window_fill="gray10", grid_color="gray25")
date <- seq(as.Date("2013/1/1"), as.Date("2016/1/1"), by="quarter")
x1 <- rnorm(13, 100, 15)
x2 <- rnorm(13, 100, 15)
x3 <- rnorm(13, 100, 15)
df <- data.frame(date, x1, x2, x3)
rm(date); rm(x1); rm(x2); rm(x3)
XY(date, x1:x3, data=df)
style()

# aggregate monthly data to plot by quarter
n.q <- 42
month <- seq(as.Date("2013/1/1"), length=n.q, by="months")
x <- rnorm(n.q, 100, 15)
XY(month, x, ts_unit="quarters", data=NULL)


# trigger a time series with a Date variable specified first
# stock prices for three companies by month:  Apple, IBM, Intel
d <- rd("StockPrice")
# only plot Apple
XY(Month, Price, filter=(Company=="Apple"))
# Trellis plots, one for each company
XY(Month, Price, facet=Company, n_col=1)
# all three plots on the same panel, three shades of blue
XY(Month, Price, by=Company, color="blues")
# exponential smoothing forecast for next 12 months, 
#   aggregate monthly data by mean over quarters
XY(Month, Price, ts_ahead=12, ts_unit="quarters")

\donttest{


#------------
# annotations
#------------

d <- Read("Employee")

# add text at the one location specified by x1 and x2
XY(Years, Salary, add="Hi There", x1=12, y1=80000)
# add text at three different specified locations
XY(Years, Salary, add="Hi", x1=c(12, 16, 18), y1=c(80000, 100000, 60000))

# add three different text blocks at three different specified locations
XY(Years, Salary, add=c("Hi", "Bye", "Wow"), x1=c(12, 16, 18),
  y1=c(80000, 100000, 60000))

# add an 0.95 data ellipse and horizontal and vertical lines through the
#  respective means
XY(Years, Salary, ellipse=0.95, add=c("v_line", "h_line"),
  x1="mean_x", y1="mean_y")
# can be done also with the following short-hand
XY(Years, Salary, ellipse=0.95, add="means")

# a rectangle requires two points, four coordinates, <x1,y1> and <x2,y2>
style(add_trans=.8, add_fill="gold", add_color="gold4", add_lwd=0.5)
XY(Years, Salary, add="rect", x1=12, y1=80000, x2=16, y2=115000)

# the first object, a rectangle, requires all four coordinates
# the vertical line at x=2 requires only an x1 coordinate, listed 2nd
XY(Years, Salary, add=c("rect", "v_line"), x1=c(10, 2),
  y1=80000, x2=12, y2=115000)

# two different rectangles with different locations, fill colors and translucence
style(add_fill=c("gold3", "green"), add_trans=c(.8,.4))
XY(Years, Salary, add=c("rect", "rect"),
  x1=c(10, 2), y1=c(60000, 45000), x2=c(12, 75000), y2=c(80000, 55000))
}

\donttest{



#---------------
# function curve
#---------------

x <- seq(10,50,by=2)
y1 <- sqrt(x)
y2 <- x**.33
# x is sorted with equal intervals so run chart by default
XY(x, y1, data=NULL)

# multiple plots from variable vectors need to have the variables
#  in a data frame
d <- data.frame(x, y1, y2)
# if variables are in the user workspace and in a data frame
#   with the same names, the user workspace versions are used,
#   which do not work with vectors of variables, so remove
rm(x); rm(y1); rm(y2)
XY(x, c(y1, y2))
}
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ plot }
\keyword{ color }
\keyword{ grouping variable }

\name{print.out_all}
\alias{print.out_all}

\title{Display All Text Output from a Saved List Object}

\description{
Displays all the results saved as an \code{R} list into an object from a \code{lessR} analysis.  An example of a saved object is \code{r} in \code{r <- reg(Y ~ X)}. The results are displayed at the console or integrated into a \code{knitr} analysis, for example from \code{RStudio}. This function is usually implicitly accessed by the user simply by entering the name of the saved object at the console or in a \code{knitr} file.
}

\usage{
\method{print}{out_all}(x, \dots)
}


\arguments{
  \item{x}{The list of components to display.}
  \item{\dots}{Other parameter values.}
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Regression}}
}

\examples{
# read internal data set
d <- rd("Employee", quiet=TRUE)
# do the summary statistics
s <- ss_brief(Salary)
# display all the output, print function is implicit
s
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ print.out_all}

\name{rescale}
\alias{rescale}

\title{Rescale a Variable}

\description{
Rescale a variable to either z-scores with a mean of 0 and standard deviation of 1, normalized with a minimum of 0 and a maximum of 1, or to a variable computed like a z-score except use the median in place of the mean and the IQR in place of the standard deviation.
}

\usage{
rescale(x, data=d, kind="z", digits_d=3)
}

\arguments{
  \item{x}{Variable to rescale.}
  \item{data}{Data frame that contains \code{x}.}
  \item{kind}{Type of rescaling.}
  \item{digits_d}{Number of significant digits.}
}

\details{
The default rescaling is standardization to z-scores, explicit with \code{kind} set to \code{"z"}, or just centering about the mean with \code{"center"}. For the min-max normalization to a range from 0 to 1, set \code{kind} to \code{"0to1"}. For the robust equivalent of standardization, set \code{kind} to \code{"robust"}. 

If \code{x} is a vector in the global environment, then set \code{data} to \code{NULL}.
}

\value{
The rescaled data.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{scale}}.
}

\examples{

# z-score for m01 
d <- Read("Employee")

d[, .("Salary")] 
x <- rescale(Salary)
x
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ rescale }

\name{order_by}
\alias{order_by}

\title{order_by the Rows of a Data Frame}

\description{
Sorts the values of a data frame according to the values of one or more variables contained in the data frame, or the row names.  Variable types include numeric and factor variables.  Factors are sorted by the ordering of their values, which, by default is alphabetical. Sorting by row names is also possible.
}

\usage{
order_by(data=d, by, direction=NULL, quiet=getOption("quiet"), \dots)
}

\arguments{
  \item{data}{The name of the data frame from which to create the subset, which
       is \code{d} by default.}
  \item{by}{One or more variables to be sorted, or just the character string 
       \code{row.names} or \code{random}.}
  \item{direction}{Default is ascending for all variables listed in \code{by}.
       Or, specify a list of \code{"+"} for ascending and \code{"-"} for
       descending, one for each variable to be sorted.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
       with \code{\link{style}} function.}
  \item{\dots}{Other parameter values.}
}

\details{
\code{order_by} sorts the rows of a data frame and lists the first five rows of the sorted data frame. Specify the values upon which to base the sort with the required \code{by} parameter. If not all sorted variables are sorted in ascending order, then also specify a sequence of \code{"+"} for ascending and \code{"-"} for descending, respectively, one for each variable to be sorted. If \code{row.names} or \code{random} is specified, then no other variables can be specified.

A list of consecutive variables can be specified using the colon notation, such as Years:Salary  To specify a list of multiple variables, or \code{"+"} and \code{"-"} signs, or sets of variables, separate each set of variables or each sign by a comma, then invoke the R combine or \code{\link{c}} function. For example, if three variables are to be sorted, the first two ascending and the last descending, then specify, \code{direction=c("+","+","-")}.

\code{order_by} is based on the standard R function \code{\link{order}}, though  the \code{order_by} function allows for the sorting of factors, whereas \code{\link{order}} does not.
}

\value{
The sorted data frame is returned, usually assigned the name of \code{d} as in the examples below.  This is the default name for the data frame input into the \code{lessR} data analysis functions.
}
\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{order}}.
}

\examples{
# construct data frame
d <- read.table(text="Severity Description
1 Mild
4 Moderate
3 Moderate
2 Mild
1 Severe", header=TRUE)

# sort the data frame called d according to Severity
#   in ascending order
d <- order_by(d, Severity)

# sort Description in descending order, sort Severity within
#  each level of Description in ascending order
d <- order_by(d, c(Description, Severity), direction=c("-", "+"))  

# sort by row names in ascending order
d <- order_by(d, row.names)

# randomly re-shuffle the rows of data
d <- order_by(d, random)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ sort }

\name{ttest}
\alias{ttest}
\alias{tt}
\alias{tt_brief}

\title{Generic Method for t-test and Standardized Mean Difference with Enhanced Graphics}

\description{
Abbreviation: \code{tt}, \code{tt_brief}

Provides enhanced output from the standard \code{\link{t.test}} function applied to the analysis of the mean of a single variable, or the independent groups analysis of the mean difference, from either data or summary statistics. Includes the analysis of a dependent-groups analysis from the data. The data can be in the form of a data frame or separate vectors of data, one for each group. This output includes the basic descriptive statistics, analysis of assumptions and the hypothesis test and confidence interval. For two groups the output also includes the analysis for both with and without the assumption of homogeneous variances, the pooled or within-group standard deviation, and the standardized mean difference or Cohen's \emph{d} and its confidence interval.

The output from data for two groups introduces the \acronym{ODDSMD} plot, which displays the Overlapping Density Distributions of the two groups as well as the means, mean difference and Standardized Mean Difference. The plot also includes the results of the descriptive and inferential analyses. For the dependent-groups analysis, a scatter plot of the two groups of data also is produced, which includes the diagonal line through the scatter plot that represents equality, and a line segment for each point in the scatter plot which is the vertical distance from the point to the diagonal line to display the amount of change.

Can also be called from the more general \code{\link{model}} function.
}

\usage{
ttest(x=NULL, y=NULL, data=d, filter=NULL, paired=FALSE,

         n=NULL, m=NULL, s=NULL, mu=NULL, 
         n1=NULL, n2=NULL, m1=NULL, m2=NULL, s1=NULL, s2=NULL, 

         Ynm="Y", Xnm="X", X1nm="Group1", X2nm="Group2", xlab=NULL, 

         brief=getOption("brief"), digits_d=NULL, conf_level=0.95,
         alternative=c("two_sided", "less", "greater"),
         mmd=NULL, msmd=NULL, Edesired=NULL, 

         show_title=TRUE, full_curve=TRUE, bw1="bcv", bw2="bcv", pt_size=0.8,
         fill=NULL, area_fill="on",

         graph=TRUE, line_chart=FALSE, quiet=getOption("quiet"),
         width=5, height=5, pdf_file=NULL, \dots)       

tt_brief(\dots)

tt(\dots)
}

\arguments{
  \item{x}{A \code{\link{formula}} of the form Y ~ X, where Y is the
        numeric response variable compared across the two groups, and X is a
        grouping variable with two levels that define the corresponding groups,
        or, if the data are submitted in the form of two vectors, the responses
        for the first group. Either side of the formula, or a vector
        argument, may also be an expression of variables, such as
        \code{log(Salary) ~ Gender}, evaluated against the data frame, then
        the user's workspace, with the expression text as the label.}
  \item{y}{If \code{x} is not a formula, the responses for the second group,
        otherwise \code{NULL}. May also be an expression of variables, as
        for \code{x}.}
  \item{data}{Data frame that contains the variable of interest, default is \code{d}.}
  \item{filter}{A logical expression that specifies a subset of rows of
        the data frame to analyze.}
  \item{paired}{Set to \code{TRUE} for a dependent-samples t-test with two data
        vectors or variables from a data frame, with the difference computed
        from subtracting the first vector from the second.}
  \item{n}{Sample size for one group.}
  \item{m}{Sample size for one group.}
  \item{s}{Sample size for one group.}
  \item{mu}{Hypothesized mean for one group. If not present, then confidence interval only.}
  \item{n1}{Sample size for first of two groups.}
  \item{n2}{Sample size for second of two groups.}
  \item{m1}{Sample mean for first of two groups.}
  \item{m2}{Sample mean for second of two groups.}
  \item{s1}{Sample standard deviation for first of two groups.}
  \item{s2}{Sample standard deviation for second of two groups.}
  \item{Ynm}{Name of response variable.}
  \item{Xnm}{Name of predictor variable, the grouping variable or factor with exactly
        two levels.}
  \item{X1nm}{Value of grouping variable, the level that defines the first group.}
  \item{X2nm}{Value of grouping variable, the level that defines the second group.}
  \item{xlab}{x-axis label, defaults to variable name, or, if present, variable label.}
  \item{brief}{If set to \code{TRUE}, reduced text output. Can change system default with \code{\link{style}} function.}
  \item{digits_d}{Number of decimal places for which to display numeric values_ Suggestion only.}
  \item{conf_level}{Confidence level of the interval, expressed as a proportion.}
  \item{alternative}{Default is \code{"two_sided"}. Other values are \code{"less"}
       and \code{"greater"}.}
  \item{mmd}{Minimum Mean Difference of practical importance, the difference of the
       response variable between two group means. The concept is optional, and
       only one of mmd and msmd is provided.}
  \item{msmd}{For the Standardized Mean Difference, Cohen's d, the Minimum value of
       practical importance. The concept is optional, and only one of mmd and msmd
       is provided.}
  \item{Edesired}{The desired margin of error for the needed sample size
       calculation for a 95\% confidence interval, based on Kupper and Hafner (1989).}
  \item{fill}{Fill color(s) for the density curve(s). For a one-group
       analysis, a single color. For a two-group analysis, a vector of
       two colors, one per group.}
  \item{area_fill}{Fill the area under each density curve (plotly). Default
       \code{"on"}; set to \code{"off"} (or \code{"transparent"}) for lines
       only.}
  \item{show_title}{Show the title on the graph of the density functions for
       two groups.}
  \item{full_curve}{For the default \code{TRUE}, the density curve(s) extends
        beyond the data range as determined by the kernel bandwidth.
        If \code{FALSE}, the curve is truncated at the range of the data.}
  \item{bw1}{Bandwidth for the computation of the densities for the first group.}
  \item{bw2}{Bandwidth for the computation of the densities for the second group.}
  \item{pt_size}{Size of plotted points for the paired t-test Cleveland dot plot of 
       differences.}
  \item{graph}{If \code{TRUE}, then display the graph of the overlapping density distributions.}
  \item{line_chart}{Plot the run chart for the response variable for each group
        in the analysis.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
       with \code{\link{style}} function.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{pdf_file}{Name of the pdf file to which the density graph is redirected.
       Also specifies to save the line charts with pre-assigned names if they
       are computed.}
  \item{\dots}{Further arguments to be passed to or from methods.}
}

\details{
OVERVIEW\cr
If \code{n} or \code{n1} are set to numeric values, then the analysis proceeds from the summary statistics, the sample size and mean and standard deviation of each group. Missing data are counted and then removed for further analysis of the non-missing data values_  Otherwise the analysis proceeds from data, which can be in a data frame, by default named \code{d}, with a grouping variable and response variable, or in two data vectors, one for each group.

Following the format and syntax of the standard \code{\link{t.test}} function, to specify the two-group test with a formula, \code{\link{formula}}, the data must include a variable that has exactly two values, a grouping variable or factor generically referred to as X, and a numerical response variable, generically referred to as Y. The formula is of the form Y ~ X, with the names Y and X replaced by the actual variable names specific to a particular analysis.  The formula method automatically retrieves the names of the variables and data values for display on the resulting output.

The values of the response variable Y can be organized into two vectors, the values of Y for each group in its corresponding vector. When submitting data in this form, the output is enhanced if the actual names of the variables referred to generically as X and Y, as well as the names of the levels of the factor X, are explicitly provided. 

For the output, when computed from the data the two groups are automatically arranged so that the group with the larger mean is listed as the first group.  The result is that the resulting mean difference, as well as the standardized mean difference, is always non-negative.

The inferential analysis in the full version provides both homogeneity of variance and the Welch test which does not assume homogeneity of variance. Only a two-sided test is provided.  The null hypothesis is a population mean difference of 0.

If computed from the data, the bandwidth parameter controls the smoothness of the estimated density curve.  To obtain a smoother curve, increase the bandwidth from the default value.

DATA\cr
If the input data frame is named something different than \code{d}, then specify the name with the \code{data} option.  Regardless of its name, the data frame need not be attached to reference the variable directly by its name without having to invoke the d$name notation. 

PRACTICAL IMPORTANCE\cr
The practical importance of the size of the mean difference is addressed when one of two parameter values are supplied, the minimum mean difference of practical importance, mmd, or the corresponding standardized version, msmd.  The  remaining value is calculated and both values are added to the graph and the console output.

DECIMAL DIGITS\cr
The number of decimal digits is determined by default from the largest number of decimal digits of the entered descriptive statistics.  The number of decimal digits is then set at that value, plus one more with a minimum of two decimal digits by default.  Or, override the default with the \code{digits_d} parameter.

VARIABLE LABELS\cr
If variable labels exist, then the corresponding variable label is by default listed as the label for the horizontal axis and on the text output. For more information, see \code{\link{Read}}.

PDF OUTPUT\cr
To obtain pdf output, use the \code{pdf_file} option, perhaps with the optional \code{width} and \code{height} options. These files are written to the default working directory, which can be explicitly specified with the R \code{\link{setwd}} function.
}

\value{
Returned value is NULL except for a two-group analysis from a formula.  Then the values for the response variable of the two groups are separated and returned invisibly as a list for further analysis as indicated in the examples below. The first group of data values is the group with the largest sample mean.
\item{value1}{Value of the grouping variable for the first group.}
\item{group1}{Data values for the first group.}
\item{value2}{Value of the grouping variable for the second group.}
\item{group2}{Data values for the second group.}
}


\references{
Gerbing, D. W. (2023). \emph{R Data Analysis without Programming: Explanation and Interpretation}, 2nd edition, Chapters 6 and 7, NY: Routledge.

Kupper and Hafner (1989). The American Statistician, 43(2):101-105.
}


\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{t.test}}, \code{\link{density}}, \code{\link{plot.density}}, \code{\link{ttestPower}}, \code{\link{formula}}.
}

\examples{
# ----------------------------------------------------------
# tt for two groups, from a formula
# ----------------------------------------------------------

d <- Read("Employee", quiet=TRUE)


# analyze data with formula version
# variable names and levels of X are automatically obtained from data
# although data frame not attached, reference variable names directly
ttest(Salary ~ Gender)

# expression as the response, evaluated against the data frame,
#   with the expression text as the label
ttest(log(Salary) ~ Gender)

# short form
#tt(Salary ~ Gender)

# brief version of results
tt_brief(Salary ~ Gender)

# return the vectors group1 and group2 into the object t.out
# separate the data values for the two groups and analyze separately
Y <- rnorm(100)
ttest(Y, data=NULL)
t.out <- ttest(Salary ~ Gender)
X(group1, data=t.out)
X(group2, data=t.out)

# compare to standard R function t.test
t.test(d$Salary ~ d$Gender, var.equal=TRUE)

# consider the practical importance of the difference
ttest(Salary ~ Gender, msmd=.5)

# obtain the line chart of the response variable for each group
ttest(Salary ~ Gender, line_chart=TRUE)

# variable of interest is in a data frame which is not the default d
# access the data frame in the lessR dataLearn data set
# although data not attached, access the variables directly by their name
data(dataLearn)
ttest(Score ~ StudyType, data=dataLearn)


# ----------------------------------------------------------
# tt for a single group, from data
# ----------------------------------------------------------

# summary statistics, confidence interval only, from data
ttest(Salary)

# confidence interval and hypothesis test, from data
ttest(Salary, mu=52000)

# just with employees with salaries less than $100,000
ttest(Salary, mu=52000, filter=(Salary < 100000))


# -------------------------------------------------------
# tt for two groups from data stored in two vectors 
# -------------------------------------------------------

# create two separate vectors of response variable Y
# the vectors exist are not in a data frame
#   their lengths need not be equal
Y1 <- round(rnorm(n=10, mean=50, sd=10),2)
Y2 <- round(rnorm(n=10, mean=60, sd=10),2)

# analyze the two vectors directly
# usually explicitly specify variable names and levels of X
#   to enhance the readability of the output
ttest(Y1, Y2, Ynm="MyY", Xnm="MyX", X1nm="Group1", X2nm="Group2", data=NULL)

# dependent groups t-test from vectors in global environment
ttest(Y1, Y2, paired=TRUE, data=NULL)

# dependent groups t-test from variables in data frame d
d <- data.frame(Y1,Y2)
rm(Y1);  rm(Y2)
ttest(Y1, Y2, paired=TRUE)
# independent groups t-test from variables (vectors) in a data frame
ttest(Y1, Y2)


# -------------------------------------------------------
# tt from summary statistics
# -------------------------------------------------------

# one group: sample size, mean and sd
# optional variable name added
tt(n=34, m=8.92, s=1.67, Ynm="Time")

# confidence interval and hypothesis test, from descriptive stats
# get rid of the data frame, analysis should still proceed
rm(d)
tt_brief(n=34, m=8.92, s=1.67, mu=9, conf_level=0.90)

# two groups: sample size, mean and sd for each group
# specify the briefer form of the output
tt_brief(n1=19, m1=9.57, s1=1.45, n2=15, m2=8.09, s2=1.59)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ t.test }
\keyword{ smd }

\name{xNum}
\alias{xNum}

\title{Text Processing: Convert a Number to a Word}

\description{Converts a number to a word. Primarily for internal use in text processing of \code{knitr} output. Not usually referenced by the user.
}

\usage{
  xNum(x) 
}


\arguments{
  \item{x}{The integer to convert.}
}


\details{
Input is an integer, or coerced to integer after rounding. For integers from 0 to 12, output is the single English word. For values larger than 12, or negative, the integer is just converted to character format.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\examples{
xNum(5)
}

\name{simCImean}
\alias{simCImean}

\title{Pedagogical Simulation for the Confidence Interval of the Mean}

\description{
Show a sequence of confidence intervals, all calculated from repeated samples of simulated data from the same normal population, and show which intervals contain the true population mean.
}

\usage{
simCImean(ns, n, mu=0, sigma=1, cl=0.95, seed=NULL, 
         show_data=FALSE, show_title=TRUE, 
         miss_only=FALSE, color_hit="gray40", color_miss="red",
         grid="grey90", ylim_bound=NULL, pause=FALSE,
         main=NULL, pdf_file=NULL, width=5, height=5, \dots)
}


\arguments{
  \item{ns}{Number of samples, that is, repetitions of the experiment.}
  \item{n}{Size of each sample.}
  \item{mu}{Population mean.}
  \item{sigma}{Population standard deviation.}
  \item{cl}{Confidence level.}
  \item{seed}{Default seed is the R default. Enter a positive integer value
       to obtain a reproducible result, the same result for the same seed.}\cr

  \item{show_data}{Plot the data for each sample over the confidence interval.}
  \item{show_title}{Place a title on the graph that contains the parameter values_}
  \item{miss_only}{For the text output, only display information for samples
        that missed the mean.}
  \item{color_hit}{Color of the confidence intervals that contains the mean.}
  \item{color_miss}{Color of the confidence intervals that miss the mean.}
  \item{grid}{Color of the grid lines.}
  \item{ylim_bound}{Specify the maximum deviation of the mean in either direction
        for the extent of the vertical axis_}
  \item{pause}{Build the graph and the text output, pausing after each
        confidence interval.}
  \item{main}{Title of graph.}\cr

  \item{pdf_file}{Name of optional pdf file to which graphics are redirected.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}\cr

  \item{\dots}{Other parameter values.} 
}


\details{
Simulate random normal data and display the resulting confidence intervals, with or without the data overlaid on each confidence interval. Highlight confidence intervals that miss the underlying population mean.}


\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\examples{
# 25 confidence intervals with a sample size each of 100
# mu=0, sigma=1, that is, sample from the standard normal
simCImean(25, 100)

# set the seed for a reproducible result with the same seed
simCImean(25, 100, seed=43)

# 25 confidence intervals with a sample size each of 100
# mu=100, sigma=15
# overlay the data over each confidence interval
simCImean(25, 100, mu=100, sigma=15, show_data=TRUE)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ confidence interval }

\name{Flows}
\alias{Flows}
\title{Sankey Flow Diagram (2- or 3-Stage) with Plotly}

\description{
Create a Sankey flow diagram between source and target categories with weighted links that visualizes movement of volume between categorical stages. Supports either two stages (A -> B) or three stages (A -> B -> C). Flows (links) are colored by the leftmost source category and retain that color across all legs. Node fills can be neutral gray or (by default) the left/source nodes can inherit the flow colors while intermediate and right nodes remain gray. In RStudio, the visualization renders in the \code{Viewer} pane.}

\usage{
Flows(
  value,
  stage1,
  stage2,
  stage3 = NULL,
  data = d,
  # appearance
  title = NULL,
  fill = NULL,
  link_alpha = 0.55,
  nodes_gray = FALSE,
  neutral_gray = "gray80",
  border_gray  = "gray60",
  lift_y = 0,
  labels_size = 1.00,
  digits_d = 0
)
}

\arguments{
  \item{stage1}{Column name for the left (source) stage. May be given unquoted (recommended) or as a character string.}
  \item{stage2}{Column name for the middle (or right, in 2-stage) stage. Unquoted or character string.}
  \item{stage3}{Optional column name for the right stage (3-stage). If \code{NULL}, a 2-stage diagram is created. Unquoted or character string.}
  \item{value}{Column name with non-negative weights (e.g., counts, volume, tonnage) used to determine link thickness. Unquoted or character string.}
  \item{data}{A data frame containing the stages and the weight column. If \code{NULL}, the function will look for the columns in the calling environment.}

  \item{title}{Optional chart title. If \code{NULL}, a title is constructed from the provided stage names.}
  \item{fill}{Optional color range name or vector used for \emph{source} categories. If \code{NULL} (default), the range is inherited from the current theme via \code{.color_range(.get_fill(getOption("theme")), n.x)}, where \code{n.x} is the number of unique \code{stage1} categories.}
  \item{link_alpha}{Numeric from 0 to 1. Transparency for flows (links). Default \code{0.55}.}
  \item{nodes_gray}{Logical. If \code{FALSE} (default), left/source nodes are colored (matching their flows) and all other nodes are neutral gray. If \code{TRUE}, all nodes are neutral gray.}
  \item{neutral_gray}{Color for gray node fills. Defaults to \code{"gray80"}.}
  \item{border_gray}{Color for node borders. Defaults to \code{"gray60"}.}
  \item{lift_y}{Proportion of vertical shift of the displayed chart.
        Positive values lift the chart upward.}
  \item{labels_size}{Size of displayed labels, with 0.90 the default.}
  \item{digits_d}{Integer number of decimals for link values shown in the hover. Default \code{0}.}
}

\details{
\strong{Flow semantics}\cr
\code{Flows} is intended for directional flows where the width of each band represents the amount moving from one category to the next (e.g., supply chain, traffic, energy, user funnels). It is \emph{not} a general association plot for arbitrary cross-tabulations without directional meaning. For hierarchical composition without directional flow, consider \code{\link{Chart}} with parameter \code{type} set to \code{"sunburst"}, \code{"treemap"}, \code{"radar"}, or \code{"pie"} instead.

\strong{Color mapping}\cr
Flows are colored by the \emph{leftmost} source category (\code{stage1}). In a 3-stage diagram, colors are carried from \code{stage1} through \code{stage2} to \code{stage3} so each link retains its origin color. When \code{nodes_gray = FALSE} (default), only source nodes inherit the flow colors; middle and right nodes are neutral gray. When \code{nodes_gray = TRUE}, all nodes are gray. If \code{fill} is \code{NULL}, colors are drawn from the current lessR theme (\code{getOption("theme")}) via \code{.get_fill()} and \code{.color_range()}.

\strong{Layout}\cr
Nodes are arranged in fixed columns: left = \code{stage1}, middle = \code{stage2}, right = \code{stage3} (if provided). Vertical positions are spaced evenly within each column. The diagram prints automatically in interactive sessions and returns a Plotly htmlwidget (invisibly) for programmatic use.
}

\value{
An object of class \code{htmlwidget} (Plotly). The widget prints
automatically in interactive sessions; otherwise it is returned (invisibly) for
further composition or saving.
}

\seealso{
\code{\link{Chart}} for other Plotly-based charts in \pkg{lessR}, including
\code{type="bar"}, \code{type="sunburst"}, \code{"treemap"}, \code{"pie"}, \code{"radar"}, and \code{"bubble"}. \code{X} and \code{XY} also create Plotly-based charts.
}

\author{
David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})
}

\examples{
\dontshow{if (interactive()) \{ }
# Example data: Source -> Port -> Destination with volumes
SupplyChain <- data.frame(
  Source      = c("China","China","China","Germany","Germany",
                  "Brazil","Brazil","USA","USA"),
  Port        = c("Los Angeles","Seattle","Houston","New York","Baltimore",
                  "Miami","Houston","Los Angeles","Miami"),
  Destination = c("Portland","Chicago","Dallas","Boston","Philadelphia",
                  "Atlanta","Dallas","San Francisco","Atlanta"),
  Volume      = c(320,180,150,220,130,200,100,170,140)
)

# 3-stage: Source -> Port -> Destination
Flows(Volume, Source, Port, Destination, data=SupplyChain)

# 2-stage: Source -> Destination, ignore Port
Flows(Volume, Source, Desination, data=SupplyChain)

# All nodes neutral gray
Flows(Volume, Source, Port, Destination, data=SupplyChain,
       nodes_gray=TRUE, link_alpha=0.6)

# Supply a specific range (overrides theme), show one decimal in hover
Flows(Volume, Source, Port, Destination, data=SupplyChain,
       fill="blues", digits_d=1)
\dontshow{\} }
}

\name{ANOVA}
\alias{ANOVA}
\alias{av}
\alias{av_brief}

\title{Analysis of Variance}

\description{
Abbreviation: \code{av}, \code{av_brief}

Analysis of variance from the R \code{\link{aov}} function plus graphics and effect sizes. Included designs are one-way between groups, two-way between groups and randomized blocks with one treatment factor with one observation for each treatment and block combination. 

Output is generated into distinct segments by topic, organized and displayed in sequence by default. When the output is assigned to an object, such as \code{a} in \code{a <- reg(Y ~ X)}, the full or partial output can be accessed for later analysis and/or viewing. A primary such analysis is with \code{knitr} for dynamic report generation. The input instructions to \code{knitr} are written comments and interpretation with embedded \code{R} code, called R~Markdown.  Generate a complete, though preliminary at this time, R Markdown document from the \code{Rmd} option ready to knit. Simply specify the option with a file name, run the ANOVA function to create the file. Then open the newly created \code{.Rmd} file in \code{RStudio} and click the \code{knit} button to create a formatted document that consists of the statistical results and interpretative comments. See the sections \code{arguments}, \code{value} and \code{examples} for more information. 
}

\usage{
ANOVA(my_formula, data=d, filter=NULL,
         brief=getOption("brief"), digits_d=NULL, 
         Rmd=NULL, jitter_x=0.4,
         res_rows=NULL, res_sort=c("zresid", "fitted", "off"),
         quiet=getOption("quiet"), 
         graphics=TRUE, pdf=FALSE, width=5, height=5,
         fun_call=NULL, \dots)

av(\dots)

av_brief(\dots, brief=TRUE) 
}


\arguments{
  \item{my_formula}{Standard R \code{\link{formula}} for specifying a model.
       Use an asterisk, \code{*}, separating the two factors for a two-way ANOVA,
       and a plus, \code{+}, separating the factors for a randomized blocks ANOVA
       with the blocking factor listed second.
       A term of the formula may also be an expression of variables in the
       data frame, such as \code{log(Salary) ~ cut(Years, 3)}, with the
       expression text as the term label. An expression for a factor must
       produce categories, such as with \code{cut()} or \code{factor()}.}
  \item{data}{The default name of the data frame that contains the data for analysis 
       is \code{d}, otherwise explicitly specify.}
  \item{filter}{A logical expression that specifies a subset of rows of the data frame
       to analyze.}
  \item{brief}{If set to \code{TRUE}, reduced text output with no Tukey multiple 
       comparison of means and no residuals. Can change system default
       with \code{\link{style}} function.}
  \item{digits_d}{For the Basic Analysis, it provides the number of decimal digits.
        For the rest of the output, it is a suggestion only.}
  \item{Rmd}{File name for the file of R Markdown instructions to be written,
        if specified. The file type is .Rmd, which automatically opens in RStudio,
        but it is a simple text file that can be edited with any text editor,
        including RStudio.}
  \item{jitter_x}{Amount of horizontal jitter for points in the scatterplot
        of levels and response variable for a one-way ANOVA.}
  \item{res_rows}{Default is 20, which lists the first 20 rows of data and residuals
       sorted by the specified sort criterion.  To disable residuals, specify a 
       value of 0. To see the residuals output for all observations, specify a 
       value of \code{"all"}.}
  \item{res_sort}{Default is \code{"zresid"}, for specifying standardized residuals
       as the sort criterion for the display of the rows of data and associated
       residuals. Other values are \code{"fitted"} for the fitted values and
      \code{"off"} to not sort the rows of data.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
       with \code{\link{style}} function.}
  \item{graphics}{Produce graphics. Default is \code{TRUE}.  In \code{Rmd} can
        be useful to set to \code{FALSE} so that \code{\link{regPlot}} can be used
        to place the graphics within the output file.}
  \item{pdf}{Indicator as to if the graphic files should be saved as pdf files
       instead of directed to the standard graphics windows.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{fun_call}{Function call. Used with \code{Rmd} to pass the function call when
        obtained from the abbreviated function call \code{av}.}
  \item{\dots}{Other parameter values for R function \code{\link{lm}} which provides the core computations.} 
}


\details{
OVERVIEW\cr
The one-way ANOVA with Tukey HSD and corresponding plot is based on the R functions \code{\link{aov}}, \code{\link{TukeyHSD}}, and provides summary statistics for each level. Two-factor ANOVA also provides an interaction plot of the means with \code{\link{interaction.plot}} as well as a table of means and other summary statistics. The two-factor analysis can be between groups or a randomized blocked design. Residuals are displayed by default. Tukey HSD comparisons and residuals are not displayed if \code{brief=TRUE}.
       
The \code{filter} parameter subsets rows (cases) of the input data frame according to a logical expression. Use the standard R operators for logical statements as described in \code{\link{Logic}} such as \code{&} for and, \code{|} for or and \code{!} for not, and use the standard R relational operators as described in \code{\link{Comparison}} such as \code{==} for logical equality \code{!=} for not equals, and \code{>} for greater than. See the Examples.

MODEL SPECIFICATION\cr
In the following specifications, Y is the response variable, X is a treatment variable and Blocks is the blocking variable. The distinction between the one-way randomized blocks and the two-way between groups models is not the variable names, but rather the delimiter between the variable names. Use \code{*} to indicate a two-way crossed between groups design and \code{+} for a randomized blocks design.\cr
one-way between groups: \code{ANOVA(Y ~ X)}\cr
one-way randomized blocks: \code{ANOVA(Y ~ X + Blocks)}\cr
two-way between groups: \code{ANOVA(Y ~ X1 * X2)}\cr
For more complex designs, use the standard R function \code{\link{aov}} upon which \code{ANOVA} depends.

BALANCED DESIGN\cr
For a two-way between groups design, a balance check is performed on the cell sample sizes. A balanced design, with equal cell sizes, is analyzed with the standard sequential (Type I) sums of squares. An unbalanced design, with unequal cell sizes, is automatically analyzed with Type II sums of squares, with the choice noted in the output. The randomized blocks design assumes a single observation for each combination of the treatment and blocking factors.

DECIMAL DIGITS\cr
The number of decimal digits displayed on the output is, by default, the maximum number of decimal digits for all the data values of the response variable. Or, this value can be explicitly specified with the \code{digits_d} parameter.
}


\value{
The output can optionally be returned and saved into an \code{R} object, otherwise it simply appears at the console. The components of this object are redesigned in \code{lessR} version 3.3.5 into (a) pieces of text that form the readable output and (b) a variety of statistics. The readable output are character strings such as tables amenable for viewing and interpretation. The statistics are numerical values amenable for further analysis, such as to be referenced in a subsequent R Markdown document. The motivation of these two types of output is to facilitate R markdown documents, as the name of each piece, preceded by the name of the saved object followed by a $, can be inserted into the R markdown document (see \code{examples}).

TEXT OUTPUT\cr
\code{out_background}: variables in the model, rows of data and retained\cr
1-predictor: \code{out_descriptive}: descriptive stats\cr
2-predictors: \code{out_cell.n}: cell sample size\cr
2-predictors: \code{out_cell.means}: cell means\cr
2-predictors: \code{out_cell.marginals}: marginal means\cr
2-predictors: \code{out_cell.gm}: grand mean\cr
2-predictors: \code{out_cell.sd}: cell standard deviations\cr
\code{out_anova}: analysis of variance summary table\cr
\code{out_effects}: effect sizes\cr
\code{out_hsd}: Tukey's honestly significant different analysis\cr
\code{out_res}: residuals\cr
\code{out_plots}: list of plots generated if more than one\cr

Separated from the rest of the text output are the major headings, which can then be deleted from custom collations of the output.
\code{out_title_bck}: BACKGROUND\cr
\code{out_title_des}: DESCRIPTIVE STATISTICS\cr
\code{out_title_basic}: BASIC ANALYSIS\cr
\code{out_title_res}: RESIDUALS\cr

STATISTICS\cr
\code{call}: function call that generated the analysis\cr
\code{formula}: model formula that specifies the model\cr
\code{n_vars}: number of variables in the model\cr
\code{n_obs}: number of rows of data submitted for analysis\cr
\code{n_keep}: number of rows of data retained in the analysis\cr
1-predictor: \code{p_value}: p-value for the overall F-test
\code{residuals}: residuals\cr
\code{fitted}: fitted values\cr

Although not typically needed for analysis, if the output is assigned to an object named, for example, \code{a}, then the complete contents of the object can be viewed directly with the \code{\link{unclass}} function, here as \code{unclass(a)}. Invoking the \code{\link{class}} function on the saved object reveals a class of \code{out_all}. The class of each of the text pieces of output is \code{out}.
}


\references{
Gerbing, D. W. (2023). \emph{R Data Analysis without Programming: Explanation and Interpretation}, 2nd edition, Chapters 8 and 9, NY: Routledge.

Gerbing, D. W. (2021). Enhancement of the Command-Line Environment for use in the Introductory Statistics Course and Beyond, \emph{Journal of Statistics and Data Science Education}, 29(3), 251-266, https://www.tandfonline.com/doi/abs/10.1080/26939169.2021.1999871. 
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\seealso{
\code{\link{aov}}, \code{\link{TukeyHSD}}, \code{\link{interaction.plot}}
}

\examples{


# access the PlantGrowth data frame
ANOVA(weight ~ group, data=PlantGrowth)
#brief version
av_brief(weight ~ group, data=PlantGrowth)

# drop the second treatment, just control and 1 treatment
ANOVA(weight ~ group, data=PlantGrowth, filter=(group != "trt2"))

# variables of interest in a data frame that is not the default d
# two-factor between-groups ANOVA with replications and interaction
# warpbreaks is a data set provided with R
ANOVA(breaks ~ wool * tension, data=warpbreaks)

# expression as a term of the model, evaluated against the data
#   frame, with the expression text as the term label
# an expression for a factor must produce categories, as with cut()
ANOVA(log(breaks) ~ tension, data=warpbreaks)

# randomized blocks design with the second term the blocking factor
#   data from Gerbing(2014, Sec 7.3.1)

# Each person is a block. Each person takes four weight-training 
#   supplements on different days and then count the repetitions
#   of the bench presses.
d <- read.csv(header=TRUE, text="
Person,sup1,sup2,sup3,sup4
p1,2,4,4,3
p2,2,5,4,6
p3,8,6,7,9
p4,4,3,5,7
p5,2,1,2,3
p6,5,5,6,8
p7,2,3,2,4")

# reshape data from wide form to long form
# do not need the row names
d <- reshape(d, direction="long",
        idvar="Person", v.names="Reps",
        varying=list(2:5), timevar="Supplement")
rownames(data) <- NULL

ANOVA(Reps ~ Supplement + Person)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ regression }

\name{dataFreqTable99}
\docType{data}
\alias{dataFreqTable99}
\title{Data: Joint Frequency Table}

\description{
Based on a survey of university students, the joint frequencies for two variables are reported. One variable is Race and the other is undergraduate Class.

\code{
 Level Asian Latino Black White
    FR    33     58     6   105
    SO    41     79     9   207
    JR    86    179    27   484
    SR   143    214    31   824
}

The data file consists just of the frequencies, the numbers, without any labels.
}

\usage{data(dataFreqTable99)}
\format{A table of joint frequencies or Race and Level.

Race: Asian, Latino, Black, White\cr
Class: FR, SO, JR, SR\cr
}

\source{author}
\keyword{datasets}

\name{dataStockPrice}
\docType{data}
\alias{dataStockPrice}
\title{Data: Stock price of Apple, IBM and Intel from 1985 through May of 2024}

\description{Monthly adjusted stock price of Apple, IBM and Intel from 1985 through May of 2024 from finance.yahoo.com.}

\usage{data(dataStockPrice)}

\format{A data table in long format with four variables: Month, Company, Price, and Volume. The variable Month is a date expression expressed in the ISO standard as a four-digit year, followed by the two-digit month, then the two-digit day, separated by dashes. A total of 1419 rows, 473 rows per company.}

\source{author}
\keyword{datasets}

\name{Transform}
\alias{Transform}

\title{Deprecated: Transform the Values of an Integer or Factor Variable}

\description{
This function is deprecated. Instead use base R  transform() function or just enter the transformation formula directly. Example, \code{d$Xsq <- d$X^2} to create a squared version of Variable X in the d data frame.

A wrapper for the base R \code{\link{transform}} function that defaults to the d data frame and provides output regarding the specified transformation(s). 
}

\usage{
Transform(data=d, quiet=getOption("quiet"), \dots)
}

\arguments{
  \item{data}{The name of the data frame from which to create the subset, which
       is \code{d} by default.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
       with \code{\link{style}} function.}
  \item{\dots}{The list of transformations, each of the form, \code{variable = equation}. Each \code{variable} can be the name of an existing variable in the data frame or a newly created variable.}
}

\details{
The first five rows of the data frame are listed before the transformation, and the first five values of the transformed variables are listed after the transformation. The default input data frame is \code{d}.

Guidance and feedback regarding the transformations are provided by default. The first five lines of the input data frame are listed before the transformation, then the specified transformations are listed, followed by the first five lines of the transformed data frame.

Multiple transformations can be defined with a single statement. Note that a newly created transformed variable cannot then be used to define another transformed variable in the same \code{Transform()} function call.  Instead, the transformed variable that depends on an earlier created transformed variable must be defined in its own \code{Transform()} function call.
}

\value{
The transformed data frame is returned, usually assigned the name of \code{d} as in the examples below.  This is the default name for the data frame input into the \code{lessR} data analysis functions.
}
\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{transform}}, \code{\link{factor}}.
}

\examples{
# construct data frame
d <- read.table(text="Status Severity
1 Mild
4 Moderate
3 Moderate
2 Mild
1 Severe", header=TRUE)

# replace Status with a transformed version
d <- Transform(Status=Status-1)

# replace Status with a transformed version
# leave input d unmodified
# save transformed data frame to the created data frame called newdata
newdata <- Transform(Status=Status-1)

# construct data frame
# recode Status into a factor
d <- Transform(Status=factor(Status, labels=c("OK","Hurts","Painful","Yikes")))

# read lessR data set dataEmployee into data frame d
d <- Read("Employee")
# multiple transformations in one statement
#  Months is a new variable
#  Salary is a new version of the old Salary
#  JobSat was read as non-numeric, so as a factor, but is also ordinal
#  Plan was read as numeric values 0,1,2, now converted to a factor
d <- Transform(
  Months=Years*12, 
  Salary=Salary/1000,
  Plan=factor(Plan,
     levels=c(0,1,2), labels=c("GoodHealth", "YellowCross", "BestCare"))
)
# new variable Months now exists
# if relevant, supply a corresponding variable label
# d <- label(Months, "Months Employed in the Company")
# confirm
db()


# ----------------------------
# transformations with factors
# ----------------------------

# transform a nominal variable to ordinal, re-order the categories
d <- Transform(JobSat=
  factor(JobSat, levels=c("low", "med", "high"), ordered=TRUE))

# recode levels of a factor that should remain a factor
#   with the Transform and factor functions
# using Recode destroys the factor attribute, converting to
#   character strings instead, so Recode does not allow
d <- Read("Employee")
d <- Transform(
    Gender=factor(Gender, levels=c("F", "M"), labels=c("Female", "Male"))
)

# recode levels of a factor to convert to integer first by
#   converting to integer with Transform and as.numeric
# here Gender has values M and F in the data
# integers start with 1 through the number of levels, can use
#    Recode to change this if desired, such as to 0 and 1
# Gender is now a factor to illustrate
d <- Transform(Gender=as.numeric(Gender))
d <- recode(Gender, old=c(1,2), new=c(0,1))

# recode integer values to levels of a factor with value labels
#   with the Transform function instead of Recode
# here Gender has values 0 and 1 in the data
d <- Read("Mach4")
d <- Transform(
      Gender=factor(Gender, levels=c(0,1), labels=c("Male","Female"))
      )
# ----------------------------
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ transform }

\name{to}
\alias{to}

\title{Create a Sequence of Numbered Variable Names with a Common Prefix and Width}

\description{
Generates sequentially numbered variable names, all starting with the same prefix, usually in conjunction with reading data values into R. The advantage over the standard R function  \code{\link{paste0}} is that \code{to} maintains equal widths of the names, such as m08 instead of m8 if some values are m10 or larger up to m99.
}

\usage{
to(prefix, until, from=1, same_size=TRUE, \dots)
}


\arguments{
  \item{prefix}{Character string that begins each variable name.}
  \item{until}{Last name in the sequence, the one with the last number.}
  \item{from}{First name in the sequence, the one with the initial number.}
  \item{same_size}{If \code{TRUE}, pads the beginning of each number for the variable
        name with leading zeros so that all names are of the same width.}
  \item{\dots}{Other parameter values.}
}


\details{
Some data sets, particularly those from surveys, have sequentially numbered variable names, each beginning with the same prefix, such as the first later of the name of a set of related attitude items. This function generates the string of such variable names, generally intended for use in a \code{read} statement for reading the data and then naming the variables, or for a subsequent assignment of the names with a \code{\link{names}}. Relies upon the R \code{\link{paste}} function.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{paste}}.
}

\examples{
# generate: "m01" "m02" "m03" "m04" "m05" "m06" "m07" "m08" "m09" "m10"
to("m", 10)

# generate: "m1"  "m2"  "m3"  "m4"  "m5"  "m6"  "m7"  "m8"  "m9"  "m10"
to("m",10, same_size=FALSE)
# equivalent to standard R function
paste0("m", 1:10)

# generate a 10 x 10 data frame
d <- data.frame(matrix(rnorm(100), nrow=10))
# name the variables in the data frame
names(d) <- to("m", 10)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ names }

\name{Merge}
\alias{Merge}
\alias{mrg}

\title{Merge Two Data Frames Horizontally or Vertically}

\description{
Abbreviation: \code{mrg}

A horizontal merge combines data frames horizontally, that is, adds variables (columns) to an existing data frame, such as with a common shared ID field. Performs the horizontal merge based directly on the standard R \code{\link{merge}} function. The vertical merge is based on the \code{\link{rbind}} function in which the two data frames have the same variables but different cases (rows), so the rows build vertically, stacked on top of each other. 

The advantages of this \code{lessR} function is that it provides a single function for merging data frames, adds text output to the standard R functions that provide feedback regarding properties of the merge, and provides more detailed and presumably more useful error messages.

}

\usage{
Merge(data1, data2, by=NULL, quiet=getOption("quiet"), \dots)

mrg(\dots)
}

\arguments{
  \item{data1}{The name of the first data frame from which to create the merged 
       data frame.}
  \item{data2}{The name of the second data frame from which to create the merged 
       data frame.}
  \item{by}{If a variable specified, then signals a horizontal merge with the
       ID field by which the data frames are merged as an inner join, that is,
       only rows of data are retained that both match on the ID. Specify
       \code{"rows"} to merge vertically.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
       with \code{\link{style}} function.}
  \item{\dots}{Additional arguments available in the base R \code{\link{merge}}
       function such as \code{all.x=TRUE} for an left outer join, which retains
       all rows of the first data frame even if not matched by a row in the
       second data table. Specify a right outer join with \code{all.y=TRUE}
       and a full outer join, in which all records from both data frames are
       retained, with \code{all=TRUE}.}
}

\details{
\code{Merge} creates a merged data frame from two input data frames.

If \code{by} is specified the merge is horizontal. That is the variables in the second input data frame are presumed different from the variables in the first input data frame. The merged data frame is the combination of variables from both input data frames, with the rows aligned by the value of \code{by}, an ID field common to both data frames. The result is a \emph{natural join}, a specific instance of an \emph{inner join} in which merging occurs according a common variable.

Invoke \code{\link{merge}} parameters \code{all.x}, \code{all.y}, and \code{all}, set to \code{TRUE} for the corresponding condition. These parameters set, respectively, a \emph{left-outer join}, \emph{right-outer join}, and a \emph{outer join} in which all records from both data frames are retained regardless if a matching row in the other data frame. 

Set \code{by} to \code{"rows"} for a vertical merge. The variables are presumed the same in each input data frame.  The merged data frame consists of the rows of both input data frames. The rows of the first data frame are stacked upon the rows of the second data frame. 

Guidance and feedback regarding the merge are provided by default. The first five lines of each of the input data frames are listed before the merge operation, followed by the first five lines of the output data frame.
}

\value{
The merged data frame is returned, usually assigned the name of \code{d} as in the examples below. This is the default name for the data frame input into the \code{lessR} data analysis functions.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{merge}}, \code{\link{rbind}}.
}

\examples{
# Horizontal
#-----------
d <- Read("Employee", quiet=TRUE)
Emp1a <- d[1:4, .(Years, Gender, Dept, Salary)]
Emp1b <- d[1:4, .(JobSat, Plan)]
# horizontal merge
d <- Merge(Emp1a, Emp1b, by="row.names")
# suppress output to console
d <- Merge(Emp1a, Emp1b, by="row.names", quiet=TRUE)

# Vertical
#---------
d <- Read("Employee", quiet=TRUE)
Emp2a <- d[1:4,]
Emp2b <- d[7:10,]
# vertical merge
d <- Merge(Emp2a, Emp2b, by="rows")


}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ merge }

\name{simMeans}
\alias{simMeans}

\title{Pedagogical Simulation of Sample Means over Repeated Samples}

\description{
Show a sequence of sample means and data, all simulated from the same normal population. Useful for developing an intuition for developing an informal confidence interval, that is, specifying a likely range of values that contain the true population mean, but without a formal probability.
}

\usage{
simMeans(ns, n, mu=0, sigma=1, seed=NULL, 
         show_title=TRUE, show_data=TRUE, max_data=10, 
         grid="grey90", ylim_bound=NULL, pause=FALSE,
         sort=NULL, set_mu=FALSE, digits_d=2,
         main=NULL, pdf_file=NULL, width=5, height=5, \dots)
}


\arguments{
  \item{ns}{Number of samples, that is, repetitions of the experiment.}
  \item{n}{Size of each sample.}
  \item{mu}{Population mean.}
  \item{sigma}{Population standard deviation.}
  \item{seed}{Default seed is the R default. Enter a positive integer value
       to obtain a reproducible result, the same result for the same seed.}\cr

  \item{show_title}{Place a title on the graph that contains the parameter values_}
  \item{show_data}{Show the data values on the text output.}
  \item{max_data}{Maximum number of data values per sample on the text output.}
  \item{grid}{Color of the grid lines.}
  \item{ylim_bound}{Specify the maximum deviation of the mean in either
        direction for the extent of the vertical axis_}
  \item{pause}{Build the graph and the text output sample by sample.}\cr

  \item{sort}{Sort the output by the means in ascending order. By default is
       \code{TRUE} unless \code{se.mu} or \code{pause} is \code{TRUE}.}
  \item{set_mu}{Have the program randomly set \code{mu} and \code{sigma},
       usually to guess the correct value.}
  \item{digits_d}{Sort the output by the means in ascending order.}
  \item{main}{Title of graph.}\cr

  \item{pdf_file}{Name of the pdf file to which graphics are redirected.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{\dots}{Other parameter values.} 
}


\details{
Simulate random normal data and display the resulting sample means, both as text output and graphic output.

If \code{pause=TRUE}, then the true population values are not revealed as the simulation progresses. These values are saved in the user's workspace and can be revealed by entering their names at the user prompt, \code{mu} and \code{sigma}. 
}


\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\examples{
# 8 samples, each with a sample size of 10
# mu=0, sigma=1, that is, sample from the standard normal
simMeans(8, 10)

# 25 sample means with a sample size each of 100
# mu=100, sigma=15
# pause after each interval and show the data
simMeans(25, 100, mu=100, sigma=15, show_data=FALSE)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ confidence interval }

\name{prob_znorm}
\alias{prob_znorm}

\title{Plot a Normal Curve with Shaded Intervals by Standard Deviation}

\description{
Display a normal curve with shading according to the z-score, the number of standard deviations from the mean.
}

\usage{
prob_znorm(mu=0, sigma=1, color_border="gray10",
         r=.10, g=.34, b=.94, a=.20,
         xlab="", ylab="", main="", 
         y_axis=FALSE, z=TRUE, axis_size=.9,
         pdf_file=NULL, width=5, height=5, \dots)
}


\arguments{
  \item{mu}{Population mean of normal distribution.}
  \item{sigma}{Population standard deviation of normal distribution.}
  \item{color_border}{Color of the border of the normal curve.}
  \item{r}{Red component of fill color, from 0 to 1.}
  \item{g}{Green component of fill color, from 0 to 1.}
  \item{b}{Blue component of fill color, from 0 to 1.}
  \item{a}{Alpha component of fill color, that is, the transparency, from 0 to 1.}
  \item{xlab}{Label for the horizontal axis_}
  \item{ylab}{Label for the optional vertical axis_}
  \item{main}{Label for the graph title.}
  \item{y_axis}{If \code{TRUE}, then a vertical axis is included.}
  \item{z}{If \code{TRUE}, then include z-values on the horizontal-axis_
       Set to \code{FALSE} if \code{mu=0} and \code{sigma=1}.}
  \item{axis_size}{Magnification factor for the axis labels, the value of
       \code{axis_cex}.}
  \item{pdf_file}{Name of the pdf file to which graphics are redirected.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{\dots}{Other parameter values for graphics.}
}

\details{
Provide a normal curve with shading of each interval defined by the number of standard deviations from the mean.  The layers are written with transparency, and over-written so that the middle interval is the darkest and the most extreme intervals, beyond three standard deviations from the mean, are the lightest.  Specify \code{a=0} to turn off the colors.  Higher values of the alpha channel, as specified by \code{a}, yield darker colors. Specify \code{a=1} for the same solid color for all intervals. 

The normal densities are calculated with \code{\link{dnorm}} and plotted with \code{\link{plot}}.
}


\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\seealso{
\code{\link{dnorm}}, \code{\link{plot}}.
}


\examples{
# Mu=0, Sigma=1: Standard normal 
prob_znorm()

# distribution for height of American women, mu=65.5, sigma=2.5
prob_znorm(65.5, 2.5, xlab="Height of American Women")

# do a red fill color
prob_znorm(65.5, 2.5, r=.9, xlab="Height of American Women")
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ probability }

\name{factors}
\alias{factors}

\title{Create Factor Variables Across a Sequential Range or Vector of Variables}

\description{Creates factors for many variables. Specify a range from a given \code{start} variable and \code{end} variable.  Applies only to variables in a data frame, \code{d} by default, and outputs the entire data frame including the factor transformation.
}

\usage{
factors(x, levels, labels=NULL, data=d, ordered=FALSE,
          new=FALSE, suffix="_f", var_labels=FALSE, \dots)
}


\arguments{
  \item{x}{Name of variable(s) to convert to a factor. List a single
        variable or a vector}
  \item{levels}{Levels for which to define the factor.}
  \item{labels}{Value labels to assign to the levels. If not
        present then assumes the character version of the levels.}
  \item{data}{The data frame of interest.}
  \item{ordered}{If \code{FALSE}, factor levels are not ordered.}
  \item{new}{If \code{FALSE}, original variables are replaced,
        otherwise new factor variables are created.}
  \item{suffix}{The appended suffix to newly created variables from 
        the original variable names when \code{new} is \code{TRUE}.}
  \item{var_labels}{Just create new variable labels for newly created
        factor variables, without doing a factor conversion,
        presumably after a previous run with factors converted to new
        factor variables.}
  \item{\dots}{Other parameter values_}
}

\details{
Returns the entire data frame if applied to one or more variables in a data frame, including the new factors. 
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\examples{
# get the data, variables Gender plus m01 through m20, 20 Mach IV items
# coded as integers from 0 to 5 on 6-pt Likert scales
d <- rd("Mach4", quiet=TRUE)

# single variable converted to a factor
d <- factors(Gender, 0:1, c("Male", "Female"))

# Define the labels
LikertCats <- c("Strongly Disagree", "Disagree", "Slightly Disagree",
                "Slightly Agree", "Agree", "Strongly Agree")

# Convert the integer responses to factors for the 20 Mach IV items
d <- factors(m01:m20, levels=0:5, labels=LikertCats)

# read the data again and this time also the variable labels
d <- rd("Mach4", quiet=TRUE)
l <- rd("Mach4_lbl")

# convert specified variables to factors according to the given vector
#   of three variables only
# leave the original variables unmodified, create new variables
d <- factors(c(m06, m07, m20), levels=0:5, labels=LikertCats, new=TRUE)
# now copy the variable labels from the original integer variables to the 
#   newly created factor variables
l <- factors(c(m06, m07, m20), var_labels=TRUE)
}

\name{X}
\alias{X}
\alias{Histogram}
\alias{hs}
\alias{Density}
\alias{BoxPlot}
\alias{bx}
\alias{ViolinPlot}
\alias{vp}

\title{Univariate and Grouped Displays for a Continuous Variable}

\description{

\code{lessR} introduces the concept of an \emph{analytic view} visualization function, in which the choice of visualization function directly reflects the structure of the data and the analyst's intent for understanding the data. The function \code{X()} visualizes the distribution of a continuous variable along with
associated summary statistics. The specific representation is selected with the
\code{form} argument:

\itemize{
  \item Histogram with \code{form = "histogram"} (default)
  \item Density plot with \code{form = "density"}
  \item Box plot with \code{form = "box"}
  \item Violin plot with \code{form = "violin"}
  \item Strip (one-dimensional scatter) plot with \code{form = "strip"}
  \item Integrated violin-box-strip (VBS) plot with \code{form = "vbs"}
}

Stratification divides the distribution into groups.
Use \code{by} to overlay the groups within a single panel, or \code{facet} to
display each group, or combination of groups, in separate panels.

When running in RStudio, static displays appear in the
\code{Plots} window, while histograms and density plots also appear as
interactive Plotly visualizations in the \code{Viewer} window.
}

\usage{
X(

    # ----------------------------------------------
    # Data from which to construct the visualization
    x, data=d, filter=NULL,

    # ----------------------------------------------------
    # Stratification: Same (by) or separate panels (facet)
    by=NULL,
    facet=NULL, n_row=NULL, n_col=NULL, aspect="fill",

    # ---------------------------------------
    # Geometric forms of distributional plots
    form = c("histogram", "freq_poly", "density",
             "violin", "box", "strip", "bs", "vbs"), # violin, box, strip

    stat=c("count", "proportion"),

    # -----------------------------------------------------------------
    # Analogy of physical Marks on paper that create the bars and labels
    theme=getOption("theme"),
    fill=getOption("bar_fill_cont"),
    color=getOption("bar_color_cont"),
    transparency=getOption("trans_bar_fill"),
    area_fill="on",

    # -----------------------------------------------------
    # Form of the histogram - bin the continuous variable x
    counts=FALSE, 
    bin_start=NULL, bin_width=NULL, bin_end=NULL, breaks="Sturges",
    cumulate=c("off", "on", "both"), reg="snow2",  # Cumulative histogram

    # -----------------------------------------------------
    # Density (smooth curve) plot
    show_histogram=TRUE,
    bandwidth=NULL, kind=c("general", "normal", "both"),
    full_curve=TRUE,
    fill_normal=NULL, fill_hist=getOption("se_fill"),
    color_normal="gray20", line_width=NULL,
    x_pt=NULL, y_axis=FALSE,
    rug=FALSE, color_rug="black", size_rug=0.5,

    # -------------------------------------------------
    # Integrated violin/box/strip plot
    vbs_plot="vbs", vbs_ratio=0.9, bw=NULL, bw_iter=10,
    violin_fill=getOption("violin_fill"),
    box_fill=getOption("box_fill"),
    pt_size=NULL,
    vbs_pt_fill="black",
    vbs_mean=FALSE, fences=FALSE, k=1.5, box_adj=FALSE, a=-4, b=3,
    jitter_x=NULL, jitter_y=NULL,

    ID="row.name", ID_size=0.60,
    out_cut=0, out_shape="circle", out_size=1,

    # -----------------------------------------------------------------
    # Labels for axes, values, and legend if x and by variables, margins
    xlab=NULL, ylab=NULL, main=NULL, sub=NULL,
    lab_adjust=c(0,0), margin_adjust=c(0,0,0,0),

    rotate_x=getOption("rotate_x"), rotate_y=getOption("rotate_y"),
    offset=getOption("offset"),
    scale_x=NULL,
    axis_fmt=c("K", ",", ".", ""), axis_x_pre="", axis_y_pre="",
    font_size=1,

    # ----------------------------------------------------------------------
    # Draw one or more objects, text, or geometric figures, on the histogram
    add=NULL, x1=NULL, y1=NULL, x2=NULL, y2=NULL,

    # ---------------------------------------
    # Output: turn off, chart to PDF file, decimal digits, markdown file
    quiet=getOption("quiet"), do_plot=TRUE,
    use_plotly=getOption("lessR.use_plotly"),
    pdf_file=NULL, width=6.5, height=6,
    digits_d=NULL, Rmd=NULL,

    # ---------------------------------
    # Other
    eval_df=NULL, fun_call=NULL, \dots)
}

\arguments{
  \item{x}{Variable(s) to analyze. May be a single numeric variable, a vector
        in the workspace, multiple variables combined with \code{\link{c}},
        or an entire data frame. If omitted, defaults to all numeric variables
        in the data frame \code{d}.}
  \item{data}{Data frame that contains one or both of \code{x} and
        \code{y}. Default data frame is \code{d}. Specify \code{NULL} if
        the variables for the analysis are in the global environment instead.}
  \item{filter}{A logical expression or a vector of integers that specify the
        row numbers to retain, defining a subset of rows of the data frame to
        analyze.}\cr

  \item{by}{A \emph{grouping variable}, a categorical variable that provides
        separate group profiles of the primary numeric variable \code{x}
        on the \emph{same} plot.
        Only one \code{by} variable is permitted, as the resulting visual clutter
        compromises interpretability.}
  \item{facet}{One categorical variable, or a vector of two categorical
        variables, providing a separate plot of the primary
        variable(s) \code{x} and \code{y} for each level of the variable or
        combination of two levels. Applies only
        to the form \code{form="scatter"}.}
  \item{n_row}{Optional specification for the number of rows
        in the facet layout, a multi-panel display.
        Specify \code{n_col} or \code{n_row}, but not both.}
  \item{n_col}{Optional specification for the number of columns in the
        facet layout. Specify \code{n_col} or \code{n_row}, but not both.
        The default is \code{1}.}
  \item{aspect}{Aspect ratio (height/width) of the panels, applied only to the
       lattice facet forms: scatter and hexbin. The default \code{"fill"} expands
       each panel to occupy the available space (here \code{"fill"} refers to
       filling space, not to the \code{fill} color argument). Set to \code{1}
       for square panels, or \code{"xy"} to bank line slopes toward an effective
       45 degrees. The base-R contour and smooth facets size their panels
       automatically and ignore \code{aspect}.}\cr

  \item{form}{The plotted geometric form. The default is a scatterplot from 
        \code{"scatter"}.
        Additional options include:
        \code{"freq_poly"} (frequency polygon),
        \code{"density"} (kernel density curve),
        \code{"violin"},
        \code{"box"},
        \code{"strip"} (one-dimensional scatter plot),
        \code{"bs"} (box-strip display),
        and \code{"vbs"} (integrated violin-box-strip display).}
  \item{stat}{Specifies the vertical axis content.
        Default is \code{"count"}. Use \code{"proportion"} for relative
        frequencies.}\cr

  \item{theme}{Color theme. Use \code{\link{style}} to set persistent defaults.}
  \item{fill}{Fill color for bars or density regions. May be a single color,
        named palette (\code{"grays"}, \code{"hcl"}, \code{"blues"},
        \code{"reds"}, \code{"greens"}), or custom vector.}
  \item{color}{Border color for bars or density curves. May be a vector.
        Default follows \code{\link{style}}.}
  \item{transparency}{Transparency of filled areas. Default from
        \code{\link{style}}.}
  \item{area_fill}{For a frequency polygon or density curve (single or
        grouped by \code{by}), controls filling the space under each curve.
        Default \code{"on"} draws a translucent fill in each curve's color.
        Set to \code{"off"} (or \code{"transparent"}) for lines only, drawn at
        full opacity; a frequency polygon also marks each vertex with a point
        in the line color. The \code{fill} parameter still sets the
        line/area color.}\cr

  \item{counts}{If \code{TRUE}, display counts for each bin on the histogram.}
  \item{bin_start}{Optional starting value of the first bin.}
  \item{bin_width}{Optional bin width, with or without a specified bin start.}
  \item{bin_end}{Optional value that must fall inside the final bin.}
  \item{breaks}{Method used to compute bins or an explicit set of breakpoints.
        Default is \code{"Sturges"}; options include \code{"Scott"} and
        \code{"FD"}.}\cr

  \item{cumulate}{Produces a cumulative histogram when set to \code{"on"}.
        Use \code{"both"} to superimpose the standard histogram.}
  \item{reg}{Color of the regular histogram when \code{cumulate="both"}.}
  \item{show_histogram}{When plotting a density curve, optionally draw a
        histogram behind it.}
  \item{bandwidth}{Bandwidth for kernel density estimation. Default begins with
        \code{bw.nrd0} but may be iteratively increased for smoother curves.}
  \item{kind}{Determines whether to display the general density curve, the
        normal density curve, or both.}
  \item{full_curve}{For the default \code{TRUE}, the density curve(s) extends
        beyond the data range as determined by the kernel bandwidth.
        If \code{FALSE}, the curve is truncated at the range of the data.}
  \item{fill_normal}{Fill color used for the normal density curve.}
  \item{fill_hist}{Fill color for histograms under density curves.}
  \item{color_normal}{Border color for the normal density curve.}
  \item{line_width}{Line width of density curves.}
  \item{x_pt}{Value on the x-axis from which to illustrate a unit interval
        of density area. Applies when \code{kind = "general"}.}
  \item{y_axis}{If \code{TRUE}, display the density axis.}
  \item{rug}{If \code{TRUE}, draw a rug plot beneath the density curve.}
  \item{color_rug}{Color of rug ticks.}
  \item{size_rug}{Line width of rug ticks.}\cr

  \item{vbs_plot}{Deprecated. Controls which components of the
        violin-box-strip display appear, overriding \code{form} when
        supplied. Characters \code{"v"}, \code{"b"}, and \code{"s"}
        indicate violin, box, and strip components. Upper/lower case
        permitted. Instead use \code{form}, such as \code{form="box"}.
        Adjust colors with \code{\link{style}} parameters such as
        \code{violin_fill}, \code{box_fill}, \code{out_fill}, etc.}
  \item{vbs_ratio}{Relative height of the violin (and box) component.}
  \item{bw}{Bandwidth for violins; larger values yield smoother shapes.}
  \item{bw_iter}{Number of iterations for modifying the bandwidth to produce
        smoother violins.}
  \item{violin_fill}{Fill color for violins.}
  \item{box_fill}{Fill color for box plots.}
  \item{pt_size}{Size of points in strip plots.}
  \item{vbs_pt_fill}{Point color in the strip component of the VBS display.
        Default is black.}
  \item{vbs_mean}{If \code{TRUE}, show the mean in box plots.}
  \item{fences}{If \code{TRUE}, draw Tukey inner fences.}
  \item{k}{IQR multiplier for determining whisker length.}
  \item{box_adj}{If \code{TRUE}, adjust box plot for skewness using medcouple.}
  \item{a, b}{Scaling factors for adjusted boxplot whiskers.}
  \item{jitter_x}{Amount of horizontal jitter.}
  \item{jitter_y}{Amount of vertical jitter.}\cr

  \item{ID}{Variable supplying labels for selected points (outlier
        identification). Defaults to row names.}
  \item{ID_size}{Point label text size.}
  \item{out_cut}{Number or proportion of extreme points to label. Interpreted
        differently for univariate vs. bivariate displays.}
  \item{out_shape}{Plotting symbol for outliers.}
  \item{out_size}{Point size for labeled outliers.}\cr

  \item{xlab}{X-axis label. Defaults to variable name or label.}
  \item{ylab}{Y-axis label. Defaults to "Frequency" or "Proportion".}
  \item{main}{Main title for the plot.}
  \item{sub}{Subtitle (not yet implemented).}
  \item{lab_adjust}{Two-element vector adjusting axis-label positions.}
  \item{margin_adjust}{Four-element vector adjusting plot margins.}\cr

  \item{rotate_x}{Rotation (in degrees) of x-axis tick labels.}
  \item{rotate_y}{Rotation (in degrees) of y-axis tick labels.}
  \item{offset}{Distance between tick labels and axis.}
  \item{scale_x}{Vector specifying start, end, and number of intervals for the
        x-axis.}
  \item{axis_fmt}{Formatting of axis numbers (\code{"K"}, \code{","},
        \code{"."}, or \code{""}).}
  \item{axis_x_pre}{Prefix for x-axis labels (e.g., \code{"$"}).}
  \item{axis_y_pre}{Prefix for y-axis labels.}
  \item{font_size}{Multiplicative scaling factor applied to the font sizes
        of the title (\code{main_size}), axis labels (\code{lab_size}), and
        axis value text (\code{axis_size}) simultaneously, preserving their
        relative proportions. Default is \code{1} (no scaling).}\cr

  \item{add}{Add text or geometric objects (rectangles, lines, arrows,
        horizontal/vertical lines, etc.) to the plot.}
  \item{x1}{First x-coordinate for added objects.}
  \item{y1}{First y-coordinate.}
  \item{x2}{Second x-coordinate (for applicable object types).}
  \item{y2}{Second y-coordinate.}\cr

  \item{quiet}{If \code{TRUE}, suppress textual output.}
  \item{do_plot}{If \code{TRUE}, generate the plot.}
  \item{use_plotly}{If \code{TRUE} (default), draw a Plotly interactive version
        in addition to the static plot.}
  \item{pdf_file}{Optional file name to direct static graphics output to PDF.}
  \item{width}{Width of plot window (inches).}
  \item{height}{Height of plot window (inches).}
  \item{digits_d}{Digits of precision for printed statistics.}
  \item{Rmd}{Name of an R Markdown file to generate containing the analysis.}\cr

  \item{eval_df}{If \code{TRUE}, checks that variables exist in the supplied
        data frame. Default of \code{NULL} determines the setting
        automatically. Set to \code{FALSE} in Shiny or pipe workflows.}
  \item{fun_call}{Function call used internally for knitr compatibility.}\cr

  \item{\dots}{Additional graphics parameters passed to \code{\link{hist}},
        \code{\link{par}}, and related functions (e.g., \code{xlim},
        \code{ylim}, \code{cex.main}, \code{col.main}, \code{cex},
        \code{col.lab}).}
}

\details{
OVERVIEW

\code{X()} implements the univariate, distributional view for numeric variables.
Internally it still relies on the base \code{R} \code{\link{hist}} function
for histogram binning when \code{form = "histogram"}, but extends that core
infrastructure to a larger family of displays including frequency polygons,
kernel density estimates, violin plots, strip plots, and the integrated
violin-box-strip (VBS) display. For histogram-based displays, the
\code{freq} option of \code{\link{hist}} is always set to \code{FALSE}, so
counts, proportions, or densities are controlled through the lessR
arguments (\code{stat} and \code{form}) rather than directly
through \code{\link{hist}}.

For plotting densities, the recommended approach is to use
\code{form = "density"}, which computes and displays a kernel density estimate.
The older usage of \code{stat = "density"} is maintained for backward
compatibility but is not recommended for new code.\cr

VARIABLES AND TRELLIS PLOTS

At a minimum there is one primary numeric variable, \code{x}, which results in a
single univariate display (histogram, density, VBS, etc.). Facet graphics
(also called Trellis graphics), from Deepayan Sarkar's \pkg{lattice} package,
may be requested by supplying one or two categorical conditioning variables
to the \code{facet} argument. A single \code{facet} variable produces one panel
per level of that variable; a two-element vector in \code{facet} produces a
panel for each combination of levels of the two facet variables.

In each panel, the same numeric primary variable \code{x} is displayed,
conditioning on the facet levels. The combination of \code{x} with
\code{facet} thus yields a grid of small multiples that share scales and
styling, facilitating comparisons across subgroups without changing the
underlying analysis.\cr

BOXPLOTS AND THE VBS DISPLAY

For a single variable, the preferred summary display is often the integrated
violin-box-strip (VBS) plot, requested with \code{form = "vbs"}. Only the
violin or only the box portion can be obtained with \code{form = "violin"}
or \code{form = "box"}, with \code{form = "bs"} for box-strip. To view
a boxplot of a continuous variable across the levels of a categorical variable,
either as part of the full VBS plot or alone, there are two primary styles:\cr
1. \code{X(x, by = g, form = "box")}\cr
2. \code{X(x, facet = f, form = "box")}

Both styles convey the same information about numeric-by-category distributions.
The difference is visual: with \code{by}, multiple boxplots appear in a single
panel using the qualitative color palette from \code{\link{getColors}}, with
all hues chosen to be comparable in perceived saturation and brightness. With
\code{facet}, a separate panel is drawn for each group, typically using a
single hue. The same default qualitative colors are used throughout lessR,
including in \code{\link{Chart}}.\cr

DATA

The data may be supplied as a vector from the global environment (user
workspace), as one or more variables within a data frame, or as an entire
data frame. The default input data frame is \code{d}. A different source
data frame may be specified with the \code{data} argument. When multiple
variables are listed, only those of numeric type are analyzed by \code{X()}.

Variables in a data frame are referenced directly by their names; there is no
need to use \code{d$name}, \code{\link{with}}, or \code{\link{attach}}. If a
name exists both as a vector in the global environment and as a variable in
the specified data frame, the vector in the global environment takes
precedence.

To obtain a histogram (or other univariate display) for each numeric variable
in the default data frame \code{d}, call \code{X()} without specifying \code{x}.
For a different data frame, set the \code{data} argument accordingly. To
restrict analysis to a subset of variables, specify them with \code{:} or
\code{\link{c}}, such as \code{m01:m03} or \code{c(m01, m02, m03)}.

The \code{filter} parameter subsets rows (cases) of the input data frame
according to either (a) a logical expression or (b) a vector of integer row
indices. Logical expressions use standard \code{R} logical operators as
described in \code{\link{Logic}} (e.g., \code{\&} for "and", \code{|} for "or",
\code{!} for "not") and relational operators as described in
\code{\link{Comparison}} (e.g., \code{==} for equality, \code{!=} for
inequality, \code{>} for "greater than"). A vector of integers can be created
with standard \code{R} syntax; see the Examples section for illustrations.\cr

COLORS

Colors for individual elements of the plot can be controlled directly through
arguments such as \code{fill} (for areas) and \code{color} (for borders), or
indirectly through the global style system. The \code{\link{style}} function
allows selection of a color theme for the entire analysis. The default theme
is \code{"lightbronze"}, with additional themes such as \code{"gray"} for
grayscale and several color-emphasis themes (e.g., \code{"red"},
\code{"green"}).

For black backgrounds and partially transparent colors, use
\code{style(sub_theme = "black")}. For all color options, including
\code{fill}, a setting of \code{"off"} is equivalent to \code{"transparent"}.

For \code{fill}, you may specify a single color, a vector of colors, or a color
range. Besides standard color names, lessR provides multiple hue-balanced
palettes, including \code{"hues"}, as well as pre-specified ranges
\code{"blues"}, \code{"reds"}, and \code{"greens"}. Standard R palettes
\code{"rainbow"}, \code{"terrain"}, and \code{"heat"} are also available.
Custom ranges can be generated via \code{\link{getColors}}.\cr

HISTOGRAMS AND RELATED OUTPUT

When \code{form = "histogram"}, the output includes a frequency histogram with
lessR's default background and grid styling, along with optional relative
frequency and/or cumulative histograms. Summary statistics and a table of bin
information (bin boundaries, midpoints, counts, proportions, cumulative
counts, and cumulative proportions) are provided as part of the returned
object.

Bin construction can follow the default Sturges rule or be customized via
\code{bin_width}, \code{bin_start}, and \code{bin_end}, or via the
\code{breaks} argument (which can accept numeric vectors or named rules such
as \code{"Scott"} or \code{"FD"} as in \code{\link{hist}}). lessR adds more
informative error checking and guidance when user-specified bins do not fully
span the data or otherwise lead to problematic binning.

If multiple variables are supplied (including a complete data frame), \code{X()}
analyzes each numeric variable in turn. The related \code{\link{CountAll}}
function performs a similar role across mixed types, producing bar charts for
categorical variables and histograms for numeric variables. Faceting via
\code{facet} can be combined with \code{X()} to create trellised displays
across conditioning variables.\cr

VARIABLE LABELS

If variable labels exist (e.g., created by \code{\link{Read}}), they are used
by default for the horizontal axis label and in the text output. Variable
names are still available, but labels provide more descriptive and
publication-ready annotations.\cr

VARIABLES AND EXPRESSIONS

The variable arguments refer by default to names of existing variables,
either in the referenced data frame (such as the default \code{d}) or,
with \code{data=NULL}, in the global environment. The arguments \code{x},
\code{by}, and \code{facet} also accept expressions, evaluated first
against the columns of the data frame, then against the user's workspace.
The expression text serves as the variable label. For example:

\preformatted{
    > X(rnorm(50))              # expression, no data frame needed
    > X(log(Salary))            # Salary resolved from d
    > X(Salary, by=cut(Years, 2))  # expression as the by variable
}

An expression that references a column of the data frame must evaluate
to one value per row of the data frame.

ERROR DETECTION

A common error for beginning users of \code{\link{hist}} is to specify a
sequence of break points that does not fully span the data, often constructed
with \code{\link{seq}}. Base \code{R} then produces a cryptic error. In
contrast, \code{X()} (and the \code{X()} alias) checks for this
problem before calling \code{\link{hist}} and, if detected, issues a more
informative message along with guidance on how to correct the specification.

In addition, full control of the binning is available via \code{bin_width}
and \code{bin_start}. If \code{bin_start} is specified without \code{bin_width},
the bin width is determined by the default Sturges rule.\cr

PDF OUTPUT

To obtain PDF output directly, use the \code{pdf_file} argument, optionally
with \code{width} and \code{height} to control the device size in inches. The
resulting files are written to the current working directory, which can be set
explicitly via \code{\link{setwd}}. This mechanism facilitates high-quality,
publication-ready graphics saved directly from \code{X()}.\cr
}

\value{
The output may be assigned to an \code{R} object; otherwise it is printed directly
to the console. The returned object contains two types of components:

\itemize{
  \item Readable output: character strings such as tables and summaries,
        formatted for display.
  \item Statistics: numerical values suitable for further computation or
        inclusion in dynamic documents.
}

These components are designed to support R Markdown workflows. Any element of the
saved object can be inserted into an R Markdown document by referencing its name,
preceded by the object name and the \code{$} operator (see \code{examples}).  
Only elements relevant to the requested analysis are returned.  
For example, bin proportions appear only when a histogram is requested.

To save the results, assign the output to an object, such as \code{h <- X(Salary)}.
Use \code{names(h)} to view the available components, and display any one by typing, for
example, \code{h$out_freq}. Output can be viewed interactively at the console or embedded in
R Markdown documents along with narrative interpretation.

READABLE OUTPUT\cr
\code{out_suggest}: Suggestions for other similar analyses\cr
\code{out_summary}: Summary statistics\cr
\code{out_freq}: Frequency distribution\cr
\code{out_outliers}: Outlier analysis\cr

STATISTICS\cr
\code{bin_width}: Bin width\cr
\code{n_bins}: Number of bins\cr
\code{breaks}: Breaks of the bins\cr
\code{mids}: Bin midpoints\cr
\code{counts}: Bin counts\cr
\code{prop}: Bin proportions\cr 
\code{cumulate}: Bin cumulative counts\cr 
\code{cprop}: Bin cumulative proportions\cr
}

\references{
Gerbing, D. W. (2023). \emph{R Data Analysis without Programming: Explanation and Interpretation}, 2nd edition, Chapter 5, NY: Routledge.

Gerbing, D. W. (2020). R Visualizations: Derive Meaning from Data, Chapter 4, NY: CRC Press.

Gerbing, D. W. (2021). Enhancement of the Command-Line Environment for use in the Introductory Statistics Course and Beyond, \emph{Journal of Statistics and Data Science Education}, 29(3), 251-266.

Hubert, M. and Vandervieren, E. (2008). An adjusted boxplot for skewed distributions, Computational Statistics and Data Analysis 52, 51865201.

Sarkar, D. (2008). \emph{Lattice: Multivariate Data Visualization with R}. Springer.

Sievert, C. (2020). \emph{Interactive Web-Based Data Visualization with R, plotly, and shiny}. Chapman and Hall/CRC. URL: \url{https://plotly.com/r/}
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{\code{\link{XY}}, \code{\link{Chart}}, \code{\link{getColors}}, \code{\link{style}}.
}

\examples{
# get the data
d <- rd("Employee")

# make sure default style is active
style()

# --------------------
# different histograms
# --------------------

# histogram with all defaults
X(Salary, form="histogram")
# with deprecated alias
X(Salary)

# output saved for later analysis into object h
h <- hs(Salary)
# view full text output
h
# view just the outlier analysis
h$out_outliers
# list the names of all the components
names(h)

# histogram with no borders for the bars
X(Salary, color="off")

# just males employed more than 5 years
X(Salary, filter=(Gender=="M" & Years > 5))

# histogram of an expression, evaluated against the data frame,
#   with the expression text as the variable label
X(log(Salary))

# histogram with red bars, black background, and black border
style(panel_fill="black", fill="red", panel_color="black")
X(Salary)
# or use a lessR pre-defined sequential color palette
#   with some transparency
X(Salary, fill="rusts", color="brown", transparency=.1)

# histogram with purple color theme, translucent gold bars
style("purple", sub_theme="black")
X(Salary)
# back to default color theme
style()

# histogram with specified bin width
# can also use bin_start
X(Salary, bin_width=12000)

# histogram with rotated axis values, offset more from axis
# suppress text output
style(rotate_x=45, offset=1)
X(Salary, quiet=TRUE)
style()

# histogram with specified bin width
X(Salary, bin_width=20000, xlab="My Variable")

# histogram with bins calculated with the Scott method and values displayed
X(Salary, breaks="Scott", counts=TRUE, quiet=TRUE)

# histogram with the number of suggested bins, with proportions
X(Salary, breaks=15, stat="proportion")

# histogram with non-default values for x- and y-axes
d[2,4] <- 45000
X(Salary, scale_x=c(20000,160000,8))

# ----------------
# Trellis graphics
# ----------------
X(Salary, facet=Dept)

# ---------------------
# cumulative histograms
# ---------------------

# cumulative histogram with superimposed regular histogram, all defaults
X(Salary, cumulate="both")

# cumulative histogram plus regular histogram
X(Salary, cumulate="both", reg="mistyrose")

# -------------
# density plots
# -------------

# default density plot
X(Salary, form="density")

# normal curve and general density curves superimposed over histogram
# all defaults
X(Salary, form="density", kind="both")

# display only the general estimated density
#  so do not display the estimated normal curve
# specify the bandwidth for the general density curve
X(Salary, form="density", bandwidth=8000)

# display only the general estimated density and a corresponding
#  interval of unit width around x_pt
X(Salary, form="density", x_pt=40000)

# densities for all specified numeric variables in a list of variables
# e.g., use the combine or c function to specify a list of variables
X(c(Years, Salary), form="density")

# ------------------
# frequency polygons
# ------------------

# frequency polygon, base R and interactive plotly versions
X(Salary, form="freq_poly")

# grouped frequency polygon, one translucent polygon per group (plotly)
X(Salary, by=Dept, form="freq_poly")

# grouped frequency polygon as lines only, no fill under the curve
X(Salary, by=Dept, form="freq_poly", area_fill="off")

# -------------------------------------------------
# histograms for data frames and multiple variables
# -------------------------------------------------

# create data frame, d, to mimic reading data with Read function
# d contains both numeric and non-numeric data
d <- data.frame(rnorm(50), rnorm(50), rnorm(50), rep(c("A","B"),25))
names(d) <- c("X","Y","Z","C")

# although data not attached, access the variable directly by its name
X(X)

# histograms for all numeric variables in data frame called d
# d is the default name, so does not need to be specified with data
X()

# histogram with specified options, including red axis labels
style(fill="palegreen1", panel_fill="ivory", axis_color="red") 
X(counts=TRUE)
style()  # reset

# histograms for all specified numeric variables
# use the combine or c function to specify a list of variables
X(c(X,Y))

# integrated violin/box/scatter plot (VBS)
d <- Read("Employee")
X(Salary, form="vbs")

X(Years, by=Gender, pt_size=1.25,
     fill=c("olivedrab3", "gold1"),
     color=c("darkgreen", "gold4"), form="vbs")

\donttest{

# by variable, different colors for different values of the variable
# two panels
X(Salary, facet=Dept)

# large sample size
x <- rnorm(10000)
X(x, data=NULL)

# custom colors for outliers, which might not appear in this subset data
style(out_fill="hotpink", out2_fill="purple")
X(Salary, form="vbs")
style()

# no violin plot or scatterplot, just a boxplot
X(Salary, form="box")

# -----------
# annotations
# -----------

d <- rd("Employee")

# Place a message in the top-right of the graph
# Use \n to indicate a new line
X(Salary, add="Salaries in our Company", x1=100000, y1=7)

# Use style to change some parameter values
style(add_trans=.8, add_fill="gold", add_color="gold4",
      add_lwd=0.5, add_size=1.1)
# Add a rectangle around the message centered at <100000,7>
X(Salary, add=c("rect", "Salaries in our Company"),
      x1=c(82000, 100000), y1=c(7.7, 7), x2=118000, y2=6.2)
}
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ histogram }
\keyword{ color }

\name{Logit}
\alias{Logit}
\alias{lr}

\title{Logit Regression Analysis}

\description{
Abbreviation: \code{lr}

A wrapper for the standard R \code{\link{glm}} function with \code{family="binomial"}, automatically provides a logit regression analysis with graphics from a single, simple function call with many default settings, each of which can be re-specified.  By default the data exists as a data frame with the default name of \code{d}, such as data read by the \code{lessR} \code{Read} function.  Specify the model in the function call according to an R \code{\link{formula}}, that is, the response variable followed by a tilde, followed by the list of predictor variables, each pair separated by a plus sign.

The response variable for analysis has values only of 0 and 1, with 1 designating the reference group. If the response variable is a factor with two levels, the factor levels are automatically converted to a numeric variable with values of 0 and 1.

Default output includes the inferential analysis of the estimated coefficients and model, sorted residuals and Cook's Distance, and sorted fitted values for existing data or new data.  For a single predictor variable model, the scatterplot of the data with plotted logit function is provided.

Can also be called from the more general \code{\link{model}} function.
}

\usage{
Logit(my_formula, data=d, filter=NULL, ref_group=NULL,
     pt_size=0.9, transparency=0.8,
     digits_d=4, text_width=120,

     brief=getOption("brief"),

     res_rows=NULL, res_sort=c("cooks","rstudent","dffits","off"),
     pred=TRUE, pred_all=FALSE, prob_cut=0.5, cooks_cut=1,

     X1_new=NULL, X2_new=NULL, X3_new=NULL, X4_new=NULL,
     X5_new=NULL, X6_new=NULL,

     xlab=NULL, ylab=NULL,
     pdf_file=NULL, width=5, height=5, \dots)

lr(\dots)
}


\arguments{
  \item{my_formula}{Standard R \code{\link{formula}} for specifying a model.
       For example, for a response variable named Y and two predictor variables,
       X1 and X2, specify the corresponding linear model as Y ~ X1 + X2.
       A term of the formula may also be an expression of variables, such as
       Y ~ log(X1), evaluated against the data frame, with the expression
       text as the term label. Because the operators \code{+}, \code{*}, and
       \code{^} express model structure within a formula, enclose an
       expression that applies them arithmetically in \code{\link{I}()},
       as in \code{I(X1^2)} for the square of X1.}
  \item{data}{The default name of the data frame that contains the data
       for analysis is \code{d}, otherwise explicitly specify.}
  \item{filter}{A logical expression that specifies a subset of rows of
       the data frame to analyze.}
  \item{ref_group}{Value of the response variable that is the reference group, 
       otherwise set by default as the value that yields a \code{+} slope
       for one predictor variable or the largest alphabetical/numerical
       value if more than one predictor.}
  \item{pt_size}{Size of the plotted points of the scatterplot for a
       one-predictor model.}
  \item{transparency}{Transparency level of the plotted points of the
       scatterplot, from 0 to 1 for full transparency.}
  \item{digits_d}{For the Basic Analysis, it provides the number of decimal
       digits. For the rest of the output, it is a suggestion only.}
  \item{text_width}{Width of the text output at the console.}\cr

  \item{brief}{If set to \code{TRUE}, reduced text output. Can change system
       default with \code{\link{style}} function.}\cr

  \item{res_rows}{Default is 25, which lists the first 25 rows of data sorted
       by the specified sort criterion.  To turn this option off, specify a
       value of 0. To see the output for all observations, specify a value of
       \code{"all"}.}
  \item{res_sort}{Default is \code{"cooks"}, for specifying Cook's distance as
       the sort criterion for the display of the rows of data and associated
       residuals. Other values are \code{"rstudent"} for the value of
       \code{\link{rstudent}}, which for the logit model is the standardized
       Pearson residual, the Pearson residual divided by
       \code{sqrt(1 - hat)}, \code{"dffits"}, and \code{"off"} to not
       provide the analysis.}
  \item{pred}{Default is \code{TRUE}, which, produces confidence and prediction
       intervals for each row, or selected rows, of data.}
  \item{pred_all}{Default is \code{FALSE}, which produces prediction intervals
       only for the first, middle and last five rows of data.}
  \item{prob_cut}{Probability threshold for classifying an observation into the
       reference group (1) or not (0), applied to the forecasts with prediction
       intervals as well as to the confusion matrix. Can be a vector, in which
       case if multiple predictors, the forecasts are for a threshold of 0.5,
       then the confusion matrices according to the specified values. If a single
       specified value, then both the forecasts and the one confusion matrix are
       computed with that value.}
  \item{cooks_cut}{Cutoff value of Cook's Distance at which observations with a
       larger value are flagged in red and labeled in the resulting scatterplot
       of Residuals and Fitted Values. Default value is 1.0.}\cr

  \item{X1_new}{Values of the first listed predictor variable for which
       forecasted values and corresponding prediction intervals are calculated.}
  \item{X2_new}{Values of the second listed predictor variable for which
       forecasted values and corresponding prediction intervals are calculated.}
  \item{X3_new}{Values of the third listed predictor variable for which
       forecasted values and corresponding prediction intervals are calculated.}
  \item{X4_new}{Values of the fourth listed predictor variable for which
       forecasted values and corresponding prediction intervals are calculated.}
  \item{X5_new}{Values of the fifth listed predictor variable for which
       forecasted values and corresponding prediction intervals are calculated.}
  \item{X6_new}{Values of the sixth listed predictor variable for which
       forecasted values and corresponding prediction intervals are calculated.}\cr

  \item{xlab}{x-axis label, name of the x-variable by default.}
  \item{ylab}{y-axis label, name of the y-variable by default.}
  \item{pdf_file}{Name of the pdf file to which graphics are redirected.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}\cr

  \item{\dots}{Other parameter values for R function \code{\link{glm}} which provides the core computations.}
}



\details{
OVERVIEW\cr
\code{Logit} combines the following function calls into one, as well as provide ancillary analyses such as graphics, organizing output into tables and sorting to assist interpretation of the output. The basic analysis successively invokes several standard R functions beginning with the standard R function for estimation of the logit model, \code{\link{glm}} with \code{family="binomial"}. The output of the analysis is stored in the object \code{lm.out}, available for further analysis in the R environment upon completion of the \code{Logit} function. By default automatically provides the analyses from the standard R functions, \code{\link{summary}}, \code{\link{confint}} and \code{\link{anova}}, with some of the standard output modified and enhanced. The residual analysis invokes \code{\link{fitted}}, \code{\link{resid}}, \code{\link{rstudent}}, and \code{\link{cooks.distance}} functions.  The option for prediction intervals calls the standard generic R function \code{\link{predict}}.

The default analysis provides the model's parameter estimates and corresponding hypothesis tests and confidence intervals, goodness of fit indices, the ANOVA table, analysis of residuals and influence as well as the fitted value and standard error for each observation in the model.

DATA\cr
The name \code{d} is by default provided by the \code{\link{Read}} function included in this package for reading and displaying information about the data in preparation for analysis. If all the variables in the model are not in the same data frame, the analysis will not complete.  The data frame does not need to be attached, just specified by name with the \code{data} option if the name is not the default \code{d}.

The \code{filter} parameter subsets rows (cases) of the input data frame according to a logical expression. Use the standard R operators for logical statements as described in \code{\link{Logic}} such as \code{&} for and, \code{|} for or and \code{!} for not, and use the standard R relational operators as described in \code{\link{Comparison}} such as \code{==} for logical equality \code{!=} for not equals, and \code{>} for greater than. See the Examples.

GRAPHICS\cr
For models with a single predictor variable, a scatter plot of the data is produced, which also includes the fitted values. As with the density histogram plot of the residuals and the scatterplot of the fitted values and residuals, the scatterplot includes a colored background with grid lines. If more than a single predictor variable, then a scatter plot matrix is produced.

FORECASTS\cr
Fitted and forecasted values are listed for all rows of data if the number of rows is less than 25 or if \code{pred_all=TRUE}. If only some of the rows are listed, sorted by the fitted value, the first and last four rows of data are listed. Also the 4 rows immediately around the fitted value of 0.5 are listed.

RESIDUAL ANALYSIS\cr
By default the residual analysis lists the data and fitted value for each observation as well as the residual, the value of \code{\link{rstudent}}, Cook's distance and dffits, with the first 20 observations listed and sorted by Cook's distance. For the logit model, \code{\link{rstudent}} returns the standardized Pearson residual, the Pearson residual divided by \code{sqrt(1 - hat)}, not the Studentized residual of a linear model. The residual displayed is the actual difference between fitted and observed, that is, with the setting in the \code{\link{residuals}} of \code{type="response"}.  The \code{res_sort} option provides for sorting by these \code{\link{rstudent}} values or not sorting at all.  The \code{res_rows} option provides for listing these rows of data and computed statistics statistics for any specified number of observations (rows).  To turn off the analysis of residuals, specify \code{res_rows=0}.

INVOKED R OPTIONS\cr
The \code{\link{options}} function turns off the stars for different significance levels (show.signif.stars=FALSE), turns off scientific notation for the output (scipen=30), and sets the width of the text output at the console to 120 characters. The latter option can be re-specified with the \code{text_width} option. After \code{Logit} is finished with a normal termination, the options are re-set to their values before the \code{Logit} function began executing.

COLORS\cr
The default color theme is \code{"colors"}, but a gray scale is available with \code{"gray"}, and other themes are available as explained in \code{\link{style}}, such as \code{"red"} and \code{"green"}. Use the option \code{style(sub_theme="black")} for a black background and partial transparency of plotted colors.
}

\value{
Following the standard \code{R} function \code{\link{glm}}, invisibly returns an object of \code{\link{class}} inheriting from "glm" which inherits from the \code{\link{class}} "lm". Particularly useful for comparing nested models. Assign the output of \code{Logit} for a model to an object. Then for a nested model. Then use the \code{\link{anova}} function to compare the models as shown in the examples below.
}

\references{
Gerbing, D. W. (2023). \emph{R Data Analysis without Programming: Explanation and Interpretation}, 2nd edition, Chapter 13, NY: Routledge.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{formula}}, \code{\link{glm}}, \code{\link{summary.glm}}, \code{\link{anova}}, \code{\link{confint}}, \code{\link{fitted}}, \code{\link{resid}}, \code{\link{rstudent}}, \code{\link{cooks.distance}}
}

\examples{
# Gender has values of "M" and "F"
d <- Read("Employee", quiet=TRUE)
# logit regression, rely upon default parameter value: data=d
Logit(Gender ~ Years)

# expression as a term of the model, evaluated against the data
#   frame, with the expression text as the term label
Logit(Gender ~ log(Years))

# short name
lr(Gender ~ Years)

# Modify the default settings as specified
Logit(Gender ~ Years, res_rows=8, res_sort="rstudent", digits_d=8, pred=FALSE)

Logit(Gender ~ Years)

# Multiple logistic regression model with specified probability thresholds
#  for classification into the reference group
# just for employees who have worked more than 5 years at the firm
Logit(Gender ~ Years + Salary, prob_cut=c(.4, .7), filter=(Years > 3))

# Custom contrasts for categorical predictor
d$JobSat <- factor(d$JobSat, levels=c("low", "med", "high"))
contrasts(d$JobSat) <- contr.sum(n=3)
Logit(Gender ~ JobSat)


# Compare nested models
# easier and better treatment of missing data with lessR function:  Nest
full_model <- Logit(Gender ~ Years + Salary)
reduced_model <- Logit(Gender ~ Years)
anova(reduced_model, full_model)

# Save the three plots as pdf files 4 inches square, gray scale
#Logit(Gender ~ Years, pdf_file="MyModel.pdf",
#      width=4, height=4, colors="gray")

# Specify new values of the predictor variables to calculate
#  forecasted values
d <- Read("Cars93")
Logit(Source ~ HP + MidPrice, X1_new=seq(100,250,50), X2_new=c(10,60,10))
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ regression }
\keyword{ logit }

\name{Chart}
\alias{Chart}
\alias{BarChart}
\alias{PieChart}
\alias{pc}

\title{Charts for One or Two Categorical Variables}

\description{

\code{lessR} introduces the concept of an \emph{analytic view} visualization function, in which the choice of visualization function directly reflects the structure of the data and the analyst's intent for understanding the data. The function \code{Chart()} visualizes the distribution of a categorical variable along with related statistics from aggregated data of a numerical variable, either counts or a statistic such as the mean of another numerical variable. Choose the type of visualization according to the value of the parameter \code{form}. 
\itemize{
\item Bar chart with \code{form = "bar"}, the default value
\item Dot chart with \code{form = "dot"}
\item Radar chart with \code{form = "radar"}
\item Bubble chart with \code{form = "bubble"}
\item Pie chart with \code{form = "pie"}
\item Starburst chart with \code{form = "pie"} and another categorical variable(s) with \code{by}
\item Treemap chart with \code{form = "treemap"}
\item Icicle chart with \code{form = "icicle"}
}

Stratify, that is, divide the distribution into groups with each group plotted separately, with parameters \code{by}, which plots the groups on the same panel, or \code{facet}, which plots the groups on different panels, one panel per level. \code{facet} may be a single variable or a vector of variables; multiple variables are crossed so that each panel corresponds to one combination of their levels. With this conceptualization, a starburst chart is a pie chart with nested layers, For the hierarchical charts -- pie and starburst, treemap, and icicle -- the \code{by} stratification parameter can be a vector, defining multiple levels of the hierarchy, whereas a vector of \code{facet} variables instead defines the grid of panels. For the bubble chart, \code{facet} applies only to a single categorical variable (no \code{by} variable).

When using RStudio, plots are directed to the \code{Plots} window for the bar chart, and also the \code{Viewer} window for Plotly interactive plots. The remaining plots are all Plotly visualizations.

Unless \code{by} is a vector of at least length two, the chart is constructed from the one- or two-dimensional table that pairs each level or joint level of the categorical variables with the corresponding numerical value of \code{y}. Usually, this table is a summary (pivot) table calculated as a data aggregation from the original data table of measurements. A one-dimensional example is the average salary of the employees in each department. Corresponding two-dimensional example is the average salary of men and women in each department. Enter the original, raw data from which \code{Chart} calculates the summary table, or enter the summary table directly as the input data.

\code{Chart} also displays the foundational summary table, such as frequency table for one or two variables. If a frequency table, also displayed are Cramer's V association, and the corresponding chi-square inferential analysis. For two variables, the frequencies include the joint and marginal frequencies.

To activate facets, a multi-panel display, specify a \code{facet} variable, or vector of variables. For the bar chart the panels are drawn as Trellis graphics with the \code{lattice} framework; for the Plotly forms -- \code{radar}, \code{dot}, \code{pie}/starburst, \code{treemap}, \code{icicle}, and \code{bubble} -- the panels form a Plotly grid, one panel per level or per combination of levels.

For bar charts, if the provided object to analyze is a set of multiple variables, including the name of an entire data frame, then a bar chart is calculated for \emph{each} non-numeric variable in the data frame. For the default bar chart, a standard bar chart is presented simultaneously with the interactive version because there are some features in the standard chart not yet available in the interactive version. 
}

\usage{
Chart(

        # ------------------------------------------
        # Data from which to construct the bar chart
        x=NULL, y=NULL, data=d, filter=NULL,

        # ----------------------------------------------------
        # Stratification: Same (by) or separate panels (facet)
        by=NULL,
        facet=NULL, n_row=NULL, n_col=NULL, aspect="fill",

        # -----------------------------------
        # Geometric forms of relational plots
        form=c("bar", "radar", "bubble", "dot", "pie", "icicle", "treemap"),

        hole=0.65,  # pie chart
        radius=0.50, power=0.5,  # bubble chart
        segments_x=NULL, segments_y=NULL,
        pt_size=1, origin_x=NULL, origin_y=NULL, # dot chart

        # --------------------------
        # Chart from aggregated data
        stat=c("mean", "sum", "sd", "deviation", "min", "median", "max"),
        stat_x=c("count", "proportion"),

        # -----------------------------------------------------
        # Bar chart parameters: Layout and ordering of the bars
        horiz=FALSE, sort=c("0", "-", "+"),
        beside=FALSE, stack100=FALSE,
        gap=NULL, scale_y=NULL, one_plot=NULL,

        # ----------------------------------------------------------------
        # Analogy of physical Marks on paper to create the bars and labels
        theme=getOption("theme"),
        fill=NULL,
        color=getOption("bar_color_discrete"),
        transparency=getOption("trans_bar_fill"),
        fill_split=NULL, fill_scaled=FALSE, fill_chroma=75,

        labels=c("\%", "input", "prop", "off"),
        labels_position=c("in", "out"),
        labels_color="white",
        labels_size=0.90,
        labels_decimals=NULL,
        labels_cut=NULL,

        # ------------------------------------------------------------------
        # Labels for axes, values, and legend if x and by variables, margins
        xlab=NULL, ylab=NULL, main=NULL, sub=NULL,
        lab_adjust=c(0,0), margin_adjust=c(0,0,0,0),
        pad_y_min=0, pad_y_max=0,
    
        rotate_x=getOption("rotate_x"), rotate_y=getOption("rotate_y"),
        break_x=NULL, offset=getOption("offset"),
        axis_fmt=c("K", ",", ".", ""), axis_x_pre="", axis_y_pre="",
        font_size=1, label_max=100,

        legend_title=NULL, legend_position="right_margin",
        legend_labels=NULL, legend_horiz=FALSE,
        legend_size=NULL, legend_abbrev=10, legend_adjust=0,

        # ----------------------------------------------------
        # Draw one or more objects, text, or geometric figures
        # Only applies to the standard bar chart
        add=NULL, x1=NULL, y1=NULL, x2=NULL, y2=NULL,

        # --------------------------------------------------------------------
        # Output: text or chart turned off, to PDF file, number decimal digits
        quiet=getOption("quiet"), do_plot=TRUE, 
        use_plotly=getOption("lessR.use_plotly"),
        pdf_file=NULL, width=6.5, height=6,
        digits_d=NULL,

        # -------------
        # Miscellaneous
        eval_df=NULL, fun_call=NULL, \dots)
}


\arguments{
  \item{x}{Primary categorical \bold{variable} to analyze. For bar charts, \code{x} can be
        a single variable (in a data frame or as a vector in the user's workspace),
        a vector of variables specified with \code{\link{c}}, or an entire data frame.
        If not specified, defaults to all non-numeric variables in the data frame
        given by \code{data} (or \code{d} by default).
        To improve label legibility, category labels are automatically wrapped:
        unless \code{break_x = FALSE}, spaces in labels are replaced with line breaks.
        To keep two short words on the same line, replace the intervening space
        with a tilde; the tilde is displayed as a blank in the axis label.}
  \item{y}{Numeric variable whose values determine bar heights, bubble sizes,
        or other aggregated measures across categories.
        If \code{y} is supplied for raw data, a summary statistic must be specified
        via \code{stat}. If \code{y} is omitted, counts (or proportions) are
        computed from the data and used as the default response.}
  \item{data}{Optional data frame that contains the variables of interest.
        May be raw data, from which summaries are computed, or a pre-aggregated
        summary table with one categorical column and one numeric column giving
        the heights/sizes of the plotted objects.}
  \item{filter}{Logical expression or vector of row indices that defines a subset
        of rows in \code{data} to analyze.
        Use logical operators such as \code{\&}, \code{|}, and \code{!} and
        relational operators such as \code{==}, \code{!=}, and \code{>}.}\cr

  \item{by}{Optional second categorical variable for stratification.
        Creates a two-way display (e.g., stacked or grouped bars, nested pies,
        multi-variable bubbles), with subgroups shown within each level of \code{x}.
        The same stratification applies within panels when \code{facet} is used.
        A single \code{by} variable applies to any chart. For the
        non-hierarchical charts a second \code{by} variable is not permitted,
        as the resulting visual clutter compromises interpretability. Only the
        hierarchical charts -- pie/sunburst, treemap, and icicle -- accept a
        vector of two or more \code{by} variables, \code{by=c(V1, V2)}, which
        define the successive levels of the hierarchy.}
  \item{facet}{Optional categorical variable, or vector of categorical
        variables, that produces a \bold{multi-panel display}: a separate
        chart for each level of \code{facet}, or each combination of levels
        when a vector of two or more variables is given, in contrast to
        \code{by}, which overlays subgroups on the same panel. For the bar
        chart the panels are drawn with the \code{lattice} framework
        (Trellis graphics); for the Plotly forms -- \code{radar}, \code{dot},
        \code{pie}/starburst, \code{treemap}, \code{icicle}, and
        \code{bubble} -- the panels form a Plotly grid. For \code{bubble},
        \code{facet} applies only to a single categorical variable (no
        \code{by} variable).}
  \item{n_row}{Number of rows in the facet layout. If specified, \code{n_col}
        is determined automatically and should not be set simultaneously.}
  \item{n_col}{Number of columns in the facet layout. If specified, \code{n_row}
        is determined automatically and should not be set simultaneously.
        When \code{n_col = 1}, facet strips are placed to the left of panels
        instead of above.}
  \item{aspect}{Aspect ratio (height/width) of the panels, applied only to the
       lattice facet for \code{form="bar"}, the default.
       The default \code{"fill"} expands
       each panel to occupy the available space (here \code{"fill"} refers to
       filling space, not to the \code{fill} color argument). Set to \code{1}
       for square panels, or \code{"xy"} to bank line slopes toward an effective
       45 degrees. The base-R contour and smooth facets size their panels
       automatically and ignore \code{aspect}.}\cr

  \item{form}{The plotted geometric form. Default is \code{"bar"}.
        Alternatives are \code{"radar"}, \code{"bubble"}, \code{"dot"},
        \code{"pie"}, \code{"icicle"}, and \code{"treemap"}. A hierarchical
        pie chart (with a \code{by} vector) is rendered as a sunburst
        chart.}
  \item{hole}{For pie and sunburst charts, proportion of the radius occupied by
        the inner hole (a doughnut chart). Set to \code{0} or \code{FALSE}
        for a full pie.}
  \item{radius}{For bubble charts, scaling factor for bubble radius (in pixels)
        controlling the size of the largest displayed bubble.}
  \item{power}{For bubble charts, controls the relative scaling of bubbles.
        The default \code{0.5} scales radii so that bubble \emph{areas} are
        proportional to the underlying values. A value of \code{1} scales
        radii directly to the values, increasing visual differences in size.}
  \item{segments_x}{For the dot plot, connect the each point to the x-axis with
        a line segment when \code{TRUE}.}
  \item{segments_y}{For the dot plot, connect the each point to the y-axis with
        a line segment when \code{TRUE}.}
  \item{pt_size}{Size of the plotted points for a dot chart, \code{form="dot"}.
        Default value is \code{0.9}, which renders as approximately 6.5 pixels
        in the Plotly display. Increase for larger points, decrease for smaller.
        For bar charts, see \code{out_size}.}
  \item{origin_x}{The starting point on the x-axis.}
  \item{origin_y}{The starting point on the y-axis.}\cr 

  \item{stat}{Summary statistic applied to \code{y} within groups defined
       by \code{x} and optional \code{by}. Values are \code{"mean"},
       \code{"sum"}, \code{"sd"}, \code{"deviation"} (mean deviations),
       \code{"min"}, \code{"median"}, and \code{"max"}.
       The resulting summary table (pivot table) defines the plotted heights
       or sizes.}
  \item{stat_x}{When \code{y} is not supplied, specifies whether to plot the
        \code{"count"} (default) of each group or its \code{"proportion"}.}\cr

  \item{horiz}{Orientation of bars in a bar chart. Defaults to \code{FALSE}
        (vertical bars) unless \code{one_plot = TRUE}, in which case horizontal
        bars are often more readable.}
  \item{sort}{Sorting strategy for bar categories.
        Default \code{"0"} retains the original order.
        Use \code{"-"} for descending and \code{"+"} for ascending order of
        frequencies (for one-way charts) or column sums (with \code{by}).
        Not applicable to facet plots. When \code{one_plot = TRUE}, the default
        is \code{"+"}.}
  \item{beside}{For a two-way bar chart, if \code{TRUE} plots the levels of
        the second variable as adjacent bars (grouped bars) rather than stacked
        segments.}
  \item{stack100}{Produces a 100\% stacked bar chart when a \code{by} variable
        is present, equivalent to setting \code{stat_x = "proportion"}
        with \code{by}.}
  \item{gap}{Controls the spacing between bars, in multiples of the bar
        width; passed to the \code{space} argument of \code{\link{barplot}}.
        Default is \code{0.2}, except for two-variable plots with
        \code{beside = TRUE}, where the default is \code{c(0.1, 1)}: the
        gap within a group of bars, then the gap between groups. For an
        interactive (Plotly) chart the default is Plotly's own bar spacing,
        which \code{gap} overrides when specified. Only the between-group
        gap applies there, as the Plotly interface does not accept a
        within-group setting.}
  \item{scale_y}{Optional numeric vector of length three defining the y-axis
        (numeric axis) scale: minimum, maximum, and number of intervals.
        Applies to bar and similar charts.}
  \item{one_plot}{For multiple \code{x} variables, selects whether to draw
       a separate bar chart for each variable or combine all variables
       into a single multi-item chart. By default, if variables share a
       common response scale (e.g., Likert items), \code{one_plot} is set to
       \code{TRUE}; otherwise it defaults to \code{FALSE}.}\cr

  \item{theme}{Color \bold{theme} for this analysis. Use \code{\link{style}}
        to set persistent defaults across analyses.}
\item{fill}{Fill color(s) for bars, pie slices, tiles, or bubbles.
        Default is the qualitative \code{"hues"} palette under the
        \code{"colors"} theme, or an ordered sequential palette (e.g., \code{"blues"})
        for ordinal categories. For other themes, default fill is taken from
        the corresponding gradient (e.g., \code{"reds"} for \code{"darkred"}).
        May also be any vector of colors (e.g., from \code{\link{getColors}})
        or predefined palettes including color-blind--safe options such as
        \code{"viridis"}. When \code{fill} is set to the name of \code{y}
        (or \code{(count)} for tabulated counts), values of \code{y} are
        mapped to a color scale. For a divergent color scale with
        \code{fill_split}, supply exactly two colors, e.g.,
        \code{fill=c("gray","purple")}, for values below and above the
        split threshold respectively.}
  \item{color}{Border color of plotted objects (bars, slices, bubbles, tiles).
        May be a vector to vary borders by category. Default is
        \code{bar_color_discrete} from \code{\link{style}}.}
  \item{transparency}{Transparency of filled areas, from \code{0} (opaque) to
        \code{1} (fully transparent). Default is \code{trans_bar_fill} from
        \code{\link{style}}.}
  \item{fill_split}{For bar charts, splits bars into two fill colors relative
        to a numeric threshold. Bars with \code{y <= fill_split} are drawn in
        the first fill color; larger values use the second. By default the two
        colors are derived from the current theme. To specify custom colors,
        supply a length-2 vector to \code{fill}, e.g.,
        \code{fill=c("gray","purple")}.}
  \item{fill_scaled}{For bar charts without a \code{by} variable, scales the
        lightness of the fill color in proportion to the bar value rather than
        by rank. Larger absolute values yield darker shading. Applies
        automatically when the theme uses a sequential palette such as
        \code{"gray"} or \code{"white"}, and also when \code{fill} is set to
        a named sequential palette (e.g., \code{"blues"}).}
  \item{fill_chroma}{Chroma (saturation) for \code{fill_scaled} bars.
        Full saturation is 100; lower values approach grayscale.
        Has no effect for the \code{"gray"} theme, which is already achromatic.}\cr

  \item{labels}{Adds numeric labels to bars or pie slices.
        Default \code{"\%"} displays percentages,
        \code{"prop"} shows proportions,
        and \code{"input"} shows the underlying numeric values (counts or
        supplied \code{y}). If \code{y} is omitted, the input values are
        the tabulated counts.}
  \item{labels_position}{Position of labels for pies/sunbursts.
        Default is \code{"in"} (inside slices); use \code{"out"} to place
        labels outside.}
  \item{labels_color}{Color(s) of the plotted labels. May be a vector; if fewer
        colors are given than categories, colors are recycled.}
  \item{labels_size}{Character expansion factor for label text.
        Default is \code{0.95}, or \code{0.9} of that value when
        \code{beside = TRUE} and \code{labels_position = "in"} (to account
        for narrower bars).}
  \item{labels_decimals}{Number of decimal places displayed in labels.
        Defaults to 0 for integer-valued \code{y} and 2 for \code{"prop"}.}
  \item{labels_cut}{Minimum relative size required to show a label.
        When \code{labels_position = "out"}, the default is \code{0.028} for
        simple charts, and \code{0.040} when a \code{by} variable is present
        or multiple \code{x} variables are combined.}\cr

  \item{xlab}{\bold{Axis label} for the \code{x}-axis. If omitted, the label
       is taken from the variable label (if present) or the variable name.
       If \code{xy_ticks = FALSE}, no x-axis label is drawn.
       When no \code{y} is specified, \code{xlab} defaults to \code{"Index"}
       unless explicitly set.}
  \item{ylab}{Axis label for the \code{y}-axis. If omitted, the label is taken
       from the variable label (if present) or the variable name.
       If \code{xy_ticks = FALSE}, no y-axis label is drawn.}
  \item{main}{Title of the chart. Size and color may be controlled via
       \code{main_size} and \code{main_color} in \code{\link{style}}.}
  \item{sub}{Subtitle placed below \code{xlab}. Not yet implemented.}
  \item{lab_adjust}{Two-element numeric vector (x-label, y-label) giving
       approximate inch offsets for axis labels. Positive values move labels
       away from the plotting region. Not applicable to facet (Trellis) plots.}
  \item{margin_adjust}{Four-element numeric vector (top, right, bottom, left)
       that adjusts plot margins in inches. Positive values expand the
       corresponding margin. Not applicable to facet plots.}
  \item{pad_y_min}{Proportion of padding added at the lower end of the
       \code{y}-axis (0--1).}
  \item{pad_y_max}{Proportion of padding added at the upper end of the
       \code{y}-axis (0--1).}\cr

  \item{rotate_x}{For bar charts, rotation (in degrees) of category labels
        on the \code{x}-axis, typically used to accommodate long labels in
        combination with \code{offset}. When \code{rotate_x = 90}, labels are
        vertical and an alternative placement algorithm is used, so
        \code{offset} is usually unnecessary.}
  \item{rotate_y}{Applies to BPFM (bubble plot frequency matrix), a sequence
        of stacked bubble charts. Controls rotation of labels along the
        vertical axis.}
  \item{break_x}{For bar charts, controls automatic line-breaking of category
        labels. When \code{TRUE}, spaces are converted to new lines and tildes
        to blanks (keeping words joined by a tilde on the same line).
        Defaults to \code{TRUE} for vertical bars with \code{rotate_x = 0},
        and \code{FALSE} otherwise.}
  \item{offset}{For bar charts, controls the spacing between axis labels and
        the axis itself. Default is \code{0.5}. Larger values (e.g., \code{1.0})
        create additional room for rotated or long labels.}
  \item{axis_fmt}{Numeric format for axis labels. Default \code{"K"} shows
        thousands as \code{"K"} (e.g., \code{100000} as \code{100K}).
        Alternatives include \code{","} (comma separators with decimal point),
        \code{"."} (period separators), or \code{""} to disable formatting.}
  \item{axis_x_pre}{Prefix for labels on the \code{x}-axis, such as \code{"$"}.}
  \item{axis_y_pre}{Prefix for labels on the \code{y}-axis, such as \code{"$"}.}
  \item{font_size}{Multiplicative scaling factor applied to the font sizes
        of the title (\code{main_size}), axis labels (\code{lab_size}), and
        axis value text (\code{axis_size}) simultaneously, preserving their
        relative proportions. Default is \code{1} (no scaling). Useful for
        adjusting all font sizes to suit a larger or smaller plot.}
  \item{label_max}{For bar charts, improves console readability of text output
        by setting a target maximum label length. Longer labels are abbreviated
        in the printed frequency distribution. The limit is not strict when
        necessary to preserve uniqueness.}\cr

  \item{legend_title}{Title of the \bold{legend}. Usually set automatically
        from variable names, but must be supplied explicitly when plotting
        raw count matrices without variable metadata.}
  \item{legend_position}{Legend placement when plotting two variables.
        Default is in the right margin. Standard positions such as
        \code{"topleft"}, \code{"top"}, and \code{"topright"} are also
        available; see \code{\link{legend}}.}
  \item{legend_labels}{Legend labels when plotting two variables.
        Defaults to the levels of the second (or \code{by}) variable.}
  \item{legend_horiz}{If \code{TRUE}, draws the legend horizontally;
        default is vertical.}
  \item{legend_size}{Character expansion factor for legend text.}
  \item{legend_abbrev}{If specified, truncates legend title and labels to at most
        the given number of characters (subject to preserving uniqueness).}
  \item{legend_adjust}{Horizontal shift of the legend in two-way bar charts.
        Positive values move the legend to the right from its default position.}\cr

  \item{add}{For bar charts, \bold{overlays} additional objects (text or
       geometric figures) on the plot.
       The first argument \code{"text"} writes arbitrary text; geometric options
       include \code{"rect"}, \code{"line"}, \code{"arrow"},
       \code{"v_line"} (vertical line), and \code{"h_line"} (horizontal line).
       The value \code{"means"} is shorthand for vertical and horizontal
       lines at the respective means. Does not apply to facet plots.
       Use \code{\link{style}} parameters such as \code{add_fill} and
       \code{add_color} to control appearance.}
  \item{x1}{First x-coordinate (in standardized \code{-1} to \code{1} units)
       for each added object.}
  \item{y1}{First y-coordinate for each added object.}
  \item{x2}{Second x-coordinate for each added object.
        Used for \code{"rect"}, \code{"line"}, and \code{"arrow"}.}
  \item{y2}{Second y-coordinate for each added object.
        Used for \code{"rect"}, \code{"line"}, and \code{"arrow"}.}\cr

  \item{quiet}{If \code{TRUE}, suppresses text output to the console.
        The default can be changed via \code{\link{style}}.}
  \item{do_plot}{If \code{TRUE} (default), produces the chart. Set to
        \code{FALSE} to compute and return results without plotting.}
  \item{use_plotly}{If \code{TRUE} (default), produces a Plotly-based
        interactive chart in the RStudio \code{Viewer} window in addition
        to the static plot in the \code{Plots} window. Some advanced options
        apply only to the static chart.}
  \item{pdf_file}{If specified, directs graphics output to a PDF file with
        this name.}
  \item{width}{Width of the plot window (or PDF device) in inches.
        Default is \code{4.5}.}
  \item{height}{Height of the plot window (or PDF device) in inches.
        Default is \code{4.5}.}
  \item{digits_d}{Number of decimal digits used for displayed numeric
        summaries. Defaults to at least 2 or one more than the maximum number
        of digits in the response variable, whichever is larger.}\cr

  \item{eval_df}{If \code{TRUE}, checks that variables exist in the supplied
        data frame. Default of \code{NULL} determines the setting
        automatically. Set to \code{FALSE} in Shiny or pipe workflows.}
  \item{fun_call}{Function call object used internally (e.g., by \pkg{knitr})
        to reconstruct the original call.}\cr

  \item{\dots}{Additional graphical parameters passed to base \code{\link{barplot}},
      \code{\link{legend}}, and \code{\link{par}}.
      Common options include \code{cex.main} (title size),
      \code{col.main} (title color), line types such as
      \code{"dotted"} or \code{"dotdash"},
      and subtitle options \code{sub} and \code{col.sub}.
      Axis label orientation can be adjusted with \code{las = 3},
      and bar spacing with \code{space} in one-variable bar charts.}
}


\details{
\strong{OVERVIEW}

\code{Chart()} visualizes numerical values associated with one or two categorical variables, each with a relatively small number of levels. By default, colors for bars, background, and grid lines are taken from the active \code{\link{style}} theme, but all can be customized. Base computations use standard R functions such as \code{\link{barplot}}, \code{\link{chisq.test}}, and, for two variables, \code{\link{legend}}. For horizontal bar charts (\code{horiz = TRUE}), category labels are drawn horizontally and the left margin is automatically extended to accommodate both the labels and the axis title.\cr

\strong{DATA}

Conceptually, the chart is built from a summary table in which each row consists of a level of the categorical variable \code{x} paired with a numerical value \code{y}, with as many rows as there are levels of \code{x}. You may:
\itemize{
\item supply \code{x} and \code{y} directly as a pre-aggregated summary table, or
\item supply \code{x} (and optionally \code{y}) at the observation level and let \code{Chart()} aggregate over the levels of \code{x} (and \code{by}) using \code{stat}.
}
A second categorical variable \code{by} can be used to form a two-way table.

The \code{filter} parameter subsets rows (cases) of the input data frame according to a logical expression or a set of integers that specify the row numbers to retain. Use the standard R logical operators described in \code{\link{Logic}}, such as \code{\&} (and), \code{|} (or), and \code{!} (not), and the standard relational operators described in \code{\link{Comparison}}, such as \code{==} (equality), \code{!=} (not equal), and \code{>} (greater than). Alternatively, specify a vector of integers that correspond to row numbers. See the Examples.

The input can be factors, numeric values, characters, or a matrix. You can:
\itemize{
\item enter raw data and let \code{Chart()} compute frequencies or summaries, or
\item enter a pre-tabulated summary table of counts or statistics.
}
When \code{y} is not supplied, the numerical values are simply the counts of each level of \code{x} (and of each combination of \code{x} and \code{by}).\cr

\strong{TWO DATA MODES FOR PLOTLY OUTPUTS}

\code{Chart()} supports two conceptual modes for aggregated values used in the plots and tables:
\itemize{
\item \strong{Count mode} (default): if \code{y} is \code{NULL}, the chart uses counts of \code{x} (and \code{by}, when supplied).
\item \strong{Summary mode}: if \code{y} is numeric, the chart aggregates \code{y} over the categories of \code{x} (and \code{by}) using \code{stat}.
}

From full data with repeated values of \code{x} (and \code{by}), you can reduce to a summary table using one of the following transformations:

\tabular{ll}{
Transformation \tab Meaning\cr
-------------- \tab -------------------\cr
\code{"sum"} \tab sum\cr
\code{"mean"} \tab mean\cr
\code{"sd"} \tab standard deviation\cr
\code{"dev"} \tab mean deviation\cr
\code{"min"} \tab minimum\cr
\code{"median"} \tab median\cr
\code{"max"} \tab maximum\cr
------------- \tab -------------------\cr
}

All numeric values (both in console tables and Plotly hovers) are formatted according to \code{digits_d}.

Before plotting, \code{Chart()} constructs a 1-D table (\code{x}) or 2-D table (\code{by} × \code{x}) of either counts (when \code{y = NULL}) or aggregated \code{y} (when \code{y} is supplied). For count mode, \code{Chart()} prints the frequency table and a chi-square test of equal probabilities. For summary mode, it prints the aggregated table (no chi-square test is computed for numeric summaries). These tables serve as a concise audit of the data supplied to the visualization.\cr

\strong{NON-HIERARCHICAL PLOTLY CHARTS}

For non-hierarchical charts (\code{form = "bar"}, \code{"radar"}, or \code{"bubble"}):
\itemize{
\item with \code{y = NULL}, the geometry encodes counts;
\item with \code{y} supplied, the geometry encodes the chosen \code{stat} of \code{y} per category (and per group when \code{by} is supplied).
}
In bubble charts, bubble size is proportional to the aggregated value. Use \code{radius} (in pixels) and \code{power} to control size mapping (area proportional to the value when \code{power = 0.5}).\cr

\strong{DOT PLOTS}

A dot plot, \code{form = "dot"}, plots one dot for each level of \code{x}, each dot at the end of a stem that extends from the response axis (the stems are toggled with \code{segments_x} and \code{segments_y}). The dot plot shares the data model of the bar chart, so the same two data modes apply:
\itemize{
\item \strong{Count mode} (\code{y} omitted): one dot per level of \code{x} at its frequency, a stem-and-dot rendering of the corresponding bar chart of counts.
\item \strong{Summary mode} (numeric \code{y}): one dot per level at the chosen \code{stat} of \code{y}. As for the other chart types, a \code{stat} is required when \code{y} is raw data, so the aggregation is always explicit.
}
When the categorical \code{x} uniquely identifies the cases, the data are already a summary table with one value of \code{y} per row. These values are then plotted directly, with no \code{stat} and no aggregation; in the dot plot this is the form introduced by Cleveland. This one-value-per-case data is not specific to the dot plot: like an aggregated summary table, it renders in any \code{Chart()} display type, comparative or part-whole, including the bar chart, pie chart, treemap, icicle, bubble plot, and radar chart. To identify the cases by the row names of the data frame rather than by a data column, specify the reserved name \code{row_names} as \code{x}.

A multiple-column \code{y}, such as \code{y = c(Pretest, Posttest)}, produces a paired dot plot: the value in each column is shown as a separate dot for each level of \code{x}, with the dots connected and no \code{stat} applied. The \code{facet} parameter does not apply to the paired dot plot.

Orientation follows \code{horiz}: by default the categories are on the horizontal axis, and \code{horiz = TRUE} places them on the vertical axis. Use \code{sort} to order the categories by their plotted value, \code{pt_size} to scale the dots, and \code{origin_x} or \code{origin_y} to set where the stems begin.\cr

\strong{HIERARCHICAL PLOTLY CHARTS}

Hierarchical charts include pies with a \code{by} variable (sunburst charts) and \code{form = "treemap"} or \code{"icicle"}. For these charts, \code{Chart()} constructs a path table from \code{x} and \code{by}, where \code{by} may be:
\itemize{
\item a single factor (one additional level), or
\item a data frame of multiple factors, where each column represents a deeper level in the hierarchy.
}
It then aggregates \code{y} (or counts, if \code{y = NULL}) along the path:

\itemize{
\item Node values are computed by applying \code{stat} within each node to its child records.
\item For \strong{additive} statistics (\code{"sum"} and counts), parent node values equal the sum of their children. Children are sized proportionally to their parent (\code{branchvalues = "total"}), so hover percentages of parent/root are well defined.
\item For \strong{non-additive} statistics (\code{"mean"}, \code{"median"}, \code{"min"}, \code{"max"}, \code{"sd"}), parent values are computed at the parent level using the same \code{stat} and are not sums of children. In this case, "\% of parent/root" is not shown in hovers because these proportions are not meaningful for non-additive summaries.
}

All numeric values shown in hovers are formatted using \code{digits_d}. For hierarchical charts:
\itemize{
\item additive modes show the aggregated value and, when appropriate, the \% of parent and \% of root;
\item non-additive modes show the aggregated value only.
}

Titles for console output and interactive plots reflect the mode:
\itemize{
\item Count mode: e.g., "Count of \code{x}" (optionally "by \code{by}").
\item Summary mode: e.g., "\code{stat} of \code{y} by \code{x}" (and "by \code{by}" when grouped).
\item Hierarchical: analogous titles using the same \code{stat} and variable names.
}

In all cases, \code{Chart()} preserves factor level order when building 1-D and 2-D tables and prints tables with informative dimnames. The console chi-square test is computed only for count mode (1-D or 2-D).\cr

\strong{VECTOR OF x-VALUES}

A vector of categorical \code{x}-variables (character or factor) generalizes to a matrix of one-dimensional plots, depending on the value of \code{form}:
\itemize{
\item for \code{form = "bar"}, a stacked bar chart (stack of one-dimensional bar plots),
\item for \code{form = "bubble"}, a stacked bubble chart, referred to as a \emph{bubble plot frequency matrix} (BPFM).\cr
}

\strong{COLORS}

For a one-variable plot, the default bar colors are taken from the current theme via the \code{bar_fill_discrete} argument of \code{\link{style}}, which by default uses the qualitative HCL palette \code{"hues"}. Alternatively, set the bar colors explicitly with the \code{fill} parameter, using:
\itemize{
\item a single color,
\item a palette name, or
\item a vector of colors, e.g., from \code{\link{getColors}}.
}

Pre-defined sequential and divergent HCL ranges are available through \code{\link{getColors}}. The qualitative sequence \code{"hues"} provides equally spaced HCL colors (same chroma and luminance). Sequential and divergent ranges are available at 30-degree increments around the HCL color wheel, including \code{"reds"}, \code{"rusts"}, \code{"browns"}, \code{"olives"}, \code{"greens"}, \code{"emeralds"}, \code{"turquoises"}, \code{"aquas"}, \code{"blues"}, \code{"purples"}, \code{"violets"}, \code{"magentas"}, and \code{"grays"}.

Define a \emph{divergent color scale} by providing a vector of two such ranges to \code{fill}, e.g., \code{c("purples", "rusts")}. These are especially useful for multiple bar charts with a common response scale (e.g., Likert items). Alternatively, specify colors manually, such as \code{c("coral3", "seagreen3")} for a two-level \code{by} variable.

For finer control, call \code{\link{getColors}} explicitly and pass its result to \code{fill}, adjusting chroma (\code{c}) and luminance (\code{l}), or defining a custom hue (\code{h}). See \code{\link{getColors}} for details.

The values of another variable can be mapped to bar fill by setting \code{fill} equal to that variable's name, typically \code{y} when supplied. When \code{y} is tabulated, refer to it as \code{(count)}. Larger values produce darker bars.

Additional pre-specified palettes include \code{"rainbow"}, \code{"terrain"}, and \code{"heat"}. Distinct palettes include \code{"distinct"} (maximally separated hues), the viridis family (\code{"viridis"}, \code{"cividis"}, \code{"magma"}, \code{"inferno"}, \code{"plasma"}), and color-blind friendly options such as \code{"Okabe-Ito"}. Wes Anderson--inspired palettes such as \code{"Moonrise1"}, \code{"Royal1"}, \code{"GrandBudapest1"}, \code{"Darjeeling1"}, and \code{"BottleRocket1"} are also available (with variants using \code{2} or \code{3} in the name where defined).\cr

\strong{LEGEND}

When two variables are plotted, a legend is produced with entries for each level of the second or \code{by} variable. By default, the legend is placed in the right margin. This position can be changed with \code{legend_position}, which accepts \code{"right_margin"} and any valid position accepted by the standard R \code{\link{legend}} function.

The legend title can be abbreviated with \code{legend_abbrev}, which specifies the maximum number of characters. The legend is vertical by default, but can be drawn horizontally with \code{legend_horiz}.\cr

\strong{LONG CATEGORY NAMES}

Category labels are often long. Adjust their display with \code{rotate_x} and \code{rotate_y}, in conjunction with \code{offset}, which moves labels away from the axis to compensate for rotation. These settings can be made persistent with \code{\link{style}}. To reset to defaults, call \code{style()} again.

Spacing codes for category names:
\enumerate{
\item Any space in a category name is converted to a new line in the plotted label.
\item To keep words on the same line, replace the space with a tilde \code{~}; the tilde is rendered as a space without a line break.
}

For console output, you can limit label length with \code{label_max}. Longer names are abbreviated to the specified number of characters, with a mapping table provided to show the correspondence between abbreviated and full names. For one-variable frequency distributions, \code{out_size} controls the maximum line width before the distribution is printed vertically instead of horizontally.\cr

\strong{MULTIPLE BAR CHARTS ON THE SAME PANEL (PLOT)}

For multiple \code{x}-variables, set \code{one_plot = TRUE} to overlay individual bar charts on a single panel. This is especially useful when all items share a common response scale (e.g., Likert items). By default, \code{Chart()} produces a single-panel display when a common response scale is detected.

The algorithm for detecting a common response scale identifies the variable with the largest set of responses, then checks that all other variables' responses are contained within that set. Some items may not exhibit all possible responses (e.g., no one chooses "Strongly Disagree"), but as long as at least one variable contains the full response set, the scales are treated as common.

Regardless of this automatic detection, you can explicitly set \code{one_plot} to either \code{TRUE} or \code{FALSE}. Explicitly setting \code{one_plot} bypasses the commonality check and saves computation.\cr

\strong{ENTER NUMERIC VARIABLE DIRECTLY}

Instead of computing counts from raw data, you can enter a numeric variable directly as \code{y}, together with a categorical \code{x} (and possibly a categorical \code{by}). In this case, the chart uses the supplied numeric values as-is (or aggregates them according to \code{stat}). Alternatively, you can read a pre-tabulated table of counts into R as a matrix or data frame and pass it to \code{Chart()}.\cr

\strong{STATISTICS}

In addition to the Plotly and static charts, descriptive and optional inferential statistics are reported. For count mode, a frequency table (one variable) or joint frequency table (two variables) is displayed, followed by Cramér's V and the chi-square test of independence (or equal probabilities) by default. For summary mode, the aggregated table is printed without a chi-square test, as the test is not appropriate for numeric summaries.\cr

\strong{VARIABLE LABELS}

If variable labels are stored in the data frame (e.g., via \code{\link{Read}} or \code{\link{VariableLabels}}), they are used by default as axis labels and in text output. For a single variable, the \code{x}-axis label defaults to the variable label unless \code{xlab} is explicitly supplied. For two variables, the plot title is derived from both variable labels unless overridden by \code{main}. Variable labels are also shown in the printed tables.\cr

\strong{PDF OUTPUT}

To write graphics to a PDF file, use \code{pdf_file}, optionally with \code{width} and \code{height}. Files are written to the current working directory, which you can explicitly set with \code{\link{setwd}}.\cr

\strong{VARIABLES AND EXPRESSIONS}

Arguments that denote variables in \code{Chart()} refer by default to names of existing variables, either in the referenced data frame (e.g., the default \code{d}) or, with \code{data=NULL}, in the user's workspace (global environment). A vector of variable names retains its column-selection meaning, as in \code{Chart(c(Years, Salary))}.

The variable arguments \code{x}, \code{y}, \code{by}, and \code{facet} also accept expressions, evaluated first against the columns of the data frame, then against the user's workspace. The expression text serves as the variable label. For example:

\preformatted{
    > Chart(cut(rnorm(50), 3))       # expression, no data frame needed
    > Chart(cut(Salary, 3))          # Salary resolved from d
    > Chart(Dept, by=cut(Salary, 2)) # expression as the by variable}

An expression that references a column of the data frame must evaluate to one value per row of the data frame.
}


\value{
For interactive visualizations, \code{Chart()} returns a Plotly
\code{htmlwidget} object (class \code{plotly}) that can be printed for
interactive viewing or saved as a self-contained HTML file.

For standard (non-interactive) charts, the output can optionally be
saved as an \R object. Otherwise, it appears only in the console (unless
\code{quiet = TRUE}). Two types of components are provided:
\emph{readable text output} and \emph{numerical statistics}.

The readable output consists of character strings such as frequency or
summary tables suitable for display. The numerical components are
statistics amenable to further analysis. This design supports
reproducible reporting in R Markdown documents by referencing the name
of each output component directly, using the syntax
\code{object$component}.

Each component appears only when relevant to the current analysis. For
example, cell proportions (\code{out_prop}) are included only for
two-way tables.

Example: save the output of a standard chart to an object with any valid
R name, such as \code{b <- Chart(Dept)}. View the available output
elements with \code{names(b)}, and access a specific component by
prefixing with the object name, such as \code{b$out_chi} to display the
chi-square test results. These objects can be displayed directly in the
console or within R Markdown for integrated text and analysis.

\strong{Bar charts only: tabulated numerical variable \code{y}}

When \code{Chart()} is used as a bar chart with a tabulated numerical
variable (counts or proportions), the object may contain:

\subsection{Readable output}{
\describe{
  \item{\code{out_title}}{Title of the analysis.}
  \item{\code{out_lbl}}{Variable label.}
  \item{\code{out_counts}}{Frequency or two-way frequency distribution.}
  \item{\code{out_chi}}{Chi-square test of equal probabilities
        (one variable) or independence (two variables).}
  \item{\emph{One variable} \code{out_miss}}{Number of missing values.}
  \item{\emph{Two variables} \code{out_prop}}{Cell proportions.}
  \item{\emph{Two variables} \code{out_row}}{Row-wise cell proportions.}
  \item{\emph{Two variables} \code{out_col}}{Column-wise cell proportions.}
}
}

\subsection{Statistics}{
\describe{
  \item{\code{n_dim}}{Number of dimensions, 1 or 2.}
  \item{\code{p_value}}{p-value for the null hypothesis of equal
        proportions (one variable) or independence (two variables).}
  \item{\code{freq}}{Data frame of the frequency distribution.}
  \item{\emph{One variable} \code{values}}{y-values read directly.}
  \item{\emph{One variable} \code{prop}}{Frequency distribution of
        proportions.}
  \item{\emph{One variable} \code{n_miss}}{Number of missing values.}
}
}

\strong{Numerical variable \code{y} read from data}

When \code{Chart()} reads a numeric variable \code{y} directly from the
data and summarizes it across one or two categorical variables, the
returned object can include:

\describe{
  \item{\code{out_y}}{Values of \code{y} used in the analysis.}
  \item{\code{n_dim}}{Number of dimensions, 1 or 2.}
}
}

\references{
Gerbing, D. W. (2023). \emph{R Data Analysis without Programming: Explanation and Interpretation}, 2nd edition, Chapter 4, NY: Routledge.

Gerbing, D. W. (2020). R Visualizations: Derive Meaning from Data, Chapter 3, NY: CRC Press.

Gerbing, D. W. (2021). Enhancement of the Command-Line Environment for use in the Introductory Statistics Course and Beyond, \emph{Journal of Statistics and Data Science Education}, 29(3), 251-266, https://www.tandfonline.com/doi/abs/10.1080/26939169.2021.1999871. 

Sievert, C. (2020). \emph{Interactive Web-Based Data Visualization with R, plotly, and shiny}. Chapman and Hall/CRC. URL: \url{https://plotly.com/r/}
}

\author{
David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})
}

\seealso{\code{\link{X}}, \code{\link{XY}},
\code{\link{getColors}}, \code{\link{barplot}}, \code{\link{table}}, \code{\link{legend}}, \code{\link{savePlotly}}.
}


\examples{

# get the data
d <- Read("Employee")

# --------------------------------------------------------
# bar chart from tabulating the data for a single variable
# --------------------------------------------------------

# for each level of Dept, display the frequencies
# -----------------------------------------------
# bar chart, standard and plotly
  Chart(Dept)  # bar chart by default

  # radar chart, plotly only
  Chart(Dept, form="radar") 

  # bubble chart, plotly only
  Chart(Dept, form="bubble") 

  # pie chart, plotly only
  Chart(Dept, form="pie") 

  # treemap chart, plotly only
  Chart(Dept, form="treemap") 

#  the values output by BarChart into the myOutput list
myOutput <- Chart(Dept)
# display the saved output
myOutput

# just males with salaries larger than 75,000 USD
Chart(Dept, filter=(Gender=="M" & Salary > 85000))

# tabulate an expression, evaluated against the data frame,
#   with the expression text as the variable label
Chart(cut(Salary, 3))

# rotate and offset the axis labels, sort categories by frequencies
Chart(Dept, rotate_x=45, offset=1, sort="-")

# set bars to a single color of blue with some transparency
Chart(Dept, fill="blue", transparency=0.3)
# progressive (sequential) color scale of blues
Chart(Dept, fill="blues")

# viridis palate
Chart(Dept, fill="viridis")

# change the theme just for this analysis, as opposed to style()
Chart(Dept, theme="darkgreen")

# set bar color to hcl custom hues with chroma and luminance
#   at the values provided by the default hcl colors from
#   the getColors function, which defaults to h=240 and h=60
#   for the first two colors on the qualitative scale
Chart(Gender, fill=c(hcl(h=180,c=100,l=55), hcl(h=0,c=100,l=55)))

# or set to unique colors via color names
Chart(Gender, fill=c("palegreen3","tan"))

# darken the colors with an explicit call to getColors,
#   do a lower value of luminance, set to l=25
Chart(Dept, fill=getColors(l=25), transparency=0.4)

# column proportions instead of frequencies
Chart(Gender, stat_x="proportion")

# map value of tabulated count to bar fill
Chart(Dept, fill=(count))

# data with many values of categorical variable Make and large labels
myd <- Read("Cars93")
# perpendicular labels
Chart(Make, rotate_x=90, data=myd)
# manage size of horizontal value labels
Chart(Make, horiz=TRUE, label_max=4, data=myd)

# read y variable, Salary
# display bars for values of count <= 0 in a different color
#  than values above
Chart(Dept, y=Salary, stat="deviation", sort="+", fill_split=0)

# scale the luminosity of the bars with the sequential scale
Chart(Dept, y=Salary, stat="deviation", sort="+",
      fill_scaled=TRUE, fill="green")

# scale the luminosity of the bars with a divergent scale
Chart(Dept, y=Salary, stat="deviation", sort="+", fill_scaled=TRUE,
         fill=c("red", "blue"))

# ----------------------------------------------------
# bar chart from tabulating the data for two variables
# ----------------------------------------------------

# at each level of Dept, show the frequencies of the Gender levels
  # bar chart, standard and plotly
  Chart(Dept, by=Gender)  # bar chart by default

  # radar chart, plotly only
  Chart(Dept, by=Gender, form="radar") 

  # bubble chart, plotly only
  Chart(Dept, by=Gender, form="bubble") 

  # pie chart, plotly only
  Chart(Dept, by=Gender, form="pie") 

  # treemap chart, plotly only
  Chart(Dept, by=Gender, form="treemap") 
# --------------------------------------

# facet (multi-panel) plot, one panel per level of Gender
# bar chart uses lattice Trellis graphics
Chart(Dept, facet=Gender)

# facet also available for the Plotly forms, with one or more facet
#   variables; each panel is one combination of the facet levels
Chart(Dept, facet=c(Gender, Plan), form="treemap")
Chart(Dept, facet=c(Gender, Plan), form="icicle")
Chart(Dept, facet=c(Gender, Plan), form="bubble")

# at each level of Dept, show the row proportions of the Gender levels
#   i.e., 100% stacked bar graph
Chart(Dept, by=Gender, stack100=TRUE)

# at each level of Gender, show the frequencies of the Dept levels
# do not display percentages directly on the bars
Chart(Gender, by=JobSat, fill="reds", labels="off")

# specify two fill colors for Gender
Chart(Dept, by=Gender, fill=c("deepskyblue", "black"))

# display bars beside each other instead of stacked, Female and Male
# the levels of Dept are included within each respective bar
# plot horizontally, display the value for each bar at the
#   top of each bar
Chart(Gender, by=Dept, beside=TRUE, horiz=TRUE, labels_position="out")

# horizontal bar chart of two variables, put legend on the top
Chart(Gender, by=Dept, horiz=TRUE, legend_position="top")

# for more info on base R graphic options, enter:  help(par)
# for lessR options, enter:  style(show=TRUE)
# here fill is set in the style function instead of BarChart
#   along with the others
style(fill=c("coral3","seagreen3"), lab_color="wheat4", lab_size=1.2,
      panel_fill="wheat1", main_color="wheat4")
Chart(Dept, by=Gender,
         legend_position="topleft", legend_labels=c("Girls", "Boys"),
         xlab="Dept Level", main="Gender for Different Dept Levels")
style()


# -------------------------------------------------------------------------
# bar chart from a statistic aggregated across 1 or 2 categorical variables
# -------------------------------------------------------------------------
Chart(Dept, y=Salary, stat="mean")

Chart(Dept, by=Gender, y=Salary, stat="mean")

# ---------
# dot plots
# ---------
# count of each level of Dept, a stem-and-dot version of the bar chart
Chart(Dept, form="dot")

# mean Salary within each Dept; stat required for raw data, as for bars
Chart(Dept, y=Salary, stat="mean", form="dot")

# Cleveland dot plot: each case (employee) has one Salary, plotted
#   directly with no stat, using the row names to identify the cases
Chart(row_names, y=Salary, form="dot")

# -----------------------------------------------------------------
# multiple bar charts tabulated from data across multiple variables
# -----------------------------------------------------------------

# bar charts for all non-numeric variables in the data frame called d
#   and all numeric variables with a small number of values, < n_cat
# BarChart(one_plot=FALSE)

d <- rd("Mach4", quiet=TRUE)

# stacked bar charts for 20 6-pt Likert scale items
# default scale is divergent from "browns" to "blues"
Chart(m01:m20, horiz=TRUE, labels="off", sort="+")

# stacked bubble charts for 20 6-pt Likert scale items
Chart(m01:m20, form="bubble")


\donttest{

# custom scale with explicit call to getColors, HCL chroma at 50
clrs <- getColors("greens", "purples", c=50)
Chart(m01:m20, horiz=TRUE, labels="off", sort="+", fill=clrs)

# custom divergent scale with pre-defined color palettes
#  with implicit call to getColors
Chart(m01:m20, horiz=TRUE, labels="off", fill=c("aquas", "rusts"))


# ----------------------------
# can enter many types of data
# ----------------------------

# generate and enter integer data
X1 <- sample(1:4, size=100, replace=TRUE)
X2 <- sample(1:4, size=100, replace=TRUE)
Chart(X1, data=NULL)
Chart(X1, by=X2, data=NULL)

# generate and enter type double data
X1 <- sample(c(1,2,3,4), size=100, replace=TRUE)
X2 <- sample(c(1,2,3,4), size=100, replace=TRUE)
Chart(X1, data=NULL)
Chart(X1, by=X2, data=NULL)

# generate and enter character string data
# that is, without first converting to a factor
Travel <- sample(c("Bike", "Bus", "Car", "Motorcycle"), size=25, replace=TRUE)
Chart(Travel, horiz=TRUE, data=NULL)


# ----------------------------
# bar chart directly from data
# ----------------------------

# include a y-variable, here Salary, in the data table to read directly
d <- read.csv(text="
Dept, Salary
ACCT,51792.78
ADMN,71277.12
FINC,59010.68
MKTG,60257.13
SALE,68830.06", header=TRUE)
Chart(Dept, y=Salary)

# specify two variables for a two variable bar chart
# also specify a y-variable to provide the counts directly
# when reading y values directly, must be a summary table,
#   one row of data for each combination of levels with
#   a numerical value of y
# use lessR pivot function to get summary table, cannot process missing data
#   so set na_show_group to FALSE
d <- Read("Employee")
a <- pivot(d, mean, Salary, c(Dept,Gender), na_group_show=FALSE)
Chart(Dept, y=Salary_mean, by=Gender, data=a)
# do so just with BarChart, display bars in grayscale
# How does average salary vary by gender across the various departments?
Chart(Dept, y=Salary, by=Gender, stat="mean", data=d, fill="grays")


# -----------
# annotations
# -----------

d <- rd("Employee")

# Place a message in the center of the plot
# \n indicates a new line
Chart(Dept, add="Employees by\nDepartment", x1=3, y1=10)

# Use style to change some parameter values
style(add_trans=.8, add_fill="gold", add_color="gold4", add_lwd=0.5)
# Add a rectangle around the message centered at <3,10>
Chart(Dept, add=c("rect", "Employees by\nDepartment"),
                     x1=c(2,3), y1=c(11, 10), x2=4, y2=9)
}
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ chart }
\keyword{ bar chart }
\keyword{ pie chart }
\keyword{ sunburst }
\keyword{ treemap }
\keyword{ radar chart }
\keyword{ bubble chart }
\keyword{ color }

\name{dataEmployee_lbl}
\docType{data}
\alias{dataEmployee_lbl}
\title{VariableLabels: Employee Data Set}

\description{For the data on 37 employees with 6 variables, includes the variable labels and variable units.}

\usage{data(dataEmployee_lbl)}
\format{Variable labels, and some unites.

Years,"Years Employed in the Company"\cr
Gender,"Male or Female"\cr
Dept,"Department Employed"\cr
Salary,"Annual Salary (USD)"\cr
JobSat,"JobSat with Work Environment"\cr
Plan,"1=GoodHealth, 2=YellowCross, 3=BestCare"\cr
Pre,"Test score on legal issues before instruction"\cr
Post,"Test score on legal issues after instruction"
}

\source{author}
\keyword{datasets}

\name{Subset}
\alias{Subset}

\title{Subset the Values of One or More Variables}

\description{
Abbreviation: \code{subs}

Deprecated, use \code{\link{.}} instead in conjunction with base R \code{link{Extract}}.

Based directly on the standard R \code{\link{subset}} function to only include or exclude specified rows or data, and for specified columns of data.  Output provides feedback and guidance regarding the specified subset operations. Rows of data may be randomly extracted, and also with the code provided to generate a hold out validation sample created. The hold out sample is created from the original data frame, usually named d, so the subset data frame must be directed to a data frame with a new name or the data re-read to construct the holdout sample. Any existing variable labels are retained in the subset data frame.

}

\usage{
Subset(rows, columns, data=d, holdout=FALSE,
       random=0, quiet=getOption("quiet"), \dots)
}

\arguments{
  \item{rows}{Specify the rows, i.e., observations, to be included or deleted,
       such as with a logical expression or by direct specification of the
       numbers of the corresponding rows of data.}
  \item{columns}{Specify the columns, i.e., variables, to be included or
        deleted.}
  \item{data}{The name of the data frame from which to create the subset, which
       is \code{d} by default.}
  \item{holdout}{Create a hold out sample for validation if rows is a proportion
       or an integer to indicate random extraction of rows of data.}
  \item{random}{If an integer or proportion, specifies number of rows to data
        to randomly extract.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
       with \code{\link{style}} function.}
  \item{\dots}{The list of variables, each of the form, \code{variable = equation}.
       Each \code{variable} can be the name of an existing variable in the data frame
       or a newly created variable.}
}

\details{
\code{Subset} creates a subset data frame based on one or more rows of data and one or more variables in the input data frame, and lists the first five rows of the revised data frame. Guidance and feedback regarding the subsets are provided by default. The first five lines of the input data frame are listed before the subset operation, followed by the first five lines of the output data frame.

The argument \code{rows} can be a logical expression based on values of the variables, or it can be an integer or proportion to indicate random extraction of rows. An integer specifies the number of rows to retain, and a proportion specifies the corresponding proportion, which is then rounded to an integer. If \code{holdout=TRUE}, then the code to create a hold out data frame with a subsequent \code{Subset} analysis is also created. Copy and run this code on the original data frame to create the hold out sample.

To indicate retaining an observation, specify at least one variable name and the value of the variable for which to retain the corresponding observations, using two equal signs to indicate the logical equality.  If no rows are specified, all rows are retained. Use the base R \code{\link{row.names}} function to identify rows by their row names, as illustrated in the examples below.

To indicate retaining a variable, specify at least one variable name. To specify multiple variables, separate adjacent variables by a comma, and enclose the list within the standard R combine function, \code{\link{c}}.  A single variable may be replaced by a range of consecutive variables indicated by a colon, which separates the first and last variables of the range.  To delete a variable or variables, put a minus sign, -, in front of the \code{c}.
}

\value{
The subset of the data frame is returned, usually assigned the name of \code{d} as in the examples below.  This is the default name for the data frame input into the \code{lessR} data analysis functions.
}
\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{subset}}, \code{\link{factor}}.
}

\examples{
# construct data frame
d <- read.table(text="Severity Description
1 Mild
4 Moderate
3 Moderate
2 Mild
1 Severe", header=TRUE)

# only include those with a value of Moderate for Description
d <- Subset(rows=Description=="Moderate")

# locate, that is, display only, the 2nd and 4th rows of data
Subset(row.names(d)=="2" | row.names(d)=="4")

# retain only the first and fourth rows of data, store in myd
myd <- Subset(c(1,4))

# delete only the first and fourth rows of data, store in myd
myd <- Subset(-c(1,4))

# built-in data table warpbreaks has several levels of wool
#   and breaks plus continuous measure tension
# retain only the A level of wool and the L level of tension,
#   and the one variable breaks
d <- Subset(wool=="A" & tension=="L", columns=breaks, data=warpbreaks)

# delete Years and Salary 
d <- Read("Employee", quiet=TRUE)
d <- Subset(columns=-c(Years, Salary))

# locate, display only, a specified row by its row.name
d <- Read("Employee", quiet=TRUE)
Subset(row.names(d)=="Fulton, Scott")

# randomly extract 60\% of the data
# generate code to create the hold out sample of the rest
d <- Read("Employee", quiet=TRUE)
mysubset <- Subset(random=.6, holdout=TRUE)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ subset }

\name{prob_tcut}
\alias{prob_tcut}

\title{Plot t-distribution Curve and Specified Cutoffs with Normal Curve}

\description{
Plot a specified t-distribution against the standardized normal curve with the corresponding upper and lower tail cutoffs.
}

\usage{
prob_tcut(df, alpha=0.05, digits_d=3, y_axis=FALSE,
         fill="aliceblue", color_tail="palevioletred4",
         nrm_color=gray(.7), color_t=gray(.08),
         pdf_file=NULL, width=5, height=5, \dots)
}


\arguments{
  \item{df}{Degrees of freedom for t-distribution, must be 2 or larger.}
  \item{alpha}{Alpha to define the tail cutoff area.}
  \item{digits_d}{Number of decimal digits in the output.}
  \item{y_axis}{If \code{FALSE}, then the y axis is not displayed.}
  \item{fill}{Fill color for the interior of the t-distribution curve.}
  \item{color_tail}{Color of the tail areas of the t-distribution.}
  \item{nrm_color}{Color of the normal curve.}
  \item{color_t}{Color of the t-distribution curve.}
  \item{pdf_file}{Name of the pdf file to which graphics are redirected.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{\dots}{Other parameter values for graphics.}
}

\details{
Replaces a t-table by providing the corresponding t-cutoff, the critical value based on the corresponding quantile, as well as a plot that illustrates the tail probabilities. Also compare to the standardized normal curve.
}

\value{
\code{cutoff}: Cutoff-value, the corresponding quantile.
}


\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\seealso{
\code{\link{qt}}, \code{\link{pnorm}}.
}


\examples{
# t-distribution with 0.025 cutoffs for degrees of freedom of 15
prob_tcut(15)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ probability }
\keyword{ t-cutoff }
\keyword{ t-distribution }

\name{Prop_test}
\alias{Prop_test}
\alias{prop}

\title{Analysis of Prop_test}

\description{
Abbreviation: \code{prop}

Analyze proportions, either of a single proportion against a fixed alternative, a set of proportions evaluated for equality, or a goodness-of-fit test for a single categorical variable or a test of independence for multiple variables.
}

\usage{
Prop_test(variable=NULL, success=NULL, by=NULL, data=d,
          n_succ=NULL, n_fail=NULL, n_tot=NULL, n_table=NULL,
          Yates=FALSE, pi=NULL, digits_d=3, \dots)

prop(\dots)
}

\arguments{
  \item{variable}{Numerical variable to analyze.}
  \item{success}{Value of \code{variable} considered a success.}
  \item{by}{Compare proportions over groups, the values of this
        categorical variable.}
  \item{data}{Data frame that contains the \code{variable} to analyze.}
  \item{n_succ}{Number of successes.}
  \item{n_fail}{Number of trials, either provide this or \code{n}.}
  \item{n_tot}{Number of trials, either provide this or \code{q}.}
  \item{n_table}{Path name of the file that contains a frequency table.}
  \item{Yates}{Set to \code{TRUE} to implement Yate's correction factor
        where applicable.}
  \item{pi}{Value of null hypothesized probability.}
  \item{digits_d}{Number of significant digits for each of the displayed summary
        statistics.}
  \item{\dots}{Parameter values passed to \code{Prop_test}.} 
}


\details{
The analysis of proportions is of two primary types.

For one or more samples of data, focus on a single value of a categorical variable, traditionally called a success. Analyze the resulting proportion of occurrence for a single sample or compare proportions of occurrence of a success across distinct samples of data, what is called a test of homogeneity.

For a single sample, compare proportions from a contingency table. These tests are called a goodness-of-fit test for a single variable and a test of independence for multiple variables.

From standard base R functions, the lessR function \code{Prop_test()}, abbreviated \code{prop()}, provides for either type of the analysis for proportions. To use, enter either the original data from which the sample proportions are computed, or directly enter already computed sample frequencies from which the proportions are computed.

TEST OF HOMOGENEITY\cr
When analyzing the original data, an entered value for the parameter \code{success} for the categorical variable of interest, indicated by parameter \code{variable}, triggers the test of homogeneity. For a single proportion the analysis is the exact binomial test. If the proportions are entered directly, indicate the number of successes and the total number of trials with the \code{n_succ} and \code{n_tot} parameters, each as a single value for a single sample or as vectors of multiple values for multiple samples. 

TEST OF UNIFORM GOODNESS-OF-FIT\cr
To test for goodness-of-fit from the original data, just enter the name of the categorical variable. To test from the proportions, specify the proportions as a vector with the \code{n_tot} parameter.

TEST OF INDEPENDENCE\cr
Without a value for \code{success} or \code{n_succ} the analysis is of goodness-of-fit or independence. For the test of independence, to enter the joint frequency table directly, store the frequencies in a file accessible from your computer system. One possibility is to enter the numbers into a text file with file type `.csv` or `.txt`. Enter the numbers with a text editor, or with a word processor saving the file as a text file. With this file format, separate the adjacent values in each row with a comma, as indicated below. Or, enter the numbers into an MS Excel formatted file with file type `.xlsx`. Enter only the numeric frequencies, no labels. Use the parameter \code{n_table} to indicate the path name to the file, enclosed in quotes. Or, leave the quotes empty to browse for the joint frequency table. 

To conduct the test from the data, enter the names of the two categorical variables. The variable listed first is the parameter `variable`. The second listed variable is for the parameter `by`, the name of which must be included in the function call.

See the corresponding vignette for more detail and examples.\cr
Enter \code{browseVignettes("lessR")}.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\seealso{
\code{\link{binom.test}}.
}

\examples{

# generate data
Classvalues <- c("Freshman", "Sophomore", "Junior", "Senior")
Goodvalues <- c("Nice", "OK", "Mean")
Class <- sample(Classvalues, size=250, replace=TRUE)
Goodness <- sample(Goodvalues, size=250, replace=TRUE)
d <- data.frame(Class, Goodness)

# Test a single proportion
Prop_test(variable=Goodness, success="Nice")

# Test multiple proportions, one each for each level of Plan
Prop_test(Goodness, "Nice", by=Class)

# Test of independence
Prop_test(Goodness, by=Class)

# Same example as for the base R binom.test
Prop_test(n_succ=682, n_fail=243, p=.75, digits_d=2)

}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ proportion }

\name{Regression}
\alias{Regression}
\alias{reg}
\alias{reg_brief}

\title{Regression Analysis}

\description{
Abbreviation: \code{reg}, \code{reg_brief}

Provides a regression analysis with extensive output, including graphics, from a single, simple function call with many default settings, each of which can be re-specified. The computations are obtained from the \code{R} function \code{\link{lm}} and related \code{R} regression functions. The outputs of these functions are re-arranged and collated.

By default the data exists as a data frame with the default name of \code{d}, or specify explicitly with the \code{data} option.  Specify the model in the function call as an R \code{\link{formula}}, that is, for a basic model, the response variable followed by a tilde, followed by the list of predictor variables, each pair separated by a plus sign, such as \code{reg(Y ~ X1 + X2)}.

Output is generated into distinct segments by topic, organized and displayed in sequence by default. When the output is assigned to an object, such as \code{r} in \code{r <- reg(Y ~ X)}, the full or partial output can be accessed for later analysis and/or viewing. A primary such analysis is with \code{knitr} for dynamic report generation, run from R directly or from within \code{RStudio}. The input instructions to \code{knitr} are written comments and interpretation with embedded \code{R} code, called R~Markdown. Doing a \code{knitr} analysis is to "knit" these comments and subsequent output together so that the \code{R} output is embedded in the resulting document -- either html, pdf or Word -- by default with explanation and interpretation. Generate a complete R~Markdown file with filetype (\code{.Rmd}) from the \code{Rmd} option. Simply specify the option with a file name in quotes, then run the Regression analysis to create the markdown file. Open the newly created \code{.Rmd} file in \code{RStudio} and click the \code{knit} button to create a formatted document that consists of the statistical results plus interpretative comments. See the sections \code{arguments}, \code{value} and \code{examples} for more information.
}

\usage{
Regression(my_formula, data=d, filter=NULL,
         digits_d=NULL,

         Rmd=NULL, Rmd_browser=TRUE, 
         Rmd_format=c("html", "word", "pdf", "odt", "none"),
         Rmd_data=NULL, Rmd_custom=NULL, Rmd_dir=path.expand("~/reg"),
         Rmd_labels=FALSE,
         results=getOption("results"), explain=getOption("explain"),
         interpret=getOption("interpret"), code=getOption("code"), 

         text_width=120, brief=getOption("brief"), show_R=FALSE,
         plot_errors,

         n_res_rows=NULL, res_sort=c("cooks","rstudent","dffits","off"),
         n_pred_rows=NULL, pred_sort=c("predint", "off"),
         subsets=NULL, best_sub=c("adjr2", "Cp"), cooks_cut=1,

         scatter_coef=TRUE, mod=NULL, mod_transf=c("center", "z", "none"), 

         X1_new=NULL, X2_new=NULL, X3_new=NULL, X4_new=NULL,
         X5_new=NULL, X6_new=NULL,

         kfold=0, seed=NULL,
         new_scale=c("none", "z", "center", "0to1", "robust"),
         scale_response=FALSE,

         quiet=getOption("quiet"), bubble_plot=NULL,
         graphics=TRUE, size=NULL, pdf=FALSE, width=6.5, height=6.5,
         refs=FALSE,

         n_cat=getOption("n_cat"),

         fun_call=NULL, \dots)

reg(\dots)
reg_brief(\dots, brief=TRUE)
}


\arguments{
  \item{my_formula}{Standard R \code{\link{formula}} for specifying a model.  For
       example, for a response variable named Y and two predictor variables, X1 and
       X2, specify the corresponding linear model as Y ~ X1 + X2.
       A term of the formula may also be an expression of variables, such as
       log(Y) ~ X1 + I(X1^2), evaluated against the data frame, with the
       expression text as the term label. Within a formula, the arithmetic
       operators \code{+}, \code{*}, and \code{^} have special meanings that
       define the structure of the model, such as \code{*} to cross two
       predictor variables. To instead apply an operator arithmetically
       within an expression, enclose the expression in \code{\link{I}()},
       as in \code{I(X1^2)} for the square of X1.}
  \item{data}{The default name of the data frame that contains the data for analysis
       is \code{d}, otherwise explicitly specify. If knitting and rendering the
       generated R~Markdown for an interpretative output as specified by the
       \code{Rmd} parameter, then this data frame must first be read by the
       \code{lessR} function \code{\link{Read}}.}
  \item{filter}{A logical expression that specifies a subset of rows of the data frame
       to analyze.}
  \item{digits_d}{For the Basic Analysis, it provides the number of decimal digits,
        set by default to at least 2 or the largest number of digits in the values
        of the response variable plus 1.}\cr 

  \item{Rmd}{File name for the automatically generated R Markdown file, if specified.
        The file type is .Rmd, a simple text file that can be edited with
        any text editor, including RStudio to generate custom output.}
  \item{Rmd_browser}{If \code{html} format for Rmd rendering, then automatically
        open output in a browser.}
  \item{Rmd_format}{Format of one or more rendered R Markdown file formats,
        expressed in any
        combination of uppercase and lowercase letters. Default is \code{"html"},
        with a browser view automatic, or \code{"word"}, \code{"odt"}, 
        \code{"pdf"} (if LaTeX is available), or \code{"none"}.
        Requires \code{pandoc} installed, such as from \code{RStudio}.}
  \item{Rmd_data}{The default file reference
        of the data file when running the generated
        R Markdown file is the last data file as read by \code{\link{Read}} 
        (with the unabbreviated version of the function name). To refer
        to a different file to read
        specify the path name or web URL of the file.}
  \item{Rmd_custom}{Vector of input text sections in the Rmd file for which
        to convert.}
  \item{Rmd_dir}{Directory where custom input text files are located
        for the \code{Rmd} option.}
  \item{Rmd_labels}{Label each section of the markdown output according to the
        name of its input file.}
  \item{results}{By default TRUE. If set to \code{FALSE} the results
        are not provided in the R Markdown document, relying upon the interpretations.
        Can set globally with \code{style(results=FALSE)}.}
  \item{explain}{By default TRUE. If set to \code{FALSE} the explanations are not
        provided in the R Markdown document. Can set globally with
        \code{style(explain=FALSE)}.}
  \item{interpret}{By default TRUE. If set to \code{FALSE} the interpretations
        of the results are not provided in the R Markdown document.  Can set globally
        with \code{style(interpret=FALSE)}.}
  \item{code}{By default TRUE. If set to \code{FALSE} the R code that generates the
        results is not provided in the R Markdown file. Can set globally
        with \code{style(code=FALSE)}.}\cr

  \item{text_width}{Width of the text output at the console.}
  \item{brief}{If set to \code{TRUE}, reduced text output. Can change system default
        with \code{\link{style}} function.}
  \item{show_R}{Display the R instructions that yielded the \code{lessR} output,
        albeit without the additional formatting of the results such as combining
        output of different functions into a table.}
  \item{plot_errors}{By default is \code{FALSE}. 
        For a one-predictor model, plot the line segment that
        joins each point to the regression line, illustrating the size of the
        residuals.}\cr

  \item{n_res_rows}{Default is 20, which lists the first 20 rows of data sorted by the
       specified sort criterion.  To disable residuals, specify a value of 0.  To view
       the output for all observations, specify a value of \code{"all"}.}
  \item{res_sort}{Default is \code{"cooks"}, for specifying Cook's distance as the
       sort criterion for the display of the rows of data and associated residuals.
       Other values are \code{"rstudent"} for externally Studentized residuals,
       \code{"dffits"} for dffits and \code{"off"} to not sort the rows of data.}
  \item{n_pred_rows}{Default is 3, which lists prediction intervals only for the
       first, middle and last 3 rows of data, unless there are 25 or less
       rows of data when all rows are displayed.  To disable prediction intervals,
       specify a value of 0.  To see the output for all rows of data,
       specify a value of \code{"all"}.}
  \item{pred_sort}{Default is \code{"predint"}, which sorts the rows of data
        and associated intervals by the lower bound of each prediction interval.
        Turn off this sort by specifying a value of \code{"off"}.}
  \item{subsets}{Default is to produce the analysis of the fit based on
       adjusted R-squared for all possible model subsets of size 10 for
       each number of predictors, from the \code{leaps} package. Set to
       \code{FALSE} to turn off. Defaults lists a maximum of the first 50 values.
       Specify an integer to change the maximum.}
  \item{best_sub}{Criterion for selecting best subsets of predictor variables,
       with default of \code{"adjr2"} or choose Mallow's \code{"Cp"} statistic.}
  \item{cooks_cut}{Cutoff value of Cook's Distance at which observations with a
       larger value are flagged in red and labeled in the resulting scatterplot
       of Residuals and Fitted Values. Default value is 1.0.}\cr

  \item{scatter_coef}{Display the correlation coefficients in the upper triangle
        of the scatterplot matrix.}
  \item{mod}{Declare one continuous (numeric) predictor variable a
       moderator variable in a two predictor model.}
  \item{mod_transf}{Applies when \code{mod} specified, rescales the
        predictor variables, with default \code{"center"}, and options of
        \code{"z"} for standardize and \code{"none"}.}\cr

  \item{X1_new}{Values of the first listed numeric predictor variable for
        which forecasted values
        and corresponding prediction intervals are calculated.}
  \item{X2_new}{Values of the second listed numeric predictor variable for
        which forecasted values
        and corresponding prediction intervals are calculated.}
  \item{X3_new}{Values of the third listed numeric predictor variable for
        which forecasted values
        and corresponding prediction intervals are calculated.}
  \item{X4_new}{Values of the fourth listed numeric predictor variable for
        which forecasted values
        and corresponding prediction intervals are calculated.}
  \item{X5_new}{Values of the fifth listed numeric predictor variable for
        which forecasted values
        and corresponding prediction intervals are calculated.}
  \item{X6_new}{Values of the sixth listed numeric predictor variable 
        for which forecasted values
        and corresponding prediction intervals are calculated.}\cr

  \item{kfold}{Number of K-fold cross-validations. If conducted, only the
       cross-validation output shown.}
  \item{seed}{Parameter \code{kfold} generates random partitions, folds, of data.
       Set the seed to an integer to recover the same random partitions on
       subsequent runs.}
  \item{new_scale}{Transform numeric predictor variables with more than two
       unique values to the specified metric before
       conducting the analysis, \code{"z"}, \code{"center"}, \code{"0to1"},
       or \code{"robust"}. Applies to \code{kfold} separately to the
       training and testing folds as well to avoid data leakage.}
  \item{scale_response}{If doing a rescale with \code{new_scale}, by default
       do not scale the response variable, or set to \code{TRUE} to
       rescale along with the predictor variables.}\cr

  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
       with \code{\link{style}} function.}
  \item{graphics}{Produce graphics. Default is \code{TRUE}.  In \code{knitr}
       can be useful to set to \code{FALSE} so that \code{\link{regPlot}}
       can be used to place the graphics within the output file.}
  \item{size}{Size of plotted points.}
  \item{pdf}{If \code{TRUE}, then graphics are written to pdf files.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{bubble_plot}{For a single predictor variable, by default, plot
       as bubbles only when the single predictive variable and the
       target variable have less than or equal to 12 unique values. Otherwise,
       set \code{TRUE} or \code{FALSE}.}
  \item{refs}{If \code{TRUE}, then list the references for R and the packages
        used from which functions were used to generate the output.}
  \item{n_cat}{Number of categories, specifies the largest number of
        unique, equally spaced integer values of a variable for which
        the variable will be analyzed as categorical instead of continuous.
        Default is 0. Use to specify that such variables are to be analyzed
        as categorical, a kind of informal R factor.
        \bold{[deprecated]}: Best to convert a categorical integer variable
         to a factor.}
  \item{fun_call}{Function call. Used internally with \code{knitr} to pass the
        function call when obtained from the abbreviated function call \code{reg}.
        Not usually invoked by the user.}
  \item{\dots}{Other parameter values for R function \code{\link{lm}} which
       provides the core computations.}
}


\details{
OVERVIEW\cr
The purpose of \code{Regression} is to combine the following function calls into one, as well as provide ancillary analyses such as graphics, organizing output into tables and sorting to assist interpretation of the output, as well as generate R Markdown to run through \code{knitr}, such as with \code{RStudio}, to provide extensive interpretative output.

The basic analysis successively invokes several standard R functions beginning with the standard R function for estimation of a linear model, \code{\link{lm}}. The output of the analysis of \code{\link{lm}} is stored in the object \code{lm.out}, available for further analysis in the R environment upon completion of the \code{Regression} function. By default \code{reg} automatically provides the analyses from the standard R functions, \code{\link{summary}}, \code{\link{confint}} and \code{\link{anova}}, with some of the standard output modified and enhanced. The residual analysis invokes \code{\link{fitted}}, \code{\link{resid}}, \code{\link{rstudent}}, and \code{\link{cooks.distance}} functions.  The option for prediction intervals calls the standard R function \code{\link{predict}}, once with the argument \code{interval="confidence"} and once with \code{interval="prediction"}. The \code{lessR} \code{\link{X}} function with \code{type="density"} provides the histogram and density plots for the residuals and the \code{\link{ScatterPlot}} function provides the scatter plots of the residuals with the fitted values and of the data for the one-predictor model. The \code{pairs} function provides the scatterplot matrix of all the variables in the model. Thomas Lumley's \code{leaps} package contains the \code{leaps} function that provides the analysis of the fit of all possible model subsets.

INPUT DATA FRAME\cr
The name \code{d} is by default provided by the \code{\link{Read}} function included in this package for reading and displaying information about the data in preparation for analysis. If all the variables in the model are not in the same data frame, the analysis will not complete.  Specify the name of the data frame for analysis with the \code{data} option if the name is not the default \code{d}.
       
The \code{filter} parameter subsets rows (cases) of the input data frame according to a logical expression. Use the standard R operators for logical statements as described in \code{\link{Logic}} such as \code{&} for and, \code{|} for or and \code{!} for not, and use the standard R relational operators as described in \code{\link{Comparison}} such as \code{==} for logical equality \code{!=} for not equals, and \code{>} for greater than. See the Examples.

TEXT OUTPUT\cr
The output is produced in pieces by topic (see \code{values} below), automatically collated by default in the final output. But the pieces are available for later reference if the output of the function is directed toward an object, such as \code{r} in \code{r <- reg(Y ~ X)}. This is especially useful if the pieces are accessed within \code{knitr} or individual pieces are displayed at the console.

The text output is organized to provide the most relevant information while at the same time minimizing the total amount of output, particularly for analyses with large numbers of observations (rows of data), the display of which is by default restricted to only the most interesting or representative observations in the analyses of the residuals and predicted values. Additional economy can be obtained by invoking the \code{brief=TRUE} option, or run \code{reg_brief}, which limits the analysis to just the basic analysis of the estimated coefficients and fit, and if \code{X1_new}, etc. are requested, the relevant rows of forecasted values.
.

R MARKDOWN\cr
An R~Markdown file ready for knitting and rendering into one of several formats can be obtained by specifying a value for \code{Rmd}. For the specified file name, the directory to which the file is written is displayed on the console text output, and the file type \code{.Rmd} is automatically appended to the specified name if it is not included in the specification. 

To access the same data file for the regression analysis from running \code{Regression} from the R console, and that accomplished by knitting the generated R~Markdown, first read the data into R with the lessR \code{\link{Read}} function. That function stores the name of the last data file read so that it can be accessed via R as the markdown is knit and then rendered into the specified format. The default rendering is to \code{HTML}, but other formats can be specified with \code{Rmd_format}. 

The output from \code{Rmd} is conceptually partitioned into four parts:  results, explanations of the results, interpretations of the results, documentation of the code, and the code itself. By default, all available output is generated but the flags \code{results}, \code{explain}, \code{interpret}, \code{document}, \code{code} can be set to \code{FALSE} to reduce the output. The options can be specified in a specific function call or set globally, such as with \code{options(explain=FALSE)}. Turning off all the flags leaves just the outline of the potential output and a bare minimum of results.

Both any existing variable labels and variable units are included in the output to the R~Markdown file. Any variable units set as a dollar, are set as USD dollars and cents in the output, displayed with a dollar sign.

The default analysis provides as text output to the console the model's parameter estimates and corresponding hypothesis tests and confidence intervals, goodness of fit indices, the ANOVA table, analysis of residuals and influence as well as the confidence and prediction intervals for each observation in the model. Also provided, for multiple regression models, collinearity analysis of the predictor variables and adjusted R-squared for the corresponding models defined by each possible subset of the predictor variables.

The Markdown is produced from input files, one for each section of the rendered document. Find the default files and their names at:\\
\code{system.file("Rmd/reg/", package="lessR")}\\
The \code{Rmd_dir} option specifies a location for custom input files. The \code{Rmd_custom} parameter specifies which default files should be replaced by custom files, anywhere from any one of them to all eight. 


DECIMAL DIGITS\cr
The number of decimal digits displayed on the output is, by default, the maximum number of decimal digits for all the data values of the response variable. Or, this value can be explicitly specified with the \code{digits_d} parameter.

Visualizations\cr
Three default graphs are provided. When running \code{R} by itself, by default the graphs are written to separate graphics windows (which may overlap each other completely, in which case move the top graphics windows). Or, the \code{pdf} option may be invoked to save the graphs to a single pdf file called \code{regOut.pdf}. Within \code{RStudio} the graphs are successively written to the \code{Plots} window. Within \code{knitr} from \code{RStudio} the graphics will all appear by default at the beginning of the output. Or set to \code{graphics=FALSE}, and generate them individually with the accompanying function \code{\link{regPlot}} at the desired location within the file.

1. A histogram of the residuals includes the superimposed normal and general density plots from the \code{\link{X}} function with \code{type="density"} included in this \code{lessR} package.  The overlapping density plots, which both overlap the histogram, are filled with semi-transparent colors to enhance readability.

2. A scatterplot of the residuals with the fitted values is also provided from the \code{\link{ScatterPlot}} function included in this package. The point corresponding to the largest value of Cook's distance, regardless of its size, is plotted in red and labeled and the corresponding value of Cook's distance specified in the subtitle of the plot. Also by default all points with a Cook's distance value larger than 1.0 are plotted in red, a value that can be specified to any arbitrary value with the \code{cooks_cut} option.  This scatterplot also includes the \code{\link{lowess}} curve.

3. For models with a single predictor variable, a scatterplot of the data is produced, which also includes the regression line and corresponding confidence and prediction intervals. As with the density histogram plot of the residuals and the scatterplot of the fitted values and residuals, the scatterplot includes a colored background with grid lines. For multiple regression models, a scatterplot matrix of the variables in the model with the \code{\link{lowess}} best-fit line of each constituent scatterplot is produced. If the \code{scatter_coef} option is invoked, each scatterplot in the upper-diagonal of the correlation matrix is replaced with its correlation coefficient.

RESIDUAL ANALYSIS\cr
By default the residual analysis lists the data and fitted value for each observation as well as the residual, Studentized residual, Cook's distance and dffits, with the first 20 observations listed and sorted by Cook's distance.  The \code{res_sort} option provides for sorting by the Studentized residuals or not sorting at all.  The \code{n_res_rows} option provides for listing these rows of data and computed statistics for any specified number of observations (rows).  To turn off the analysis of residuals, specify \code{n_res_rows=0}.

PREDICTION INTERVALS\cr
The output for the confidence and prediction intervals includes a table with the data and fitted value for each observation, the lower and upper bounds for the confidence interval and the prediction interval, and the width of the prediction interval.  The observations are sorted by the lower bound of each prediction interval.  If there are 25 or more observations then the information for only the first three, the middle three and the last three observations is displayed. To turn off the analysis of prediction intervals, specify \code{n_pred_rows=0}, which also removes the corresponding intervals from the scatterplot produced with a model with exactly one predictor variable, yielding just the scatterplot and the regression line.

The data for the default analysis of the prediction intervals is for the values of the predictor variables for each observation, that is, for each row of the data. New values of the predictor variables can be specified for the calculation of the prediction intervals by providing values for the options \code{X1_new} for the values of the first listed predictor variable in the model, \code{X2_new} for the second listed predictor variable, and so forth for up to five predictor variables, and all predictor variables are numeric. To provide these values, use functions such as \code{\link{seq}} for specifying a sequence of values and \code{\link{c}} for specifying a vector of values. For multiple regression models, all combinations of the specified new values for all of the predictor variables are analyzed.

RELATIONS AMONG THE VARIABLES\cr
The relations among the variables are displayed visually in the scatterplot matrix, which by default shows a scatterplot for each pair of variables in the lower triangle and the corresponding correlation coefficient in the upper triangle (see \code{scatter_coef}). For multiple regression models, collinearity analysis is also provided. Also provided are the first 50 models with the largest R squared adjusted from each possible model from an analysis of all possible subsets of the predictor variables.  This all subsets analysis requires the \code{leaps} function from the \code{leaps} package. These contributed packages are automatically loaded if available.  To turn off the all possible sets option, set \code{subsets=FALSE}.

RECODE PREDICTOR VARIABLES\cr
The \code{new_scale} parameter provides for recoding the values of the predictor variables according to several different transformations:  \code{"z"}, \code{"center"}, \code{"0to1"}, or \code{"robust"}. The latter is a robust version of classic standardization in which the mean is replaced by the median and the standard deviation by the IQR. All numeric predictor variables with more than two values are standardized. 

So any numeric variable with more than two values that is a categorical variable should be first converted to an R factor. If there are some numeric predictor variables that should not be standardized, such as an interaction term with centered variables that define the interaction, then the rescaling should be done separately, such as with base~R function \code{\link{scale}} or lessR  \code{\link{rescale}}. 

ANCOVA\cr
If there are two predictor variables, one categorical and one continuous, an analysis of covariance is performed. The resulting scatterplot is of the continuous response variable and predictor variable, at each level of the categorical variable. To address the unbalanced ANOVA design, the Type~II sums of squares are reported for each effect. The regression model for each level of the categorical variable are displayed.

A categorical variable is defined as either an R \code{factor} or a non-numeric variable. If numeric and categorical, then explicitly define the categorical variable as a factor. 

MODERATOR VARIABLE\cr
For two predictor models, one of the predictor variables can be entered into the analysis as a moderator variable with the \code{mod} parameter. By default the two predictor variables are centered, so their means become zero. Then a third variable is entered into the model, the interaction of the two centered variables, computed by multiplication of their respective values, row by row. The potential interaction is visually displayed by plotting response Y against predictor X, at three different values of continuous W: the mean and 1 standard deviation above and below the mean.

For predictor variable, X, second predictor as a potential moderator, W, and response Y, enter the following R input.\cr
\code{reg(Y ~ X + W, mod=W)}\cr
From this, with now centered variables X and W, the following multiple regression model is automatically defined.\cr
\eqn{\hat{Y} = b_0 + b_x X + b_w W + b_{xw} XW}\cr
From that model, the function sets the moderator variable W to each of the three constant values, \code{Wc}, and solves for the given value \code{Wc} to visually plot the potential interaction. 



INVOKED R OPTIONS\cr
The \code{\link{options}} function is called to turn off the stars for different significance levels (show.signif.stars=FALSE), to turn off scientific notation for the output (scipen=30), and to set the width of the text output at the console to 120 characters. The later option can be re-specified with the \code{text_width} option.  After \code{Regression} is finished with a normal termination, the options are re-set to their values before the \code{Regression} function began executing.

COLOR THEME\cr
A color theme for all the colors can be changed globally with \link{style}. Or, the color theme can be changed for all subsequent graphical analysis with the \code{lessR} function \code{\link{style}}. The default color theme is \code{lightbronze}, but a gray scale is available by removing the bronze background, such as with \code{style(window_fill="white")} or with \code{"gray"}. Other themes are available as explained in \code{\link{style}}.

VARIABLE LABELS\cr
If variable labels exist, then the corresponding variable label is by default listed as the label for the horizontal axis and on the text output. For more information, see \code{\link{Read}}.
}

\value{
The output can optionally be returned and saved into an \code{R} object, otherwise it simply appears at the console. The components of this object are redesigned in \code{lessR} version 3.3 into (a) pieces of text that form the readable output and (b) a variety of statistics. The readable output are character strings such as tables amenable for viewing and interpretation. The statistics are numerical values amenable for further analysis, such as to be referenced in a subsequent \code{knitr} document. The motivation of these two types of output is to facilitate \code{knitr} documents, as the name of each piece, preceded by the name of the saved object followed by a dollar sign, can be inserted into the \code{knitr} document (see \code{examples}).

TEXT OUTPUT\cr
\code{out_background}: variables in the model, rows of data and retained\cr
\code{out_estimates}: estimated coefficients, hypothesis tests and confidence intervals\cr
\code{out_fit}: fit indices; st dev of residuals; R-sq with adj and PRESS versions\cr
\code{out_anova}: analysis of variance\cr
\code{out_collinear}: collinearity analysis\cr
\code{out_subsets}: R squared adjusted for all (or many) possible subsets\cr
\code{out_residuals}: residuals\cr
\code{out_predict}: analysis of residuals and influence\cr
\code{out_ref}: references if selected on the \code{Regression} function call\cr
\code{out_Rmd}: lists the name and location of the generated \code{Rmd} file\cr
\code{out_plots}: list of plots generated if more than one\cr
\code{out_suggest}: list of suggested other analyses\cr

Separated from the rest of the text output are the major headings, which cannot be included with custom collations of the output.
\code{out_title_bck}: BACKGROUND\cr
\code{out_title_basic}: BASIC ANALYSIS\cr
\code{out_title_rel}: RELATIONS AMONG THE VARIABLES\cr
\code{out_title_res}: ANALYSIS OF RESIDUALS AND INFLUENCE\cr
\code{out_title_pred}: FORECASTING ERROR\cr

STATISTICS\cr
\code{call}: function call that generated the analysis\cr
\code{formula}: model formula that specifies the model\cr
\code{vars}: vector of variable names in the model\cr
\code{n.vars}: number of variables in the model\cr
\code{n.obs}: number of rows of data submitted for analysis\cr
\code{n.keep}: number of rows of data retained in the analysis\cr
\code{coefficients}: estimated regression coefficients\cr
\code{sterrs}: standard errors of the estimated coefficients\cr
\code{tvalues}: t-values of the estimated coefficients for null of 0\cr
\code{pvalues}: p-values from the t-tests of the estimated coefficients\cr
\code{cilb}: lower bound of 95\% confidence interval of estimate\cr
\code{ciub}: upper bound of 95\% confidence interval of estimate \cr
\code{anova_model}: model df, ss, ms, F-value and p-value\cr
\code{anova_residual}: residual df, ss and ms\cr
\code{anova_total}: total df, ss and ms\cr
\code{se}: standard deviation of the residuals\cr
\code{resid_range}: 95\% range of normally distributed fitted residuals\cr
\code{Rsq}: R-squared\cr
\code{Rsqadj}: adjusted R-squared\cr
\code{PRESS}: PRESS sum of squares\cr
\code{RsqPRESS}: PRESS R-squared\cr
\code{m_se}: K-fold average of the standard deviation of residuals.
\code{m_MSE}: K-fold average of the MSE.
\code{m_Rsq}: K-fold average of R-squared.
\code{tolerances}: tolerance of each predictor variable for collinearity analysis\cr
\code{VIF}: variance inflation factor for each predictor variable\cr
\code{resid.max}: five largest values of the residuals on which the output is sorted\cr
\code{pred_min_max}: Rows with the smallest and largest prediction intervals\cr
\code{residuals}: residuals\cr
\code{fitted}: fitted values\cr
\code{cooks.distance}: Cook's distance\cr
\code{model}: data retained for the analysis\cr
\code{terms}: terms specified for the analysis\cr

Although not typically needed for analysis, if the regression output is assigned to an object named, for example, \code{r}, then the complete contents of the object can be viewed directly with the \code{\link{unclass}} function, here as \code{unclass(r)}. Invoking the \code{\link{class}} function on the saved object reveals a class of \code{out_all}. The class of each of the text pieces of output is \code{out}.
}

\references{
Lumley, T., \code{leaps} function from the \code{leaps} package.\cr

Gerbing, D. W. (2023). \emph{R Data Analysis without Programming: Explanation and Interpretation}, 2nd edition, Chapters 11-13, NY: Routledge.

Gerbing, D. W. (2021). Enhancement of the Command-Line Environment for use in the Introductory Statistics Course and Beyond, \emph{Journal of Statistics and Data Science Education}, 29(3), 251-266, https://www.tandfonline.com/doi/abs/10.1080/26939169.2021.1999871. 

Xie, Y. (2013). Dynamic Documents with R and knitr, Chapman & Hall/CRC The R Series.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{formula}}, \code{\link{lm}}, \code{\link{summary.lm}}, \code{\link{anova}}, \code{\link{confint}}, \code{\link{fitted}}, \code{\link{resid}}, \code{\link{rstudent}}, \code{\link{cooks.distance}}, \code{\link{Nest}}, \code{\link{regPlot}}
}

\examples{
# read internal data set
d <- rd("Reading", quiet=TRUE)
# do not need all this data, so take only 30% to reduce CPU time
d <- Subset(random=.3)

# one-predictor regression
# Provide all default analyses including scatterplot etc.
# Can abbreviate Regression with reg
Regression(Reading ~ Verbal)

# expression as a term of the model, evaluated against the data
#   frame, with the expression text as the term label
# I() gives ^ its arithmetic meaning, here the square of Verbal,
#   because ^ otherwise expresses formula structure, not arithmetic
reg(Reading ~ Verbal + I(Verbal^2))
# Provide only the brief analysis on standardized variables
#  with 3-fold cross-validations
reg_brief(Reading ~ Verbal, new_scale="z", kfold=3)

# Access the pieces of output, here in an object named \code{r}
r <- reg(Reading ~ Verbal + Absent + Income)
# Display all output at the console in the standard sequence
r
# list the names of all the saved components
names(r)
# Display just the estimated coefficients and their inferential analysis
r$out_estimates


\donttest{
# Generate an R markdown file with the option: Rmd
# Output file here will be read.Rmd, a simple text file that can
#   be edited with any text editor including RStudio from which it
#   can be knit to generate dynamic output to a Word document,
#   pdf file or html file, as well as automatically rendered
# Here knit into an html file, but do not display
#reg(Reading ~ Verbal + Absent, Rmd="read", Rmd_browser=FALSE)

# generate interpretative R markdown file and render Word and odt
#reg(Reading ~ Verbal + Absent, Rmd="eg", Rmd_format=c("word", "odt"))

# just for incomes > 100000 and less than 5 days absent 
Regression(Reading ~ Verbal, filter=(Income > 100 & Absent < 5))

# standardize
Regression(Reading ~ Verbal, new_scale="z")


# Multiple regression model
# Save the three output plots as pdf files 4 inches square
#Regression(Reading ~ Verbal + Absent + Income, pdf=TRUE,
#   width=4, height=4)

# Compare nested models
# Reduced model:  Reading ~ Verbal
# Full model:  Reading ~ Verbal + Income + Absent
Nest(Reading, Verbal, c(Income, Absent))
}

# Specify new values of the predictor variables to calculate
#  forecasted values and the corresponding prediction intervals
# Specify an input data frame other than d, see help(mtcars)
Regression(mpg ~ hp + wt, data=mtcars,
  X1_new=seq(50,350,50), X2_new=c(2,3))

# Indicator (dummy) variable
#d <- Read("Employee", quiet=TRUE)
#reg(Salary ~ Dept)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ regression }

\name{skew}
\alias{skew}

\title{Skew of a variable.}

\description{
The Fisher-Pearson standardized moment coefficient adjusted for sample size.
}

\usage{
skew(x, na.rm=TRUE)
}

\arguments{
  \item{x}{Variable from which to compute skewness.}
  \item{na.rm}{A logical value indicating whether NA values should be
       removed before the computation proceeds.}
}

\details{
\code{G1}, the adjusted Fisher-Pearson standardized moment coefficient. The adjustment is the sample size \code{n} divided by the product of \code{n-1} and \code{n-2}.

The core component of the skewness expression is for each data value calculate, standardize the value, then raise the standardized value to the third power. The component is the sum of these cubics.  
}

\value{
Skew.
}


\references{
Doane, D. P. & Seward, L. E. (2011). Measuring Skewness: A Forgotten Statistic?,Journal of Statistics Education, 19(2), 1-18. URL: https://doi.org/10.1080/10691898.2011.11889611.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\examples{
x <- rnorm(100)
skew(x)
}

% Add one or more standard keywords, skew file 'KEYWORDS' in the
% R documentation directory.
\keyword{skew}

\name{dataAnova_2way}
\docType{data}
\alias{dataAnova_2way}
\title{Data for a Two-Way Balanced Factorial Design}

\description{Laboratory rats were randomly and equally divided into groups, and then given one of three dosages of an arousal inducing drug: 0, 5, and 10 milligrams. Following the dosage, each rat completed either an easy or a hard maze to obtain a food reward. The response (dependent) variable is the Time in seconds to complete the maze.}

\format{A data table with 48 rows of data and 3 columns: Difficulty, Dosage, and Time.}

\references{
Gerbing, D. W. (later in 2022). R Data Analysis without Programming, 2nd Edition, Chapter 7, NY: Routledge.

Gerbing, D. W. (2021). Enhancement of the Command-Line Environment for use in the Introductory Statistics Course and Beyond, \emph{Journal of Statistics and Data Science Education}, 29(3), 251-266, https://www.tandfonline.com/doi/abs/10.1080/26939169.2021.1999871. 
}

\author{
David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})
}

\examples{
d <- Read("Anova_2way")
ANOVA(Time ~ Dosage * Difficulty)
}

\source{author}
\keyword{datasets}

\name{Correlation}
\alias{Correlation}
\alias{cr}
\alias{cr_brief}

\title{Correlation Analysis}

\description{
Abbreviation: \code{cr}, \code{cr_brief}

For two variables, yields the correlation coefficient with hypothesis test and confidence interval. For a data frame or subset of variables from a data frame, yields the correlation matrix. The default computed coefficient(s) are the standard Pearson's product-moment correlation, with Spearman and Kendall coefficients available. For the default missing data technique of pairwise deletion, an analysis of missing data for each computed correlation coefficient is provided. For a correlation matrix, a statistical summary of the missing data across all cells is provided.
}

\usage{
Correlation(x, y, data=d,
         miss=c("pairwise", "listwise", "everything"),
         show=c("cor", "missing"),
         fill_low=NULL, fill_hi=NULL,
         brief=FALSE, digits_d=NULL, heat_map=TRUE,
         main=NULL, bottom=3, right=3, quiet=getOption("quiet"),
         pdf_file=NULL, width=5, height=5, \dots)

cr_brief(\dots, brief=TRUE) 

cr(\dots) 
}


\arguments{
  \item{x}{First variable, or list of variables for a correlation matrix.
       May also be an expression of variables, such as \code{log(Years)},
       evaluated against the data frame, then the user's workspace, with
       the expression text as the label. An expression that yields a data
       frame, such as \code{d[, 1:4]}, specifies a correlation matrix.}
  \item{y}{Second variable or not specified if the first argument is a
       list. May also be an expression of variables, as for \code{x}.}
  \item{data}{Optional data frame that contains the variables of interest,
       default is \code{d}.}
  \item{miss}{Basis for deleting missing data values.}
  \item{show}{Default is to compute and show correlations, or specify to 
       compute and show missing data by setting to \code{"missing"}.}
  \item{fill_low}{Starting color for a custom sequential palette.}
  \item{fill_hi}{Ending color for a custom sequential palette.}
  \item{brief}{Pertains to a single correlation coefficient analysis. If 
       \code{FALSE}, then the sample covariance and number of non-missing
       and missing observations are displayed.}
  \item{digits_d}{Specifies the number of decimal digits to display in the output.}
  \item{heat_map}{If \code{TRUE}, generate a heat map.}
  \item{main}{Graph title of heat map. Set to \code{main=""} to turn off.}
  \item{bottom}{Number of lines in the bottom margin of heat map.}
  \item{right}{Number of lines in the right margin of heat map.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
        with \code{\link{style}} function.}
  \item{pdf_file}{Indicate to direct pdf graphics to the specified name of
        the pdf file.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{\dots}{Additional arguments passed to \code{\link{cor}} and
        \code{\link{cor.test}}, e.g., \code{method="spearman"} or
        \code{method="kendall"}, and \code{alternative="less"} or
        \code{alternative="greater"}.}
}


\details{
When two variables are specified, both \code{x} and \code{y}, the output is the correlation coefficient with hypothesis test, for a null hypothesis of 0, and confidence interval. Also displays the sample covariance. Based on R functions \code{\link{cor}}, \code{\link{cor.test}}, \code{\link{cov}}.

In place of two variables \code{x} and \code{y}, \code{x} can be a complete data frame, either specified with the name of a data frame, or blank to rely upon the default data frame \code{d}. Or, \code{x} can be a list of variables from the input data frame. In these situations \code{y} is missing. Any non-numeric variables in the data frame or specified variable list are automatically deleted from the analysis. 

When \code{heat_map=TRUE}, generate a heat map to standard graphics device. Set \code{pdf_file} to generate these graphics but have them directed to their respective pdf files.

For treating missing data, the default is \code{pairwise}, which means that an observation is deleted only for the computation of a specific correlation coefficient if one or both variables are missing the value for the relevant variable(s).  For \code{listwise} deletion, the entire observation is deleted from the analysis if any of its data values are missing.  For the more extreme \code{everything} option, any missing data values for a variable result in all correlations for that variable reported as missing.
}

\value{
From versions of \code{lessR} of 3.3 and earlier, if a correlation matrix is computed, the matrix is returned. Now more values are returned, so the matrix is embedded in a list of returned elements.

READABLE OUTPUT\cr

single coefficient\cr
\code{r}: Estimated correlation coefficient\cr
\code{tvalue}: t statistic for testing \eqn{H_0:r=0}\cr
\code{df}: Degrees of freedom for the t test\cr
\code{pvalue}: P-value for the t test\cr
\code{lb}: Lower bound of the confidence interval for \code{r}\cr
\code{ub}: Upper bound of the confidence interval for \code{r}\cr
\code{n}: Number of non-missing paired observations\cr
\code{cov}: Sample covariance\cr

matrix\cr
\code{out_cor}: Correlations or \code{out_missing}: Missing values analysis\cr


STATISTICS\cr

single coefficient\cr
\code{r}: Model formula that specifies the model\cr
\code{tvalue}: t-statistic of estimated value of null hypothesis of no relationship\cr
\code{df}: Degrees of freedom of hypothesis test 
\code{pvalue}: Number of rows of data submitted for analysis\cr
\code{lb}: Lower bound of confidence interval\cr
\code{ub}: Upper bound of confidence interval\cr

matrix\cr
\code{R}: Correlations\cr
}

\references{
Gerbing, D. W. (2023). \emph{R Data Analysis without Programming: Explanation and Interpretation}, 2nd edition, Chapter 10, NY: Routledge.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{cor.test}}, \code{\link{cov}}.
}

\examples{
# data
n <- 12
f <- sample(c("Group1","Group2"), size=n, replace=TRUE)
x1 <- round(rnorm(n=n, mean=50, sd=10), 2)
x2 <- round(rnorm(n=n, mean=50, sd=10), 2)
x3 <- round(rnorm(n=n, mean=50, sd=10), 2)
x4 <- round(rnorm(n=n, mean=50, sd=10), 2)
d <- data.frame(f,x1, x2, x3, x4)
rm(f); rm(x1); rm(x2); rm(x3); rm(x4)

# correlation and covariance
Correlation(x1, x2)
# short name
cr(x1, x2)

# expression as a variable, evaluated against the data frame,
#   with the expression text as the label
Correlation(x1, log(x2))
# brief form of output
cr_brief(x1, x2)

# Spearman rank correlation, one-sided test
Correlation(x1, x2, method="spearman", alternative="less")

# correlation matrix of the numerical variables in d assigned to R
R <- Correlation()

# correlation matrix of Kendall's tau coefficients
R <- cr(method="kendall")

# analysis with data not from data frame R
data(attitude)
R <- Correlation(rating, learning, data=attitude)

# analysis of entire data frame that is not R
data(attitude)
R <- Correlation(attitude)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ write }
\keyword{ csv }

\name{corReflect}
\alias{corReflect}
\alias{reflect}

\title{Reflect Specified Variables in a Correlation Matrix}

\description{
Abbreviation: \code{reflect}

Reflects the specified variables by multiplying each correlation of the variable by -1.
Usually a prelude to a factor analysis, such as provided by \code{\link{corCFA}}.
}

\usage{
corReflect(R=mycor, vars,
          main=NULL, heat_map=TRUE, bottom=NULL,right=NULL, 
          pdf_file=NULL, width=5, height=5, \dots)

reflect(\dots)
}

\arguments{
  \item{R}{Correlation matrix.}
  \item{vars}{List of the re-ordered variables, each variable listed by its ordinal
       position in the input correlation matrix.}
  \item{main}{Graph title. Set to \code{main=""} to turn off.}
  \item{heat_map}{If \code{TRUE}, display a heat map of the item
        correlations with item communalities in the diagonal.}
  \item{bottom}{Number of lines of bottom margin.}
  \item{right}{Number of lines of right margin.}
  \item{pdf_file}{Name of the pdf file to which graphics are redirected.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{\dots}{Parameter values_}
}

\details{
Reflects the specified variables by multiplying each correlation of the variable by -1.
The original data from which the correlations are computed is unmodified unless the output of the function is written into the input correlation matrix, by default \code{mycor}.

Define the constituent variables, the items, with a listing of each variable by its name in the correlation matrix. If the specified variables are in consecutive order in the input correlation matrix, the list can be specified by listing the first variable, a colon, and then the last variable.  To specify multiple variables, a single variable or a list, separate each by a comma, then invoke the R combine or \code{\link{c}} function. For example, if the list of variables in the input correlation matrix is from m02 through m05, and the variable Anxiety, then define the list in the \code{corReflect} function call according to \code{vars=c(m02:m05,Anxiety)}. 

}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Correlation}}, \code{\link{recode}}.
}

\examples{
# input correlation matrix of perfect two-factor model
# Factor Pattern for each Factor: 0.8, 0.6, 0.4
# Factor-Factor correlation: 0.3
mycor <- matrix(nrow=6, ncol=6, byrow=TRUE,
c(1.000,0.480,0.320,0.192,0.144,0.096,
  0.480,1.000,0.240,0.144,0.108,0.072,
  0.320,0.240,1.000,0.096,0.072,0.048,
  0.192,0.144,0.096,1.000,0.480,0.320,
  0.144,0.108,0.072,0.480,1.000,0.240,
  0.096,0.072,0.048,0.320,0.240,1.000))
colnames(mycor) <- c("V1", "V2", "V3", "V4", "V5", "V6")
rownames(mycor) <- colnames(mycor) 

# reflect all 3 indicators of the second factor
mynewcor <- corReflect(vars=c(V4,V5,V6))

# abbreviated form
# replace original mycor
mycor <- reflect(vars=c(V4,V5,V6))
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ correlation }

\name{tsExtract}
\alias{tsExtract}

\title{Extract Dates and Values from a Time Series}

\description{
Converts a base R time series object of class \code{ts} into two
data frames --- one of \code{Date} values and one of numeric values ---
suitable for passing directly to \code{\link{XY}} as the \code{x} and
\code{y} arguments.

\code{\link{XY}} no longer accepts a \code{ts} object directly.
Use \code{tsExtract} to prepare the components first, then pass them
to \code{\link{XY}}. Because the extracted vectors exist in the global
environment rather than in a data frame, include \code{data=NULL} in
the \code{\link{XY}} call.
}

\usage{
tsExtract(y.ts, x.name=NULL)
}

\arguments{
  \item{y.ts}{A time series object of class \code{ts}, either univariate
       or multivariate.}
  \item{x.name}{Optional character string used to name the date column in
       the returned \code{x.dates} data frame. When \code{NULL}, the
       column is named \code{x.dates}.}
}

\details{
The function uses \code{\link{time}} to obtain the fractional-year time
index of each observation and converts it to a \code{\link{Date}} object.
Supported frequencies are:

\tabular{ll}{
  \code{365} or \code{366} \tab Daily \cr
  \code{52}                \tab Weekly \cr
  \code{12}                \tab Monthly \cr
  \code{4}                 \tab Quarterly \cr
  \code{1}                 \tab Yearly \cr
}

Monthly conversion maps each fractional-year index to the first day of
the corresponding calendar month, which sidesteps the uneven month
lengths that base R's \code{ts} indexing does not track.

For a multivariate \code{ts} object, the y component contains one column
per time series, named after the original column names.
}

\value{
A list with three components:

\item{x.dates}{A single-column data frame of class \code{Date}, one row
     per observation.}
\item{y}{A data frame of numeric values. One column for a univariate
     series; one column per series for a multivariate object.}
\item{y.name}{Character string giving the name of the y variable (or the
     name from the \code{yname} option for a univariate series).}
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{XY}}, \code{\link{ts}}, \code{\link{time}}
}

\examples{
# Monthly airline passenger data (built-in R dataset)
pull <- tsExtract(AirPassengers)
x <- pull$x.dates
y <- pull$y
XY(x,y, data=NULL)

# Quarterly earnings data
pull <- tsExtract(JohnsonJohnson)
x <- pull$x.dates
y <- pull$y
XY(x, y, data=NULL)
}

\keyword{ts}
\keyword{manip}

\name{style}
\alias{style}

\title{Set the Default Color Theme and Other System Settings}

\description{
Deprecated Names: \code{set}, \code{theme}

The color and style attributes of each plot can be set as a general theme, or individually set from the following list of attributes. For convenience, groups of these attributes are specified to define color themes, plus style sub-themes that apply to any theme, with default values:  \code{theme="colors"} and \code{sub_theme="default"}. To reset to the default theme: \code{style()}. 
}

\usage{
style(
  theme=c("colors", "lightbronze", "dodgerblue", "darkred", "gray",
      "gold", "darkgreen", "blue", "red", "rose", "slatered", "green",
      "purple", "sienna", "brown", "orange", "white", "light"),
  sub_theme=c("default", "black", "wsj"),
  set=NULL, get=FALSE, reset=TRUE,

  window_fill=getOption("window_fill"),
  panel_fill=getOption("panel_fill"),
  panel_color=getOption("panel_color"),
  panel_lwd=getOption("panel_lwd"),
  panel_lty=getOption("panel_lty"),

  fill=NULL,
  bar_fill=getOption("bar_fill"),
  bar_fill_discrete=getOption("bar_fill_discrete"),
  bar_fill_cont=getOption("bar_fill_cont"),
  trans=NULL,
  trans_bar_fill=getOption("trans_bar_fill"),
  color=NULL,
  bar_color=getOption("bar_color"),
  bar_color_cont=getOption("bar_color_cont"),
  bar_color_discrete=getOption("bar_color_discrete"),
  
  labels=getOption("labels"),
  labels_color=getOption("labels_color"), 
  labels_size=getOption("labels_size"),
  labels_digits=getOption("labels_digits"),
  labels_position=getOption("labels_position"),
		 
  pt_fill=getOption("pt_fill"),
  trans_pt_fill=getOption("trans_pt_fill"),
  pt_color=getOption("pt_color"),
  se_fill=getOption("se_fill"),
  ellipse_fill=getOption("ellipse_fill"),
  ellipse_color=getOption("ellipse_color"),
  ellipse_lwd=getOption("ellipse_lwd"),
  fit_color=getOption("fit_color"),
  fit_lwd=getOption("fit_lwd"),
  bubble_text_color=getOption("bubble_text_color"),
  segment_color=getOption("segment_color"),
  ID_color=getOption("ID_color"),
  out_fill=getOption("out_fill"),
  out_color=getOption("out_color"),
  out2_fill=getOption("out2_fill"),
  out2_color=getOption("out2_color"),

  violin_fill=getOption("violin_fill"),
  violin_color=getOption("violin_color"),
  box_fill=getOption("box_fill"),
  box_color=getOption("box_color"),

  axis_color=getOption("axis_color"),
  axis_x_color=getOption("axis_x_color"),
  axis_y_color=getOption("axis_y_color"),
  axis_lwd=getOption("axis_lwd"),
  axis_x_lwd=getOption("axis_x_lwd"),
  axis_y_lwd=getOption("axis_y_lwd"),
  axis_lty=getOption("axis_lty"),
  axis_x_lty=getOption("axis_x_lty"),
  axis_y_lty=getOption("axis_y_lty"),
  axis_size=getOption("axis_size"),
  axis_x_size=getOption("axis_x_size"),
  axis_y_size=getOption("axis_y_size"),
  axis_text_color=getOption("axis_text_color"),
  axis_x_text_color=getOption("axis_x_text_color"),
  axis_y_text_color=getOption("axis_y_text_color"),
  rotate_x=getOption("rotate_x"),
  rotate_y=getOption("rotate_y"),
  offset=getOption("offset"),

  lab_color=getOption("lab_color"),
  lab_x_color=getOption("lab_x_color"),
  lab_y_color=getOption("lab_y_color"),
  lab_size=getOption("lab_size"),
  lab_x_size=getOption("lab_x_size"),
  lab_y_size=getOption("lab_y_size"),
  main_color=getOption("main_color"),
  main_size=getOption("main_size"),

  grid_color=getOption("grid_color"),
  grid_x_color=getOption("grid_x_color"),
  grid_y_color=getOption("grid_y_color"),
  grid_lwd=getOption("grid_lwd"),
  grid_x_lwd=getOption("grid_x_lwd"),
  grid_y_lwd=getOption("grid_y_lwd"),
  grid_lty=getOption("grid_lty"),
  grid_x_lty=getOption("grid_x_lty"),
  grid_y_lty=getOption("grid_y_lty"),

  strip_fill=getOption("strip_fill"),
  strip_color=getOption("strip_color"),
  strip_text_color=getOption("strip_text_color"),

  add_fill=getOption("add_fill"),
  add_trans=getOption("add_trans"),
  add_color=getOption("add_color"),
  add_size=getOption("add_size"),
  add_lwd=getOption("add_lwd"),
  add_lty=getOption("add_lty"),

  n_cat=getOption("n_cat"),
  suggest=getOption("suggest"),
  notes=getOption("notes"),
  quiet=getOption("quiet"),
  brief=getOption("brief"),
  lessR.use_plotly=getOption("lessR.use_plotly"),

  results=getOption("results"), explain=getOption("explain"),
  interpret=getOption("interpret"), document=getOption("document"), 
  code=getOption("code"),

  width=120, show=FALSE, \dots)
}


\arguments{
  \item{theme}{The specified color scheme. If specified, re-sets all style
       attributes to the values consistent with that theme.}
  \item{sub_theme}{Further modification of the main themes.}
  \item{set}{A list of parameter values, a theme, that was previously
       saved, and now is read back to become the current set of parameter
       values. See the examples.}
  \item{get}{Save the current list of parameter values, a theme, into
       an R object.}
  \item{reset}{Change one or more settings or the entire theme.}\cr

  \item{window_fill}{Fill color of the entire device window.}
  \item{panel_fill}{Color of the plot background.}
  \item{panel_color}{Color of border around the plot background, the box, that
        encloses the plot, with a default of \code{"black"}.}
  \item{panel_lwd}{Line width of the box around the plot.}
  \item{panel_lty}{Line type of the box around the plot. Acceptable values are 
        \code{"blank"}, \code{"solid"}, \code{"dashed"}, \code{"dotted"},
        \code{"dotdash"}, and \code{"longdash"}.}\cr

  \item{fill}{Color of a filled region -- bars, points and bubbles -- 
        depending on the
        objected plotted. Can explicitly choose \code{"grays"}
        or \code{"hues"} , or pre-specified R color schemes 
        \code{"rainbow"}, \code{"terrain"}, and \code{"heat"}. Can also
        provide pre-defined color ranges \code{"blues"}, \code{"reds"}
        and \code{"greens"}, as well as
        custom colors, such as generated by \code{\link{getColors}}}
  \item{bar_fill}{Color of a filled bar, bubble or box.}
  \item{bar_fill_discrete}{Color of a filled bar chart bar or pie chart slice.}
  \item{bar_fill_cont}{Color of a filled histogram bar.}
  \item{trans}{Transparency of a filled bar, rectangular region, or points from 0
       (none) to 1 (complete).}
  \item{trans_bar_fill}{The transparency of a filled bar or rectangular region,
       such as a histogram bar or the box in a box plot. Value from 0 to 1,
       opaque to transparent.}
  \item{color}{Color of a line segment such as the border of bar or point.
        Can explicitly choose \code{"grays"}
        or \code{"hues"}, or pre-specified R color schemes 
        \code{"rainbow"}, \code{"terrain"}, and \code{"heat"}. Can also
        provide pre-defined color ranges \code{"blues"}, \code{"reds"}
        and \code{"greens"}, as well as
        custom colors, such as generated by \code{\link{getColors}}}
  \item{bar_color}{Color of the border of a filled region such as a histogram
       bar.}
  \item{bar_color_discrete}{Color of the border of a filled region for
       values on a qualitative scale.}
  \item{bar_color_cont}{Color of the border of a filled region for
       values on a quantitative scale, such as a histogram bar.}\cr

  \item{labels}{If not the default value of \code{"off"}, adds the
        numerical results to the plot according to \code{"\%"}, 
        \code{"prop"} or \code{"input"}, that is, percentages,
         proportions, or the value from which the slices are plotted,
         such as tabulated counts if \code{y} is not specified,
         or the value of \code{y} if the plotted values are provided. If
         any other \code{labels} parameter is specified, default is set
         to \code{"\%"}.}
  \item{labels_color}{Color of the plotted text. Could be a vector to specify
        a unique color for each value. If fewer colors are specified than
        the number of categories, the colors are recycled.}
  \item{labels_size}{Character expansion factor, the size, of the plotted text, 
        for which the default value is 0.95.}
  \item{labels_digits}{Number of decimal digits for which to display the labels.
        Default is 0, round to the nearest integer, for \code{"\%"}
        and 2 for \code{"prop"}.}
  \item{labels_position}{Position of the plotted text. Default is inside the pie,
        or, if \code{"label"}, as part of the label for each value
        outside of the pie.}\cr

  \item{pt_fill}{Color of a filled plotted point.}
  \item{trans_pt_fill}{The transparency of the inner region of a plotted point.
       Value from 0 to 1, opaque to transparent.}
  \item{pt_color}{Color of a line or outline of a filled region, such as the
       border of a plotted point.}
  \item{se_fill}{Color of the fill for the standard error plot about a
       fit line in a scatter plot.}
  \item{ellipse_fill}{Color of the fill for an ellipse in a scatter plot.}
  \item{ellipse_color}{Color of the border for an ellipse in a scatter plot.}
  \item{ellipse_lwd}{Line width of the border for an ellipse in a scatter plot.}
  \item{fit_color}{Color of the fit line in a scatter plot.}
  \item{fit_lwd}{Width of fit line. By default is 2 for Windows and 1.5 for Mac.}
  \item{bubble_text_color}{Color of the displayed text regarding the size of a bubble,
        either a tabulated frequency for categorical variables, or the value of a
        third variable according to \code{size}.}
  \item{segment_color}{Color of connecting line segments when there are also plotted
        points, such as in a frequency polygon. Default color is \code{color}.}
  \item{ID_color}{Color of the text to display the ID labels.}
  \item{out_fill}{For a scatterplot, color of the border of potential outliers, which,
       for the unadjusted boxplot, are default values
       1.5 IQR's beyond the lower or upper quartile.}
  \item{out_color}{For a scatterplot, color of potential outliers.}
  \item{out2_fill}{For a scatterplot, color of extreme outliers, which,
       for the unadjusted boxplot, are default values
       3 IQR's beyond the lower or upper quartile.}
  \item{out2_color}{For a scatterplot, color of the border of extreme outliers.}\cr

  \item{violin_fill}{Fill color for a \bold{violin plot.}}
  \item{violin_color}{Border color for the violin in a violin plot.}
  \item{box_fill}{Fill color for a box plot.}
  \item{box_color}{Border color of a box in a box plot.}\cr

  \item{axis_color}{Color of the axes.}
  \item{axis_x_color}{Color of the \code{x}-axis_}
  \item{axis_y_color}{Color of the \code{y}-axis_}
  \item{axis_lwd}{Line width of axes.}
  \item{axis_x_lwd}{Line width of horizontal axis_}
  \item{axis_y_lwd}{Line width of vertical axis_}
  \item{axis_lty}{Line type of axes, either "solid", "dashed",
       "dotted", "dotdash", "longdash", "twodash", or "blank".}
  \item{axis_x_lty}{Line type of horizontal axis_}
  \item{axis_y_lty}{Line type of vertical axis_}
  \item{axis_size}{Font size of the axis value text for both axes, which by
        default displays smaller than the axis labels.}
  \item{axis_x_size}{Font size of the \code{x}-axis value text.}
  \item{axis_y_size}{Font size of the \code{y}-axis value text.}
  \item{axis_text_color}{Color of the font used to label the axis values.}
  \item{axis_x_text_color}{Color of the font used to label the \code{x}-axis values.}
  \item{axis_y_text_color}{Color of the font used to label the \code{y}-axis values.}
  \item{rotate_x}{Degrees that the \code{x}-axis values are rotated, usually to
        accommodate longer values, typically used in conjunction with \code{offset}.}
  \item{rotate_y}{Degrees that the \code{y}-axis values are rotated.}
  \item{offset}{The spacing between the axis values and the axis_ Default
        is 0.5. Larger values such as 1.0 are used to create space for the label when
        longer axis value names are rotated.}\cr

  \item{lab_color}{Color of the axis labels.}
  \item{lab_x_color}{Color of the axis labels on the horizontal axis_}
  \item{lab_y_color}{Color of the axis labels on the vertical axis_}
  \item{lab_size}{Font size of the axis labels for both axes.}
  \item{lab_x_size}{Font size of the \code{x}-axis label.}
  \item{lab_y_size}{Font size of the \code{y}-axis label.}
  \item{main_color}{Color of the title.}
  \item{main_size}{Font size of the plot title.}\cr

  \item{grid_color}{Color of the grid lines.}
  \item{grid_x_color}{Color of the grid lines for the \code{x}-axis_}
  \item{grid_y_color}{Color of the grid lines for the \code{y}-axis_}
  \item{grid_lwd}{Width of grid lines.}
  \item{grid_x_lwd}{Width of vertical grid lines, inherits from \code{grid_lwd}.}
  \item{grid_y_lwd}{Width of horizontal grid lines, inherits from \code{grid_lwd}.}
  \item{grid_lty}{Line type for grid lines: "solid", "dashed",
        "dotted", "dotdash", "longdash", or "twodash", or "blank".}
  \item{grid_x_lty}{Line-type of vertical grid lines, inherits from \code{grid_lty}.}
  \item{grid_y_lty}{Line-type of horizontal grid lines, inherits from \code{grid_lty}.}\cr

  \item{strip_fill}{Fill color for the \bold{strip that labels each panel} in
   a Trellis plot.}
  \item{strip_color}{Border color for the strip that labels each panel in
   a Trellis plot.}
  \item{strip_text_color}{Color of the label in each strip of a Trellis plot.}\cr

  \item{add_fill}{Interior fill color of added object.
        Can explicitly choose \code{"grays"}
        or \code{"hues"}, or pre-specified R color schemes 
        \code{"rainbow"}, \code{"terrain"}, and \code{"heat"}. Can also
        provide pre-defined color ranges \code{"blues"}, \code{"reds"}
        and \code{"greens"}, as well as
        custom colors, such as generated by \code{\link{getColors}}}
  \item{add_trans}{Transparency level of color or fill, which ever is
       applicable from 0 (opaque) to 1 (transparent).}
  \item{add_color}{Color of borders and lines of added object.}
  \item{add_size}{Size of annotated text, relative to 1. As with the following
   properties, can be a vector for multiple placement or objects.}
  \item{add_lwd}{Line width of added object.}
  \item{add_lty}{Line type of added object. See \code{panel_lty} for types.}\cr

  \item{n_cat}{Number of categories that specifies the largest number of unique
        equally-spaced values of variable of a numeric data type for which the
        variable will be analyzed as categorical. Default value is 0.
        \emph{[deprecated]}: Best to convert a categorical integer variable
        to a factor.}
  \item{suggest}{If \code{TRUE}, then provide suggestions for alternative analyses.}
  \item{notes}{If \code{TRUE}, then provide notes.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
        with \code{\link{style}} function.}
  \item{brief}{If set to \code{TRUE}, reduced text output.}\cr
  \item{lessR.use_plotly}{If set to \code{TRUE}, an use_plotly plot is created 
        in the RStudio \code{Viewer} window in addition to the usual
        static plot in the plot window for most plotting routines.}\cr
  \item{results}{For the R markdown file generated by the Rmd option, 
        show the results.}
  \item{explain}{For the R markdown file generated by the Rmd option, 
        explain the results.}
  \item{interpret}{For the R markdown file generated by the Rmd option, 
        interpret the results.}
  \item{document}{For the R markdown file generated by the Rmd option,
        documents the code that generated the results.} 
  \item{code}{For the R markdown file generated by the Rmd option, 
        shows the code that generated the results.}\cr

  \item{width}{Maximum width of each line displayed at the console, just accesses
        the standard R options function for width.}
  \item{show}{Option for showing all settings.}
  \item{\dots}{Parameter values.}
}


\details{
OVERVIEW\cr
Sets the default color palette via the R \code{\link{options}} statement, as well as the transparency of plotted bars and points and other non-color characteristics such as the color of the grid lines. For convenience, groups of attributes are organized into themes and sub-themes. When the \code{theme} is specified, \emph{all} options are reset to their default values. All other modifications, with individual parameters or grouped parameters as a sub-theme, are cumulative. For example, one sub-theme can be followed by another, as well as the specifications of individual attributes. Calling the function with no arguments sets to the default style.

Available themes:\cr
"lightbronze" [default]\cr
"dodgerblue" [default \code{lessR} 3.6.0 and earlier]\cr
"darkred"\cr
"gray"\cr
"gold"\cr
"darkgreen"\cr
"blue"\cr
"red"\cr
"rose"\cr
"green"\cr
"purple"\cr
"sienna"\cr
"brown"\cr
"orange"\cr
"white"\cr
"light"\cr

The \code{"gray"} color theme is based on the colors used in Hadley Wickham's \code{ggplot2} package. The \code{"lightbronze"} theme, especially with the \code{wsj} sub-theme, is based on Jeffrey Arnold's \code{wsj} theme from his ggthemes package.

SUB-THEMES\cr
\code{"black"}: Black background of the entire device window with translucent fill colors from the current theme. 
\code{"wsj"}: Similar to the \code{wsj} theme from the \code{ggthemes} package, especially with the theme of \code{"lightbronze"}. The \code{y}-axis is removed with though the value labels retained, the vertical grid is removed, and the horizontal grid is dotted and thicker than the default.
}


\value{
The current settings can optionally be saved into an \code{R} object, and then read back at a later time with the \code{set} function.\cr
}


\references{
Arnold, Jeffrey B., (2017), ggthemes: Extra Themes, Scales and Geoms for 'ggplot2'. R package version 3.4.0. https://CRAN.R-project.org/package=ggthemes

Gerbing, D. W. (2020). R Visualizations: Derive Meaning from Data, Chapter 10, NY: CRC Press.

Wickham, Hadley, (2009), ggplot2: Elegant Graphics for Data Analysis, 2nd edition, Springer.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{options}}.
}

\examples{

# some data
d <- rd("Employee", quiet=TRUE)

# gold colors embedded in a black background
style("gold", sub_theme="black")
XY(Years, Salary, pt_size=0, ellipse=seq(.1,.9,.1))

# three ways to do gray scale
style(window_fill="white")
# 1. gray scale with a light gray background
style("gray")
# 2. gray scale with a dark, almost black, background
style("gray", sub_theme="black")
# 3. mostly black and white
style("white")

# reset style to the default "colors"
style()

# set bar fill to qualitative hcl colors
# here also turn off bar borders and set to a mild transparency
X(Salary, fill="greens", color="off")
# same as
# style(bar_fill_cont="greens", bar_color="off")
# X(Salary)

# set bar fill to 6 blue colors
# for continuous band explicitly call getColors and specify n
#   to obtain the full spectrum, such as for analysis of Likert
#   scale responses with six possible responses per item
style(bar_fill=getColors("blues", n=6))

# adjust Trellis strip to a dark background
style(strip_fill="gray60", strip_color="gray20",
      strip_text_color=rgb(247,242,230, maxColorValue=255))
XY(Years, Salary, facet=Gender)

# define a custom style beyond just colors
style(panel_fill="off", panel_color="off",
      window_fill=rgb(247,242,230, maxColorValue=255),
      pt_fill="black", trans=0,
      lab_color="black", axis_text_color="black",
      axis_y_color="off",
      grid_x_color="off", grid_y_color="black",  grid_lty="dotted", grid_lwd=1)
X(Salary)

# save the current theme settings into an R object without changes
# unless set to FALSE, get is always TRUE, for all calls to style
mystyle <- style(get=TRUE)
# ...  bunch of changes
# then recall older settings to current theme setting
style(set=mystyle)

# create a gray-scale with a sub-theme of wsj
# save, and then at a later session read back in
grayWSJ <- style("gray", sub_theme="wsj")
# Write(grayWSJ, "grayWSJ", format="R")
# ...
#mystyle <- Read("grayWSJ.rda")  # read grayWSJ.rda
#style(set=mystyle)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ sets }
\keyword{ csv }

\name{corEFA}
\alias{corEFA}
\alias{efa}

\title{Exploratory Factor Analysis and Multiple Indicator Measurement Model}

\description{
Abbreviation: \code{efa}

A maximum likelihood exploratory factor analysis of an input correlation matrix, provided by the standard R exploratory factor analysis \code{\link{factanal}}, which requires the specified number of factors as an input to the analysis. Then constructs the code to run the corresponding multiple indicator measurement model (MIMM) suggested by the exploratory factor analysis loadings in terms of both the \code{lessR} \code{\link{corCFA}} and the \code{cfa} function from the \code{lavaan} package.
}

\usage{
corEFA(R=mycor, n_factors, rotate=c("promax", "varimax", "none"),
          min_loading=.2, sort=TRUE, \dots)

efa(\dots)
}

\arguments{
  \item{R}{Correlation matrix.}
  \item{n_factors}{Number of factors.}
  \item{rotate}{Rotation method, if any. Choices are promax (obique) or
       varimax (orthogonal.}
  \item{min_loading}{Minimum loading to include in suggested factor for
        confirmatory analysis and for the display of the loadings for the
        exploratory analysis. To ignore, set to 0.}
  \item{sort}{Sort the input variables by their highest factor loadings (but only
        first just list those items with loadings larger than 0.5).}
  \item{\dots}{Parameter values_}
}

\details{
Only the loadings from the exploratory factor analysis are provided, with either an oblique (promax), by default, or an orthogonal (varimax) rotation.  If more information is desired, run \code{\link{factanal}} directly.

Also provides the associated multiple indicator measurement model suggested by the exploratory factor analysis. Each MIMM factor is defined by the items that have the highest loading on the corresponding exploratory factor.

For versions of \code{lessR} including and after 4.4.3, the correlation matrix computed by \code{\link{Correlation}} is now the object returned if \code{show} is equal to \code{"cor"}, the default, or a missing data analysis if equal to \code{"missing"}.}

\value{
The output can optionally be returned and saved into an \code{R} object, otherwise it simply appears at the console. The components of this object are of two different types: pieces of text that form the readable output, and a variety of statistics. The readable output are character strings such as tables amenable for viewing and interpretation. The statistics are numerical values amenable for further analysis. The name of each piece, preceded by the name of the saved object followed by a dollar sign, can be referenced directly, such as in a subsequent R markdown document.

READABLE OUTPUT\cr
\code{out_title_efa}: Title for the exploratory factor analysis\cr
\code{out_type}: Extraction method and, for more than one factor, the rotation\cr
\code{out_loadings}: Factor loadings, with values between plus and minus \code{min_loading} suppressed\cr
\code{out_ss}: Sum of squared loadings for each factor, with proportion and cumulative variance\cr
\code{out_title_cfa}: Title for the suggested confirmatory model code\cr
\code{out_cfa_code}: Generated \code{lessR} and \code{lavaan} code for the suggested measurement model\cr
\code{out_deleted}: Items with no loading larger than \code{min_loading}, deleted from the suggested model\cr

STATISTICS\cr
\code{converged}: Logical, whether the maximum likelihood extraction converged\cr
\code{n_factors}: Number of factors extracted\cr
\code{ss_factors}: Sum of squared loadings for each factor\cr
\code{loadings}: Matrix of factor loadings\cr
\code{call}: The function call\cr

Although not typically needed for analysis, if the output is assigned to an object named, for example, \code{fa}, then the complete contents of the object can be viewed directly with the \code{\link{unclass}} function, here as \code{unclass(fa)}. Invoking the \code{\link{class}} function on the saved object reveals a class of \code{out_all}. The class of each of the text pieces of output is \code{out}.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\references{
Gerbing, D. W. (2014). R Data Analysis without Programming, Chapter 11, NY: Routledge.

Yves Rosseel (2012). lavaan: An R Package for Structural Equation
Modeling. Journal of Statistical Software, 48(2), 1-36. URL
http://www.jstatsoft.org/v48/i02/.
}

\seealso{
\code{\link{Correlation}}.
}

\examples{
# input correlation matrix of perfect two-factor model
# Factor Pattern for each Factor: 0.8, 0.6, 0.4
# Factor-Factor correlation: 0.3
mycor <- matrix(nrow=6, ncol=6, byrow=TRUE,
c(1.000,0.480,0.320,0.192,0.144,0.096,
  0.480,1.000,0.240,0.144,0.108,0.072,
  0.320,0.240,1.000,0.096,0.072,0.048,
  0.192,0.144,0.096,1.000,0.480,0.320,
  0.144,0.108,0.072,0.480,1.000,0.240,
  0.096,0.072,0.048,0.320,0.240,1.000))
colnames(mycor) <- c("X1", "X2", "X3", "X4", "X5", "X6")
rownames(mycor) <- colnames(mycor) 

# default factor analysis of default correlation matrix mycor
#   with two factors extracted
corEFA(n_factors=2)

# abbreviated form
# use all items to construct the MIMM, regardless of their loadings
#  and show all loadings
# show the initial factor extraction
efa(n_factors=2, min_loading=0, show_initial=TRUE)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ correlation }
\keyword{ factor analysis }

\name{dataAnova_sp}
\docType{data}
\alias{dataAnova_sp}
\title{Data for a Split-Plot ANOVA}

\description{A study of four different pre-workout supplements analyzed their effectiveness in terms of the number of repetitions of a given exercise and weight. Each of 14 participants were randomly assigned to one of two groups: Hi quality Food, a nutritious breakfast, and Low quality Food, a less nutritious breakfast. Each group of 7 participants took all four Supplements, each in randomized order, one for each workout. The result is a total of 28 data values for each group, 56 data values overall.

Type of Supplements is a within- groups treatment variable. The other treatment variable, Food quality, is a between-groups treatment variable.
}

\format{A data table with 56 rows of data and 4 columns: Person, Food, Supplement, and Reps.}

\references{
Gerbing, D. W. (later in 2022). R Data Analysis without Programming, 2nd Edition, Chapter 7, NY: Routledge.

Gerbing, D. W. (2021). Enhancement of the Command-Line Environment for use in the Introductory Statistics Course and Beyond, \emph{Journal of Statistics and Data Science Education}, 29(3), 251-266, https://www.tandfonline.com/doi/abs/10.1080/26939169.2021.1999871. 
}

\author{
David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})
}

\examples{
d <- Read("Anova_sp")
fit <- aov(Reps ~ (Food*Supplement) + Error(Person/Food), data=d)
summary(fit)
}

\source{author}
\keyword{datasets}

\name{dataWeightLoss}
\docType{data}
\alias{dataWeightLoss}
\title{Data: WeightLoss}

\description{The weights of 10 people were recorded. Then they entered a weight loss program. Following completion of the program, their weights were once again recorded. Data are simulated.}

\usage{data(dataWeightLoss)}

\format{A data table with 10 observations.}

\source{author}
\keyword{datasets}

\name{values}
\alias{values}

\title{List the Values of a Variable}

\description{
List the values of a variable from the global environment or a data frame.
}

\usage{
values(x, data=d, \dots) 
}


\arguments{
  \item{x}{Variable for which to construct the histogram and density plots.}
  \item{data}{Data frame that contains the variable of interest, default is \code{d}.}
  \item{\dots}{Other parameter values for as defined processed 
      by \code{\link{print}}, including \code{digits}.}
}


\details{
Provided for listing the values of a variable in an unattached data frame.  All \code{lessR} functions that access data for analysis from a data frame, such as the default \code{d} provided by the \code{\link{Read}} function that reads the data frame from an external data file, do not require the data frame to be attached.  Attaching a data frame can lead to some confusing issues, but one negative of not attaching is that simply listing the name of a variable within the data frame leads to an 'object not found' error.  The \code{values} function provides access to that variable within a data frame just as is true for any other \code{lessR} function that accesses data.

The function displays the values of the specified variable with the standard R \code{\link{print}} function, so parameter values for \code{\link{print}} can also be passed to \code{values}.
}


\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{print}}
}


\examples{
# generate 10 random normal data values
Y <- rnorm(10)
d <- data.frame(Y)
rm(Y)

# list the values of Y
values(Y)

# variable of interest is in a data frame which is not the default d
# access the breaks variable in the R provided warpbreaks data set
# although data not attached, access the variable directly by its name
data(warpbreaks)
values(breaks, data=warpbreaks)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ values }
\keyword{ print }

\name{dataCars93}
\docType{data}
\alias{dataCars93}
\title{Data: Cars93}

\description{1993 New Car Data.}

\usage{data(dataCars93)}
\format{A data table with 93 observations and 25 variables.\cr

Variables\cr
-------------------------------------------\cr
Make: Model\cr
Type: Small, Sporty, Compact, Midsize, Large, Van\cr
MinPrice: Minimum Price (in $1,000) - Price for basic version of this model\cr
MidPrice: Midrange Price (in $1,000) - Average of Min and Max prices\cr
MaxPrice: Maximum Price (in $1,000) - Price for a premium version\cr
MPGcity: City MPG\cr
MPGhiway: Highway MPG\cr
Airbags: 0 = none, 1 = driver only, 2 = driver & passenger\cr
DriveTrain: 0 = rear wheel drive, 1 = front wheel drive, 2 = all wheel drive\cr
Cylinders: Number of cylinders\cr
Engine: Engine size (liters)\cr
HP: maximum Horsepower\cr
RPM: revolutions per minute at maximum horsepower\cr
RevMile: Engine revolutions per mile in highest gear\cr
Manual: Manual transmission available, 0 = No, 1 = Yes\cr
FuelCap: Fuel tank capacity (gallons)\cr
PassCap: Passenger capacity (persons)\cr
Length: Length (inches)\cr
Wheelbase: Wheelbase (inches)\cr
Width: Width (inches)\cr
Uturn: U-turn space (feet)\cr
RearSeat: Rear seat room (inches)\cr
LugCap: Luggage capacity (cu. ft.)\cr
Weight: Weight (pounds)\cr
Source: 0=non-USA manufacturer, 1=USA manufacturer\cr
}

\source{Lock, R. H. (1993). 1993 new car data. Journal of Statistics Education, 1(1).}
\keyword{datasets}

\name{xU}
\alias{xU}

\title{Text Processing: Capitalize First Letter of a Word}

\description{Capitalize the first letter of a word. Primarily for internal use in text processing of \code{knitr} output. Not usually referenced by the user.
}

\usage{
xU(x)
}


\arguments{
  \item{x}{The character string (word) for which to capitalize the first letter.}
}


\details{
Input is a single word.  Output is the word with its first letter capitalized.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\examples{
xU("the")
}

\name{xAnd}
\alias{xAnd}

\title{Text Processing: Insert and Into a List}

\description{Inserts the word \code{and} into a vector of words, each a separate character string. Primarily for internal use in text processing of \code{knitr} output. Not usually referenced by the user.
}

\usage{
xAnd(x)
}


\arguments{
  \item{x}{The set of character strings for which to insert \code{and}.}
}


\details{
Input is a vector of character strings, output is a single character string with \code{and} inserted if needed.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\examples{
xAnd(c("sky", "land", "mountains"))
}

\name{corScree}
\alias{corScree}
\alias{scree}

\title{Eigenvalue Plot of a Correlation Matrix}

\description{
Abbreviation: \code{scree}

Plots the successive eigenvalues of an input correlation matrix. Also plots the successive differences of the eigenvalues. The purpose is usually to help determine the number of factors that explain the correlations in a correlation matrix. So usually a prelude to an exploratory factor analysis, such as provided by the \code{lessR} function \code{\link{corEFA}}. This program relies upon the standard R exploratory factor analysis \code{\link{factanal}}, which requires the specified number of factors as an input to the analysis.
}

\usage{
corScree(R=mycor, 
          main=NULL, pdf=FALSE, width=5, height=5, \ldots)

scree(\ldots)
}

\arguments{
  \item{R}{Correlation matrix.}
  \item{main}{Graph title, which is blank by default.}
  \item{pdf}{Indicator as to if the graphic files should be saved as pdf files
       instead of directed to the standard graphics windows.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{\dots}{Parameter values_}
}


\details{
Interpretation of the scree plot to assist in the assessment of the number of factors that account for the structure of a correlation matrix depends primarily on the analysis of the differences between the successive eigenvalues_ The differences begin to diminish where the "scree" begins, analogous to the debris that falls off of a hill top.  Accordingly both the scree plot itself, the plot of the successive eigenvalues, and the plot of the differences of the successive eigenvalues are presented.

PDF OUTPUT\cr
Because of the customized graphic windowing system that maintains a unique graphic window for the Help function, the standard graphic output functions such as \code{\link{pdf}} do not work with the \code{lessR} graphics functions.  Instead, to obtain pdf output, use the \code{pdf_file} option, perhaps with the optional \code{width} and \code{height} options. These files are written to the default working directory, which can be explicitly specified with the R \code{\link{setwd}} function.

If the two plots, of the population and sample distributions respectively, are written to pdf files, according to \code{pdf=TRUE}, they are named Scree.pdf and ScreeDiff.pdf. Their names and the directory to which they are written are provided as part the console output.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\references{
Gerbing, D. W. (2014). R Data Analysis without Programming, Chapters 9 and 10, NY: Routledge.
}

\seealso{
\code{\link{Correlation}}.
}

\examples{
# input correlation matrix of perfect two-factor model
# Factor Pattern for each Factor: 0.8, 0.6, 0.4
# Factor-Factor correlation: 0.3
mycor <- matrix(nrow=6, ncol=6, byrow=TRUE,
c(1.000,0.480,0.320,0.192,0.144,0.096,
  0.480,1.000,0.240,0.144,0.108,0.072,
  0.320,0.240,1.000,0.096,0.072,0.048,
  0.192,0.144,0.096,1.000,0.480,0.320,
  0.144,0.108,0.072,0.480,1.000,0.240,
  0.096,0.072,0.048,0.320,0.240,1.000))
colnames(mycor) <- c("V1", "V2", "V3", "V4", "V5", "V6")
rownames(mycor) <- colnames(mycor) 

# obtain the scree plots
corScree()
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ correlation }
\keyword{ scree }

\name{regPlot}
\alias{regPlot}

\title{regPlot Analysis}

\description{
Following a call to the \code{lessR} function \code{\link{Regression}}, in which the returned values of the function are saved into an object, allows the default plots generated by \code{\link{Regression}} to be accessed one at a time_ The specific motivation for this function is to allow custom placement of the graphs from the regression analysis from within \code{knitr}. Usually the \code{graphics=FALSE} parameter is set on the call to \code{\link{Regression}} within \code{knitr} to suppress the normal graphic output that leads to the generation of the graphs at the beginning of the \code{knitr} output.
}

\usage{
regPlot(out, type, d.ancova, digits_d=NULL, pred.intervals=TRUE,
         res_sort=c("cooks","rstudent","dffits","off"),
         n_res_rows=NULL, cooks_cut=1, scatter_coef=NULL, 
         pdf=FALSE, width=5, height=5, manage.gr=FALSE, \dots)
}


\arguments{
  \item{out}{The object returned by the \code{lessR} function  \code{\link{Regression}}.}
  \item{type}{Type of plot: 1 plots the scatter plot for a single predictor
        variable, or the scatter plot matrix for multiple predictors. If a single
        scatter plot, then the confidence and prediction intervals are included. 2
        plots the density and histogram of residuals and 3 plots a scatter plot of
        the residuals with the fitted values_}
  \item{d.ancova}{If not \code{NULL}, then an ANCOVA design with 1 grouping variable
       and 1 covariate, which contains the original data.}
  \item{digits_d}{For the Basic Analysis, the number of decimal digits,
        set by default to at least 3 or the largest number of digits in the values 
        of the response variable plus 1.}
  \item{pred.intervals}{If set to \code{FALSE}, the scatter plot for a single
        predictor with the response does not contain prediction and confidence
        intervals.}
  \item{res_sort}{Default is \code{"cooks"}, for specifying Cook's distance as
       the sort criterion for the display of the rows of data and associated
       residuals. Other values are \code{"rstudent"} for externally Studentized
       residuals, \code{"dffits"} for dffits
       and \code{"off"} to not sort the rows of data.}
  \item{n_res_rows}{Default is 20, which lists the first 20 rows of data sorted
       by the specified sort criterion.  To disable residuals, specify a value
       of 0.  To see the output for all observations, specify a value of
       \code{"all"}.}
  \item{cooks_cut}{Cutoff value of Cook's Distance at which observations with a
       larger value are flagged in red and labeled in the resulting scatterplot
       of Residuals and Fitted Values.  Default value is 1.0.}
  \item{scatter_coef}{Display the correlation coefficients in the upper triangle
       of the scatterplot matrix.}
  \item{pdf}{If \code{TRUE}, then graphics are written to pdf files.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{manage.gr}{Usually leave \code{FALSE}. Refers to graphic management of
       the \code{lessR} system.}
  \item{\dots}{Other parameter values for R function \code{\link{lm}} which
       provides the core computations.} 
}


\details{
OVERVIEW\cr
The ability to separate plots is particularly useful with \code{knitr} to break up the output to intersperse comments between the plots. For Plot 1, for single predictor a scatter plot with the regression line and confidence and prediction intervals is produced.  Otherwise a scatter plot matrix of all the variables in the models is obtained.

To help assess the validity of the model, Plot 2 is of the distribution of the residuals, histogram and density plots, both general and normal. Plot 3 plots the residuals against the fitted value and also identifies the points with the largest values of Cook's distance.
}

\references{
Gerbing, D. W. (2014). R Data Analysis without Programming, Chapters 9 and 10, NY: Routledge.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{lm}}, \code{\link{Regression}}
}

\examples{
# read internal data set
d <- rd("Reading", quiet=TRUE)
# do regression analysis, save result into out
reg.out <- reg(Reading ~ Verbal)
# The full output already contains these plots, obtained by
# entering the name of the saved object
reg.out
# Particularly for knitr it is useful to obtain the plots
#   separately from the full output
# Get the scatter plot of the data with the regression line
#   and prediction and confidence intervals 
regPlot(reg.out, 1, NULL)

# Can use with multiple regression for the scatter plot matrix
r <- reg(Reading ~ Verbal + Absent + Income)
regPlot(r, 1, NULL, scatter_coef=TRUE)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ regPlot }

\name{Write}
\alias{Write}
\alias{wrt}
\alias{wrt_r}
\alias{wrt_x}

\title{Write the Contents of a Data Frame to an External File}

\description{
Abbreviation: \code{wrt}, \code{wrt_r}, \code{wrt_x}

Writes the contents of the specified data frame, such as with the default \code{d}, to the current working directory as either the default \code{csv} data file and also tab limited and space unlimited text files, an Excel data table, an OpenDocument Spreadsheet file, an arrow \code{feather} or \code{parquet} file, or a native R data file of the specified data frame. If the write is for a \code{.csv}, or \code{.tsv}, or \code{.prn} text file, then any variable labels are written to a second \code{csv} file with "_lbl" appended to the file name. Any variable labels and variable units are automatically included in a native R data file.
}

\usage{
Write(data=d, to=NULL, 

         format=c("csv", "txt", "tsv", "prn",
                  "Excel", "ODS", "R", "SPSS", "feather", "parquet"),

         row_names=NULL, quote="if_needed", missing=NULL, dec=".", sep=NULL,  

         ExcelTable=FALSE, ExcelColWidth=TRUE,

         quiet=getOption("quiet"), \dots)

wrt(\dots)

wrt_r(\dots, format="R")
wrt_x(\dots, format="Excel")
}


\arguments{
  \item{data}{Data frame of which the contents are to be written to an
        external data file, that is, no quotes.}
  \item{to}{Name of the output file as a character string, that is, with quotes.
        If not included in the name, the file type is automatically added to the
        name according to the specified \code{format}. Or, specify the file name
        with the file extension from which the \code{format} is derived.
        If omitted, then the file name is the data frame name.}
  \item{format}{Format of file to be written with \code{.csv} as the default.}
  \item{row_names}{Format of file to be written with \code{.csv} as the default.
       Set to \code{TRUE} by default unless writing to Excel or csv file
       and row names are just the integers from 1 to the number of rows.}\cr
  \item{quote}{Specifies how character data values are to be quoted. The default is
       \code{"if_needed"}, which puts quotes around character data values that
        include spaces, commas, tabs, and other white spaces. The value of \code{TRUE}
        quotes character data values, needed or not.}
  \item{missing}{The data value indicates missing for text files. Defaults to a
        blank space except for \code{prn} files, which is then \code{NA}.}
  \item{dec}{The character that represents the decimal point for text files.}
  \item{sep}{The character that separates adjacent data values for text files.
        Defaults to \code{","}.}\cr

  \item{ExcelTable}{If \code{TRUE}, write the Excel file as an Excel table.}
  \item{ExcelColWidth}{\code{TRUE} by default but calculation of column widths for
       large files takes more time, so option to turn off.}\cr

  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default with
       \code{\link{style}} function.}
  \item{\dots}{Other parameter values for \code{csv} files consistent with the
       usual \code{\link{write.table}}, including \code{na=""} to write missing
       data to a \code{csv} file as blanks instead of \code{NA}.}
}


\details{
The default file name is the name of the data frame to be written, otherwise use \code{to} to specify the name. To specify the file type of the output data file, do so with any available file type provided as part of the file name for the output file, or by the value of the \code{format} parameter. Can specify the file name without the file type, which, if no \code{format} is provided, \code{Write} adds automatically the \code{.csv} file extension. The name of the file that is written, as well as the name of the working directory into which the file was written, are displayed at the console. 

The following table lists various file formats along with the associated R packages and functions for writing them. The default text file format, \code{.txt}, defaults to \code{dec="."} and \code{sep=","}, that is, North American \code{csv} format, but can be customize as needed.

\tabular{llll}{
  \strong{Extension}  \tab \strong{Format} \tab \strong{Package} \tab \strong{Function} \cr
  .txt     \tab Text, customize dec and sep  \tab R utils  \tab \code{write.table()} \cr
  .csv     \tab Text, comma-separated values  \tab R utils  \tab \code{write.table()} \cr
  .tsv     \tab Text, tab-separated values  \tab R utils  \tab \code{write.table()} \cr
  .prn     \tab Text, space-separated values  \tab R utils  \tab \code{write.table()} \cr
  .xlsx    \tab Excel  \tab openxlsx  \tab \code{writeData()} or \code{writeDataTable()} \cr
  .ods     \tab ODS  \tab readODS  \tab \code{write_ods()} \cr
  .feather \tab Feather  \tab arrow  \tab \code{write_feather()} \cr
  .parquet \tab Parquet  \tab arrow  \tab \code{write_parquet()} \cr
  .rda     \tab R data  \tab R base  \tab \code{save()} \cr
  .sav     \tab SPSS  \tab haven  \tab \code{write_sav()} \cr
}

\code{Write} is designed to work in conjunction with the function \code{\link{Read}} from this package, which reads a csv or other text file, fixed width format, or native SPSS or R data files into the data frame \code{d}. \code{Write} relies upon the R functions \code{\link{write.csv}} and \code{\link{save}}.

When writing the data frame in native R format, the specified name of the resulting \code{.rda} file is distinct from the name of the data frame as stored within R.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Read}}, \code{\link{write.table}}, \code{\link{save}}.
}

\examples{
# create data frame called d
#n <- 12
#X <- sample(c("Group1","Group2"), size=n, replace=TRUE)
#Y <- rnorm(n=n, mean=50, sd=10)
#d <- data.frame(X,Y)

# write the current contents of default data frame d to GoodData.csv
# Write(d, "GoodData")
# short name
# write the default data frame d to the R data file d.rda
#  wrt_r(d)

# write the data as an Excel data table in an Excel file
# Write(d, "GoodData", format="Excel")
# with abbreviation
# wrt_x(d, "GoodData")

# access the R data frame warpbreaks
#   then, write the file warpbreaks.rda
# data(warpbreaks)
# wrt_r(warpbreaks)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ write }
\keyword{ csv }

\name{dataMach4_lbl}
\docType{data}
\alias{dataMach4_lbl}
\title{VariableLabels: Mach4 Data Set}

\description{For the data of 351 responses to the 20-item Mach IV scale.}

\usage{data(dataMach4_lbl)}
\format{Variable labels, the items of the Christie and Geiss Mach IV Scale\cr
\cr
m01: Never tell anyone the real reason you did something unless it is useful to do so\cr
m02: The best way to handle people is to tell them what they want to hear\cr
m03: One should take action only when sure it is morally right\cr
m04: Most people are basically good and kind\cr
m05: It is safest to assume that all people have a vicious streak and it will come out when they are given a chance\cr
m06: Honesty is the best policy in all cases\cr
m07: There is no excuse for lying to someone else\cr
m08: Generally speaking, people won't work hard unless they're forced to do so\cr
m09: All in all, it is better to be humble and honest than to be important and dishonest\cr
m10: When you ask someone to do something for you, it is best to give the real reasons for wanting it rather than giving reasons which carry more weight\cr
m11: Most people who get ahead in the world lead clean, moral lives\cr
m12: Anyone who completely trusts anyone else is asking for trouble\cr
m13: The biggest difference between most criminals and other people is that the criminals are stupid enough to get caught\cr
m14: Most people are brave\cr
m15: It is wise to flatter important people\cr
m16: It is possible to be good in all respects\cr
m17: Barnum was wrong when he said that there's a sucker born every minute\cr
m18: It is hard to get ahead without cutting corners here and there\cr
m19: People suffering from incurable diseases should have the choice of being put painlessly to death\cr
m20: Most people forget more easily the death of a parent than the loss of their property
}

\source{author}

\references{
Christie, R., & Geis, F. L., (1970).  Studies in Machiavellianism.  New York:  Academic Press.

Hunter, J. E., Gerbing, D. W., and Boster, F. J. (1982). Machiavellian beliefs and personality: The construct invalidity of the Machiavellian dimension. Journal of Personality 
}

\examples{
# Read data and variable labels (items)
d <- Read("Mach4")
l <- Read("Mach4_lbl")

# Convert to factors, i.e., categorical with value labels
d <- factors(m01:m20,
            levels=0:5,
            labels=c("Strongly Disagree", "Disagree", "Slightly Disagree",
                     "Slightly Agree", "Agree", "Strongly Agree"))

}

\keyword{datasets}

\name{Nest}
\alias{Nest}
\alias{nt}

\title{Nest the Values of an Integer or Factor Variable}

\description{
Abbreviation: \code{nt}

A nested model has a subset of predictor variables from the corresponding full model. Compare a nested linear model with a full model to evaluate the effectiveness of the predictor variables deleted from the full model to define the nested model. 
}

\usage{
Nest(y, nested_model, full_model, method=c("lm", "logit"),
         data=d, digits_d=NULL, \dots)

nt(\dots)
}

\arguments{
  \item{y}{Response variable.}
  \item{nested_model}{Predictor variables in the nested model.}
  \item{full_model}{Predictor variables in either the full model, or
        just those that added to the reduced model to derive the
        full model.}
  \item{method}{Do a least squares analysis, \code{ls}, the default, or 
        set to \code{logit}.}
  \item{data}{The name of the data frame from which to create the subset, which
       is \code{d} by default.}
  \item{digits_d}{Number of decimal digits, set by default to at least 2
        or the largest number of digits in the values of the response variable
        plus 1.}
  \item{\dots}{The specified arguments.}
}

\details{
Use the standard \code{R} function \code{\link{anova}} function to compare a nested model with a corresponding full model. By default, compare models estimated with ordinary least squares from the \code{R} function \code{\link{lm}}, or compare models estimated with logistic regression from the \code{R} function \code{\link{glm}} with \code{family="binomial"}. For the logistic analysis, the \code{\link{anova}} analysis is with \code{test="Chisq"}.

To insure that the same data are analyzed for both models, the fit for the full model is first obtained. Then the data frame that is returned by this analysis is input into the analysis for the nested model. This guarantees that any cases with missing data values missing for the full analysis will have been deleted for the nested analysis.  Otherwise rows of data could be retained for the nested analysis that were dropped for the full analysis because of missing data values for the deleted predictor variables. This method also guarantees that cases are not deleted because data was missing on variables not included in full analysis. 
}

\value{
The output can optionally be returned and saved into an \code{R} object, otherwise it simply appears at the console. The components of this object are redesigned in \code{lessR} version 3.3 into (a) pieces of text that form the readable output and (b) a variety of statistics. The readable output are character strings such as tables amenable for viewing and interpretation. The statistics are numerical values amenable for further analysis, such as to be referenced in a subsequent R markdown document. The motivation of these three types of output is to facilitate R markdown documents, as the name of each piece, preceded by the name of the saved object followed by a dollar sign, can be inserted into the R markdown document (see \code{examples}).

TEXT OUTPUT\cr
\code{out_models}: The specification of the two models compared\cr
\code{out_anova}: Analysis of variance or, for logit, analysis of deviance\cr

STATISTICS\cr
\code{fun_call}: Function call that generated the analysis\cr
\code{anova_tested}: Term that is tested\cr
\code{anova_residual}: Residual df, and either ss and ms or deviance for logit\cr
\code{anova_total}: For logit, total df and deviance\cr

Although not typically needed for analysis, if the output is assigned to an object named, for example, \code{n}, then the complete contents of the object can be viewed directly with the \code{\link{unclass}} function, here as \code{unclass(n)}. Invoking the \code{\link{class}} function on the saved object reveals a class of \code{out_all}. The class of each of the text pieces of output is \code{out}.
}

\references{
Gerbing, D. W. (2023). \emph{R Data Analysis without Programming: Explanation and Interpretation}, 2nd edition, Chapter 12, NY: Routledge.
}
\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{anova}}, \code{\link{lm}}, \code{\link{glm}}.
}

\examples{

d <- Read("Reading")

# compare least-squares models
# can specify all the variables in the full model
Nest(Reading, c(Absent), c(Verbal,Absent,Income))
# or, can specify just the additional variables in the full model
Nest(Reading, c(Absent), c(Verbal,Income))

# compare logistic models, save results into an object
# define the full model by adding just the variables
#  not found in the reduced model
d <- Read("BodyMeas")
n <- Nest(Gender, c(Weight, Hips, Hand, Shoe),
      c(Height, Waist, Chest), method="logit")
# view the results
n
# see the names of the available output components
names(n)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ nested models }

\name{dataAnova_rb}
\docType{data}
\alias{dataAnova_rb}
\title{Data for a Randomized Block ANOVA}

\description{Seven people, with differing amounts of muscle strength, took one of four different pre-workout supplements and then did a bench press of 125 lbs as many times as possible. Each person did four workouts at four different times, with a different supplement before each workout. The experimenter randomized the presentation order of the supplements to each person to avoid any artifacts from presentation order.}


\format{A data table with 7 rows of data and 5 columns: Person, and sup1 through sup4 for the four supplements.}

\references{
Gerbing, D. W. (later in 2022). R Data Analysis without Programming, 2nd Edition, Chapter 7, NY: Routledge.

Gerbing, D. W. (2021). Enhancement of the Command-Line Environment for use in the Introductory Statistics Course and Beyond, \emph{Journal of Statistics and Data Science Education}, 29(3), 251-266, https://www.tandfonline.com/doi/abs/10.1080/26939169.2021.1999871. 
}

\author{
David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})
}

\examples{
d <- Read("Anova_rb")
d <- reshape_long(d, sup1:sup4, group="Supplement", response="Reps")
ANOVA(Reps ~ Supplement + Person)
}

\source{author}
\keyword{datasets}

\name{ttestPower}
\alias{ttestPower}
\alias{ttp}

\title{Compute a Power Curve for a One or Two Group t-test}

\description{
Abbreviation: \code{ttp}

From one or two sample sizes, and either the within-cell (pooled) standard deviation, or one or two separate group standard deviations, generate and calibrate a power curve for either the one-sample t-test or the independent-groups t-test, as well as ancillary statistics.  Uses the standard R function \code{power.t.test} to calculate power and then the \code{\link{ScatterPlot}} function in this package to automatically display the annotated power curve with colors.

For both the one and two-group t-tests, power is calculated from a single sample size and single standard deviation. For the two-sample test, the within-group standard deviation is automatically calculated from the two separate group standard deviations if not provided directly. Similarly, the harmonic mean of two separate sample sizes is calculated if two separate sample sizes are provided.
}

\usage{
ttestPower(n=NULL, s=NULL, n1=NULL, n2=NULL, s1=NULL, s2=NULL, 
         mmd=NULL, msmd=NULL, mdp=.8, mu=NULL, 
         pdf_file=NULL, width=5, height=5, \dots)

ttp(\dots)
}


\arguments{
  \item{n}{Sample size for each of the two groups.}
  \item{s}{Within-group, or pooled, standard deviation.}
  \item{n1}{Sample size for Group 1.}
  \item{n2}{Sample size for Group 2.}
  \item{s1}{Sample standard deviation for Group 1.}
  \item{s2}{Sample standard deviation for Group 2.}
  \item{mmd}{Minimum Mean Difference of practical importance, the difference of the
       response variable between two group means. The concept is optional, and only one of \code{mmd} and \code{msmd} is provided.}
  \item{msmd}{For the Standardized Mean Difference, Cohen's \code{d}, the Minimum value of
       practical importance. The concept is optional, and only one of \code{mmd} and \code{msmd} is provided.}
  \item{mdp}{Minimum Desired Power, the smallest value of power considered to provide
       sufficient power. Default is 0.8. If changed to 0 then the concept is dropped from the analysis.}
  \item{mu}{Hypothesized mean, of which a provided value triggers a one-sample 
       analysis.}
  \item{pdf_file}{Name of the pdf file to which graphics are redirected.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{\dots}{Other parameter values, such as \code{lwd} and \code{lab_cex} from \code{\link{plot}}
        and \code{col.line} and \code{col.bg} from \code{\link{ScatterPlot}}.}
}


\details{
This function relies upon the standard \code{\link{power.t.test}} function to calibrate and then calculate the power curve according to the relevant non-central t-distribution. The \code{\link{Plot}} function from this package, which in turn relies upon the standard \code{\link{plot}} function, plots the power curve. As such, parameters in \code{\link{Plot}} for controlling the different colors and other aspects of the display are also available, as are many of the more basic parameters in the usual \code{\link{plot}} function.

Also plotted, if provided, is the minimal meaningful difference, \code{mmd}, as well as the minimal desired power, \code{mdp}, provided by default.  Relevant calculations regarding these values are also displayed at the console.  One or both concepts can be deleted from the analysis.  Not providing a value \code{mmd} implies that the concept will not be considered, and similarly for setting \code{mdp} to 0.

Invoke the function with the either the within-group (pooled) standard deviation, \code{s}, or the two separate group standard deviations, \code{s1} and \code{s2}, from which \code{s} is computed.  If the separate standard deviations are provided, then also provide the sample sizes, either as a single value of \code{n} or as two separate sample sizes, \code{n1} and \code{n2}.  If separate sample sizes \code{n1} and \code{n2} are entered, their harmonic mean serves as the value of \code{n}.

For power analysis of the two-sample t-test, the null hypothesis is a zero population mean difference.  For a one-sample test, the null hypothesis is specified, and it is this non-null specification of mu that triggers the one-sample analysis. Only non-directional or two-tailed tests are analyzed.

The  effect size that achieves a power of 0.8 is displayed. If a minimal meaningful difference, \code{mmd}, is provided, then the  associated power is also displayed, as well as the needed sample size to achieve a power of 0.8.

If the function is called with no parameter values, that is, as \code{ttp()}, then the values of \code{n1}, \code{n2} and sw must already exist before the function call.  If they do, these values are used in the power computations.  
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Plot}}, \code{\link{plot}}, \code{\link{power.t.test}}.
}
\examples{
# default power curve and colors
ttestPower(n=20, s=5)
# short name
ttp(n=20, s=5)

# default power curve and colors
# plus optional smallest meaningful effect to enhance the analysis
ttestPower(n=20, s=5, mmd=2)

# power curve from both group standard deviations and sample sizes
# also provide the minimum standardized mean difference of 
#   practical importance to obtain corresponding power
ttestPower(n1=14, n2=27, s1=4, s2=6, msmd=.5)
  
# power curve for one sample t-test, triggered by non-null mu
ttestPower(n=20, s=5, mu=30, mmd=2)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ power }
\keyword{ t.test }

\name{recode}
\alias{recode}

\title{Recode the Values of an Integer or Factor Variable}

\description{
Recodes the values of one or more integer variables in a data frame. The values of the original variable may be overwritten with the recoded values, or the recoded values can be designated to be placed in a new variable, indicated by the \code{new_name} option. Valid values may be converted to missing, and missing values may be converted to valid values. Any existing variable labels are retained in the recoded data frame.

There is no provision to recode integer values to character strings because that task is best accomplished with the standard R \code{\link{factor}} function. 
}

\usage{
recode(old_vars, new_vars=NULL, old, new, data=d,
       quiet=getOption("quiet"), \dots)
}

\arguments{
  \item{old_vars}{One or more variables to be recoded.}
  \item{new_vars}{Name of the new variable or variables that contain the recoded
       values, each name in quotes. If not provided, then the values of the
       original variable are replaced.}
  \item{old}{The values of the variables that are to be recoded. If the value is
       \code{"missing"} then any existing missing values are replaced by the
       value specified with \code{new}.}
  \item{new}{The recoded values, which match one-to-one with the values in \code{old}. If the 
       value is \code{"missing"} then instead any values specified in \code{old} are
       converted to missing.}
  \item{data}{The name of the data frame from which to create the subset, which
       is \code{d} by default.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
       with \code{\link{style}} function.}
  \item{\dots}{Parameter values_}
}

\details{
Specify the values to be recoded with the required \code{old} parameter, and the corresponding recoded values with the required \code{new} parameter. There must be a 1-to-1 correspondence between the two sets of values, such as 0:5 recoded to 5:0, six items in the \code{old} set and six items in the \code{new} set. 

Use \code{new_vars} to specify the name of the variable that contains the recoded values. If \code{new_vars} is not present, then the values of the original variable are overwritten with the recoded values.

Not all of the existing values of the variable to be recoded need be specified.  Any value not specified is unchanged in the values of the recoded variable. 

Unless otherwise specified, missing values are unchanged.  To modify missing values, set \code{old="missing"} to covert missing data values to the specified value data value given in \code{new}.  Or, set \code{new="missing"} to covert the one or more existing valid data values specified in \code{old} to missing data values.

Diagnostic checks are performed before the recode. First, it is verified that the same number of values exist in the \code{old} and \code{new} lists of values_  Second, it is verified that all of the values specified to be recoded in fact exist in the original data. 

If the levels of a factor were to be recoded with \code{recode}, then the factor attribute would be lost as the resulting recoded variable would be character strings. Accordingly, this type of transformation is not allowed, and instead should be accomplished with the \code{Transform} and \code{factor} functions as shown in the examples.
}

\value{
The recoded data frame is returned, usually assigned the name of \code{d} as in the examples below.  This is the default name for the data frame input into the \code{lessR} data analysis functions.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{transform}}, \code{\link{factor}}.
}

\examples{
# construct data frame
d <- read.table(text="Severity Description
1 Mild
4 Moderate
3 Moderate
2 Mild
1 Severe", header=TRUE, stringsAsFactors=FALSE)

# recode Severity into a new variable called SevereNew
d <- recode(Severity, new_vars="SevereNew", old=1:4, new=c(10,20,30,40))

# reverse score four Likert variables: m01, m02, m03, m10 
d <- Read("Mach4")
d <- recode(c(m01:m03,m10), old=0:5, new=5:0)

# convert any 1 for Plan to missing
# use Read to put data into d data frame
# write results to newdata data frame
d <- Read("Employee")
newdata <- recode(Plan, old=1, new="missing")

# for Years and Salary convert any missing value to 99
d <- recode(c(Years, Salary), old="missing", new=99)


# ------------------------------------
# convert between factors and integers
# ------------------------------------

# recode levels of a factor that should remain a factor
#   with the Transform and factor functions
# using recode destroys the factor attribute, converting to
#   character strings instead, so Recode does not allow
d <- Read("Employee")
d <- Transform(
    Gender=factor(Gender, levels=c("F", "M"), labels=c("Female", "Male"))
)

# recode levels of a factor to convert to integer first by
#   converting to integer with Transform and as.numeric
# here Gender has values M and F in the data
# integers start with 1 through the number of levels, can use
#   recode() to change this if desired, such as to 0 and 1
d <- Transform(Gender=as.numeric(Gender))
d <- recode(Gender, old=c(1,2), new=c(0,1))

# recode integer values to levels of a factor with value labels
#   instead of recode()
# here Gender has values 0 and 1 in the data
d <- Read("Mach4")
d <- Transform(
      Gender=factor(Gender, levels=c(0,1), labels=c("Male","Female"))
      )
# ------------------------------------
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ recode }

\name{corReorder}
\alias{corReorder}
\alias{reord}

\title{Reorder Variables in a Correlation Matrix}

\description{
Abbreviation: \code{reord}

Re-arranges the order of the variables in the input correlation matrix.  If no variable list is specified then by default the variables are re-ordered according to hierarchical clustering. Or, re-order with the Hunter (1973) chain method in which the first variable is the variable with the largest sum of squared correlations of all the variables, then the next variable is that with the highest correlation with the first variable, and so forth. Or, re-order manually.
}

\usage{
corReorder(R=mycor, order=c("hclust", "chain", "manual", "as_is"),
          hclust_type = c("complete", "ward.D", "ward.D2", "single",
                          "average", "mcquitty", "median", "centroid"),
          dist_type=c("R", "dist"),
          n_clusters=NULL, vars=NULL, chain_first=0,
          heat_map=TRUE, dendrogram=TRUE, diagonal_new=TRUE,
          main=NULL, bottom=NULL, right=NULL, quiet=getOption("quiet"),
          pdf=FALSE, width=5, height=5, \ldots)

reord(\ldots)
}

\arguments{
  \item{R}{Correlation matrix.}
  \item{order}{Source of ordering (seriation): Default of hierarchical cluster
       analysis,
       Hunter(1973) chain method, manually specified with \code{vars}, or left
       \code{"as_is"}.}
  \item{hclust_type}{Type of hierarchical cluster analysis.}
  \item{dist_type}{Default is a correlation matrix of similarities, otherwise
       a distance matrix.}
  \item{n_clusters}{For a hierarchical cluster analysis, optionally specify
       the cluster
       membership for the specified number of clusters.}
  \item{vars}{List of the re-ordered variables, each variable listed by its ordinal
       position in the input correlation matrix. If this is set, then
       \code{order} set to \code{"manual"}.}
  \item{chain_first}{The first variable listed in the ordered matrix with
       the chain method.}
  \item{main}{Graph title. Set to \code{main=""} to turn off.}
  \item{heat_map}{If \code{TRUE}, display a heat map of the item correlations.}
  \item{dendrogram}{If \code{TRUE}, display a heat map of the item correlations
       for a hierarchical cluster analysis.}
  \item{diagonal_new}{If \code{TRUE}, replace diagonal for the heat map only
       with an average of the correlation of item on the diagonal with the two
       adjacent items.}
  \item{bottom}{Number of lines of bottom margin.}
  \item{right}{Number of lines of right margin.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
        with \code{\link{style}} function.}
  \item{pdf}{if \code{TRUE}, create possibly two PDF files: the hierarchical
       cluster analysis dendrogram if requested and the heat map of the reordered
       correlation matrix.}
  \item{width}{Width of a pdf file in inches.}
  \item{height}{Height of a pdf file in inches.}
  \item{\dots}{Parameter values_}
}

\details{
Reorder and/or delete variables in the input correlation matrix.  

Define the constituent variables, the items, with a listing of each variable by its name in the correlation matrix. If the specified variables are in consecutive order in the input correlation matrix, the list can be specified by listing the first variable, a colon, and then the last variable.  To specify multiple variables, a single variable or a list, separate each by a comma, then invoke the R combine or \code{\link{c}} function. For example, if the list of variables in the input correlation matrix is from m02 through m05, and the variable Anxiety, then define the list in the \code{corReorder} function call according to \code{vars=c(m02:m05,Anxiety)}. 

Or, define the ordering with a hierarchical cluster analysis from the base R function \code{hclust()}. The same default type of \code{"complete"} is provided, though this can be changed with the parameter \code{hclust_type} according to \code{\link{hclust}}. Default input is a correlation matrix, converted to a matrix of dissimilarities by subtracting each element from 1.

Or, use the Hunter (1973) chain method. Define the ordering of the variables according to the following algorithm. If no variable list is specified then the variables are re-ordered such that the first variable is that which has the largest sum of squared correlations of all the variables, then the variable that has the highest correlation with the first variable, and so forth.

In the absence of a variable list, the first variable in the re-ordered matrix can be specified with the \code{chain_first} option.

}


\references{
Hunter, J.E. (1973), Methods of reordering the correlation matrix to facilitate visual inspection and preliminary cluster analysis, Journal of Educational Measurement, 10, p51-61.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Correlation}}, \code{\link{hclust}}.
}

\examples{
# input correlation matrix of perfect two-factor model
# Factor Pattern for each Factor: 0.8, 0.6, 0.4
# Factor-Factor correlation: 0.3
mycor <- matrix(nrow=6, ncol=6, byrow=TRUE,
c(1.000,0.480,0.320,0.192,0.144,0.096,
  0.480,1.000,0.240,0.144,0.108,0.072,
  0.320,0.240,1.000,0.096,0.072,0.048,
  0.192,0.144,0.096,1.000,0.480,0.320,
  0.144,0.108,0.072,0.480,1.000,0.240,
  0.096,0.072,0.048,0.320,0.240,1.000))
colnames(mycor) <- c("V1", "V2", "V3", "V4", "V5", "V6")
rownames(mycor) <- colnames(mycor)

# leave only the 3 indicators of the second factor
#  in reverse order
#replace original mycor
mycor <- corReorder(vars=c(V6,V5,V4))

#  reorder according to results of a hierarchical cluster analysis
mynewcor <- corReorder()

#  get cluster membership for two clusters
# specify each parameter
mynewcor <- corReorder(mycor, order="hclust", n_clusters=2)

#  reorder with first variable with largest sums of squares
mynewcor <- corReorder(order="chain")

# reorder the variables according to the ordering algorithm
#  with the 4th variable listed first
# no heat map
mynewcor <- corReorder(chain_first=2, heat_map=FALSE)

mycor <- matrix(nrow=6, ncol=6, byrow=TRUE,
c(1.000,0.480,0.320,0.192,0.144,0.096,
  0.480,1.000,0.240,0.144,0.108,0.072,
  0.320,0.240,1.000,0.096,0.072,0.048,
  0.192,0.144,0.096,1.000,0.480,0.320,
  0.144,0.108,0.072,0.480,1.000,0.240,
  0.096,0.072,0.048,0.320,0.240,1.000))
colnames(mycor) <- c("V1", "V2", "V3", "V4", "V5", "V6")
rownames(mycor) <- colnames(mycor)

# can also re=order with index position of each variable
mycor <- corReorder(vars=c(4,5,6,1,2,3))

}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ correlation }

\name{Model}
\alias{Model}
\alias{model}
\alias{model_brief}


\title{Regression, Logit Regression, ANOVA, or t-test from a Model
 Specification}

\description{
Abbreviation: \code{model}, \code{model_brief}

Specify a model with a standard R \code{\link{formula}}, and \code{Model}
selects and runs the appropriate statistical procedure: OLS regression,
logit regression, ANOVA, or a t-test. The selection follows from the
analytic structure of the model's variables -- whether the response and
predictor variables are numerical or categorical, and how many unique
values they have. The analysis itself, with its full text and graphics
output, is produced by the corresponding \code{lessR} function:
\code{\link{Regression}}, \code{\link{Logit}}, \code{\link{ANOVA}}, or
\code{\link{ttest}}. Any parameter of the selected function can be passed
through the \code{Model} call.

By default the data exist in the data frame \code{d}, such as data read by
the \code{lessR} \code{\link{Read}} function.
}

\usage{
Model(my_formula, data=d, brief=getOption("brief"), xlab=NULL, \dots)

model_brief(\dots, brief=TRUE)

model(\dots)
}


\arguments{
  \item{my_formula}{Standard R \code{\link{formula}} for specifying a model.
       For example, for a response variable named Y and two predictor
       variables, X1 and X2, specify the corresponding linear model as
       Y ~ X1 + X2.}
  \item{data}{The default name of the data frame that contains the data for
       analysis is \code{d}, otherwise explicitly specify.}
  \item{brief}{If set to \code{TRUE}, reduced text output. Can change
       system default with the \code{\link{style}} function.}
  \item{xlab}{x-axis label for the graphics output of the logit and t-test
       analyses, defaults to the variable name, or, if present, the
       variable label.}
  \item{\dots}{Parameter values passed to the selected analysis function,
       \code{\link{Regression}}, \code{\link{Logit}}, \code{\link{ANOVA}},
       or \code{\link{ttest}}.}
}



\details{
OVERVIEW\cr
The purpose of \code{Model} is to select the appropriate statistical
procedure from the specified model and properties of the data. The analyst
specifies the model, the analytic question of interest; \code{Model}
identifies and runs the procedure that answers it. A message that precedes
the output of each analysis reports which procedure was selected and why.

SELECTION OF THE PROCEDURE\cr
Classify the response variable (before the tilde in the formula) and the
predictor variables (after the tilde) as categorical -- an R factor,
character, or logical variable -- or as numerical. The analysis follows
from that classification.

For a categorical response variable with exactly two categories, run a
logit regression with \code{\link{Logit}}, regardless of the type of the
predictor variables. A categorical response variable with more than two
categories is not supported.

For a numerical response variable:
\itemize{
\item If the values of the response variable are only 0 and 1, run a logit
 regression with \code{\link{Logit}}.
\item If there is a single categorical predictor variable with exactly two
 unique values, compare the two corresponding group means with
 \code{\link{ttest}}.
\item If all predictor variables are categorical, compare the group means
 with \code{\link{ANOVA}}.
\item Otherwise, that is, for predictor variables that are all numerical,
 or a mix of numerical and categorical variables, run an OLS regression
 with \code{\link{Regression}}, which for one numerical and one categorical
 predictor variable provides an analysis of covariance.
}

A numerical response variable with exactly two unique values other than 0
and 1 is intended as binary, so first transform its values to 0 and 1 with
\code{\link{recode}} before running \code{Model}.

For further details of each analysis, and the additional parameters
available for each, see the corresponding function:
\code{\link{Regression}}, \code{\link{Logit}}, \code{\link{ANOVA}}, and
\code{\link{ttest}}.
}

\value{
The value returned by the selected analysis function, invisibly.
The primary output is the text and graphics of the selected analysis.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Regression}}, \code{\link{Logit}}, \code{\link{ANOVA}},
\code{\link{ttest}}, \code{\link{formula}}, \code{\link{lm}},
\code{\link{glm}}
}

\examples{
# Generate random data, place in data frame d
n <- 200
X1 <- rnorm(n)
X2 <- rnorm(n)
Y <- .7*X1 + .2*X2 + .6*rnorm(n)
Ybin <- cut(Y, breaks=2, labels=FALSE)
#  instead, if read data with the Read function
#   then the result is the data frame called d
d <- round(data.frame(X1, X2, Y, Ybin),2)
rm(Y); rm(Ybin); rm(X1); rm(X2)

# One-predictor regression
# Provide all default analyses including scatterplot etc.
Model(Y ~ X1)
# alternate form
model(Y ~ X1)

# Multiple regression model
# Provide all default analyses
Model(Y ~ X1 + X2)

# Logit analysis from a numeric response variable of 0's and 1's
d <- recode(Ybin, old=c(1,2), new=c(0,1), quiet=TRUE)
Model(Ybin ~ X1)

# t-test
Model(breaks ~ wool, data=warpbreaks)

# ANOVA analysis
# from a data frame other than the default d
# breaks is numerical, wool and tension are categorical
Model(breaks ~ wool + tension, data=warpbreaks)

# Analysis of covariance: one numerical and one categorical predictor
d <- Read("Employee", quiet=TRUE)
Model(Salary ~ Years + Gender)

# Logit analysis from a two-category response variable
Model(Gender ~ Salary)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ regression }

\name{details}
\alias{details}
\alias{db}

\title{Display Contents of a Data File and Optional Variable Labels}

\description{
Abbreviation: \code{db}

Provides feedback regarding a data frame which includes the variable names, the dimensions of the resulting data frame, the data type for each variable, and the values of the variables in the data file for the first and last rows of the data. In addition, an analysis of missing data is provided, listing the number of missing values for each variable and for each observation.
}

\usage{
details(data=d, n_mcut=1, max_lines=30,
         miss_show=30, miss_zero=FALSE, miss_matrix=FALSE, var_labels=FALSE,
         brief=getOption("brief"))

db(\dots, brief=TRUE)
}

\arguments{
  \item{data}{Data frame for which to provide the details.}
  \item{n_mcut}{For the missing value analysis, list the row name and number
        of missing values if the number of missing exceeds or equals this
        cutoff.}
  \item{max_lines}{Maximum number of lines to list of the data and labels.}
  \item{miss_show}{For the missing value analysis, the number of rows, one
       row per observation, that has as many or missing values as \code{n_mcut}.}
  \item{miss_zero}{For the missing value analysis, list a row even for a value
       of 0, that is, with no missing data. By default only rows with missing
       data are listed.}
  \item{miss_matrix}{For the missing value analysis, if there is any missing data,
       list a version of the complete data table with a 0 for a non-missing]
        value and a 1 for a missing value.}
  \item{var_labels}{The data frame consists of variable labels if \code{TRUE}, 
       so the message about a column of unique values is not displayed.}
  \item{brief}{If \code{TRUE}, display only variable names table plus any
        variable labels. The default for ``details brief'' abbreviation \code{db}.}
  \item{\dots}{Further arguments to be passed to or from methods consistent
       with the R \code{\link{read.table}} function. For example, can set
       \code{stringsAsFactors} as \code{TRUE}.}
}

\details{
MISSING DATA\cr
When \code{brief} is set to \code{FALSE}, \code{details} provides a list the row of data with missing values, indicated by the standard R missing value code NA. To view the entire data table in terms of 0's and 1's for non-missing and missing data, respectively, invoke the \code{miss_matrix=TRUE} option. 

VARIABLE LABELS\cr
Standard R does not provide for variable labels, but \code{lessR} does. Variable labels can be provided for some or all of the variables in the data frames.  One way to enter the variable labels is to read them from their own file with \code{details} with \code{labels} set to the full path name or \code{URL} of the labels file, or just the file name if the labels file is in the same directory as the data file.  Another method is to include the labels directly in the data file.  To to this, specify the file of variable labels with the \code{label="row2"} option. The web survey application Qualtrics downloads \code{csv} files in this format.

For a file that contains only labels, each row of the file, including the first row, consists of the variable name, a comma, and then the label, that is, standard \code{csv} format such as obtained with the \code{csv} option from a standard worksheet application such as Microsoft Excel or LibreOffice Calc. Not all variables in the data frame that contains the data, usually \code{d}, need have a label, and the variables with their corresponding labels can be listed in any order. An example follows.

I2,This instructor presents material in a clear and organized manner.\cr
I4,Overall, this instructor was highly effective in this class.\cr
I1,This instructor has command of the subject.\cr
I3,This instructor relates course materials to real world situations.\cr

If there is a comma in the variable label, then the label needs to be enclosed in quotes.

The \code{lessR} functions that provide analysis, such as \code{\link{X}} for a histogram, automatically include the variable labels in their output, such as the title of a graph.  Standard R functions can also use these variable labels by invoking the \code{\link{label}} function, such as setting \code{main=label(I4)} to put the variable label for a variable named I4 in the title of a graph.  
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Read}}.
}

\examples{
# read the built-in data set dataEmployee
# this provides an automatic call to details
d <- Read("Employee")

# manually request the details for d
details()

# manually request just variable names, labels for d
db()
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ read }
\keyword{ csv }

\name{pivot}
\alias{pivot}

\title{Create a Pivot (Summary) Table}

\description{
Compute one or more designated descriptive statistics (\code{compute} over one or more numerical variables (\code{variable}) either for all the data or aggregated over one or more categorical variables (\code{by}). Because the output is a two-dimensional table, select any two of the three possibilities: Multiple compute functions for the descriptive statistics, multiple continuous variables over which to compute, and multiple categorical variables by which to define groups for aggregation. Displays the sample size for each group. Uses the base R function \code{\link{aggregate}} for which to perform the aggregation.
}

\usage{
pivot(data, compute, variable, by=NULL, by_cols=NULL, filter=NULL,
         show_n=TRUE, na_by_show=TRUE, na_group_show=TRUE, na_remove=TRUE,
         out_names=NULL, sort=NULL, sort_var=NULL,  
         table_prop=c("none", "all", "row", "col"), table_long=NULL,
         factors=TRUE, q_num=4, digits_d=NULL, quiet=getOption("quiet"))
}

\arguments{
  \item{data}{Data frame that contains the variables.}
  \item{compute}{One or more statistics, defined as one or more functions,
       to aggregate over the combinations of the values of the categorical
       variables. If no numerical variable, then ignore.}
  \item{variable}{One or more numeric response variables for which to
       \code{compute} the specified statistics, perhaps aggregated,
       i.e., summarized across the groups.}
  \item{by}{Categorical variables that define the groups (cells) listed
       in the rows of the output long-form data frame, available to input
       into other data analysis routines. Ignore to compute over the variables
       for all the data, e.g., the grand mean.}
  \item{by_cols}{Up to two categorical variables that define the groups
       displayed as columns in a two dimensional table.} 
  \item{filter}{Subset, i.e., filter, rows of the input data frame for
        analysis.}\cr

  \item{show_n}{By default, display the sample size and number missing for each
        computed summary statistic. If \code{FALSE}, delete all variables
        from the output data frame that end with \code{n_} or \code{na_}.}
  \item{na_by_show}{If \code{TRUE},
       the default, if all values of `variable` are missing for a group
       so that the entire level of the `by` variables is missing, show those
       missing cells with a reported value of computed variable \code{n} as 0.
       Otherwise delete the row from the output.}
  \item{na_group_show}{If \code{TRUE}, the default, display \code{<NA>} for missing
       data of a grouping variable as a level for that variable. Otherwise, do
       not treat a missing value of a group as a level for which to aggregate,
       deleting the level from the analysis.}
  \item{na_remove}{Sets base R parameter \code{na.rm}. If \code{TRUE},
       the default, removes missing values from the \code{variable}(s),
       which are aggregated,
       then reports how many values were missing. Otherwise, the 
       aggregation statistic for a cell with any missing data returns \code{NA}.}
  \item{out_names}{Custom names for the aggregated variables. If more than one,
        list in the same order as specified in \code{variable}. Does not apply
        to the \code{table} option where the column names are the levels of
        the \code{by} variable(s).}\cr

  \item{sort}{Set to \code{"+"} for an ascending sort or \code{"-"} for
       a descending sort according to the last variable in the output data
       frame.}
  \item{sort_var}{Either the name of the variable in the output data frame
       to sort, or its column number. Default is the last column.}\cr

  \item{table_prop}{Applies to a created \code{table} for the value of
        \code{compute}. Default value of \code{"none"} leaves frequencies.
        Value of \code{"all"} converts to cell proportions based on the
        grand total. Values of \code{"row"} and \code{"col"} provide
        proportions based on row and column sums.}
  \item{table_long}{Applies to the value of \code{compute} of \code{table}.
        When \code{TRUE}, the cross-tabs table is output in
        long form, one count per row.}\cr

  \item{factors}{For \code{by} variables of type
        \code{character} and \code{integer}, converted to factors
        in the summary table by default, except for \code{Date}
        variables that always retain their type. If \code{FALSE}, then
        the \code{by} variables retain their original character or 
        integer type.}
  \item{q_num}{For the computation of quantiles, number of intervals. Default
        value of 4 provides quartiles.}
  \item{digits_d}{Number of significant digits for each displayed
       summary statistic. Trailing zeros are deleted, so, for example, integers
       display as integers. If not specified, defaults to 3
       unless there are more than 3 decimal digits and only a single
       digit to the left of the decimal point. Then enough digits are
       displayed to capture some non-zero decimal digits to avoid rounding
       to 0.000. To see all digits without trailing decimal 0's,
       set at a large number such as 20.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system default
       with \code{\link{style}} function.}
}

\details{
\code{pivot} uses base R \code{\link{aggregate}} to generate a pivot table (Excel terminology). Express multiple categorical variables over which to pivot as a vector with the \code{\link{c}} function.

\code{pivot} provides two additional features than \code{\link{aggregate}} provides. First is a complete missing data analysis. If there is no missing data for the numerical variables that are aggregated, then the cell sizes are included with the aggregated data. If there is such missing data, then the amount of available data is displayed for all values to be aggregated for each cell.

The second is that the data parameter is listed first in the parameter list, which facilitates the use of the pipe operator from the \code{magrittr} package. Also, there is a different interface as the \code{by} variables are specified as a vector.

Variable ranges in the specification of \code{by} are not needed in general. Only a small number of grouping variables generally define the cells for the aggregation.

The following table lists available single summary statistics. The list is not necessarily exhaustive as the references are to functions provided by base R, including any not listed below.

\tabular{ll}{
Statistic \tab Meaning\cr
----------- \tab --------------------------------\cr
\code{sum} \tab sum\cr
\code{mean} \tab arithmetic mean\cr
\code{median} \tab median\cr
\code{min} \tab minimum\cr
\code{max} \tab maximum\cr
\code{sd} \tab standard deviation\cr
\code{var} \tab variance\cr
\code{skew} \tab skew\cr
\code{kurtosis} \tab kurtosis\cr
\code{IQR} \tab inter-quartile range\cr
\code{mad} \tab mean absolute deviation\cr
----------- \tab --------------------------------\cr
}

The functions \code{skew()} and \code{kurtosis()} are provided by this package as they have no counterparts in base R. All other functions are from base R.

The \code{quantile} and \code{table} statistical function returns multiple values.

\tabular{ll}{
Statistic \tab Meaning\cr
----------- \tab --------------------------------\cr
\code{quantile} \tab min, quartiles, max\cr
\code{table}    \tab frequencies or proportions\cr
----------- \tab --------------------------------\cr
}
The \code{table} computation applies to an aggregated variable that consists of discrete categories, such as the numbers 1 through 5 for responses to a 5-pt Likert scale. The result is a table of frequencies or proportions, a contingency table, referred to for two or more variables as a cross-tabulation table or a joint frequency distribution. Other statistical functions can be simultaneously computed with \code{table}, though only meaningful if the aggregated variable consists of a relatively small set of discrete, numeric values. 

The default quantiles for \code{quantile} are quartiles. Specify a custom number of quantiles with the \code{q_num} parameter, which has the default value of 4 for quartiles.


}

\value{
Returns a data frame of the aggregated values, unless for two \code{by} variables and \code{table_2d} is \code{TRUE}, when a table is returned. 

The count of the number of elements in each group is provided as the variable \code{n}. If a combination of \code{by} variable levels that defines a group is empty, the \code{n} is set to 0 with the values of the \code{variable} set to \code{NA}.

The number of missing elements of the \code{value} variable is provided as the variable \code{miss}.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{aggregate}}.
}

\examples{
library(knitr)  # for kable() called from pivot()
d <- Read("Employee", quiet=TRUE)

# parameter values named
pivot(data=d, compute=mean, variable=Salary, by=c(Dept, Gender))

# visualize the aggregation
# when reading a table of coordinates, a, BarChart cannot deal with
#   with missing data so do not show groups that are missing as
#   another level
a <- pivot(d, mean, Salary, c(Dept, Gender), na_group_show=FALSE)
BarChart(Dept, Salary_mean, by=Gender, data=a)

# calculate mean of Years and Salary for each combination of Dept and Gender
# parameter values by position
pivot(d, mean, c(Years, Salary), c(Dept, Gender))

# output as a 2-d cross-tabulation table
pivot(d, mean, Salary, Dept, Gender)

# cross-tabulation table
pivot(d, table, by=c(Dept, Gender))
# short form
pivot(d, table, by=c(Dept, Gender), table_long=TRUE)

# multiple functions for which to aggregate
pivot(d, c(mean,sd,median,IQR), Years, by=c(Gender,Dept), digits_d=2)

# A variety of statistics computed for several variables over the
#  entire data set without aggregation
pivot(d, c(mean,sd,skew,kurtosis), c(Years,Salary,Pre,Post), digits_d=2)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.

\keyword{pivot}

\name{corProp}
\alias{corProp}
\alias{cp}

\title{Proportionality Coefficients from Correlations}

\description{
Abbreviation: \code{cp}

In the population, indicators of the same factor or latent variable have parallel correlations with all other variables. Of course, in the presence of sampling error, this parallelism will only be approximate. To assess this parallelism, proportionality coefficients are computed for each pair of variables in the input correlation matrix.  Also output is a heat map of the resulting matrix of proportionality coefficients. Each graph is based on a default color theme. The original default is \code{lightbronze}, but other color palettes can be generated as well.
}

\usage{
corProp(R=mycor, 
          main=NULL, heat_map=TRUE, bottom=NULL, right=NULL, 
          pdf_file=NULL, width=5, height=5, \dots)

cp(\dots)
}

\arguments{
  \item{R}{Correlation matrix.}
  \item{main}{Graph title. Set to \code{main=""} to turn off.}
  \item{heat_map}{If \code{TRUE}, display a heat map of the item
        correlations with the diagonal ignored.}
  \item{bottom}{Number of lines of bottom margin.}
  \item{right}{Number of lines of right margin.}
  \item{pdf_file}{Name of the pdf file to which graphics are redirected.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{\dots}{Parameter values_}
}

\details{
Proportionality coefficients indicate the extent of proportionality between two variables.  Perfect proportionality of two variables is consistent with both variables being indicators of the same latent variable or factor and indicators of no other factor.

In the current version the diagonal of the input correlation matrix is ignored.  To maintain parallelism, the diagonal element of 1.00 would need to be replaced the corresponding communalities, which first requires a factor analysis.  
}

\references{
Gerbing, D. W. (2014). R Data Analysis without Programming, Chapter 11, NY: Routledge.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\seealso{
\code{\link{Correlation}}.
}

\examples{
# input correlation matrix of perfect two-factor model
# Factor Pattern for each Factor: 0.8, 0.6, 0.4
# Factor-Factor correlation: 0.3
mycor <- matrix(nrow=6, ncol=6, byrow=TRUE,
c(1.000,0.480,0.320,0.192,0.144,0.096,
  0.480,1.000,0.240,0.144,0.108,0.072,
  0.320,0.240,1.000,0.096,0.072,0.048,
  0.192,0.144,0.096,1.000,0.480,0.320,
  0.144,0.108,0.072,0.480,1.000,0.240,
  0.096,0.072,0.048,0.320,0.240,1.000))
colnames(mycor) <- c("X1", "X2", "X3", "X4", "X5", "X6")
rownames(mycor) <- colnames(mycor)

# proportionality coefficients of correlation matrix mycor
# indicators of the same factor have proportional correlations
corProp()

# abbreviated form
cp()

# calculate and store proportionality coefficients in myprop
# order the proportionality coefficients to help identify factors
myprop <- corProp()
corReorder(myprop)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ correlation }
\keyword{ proportionality }

\name{print.out}
\alias{print.out}

\title{Display a Portion of Output from a Saved List Object}

\description{
Displays the portions of saved results of an analysis from a \code{lessR} function into an object, such as for later display at the console or to be integrated into a \code{Rmd} analysis, for example from \code{RStudio}. This function is usually implicitly accessed by the user simply by entering the name of an output piece into the console or in a \code{Rmd} file, such as, such as \code{r$out_coefs} that results from \code{r} in \code{r <- reg(Y ~ X)}.

Now just applies to the \code{lessR} \code{\link{Regression}} function.
}

\usage{
\method{print}{out}(x, \dots)
}


\arguments{
  \item{x}{The piece of output to display, a character vector or a list of character vectors.}
  \item{\dots}{Other parameter values.}
}

\references{
Gerbing, D. W. (2014). R Data Analysis without Programming, Chapters 9 and 10, NY: Routledge.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Regression}}
}

\examples{
# read internal data set
d <- rd("Employee", quiet=TRUE)
# do the summary statistics
s <- ss_brief(Salary)
# print the piece of output, print function is implicit
s$outliers
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ print.out }

\name{dataAnova_1way}
\docType{data}
\alias{dataAnova_1way}
\title{Data for a One-Way ANOVA}

\description{To study the impact of arousal on the ability to complete a task, 24 laboratory rats were randomly and equally divided into three groups of eight. Each rat was administered one of three dosages of an arousal inducing drug: 0, 5, and 10 milligrams. Following the dosage, each rat completed a maze to obtain a food reward. The response (dependent) variable is the Time in seconds to complete the maze.}

\format{A data table with 24 rows of data and 2 columns, with variables Dosage and Time.}

\references{
Gerbing, D. W. (later in 2022). R Data Analysis without Programming, 2nd Edition, Chapter 7, NY: Routledge.

Gerbing, D. W. (2021). Enhancement of the Command-Line Environment for use in the Introductory Statistics Course and Beyond, \emph{Journal of Statistics and Data Science Education}, 29(3), 251-266, https://www.tandfonline.com/doi/abs/10.1080/26939169.2021.1999871. 
}

\author{
David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})
}

\examples{
d <- Read("Anova_1way")
ANOVA(Time ~ Dosage)
}

\source{author}
\keyword{datasets}

\name{interact}
\alias{interact}

\title{Run Interactive Shiny Data Visualizations}

\description{Interactive data visualizations. Choose your data, choose your variables, and set the parameters as desired.
}

\usage{
interact(app)
}


\arguments{
  \item{app}{Name of the shiny app to run, enclosed in quotes.}
}


\details{
Valid names are \code{"Chart"}, \code{"X"}, \code{"XY"}. If missing, then the valid names are listed.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\examples{
# Commented out as the analyses are interactive
#interact()
#interact("BarChart")
}

\name{reshape_long}
\alias{reshape_long}

\title{Reshape a Wide-Form Data Frame to Long-Form}

\description{
A simple wrapper for Base R \code{\link{reshape}} with sensible parameter names and sensible defaults, and able to specify a range of variables to transform.
}

\usage{
reshape_long(data, transform, group="Group", response="Response", ID="ID",
           prefix=ID, sep="", shape=c("rect", "square"), reverse_y=NULL)
}

\arguments{
  \item{data}{Data frame that contains the variables to reshape.}
  \item{transform}{The wide-form column variable names to transform to a
        long-form single column.}
  \item{group}{Name of the grouping variable in the new
        long-form column.}
  \item{response}{Name of the variable of the response values in the new
        long-form column.}
  \item{ID}{Name of the newly created ID field in the new long-form
        column, the original row number from the wide-form. If \code{NULL},
        then not created.}
  \item{prefix}{The prefix added to the value of ID for each row of data.}
  \item{sep}{Any potential separator of the ID prefix from the given value
       of the ID.}
  \item{shape}{In general, the input data is a rectangular, wide-form data frame.
       However, it can also be a symmetric, square correlation or 
       covariance matrix.}
  \item{reverse_y}{Applies only when \code{shape="square"}. If \code{TRUE},
       the factor levels of the first output column (rows of the input matrix)
       are reversed so that the first row appears at the \emph{top} of a heat
       map y-axis, which runs bottom-to-top. If \code{FALSE}, the original row
       order is preserved. The default is \code{NULL}, which behaves like
       \code{TRUE} but also prints a message informing the user of the reversal
       and how to suppress it.}
}

\details{
\code{reshape_long} takes the \code{transform} variables in the wide-form from
which it creates three new columns, \code{group}, \code{response}, and \code{ID}.

The correspondence between the original  \code{\link{reshape}} parameter names and the \code{reshape_long} parameter names is shown in the following table.

\tabular{ll}{
reshape \tab reshape_long\cr
----------- \tab ----------------\cr
\code{varying} \tab \code{transform}\cr
\code{v.names} \tab \code{response}\cr
\code{timevar} \tab \code{group}\cr
\code{times} \tab \code{transform}\cr
\code{idvar} \tab \code{ID}\cr
----------- \tab ----------------\cr
}

For a correlation or related symmetric, square input matrix, the applicable parameters are the \code{data} parameter to specify the input matrix, \code{group} to name the two columns that contain the variable names, and \code{response} to specify the name of the variable with data values that are the input correlations or related. 

The name entered for \code{group} is repeated for the first two columns of the output with a suffix of 1 and 2, respectively. For example, \code{group="Item"} becomes \code{"Item1"} and \code{"Item2"}. If no name for \code{group} is entered, the default variable names are \code{Row} and \code{Col}.

When \code{shape="square"}, the row-factor levels of the reshaped data are by default reversed (\code{reverse_y=NULL} or \code{reverse_y=TRUE}) so that the first row of the input matrix appears at the top of the y-axis in a heat map (because plot y-axes run bottom-to-top). Pass \code{reverse_y=FALSE} to retain the original row order. When the default \code{NULL} is in effect, a message is printed to inform the user of the reversal. Passing \code{TRUE} explicitly applies the same reversal silently.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{reshape}}.
}

\examples{
d <- Read("Anova_rb")
d

# with the default variable names in the long-form
reshape_long(d, c("sup1", "sup2", "sup3", "sup4"))

# with a variable range and custom variable names in the long-form
reshape_long(d, sup1:sup4, group="Supplement", response="Reps", ID="Person")

# input correlation matrix
R <- matrix(nrow=3, ncol=3, byrow=TRUE,
c(1.000,0.480,0.320,
  0.480,1.000,0.240,
  0.320,0.240,1.000))
colnames(R) <- c("X1", "X2", "X3")
rownames(R) <- colnames(R)
# reshape to long (default: row levels reversed for heat map y-axis, with message)
dl <- reshape_long(R, shape="square", group="Item", response="Cor")
dl

# explicitly reverse row levels (heat map convention, no message)
dl <- reshape_long(R, shape="square", group="Item", response="Cor", reverse_y=TRUE)

# keep original row order
dl <- reshape_long(R, shape="square", group="Item", response="Cor", reverse_y=FALSE)
dl

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ reshape }
\keyword{ wide-form }
\keyword{ long-form }

\name{dataJackets}
\docType{data}
\alias{dataJackets}
\title{Data: Motorcycle Type and Thickness of Jacket}

\description{Two variables, one is type of motorcycle and the other is the thickness of the purchased jacket.}

\usage{data(dataJackets)}
\format{A data table with 1025 observations.

Bike,"Type of Motorcycle, Honda or BMW"\cr
Jacket,"Lite, Med or Thick"\cr
}

\source{author}
\keyword{datasets}

\name{STL}
\alias{STL}

\title{Seasonal and Trend Decomposition of a Time Series via Loess}

\description{
Decompose a time series into seasonal, trend and irregular components using loess, a wrapper to provide additional information to the Base R \code{stl} function and accept more general input beyond the \code{stl} required time series object input. This function accepts a Base R time series from the global environment as input, but also accepts data in the traditional \code{x},\code{y} format where \code{x} is a variable of type \code{Date}. Moreover, the \code{Date} variable can be inferred from digital character string inputs. The time unit of the input dates can also be aggregated, such as changing monthly dates to quarterly dates.
}

\usage{
STL(x, y=NULL, data=d, filter=NULL,
    ts_format=NULL, ts_unit=NULL, ts_agg=c("sum","mean"),
    show_range=FALSE, robust=FALSE, quiet=FALSE, do_plot=TRUE,
    pdf_file=NULL, width=6.5, height=6)
}


\arguments{
  \item{x}{Dates for the time series as a variable within a data frame,
        or a time series object created with the Base R function \code{ts}.
        If the dates are of type \code{character}, they will be
        automatically converted to type \code{Date}.}
  \item{y}{Numerical variable that is planted in the time series, not used if 
        \code{x} is a time series object.}
  \item{data}{Data frame that contains the \code{x} and
        \code{y} variables. Default data frame is \code{d}.}
  \item{filter}{A logical expression that specifies a subset of rows of
        the data frame to analyze.}
  \item{ts_format}{A specified format (for R function \code{as.Date()})
    that describes the values of the date variable on the x-axis, 
    needed if the function cannot identify the correct date format to properly
    decode the given date values. For example, describe a character string
    date such as \code{"09/01/2024"} by the format \code{"\%m/\%d/\%Y"}.
    See \code{details} for more information.}
  \item{ts_unit}{Specify the time unit from which to plot a time series,
        plotted when the \code{x}-variable is of type \code{Date}.
        Default value is the time unit that describes the time intervals as
        they occur in the data.
        Aggregation according to the time unit will occur as specified, such as
        a daily time series aggregated to \code{"months"}. Dates are currently
        stored as variable type \code{Date()} which stores information as
        calendar dates without times of the day.
        Valid values include: \code{"days"}, \code{"weeks"},
        \code{"months"}, \code{"quarters"}, and \code{"years"}, as well as 
        \code{"days7"} to provide seasonality for daily data on a weekly instead
        of annual basis.
        Otherwise, for forecasting, the time unit for detecting seasonality
        will usually be `"months"` or `"quarters"`. }
  \item{ts_agg}{Function by which to aggregate over time according to
        \code{ts_unit}. Default is \code{"sum"} with an option for
        \code{"means"}.}
  \item{show_range}{Display the range for each component.}
  \item{robust}{\code{stl()} parameter for a more robust solution.}
  \item{quiet}{If \code{TRUE}, no text output to the console.}
  \item{do_plot}{If \code{FALSE}, no plot.}
  \item{pdf_file}{Indicate to direct pdf graphics to the specified name of
        the pdf file.}
  \item{width}{Width of the plot window in inches, defaults to 5 except in RStudio
        to maintain an approximate square plotting area.}
  \item{height}{Height of the plot window in inches, defaults to 4.5 except for
        1-D scatterplots and when in RStudio.}
}

\details{
PURPOSE\cr
Obtain and plot the seasonal, trend, and the irregular (remainder or residual) components of a time series using the Base R \code{stl} function. The corresponding plot is of four panels, one for the data and one each for the seasonal, trend, remainder components. Provide additional information comparing the relative sizes of the components in the form of the percent of variance of each component accounted for and the range of values of each component. 

Seasonality is detected over a year, such as four quarters in a year or 12 months in a year. The exception is for daily data, for which seasonality can be indicated by the time unit of \code{"days7"}, which will evaluate seasonality over the seven days of a week.

RANGE BARS\cr
By definition, the data shows the most variability compared to the three components. If the four panels were scaled on the same y-axis, then the relative magnitude of the variations in each of the components, such as assessed by the ranges of each of their values, would be more directly observable. For example, if seasonality has no  practical presence in the data, then the amplitude of the seasonal plot, the range of the seasonal component values, would be a small fraction the amplitude of the data plot, only reflecting random noise. Plotted on the same panel, the comparison would be direct. 

Instead, however, the plots of the data and each of the three components are drawn such that each component is plotted on its own panel with its own scale with the most detail possible. The purpose of the range bars is to show a relative scale for comparison across the panels. Each range bar is a magnification indicator. The larger the bar, the more expanded is the corresponding panel, which means the smaller the variation of the component relative to the range of the data. Shrinking the size of a range bar along with the corresponding panel to the same size as the range bar for the data, the smallest range bar, would show the comparison directly.

DATE FORMAT\cr
\code{STL()} makes reasonable attempt to decode a character string date value as the \code{x}-axis variable as read from a text data file such as a \code{csv} file. Some date formats are not available for conversion by default, such as date values that include the name of the month instead of its number. And, in general, there is no guarantee that a date format is not miss-inferred as they can be inherently ambiguous. If the default date conversion is not working, then manually supply the date format following one of the format examples in the following table according to the parameter \code{ts_format}.

\tabular{ll}{
Date \tab Format\cr
"2022-09-01" \tab "\%Y-\%m-\%d"\cr 
"2022/9/1" \tab "\%Y/\%m/\%d"\cr
"2022.09.01" \tab "\%Y.\%m.\%d"\cr
"09/01/2022" \tab "\%m/\%d/\%Y"\cr
"9/1/15" \tab "\%m/\%d/\%y"\cr
"September 1, 2022" "\tab \%B \%d, \%Y"\cr
"Sep 1, 2022" \tab "\%b \%d, \%Y"\cr
"20220901" \tab "\%Y\%m\%d"\cr
}



For emphasis, each range bar is displayed in a pale yellow color. 
}

\value{
An \code{stl()} object and text to the console.

Here is an example of saving the output to an R object with any valid R name, such as \code{s}: \code{s <- STL(Price)}. To see the names of the output objects for that specific analysis, enter \code{names(s)}. To display any of the objects, precede the name with \code{s$}, such as to view the saved frequency distribution with \code{s$out_freq}. Or, only list the name of the output object to get the four output components displayed as a single data frame. View the output at the R console or within a markdown document that displays your results.

\code{x.name}: Name of the date variable on the horizontal axis.
\code{trend}: Value of the \code{trend} component for each x-value.
\code{season}: Value of the \code{season} component for each x-value.
\code{error}: Value of the \code{error} component for each x-value.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{stl}}, \code{\link{tsExtract}}, \code{\link{XY}}
}

\examples{
# read the built-in data set dataStockPrice
d <- Read("StockPrice")
# extract just the data for Apple, the first 473 rows of data
d <- d[1:473,]

# do the time series decomposition
STL(Month, Price)

# enter a time series, here one that comes with Base R
# monthly average air temperatures in Nottingham, UK from 1920 to 1939
# get the time series into the global environment
my.ts <- nottem
STL(my.ts, data=NULL)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ stl }
\keyword{ time series }

\name{simCLT}
\alias{simCLT}

\title{Pedagogical Simulation for the Central Limit Theorem}

\description{
Show the distribution of sample means and relevant summary statistics, such as the 95\% range of variation. Provide a plot of both the specified population and the corresponding distribution of sample means.
}

\usage{
simCLT(ns, n, p1=0, p2=1, seed=NULL,
       dist=c("normal", "uniform", "lognormal", "antinormal"),
       fill="lightsteelblue3", n_display=0, digits_d=3, 
       subtitle=TRUE, pop=TRUE, 
       main=NULL, pdf=FALSE, width=5, height=5, \dots)
}


\arguments{
  \item{ns}{Number of samples, that is, repetitions of the experiment.}
  \item{n}{Size of each sample.}
  \item{p1}{First parameter value for the population distribution, the mean,
        minimum or meanlog for the normal, uniform, and lognormal populations,
        respectively. Must be 0, the minimum, for the anti-normal distribution.}
  \item{p2}{Second parameter value for the population distribution, the standard
        deviation, maximum or sdlog for the normal, uniform and lognormal
        populations, respectively. Is the maximum for the anti-normal,
        usually left at the default value of 1.}
  \item{seed}{Default seed is the R default. Enter a positive integer value
       to obtain a reproducible result, the same result for the same seed.}\cr

  \item{dist}{The general population distribution.}
  \item{fill}{Fill color of the graphs.}
  \item{n_display}{Number of samples for which to display the sample mean
        and data values.}
  \item{digits_d}{Number of decimal digits to display on the output.}
  \item{subtitle}{If \code{TRUE}, then display the specific parameter values
        of the population or sample, depending on the graph.}
  \item{pop}{If \code{TRUE}, then display the graph of the population from
        which the data are sampled.}
  \item{main}{Title of graph.}\cr

  \item{pdf}{Indicator as to if the graphic files should be saved as pdf files
       instead of directed to the standard graphics windows.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}\cr

  \item{\dots}{Other parameter values for R function \code{\link{lm}}
        which provides the core computations.} 
}


\details{
Provide a plot of both the specified population and the corresponding distribution of sample means. Include descriptive statistics including the 95\% range of sampling variation in raw units and standard errors for comparison to the normal distribution.  Also provide a few samples of the data and corresponding means.

Four different populations are provided: normal, uniform, lognormal for a skewed distribution, and what is called the anti-normal, the combining of two side-by-side triangular distributions so that most of the values are in the extremes and fewer values are close to the middle.

For the lognormal distribution, increase the skew by increasing the value of \code{p2}, which is the population standard deviation.

The anti-normal distribution requires the \code{triangle} package. No population mean and standard deviation are provided for the anti-normal distribution, so the 95\% range of sampling variable of the sample mean in terms of standard errors is not provided.  ** Not activated until the triangle package is updated. **

If the two plots, of the population and sample distributions respectively, are written to pdf files, according to \code{pdf=TRUE}, they are named SimPopulation.pdf and SimSample.pdf.  Their names and the directory to which they are written are provided as part the console output.
}


\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\examples{
# plot of the standardized normal 
#  and corresponding sampling distribution with 10000 samples
#  each of size 2
simCLT(ns=1000, n=2)

# plot of the uniform dist from 0 to 4
#  and corresponding sampling distribution with 10000 samples
#  each of size 2
simCLT(ns=1000, n=2, p1=0, p2=4, dist="uniform", bin_width=0.01)

# save the population and sample distributions to pdf files
# simCLT(100, 10, pdf=TRUE)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ central limit theorem }

\name{dataReading}
\docType{data}
\alias{dataReading}
\title{Data: Reading Ability}

\description{Reading ability test score and also verbal aptitude test score, number of absences from school and family income in USD $1000's. Data are simulated.}

\usage{data(dataReading)}

\format{A data table with 100 observations.}

\source{author}
\keyword{datasets}

\name{dataMach4}
\docType{data}
\alias{dataMach4}
\title{Data: Machiavellianism}
\description{Likert data responses to Christie and Geiss's (1970) Mach~IV scale from Hunter, Gerbing and Boster (1982).

All Likert items assessed on a 6-point scale from 0: Strongly Disagree to 5: Strongly Agree. Variable labels, the item content, are included.

To construct composite scale scores, such as the Mach~IV total score, the following items should first be reverse scored: m03, m04, m06, m07, m09, m10, m11, m14, m16, m17, m19.
}

\usage{data(dataMach4)}

\format{A data table with 351 observations.

Gender, 1 column, 0:Male, 1:Female\cr
Mach IV, 20 Likert items: m01, m02, \ldots, m20, see \code{\link{dataMach4_lbl}} for the item content.
}

\source{author}

\references{
Christie, R., & Geis, F. L., (1970).  Studies in Machiavellianism.  New York:  Academic Press.

Hunter, J. E., Gerbing, D. W., and Boster, F. J. (1982). Machiavellian beliefs and personality: The construct invalidity of the Machiavellian dimension. Journal of Personality and Social Psychology, 43, 1293-1305.
}

\examples{
# Read data and variable labels (items)
d <- Read("Mach4")
l <- Read("Mach4_lbl")

# Convert to factors, i.e., categorical with value labels
d <- factors(m01:m20,
            levels=0:5,
            labels=c("Strongly Disagree", "Disagree", "Slightly Disagree",
                     "Slightly Agree", "Agree", "Strongly Agree"))
}

\keyword{datasets}

\name{dataEmployee}
\docType{data}
\alias{dataEmployee}
\title{Data: Employees}

\description{Some human resource data on 37 employees with 6 variables. Variable labels and variable units are included in the data file.}

\usage{data(dataEmployee)}
\format{A data table with 37 observations.

Years,"Years Employed in the Company"\cr
Gender,"Male or Female"\cr
Dept,"Department Employed"\cr
Salary,"Annual Salary (USD)"\cr
JobSat,"JobSat with Work Environment"\cr
Plan,"1=GoodHealth, 2=YellowCross, 3=BestCare"\cr
Pre,"Test score on legal issues before instruction"\cr
Post,"Test score on legal issues after instruction"
}

\source{author}
\keyword{datasets}

\name{rename}
\alias{rename}

\title{Rename One or More Variables in a Data Frame}

\description{
\code{rename} renames a single variable or a vector of variables in a data frame.
}

\usage{
rename(data, from, to)
}

\arguments{
  \item{data}{Data frame that contains the relevant variables.}
  \item{from}{One or more variables to rename.}
  \item{to}{Corresponding list of new variable names.}
}

\details{
Assign the result to the data frame of interest, which can be the same data frame that contains the variables to rename.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{recode}}.
}

\examples{

d <- Read("Mach4", quiet=TRUE)
names(d)

# single name change
d <- rename(d, m03, third)
names(d)

# vector of name changes
d <- rename(d, c(m01, m19), c(first, nineteen))
names(d)

}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ reshape }
\keyword{ wide-form }
\keyword{ long-form }

\name{kurtosis}
\alias{kurtosis}

\title{Kurtosis}

\description{
Kurtosis computed from the from the unbiased estimates of variance and of the fourth moment about the mean.
}

\usage{
kurtosis(x, na.rm=TRUE)
}

\arguments{
  \item{x}{Variable from which to compute kurtosis.}
  \item{na.rm}{A logical value indicating whether NA values should be
       stripped before the computation proceeds.}
}

\details{
Kurtosis as implemented by SAS, Type 2 formula as classified by Joanes and Gill (1998). This version of the formula relies upon the unbiased estimates of variance and of the fourth moment about the mean. A perfect normal distribution would have a kurtosis of 0.
}

\value{
kurtosis.
}

\references{
Joanes, D.N. and Gill, C.A (1998). Comparing measures of sample skewness and kurtosis. The Statistician, 47, 183-189.}


\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\examples{
x <- rnorm(100)
kurtosis(x)
}

% Add one or more standard keywords, kurtosis file 'KEYWORDS' in the
% R documentation directory.
\keyword{kurtosis}

\name{dataLearn}
\docType{data}
\alias{dataLearn}
\title{Data: Distributed vs Massed Practice}

\description{Completely Randomized design, one-factor with two levels (CR-2): One grouping variable that specifies type of learning, distributed or massed practice, and one response variable, Learning.}

\usage{data(dataLearn)}

\format{A data table with 34 observations.}

\source{author}
\keyword{datasets}

\name{dataBodyMeas}
\docType{data}
\alias{dataBodyMeas}
\title{Data: Body Measurements}

\description{Body measurements of 170 women and 170 men who purchased motorcycle clothing.
}

\usage{data(dataBodyMeas)}

\format{A data table with 340 observations and the following 7 variables.

Gender, "M" or "F" (factor)\cr
Weight (integer in pounds)\cr
Height (integer in inches)\cr
Waist (integer in inches)\cr
Hips (integer in inches)\cr
Chest (integer in inches)\cr
Hand (numeric, circumference of hand in inches to nearest quarter of an inch)\cr
Shoe (numeric, size including half sizes)
}

\source{author}
\keyword{datasets}

\name{reshape_wide}
\alias{reshape_wide}

\title{Reshape a Long-Form Data Frame to Wide-Form}

\description{
Takes the variables in a long-form data frame, \code{widen}, \code{response}, and \code{ID}, and transforms to a wide form data frame. All other variables are deleted in the transformed data frame. A simple wrapper for Base R \code{\link{reshape}} with sensible parameter names and sensible defaults, and able to specify a range of variables to transform. Conversion currently limited to converting based on a single grouping variable.
}

\usage{
reshape_wide(data, widen, response, ID, prefix=NULL, sep="_", ...)
}

\arguments{
  \item{data}{Data frame that contains the variables to analyze as a
        wide-form single column.}
  \item{widen}{Name of the (single) grouping variable in the input long-form column to have its individual values listed as columns in the corresponding wide form version.}
  \item{response}{Name of the variable of the response values in the input long-form column that becomes the data values in the wide-form version.}
  \item{ID}{Name of the ID field in the long-form column used to identify each row in the wide-form version.}
  \item{prefix}{If \code{TRUE}, prefix the column names in the wide form
        of each corresponding level of the  
        \code{widen} variable with the name of the \code{response}. Unless
        the values of \code{widen} are numeric, the default is \code{FALSE},
        just using the level names as the column names.}
  \item{sep}{If \code{prefix} is \code{TRUE}, the separator between the
        name of the level and the name of the \code{response} variable, with
        default \code{"_"}.}
  \item{\dots}{Older parameter values to be converted internally.}
}

\details{

Here is the correspondence between the original \code{\link{reshape}} parameter names and the \code{reshape_wide} parameter names.

\tabular{ll}{
reshape \tab reshape_wide\cr
----------- \tab ----------------\cr
\code{v.names} \tab \code{response}\cr
\code{timevar} \tab \code{widen}\cr
\code{idvar} \tab \code{ID}\cr
----------- \tab ----------------\cr
}
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{reshape}}.
}

\examples{
d <- Read("Anova_rb")  # already in wide-form
dl <- reshape_long(d, sup1:sup4)  # convert to long-form

# convert back to wide form 
reshape_wide(dl, widen=Group, response=Response, ID=Person)

# with the name of the response prefixed to the column names
reshape_wide(dl, widen=Group, response=Response, ID=Person,
             prefix=TRUE, sep=".")
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ reshape }
\keyword{ wide-form }
\keyword{ wide-form }

\name{xP}
\alias{xP}

\title{Text Processing: Print Formatted Numbers}

\description{Prints numbers nicely formatted, with optional units. Primarily for internal use in text processing of \code{knitr} output. Not usually referenced by the user.
}

\usage{
xP(x, d_d=NULL, unit=NULL, semi=FALSE)
}


\arguments{
  \item{x}{The variable.}
  \item{d_d}{The digits.}
  \item{unit}{Unit of measurement for the variable.}
  \item{semi}{Add a semicolon before the unit to add some horizontal spacing
        in math mode.}
}


\details{
Input is numeric, output is formatted text. A special unit is \code{"$"}, which is added to the front of the number instead of as a trailing descriptor.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\examples{
xP(12345678.9, d_d=2, unit="$")

xP(12345678.9, d_d=2, unit="lbs")
}

\name{dataAnova_rbf}
\docType{data}
\alias{dataAnova_rbf}
\title{Data for a Randomized Block Factorial ANOVA}

\description{
The data for this randomized blocks factorial is a partitioning of 48 rats into 8 groups of 6 based on an initial assessment of each rat's ability to navigate a maze. That is, some rats in general do better than others. A trial maze served as a sort of a pre-test in which the rats were sorted on the basis of their ability to solve the maze. The first block of 6 rats ran the trial maze the fastest, and the last block the slowest. Within each block the rats were randomly assigned to each of the 6 treatment combinations. Each block of matched rats provides a score on each of the six treatment combinations.

This design is within-subjects because similar rats in terms of maze running ability provide the data for each block of data values. Each rat in this block only experiences one of the 6 cells, but all the rats in a block are evaluated across all 6 combinations of the levels of the two treatment variables.
}

\format{A data table in wide format with 48 rows of data and 4 columns: Difficulty, Dosage, Block, and Time.}

\references{
Gerbing, D. W. (later in 2022). R Data Analysis without Programming, 2nd Edition, Chapter 7, NY: Routledge.

Gerbing, D. W. (2021). Enhancement of the Command-Line Environment for use in the Introductory Statistics Course and Beyond, \emph{Journal of Statistics and Data Science Education}, 29(3), 251-266, https://www.tandfonline.com/doi/abs/10.1080/26939169.2021.1999871.
}

\author{
David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})
}

\examples{
d <- Read("Anova_rbf")
fit <- aov(Time ~ (Dosage*Difficulty) + Error(Block), data=d)
summary(fit)
}

\source{author}
\keyword{datasets}

\name{corCFA}
\alias{corCFA}
\alias{cfa}
\alias{scales}

\title{Confirmatory Factor Analysis of a Multiple Indicator Measurement Model}

\description{
Abbreviation: \code{cfa}

A multiple indicator measurement model partitions a set of indicators, such as items on a survey, into mutually exclusive groups with one common factor per group of indicators. From the input correlation matrix of the indicator variables, this procedure uses iterated centroid estimation to estimate the coefficients of the model, the factor pattern and factor-factor correlations, as well as the correlations of each factor with each indicator. The analysis is an adaptation and extension of John Hunter's program PACKAGE (Hunter and Cohen, 1969).

Corresponding scale reliabilities are provided, as well as the residuals, the difference between the indicator correlations and those predicted by the model.  To visualize the relationships, a heat map of the re-ordered correlation matrix is also provided, with indicator communalities in the diagonal. To understand the meaning of each factor, the corresponding indicator content is displayed for each factor if the indicators have been read as variable labels. Also provides the code to obtain the maximum likelihood solution of the corresponding multiple indicator measurement model (MIMM) with the \code{cfa} function from the \code{lavaan} package.

The \code{scales} is a wrapper that retains 1's in the diagonal of the indicator correlation matrix, so provides scale reliabilities and observed indicator-scale and scale-scale correlations.

Output is generated into distinct pieces by topic, organized and displayed in sequence by default. When the output is assigned to an object, such as \code{f} in \code{f <- cfa(Fac =~ X1 + X2 + X3)}, the full or partial output can be accessed for later analysis and/or viewing. A primary such analysis is with \code{knitr} for dynamic report generation, run from, for example, \code{RStudio}. The input instructions written to the R~Markdown file are written comments and interpretation with embedded \code{R} code. Doing a \code{knitr} analysis is to "knit" these comments and subsequent output together so that the \code{R} output is embedded in the resulting document, either html, pdf or Word, by default with explanation and interpretation. Generate a complete R~Markdown set of instructions ready to knit from the \code{Rmd} option. Simply specify the option and create the file and then open in \code{RStudio} and click the \code{knit} button to create a formatted document that consists of the statistical results and interpretative comments. See the following sections \code{arguments}, \code{value} and \code{examples} for more information. 
}

\usage{
corCFA(mimm=NULL, R=mycor, data=d, fac.names=NULL, 

         Rmd=NULL, explain=getOption("explain"),
         results=getOption("results"),

         labels=c("include", "exclude", "only"),

         min_cor=.10, min_res=.05, iter=50, grid=TRUE, 

         resid=TRUE, item_cor=TRUE, sort=TRUE,

         main=NULL, heat_map=TRUE, bottom=NULL, right=NULL, 

         pdf_file=NULL, width=5, height=5,

         F1=NULL, F2=NULL, F3=NULL, F4=NULL, F5=NULL,
         F6=NULL, F7=NULL, F8=NULL, F9=NULL, F10=NULL,
         F11=NULL, F12=NULL, F13=NULL, F14=NULL, F15=NULL,
         F16=NULL, F17=NULL, F18=NULL, F19=NULL, F20=NULL,

         fun_call=NULL, \dots)

cfa(\dots)

scales(\dots, iter=0, resid=FALSE, item_cor=FALSE, sort=FALSE, heat_map=FALSE)
}

\arguments{
  \item{mimm}{Multiple indicator measurement model, a character string with the
        specification of each factor on a separate line: the factor
        name, an equals sign, and the indicators separated by plus signs. 
        Each indicator is assigned to only one factor.}
  \item{R}{Correlation matrix to be analyzed.}
  \item{data}{Data frame of the original data to be checked for any
       variable labels, usually indicator (item) content. This is not to
       calculate correlations, which is separately provided for by the
       \code{lessR} function \code{\link{Correlation}}.}
  \item{fac.names}{Optional factor names for the original, non-lavaan
        model specification.}
  \item{Rmd}{File name for the file of R Markdown instructions to be written,
        if specified. The file type is .Rmd, which automatically opens in
        RStudio, but it is a simple text file that can be edited with any text
        editor, including RStudio.}
  \item{explain}{If set to \code{FALSE} the explanations of the results are not
        provided in the R~Markdown file. Set globally with options(explain=FALSE).}
  \item{results}{If set to \code{FALSE} the results
        are not provided in the R~Markdown file.
        Set globally with options(results=FALSE).}
  \item{labels}{If "include" or "exclude" then variable labels are displayed
       (if available) or not, organized by the items within each factor.
       If "only" then no data analysis performed, only the display of the
       labels by factor.}
  \item{min_cor}{Minimum correlation to display. To display all, set to 0.}
  \item{min_res}{Minimum residual to display. To display all, set to 0.}
  \item{iter}{Number of iterations for communality estimates.}
  \item{grid}{If \code{TRUE}, then separate items in different factors
        by a grid of horizontal and vertical lines in the output 
        correlation matrix.}
  \item{resid}{If \code{TRUE}, then calculate and print the residuals.}
  \item{item_cor}{If \code{TRUE}, display the indicator correlations.}
  \item{sort}{If \code{TRUE}, re-order the output correlation matrix so that
        indicators within each factor are sorted by their factor loadings on
        their own factor.}
  \item{main}{Graph title of heat map. Set to \code{main=""} to turn off.}
  \item{heat_map}{If \code{TRUE}, display a heat map of the indicator
        correlations with indicator communalities in the diagonal.}
  \item{bottom}{Number of lines of bottom margin of heat map.}
  \item{right}{Number of lines of right margin of heat map.}
  \item{pdf_file}{Name of the pdf file to which graphics are redirected.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{F1}{Variables that define Factor 1.}
  \item{F2}{Variables that define Factor 2.}
  \item{F3}{Variables that define Factor 3.}
  \item{F4}{Variables that define Factor 4.}
  \item{F5}{Variables that define Factor 5.}
  \item{F6}{Variables that define Factor 6.}
  \item{F7}{Variables that define Factor 7.}
  \item{F8}{Variables that define Factor 8.}
  \item{F9}{Variables that define Factor 9.}
  \item{F10}{Variables that define Factor 10.}
  \item{F11}{Variables that define Factor 11.}
  \item{F12}{Variables that define Factor 12.}
  \item{F13}{Variables that define Factor 13.}
  \item{F14}{Variables that define Factor 14.}
  \item{F15}{Variables that define Factor 15.}
  \item{F16}{Variables that define Factor 16.}
  \item{F17}{Variables that define Factor 17.}
  \item{F18}{Variables that define Factor 18.}
  \item{F19}{Variables that define Factor 19.}
  \item{F20}{Variables that define Factor 20.}
  \item{fun_call}{Function call. Used internally with \code{knitr} to pass the 
        function call when obtained from the abbreviated function call \code{cfa}.
        Not usually invoked by the user.}
  \item{\dots}{Parameter values_}
}

\details{
OVERVIEW\cr
A multiple indicator measurement model defines one or more latent variables, called factors, in terms of mutually exclusive sets of indicator variables, such as items from a questionnaire or survey.  That is, each factor is defined by a unique set or group of indicators, and each indicator only contributes to the definition of one factor. Two sets of parameters are estimated by the model, the factor pattern coefficients, the lambda's, and the factor-factor correlations, the phi's. Also estimated here are the correlations of each indicator with the other factors. 

INPUT\cr
Unless \code{labels="only"}, the analysis requires the correlation matrix of the indicators and the specification of the groups of indicators, each of which defines a factor in the multiple indicator measurement model.  The default name for the indicator correlation matrix is \code{mycor}, which is also the default name of the matrix produced by the \code{lessR} function \code{\link{Correlation}} that computes the correlations from the data, as well as the name of the matrix read by the \code{lessR} function \code{\link{corRead}} that reads the already computed correlation matrix from an external file.

For versions of \code{lessR} including and after 4.4.3, the correlation matrix computed by \code{\link{Correlation}} is now the object returned if \code{show} is equal to \code{"cor"}, the default, or a missing data analysis if equal to \code{"missing"}.

The data frame from which the correlation matrix was computed is required only if any associated variable labels are listed, organized by the items within each factor. By default, \code{labels="include"}, these labels are listed as part of the analysis if they are available.

Define the constituent variables, the indicators, of each factor with a listing of each variable by its name in the correlation matrix. Each of the up to 20 factors is named by default F1, F2, etc. If the specified variables of a factor are in consecutive order in the input correlation matrix, the list can be specified by listing the first variable, a colon, and then the last variable.  To specify multiple variables, a single variable or a list, separate each by a comma, then invoke the R combine or \code{\link{c}} function, preceded by the factor's name and an equals sign. For example, if the first factor is defined by variables in the input correlation matrix from m02 through m05, and the variable Anxiety, then define the factor in the \code{corCFA} function call according to \code{F1=c(m02:m05,Anxiety)}. 

OUTPUT\cr
The result of the analysis is the correlation matrix of the indicator variables and resulting factors, plus the reliability analysis of the observed total scores or scale that corresponds to each factor.  Each scale is defined as an unweighted composite. The corresponding code to analyze the model with the \code{cfa} function from the \code{lavaan} package is also provided with the default maximum likelihood estimation procedure. The comparable \code{lavaan} solution appears in the column that represents the fully standardized solution, factors and indicators, \code{Std.all}, the last column of the solution output. If the \code{lavaan} library is loaded, then explicitly refer to the \code{lessR} function \code{cfa} with \code{lessR::cfa} and the corresponding \code{lavaan} function with \code{lavaan::cfa}.  

VARIABLE LABELS\cr
To display the indicator content, first read the indicators as variable labels with the \code{lessR} function \code{\link{Read}}.  If this labels data frame exists, then the corresponding variable labels, such as the actual items on a survey, are listed by factor. For more information, see \code{\link{Read}}.

HEAT MAP\cr
To help visualize the overall pattering of the correlations, the corresponding heat map of the item correlation matrix with communalities is produced when \code{heat_map=TRUE}, the default. As is true of the output correlation matrix, the correlations illustrated in the heat map are also sorted by their ordering within each factor. The corresponding color scheme is dictated by the system setting, according to the \code{lessR} function \code{\link{style}}.  The default color scheme is \code{blue}.

ESTIMATION PROCEDURE\cr
The estimation procedure is centroid factor analysis, which defines each factor, parallel to the definition of each scale score, as the unweighted composite of the corresponding items for that scale.  The latent variables are obtained by replacing the 1's in the diagonal of the indicator variable correlation matrix with communality estimates.  These estimates are obtained by iterating the solution to the specified number of iterations according to \code{iter}, which defaults to 50.

A communality is the percentage of the item's correlation attributable to, in this situation of a multiple indicator measurement model, its one underlying factor.  As such, the communality is comparable to the item correlations for items within the same factor, which are also due only to the influence of the one common, underlying factor. A value of 0 for \code{iter} implies that the 1's remain in the observed variable correlation matrix, which then means that there are no latent factors defined.  Instead the resulting correlation matrix is of the observed scale scores and the component items.
}

\value{

TEXT OUTPUT\cr
\code{out_labels}: variables in the model\cr
\code{out_reliability}: reliability analysis with alpha and omega\cr
\code{out_indicators}: solution in terms of the analysis of each indicator\cr
\code{out_solution}: full solution\cr
\code{out_residuals}: residuals\cr
\code{out_res_stats}: stats for residuals\cr
\code{out_lavaan}: lavaan model specification\cr

Separated from the rest of the text output are the major headings, which can then be deleted from custom collations of the output.
\code{out_title_scales}: scales\cr
\code{out_title_rel}: reliability analysis\cr
\code{out_title_solution}: solution\cr
\code{out_title_residuals}: residual analysis\cr
\code{out_title_lavaan}: lavaan specification\cr

STATISTICS\cr
Returns a list of six components.\cr
1. \code{ff.cor}: matrix of the factor correlations\cr
2. \code{if.cor}: matrix of the indicator-factor correlations that includes the estimated pattern coefficients of the model that link a factor to its indicators\cr
3. \code{diag.cor}: the indicator communalities\cr
4. \code{alpha}: coefficient alpha for each set of indicators\cr
5. \code{omega}: if a factor analysis with communality estimates (\code{iter} > 0), contains coefficient omega for each set of indicators\cr
6. \code{pred}: matrix of correlations predicted by the model and its estimates 
7. \code{resid}: matrix of raw indicator residuals defined as the observed correlation minus that predicted by the model and its estimates 
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\references{
Gerbing, D. W. (2014). R Data Analysis without Programming, Chapter 11, NY: Routledge.

Gerbing, D. W., & Hamilton, J. G. (1994). The surprising viability of a simple alternate estimation procedure for the construction of large-scale structural equation measurement models. Structural Equation Modeling: A Multidisciplinary Journal, 1, 103-115.

Hunter, J. E., Gerbing, D. W., & Boster, F. J. (1982). Machiavellian beliefs and personality: The construct invalidity of the Machiavellian dimension. Journal of Personality and Social Psychology, 43, 1293-1305.

Hunter, J. & Cohen, J. (1969). PACKAGE: A system of computer routines for the analysis of correlational data. Educational and Psychological Measurement, 1969, 29, 697-700.

Yves Rosseel (2012). lavaan: An R Package for Structural Equation
Modeling. Journal of Statistical Software, 48(2), 1-36. URL
http://www.jstatsoft.org/v48/i02/.
}

\seealso{
\code{\link{Correlation}}.
}

\examples{
# perfect input correlation matrix for two-factor model
# Population Factor Pattern of the 3 items for each respective
#   Factor: 0.8, 0.6, 0.4
# Population Factor-Factor correlation: 0.3
mycor <- matrix(nrow=6, ncol=6, byrow=TRUE,
c(1.000,0.480,0.320,0.192,0.144,0.096,
  0.480,1.000,0.240,0.144,0.108,0.072,
  0.320,0.240,1.000,0.096,0.072,0.048,
  0.192,0.144,0.096,1.000,0.480,0.320,
  0.144,0.108,0.072,0.480,1.000,0.240,
  0.096,0.072,0.048,0.320,0.240,1.000))
colnames(mycor) <- c("X1", "X2", "X3", "X4", "X5", "X6")
rownames(mycor) <- colnames(mycor)

# the confirmatory factor analysis
# first three variables with first factor, last three with second
# default correlation matrix is mycor
MeasModel <- 
" 
   First =~ X1 + X2 + X3 
   Second =~ X4 + X5 + X6
"
c <- cfa(MeasModel)

# access the solution directly by saving to an object called fit
cfa(MeasModel)
fit <- cfa(MeasModel)
fit
# get the pattern coefficients from the communalities
lambda <- sqrt(fit$diag.cor)
lambda

# alternative specification described in Gerbing(2014),
#   retained to be consistent with that description
# can specify the items with a colon and with commas
# abbreviated form of function name: cfa
cfa(F1=c(X4,X5,X6), F2=X1:X3)

# component analysis, show observed scale correlations
scales(F1=X1:X3, F2=X4:X6)

# produce a gray scale heat map of the item correlations
#   with communalities in the diagonal
# all subsequent graphics are in gray scale until changed
style("gray")
corCFA(F1=X1:X3, F2=X4:X6)

# access the lessR data set called datMach4
# read the optional variable labels
d <- Read("Mach4", quiet=TRUE)
l <- Read("Mach4_lbl", var_labels=TRUE)
# calculate the correlations and store in mycor
mycor <- cr(m01:m20)
R <- mycor
# specify measurement model in Lavaan notation
MeasModel <- 
" 
   Deceit =~ m07 + m06 + m10 + m09 
   Trust =~ m12 + m05 + m13 + m01 
   Cynicism =~ m11 + m16 + m04 
   Flattery =~ m15 + m02 
"
# confirmatory factor analysis of 4-factor solution of Mach IV scale
# Hunter, Gerbing and Boster (1982)
# generate R Markdown instructions with the option: Rmd
# Output file will be m4.Rmd, a simple text file that can
#   be edited with any text editor including RStudio, from which it
#   can be knit to generate dynamic output such as to a Word document
#c <- cfa(MeasModel, R, Rmd="m4")
# view all the output
#c
# view just the scale reliabilities
#c$out_reliability

# analysis of item content only
cfa(MeasModel, labels="only")


# bad fitting model to illustrate indicator diagnostics
mycor <- corReflect(vars=c(m20))
MeasModel <- 
" 
   F1 =~ m06 + m09 + m19
   F2 =~ m07
   F3 =~ m04 + m11 + m16 
   F4 =~ m15 + m12 + m20 + m18 
"
cfa(MeasModel)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ correlation }
\keyword{ factor analysis }

\name{showColors}
\alias{showColors}

\title{Display All Named R Colors and Corresponding rgb Values}

\description{
For each specified color, displays the color, the name and the associated \code{rgb} definition.
}

\usage{
showColors(file="colors.pdf", color=NULL)
}


\arguments{
  \item{file}{Name of pdf file that contains the list of colors with a default of \code{colors.pdf}.}
  \item{color}{NULL for all colors, otherwise specify a color and all colors which include that color as part of their name are displayed.}
}


\details{
Every color name is defined in terms of a red, a green and a blue component. This function lists the \code{rgb} definitions for the specified colors, as well as the name and a display of each color_ The output should be routed to an external pdf file for storage. The directory and file name of the output file are displayed.}


\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\examples{
# all colors
#showColors()

# all colors with 'blue' in their name
#showColors(file="theblues.pdf", color="blue")
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ color }

\name{Read}
\alias{Read}
\alias{rd}
\alias{rd_lbl}
\alias{Read2}

\title{Read Contents of a Data File with Optional Variable Labels and Feedback}

\description{
Abbreviation: \code{rd}, \code{rd_lbl}, \code{Read2}

Reads the contents of the specified data file into an R data table, what R calls a data frame.  By default the format of the file is detected from its filetype: comma or tab separated value text file from \code{.csv}, SPSS data file from \code{.sav}, SAS data from \code{.sas7bdat}, or R data file from \code{.rda}, and Excel file from \code{.xls}, \code{.xlsx} using Alexander Walker's \code{openxlsx} package, or \code{.ods} using Gerrit-Jan Schutten and Chung-hong Chan plus other contributors' \code{readODS} package. Specify a fixed width formatted text data file to be read with the required R \code{widths} option. Identify the data file by either browsing for the file on the local computer system with \code{Read()}, or identify the file with the first argument a character string in the form of a path name or a web URL (except for .Rda files which must be on the local computer system).

Any variable labels in a native SPSS data file are automatically included in the data file. See the \code{details} section below for more information. Variable labels can also be added and modified individually with the \code{lessR} function \code{\link{label}}, and more comprehensively with the \code{\link{VariableLabels}} function.

The function provides feedback regarding the data that is read by invoking the \code{lessR} function \code{\link{details}}. The brief form of this function, invoked by default, only lists the input files, the variable name table, and any variable labels.

The \code{lessR} function \code{\link{corRead}} reads a correlation matrix.
}

\usage{
Read(from=NULL, format=NULL, var_labels=FALSE, widths=NULL,

         missing=NULL, n_mcut=1,
         miss_show=30, miss_zero=FALSE, miss_matrix=FALSE, 
      
         max_lines=30, sheet=1, row_names=NULL, header=TRUE,

         brief=TRUE, quiet=getOption("quiet"),

         fun_call=NULL, \dots)

rd(\dots) 
rd_lbl(\dots, var_labels=TRUE)
Read2(\dots, sep=";", dec=",")
}


\arguments{
  \item{from}{File reference included in quotes, either empty to browse 
       for the data file, a full path name or web URL, or the name of a
       data file included with lessR, such as \code{"Employee"}. 
       A URL begins with \code{http://} or \code{https://}.}
  \item{format}{Format of the data in the file, not usually specified because set
        by default according to the
        file type of the file to read: \code{.csv}, \code{.tsv} or \code{.txt}
        read as a text file, \code{.xls}, \code{.xlsx} read as an Excel file, or
        \code{.ods} as an OpenDocument Spreadsheet file.
        \code{.feather} and \code{.parquet} for the \code{arrow} formats for
          feather and parquet data files.
        \code{.sav} reads as an SPSS file, which also reads the variable labels
        if present, \code{.sas7bdat} reads as a SAS file, and \code{.rda} reads as a
        native R data file. If the data file is not identified by one of these
        file types, then explicitly set by setting to one of the following values:
        \code{"csv"}, \code{"tsv"}, \code{"Excel"}, \code{"feather"}, 
        \code{"parquet"}, \code{"R"}, \code{"SPSS"},
        or \code{"SAS"}.}
  \item{var_labels}{Set \code{TRUE} if reading a csv or Excel file of 
       variable labels into the data frame \code{l} in which each
       row consists of a variable name in the first
       column and the corresponding variable label in the second column, and perhaps
       units in the third column if using \code{\link{Regression}} function to
       generate automatic markdown files of discursive text.}
  \item{widths}{Specifies the width of the successive columns for fixed width
       formatted data.}\cr

  \item{missing}{Missing value code, which by default specifies one or more
        missing data values in the data table. Can combine numerical
        and character codes, such as \code{missing=c(-99, "xxxx")}.}
  \item{n_mcut}{For the missing value analysis, list the row name and number of
        missing values if the number of missing exceeds or equals this cutoff.
        Requires \code{brief=FALSE}.}
  \item{miss_show}{For the missing value analysis, the number of rows, one row per
        observation, that has as many or more missing values as \code{n_mcut}. 
        Requires \code{brief=FALSE}.}
  \item{miss_zero}{For the missing value analysis, list a row even for a value
        of 0, that is, with no missing data. By default only rows with missing
        data are listed. Requires \code{brief=FALSE}.}
  \item{miss_matrix}{For the missing value analysis, if there is any missing data, 
        list a version of the complete data table with a 0 for a non-missing value
        and a 1 for a missing value.}\cr

  \item{sep}{Character that separates adjacent values in a text file of data.}
  \item{dec}{Character that serves as the decimal separator in a number.}
  \item{max_lines}{Maximum number of lines to list of the data and labels.}
  \item{sheet}{For Excel files, specifies the work sheet to read. Provide either
       the worksheet number according to its position, or its name enclosed in
       quotes. The default is the first work sheet.}
  \item{row_names}{\code{FALSE} by default so no row names from the input data.
       Set to \code{TRUE} to convert the first column of input data to row names.
       For reading \code{.csv} files, can also set to the integer number of the
       column to convert to row names. For Excel and ODS files, the only acceptable
       value is 1 for the first column.}
  \item{header}{If \code{TRUE}, the default, then the first row of the data table
        contains the variable names.}
  \item{brief}{If \code{TRUE}, display only variable names table plus any variable
       labels.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change the corresponding
       system default with \code{\link{style}} function.}
  \item{fun_call}{Function call. Used with \code{Rmd} to pass the function call when
        obtained from the abbreviated function call \code{rd}.}
  \item{\dots}{Other parameter values defined with the R read functions, such as the
       \code{read.table} function for text files, with row.names and header.}
}


\details{
The following table lists various file formats along with the associated R packages and functions for reading them.

\tabular{llll}{
  \strong{Extension}  \tab \strong{Format} \tab \strong{Package} \tab \strong{Function} \cr
  .csv      \tab Text, comma-separated values \tab utils     \tab \code{read.csv()} \cr
  .tsv      \tab Text, tab-separated values   \tab utils     \tab \code{read.delim()} \cr
  .prn      \tab Text, space-separated values \tab utils     \tab \code{read.table()} \cr
  .txt      \tab Text, comma or tab-separated \tab utils     \tab \code{read.table()} \cr
  .xls      \tab Excel                        \tab openxlsx  \tab \code{read.xlsx()} \cr
  .xlsx     \tab Excel                        \tab openxlsx  \tab \code{read.xlsx()} \cr
  .ods      \tab ODS                          \tab readODS   \tab \code{read_ods()} \cr
  .feather  \tab Feather                      \tab arrow     \tab \code{read_feather()} \cr
  .parquet  \tab Parquet                      \tab arrow     \tab \code{read_parquet()} \cr
  .rda      \tab R data                       \tab base      \tab \code{load()} \cr
  .sav      \tab SPSS                         \tab haven     \tab \code{read_sav()} \cr
  .zsav     \tab SPSS (compressed)            \tab haven     \tab \code{read_zsav()} \cr
  .dta      \tab Stata                        \tab haven     \tab \code{read_dta()} \cr
  .sas7bdat \tab SAS                          \tab haven     \tab \code{read_sas()} \cr
}

CREATE csv FILE\cr
One way to create a csv data file is to enter the data into a text editor. A more structured method is to use a worksheet application such as MS Excel, LibreOffice Calc, or Apple Numbers. Place the variable names in the first row of the worksheet. Each column of the worksheet contains the data for the corresponding variable. Each subsequent row contains the data for a specific observation, such as for a person or a company.

Call \code{?read.table} to view the other R options that can also be implemented from \code{Read}.

MECHANICS\cr
Specify the file as with the \code{\link{Read}} function for reading the data into a data frame. If no arguments are passed to the function, then interactively browse for the file.

Given a csv data file, or tab-delimited text file, read the data into an R data frame called \code{d} with \code{\link{Read}}. Because \code{\link{Read}} calls the standard R function \code{read.csv}, which serves as a wrapper for \code{read.table}, the usual options that work with \code{read.table}, such as \code{row.names}, also can be passed through the call to \code{Read}. 

SPSS DATA\cr
Relies upon \code{read_spss} from the \code{haven} package to read data in the SPSS \code{.sav} or \code{.zsav} format. If the file has a file type of \code{.sav}, that is, the file specification ends in \code{.sav}, then the \code{format} is automatically set to \code{"SPSS"}. To invoke this option for a relevant data file of any file type, explicitly specify \code{format="SPSS"}. Each (usually) integer variable with value labels is converted into two R variables: the original numeric code with the original variable name, and also the corresponding factor with the variable labels named with the original name plus the suffix \code{_f}. The variable labels are also displayed for copying into a variable label file. See the SPSS section from \code{vignette("Read")}. 

R DATA\cr
Relies upon the standard R function \code{load}. By convention only, data files in native R format have a file type of \code{.rda}. To read a native R data file, if the file type is \code{.rda}, the \code{format} is automatically set to \code{"R"}. To invoke this option for a relevant data file of any file type, explicitly specify \code{format="R"}. Create a native R data file by saving the current data frame, usually \code{d}, with the \code{lessR} function \code{\link{Write}}.

Excel DATA\cr
Relies upon the function \code{read.xlsx} from Alexander Walker's \code{openxlsx} package. Files with a file type of \code{.xlsx} are assigned a \code{format} of \code{"Excel"}. The \code{read.xlsx} parameter \code{sheet} specifies the ordinal position of the worksheet in the Excel file, with a default value of 1. The \code{row.names} parameter can only have a value of 1. Dates stored in Excel as an Excel date type are automatically read as an R Date type. See the help file for \code{read.xlsx} for additional parameters, such as \code{sheet} for the name or number of the worksheet to read and \code{startRow} for the row number for which to start reading data.

lessR DATA\cr
\code{lessR} has some data sets included with the package: "BodyMeas", "Cars93", "Employee", "Jackets", "Learn", "Mach4", "Reading", and "StockPrice". \code{Read} reads each such data set by specifying its name, such as \code{Read("Employee")}. No specification of \code{format} and no provided filetype, just enter the name of the data set. 

FIXED WIDTH FORMATTED DATA\cr
Relies upon \code{read.fwf}. Applies to data files in which the width of the column of data values of a variable is the same for each data value and there is no delimiter to separate adjacent data values. An example is a data file of Likert scale responses from 1 to 5 on a 50 item survey such that the data consist of 50 columns with no spaces or other delimiter to separate adjacent data values. To read this data set, invoke the \code{widths} option of \code{read.fwf}.

MISSING DATA\cr
By default, \code{Read} provides a list of each variable and each row with the display of the number of associated missing values, indicated by the standard R missing value code NA. When reading the data, \code{Read} automatically sets any empty values as missing. Note that this is different from the R default in \code{read.table} in which an empty value for character string variables are treated as a regular data value. Any other valid value for any data type can be set to missing as well with the \code{missing} option. To mimic the standard R default for missing character values, set \code{missing=NA}. 

By default, the missing data analysis lists only the rows that have missing data, which can appreciably reduce the amount of output for large data sets. To list every row, including those with no missing data, invoke the \code{miss_zero=TRUE} option. To view the entire data table in terms of 0's and 1's for non-missing and missing data, respectively, invoke the \code{miss_matrix=TRUE} option.

VARIABLE LABELS\cr
Unlike standard R, \code{lessR} provides for variable labels, which can be provided for some or all of the variables in a data frame. Store the variable labels in a separate data frame \code{l}. The variable labels file that is read by \code{Read} consists of one row for each variable for which a variable label is provided. Each row consists of either two columns, the variable name in the first column and the associated variable label in the second column, or three columns with the third column the variable units. Use the units in conjunction for enhanced readability with the automatic markdown generated by the \code{Rmd} parameter for the \code{\link{Regression}} function. The format of the file can be \code{csv} or \code{xlsx}. The data frame \code{Read} constructs from this input consists of one variable, called \code{label}, with the variable names as row names. 

The \code{lessR} legacy approach is to store the variable labels directly with the data in the same data frame. The problem with this approach is that any transformations of the data with any function other than \code{lessR} transformation functions remove the variable labels. The option for reading the variable labels with the \code{labels} option of \code{Read} statement is retained for compatibility.

Reading the data from an SPSS file, however, retains the SPSS variable labels as part of the data file. The \code{lessR} data analysis functions will properly process these variable labels, but any non-\code{lessR} data transformations will remove the labels from the data frame. To retain the labels, copy them to the \code{l} data frame with the \code{\link{VariableLabels}} function with the name of the data frame as the sole argument.

The \code{lessR} functions that provide analysis, such as \code{\link{X}} for a histogram, automatically include the variable labels in their output, such as the title of a graph. Standard R functions can also use these variable labels by invoking the \code{lessR} function \code{\link{label}}, such as setting \code{main=label(I4)} to put the variable label for a variable named I4 in the title of a graph.
}

\value{
The read data frame is returned, usually assigned the name of \code{d} as in the examples below. This is the default name for the data frame input into the \code{lessR} data analysis functions.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\references{
Gerbing, D. W. (2020). R Visualizations: Derive Meaning from Data, Chapter 1, NY: CRC Press.

Alexander Walker (2018). openxlsx: Read, Write and Edit XLSX Files. R package version 4.1.0. https://CRAN.R-project.org/package=openxlsx
}


\seealso{
\code{\link{read.csv}},
\code{\link{read.fwf}}, \code{\link{corRead}}, \code{\link{label}},
 \code{\link{details}}, \code{\link{VariableLabels}}.
}

\examples{
# remove the # sign before each of the following Read statements to run

# to browse for a data file on the computer system, invoke Read with 
#   the from argument empty
# d <- Read()
# abbreviated name
# d <- rd()

# read the variable labels from
#  the specified label file, here a Excel file with two columns,
#  the first column of variable names and the second column the 
#  corresponding labels
# l <- Read("Employee_lbl", var_labels=TRUE)

# read a csv data file from the web
# d <- Read("http://web.pdx.edu/~gerbing/data/twogroup.csv")

# read a csv data file with -99 and XXX set to missing
# d <- Read(missing=c(-99, "XXX"))

# do not display any output
# d <- Read(quiet=TRUE)
# display full output
# d <- Read(brief=FALSE)

# read the built-in data set dataEmployee
d <- Read("Employee")

# read a data file organized by columns, with a 
#   5 column ID field, 2 column Age field
#   and 75 single columns of data, no spaces between columns
#   name the variables with lessR function: to
#   the variable names are Q01, Q02, ..., Q74, Q75
# d <- Read(widths=c(5,2,rep(1,75)), col.names=c("ID", "Age", to("Q", 75)))
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ read }
\keyword{ csv }

\name{prob_norm}
\alias{prob_norm}

\title{Compute and Plot Normal Curve Probabilities over an Interval}

\description{
Calculate the probability of an interval for a normal distribution with specified mean and standard deviation, providing both the numerical probability and a plot of the interval with the corresponding normal curve.
}

\usage{
prob_norm(lo=NULL, hi=NULL, mu=0, sigma=1, nrm_color="black", 
         fill_nrm="grey91", fill_int="slategray3", 
         ylab="", y_axis=FALSE, z=TRUE, axis_size=.9,
         pdf_file=NULL, width=5, height=5, \dots)
}


\arguments{
  \item{lo}{Lowest value in the interval for which to compute probability.}
  \item{hi}{Highest value in the interval for which to compute probability.}
  \item{mu}{Population mean of normal distribution.}
  \item{sigma}{Population standard deviation of normal distribution.}
  \item{nrm_color}{Color of the border of the normal curve.}
  \item{fill_nrm}{Fill color of the normal curve.}
  \item{fill_int}{Fill color of the interval for which the probability is computed.}
  \item{ylab}{Label for the optional vertical axis_}
  \item{y_axis}{If \code{TRUE}, then a vertical axis is included.}
  \item{z}{If \code{TRUE}, then include z-values on the horizontal-axis_ Set to 
       \code{FALSE} if \code{mu=0} and \code{sigma=1}.}
  \item{axis_size}{Magnification factor for the axis labels, the value of
       \code{axis_cex}.}
  \item{pdf_file}{Name of the pdf file to which graphics are redirected.}
  \item{width}{Width of the pdf file in inches.}
  \item{height}{Height of the pdf file in inches.}
  \item{\dots}{Other parameter values for graphics.}
}

\details{
Calculate the normal curve probability for the specified interval and normal curve. If there is no upper value of the interval provided, \code{hi}, then the upper tail probability is provided, that is, from the specified value until positive infinity.  If there is no lower value, \code{lo}, then the lower tail probability is provided.  The probability is calculated with \code{\link{pnorm}}.
}


\value{
\code{prob}: Calculated probability.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}


\seealso{
\code{\link{pnorm}}, \code{\link{plot}}.
}


\examples{
# Mu=0, Sigma=1: Standard normal prob, values between 0 and 2
prob_norm(0,2)

# Mu=0, Sigma=1: Standard normal prob, values lower than 2
prob_norm(hi=2)

# Mu=0, Sigma=1: Standard normal prob, values larger than 2
prob_norm(lo=2)

# Mu=100, Sigma=15: Change default fill color of plotted interval
prob_norm(lo=115, hi=125, mu=100, sigma=15, fill_int="plum")
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ probability }

\name{see}
\alias{see}

\title{View the Upper and Left Corners of a Data Frame}

\description{
Useful for large data frame. View the top-left corner of the specified data frame and the bottom-right corner of the data frame.
}

\usage{
see(data, n_row=min(nrow(data), 5), n_col=min(ncol(data), 8))
}

\arguments{
  \item{data}{Name of the data frame to view.}
  \item{n_row}{Number of rows to view.}
  \item{n_col}{Number of columns to view.}
}

\details{
For the specified number of rows and columns, just view the subset of the data frame in terms of the top-left and the bottom-right.
}

\value{
The subset data frame.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Extract}}.
}

\examples{
d <- Read("Employee", quiet=TRUE)

# view the default top-left and bottom-right four rows and eight columns
see(d)

# view the top-left two rows and bottom-right four columns
see(d, n_row=2, n_col=2)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{see}

\name{VariableLabels}
\alias{VariableLabels}
\alias{vl}

\title{Create or Display Variable Labels}

\description{
Assign and/or display variable labels stored in the data frame \code{l}. Variable labels enhance output of analyses either as text output at the console or as graphics, such as an axis label on a graph.  The variable labels can be assigned individually, or for some or all variables. 

NOTE: Mostly deprecated. Can just set \code{var_labels=TRUE} on for a call to 
\code{\link{Read}} to read a file of variable labels, and assign the output to \code{l}. Still needed to pull labels out of data frame from an SPSS read, or to read units to generate Rmd files from \code{\link{Regression}} .
}

\usage{
VariableLabels(x, value=NULL, quiet=getOption("quiet"))

vl(\dots)
}


\arguments{
  \item{x}{The file reference or character string variable (see examples)
    from which to obtain the variable labels, or a variable name for which
    to assign or obtain the corresponding variable label in conjunction with
    the \code{value} parameter. Can also be a data frame from which to
    extract any existing variable labels.}
  \item{value}{The variable label assigned to a specific variable,
  otherwise \code{NULL}.}
  \item{quiet}{If set to \code{TRUE}, no text output. Can change system
    default with \code{\link{style}} function.}
  \item{\dots}{Other parameter values.}

}


\details{
Unlike standard R, \code{lessR} provides for variable labels, here stored in the data frame \code{l}. To read the labels from an external file, specify a file reference as the first argument of the function call. Or create a character string of variable names and labels and specify the character string as the first argument to the function call. To assign an individual variable label with this function specify the variable name as the first argument followed by the label in quotes. Not all variables need have a label, and the variables with their corresponding labels can be listed or assigned in any order. If the \code{l} data frame is created or modified, the output of the function must be assigned to \code{l}, as shown in the following examples.

When all or some of the labels are read, either from the console or an external \code{csv} or \code{Excel} file, each line of the file contains the variable name and then the associated variable label. The file types of \code{.csv} and \code{.xlsx} in the file reference listed in the first position of the function call are what trigger the interpretation of the argument as a file reference. 

For a file that contains only labels, each row of the file, including the first row, consists of the variable name, a comma if a \code{csv} file, and then the label. For the \code{csv} form of the file, this is the standard \code{csv} format such as obtained with the \code{csv} option from a standard worksheet application such as Microsoft Excel or LibreOffice Calc. Not all variables in the data frame that contains the data, usually \code{d}, need have a label, and the variables with their corresponding labels can be listed in any order. An example of this file follows for four variables, I1 through I4, and their associated labels.

I2,This instructor presents material in a clear and organized manner.\cr
I4,Overall, this instructor was highly effective in this class.\cr
I1,This instructor has command of the subject.\cr
I3,This instructor relates course materials to real world situations.\cr

If there is a comma in the variable label, then the label needs to be enclosed in quotes.

The \code{lessR} functions that provide analysis, such as \code{\link{Histogram}} for a histogram, automatically include the variable labels in their output, such as the title of a graph.  Standard R functions can also use these variable labels by invoking the \code{lessR} function \code{\link{label}}, such as setting \code{main=label(I4)} to put the variable label for a variable named I4 in the title of a graph.  

Variable units may also be added to the third column of a variable label file. These are used for generating a better natural language text in the generation of R~Markdown files with the \code{Rmd} option on supporting functions such as \code{\link{Regression}}. For currency (USD), indicate with unit: dollar.
a
}

\value{
The data frame with the variable labels is returned. 
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Read}}.
}

\examples{

# read file and then variable labels from csv files
# l <- Read("http://lessRstats.com/data/employee.csv")
# l <- VariableLabels("http://lessRstats.com/data/employee_lbl.csv")

# construct and read variable labels from console
lbl <- "
Years, Years of Company Employment
Gender, Male or Female
Dept, Department Employed
Salary, Annual Salary (USD)
JobSat, JobSat with Work Environment
Plan, 1=GoodHealth 2=YellowCross 3=BestCare
"
l <- VariableLabels(lbl)
l

# add/modify a single variable label
l <- VariableLabels(Salary, "Annual Salaries in USD")
l

# list the contents of a single variable label
VariableLabels(Salary)

# display all variable labels
VariableLabels()

}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ labels }
\keyword{ csv }

\name{train_test}
\alias{train_test}

\title{Create Training and Testing Data}

\description{
Given a data frame, create a list of either two components, \code{train} and \code{test}, or four components, for training and testing data: \code{train_x}, \code{train_y}, \code{test_x}, and \code{test_y}.
}

\usage{
train_test(data, response=NULL, p_train=0.75, seed=NULL, matrix_out=FALSE)
}

\arguments{
  \item{data}{Data frame that contains the variables.}
  \item{response}{Optional name of the response variable of the response values.}
  \item{p_train}{Percentage of the input data frame to be retained for training.}
  \item{seed}{Set to a usually odd value to reproduce results.}
  \item{matrix_out}{If \code{TRUE} then output data structures as matrices
        instead of data frames.}
}

\details{
From the input data frame create training and testing data frames. If the \code{response} is specified, create four component data frames with x and y variables separated. Otherwise create two component data frames, \code{train} and \code{test}.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\examples{
d <- Read("Employee")

# create two component data frames, train and test, which retain all
#   variables for the model in the same data frame
out <- train_test(d)
names(out)
# then can copy to regular data frames apart from the list output structure
d_train <- out$train
d_test <- out$test

# create four component data frames that separate the response variable, y,
#   from predictor variables, X: train_x, train_y, test_x, and test_y
out <- train_test(d, response=Salary)
names(out)
# then can copy to regular data frames apart from the list output structure
X_train <- out$train_x
y_train <- out$train_y
X_test <- out$test_x
y_test <- out$test_y
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ reshape }
\keyword{ wide-form }
\keyword{ long-form }

\name{corPrint}
\alias{corPrint}

\title{Print a Correlation Matrix with Special Formatting}

\description{
Display a correlation matrix in readable, compact form. 
}

\usage{
corPrint(R, min_value=0)
}

\arguments{
  \item{R}{Square, input correlation matrix.}
  \item{min_value}{The minimal value in magnitude of the displayed correlations.}
}

\details{
Drop the \code{0.} characters of each displayed correlation coefficient. For example, display 0.42 as 42. Have an option to only display correlations larger in magnitude than a minimum threshold, so that all correlations between \code{-min_value} and \code{+min_value} display as blank spaces.
}

\value{
The output correlation matrix.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Correlation}}, \code{\link{corReorder}}.
}

\examples{
mycor <- matrix(nrow=6, ncol=6, byrow=TRUE,
c(1.000,0.480,0.320,0.192,0.144,0.096,
  0.480,1.000,0.240,0.144,0.108,0.072,
  0.320,0.240,1.000,0.096,0.072,0.048,
  0.192,0.144,0.096,1.000,0.480,0.320,
  0.144,0.108,0.072,0.480,1.000,0.240,
  0.096,0.072,0.048,0.320,0.240,1.000))
colnames(mycor) <- c("X1", "X2", "X3", "X4", "X5", "X6")
rownames(mycor) <- colnames(mycor)

# display all the correlations
corPrint(mycor)

# only display correlations in magnitude of 0.2 or larger
corPrint(mycor, min_value=.2)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ correlation }

\name{label}
\alias{label}

\title{Assign Variable Labels [Superseded by VariableLabels]}

\description{
Deprecated, replaced by \code{\link{VariableLabels}}. Display a variable label for output, either text output at the console or graphics, such as a title on a graph.  To return a variable label generally applies to standard R functions such that the functions can access \code{lessR} variable labels. Or, the variable name and label can be listed on the standard output. To assign a variable label, invoke the \code{value} option and assign the output to a specified data frame. 
}

\usage{
label(x, value=NULL, data=d)
}


\arguments{
  \item{x}{The variable for which to obtain the corresponding variable label.}
  \item{value}{If assigned, then the specified data frame is updated with this
       assigned label.}
  \item{data}{Data frame that contains the variable of interest. The output
       of the function is assigned to this data frame.}
}


\details{
Standard R does not provide for variable labels, but \code{lessR} does.  Read the labels with the \code{lessR} \code{\link{Read}} function, as explained in the corresponding documentation. Individual variable labels can also be assigned with this function. Not all variables need have a label, and the variables with their corresponding labels can be listed or assigned in any order.

The function provides two different modes. The first mode is to return the variable name and label for an existing variable label. One such use is to provide the function as an argument to an existing R function call to access a \code{lessR} variable label. For example, use the function as the argument for \code{main} in graphics output, where \code{main} is the title of the graph. This mode is triggered by not invoking the \code{value} option.

The second mode is to assign a variable label to an existing variable. Invoke this mode by specifying a variable label with the \code{value} option. The function accesses the entire specified data frame, and then modifies the specified variable label. As such, assign the output of the function to the data frame of interest, such as the default \code{d}. One use of this function is to add a variable label to a data frame that contains a new variable created by a transformation of the existing variables. 
}

\value{
The specified value of \code{value} is returned.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{Read}}.
}

\examples{
# read the data and variable labels
#d <- rd("http://lessRstats.com/data/employee.xlsx")
#l <- vl("http://lessRstats.com/data/employee_lbl.xlsx")

# variable label as the title of a graph for non-lessR functions
# base R
#hist(d$Salary, xlab=label(Salary))
# ggplot2
#ggplot(d, aes(Salary)) + geom_histogram(binwidth=10000) + labs(x=label(Salary))

# assign a new label for the variable Years in d
#d <- label(Years, "Years Worked")
# verify
#label(Years)
# or view all variable labels in d
#db()

#d <- Read("Employee")
# specify a label of variable in a data frame other than d
#myd <- Subset(Gender=="M")
#myd <- label(Gender, "Only is Male", data=myd)
#db(myd)
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ labels }
\keyword{ csv }

\name{xRow}
\alias{xRow}

\title{Text Processing: Add the Word Row to Case Labels that Could be Numeric}

\description{For a vector of row names, if the names can be represented as integers the word Row is added to the beginning of each name in the vector. Primarily for internal use in text processing of \code{knitr} output. Not usually referenced by the user.
}

\usage{
xRow(x)
}

\arguments{
  \item{x}{Vector with names for each value.}
}

\details{
Input is a vector of values, output is vector of associated row labels, perhaps with the added word Row.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\examples{
# The word Row gets added
v <- c(2, 4, 6)
names(v) <- c("1", "2", "3")
xRow(v)

# The word Row does not get added
v <- c(2, 4, 6)
names(v) <- c("Bill", "Tulane", "Hanna")
xRow(v)
}

\name{SummaryStats}
\alias{SummaryStats}
\alias{ss}
\alias{ss_brief}

\title{Summary Statistics for One or Two Variables}

\description{
Abbreviation: \code{ss}

The summary statistics aspect for continuous variables is deprecated. Use \code{\link{pivot}} instead.

Descriptive or summary statistics for a numeric variable or a factor, one at a time or for all numeric and factor variables in the data frame.  For a single variable, there is also an option for summary statistics at each level of a second, usually categorical variable or factor, with a relatively few number of levels.  For a numeric variable, output includes the sample mean, standard deviation, skewness, kurtosis, minimum, 1st quartile, median, third quartile and maximum, as well as the number of non-missing and missing values_ For a categorical variable, the output includes the table of counts for each value of a factor, the total sample size, and the corresponding proportions.  

If the provided object to analyze is a set of multiple variables, including an entire data frame, then each non-numeric variable in the data frame is analyzed and the results written to a pdf file in the current working directory. The name of each output pdf file that contains a bar chart and its path are specified in the output.

When output is assigned into an object, such as \code{s} in \code{s <- ss(Y)}, the pieces of output can be accessed for later analysis. A primary such analysis is \code{knitr} for dynamic report generation in which R output embedded in documents See \code{value} below.
}

\usage{
SummaryStats(x=NULL, by=NULL, data=d, rows=NULL, n_cat=getOption("n_cat"), 
         digits_d=NULL, brief=getOption("brief"), label_max=20, \dots)

ss_brief(\dots, brief=TRUE)

ss(\dots)
}

\arguments{
  \item{x}{Variable(s) to analyze.  Can be a single variable, either
        within a data frame or as a vector in the user's workspace,
        or multiple variables in a data frame such as designated with the
        \code{\link{c}} function, or an entire data frame. If not specified,
        then defaults to all variables in the specified data frame,
        \code{d} by default.}
  \item{by}{Applies to an analysis of a numeric variable, which is then analyzed at
       each level of the \code{by} variable. The variable is coerced to a factor.}
  \item{data}{Optional data frame that contains the variable of interest, default
       is \code{d}.}
  \item{rows}{A logical expression that specifies a subset of rows of the data frame
       to analyze.}
  \item{n_cat}{Specifies the largest number of unique values of variable of a numeric
       data type for which the variable will be analyzed as a categorical. Default is
       off, set to 0.
       \emph{[deprecated]}: Best to convert a categorical integer variable to a factor.}
  \item{digits_d}{Specifies the number of decimal digits to display in the output.}
  \item{brief}{If set to \code{TRUE}, reduced text output. Can change system default
       with \code{\link{style}} function.}
  \item{label_max}{Maximum size of labels for the values of a variable.
        Not a literal maximum as preserving unique values may require a larger number
        of characters than specified.}

  \item{\dots}{Further arguments to be passed to or from methods.}
}

\details{
OVERVIEW\cr
The \code{by} option specifies a categorical variable or factor, with a relatively few number of values called levels. The variable of interest is analyzed at each level of the factor. 

The \code{digits_d} parameter specifies the number of decimal digits in the output.  It must follow the formula specification when used with the formula version. By default the number of decimal digits displayed for the analysis of a variable is one more than the largest number of decimal digits in the data for that variable.

Reported outliers are based on the boxplot criterion.  The determination of an outlier is based on the length of the box, which corresponds, but may not equal exactly, the interquartile range.  A value is reported as an outlier if it is more than 1.5 box lengths away from the box.

Skewness is computed with the usual adjusted Fisher-Pearson standardized moment skewness coefficient, the version found in many commercial packages.

The \code{lessR} function \code{\link{Read}} reads the data from an external csv file into the data frame called \code{d}.  To describe all of the variables in a data frame, invoke \code{SummaryStats(d)}, or just \code{SummaryStats()}, which then defaults to the former.

In the analysis of a categorical variable, if there are more than 10 levels then an abbreviated analysis is performed, only reporting the values and the associated frequencies. If all the values are unique, then the user is prompted with a note that perhaps this is actually an ID field which should be specified using the \code{row.names} option when reading the data.


DATA\cr
If the variable is in a data frame, the input data frame has the assumed name of \code{d}.  If this data frame is named something different, then specify the name with the \code{data} option.  Regardless of its name, the data frame need not be attached to reference the variable directly by its name, that is, no need to invoke the \code{d$name} notation.

To analyze each variable in the \code{d} data frame, use \code{SummaryStats()}.  Or, for a data frame with a different name, insert the name between the parentheses. To analyze a subset of the variables in a data frame, specify the list with either a : or the \code{\link{c}} function, such as m01:m03 or c(m01,m02,m03).

VARIABLE LABELS\cr
If variable labels exist, then the corresponding variable label is by default listed as the label for the horizontal axis and on the text output. For more information, see \code{\link{Read}}.

ONLY VARIABLES ARE REFERENCED\cr
The referenced variable in a \code{lessR} function can only be a variable name. This referenced variable must exist in either the referenced data frame, such as the default \code{d}, or in the user's workspace, more formally called the global environment. That is, expressions cannot be directly evaluated. For example:

\code{> SummaryStats(rnorm(50))   # does NOT work}

Instead, do the following:
\preformatted{    > Y <- rnorm(50)   # create vector Y in user workspace
    > SummaryStats(Y)     # directly reference Y}


}

\value{
The output can optionally be saved into an \code{R} object, otherwise it simply appears in the console. Redesigned in \code{lessR} version 3.3 to provide two different types of components: the pieces of readable output in character format, and a variety of statistics. The readable output are character strings such as tables amenable for reading. The statistics are numerical values amenable for further analysis. A primary motivation of these two types of output is to facilitate \code{knitr} documents, as the name of each piece can be inserted into the \code{knitr} document.

If the analysis is of a single numeric variable, the full analysis returns the following statistics: \code{n}, \code{miss}, \code{mean}, \code{sd}, \code{skew}, \code{kurtosis}, \code{min}, \code{quartile1}, \code{median}, \code{quartile3}, \code{max}, \code{IQR}. The brief analysis returns the corresponding subset of the summary statistics. If the anlaysis is conditioned on a \code{by} variable, then nothing is returned except the text output. The pieces of readable output are \code{out_stats} and \code{out_outliers}.

If the analysis is of a single categorical variable, a list is invisibly returned with two tables, the frequencies and the proportions, respectively named \code{freq} and \code{prop}. The pieces of readable output are \code{out_title} and \code{out_stats}.

If two categorical variables are analyzed, then for the full analysis four tables are returned as readable output, but no numerical statistics. The pieces are \code{out_title}, \code{out_freq}, \code{out_prop}, \code{out_colsum}, \code{out_rowsum}.

Although not typically needed, if the output is assigned to an object named, for example, \code{s}, as in \code{s <- ss(Y)}, then the contents of the object can be viewed directly with the \code{\link{unclass}} function, here as \code{unclass(s)}.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{summary}}, \code{\link{formula}}, \code{\link{boxplot}}.
}

\examples{

# -------------------------------------------
# one or two numeric or categorical variables
# -------------------------------------------

# create data frame, d, to mimic reading data with rad function
# d contains both numeric and non-numeric data
# X has two character values, Y is numeric
n <- 15
X <- sample(c("Group1","Group2"), size=n, replace=TRUE)
Y <- round(rnorm(n=n, mean=50, sd=10),3)
d <- data.frame(X,Y)
#rm(X); rm(Y)

# Analyze the values of numerical Y
# Calculate n, mean, sd, skew, kurtosis, min, max, quartiles
SummaryStats(Y, data=NULL)
# short name
ss(Y)
# output saved for later analysis
s <- ss(Y, data=NULL)
# view full text output
s
# view just the outlier analysis
s$out_outliers
# list the names of all the components
names(s)

# Analyze the values of categorical X
# Calculate frequencies and proportions, totals, chi-square
SummaryStats(X, data=NULL)

# Only a subset of available summary statistics
ss_brief(Y, data=NULL)
ss_brief(X, label_max=3, data=NULL)

# Reference the summary stats in the object: stats
stats <- ss(Y, data=NULL)
my.mean <- stats$mean

# Get the summary statistics for Y at each level of X
# Specify 2 decimal digits for each statistic displayed
SummaryStats(Y, by=X, digits_d=2, data=NULL)


# ----------
# data frame 
# ----------

# Analyze all variables in data frame d at once
# Any variables with a numeric data type and 4 or less
#  unique values will be analyzed as a categorical variable
SummaryStats()

# analyze just a subset of a data frame
d <- Read("Employee", quiet=TRUE)
SummaryStats(c(Salary,Years))


# ----------------------------------------
# data frame different from default d
# ----------------------------------------

# variables in a data frame which is not the default d
# access the breaks variable in the R provided warpbreaks data set
# although data not attached, access the variable directly by its name
data(warpbreaks)
SummaryStats(breaks, by=wool, data=warpbreaks)

# Analyze all variables in data frame warpbreaks at once
#SummaryStats(warpbreaks)


# ----------------------------
# can enter many types of data
# ----------------------------

# generate and enter integer data
X1 <- sample(1:4, size=100, replace=TRUE)
X2 <- sample(1:4, size=100, replace=TRUE)
SummaryStats(X1, data=NULL)
SummaryStats(X1,X2, data=NULL)

# generate and enter type double data
X1 <- sample(c(1,2,3,4), size=100, replace=TRUE)
X2 <- sample(c(1,2,3,4), size=100, replace=TRUE)
SummaryStats(X1, data=NULL)
SummaryStats(X1, by=X2, data=NULL)

# generate and enter character string data
# that is, without first converting to a factor
Travel <- sample(c("Bike", "Bus", "Car", "Motorcycle"), size=25, replace=TRUE)
SummaryStats(Travel, data=NULL)
}

% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ summary }

\name{CountAll}
\alias{CountAll}
\alias{ca}

\title{CountAll Descriptive Analysis of all Variables in the Data Frame}

\description{
Automatically call the following functions in this package:  \code{\link{SummaryStats}}, \code{\link{X}} and \code{\link{Chart}}. The result is set of summary statistics for every variable in the data frame, by default called \code{d}, a histogram for each numerical variable and a bar chart for each categorical variable.
}

\usage{
CountAll(x=d, quiet=FALSE, \dots)

ca(\ldots)
}

\arguments{
  \item{x}{Data frame that contains the variables to analyze, by default \code{d}.}
  \item{quiet}{Suppress text output if \code{TRUE}.}
  \item{\dots}{Other parameter values for graphics.}
}

\details{
\code{CountAll} is designed to work in conjunction with the \code{lessR} function \code{\link{Read}}, which reads a \code{csv} or other formatted data file into the data frame \code{d}. All the bar charts and associated summary statistics are written to one file and all the histograms and associated summary statistics for the numerical variables are written to another file.
}

\author{David W. Gerbing (Portland State University; \email{gerbing@pdx.edu})}

\seealso{
\code{\link{SummaryStats}}, \code{\link{X}}, \code{\link{Chart}}.
}

\examples{
# create data frame called d
n <- 12
X <- sample(c("Group1","Group2"), size=n, replace=TRUE)
Y <- rnorm(n=n, mean=50, sd=10)
d <- data.frame(X,Y)
rm(X); rm(Y)

# CountAll descriptive analysis of d
CountAll()
# short name
ca()
}


% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ descriptive }
\keyword{ histogram }
\keyword{ bar chart }
